/*******************************************************************************

        copyright:      Copyright (c) 2007 Peter Triller. All rights reserved

        license:        BSD style: 513 545 544 513 0LICENSE)

        version:        Initial release: Sept 2007

        authors:        Peter

		Contains the Unicode Data files converted to structs and simple
		accessor functions. This file is generated by a Perl script. All
		necessary changes should be made in the script, not in this file. 

*******************************************************************************/

module tango.text.UnicodeData;

struct UnicodeData {
	
	enum GeneralCategory {
         Lu = 1, //  Letter, Uppercase
        Ll = 1 <<  1, //  Letter, Lowercase
        Lt = 1 <<  2, //  Letter, Titlecase
        Lm = 1 <<  3, //  Letter, Modifier
        Lo = 1 <<  4, //  Letter, Other
        Mn = 1 <<  5, //  Mark, Nonspacing
        Mc = 1 <<  6, //  Mark, Spacing Combining
        Me = 1 <<  7, //  Mark, Enclosing
        Nd = 1 <<  8, //  Number, Decimal Digit
        Nl = 1 <<  9, //  Number, Letter
        No = 1 << 10, //  Number, Other
        Pc = 1 << 11, //  Punctuation, Connector
        Pd = 1 << 12, //  Punctuation, Dash
        Ps = 1 << 13, //  Punctuation, Open
        Pe = 1 << 14, //  Punctuation, Close
        Pi = 1 << 15, //  Punctuation, Initial quote (may behave like Ps or Pe depending on usage)
        Pf = 1 << 16, //  Punctuation, Final quote (may behave like Ps or Pe depending on usage)
        Po = 1 << 17, //  Punctuation, Other
        Sm = 1 << 18, //  Symbol, Math
        Sc = 1 << 19, //  Symbol, Currency
        Sk = 1 << 20, //  Symbol, Modifier
        So = 1 << 21, //  Symbol, Other
        Zs = 1 << 22, //  Separator, Space
        Zl = 1 << 23, //  Separator, Line
        Zp = 1 << 24, //  Separator, Paragraph
        Cc = 1 << 25, //  Other, Control
        Cf = 1 << 26, //  Other, Format
        Cs = 1 << 27, //  Other, Surrogate
        Co = 1 << 28, //  Other, Private Use
        Cn = 1 << 29, //  Other, Not Assigned (no characters in the file have this property)
        SpecialMapping = 1 << 30 // Special Bit for detection of specialMappings
    }
    
    
    enum BidiClass {
        L, //  Left-to-Right
        LRE, //  Left-to-Right Embedding
        LRO, //  Left-to-Right Override
        R, //  Right-to-Left
        AL, //  Right-to-Left Arabic
        RLE, //  Right-to-Left Embedding
        RLO, //  Right-to-Left Override
        PDF, //  Pop Directional Format
        EN, //  European Number
        ES, //  European Number Separator
        ET, //  European Number Terminator
        AN, //  Arabic Number
        CS, //  Common Number Separator
        NSM, //  Non-Spacing Mark
        BN, //  Boundary Neutral
        B, //  Paragraph Separator
        S, //  Segment Separator
        WS, //  Whitespace
        ON //  Other Neutrals
    }
    
    enum DecompositionType {
        None, // Custom type signaling no Decomposition
        Font, //    A font variant (e.g. a blackletter form).
        NoBreak, //    A no-break version of a space or hyphen.
        Initial, //    An initial presentation form (Arabic).
        Medial, //    A medial presentation form (Arabic).
        Final, //    A final presentation form (Arabic).
        Isolated, //    An isolated presentation form (Arabic).
        Circle, //    An encircled form.
        Super, //    A superscript form.
        Sub, //    A subscript form.
        Vertical, //    A vertical layout presentation form.
        Wide, //    A wide (or zenkaku) compatibility character.
        Narrow, //    A narrow (or hankaku) compatibility character.
        Small, //    A small variant form (CNS compatibility).
        Square, //    A CJK squared font variant.
        Fraction, //    A vulgar fraction form.
        Compat //    Otherwise unspecified compatibility character.
    }
    
    enum BidiMirrored {
        Y, // Yes
        N  // No
    }
    
    dchar code;
    
//    char[] name;
    
    GeneralCategory generalCategory;
    
//    short canonicalCombiningClass;
    
    //TODO the defaults are not yet set correctly
    
//    BidiClass bidiClass;
    
    //TODO end
    
//    DecompositionType decompositionType;
    
//    dchar[] decompositionMapping;
    
    
    // TODO Check handling
    
//    int numeric_1;
    
//    int numeric_2;
    
//    double numeric_3;
    
    // TODO end
    
//    BidiMirrored bidiMirrored;
    
//    char[] unicode1Name;
    
//    char [] isoComment;
    
    dchar simpleUpperCaseMapping;
    
    dchar simpleLowerCaseMapping;
    
    dchar simpleTitleCaseMapping;
      
}

struct SpecialCaseData {
    
    dchar code;
    
    dchar[] upperCaseMapping;

    dchar[] lowerCaseMapping;

    dchar[] titleCaseMapping;

}

struct FoldingCaseData {
	
	dchar code;
	
	dchar[] mapping;
	
}

UnicodeData *unicodeData[dchar];

SpecialCaseData *specialCaseData[dchar];

FoldingCaseData *foldingCaseData[dchar];

private {
	UnicodeData internalUnicodeData[] = [
 { code:0x0000
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0000
  ,simpleLowerCaseMapping:0x0000
  ,simpleTitleCaseMapping:0x0000
 },
 { code:0x0001
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0001
  ,simpleLowerCaseMapping:0x0001
  ,simpleTitleCaseMapping:0x0001
 },
 { code:0x0002
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0002
  ,simpleLowerCaseMapping:0x0002
  ,simpleTitleCaseMapping:0x0002
 },
 { code:0x0003
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0003
  ,simpleLowerCaseMapping:0x0003
  ,simpleTitleCaseMapping:0x0003
 },
 { code:0x0004
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0004
  ,simpleLowerCaseMapping:0x0004
  ,simpleTitleCaseMapping:0x0004
 },
 { code:0x0005
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0005
  ,simpleLowerCaseMapping:0x0005
  ,simpleTitleCaseMapping:0x0005
 },
 { code:0x0006
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0006
  ,simpleLowerCaseMapping:0x0006
  ,simpleTitleCaseMapping:0x0006
 },
 { code:0x0007
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0007
  ,simpleLowerCaseMapping:0x0007
  ,simpleTitleCaseMapping:0x0007
 },
 { code:0x0008
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0008
  ,simpleLowerCaseMapping:0x0008
  ,simpleTitleCaseMapping:0x0008
 },
 { code:0x0009
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0009
  ,simpleLowerCaseMapping:0x0009
  ,simpleTitleCaseMapping:0x0009
 },
 { code:0x000A
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x000A
  ,simpleLowerCaseMapping:0x000A
  ,simpleTitleCaseMapping:0x000A
 },
 { code:0x000B
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x000B
  ,simpleLowerCaseMapping:0x000B
  ,simpleTitleCaseMapping:0x000B
 },
 { code:0x000C
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x000C
  ,simpleLowerCaseMapping:0x000C
  ,simpleTitleCaseMapping:0x000C
 },
 { code:0x000D
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x000D
  ,simpleLowerCaseMapping:0x000D
  ,simpleTitleCaseMapping:0x000D
 },
 { code:0x000E
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x000E
  ,simpleLowerCaseMapping:0x000E
  ,simpleTitleCaseMapping:0x000E
 },
 { code:0x000F
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x000F
  ,simpleLowerCaseMapping:0x000F
  ,simpleTitleCaseMapping:0x000F
 },
 { code:0x0010
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0010
  ,simpleLowerCaseMapping:0x0010
  ,simpleTitleCaseMapping:0x0010
 },
 { code:0x0011
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0011
  ,simpleLowerCaseMapping:0x0011
  ,simpleTitleCaseMapping:0x0011
 },
 { code:0x0012
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0012
  ,simpleLowerCaseMapping:0x0012
  ,simpleTitleCaseMapping:0x0012
 },
 { code:0x0013
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0013
  ,simpleLowerCaseMapping:0x0013
  ,simpleTitleCaseMapping:0x0013
 },
 { code:0x0014
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0014
  ,simpleLowerCaseMapping:0x0014
  ,simpleTitleCaseMapping:0x0014
 },
 { code:0x0015
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0015
  ,simpleLowerCaseMapping:0x0015
  ,simpleTitleCaseMapping:0x0015
 },
 { code:0x0016
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0016
  ,simpleLowerCaseMapping:0x0016
  ,simpleTitleCaseMapping:0x0016
 },
 { code:0x0017
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0017
  ,simpleLowerCaseMapping:0x0017
  ,simpleTitleCaseMapping:0x0017
 },
 { code:0x0018
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0018
  ,simpleLowerCaseMapping:0x0018
  ,simpleTitleCaseMapping:0x0018
 },
 { code:0x0019
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0019
  ,simpleLowerCaseMapping:0x0019
  ,simpleTitleCaseMapping:0x0019
 },
 { code:0x001A
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x001A
  ,simpleLowerCaseMapping:0x001A
  ,simpleTitleCaseMapping:0x001A
 },
 { code:0x001B
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x001B
  ,simpleLowerCaseMapping:0x001B
  ,simpleTitleCaseMapping:0x001B
 },
 { code:0x001C
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x001C
  ,simpleLowerCaseMapping:0x001C
  ,simpleTitleCaseMapping:0x001C
 },
 { code:0x001D
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x001D
  ,simpleLowerCaseMapping:0x001D
  ,simpleTitleCaseMapping:0x001D
 },
 { code:0x001E
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x001E
  ,simpleLowerCaseMapping:0x001E
  ,simpleTitleCaseMapping:0x001E
 },
 { code:0x001F
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x001F
  ,simpleLowerCaseMapping:0x001F
  ,simpleTitleCaseMapping:0x001F
 },
 { code:0x0020
  ,generalCategory:UnicodeData.GeneralCategory.Zs
  ,simpleUpperCaseMapping:0x0020
  ,simpleLowerCaseMapping:0x0020
  ,simpleTitleCaseMapping:0x0020
 },
 { code:0x0021
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0021
  ,simpleLowerCaseMapping:0x0021
  ,simpleTitleCaseMapping:0x0021
 },
 { code:0x0022
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0022
  ,simpleLowerCaseMapping:0x0022
  ,simpleTitleCaseMapping:0x0022
 },
 { code:0x0023
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0023
  ,simpleLowerCaseMapping:0x0023
  ,simpleTitleCaseMapping:0x0023
 },
 { code:0x0024
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x0024
  ,simpleLowerCaseMapping:0x0024
  ,simpleTitleCaseMapping:0x0024
 },
 { code:0x0025
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0025
  ,simpleLowerCaseMapping:0x0025
  ,simpleTitleCaseMapping:0x0025
 },
 { code:0x0026
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0026
  ,simpleLowerCaseMapping:0x0026
  ,simpleTitleCaseMapping:0x0026
 },
 { code:0x0027
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0027
  ,simpleLowerCaseMapping:0x0027
  ,simpleTitleCaseMapping:0x0027
 },
 { code:0x0028
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x0028
  ,simpleLowerCaseMapping:0x0028
  ,simpleTitleCaseMapping:0x0028
 },
 { code:0x0029
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x0029
  ,simpleLowerCaseMapping:0x0029
  ,simpleTitleCaseMapping:0x0029
 },
 { code:0x002A
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x002A
  ,simpleLowerCaseMapping:0x002A
  ,simpleTitleCaseMapping:0x002A
 },
 { code:0x002B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x002B
  ,simpleLowerCaseMapping:0x002B
  ,simpleTitleCaseMapping:0x002B
 },
 { code:0x002C
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x002C
  ,simpleLowerCaseMapping:0x002C
  ,simpleTitleCaseMapping:0x002C
 },
 { code:0x002D
  ,generalCategory:UnicodeData.GeneralCategory.Pd
  ,simpleUpperCaseMapping:0x002D
  ,simpleLowerCaseMapping:0x002D
  ,simpleTitleCaseMapping:0x002D
 },
 { code:0x002E
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x002E
  ,simpleLowerCaseMapping:0x002E
  ,simpleTitleCaseMapping:0x002E
 },
 { code:0x002F
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x002F
  ,simpleLowerCaseMapping:0x002F
  ,simpleTitleCaseMapping:0x002F
 },
 { code:0x0030
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0030
  ,simpleLowerCaseMapping:0x0030
  ,simpleTitleCaseMapping:0x0030
 },
 { code:0x0031
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0031
  ,simpleLowerCaseMapping:0x0031
  ,simpleTitleCaseMapping:0x0031
 },
 { code:0x0032
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0032
  ,simpleLowerCaseMapping:0x0032
  ,simpleTitleCaseMapping:0x0032
 },
 { code:0x0033
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0033
  ,simpleLowerCaseMapping:0x0033
  ,simpleTitleCaseMapping:0x0033
 },
 { code:0x0034
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0034
  ,simpleLowerCaseMapping:0x0034
  ,simpleTitleCaseMapping:0x0034
 },
 { code:0x0035
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0035
  ,simpleLowerCaseMapping:0x0035
  ,simpleTitleCaseMapping:0x0035
 },
 { code:0x0036
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0036
  ,simpleLowerCaseMapping:0x0036
  ,simpleTitleCaseMapping:0x0036
 },
 { code:0x0037
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0037
  ,simpleLowerCaseMapping:0x0037
  ,simpleTitleCaseMapping:0x0037
 },
 { code:0x0038
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0038
  ,simpleLowerCaseMapping:0x0038
  ,simpleTitleCaseMapping:0x0038
 },
 { code:0x0039
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0039
  ,simpleLowerCaseMapping:0x0039
  ,simpleTitleCaseMapping:0x0039
 },
 { code:0x003A
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x003A
  ,simpleLowerCaseMapping:0x003A
  ,simpleTitleCaseMapping:0x003A
 },
 { code:0x003B
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x003B
  ,simpleLowerCaseMapping:0x003B
  ,simpleTitleCaseMapping:0x003B
 },
 { code:0x003C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x003C
  ,simpleLowerCaseMapping:0x003C
  ,simpleTitleCaseMapping:0x003C
 },
 { code:0x003D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x003D
  ,simpleLowerCaseMapping:0x003D
  ,simpleTitleCaseMapping:0x003D
 },
 { code:0x003E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x003E
  ,simpleLowerCaseMapping:0x003E
  ,simpleTitleCaseMapping:0x003E
 },
 { code:0x003F
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x003F
  ,simpleLowerCaseMapping:0x003F
  ,simpleTitleCaseMapping:0x003F
 },
 { code:0x0040
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0040
  ,simpleLowerCaseMapping:0x0040
  ,simpleTitleCaseMapping:0x0040
 },
 { code:0x0041
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0041
  ,simpleLowerCaseMapping:0x0061
  ,simpleTitleCaseMapping:0x0041
 },
 { code:0x0042
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0042
  ,simpleLowerCaseMapping:0x0062
  ,simpleTitleCaseMapping:0x0042
 },
 { code:0x0043
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0043
  ,simpleLowerCaseMapping:0x0063
  ,simpleTitleCaseMapping:0x0043
 },
 { code:0x0044
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0044
  ,simpleLowerCaseMapping:0x0064
  ,simpleTitleCaseMapping:0x0044
 },
 { code:0x0045
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0045
  ,simpleLowerCaseMapping:0x0065
  ,simpleTitleCaseMapping:0x0045
 },
 { code:0x0046
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0046
  ,simpleLowerCaseMapping:0x0066
  ,simpleTitleCaseMapping:0x0046
 },
 { code:0x0047
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0047
  ,simpleLowerCaseMapping:0x0067
  ,simpleTitleCaseMapping:0x0047
 },
 { code:0x0048
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0048
  ,simpleLowerCaseMapping:0x0068
  ,simpleTitleCaseMapping:0x0048
 },
 { code:0x0049
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0049
  ,simpleLowerCaseMapping:0x0069
  ,simpleTitleCaseMapping:0x0049
 },
 { code:0x004A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x004A
  ,simpleLowerCaseMapping:0x006A
  ,simpleTitleCaseMapping:0x004A
 },
 { code:0x004B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x004B
  ,simpleLowerCaseMapping:0x006B
  ,simpleTitleCaseMapping:0x004B
 },
 { code:0x004C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x004C
  ,simpleLowerCaseMapping:0x006C
  ,simpleTitleCaseMapping:0x004C
 },
 { code:0x004D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x004D
  ,simpleLowerCaseMapping:0x006D
  ,simpleTitleCaseMapping:0x004D
 },
 { code:0x004E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x004E
  ,simpleLowerCaseMapping:0x006E
  ,simpleTitleCaseMapping:0x004E
 },
 { code:0x004F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x004F
  ,simpleLowerCaseMapping:0x006F
  ,simpleTitleCaseMapping:0x004F
 },
 { code:0x0050
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0050
  ,simpleLowerCaseMapping:0x0070
  ,simpleTitleCaseMapping:0x0050
 },
 { code:0x0051
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0051
  ,simpleLowerCaseMapping:0x0071
  ,simpleTitleCaseMapping:0x0051
 },
 { code:0x0052
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0052
  ,simpleLowerCaseMapping:0x0072
  ,simpleTitleCaseMapping:0x0052
 },
 { code:0x0053
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0053
  ,simpleLowerCaseMapping:0x0073
  ,simpleTitleCaseMapping:0x0053
 },
 { code:0x0054
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0054
  ,simpleLowerCaseMapping:0x0074
  ,simpleTitleCaseMapping:0x0054
 },
 { code:0x0055
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0055
  ,simpleLowerCaseMapping:0x0075
  ,simpleTitleCaseMapping:0x0055
 },
 { code:0x0056
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0056
  ,simpleLowerCaseMapping:0x0076
  ,simpleTitleCaseMapping:0x0056
 },
 { code:0x0057
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0057
  ,simpleLowerCaseMapping:0x0077
  ,simpleTitleCaseMapping:0x0057
 },
 { code:0x0058
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0058
  ,simpleLowerCaseMapping:0x0078
  ,simpleTitleCaseMapping:0x0058
 },
 { code:0x0059
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0059
  ,simpleLowerCaseMapping:0x0079
  ,simpleTitleCaseMapping:0x0059
 },
 { code:0x005A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x005A
  ,simpleLowerCaseMapping:0x007A
  ,simpleTitleCaseMapping:0x005A
 },
 { code:0x005B
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x005B
  ,simpleLowerCaseMapping:0x005B
  ,simpleTitleCaseMapping:0x005B
 },
 { code:0x005C
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x005C
  ,simpleLowerCaseMapping:0x005C
  ,simpleTitleCaseMapping:0x005C
 },
 { code:0x005D
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x005D
  ,simpleLowerCaseMapping:0x005D
  ,simpleTitleCaseMapping:0x005D
 },
 { code:0x005E
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x005E
  ,simpleLowerCaseMapping:0x005E
  ,simpleTitleCaseMapping:0x005E
 },
 { code:0x005F
  ,generalCategory:UnicodeData.GeneralCategory.Pc
  ,simpleUpperCaseMapping:0x005F
  ,simpleLowerCaseMapping:0x005F
  ,simpleTitleCaseMapping:0x005F
 },
 { code:0x0060
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x0060
  ,simpleLowerCaseMapping:0x0060
  ,simpleTitleCaseMapping:0x0060
 },
 { code:0x0061
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0041
  ,simpleLowerCaseMapping:0x0061
  ,simpleTitleCaseMapping:0x0041
 },
 { code:0x0062
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0042
  ,simpleLowerCaseMapping:0x0062
  ,simpleTitleCaseMapping:0x0042
 },
 { code:0x0063
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0043
  ,simpleLowerCaseMapping:0x0063
  ,simpleTitleCaseMapping:0x0043
 },
 { code:0x0064
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0044
  ,simpleLowerCaseMapping:0x0064
  ,simpleTitleCaseMapping:0x0044
 },
 { code:0x0065
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0045
  ,simpleLowerCaseMapping:0x0065
  ,simpleTitleCaseMapping:0x0045
 },
 { code:0x0066
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0046
  ,simpleLowerCaseMapping:0x0066
  ,simpleTitleCaseMapping:0x0046
 },
 { code:0x0067
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0047
  ,simpleLowerCaseMapping:0x0067
  ,simpleTitleCaseMapping:0x0047
 },
 { code:0x0068
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0048
  ,simpleLowerCaseMapping:0x0068
  ,simpleTitleCaseMapping:0x0048
 },
 { code:0x0069
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0049
  ,simpleLowerCaseMapping:0x0069
  ,simpleTitleCaseMapping:0x0049
 },
 { code:0x006A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x004A
  ,simpleLowerCaseMapping:0x006A
  ,simpleTitleCaseMapping:0x004A
 },
 { code:0x006B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x004B
  ,simpleLowerCaseMapping:0x006B
  ,simpleTitleCaseMapping:0x004B
 },
 { code:0x006C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x004C
  ,simpleLowerCaseMapping:0x006C
  ,simpleTitleCaseMapping:0x004C
 },
 { code:0x006D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x004D
  ,simpleLowerCaseMapping:0x006D
  ,simpleTitleCaseMapping:0x004D
 },
 { code:0x006E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x004E
  ,simpleLowerCaseMapping:0x006E
  ,simpleTitleCaseMapping:0x004E
 },
 { code:0x006F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x004F
  ,simpleLowerCaseMapping:0x006F
  ,simpleTitleCaseMapping:0x004F
 },
 { code:0x0070
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0050
  ,simpleLowerCaseMapping:0x0070
  ,simpleTitleCaseMapping:0x0050
 },
 { code:0x0071
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0051
  ,simpleLowerCaseMapping:0x0071
  ,simpleTitleCaseMapping:0x0051
 },
 { code:0x0072
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0052
  ,simpleLowerCaseMapping:0x0072
  ,simpleTitleCaseMapping:0x0052
 },
 { code:0x0073
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0053
  ,simpleLowerCaseMapping:0x0073
  ,simpleTitleCaseMapping:0x0053
 },
 { code:0x0074
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0054
  ,simpleLowerCaseMapping:0x0074
  ,simpleTitleCaseMapping:0x0054
 },
 { code:0x0075
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0055
  ,simpleLowerCaseMapping:0x0075
  ,simpleTitleCaseMapping:0x0055
 },
 { code:0x0076
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0056
  ,simpleLowerCaseMapping:0x0076
  ,simpleTitleCaseMapping:0x0056
 },
 { code:0x0077
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0057
  ,simpleLowerCaseMapping:0x0077
  ,simpleTitleCaseMapping:0x0057
 },
 { code:0x0078
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0058
  ,simpleLowerCaseMapping:0x0078
  ,simpleTitleCaseMapping:0x0058
 },
 { code:0x0079
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0059
  ,simpleLowerCaseMapping:0x0079
  ,simpleTitleCaseMapping:0x0059
 },
 { code:0x007A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x005A
  ,simpleLowerCaseMapping:0x007A
  ,simpleTitleCaseMapping:0x005A
 },
 { code:0x007B
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x007B
  ,simpleLowerCaseMapping:0x007B
  ,simpleTitleCaseMapping:0x007B
 },
 { code:0x007C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x007C
  ,simpleLowerCaseMapping:0x007C
  ,simpleTitleCaseMapping:0x007C
 },
 { code:0x007D
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x007D
  ,simpleLowerCaseMapping:0x007D
  ,simpleTitleCaseMapping:0x007D
 },
 { code:0x007E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x007E
  ,simpleLowerCaseMapping:0x007E
  ,simpleTitleCaseMapping:0x007E
 },
 { code:0x007F
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x007F
  ,simpleLowerCaseMapping:0x007F
  ,simpleTitleCaseMapping:0x007F
 },
 { code:0x0080
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0080
  ,simpleLowerCaseMapping:0x0080
  ,simpleTitleCaseMapping:0x0080
 },
 { code:0x0081
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0081
  ,simpleLowerCaseMapping:0x0081
  ,simpleTitleCaseMapping:0x0081
 },
 { code:0x0082
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0082
  ,simpleLowerCaseMapping:0x0082
  ,simpleTitleCaseMapping:0x0082
 },
 { code:0x0083
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0083
  ,simpleLowerCaseMapping:0x0083
  ,simpleTitleCaseMapping:0x0083
 },
 { code:0x0084
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0084
  ,simpleLowerCaseMapping:0x0084
  ,simpleTitleCaseMapping:0x0084
 },
 { code:0x0085
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0085
  ,simpleLowerCaseMapping:0x0085
  ,simpleTitleCaseMapping:0x0085
 },
 { code:0x0086
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0086
  ,simpleLowerCaseMapping:0x0086
  ,simpleTitleCaseMapping:0x0086
 },
 { code:0x0087
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0087
  ,simpleLowerCaseMapping:0x0087
  ,simpleTitleCaseMapping:0x0087
 },
 { code:0x0088
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0088
  ,simpleLowerCaseMapping:0x0088
  ,simpleTitleCaseMapping:0x0088
 },
 { code:0x0089
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0089
  ,simpleLowerCaseMapping:0x0089
  ,simpleTitleCaseMapping:0x0089
 },
 { code:0x008A
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x008A
  ,simpleLowerCaseMapping:0x008A
  ,simpleTitleCaseMapping:0x008A
 },
 { code:0x008B
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x008B
  ,simpleLowerCaseMapping:0x008B
  ,simpleTitleCaseMapping:0x008B
 },
 { code:0x008C
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x008C
  ,simpleLowerCaseMapping:0x008C
  ,simpleTitleCaseMapping:0x008C
 },
 { code:0x008D
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x008D
  ,simpleLowerCaseMapping:0x008D
  ,simpleTitleCaseMapping:0x008D
 },
 { code:0x008E
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x008E
  ,simpleLowerCaseMapping:0x008E
  ,simpleTitleCaseMapping:0x008E
 },
 { code:0x008F
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x008F
  ,simpleLowerCaseMapping:0x008F
  ,simpleTitleCaseMapping:0x008F
 },
 { code:0x0090
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0090
  ,simpleLowerCaseMapping:0x0090
  ,simpleTitleCaseMapping:0x0090
 },
 { code:0x0091
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0091
  ,simpleLowerCaseMapping:0x0091
  ,simpleTitleCaseMapping:0x0091
 },
 { code:0x0092
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0092
  ,simpleLowerCaseMapping:0x0092
  ,simpleTitleCaseMapping:0x0092
 },
 { code:0x0093
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0093
  ,simpleLowerCaseMapping:0x0093
  ,simpleTitleCaseMapping:0x0093
 },
 { code:0x0094
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0094
  ,simpleLowerCaseMapping:0x0094
  ,simpleTitleCaseMapping:0x0094
 },
 { code:0x0095
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0095
  ,simpleLowerCaseMapping:0x0095
  ,simpleTitleCaseMapping:0x0095
 },
 { code:0x0096
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0096
  ,simpleLowerCaseMapping:0x0096
  ,simpleTitleCaseMapping:0x0096
 },
 { code:0x0097
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0097
  ,simpleLowerCaseMapping:0x0097
  ,simpleTitleCaseMapping:0x0097
 },
 { code:0x0098
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0098
  ,simpleLowerCaseMapping:0x0098
  ,simpleTitleCaseMapping:0x0098
 },
 { code:0x0099
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x0099
  ,simpleLowerCaseMapping:0x0099
  ,simpleTitleCaseMapping:0x0099
 },
 { code:0x009A
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x009A
  ,simpleLowerCaseMapping:0x009A
  ,simpleTitleCaseMapping:0x009A
 },
 { code:0x009B
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x009B
  ,simpleLowerCaseMapping:0x009B
  ,simpleTitleCaseMapping:0x009B
 },
 { code:0x009C
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x009C
  ,simpleLowerCaseMapping:0x009C
  ,simpleTitleCaseMapping:0x009C
 },
 { code:0x009D
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x009D
  ,simpleLowerCaseMapping:0x009D
  ,simpleTitleCaseMapping:0x009D
 },
 { code:0x009E
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x009E
  ,simpleLowerCaseMapping:0x009E
  ,simpleTitleCaseMapping:0x009E
 },
 { code:0x009F
  ,generalCategory:UnicodeData.GeneralCategory.Cc
  ,simpleUpperCaseMapping:0x009F
  ,simpleLowerCaseMapping:0x009F
  ,simpleTitleCaseMapping:0x009F
 },
 { code:0x00A0
  ,generalCategory:UnicodeData.GeneralCategory.Zs
  ,simpleUpperCaseMapping:0x00A0
  ,simpleLowerCaseMapping:0x00A0
  ,simpleTitleCaseMapping:0x00A0
 },
 { code:0x00A1
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x00A1
  ,simpleLowerCaseMapping:0x00A1
  ,simpleTitleCaseMapping:0x00A1
 },
 { code:0x00A2
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x00A2
  ,simpleLowerCaseMapping:0x00A2
  ,simpleTitleCaseMapping:0x00A2
 },
 { code:0x00A3
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x00A3
  ,simpleLowerCaseMapping:0x00A3
  ,simpleTitleCaseMapping:0x00A3
 },
 { code:0x00A4
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x00A4
  ,simpleLowerCaseMapping:0x00A4
  ,simpleTitleCaseMapping:0x00A4
 },
 { code:0x00A5
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x00A5
  ,simpleLowerCaseMapping:0x00A5
  ,simpleTitleCaseMapping:0x00A5
 },
 { code:0x00A6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x00A6
  ,simpleLowerCaseMapping:0x00A6
  ,simpleTitleCaseMapping:0x00A6
 },
 { code:0x00A7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x00A7
  ,simpleLowerCaseMapping:0x00A7
  ,simpleTitleCaseMapping:0x00A7
 },
 { code:0x00A8
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x00A8
  ,simpleLowerCaseMapping:0x00A8
  ,simpleTitleCaseMapping:0x00A8
 },
 { code:0x00A9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x00A9
  ,simpleLowerCaseMapping:0x00A9
  ,simpleTitleCaseMapping:0x00A9
 },
 { code:0x00AA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00AA
  ,simpleLowerCaseMapping:0x00AA
  ,simpleTitleCaseMapping:0x00AA
 },
 { code:0x00AB
  ,generalCategory:UnicodeData.GeneralCategory.Pi
  ,simpleUpperCaseMapping:0x00AB
  ,simpleLowerCaseMapping:0x00AB
  ,simpleTitleCaseMapping:0x00AB
 },
 { code:0x00AC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x00AC
  ,simpleLowerCaseMapping:0x00AC
  ,simpleTitleCaseMapping:0x00AC
 },
 { code:0x00AD
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x00AD
  ,simpleLowerCaseMapping:0x00AD
  ,simpleTitleCaseMapping:0x00AD
 },
 { code:0x00AE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x00AE
  ,simpleLowerCaseMapping:0x00AE
  ,simpleTitleCaseMapping:0x00AE
 },
 { code:0x00AF
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x00AF
  ,simpleLowerCaseMapping:0x00AF
  ,simpleTitleCaseMapping:0x00AF
 },
 { code:0x00B0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x00B0
  ,simpleLowerCaseMapping:0x00B0
  ,simpleTitleCaseMapping:0x00B0
 },
 { code:0x00B1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x00B1
  ,simpleLowerCaseMapping:0x00B1
  ,simpleTitleCaseMapping:0x00B1
 },
 { code:0x00B2
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x00B2
  ,simpleLowerCaseMapping:0x00B2
  ,simpleTitleCaseMapping:0x00B2
 },
 { code:0x00B3
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x00B3
  ,simpleLowerCaseMapping:0x00B3
  ,simpleTitleCaseMapping:0x00B3
 },
 { code:0x00B4
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x00B4
  ,simpleLowerCaseMapping:0x00B4
  ,simpleTitleCaseMapping:0x00B4
 },
 { code:0x00B5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x039C
  ,simpleLowerCaseMapping:0x00B5
  ,simpleTitleCaseMapping:0x039C
 },
 { code:0x00B6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x00B6
  ,simpleLowerCaseMapping:0x00B6
  ,simpleTitleCaseMapping:0x00B6
 },
 { code:0x00B7
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x00B7
  ,simpleLowerCaseMapping:0x00B7
  ,simpleTitleCaseMapping:0x00B7
 },
 { code:0x00B8
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x00B8
  ,simpleLowerCaseMapping:0x00B8
  ,simpleTitleCaseMapping:0x00B8
 },
 { code:0x00B9
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x00B9
  ,simpleLowerCaseMapping:0x00B9
  ,simpleTitleCaseMapping:0x00B9
 },
 { code:0x00BA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00BA
  ,simpleLowerCaseMapping:0x00BA
  ,simpleTitleCaseMapping:0x00BA
 },
 { code:0x00BB
  ,generalCategory:UnicodeData.GeneralCategory.Pf
  ,simpleUpperCaseMapping:0x00BB
  ,simpleLowerCaseMapping:0x00BB
  ,simpleTitleCaseMapping:0x00BB
 },
 { code:0x00BC
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x00BC
  ,simpleLowerCaseMapping:0x00BC
  ,simpleTitleCaseMapping:0x00BC
 },
 { code:0x00BD
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x00BD
  ,simpleLowerCaseMapping:0x00BD
  ,simpleTitleCaseMapping:0x00BD
 },
 { code:0x00BE
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x00BE
  ,simpleLowerCaseMapping:0x00BE
  ,simpleTitleCaseMapping:0x00BE
 },
 { code:0x00BF
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x00BF
  ,simpleLowerCaseMapping:0x00BF
  ,simpleTitleCaseMapping:0x00BF
 },
 { code:0x00C0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00C0
  ,simpleLowerCaseMapping:0x00E0
  ,simpleTitleCaseMapping:0x00C0
 },
 { code:0x00C1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00C1
  ,simpleLowerCaseMapping:0x00E1
  ,simpleTitleCaseMapping:0x00C1
 },
 { code:0x00C2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00C2
  ,simpleLowerCaseMapping:0x00E2
  ,simpleTitleCaseMapping:0x00C2
 },
 { code:0x00C3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00C3
  ,simpleLowerCaseMapping:0x00E3
  ,simpleTitleCaseMapping:0x00C3
 },
 { code:0x00C4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00C4
  ,simpleLowerCaseMapping:0x00E4
  ,simpleTitleCaseMapping:0x00C4
 },
 { code:0x00C5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00C5
  ,simpleLowerCaseMapping:0x00E5
  ,simpleTitleCaseMapping:0x00C5
 },
 { code:0x00C6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00C6
  ,simpleLowerCaseMapping:0x00E6
  ,simpleTitleCaseMapping:0x00C6
 },
 { code:0x00C7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00C7
  ,simpleLowerCaseMapping:0x00E7
  ,simpleTitleCaseMapping:0x00C7
 },
 { code:0x00C8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00C8
  ,simpleLowerCaseMapping:0x00E8
  ,simpleTitleCaseMapping:0x00C8
 },
 { code:0x00C9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00C9
  ,simpleLowerCaseMapping:0x00E9
  ,simpleTitleCaseMapping:0x00C9
 },
 { code:0x00CA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00CA
  ,simpleLowerCaseMapping:0x00EA
  ,simpleTitleCaseMapping:0x00CA
 },
 { code:0x00CB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00CB
  ,simpleLowerCaseMapping:0x00EB
  ,simpleTitleCaseMapping:0x00CB
 },
 { code:0x00CC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00CC
  ,simpleLowerCaseMapping:0x00EC
  ,simpleTitleCaseMapping:0x00CC
 },
 { code:0x00CD
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00CD
  ,simpleLowerCaseMapping:0x00ED
  ,simpleTitleCaseMapping:0x00CD
 },
 { code:0x00CE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00CE
  ,simpleLowerCaseMapping:0x00EE
  ,simpleTitleCaseMapping:0x00CE
 },
 { code:0x00CF
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00CF
  ,simpleLowerCaseMapping:0x00EF
  ,simpleTitleCaseMapping:0x00CF
 },
 { code:0x00D0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00D0
  ,simpleLowerCaseMapping:0x00F0
  ,simpleTitleCaseMapping:0x00D0
 },
 { code:0x00D1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00D1
  ,simpleLowerCaseMapping:0x00F1
  ,simpleTitleCaseMapping:0x00D1
 },
 { code:0x00D2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00D2
  ,simpleLowerCaseMapping:0x00F2
  ,simpleTitleCaseMapping:0x00D2
 },
 { code:0x00D3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00D3
  ,simpleLowerCaseMapping:0x00F3
  ,simpleTitleCaseMapping:0x00D3
 },
 { code:0x00D4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00D4
  ,simpleLowerCaseMapping:0x00F4
  ,simpleTitleCaseMapping:0x00D4
 },
 { code:0x00D5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00D5
  ,simpleLowerCaseMapping:0x00F5
  ,simpleTitleCaseMapping:0x00D5
 },
 { code:0x00D6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00D6
  ,simpleLowerCaseMapping:0x00F6
  ,simpleTitleCaseMapping:0x00D6
 },
 { code:0x00D7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x00D7
  ,simpleLowerCaseMapping:0x00D7
  ,simpleTitleCaseMapping:0x00D7
 },
 { code:0x00D8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00D8
  ,simpleLowerCaseMapping:0x00F8
  ,simpleTitleCaseMapping:0x00D8
 },
 { code:0x00D9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00D9
  ,simpleLowerCaseMapping:0x00F9
  ,simpleTitleCaseMapping:0x00D9
 },
 { code:0x00DA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00DA
  ,simpleLowerCaseMapping:0x00FA
  ,simpleTitleCaseMapping:0x00DA
 },
 { code:0x00DB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00DB
  ,simpleLowerCaseMapping:0x00FB
  ,simpleTitleCaseMapping:0x00DB
 },
 { code:0x00DC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00DC
  ,simpleLowerCaseMapping:0x00FC
  ,simpleTitleCaseMapping:0x00DC
 },
 { code:0x00DD
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00DD
  ,simpleLowerCaseMapping:0x00FD
  ,simpleTitleCaseMapping:0x00DD
 },
 { code:0x00DE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x00DE
  ,simpleLowerCaseMapping:0x00FE
  ,simpleTitleCaseMapping:0x00DE
 },
 { code:0x00DF
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x00DF
  ,simpleLowerCaseMapping:0x00DF
  ,simpleTitleCaseMapping:0x00DF
 },
 { code:0x00E0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00C0
  ,simpleLowerCaseMapping:0x00E0
  ,simpleTitleCaseMapping:0x00C0
 },
 { code:0x00E1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00C1
  ,simpleLowerCaseMapping:0x00E1
  ,simpleTitleCaseMapping:0x00C1
 },
 { code:0x00E2
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00C2
  ,simpleLowerCaseMapping:0x00E2
  ,simpleTitleCaseMapping:0x00C2
 },
 { code:0x00E3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00C3
  ,simpleLowerCaseMapping:0x00E3
  ,simpleTitleCaseMapping:0x00C3
 },
 { code:0x00E4
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00C4
  ,simpleLowerCaseMapping:0x00E4
  ,simpleTitleCaseMapping:0x00C4
 },
 { code:0x00E5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00C5
  ,simpleLowerCaseMapping:0x00E5
  ,simpleTitleCaseMapping:0x00C5
 },
 { code:0x00E6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00C6
  ,simpleLowerCaseMapping:0x00E6
  ,simpleTitleCaseMapping:0x00C6
 },
 { code:0x00E7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00C7
  ,simpleLowerCaseMapping:0x00E7
  ,simpleTitleCaseMapping:0x00C7
 },
 { code:0x00E8
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00C8
  ,simpleLowerCaseMapping:0x00E8
  ,simpleTitleCaseMapping:0x00C8
 },
 { code:0x00E9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00C9
  ,simpleLowerCaseMapping:0x00E9
  ,simpleTitleCaseMapping:0x00C9
 },
 { code:0x00EA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00CA
  ,simpleLowerCaseMapping:0x00EA
  ,simpleTitleCaseMapping:0x00CA
 },
 { code:0x00EB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00CB
  ,simpleLowerCaseMapping:0x00EB
  ,simpleTitleCaseMapping:0x00CB
 },
 { code:0x00EC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00CC
  ,simpleLowerCaseMapping:0x00EC
  ,simpleTitleCaseMapping:0x00CC
 },
 { code:0x00ED
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00CD
  ,simpleLowerCaseMapping:0x00ED
  ,simpleTitleCaseMapping:0x00CD
 },
 { code:0x00EE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00CE
  ,simpleLowerCaseMapping:0x00EE
  ,simpleTitleCaseMapping:0x00CE
 },
 { code:0x00EF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00CF
  ,simpleLowerCaseMapping:0x00EF
  ,simpleTitleCaseMapping:0x00CF
 },
 { code:0x00F0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00D0
  ,simpleLowerCaseMapping:0x00F0
  ,simpleTitleCaseMapping:0x00D0
 },
 { code:0x00F1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00D1
  ,simpleLowerCaseMapping:0x00F1
  ,simpleTitleCaseMapping:0x00D1
 },
 { code:0x00F2
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00D2
  ,simpleLowerCaseMapping:0x00F2
  ,simpleTitleCaseMapping:0x00D2
 },
 { code:0x00F3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00D3
  ,simpleLowerCaseMapping:0x00F3
  ,simpleTitleCaseMapping:0x00D3
 },
 { code:0x00F4
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00D4
  ,simpleLowerCaseMapping:0x00F4
  ,simpleTitleCaseMapping:0x00D4
 },
 { code:0x00F5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00D5
  ,simpleLowerCaseMapping:0x00F5
  ,simpleTitleCaseMapping:0x00D5
 },
 { code:0x00F6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00D6
  ,simpleLowerCaseMapping:0x00F6
  ,simpleTitleCaseMapping:0x00D6
 },
 { code:0x00F7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x00F7
  ,simpleLowerCaseMapping:0x00F7
  ,simpleTitleCaseMapping:0x00F7
 },
 { code:0x00F8
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00D8
  ,simpleLowerCaseMapping:0x00F8
  ,simpleTitleCaseMapping:0x00D8
 },
 { code:0x00F9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00D9
  ,simpleLowerCaseMapping:0x00F9
  ,simpleTitleCaseMapping:0x00D9
 },
 { code:0x00FA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00DA
  ,simpleLowerCaseMapping:0x00FA
  ,simpleTitleCaseMapping:0x00DA
 },
 { code:0x00FB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00DB
  ,simpleLowerCaseMapping:0x00FB
  ,simpleTitleCaseMapping:0x00DB
 },
 { code:0x00FC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00DC
  ,simpleLowerCaseMapping:0x00FC
  ,simpleTitleCaseMapping:0x00DC
 },
 { code:0x00FD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00DD
  ,simpleLowerCaseMapping:0x00FD
  ,simpleTitleCaseMapping:0x00DD
 },
 { code:0x00FE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x00DE
  ,simpleLowerCaseMapping:0x00FE
  ,simpleTitleCaseMapping:0x00DE
 },
 { code:0x00FF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0178
  ,simpleLowerCaseMapping:0x00FF
  ,simpleTitleCaseMapping:0x0178
 },
 { code:0x0100
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0100
  ,simpleLowerCaseMapping:0x0101
  ,simpleTitleCaseMapping:0x0100
 },
 { code:0x0101
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0100
  ,simpleLowerCaseMapping:0x0101
  ,simpleTitleCaseMapping:0x0100
 },
 { code:0x0102
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0102
  ,simpleLowerCaseMapping:0x0103
  ,simpleTitleCaseMapping:0x0102
 },
 { code:0x0103
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0102
  ,simpleLowerCaseMapping:0x0103
  ,simpleTitleCaseMapping:0x0102
 },
 { code:0x0104
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0104
  ,simpleLowerCaseMapping:0x0105
  ,simpleTitleCaseMapping:0x0104
 },
 { code:0x0105
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0104
  ,simpleLowerCaseMapping:0x0105
  ,simpleTitleCaseMapping:0x0104
 },
 { code:0x0106
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0106
  ,simpleLowerCaseMapping:0x0107
  ,simpleTitleCaseMapping:0x0106
 },
 { code:0x0107
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0106
  ,simpleLowerCaseMapping:0x0107
  ,simpleTitleCaseMapping:0x0106
 },
 { code:0x0108
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0108
  ,simpleLowerCaseMapping:0x0109
  ,simpleTitleCaseMapping:0x0108
 },
 { code:0x0109
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0108
  ,simpleLowerCaseMapping:0x0109
  ,simpleTitleCaseMapping:0x0108
 },
 { code:0x010A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x010A
  ,simpleLowerCaseMapping:0x010B
  ,simpleTitleCaseMapping:0x010A
 },
 { code:0x010B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x010A
  ,simpleLowerCaseMapping:0x010B
  ,simpleTitleCaseMapping:0x010A
 },
 { code:0x010C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x010C
  ,simpleLowerCaseMapping:0x010D
  ,simpleTitleCaseMapping:0x010C
 },
 { code:0x010D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x010C
  ,simpleLowerCaseMapping:0x010D
  ,simpleTitleCaseMapping:0x010C
 },
 { code:0x010E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x010E
  ,simpleLowerCaseMapping:0x010F
  ,simpleTitleCaseMapping:0x010E
 },
 { code:0x010F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x010E
  ,simpleLowerCaseMapping:0x010F
  ,simpleTitleCaseMapping:0x010E
 },
 { code:0x0110
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0110
  ,simpleLowerCaseMapping:0x0111
  ,simpleTitleCaseMapping:0x0110
 },
 { code:0x0111
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0110
  ,simpleLowerCaseMapping:0x0111
  ,simpleTitleCaseMapping:0x0110
 },
 { code:0x0112
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0112
  ,simpleLowerCaseMapping:0x0113
  ,simpleTitleCaseMapping:0x0112
 },
 { code:0x0113
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0112
  ,simpleLowerCaseMapping:0x0113
  ,simpleTitleCaseMapping:0x0112
 },
 { code:0x0114
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0114
  ,simpleLowerCaseMapping:0x0115
  ,simpleTitleCaseMapping:0x0114
 },
 { code:0x0115
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0114
  ,simpleLowerCaseMapping:0x0115
  ,simpleTitleCaseMapping:0x0114
 },
 { code:0x0116
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0116
  ,simpleLowerCaseMapping:0x0117
  ,simpleTitleCaseMapping:0x0116
 },
 { code:0x0117
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0116
  ,simpleLowerCaseMapping:0x0117
  ,simpleTitleCaseMapping:0x0116
 },
 { code:0x0118
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0118
  ,simpleLowerCaseMapping:0x0119
  ,simpleTitleCaseMapping:0x0118
 },
 { code:0x0119
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0118
  ,simpleLowerCaseMapping:0x0119
  ,simpleTitleCaseMapping:0x0118
 },
 { code:0x011A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x011A
  ,simpleLowerCaseMapping:0x011B
  ,simpleTitleCaseMapping:0x011A
 },
 { code:0x011B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x011A
  ,simpleLowerCaseMapping:0x011B
  ,simpleTitleCaseMapping:0x011A
 },
 { code:0x011C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x011C
  ,simpleLowerCaseMapping:0x011D
  ,simpleTitleCaseMapping:0x011C
 },
 { code:0x011D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x011C
  ,simpleLowerCaseMapping:0x011D
  ,simpleTitleCaseMapping:0x011C
 },
 { code:0x011E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x011E
  ,simpleLowerCaseMapping:0x011F
  ,simpleTitleCaseMapping:0x011E
 },
 { code:0x011F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x011E
  ,simpleLowerCaseMapping:0x011F
  ,simpleTitleCaseMapping:0x011E
 },
 { code:0x0120
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0120
  ,simpleLowerCaseMapping:0x0121
  ,simpleTitleCaseMapping:0x0120
 },
 { code:0x0121
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0120
  ,simpleLowerCaseMapping:0x0121
  ,simpleTitleCaseMapping:0x0120
 },
 { code:0x0122
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0122
  ,simpleLowerCaseMapping:0x0123
  ,simpleTitleCaseMapping:0x0122
 },
 { code:0x0123
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0122
  ,simpleLowerCaseMapping:0x0123
  ,simpleTitleCaseMapping:0x0122
 },
 { code:0x0124
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0124
  ,simpleLowerCaseMapping:0x0125
  ,simpleTitleCaseMapping:0x0124
 },
 { code:0x0125
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0124
  ,simpleLowerCaseMapping:0x0125
  ,simpleTitleCaseMapping:0x0124
 },
 { code:0x0126
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0126
  ,simpleLowerCaseMapping:0x0127
  ,simpleTitleCaseMapping:0x0126
 },
 { code:0x0127
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0126
  ,simpleLowerCaseMapping:0x0127
  ,simpleTitleCaseMapping:0x0126
 },
 { code:0x0128
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0128
  ,simpleLowerCaseMapping:0x0129
  ,simpleTitleCaseMapping:0x0128
 },
 { code:0x0129
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0128
  ,simpleLowerCaseMapping:0x0129
  ,simpleTitleCaseMapping:0x0128
 },
 { code:0x012A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x012A
  ,simpleLowerCaseMapping:0x012B
  ,simpleTitleCaseMapping:0x012A
 },
 { code:0x012B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x012A
  ,simpleLowerCaseMapping:0x012B
  ,simpleTitleCaseMapping:0x012A
 },
 { code:0x012C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x012C
  ,simpleLowerCaseMapping:0x012D
  ,simpleTitleCaseMapping:0x012C
 },
 { code:0x012D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x012C
  ,simpleLowerCaseMapping:0x012D
  ,simpleTitleCaseMapping:0x012C
 },
 { code:0x012E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x012E
  ,simpleLowerCaseMapping:0x012F
  ,simpleTitleCaseMapping:0x012E
 },
 { code:0x012F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x012E
  ,simpleLowerCaseMapping:0x012F
  ,simpleTitleCaseMapping:0x012E
 },
 { code:0x0130
  ,generalCategory:UnicodeData.GeneralCategory.Lu | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x0130
  ,simpleLowerCaseMapping:0x0069
  ,simpleTitleCaseMapping:0x0130
 },
 { code:0x0131
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0049
  ,simpleLowerCaseMapping:0x0131
  ,simpleTitleCaseMapping:0x0049
 },
 { code:0x0132
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0132
  ,simpleLowerCaseMapping:0x0133
  ,simpleTitleCaseMapping:0x0132
 },
 { code:0x0133
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0132
  ,simpleLowerCaseMapping:0x0133
  ,simpleTitleCaseMapping:0x0132
 },
 { code:0x0134
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0134
  ,simpleLowerCaseMapping:0x0135
  ,simpleTitleCaseMapping:0x0134
 },
 { code:0x0135
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0134
  ,simpleLowerCaseMapping:0x0135
  ,simpleTitleCaseMapping:0x0134
 },
 { code:0x0136
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0136
  ,simpleLowerCaseMapping:0x0137
  ,simpleTitleCaseMapping:0x0136
 },
 { code:0x0137
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0136
  ,simpleLowerCaseMapping:0x0137
  ,simpleTitleCaseMapping:0x0136
 },
 { code:0x0138
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0138
  ,simpleLowerCaseMapping:0x0138
  ,simpleTitleCaseMapping:0x0138
 },
 { code:0x0139
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0139
  ,simpleLowerCaseMapping:0x013A
  ,simpleTitleCaseMapping:0x0139
 },
 { code:0x013A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0139
  ,simpleLowerCaseMapping:0x013A
  ,simpleTitleCaseMapping:0x0139
 },
 { code:0x013B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x013B
  ,simpleLowerCaseMapping:0x013C
  ,simpleTitleCaseMapping:0x013B
 },
 { code:0x013C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x013B
  ,simpleLowerCaseMapping:0x013C
  ,simpleTitleCaseMapping:0x013B
 },
 { code:0x013D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x013D
  ,simpleLowerCaseMapping:0x013E
  ,simpleTitleCaseMapping:0x013D
 },
 { code:0x013E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x013D
  ,simpleLowerCaseMapping:0x013E
  ,simpleTitleCaseMapping:0x013D
 },
 { code:0x013F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x013F
  ,simpleLowerCaseMapping:0x0140
  ,simpleTitleCaseMapping:0x013F
 },
 { code:0x0140
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x013F
  ,simpleLowerCaseMapping:0x0140
  ,simpleTitleCaseMapping:0x013F
 },
 { code:0x0141
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0141
  ,simpleLowerCaseMapping:0x0142
  ,simpleTitleCaseMapping:0x0141
 },
 { code:0x0142
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0141
  ,simpleLowerCaseMapping:0x0142
  ,simpleTitleCaseMapping:0x0141
 },
 { code:0x0143
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0143
  ,simpleLowerCaseMapping:0x0144
  ,simpleTitleCaseMapping:0x0143
 },
 { code:0x0144
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0143
  ,simpleLowerCaseMapping:0x0144
  ,simpleTitleCaseMapping:0x0143
 },
 { code:0x0145
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0145
  ,simpleLowerCaseMapping:0x0146
  ,simpleTitleCaseMapping:0x0145
 },
 { code:0x0146
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0145
  ,simpleLowerCaseMapping:0x0146
  ,simpleTitleCaseMapping:0x0145
 },
 { code:0x0147
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0147
  ,simpleLowerCaseMapping:0x0148
  ,simpleTitleCaseMapping:0x0147
 },
 { code:0x0148
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0147
  ,simpleLowerCaseMapping:0x0148
  ,simpleTitleCaseMapping:0x0147
 },
 { code:0x0149
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x0149
  ,simpleLowerCaseMapping:0x0149
  ,simpleTitleCaseMapping:0x0149
 },
 { code:0x014A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x014A
  ,simpleLowerCaseMapping:0x014B
  ,simpleTitleCaseMapping:0x014A
 },
 { code:0x014B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x014A
  ,simpleLowerCaseMapping:0x014B
  ,simpleTitleCaseMapping:0x014A
 },
 { code:0x014C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x014C
  ,simpleLowerCaseMapping:0x014D
  ,simpleTitleCaseMapping:0x014C
 },
 { code:0x014D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x014C
  ,simpleLowerCaseMapping:0x014D
  ,simpleTitleCaseMapping:0x014C
 },
 { code:0x014E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x014E
  ,simpleLowerCaseMapping:0x014F
  ,simpleTitleCaseMapping:0x014E
 },
 { code:0x014F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x014E
  ,simpleLowerCaseMapping:0x014F
  ,simpleTitleCaseMapping:0x014E
 },
 { code:0x0150
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0150
  ,simpleLowerCaseMapping:0x0151
  ,simpleTitleCaseMapping:0x0150
 },
 { code:0x0151
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0150
  ,simpleLowerCaseMapping:0x0151
  ,simpleTitleCaseMapping:0x0150
 },
 { code:0x0152
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0152
  ,simpleLowerCaseMapping:0x0153
  ,simpleTitleCaseMapping:0x0152
 },
 { code:0x0153
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0152
  ,simpleLowerCaseMapping:0x0153
  ,simpleTitleCaseMapping:0x0152
 },
 { code:0x0154
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0154
  ,simpleLowerCaseMapping:0x0155
  ,simpleTitleCaseMapping:0x0154
 },
 { code:0x0155
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0154
  ,simpleLowerCaseMapping:0x0155
  ,simpleTitleCaseMapping:0x0154
 },
 { code:0x0156
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0156
  ,simpleLowerCaseMapping:0x0157
  ,simpleTitleCaseMapping:0x0156
 },
 { code:0x0157
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0156
  ,simpleLowerCaseMapping:0x0157
  ,simpleTitleCaseMapping:0x0156
 },
 { code:0x0158
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0158
  ,simpleLowerCaseMapping:0x0159
  ,simpleTitleCaseMapping:0x0158
 },
 { code:0x0159
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0158
  ,simpleLowerCaseMapping:0x0159
  ,simpleTitleCaseMapping:0x0158
 },
 { code:0x015A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x015A
  ,simpleLowerCaseMapping:0x015B
  ,simpleTitleCaseMapping:0x015A
 },
 { code:0x015B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x015A
  ,simpleLowerCaseMapping:0x015B
  ,simpleTitleCaseMapping:0x015A
 },
 { code:0x015C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x015C
  ,simpleLowerCaseMapping:0x015D
  ,simpleTitleCaseMapping:0x015C
 },
 { code:0x015D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x015C
  ,simpleLowerCaseMapping:0x015D
  ,simpleTitleCaseMapping:0x015C
 },
 { code:0x015E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x015E
  ,simpleLowerCaseMapping:0x015F
  ,simpleTitleCaseMapping:0x015E
 },
 { code:0x015F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x015E
  ,simpleLowerCaseMapping:0x015F
  ,simpleTitleCaseMapping:0x015E
 },
 { code:0x0160
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0160
  ,simpleLowerCaseMapping:0x0161
  ,simpleTitleCaseMapping:0x0160
 },
 { code:0x0161
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0160
  ,simpleLowerCaseMapping:0x0161
  ,simpleTitleCaseMapping:0x0160
 },
 { code:0x0162
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0162
  ,simpleLowerCaseMapping:0x0163
  ,simpleTitleCaseMapping:0x0162
 },
 { code:0x0163
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0162
  ,simpleLowerCaseMapping:0x0163
  ,simpleTitleCaseMapping:0x0162
 },
 { code:0x0164
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0164
  ,simpleLowerCaseMapping:0x0165
  ,simpleTitleCaseMapping:0x0164
 },
 { code:0x0165
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0164
  ,simpleLowerCaseMapping:0x0165
  ,simpleTitleCaseMapping:0x0164
 },
 { code:0x0166
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0166
  ,simpleLowerCaseMapping:0x0167
  ,simpleTitleCaseMapping:0x0166
 },
 { code:0x0167
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0166
  ,simpleLowerCaseMapping:0x0167
  ,simpleTitleCaseMapping:0x0166
 },
 { code:0x0168
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0168
  ,simpleLowerCaseMapping:0x0169
  ,simpleTitleCaseMapping:0x0168
 },
 { code:0x0169
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0168
  ,simpleLowerCaseMapping:0x0169
  ,simpleTitleCaseMapping:0x0168
 },
 { code:0x016A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x016A
  ,simpleLowerCaseMapping:0x016B
  ,simpleTitleCaseMapping:0x016A
 },
 { code:0x016B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x016A
  ,simpleLowerCaseMapping:0x016B
  ,simpleTitleCaseMapping:0x016A
 },
 { code:0x016C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x016C
  ,simpleLowerCaseMapping:0x016D
  ,simpleTitleCaseMapping:0x016C
 },
 { code:0x016D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x016C
  ,simpleLowerCaseMapping:0x016D
  ,simpleTitleCaseMapping:0x016C
 },
 { code:0x016E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x016E
  ,simpleLowerCaseMapping:0x016F
  ,simpleTitleCaseMapping:0x016E
 },
 { code:0x016F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x016E
  ,simpleLowerCaseMapping:0x016F
  ,simpleTitleCaseMapping:0x016E
 },
 { code:0x0170
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0170
  ,simpleLowerCaseMapping:0x0171
  ,simpleTitleCaseMapping:0x0170
 },
 { code:0x0171
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0170
  ,simpleLowerCaseMapping:0x0171
  ,simpleTitleCaseMapping:0x0170
 },
 { code:0x0172
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0172
  ,simpleLowerCaseMapping:0x0173
  ,simpleTitleCaseMapping:0x0172
 },
 { code:0x0173
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0172
  ,simpleLowerCaseMapping:0x0173
  ,simpleTitleCaseMapping:0x0172
 },
 { code:0x0174
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0174
  ,simpleLowerCaseMapping:0x0175
  ,simpleTitleCaseMapping:0x0174
 },
 { code:0x0175
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0174
  ,simpleLowerCaseMapping:0x0175
  ,simpleTitleCaseMapping:0x0174
 },
 { code:0x0176
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0176
  ,simpleLowerCaseMapping:0x0177
  ,simpleTitleCaseMapping:0x0176
 },
 { code:0x0177
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0176
  ,simpleLowerCaseMapping:0x0177
  ,simpleTitleCaseMapping:0x0176
 },
 { code:0x0178
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0178
  ,simpleLowerCaseMapping:0x00FF
  ,simpleTitleCaseMapping:0x0178
 },
 { code:0x0179
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0179
  ,simpleLowerCaseMapping:0x017A
  ,simpleTitleCaseMapping:0x0179
 },
 { code:0x017A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0179
  ,simpleLowerCaseMapping:0x017A
  ,simpleTitleCaseMapping:0x0179
 },
 { code:0x017B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x017B
  ,simpleLowerCaseMapping:0x017C
  ,simpleTitleCaseMapping:0x017B
 },
 { code:0x017C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x017B
  ,simpleLowerCaseMapping:0x017C
  ,simpleTitleCaseMapping:0x017B
 },
 { code:0x017D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x017D
  ,simpleLowerCaseMapping:0x017E
  ,simpleTitleCaseMapping:0x017D
 },
 { code:0x017E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x017D
  ,simpleLowerCaseMapping:0x017E
  ,simpleTitleCaseMapping:0x017D
 },
 { code:0x017F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0053
  ,simpleLowerCaseMapping:0x017F
  ,simpleTitleCaseMapping:0x0053
 },
 { code:0x0180
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0243
  ,simpleLowerCaseMapping:0x0180
  ,simpleTitleCaseMapping:0x0243
 },
 { code:0x0181
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0181
  ,simpleLowerCaseMapping:0x0253
  ,simpleTitleCaseMapping:0x0181
 },
 { code:0x0182
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0182
  ,simpleLowerCaseMapping:0x0183
  ,simpleTitleCaseMapping:0x0182
 },
 { code:0x0183
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0182
  ,simpleLowerCaseMapping:0x0183
  ,simpleTitleCaseMapping:0x0182
 },
 { code:0x0184
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0184
  ,simpleLowerCaseMapping:0x0185
  ,simpleTitleCaseMapping:0x0184
 },
 { code:0x0185
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0184
  ,simpleLowerCaseMapping:0x0185
  ,simpleTitleCaseMapping:0x0184
 },
 { code:0x0186
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0186
  ,simpleLowerCaseMapping:0x0254
  ,simpleTitleCaseMapping:0x0186
 },
 { code:0x0187
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0187
  ,simpleLowerCaseMapping:0x0188
  ,simpleTitleCaseMapping:0x0187
 },
 { code:0x0188
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0187
  ,simpleLowerCaseMapping:0x0188
  ,simpleTitleCaseMapping:0x0187
 },
 { code:0x0189
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0189
  ,simpleLowerCaseMapping:0x0256
  ,simpleTitleCaseMapping:0x0189
 },
 { code:0x018A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x018A
  ,simpleLowerCaseMapping:0x0257
  ,simpleTitleCaseMapping:0x018A
 },
 { code:0x018B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x018B
  ,simpleLowerCaseMapping:0x018C
  ,simpleTitleCaseMapping:0x018B
 },
 { code:0x018C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x018B
  ,simpleLowerCaseMapping:0x018C
  ,simpleTitleCaseMapping:0x018B
 },
 { code:0x018D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x018D
  ,simpleLowerCaseMapping:0x018D
  ,simpleTitleCaseMapping:0x018D
 },
 { code:0x018E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x018E
  ,simpleLowerCaseMapping:0x01DD
  ,simpleTitleCaseMapping:0x018E
 },
 { code:0x018F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x018F
  ,simpleLowerCaseMapping:0x0259
  ,simpleTitleCaseMapping:0x018F
 },
 { code:0x0190
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0190
  ,simpleLowerCaseMapping:0x025B
  ,simpleTitleCaseMapping:0x0190
 },
 { code:0x0191
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0191
  ,simpleLowerCaseMapping:0x0192
  ,simpleTitleCaseMapping:0x0191
 },
 { code:0x0192
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0191
  ,simpleLowerCaseMapping:0x0192
  ,simpleTitleCaseMapping:0x0191
 },
 { code:0x0193
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0193
  ,simpleLowerCaseMapping:0x0260
  ,simpleTitleCaseMapping:0x0193
 },
 { code:0x0194
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0194
  ,simpleLowerCaseMapping:0x0263
  ,simpleTitleCaseMapping:0x0194
 },
 { code:0x0195
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01F6
  ,simpleLowerCaseMapping:0x0195
  ,simpleTitleCaseMapping:0x01F6
 },
 { code:0x0196
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0196
  ,simpleLowerCaseMapping:0x0269
  ,simpleTitleCaseMapping:0x0196
 },
 { code:0x0197
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0197
  ,simpleLowerCaseMapping:0x0268
  ,simpleTitleCaseMapping:0x0197
 },
 { code:0x0198
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0198
  ,simpleLowerCaseMapping:0x0199
  ,simpleTitleCaseMapping:0x0198
 },
 { code:0x0199
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0198
  ,simpleLowerCaseMapping:0x0199
  ,simpleTitleCaseMapping:0x0198
 },
 { code:0x019A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x023D
  ,simpleLowerCaseMapping:0x019A
  ,simpleTitleCaseMapping:0x023D
 },
 { code:0x019B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x019B
  ,simpleLowerCaseMapping:0x019B
  ,simpleTitleCaseMapping:0x019B
 },
 { code:0x019C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x019C
  ,simpleLowerCaseMapping:0x026F
  ,simpleTitleCaseMapping:0x019C
 },
 { code:0x019D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x019D
  ,simpleLowerCaseMapping:0x0272
  ,simpleTitleCaseMapping:0x019D
 },
 { code:0x019E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0220
  ,simpleLowerCaseMapping:0x019E
  ,simpleTitleCaseMapping:0x0220
 },
 { code:0x019F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x019F
  ,simpleLowerCaseMapping:0x0275
  ,simpleTitleCaseMapping:0x019F
 },
 { code:0x01A0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01A0
  ,simpleLowerCaseMapping:0x01A1
  ,simpleTitleCaseMapping:0x01A0
 },
 { code:0x01A1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01A0
  ,simpleLowerCaseMapping:0x01A1
  ,simpleTitleCaseMapping:0x01A0
 },
 { code:0x01A2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01A2
  ,simpleLowerCaseMapping:0x01A3
  ,simpleTitleCaseMapping:0x01A2
 },
 { code:0x01A3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01A2
  ,simpleLowerCaseMapping:0x01A3
  ,simpleTitleCaseMapping:0x01A2
 },
 { code:0x01A4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01A4
  ,simpleLowerCaseMapping:0x01A5
  ,simpleTitleCaseMapping:0x01A4
 },
 { code:0x01A5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01A4
  ,simpleLowerCaseMapping:0x01A5
  ,simpleTitleCaseMapping:0x01A4
 },
 { code:0x01A6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01A6
  ,simpleLowerCaseMapping:0x0280
  ,simpleTitleCaseMapping:0x01A6
 },
 { code:0x01A7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01A7
  ,simpleLowerCaseMapping:0x01A8
  ,simpleTitleCaseMapping:0x01A7
 },
 { code:0x01A8
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01A7
  ,simpleLowerCaseMapping:0x01A8
  ,simpleTitleCaseMapping:0x01A7
 },
 { code:0x01A9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01A9
  ,simpleLowerCaseMapping:0x0283
  ,simpleTitleCaseMapping:0x01A9
 },
 { code:0x01AA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01AA
  ,simpleLowerCaseMapping:0x01AA
  ,simpleTitleCaseMapping:0x01AA
 },
 { code:0x01AB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01AB
  ,simpleLowerCaseMapping:0x01AB
  ,simpleTitleCaseMapping:0x01AB
 },
 { code:0x01AC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01AC
  ,simpleLowerCaseMapping:0x01AD
  ,simpleTitleCaseMapping:0x01AC
 },
 { code:0x01AD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01AC
  ,simpleLowerCaseMapping:0x01AD
  ,simpleTitleCaseMapping:0x01AC
 },
 { code:0x01AE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01AE
  ,simpleLowerCaseMapping:0x0288
  ,simpleTitleCaseMapping:0x01AE
 },
 { code:0x01AF
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01AF
  ,simpleLowerCaseMapping:0x01B0
  ,simpleTitleCaseMapping:0x01AF
 },
 { code:0x01B0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01AF
  ,simpleLowerCaseMapping:0x01B0
  ,simpleTitleCaseMapping:0x01AF
 },
 { code:0x01B1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01B1
  ,simpleLowerCaseMapping:0x028A
  ,simpleTitleCaseMapping:0x01B1
 },
 { code:0x01B2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01B2
  ,simpleLowerCaseMapping:0x028B
  ,simpleTitleCaseMapping:0x01B2
 },
 { code:0x01B3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01B3
  ,simpleLowerCaseMapping:0x01B4
  ,simpleTitleCaseMapping:0x01B3
 },
 { code:0x01B4
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01B3
  ,simpleLowerCaseMapping:0x01B4
  ,simpleTitleCaseMapping:0x01B3
 },
 { code:0x01B5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01B5
  ,simpleLowerCaseMapping:0x01B6
  ,simpleTitleCaseMapping:0x01B5
 },
 { code:0x01B6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01B5
  ,simpleLowerCaseMapping:0x01B6
  ,simpleTitleCaseMapping:0x01B5
 },
 { code:0x01B7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01B7
  ,simpleLowerCaseMapping:0x0292
  ,simpleTitleCaseMapping:0x01B7
 },
 { code:0x01B8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01B8
  ,simpleLowerCaseMapping:0x01B9
  ,simpleTitleCaseMapping:0x01B8
 },
 { code:0x01B9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01B8
  ,simpleLowerCaseMapping:0x01B9
  ,simpleTitleCaseMapping:0x01B8
 },
 { code:0x01BA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01BA
  ,simpleLowerCaseMapping:0x01BA
  ,simpleTitleCaseMapping:0x01BA
 },
 { code:0x01BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x01BB
  ,simpleLowerCaseMapping:0x01BB
  ,simpleTitleCaseMapping:0x01BB
 },
 { code:0x01BC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01BC
  ,simpleLowerCaseMapping:0x01BD
  ,simpleTitleCaseMapping:0x01BC
 },
 { code:0x01BD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01BC
  ,simpleLowerCaseMapping:0x01BD
  ,simpleTitleCaseMapping:0x01BC
 },
 { code:0x01BE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01BE
  ,simpleLowerCaseMapping:0x01BE
  ,simpleTitleCaseMapping:0x01BE
 },
 { code:0x01BF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01F7
  ,simpleLowerCaseMapping:0x01BF
  ,simpleTitleCaseMapping:0x01F7
 },
 { code:0x01C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x01C0
  ,simpleLowerCaseMapping:0x01C0
  ,simpleTitleCaseMapping:0x01C0
 },
 { code:0x01C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x01C1
  ,simpleLowerCaseMapping:0x01C1
  ,simpleTitleCaseMapping:0x01C1
 },
 { code:0x01C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x01C2
  ,simpleLowerCaseMapping:0x01C2
  ,simpleTitleCaseMapping:0x01C2
 },
 { code:0x01C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x01C3
  ,simpleLowerCaseMapping:0x01C3
  ,simpleTitleCaseMapping:0x01C3
 },
 { code:0x01C4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01C4
  ,simpleLowerCaseMapping:0x01C6
  ,simpleTitleCaseMapping:0x01C5
 },
 { code:0x01C5
  ,generalCategory:UnicodeData.GeneralCategory.Lt
  ,simpleUpperCaseMapping:0x01C4
  ,simpleLowerCaseMapping:0x01C6
  ,simpleTitleCaseMapping:0x01C5
 },
 { code:0x01C6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01C4
  ,simpleLowerCaseMapping:0x01C6
  ,simpleTitleCaseMapping:0x01C5
 },
 { code:0x01C7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01C7
  ,simpleLowerCaseMapping:0x01C9
  ,simpleTitleCaseMapping:0x01C8
 },
 { code:0x01C8
  ,generalCategory:UnicodeData.GeneralCategory.Lt
  ,simpleUpperCaseMapping:0x01C7
  ,simpleLowerCaseMapping:0x01C9
  ,simpleTitleCaseMapping:0x01C8
 },
 { code:0x01C9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01C7
  ,simpleLowerCaseMapping:0x01C9
  ,simpleTitleCaseMapping:0x01C8
 },
 { code:0x01CA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01CA
  ,simpleLowerCaseMapping:0x01CC
  ,simpleTitleCaseMapping:0x01CB
 },
 { code:0x01CB
  ,generalCategory:UnicodeData.GeneralCategory.Lt
  ,simpleUpperCaseMapping:0x01CA
  ,simpleLowerCaseMapping:0x01CC
  ,simpleTitleCaseMapping:0x01CB
 },
 { code:0x01CC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01CA
  ,simpleLowerCaseMapping:0x01CC
  ,simpleTitleCaseMapping:0x01CB
 },
 { code:0x01CD
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01CD
  ,simpleLowerCaseMapping:0x01CE
  ,simpleTitleCaseMapping:0x01CD
 },
 { code:0x01CE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01CD
  ,simpleLowerCaseMapping:0x01CE
  ,simpleTitleCaseMapping:0x01CD
 },
 { code:0x01CF
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01CF
  ,simpleLowerCaseMapping:0x01D0
  ,simpleTitleCaseMapping:0x01CF
 },
 { code:0x01D0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01CF
  ,simpleLowerCaseMapping:0x01D0
  ,simpleTitleCaseMapping:0x01CF
 },
 { code:0x01D1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01D1
  ,simpleLowerCaseMapping:0x01D2
  ,simpleTitleCaseMapping:0x01D1
 },
 { code:0x01D2
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01D1
  ,simpleLowerCaseMapping:0x01D2
  ,simpleTitleCaseMapping:0x01D1
 },
 { code:0x01D3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01D3
  ,simpleLowerCaseMapping:0x01D4
  ,simpleTitleCaseMapping:0x01D3
 },
 { code:0x01D4
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01D3
  ,simpleLowerCaseMapping:0x01D4
  ,simpleTitleCaseMapping:0x01D3
 },
 { code:0x01D5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01D5
  ,simpleLowerCaseMapping:0x01D6
  ,simpleTitleCaseMapping:0x01D5
 },
 { code:0x01D6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01D5
  ,simpleLowerCaseMapping:0x01D6
  ,simpleTitleCaseMapping:0x01D5
 },
 { code:0x01D7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01D7
  ,simpleLowerCaseMapping:0x01D8
  ,simpleTitleCaseMapping:0x01D7
 },
 { code:0x01D8
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01D7
  ,simpleLowerCaseMapping:0x01D8
  ,simpleTitleCaseMapping:0x01D7
 },
 { code:0x01D9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01D9
  ,simpleLowerCaseMapping:0x01DA
  ,simpleTitleCaseMapping:0x01D9
 },
 { code:0x01DA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01D9
  ,simpleLowerCaseMapping:0x01DA
  ,simpleTitleCaseMapping:0x01D9
 },
 { code:0x01DB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01DB
  ,simpleLowerCaseMapping:0x01DC
  ,simpleTitleCaseMapping:0x01DB
 },
 { code:0x01DC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01DB
  ,simpleLowerCaseMapping:0x01DC
  ,simpleTitleCaseMapping:0x01DB
 },
 { code:0x01DD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x018E
  ,simpleLowerCaseMapping:0x01DD
  ,simpleTitleCaseMapping:0x018E
 },
 { code:0x01DE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01DE
  ,simpleLowerCaseMapping:0x01DF
  ,simpleTitleCaseMapping:0x01DE
 },
 { code:0x01DF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01DE
  ,simpleLowerCaseMapping:0x01DF
  ,simpleTitleCaseMapping:0x01DE
 },
 { code:0x01E0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01E0
  ,simpleLowerCaseMapping:0x01E1
  ,simpleTitleCaseMapping:0x01E0
 },
 { code:0x01E1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01E0
  ,simpleLowerCaseMapping:0x01E1
  ,simpleTitleCaseMapping:0x01E0
 },
 { code:0x01E2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01E2
  ,simpleLowerCaseMapping:0x01E3
  ,simpleTitleCaseMapping:0x01E2
 },
 { code:0x01E3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01E2
  ,simpleLowerCaseMapping:0x01E3
  ,simpleTitleCaseMapping:0x01E2
 },
 { code:0x01E4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01E4
  ,simpleLowerCaseMapping:0x01E5
  ,simpleTitleCaseMapping:0x01E4
 },
 { code:0x01E5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01E4
  ,simpleLowerCaseMapping:0x01E5
  ,simpleTitleCaseMapping:0x01E4
 },
 { code:0x01E6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01E6
  ,simpleLowerCaseMapping:0x01E7
  ,simpleTitleCaseMapping:0x01E6
 },
 { code:0x01E7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01E6
  ,simpleLowerCaseMapping:0x01E7
  ,simpleTitleCaseMapping:0x01E6
 },
 { code:0x01E8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01E8
  ,simpleLowerCaseMapping:0x01E9
  ,simpleTitleCaseMapping:0x01E8
 },
 { code:0x01E9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01E8
  ,simpleLowerCaseMapping:0x01E9
  ,simpleTitleCaseMapping:0x01E8
 },
 { code:0x01EA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01EA
  ,simpleLowerCaseMapping:0x01EB
  ,simpleTitleCaseMapping:0x01EA
 },
 { code:0x01EB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01EA
  ,simpleLowerCaseMapping:0x01EB
  ,simpleTitleCaseMapping:0x01EA
 },
 { code:0x01EC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01EC
  ,simpleLowerCaseMapping:0x01ED
  ,simpleTitleCaseMapping:0x01EC
 },
 { code:0x01ED
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01EC
  ,simpleLowerCaseMapping:0x01ED
  ,simpleTitleCaseMapping:0x01EC
 },
 { code:0x01EE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01EE
  ,simpleLowerCaseMapping:0x01EF
  ,simpleTitleCaseMapping:0x01EE
 },
 { code:0x01EF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01EE
  ,simpleLowerCaseMapping:0x01EF
  ,simpleTitleCaseMapping:0x01EE
 },
 { code:0x01F0
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x01F0
  ,simpleLowerCaseMapping:0x01F0
  ,simpleTitleCaseMapping:0x01F0
 },
 { code:0x01F1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01F1
  ,simpleLowerCaseMapping:0x01F3
  ,simpleTitleCaseMapping:0x01F2
 },
 { code:0x01F2
  ,generalCategory:UnicodeData.GeneralCategory.Lt
  ,simpleUpperCaseMapping:0x01F1
  ,simpleLowerCaseMapping:0x01F3
  ,simpleTitleCaseMapping:0x01F2
 },
 { code:0x01F3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01F1
  ,simpleLowerCaseMapping:0x01F3
  ,simpleTitleCaseMapping:0x01F2
 },
 { code:0x01F4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01F4
  ,simpleLowerCaseMapping:0x01F5
  ,simpleTitleCaseMapping:0x01F4
 },
 { code:0x01F5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01F4
  ,simpleLowerCaseMapping:0x01F5
  ,simpleTitleCaseMapping:0x01F4
 },
 { code:0x01F6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01F6
  ,simpleLowerCaseMapping:0x0195
  ,simpleTitleCaseMapping:0x01F6
 },
 { code:0x01F7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01F7
  ,simpleLowerCaseMapping:0x01BF
  ,simpleTitleCaseMapping:0x01F7
 },
 { code:0x01F8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01F8
  ,simpleLowerCaseMapping:0x01F9
  ,simpleTitleCaseMapping:0x01F8
 },
 { code:0x01F9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01F8
  ,simpleLowerCaseMapping:0x01F9
  ,simpleTitleCaseMapping:0x01F8
 },
 { code:0x01FA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01FA
  ,simpleLowerCaseMapping:0x01FB
  ,simpleTitleCaseMapping:0x01FA
 },
 { code:0x01FB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01FA
  ,simpleLowerCaseMapping:0x01FB
  ,simpleTitleCaseMapping:0x01FA
 },
 { code:0x01FC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01FC
  ,simpleLowerCaseMapping:0x01FD
  ,simpleTitleCaseMapping:0x01FC
 },
 { code:0x01FD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01FC
  ,simpleLowerCaseMapping:0x01FD
  ,simpleTitleCaseMapping:0x01FC
 },
 { code:0x01FE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x01FE
  ,simpleLowerCaseMapping:0x01FF
  ,simpleTitleCaseMapping:0x01FE
 },
 { code:0x01FF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01FE
  ,simpleLowerCaseMapping:0x01FF
  ,simpleTitleCaseMapping:0x01FE
 },
 { code:0x0200
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0200
  ,simpleLowerCaseMapping:0x0201
  ,simpleTitleCaseMapping:0x0200
 },
 { code:0x0201
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0200
  ,simpleLowerCaseMapping:0x0201
  ,simpleTitleCaseMapping:0x0200
 },
 { code:0x0202
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0202
  ,simpleLowerCaseMapping:0x0203
  ,simpleTitleCaseMapping:0x0202
 },
 { code:0x0203
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0202
  ,simpleLowerCaseMapping:0x0203
  ,simpleTitleCaseMapping:0x0202
 },
 { code:0x0204
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0204
  ,simpleLowerCaseMapping:0x0205
  ,simpleTitleCaseMapping:0x0204
 },
 { code:0x0205
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0204
  ,simpleLowerCaseMapping:0x0205
  ,simpleTitleCaseMapping:0x0204
 },
 { code:0x0206
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0206
  ,simpleLowerCaseMapping:0x0207
  ,simpleTitleCaseMapping:0x0206
 },
 { code:0x0207
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0206
  ,simpleLowerCaseMapping:0x0207
  ,simpleTitleCaseMapping:0x0206
 },
 { code:0x0208
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0208
  ,simpleLowerCaseMapping:0x0209
  ,simpleTitleCaseMapping:0x0208
 },
 { code:0x0209
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0208
  ,simpleLowerCaseMapping:0x0209
  ,simpleTitleCaseMapping:0x0208
 },
 { code:0x020A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x020A
  ,simpleLowerCaseMapping:0x020B
  ,simpleTitleCaseMapping:0x020A
 },
 { code:0x020B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x020A
  ,simpleLowerCaseMapping:0x020B
  ,simpleTitleCaseMapping:0x020A
 },
 { code:0x020C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x020C
  ,simpleLowerCaseMapping:0x020D
  ,simpleTitleCaseMapping:0x020C
 },
 { code:0x020D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x020C
  ,simpleLowerCaseMapping:0x020D
  ,simpleTitleCaseMapping:0x020C
 },
 { code:0x020E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x020E
  ,simpleLowerCaseMapping:0x020F
  ,simpleTitleCaseMapping:0x020E
 },
 { code:0x020F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x020E
  ,simpleLowerCaseMapping:0x020F
  ,simpleTitleCaseMapping:0x020E
 },
 { code:0x0210
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0210
  ,simpleLowerCaseMapping:0x0211
  ,simpleTitleCaseMapping:0x0210
 },
 { code:0x0211
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0210
  ,simpleLowerCaseMapping:0x0211
  ,simpleTitleCaseMapping:0x0210
 },
 { code:0x0212
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0212
  ,simpleLowerCaseMapping:0x0213
  ,simpleTitleCaseMapping:0x0212
 },
 { code:0x0213
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0212
  ,simpleLowerCaseMapping:0x0213
  ,simpleTitleCaseMapping:0x0212
 },
 { code:0x0214
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0214
  ,simpleLowerCaseMapping:0x0215
  ,simpleTitleCaseMapping:0x0214
 },
 { code:0x0215
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0214
  ,simpleLowerCaseMapping:0x0215
  ,simpleTitleCaseMapping:0x0214
 },
 { code:0x0216
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0216
  ,simpleLowerCaseMapping:0x0217
  ,simpleTitleCaseMapping:0x0216
 },
 { code:0x0217
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0216
  ,simpleLowerCaseMapping:0x0217
  ,simpleTitleCaseMapping:0x0216
 },
 { code:0x0218
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0218
  ,simpleLowerCaseMapping:0x0219
  ,simpleTitleCaseMapping:0x0218
 },
 { code:0x0219
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0218
  ,simpleLowerCaseMapping:0x0219
  ,simpleTitleCaseMapping:0x0218
 },
 { code:0x021A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x021A
  ,simpleLowerCaseMapping:0x021B
  ,simpleTitleCaseMapping:0x021A
 },
 { code:0x021B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x021A
  ,simpleLowerCaseMapping:0x021B
  ,simpleTitleCaseMapping:0x021A
 },
 { code:0x021C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x021C
  ,simpleLowerCaseMapping:0x021D
  ,simpleTitleCaseMapping:0x021C
 },
 { code:0x021D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x021C
  ,simpleLowerCaseMapping:0x021D
  ,simpleTitleCaseMapping:0x021C
 },
 { code:0x021E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x021E
  ,simpleLowerCaseMapping:0x021F
  ,simpleTitleCaseMapping:0x021E
 },
 { code:0x021F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x021E
  ,simpleLowerCaseMapping:0x021F
  ,simpleTitleCaseMapping:0x021E
 },
 { code:0x0220
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0220
  ,simpleLowerCaseMapping:0x019E
  ,simpleTitleCaseMapping:0x0220
 },
 { code:0x0221
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0221
  ,simpleLowerCaseMapping:0x0221
  ,simpleTitleCaseMapping:0x0221
 },
 { code:0x0222
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0222
  ,simpleLowerCaseMapping:0x0223
  ,simpleTitleCaseMapping:0x0222
 },
 { code:0x0223
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0222
  ,simpleLowerCaseMapping:0x0223
  ,simpleTitleCaseMapping:0x0222
 },
 { code:0x0224
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0224
  ,simpleLowerCaseMapping:0x0225
  ,simpleTitleCaseMapping:0x0224
 },
 { code:0x0225
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0224
  ,simpleLowerCaseMapping:0x0225
  ,simpleTitleCaseMapping:0x0224
 },
 { code:0x0226
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0226
  ,simpleLowerCaseMapping:0x0227
  ,simpleTitleCaseMapping:0x0226
 },
 { code:0x0227
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0226
  ,simpleLowerCaseMapping:0x0227
  ,simpleTitleCaseMapping:0x0226
 },
 { code:0x0228
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0228
  ,simpleLowerCaseMapping:0x0229
  ,simpleTitleCaseMapping:0x0228
 },
 { code:0x0229
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0228
  ,simpleLowerCaseMapping:0x0229
  ,simpleTitleCaseMapping:0x0228
 },
 { code:0x022A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x022A
  ,simpleLowerCaseMapping:0x022B
  ,simpleTitleCaseMapping:0x022A
 },
 { code:0x022B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x022A
  ,simpleLowerCaseMapping:0x022B
  ,simpleTitleCaseMapping:0x022A
 },
 { code:0x022C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x022C
  ,simpleLowerCaseMapping:0x022D
  ,simpleTitleCaseMapping:0x022C
 },
 { code:0x022D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x022C
  ,simpleLowerCaseMapping:0x022D
  ,simpleTitleCaseMapping:0x022C
 },
 { code:0x022E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x022E
  ,simpleLowerCaseMapping:0x022F
  ,simpleTitleCaseMapping:0x022E
 },
 { code:0x022F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x022E
  ,simpleLowerCaseMapping:0x022F
  ,simpleTitleCaseMapping:0x022E
 },
 { code:0x0230
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0230
  ,simpleLowerCaseMapping:0x0231
  ,simpleTitleCaseMapping:0x0230
 },
 { code:0x0231
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0230
  ,simpleLowerCaseMapping:0x0231
  ,simpleTitleCaseMapping:0x0230
 },
 { code:0x0232
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0232
  ,simpleLowerCaseMapping:0x0233
  ,simpleTitleCaseMapping:0x0232
 },
 { code:0x0233
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0232
  ,simpleLowerCaseMapping:0x0233
  ,simpleTitleCaseMapping:0x0232
 },
 { code:0x0234
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0234
  ,simpleLowerCaseMapping:0x0234
  ,simpleTitleCaseMapping:0x0234
 },
 { code:0x0235
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0235
  ,simpleLowerCaseMapping:0x0235
  ,simpleTitleCaseMapping:0x0235
 },
 { code:0x0236
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0236
  ,simpleLowerCaseMapping:0x0236
  ,simpleTitleCaseMapping:0x0236
 },
 { code:0x0237
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0237
  ,simpleLowerCaseMapping:0x0237
  ,simpleTitleCaseMapping:0x0237
 },
 { code:0x0238
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0238
  ,simpleLowerCaseMapping:0x0238
  ,simpleTitleCaseMapping:0x0238
 },
 { code:0x0239
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0239
  ,simpleLowerCaseMapping:0x0239
  ,simpleTitleCaseMapping:0x0239
 },
 { code:0x023A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x023A
  ,simpleLowerCaseMapping:0x2C65
  ,simpleTitleCaseMapping:0x023A
 },
 { code:0x023B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x023B
  ,simpleLowerCaseMapping:0x023C
  ,simpleTitleCaseMapping:0x023B
 },
 { code:0x023C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x023B
  ,simpleLowerCaseMapping:0x023C
  ,simpleTitleCaseMapping:0x023B
 },
 { code:0x023D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x023D
  ,simpleLowerCaseMapping:0x019A
  ,simpleTitleCaseMapping:0x023D
 },
 { code:0x023E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x023E
  ,simpleLowerCaseMapping:0x2C66
  ,simpleTitleCaseMapping:0x023E
 },
 { code:0x023F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x023F
  ,simpleLowerCaseMapping:0x023F
  ,simpleTitleCaseMapping:0x023F
 },
 { code:0x0240
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0240
  ,simpleLowerCaseMapping:0x0240
  ,simpleTitleCaseMapping:0x0240
 },
 { code:0x0241
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0241
  ,simpleLowerCaseMapping:0x0242
  ,simpleTitleCaseMapping:0x0241
 },
 { code:0x0242
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0241
  ,simpleLowerCaseMapping:0x0242
  ,simpleTitleCaseMapping:0x0241
 },
 { code:0x0243
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0243
  ,simpleLowerCaseMapping:0x0180
  ,simpleTitleCaseMapping:0x0243
 },
 { code:0x0244
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0244
  ,simpleLowerCaseMapping:0x0289
  ,simpleTitleCaseMapping:0x0244
 },
 { code:0x0245
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0245
  ,simpleLowerCaseMapping:0x028C
  ,simpleTitleCaseMapping:0x0245
 },
 { code:0x0246
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0246
  ,simpleLowerCaseMapping:0x0247
  ,simpleTitleCaseMapping:0x0246
 },
 { code:0x0247
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0246
  ,simpleLowerCaseMapping:0x0247
  ,simpleTitleCaseMapping:0x0246
 },
 { code:0x0248
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0248
  ,simpleLowerCaseMapping:0x0249
  ,simpleTitleCaseMapping:0x0248
 },
 { code:0x0249
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0248
  ,simpleLowerCaseMapping:0x0249
  ,simpleTitleCaseMapping:0x0248
 },
 { code:0x024A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x024A
  ,simpleLowerCaseMapping:0x024B
  ,simpleTitleCaseMapping:0x024A
 },
 { code:0x024B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x024A
  ,simpleLowerCaseMapping:0x024B
  ,simpleTitleCaseMapping:0x024A
 },
 { code:0x024C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x024C
  ,simpleLowerCaseMapping:0x024D
  ,simpleTitleCaseMapping:0x024C
 },
 { code:0x024D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x024C
  ,simpleLowerCaseMapping:0x024D
  ,simpleTitleCaseMapping:0x024C
 },
 { code:0x024E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x024E
  ,simpleLowerCaseMapping:0x024F
  ,simpleTitleCaseMapping:0x024E
 },
 { code:0x024F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x024E
  ,simpleLowerCaseMapping:0x024F
  ,simpleTitleCaseMapping:0x024E
 },
 { code:0x0250
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0250
  ,simpleLowerCaseMapping:0x0250
  ,simpleTitleCaseMapping:0x0250
 },
 { code:0x0251
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0251
  ,simpleLowerCaseMapping:0x0251
  ,simpleTitleCaseMapping:0x0251
 },
 { code:0x0252
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0252
  ,simpleLowerCaseMapping:0x0252
  ,simpleTitleCaseMapping:0x0252
 },
 { code:0x0253
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0181
  ,simpleLowerCaseMapping:0x0253
  ,simpleTitleCaseMapping:0x0181
 },
 { code:0x0254
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0186
  ,simpleLowerCaseMapping:0x0254
  ,simpleTitleCaseMapping:0x0186
 },
 { code:0x0255
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0255
  ,simpleLowerCaseMapping:0x0255
  ,simpleTitleCaseMapping:0x0255
 },
 { code:0x0256
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0189
  ,simpleLowerCaseMapping:0x0256
  ,simpleTitleCaseMapping:0x0189
 },
 { code:0x0257
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x018A
  ,simpleLowerCaseMapping:0x0257
  ,simpleTitleCaseMapping:0x018A
 },
 { code:0x0258
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0258
  ,simpleLowerCaseMapping:0x0258
  ,simpleTitleCaseMapping:0x0258
 },
 { code:0x0259
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x018F
  ,simpleLowerCaseMapping:0x0259
  ,simpleTitleCaseMapping:0x018F
 },
 { code:0x025A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x025A
  ,simpleLowerCaseMapping:0x025A
  ,simpleTitleCaseMapping:0x025A
 },
 { code:0x025B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0190
  ,simpleLowerCaseMapping:0x025B
  ,simpleTitleCaseMapping:0x0190
 },
 { code:0x025C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x025C
  ,simpleLowerCaseMapping:0x025C
  ,simpleTitleCaseMapping:0x025C
 },
 { code:0x025D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x025D
  ,simpleLowerCaseMapping:0x025D
  ,simpleTitleCaseMapping:0x025D
 },
 { code:0x025E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x025E
  ,simpleLowerCaseMapping:0x025E
  ,simpleTitleCaseMapping:0x025E
 },
 { code:0x025F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x025F
  ,simpleLowerCaseMapping:0x025F
  ,simpleTitleCaseMapping:0x025F
 },
 { code:0x0260
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0193
  ,simpleLowerCaseMapping:0x0260
  ,simpleTitleCaseMapping:0x0193
 },
 { code:0x0261
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0261
  ,simpleLowerCaseMapping:0x0261
  ,simpleTitleCaseMapping:0x0261
 },
 { code:0x0262
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0262
  ,simpleLowerCaseMapping:0x0262
  ,simpleTitleCaseMapping:0x0262
 },
 { code:0x0263
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0194
  ,simpleLowerCaseMapping:0x0263
  ,simpleTitleCaseMapping:0x0194
 },
 { code:0x0264
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0264
  ,simpleLowerCaseMapping:0x0264
  ,simpleTitleCaseMapping:0x0264
 },
 { code:0x0265
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0265
  ,simpleLowerCaseMapping:0x0265
  ,simpleTitleCaseMapping:0x0265
 },
 { code:0x0266
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0266
  ,simpleLowerCaseMapping:0x0266
  ,simpleTitleCaseMapping:0x0266
 },
 { code:0x0267
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0267
  ,simpleLowerCaseMapping:0x0267
  ,simpleTitleCaseMapping:0x0267
 },
 { code:0x0268
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0197
  ,simpleLowerCaseMapping:0x0268
  ,simpleTitleCaseMapping:0x0197
 },
 { code:0x0269
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0196
  ,simpleLowerCaseMapping:0x0269
  ,simpleTitleCaseMapping:0x0196
 },
 { code:0x026A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x026A
  ,simpleLowerCaseMapping:0x026A
  ,simpleTitleCaseMapping:0x026A
 },
 { code:0x026B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C62
  ,simpleLowerCaseMapping:0x026B
  ,simpleTitleCaseMapping:0x2C62
 },
 { code:0x026C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x026C
  ,simpleLowerCaseMapping:0x026C
  ,simpleTitleCaseMapping:0x026C
 },
 { code:0x026D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x026D
  ,simpleLowerCaseMapping:0x026D
  ,simpleTitleCaseMapping:0x026D
 },
 { code:0x026E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x026E
  ,simpleLowerCaseMapping:0x026E
  ,simpleTitleCaseMapping:0x026E
 },
 { code:0x026F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x019C
  ,simpleLowerCaseMapping:0x026F
  ,simpleTitleCaseMapping:0x019C
 },
 { code:0x0270
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0270
  ,simpleLowerCaseMapping:0x0270
  ,simpleTitleCaseMapping:0x0270
 },
 { code:0x0271
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0271
  ,simpleLowerCaseMapping:0x0271
  ,simpleTitleCaseMapping:0x0271
 },
 { code:0x0272
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x019D
  ,simpleLowerCaseMapping:0x0272
  ,simpleTitleCaseMapping:0x019D
 },
 { code:0x0273
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0273
  ,simpleLowerCaseMapping:0x0273
  ,simpleTitleCaseMapping:0x0273
 },
 { code:0x0274
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0274
  ,simpleLowerCaseMapping:0x0274
  ,simpleTitleCaseMapping:0x0274
 },
 { code:0x0275
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x019F
  ,simpleLowerCaseMapping:0x0275
  ,simpleTitleCaseMapping:0x019F
 },
 { code:0x0276
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0276
  ,simpleLowerCaseMapping:0x0276
  ,simpleTitleCaseMapping:0x0276
 },
 { code:0x0277
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0277
  ,simpleLowerCaseMapping:0x0277
  ,simpleTitleCaseMapping:0x0277
 },
 { code:0x0278
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0278
  ,simpleLowerCaseMapping:0x0278
  ,simpleTitleCaseMapping:0x0278
 },
 { code:0x0279
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0279
  ,simpleLowerCaseMapping:0x0279
  ,simpleTitleCaseMapping:0x0279
 },
 { code:0x027A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x027A
  ,simpleLowerCaseMapping:0x027A
  ,simpleTitleCaseMapping:0x027A
 },
 { code:0x027B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x027B
  ,simpleLowerCaseMapping:0x027B
  ,simpleTitleCaseMapping:0x027B
 },
 { code:0x027C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x027C
  ,simpleLowerCaseMapping:0x027C
  ,simpleTitleCaseMapping:0x027C
 },
 { code:0x027D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C64
  ,simpleLowerCaseMapping:0x027D
  ,simpleTitleCaseMapping:0x2C64
 },
 { code:0x027E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x027E
  ,simpleLowerCaseMapping:0x027E
  ,simpleTitleCaseMapping:0x027E
 },
 { code:0x027F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x027F
  ,simpleLowerCaseMapping:0x027F
  ,simpleTitleCaseMapping:0x027F
 },
 { code:0x0280
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01A6
  ,simpleLowerCaseMapping:0x0280
  ,simpleTitleCaseMapping:0x01A6
 },
 { code:0x0281
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0281
  ,simpleLowerCaseMapping:0x0281
  ,simpleTitleCaseMapping:0x0281
 },
 { code:0x0282
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0282
  ,simpleLowerCaseMapping:0x0282
  ,simpleTitleCaseMapping:0x0282
 },
 { code:0x0283
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01A9
  ,simpleLowerCaseMapping:0x0283
  ,simpleTitleCaseMapping:0x01A9
 },
 { code:0x0284
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0284
  ,simpleLowerCaseMapping:0x0284
  ,simpleTitleCaseMapping:0x0284
 },
 { code:0x0285
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0285
  ,simpleLowerCaseMapping:0x0285
  ,simpleTitleCaseMapping:0x0285
 },
 { code:0x0286
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0286
  ,simpleLowerCaseMapping:0x0286
  ,simpleTitleCaseMapping:0x0286
 },
 { code:0x0287
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0287
  ,simpleLowerCaseMapping:0x0287
  ,simpleTitleCaseMapping:0x0287
 },
 { code:0x0288
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01AE
  ,simpleLowerCaseMapping:0x0288
  ,simpleTitleCaseMapping:0x01AE
 },
 { code:0x0289
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0244
  ,simpleLowerCaseMapping:0x0289
  ,simpleTitleCaseMapping:0x0244
 },
 { code:0x028A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01B1
  ,simpleLowerCaseMapping:0x028A
  ,simpleTitleCaseMapping:0x01B1
 },
 { code:0x028B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01B2
  ,simpleLowerCaseMapping:0x028B
  ,simpleTitleCaseMapping:0x01B2
 },
 { code:0x028C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0245
  ,simpleLowerCaseMapping:0x028C
  ,simpleTitleCaseMapping:0x0245
 },
 { code:0x028D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x028D
  ,simpleLowerCaseMapping:0x028D
  ,simpleTitleCaseMapping:0x028D
 },
 { code:0x028E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x028E
  ,simpleLowerCaseMapping:0x028E
  ,simpleTitleCaseMapping:0x028E
 },
 { code:0x028F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x028F
  ,simpleLowerCaseMapping:0x028F
  ,simpleTitleCaseMapping:0x028F
 },
 { code:0x0290
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0290
  ,simpleLowerCaseMapping:0x0290
  ,simpleTitleCaseMapping:0x0290
 },
 { code:0x0291
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0291
  ,simpleLowerCaseMapping:0x0291
  ,simpleTitleCaseMapping:0x0291
 },
 { code:0x0292
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x01B7
  ,simpleLowerCaseMapping:0x0292
  ,simpleTitleCaseMapping:0x01B7
 },
 { code:0x0293
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0293
  ,simpleLowerCaseMapping:0x0293
  ,simpleTitleCaseMapping:0x0293
 },
 { code:0x0294
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0294
  ,simpleLowerCaseMapping:0x0294
  ,simpleTitleCaseMapping:0x0294
 },
 { code:0x0295
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0295
  ,simpleLowerCaseMapping:0x0295
  ,simpleTitleCaseMapping:0x0295
 },
 { code:0x0296
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0296
  ,simpleLowerCaseMapping:0x0296
  ,simpleTitleCaseMapping:0x0296
 },
 { code:0x0297
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0297
  ,simpleLowerCaseMapping:0x0297
  ,simpleTitleCaseMapping:0x0297
 },
 { code:0x0298
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0298
  ,simpleLowerCaseMapping:0x0298
  ,simpleTitleCaseMapping:0x0298
 },
 { code:0x0299
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0299
  ,simpleLowerCaseMapping:0x0299
  ,simpleTitleCaseMapping:0x0299
 },
 { code:0x029A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x029A
  ,simpleLowerCaseMapping:0x029A
  ,simpleTitleCaseMapping:0x029A
 },
 { code:0x029B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x029B
  ,simpleLowerCaseMapping:0x029B
  ,simpleTitleCaseMapping:0x029B
 },
 { code:0x029C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x029C
  ,simpleLowerCaseMapping:0x029C
  ,simpleTitleCaseMapping:0x029C
 },
 { code:0x029D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x029D
  ,simpleLowerCaseMapping:0x029D
  ,simpleTitleCaseMapping:0x029D
 },
 { code:0x029E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x029E
  ,simpleLowerCaseMapping:0x029E
  ,simpleTitleCaseMapping:0x029E
 },
 { code:0x029F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x029F
  ,simpleLowerCaseMapping:0x029F
  ,simpleTitleCaseMapping:0x029F
 },
 { code:0x02A0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x02A0
  ,simpleLowerCaseMapping:0x02A0
  ,simpleTitleCaseMapping:0x02A0
 },
 { code:0x02A1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x02A1
  ,simpleLowerCaseMapping:0x02A1
  ,simpleTitleCaseMapping:0x02A1
 },
 { code:0x02A2
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x02A2
  ,simpleLowerCaseMapping:0x02A2
  ,simpleTitleCaseMapping:0x02A2
 },
 { code:0x02A3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x02A3
  ,simpleLowerCaseMapping:0x02A3
  ,simpleTitleCaseMapping:0x02A3
 },
 { code:0x02A4
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x02A4
  ,simpleLowerCaseMapping:0x02A4
  ,simpleTitleCaseMapping:0x02A4
 },
 { code:0x02A5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x02A5
  ,simpleLowerCaseMapping:0x02A5
  ,simpleTitleCaseMapping:0x02A5
 },
 { code:0x02A6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x02A6
  ,simpleLowerCaseMapping:0x02A6
  ,simpleTitleCaseMapping:0x02A6
 },
 { code:0x02A7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x02A7
  ,simpleLowerCaseMapping:0x02A7
  ,simpleTitleCaseMapping:0x02A7
 },
 { code:0x02A8
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x02A8
  ,simpleLowerCaseMapping:0x02A8
  ,simpleTitleCaseMapping:0x02A8
 },
 { code:0x02A9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x02A9
  ,simpleLowerCaseMapping:0x02A9
  ,simpleTitleCaseMapping:0x02A9
 },
 { code:0x02AA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x02AA
  ,simpleLowerCaseMapping:0x02AA
  ,simpleTitleCaseMapping:0x02AA
 },
 { code:0x02AB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x02AB
  ,simpleLowerCaseMapping:0x02AB
  ,simpleTitleCaseMapping:0x02AB
 },
 { code:0x02AC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x02AC
  ,simpleLowerCaseMapping:0x02AC
  ,simpleTitleCaseMapping:0x02AC
 },
 { code:0x02AD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x02AD
  ,simpleLowerCaseMapping:0x02AD
  ,simpleTitleCaseMapping:0x02AD
 },
 { code:0x02AE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x02AE
  ,simpleLowerCaseMapping:0x02AE
  ,simpleTitleCaseMapping:0x02AE
 },
 { code:0x02AF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x02AF
  ,simpleLowerCaseMapping:0x02AF
  ,simpleTitleCaseMapping:0x02AF
 },
 { code:0x02B0
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02B0
  ,simpleLowerCaseMapping:0x02B0
  ,simpleTitleCaseMapping:0x02B0
 },
 { code:0x02B1
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02B1
  ,simpleLowerCaseMapping:0x02B1
  ,simpleTitleCaseMapping:0x02B1
 },
 { code:0x02B2
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02B2
  ,simpleLowerCaseMapping:0x02B2
  ,simpleTitleCaseMapping:0x02B2
 },
 { code:0x02B3
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02B3
  ,simpleLowerCaseMapping:0x02B3
  ,simpleTitleCaseMapping:0x02B3
 },
 { code:0x02B4
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02B4
  ,simpleLowerCaseMapping:0x02B4
  ,simpleTitleCaseMapping:0x02B4
 },
 { code:0x02B5
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02B5
  ,simpleLowerCaseMapping:0x02B5
  ,simpleTitleCaseMapping:0x02B5
 },
 { code:0x02B6
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02B6
  ,simpleLowerCaseMapping:0x02B6
  ,simpleTitleCaseMapping:0x02B6
 },
 { code:0x02B7
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02B7
  ,simpleLowerCaseMapping:0x02B7
  ,simpleTitleCaseMapping:0x02B7
 },
 { code:0x02B8
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02B8
  ,simpleLowerCaseMapping:0x02B8
  ,simpleTitleCaseMapping:0x02B8
 },
 { code:0x02B9
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02B9
  ,simpleLowerCaseMapping:0x02B9
  ,simpleTitleCaseMapping:0x02B9
 },
 { code:0x02BA
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02BA
  ,simpleLowerCaseMapping:0x02BA
  ,simpleTitleCaseMapping:0x02BA
 },
 { code:0x02BB
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02BB
  ,simpleLowerCaseMapping:0x02BB
  ,simpleTitleCaseMapping:0x02BB
 },
 { code:0x02BC
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02BC
  ,simpleLowerCaseMapping:0x02BC
  ,simpleTitleCaseMapping:0x02BC
 },
 { code:0x02BD
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02BD
  ,simpleLowerCaseMapping:0x02BD
  ,simpleTitleCaseMapping:0x02BD
 },
 { code:0x02BE
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02BE
  ,simpleLowerCaseMapping:0x02BE
  ,simpleTitleCaseMapping:0x02BE
 },
 { code:0x02BF
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02BF
  ,simpleLowerCaseMapping:0x02BF
  ,simpleTitleCaseMapping:0x02BF
 },
 { code:0x02C0
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02C0
  ,simpleLowerCaseMapping:0x02C0
  ,simpleTitleCaseMapping:0x02C0
 },
 { code:0x02C1
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02C1
  ,simpleLowerCaseMapping:0x02C1
  ,simpleTitleCaseMapping:0x02C1
 },
 { code:0x02C2
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02C2
  ,simpleLowerCaseMapping:0x02C2
  ,simpleTitleCaseMapping:0x02C2
 },
 { code:0x02C3
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02C3
  ,simpleLowerCaseMapping:0x02C3
  ,simpleTitleCaseMapping:0x02C3
 },
 { code:0x02C4
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02C4
  ,simpleLowerCaseMapping:0x02C4
  ,simpleTitleCaseMapping:0x02C4
 },
 { code:0x02C5
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02C5
  ,simpleLowerCaseMapping:0x02C5
  ,simpleTitleCaseMapping:0x02C5
 },
 { code:0x02C6
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02C6
  ,simpleLowerCaseMapping:0x02C6
  ,simpleTitleCaseMapping:0x02C6
 },
 { code:0x02C7
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02C7
  ,simpleLowerCaseMapping:0x02C7
  ,simpleTitleCaseMapping:0x02C7
 },
 { code:0x02C8
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02C8
  ,simpleLowerCaseMapping:0x02C8
  ,simpleTitleCaseMapping:0x02C8
 },
 { code:0x02C9
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02C9
  ,simpleLowerCaseMapping:0x02C9
  ,simpleTitleCaseMapping:0x02C9
 },
 { code:0x02CA
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02CA
  ,simpleLowerCaseMapping:0x02CA
  ,simpleTitleCaseMapping:0x02CA
 },
 { code:0x02CB
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02CB
  ,simpleLowerCaseMapping:0x02CB
  ,simpleTitleCaseMapping:0x02CB
 },
 { code:0x02CC
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02CC
  ,simpleLowerCaseMapping:0x02CC
  ,simpleTitleCaseMapping:0x02CC
 },
 { code:0x02CD
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02CD
  ,simpleLowerCaseMapping:0x02CD
  ,simpleTitleCaseMapping:0x02CD
 },
 { code:0x02CE
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02CE
  ,simpleLowerCaseMapping:0x02CE
  ,simpleTitleCaseMapping:0x02CE
 },
 { code:0x02CF
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02CF
  ,simpleLowerCaseMapping:0x02CF
  ,simpleTitleCaseMapping:0x02CF
 },
 { code:0x02D0
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02D0
  ,simpleLowerCaseMapping:0x02D0
  ,simpleTitleCaseMapping:0x02D0
 },
 { code:0x02D1
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02D1
  ,simpleLowerCaseMapping:0x02D1
  ,simpleTitleCaseMapping:0x02D1
 },
 { code:0x02D2
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02D2
  ,simpleLowerCaseMapping:0x02D2
  ,simpleTitleCaseMapping:0x02D2
 },
 { code:0x02D3
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02D3
  ,simpleLowerCaseMapping:0x02D3
  ,simpleTitleCaseMapping:0x02D3
 },
 { code:0x02D4
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02D4
  ,simpleLowerCaseMapping:0x02D4
  ,simpleTitleCaseMapping:0x02D4
 },
 { code:0x02D5
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02D5
  ,simpleLowerCaseMapping:0x02D5
  ,simpleTitleCaseMapping:0x02D5
 },
 { code:0x02D6
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02D6
  ,simpleLowerCaseMapping:0x02D6
  ,simpleTitleCaseMapping:0x02D6
 },
 { code:0x02D7
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02D7
  ,simpleLowerCaseMapping:0x02D7
  ,simpleTitleCaseMapping:0x02D7
 },
 { code:0x02D8
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02D8
  ,simpleLowerCaseMapping:0x02D8
  ,simpleTitleCaseMapping:0x02D8
 },
 { code:0x02D9
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02D9
  ,simpleLowerCaseMapping:0x02D9
  ,simpleTitleCaseMapping:0x02D9
 },
 { code:0x02DA
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02DA
  ,simpleLowerCaseMapping:0x02DA
  ,simpleTitleCaseMapping:0x02DA
 },
 { code:0x02DB
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02DB
  ,simpleLowerCaseMapping:0x02DB
  ,simpleTitleCaseMapping:0x02DB
 },
 { code:0x02DC
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02DC
  ,simpleLowerCaseMapping:0x02DC
  ,simpleTitleCaseMapping:0x02DC
 },
 { code:0x02DD
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02DD
  ,simpleLowerCaseMapping:0x02DD
  ,simpleTitleCaseMapping:0x02DD
 },
 { code:0x02DE
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02DE
  ,simpleLowerCaseMapping:0x02DE
  ,simpleTitleCaseMapping:0x02DE
 },
 { code:0x02DF
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02DF
  ,simpleLowerCaseMapping:0x02DF
  ,simpleTitleCaseMapping:0x02DF
 },
 { code:0x02E0
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02E0
  ,simpleLowerCaseMapping:0x02E0
  ,simpleTitleCaseMapping:0x02E0
 },
 { code:0x02E1
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02E1
  ,simpleLowerCaseMapping:0x02E1
  ,simpleTitleCaseMapping:0x02E1
 },
 { code:0x02E2
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02E2
  ,simpleLowerCaseMapping:0x02E2
  ,simpleTitleCaseMapping:0x02E2
 },
 { code:0x02E3
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02E3
  ,simpleLowerCaseMapping:0x02E3
  ,simpleTitleCaseMapping:0x02E3
 },
 { code:0x02E4
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02E4
  ,simpleLowerCaseMapping:0x02E4
  ,simpleTitleCaseMapping:0x02E4
 },
 { code:0x02E5
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02E5
  ,simpleLowerCaseMapping:0x02E5
  ,simpleTitleCaseMapping:0x02E5
 },
 { code:0x02E6
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02E6
  ,simpleLowerCaseMapping:0x02E6
  ,simpleTitleCaseMapping:0x02E6
 },
 { code:0x02E7
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02E7
  ,simpleLowerCaseMapping:0x02E7
  ,simpleTitleCaseMapping:0x02E7
 },
 { code:0x02E8
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02E8
  ,simpleLowerCaseMapping:0x02E8
  ,simpleTitleCaseMapping:0x02E8
 },
 { code:0x02E9
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02E9
  ,simpleLowerCaseMapping:0x02E9
  ,simpleTitleCaseMapping:0x02E9
 },
 { code:0x02EA
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02EA
  ,simpleLowerCaseMapping:0x02EA
  ,simpleTitleCaseMapping:0x02EA
 },
 { code:0x02EB
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02EB
  ,simpleLowerCaseMapping:0x02EB
  ,simpleTitleCaseMapping:0x02EB
 },
 { code:0x02EC
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02EC
  ,simpleLowerCaseMapping:0x02EC
  ,simpleTitleCaseMapping:0x02EC
 },
 { code:0x02ED
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02ED
  ,simpleLowerCaseMapping:0x02ED
  ,simpleTitleCaseMapping:0x02ED
 },
 { code:0x02EE
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x02EE
  ,simpleLowerCaseMapping:0x02EE
  ,simpleTitleCaseMapping:0x02EE
 },
 { code:0x02EF
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02EF
  ,simpleLowerCaseMapping:0x02EF
  ,simpleTitleCaseMapping:0x02EF
 },
 { code:0x02F0
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02F0
  ,simpleLowerCaseMapping:0x02F0
  ,simpleTitleCaseMapping:0x02F0
 },
 { code:0x02F1
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02F1
  ,simpleLowerCaseMapping:0x02F1
  ,simpleTitleCaseMapping:0x02F1
 },
 { code:0x02F2
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02F2
  ,simpleLowerCaseMapping:0x02F2
  ,simpleTitleCaseMapping:0x02F2
 },
 { code:0x02F3
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02F3
  ,simpleLowerCaseMapping:0x02F3
  ,simpleTitleCaseMapping:0x02F3
 },
 { code:0x02F4
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02F4
  ,simpleLowerCaseMapping:0x02F4
  ,simpleTitleCaseMapping:0x02F4
 },
 { code:0x02F5
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02F5
  ,simpleLowerCaseMapping:0x02F5
  ,simpleTitleCaseMapping:0x02F5
 },
 { code:0x02F6
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02F6
  ,simpleLowerCaseMapping:0x02F6
  ,simpleTitleCaseMapping:0x02F6
 },
 { code:0x02F7
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02F7
  ,simpleLowerCaseMapping:0x02F7
  ,simpleTitleCaseMapping:0x02F7
 },
 { code:0x02F8
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02F8
  ,simpleLowerCaseMapping:0x02F8
  ,simpleTitleCaseMapping:0x02F8
 },
 { code:0x02F9
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02F9
  ,simpleLowerCaseMapping:0x02F9
  ,simpleTitleCaseMapping:0x02F9
 },
 { code:0x02FA
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02FA
  ,simpleLowerCaseMapping:0x02FA
  ,simpleTitleCaseMapping:0x02FA
 },
 { code:0x02FB
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02FB
  ,simpleLowerCaseMapping:0x02FB
  ,simpleTitleCaseMapping:0x02FB
 },
 { code:0x02FC
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02FC
  ,simpleLowerCaseMapping:0x02FC
  ,simpleTitleCaseMapping:0x02FC
 },
 { code:0x02FD
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02FD
  ,simpleLowerCaseMapping:0x02FD
  ,simpleTitleCaseMapping:0x02FD
 },
 { code:0x02FE
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02FE
  ,simpleLowerCaseMapping:0x02FE
  ,simpleTitleCaseMapping:0x02FE
 },
 { code:0x02FF
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x02FF
  ,simpleLowerCaseMapping:0x02FF
  ,simpleTitleCaseMapping:0x02FF
 },
 { code:0x0300
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0300
  ,simpleLowerCaseMapping:0x0300
  ,simpleTitleCaseMapping:0x0300
 },
 { code:0x0301
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0301
  ,simpleLowerCaseMapping:0x0301
  ,simpleTitleCaseMapping:0x0301
 },
 { code:0x0302
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0302
  ,simpleLowerCaseMapping:0x0302
  ,simpleTitleCaseMapping:0x0302
 },
 { code:0x0303
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0303
  ,simpleLowerCaseMapping:0x0303
  ,simpleTitleCaseMapping:0x0303
 },
 { code:0x0304
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0304
  ,simpleLowerCaseMapping:0x0304
  ,simpleTitleCaseMapping:0x0304
 },
 { code:0x0305
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0305
  ,simpleLowerCaseMapping:0x0305
  ,simpleTitleCaseMapping:0x0305
 },
 { code:0x0306
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0306
  ,simpleLowerCaseMapping:0x0306
  ,simpleTitleCaseMapping:0x0306
 },
 { code:0x0307
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0307
  ,simpleLowerCaseMapping:0x0307
  ,simpleTitleCaseMapping:0x0307
 },
 { code:0x0308
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0308
  ,simpleLowerCaseMapping:0x0308
  ,simpleTitleCaseMapping:0x0308
 },
 { code:0x0309
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0309
  ,simpleLowerCaseMapping:0x0309
  ,simpleTitleCaseMapping:0x0309
 },
 { code:0x030A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x030A
  ,simpleLowerCaseMapping:0x030A
  ,simpleTitleCaseMapping:0x030A
 },
 { code:0x030B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x030B
  ,simpleLowerCaseMapping:0x030B
  ,simpleTitleCaseMapping:0x030B
 },
 { code:0x030C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x030C
  ,simpleLowerCaseMapping:0x030C
  ,simpleTitleCaseMapping:0x030C
 },
 { code:0x030D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x030D
  ,simpleLowerCaseMapping:0x030D
  ,simpleTitleCaseMapping:0x030D
 },
 { code:0x030E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x030E
  ,simpleLowerCaseMapping:0x030E
  ,simpleTitleCaseMapping:0x030E
 },
 { code:0x030F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x030F
  ,simpleLowerCaseMapping:0x030F
  ,simpleTitleCaseMapping:0x030F
 },
 { code:0x0310
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0310
  ,simpleLowerCaseMapping:0x0310
  ,simpleTitleCaseMapping:0x0310
 },
 { code:0x0311
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0311
  ,simpleLowerCaseMapping:0x0311
  ,simpleTitleCaseMapping:0x0311
 },
 { code:0x0312
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0312
  ,simpleLowerCaseMapping:0x0312
  ,simpleTitleCaseMapping:0x0312
 },
 { code:0x0313
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0313
  ,simpleLowerCaseMapping:0x0313
  ,simpleTitleCaseMapping:0x0313
 },
 { code:0x0314
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0314
  ,simpleLowerCaseMapping:0x0314
  ,simpleTitleCaseMapping:0x0314
 },
 { code:0x0315
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0315
  ,simpleLowerCaseMapping:0x0315
  ,simpleTitleCaseMapping:0x0315
 },
 { code:0x0316
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0316
  ,simpleLowerCaseMapping:0x0316
  ,simpleTitleCaseMapping:0x0316
 },
 { code:0x0317
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0317
  ,simpleLowerCaseMapping:0x0317
  ,simpleTitleCaseMapping:0x0317
 },
 { code:0x0318
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0318
  ,simpleLowerCaseMapping:0x0318
  ,simpleTitleCaseMapping:0x0318
 },
 { code:0x0319
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0319
  ,simpleLowerCaseMapping:0x0319
  ,simpleTitleCaseMapping:0x0319
 },
 { code:0x031A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x031A
  ,simpleLowerCaseMapping:0x031A
  ,simpleTitleCaseMapping:0x031A
 },
 { code:0x031B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x031B
  ,simpleLowerCaseMapping:0x031B
  ,simpleTitleCaseMapping:0x031B
 },
 { code:0x031C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x031C
  ,simpleLowerCaseMapping:0x031C
  ,simpleTitleCaseMapping:0x031C
 },
 { code:0x031D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x031D
  ,simpleLowerCaseMapping:0x031D
  ,simpleTitleCaseMapping:0x031D
 },
 { code:0x031E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x031E
  ,simpleLowerCaseMapping:0x031E
  ,simpleTitleCaseMapping:0x031E
 },
 { code:0x031F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x031F
  ,simpleLowerCaseMapping:0x031F
  ,simpleTitleCaseMapping:0x031F
 },
 { code:0x0320
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0320
  ,simpleLowerCaseMapping:0x0320
  ,simpleTitleCaseMapping:0x0320
 },
 { code:0x0321
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0321
  ,simpleLowerCaseMapping:0x0321
  ,simpleTitleCaseMapping:0x0321
 },
 { code:0x0322
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0322
  ,simpleLowerCaseMapping:0x0322
  ,simpleTitleCaseMapping:0x0322
 },
 { code:0x0323
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0323
  ,simpleLowerCaseMapping:0x0323
  ,simpleTitleCaseMapping:0x0323
 },
 { code:0x0324
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0324
  ,simpleLowerCaseMapping:0x0324
  ,simpleTitleCaseMapping:0x0324
 },
 { code:0x0325
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0325
  ,simpleLowerCaseMapping:0x0325
  ,simpleTitleCaseMapping:0x0325
 },
 { code:0x0326
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0326
  ,simpleLowerCaseMapping:0x0326
  ,simpleTitleCaseMapping:0x0326
 },
 { code:0x0327
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0327
  ,simpleLowerCaseMapping:0x0327
  ,simpleTitleCaseMapping:0x0327
 },
 { code:0x0328
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0328
  ,simpleLowerCaseMapping:0x0328
  ,simpleTitleCaseMapping:0x0328
 },
 { code:0x0329
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0329
  ,simpleLowerCaseMapping:0x0329
  ,simpleTitleCaseMapping:0x0329
 },
 { code:0x032A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x032A
  ,simpleLowerCaseMapping:0x032A
  ,simpleTitleCaseMapping:0x032A
 },
 { code:0x032B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x032B
  ,simpleLowerCaseMapping:0x032B
  ,simpleTitleCaseMapping:0x032B
 },
 { code:0x032C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x032C
  ,simpleLowerCaseMapping:0x032C
  ,simpleTitleCaseMapping:0x032C
 },
 { code:0x032D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x032D
  ,simpleLowerCaseMapping:0x032D
  ,simpleTitleCaseMapping:0x032D
 },
 { code:0x032E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x032E
  ,simpleLowerCaseMapping:0x032E
  ,simpleTitleCaseMapping:0x032E
 },
 { code:0x032F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x032F
  ,simpleLowerCaseMapping:0x032F
  ,simpleTitleCaseMapping:0x032F
 },
 { code:0x0330
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0330
  ,simpleLowerCaseMapping:0x0330
  ,simpleTitleCaseMapping:0x0330
 },
 { code:0x0331
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0331
  ,simpleLowerCaseMapping:0x0331
  ,simpleTitleCaseMapping:0x0331
 },
 { code:0x0332
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0332
  ,simpleLowerCaseMapping:0x0332
  ,simpleTitleCaseMapping:0x0332
 },
 { code:0x0333
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0333
  ,simpleLowerCaseMapping:0x0333
  ,simpleTitleCaseMapping:0x0333
 },
 { code:0x0334
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0334
  ,simpleLowerCaseMapping:0x0334
  ,simpleTitleCaseMapping:0x0334
 },
 { code:0x0335
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0335
  ,simpleLowerCaseMapping:0x0335
  ,simpleTitleCaseMapping:0x0335
 },
 { code:0x0336
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0336
  ,simpleLowerCaseMapping:0x0336
  ,simpleTitleCaseMapping:0x0336
 },
 { code:0x0337
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0337
  ,simpleLowerCaseMapping:0x0337
  ,simpleTitleCaseMapping:0x0337
 },
 { code:0x0338
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0338
  ,simpleLowerCaseMapping:0x0338
  ,simpleTitleCaseMapping:0x0338
 },
 { code:0x0339
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0339
  ,simpleLowerCaseMapping:0x0339
  ,simpleTitleCaseMapping:0x0339
 },
 { code:0x033A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x033A
  ,simpleLowerCaseMapping:0x033A
  ,simpleTitleCaseMapping:0x033A
 },
 { code:0x033B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x033B
  ,simpleLowerCaseMapping:0x033B
  ,simpleTitleCaseMapping:0x033B
 },
 { code:0x033C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x033C
  ,simpleLowerCaseMapping:0x033C
  ,simpleTitleCaseMapping:0x033C
 },
 { code:0x033D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x033D
  ,simpleLowerCaseMapping:0x033D
  ,simpleTitleCaseMapping:0x033D
 },
 { code:0x033E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x033E
  ,simpleLowerCaseMapping:0x033E
  ,simpleTitleCaseMapping:0x033E
 },
 { code:0x033F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x033F
  ,simpleLowerCaseMapping:0x033F
  ,simpleTitleCaseMapping:0x033F
 },
 { code:0x0340
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0340
  ,simpleLowerCaseMapping:0x0340
  ,simpleTitleCaseMapping:0x0340
 },
 { code:0x0341
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0341
  ,simpleLowerCaseMapping:0x0341
  ,simpleTitleCaseMapping:0x0341
 },
 { code:0x0342
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0342
  ,simpleLowerCaseMapping:0x0342
  ,simpleTitleCaseMapping:0x0342
 },
 { code:0x0343
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0343
  ,simpleLowerCaseMapping:0x0343
  ,simpleTitleCaseMapping:0x0343
 },
 { code:0x0344
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0344
  ,simpleLowerCaseMapping:0x0344
  ,simpleTitleCaseMapping:0x0344
 },
 { code:0x0345
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0399
  ,simpleLowerCaseMapping:0x0345
  ,simpleTitleCaseMapping:0x0399
 },
 { code:0x0346
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0346
  ,simpleLowerCaseMapping:0x0346
  ,simpleTitleCaseMapping:0x0346
 },
 { code:0x0347
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0347
  ,simpleLowerCaseMapping:0x0347
  ,simpleTitleCaseMapping:0x0347
 },
 { code:0x0348
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0348
  ,simpleLowerCaseMapping:0x0348
  ,simpleTitleCaseMapping:0x0348
 },
 { code:0x0349
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0349
  ,simpleLowerCaseMapping:0x0349
  ,simpleTitleCaseMapping:0x0349
 },
 { code:0x034A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x034A
  ,simpleLowerCaseMapping:0x034A
  ,simpleTitleCaseMapping:0x034A
 },
 { code:0x034B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x034B
  ,simpleLowerCaseMapping:0x034B
  ,simpleTitleCaseMapping:0x034B
 },
 { code:0x034C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x034C
  ,simpleLowerCaseMapping:0x034C
  ,simpleTitleCaseMapping:0x034C
 },
 { code:0x034D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x034D
  ,simpleLowerCaseMapping:0x034D
  ,simpleTitleCaseMapping:0x034D
 },
 { code:0x034E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x034E
  ,simpleLowerCaseMapping:0x034E
  ,simpleTitleCaseMapping:0x034E
 },
 { code:0x034F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x034F
  ,simpleLowerCaseMapping:0x034F
  ,simpleTitleCaseMapping:0x034F
 },
 { code:0x0350
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0350
  ,simpleLowerCaseMapping:0x0350
  ,simpleTitleCaseMapping:0x0350
 },
 { code:0x0351
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0351
  ,simpleLowerCaseMapping:0x0351
  ,simpleTitleCaseMapping:0x0351
 },
 { code:0x0352
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0352
  ,simpleLowerCaseMapping:0x0352
  ,simpleTitleCaseMapping:0x0352
 },
 { code:0x0353
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0353
  ,simpleLowerCaseMapping:0x0353
  ,simpleTitleCaseMapping:0x0353
 },
 { code:0x0354
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0354
  ,simpleLowerCaseMapping:0x0354
  ,simpleTitleCaseMapping:0x0354
 },
 { code:0x0355
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0355
  ,simpleLowerCaseMapping:0x0355
  ,simpleTitleCaseMapping:0x0355
 },
 { code:0x0356
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0356
  ,simpleLowerCaseMapping:0x0356
  ,simpleTitleCaseMapping:0x0356
 },
 { code:0x0357
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0357
  ,simpleLowerCaseMapping:0x0357
  ,simpleTitleCaseMapping:0x0357
 },
 { code:0x0358
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0358
  ,simpleLowerCaseMapping:0x0358
  ,simpleTitleCaseMapping:0x0358
 },
 { code:0x0359
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0359
  ,simpleLowerCaseMapping:0x0359
  ,simpleTitleCaseMapping:0x0359
 },
 { code:0x035A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x035A
  ,simpleLowerCaseMapping:0x035A
  ,simpleTitleCaseMapping:0x035A
 },
 { code:0x035B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x035B
  ,simpleLowerCaseMapping:0x035B
  ,simpleTitleCaseMapping:0x035B
 },
 { code:0x035C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x035C
  ,simpleLowerCaseMapping:0x035C
  ,simpleTitleCaseMapping:0x035C
 },
 { code:0x035D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x035D
  ,simpleLowerCaseMapping:0x035D
  ,simpleTitleCaseMapping:0x035D
 },
 { code:0x035E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x035E
  ,simpleLowerCaseMapping:0x035E
  ,simpleTitleCaseMapping:0x035E
 },
 { code:0x035F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x035F
  ,simpleLowerCaseMapping:0x035F
  ,simpleTitleCaseMapping:0x035F
 },
 { code:0x0360
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0360
  ,simpleLowerCaseMapping:0x0360
  ,simpleTitleCaseMapping:0x0360
 },
 { code:0x0361
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0361
  ,simpleLowerCaseMapping:0x0361
  ,simpleTitleCaseMapping:0x0361
 },
 { code:0x0362
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0362
  ,simpleLowerCaseMapping:0x0362
  ,simpleTitleCaseMapping:0x0362
 },
 { code:0x0363
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0363
  ,simpleLowerCaseMapping:0x0363
  ,simpleTitleCaseMapping:0x0363
 },
 { code:0x0364
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0364
  ,simpleLowerCaseMapping:0x0364
  ,simpleTitleCaseMapping:0x0364
 },
 { code:0x0365
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0365
  ,simpleLowerCaseMapping:0x0365
  ,simpleTitleCaseMapping:0x0365
 },
 { code:0x0366
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0366
  ,simpleLowerCaseMapping:0x0366
  ,simpleTitleCaseMapping:0x0366
 },
 { code:0x0367
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0367
  ,simpleLowerCaseMapping:0x0367
  ,simpleTitleCaseMapping:0x0367
 },
 { code:0x0368
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0368
  ,simpleLowerCaseMapping:0x0368
  ,simpleTitleCaseMapping:0x0368
 },
 { code:0x0369
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0369
  ,simpleLowerCaseMapping:0x0369
  ,simpleTitleCaseMapping:0x0369
 },
 { code:0x036A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x036A
  ,simpleLowerCaseMapping:0x036A
  ,simpleTitleCaseMapping:0x036A
 },
 { code:0x036B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x036B
  ,simpleLowerCaseMapping:0x036B
  ,simpleTitleCaseMapping:0x036B
 },
 { code:0x036C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x036C
  ,simpleLowerCaseMapping:0x036C
  ,simpleTitleCaseMapping:0x036C
 },
 { code:0x036D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x036D
  ,simpleLowerCaseMapping:0x036D
  ,simpleTitleCaseMapping:0x036D
 },
 { code:0x036E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x036E
  ,simpleLowerCaseMapping:0x036E
  ,simpleTitleCaseMapping:0x036E
 },
 { code:0x036F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x036F
  ,simpleLowerCaseMapping:0x036F
  ,simpleTitleCaseMapping:0x036F
 },
 { code:0x0374
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x0374
  ,simpleLowerCaseMapping:0x0374
  ,simpleTitleCaseMapping:0x0374
 },
 { code:0x0375
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x0375
  ,simpleLowerCaseMapping:0x0375
  ,simpleTitleCaseMapping:0x0375
 },
 { code:0x037A
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x037A
  ,simpleLowerCaseMapping:0x037A
  ,simpleTitleCaseMapping:0x037A
 },
 { code:0x037B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03FD
  ,simpleLowerCaseMapping:0x037B
  ,simpleTitleCaseMapping:0x03FD
 },
 { code:0x037C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03FE
  ,simpleLowerCaseMapping:0x037C
  ,simpleTitleCaseMapping:0x03FE
 },
 { code:0x037D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03FF
  ,simpleLowerCaseMapping:0x037D
  ,simpleTitleCaseMapping:0x03FF
 },
 { code:0x037E
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x037E
  ,simpleLowerCaseMapping:0x037E
  ,simpleTitleCaseMapping:0x037E
 },
 { code:0x0384
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x0384
  ,simpleLowerCaseMapping:0x0384
  ,simpleTitleCaseMapping:0x0384
 },
 { code:0x0385
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x0385
  ,simpleLowerCaseMapping:0x0385
  ,simpleTitleCaseMapping:0x0385
 },
 { code:0x0386
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0386
  ,simpleLowerCaseMapping:0x03AC
  ,simpleTitleCaseMapping:0x0386
 },
 { code:0x0387
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0387
  ,simpleLowerCaseMapping:0x0387
  ,simpleTitleCaseMapping:0x0387
 },
 { code:0x0388
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0388
  ,simpleLowerCaseMapping:0x03AD
  ,simpleTitleCaseMapping:0x0388
 },
 { code:0x0389
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0389
  ,simpleLowerCaseMapping:0x03AE
  ,simpleTitleCaseMapping:0x0389
 },
 { code:0x038A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x038A
  ,simpleLowerCaseMapping:0x03AF
  ,simpleTitleCaseMapping:0x038A
 },
 { code:0x038C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x038C
  ,simpleLowerCaseMapping:0x03CC
  ,simpleTitleCaseMapping:0x038C
 },
 { code:0x038E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x038E
  ,simpleLowerCaseMapping:0x03CD
  ,simpleTitleCaseMapping:0x038E
 },
 { code:0x038F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x038F
  ,simpleLowerCaseMapping:0x03CE
  ,simpleTitleCaseMapping:0x038F
 },
 { code:0x0390
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x0390
  ,simpleLowerCaseMapping:0x0390
  ,simpleTitleCaseMapping:0x0390
 },
 { code:0x0391
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0391
  ,simpleLowerCaseMapping:0x03B1
  ,simpleTitleCaseMapping:0x0391
 },
 { code:0x0392
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0392
  ,simpleLowerCaseMapping:0x03B2
  ,simpleTitleCaseMapping:0x0392
 },
 { code:0x0393
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0393
  ,simpleLowerCaseMapping:0x03B3
  ,simpleTitleCaseMapping:0x0393
 },
 { code:0x0394
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0394
  ,simpleLowerCaseMapping:0x03B4
  ,simpleTitleCaseMapping:0x0394
 },
 { code:0x0395
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0395
  ,simpleLowerCaseMapping:0x03B5
  ,simpleTitleCaseMapping:0x0395
 },
 { code:0x0396
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0396
  ,simpleLowerCaseMapping:0x03B6
  ,simpleTitleCaseMapping:0x0396
 },
 { code:0x0397
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0397
  ,simpleLowerCaseMapping:0x03B7
  ,simpleTitleCaseMapping:0x0397
 },
 { code:0x0398
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0398
  ,simpleLowerCaseMapping:0x03B8
  ,simpleTitleCaseMapping:0x0398
 },
 { code:0x0399
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0399
  ,simpleLowerCaseMapping:0x03B9
  ,simpleTitleCaseMapping:0x0399
 },
 { code:0x039A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x039A
  ,simpleLowerCaseMapping:0x03BA
  ,simpleTitleCaseMapping:0x039A
 },
 { code:0x039B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x039B
  ,simpleLowerCaseMapping:0x03BB
  ,simpleTitleCaseMapping:0x039B
 },
 { code:0x039C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x039C
  ,simpleLowerCaseMapping:0x03BC
  ,simpleTitleCaseMapping:0x039C
 },
 { code:0x039D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x039D
  ,simpleLowerCaseMapping:0x03BD
  ,simpleTitleCaseMapping:0x039D
 },
 { code:0x039E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x039E
  ,simpleLowerCaseMapping:0x03BE
  ,simpleTitleCaseMapping:0x039E
 },
 { code:0x039F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x039F
  ,simpleLowerCaseMapping:0x03BF
  ,simpleTitleCaseMapping:0x039F
 },
 { code:0x03A0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03A0
  ,simpleLowerCaseMapping:0x03C0
  ,simpleTitleCaseMapping:0x03A0
 },
 { code:0x03A1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03A1
  ,simpleLowerCaseMapping:0x03C1
  ,simpleTitleCaseMapping:0x03A1
 },
 { code:0x03A3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03A3
  ,simpleLowerCaseMapping:0x03C3
  ,simpleTitleCaseMapping:0x03A3
 },
 { code:0x03A4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03A4
  ,simpleLowerCaseMapping:0x03C4
  ,simpleTitleCaseMapping:0x03A4
 },
 { code:0x03A5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03A5
  ,simpleLowerCaseMapping:0x03C5
  ,simpleTitleCaseMapping:0x03A5
 },
 { code:0x03A6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03A6
  ,simpleLowerCaseMapping:0x03C6
  ,simpleTitleCaseMapping:0x03A6
 },
 { code:0x03A7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03A7
  ,simpleLowerCaseMapping:0x03C7
  ,simpleTitleCaseMapping:0x03A7
 },
 { code:0x03A8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03A8
  ,simpleLowerCaseMapping:0x03C8
  ,simpleTitleCaseMapping:0x03A8
 },
 { code:0x03A9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03A9
  ,simpleLowerCaseMapping:0x03C9
  ,simpleTitleCaseMapping:0x03A9
 },
 { code:0x03AA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03AA
  ,simpleLowerCaseMapping:0x03CA
  ,simpleTitleCaseMapping:0x03AA
 },
 { code:0x03AB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03AB
  ,simpleLowerCaseMapping:0x03CB
  ,simpleTitleCaseMapping:0x03AB
 },
 { code:0x03AC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0386
  ,simpleLowerCaseMapping:0x03AC
  ,simpleTitleCaseMapping:0x0386
 },
 { code:0x03AD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0388
  ,simpleLowerCaseMapping:0x03AD
  ,simpleTitleCaseMapping:0x0388
 },
 { code:0x03AE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0389
  ,simpleLowerCaseMapping:0x03AE
  ,simpleTitleCaseMapping:0x0389
 },
 { code:0x03AF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x038A
  ,simpleLowerCaseMapping:0x03AF
  ,simpleTitleCaseMapping:0x038A
 },
 { code:0x03B0
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x03B0
  ,simpleLowerCaseMapping:0x03B0
  ,simpleTitleCaseMapping:0x03B0
 },
 { code:0x03B1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0391
  ,simpleLowerCaseMapping:0x03B1
  ,simpleTitleCaseMapping:0x0391
 },
 { code:0x03B2
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0392
  ,simpleLowerCaseMapping:0x03B2
  ,simpleTitleCaseMapping:0x0392
 },
 { code:0x03B3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0393
  ,simpleLowerCaseMapping:0x03B3
  ,simpleTitleCaseMapping:0x0393
 },
 { code:0x03B4
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0394
  ,simpleLowerCaseMapping:0x03B4
  ,simpleTitleCaseMapping:0x0394
 },
 { code:0x03B5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0395
  ,simpleLowerCaseMapping:0x03B5
  ,simpleTitleCaseMapping:0x0395
 },
 { code:0x03B6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0396
  ,simpleLowerCaseMapping:0x03B6
  ,simpleTitleCaseMapping:0x0396
 },
 { code:0x03B7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0397
  ,simpleLowerCaseMapping:0x03B7
  ,simpleTitleCaseMapping:0x0397
 },
 { code:0x03B8
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0398
  ,simpleLowerCaseMapping:0x03B8
  ,simpleTitleCaseMapping:0x0398
 },
 { code:0x03B9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0399
  ,simpleLowerCaseMapping:0x03B9
  ,simpleTitleCaseMapping:0x0399
 },
 { code:0x03BA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x039A
  ,simpleLowerCaseMapping:0x03BA
  ,simpleTitleCaseMapping:0x039A
 },
 { code:0x03BB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x039B
  ,simpleLowerCaseMapping:0x03BB
  ,simpleTitleCaseMapping:0x039B
 },
 { code:0x03BC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x039C
  ,simpleLowerCaseMapping:0x03BC
  ,simpleTitleCaseMapping:0x039C
 },
 { code:0x03BD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x039D
  ,simpleLowerCaseMapping:0x03BD
  ,simpleTitleCaseMapping:0x039D
 },
 { code:0x03BE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x039E
  ,simpleLowerCaseMapping:0x03BE
  ,simpleTitleCaseMapping:0x039E
 },
 { code:0x03BF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x039F
  ,simpleLowerCaseMapping:0x03BF
  ,simpleTitleCaseMapping:0x039F
 },
 { code:0x03C0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03A0
  ,simpleLowerCaseMapping:0x03C0
  ,simpleTitleCaseMapping:0x03A0
 },
 { code:0x03C1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03A1
  ,simpleLowerCaseMapping:0x03C1
  ,simpleTitleCaseMapping:0x03A1
 },
 { code:0x03C2
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03A3
  ,simpleLowerCaseMapping:0x03C2
  ,simpleTitleCaseMapping:0x03A3
 },
 { code:0x03C3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03A3
  ,simpleLowerCaseMapping:0x03C3
  ,simpleTitleCaseMapping:0x03A3
 },
 { code:0x03C4
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03A4
  ,simpleLowerCaseMapping:0x03C4
  ,simpleTitleCaseMapping:0x03A4
 },
 { code:0x03C5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03A5
  ,simpleLowerCaseMapping:0x03C5
  ,simpleTitleCaseMapping:0x03A5
 },
 { code:0x03C6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03A6
  ,simpleLowerCaseMapping:0x03C6
  ,simpleTitleCaseMapping:0x03A6
 },
 { code:0x03C7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03A7
  ,simpleLowerCaseMapping:0x03C7
  ,simpleTitleCaseMapping:0x03A7
 },
 { code:0x03C8
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03A8
  ,simpleLowerCaseMapping:0x03C8
  ,simpleTitleCaseMapping:0x03A8
 },
 { code:0x03C9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03A9
  ,simpleLowerCaseMapping:0x03C9
  ,simpleTitleCaseMapping:0x03A9
 },
 { code:0x03CA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03AA
  ,simpleLowerCaseMapping:0x03CA
  ,simpleTitleCaseMapping:0x03AA
 },
 { code:0x03CB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03AB
  ,simpleLowerCaseMapping:0x03CB
  ,simpleTitleCaseMapping:0x03AB
 },
 { code:0x03CC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x038C
  ,simpleLowerCaseMapping:0x03CC
  ,simpleTitleCaseMapping:0x038C
 },
 { code:0x03CD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x038E
  ,simpleLowerCaseMapping:0x03CD
  ,simpleTitleCaseMapping:0x038E
 },
 { code:0x03CE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x038F
  ,simpleLowerCaseMapping:0x03CE
  ,simpleTitleCaseMapping:0x038F
 },
 { code:0x03D0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0392
  ,simpleLowerCaseMapping:0x03D0
  ,simpleTitleCaseMapping:0x0392
 },
 { code:0x03D1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0398
  ,simpleLowerCaseMapping:0x03D1
  ,simpleTitleCaseMapping:0x0398
 },
 { code:0x03D2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03D2
  ,simpleLowerCaseMapping:0x03D2
  ,simpleTitleCaseMapping:0x03D2
 },
 { code:0x03D3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03D3
  ,simpleLowerCaseMapping:0x03D3
  ,simpleTitleCaseMapping:0x03D3
 },
 { code:0x03D4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03D4
  ,simpleLowerCaseMapping:0x03D4
  ,simpleTitleCaseMapping:0x03D4
 },
 { code:0x03D5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03A6
  ,simpleLowerCaseMapping:0x03D5
  ,simpleTitleCaseMapping:0x03A6
 },
 { code:0x03D6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03A0
  ,simpleLowerCaseMapping:0x03D6
  ,simpleTitleCaseMapping:0x03A0
 },
 { code:0x03D7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03D7
  ,simpleLowerCaseMapping:0x03D7
  ,simpleTitleCaseMapping:0x03D7
 },
 { code:0x03D8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03D8
  ,simpleLowerCaseMapping:0x03D9
  ,simpleTitleCaseMapping:0x03D8
 },
 { code:0x03D9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03D8
  ,simpleLowerCaseMapping:0x03D9
  ,simpleTitleCaseMapping:0x03D8
 },
 { code:0x03DA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03DA
  ,simpleLowerCaseMapping:0x03DB
  ,simpleTitleCaseMapping:0x03DA
 },
 { code:0x03DB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03DA
  ,simpleLowerCaseMapping:0x03DB
  ,simpleTitleCaseMapping:0x03DA
 },
 { code:0x03DC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03DC
  ,simpleLowerCaseMapping:0x03DD
  ,simpleTitleCaseMapping:0x03DC
 },
 { code:0x03DD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03DC
  ,simpleLowerCaseMapping:0x03DD
  ,simpleTitleCaseMapping:0x03DC
 },
 { code:0x03DE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03DE
  ,simpleLowerCaseMapping:0x03DF
  ,simpleTitleCaseMapping:0x03DE
 },
 { code:0x03DF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03DE
  ,simpleLowerCaseMapping:0x03DF
  ,simpleTitleCaseMapping:0x03DE
 },
 { code:0x03E0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03E0
  ,simpleLowerCaseMapping:0x03E1
  ,simpleTitleCaseMapping:0x03E0
 },
 { code:0x03E1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03E0
  ,simpleLowerCaseMapping:0x03E1
  ,simpleTitleCaseMapping:0x03E0
 },
 { code:0x03E2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03E2
  ,simpleLowerCaseMapping:0x03E3
  ,simpleTitleCaseMapping:0x03E2
 },
 { code:0x03E3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03E2
  ,simpleLowerCaseMapping:0x03E3
  ,simpleTitleCaseMapping:0x03E2
 },
 { code:0x03E4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03E4
  ,simpleLowerCaseMapping:0x03E5
  ,simpleTitleCaseMapping:0x03E4
 },
 { code:0x03E5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03E4
  ,simpleLowerCaseMapping:0x03E5
  ,simpleTitleCaseMapping:0x03E4
 },
 { code:0x03E6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03E6
  ,simpleLowerCaseMapping:0x03E7
  ,simpleTitleCaseMapping:0x03E6
 },
 { code:0x03E7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03E6
  ,simpleLowerCaseMapping:0x03E7
  ,simpleTitleCaseMapping:0x03E6
 },
 { code:0x03E8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03E8
  ,simpleLowerCaseMapping:0x03E9
  ,simpleTitleCaseMapping:0x03E8
 },
 { code:0x03E9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03E8
  ,simpleLowerCaseMapping:0x03E9
  ,simpleTitleCaseMapping:0x03E8
 },
 { code:0x03EA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03EA
  ,simpleLowerCaseMapping:0x03EB
  ,simpleTitleCaseMapping:0x03EA
 },
 { code:0x03EB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03EA
  ,simpleLowerCaseMapping:0x03EB
  ,simpleTitleCaseMapping:0x03EA
 },
 { code:0x03EC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03EC
  ,simpleLowerCaseMapping:0x03ED
  ,simpleTitleCaseMapping:0x03EC
 },
 { code:0x03ED
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03EC
  ,simpleLowerCaseMapping:0x03ED
  ,simpleTitleCaseMapping:0x03EC
 },
 { code:0x03EE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03EE
  ,simpleLowerCaseMapping:0x03EF
  ,simpleTitleCaseMapping:0x03EE
 },
 { code:0x03EF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03EE
  ,simpleLowerCaseMapping:0x03EF
  ,simpleTitleCaseMapping:0x03EE
 },
 { code:0x03F0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x039A
  ,simpleLowerCaseMapping:0x03F0
  ,simpleTitleCaseMapping:0x039A
 },
 { code:0x03F1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03A1
  ,simpleLowerCaseMapping:0x03F1
  ,simpleTitleCaseMapping:0x03A1
 },
 { code:0x03F2
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03F9
  ,simpleLowerCaseMapping:0x03F2
  ,simpleTitleCaseMapping:0x03F9
 },
 { code:0x03F3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03F3
  ,simpleLowerCaseMapping:0x03F3
  ,simpleTitleCaseMapping:0x03F3
 },
 { code:0x03F4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03F4
  ,simpleLowerCaseMapping:0x03B8
  ,simpleTitleCaseMapping:0x03F4
 },
 { code:0x03F5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0395
  ,simpleLowerCaseMapping:0x03F5
  ,simpleTitleCaseMapping:0x0395
 },
 { code:0x03F6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x03F6
  ,simpleLowerCaseMapping:0x03F6
  ,simpleTitleCaseMapping:0x03F6
 },
 { code:0x03F7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03F7
  ,simpleLowerCaseMapping:0x03F8
  ,simpleTitleCaseMapping:0x03F7
 },
 { code:0x03F8
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03F7
  ,simpleLowerCaseMapping:0x03F8
  ,simpleTitleCaseMapping:0x03F7
 },
 { code:0x03F9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03F9
  ,simpleLowerCaseMapping:0x03F2
  ,simpleTitleCaseMapping:0x03F9
 },
 { code:0x03FA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03FA
  ,simpleLowerCaseMapping:0x03FB
  ,simpleTitleCaseMapping:0x03FA
 },
 { code:0x03FB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03FA
  ,simpleLowerCaseMapping:0x03FB
  ,simpleTitleCaseMapping:0x03FA
 },
 { code:0x03FC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x03FC
  ,simpleLowerCaseMapping:0x03FC
  ,simpleTitleCaseMapping:0x03FC
 },
 { code:0x03FD
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03FD
  ,simpleLowerCaseMapping:0x037B
  ,simpleTitleCaseMapping:0x03FD
 },
 { code:0x03FE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03FE
  ,simpleLowerCaseMapping:0x037C
  ,simpleTitleCaseMapping:0x03FE
 },
 { code:0x03FF
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x03FF
  ,simpleLowerCaseMapping:0x037D
  ,simpleTitleCaseMapping:0x03FF
 },
 { code:0x0400
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0400
  ,simpleLowerCaseMapping:0x0450
  ,simpleTitleCaseMapping:0x0400
 },
 { code:0x0401
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0401
  ,simpleLowerCaseMapping:0x0451
  ,simpleTitleCaseMapping:0x0401
 },
 { code:0x0402
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0402
  ,simpleLowerCaseMapping:0x0452
  ,simpleTitleCaseMapping:0x0402
 },
 { code:0x0403
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0403
  ,simpleLowerCaseMapping:0x0453
  ,simpleTitleCaseMapping:0x0403
 },
 { code:0x0404
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0404
  ,simpleLowerCaseMapping:0x0454
  ,simpleTitleCaseMapping:0x0404
 },
 { code:0x0405
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0405
  ,simpleLowerCaseMapping:0x0455
  ,simpleTitleCaseMapping:0x0405
 },
 { code:0x0406
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0406
  ,simpleLowerCaseMapping:0x0456
  ,simpleTitleCaseMapping:0x0406
 },
 { code:0x0407
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0407
  ,simpleLowerCaseMapping:0x0457
  ,simpleTitleCaseMapping:0x0407
 },
 { code:0x0408
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0408
  ,simpleLowerCaseMapping:0x0458
  ,simpleTitleCaseMapping:0x0408
 },
 { code:0x0409
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0409
  ,simpleLowerCaseMapping:0x0459
  ,simpleTitleCaseMapping:0x0409
 },
 { code:0x040A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x040A
  ,simpleLowerCaseMapping:0x045A
  ,simpleTitleCaseMapping:0x040A
 },
 { code:0x040B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x040B
  ,simpleLowerCaseMapping:0x045B
  ,simpleTitleCaseMapping:0x040B
 },
 { code:0x040C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x040C
  ,simpleLowerCaseMapping:0x045C
  ,simpleTitleCaseMapping:0x040C
 },
 { code:0x040D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x040D
  ,simpleLowerCaseMapping:0x045D
  ,simpleTitleCaseMapping:0x040D
 },
 { code:0x040E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x040E
  ,simpleLowerCaseMapping:0x045E
  ,simpleTitleCaseMapping:0x040E
 },
 { code:0x040F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x040F
  ,simpleLowerCaseMapping:0x045F
  ,simpleTitleCaseMapping:0x040F
 },
 { code:0x0410
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0410
  ,simpleLowerCaseMapping:0x0430
  ,simpleTitleCaseMapping:0x0410
 },
 { code:0x0411
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0411
  ,simpleLowerCaseMapping:0x0431
  ,simpleTitleCaseMapping:0x0411
 },
 { code:0x0412
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0412
  ,simpleLowerCaseMapping:0x0432
  ,simpleTitleCaseMapping:0x0412
 },
 { code:0x0413
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0413
  ,simpleLowerCaseMapping:0x0433
  ,simpleTitleCaseMapping:0x0413
 },
 { code:0x0414
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0414
  ,simpleLowerCaseMapping:0x0434
  ,simpleTitleCaseMapping:0x0414
 },
 { code:0x0415
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0415
  ,simpleLowerCaseMapping:0x0435
  ,simpleTitleCaseMapping:0x0415
 },
 { code:0x0416
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0416
  ,simpleLowerCaseMapping:0x0436
  ,simpleTitleCaseMapping:0x0416
 },
 { code:0x0417
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0417
  ,simpleLowerCaseMapping:0x0437
  ,simpleTitleCaseMapping:0x0417
 },
 { code:0x0418
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0418
  ,simpleLowerCaseMapping:0x0438
  ,simpleTitleCaseMapping:0x0418
 },
 { code:0x0419
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0419
  ,simpleLowerCaseMapping:0x0439
  ,simpleTitleCaseMapping:0x0419
 },
 { code:0x041A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x041A
  ,simpleLowerCaseMapping:0x043A
  ,simpleTitleCaseMapping:0x041A
 },
 { code:0x041B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x041B
  ,simpleLowerCaseMapping:0x043B
  ,simpleTitleCaseMapping:0x041B
 },
 { code:0x041C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x041C
  ,simpleLowerCaseMapping:0x043C
  ,simpleTitleCaseMapping:0x041C
 },
 { code:0x041D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x041D
  ,simpleLowerCaseMapping:0x043D
  ,simpleTitleCaseMapping:0x041D
 },
 { code:0x041E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x041E
  ,simpleLowerCaseMapping:0x043E
  ,simpleTitleCaseMapping:0x041E
 },
 { code:0x041F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x041F
  ,simpleLowerCaseMapping:0x043F
  ,simpleTitleCaseMapping:0x041F
 },
 { code:0x0420
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0420
  ,simpleLowerCaseMapping:0x0440
  ,simpleTitleCaseMapping:0x0420
 },
 { code:0x0421
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0421
  ,simpleLowerCaseMapping:0x0441
  ,simpleTitleCaseMapping:0x0421
 },
 { code:0x0422
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0422
  ,simpleLowerCaseMapping:0x0442
  ,simpleTitleCaseMapping:0x0422
 },
 { code:0x0423
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0423
  ,simpleLowerCaseMapping:0x0443
  ,simpleTitleCaseMapping:0x0423
 },
 { code:0x0424
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0424
  ,simpleLowerCaseMapping:0x0444
  ,simpleTitleCaseMapping:0x0424
 },
 { code:0x0425
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0425
  ,simpleLowerCaseMapping:0x0445
  ,simpleTitleCaseMapping:0x0425
 },
 { code:0x0426
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0426
  ,simpleLowerCaseMapping:0x0446
  ,simpleTitleCaseMapping:0x0426
 },
 { code:0x0427
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0427
  ,simpleLowerCaseMapping:0x0447
  ,simpleTitleCaseMapping:0x0427
 },
 { code:0x0428
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0428
  ,simpleLowerCaseMapping:0x0448
  ,simpleTitleCaseMapping:0x0428
 },
 { code:0x0429
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0429
  ,simpleLowerCaseMapping:0x0449
  ,simpleTitleCaseMapping:0x0429
 },
 { code:0x042A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x042A
  ,simpleLowerCaseMapping:0x044A
  ,simpleTitleCaseMapping:0x042A
 },
 { code:0x042B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x042B
  ,simpleLowerCaseMapping:0x044B
  ,simpleTitleCaseMapping:0x042B
 },
 { code:0x042C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x042C
  ,simpleLowerCaseMapping:0x044C
  ,simpleTitleCaseMapping:0x042C
 },
 { code:0x042D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x042D
  ,simpleLowerCaseMapping:0x044D
  ,simpleTitleCaseMapping:0x042D
 },
 { code:0x042E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x042E
  ,simpleLowerCaseMapping:0x044E
  ,simpleTitleCaseMapping:0x042E
 },
 { code:0x042F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x042F
  ,simpleLowerCaseMapping:0x044F
  ,simpleTitleCaseMapping:0x042F
 },
 { code:0x0430
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0410
  ,simpleLowerCaseMapping:0x0430
  ,simpleTitleCaseMapping:0x0410
 },
 { code:0x0431
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0411
  ,simpleLowerCaseMapping:0x0431
  ,simpleTitleCaseMapping:0x0411
 },
 { code:0x0432
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0412
  ,simpleLowerCaseMapping:0x0432
  ,simpleTitleCaseMapping:0x0412
 },
 { code:0x0433
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0413
  ,simpleLowerCaseMapping:0x0433
  ,simpleTitleCaseMapping:0x0413
 },
 { code:0x0434
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0414
  ,simpleLowerCaseMapping:0x0434
  ,simpleTitleCaseMapping:0x0414
 },
 { code:0x0435
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0415
  ,simpleLowerCaseMapping:0x0435
  ,simpleTitleCaseMapping:0x0415
 },
 { code:0x0436
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0416
  ,simpleLowerCaseMapping:0x0436
  ,simpleTitleCaseMapping:0x0416
 },
 { code:0x0437
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0417
  ,simpleLowerCaseMapping:0x0437
  ,simpleTitleCaseMapping:0x0417
 },
 { code:0x0438
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0418
  ,simpleLowerCaseMapping:0x0438
  ,simpleTitleCaseMapping:0x0418
 },
 { code:0x0439
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0419
  ,simpleLowerCaseMapping:0x0439
  ,simpleTitleCaseMapping:0x0419
 },
 { code:0x043A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x041A
  ,simpleLowerCaseMapping:0x043A
  ,simpleTitleCaseMapping:0x041A
 },
 { code:0x043B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x041B
  ,simpleLowerCaseMapping:0x043B
  ,simpleTitleCaseMapping:0x041B
 },
 { code:0x043C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x041C
  ,simpleLowerCaseMapping:0x043C
  ,simpleTitleCaseMapping:0x041C
 },
 { code:0x043D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x041D
  ,simpleLowerCaseMapping:0x043D
  ,simpleTitleCaseMapping:0x041D
 },
 { code:0x043E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x041E
  ,simpleLowerCaseMapping:0x043E
  ,simpleTitleCaseMapping:0x041E
 },
 { code:0x043F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x041F
  ,simpleLowerCaseMapping:0x043F
  ,simpleTitleCaseMapping:0x041F
 },
 { code:0x0440
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0420
  ,simpleLowerCaseMapping:0x0440
  ,simpleTitleCaseMapping:0x0420
 },
 { code:0x0441
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0421
  ,simpleLowerCaseMapping:0x0441
  ,simpleTitleCaseMapping:0x0421
 },
 { code:0x0442
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0422
  ,simpleLowerCaseMapping:0x0442
  ,simpleTitleCaseMapping:0x0422
 },
 { code:0x0443
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0423
  ,simpleLowerCaseMapping:0x0443
  ,simpleTitleCaseMapping:0x0423
 },
 { code:0x0444
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0424
  ,simpleLowerCaseMapping:0x0444
  ,simpleTitleCaseMapping:0x0424
 },
 { code:0x0445
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0425
  ,simpleLowerCaseMapping:0x0445
  ,simpleTitleCaseMapping:0x0425
 },
 { code:0x0446
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0426
  ,simpleLowerCaseMapping:0x0446
  ,simpleTitleCaseMapping:0x0426
 },
 { code:0x0447
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0427
  ,simpleLowerCaseMapping:0x0447
  ,simpleTitleCaseMapping:0x0427
 },
 { code:0x0448
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0428
  ,simpleLowerCaseMapping:0x0448
  ,simpleTitleCaseMapping:0x0428
 },
 { code:0x0449
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0429
  ,simpleLowerCaseMapping:0x0449
  ,simpleTitleCaseMapping:0x0429
 },
 { code:0x044A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x042A
  ,simpleLowerCaseMapping:0x044A
  ,simpleTitleCaseMapping:0x042A
 },
 { code:0x044B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x042B
  ,simpleLowerCaseMapping:0x044B
  ,simpleTitleCaseMapping:0x042B
 },
 { code:0x044C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x042C
  ,simpleLowerCaseMapping:0x044C
  ,simpleTitleCaseMapping:0x042C
 },
 { code:0x044D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x042D
  ,simpleLowerCaseMapping:0x044D
  ,simpleTitleCaseMapping:0x042D
 },
 { code:0x044E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x042E
  ,simpleLowerCaseMapping:0x044E
  ,simpleTitleCaseMapping:0x042E
 },
 { code:0x044F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x042F
  ,simpleLowerCaseMapping:0x044F
  ,simpleTitleCaseMapping:0x042F
 },
 { code:0x0450
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0400
  ,simpleLowerCaseMapping:0x0450
  ,simpleTitleCaseMapping:0x0400
 },
 { code:0x0451
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0401
  ,simpleLowerCaseMapping:0x0451
  ,simpleTitleCaseMapping:0x0401
 },
 { code:0x0452
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0402
  ,simpleLowerCaseMapping:0x0452
  ,simpleTitleCaseMapping:0x0402
 },
 { code:0x0453
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0403
  ,simpleLowerCaseMapping:0x0453
  ,simpleTitleCaseMapping:0x0403
 },
 { code:0x0454
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0404
  ,simpleLowerCaseMapping:0x0454
  ,simpleTitleCaseMapping:0x0404
 },
 { code:0x0455
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0405
  ,simpleLowerCaseMapping:0x0455
  ,simpleTitleCaseMapping:0x0405
 },
 { code:0x0456
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0406
  ,simpleLowerCaseMapping:0x0456
  ,simpleTitleCaseMapping:0x0406
 },
 { code:0x0457
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0407
  ,simpleLowerCaseMapping:0x0457
  ,simpleTitleCaseMapping:0x0407
 },
 { code:0x0458
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0408
  ,simpleLowerCaseMapping:0x0458
  ,simpleTitleCaseMapping:0x0408
 },
 { code:0x0459
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0409
  ,simpleLowerCaseMapping:0x0459
  ,simpleTitleCaseMapping:0x0409
 },
 { code:0x045A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x040A
  ,simpleLowerCaseMapping:0x045A
  ,simpleTitleCaseMapping:0x040A
 },
 { code:0x045B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x040B
  ,simpleLowerCaseMapping:0x045B
  ,simpleTitleCaseMapping:0x040B
 },
 { code:0x045C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x040C
  ,simpleLowerCaseMapping:0x045C
  ,simpleTitleCaseMapping:0x040C
 },
 { code:0x045D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x040D
  ,simpleLowerCaseMapping:0x045D
  ,simpleTitleCaseMapping:0x040D
 },
 { code:0x045E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x040E
  ,simpleLowerCaseMapping:0x045E
  ,simpleTitleCaseMapping:0x040E
 },
 { code:0x045F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x040F
  ,simpleLowerCaseMapping:0x045F
  ,simpleTitleCaseMapping:0x040F
 },
 { code:0x0460
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0460
  ,simpleLowerCaseMapping:0x0461
  ,simpleTitleCaseMapping:0x0460
 },
 { code:0x0461
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0460
  ,simpleLowerCaseMapping:0x0461
  ,simpleTitleCaseMapping:0x0460
 },
 { code:0x0462
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0462
  ,simpleLowerCaseMapping:0x0463
  ,simpleTitleCaseMapping:0x0462
 },
 { code:0x0463
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0462
  ,simpleLowerCaseMapping:0x0463
  ,simpleTitleCaseMapping:0x0462
 },
 { code:0x0464
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0464
  ,simpleLowerCaseMapping:0x0465
  ,simpleTitleCaseMapping:0x0464
 },
 { code:0x0465
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0464
  ,simpleLowerCaseMapping:0x0465
  ,simpleTitleCaseMapping:0x0464
 },
 { code:0x0466
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0466
  ,simpleLowerCaseMapping:0x0467
  ,simpleTitleCaseMapping:0x0466
 },
 { code:0x0467
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0466
  ,simpleLowerCaseMapping:0x0467
  ,simpleTitleCaseMapping:0x0466
 },
 { code:0x0468
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0468
  ,simpleLowerCaseMapping:0x0469
  ,simpleTitleCaseMapping:0x0468
 },
 { code:0x0469
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0468
  ,simpleLowerCaseMapping:0x0469
  ,simpleTitleCaseMapping:0x0468
 },
 { code:0x046A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x046A
  ,simpleLowerCaseMapping:0x046B
  ,simpleTitleCaseMapping:0x046A
 },
 { code:0x046B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x046A
  ,simpleLowerCaseMapping:0x046B
  ,simpleTitleCaseMapping:0x046A
 },
 { code:0x046C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x046C
  ,simpleLowerCaseMapping:0x046D
  ,simpleTitleCaseMapping:0x046C
 },
 { code:0x046D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x046C
  ,simpleLowerCaseMapping:0x046D
  ,simpleTitleCaseMapping:0x046C
 },
 { code:0x046E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x046E
  ,simpleLowerCaseMapping:0x046F
  ,simpleTitleCaseMapping:0x046E
 },
 { code:0x046F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x046E
  ,simpleLowerCaseMapping:0x046F
  ,simpleTitleCaseMapping:0x046E
 },
 { code:0x0470
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0470
  ,simpleLowerCaseMapping:0x0471
  ,simpleTitleCaseMapping:0x0470
 },
 { code:0x0471
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0470
  ,simpleLowerCaseMapping:0x0471
  ,simpleTitleCaseMapping:0x0470
 },
 { code:0x0472
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0472
  ,simpleLowerCaseMapping:0x0473
  ,simpleTitleCaseMapping:0x0472
 },
 { code:0x0473
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0472
  ,simpleLowerCaseMapping:0x0473
  ,simpleTitleCaseMapping:0x0472
 },
 { code:0x0474
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0474
  ,simpleLowerCaseMapping:0x0475
  ,simpleTitleCaseMapping:0x0474
 },
 { code:0x0475
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0474
  ,simpleLowerCaseMapping:0x0475
  ,simpleTitleCaseMapping:0x0474
 },
 { code:0x0476
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0476
  ,simpleLowerCaseMapping:0x0477
  ,simpleTitleCaseMapping:0x0476
 },
 { code:0x0477
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0476
  ,simpleLowerCaseMapping:0x0477
  ,simpleTitleCaseMapping:0x0476
 },
 { code:0x0478
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0478
  ,simpleLowerCaseMapping:0x0479
  ,simpleTitleCaseMapping:0x0478
 },
 { code:0x0479
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0478
  ,simpleLowerCaseMapping:0x0479
  ,simpleTitleCaseMapping:0x0478
 },
 { code:0x047A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x047A
  ,simpleLowerCaseMapping:0x047B
  ,simpleTitleCaseMapping:0x047A
 },
 { code:0x047B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x047A
  ,simpleLowerCaseMapping:0x047B
  ,simpleTitleCaseMapping:0x047A
 },
 { code:0x047C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x047C
  ,simpleLowerCaseMapping:0x047D
  ,simpleTitleCaseMapping:0x047C
 },
 { code:0x047D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x047C
  ,simpleLowerCaseMapping:0x047D
  ,simpleTitleCaseMapping:0x047C
 },
 { code:0x047E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x047E
  ,simpleLowerCaseMapping:0x047F
  ,simpleTitleCaseMapping:0x047E
 },
 { code:0x047F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x047E
  ,simpleLowerCaseMapping:0x047F
  ,simpleTitleCaseMapping:0x047E
 },
 { code:0x0480
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0480
  ,simpleLowerCaseMapping:0x0481
  ,simpleTitleCaseMapping:0x0480
 },
 { code:0x0481
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0480
  ,simpleLowerCaseMapping:0x0481
  ,simpleTitleCaseMapping:0x0480
 },
 { code:0x0482
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0482
  ,simpleLowerCaseMapping:0x0482
  ,simpleTitleCaseMapping:0x0482
 },
 { code:0x0483
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0483
  ,simpleLowerCaseMapping:0x0483
  ,simpleTitleCaseMapping:0x0483
 },
 { code:0x0484
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0484
  ,simpleLowerCaseMapping:0x0484
  ,simpleTitleCaseMapping:0x0484
 },
 { code:0x0485
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0485
  ,simpleLowerCaseMapping:0x0485
  ,simpleTitleCaseMapping:0x0485
 },
 { code:0x0486
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0486
  ,simpleLowerCaseMapping:0x0486
  ,simpleTitleCaseMapping:0x0486
 },
 { code:0x0488
  ,generalCategory:UnicodeData.GeneralCategory.Me
  ,simpleUpperCaseMapping:0x0488
  ,simpleLowerCaseMapping:0x0488
  ,simpleTitleCaseMapping:0x0488
 },
 { code:0x0489
  ,generalCategory:UnicodeData.GeneralCategory.Me
  ,simpleUpperCaseMapping:0x0489
  ,simpleLowerCaseMapping:0x0489
  ,simpleTitleCaseMapping:0x0489
 },
 { code:0x048A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x048A
  ,simpleLowerCaseMapping:0x048B
  ,simpleTitleCaseMapping:0x048A
 },
 { code:0x048B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x048A
  ,simpleLowerCaseMapping:0x048B
  ,simpleTitleCaseMapping:0x048A
 },
 { code:0x048C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x048C
  ,simpleLowerCaseMapping:0x048D
  ,simpleTitleCaseMapping:0x048C
 },
 { code:0x048D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x048C
  ,simpleLowerCaseMapping:0x048D
  ,simpleTitleCaseMapping:0x048C
 },
 { code:0x048E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x048E
  ,simpleLowerCaseMapping:0x048F
  ,simpleTitleCaseMapping:0x048E
 },
 { code:0x048F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x048E
  ,simpleLowerCaseMapping:0x048F
  ,simpleTitleCaseMapping:0x048E
 },
 { code:0x0490
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0490
  ,simpleLowerCaseMapping:0x0491
  ,simpleTitleCaseMapping:0x0490
 },
 { code:0x0491
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0490
  ,simpleLowerCaseMapping:0x0491
  ,simpleTitleCaseMapping:0x0490
 },
 { code:0x0492
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0492
  ,simpleLowerCaseMapping:0x0493
  ,simpleTitleCaseMapping:0x0492
 },
 { code:0x0493
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0492
  ,simpleLowerCaseMapping:0x0493
  ,simpleTitleCaseMapping:0x0492
 },
 { code:0x0494
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0494
  ,simpleLowerCaseMapping:0x0495
  ,simpleTitleCaseMapping:0x0494
 },
 { code:0x0495
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0494
  ,simpleLowerCaseMapping:0x0495
  ,simpleTitleCaseMapping:0x0494
 },
 { code:0x0496
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0496
  ,simpleLowerCaseMapping:0x0497
  ,simpleTitleCaseMapping:0x0496
 },
 { code:0x0497
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0496
  ,simpleLowerCaseMapping:0x0497
  ,simpleTitleCaseMapping:0x0496
 },
 { code:0x0498
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0498
  ,simpleLowerCaseMapping:0x0499
  ,simpleTitleCaseMapping:0x0498
 },
 { code:0x0499
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0498
  ,simpleLowerCaseMapping:0x0499
  ,simpleTitleCaseMapping:0x0498
 },
 { code:0x049A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x049A
  ,simpleLowerCaseMapping:0x049B
  ,simpleTitleCaseMapping:0x049A
 },
 { code:0x049B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x049A
  ,simpleLowerCaseMapping:0x049B
  ,simpleTitleCaseMapping:0x049A
 },
 { code:0x049C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x049C
  ,simpleLowerCaseMapping:0x049D
  ,simpleTitleCaseMapping:0x049C
 },
 { code:0x049D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x049C
  ,simpleLowerCaseMapping:0x049D
  ,simpleTitleCaseMapping:0x049C
 },
 { code:0x049E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x049E
  ,simpleLowerCaseMapping:0x049F
  ,simpleTitleCaseMapping:0x049E
 },
 { code:0x049F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x049E
  ,simpleLowerCaseMapping:0x049F
  ,simpleTitleCaseMapping:0x049E
 },
 { code:0x04A0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04A0
  ,simpleLowerCaseMapping:0x04A1
  ,simpleTitleCaseMapping:0x04A0
 },
 { code:0x04A1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04A0
  ,simpleLowerCaseMapping:0x04A1
  ,simpleTitleCaseMapping:0x04A0
 },
 { code:0x04A2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04A2
  ,simpleLowerCaseMapping:0x04A3
  ,simpleTitleCaseMapping:0x04A2
 },
 { code:0x04A3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04A2
  ,simpleLowerCaseMapping:0x04A3
  ,simpleTitleCaseMapping:0x04A2
 },
 { code:0x04A4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04A4
  ,simpleLowerCaseMapping:0x04A5
  ,simpleTitleCaseMapping:0x04A4
 },
 { code:0x04A5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04A4
  ,simpleLowerCaseMapping:0x04A5
  ,simpleTitleCaseMapping:0x04A4
 },
 { code:0x04A6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04A6
  ,simpleLowerCaseMapping:0x04A7
  ,simpleTitleCaseMapping:0x04A6
 },
 { code:0x04A7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04A6
  ,simpleLowerCaseMapping:0x04A7
  ,simpleTitleCaseMapping:0x04A6
 },
 { code:0x04A8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04A8
  ,simpleLowerCaseMapping:0x04A9
  ,simpleTitleCaseMapping:0x04A8
 },
 { code:0x04A9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04A8
  ,simpleLowerCaseMapping:0x04A9
  ,simpleTitleCaseMapping:0x04A8
 },
 { code:0x04AA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04AA
  ,simpleLowerCaseMapping:0x04AB
  ,simpleTitleCaseMapping:0x04AA
 },
 { code:0x04AB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04AA
  ,simpleLowerCaseMapping:0x04AB
  ,simpleTitleCaseMapping:0x04AA
 },
 { code:0x04AC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04AC
  ,simpleLowerCaseMapping:0x04AD
  ,simpleTitleCaseMapping:0x04AC
 },
 { code:0x04AD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04AC
  ,simpleLowerCaseMapping:0x04AD
  ,simpleTitleCaseMapping:0x04AC
 },
 { code:0x04AE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04AE
  ,simpleLowerCaseMapping:0x04AF
  ,simpleTitleCaseMapping:0x04AE
 },
 { code:0x04AF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04AE
  ,simpleLowerCaseMapping:0x04AF
  ,simpleTitleCaseMapping:0x04AE
 },
 { code:0x04B0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04B0
  ,simpleLowerCaseMapping:0x04B1
  ,simpleTitleCaseMapping:0x04B0
 },
 { code:0x04B1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04B0
  ,simpleLowerCaseMapping:0x04B1
  ,simpleTitleCaseMapping:0x04B0
 },
 { code:0x04B2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04B2
  ,simpleLowerCaseMapping:0x04B3
  ,simpleTitleCaseMapping:0x04B2
 },
 { code:0x04B3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04B2
  ,simpleLowerCaseMapping:0x04B3
  ,simpleTitleCaseMapping:0x04B2
 },
 { code:0x04B4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04B4
  ,simpleLowerCaseMapping:0x04B5
  ,simpleTitleCaseMapping:0x04B4
 },
 { code:0x04B5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04B4
  ,simpleLowerCaseMapping:0x04B5
  ,simpleTitleCaseMapping:0x04B4
 },
 { code:0x04B6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04B6
  ,simpleLowerCaseMapping:0x04B7
  ,simpleTitleCaseMapping:0x04B6
 },
 { code:0x04B7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04B6
  ,simpleLowerCaseMapping:0x04B7
  ,simpleTitleCaseMapping:0x04B6
 },
 { code:0x04B8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04B8
  ,simpleLowerCaseMapping:0x04B9
  ,simpleTitleCaseMapping:0x04B8
 },
 { code:0x04B9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04B8
  ,simpleLowerCaseMapping:0x04B9
  ,simpleTitleCaseMapping:0x04B8
 },
 { code:0x04BA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04BA
  ,simpleLowerCaseMapping:0x04BB
  ,simpleTitleCaseMapping:0x04BA
 },
 { code:0x04BB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04BA
  ,simpleLowerCaseMapping:0x04BB
  ,simpleTitleCaseMapping:0x04BA
 },
 { code:0x04BC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04BC
  ,simpleLowerCaseMapping:0x04BD
  ,simpleTitleCaseMapping:0x04BC
 },
 { code:0x04BD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04BC
  ,simpleLowerCaseMapping:0x04BD
  ,simpleTitleCaseMapping:0x04BC
 },
 { code:0x04BE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04BE
  ,simpleLowerCaseMapping:0x04BF
  ,simpleTitleCaseMapping:0x04BE
 },
 { code:0x04BF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04BE
  ,simpleLowerCaseMapping:0x04BF
  ,simpleTitleCaseMapping:0x04BE
 },
 { code:0x04C0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04C0
  ,simpleLowerCaseMapping:0x04CF
  ,simpleTitleCaseMapping:0x04C0
 },
 { code:0x04C1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04C1
  ,simpleLowerCaseMapping:0x04C2
  ,simpleTitleCaseMapping:0x04C1
 },
 { code:0x04C2
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04C1
  ,simpleLowerCaseMapping:0x04C2
  ,simpleTitleCaseMapping:0x04C1
 },
 { code:0x04C3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04C3
  ,simpleLowerCaseMapping:0x04C4
  ,simpleTitleCaseMapping:0x04C3
 },
 { code:0x04C4
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04C3
  ,simpleLowerCaseMapping:0x04C4
  ,simpleTitleCaseMapping:0x04C3
 },
 { code:0x04C5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04C5
  ,simpleLowerCaseMapping:0x04C6
  ,simpleTitleCaseMapping:0x04C5
 },
 { code:0x04C6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04C5
  ,simpleLowerCaseMapping:0x04C6
  ,simpleTitleCaseMapping:0x04C5
 },
 { code:0x04C7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04C7
  ,simpleLowerCaseMapping:0x04C8
  ,simpleTitleCaseMapping:0x04C7
 },
 { code:0x04C8
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04C7
  ,simpleLowerCaseMapping:0x04C8
  ,simpleTitleCaseMapping:0x04C7
 },
 { code:0x04C9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04C9
  ,simpleLowerCaseMapping:0x04CA
  ,simpleTitleCaseMapping:0x04C9
 },
 { code:0x04CA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04C9
  ,simpleLowerCaseMapping:0x04CA
  ,simpleTitleCaseMapping:0x04C9
 },
 { code:0x04CB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04CB
  ,simpleLowerCaseMapping:0x04CC
  ,simpleTitleCaseMapping:0x04CB
 },
 { code:0x04CC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04CB
  ,simpleLowerCaseMapping:0x04CC
  ,simpleTitleCaseMapping:0x04CB
 },
 { code:0x04CD
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04CD
  ,simpleLowerCaseMapping:0x04CE
  ,simpleTitleCaseMapping:0x04CD
 },
 { code:0x04CE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04CD
  ,simpleLowerCaseMapping:0x04CE
  ,simpleTitleCaseMapping:0x04CD
 },
 { code:0x04CF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04C0
  ,simpleLowerCaseMapping:0x04CF
  ,simpleTitleCaseMapping:0x04C0
 },
 { code:0x04D0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04D0
  ,simpleLowerCaseMapping:0x04D1
  ,simpleTitleCaseMapping:0x04D0
 },
 { code:0x04D1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04D0
  ,simpleLowerCaseMapping:0x04D1
  ,simpleTitleCaseMapping:0x04D0
 },
 { code:0x04D2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04D2
  ,simpleLowerCaseMapping:0x04D3
  ,simpleTitleCaseMapping:0x04D2
 },
 { code:0x04D3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04D2
  ,simpleLowerCaseMapping:0x04D3
  ,simpleTitleCaseMapping:0x04D2
 },
 { code:0x04D4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04D4
  ,simpleLowerCaseMapping:0x04D5
  ,simpleTitleCaseMapping:0x04D4
 },
 { code:0x04D5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04D4
  ,simpleLowerCaseMapping:0x04D5
  ,simpleTitleCaseMapping:0x04D4
 },
 { code:0x04D6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04D6
  ,simpleLowerCaseMapping:0x04D7
  ,simpleTitleCaseMapping:0x04D6
 },
 { code:0x04D7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04D6
  ,simpleLowerCaseMapping:0x04D7
  ,simpleTitleCaseMapping:0x04D6
 },
 { code:0x04D8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04D8
  ,simpleLowerCaseMapping:0x04D9
  ,simpleTitleCaseMapping:0x04D8
 },
 { code:0x04D9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04D8
  ,simpleLowerCaseMapping:0x04D9
  ,simpleTitleCaseMapping:0x04D8
 },
 { code:0x04DA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04DA
  ,simpleLowerCaseMapping:0x04DB
  ,simpleTitleCaseMapping:0x04DA
 },
 { code:0x04DB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04DA
  ,simpleLowerCaseMapping:0x04DB
  ,simpleTitleCaseMapping:0x04DA
 },
 { code:0x04DC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04DC
  ,simpleLowerCaseMapping:0x04DD
  ,simpleTitleCaseMapping:0x04DC
 },
 { code:0x04DD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04DC
  ,simpleLowerCaseMapping:0x04DD
  ,simpleTitleCaseMapping:0x04DC
 },
 { code:0x04DE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04DE
  ,simpleLowerCaseMapping:0x04DF
  ,simpleTitleCaseMapping:0x04DE
 },
 { code:0x04DF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04DE
  ,simpleLowerCaseMapping:0x04DF
  ,simpleTitleCaseMapping:0x04DE
 },
 { code:0x04E0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04E0
  ,simpleLowerCaseMapping:0x04E1
  ,simpleTitleCaseMapping:0x04E0
 },
 { code:0x04E1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04E0
  ,simpleLowerCaseMapping:0x04E1
  ,simpleTitleCaseMapping:0x04E0
 },
 { code:0x04E2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04E2
  ,simpleLowerCaseMapping:0x04E3
  ,simpleTitleCaseMapping:0x04E2
 },
 { code:0x04E3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04E2
  ,simpleLowerCaseMapping:0x04E3
  ,simpleTitleCaseMapping:0x04E2
 },
 { code:0x04E4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04E4
  ,simpleLowerCaseMapping:0x04E5
  ,simpleTitleCaseMapping:0x04E4
 },
 { code:0x04E5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04E4
  ,simpleLowerCaseMapping:0x04E5
  ,simpleTitleCaseMapping:0x04E4
 },
 { code:0x04E6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04E6
  ,simpleLowerCaseMapping:0x04E7
  ,simpleTitleCaseMapping:0x04E6
 },
 { code:0x04E7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04E6
  ,simpleLowerCaseMapping:0x04E7
  ,simpleTitleCaseMapping:0x04E6
 },
 { code:0x04E8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04E8
  ,simpleLowerCaseMapping:0x04E9
  ,simpleTitleCaseMapping:0x04E8
 },
 { code:0x04E9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04E8
  ,simpleLowerCaseMapping:0x04E9
  ,simpleTitleCaseMapping:0x04E8
 },
 { code:0x04EA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04EA
  ,simpleLowerCaseMapping:0x04EB
  ,simpleTitleCaseMapping:0x04EA
 },
 { code:0x04EB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04EA
  ,simpleLowerCaseMapping:0x04EB
  ,simpleTitleCaseMapping:0x04EA
 },
 { code:0x04EC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04EC
  ,simpleLowerCaseMapping:0x04ED
  ,simpleTitleCaseMapping:0x04EC
 },
 { code:0x04ED
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04EC
  ,simpleLowerCaseMapping:0x04ED
  ,simpleTitleCaseMapping:0x04EC
 },
 { code:0x04EE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04EE
  ,simpleLowerCaseMapping:0x04EF
  ,simpleTitleCaseMapping:0x04EE
 },
 { code:0x04EF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04EE
  ,simpleLowerCaseMapping:0x04EF
  ,simpleTitleCaseMapping:0x04EE
 },
 { code:0x04F0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04F0
  ,simpleLowerCaseMapping:0x04F1
  ,simpleTitleCaseMapping:0x04F0
 },
 { code:0x04F1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04F0
  ,simpleLowerCaseMapping:0x04F1
  ,simpleTitleCaseMapping:0x04F0
 },
 { code:0x04F2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04F2
  ,simpleLowerCaseMapping:0x04F3
  ,simpleTitleCaseMapping:0x04F2
 },
 { code:0x04F3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04F2
  ,simpleLowerCaseMapping:0x04F3
  ,simpleTitleCaseMapping:0x04F2
 },
 { code:0x04F4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04F4
  ,simpleLowerCaseMapping:0x04F5
  ,simpleTitleCaseMapping:0x04F4
 },
 { code:0x04F5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04F4
  ,simpleLowerCaseMapping:0x04F5
  ,simpleTitleCaseMapping:0x04F4
 },
 { code:0x04F6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04F6
  ,simpleLowerCaseMapping:0x04F7
  ,simpleTitleCaseMapping:0x04F6
 },
 { code:0x04F7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04F6
  ,simpleLowerCaseMapping:0x04F7
  ,simpleTitleCaseMapping:0x04F6
 },
 { code:0x04F8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04F8
  ,simpleLowerCaseMapping:0x04F9
  ,simpleTitleCaseMapping:0x04F8
 },
 { code:0x04F9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04F8
  ,simpleLowerCaseMapping:0x04F9
  ,simpleTitleCaseMapping:0x04F8
 },
 { code:0x04FA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04FA
  ,simpleLowerCaseMapping:0x04FB
  ,simpleTitleCaseMapping:0x04FA
 },
 { code:0x04FB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04FA
  ,simpleLowerCaseMapping:0x04FB
  ,simpleTitleCaseMapping:0x04FA
 },
 { code:0x04FC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04FC
  ,simpleLowerCaseMapping:0x04FD
  ,simpleTitleCaseMapping:0x04FC
 },
 { code:0x04FD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04FC
  ,simpleLowerCaseMapping:0x04FD
  ,simpleTitleCaseMapping:0x04FC
 },
 { code:0x04FE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x04FE
  ,simpleLowerCaseMapping:0x04FF
  ,simpleTitleCaseMapping:0x04FE
 },
 { code:0x04FF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x04FE
  ,simpleLowerCaseMapping:0x04FF
  ,simpleTitleCaseMapping:0x04FE
 },
 { code:0x0500
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0500
  ,simpleLowerCaseMapping:0x0501
  ,simpleTitleCaseMapping:0x0500
 },
 { code:0x0501
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0500
  ,simpleLowerCaseMapping:0x0501
  ,simpleTitleCaseMapping:0x0500
 },
 { code:0x0502
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0502
  ,simpleLowerCaseMapping:0x0503
  ,simpleTitleCaseMapping:0x0502
 },
 { code:0x0503
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0502
  ,simpleLowerCaseMapping:0x0503
  ,simpleTitleCaseMapping:0x0502
 },
 { code:0x0504
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0504
  ,simpleLowerCaseMapping:0x0505
  ,simpleTitleCaseMapping:0x0504
 },
 { code:0x0505
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0504
  ,simpleLowerCaseMapping:0x0505
  ,simpleTitleCaseMapping:0x0504
 },
 { code:0x0506
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0506
  ,simpleLowerCaseMapping:0x0507
  ,simpleTitleCaseMapping:0x0506
 },
 { code:0x0507
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0506
  ,simpleLowerCaseMapping:0x0507
  ,simpleTitleCaseMapping:0x0506
 },
 { code:0x0508
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0508
  ,simpleLowerCaseMapping:0x0509
  ,simpleTitleCaseMapping:0x0508
 },
 { code:0x0509
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0508
  ,simpleLowerCaseMapping:0x0509
  ,simpleTitleCaseMapping:0x0508
 },
 { code:0x050A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x050A
  ,simpleLowerCaseMapping:0x050B
  ,simpleTitleCaseMapping:0x050A
 },
 { code:0x050B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x050A
  ,simpleLowerCaseMapping:0x050B
  ,simpleTitleCaseMapping:0x050A
 },
 { code:0x050C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x050C
  ,simpleLowerCaseMapping:0x050D
  ,simpleTitleCaseMapping:0x050C
 },
 { code:0x050D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x050C
  ,simpleLowerCaseMapping:0x050D
  ,simpleTitleCaseMapping:0x050C
 },
 { code:0x050E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x050E
  ,simpleLowerCaseMapping:0x050F
  ,simpleTitleCaseMapping:0x050E
 },
 { code:0x050F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x050E
  ,simpleLowerCaseMapping:0x050F
  ,simpleTitleCaseMapping:0x050E
 },
 { code:0x0510
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0510
  ,simpleLowerCaseMapping:0x0511
  ,simpleTitleCaseMapping:0x0510
 },
 { code:0x0511
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0510
  ,simpleLowerCaseMapping:0x0511
  ,simpleTitleCaseMapping:0x0510
 },
 { code:0x0512
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0512
  ,simpleLowerCaseMapping:0x0513
  ,simpleTitleCaseMapping:0x0512
 },
 { code:0x0513
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0512
  ,simpleLowerCaseMapping:0x0513
  ,simpleTitleCaseMapping:0x0512
 },
 { code:0x0531
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0531
  ,simpleLowerCaseMapping:0x0561
  ,simpleTitleCaseMapping:0x0531
 },
 { code:0x0532
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0532
  ,simpleLowerCaseMapping:0x0562
  ,simpleTitleCaseMapping:0x0532
 },
 { code:0x0533
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0533
  ,simpleLowerCaseMapping:0x0563
  ,simpleTitleCaseMapping:0x0533
 },
 { code:0x0534
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0534
  ,simpleLowerCaseMapping:0x0564
  ,simpleTitleCaseMapping:0x0534
 },
 { code:0x0535
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0535
  ,simpleLowerCaseMapping:0x0565
  ,simpleTitleCaseMapping:0x0535
 },
 { code:0x0536
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0536
  ,simpleLowerCaseMapping:0x0566
  ,simpleTitleCaseMapping:0x0536
 },
 { code:0x0537
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0537
  ,simpleLowerCaseMapping:0x0567
  ,simpleTitleCaseMapping:0x0537
 },
 { code:0x0538
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0538
  ,simpleLowerCaseMapping:0x0568
  ,simpleTitleCaseMapping:0x0538
 },
 { code:0x0539
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0539
  ,simpleLowerCaseMapping:0x0569
  ,simpleTitleCaseMapping:0x0539
 },
 { code:0x053A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x053A
  ,simpleLowerCaseMapping:0x056A
  ,simpleTitleCaseMapping:0x053A
 },
 { code:0x053B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x053B
  ,simpleLowerCaseMapping:0x056B
  ,simpleTitleCaseMapping:0x053B
 },
 { code:0x053C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x053C
  ,simpleLowerCaseMapping:0x056C
  ,simpleTitleCaseMapping:0x053C
 },
 { code:0x053D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x053D
  ,simpleLowerCaseMapping:0x056D
  ,simpleTitleCaseMapping:0x053D
 },
 { code:0x053E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x053E
  ,simpleLowerCaseMapping:0x056E
  ,simpleTitleCaseMapping:0x053E
 },
 { code:0x053F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x053F
  ,simpleLowerCaseMapping:0x056F
  ,simpleTitleCaseMapping:0x053F
 },
 { code:0x0540
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0540
  ,simpleLowerCaseMapping:0x0570
  ,simpleTitleCaseMapping:0x0540
 },
 { code:0x0541
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0541
  ,simpleLowerCaseMapping:0x0571
  ,simpleTitleCaseMapping:0x0541
 },
 { code:0x0542
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0542
  ,simpleLowerCaseMapping:0x0572
  ,simpleTitleCaseMapping:0x0542
 },
 { code:0x0543
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0543
  ,simpleLowerCaseMapping:0x0573
  ,simpleTitleCaseMapping:0x0543
 },
 { code:0x0544
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0544
  ,simpleLowerCaseMapping:0x0574
  ,simpleTitleCaseMapping:0x0544
 },
 { code:0x0545
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0545
  ,simpleLowerCaseMapping:0x0575
  ,simpleTitleCaseMapping:0x0545
 },
 { code:0x0546
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0546
  ,simpleLowerCaseMapping:0x0576
  ,simpleTitleCaseMapping:0x0546
 },
 { code:0x0547
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0547
  ,simpleLowerCaseMapping:0x0577
  ,simpleTitleCaseMapping:0x0547
 },
 { code:0x0548
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0548
  ,simpleLowerCaseMapping:0x0578
  ,simpleTitleCaseMapping:0x0548
 },
 { code:0x0549
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0549
  ,simpleLowerCaseMapping:0x0579
  ,simpleTitleCaseMapping:0x0549
 },
 { code:0x054A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x054A
  ,simpleLowerCaseMapping:0x057A
  ,simpleTitleCaseMapping:0x054A
 },
 { code:0x054B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x054B
  ,simpleLowerCaseMapping:0x057B
  ,simpleTitleCaseMapping:0x054B
 },
 { code:0x054C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x054C
  ,simpleLowerCaseMapping:0x057C
  ,simpleTitleCaseMapping:0x054C
 },
 { code:0x054D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x054D
  ,simpleLowerCaseMapping:0x057D
  ,simpleTitleCaseMapping:0x054D
 },
 { code:0x054E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x054E
  ,simpleLowerCaseMapping:0x057E
  ,simpleTitleCaseMapping:0x054E
 },
 { code:0x054F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x054F
  ,simpleLowerCaseMapping:0x057F
  ,simpleTitleCaseMapping:0x054F
 },
 { code:0x0550
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0550
  ,simpleLowerCaseMapping:0x0580
  ,simpleTitleCaseMapping:0x0550
 },
 { code:0x0551
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0551
  ,simpleLowerCaseMapping:0x0581
  ,simpleTitleCaseMapping:0x0551
 },
 { code:0x0552
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0552
  ,simpleLowerCaseMapping:0x0582
  ,simpleTitleCaseMapping:0x0552
 },
 { code:0x0553
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0553
  ,simpleLowerCaseMapping:0x0583
  ,simpleTitleCaseMapping:0x0553
 },
 { code:0x0554
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0554
  ,simpleLowerCaseMapping:0x0584
  ,simpleTitleCaseMapping:0x0554
 },
 { code:0x0555
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0555
  ,simpleLowerCaseMapping:0x0585
  ,simpleTitleCaseMapping:0x0555
 },
 { code:0x0556
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x0556
  ,simpleLowerCaseMapping:0x0586
  ,simpleTitleCaseMapping:0x0556
 },
 { code:0x0559
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x0559
  ,simpleLowerCaseMapping:0x0559
  ,simpleTitleCaseMapping:0x0559
 },
 { code:0x055A
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x055A
  ,simpleLowerCaseMapping:0x055A
  ,simpleTitleCaseMapping:0x055A
 },
 { code:0x055B
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x055B
  ,simpleLowerCaseMapping:0x055B
  ,simpleTitleCaseMapping:0x055B
 },
 { code:0x055C
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x055C
  ,simpleLowerCaseMapping:0x055C
  ,simpleTitleCaseMapping:0x055C
 },
 { code:0x055D
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x055D
  ,simpleLowerCaseMapping:0x055D
  ,simpleTitleCaseMapping:0x055D
 },
 { code:0x055E
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x055E
  ,simpleLowerCaseMapping:0x055E
  ,simpleTitleCaseMapping:0x055E
 },
 { code:0x055F
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x055F
  ,simpleLowerCaseMapping:0x055F
  ,simpleTitleCaseMapping:0x055F
 },
 { code:0x0561
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0531
  ,simpleLowerCaseMapping:0x0561
  ,simpleTitleCaseMapping:0x0531
 },
 { code:0x0562
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0532
  ,simpleLowerCaseMapping:0x0562
  ,simpleTitleCaseMapping:0x0532
 },
 { code:0x0563
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0533
  ,simpleLowerCaseMapping:0x0563
  ,simpleTitleCaseMapping:0x0533
 },
 { code:0x0564
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0534
  ,simpleLowerCaseMapping:0x0564
  ,simpleTitleCaseMapping:0x0534
 },
 { code:0x0565
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0535
  ,simpleLowerCaseMapping:0x0565
  ,simpleTitleCaseMapping:0x0535
 },
 { code:0x0566
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0536
  ,simpleLowerCaseMapping:0x0566
  ,simpleTitleCaseMapping:0x0536
 },
 { code:0x0567
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0537
  ,simpleLowerCaseMapping:0x0567
  ,simpleTitleCaseMapping:0x0537
 },
 { code:0x0568
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0538
  ,simpleLowerCaseMapping:0x0568
  ,simpleTitleCaseMapping:0x0538
 },
 { code:0x0569
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0539
  ,simpleLowerCaseMapping:0x0569
  ,simpleTitleCaseMapping:0x0539
 },
 { code:0x056A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x053A
  ,simpleLowerCaseMapping:0x056A
  ,simpleTitleCaseMapping:0x053A
 },
 { code:0x056B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x053B
  ,simpleLowerCaseMapping:0x056B
  ,simpleTitleCaseMapping:0x053B
 },
 { code:0x056C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x053C
  ,simpleLowerCaseMapping:0x056C
  ,simpleTitleCaseMapping:0x053C
 },
 { code:0x056D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x053D
  ,simpleLowerCaseMapping:0x056D
  ,simpleTitleCaseMapping:0x053D
 },
 { code:0x056E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x053E
  ,simpleLowerCaseMapping:0x056E
  ,simpleTitleCaseMapping:0x053E
 },
 { code:0x056F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x053F
  ,simpleLowerCaseMapping:0x056F
  ,simpleTitleCaseMapping:0x053F
 },
 { code:0x0570
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0540
  ,simpleLowerCaseMapping:0x0570
  ,simpleTitleCaseMapping:0x0540
 },
 { code:0x0571
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0541
  ,simpleLowerCaseMapping:0x0571
  ,simpleTitleCaseMapping:0x0541
 },
 { code:0x0572
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0542
  ,simpleLowerCaseMapping:0x0572
  ,simpleTitleCaseMapping:0x0542
 },
 { code:0x0573
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0543
  ,simpleLowerCaseMapping:0x0573
  ,simpleTitleCaseMapping:0x0543
 },
 { code:0x0574
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0544
  ,simpleLowerCaseMapping:0x0574
  ,simpleTitleCaseMapping:0x0544
 },
 { code:0x0575
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0545
  ,simpleLowerCaseMapping:0x0575
  ,simpleTitleCaseMapping:0x0545
 },
 { code:0x0576
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0546
  ,simpleLowerCaseMapping:0x0576
  ,simpleTitleCaseMapping:0x0546
 },
 { code:0x0577
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0547
  ,simpleLowerCaseMapping:0x0577
  ,simpleTitleCaseMapping:0x0547
 },
 { code:0x0578
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0548
  ,simpleLowerCaseMapping:0x0578
  ,simpleTitleCaseMapping:0x0548
 },
 { code:0x0579
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0549
  ,simpleLowerCaseMapping:0x0579
  ,simpleTitleCaseMapping:0x0549
 },
 { code:0x057A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x054A
  ,simpleLowerCaseMapping:0x057A
  ,simpleTitleCaseMapping:0x054A
 },
 { code:0x057B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x054B
  ,simpleLowerCaseMapping:0x057B
  ,simpleTitleCaseMapping:0x054B
 },
 { code:0x057C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x054C
  ,simpleLowerCaseMapping:0x057C
  ,simpleTitleCaseMapping:0x054C
 },
 { code:0x057D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x054D
  ,simpleLowerCaseMapping:0x057D
  ,simpleTitleCaseMapping:0x054D
 },
 { code:0x057E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x054E
  ,simpleLowerCaseMapping:0x057E
  ,simpleTitleCaseMapping:0x054E
 },
 { code:0x057F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x054F
  ,simpleLowerCaseMapping:0x057F
  ,simpleTitleCaseMapping:0x054F
 },
 { code:0x0580
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0550
  ,simpleLowerCaseMapping:0x0580
  ,simpleTitleCaseMapping:0x0550
 },
 { code:0x0581
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0551
  ,simpleLowerCaseMapping:0x0581
  ,simpleTitleCaseMapping:0x0551
 },
 { code:0x0582
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0552
  ,simpleLowerCaseMapping:0x0582
  ,simpleTitleCaseMapping:0x0552
 },
 { code:0x0583
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0553
  ,simpleLowerCaseMapping:0x0583
  ,simpleTitleCaseMapping:0x0553
 },
 { code:0x0584
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0554
  ,simpleLowerCaseMapping:0x0584
  ,simpleTitleCaseMapping:0x0554
 },
 { code:0x0585
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0555
  ,simpleLowerCaseMapping:0x0585
  ,simpleTitleCaseMapping:0x0555
 },
 { code:0x0586
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0556
  ,simpleLowerCaseMapping:0x0586
  ,simpleTitleCaseMapping:0x0556
 },
 { code:0x0587
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x0587
  ,simpleLowerCaseMapping:0x0587
  ,simpleTitleCaseMapping:0x0587
 },
 { code:0x0589
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0589
  ,simpleLowerCaseMapping:0x0589
  ,simpleTitleCaseMapping:0x0589
 },
 { code:0x058A
  ,generalCategory:UnicodeData.GeneralCategory.Pd
  ,simpleUpperCaseMapping:0x058A
  ,simpleLowerCaseMapping:0x058A
  ,simpleTitleCaseMapping:0x058A
 },
 { code:0x0591
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0591
  ,simpleLowerCaseMapping:0x0591
  ,simpleTitleCaseMapping:0x0591
 },
 { code:0x0592
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0592
  ,simpleLowerCaseMapping:0x0592
  ,simpleTitleCaseMapping:0x0592
 },
 { code:0x0593
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0593
  ,simpleLowerCaseMapping:0x0593
  ,simpleTitleCaseMapping:0x0593
 },
 { code:0x0594
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0594
  ,simpleLowerCaseMapping:0x0594
  ,simpleTitleCaseMapping:0x0594
 },
 { code:0x0595
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0595
  ,simpleLowerCaseMapping:0x0595
  ,simpleTitleCaseMapping:0x0595
 },
 { code:0x0596
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0596
  ,simpleLowerCaseMapping:0x0596
  ,simpleTitleCaseMapping:0x0596
 },
 { code:0x0597
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0597
  ,simpleLowerCaseMapping:0x0597
  ,simpleTitleCaseMapping:0x0597
 },
 { code:0x0598
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0598
  ,simpleLowerCaseMapping:0x0598
  ,simpleTitleCaseMapping:0x0598
 },
 { code:0x0599
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0599
  ,simpleLowerCaseMapping:0x0599
  ,simpleTitleCaseMapping:0x0599
 },
 { code:0x059A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x059A
  ,simpleLowerCaseMapping:0x059A
  ,simpleTitleCaseMapping:0x059A
 },
 { code:0x059B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x059B
  ,simpleLowerCaseMapping:0x059B
  ,simpleTitleCaseMapping:0x059B
 },
 { code:0x059C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x059C
  ,simpleLowerCaseMapping:0x059C
  ,simpleTitleCaseMapping:0x059C
 },
 { code:0x059D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x059D
  ,simpleLowerCaseMapping:0x059D
  ,simpleTitleCaseMapping:0x059D
 },
 { code:0x059E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x059E
  ,simpleLowerCaseMapping:0x059E
  ,simpleTitleCaseMapping:0x059E
 },
 { code:0x059F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x059F
  ,simpleLowerCaseMapping:0x059F
  ,simpleTitleCaseMapping:0x059F
 },
 { code:0x05A0
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05A0
  ,simpleLowerCaseMapping:0x05A0
  ,simpleTitleCaseMapping:0x05A0
 },
 { code:0x05A1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05A1
  ,simpleLowerCaseMapping:0x05A1
  ,simpleTitleCaseMapping:0x05A1
 },
 { code:0x05A2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05A2
  ,simpleLowerCaseMapping:0x05A2
  ,simpleTitleCaseMapping:0x05A2
 },
 { code:0x05A3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05A3
  ,simpleLowerCaseMapping:0x05A3
  ,simpleTitleCaseMapping:0x05A3
 },
 { code:0x05A4
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05A4
  ,simpleLowerCaseMapping:0x05A4
  ,simpleTitleCaseMapping:0x05A4
 },
 { code:0x05A5
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05A5
  ,simpleLowerCaseMapping:0x05A5
  ,simpleTitleCaseMapping:0x05A5
 },
 { code:0x05A6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05A6
  ,simpleLowerCaseMapping:0x05A6
  ,simpleTitleCaseMapping:0x05A6
 },
 { code:0x05A7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05A7
  ,simpleLowerCaseMapping:0x05A7
  ,simpleTitleCaseMapping:0x05A7
 },
 { code:0x05A8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05A8
  ,simpleLowerCaseMapping:0x05A8
  ,simpleTitleCaseMapping:0x05A8
 },
 { code:0x05A9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05A9
  ,simpleLowerCaseMapping:0x05A9
  ,simpleTitleCaseMapping:0x05A9
 },
 { code:0x05AA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05AA
  ,simpleLowerCaseMapping:0x05AA
  ,simpleTitleCaseMapping:0x05AA
 },
 { code:0x05AB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05AB
  ,simpleLowerCaseMapping:0x05AB
  ,simpleTitleCaseMapping:0x05AB
 },
 { code:0x05AC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05AC
  ,simpleLowerCaseMapping:0x05AC
  ,simpleTitleCaseMapping:0x05AC
 },
 { code:0x05AD
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05AD
  ,simpleLowerCaseMapping:0x05AD
  ,simpleTitleCaseMapping:0x05AD
 },
 { code:0x05AE
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05AE
  ,simpleLowerCaseMapping:0x05AE
  ,simpleTitleCaseMapping:0x05AE
 },
 { code:0x05AF
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05AF
  ,simpleLowerCaseMapping:0x05AF
  ,simpleTitleCaseMapping:0x05AF
 },
 { code:0x05B0
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05B0
  ,simpleLowerCaseMapping:0x05B0
  ,simpleTitleCaseMapping:0x05B0
 },
 { code:0x05B1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05B1
  ,simpleLowerCaseMapping:0x05B1
  ,simpleTitleCaseMapping:0x05B1
 },
 { code:0x05B2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05B2
  ,simpleLowerCaseMapping:0x05B2
  ,simpleTitleCaseMapping:0x05B2
 },
 { code:0x05B3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05B3
  ,simpleLowerCaseMapping:0x05B3
  ,simpleTitleCaseMapping:0x05B3
 },
 { code:0x05B4
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05B4
  ,simpleLowerCaseMapping:0x05B4
  ,simpleTitleCaseMapping:0x05B4
 },
 { code:0x05B5
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05B5
  ,simpleLowerCaseMapping:0x05B5
  ,simpleTitleCaseMapping:0x05B5
 },
 { code:0x05B6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05B6
  ,simpleLowerCaseMapping:0x05B6
  ,simpleTitleCaseMapping:0x05B6
 },
 { code:0x05B7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05B7
  ,simpleLowerCaseMapping:0x05B7
  ,simpleTitleCaseMapping:0x05B7
 },
 { code:0x05B8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05B8
  ,simpleLowerCaseMapping:0x05B8
  ,simpleTitleCaseMapping:0x05B8
 },
 { code:0x05B9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05B9
  ,simpleLowerCaseMapping:0x05B9
  ,simpleTitleCaseMapping:0x05B9
 },
 { code:0x05BA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05BA
  ,simpleLowerCaseMapping:0x05BA
  ,simpleTitleCaseMapping:0x05BA
 },
 { code:0x05BB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05BB
  ,simpleLowerCaseMapping:0x05BB
  ,simpleTitleCaseMapping:0x05BB
 },
 { code:0x05BC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05BC
  ,simpleLowerCaseMapping:0x05BC
  ,simpleTitleCaseMapping:0x05BC
 },
 { code:0x05BD
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05BD
  ,simpleLowerCaseMapping:0x05BD
  ,simpleTitleCaseMapping:0x05BD
 },
 { code:0x05BE
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x05BE
  ,simpleLowerCaseMapping:0x05BE
  ,simpleTitleCaseMapping:0x05BE
 },
 { code:0x05BF
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05BF
  ,simpleLowerCaseMapping:0x05BF
  ,simpleTitleCaseMapping:0x05BF
 },
 { code:0x05C0
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x05C0
  ,simpleLowerCaseMapping:0x05C0
  ,simpleTitleCaseMapping:0x05C0
 },
 { code:0x05C1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05C1
  ,simpleLowerCaseMapping:0x05C1
  ,simpleTitleCaseMapping:0x05C1
 },
 { code:0x05C2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05C2
  ,simpleLowerCaseMapping:0x05C2
  ,simpleTitleCaseMapping:0x05C2
 },
 { code:0x05C3
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x05C3
  ,simpleLowerCaseMapping:0x05C3
  ,simpleTitleCaseMapping:0x05C3
 },
 { code:0x05C4
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05C4
  ,simpleLowerCaseMapping:0x05C4
  ,simpleTitleCaseMapping:0x05C4
 },
 { code:0x05C5
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05C5
  ,simpleLowerCaseMapping:0x05C5
  ,simpleTitleCaseMapping:0x05C5
 },
 { code:0x05C6
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x05C6
  ,simpleLowerCaseMapping:0x05C6
  ,simpleTitleCaseMapping:0x05C6
 },
 { code:0x05C7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x05C7
  ,simpleLowerCaseMapping:0x05C7
  ,simpleTitleCaseMapping:0x05C7
 },
 { code:0x05D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05D0
  ,simpleLowerCaseMapping:0x05D0
  ,simpleTitleCaseMapping:0x05D0
 },
 { code:0x05D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05D1
  ,simpleLowerCaseMapping:0x05D1
  ,simpleTitleCaseMapping:0x05D1
 },
 { code:0x05D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05D2
  ,simpleLowerCaseMapping:0x05D2
  ,simpleTitleCaseMapping:0x05D2
 },
 { code:0x05D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05D3
  ,simpleLowerCaseMapping:0x05D3
  ,simpleTitleCaseMapping:0x05D3
 },
 { code:0x05D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05D4
  ,simpleLowerCaseMapping:0x05D4
  ,simpleTitleCaseMapping:0x05D4
 },
 { code:0x05D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05D5
  ,simpleLowerCaseMapping:0x05D5
  ,simpleTitleCaseMapping:0x05D5
 },
 { code:0x05D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05D6
  ,simpleLowerCaseMapping:0x05D6
  ,simpleTitleCaseMapping:0x05D6
 },
 { code:0x05D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05D7
  ,simpleLowerCaseMapping:0x05D7
  ,simpleTitleCaseMapping:0x05D7
 },
 { code:0x05D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05D8
  ,simpleLowerCaseMapping:0x05D8
  ,simpleTitleCaseMapping:0x05D8
 },
 { code:0x05D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05D9
  ,simpleLowerCaseMapping:0x05D9
  ,simpleTitleCaseMapping:0x05D9
 },
 { code:0x05DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05DA
  ,simpleLowerCaseMapping:0x05DA
  ,simpleTitleCaseMapping:0x05DA
 },
 { code:0x05DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05DB
  ,simpleLowerCaseMapping:0x05DB
  ,simpleTitleCaseMapping:0x05DB
 },
 { code:0x05DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05DC
  ,simpleLowerCaseMapping:0x05DC
  ,simpleTitleCaseMapping:0x05DC
 },
 { code:0x05DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05DD
  ,simpleLowerCaseMapping:0x05DD
  ,simpleTitleCaseMapping:0x05DD
 },
 { code:0x05DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05DE
  ,simpleLowerCaseMapping:0x05DE
  ,simpleTitleCaseMapping:0x05DE
 },
 { code:0x05DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05DF
  ,simpleLowerCaseMapping:0x05DF
  ,simpleTitleCaseMapping:0x05DF
 },
 { code:0x05E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05E0
  ,simpleLowerCaseMapping:0x05E0
  ,simpleTitleCaseMapping:0x05E0
 },
 { code:0x05E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05E1
  ,simpleLowerCaseMapping:0x05E1
  ,simpleTitleCaseMapping:0x05E1
 },
 { code:0x05E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05E2
  ,simpleLowerCaseMapping:0x05E2
  ,simpleTitleCaseMapping:0x05E2
 },
 { code:0x05E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05E3
  ,simpleLowerCaseMapping:0x05E3
  ,simpleTitleCaseMapping:0x05E3
 },
 { code:0x05E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05E4
  ,simpleLowerCaseMapping:0x05E4
  ,simpleTitleCaseMapping:0x05E4
 },
 { code:0x05E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05E5
  ,simpleLowerCaseMapping:0x05E5
  ,simpleTitleCaseMapping:0x05E5
 },
 { code:0x05E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05E6
  ,simpleLowerCaseMapping:0x05E6
  ,simpleTitleCaseMapping:0x05E6
 },
 { code:0x05E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05E7
  ,simpleLowerCaseMapping:0x05E7
  ,simpleTitleCaseMapping:0x05E7
 },
 { code:0x05E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05E8
  ,simpleLowerCaseMapping:0x05E8
  ,simpleTitleCaseMapping:0x05E8
 },
 { code:0x05E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05E9
  ,simpleLowerCaseMapping:0x05E9
  ,simpleTitleCaseMapping:0x05E9
 },
 { code:0x05EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05EA
  ,simpleLowerCaseMapping:0x05EA
  ,simpleTitleCaseMapping:0x05EA
 },
 { code:0x05F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05F0
  ,simpleLowerCaseMapping:0x05F0
  ,simpleTitleCaseMapping:0x05F0
 },
 { code:0x05F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05F1
  ,simpleLowerCaseMapping:0x05F1
  ,simpleTitleCaseMapping:0x05F1
 },
 { code:0x05F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x05F2
  ,simpleLowerCaseMapping:0x05F2
  ,simpleTitleCaseMapping:0x05F2
 },
 { code:0x05F3
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x05F3
  ,simpleLowerCaseMapping:0x05F3
  ,simpleTitleCaseMapping:0x05F3
 },
 { code:0x05F4
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x05F4
  ,simpleLowerCaseMapping:0x05F4
  ,simpleTitleCaseMapping:0x05F4
 },
 { code:0x0600
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x0600
  ,simpleLowerCaseMapping:0x0600
  ,simpleTitleCaseMapping:0x0600
 },
 { code:0x0601
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x0601
  ,simpleLowerCaseMapping:0x0601
  ,simpleTitleCaseMapping:0x0601
 },
 { code:0x0602
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x0602
  ,simpleLowerCaseMapping:0x0602
  ,simpleTitleCaseMapping:0x0602
 },
 { code:0x0603
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x0603
  ,simpleLowerCaseMapping:0x0603
  ,simpleTitleCaseMapping:0x0603
 },
 { code:0x060B
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x060B
  ,simpleLowerCaseMapping:0x060B
  ,simpleTitleCaseMapping:0x060B
 },
 { code:0x060C
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x060C
  ,simpleLowerCaseMapping:0x060C
  ,simpleTitleCaseMapping:0x060C
 },
 { code:0x060D
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x060D
  ,simpleLowerCaseMapping:0x060D
  ,simpleTitleCaseMapping:0x060D
 },
 { code:0x060E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x060E
  ,simpleLowerCaseMapping:0x060E
  ,simpleTitleCaseMapping:0x060E
 },
 { code:0x060F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x060F
  ,simpleLowerCaseMapping:0x060F
  ,simpleTitleCaseMapping:0x060F
 },
 { code:0x0610
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0610
  ,simpleLowerCaseMapping:0x0610
  ,simpleTitleCaseMapping:0x0610
 },
 { code:0x0611
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0611
  ,simpleLowerCaseMapping:0x0611
  ,simpleTitleCaseMapping:0x0611
 },
 { code:0x0612
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0612
  ,simpleLowerCaseMapping:0x0612
  ,simpleTitleCaseMapping:0x0612
 },
 { code:0x0613
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0613
  ,simpleLowerCaseMapping:0x0613
  ,simpleTitleCaseMapping:0x0613
 },
 { code:0x0614
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0614
  ,simpleLowerCaseMapping:0x0614
  ,simpleTitleCaseMapping:0x0614
 },
 { code:0x0615
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0615
  ,simpleLowerCaseMapping:0x0615
  ,simpleTitleCaseMapping:0x0615
 },
 { code:0x061B
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x061B
  ,simpleLowerCaseMapping:0x061B
  ,simpleTitleCaseMapping:0x061B
 },
 { code:0x061E
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x061E
  ,simpleLowerCaseMapping:0x061E
  ,simpleTitleCaseMapping:0x061E
 },
 { code:0x061F
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x061F
  ,simpleLowerCaseMapping:0x061F
  ,simpleTitleCaseMapping:0x061F
 },
 { code:0x0621
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0621
  ,simpleLowerCaseMapping:0x0621
  ,simpleTitleCaseMapping:0x0621
 },
 { code:0x0622
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0622
  ,simpleLowerCaseMapping:0x0622
  ,simpleTitleCaseMapping:0x0622
 },
 { code:0x0623
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0623
  ,simpleLowerCaseMapping:0x0623
  ,simpleTitleCaseMapping:0x0623
 },
 { code:0x0624
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0624
  ,simpleLowerCaseMapping:0x0624
  ,simpleTitleCaseMapping:0x0624
 },
 { code:0x0625
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0625
  ,simpleLowerCaseMapping:0x0625
  ,simpleTitleCaseMapping:0x0625
 },
 { code:0x0626
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0626
  ,simpleLowerCaseMapping:0x0626
  ,simpleTitleCaseMapping:0x0626
 },
 { code:0x0627
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0627
  ,simpleLowerCaseMapping:0x0627
  ,simpleTitleCaseMapping:0x0627
 },
 { code:0x0628
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0628
  ,simpleLowerCaseMapping:0x0628
  ,simpleTitleCaseMapping:0x0628
 },
 { code:0x0629
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0629
  ,simpleLowerCaseMapping:0x0629
  ,simpleTitleCaseMapping:0x0629
 },
 { code:0x062A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x062A
  ,simpleLowerCaseMapping:0x062A
  ,simpleTitleCaseMapping:0x062A
 },
 { code:0x062B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x062B
  ,simpleLowerCaseMapping:0x062B
  ,simpleTitleCaseMapping:0x062B
 },
 { code:0x062C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x062C
  ,simpleLowerCaseMapping:0x062C
  ,simpleTitleCaseMapping:0x062C
 },
 { code:0x062D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x062D
  ,simpleLowerCaseMapping:0x062D
  ,simpleTitleCaseMapping:0x062D
 },
 { code:0x062E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x062E
  ,simpleLowerCaseMapping:0x062E
  ,simpleTitleCaseMapping:0x062E
 },
 { code:0x062F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x062F
  ,simpleLowerCaseMapping:0x062F
  ,simpleTitleCaseMapping:0x062F
 },
 { code:0x0630
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0630
  ,simpleLowerCaseMapping:0x0630
  ,simpleTitleCaseMapping:0x0630
 },
 { code:0x0631
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0631
  ,simpleLowerCaseMapping:0x0631
  ,simpleTitleCaseMapping:0x0631
 },
 { code:0x0632
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0632
  ,simpleLowerCaseMapping:0x0632
  ,simpleTitleCaseMapping:0x0632
 },
 { code:0x0633
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0633
  ,simpleLowerCaseMapping:0x0633
  ,simpleTitleCaseMapping:0x0633
 },
 { code:0x0634
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0634
  ,simpleLowerCaseMapping:0x0634
  ,simpleTitleCaseMapping:0x0634
 },
 { code:0x0635
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0635
  ,simpleLowerCaseMapping:0x0635
  ,simpleTitleCaseMapping:0x0635
 },
 { code:0x0636
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0636
  ,simpleLowerCaseMapping:0x0636
  ,simpleTitleCaseMapping:0x0636
 },
 { code:0x0637
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0637
  ,simpleLowerCaseMapping:0x0637
  ,simpleTitleCaseMapping:0x0637
 },
 { code:0x0638
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0638
  ,simpleLowerCaseMapping:0x0638
  ,simpleTitleCaseMapping:0x0638
 },
 { code:0x0639
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0639
  ,simpleLowerCaseMapping:0x0639
  ,simpleTitleCaseMapping:0x0639
 },
 { code:0x063A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x063A
  ,simpleLowerCaseMapping:0x063A
  ,simpleTitleCaseMapping:0x063A
 },
 { code:0x0640
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x0640
  ,simpleLowerCaseMapping:0x0640
  ,simpleTitleCaseMapping:0x0640
 },
 { code:0x0641
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0641
  ,simpleLowerCaseMapping:0x0641
  ,simpleTitleCaseMapping:0x0641
 },
 { code:0x0642
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0642
  ,simpleLowerCaseMapping:0x0642
  ,simpleTitleCaseMapping:0x0642
 },
 { code:0x0643
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0643
  ,simpleLowerCaseMapping:0x0643
  ,simpleTitleCaseMapping:0x0643
 },
 { code:0x0644
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0644
  ,simpleLowerCaseMapping:0x0644
  ,simpleTitleCaseMapping:0x0644
 },
 { code:0x0645
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0645
  ,simpleLowerCaseMapping:0x0645
  ,simpleTitleCaseMapping:0x0645
 },
 { code:0x0646
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0646
  ,simpleLowerCaseMapping:0x0646
  ,simpleTitleCaseMapping:0x0646
 },
 { code:0x0647
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0647
  ,simpleLowerCaseMapping:0x0647
  ,simpleTitleCaseMapping:0x0647
 },
 { code:0x0648
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0648
  ,simpleLowerCaseMapping:0x0648
  ,simpleTitleCaseMapping:0x0648
 },
 { code:0x0649
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0649
  ,simpleLowerCaseMapping:0x0649
  ,simpleTitleCaseMapping:0x0649
 },
 { code:0x064A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x064A
  ,simpleLowerCaseMapping:0x064A
  ,simpleTitleCaseMapping:0x064A
 },
 { code:0x064B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x064B
  ,simpleLowerCaseMapping:0x064B
  ,simpleTitleCaseMapping:0x064B
 },
 { code:0x064C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x064C
  ,simpleLowerCaseMapping:0x064C
  ,simpleTitleCaseMapping:0x064C
 },
 { code:0x064D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x064D
  ,simpleLowerCaseMapping:0x064D
  ,simpleTitleCaseMapping:0x064D
 },
 { code:0x064E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x064E
  ,simpleLowerCaseMapping:0x064E
  ,simpleTitleCaseMapping:0x064E
 },
 { code:0x064F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x064F
  ,simpleLowerCaseMapping:0x064F
  ,simpleTitleCaseMapping:0x064F
 },
 { code:0x0650
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0650
  ,simpleLowerCaseMapping:0x0650
  ,simpleTitleCaseMapping:0x0650
 },
 { code:0x0651
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0651
  ,simpleLowerCaseMapping:0x0651
  ,simpleTitleCaseMapping:0x0651
 },
 { code:0x0652
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0652
  ,simpleLowerCaseMapping:0x0652
  ,simpleTitleCaseMapping:0x0652
 },
 { code:0x0653
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0653
  ,simpleLowerCaseMapping:0x0653
  ,simpleTitleCaseMapping:0x0653
 },
 { code:0x0654
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0654
  ,simpleLowerCaseMapping:0x0654
  ,simpleTitleCaseMapping:0x0654
 },
 { code:0x0655
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0655
  ,simpleLowerCaseMapping:0x0655
  ,simpleTitleCaseMapping:0x0655
 },
 { code:0x0656
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0656
  ,simpleLowerCaseMapping:0x0656
  ,simpleTitleCaseMapping:0x0656
 },
 { code:0x0657
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0657
  ,simpleLowerCaseMapping:0x0657
  ,simpleTitleCaseMapping:0x0657
 },
 { code:0x0658
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0658
  ,simpleLowerCaseMapping:0x0658
  ,simpleTitleCaseMapping:0x0658
 },
 { code:0x0659
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0659
  ,simpleLowerCaseMapping:0x0659
  ,simpleTitleCaseMapping:0x0659
 },
 { code:0x065A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x065A
  ,simpleLowerCaseMapping:0x065A
  ,simpleTitleCaseMapping:0x065A
 },
 { code:0x065B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x065B
  ,simpleLowerCaseMapping:0x065B
  ,simpleTitleCaseMapping:0x065B
 },
 { code:0x065C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x065C
  ,simpleLowerCaseMapping:0x065C
  ,simpleTitleCaseMapping:0x065C
 },
 { code:0x065D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x065D
  ,simpleLowerCaseMapping:0x065D
  ,simpleTitleCaseMapping:0x065D
 },
 { code:0x065E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x065E
  ,simpleLowerCaseMapping:0x065E
  ,simpleTitleCaseMapping:0x065E
 },
 { code:0x0660
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0660
  ,simpleLowerCaseMapping:0x0660
  ,simpleTitleCaseMapping:0x0660
 },
 { code:0x0661
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0661
  ,simpleLowerCaseMapping:0x0661
  ,simpleTitleCaseMapping:0x0661
 },
 { code:0x0662
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0662
  ,simpleLowerCaseMapping:0x0662
  ,simpleTitleCaseMapping:0x0662
 },
 { code:0x0663
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0663
  ,simpleLowerCaseMapping:0x0663
  ,simpleTitleCaseMapping:0x0663
 },
 { code:0x0664
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0664
  ,simpleLowerCaseMapping:0x0664
  ,simpleTitleCaseMapping:0x0664
 },
 { code:0x0665
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0665
  ,simpleLowerCaseMapping:0x0665
  ,simpleTitleCaseMapping:0x0665
 },
 { code:0x0666
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0666
  ,simpleLowerCaseMapping:0x0666
  ,simpleTitleCaseMapping:0x0666
 },
 { code:0x0667
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0667
  ,simpleLowerCaseMapping:0x0667
  ,simpleTitleCaseMapping:0x0667
 },
 { code:0x0668
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0668
  ,simpleLowerCaseMapping:0x0668
  ,simpleTitleCaseMapping:0x0668
 },
 { code:0x0669
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0669
  ,simpleLowerCaseMapping:0x0669
  ,simpleTitleCaseMapping:0x0669
 },
 { code:0x066A
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x066A
  ,simpleLowerCaseMapping:0x066A
  ,simpleTitleCaseMapping:0x066A
 },
 { code:0x066B
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x066B
  ,simpleLowerCaseMapping:0x066B
  ,simpleTitleCaseMapping:0x066B
 },
 { code:0x066C
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x066C
  ,simpleLowerCaseMapping:0x066C
  ,simpleTitleCaseMapping:0x066C
 },
 { code:0x066D
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x066D
  ,simpleLowerCaseMapping:0x066D
  ,simpleTitleCaseMapping:0x066D
 },
 { code:0x066E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x066E
  ,simpleLowerCaseMapping:0x066E
  ,simpleTitleCaseMapping:0x066E
 },
 { code:0x066F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x066F
  ,simpleLowerCaseMapping:0x066F
  ,simpleTitleCaseMapping:0x066F
 },
 { code:0x0670
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0670
  ,simpleLowerCaseMapping:0x0670
  ,simpleTitleCaseMapping:0x0670
 },
 { code:0x0671
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0671
  ,simpleLowerCaseMapping:0x0671
  ,simpleTitleCaseMapping:0x0671
 },
 { code:0x0672
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0672
  ,simpleLowerCaseMapping:0x0672
  ,simpleTitleCaseMapping:0x0672
 },
 { code:0x0673
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0673
  ,simpleLowerCaseMapping:0x0673
  ,simpleTitleCaseMapping:0x0673
 },
 { code:0x0674
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0674
  ,simpleLowerCaseMapping:0x0674
  ,simpleTitleCaseMapping:0x0674
 },
 { code:0x0675
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0675
  ,simpleLowerCaseMapping:0x0675
  ,simpleTitleCaseMapping:0x0675
 },
 { code:0x0676
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0676
  ,simpleLowerCaseMapping:0x0676
  ,simpleTitleCaseMapping:0x0676
 },
 { code:0x0677
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0677
  ,simpleLowerCaseMapping:0x0677
  ,simpleTitleCaseMapping:0x0677
 },
 { code:0x0678
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0678
  ,simpleLowerCaseMapping:0x0678
  ,simpleTitleCaseMapping:0x0678
 },
 { code:0x0679
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0679
  ,simpleLowerCaseMapping:0x0679
  ,simpleTitleCaseMapping:0x0679
 },
 { code:0x067A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x067A
  ,simpleLowerCaseMapping:0x067A
  ,simpleTitleCaseMapping:0x067A
 },
 { code:0x067B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x067B
  ,simpleLowerCaseMapping:0x067B
  ,simpleTitleCaseMapping:0x067B
 },
 { code:0x067C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x067C
  ,simpleLowerCaseMapping:0x067C
  ,simpleTitleCaseMapping:0x067C
 },
 { code:0x067D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x067D
  ,simpleLowerCaseMapping:0x067D
  ,simpleTitleCaseMapping:0x067D
 },
 { code:0x067E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x067E
  ,simpleLowerCaseMapping:0x067E
  ,simpleTitleCaseMapping:0x067E
 },
 { code:0x067F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x067F
  ,simpleLowerCaseMapping:0x067F
  ,simpleTitleCaseMapping:0x067F
 },
 { code:0x0680
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0680
  ,simpleLowerCaseMapping:0x0680
  ,simpleTitleCaseMapping:0x0680
 },
 { code:0x0681
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0681
  ,simpleLowerCaseMapping:0x0681
  ,simpleTitleCaseMapping:0x0681
 },
 { code:0x0682
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0682
  ,simpleLowerCaseMapping:0x0682
  ,simpleTitleCaseMapping:0x0682
 },
 { code:0x0683
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0683
  ,simpleLowerCaseMapping:0x0683
  ,simpleTitleCaseMapping:0x0683
 },
 { code:0x0684
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0684
  ,simpleLowerCaseMapping:0x0684
  ,simpleTitleCaseMapping:0x0684
 },
 { code:0x0685
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0685
  ,simpleLowerCaseMapping:0x0685
  ,simpleTitleCaseMapping:0x0685
 },
 { code:0x0686
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0686
  ,simpleLowerCaseMapping:0x0686
  ,simpleTitleCaseMapping:0x0686
 },
 { code:0x0687
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0687
  ,simpleLowerCaseMapping:0x0687
  ,simpleTitleCaseMapping:0x0687
 },
 { code:0x0688
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0688
  ,simpleLowerCaseMapping:0x0688
  ,simpleTitleCaseMapping:0x0688
 },
 { code:0x0689
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0689
  ,simpleLowerCaseMapping:0x0689
  ,simpleTitleCaseMapping:0x0689
 },
 { code:0x068A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x068A
  ,simpleLowerCaseMapping:0x068A
  ,simpleTitleCaseMapping:0x068A
 },
 { code:0x068B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x068B
  ,simpleLowerCaseMapping:0x068B
  ,simpleTitleCaseMapping:0x068B
 },
 { code:0x068C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x068C
  ,simpleLowerCaseMapping:0x068C
  ,simpleTitleCaseMapping:0x068C
 },
 { code:0x068D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x068D
  ,simpleLowerCaseMapping:0x068D
  ,simpleTitleCaseMapping:0x068D
 },
 { code:0x068E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x068E
  ,simpleLowerCaseMapping:0x068E
  ,simpleTitleCaseMapping:0x068E
 },
 { code:0x068F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x068F
  ,simpleLowerCaseMapping:0x068F
  ,simpleTitleCaseMapping:0x068F
 },
 { code:0x0690
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0690
  ,simpleLowerCaseMapping:0x0690
  ,simpleTitleCaseMapping:0x0690
 },
 { code:0x0691
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0691
  ,simpleLowerCaseMapping:0x0691
  ,simpleTitleCaseMapping:0x0691
 },
 { code:0x0692
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0692
  ,simpleLowerCaseMapping:0x0692
  ,simpleTitleCaseMapping:0x0692
 },
 { code:0x0693
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0693
  ,simpleLowerCaseMapping:0x0693
  ,simpleTitleCaseMapping:0x0693
 },
 { code:0x0694
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0694
  ,simpleLowerCaseMapping:0x0694
  ,simpleTitleCaseMapping:0x0694
 },
 { code:0x0695
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0695
  ,simpleLowerCaseMapping:0x0695
  ,simpleTitleCaseMapping:0x0695
 },
 { code:0x0696
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0696
  ,simpleLowerCaseMapping:0x0696
  ,simpleTitleCaseMapping:0x0696
 },
 { code:0x0697
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0697
  ,simpleLowerCaseMapping:0x0697
  ,simpleTitleCaseMapping:0x0697
 },
 { code:0x0698
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0698
  ,simpleLowerCaseMapping:0x0698
  ,simpleTitleCaseMapping:0x0698
 },
 { code:0x0699
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0699
  ,simpleLowerCaseMapping:0x0699
  ,simpleTitleCaseMapping:0x0699
 },
 { code:0x069A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x069A
  ,simpleLowerCaseMapping:0x069A
  ,simpleTitleCaseMapping:0x069A
 },
 { code:0x069B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x069B
  ,simpleLowerCaseMapping:0x069B
  ,simpleTitleCaseMapping:0x069B
 },
 { code:0x069C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x069C
  ,simpleLowerCaseMapping:0x069C
  ,simpleTitleCaseMapping:0x069C
 },
 { code:0x069D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x069D
  ,simpleLowerCaseMapping:0x069D
  ,simpleTitleCaseMapping:0x069D
 },
 { code:0x069E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x069E
  ,simpleLowerCaseMapping:0x069E
  ,simpleTitleCaseMapping:0x069E
 },
 { code:0x069F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x069F
  ,simpleLowerCaseMapping:0x069F
  ,simpleTitleCaseMapping:0x069F
 },
 { code:0x06A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06A0
  ,simpleLowerCaseMapping:0x06A0
  ,simpleTitleCaseMapping:0x06A0
 },
 { code:0x06A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06A1
  ,simpleLowerCaseMapping:0x06A1
  ,simpleTitleCaseMapping:0x06A1
 },
 { code:0x06A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06A2
  ,simpleLowerCaseMapping:0x06A2
  ,simpleTitleCaseMapping:0x06A2
 },
 { code:0x06A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06A3
  ,simpleLowerCaseMapping:0x06A3
  ,simpleTitleCaseMapping:0x06A3
 },
 { code:0x06A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06A4
  ,simpleLowerCaseMapping:0x06A4
  ,simpleTitleCaseMapping:0x06A4
 },
 { code:0x06A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06A5
  ,simpleLowerCaseMapping:0x06A5
  ,simpleTitleCaseMapping:0x06A5
 },
 { code:0x06A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06A6
  ,simpleLowerCaseMapping:0x06A6
  ,simpleTitleCaseMapping:0x06A6
 },
 { code:0x06A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06A7
  ,simpleLowerCaseMapping:0x06A7
  ,simpleTitleCaseMapping:0x06A7
 },
 { code:0x06A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06A8
  ,simpleLowerCaseMapping:0x06A8
  ,simpleTitleCaseMapping:0x06A8
 },
 { code:0x06A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06A9
  ,simpleLowerCaseMapping:0x06A9
  ,simpleTitleCaseMapping:0x06A9
 },
 { code:0x06AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06AA
  ,simpleLowerCaseMapping:0x06AA
  ,simpleTitleCaseMapping:0x06AA
 },
 { code:0x06AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06AB
  ,simpleLowerCaseMapping:0x06AB
  ,simpleTitleCaseMapping:0x06AB
 },
 { code:0x06AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06AC
  ,simpleLowerCaseMapping:0x06AC
  ,simpleTitleCaseMapping:0x06AC
 },
 { code:0x06AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06AD
  ,simpleLowerCaseMapping:0x06AD
  ,simpleTitleCaseMapping:0x06AD
 },
 { code:0x06AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06AE
  ,simpleLowerCaseMapping:0x06AE
  ,simpleTitleCaseMapping:0x06AE
 },
 { code:0x06AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06AF
  ,simpleLowerCaseMapping:0x06AF
  ,simpleTitleCaseMapping:0x06AF
 },
 { code:0x06B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06B0
  ,simpleLowerCaseMapping:0x06B0
  ,simpleTitleCaseMapping:0x06B0
 },
 { code:0x06B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06B1
  ,simpleLowerCaseMapping:0x06B1
  ,simpleTitleCaseMapping:0x06B1
 },
 { code:0x06B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06B2
  ,simpleLowerCaseMapping:0x06B2
  ,simpleTitleCaseMapping:0x06B2
 },
 { code:0x06B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06B3
  ,simpleLowerCaseMapping:0x06B3
  ,simpleTitleCaseMapping:0x06B3
 },
 { code:0x06B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06B4
  ,simpleLowerCaseMapping:0x06B4
  ,simpleTitleCaseMapping:0x06B4
 },
 { code:0x06B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06B5
  ,simpleLowerCaseMapping:0x06B5
  ,simpleTitleCaseMapping:0x06B5
 },
 { code:0x06B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06B6
  ,simpleLowerCaseMapping:0x06B6
  ,simpleTitleCaseMapping:0x06B6
 },
 { code:0x06B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06B7
  ,simpleLowerCaseMapping:0x06B7
  ,simpleTitleCaseMapping:0x06B7
 },
 { code:0x06B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06B8
  ,simpleLowerCaseMapping:0x06B8
  ,simpleTitleCaseMapping:0x06B8
 },
 { code:0x06B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06B9
  ,simpleLowerCaseMapping:0x06B9
  ,simpleTitleCaseMapping:0x06B9
 },
 { code:0x06BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06BA
  ,simpleLowerCaseMapping:0x06BA
  ,simpleTitleCaseMapping:0x06BA
 },
 { code:0x06BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06BB
  ,simpleLowerCaseMapping:0x06BB
  ,simpleTitleCaseMapping:0x06BB
 },
 { code:0x06BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06BC
  ,simpleLowerCaseMapping:0x06BC
  ,simpleTitleCaseMapping:0x06BC
 },
 { code:0x06BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06BD
  ,simpleLowerCaseMapping:0x06BD
  ,simpleTitleCaseMapping:0x06BD
 },
 { code:0x06BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06BE
  ,simpleLowerCaseMapping:0x06BE
  ,simpleTitleCaseMapping:0x06BE
 },
 { code:0x06BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06BF
  ,simpleLowerCaseMapping:0x06BF
  ,simpleTitleCaseMapping:0x06BF
 },
 { code:0x06C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06C0
  ,simpleLowerCaseMapping:0x06C0
  ,simpleTitleCaseMapping:0x06C0
 },
 { code:0x06C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06C1
  ,simpleLowerCaseMapping:0x06C1
  ,simpleTitleCaseMapping:0x06C1
 },
 { code:0x06C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06C2
  ,simpleLowerCaseMapping:0x06C2
  ,simpleTitleCaseMapping:0x06C2
 },
 { code:0x06C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06C3
  ,simpleLowerCaseMapping:0x06C3
  ,simpleTitleCaseMapping:0x06C3
 },
 { code:0x06C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06C4
  ,simpleLowerCaseMapping:0x06C4
  ,simpleTitleCaseMapping:0x06C4
 },
 { code:0x06C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06C5
  ,simpleLowerCaseMapping:0x06C5
  ,simpleTitleCaseMapping:0x06C5
 },
 { code:0x06C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06C6
  ,simpleLowerCaseMapping:0x06C6
  ,simpleTitleCaseMapping:0x06C6
 },
 { code:0x06C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06C7
  ,simpleLowerCaseMapping:0x06C7
  ,simpleTitleCaseMapping:0x06C7
 },
 { code:0x06C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06C8
  ,simpleLowerCaseMapping:0x06C8
  ,simpleTitleCaseMapping:0x06C8
 },
 { code:0x06C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06C9
  ,simpleLowerCaseMapping:0x06C9
  ,simpleTitleCaseMapping:0x06C9
 },
 { code:0x06CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06CA
  ,simpleLowerCaseMapping:0x06CA
  ,simpleTitleCaseMapping:0x06CA
 },
 { code:0x06CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06CB
  ,simpleLowerCaseMapping:0x06CB
  ,simpleTitleCaseMapping:0x06CB
 },
 { code:0x06CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06CC
  ,simpleLowerCaseMapping:0x06CC
  ,simpleTitleCaseMapping:0x06CC
 },
 { code:0x06CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06CD
  ,simpleLowerCaseMapping:0x06CD
  ,simpleTitleCaseMapping:0x06CD
 },
 { code:0x06CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06CE
  ,simpleLowerCaseMapping:0x06CE
  ,simpleTitleCaseMapping:0x06CE
 },
 { code:0x06CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06CF
  ,simpleLowerCaseMapping:0x06CF
  ,simpleTitleCaseMapping:0x06CF
 },
 { code:0x06D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06D0
  ,simpleLowerCaseMapping:0x06D0
  ,simpleTitleCaseMapping:0x06D0
 },
 { code:0x06D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06D1
  ,simpleLowerCaseMapping:0x06D1
  ,simpleTitleCaseMapping:0x06D1
 },
 { code:0x06D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06D2
  ,simpleLowerCaseMapping:0x06D2
  ,simpleTitleCaseMapping:0x06D2
 },
 { code:0x06D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06D3
  ,simpleLowerCaseMapping:0x06D3
  ,simpleTitleCaseMapping:0x06D3
 },
 { code:0x06D4
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x06D4
  ,simpleLowerCaseMapping:0x06D4
  ,simpleTitleCaseMapping:0x06D4
 },
 { code:0x06D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06D5
  ,simpleLowerCaseMapping:0x06D5
  ,simpleTitleCaseMapping:0x06D5
 },
 { code:0x06D6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06D6
  ,simpleLowerCaseMapping:0x06D6
  ,simpleTitleCaseMapping:0x06D6
 },
 { code:0x06D7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06D7
  ,simpleLowerCaseMapping:0x06D7
  ,simpleTitleCaseMapping:0x06D7
 },
 { code:0x06D8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06D8
  ,simpleLowerCaseMapping:0x06D8
  ,simpleTitleCaseMapping:0x06D8
 },
 { code:0x06D9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06D9
  ,simpleLowerCaseMapping:0x06D9
  ,simpleTitleCaseMapping:0x06D9
 },
 { code:0x06DA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06DA
  ,simpleLowerCaseMapping:0x06DA
  ,simpleTitleCaseMapping:0x06DA
 },
 { code:0x06DB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06DB
  ,simpleLowerCaseMapping:0x06DB
  ,simpleTitleCaseMapping:0x06DB
 },
 { code:0x06DC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06DC
  ,simpleLowerCaseMapping:0x06DC
  ,simpleTitleCaseMapping:0x06DC
 },
 { code:0x06DD
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x06DD
  ,simpleLowerCaseMapping:0x06DD
  ,simpleTitleCaseMapping:0x06DD
 },
 { code:0x06DE
  ,generalCategory:UnicodeData.GeneralCategory.Me
  ,simpleUpperCaseMapping:0x06DE
  ,simpleLowerCaseMapping:0x06DE
  ,simpleTitleCaseMapping:0x06DE
 },
 { code:0x06DF
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06DF
  ,simpleLowerCaseMapping:0x06DF
  ,simpleTitleCaseMapping:0x06DF
 },
 { code:0x06E0
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06E0
  ,simpleLowerCaseMapping:0x06E0
  ,simpleTitleCaseMapping:0x06E0
 },
 { code:0x06E1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06E1
  ,simpleLowerCaseMapping:0x06E1
  ,simpleTitleCaseMapping:0x06E1
 },
 { code:0x06E2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06E2
  ,simpleLowerCaseMapping:0x06E2
  ,simpleTitleCaseMapping:0x06E2
 },
 { code:0x06E3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06E3
  ,simpleLowerCaseMapping:0x06E3
  ,simpleTitleCaseMapping:0x06E3
 },
 { code:0x06E4
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06E4
  ,simpleLowerCaseMapping:0x06E4
  ,simpleTitleCaseMapping:0x06E4
 },
 { code:0x06E5
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x06E5
  ,simpleLowerCaseMapping:0x06E5
  ,simpleTitleCaseMapping:0x06E5
 },
 { code:0x06E6
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x06E6
  ,simpleLowerCaseMapping:0x06E6
  ,simpleTitleCaseMapping:0x06E6
 },
 { code:0x06E7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06E7
  ,simpleLowerCaseMapping:0x06E7
  ,simpleTitleCaseMapping:0x06E7
 },
 { code:0x06E8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06E8
  ,simpleLowerCaseMapping:0x06E8
  ,simpleTitleCaseMapping:0x06E8
 },
 { code:0x06E9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x06E9
  ,simpleLowerCaseMapping:0x06E9
  ,simpleTitleCaseMapping:0x06E9
 },
 { code:0x06EA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06EA
  ,simpleLowerCaseMapping:0x06EA
  ,simpleTitleCaseMapping:0x06EA
 },
 { code:0x06EB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06EB
  ,simpleLowerCaseMapping:0x06EB
  ,simpleTitleCaseMapping:0x06EB
 },
 { code:0x06EC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06EC
  ,simpleLowerCaseMapping:0x06EC
  ,simpleTitleCaseMapping:0x06EC
 },
 { code:0x06ED
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x06ED
  ,simpleLowerCaseMapping:0x06ED
  ,simpleTitleCaseMapping:0x06ED
 },
 { code:0x06EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06EE
  ,simpleLowerCaseMapping:0x06EE
  ,simpleTitleCaseMapping:0x06EE
 },
 { code:0x06EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06EF
  ,simpleLowerCaseMapping:0x06EF
  ,simpleTitleCaseMapping:0x06EF
 },
 { code:0x06F0
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x06F0
  ,simpleLowerCaseMapping:0x06F0
  ,simpleTitleCaseMapping:0x06F0
 },
 { code:0x06F1
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x06F1
  ,simpleLowerCaseMapping:0x06F1
  ,simpleTitleCaseMapping:0x06F1
 },
 { code:0x06F2
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x06F2
  ,simpleLowerCaseMapping:0x06F2
  ,simpleTitleCaseMapping:0x06F2
 },
 { code:0x06F3
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x06F3
  ,simpleLowerCaseMapping:0x06F3
  ,simpleTitleCaseMapping:0x06F3
 },
 { code:0x06F4
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x06F4
  ,simpleLowerCaseMapping:0x06F4
  ,simpleTitleCaseMapping:0x06F4
 },
 { code:0x06F5
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x06F5
  ,simpleLowerCaseMapping:0x06F5
  ,simpleTitleCaseMapping:0x06F5
 },
 { code:0x06F6
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x06F6
  ,simpleLowerCaseMapping:0x06F6
  ,simpleTitleCaseMapping:0x06F6
 },
 { code:0x06F7
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x06F7
  ,simpleLowerCaseMapping:0x06F7
  ,simpleTitleCaseMapping:0x06F7
 },
 { code:0x06F8
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x06F8
  ,simpleLowerCaseMapping:0x06F8
  ,simpleTitleCaseMapping:0x06F8
 },
 { code:0x06F9
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x06F9
  ,simpleLowerCaseMapping:0x06F9
  ,simpleTitleCaseMapping:0x06F9
 },
 { code:0x06FA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06FA
  ,simpleLowerCaseMapping:0x06FA
  ,simpleTitleCaseMapping:0x06FA
 },
 { code:0x06FB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06FB
  ,simpleLowerCaseMapping:0x06FB
  ,simpleTitleCaseMapping:0x06FB
 },
 { code:0x06FC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06FC
  ,simpleLowerCaseMapping:0x06FC
  ,simpleTitleCaseMapping:0x06FC
 },
 { code:0x06FD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x06FD
  ,simpleLowerCaseMapping:0x06FD
  ,simpleTitleCaseMapping:0x06FD
 },
 { code:0x06FE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x06FE
  ,simpleLowerCaseMapping:0x06FE
  ,simpleTitleCaseMapping:0x06FE
 },
 { code:0x06FF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x06FF
  ,simpleLowerCaseMapping:0x06FF
  ,simpleTitleCaseMapping:0x06FF
 },
 { code:0x0700
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0700
  ,simpleLowerCaseMapping:0x0700
  ,simpleTitleCaseMapping:0x0700
 },
 { code:0x0701
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0701
  ,simpleLowerCaseMapping:0x0701
  ,simpleTitleCaseMapping:0x0701
 },
 { code:0x0702
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0702
  ,simpleLowerCaseMapping:0x0702
  ,simpleTitleCaseMapping:0x0702
 },
 { code:0x0703
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0703
  ,simpleLowerCaseMapping:0x0703
  ,simpleTitleCaseMapping:0x0703
 },
 { code:0x0704
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0704
  ,simpleLowerCaseMapping:0x0704
  ,simpleTitleCaseMapping:0x0704
 },
 { code:0x0705
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0705
  ,simpleLowerCaseMapping:0x0705
  ,simpleTitleCaseMapping:0x0705
 },
 { code:0x0706
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0706
  ,simpleLowerCaseMapping:0x0706
  ,simpleTitleCaseMapping:0x0706
 },
 { code:0x0707
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0707
  ,simpleLowerCaseMapping:0x0707
  ,simpleTitleCaseMapping:0x0707
 },
 { code:0x0708
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0708
  ,simpleLowerCaseMapping:0x0708
  ,simpleTitleCaseMapping:0x0708
 },
 { code:0x0709
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0709
  ,simpleLowerCaseMapping:0x0709
  ,simpleTitleCaseMapping:0x0709
 },
 { code:0x070A
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x070A
  ,simpleLowerCaseMapping:0x070A
  ,simpleTitleCaseMapping:0x070A
 },
 { code:0x070B
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x070B
  ,simpleLowerCaseMapping:0x070B
  ,simpleTitleCaseMapping:0x070B
 },
 { code:0x070C
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x070C
  ,simpleLowerCaseMapping:0x070C
  ,simpleTitleCaseMapping:0x070C
 },
 { code:0x070D
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x070D
  ,simpleLowerCaseMapping:0x070D
  ,simpleTitleCaseMapping:0x070D
 },
 { code:0x070F
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x070F
  ,simpleLowerCaseMapping:0x070F
  ,simpleTitleCaseMapping:0x070F
 },
 { code:0x0710
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0710
  ,simpleLowerCaseMapping:0x0710
  ,simpleTitleCaseMapping:0x0710
 },
 { code:0x0711
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0711
  ,simpleLowerCaseMapping:0x0711
  ,simpleTitleCaseMapping:0x0711
 },
 { code:0x0712
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0712
  ,simpleLowerCaseMapping:0x0712
  ,simpleTitleCaseMapping:0x0712
 },
 { code:0x0713
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0713
  ,simpleLowerCaseMapping:0x0713
  ,simpleTitleCaseMapping:0x0713
 },
 { code:0x0714
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0714
  ,simpleLowerCaseMapping:0x0714
  ,simpleTitleCaseMapping:0x0714
 },
 { code:0x0715
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0715
  ,simpleLowerCaseMapping:0x0715
  ,simpleTitleCaseMapping:0x0715
 },
 { code:0x0716
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0716
  ,simpleLowerCaseMapping:0x0716
  ,simpleTitleCaseMapping:0x0716
 },
 { code:0x0717
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0717
  ,simpleLowerCaseMapping:0x0717
  ,simpleTitleCaseMapping:0x0717
 },
 { code:0x0718
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0718
  ,simpleLowerCaseMapping:0x0718
  ,simpleTitleCaseMapping:0x0718
 },
 { code:0x0719
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0719
  ,simpleLowerCaseMapping:0x0719
  ,simpleTitleCaseMapping:0x0719
 },
 { code:0x071A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x071A
  ,simpleLowerCaseMapping:0x071A
  ,simpleTitleCaseMapping:0x071A
 },
 { code:0x071B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x071B
  ,simpleLowerCaseMapping:0x071B
  ,simpleTitleCaseMapping:0x071B
 },
 { code:0x071C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x071C
  ,simpleLowerCaseMapping:0x071C
  ,simpleTitleCaseMapping:0x071C
 },
 { code:0x071D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x071D
  ,simpleLowerCaseMapping:0x071D
  ,simpleTitleCaseMapping:0x071D
 },
 { code:0x071E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x071E
  ,simpleLowerCaseMapping:0x071E
  ,simpleTitleCaseMapping:0x071E
 },
 { code:0x071F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x071F
  ,simpleLowerCaseMapping:0x071F
  ,simpleTitleCaseMapping:0x071F
 },
 { code:0x0720
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0720
  ,simpleLowerCaseMapping:0x0720
  ,simpleTitleCaseMapping:0x0720
 },
 { code:0x0721
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0721
  ,simpleLowerCaseMapping:0x0721
  ,simpleTitleCaseMapping:0x0721
 },
 { code:0x0722
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0722
  ,simpleLowerCaseMapping:0x0722
  ,simpleTitleCaseMapping:0x0722
 },
 { code:0x0723
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0723
  ,simpleLowerCaseMapping:0x0723
  ,simpleTitleCaseMapping:0x0723
 },
 { code:0x0724
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0724
  ,simpleLowerCaseMapping:0x0724
  ,simpleTitleCaseMapping:0x0724
 },
 { code:0x0725
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0725
  ,simpleLowerCaseMapping:0x0725
  ,simpleTitleCaseMapping:0x0725
 },
 { code:0x0726
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0726
  ,simpleLowerCaseMapping:0x0726
  ,simpleTitleCaseMapping:0x0726
 },
 { code:0x0727
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0727
  ,simpleLowerCaseMapping:0x0727
  ,simpleTitleCaseMapping:0x0727
 },
 { code:0x0728
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0728
  ,simpleLowerCaseMapping:0x0728
  ,simpleTitleCaseMapping:0x0728
 },
 { code:0x0729
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0729
  ,simpleLowerCaseMapping:0x0729
  ,simpleTitleCaseMapping:0x0729
 },
 { code:0x072A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x072A
  ,simpleLowerCaseMapping:0x072A
  ,simpleTitleCaseMapping:0x072A
 },
 { code:0x072B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x072B
  ,simpleLowerCaseMapping:0x072B
  ,simpleTitleCaseMapping:0x072B
 },
 { code:0x072C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x072C
  ,simpleLowerCaseMapping:0x072C
  ,simpleTitleCaseMapping:0x072C
 },
 { code:0x072D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x072D
  ,simpleLowerCaseMapping:0x072D
  ,simpleTitleCaseMapping:0x072D
 },
 { code:0x072E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x072E
  ,simpleLowerCaseMapping:0x072E
  ,simpleTitleCaseMapping:0x072E
 },
 { code:0x072F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x072F
  ,simpleLowerCaseMapping:0x072F
  ,simpleTitleCaseMapping:0x072F
 },
 { code:0x0730
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0730
  ,simpleLowerCaseMapping:0x0730
  ,simpleTitleCaseMapping:0x0730
 },
 { code:0x0731
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0731
  ,simpleLowerCaseMapping:0x0731
  ,simpleTitleCaseMapping:0x0731
 },
 { code:0x0732
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0732
  ,simpleLowerCaseMapping:0x0732
  ,simpleTitleCaseMapping:0x0732
 },
 { code:0x0733
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0733
  ,simpleLowerCaseMapping:0x0733
  ,simpleTitleCaseMapping:0x0733
 },
 { code:0x0734
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0734
  ,simpleLowerCaseMapping:0x0734
  ,simpleTitleCaseMapping:0x0734
 },
 { code:0x0735
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0735
  ,simpleLowerCaseMapping:0x0735
  ,simpleTitleCaseMapping:0x0735
 },
 { code:0x0736
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0736
  ,simpleLowerCaseMapping:0x0736
  ,simpleTitleCaseMapping:0x0736
 },
 { code:0x0737
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0737
  ,simpleLowerCaseMapping:0x0737
  ,simpleTitleCaseMapping:0x0737
 },
 { code:0x0738
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0738
  ,simpleLowerCaseMapping:0x0738
  ,simpleTitleCaseMapping:0x0738
 },
 { code:0x0739
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0739
  ,simpleLowerCaseMapping:0x0739
  ,simpleTitleCaseMapping:0x0739
 },
 { code:0x073A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x073A
  ,simpleLowerCaseMapping:0x073A
  ,simpleTitleCaseMapping:0x073A
 },
 { code:0x073B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x073B
  ,simpleLowerCaseMapping:0x073B
  ,simpleTitleCaseMapping:0x073B
 },
 { code:0x073C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x073C
  ,simpleLowerCaseMapping:0x073C
  ,simpleTitleCaseMapping:0x073C
 },
 { code:0x073D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x073D
  ,simpleLowerCaseMapping:0x073D
  ,simpleTitleCaseMapping:0x073D
 },
 { code:0x073E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x073E
  ,simpleLowerCaseMapping:0x073E
  ,simpleTitleCaseMapping:0x073E
 },
 { code:0x073F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x073F
  ,simpleLowerCaseMapping:0x073F
  ,simpleTitleCaseMapping:0x073F
 },
 { code:0x0740
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0740
  ,simpleLowerCaseMapping:0x0740
  ,simpleTitleCaseMapping:0x0740
 },
 { code:0x0741
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0741
  ,simpleLowerCaseMapping:0x0741
  ,simpleTitleCaseMapping:0x0741
 },
 { code:0x0742
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0742
  ,simpleLowerCaseMapping:0x0742
  ,simpleTitleCaseMapping:0x0742
 },
 { code:0x0743
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0743
  ,simpleLowerCaseMapping:0x0743
  ,simpleTitleCaseMapping:0x0743
 },
 { code:0x0744
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0744
  ,simpleLowerCaseMapping:0x0744
  ,simpleTitleCaseMapping:0x0744
 },
 { code:0x0745
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0745
  ,simpleLowerCaseMapping:0x0745
  ,simpleTitleCaseMapping:0x0745
 },
 { code:0x0746
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0746
  ,simpleLowerCaseMapping:0x0746
  ,simpleTitleCaseMapping:0x0746
 },
 { code:0x0747
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0747
  ,simpleLowerCaseMapping:0x0747
  ,simpleTitleCaseMapping:0x0747
 },
 { code:0x0748
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0748
  ,simpleLowerCaseMapping:0x0748
  ,simpleTitleCaseMapping:0x0748
 },
 { code:0x0749
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0749
  ,simpleLowerCaseMapping:0x0749
  ,simpleTitleCaseMapping:0x0749
 },
 { code:0x074A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x074A
  ,simpleLowerCaseMapping:0x074A
  ,simpleTitleCaseMapping:0x074A
 },
 { code:0x074D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x074D
  ,simpleLowerCaseMapping:0x074D
  ,simpleTitleCaseMapping:0x074D
 },
 { code:0x074E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x074E
  ,simpleLowerCaseMapping:0x074E
  ,simpleTitleCaseMapping:0x074E
 },
 { code:0x074F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x074F
  ,simpleLowerCaseMapping:0x074F
  ,simpleTitleCaseMapping:0x074F
 },
 { code:0x0750
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0750
  ,simpleLowerCaseMapping:0x0750
  ,simpleTitleCaseMapping:0x0750
 },
 { code:0x0751
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0751
  ,simpleLowerCaseMapping:0x0751
  ,simpleTitleCaseMapping:0x0751
 },
 { code:0x0752
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0752
  ,simpleLowerCaseMapping:0x0752
  ,simpleTitleCaseMapping:0x0752
 },
 { code:0x0753
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0753
  ,simpleLowerCaseMapping:0x0753
  ,simpleTitleCaseMapping:0x0753
 },
 { code:0x0754
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0754
  ,simpleLowerCaseMapping:0x0754
  ,simpleTitleCaseMapping:0x0754
 },
 { code:0x0755
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0755
  ,simpleLowerCaseMapping:0x0755
  ,simpleTitleCaseMapping:0x0755
 },
 { code:0x0756
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0756
  ,simpleLowerCaseMapping:0x0756
  ,simpleTitleCaseMapping:0x0756
 },
 { code:0x0757
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0757
  ,simpleLowerCaseMapping:0x0757
  ,simpleTitleCaseMapping:0x0757
 },
 { code:0x0758
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0758
  ,simpleLowerCaseMapping:0x0758
  ,simpleTitleCaseMapping:0x0758
 },
 { code:0x0759
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0759
  ,simpleLowerCaseMapping:0x0759
  ,simpleTitleCaseMapping:0x0759
 },
 { code:0x075A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x075A
  ,simpleLowerCaseMapping:0x075A
  ,simpleTitleCaseMapping:0x075A
 },
 { code:0x075B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x075B
  ,simpleLowerCaseMapping:0x075B
  ,simpleTitleCaseMapping:0x075B
 },
 { code:0x075C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x075C
  ,simpleLowerCaseMapping:0x075C
  ,simpleTitleCaseMapping:0x075C
 },
 { code:0x075D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x075D
  ,simpleLowerCaseMapping:0x075D
  ,simpleTitleCaseMapping:0x075D
 },
 { code:0x075E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x075E
  ,simpleLowerCaseMapping:0x075E
  ,simpleTitleCaseMapping:0x075E
 },
 { code:0x075F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x075F
  ,simpleLowerCaseMapping:0x075F
  ,simpleTitleCaseMapping:0x075F
 },
 { code:0x0760
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0760
  ,simpleLowerCaseMapping:0x0760
  ,simpleTitleCaseMapping:0x0760
 },
 { code:0x0761
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0761
  ,simpleLowerCaseMapping:0x0761
  ,simpleTitleCaseMapping:0x0761
 },
 { code:0x0762
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0762
  ,simpleLowerCaseMapping:0x0762
  ,simpleTitleCaseMapping:0x0762
 },
 { code:0x0763
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0763
  ,simpleLowerCaseMapping:0x0763
  ,simpleTitleCaseMapping:0x0763
 },
 { code:0x0764
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0764
  ,simpleLowerCaseMapping:0x0764
  ,simpleTitleCaseMapping:0x0764
 },
 { code:0x0765
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0765
  ,simpleLowerCaseMapping:0x0765
  ,simpleTitleCaseMapping:0x0765
 },
 { code:0x0766
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0766
  ,simpleLowerCaseMapping:0x0766
  ,simpleTitleCaseMapping:0x0766
 },
 { code:0x0767
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0767
  ,simpleLowerCaseMapping:0x0767
  ,simpleTitleCaseMapping:0x0767
 },
 { code:0x0768
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0768
  ,simpleLowerCaseMapping:0x0768
  ,simpleTitleCaseMapping:0x0768
 },
 { code:0x0769
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0769
  ,simpleLowerCaseMapping:0x0769
  ,simpleTitleCaseMapping:0x0769
 },
 { code:0x076A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x076A
  ,simpleLowerCaseMapping:0x076A
  ,simpleTitleCaseMapping:0x076A
 },
 { code:0x076B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x076B
  ,simpleLowerCaseMapping:0x076B
  ,simpleTitleCaseMapping:0x076B
 },
 { code:0x076C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x076C
  ,simpleLowerCaseMapping:0x076C
  ,simpleTitleCaseMapping:0x076C
 },
 { code:0x076D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x076D
  ,simpleLowerCaseMapping:0x076D
  ,simpleTitleCaseMapping:0x076D
 },
 { code:0x0780
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0780
  ,simpleLowerCaseMapping:0x0780
  ,simpleTitleCaseMapping:0x0780
 },
 { code:0x0781
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0781
  ,simpleLowerCaseMapping:0x0781
  ,simpleTitleCaseMapping:0x0781
 },
 { code:0x0782
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0782
  ,simpleLowerCaseMapping:0x0782
  ,simpleTitleCaseMapping:0x0782
 },
 { code:0x0783
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0783
  ,simpleLowerCaseMapping:0x0783
  ,simpleTitleCaseMapping:0x0783
 },
 { code:0x0784
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0784
  ,simpleLowerCaseMapping:0x0784
  ,simpleTitleCaseMapping:0x0784
 },
 { code:0x0785
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0785
  ,simpleLowerCaseMapping:0x0785
  ,simpleTitleCaseMapping:0x0785
 },
 { code:0x0786
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0786
  ,simpleLowerCaseMapping:0x0786
  ,simpleTitleCaseMapping:0x0786
 },
 { code:0x0787
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0787
  ,simpleLowerCaseMapping:0x0787
  ,simpleTitleCaseMapping:0x0787
 },
 { code:0x0788
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0788
  ,simpleLowerCaseMapping:0x0788
  ,simpleTitleCaseMapping:0x0788
 },
 { code:0x0789
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0789
  ,simpleLowerCaseMapping:0x0789
  ,simpleTitleCaseMapping:0x0789
 },
 { code:0x078A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x078A
  ,simpleLowerCaseMapping:0x078A
  ,simpleTitleCaseMapping:0x078A
 },
 { code:0x078B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x078B
  ,simpleLowerCaseMapping:0x078B
  ,simpleTitleCaseMapping:0x078B
 },
 { code:0x078C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x078C
  ,simpleLowerCaseMapping:0x078C
  ,simpleTitleCaseMapping:0x078C
 },
 { code:0x078D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x078D
  ,simpleLowerCaseMapping:0x078D
  ,simpleTitleCaseMapping:0x078D
 },
 { code:0x078E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x078E
  ,simpleLowerCaseMapping:0x078E
  ,simpleTitleCaseMapping:0x078E
 },
 { code:0x078F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x078F
  ,simpleLowerCaseMapping:0x078F
  ,simpleTitleCaseMapping:0x078F
 },
 { code:0x0790
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0790
  ,simpleLowerCaseMapping:0x0790
  ,simpleTitleCaseMapping:0x0790
 },
 { code:0x0791
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0791
  ,simpleLowerCaseMapping:0x0791
  ,simpleTitleCaseMapping:0x0791
 },
 { code:0x0792
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0792
  ,simpleLowerCaseMapping:0x0792
  ,simpleTitleCaseMapping:0x0792
 },
 { code:0x0793
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0793
  ,simpleLowerCaseMapping:0x0793
  ,simpleTitleCaseMapping:0x0793
 },
 { code:0x0794
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0794
  ,simpleLowerCaseMapping:0x0794
  ,simpleTitleCaseMapping:0x0794
 },
 { code:0x0795
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0795
  ,simpleLowerCaseMapping:0x0795
  ,simpleTitleCaseMapping:0x0795
 },
 { code:0x0796
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0796
  ,simpleLowerCaseMapping:0x0796
  ,simpleTitleCaseMapping:0x0796
 },
 { code:0x0797
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0797
  ,simpleLowerCaseMapping:0x0797
  ,simpleTitleCaseMapping:0x0797
 },
 { code:0x0798
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0798
  ,simpleLowerCaseMapping:0x0798
  ,simpleTitleCaseMapping:0x0798
 },
 { code:0x0799
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0799
  ,simpleLowerCaseMapping:0x0799
  ,simpleTitleCaseMapping:0x0799
 },
 { code:0x079A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x079A
  ,simpleLowerCaseMapping:0x079A
  ,simpleTitleCaseMapping:0x079A
 },
 { code:0x079B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x079B
  ,simpleLowerCaseMapping:0x079B
  ,simpleTitleCaseMapping:0x079B
 },
 { code:0x079C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x079C
  ,simpleLowerCaseMapping:0x079C
  ,simpleTitleCaseMapping:0x079C
 },
 { code:0x079D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x079D
  ,simpleLowerCaseMapping:0x079D
  ,simpleTitleCaseMapping:0x079D
 },
 { code:0x079E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x079E
  ,simpleLowerCaseMapping:0x079E
  ,simpleTitleCaseMapping:0x079E
 },
 { code:0x079F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x079F
  ,simpleLowerCaseMapping:0x079F
  ,simpleTitleCaseMapping:0x079F
 },
 { code:0x07A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07A0
  ,simpleLowerCaseMapping:0x07A0
  ,simpleTitleCaseMapping:0x07A0
 },
 { code:0x07A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07A1
  ,simpleLowerCaseMapping:0x07A1
  ,simpleTitleCaseMapping:0x07A1
 },
 { code:0x07A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07A2
  ,simpleLowerCaseMapping:0x07A2
  ,simpleTitleCaseMapping:0x07A2
 },
 { code:0x07A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07A3
  ,simpleLowerCaseMapping:0x07A3
  ,simpleTitleCaseMapping:0x07A3
 },
 { code:0x07A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07A4
  ,simpleLowerCaseMapping:0x07A4
  ,simpleTitleCaseMapping:0x07A4
 },
 { code:0x07A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07A5
  ,simpleLowerCaseMapping:0x07A5
  ,simpleTitleCaseMapping:0x07A5
 },
 { code:0x07A6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07A6
  ,simpleLowerCaseMapping:0x07A6
  ,simpleTitleCaseMapping:0x07A6
 },
 { code:0x07A7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07A7
  ,simpleLowerCaseMapping:0x07A7
  ,simpleTitleCaseMapping:0x07A7
 },
 { code:0x07A8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07A8
  ,simpleLowerCaseMapping:0x07A8
  ,simpleTitleCaseMapping:0x07A8
 },
 { code:0x07A9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07A9
  ,simpleLowerCaseMapping:0x07A9
  ,simpleTitleCaseMapping:0x07A9
 },
 { code:0x07AA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07AA
  ,simpleLowerCaseMapping:0x07AA
  ,simpleTitleCaseMapping:0x07AA
 },
 { code:0x07AB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07AB
  ,simpleLowerCaseMapping:0x07AB
  ,simpleTitleCaseMapping:0x07AB
 },
 { code:0x07AC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07AC
  ,simpleLowerCaseMapping:0x07AC
  ,simpleTitleCaseMapping:0x07AC
 },
 { code:0x07AD
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07AD
  ,simpleLowerCaseMapping:0x07AD
  ,simpleTitleCaseMapping:0x07AD
 },
 { code:0x07AE
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07AE
  ,simpleLowerCaseMapping:0x07AE
  ,simpleTitleCaseMapping:0x07AE
 },
 { code:0x07AF
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07AF
  ,simpleLowerCaseMapping:0x07AF
  ,simpleTitleCaseMapping:0x07AF
 },
 { code:0x07B0
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07B0
  ,simpleLowerCaseMapping:0x07B0
  ,simpleTitleCaseMapping:0x07B0
 },
 { code:0x07B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07B1
  ,simpleLowerCaseMapping:0x07B1
  ,simpleTitleCaseMapping:0x07B1
 },
 { code:0x07C0
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x07C0
  ,simpleLowerCaseMapping:0x07C0
  ,simpleTitleCaseMapping:0x07C0
 },
 { code:0x07C1
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x07C1
  ,simpleLowerCaseMapping:0x07C1
  ,simpleTitleCaseMapping:0x07C1
 },
 { code:0x07C2
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x07C2
  ,simpleLowerCaseMapping:0x07C2
  ,simpleTitleCaseMapping:0x07C2
 },
 { code:0x07C3
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x07C3
  ,simpleLowerCaseMapping:0x07C3
  ,simpleTitleCaseMapping:0x07C3
 },
 { code:0x07C4
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x07C4
  ,simpleLowerCaseMapping:0x07C4
  ,simpleTitleCaseMapping:0x07C4
 },
 { code:0x07C5
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x07C5
  ,simpleLowerCaseMapping:0x07C5
  ,simpleTitleCaseMapping:0x07C5
 },
 { code:0x07C6
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x07C6
  ,simpleLowerCaseMapping:0x07C6
  ,simpleTitleCaseMapping:0x07C6
 },
 { code:0x07C7
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x07C7
  ,simpleLowerCaseMapping:0x07C7
  ,simpleTitleCaseMapping:0x07C7
 },
 { code:0x07C8
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x07C8
  ,simpleLowerCaseMapping:0x07C8
  ,simpleTitleCaseMapping:0x07C8
 },
 { code:0x07C9
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x07C9
  ,simpleLowerCaseMapping:0x07C9
  ,simpleTitleCaseMapping:0x07C9
 },
 { code:0x07CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07CA
  ,simpleLowerCaseMapping:0x07CA
  ,simpleTitleCaseMapping:0x07CA
 },
 { code:0x07CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07CB
  ,simpleLowerCaseMapping:0x07CB
  ,simpleTitleCaseMapping:0x07CB
 },
 { code:0x07CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07CC
  ,simpleLowerCaseMapping:0x07CC
  ,simpleTitleCaseMapping:0x07CC
 },
 { code:0x07CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07CD
  ,simpleLowerCaseMapping:0x07CD
  ,simpleTitleCaseMapping:0x07CD
 },
 { code:0x07CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07CE
  ,simpleLowerCaseMapping:0x07CE
  ,simpleTitleCaseMapping:0x07CE
 },
 { code:0x07CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07CF
  ,simpleLowerCaseMapping:0x07CF
  ,simpleTitleCaseMapping:0x07CF
 },
 { code:0x07D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07D0
  ,simpleLowerCaseMapping:0x07D0
  ,simpleTitleCaseMapping:0x07D0
 },
 { code:0x07D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07D1
  ,simpleLowerCaseMapping:0x07D1
  ,simpleTitleCaseMapping:0x07D1
 },
 { code:0x07D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07D2
  ,simpleLowerCaseMapping:0x07D2
  ,simpleTitleCaseMapping:0x07D2
 },
 { code:0x07D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07D3
  ,simpleLowerCaseMapping:0x07D3
  ,simpleTitleCaseMapping:0x07D3
 },
 { code:0x07D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07D4
  ,simpleLowerCaseMapping:0x07D4
  ,simpleTitleCaseMapping:0x07D4
 },
 { code:0x07D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07D5
  ,simpleLowerCaseMapping:0x07D5
  ,simpleTitleCaseMapping:0x07D5
 },
 { code:0x07D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07D6
  ,simpleLowerCaseMapping:0x07D6
  ,simpleTitleCaseMapping:0x07D6
 },
 { code:0x07D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07D7
  ,simpleLowerCaseMapping:0x07D7
  ,simpleTitleCaseMapping:0x07D7
 },
 { code:0x07D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07D8
  ,simpleLowerCaseMapping:0x07D8
  ,simpleTitleCaseMapping:0x07D8
 },
 { code:0x07D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07D9
  ,simpleLowerCaseMapping:0x07D9
  ,simpleTitleCaseMapping:0x07D9
 },
 { code:0x07DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07DA
  ,simpleLowerCaseMapping:0x07DA
  ,simpleTitleCaseMapping:0x07DA
 },
 { code:0x07DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07DB
  ,simpleLowerCaseMapping:0x07DB
  ,simpleTitleCaseMapping:0x07DB
 },
 { code:0x07DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07DC
  ,simpleLowerCaseMapping:0x07DC
  ,simpleTitleCaseMapping:0x07DC
 },
 { code:0x07DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07DD
  ,simpleLowerCaseMapping:0x07DD
  ,simpleTitleCaseMapping:0x07DD
 },
 { code:0x07DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07DE
  ,simpleLowerCaseMapping:0x07DE
  ,simpleTitleCaseMapping:0x07DE
 },
 { code:0x07DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07DF
  ,simpleLowerCaseMapping:0x07DF
  ,simpleTitleCaseMapping:0x07DF
 },
 { code:0x07E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07E0
  ,simpleLowerCaseMapping:0x07E0
  ,simpleTitleCaseMapping:0x07E0
 },
 { code:0x07E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07E1
  ,simpleLowerCaseMapping:0x07E1
  ,simpleTitleCaseMapping:0x07E1
 },
 { code:0x07E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07E2
  ,simpleLowerCaseMapping:0x07E2
  ,simpleTitleCaseMapping:0x07E2
 },
 { code:0x07E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07E3
  ,simpleLowerCaseMapping:0x07E3
  ,simpleTitleCaseMapping:0x07E3
 },
 { code:0x07E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07E4
  ,simpleLowerCaseMapping:0x07E4
  ,simpleTitleCaseMapping:0x07E4
 },
 { code:0x07E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07E5
  ,simpleLowerCaseMapping:0x07E5
  ,simpleTitleCaseMapping:0x07E5
 },
 { code:0x07E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07E6
  ,simpleLowerCaseMapping:0x07E6
  ,simpleTitleCaseMapping:0x07E6
 },
 { code:0x07E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07E7
  ,simpleLowerCaseMapping:0x07E7
  ,simpleTitleCaseMapping:0x07E7
 },
 { code:0x07E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07E8
  ,simpleLowerCaseMapping:0x07E8
  ,simpleTitleCaseMapping:0x07E8
 },
 { code:0x07E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07E9
  ,simpleLowerCaseMapping:0x07E9
  ,simpleTitleCaseMapping:0x07E9
 },
 { code:0x07EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x07EA
  ,simpleLowerCaseMapping:0x07EA
  ,simpleTitleCaseMapping:0x07EA
 },
 { code:0x07EB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07EB
  ,simpleLowerCaseMapping:0x07EB
  ,simpleTitleCaseMapping:0x07EB
 },
 { code:0x07EC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07EC
  ,simpleLowerCaseMapping:0x07EC
  ,simpleTitleCaseMapping:0x07EC
 },
 { code:0x07ED
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07ED
  ,simpleLowerCaseMapping:0x07ED
  ,simpleTitleCaseMapping:0x07ED
 },
 { code:0x07EE
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07EE
  ,simpleLowerCaseMapping:0x07EE
  ,simpleTitleCaseMapping:0x07EE
 },
 { code:0x07EF
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07EF
  ,simpleLowerCaseMapping:0x07EF
  ,simpleTitleCaseMapping:0x07EF
 },
 { code:0x07F0
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07F0
  ,simpleLowerCaseMapping:0x07F0
  ,simpleTitleCaseMapping:0x07F0
 },
 { code:0x07F1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07F1
  ,simpleLowerCaseMapping:0x07F1
  ,simpleTitleCaseMapping:0x07F1
 },
 { code:0x07F2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07F2
  ,simpleLowerCaseMapping:0x07F2
  ,simpleTitleCaseMapping:0x07F2
 },
 { code:0x07F3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x07F3
  ,simpleLowerCaseMapping:0x07F3
  ,simpleTitleCaseMapping:0x07F3
 },
 { code:0x07F4
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x07F4
  ,simpleLowerCaseMapping:0x07F4
  ,simpleTitleCaseMapping:0x07F4
 },
 { code:0x07F5
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x07F5
  ,simpleLowerCaseMapping:0x07F5
  ,simpleTitleCaseMapping:0x07F5
 },
 { code:0x07F6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x07F6
  ,simpleLowerCaseMapping:0x07F6
  ,simpleTitleCaseMapping:0x07F6
 },
 { code:0x07F7
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x07F7
  ,simpleLowerCaseMapping:0x07F7
  ,simpleTitleCaseMapping:0x07F7
 },
 { code:0x07F8
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x07F8
  ,simpleLowerCaseMapping:0x07F8
  ,simpleTitleCaseMapping:0x07F8
 },
 { code:0x07F9
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x07F9
  ,simpleLowerCaseMapping:0x07F9
  ,simpleTitleCaseMapping:0x07F9
 },
 { code:0x07FA
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x07FA
  ,simpleLowerCaseMapping:0x07FA
  ,simpleTitleCaseMapping:0x07FA
 },
 { code:0x0901
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0901
  ,simpleLowerCaseMapping:0x0901
  ,simpleTitleCaseMapping:0x0901
 },
 { code:0x0902
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0902
  ,simpleLowerCaseMapping:0x0902
  ,simpleTitleCaseMapping:0x0902
 },
 { code:0x0903
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0903
  ,simpleLowerCaseMapping:0x0903
  ,simpleTitleCaseMapping:0x0903
 },
 { code:0x0904
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0904
  ,simpleLowerCaseMapping:0x0904
  ,simpleTitleCaseMapping:0x0904
 },
 { code:0x0905
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0905
  ,simpleLowerCaseMapping:0x0905
  ,simpleTitleCaseMapping:0x0905
 },
 { code:0x0906
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0906
  ,simpleLowerCaseMapping:0x0906
  ,simpleTitleCaseMapping:0x0906
 },
 { code:0x0907
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0907
  ,simpleLowerCaseMapping:0x0907
  ,simpleTitleCaseMapping:0x0907
 },
 { code:0x0908
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0908
  ,simpleLowerCaseMapping:0x0908
  ,simpleTitleCaseMapping:0x0908
 },
 { code:0x0909
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0909
  ,simpleLowerCaseMapping:0x0909
  ,simpleTitleCaseMapping:0x0909
 },
 { code:0x090A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x090A
  ,simpleLowerCaseMapping:0x090A
  ,simpleTitleCaseMapping:0x090A
 },
 { code:0x090B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x090B
  ,simpleLowerCaseMapping:0x090B
  ,simpleTitleCaseMapping:0x090B
 },
 { code:0x090C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x090C
  ,simpleLowerCaseMapping:0x090C
  ,simpleTitleCaseMapping:0x090C
 },
 { code:0x090D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x090D
  ,simpleLowerCaseMapping:0x090D
  ,simpleTitleCaseMapping:0x090D
 },
 { code:0x090E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x090E
  ,simpleLowerCaseMapping:0x090E
  ,simpleTitleCaseMapping:0x090E
 },
 { code:0x090F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x090F
  ,simpleLowerCaseMapping:0x090F
  ,simpleTitleCaseMapping:0x090F
 },
 { code:0x0910
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0910
  ,simpleLowerCaseMapping:0x0910
  ,simpleTitleCaseMapping:0x0910
 },
 { code:0x0911
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0911
  ,simpleLowerCaseMapping:0x0911
  ,simpleTitleCaseMapping:0x0911
 },
 { code:0x0912
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0912
  ,simpleLowerCaseMapping:0x0912
  ,simpleTitleCaseMapping:0x0912
 },
 { code:0x0913
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0913
  ,simpleLowerCaseMapping:0x0913
  ,simpleTitleCaseMapping:0x0913
 },
 { code:0x0914
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0914
  ,simpleLowerCaseMapping:0x0914
  ,simpleTitleCaseMapping:0x0914
 },
 { code:0x0915
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0915
  ,simpleLowerCaseMapping:0x0915
  ,simpleTitleCaseMapping:0x0915
 },
 { code:0x0916
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0916
  ,simpleLowerCaseMapping:0x0916
  ,simpleTitleCaseMapping:0x0916
 },
 { code:0x0917
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0917
  ,simpleLowerCaseMapping:0x0917
  ,simpleTitleCaseMapping:0x0917
 },
 { code:0x0918
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0918
  ,simpleLowerCaseMapping:0x0918
  ,simpleTitleCaseMapping:0x0918
 },
 { code:0x0919
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0919
  ,simpleLowerCaseMapping:0x0919
  ,simpleTitleCaseMapping:0x0919
 },
 { code:0x091A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x091A
  ,simpleLowerCaseMapping:0x091A
  ,simpleTitleCaseMapping:0x091A
 },
 { code:0x091B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x091B
  ,simpleLowerCaseMapping:0x091B
  ,simpleTitleCaseMapping:0x091B
 },
 { code:0x091C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x091C
  ,simpleLowerCaseMapping:0x091C
  ,simpleTitleCaseMapping:0x091C
 },
 { code:0x091D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x091D
  ,simpleLowerCaseMapping:0x091D
  ,simpleTitleCaseMapping:0x091D
 },
 { code:0x091E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x091E
  ,simpleLowerCaseMapping:0x091E
  ,simpleTitleCaseMapping:0x091E
 },
 { code:0x091F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x091F
  ,simpleLowerCaseMapping:0x091F
  ,simpleTitleCaseMapping:0x091F
 },
 { code:0x0920
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0920
  ,simpleLowerCaseMapping:0x0920
  ,simpleTitleCaseMapping:0x0920
 },
 { code:0x0921
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0921
  ,simpleLowerCaseMapping:0x0921
  ,simpleTitleCaseMapping:0x0921
 },
 { code:0x0922
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0922
  ,simpleLowerCaseMapping:0x0922
  ,simpleTitleCaseMapping:0x0922
 },
 { code:0x0923
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0923
  ,simpleLowerCaseMapping:0x0923
  ,simpleTitleCaseMapping:0x0923
 },
 { code:0x0924
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0924
  ,simpleLowerCaseMapping:0x0924
  ,simpleTitleCaseMapping:0x0924
 },
 { code:0x0925
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0925
  ,simpleLowerCaseMapping:0x0925
  ,simpleTitleCaseMapping:0x0925
 },
 { code:0x0926
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0926
  ,simpleLowerCaseMapping:0x0926
  ,simpleTitleCaseMapping:0x0926
 },
 { code:0x0927
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0927
  ,simpleLowerCaseMapping:0x0927
  ,simpleTitleCaseMapping:0x0927
 },
 { code:0x0928
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0928
  ,simpleLowerCaseMapping:0x0928
  ,simpleTitleCaseMapping:0x0928
 },
 { code:0x0929
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0929
  ,simpleLowerCaseMapping:0x0929
  ,simpleTitleCaseMapping:0x0929
 },
 { code:0x092A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x092A
  ,simpleLowerCaseMapping:0x092A
  ,simpleTitleCaseMapping:0x092A
 },
 { code:0x092B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x092B
  ,simpleLowerCaseMapping:0x092B
  ,simpleTitleCaseMapping:0x092B
 },
 { code:0x092C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x092C
  ,simpleLowerCaseMapping:0x092C
  ,simpleTitleCaseMapping:0x092C
 },
 { code:0x092D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x092D
  ,simpleLowerCaseMapping:0x092D
  ,simpleTitleCaseMapping:0x092D
 },
 { code:0x092E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x092E
  ,simpleLowerCaseMapping:0x092E
  ,simpleTitleCaseMapping:0x092E
 },
 { code:0x092F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x092F
  ,simpleLowerCaseMapping:0x092F
  ,simpleTitleCaseMapping:0x092F
 },
 { code:0x0930
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0930
  ,simpleLowerCaseMapping:0x0930
  ,simpleTitleCaseMapping:0x0930
 },
 { code:0x0931
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0931
  ,simpleLowerCaseMapping:0x0931
  ,simpleTitleCaseMapping:0x0931
 },
 { code:0x0932
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0932
  ,simpleLowerCaseMapping:0x0932
  ,simpleTitleCaseMapping:0x0932
 },
 { code:0x0933
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0933
  ,simpleLowerCaseMapping:0x0933
  ,simpleTitleCaseMapping:0x0933
 },
 { code:0x0934
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0934
  ,simpleLowerCaseMapping:0x0934
  ,simpleTitleCaseMapping:0x0934
 },
 { code:0x0935
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0935
  ,simpleLowerCaseMapping:0x0935
  ,simpleTitleCaseMapping:0x0935
 },
 { code:0x0936
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0936
  ,simpleLowerCaseMapping:0x0936
  ,simpleTitleCaseMapping:0x0936
 },
 { code:0x0937
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0937
  ,simpleLowerCaseMapping:0x0937
  ,simpleTitleCaseMapping:0x0937
 },
 { code:0x0938
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0938
  ,simpleLowerCaseMapping:0x0938
  ,simpleTitleCaseMapping:0x0938
 },
 { code:0x0939
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0939
  ,simpleLowerCaseMapping:0x0939
  ,simpleTitleCaseMapping:0x0939
 },
 { code:0x093C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x093C
  ,simpleLowerCaseMapping:0x093C
  ,simpleTitleCaseMapping:0x093C
 },
 { code:0x093D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x093D
  ,simpleLowerCaseMapping:0x093D
  ,simpleTitleCaseMapping:0x093D
 },
 { code:0x093E
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x093E
  ,simpleLowerCaseMapping:0x093E
  ,simpleTitleCaseMapping:0x093E
 },
 { code:0x093F
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x093F
  ,simpleLowerCaseMapping:0x093F
  ,simpleTitleCaseMapping:0x093F
 },
 { code:0x0940
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0940
  ,simpleLowerCaseMapping:0x0940
  ,simpleTitleCaseMapping:0x0940
 },
 { code:0x0941
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0941
  ,simpleLowerCaseMapping:0x0941
  ,simpleTitleCaseMapping:0x0941
 },
 { code:0x0942
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0942
  ,simpleLowerCaseMapping:0x0942
  ,simpleTitleCaseMapping:0x0942
 },
 { code:0x0943
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0943
  ,simpleLowerCaseMapping:0x0943
  ,simpleTitleCaseMapping:0x0943
 },
 { code:0x0944
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0944
  ,simpleLowerCaseMapping:0x0944
  ,simpleTitleCaseMapping:0x0944
 },
 { code:0x0945
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0945
  ,simpleLowerCaseMapping:0x0945
  ,simpleTitleCaseMapping:0x0945
 },
 { code:0x0946
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0946
  ,simpleLowerCaseMapping:0x0946
  ,simpleTitleCaseMapping:0x0946
 },
 { code:0x0947
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0947
  ,simpleLowerCaseMapping:0x0947
  ,simpleTitleCaseMapping:0x0947
 },
 { code:0x0948
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0948
  ,simpleLowerCaseMapping:0x0948
  ,simpleTitleCaseMapping:0x0948
 },
 { code:0x0949
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0949
  ,simpleLowerCaseMapping:0x0949
  ,simpleTitleCaseMapping:0x0949
 },
 { code:0x094A
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x094A
  ,simpleLowerCaseMapping:0x094A
  ,simpleTitleCaseMapping:0x094A
 },
 { code:0x094B
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x094B
  ,simpleLowerCaseMapping:0x094B
  ,simpleTitleCaseMapping:0x094B
 },
 { code:0x094C
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x094C
  ,simpleLowerCaseMapping:0x094C
  ,simpleTitleCaseMapping:0x094C
 },
 { code:0x094D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x094D
  ,simpleLowerCaseMapping:0x094D
  ,simpleTitleCaseMapping:0x094D
 },
 { code:0x0950
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0950
  ,simpleLowerCaseMapping:0x0950
  ,simpleTitleCaseMapping:0x0950
 },
 { code:0x0951
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0951
  ,simpleLowerCaseMapping:0x0951
  ,simpleTitleCaseMapping:0x0951
 },
 { code:0x0952
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0952
  ,simpleLowerCaseMapping:0x0952
  ,simpleTitleCaseMapping:0x0952
 },
 { code:0x0953
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0953
  ,simpleLowerCaseMapping:0x0953
  ,simpleTitleCaseMapping:0x0953
 },
 { code:0x0954
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0954
  ,simpleLowerCaseMapping:0x0954
  ,simpleTitleCaseMapping:0x0954
 },
 { code:0x0958
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0958
  ,simpleLowerCaseMapping:0x0958
  ,simpleTitleCaseMapping:0x0958
 },
 { code:0x0959
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0959
  ,simpleLowerCaseMapping:0x0959
  ,simpleTitleCaseMapping:0x0959
 },
 { code:0x095A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x095A
  ,simpleLowerCaseMapping:0x095A
  ,simpleTitleCaseMapping:0x095A
 },
 { code:0x095B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x095B
  ,simpleLowerCaseMapping:0x095B
  ,simpleTitleCaseMapping:0x095B
 },
 { code:0x095C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x095C
  ,simpleLowerCaseMapping:0x095C
  ,simpleTitleCaseMapping:0x095C
 },
 { code:0x095D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x095D
  ,simpleLowerCaseMapping:0x095D
  ,simpleTitleCaseMapping:0x095D
 },
 { code:0x095E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x095E
  ,simpleLowerCaseMapping:0x095E
  ,simpleTitleCaseMapping:0x095E
 },
 { code:0x095F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x095F
  ,simpleLowerCaseMapping:0x095F
  ,simpleTitleCaseMapping:0x095F
 },
 { code:0x0960
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0960
  ,simpleLowerCaseMapping:0x0960
  ,simpleTitleCaseMapping:0x0960
 },
 { code:0x0961
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0961
  ,simpleLowerCaseMapping:0x0961
  ,simpleTitleCaseMapping:0x0961
 },
 { code:0x0962
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0962
  ,simpleLowerCaseMapping:0x0962
  ,simpleTitleCaseMapping:0x0962
 },
 { code:0x0963
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0963
  ,simpleLowerCaseMapping:0x0963
  ,simpleTitleCaseMapping:0x0963
 },
 { code:0x0964
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0964
  ,simpleLowerCaseMapping:0x0964
  ,simpleTitleCaseMapping:0x0964
 },
 { code:0x0965
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0965
  ,simpleLowerCaseMapping:0x0965
  ,simpleTitleCaseMapping:0x0965
 },
 { code:0x0966
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0966
  ,simpleLowerCaseMapping:0x0966
  ,simpleTitleCaseMapping:0x0966
 },
 { code:0x0967
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0967
  ,simpleLowerCaseMapping:0x0967
  ,simpleTitleCaseMapping:0x0967
 },
 { code:0x0968
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0968
  ,simpleLowerCaseMapping:0x0968
  ,simpleTitleCaseMapping:0x0968
 },
 { code:0x0969
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0969
  ,simpleLowerCaseMapping:0x0969
  ,simpleTitleCaseMapping:0x0969
 },
 { code:0x096A
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x096A
  ,simpleLowerCaseMapping:0x096A
  ,simpleTitleCaseMapping:0x096A
 },
 { code:0x096B
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x096B
  ,simpleLowerCaseMapping:0x096B
  ,simpleTitleCaseMapping:0x096B
 },
 { code:0x096C
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x096C
  ,simpleLowerCaseMapping:0x096C
  ,simpleTitleCaseMapping:0x096C
 },
 { code:0x096D
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x096D
  ,simpleLowerCaseMapping:0x096D
  ,simpleTitleCaseMapping:0x096D
 },
 { code:0x096E
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x096E
  ,simpleLowerCaseMapping:0x096E
  ,simpleTitleCaseMapping:0x096E
 },
 { code:0x096F
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x096F
  ,simpleLowerCaseMapping:0x096F
  ,simpleTitleCaseMapping:0x096F
 },
 { code:0x0970
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0970
  ,simpleLowerCaseMapping:0x0970
  ,simpleTitleCaseMapping:0x0970
 },
 { code:0x097B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x097B
  ,simpleLowerCaseMapping:0x097B
  ,simpleTitleCaseMapping:0x097B
 },
 { code:0x097C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x097C
  ,simpleLowerCaseMapping:0x097C
  ,simpleTitleCaseMapping:0x097C
 },
 { code:0x097D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x097D
  ,simpleLowerCaseMapping:0x097D
  ,simpleTitleCaseMapping:0x097D
 },
 { code:0x097E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x097E
  ,simpleLowerCaseMapping:0x097E
  ,simpleTitleCaseMapping:0x097E
 },
 { code:0x097F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x097F
  ,simpleLowerCaseMapping:0x097F
  ,simpleTitleCaseMapping:0x097F
 },
 { code:0x0981
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0981
  ,simpleLowerCaseMapping:0x0981
  ,simpleTitleCaseMapping:0x0981
 },
 { code:0x0982
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0982
  ,simpleLowerCaseMapping:0x0982
  ,simpleTitleCaseMapping:0x0982
 },
 { code:0x0983
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0983
  ,simpleLowerCaseMapping:0x0983
  ,simpleTitleCaseMapping:0x0983
 },
 { code:0x0985
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0985
  ,simpleLowerCaseMapping:0x0985
  ,simpleTitleCaseMapping:0x0985
 },
 { code:0x0986
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0986
  ,simpleLowerCaseMapping:0x0986
  ,simpleTitleCaseMapping:0x0986
 },
 { code:0x0987
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0987
  ,simpleLowerCaseMapping:0x0987
  ,simpleTitleCaseMapping:0x0987
 },
 { code:0x0988
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0988
  ,simpleLowerCaseMapping:0x0988
  ,simpleTitleCaseMapping:0x0988
 },
 { code:0x0989
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0989
  ,simpleLowerCaseMapping:0x0989
  ,simpleTitleCaseMapping:0x0989
 },
 { code:0x098A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x098A
  ,simpleLowerCaseMapping:0x098A
  ,simpleTitleCaseMapping:0x098A
 },
 { code:0x098B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x098B
  ,simpleLowerCaseMapping:0x098B
  ,simpleTitleCaseMapping:0x098B
 },
 { code:0x098C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x098C
  ,simpleLowerCaseMapping:0x098C
  ,simpleTitleCaseMapping:0x098C
 },
 { code:0x098F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x098F
  ,simpleLowerCaseMapping:0x098F
  ,simpleTitleCaseMapping:0x098F
 },
 { code:0x0990
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0990
  ,simpleLowerCaseMapping:0x0990
  ,simpleTitleCaseMapping:0x0990
 },
 { code:0x0993
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0993
  ,simpleLowerCaseMapping:0x0993
  ,simpleTitleCaseMapping:0x0993
 },
 { code:0x0994
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0994
  ,simpleLowerCaseMapping:0x0994
  ,simpleTitleCaseMapping:0x0994
 },
 { code:0x0995
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0995
  ,simpleLowerCaseMapping:0x0995
  ,simpleTitleCaseMapping:0x0995
 },
 { code:0x0996
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0996
  ,simpleLowerCaseMapping:0x0996
  ,simpleTitleCaseMapping:0x0996
 },
 { code:0x0997
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0997
  ,simpleLowerCaseMapping:0x0997
  ,simpleTitleCaseMapping:0x0997
 },
 { code:0x0998
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0998
  ,simpleLowerCaseMapping:0x0998
  ,simpleTitleCaseMapping:0x0998
 },
 { code:0x0999
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0999
  ,simpleLowerCaseMapping:0x0999
  ,simpleTitleCaseMapping:0x0999
 },
 { code:0x099A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x099A
  ,simpleLowerCaseMapping:0x099A
  ,simpleTitleCaseMapping:0x099A
 },
 { code:0x099B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x099B
  ,simpleLowerCaseMapping:0x099B
  ,simpleTitleCaseMapping:0x099B
 },
 { code:0x099C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x099C
  ,simpleLowerCaseMapping:0x099C
  ,simpleTitleCaseMapping:0x099C
 },
 { code:0x099D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x099D
  ,simpleLowerCaseMapping:0x099D
  ,simpleTitleCaseMapping:0x099D
 },
 { code:0x099E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x099E
  ,simpleLowerCaseMapping:0x099E
  ,simpleTitleCaseMapping:0x099E
 },
 { code:0x099F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x099F
  ,simpleLowerCaseMapping:0x099F
  ,simpleTitleCaseMapping:0x099F
 },
 { code:0x09A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09A0
  ,simpleLowerCaseMapping:0x09A0
  ,simpleTitleCaseMapping:0x09A0
 },
 { code:0x09A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09A1
  ,simpleLowerCaseMapping:0x09A1
  ,simpleTitleCaseMapping:0x09A1
 },
 { code:0x09A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09A2
  ,simpleLowerCaseMapping:0x09A2
  ,simpleTitleCaseMapping:0x09A2
 },
 { code:0x09A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09A3
  ,simpleLowerCaseMapping:0x09A3
  ,simpleTitleCaseMapping:0x09A3
 },
 { code:0x09A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09A4
  ,simpleLowerCaseMapping:0x09A4
  ,simpleTitleCaseMapping:0x09A4
 },
 { code:0x09A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09A5
  ,simpleLowerCaseMapping:0x09A5
  ,simpleTitleCaseMapping:0x09A5
 },
 { code:0x09A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09A6
  ,simpleLowerCaseMapping:0x09A6
  ,simpleTitleCaseMapping:0x09A6
 },
 { code:0x09A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09A7
  ,simpleLowerCaseMapping:0x09A7
  ,simpleTitleCaseMapping:0x09A7
 },
 { code:0x09A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09A8
  ,simpleLowerCaseMapping:0x09A8
  ,simpleTitleCaseMapping:0x09A8
 },
 { code:0x09AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09AA
  ,simpleLowerCaseMapping:0x09AA
  ,simpleTitleCaseMapping:0x09AA
 },
 { code:0x09AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09AB
  ,simpleLowerCaseMapping:0x09AB
  ,simpleTitleCaseMapping:0x09AB
 },
 { code:0x09AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09AC
  ,simpleLowerCaseMapping:0x09AC
  ,simpleTitleCaseMapping:0x09AC
 },
 { code:0x09AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09AD
  ,simpleLowerCaseMapping:0x09AD
  ,simpleTitleCaseMapping:0x09AD
 },
 { code:0x09AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09AE
  ,simpleLowerCaseMapping:0x09AE
  ,simpleTitleCaseMapping:0x09AE
 },
 { code:0x09AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09AF
  ,simpleLowerCaseMapping:0x09AF
  ,simpleTitleCaseMapping:0x09AF
 },
 { code:0x09B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09B0
  ,simpleLowerCaseMapping:0x09B0
  ,simpleTitleCaseMapping:0x09B0
 },
 { code:0x09B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09B2
  ,simpleLowerCaseMapping:0x09B2
  ,simpleTitleCaseMapping:0x09B2
 },
 { code:0x09B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09B6
  ,simpleLowerCaseMapping:0x09B6
  ,simpleTitleCaseMapping:0x09B6
 },
 { code:0x09B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09B7
  ,simpleLowerCaseMapping:0x09B7
  ,simpleTitleCaseMapping:0x09B7
 },
 { code:0x09B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09B8
  ,simpleLowerCaseMapping:0x09B8
  ,simpleTitleCaseMapping:0x09B8
 },
 { code:0x09B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09B9
  ,simpleLowerCaseMapping:0x09B9
  ,simpleTitleCaseMapping:0x09B9
 },
 { code:0x09BC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x09BC
  ,simpleLowerCaseMapping:0x09BC
  ,simpleTitleCaseMapping:0x09BC
 },
 { code:0x09BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09BD
  ,simpleLowerCaseMapping:0x09BD
  ,simpleTitleCaseMapping:0x09BD
 },
 { code:0x09BE
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x09BE
  ,simpleLowerCaseMapping:0x09BE
  ,simpleTitleCaseMapping:0x09BE
 },
 { code:0x09BF
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x09BF
  ,simpleLowerCaseMapping:0x09BF
  ,simpleTitleCaseMapping:0x09BF
 },
 { code:0x09C0
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x09C0
  ,simpleLowerCaseMapping:0x09C0
  ,simpleTitleCaseMapping:0x09C0
 },
 { code:0x09C1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x09C1
  ,simpleLowerCaseMapping:0x09C1
  ,simpleTitleCaseMapping:0x09C1
 },
 { code:0x09C2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x09C2
  ,simpleLowerCaseMapping:0x09C2
  ,simpleTitleCaseMapping:0x09C2
 },
 { code:0x09C3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x09C3
  ,simpleLowerCaseMapping:0x09C3
  ,simpleTitleCaseMapping:0x09C3
 },
 { code:0x09C4
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x09C4
  ,simpleLowerCaseMapping:0x09C4
  ,simpleTitleCaseMapping:0x09C4
 },
 { code:0x09C7
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x09C7
  ,simpleLowerCaseMapping:0x09C7
  ,simpleTitleCaseMapping:0x09C7
 },
 { code:0x09C8
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x09C8
  ,simpleLowerCaseMapping:0x09C8
  ,simpleTitleCaseMapping:0x09C8
 },
 { code:0x09CB
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x09CB
  ,simpleLowerCaseMapping:0x09CB
  ,simpleTitleCaseMapping:0x09CB
 },
 { code:0x09CC
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x09CC
  ,simpleLowerCaseMapping:0x09CC
  ,simpleTitleCaseMapping:0x09CC
 },
 { code:0x09CD
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x09CD
  ,simpleLowerCaseMapping:0x09CD
  ,simpleTitleCaseMapping:0x09CD
 },
 { code:0x09CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09CE
  ,simpleLowerCaseMapping:0x09CE
  ,simpleTitleCaseMapping:0x09CE
 },
 { code:0x09D7
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x09D7
  ,simpleLowerCaseMapping:0x09D7
  ,simpleTitleCaseMapping:0x09D7
 },
 { code:0x09DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09DC
  ,simpleLowerCaseMapping:0x09DC
  ,simpleTitleCaseMapping:0x09DC
 },
 { code:0x09DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09DD
  ,simpleLowerCaseMapping:0x09DD
  ,simpleTitleCaseMapping:0x09DD
 },
 { code:0x09DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09DF
  ,simpleLowerCaseMapping:0x09DF
  ,simpleTitleCaseMapping:0x09DF
 },
 { code:0x09E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09E0
  ,simpleLowerCaseMapping:0x09E0
  ,simpleTitleCaseMapping:0x09E0
 },
 { code:0x09E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09E1
  ,simpleLowerCaseMapping:0x09E1
  ,simpleTitleCaseMapping:0x09E1
 },
 { code:0x09E2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x09E2
  ,simpleLowerCaseMapping:0x09E2
  ,simpleTitleCaseMapping:0x09E2
 },
 { code:0x09E3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x09E3
  ,simpleLowerCaseMapping:0x09E3
  ,simpleTitleCaseMapping:0x09E3
 },
 { code:0x09E6
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x09E6
  ,simpleLowerCaseMapping:0x09E6
  ,simpleTitleCaseMapping:0x09E6
 },
 { code:0x09E7
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x09E7
  ,simpleLowerCaseMapping:0x09E7
  ,simpleTitleCaseMapping:0x09E7
 },
 { code:0x09E8
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x09E8
  ,simpleLowerCaseMapping:0x09E8
  ,simpleTitleCaseMapping:0x09E8
 },
 { code:0x09E9
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x09E9
  ,simpleLowerCaseMapping:0x09E9
  ,simpleTitleCaseMapping:0x09E9
 },
 { code:0x09EA
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x09EA
  ,simpleLowerCaseMapping:0x09EA
  ,simpleTitleCaseMapping:0x09EA
 },
 { code:0x09EB
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x09EB
  ,simpleLowerCaseMapping:0x09EB
  ,simpleTitleCaseMapping:0x09EB
 },
 { code:0x09EC
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x09EC
  ,simpleLowerCaseMapping:0x09EC
  ,simpleTitleCaseMapping:0x09EC
 },
 { code:0x09ED
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x09ED
  ,simpleLowerCaseMapping:0x09ED
  ,simpleTitleCaseMapping:0x09ED
 },
 { code:0x09EE
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x09EE
  ,simpleLowerCaseMapping:0x09EE
  ,simpleTitleCaseMapping:0x09EE
 },
 { code:0x09EF
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x09EF
  ,simpleLowerCaseMapping:0x09EF
  ,simpleTitleCaseMapping:0x09EF
 },
 { code:0x09F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09F0
  ,simpleLowerCaseMapping:0x09F0
  ,simpleTitleCaseMapping:0x09F0
 },
 { code:0x09F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x09F1
  ,simpleLowerCaseMapping:0x09F1
  ,simpleTitleCaseMapping:0x09F1
 },
 { code:0x09F2
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x09F2
  ,simpleLowerCaseMapping:0x09F2
  ,simpleTitleCaseMapping:0x09F2
 },
 { code:0x09F3
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x09F3
  ,simpleLowerCaseMapping:0x09F3
  ,simpleTitleCaseMapping:0x09F3
 },
 { code:0x09F4
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x09F4
  ,simpleLowerCaseMapping:0x09F4
  ,simpleTitleCaseMapping:0x09F4
 },
 { code:0x09F5
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x09F5
  ,simpleLowerCaseMapping:0x09F5
  ,simpleTitleCaseMapping:0x09F5
 },
 { code:0x09F6
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x09F6
  ,simpleLowerCaseMapping:0x09F6
  ,simpleTitleCaseMapping:0x09F6
 },
 { code:0x09F7
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x09F7
  ,simpleLowerCaseMapping:0x09F7
  ,simpleTitleCaseMapping:0x09F7
 },
 { code:0x09F8
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x09F8
  ,simpleLowerCaseMapping:0x09F8
  ,simpleTitleCaseMapping:0x09F8
 },
 { code:0x09F9
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x09F9
  ,simpleLowerCaseMapping:0x09F9
  ,simpleTitleCaseMapping:0x09F9
 },
 { code:0x09FA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x09FA
  ,simpleLowerCaseMapping:0x09FA
  ,simpleTitleCaseMapping:0x09FA
 },
 { code:0x0A01
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0A01
  ,simpleLowerCaseMapping:0x0A01
  ,simpleTitleCaseMapping:0x0A01
 },
 { code:0x0A02
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0A02
  ,simpleLowerCaseMapping:0x0A02
  ,simpleTitleCaseMapping:0x0A02
 },
 { code:0x0A03
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0A03
  ,simpleLowerCaseMapping:0x0A03
  ,simpleTitleCaseMapping:0x0A03
 },
 { code:0x0A05
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A05
  ,simpleLowerCaseMapping:0x0A05
  ,simpleTitleCaseMapping:0x0A05
 },
 { code:0x0A06
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A06
  ,simpleLowerCaseMapping:0x0A06
  ,simpleTitleCaseMapping:0x0A06
 },
 { code:0x0A07
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A07
  ,simpleLowerCaseMapping:0x0A07
  ,simpleTitleCaseMapping:0x0A07
 },
 { code:0x0A08
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A08
  ,simpleLowerCaseMapping:0x0A08
  ,simpleTitleCaseMapping:0x0A08
 },
 { code:0x0A09
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A09
  ,simpleLowerCaseMapping:0x0A09
  ,simpleTitleCaseMapping:0x0A09
 },
 { code:0x0A0A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A0A
  ,simpleLowerCaseMapping:0x0A0A
  ,simpleTitleCaseMapping:0x0A0A
 },
 { code:0x0A0F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A0F
  ,simpleLowerCaseMapping:0x0A0F
  ,simpleTitleCaseMapping:0x0A0F
 },
 { code:0x0A10
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A10
  ,simpleLowerCaseMapping:0x0A10
  ,simpleTitleCaseMapping:0x0A10
 },
 { code:0x0A13
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A13
  ,simpleLowerCaseMapping:0x0A13
  ,simpleTitleCaseMapping:0x0A13
 },
 { code:0x0A14
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A14
  ,simpleLowerCaseMapping:0x0A14
  ,simpleTitleCaseMapping:0x0A14
 },
 { code:0x0A15
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A15
  ,simpleLowerCaseMapping:0x0A15
  ,simpleTitleCaseMapping:0x0A15
 },
 { code:0x0A16
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A16
  ,simpleLowerCaseMapping:0x0A16
  ,simpleTitleCaseMapping:0x0A16
 },
 { code:0x0A17
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A17
  ,simpleLowerCaseMapping:0x0A17
  ,simpleTitleCaseMapping:0x0A17
 },
 { code:0x0A18
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A18
  ,simpleLowerCaseMapping:0x0A18
  ,simpleTitleCaseMapping:0x0A18
 },
 { code:0x0A19
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A19
  ,simpleLowerCaseMapping:0x0A19
  ,simpleTitleCaseMapping:0x0A19
 },
 { code:0x0A1A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A1A
  ,simpleLowerCaseMapping:0x0A1A
  ,simpleTitleCaseMapping:0x0A1A
 },
 { code:0x0A1B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A1B
  ,simpleLowerCaseMapping:0x0A1B
  ,simpleTitleCaseMapping:0x0A1B
 },
 { code:0x0A1C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A1C
  ,simpleLowerCaseMapping:0x0A1C
  ,simpleTitleCaseMapping:0x0A1C
 },
 { code:0x0A1D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A1D
  ,simpleLowerCaseMapping:0x0A1D
  ,simpleTitleCaseMapping:0x0A1D
 },
 { code:0x0A1E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A1E
  ,simpleLowerCaseMapping:0x0A1E
  ,simpleTitleCaseMapping:0x0A1E
 },
 { code:0x0A1F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A1F
  ,simpleLowerCaseMapping:0x0A1F
  ,simpleTitleCaseMapping:0x0A1F
 },
 { code:0x0A20
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A20
  ,simpleLowerCaseMapping:0x0A20
  ,simpleTitleCaseMapping:0x0A20
 },
 { code:0x0A21
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A21
  ,simpleLowerCaseMapping:0x0A21
  ,simpleTitleCaseMapping:0x0A21
 },
 { code:0x0A22
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A22
  ,simpleLowerCaseMapping:0x0A22
  ,simpleTitleCaseMapping:0x0A22
 },
 { code:0x0A23
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A23
  ,simpleLowerCaseMapping:0x0A23
  ,simpleTitleCaseMapping:0x0A23
 },
 { code:0x0A24
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A24
  ,simpleLowerCaseMapping:0x0A24
  ,simpleTitleCaseMapping:0x0A24
 },
 { code:0x0A25
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A25
  ,simpleLowerCaseMapping:0x0A25
  ,simpleTitleCaseMapping:0x0A25
 },
 { code:0x0A26
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A26
  ,simpleLowerCaseMapping:0x0A26
  ,simpleTitleCaseMapping:0x0A26
 },
 { code:0x0A27
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A27
  ,simpleLowerCaseMapping:0x0A27
  ,simpleTitleCaseMapping:0x0A27
 },
 { code:0x0A28
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A28
  ,simpleLowerCaseMapping:0x0A28
  ,simpleTitleCaseMapping:0x0A28
 },
 { code:0x0A2A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A2A
  ,simpleLowerCaseMapping:0x0A2A
  ,simpleTitleCaseMapping:0x0A2A
 },
 { code:0x0A2B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A2B
  ,simpleLowerCaseMapping:0x0A2B
  ,simpleTitleCaseMapping:0x0A2B
 },
 { code:0x0A2C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A2C
  ,simpleLowerCaseMapping:0x0A2C
  ,simpleTitleCaseMapping:0x0A2C
 },
 { code:0x0A2D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A2D
  ,simpleLowerCaseMapping:0x0A2D
  ,simpleTitleCaseMapping:0x0A2D
 },
 { code:0x0A2E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A2E
  ,simpleLowerCaseMapping:0x0A2E
  ,simpleTitleCaseMapping:0x0A2E
 },
 { code:0x0A2F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A2F
  ,simpleLowerCaseMapping:0x0A2F
  ,simpleTitleCaseMapping:0x0A2F
 },
 { code:0x0A30
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A30
  ,simpleLowerCaseMapping:0x0A30
  ,simpleTitleCaseMapping:0x0A30
 },
 { code:0x0A32
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A32
  ,simpleLowerCaseMapping:0x0A32
  ,simpleTitleCaseMapping:0x0A32
 },
 { code:0x0A33
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A33
  ,simpleLowerCaseMapping:0x0A33
  ,simpleTitleCaseMapping:0x0A33
 },
 { code:0x0A35
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A35
  ,simpleLowerCaseMapping:0x0A35
  ,simpleTitleCaseMapping:0x0A35
 },
 { code:0x0A36
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A36
  ,simpleLowerCaseMapping:0x0A36
  ,simpleTitleCaseMapping:0x0A36
 },
 { code:0x0A38
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A38
  ,simpleLowerCaseMapping:0x0A38
  ,simpleTitleCaseMapping:0x0A38
 },
 { code:0x0A39
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A39
  ,simpleLowerCaseMapping:0x0A39
  ,simpleTitleCaseMapping:0x0A39
 },
 { code:0x0A3C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0A3C
  ,simpleLowerCaseMapping:0x0A3C
  ,simpleTitleCaseMapping:0x0A3C
 },
 { code:0x0A3E
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0A3E
  ,simpleLowerCaseMapping:0x0A3E
  ,simpleTitleCaseMapping:0x0A3E
 },
 { code:0x0A3F
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0A3F
  ,simpleLowerCaseMapping:0x0A3F
  ,simpleTitleCaseMapping:0x0A3F
 },
 { code:0x0A40
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0A40
  ,simpleLowerCaseMapping:0x0A40
  ,simpleTitleCaseMapping:0x0A40
 },
 { code:0x0A41
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0A41
  ,simpleLowerCaseMapping:0x0A41
  ,simpleTitleCaseMapping:0x0A41
 },
 { code:0x0A42
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0A42
  ,simpleLowerCaseMapping:0x0A42
  ,simpleTitleCaseMapping:0x0A42
 },
 { code:0x0A47
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0A47
  ,simpleLowerCaseMapping:0x0A47
  ,simpleTitleCaseMapping:0x0A47
 },
 { code:0x0A48
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0A48
  ,simpleLowerCaseMapping:0x0A48
  ,simpleTitleCaseMapping:0x0A48
 },
 { code:0x0A4B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0A4B
  ,simpleLowerCaseMapping:0x0A4B
  ,simpleTitleCaseMapping:0x0A4B
 },
 { code:0x0A4C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0A4C
  ,simpleLowerCaseMapping:0x0A4C
  ,simpleTitleCaseMapping:0x0A4C
 },
 { code:0x0A4D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0A4D
  ,simpleLowerCaseMapping:0x0A4D
  ,simpleTitleCaseMapping:0x0A4D
 },
 { code:0x0A59
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A59
  ,simpleLowerCaseMapping:0x0A59
  ,simpleTitleCaseMapping:0x0A59
 },
 { code:0x0A5A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A5A
  ,simpleLowerCaseMapping:0x0A5A
  ,simpleTitleCaseMapping:0x0A5A
 },
 { code:0x0A5B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A5B
  ,simpleLowerCaseMapping:0x0A5B
  ,simpleTitleCaseMapping:0x0A5B
 },
 { code:0x0A5C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A5C
  ,simpleLowerCaseMapping:0x0A5C
  ,simpleTitleCaseMapping:0x0A5C
 },
 { code:0x0A5E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A5E
  ,simpleLowerCaseMapping:0x0A5E
  ,simpleTitleCaseMapping:0x0A5E
 },
 { code:0x0A66
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0A66
  ,simpleLowerCaseMapping:0x0A66
  ,simpleTitleCaseMapping:0x0A66
 },
 { code:0x0A67
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0A67
  ,simpleLowerCaseMapping:0x0A67
  ,simpleTitleCaseMapping:0x0A67
 },
 { code:0x0A68
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0A68
  ,simpleLowerCaseMapping:0x0A68
  ,simpleTitleCaseMapping:0x0A68
 },
 { code:0x0A69
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0A69
  ,simpleLowerCaseMapping:0x0A69
  ,simpleTitleCaseMapping:0x0A69
 },
 { code:0x0A6A
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0A6A
  ,simpleLowerCaseMapping:0x0A6A
  ,simpleTitleCaseMapping:0x0A6A
 },
 { code:0x0A6B
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0A6B
  ,simpleLowerCaseMapping:0x0A6B
  ,simpleTitleCaseMapping:0x0A6B
 },
 { code:0x0A6C
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0A6C
  ,simpleLowerCaseMapping:0x0A6C
  ,simpleTitleCaseMapping:0x0A6C
 },
 { code:0x0A6D
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0A6D
  ,simpleLowerCaseMapping:0x0A6D
  ,simpleTitleCaseMapping:0x0A6D
 },
 { code:0x0A6E
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0A6E
  ,simpleLowerCaseMapping:0x0A6E
  ,simpleTitleCaseMapping:0x0A6E
 },
 { code:0x0A6F
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0A6F
  ,simpleLowerCaseMapping:0x0A6F
  ,simpleTitleCaseMapping:0x0A6F
 },
 { code:0x0A70
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0A70
  ,simpleLowerCaseMapping:0x0A70
  ,simpleTitleCaseMapping:0x0A70
 },
 { code:0x0A71
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0A71
  ,simpleLowerCaseMapping:0x0A71
  ,simpleTitleCaseMapping:0x0A71
 },
 { code:0x0A72
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A72
  ,simpleLowerCaseMapping:0x0A72
  ,simpleTitleCaseMapping:0x0A72
 },
 { code:0x0A73
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A73
  ,simpleLowerCaseMapping:0x0A73
  ,simpleTitleCaseMapping:0x0A73
 },
 { code:0x0A74
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A74
  ,simpleLowerCaseMapping:0x0A74
  ,simpleTitleCaseMapping:0x0A74
 },
 { code:0x0A81
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0A81
  ,simpleLowerCaseMapping:0x0A81
  ,simpleTitleCaseMapping:0x0A81
 },
 { code:0x0A82
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0A82
  ,simpleLowerCaseMapping:0x0A82
  ,simpleTitleCaseMapping:0x0A82
 },
 { code:0x0A83
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0A83
  ,simpleLowerCaseMapping:0x0A83
  ,simpleTitleCaseMapping:0x0A83
 },
 { code:0x0A85
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A85
  ,simpleLowerCaseMapping:0x0A85
  ,simpleTitleCaseMapping:0x0A85
 },
 { code:0x0A86
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A86
  ,simpleLowerCaseMapping:0x0A86
  ,simpleTitleCaseMapping:0x0A86
 },
 { code:0x0A87
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A87
  ,simpleLowerCaseMapping:0x0A87
  ,simpleTitleCaseMapping:0x0A87
 },
 { code:0x0A88
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A88
  ,simpleLowerCaseMapping:0x0A88
  ,simpleTitleCaseMapping:0x0A88
 },
 { code:0x0A89
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A89
  ,simpleLowerCaseMapping:0x0A89
  ,simpleTitleCaseMapping:0x0A89
 },
 { code:0x0A8A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A8A
  ,simpleLowerCaseMapping:0x0A8A
  ,simpleTitleCaseMapping:0x0A8A
 },
 { code:0x0A8B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A8B
  ,simpleLowerCaseMapping:0x0A8B
  ,simpleTitleCaseMapping:0x0A8B
 },
 { code:0x0A8C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A8C
  ,simpleLowerCaseMapping:0x0A8C
  ,simpleTitleCaseMapping:0x0A8C
 },
 { code:0x0A8D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A8D
  ,simpleLowerCaseMapping:0x0A8D
  ,simpleTitleCaseMapping:0x0A8D
 },
 { code:0x0A8F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A8F
  ,simpleLowerCaseMapping:0x0A8F
  ,simpleTitleCaseMapping:0x0A8F
 },
 { code:0x0A90
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A90
  ,simpleLowerCaseMapping:0x0A90
  ,simpleTitleCaseMapping:0x0A90
 },
 { code:0x0A91
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A91
  ,simpleLowerCaseMapping:0x0A91
  ,simpleTitleCaseMapping:0x0A91
 },
 { code:0x0A93
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A93
  ,simpleLowerCaseMapping:0x0A93
  ,simpleTitleCaseMapping:0x0A93
 },
 { code:0x0A94
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A94
  ,simpleLowerCaseMapping:0x0A94
  ,simpleTitleCaseMapping:0x0A94
 },
 { code:0x0A95
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A95
  ,simpleLowerCaseMapping:0x0A95
  ,simpleTitleCaseMapping:0x0A95
 },
 { code:0x0A96
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A96
  ,simpleLowerCaseMapping:0x0A96
  ,simpleTitleCaseMapping:0x0A96
 },
 { code:0x0A97
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A97
  ,simpleLowerCaseMapping:0x0A97
  ,simpleTitleCaseMapping:0x0A97
 },
 { code:0x0A98
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A98
  ,simpleLowerCaseMapping:0x0A98
  ,simpleTitleCaseMapping:0x0A98
 },
 { code:0x0A99
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A99
  ,simpleLowerCaseMapping:0x0A99
  ,simpleTitleCaseMapping:0x0A99
 },
 { code:0x0A9A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A9A
  ,simpleLowerCaseMapping:0x0A9A
  ,simpleTitleCaseMapping:0x0A9A
 },
 { code:0x0A9B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A9B
  ,simpleLowerCaseMapping:0x0A9B
  ,simpleTitleCaseMapping:0x0A9B
 },
 { code:0x0A9C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A9C
  ,simpleLowerCaseMapping:0x0A9C
  ,simpleTitleCaseMapping:0x0A9C
 },
 { code:0x0A9D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A9D
  ,simpleLowerCaseMapping:0x0A9D
  ,simpleTitleCaseMapping:0x0A9D
 },
 { code:0x0A9E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A9E
  ,simpleLowerCaseMapping:0x0A9E
  ,simpleTitleCaseMapping:0x0A9E
 },
 { code:0x0A9F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0A9F
  ,simpleLowerCaseMapping:0x0A9F
  ,simpleTitleCaseMapping:0x0A9F
 },
 { code:0x0AA0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AA0
  ,simpleLowerCaseMapping:0x0AA0
  ,simpleTitleCaseMapping:0x0AA0
 },
 { code:0x0AA1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AA1
  ,simpleLowerCaseMapping:0x0AA1
  ,simpleTitleCaseMapping:0x0AA1
 },
 { code:0x0AA2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AA2
  ,simpleLowerCaseMapping:0x0AA2
  ,simpleTitleCaseMapping:0x0AA2
 },
 { code:0x0AA3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AA3
  ,simpleLowerCaseMapping:0x0AA3
  ,simpleTitleCaseMapping:0x0AA3
 },
 { code:0x0AA4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AA4
  ,simpleLowerCaseMapping:0x0AA4
  ,simpleTitleCaseMapping:0x0AA4
 },
 { code:0x0AA5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AA5
  ,simpleLowerCaseMapping:0x0AA5
  ,simpleTitleCaseMapping:0x0AA5
 },
 { code:0x0AA6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AA6
  ,simpleLowerCaseMapping:0x0AA6
  ,simpleTitleCaseMapping:0x0AA6
 },
 { code:0x0AA7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AA7
  ,simpleLowerCaseMapping:0x0AA7
  ,simpleTitleCaseMapping:0x0AA7
 },
 { code:0x0AA8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AA8
  ,simpleLowerCaseMapping:0x0AA8
  ,simpleTitleCaseMapping:0x0AA8
 },
 { code:0x0AAA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AAA
  ,simpleLowerCaseMapping:0x0AAA
  ,simpleTitleCaseMapping:0x0AAA
 },
 { code:0x0AAB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AAB
  ,simpleLowerCaseMapping:0x0AAB
  ,simpleTitleCaseMapping:0x0AAB
 },
 { code:0x0AAC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AAC
  ,simpleLowerCaseMapping:0x0AAC
  ,simpleTitleCaseMapping:0x0AAC
 },
 { code:0x0AAD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AAD
  ,simpleLowerCaseMapping:0x0AAD
  ,simpleTitleCaseMapping:0x0AAD
 },
 { code:0x0AAE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AAE
  ,simpleLowerCaseMapping:0x0AAE
  ,simpleTitleCaseMapping:0x0AAE
 },
 { code:0x0AAF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AAF
  ,simpleLowerCaseMapping:0x0AAF
  ,simpleTitleCaseMapping:0x0AAF
 },
 { code:0x0AB0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AB0
  ,simpleLowerCaseMapping:0x0AB0
  ,simpleTitleCaseMapping:0x0AB0
 },
 { code:0x0AB2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AB2
  ,simpleLowerCaseMapping:0x0AB2
  ,simpleTitleCaseMapping:0x0AB2
 },
 { code:0x0AB3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AB3
  ,simpleLowerCaseMapping:0x0AB3
  ,simpleTitleCaseMapping:0x0AB3
 },
 { code:0x0AB5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AB5
  ,simpleLowerCaseMapping:0x0AB5
  ,simpleTitleCaseMapping:0x0AB5
 },
 { code:0x0AB6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AB6
  ,simpleLowerCaseMapping:0x0AB6
  ,simpleTitleCaseMapping:0x0AB6
 },
 { code:0x0AB7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AB7
  ,simpleLowerCaseMapping:0x0AB7
  ,simpleTitleCaseMapping:0x0AB7
 },
 { code:0x0AB8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AB8
  ,simpleLowerCaseMapping:0x0AB8
  ,simpleTitleCaseMapping:0x0AB8
 },
 { code:0x0AB9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AB9
  ,simpleLowerCaseMapping:0x0AB9
  ,simpleTitleCaseMapping:0x0AB9
 },
 { code:0x0ABC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0ABC
  ,simpleLowerCaseMapping:0x0ABC
  ,simpleTitleCaseMapping:0x0ABC
 },
 { code:0x0ABD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0ABD
  ,simpleLowerCaseMapping:0x0ABD
  ,simpleTitleCaseMapping:0x0ABD
 },
 { code:0x0ABE
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0ABE
  ,simpleLowerCaseMapping:0x0ABE
  ,simpleTitleCaseMapping:0x0ABE
 },
 { code:0x0ABF
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0ABF
  ,simpleLowerCaseMapping:0x0ABF
  ,simpleTitleCaseMapping:0x0ABF
 },
 { code:0x0AC0
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0AC0
  ,simpleLowerCaseMapping:0x0AC0
  ,simpleTitleCaseMapping:0x0AC0
 },
 { code:0x0AC1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0AC1
  ,simpleLowerCaseMapping:0x0AC1
  ,simpleTitleCaseMapping:0x0AC1
 },
 { code:0x0AC2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0AC2
  ,simpleLowerCaseMapping:0x0AC2
  ,simpleTitleCaseMapping:0x0AC2
 },
 { code:0x0AC3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0AC3
  ,simpleLowerCaseMapping:0x0AC3
  ,simpleTitleCaseMapping:0x0AC3
 },
 { code:0x0AC4
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0AC4
  ,simpleLowerCaseMapping:0x0AC4
  ,simpleTitleCaseMapping:0x0AC4
 },
 { code:0x0AC5
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0AC5
  ,simpleLowerCaseMapping:0x0AC5
  ,simpleTitleCaseMapping:0x0AC5
 },
 { code:0x0AC7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0AC7
  ,simpleLowerCaseMapping:0x0AC7
  ,simpleTitleCaseMapping:0x0AC7
 },
 { code:0x0AC8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0AC8
  ,simpleLowerCaseMapping:0x0AC8
  ,simpleTitleCaseMapping:0x0AC8
 },
 { code:0x0AC9
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0AC9
  ,simpleLowerCaseMapping:0x0AC9
  ,simpleTitleCaseMapping:0x0AC9
 },
 { code:0x0ACB
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0ACB
  ,simpleLowerCaseMapping:0x0ACB
  ,simpleTitleCaseMapping:0x0ACB
 },
 { code:0x0ACC
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0ACC
  ,simpleLowerCaseMapping:0x0ACC
  ,simpleTitleCaseMapping:0x0ACC
 },
 { code:0x0ACD
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0ACD
  ,simpleLowerCaseMapping:0x0ACD
  ,simpleTitleCaseMapping:0x0ACD
 },
 { code:0x0AD0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AD0
  ,simpleLowerCaseMapping:0x0AD0
  ,simpleTitleCaseMapping:0x0AD0
 },
 { code:0x0AE0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AE0
  ,simpleLowerCaseMapping:0x0AE0
  ,simpleTitleCaseMapping:0x0AE0
 },
 { code:0x0AE1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0AE1
  ,simpleLowerCaseMapping:0x0AE1
  ,simpleTitleCaseMapping:0x0AE1
 },
 { code:0x0AE2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0AE2
  ,simpleLowerCaseMapping:0x0AE2
  ,simpleTitleCaseMapping:0x0AE2
 },
 { code:0x0AE3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0AE3
  ,simpleLowerCaseMapping:0x0AE3
  ,simpleTitleCaseMapping:0x0AE3
 },
 { code:0x0AE6
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0AE6
  ,simpleLowerCaseMapping:0x0AE6
  ,simpleTitleCaseMapping:0x0AE6
 },
 { code:0x0AE7
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0AE7
  ,simpleLowerCaseMapping:0x0AE7
  ,simpleTitleCaseMapping:0x0AE7
 },
 { code:0x0AE8
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0AE8
  ,simpleLowerCaseMapping:0x0AE8
  ,simpleTitleCaseMapping:0x0AE8
 },
 { code:0x0AE9
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0AE9
  ,simpleLowerCaseMapping:0x0AE9
  ,simpleTitleCaseMapping:0x0AE9
 },
 { code:0x0AEA
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0AEA
  ,simpleLowerCaseMapping:0x0AEA
  ,simpleTitleCaseMapping:0x0AEA
 },
 { code:0x0AEB
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0AEB
  ,simpleLowerCaseMapping:0x0AEB
  ,simpleTitleCaseMapping:0x0AEB
 },
 { code:0x0AEC
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0AEC
  ,simpleLowerCaseMapping:0x0AEC
  ,simpleTitleCaseMapping:0x0AEC
 },
 { code:0x0AED
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0AED
  ,simpleLowerCaseMapping:0x0AED
  ,simpleTitleCaseMapping:0x0AED
 },
 { code:0x0AEE
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0AEE
  ,simpleLowerCaseMapping:0x0AEE
  ,simpleTitleCaseMapping:0x0AEE
 },
 { code:0x0AEF
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0AEF
  ,simpleLowerCaseMapping:0x0AEF
  ,simpleTitleCaseMapping:0x0AEF
 },
 { code:0x0AF1
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x0AF1
  ,simpleLowerCaseMapping:0x0AF1
  ,simpleTitleCaseMapping:0x0AF1
 },
 { code:0x0B01
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0B01
  ,simpleLowerCaseMapping:0x0B01
  ,simpleTitleCaseMapping:0x0B01
 },
 { code:0x0B02
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0B02
  ,simpleLowerCaseMapping:0x0B02
  ,simpleTitleCaseMapping:0x0B02
 },
 { code:0x0B03
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0B03
  ,simpleLowerCaseMapping:0x0B03
  ,simpleTitleCaseMapping:0x0B03
 },
 { code:0x0B05
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B05
  ,simpleLowerCaseMapping:0x0B05
  ,simpleTitleCaseMapping:0x0B05
 },
 { code:0x0B06
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B06
  ,simpleLowerCaseMapping:0x0B06
  ,simpleTitleCaseMapping:0x0B06
 },
 { code:0x0B07
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B07
  ,simpleLowerCaseMapping:0x0B07
  ,simpleTitleCaseMapping:0x0B07
 },
 { code:0x0B08
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B08
  ,simpleLowerCaseMapping:0x0B08
  ,simpleTitleCaseMapping:0x0B08
 },
 { code:0x0B09
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B09
  ,simpleLowerCaseMapping:0x0B09
  ,simpleTitleCaseMapping:0x0B09
 },
 { code:0x0B0A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B0A
  ,simpleLowerCaseMapping:0x0B0A
  ,simpleTitleCaseMapping:0x0B0A
 },
 { code:0x0B0B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B0B
  ,simpleLowerCaseMapping:0x0B0B
  ,simpleTitleCaseMapping:0x0B0B
 },
 { code:0x0B0C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B0C
  ,simpleLowerCaseMapping:0x0B0C
  ,simpleTitleCaseMapping:0x0B0C
 },
 { code:0x0B0F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B0F
  ,simpleLowerCaseMapping:0x0B0F
  ,simpleTitleCaseMapping:0x0B0F
 },
 { code:0x0B10
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B10
  ,simpleLowerCaseMapping:0x0B10
  ,simpleTitleCaseMapping:0x0B10
 },
 { code:0x0B13
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B13
  ,simpleLowerCaseMapping:0x0B13
  ,simpleTitleCaseMapping:0x0B13
 },
 { code:0x0B14
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B14
  ,simpleLowerCaseMapping:0x0B14
  ,simpleTitleCaseMapping:0x0B14
 },
 { code:0x0B15
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B15
  ,simpleLowerCaseMapping:0x0B15
  ,simpleTitleCaseMapping:0x0B15
 },
 { code:0x0B16
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B16
  ,simpleLowerCaseMapping:0x0B16
  ,simpleTitleCaseMapping:0x0B16
 },
 { code:0x0B17
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B17
  ,simpleLowerCaseMapping:0x0B17
  ,simpleTitleCaseMapping:0x0B17
 },
 { code:0x0B18
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B18
  ,simpleLowerCaseMapping:0x0B18
  ,simpleTitleCaseMapping:0x0B18
 },
 { code:0x0B19
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B19
  ,simpleLowerCaseMapping:0x0B19
  ,simpleTitleCaseMapping:0x0B19
 },
 { code:0x0B1A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B1A
  ,simpleLowerCaseMapping:0x0B1A
  ,simpleTitleCaseMapping:0x0B1A
 },
 { code:0x0B1B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B1B
  ,simpleLowerCaseMapping:0x0B1B
  ,simpleTitleCaseMapping:0x0B1B
 },
 { code:0x0B1C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B1C
  ,simpleLowerCaseMapping:0x0B1C
  ,simpleTitleCaseMapping:0x0B1C
 },
 { code:0x0B1D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B1D
  ,simpleLowerCaseMapping:0x0B1D
  ,simpleTitleCaseMapping:0x0B1D
 },
 { code:0x0B1E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B1E
  ,simpleLowerCaseMapping:0x0B1E
  ,simpleTitleCaseMapping:0x0B1E
 },
 { code:0x0B1F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B1F
  ,simpleLowerCaseMapping:0x0B1F
  ,simpleTitleCaseMapping:0x0B1F
 },
 { code:0x0B20
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B20
  ,simpleLowerCaseMapping:0x0B20
  ,simpleTitleCaseMapping:0x0B20
 },
 { code:0x0B21
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B21
  ,simpleLowerCaseMapping:0x0B21
  ,simpleTitleCaseMapping:0x0B21
 },
 { code:0x0B22
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B22
  ,simpleLowerCaseMapping:0x0B22
  ,simpleTitleCaseMapping:0x0B22
 },
 { code:0x0B23
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B23
  ,simpleLowerCaseMapping:0x0B23
  ,simpleTitleCaseMapping:0x0B23
 },
 { code:0x0B24
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B24
  ,simpleLowerCaseMapping:0x0B24
  ,simpleTitleCaseMapping:0x0B24
 },
 { code:0x0B25
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B25
  ,simpleLowerCaseMapping:0x0B25
  ,simpleTitleCaseMapping:0x0B25
 },
 { code:0x0B26
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B26
  ,simpleLowerCaseMapping:0x0B26
  ,simpleTitleCaseMapping:0x0B26
 },
 { code:0x0B27
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B27
  ,simpleLowerCaseMapping:0x0B27
  ,simpleTitleCaseMapping:0x0B27
 },
 { code:0x0B28
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B28
  ,simpleLowerCaseMapping:0x0B28
  ,simpleTitleCaseMapping:0x0B28
 },
 { code:0x0B2A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B2A
  ,simpleLowerCaseMapping:0x0B2A
  ,simpleTitleCaseMapping:0x0B2A
 },
 { code:0x0B2B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B2B
  ,simpleLowerCaseMapping:0x0B2B
  ,simpleTitleCaseMapping:0x0B2B
 },
 { code:0x0B2C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B2C
  ,simpleLowerCaseMapping:0x0B2C
  ,simpleTitleCaseMapping:0x0B2C
 },
 { code:0x0B2D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B2D
  ,simpleLowerCaseMapping:0x0B2D
  ,simpleTitleCaseMapping:0x0B2D
 },
 { code:0x0B2E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B2E
  ,simpleLowerCaseMapping:0x0B2E
  ,simpleTitleCaseMapping:0x0B2E
 },
 { code:0x0B2F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B2F
  ,simpleLowerCaseMapping:0x0B2F
  ,simpleTitleCaseMapping:0x0B2F
 },
 { code:0x0B30
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B30
  ,simpleLowerCaseMapping:0x0B30
  ,simpleTitleCaseMapping:0x0B30
 },
 { code:0x0B32
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B32
  ,simpleLowerCaseMapping:0x0B32
  ,simpleTitleCaseMapping:0x0B32
 },
 { code:0x0B33
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B33
  ,simpleLowerCaseMapping:0x0B33
  ,simpleTitleCaseMapping:0x0B33
 },
 { code:0x0B35
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B35
  ,simpleLowerCaseMapping:0x0B35
  ,simpleTitleCaseMapping:0x0B35
 },
 { code:0x0B36
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B36
  ,simpleLowerCaseMapping:0x0B36
  ,simpleTitleCaseMapping:0x0B36
 },
 { code:0x0B37
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B37
  ,simpleLowerCaseMapping:0x0B37
  ,simpleTitleCaseMapping:0x0B37
 },
 { code:0x0B38
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B38
  ,simpleLowerCaseMapping:0x0B38
  ,simpleTitleCaseMapping:0x0B38
 },
 { code:0x0B39
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B39
  ,simpleLowerCaseMapping:0x0B39
  ,simpleTitleCaseMapping:0x0B39
 },
 { code:0x0B3C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0B3C
  ,simpleLowerCaseMapping:0x0B3C
  ,simpleTitleCaseMapping:0x0B3C
 },
 { code:0x0B3D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B3D
  ,simpleLowerCaseMapping:0x0B3D
  ,simpleTitleCaseMapping:0x0B3D
 },
 { code:0x0B3E
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0B3E
  ,simpleLowerCaseMapping:0x0B3E
  ,simpleTitleCaseMapping:0x0B3E
 },
 { code:0x0B3F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0B3F
  ,simpleLowerCaseMapping:0x0B3F
  ,simpleTitleCaseMapping:0x0B3F
 },
 { code:0x0B40
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0B40
  ,simpleLowerCaseMapping:0x0B40
  ,simpleTitleCaseMapping:0x0B40
 },
 { code:0x0B41
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0B41
  ,simpleLowerCaseMapping:0x0B41
  ,simpleTitleCaseMapping:0x0B41
 },
 { code:0x0B42
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0B42
  ,simpleLowerCaseMapping:0x0B42
  ,simpleTitleCaseMapping:0x0B42
 },
 { code:0x0B43
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0B43
  ,simpleLowerCaseMapping:0x0B43
  ,simpleTitleCaseMapping:0x0B43
 },
 { code:0x0B47
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0B47
  ,simpleLowerCaseMapping:0x0B47
  ,simpleTitleCaseMapping:0x0B47
 },
 { code:0x0B48
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0B48
  ,simpleLowerCaseMapping:0x0B48
  ,simpleTitleCaseMapping:0x0B48
 },
 { code:0x0B4B
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0B4B
  ,simpleLowerCaseMapping:0x0B4B
  ,simpleTitleCaseMapping:0x0B4B
 },
 { code:0x0B4C
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0B4C
  ,simpleLowerCaseMapping:0x0B4C
  ,simpleTitleCaseMapping:0x0B4C
 },
 { code:0x0B4D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0B4D
  ,simpleLowerCaseMapping:0x0B4D
  ,simpleTitleCaseMapping:0x0B4D
 },
 { code:0x0B56
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0B56
  ,simpleLowerCaseMapping:0x0B56
  ,simpleTitleCaseMapping:0x0B56
 },
 { code:0x0B57
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0B57
  ,simpleLowerCaseMapping:0x0B57
  ,simpleTitleCaseMapping:0x0B57
 },
 { code:0x0B5C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B5C
  ,simpleLowerCaseMapping:0x0B5C
  ,simpleTitleCaseMapping:0x0B5C
 },
 { code:0x0B5D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B5D
  ,simpleLowerCaseMapping:0x0B5D
  ,simpleTitleCaseMapping:0x0B5D
 },
 { code:0x0B5F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B5F
  ,simpleLowerCaseMapping:0x0B5F
  ,simpleTitleCaseMapping:0x0B5F
 },
 { code:0x0B60
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B60
  ,simpleLowerCaseMapping:0x0B60
  ,simpleTitleCaseMapping:0x0B60
 },
 { code:0x0B61
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B61
  ,simpleLowerCaseMapping:0x0B61
  ,simpleTitleCaseMapping:0x0B61
 },
 { code:0x0B66
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0B66
  ,simpleLowerCaseMapping:0x0B66
  ,simpleTitleCaseMapping:0x0B66
 },
 { code:0x0B67
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0B67
  ,simpleLowerCaseMapping:0x0B67
  ,simpleTitleCaseMapping:0x0B67
 },
 { code:0x0B68
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0B68
  ,simpleLowerCaseMapping:0x0B68
  ,simpleTitleCaseMapping:0x0B68
 },
 { code:0x0B69
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0B69
  ,simpleLowerCaseMapping:0x0B69
  ,simpleTitleCaseMapping:0x0B69
 },
 { code:0x0B6A
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0B6A
  ,simpleLowerCaseMapping:0x0B6A
  ,simpleTitleCaseMapping:0x0B6A
 },
 { code:0x0B6B
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0B6B
  ,simpleLowerCaseMapping:0x0B6B
  ,simpleTitleCaseMapping:0x0B6B
 },
 { code:0x0B6C
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0B6C
  ,simpleLowerCaseMapping:0x0B6C
  ,simpleTitleCaseMapping:0x0B6C
 },
 { code:0x0B6D
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0B6D
  ,simpleLowerCaseMapping:0x0B6D
  ,simpleTitleCaseMapping:0x0B6D
 },
 { code:0x0B6E
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0B6E
  ,simpleLowerCaseMapping:0x0B6E
  ,simpleTitleCaseMapping:0x0B6E
 },
 { code:0x0B6F
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0B6F
  ,simpleLowerCaseMapping:0x0B6F
  ,simpleTitleCaseMapping:0x0B6F
 },
 { code:0x0B70
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0B70
  ,simpleLowerCaseMapping:0x0B70
  ,simpleTitleCaseMapping:0x0B70
 },
 { code:0x0B71
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B71
  ,simpleLowerCaseMapping:0x0B71
  ,simpleTitleCaseMapping:0x0B71
 },
 { code:0x0B82
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0B82
  ,simpleLowerCaseMapping:0x0B82
  ,simpleTitleCaseMapping:0x0B82
 },
 { code:0x0B83
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B83
  ,simpleLowerCaseMapping:0x0B83
  ,simpleTitleCaseMapping:0x0B83
 },
 { code:0x0B85
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B85
  ,simpleLowerCaseMapping:0x0B85
  ,simpleTitleCaseMapping:0x0B85
 },
 { code:0x0B86
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B86
  ,simpleLowerCaseMapping:0x0B86
  ,simpleTitleCaseMapping:0x0B86
 },
 { code:0x0B87
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B87
  ,simpleLowerCaseMapping:0x0B87
  ,simpleTitleCaseMapping:0x0B87
 },
 { code:0x0B88
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B88
  ,simpleLowerCaseMapping:0x0B88
  ,simpleTitleCaseMapping:0x0B88
 },
 { code:0x0B89
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B89
  ,simpleLowerCaseMapping:0x0B89
  ,simpleTitleCaseMapping:0x0B89
 },
 { code:0x0B8A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B8A
  ,simpleLowerCaseMapping:0x0B8A
  ,simpleTitleCaseMapping:0x0B8A
 },
 { code:0x0B8E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B8E
  ,simpleLowerCaseMapping:0x0B8E
  ,simpleTitleCaseMapping:0x0B8E
 },
 { code:0x0B8F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B8F
  ,simpleLowerCaseMapping:0x0B8F
  ,simpleTitleCaseMapping:0x0B8F
 },
 { code:0x0B90
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B90
  ,simpleLowerCaseMapping:0x0B90
  ,simpleTitleCaseMapping:0x0B90
 },
 { code:0x0B92
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B92
  ,simpleLowerCaseMapping:0x0B92
  ,simpleTitleCaseMapping:0x0B92
 },
 { code:0x0B93
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B93
  ,simpleLowerCaseMapping:0x0B93
  ,simpleTitleCaseMapping:0x0B93
 },
 { code:0x0B94
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B94
  ,simpleLowerCaseMapping:0x0B94
  ,simpleTitleCaseMapping:0x0B94
 },
 { code:0x0B95
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B95
  ,simpleLowerCaseMapping:0x0B95
  ,simpleTitleCaseMapping:0x0B95
 },
 { code:0x0B99
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B99
  ,simpleLowerCaseMapping:0x0B99
  ,simpleTitleCaseMapping:0x0B99
 },
 { code:0x0B9A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B9A
  ,simpleLowerCaseMapping:0x0B9A
  ,simpleTitleCaseMapping:0x0B9A
 },
 { code:0x0B9C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B9C
  ,simpleLowerCaseMapping:0x0B9C
  ,simpleTitleCaseMapping:0x0B9C
 },
 { code:0x0B9E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B9E
  ,simpleLowerCaseMapping:0x0B9E
  ,simpleTitleCaseMapping:0x0B9E
 },
 { code:0x0B9F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0B9F
  ,simpleLowerCaseMapping:0x0B9F
  ,simpleTitleCaseMapping:0x0B9F
 },
 { code:0x0BA3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0BA3
  ,simpleLowerCaseMapping:0x0BA3
  ,simpleTitleCaseMapping:0x0BA3
 },
 { code:0x0BA4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0BA4
  ,simpleLowerCaseMapping:0x0BA4
  ,simpleTitleCaseMapping:0x0BA4
 },
 { code:0x0BA8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0BA8
  ,simpleLowerCaseMapping:0x0BA8
  ,simpleTitleCaseMapping:0x0BA8
 },
 { code:0x0BA9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0BA9
  ,simpleLowerCaseMapping:0x0BA9
  ,simpleTitleCaseMapping:0x0BA9
 },
 { code:0x0BAA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0BAA
  ,simpleLowerCaseMapping:0x0BAA
  ,simpleTitleCaseMapping:0x0BAA
 },
 { code:0x0BAE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0BAE
  ,simpleLowerCaseMapping:0x0BAE
  ,simpleTitleCaseMapping:0x0BAE
 },
 { code:0x0BAF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0BAF
  ,simpleLowerCaseMapping:0x0BAF
  ,simpleTitleCaseMapping:0x0BAF
 },
 { code:0x0BB0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0BB0
  ,simpleLowerCaseMapping:0x0BB0
  ,simpleTitleCaseMapping:0x0BB0
 },
 { code:0x0BB1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0BB1
  ,simpleLowerCaseMapping:0x0BB1
  ,simpleTitleCaseMapping:0x0BB1
 },
 { code:0x0BB2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0BB2
  ,simpleLowerCaseMapping:0x0BB2
  ,simpleTitleCaseMapping:0x0BB2
 },
 { code:0x0BB3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0BB3
  ,simpleLowerCaseMapping:0x0BB3
  ,simpleTitleCaseMapping:0x0BB3
 },
 { code:0x0BB4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0BB4
  ,simpleLowerCaseMapping:0x0BB4
  ,simpleTitleCaseMapping:0x0BB4
 },
 { code:0x0BB5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0BB5
  ,simpleLowerCaseMapping:0x0BB5
  ,simpleTitleCaseMapping:0x0BB5
 },
 { code:0x0BB6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0BB6
  ,simpleLowerCaseMapping:0x0BB6
  ,simpleTitleCaseMapping:0x0BB6
 },
 { code:0x0BB7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0BB7
  ,simpleLowerCaseMapping:0x0BB7
  ,simpleTitleCaseMapping:0x0BB7
 },
 { code:0x0BB8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0BB8
  ,simpleLowerCaseMapping:0x0BB8
  ,simpleTitleCaseMapping:0x0BB8
 },
 { code:0x0BB9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0BB9
  ,simpleLowerCaseMapping:0x0BB9
  ,simpleTitleCaseMapping:0x0BB9
 },
 { code:0x0BBE
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0BBE
  ,simpleLowerCaseMapping:0x0BBE
  ,simpleTitleCaseMapping:0x0BBE
 },
 { code:0x0BBF
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0BBF
  ,simpleLowerCaseMapping:0x0BBF
  ,simpleTitleCaseMapping:0x0BBF
 },
 { code:0x0BC0
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0BC0
  ,simpleLowerCaseMapping:0x0BC0
  ,simpleTitleCaseMapping:0x0BC0
 },
 { code:0x0BC1
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0BC1
  ,simpleLowerCaseMapping:0x0BC1
  ,simpleTitleCaseMapping:0x0BC1
 },
 { code:0x0BC2
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0BC2
  ,simpleLowerCaseMapping:0x0BC2
  ,simpleTitleCaseMapping:0x0BC2
 },
 { code:0x0BC6
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0BC6
  ,simpleLowerCaseMapping:0x0BC6
  ,simpleTitleCaseMapping:0x0BC6
 },
 { code:0x0BC7
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0BC7
  ,simpleLowerCaseMapping:0x0BC7
  ,simpleTitleCaseMapping:0x0BC7
 },
 { code:0x0BC8
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0BC8
  ,simpleLowerCaseMapping:0x0BC8
  ,simpleTitleCaseMapping:0x0BC8
 },
 { code:0x0BCA
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0BCA
  ,simpleLowerCaseMapping:0x0BCA
  ,simpleTitleCaseMapping:0x0BCA
 },
 { code:0x0BCB
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0BCB
  ,simpleLowerCaseMapping:0x0BCB
  ,simpleTitleCaseMapping:0x0BCB
 },
 { code:0x0BCC
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0BCC
  ,simpleLowerCaseMapping:0x0BCC
  ,simpleTitleCaseMapping:0x0BCC
 },
 { code:0x0BCD
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0BCD
  ,simpleLowerCaseMapping:0x0BCD
  ,simpleTitleCaseMapping:0x0BCD
 },
 { code:0x0BD7
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0BD7
  ,simpleLowerCaseMapping:0x0BD7
  ,simpleTitleCaseMapping:0x0BD7
 },
 { code:0x0BE6
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0BE6
  ,simpleLowerCaseMapping:0x0BE6
  ,simpleTitleCaseMapping:0x0BE6
 },
 { code:0x0BE7
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0BE7
  ,simpleLowerCaseMapping:0x0BE7
  ,simpleTitleCaseMapping:0x0BE7
 },
 { code:0x0BE8
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0BE8
  ,simpleLowerCaseMapping:0x0BE8
  ,simpleTitleCaseMapping:0x0BE8
 },
 { code:0x0BE9
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0BE9
  ,simpleLowerCaseMapping:0x0BE9
  ,simpleTitleCaseMapping:0x0BE9
 },
 { code:0x0BEA
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0BEA
  ,simpleLowerCaseMapping:0x0BEA
  ,simpleTitleCaseMapping:0x0BEA
 },
 { code:0x0BEB
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0BEB
  ,simpleLowerCaseMapping:0x0BEB
  ,simpleTitleCaseMapping:0x0BEB
 },
 { code:0x0BEC
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0BEC
  ,simpleLowerCaseMapping:0x0BEC
  ,simpleTitleCaseMapping:0x0BEC
 },
 { code:0x0BED
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0BED
  ,simpleLowerCaseMapping:0x0BED
  ,simpleTitleCaseMapping:0x0BED
 },
 { code:0x0BEE
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0BEE
  ,simpleLowerCaseMapping:0x0BEE
  ,simpleTitleCaseMapping:0x0BEE
 },
 { code:0x0BEF
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0BEF
  ,simpleLowerCaseMapping:0x0BEF
  ,simpleTitleCaseMapping:0x0BEF
 },
 { code:0x0BF0
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x0BF0
  ,simpleLowerCaseMapping:0x0BF0
  ,simpleTitleCaseMapping:0x0BF0
 },
 { code:0x0BF1
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x0BF1
  ,simpleLowerCaseMapping:0x0BF1
  ,simpleTitleCaseMapping:0x0BF1
 },
 { code:0x0BF2
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x0BF2
  ,simpleLowerCaseMapping:0x0BF2
  ,simpleTitleCaseMapping:0x0BF2
 },
 { code:0x0BF3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0BF3
  ,simpleLowerCaseMapping:0x0BF3
  ,simpleTitleCaseMapping:0x0BF3
 },
 { code:0x0BF4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0BF4
  ,simpleLowerCaseMapping:0x0BF4
  ,simpleTitleCaseMapping:0x0BF4
 },
 { code:0x0BF5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0BF5
  ,simpleLowerCaseMapping:0x0BF5
  ,simpleTitleCaseMapping:0x0BF5
 },
 { code:0x0BF6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0BF6
  ,simpleLowerCaseMapping:0x0BF6
  ,simpleTitleCaseMapping:0x0BF6
 },
 { code:0x0BF7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0BF7
  ,simpleLowerCaseMapping:0x0BF7
  ,simpleTitleCaseMapping:0x0BF7
 },
 { code:0x0BF8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0BF8
  ,simpleLowerCaseMapping:0x0BF8
  ,simpleTitleCaseMapping:0x0BF8
 },
 { code:0x0BF9
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x0BF9
  ,simpleLowerCaseMapping:0x0BF9
  ,simpleTitleCaseMapping:0x0BF9
 },
 { code:0x0BFA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0BFA
  ,simpleLowerCaseMapping:0x0BFA
  ,simpleTitleCaseMapping:0x0BFA
 },
 { code:0x0C01
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0C01
  ,simpleLowerCaseMapping:0x0C01
  ,simpleTitleCaseMapping:0x0C01
 },
 { code:0x0C02
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0C02
  ,simpleLowerCaseMapping:0x0C02
  ,simpleTitleCaseMapping:0x0C02
 },
 { code:0x0C03
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0C03
  ,simpleLowerCaseMapping:0x0C03
  ,simpleTitleCaseMapping:0x0C03
 },
 { code:0x0C05
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C05
  ,simpleLowerCaseMapping:0x0C05
  ,simpleTitleCaseMapping:0x0C05
 },
 { code:0x0C06
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C06
  ,simpleLowerCaseMapping:0x0C06
  ,simpleTitleCaseMapping:0x0C06
 },
 { code:0x0C07
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C07
  ,simpleLowerCaseMapping:0x0C07
  ,simpleTitleCaseMapping:0x0C07
 },
 { code:0x0C08
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C08
  ,simpleLowerCaseMapping:0x0C08
  ,simpleTitleCaseMapping:0x0C08
 },
 { code:0x0C09
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C09
  ,simpleLowerCaseMapping:0x0C09
  ,simpleTitleCaseMapping:0x0C09
 },
 { code:0x0C0A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C0A
  ,simpleLowerCaseMapping:0x0C0A
  ,simpleTitleCaseMapping:0x0C0A
 },
 { code:0x0C0B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C0B
  ,simpleLowerCaseMapping:0x0C0B
  ,simpleTitleCaseMapping:0x0C0B
 },
 { code:0x0C0C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C0C
  ,simpleLowerCaseMapping:0x0C0C
  ,simpleTitleCaseMapping:0x0C0C
 },
 { code:0x0C0E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C0E
  ,simpleLowerCaseMapping:0x0C0E
  ,simpleTitleCaseMapping:0x0C0E
 },
 { code:0x0C0F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C0F
  ,simpleLowerCaseMapping:0x0C0F
  ,simpleTitleCaseMapping:0x0C0F
 },
 { code:0x0C10
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C10
  ,simpleLowerCaseMapping:0x0C10
  ,simpleTitleCaseMapping:0x0C10
 },
 { code:0x0C12
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C12
  ,simpleLowerCaseMapping:0x0C12
  ,simpleTitleCaseMapping:0x0C12
 },
 { code:0x0C13
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C13
  ,simpleLowerCaseMapping:0x0C13
  ,simpleTitleCaseMapping:0x0C13
 },
 { code:0x0C14
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C14
  ,simpleLowerCaseMapping:0x0C14
  ,simpleTitleCaseMapping:0x0C14
 },
 { code:0x0C15
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C15
  ,simpleLowerCaseMapping:0x0C15
  ,simpleTitleCaseMapping:0x0C15
 },
 { code:0x0C16
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C16
  ,simpleLowerCaseMapping:0x0C16
  ,simpleTitleCaseMapping:0x0C16
 },
 { code:0x0C17
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C17
  ,simpleLowerCaseMapping:0x0C17
  ,simpleTitleCaseMapping:0x0C17
 },
 { code:0x0C18
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C18
  ,simpleLowerCaseMapping:0x0C18
  ,simpleTitleCaseMapping:0x0C18
 },
 { code:0x0C19
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C19
  ,simpleLowerCaseMapping:0x0C19
  ,simpleTitleCaseMapping:0x0C19
 },
 { code:0x0C1A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C1A
  ,simpleLowerCaseMapping:0x0C1A
  ,simpleTitleCaseMapping:0x0C1A
 },
 { code:0x0C1B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C1B
  ,simpleLowerCaseMapping:0x0C1B
  ,simpleTitleCaseMapping:0x0C1B
 },
 { code:0x0C1C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C1C
  ,simpleLowerCaseMapping:0x0C1C
  ,simpleTitleCaseMapping:0x0C1C
 },
 { code:0x0C1D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C1D
  ,simpleLowerCaseMapping:0x0C1D
  ,simpleTitleCaseMapping:0x0C1D
 },
 { code:0x0C1E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C1E
  ,simpleLowerCaseMapping:0x0C1E
  ,simpleTitleCaseMapping:0x0C1E
 },
 { code:0x0C1F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C1F
  ,simpleLowerCaseMapping:0x0C1F
  ,simpleTitleCaseMapping:0x0C1F
 },
 { code:0x0C20
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C20
  ,simpleLowerCaseMapping:0x0C20
  ,simpleTitleCaseMapping:0x0C20
 },
 { code:0x0C21
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C21
  ,simpleLowerCaseMapping:0x0C21
  ,simpleTitleCaseMapping:0x0C21
 },
 { code:0x0C22
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C22
  ,simpleLowerCaseMapping:0x0C22
  ,simpleTitleCaseMapping:0x0C22
 },
 { code:0x0C23
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C23
  ,simpleLowerCaseMapping:0x0C23
  ,simpleTitleCaseMapping:0x0C23
 },
 { code:0x0C24
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C24
  ,simpleLowerCaseMapping:0x0C24
  ,simpleTitleCaseMapping:0x0C24
 },
 { code:0x0C25
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C25
  ,simpleLowerCaseMapping:0x0C25
  ,simpleTitleCaseMapping:0x0C25
 },
 { code:0x0C26
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C26
  ,simpleLowerCaseMapping:0x0C26
  ,simpleTitleCaseMapping:0x0C26
 },
 { code:0x0C27
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C27
  ,simpleLowerCaseMapping:0x0C27
  ,simpleTitleCaseMapping:0x0C27
 },
 { code:0x0C28
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C28
  ,simpleLowerCaseMapping:0x0C28
  ,simpleTitleCaseMapping:0x0C28
 },
 { code:0x0C2A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C2A
  ,simpleLowerCaseMapping:0x0C2A
  ,simpleTitleCaseMapping:0x0C2A
 },
 { code:0x0C2B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C2B
  ,simpleLowerCaseMapping:0x0C2B
  ,simpleTitleCaseMapping:0x0C2B
 },
 { code:0x0C2C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C2C
  ,simpleLowerCaseMapping:0x0C2C
  ,simpleTitleCaseMapping:0x0C2C
 },
 { code:0x0C2D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C2D
  ,simpleLowerCaseMapping:0x0C2D
  ,simpleTitleCaseMapping:0x0C2D
 },
 { code:0x0C2E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C2E
  ,simpleLowerCaseMapping:0x0C2E
  ,simpleTitleCaseMapping:0x0C2E
 },
 { code:0x0C2F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C2F
  ,simpleLowerCaseMapping:0x0C2F
  ,simpleTitleCaseMapping:0x0C2F
 },
 { code:0x0C30
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C30
  ,simpleLowerCaseMapping:0x0C30
  ,simpleTitleCaseMapping:0x0C30
 },
 { code:0x0C31
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C31
  ,simpleLowerCaseMapping:0x0C31
  ,simpleTitleCaseMapping:0x0C31
 },
 { code:0x0C32
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C32
  ,simpleLowerCaseMapping:0x0C32
  ,simpleTitleCaseMapping:0x0C32
 },
 { code:0x0C33
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C33
  ,simpleLowerCaseMapping:0x0C33
  ,simpleTitleCaseMapping:0x0C33
 },
 { code:0x0C35
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C35
  ,simpleLowerCaseMapping:0x0C35
  ,simpleTitleCaseMapping:0x0C35
 },
 { code:0x0C36
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C36
  ,simpleLowerCaseMapping:0x0C36
  ,simpleTitleCaseMapping:0x0C36
 },
 { code:0x0C37
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C37
  ,simpleLowerCaseMapping:0x0C37
  ,simpleTitleCaseMapping:0x0C37
 },
 { code:0x0C38
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C38
  ,simpleLowerCaseMapping:0x0C38
  ,simpleTitleCaseMapping:0x0C38
 },
 { code:0x0C39
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C39
  ,simpleLowerCaseMapping:0x0C39
  ,simpleTitleCaseMapping:0x0C39
 },
 { code:0x0C3E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0C3E
  ,simpleLowerCaseMapping:0x0C3E
  ,simpleTitleCaseMapping:0x0C3E
 },
 { code:0x0C3F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0C3F
  ,simpleLowerCaseMapping:0x0C3F
  ,simpleTitleCaseMapping:0x0C3F
 },
 { code:0x0C40
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0C40
  ,simpleLowerCaseMapping:0x0C40
  ,simpleTitleCaseMapping:0x0C40
 },
 { code:0x0C41
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0C41
  ,simpleLowerCaseMapping:0x0C41
  ,simpleTitleCaseMapping:0x0C41
 },
 { code:0x0C42
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0C42
  ,simpleLowerCaseMapping:0x0C42
  ,simpleTitleCaseMapping:0x0C42
 },
 { code:0x0C43
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0C43
  ,simpleLowerCaseMapping:0x0C43
  ,simpleTitleCaseMapping:0x0C43
 },
 { code:0x0C44
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0C44
  ,simpleLowerCaseMapping:0x0C44
  ,simpleTitleCaseMapping:0x0C44
 },
 { code:0x0C46
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0C46
  ,simpleLowerCaseMapping:0x0C46
  ,simpleTitleCaseMapping:0x0C46
 },
 { code:0x0C47
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0C47
  ,simpleLowerCaseMapping:0x0C47
  ,simpleTitleCaseMapping:0x0C47
 },
 { code:0x0C48
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0C48
  ,simpleLowerCaseMapping:0x0C48
  ,simpleTitleCaseMapping:0x0C48
 },
 { code:0x0C4A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0C4A
  ,simpleLowerCaseMapping:0x0C4A
  ,simpleTitleCaseMapping:0x0C4A
 },
 { code:0x0C4B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0C4B
  ,simpleLowerCaseMapping:0x0C4B
  ,simpleTitleCaseMapping:0x0C4B
 },
 { code:0x0C4C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0C4C
  ,simpleLowerCaseMapping:0x0C4C
  ,simpleTitleCaseMapping:0x0C4C
 },
 { code:0x0C4D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0C4D
  ,simpleLowerCaseMapping:0x0C4D
  ,simpleTitleCaseMapping:0x0C4D
 },
 { code:0x0C55
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0C55
  ,simpleLowerCaseMapping:0x0C55
  ,simpleTitleCaseMapping:0x0C55
 },
 { code:0x0C56
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0C56
  ,simpleLowerCaseMapping:0x0C56
  ,simpleTitleCaseMapping:0x0C56
 },
 { code:0x0C60
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C60
  ,simpleLowerCaseMapping:0x0C60
  ,simpleTitleCaseMapping:0x0C60
 },
 { code:0x0C61
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C61
  ,simpleLowerCaseMapping:0x0C61
  ,simpleTitleCaseMapping:0x0C61
 },
 { code:0x0C66
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0C66
  ,simpleLowerCaseMapping:0x0C66
  ,simpleTitleCaseMapping:0x0C66
 },
 { code:0x0C67
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0C67
  ,simpleLowerCaseMapping:0x0C67
  ,simpleTitleCaseMapping:0x0C67
 },
 { code:0x0C68
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0C68
  ,simpleLowerCaseMapping:0x0C68
  ,simpleTitleCaseMapping:0x0C68
 },
 { code:0x0C69
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0C69
  ,simpleLowerCaseMapping:0x0C69
  ,simpleTitleCaseMapping:0x0C69
 },
 { code:0x0C6A
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0C6A
  ,simpleLowerCaseMapping:0x0C6A
  ,simpleTitleCaseMapping:0x0C6A
 },
 { code:0x0C6B
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0C6B
  ,simpleLowerCaseMapping:0x0C6B
  ,simpleTitleCaseMapping:0x0C6B
 },
 { code:0x0C6C
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0C6C
  ,simpleLowerCaseMapping:0x0C6C
  ,simpleTitleCaseMapping:0x0C6C
 },
 { code:0x0C6D
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0C6D
  ,simpleLowerCaseMapping:0x0C6D
  ,simpleTitleCaseMapping:0x0C6D
 },
 { code:0x0C6E
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0C6E
  ,simpleLowerCaseMapping:0x0C6E
  ,simpleTitleCaseMapping:0x0C6E
 },
 { code:0x0C6F
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0C6F
  ,simpleLowerCaseMapping:0x0C6F
  ,simpleTitleCaseMapping:0x0C6F
 },
 { code:0x0C82
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0C82
  ,simpleLowerCaseMapping:0x0C82
  ,simpleTitleCaseMapping:0x0C82
 },
 { code:0x0C83
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0C83
  ,simpleLowerCaseMapping:0x0C83
  ,simpleTitleCaseMapping:0x0C83
 },
 { code:0x0C85
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C85
  ,simpleLowerCaseMapping:0x0C85
  ,simpleTitleCaseMapping:0x0C85
 },
 { code:0x0C86
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C86
  ,simpleLowerCaseMapping:0x0C86
  ,simpleTitleCaseMapping:0x0C86
 },
 { code:0x0C87
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C87
  ,simpleLowerCaseMapping:0x0C87
  ,simpleTitleCaseMapping:0x0C87
 },
 { code:0x0C88
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C88
  ,simpleLowerCaseMapping:0x0C88
  ,simpleTitleCaseMapping:0x0C88
 },
 { code:0x0C89
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C89
  ,simpleLowerCaseMapping:0x0C89
  ,simpleTitleCaseMapping:0x0C89
 },
 { code:0x0C8A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C8A
  ,simpleLowerCaseMapping:0x0C8A
  ,simpleTitleCaseMapping:0x0C8A
 },
 { code:0x0C8B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C8B
  ,simpleLowerCaseMapping:0x0C8B
  ,simpleTitleCaseMapping:0x0C8B
 },
 { code:0x0C8C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C8C
  ,simpleLowerCaseMapping:0x0C8C
  ,simpleTitleCaseMapping:0x0C8C
 },
 { code:0x0C8E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C8E
  ,simpleLowerCaseMapping:0x0C8E
  ,simpleTitleCaseMapping:0x0C8E
 },
 { code:0x0C8F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C8F
  ,simpleLowerCaseMapping:0x0C8F
  ,simpleTitleCaseMapping:0x0C8F
 },
 { code:0x0C90
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C90
  ,simpleLowerCaseMapping:0x0C90
  ,simpleTitleCaseMapping:0x0C90
 },
 { code:0x0C92
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C92
  ,simpleLowerCaseMapping:0x0C92
  ,simpleTitleCaseMapping:0x0C92
 },
 { code:0x0C93
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C93
  ,simpleLowerCaseMapping:0x0C93
  ,simpleTitleCaseMapping:0x0C93
 },
 { code:0x0C94
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C94
  ,simpleLowerCaseMapping:0x0C94
  ,simpleTitleCaseMapping:0x0C94
 },
 { code:0x0C95
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C95
  ,simpleLowerCaseMapping:0x0C95
  ,simpleTitleCaseMapping:0x0C95
 },
 { code:0x0C96
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C96
  ,simpleLowerCaseMapping:0x0C96
  ,simpleTitleCaseMapping:0x0C96
 },
 { code:0x0C97
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C97
  ,simpleLowerCaseMapping:0x0C97
  ,simpleTitleCaseMapping:0x0C97
 },
 { code:0x0C98
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C98
  ,simpleLowerCaseMapping:0x0C98
  ,simpleTitleCaseMapping:0x0C98
 },
 { code:0x0C99
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C99
  ,simpleLowerCaseMapping:0x0C99
  ,simpleTitleCaseMapping:0x0C99
 },
 { code:0x0C9A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C9A
  ,simpleLowerCaseMapping:0x0C9A
  ,simpleTitleCaseMapping:0x0C9A
 },
 { code:0x0C9B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C9B
  ,simpleLowerCaseMapping:0x0C9B
  ,simpleTitleCaseMapping:0x0C9B
 },
 { code:0x0C9C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C9C
  ,simpleLowerCaseMapping:0x0C9C
  ,simpleTitleCaseMapping:0x0C9C
 },
 { code:0x0C9D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C9D
  ,simpleLowerCaseMapping:0x0C9D
  ,simpleTitleCaseMapping:0x0C9D
 },
 { code:0x0C9E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C9E
  ,simpleLowerCaseMapping:0x0C9E
  ,simpleTitleCaseMapping:0x0C9E
 },
 { code:0x0C9F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0C9F
  ,simpleLowerCaseMapping:0x0C9F
  ,simpleTitleCaseMapping:0x0C9F
 },
 { code:0x0CA0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CA0
  ,simpleLowerCaseMapping:0x0CA0
  ,simpleTitleCaseMapping:0x0CA0
 },
 { code:0x0CA1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CA1
  ,simpleLowerCaseMapping:0x0CA1
  ,simpleTitleCaseMapping:0x0CA1
 },
 { code:0x0CA2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CA2
  ,simpleLowerCaseMapping:0x0CA2
  ,simpleTitleCaseMapping:0x0CA2
 },
 { code:0x0CA3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CA3
  ,simpleLowerCaseMapping:0x0CA3
  ,simpleTitleCaseMapping:0x0CA3
 },
 { code:0x0CA4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CA4
  ,simpleLowerCaseMapping:0x0CA4
  ,simpleTitleCaseMapping:0x0CA4
 },
 { code:0x0CA5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CA5
  ,simpleLowerCaseMapping:0x0CA5
  ,simpleTitleCaseMapping:0x0CA5
 },
 { code:0x0CA6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CA6
  ,simpleLowerCaseMapping:0x0CA6
  ,simpleTitleCaseMapping:0x0CA6
 },
 { code:0x0CA7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CA7
  ,simpleLowerCaseMapping:0x0CA7
  ,simpleTitleCaseMapping:0x0CA7
 },
 { code:0x0CA8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CA8
  ,simpleLowerCaseMapping:0x0CA8
  ,simpleTitleCaseMapping:0x0CA8
 },
 { code:0x0CAA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CAA
  ,simpleLowerCaseMapping:0x0CAA
  ,simpleTitleCaseMapping:0x0CAA
 },
 { code:0x0CAB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CAB
  ,simpleLowerCaseMapping:0x0CAB
  ,simpleTitleCaseMapping:0x0CAB
 },
 { code:0x0CAC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CAC
  ,simpleLowerCaseMapping:0x0CAC
  ,simpleTitleCaseMapping:0x0CAC
 },
 { code:0x0CAD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CAD
  ,simpleLowerCaseMapping:0x0CAD
  ,simpleTitleCaseMapping:0x0CAD
 },
 { code:0x0CAE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CAE
  ,simpleLowerCaseMapping:0x0CAE
  ,simpleTitleCaseMapping:0x0CAE
 },
 { code:0x0CAF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CAF
  ,simpleLowerCaseMapping:0x0CAF
  ,simpleTitleCaseMapping:0x0CAF
 },
 { code:0x0CB0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CB0
  ,simpleLowerCaseMapping:0x0CB0
  ,simpleTitleCaseMapping:0x0CB0
 },
 { code:0x0CB1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CB1
  ,simpleLowerCaseMapping:0x0CB1
  ,simpleTitleCaseMapping:0x0CB1
 },
 { code:0x0CB2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CB2
  ,simpleLowerCaseMapping:0x0CB2
  ,simpleTitleCaseMapping:0x0CB2
 },
 { code:0x0CB3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CB3
  ,simpleLowerCaseMapping:0x0CB3
  ,simpleTitleCaseMapping:0x0CB3
 },
 { code:0x0CB5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CB5
  ,simpleLowerCaseMapping:0x0CB5
  ,simpleTitleCaseMapping:0x0CB5
 },
 { code:0x0CB6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CB6
  ,simpleLowerCaseMapping:0x0CB6
  ,simpleTitleCaseMapping:0x0CB6
 },
 { code:0x0CB7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CB7
  ,simpleLowerCaseMapping:0x0CB7
  ,simpleTitleCaseMapping:0x0CB7
 },
 { code:0x0CB8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CB8
  ,simpleLowerCaseMapping:0x0CB8
  ,simpleTitleCaseMapping:0x0CB8
 },
 { code:0x0CB9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CB9
  ,simpleLowerCaseMapping:0x0CB9
  ,simpleTitleCaseMapping:0x0CB9
 },
 { code:0x0CBC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0CBC
  ,simpleLowerCaseMapping:0x0CBC
  ,simpleTitleCaseMapping:0x0CBC
 },
 { code:0x0CBD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CBD
  ,simpleLowerCaseMapping:0x0CBD
  ,simpleTitleCaseMapping:0x0CBD
 },
 { code:0x0CBE
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0CBE
  ,simpleLowerCaseMapping:0x0CBE
  ,simpleTitleCaseMapping:0x0CBE
 },
 { code:0x0CBF
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0CBF
  ,simpleLowerCaseMapping:0x0CBF
  ,simpleTitleCaseMapping:0x0CBF
 },
 { code:0x0CC0
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0CC0
  ,simpleLowerCaseMapping:0x0CC0
  ,simpleTitleCaseMapping:0x0CC0
 },
 { code:0x0CC1
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0CC1
  ,simpleLowerCaseMapping:0x0CC1
  ,simpleTitleCaseMapping:0x0CC1
 },
 { code:0x0CC2
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0CC2
  ,simpleLowerCaseMapping:0x0CC2
  ,simpleTitleCaseMapping:0x0CC2
 },
 { code:0x0CC3
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0CC3
  ,simpleLowerCaseMapping:0x0CC3
  ,simpleTitleCaseMapping:0x0CC3
 },
 { code:0x0CC4
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0CC4
  ,simpleLowerCaseMapping:0x0CC4
  ,simpleTitleCaseMapping:0x0CC4
 },
 { code:0x0CC6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0CC6
  ,simpleLowerCaseMapping:0x0CC6
  ,simpleTitleCaseMapping:0x0CC6
 },
 { code:0x0CC7
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0CC7
  ,simpleLowerCaseMapping:0x0CC7
  ,simpleTitleCaseMapping:0x0CC7
 },
 { code:0x0CC8
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0CC8
  ,simpleLowerCaseMapping:0x0CC8
  ,simpleTitleCaseMapping:0x0CC8
 },
 { code:0x0CCA
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0CCA
  ,simpleLowerCaseMapping:0x0CCA
  ,simpleTitleCaseMapping:0x0CCA
 },
 { code:0x0CCB
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0CCB
  ,simpleLowerCaseMapping:0x0CCB
  ,simpleTitleCaseMapping:0x0CCB
 },
 { code:0x0CCC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0CCC
  ,simpleLowerCaseMapping:0x0CCC
  ,simpleTitleCaseMapping:0x0CCC
 },
 { code:0x0CCD
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0CCD
  ,simpleLowerCaseMapping:0x0CCD
  ,simpleTitleCaseMapping:0x0CCD
 },
 { code:0x0CD5
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0CD5
  ,simpleLowerCaseMapping:0x0CD5
  ,simpleTitleCaseMapping:0x0CD5
 },
 { code:0x0CD6
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0CD6
  ,simpleLowerCaseMapping:0x0CD6
  ,simpleTitleCaseMapping:0x0CD6
 },
 { code:0x0CDE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CDE
  ,simpleLowerCaseMapping:0x0CDE
  ,simpleTitleCaseMapping:0x0CDE
 },
 { code:0x0CE0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CE0
  ,simpleLowerCaseMapping:0x0CE0
  ,simpleTitleCaseMapping:0x0CE0
 },
 { code:0x0CE1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0CE1
  ,simpleLowerCaseMapping:0x0CE1
  ,simpleTitleCaseMapping:0x0CE1
 },
 { code:0x0CE2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0CE2
  ,simpleLowerCaseMapping:0x0CE2
  ,simpleTitleCaseMapping:0x0CE2
 },
 { code:0x0CE3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0CE3
  ,simpleLowerCaseMapping:0x0CE3
  ,simpleTitleCaseMapping:0x0CE3
 },
 { code:0x0CE6
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0CE6
  ,simpleLowerCaseMapping:0x0CE6
  ,simpleTitleCaseMapping:0x0CE6
 },
 { code:0x0CE7
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0CE7
  ,simpleLowerCaseMapping:0x0CE7
  ,simpleTitleCaseMapping:0x0CE7
 },
 { code:0x0CE8
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0CE8
  ,simpleLowerCaseMapping:0x0CE8
  ,simpleTitleCaseMapping:0x0CE8
 },
 { code:0x0CE9
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0CE9
  ,simpleLowerCaseMapping:0x0CE9
  ,simpleTitleCaseMapping:0x0CE9
 },
 { code:0x0CEA
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0CEA
  ,simpleLowerCaseMapping:0x0CEA
  ,simpleTitleCaseMapping:0x0CEA
 },
 { code:0x0CEB
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0CEB
  ,simpleLowerCaseMapping:0x0CEB
  ,simpleTitleCaseMapping:0x0CEB
 },
 { code:0x0CEC
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0CEC
  ,simpleLowerCaseMapping:0x0CEC
  ,simpleTitleCaseMapping:0x0CEC
 },
 { code:0x0CED
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0CED
  ,simpleLowerCaseMapping:0x0CED
  ,simpleTitleCaseMapping:0x0CED
 },
 { code:0x0CEE
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0CEE
  ,simpleLowerCaseMapping:0x0CEE
  ,simpleTitleCaseMapping:0x0CEE
 },
 { code:0x0CEF
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0CEF
  ,simpleLowerCaseMapping:0x0CEF
  ,simpleTitleCaseMapping:0x0CEF
 },
 { code:0x0CF1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0CF1
  ,simpleLowerCaseMapping:0x0CF1
  ,simpleTitleCaseMapping:0x0CF1
 },
 { code:0x0CF2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0CF2
  ,simpleLowerCaseMapping:0x0CF2
  ,simpleTitleCaseMapping:0x0CF2
 },
 { code:0x0D02
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0D02
  ,simpleLowerCaseMapping:0x0D02
  ,simpleTitleCaseMapping:0x0D02
 },
 { code:0x0D03
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0D03
  ,simpleLowerCaseMapping:0x0D03
  ,simpleTitleCaseMapping:0x0D03
 },
 { code:0x0D05
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D05
  ,simpleLowerCaseMapping:0x0D05
  ,simpleTitleCaseMapping:0x0D05
 },
 { code:0x0D06
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D06
  ,simpleLowerCaseMapping:0x0D06
  ,simpleTitleCaseMapping:0x0D06
 },
 { code:0x0D07
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D07
  ,simpleLowerCaseMapping:0x0D07
  ,simpleTitleCaseMapping:0x0D07
 },
 { code:0x0D08
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D08
  ,simpleLowerCaseMapping:0x0D08
  ,simpleTitleCaseMapping:0x0D08
 },
 { code:0x0D09
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D09
  ,simpleLowerCaseMapping:0x0D09
  ,simpleTitleCaseMapping:0x0D09
 },
 { code:0x0D0A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D0A
  ,simpleLowerCaseMapping:0x0D0A
  ,simpleTitleCaseMapping:0x0D0A
 },
 { code:0x0D0B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D0B
  ,simpleLowerCaseMapping:0x0D0B
  ,simpleTitleCaseMapping:0x0D0B
 },
 { code:0x0D0C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D0C
  ,simpleLowerCaseMapping:0x0D0C
  ,simpleTitleCaseMapping:0x0D0C
 },
 { code:0x0D0E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D0E
  ,simpleLowerCaseMapping:0x0D0E
  ,simpleTitleCaseMapping:0x0D0E
 },
 { code:0x0D0F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D0F
  ,simpleLowerCaseMapping:0x0D0F
  ,simpleTitleCaseMapping:0x0D0F
 },
 { code:0x0D10
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D10
  ,simpleLowerCaseMapping:0x0D10
  ,simpleTitleCaseMapping:0x0D10
 },
 { code:0x0D12
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D12
  ,simpleLowerCaseMapping:0x0D12
  ,simpleTitleCaseMapping:0x0D12
 },
 { code:0x0D13
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D13
  ,simpleLowerCaseMapping:0x0D13
  ,simpleTitleCaseMapping:0x0D13
 },
 { code:0x0D14
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D14
  ,simpleLowerCaseMapping:0x0D14
  ,simpleTitleCaseMapping:0x0D14
 },
 { code:0x0D15
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D15
  ,simpleLowerCaseMapping:0x0D15
  ,simpleTitleCaseMapping:0x0D15
 },
 { code:0x0D16
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D16
  ,simpleLowerCaseMapping:0x0D16
  ,simpleTitleCaseMapping:0x0D16
 },
 { code:0x0D17
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D17
  ,simpleLowerCaseMapping:0x0D17
  ,simpleTitleCaseMapping:0x0D17
 },
 { code:0x0D18
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D18
  ,simpleLowerCaseMapping:0x0D18
  ,simpleTitleCaseMapping:0x0D18
 },
 { code:0x0D19
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D19
  ,simpleLowerCaseMapping:0x0D19
  ,simpleTitleCaseMapping:0x0D19
 },
 { code:0x0D1A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D1A
  ,simpleLowerCaseMapping:0x0D1A
  ,simpleTitleCaseMapping:0x0D1A
 },
 { code:0x0D1B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D1B
  ,simpleLowerCaseMapping:0x0D1B
  ,simpleTitleCaseMapping:0x0D1B
 },
 { code:0x0D1C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D1C
  ,simpleLowerCaseMapping:0x0D1C
  ,simpleTitleCaseMapping:0x0D1C
 },
 { code:0x0D1D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D1D
  ,simpleLowerCaseMapping:0x0D1D
  ,simpleTitleCaseMapping:0x0D1D
 },
 { code:0x0D1E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D1E
  ,simpleLowerCaseMapping:0x0D1E
  ,simpleTitleCaseMapping:0x0D1E
 },
 { code:0x0D1F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D1F
  ,simpleLowerCaseMapping:0x0D1F
  ,simpleTitleCaseMapping:0x0D1F
 },
 { code:0x0D20
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D20
  ,simpleLowerCaseMapping:0x0D20
  ,simpleTitleCaseMapping:0x0D20
 },
 { code:0x0D21
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D21
  ,simpleLowerCaseMapping:0x0D21
  ,simpleTitleCaseMapping:0x0D21
 },
 { code:0x0D22
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D22
  ,simpleLowerCaseMapping:0x0D22
  ,simpleTitleCaseMapping:0x0D22
 },
 { code:0x0D23
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D23
  ,simpleLowerCaseMapping:0x0D23
  ,simpleTitleCaseMapping:0x0D23
 },
 { code:0x0D24
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D24
  ,simpleLowerCaseMapping:0x0D24
  ,simpleTitleCaseMapping:0x0D24
 },
 { code:0x0D25
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D25
  ,simpleLowerCaseMapping:0x0D25
  ,simpleTitleCaseMapping:0x0D25
 },
 { code:0x0D26
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D26
  ,simpleLowerCaseMapping:0x0D26
  ,simpleTitleCaseMapping:0x0D26
 },
 { code:0x0D27
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D27
  ,simpleLowerCaseMapping:0x0D27
  ,simpleTitleCaseMapping:0x0D27
 },
 { code:0x0D28
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D28
  ,simpleLowerCaseMapping:0x0D28
  ,simpleTitleCaseMapping:0x0D28
 },
 { code:0x0D2A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D2A
  ,simpleLowerCaseMapping:0x0D2A
  ,simpleTitleCaseMapping:0x0D2A
 },
 { code:0x0D2B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D2B
  ,simpleLowerCaseMapping:0x0D2B
  ,simpleTitleCaseMapping:0x0D2B
 },
 { code:0x0D2C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D2C
  ,simpleLowerCaseMapping:0x0D2C
  ,simpleTitleCaseMapping:0x0D2C
 },
 { code:0x0D2D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D2D
  ,simpleLowerCaseMapping:0x0D2D
  ,simpleTitleCaseMapping:0x0D2D
 },
 { code:0x0D2E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D2E
  ,simpleLowerCaseMapping:0x0D2E
  ,simpleTitleCaseMapping:0x0D2E
 },
 { code:0x0D2F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D2F
  ,simpleLowerCaseMapping:0x0D2F
  ,simpleTitleCaseMapping:0x0D2F
 },
 { code:0x0D30
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D30
  ,simpleLowerCaseMapping:0x0D30
  ,simpleTitleCaseMapping:0x0D30
 },
 { code:0x0D31
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D31
  ,simpleLowerCaseMapping:0x0D31
  ,simpleTitleCaseMapping:0x0D31
 },
 { code:0x0D32
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D32
  ,simpleLowerCaseMapping:0x0D32
  ,simpleTitleCaseMapping:0x0D32
 },
 { code:0x0D33
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D33
  ,simpleLowerCaseMapping:0x0D33
  ,simpleTitleCaseMapping:0x0D33
 },
 { code:0x0D34
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D34
  ,simpleLowerCaseMapping:0x0D34
  ,simpleTitleCaseMapping:0x0D34
 },
 { code:0x0D35
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D35
  ,simpleLowerCaseMapping:0x0D35
  ,simpleTitleCaseMapping:0x0D35
 },
 { code:0x0D36
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D36
  ,simpleLowerCaseMapping:0x0D36
  ,simpleTitleCaseMapping:0x0D36
 },
 { code:0x0D37
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D37
  ,simpleLowerCaseMapping:0x0D37
  ,simpleTitleCaseMapping:0x0D37
 },
 { code:0x0D38
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D38
  ,simpleLowerCaseMapping:0x0D38
  ,simpleTitleCaseMapping:0x0D38
 },
 { code:0x0D39
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D39
  ,simpleLowerCaseMapping:0x0D39
  ,simpleTitleCaseMapping:0x0D39
 },
 { code:0x0D3E
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0D3E
  ,simpleLowerCaseMapping:0x0D3E
  ,simpleTitleCaseMapping:0x0D3E
 },
 { code:0x0D3F
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0D3F
  ,simpleLowerCaseMapping:0x0D3F
  ,simpleTitleCaseMapping:0x0D3F
 },
 { code:0x0D40
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0D40
  ,simpleLowerCaseMapping:0x0D40
  ,simpleTitleCaseMapping:0x0D40
 },
 { code:0x0D41
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0D41
  ,simpleLowerCaseMapping:0x0D41
  ,simpleTitleCaseMapping:0x0D41
 },
 { code:0x0D42
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0D42
  ,simpleLowerCaseMapping:0x0D42
  ,simpleTitleCaseMapping:0x0D42
 },
 { code:0x0D43
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0D43
  ,simpleLowerCaseMapping:0x0D43
  ,simpleTitleCaseMapping:0x0D43
 },
 { code:0x0D46
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0D46
  ,simpleLowerCaseMapping:0x0D46
  ,simpleTitleCaseMapping:0x0D46
 },
 { code:0x0D47
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0D47
  ,simpleLowerCaseMapping:0x0D47
  ,simpleTitleCaseMapping:0x0D47
 },
 { code:0x0D48
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0D48
  ,simpleLowerCaseMapping:0x0D48
  ,simpleTitleCaseMapping:0x0D48
 },
 { code:0x0D4A
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0D4A
  ,simpleLowerCaseMapping:0x0D4A
  ,simpleTitleCaseMapping:0x0D4A
 },
 { code:0x0D4B
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0D4B
  ,simpleLowerCaseMapping:0x0D4B
  ,simpleTitleCaseMapping:0x0D4B
 },
 { code:0x0D4C
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0D4C
  ,simpleLowerCaseMapping:0x0D4C
  ,simpleTitleCaseMapping:0x0D4C
 },
 { code:0x0D4D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0D4D
  ,simpleLowerCaseMapping:0x0D4D
  ,simpleTitleCaseMapping:0x0D4D
 },
 { code:0x0D57
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0D57
  ,simpleLowerCaseMapping:0x0D57
  ,simpleTitleCaseMapping:0x0D57
 },
 { code:0x0D60
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D60
  ,simpleLowerCaseMapping:0x0D60
  ,simpleTitleCaseMapping:0x0D60
 },
 { code:0x0D61
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D61
  ,simpleLowerCaseMapping:0x0D61
  ,simpleTitleCaseMapping:0x0D61
 },
 { code:0x0D66
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0D66
  ,simpleLowerCaseMapping:0x0D66
  ,simpleTitleCaseMapping:0x0D66
 },
 { code:0x0D67
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0D67
  ,simpleLowerCaseMapping:0x0D67
  ,simpleTitleCaseMapping:0x0D67
 },
 { code:0x0D68
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0D68
  ,simpleLowerCaseMapping:0x0D68
  ,simpleTitleCaseMapping:0x0D68
 },
 { code:0x0D69
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0D69
  ,simpleLowerCaseMapping:0x0D69
  ,simpleTitleCaseMapping:0x0D69
 },
 { code:0x0D6A
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0D6A
  ,simpleLowerCaseMapping:0x0D6A
  ,simpleTitleCaseMapping:0x0D6A
 },
 { code:0x0D6B
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0D6B
  ,simpleLowerCaseMapping:0x0D6B
  ,simpleTitleCaseMapping:0x0D6B
 },
 { code:0x0D6C
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0D6C
  ,simpleLowerCaseMapping:0x0D6C
  ,simpleTitleCaseMapping:0x0D6C
 },
 { code:0x0D6D
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0D6D
  ,simpleLowerCaseMapping:0x0D6D
  ,simpleTitleCaseMapping:0x0D6D
 },
 { code:0x0D6E
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0D6E
  ,simpleLowerCaseMapping:0x0D6E
  ,simpleTitleCaseMapping:0x0D6E
 },
 { code:0x0D6F
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0D6F
  ,simpleLowerCaseMapping:0x0D6F
  ,simpleTitleCaseMapping:0x0D6F
 },
 { code:0x0D82
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0D82
  ,simpleLowerCaseMapping:0x0D82
  ,simpleTitleCaseMapping:0x0D82
 },
 { code:0x0D83
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0D83
  ,simpleLowerCaseMapping:0x0D83
  ,simpleTitleCaseMapping:0x0D83
 },
 { code:0x0D85
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D85
  ,simpleLowerCaseMapping:0x0D85
  ,simpleTitleCaseMapping:0x0D85
 },
 { code:0x0D86
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D86
  ,simpleLowerCaseMapping:0x0D86
  ,simpleTitleCaseMapping:0x0D86
 },
 { code:0x0D87
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D87
  ,simpleLowerCaseMapping:0x0D87
  ,simpleTitleCaseMapping:0x0D87
 },
 { code:0x0D88
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D88
  ,simpleLowerCaseMapping:0x0D88
  ,simpleTitleCaseMapping:0x0D88
 },
 { code:0x0D89
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D89
  ,simpleLowerCaseMapping:0x0D89
  ,simpleTitleCaseMapping:0x0D89
 },
 { code:0x0D8A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D8A
  ,simpleLowerCaseMapping:0x0D8A
  ,simpleTitleCaseMapping:0x0D8A
 },
 { code:0x0D8B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D8B
  ,simpleLowerCaseMapping:0x0D8B
  ,simpleTitleCaseMapping:0x0D8B
 },
 { code:0x0D8C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D8C
  ,simpleLowerCaseMapping:0x0D8C
  ,simpleTitleCaseMapping:0x0D8C
 },
 { code:0x0D8D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D8D
  ,simpleLowerCaseMapping:0x0D8D
  ,simpleTitleCaseMapping:0x0D8D
 },
 { code:0x0D8E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D8E
  ,simpleLowerCaseMapping:0x0D8E
  ,simpleTitleCaseMapping:0x0D8E
 },
 { code:0x0D8F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D8F
  ,simpleLowerCaseMapping:0x0D8F
  ,simpleTitleCaseMapping:0x0D8F
 },
 { code:0x0D90
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D90
  ,simpleLowerCaseMapping:0x0D90
  ,simpleTitleCaseMapping:0x0D90
 },
 { code:0x0D91
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D91
  ,simpleLowerCaseMapping:0x0D91
  ,simpleTitleCaseMapping:0x0D91
 },
 { code:0x0D92
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D92
  ,simpleLowerCaseMapping:0x0D92
  ,simpleTitleCaseMapping:0x0D92
 },
 { code:0x0D93
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D93
  ,simpleLowerCaseMapping:0x0D93
  ,simpleTitleCaseMapping:0x0D93
 },
 { code:0x0D94
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D94
  ,simpleLowerCaseMapping:0x0D94
  ,simpleTitleCaseMapping:0x0D94
 },
 { code:0x0D95
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D95
  ,simpleLowerCaseMapping:0x0D95
  ,simpleTitleCaseMapping:0x0D95
 },
 { code:0x0D96
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D96
  ,simpleLowerCaseMapping:0x0D96
  ,simpleTitleCaseMapping:0x0D96
 },
 { code:0x0D9A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D9A
  ,simpleLowerCaseMapping:0x0D9A
  ,simpleTitleCaseMapping:0x0D9A
 },
 { code:0x0D9B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D9B
  ,simpleLowerCaseMapping:0x0D9B
  ,simpleTitleCaseMapping:0x0D9B
 },
 { code:0x0D9C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D9C
  ,simpleLowerCaseMapping:0x0D9C
  ,simpleTitleCaseMapping:0x0D9C
 },
 { code:0x0D9D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D9D
  ,simpleLowerCaseMapping:0x0D9D
  ,simpleTitleCaseMapping:0x0D9D
 },
 { code:0x0D9E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D9E
  ,simpleLowerCaseMapping:0x0D9E
  ,simpleTitleCaseMapping:0x0D9E
 },
 { code:0x0D9F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0D9F
  ,simpleLowerCaseMapping:0x0D9F
  ,simpleTitleCaseMapping:0x0D9F
 },
 { code:0x0DA0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DA0
  ,simpleLowerCaseMapping:0x0DA0
  ,simpleTitleCaseMapping:0x0DA0
 },
 { code:0x0DA1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DA1
  ,simpleLowerCaseMapping:0x0DA1
  ,simpleTitleCaseMapping:0x0DA1
 },
 { code:0x0DA2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DA2
  ,simpleLowerCaseMapping:0x0DA2
  ,simpleTitleCaseMapping:0x0DA2
 },
 { code:0x0DA3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DA3
  ,simpleLowerCaseMapping:0x0DA3
  ,simpleTitleCaseMapping:0x0DA3
 },
 { code:0x0DA4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DA4
  ,simpleLowerCaseMapping:0x0DA4
  ,simpleTitleCaseMapping:0x0DA4
 },
 { code:0x0DA5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DA5
  ,simpleLowerCaseMapping:0x0DA5
  ,simpleTitleCaseMapping:0x0DA5
 },
 { code:0x0DA6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DA6
  ,simpleLowerCaseMapping:0x0DA6
  ,simpleTitleCaseMapping:0x0DA6
 },
 { code:0x0DA7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DA7
  ,simpleLowerCaseMapping:0x0DA7
  ,simpleTitleCaseMapping:0x0DA7
 },
 { code:0x0DA8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DA8
  ,simpleLowerCaseMapping:0x0DA8
  ,simpleTitleCaseMapping:0x0DA8
 },
 { code:0x0DA9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DA9
  ,simpleLowerCaseMapping:0x0DA9
  ,simpleTitleCaseMapping:0x0DA9
 },
 { code:0x0DAA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DAA
  ,simpleLowerCaseMapping:0x0DAA
  ,simpleTitleCaseMapping:0x0DAA
 },
 { code:0x0DAB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DAB
  ,simpleLowerCaseMapping:0x0DAB
  ,simpleTitleCaseMapping:0x0DAB
 },
 { code:0x0DAC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DAC
  ,simpleLowerCaseMapping:0x0DAC
  ,simpleTitleCaseMapping:0x0DAC
 },
 { code:0x0DAD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DAD
  ,simpleLowerCaseMapping:0x0DAD
  ,simpleTitleCaseMapping:0x0DAD
 },
 { code:0x0DAE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DAE
  ,simpleLowerCaseMapping:0x0DAE
  ,simpleTitleCaseMapping:0x0DAE
 },
 { code:0x0DAF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DAF
  ,simpleLowerCaseMapping:0x0DAF
  ,simpleTitleCaseMapping:0x0DAF
 },
 { code:0x0DB0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DB0
  ,simpleLowerCaseMapping:0x0DB0
  ,simpleTitleCaseMapping:0x0DB0
 },
 { code:0x0DB1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DB1
  ,simpleLowerCaseMapping:0x0DB1
  ,simpleTitleCaseMapping:0x0DB1
 },
 { code:0x0DB3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DB3
  ,simpleLowerCaseMapping:0x0DB3
  ,simpleTitleCaseMapping:0x0DB3
 },
 { code:0x0DB4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DB4
  ,simpleLowerCaseMapping:0x0DB4
  ,simpleTitleCaseMapping:0x0DB4
 },
 { code:0x0DB5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DB5
  ,simpleLowerCaseMapping:0x0DB5
  ,simpleTitleCaseMapping:0x0DB5
 },
 { code:0x0DB6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DB6
  ,simpleLowerCaseMapping:0x0DB6
  ,simpleTitleCaseMapping:0x0DB6
 },
 { code:0x0DB7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DB7
  ,simpleLowerCaseMapping:0x0DB7
  ,simpleTitleCaseMapping:0x0DB7
 },
 { code:0x0DB8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DB8
  ,simpleLowerCaseMapping:0x0DB8
  ,simpleTitleCaseMapping:0x0DB8
 },
 { code:0x0DB9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DB9
  ,simpleLowerCaseMapping:0x0DB9
  ,simpleTitleCaseMapping:0x0DB9
 },
 { code:0x0DBA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DBA
  ,simpleLowerCaseMapping:0x0DBA
  ,simpleTitleCaseMapping:0x0DBA
 },
 { code:0x0DBB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DBB
  ,simpleLowerCaseMapping:0x0DBB
  ,simpleTitleCaseMapping:0x0DBB
 },
 { code:0x0DBD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DBD
  ,simpleLowerCaseMapping:0x0DBD
  ,simpleTitleCaseMapping:0x0DBD
 },
 { code:0x0DC0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DC0
  ,simpleLowerCaseMapping:0x0DC0
  ,simpleTitleCaseMapping:0x0DC0
 },
 { code:0x0DC1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DC1
  ,simpleLowerCaseMapping:0x0DC1
  ,simpleTitleCaseMapping:0x0DC1
 },
 { code:0x0DC2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DC2
  ,simpleLowerCaseMapping:0x0DC2
  ,simpleTitleCaseMapping:0x0DC2
 },
 { code:0x0DC3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DC3
  ,simpleLowerCaseMapping:0x0DC3
  ,simpleTitleCaseMapping:0x0DC3
 },
 { code:0x0DC4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DC4
  ,simpleLowerCaseMapping:0x0DC4
  ,simpleTitleCaseMapping:0x0DC4
 },
 { code:0x0DC5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DC5
  ,simpleLowerCaseMapping:0x0DC5
  ,simpleTitleCaseMapping:0x0DC5
 },
 { code:0x0DC6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0DC6
  ,simpleLowerCaseMapping:0x0DC6
  ,simpleTitleCaseMapping:0x0DC6
 },
 { code:0x0DCA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0DCA
  ,simpleLowerCaseMapping:0x0DCA
  ,simpleTitleCaseMapping:0x0DCA
 },
 { code:0x0DCF
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0DCF
  ,simpleLowerCaseMapping:0x0DCF
  ,simpleTitleCaseMapping:0x0DCF
 },
 { code:0x0DD0
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0DD0
  ,simpleLowerCaseMapping:0x0DD0
  ,simpleTitleCaseMapping:0x0DD0
 },
 { code:0x0DD1
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0DD1
  ,simpleLowerCaseMapping:0x0DD1
  ,simpleTitleCaseMapping:0x0DD1
 },
 { code:0x0DD2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0DD2
  ,simpleLowerCaseMapping:0x0DD2
  ,simpleTitleCaseMapping:0x0DD2
 },
 { code:0x0DD3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0DD3
  ,simpleLowerCaseMapping:0x0DD3
  ,simpleTitleCaseMapping:0x0DD3
 },
 { code:0x0DD4
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0DD4
  ,simpleLowerCaseMapping:0x0DD4
  ,simpleTitleCaseMapping:0x0DD4
 },
 { code:0x0DD6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0DD6
  ,simpleLowerCaseMapping:0x0DD6
  ,simpleTitleCaseMapping:0x0DD6
 },
 { code:0x0DD8
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0DD8
  ,simpleLowerCaseMapping:0x0DD8
  ,simpleTitleCaseMapping:0x0DD8
 },
 { code:0x0DD9
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0DD9
  ,simpleLowerCaseMapping:0x0DD9
  ,simpleTitleCaseMapping:0x0DD9
 },
 { code:0x0DDA
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0DDA
  ,simpleLowerCaseMapping:0x0DDA
  ,simpleTitleCaseMapping:0x0DDA
 },
 { code:0x0DDB
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0DDB
  ,simpleLowerCaseMapping:0x0DDB
  ,simpleTitleCaseMapping:0x0DDB
 },
 { code:0x0DDC
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0DDC
  ,simpleLowerCaseMapping:0x0DDC
  ,simpleTitleCaseMapping:0x0DDC
 },
 { code:0x0DDD
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0DDD
  ,simpleLowerCaseMapping:0x0DDD
  ,simpleTitleCaseMapping:0x0DDD
 },
 { code:0x0DDE
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0DDE
  ,simpleLowerCaseMapping:0x0DDE
  ,simpleTitleCaseMapping:0x0DDE
 },
 { code:0x0DDF
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0DDF
  ,simpleLowerCaseMapping:0x0DDF
  ,simpleTitleCaseMapping:0x0DDF
 },
 { code:0x0DF2
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0DF2
  ,simpleLowerCaseMapping:0x0DF2
  ,simpleTitleCaseMapping:0x0DF2
 },
 { code:0x0DF3
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0DF3
  ,simpleLowerCaseMapping:0x0DF3
  ,simpleTitleCaseMapping:0x0DF3
 },
 { code:0x0DF4
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0DF4
  ,simpleLowerCaseMapping:0x0DF4
  ,simpleTitleCaseMapping:0x0DF4
 },
 { code:0x0E01
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E01
  ,simpleLowerCaseMapping:0x0E01
  ,simpleTitleCaseMapping:0x0E01
 },
 { code:0x0E02
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E02
  ,simpleLowerCaseMapping:0x0E02
  ,simpleTitleCaseMapping:0x0E02
 },
 { code:0x0E03
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E03
  ,simpleLowerCaseMapping:0x0E03
  ,simpleTitleCaseMapping:0x0E03
 },
 { code:0x0E04
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E04
  ,simpleLowerCaseMapping:0x0E04
  ,simpleTitleCaseMapping:0x0E04
 },
 { code:0x0E05
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E05
  ,simpleLowerCaseMapping:0x0E05
  ,simpleTitleCaseMapping:0x0E05
 },
 { code:0x0E06
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E06
  ,simpleLowerCaseMapping:0x0E06
  ,simpleTitleCaseMapping:0x0E06
 },
 { code:0x0E07
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E07
  ,simpleLowerCaseMapping:0x0E07
  ,simpleTitleCaseMapping:0x0E07
 },
 { code:0x0E08
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E08
  ,simpleLowerCaseMapping:0x0E08
  ,simpleTitleCaseMapping:0x0E08
 },
 { code:0x0E09
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E09
  ,simpleLowerCaseMapping:0x0E09
  ,simpleTitleCaseMapping:0x0E09
 },
 { code:0x0E0A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E0A
  ,simpleLowerCaseMapping:0x0E0A
  ,simpleTitleCaseMapping:0x0E0A
 },
 { code:0x0E0B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E0B
  ,simpleLowerCaseMapping:0x0E0B
  ,simpleTitleCaseMapping:0x0E0B
 },
 { code:0x0E0C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E0C
  ,simpleLowerCaseMapping:0x0E0C
  ,simpleTitleCaseMapping:0x0E0C
 },
 { code:0x0E0D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E0D
  ,simpleLowerCaseMapping:0x0E0D
  ,simpleTitleCaseMapping:0x0E0D
 },
 { code:0x0E0E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E0E
  ,simpleLowerCaseMapping:0x0E0E
  ,simpleTitleCaseMapping:0x0E0E
 },
 { code:0x0E0F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E0F
  ,simpleLowerCaseMapping:0x0E0F
  ,simpleTitleCaseMapping:0x0E0F
 },
 { code:0x0E10
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E10
  ,simpleLowerCaseMapping:0x0E10
  ,simpleTitleCaseMapping:0x0E10
 },
 { code:0x0E11
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E11
  ,simpleLowerCaseMapping:0x0E11
  ,simpleTitleCaseMapping:0x0E11
 },
 { code:0x0E12
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E12
  ,simpleLowerCaseMapping:0x0E12
  ,simpleTitleCaseMapping:0x0E12
 },
 { code:0x0E13
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E13
  ,simpleLowerCaseMapping:0x0E13
  ,simpleTitleCaseMapping:0x0E13
 },
 { code:0x0E14
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E14
  ,simpleLowerCaseMapping:0x0E14
  ,simpleTitleCaseMapping:0x0E14
 },
 { code:0x0E15
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E15
  ,simpleLowerCaseMapping:0x0E15
  ,simpleTitleCaseMapping:0x0E15
 },
 { code:0x0E16
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E16
  ,simpleLowerCaseMapping:0x0E16
  ,simpleTitleCaseMapping:0x0E16
 },
 { code:0x0E17
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E17
  ,simpleLowerCaseMapping:0x0E17
  ,simpleTitleCaseMapping:0x0E17
 },
 { code:0x0E18
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E18
  ,simpleLowerCaseMapping:0x0E18
  ,simpleTitleCaseMapping:0x0E18
 },
 { code:0x0E19
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E19
  ,simpleLowerCaseMapping:0x0E19
  ,simpleTitleCaseMapping:0x0E19
 },
 { code:0x0E1A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E1A
  ,simpleLowerCaseMapping:0x0E1A
  ,simpleTitleCaseMapping:0x0E1A
 },
 { code:0x0E1B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E1B
  ,simpleLowerCaseMapping:0x0E1B
  ,simpleTitleCaseMapping:0x0E1B
 },
 { code:0x0E1C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E1C
  ,simpleLowerCaseMapping:0x0E1C
  ,simpleTitleCaseMapping:0x0E1C
 },
 { code:0x0E1D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E1D
  ,simpleLowerCaseMapping:0x0E1D
  ,simpleTitleCaseMapping:0x0E1D
 },
 { code:0x0E1E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E1E
  ,simpleLowerCaseMapping:0x0E1E
  ,simpleTitleCaseMapping:0x0E1E
 },
 { code:0x0E1F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E1F
  ,simpleLowerCaseMapping:0x0E1F
  ,simpleTitleCaseMapping:0x0E1F
 },
 { code:0x0E20
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E20
  ,simpleLowerCaseMapping:0x0E20
  ,simpleTitleCaseMapping:0x0E20
 },
 { code:0x0E21
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E21
  ,simpleLowerCaseMapping:0x0E21
  ,simpleTitleCaseMapping:0x0E21
 },
 { code:0x0E22
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E22
  ,simpleLowerCaseMapping:0x0E22
  ,simpleTitleCaseMapping:0x0E22
 },
 { code:0x0E23
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E23
  ,simpleLowerCaseMapping:0x0E23
  ,simpleTitleCaseMapping:0x0E23
 },
 { code:0x0E24
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E24
  ,simpleLowerCaseMapping:0x0E24
  ,simpleTitleCaseMapping:0x0E24
 },
 { code:0x0E25
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E25
  ,simpleLowerCaseMapping:0x0E25
  ,simpleTitleCaseMapping:0x0E25
 },
 { code:0x0E26
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E26
  ,simpleLowerCaseMapping:0x0E26
  ,simpleTitleCaseMapping:0x0E26
 },
 { code:0x0E27
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E27
  ,simpleLowerCaseMapping:0x0E27
  ,simpleTitleCaseMapping:0x0E27
 },
 { code:0x0E28
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E28
  ,simpleLowerCaseMapping:0x0E28
  ,simpleTitleCaseMapping:0x0E28
 },
 { code:0x0E29
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E29
  ,simpleLowerCaseMapping:0x0E29
  ,simpleTitleCaseMapping:0x0E29
 },
 { code:0x0E2A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E2A
  ,simpleLowerCaseMapping:0x0E2A
  ,simpleTitleCaseMapping:0x0E2A
 },
 { code:0x0E2B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E2B
  ,simpleLowerCaseMapping:0x0E2B
  ,simpleTitleCaseMapping:0x0E2B
 },
 { code:0x0E2C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E2C
  ,simpleLowerCaseMapping:0x0E2C
  ,simpleTitleCaseMapping:0x0E2C
 },
 { code:0x0E2D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E2D
  ,simpleLowerCaseMapping:0x0E2D
  ,simpleTitleCaseMapping:0x0E2D
 },
 { code:0x0E2E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E2E
  ,simpleLowerCaseMapping:0x0E2E
  ,simpleTitleCaseMapping:0x0E2E
 },
 { code:0x0E2F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E2F
  ,simpleLowerCaseMapping:0x0E2F
  ,simpleTitleCaseMapping:0x0E2F
 },
 { code:0x0E30
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E30
  ,simpleLowerCaseMapping:0x0E30
  ,simpleTitleCaseMapping:0x0E30
 },
 { code:0x0E31
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0E31
  ,simpleLowerCaseMapping:0x0E31
  ,simpleTitleCaseMapping:0x0E31
 },
 { code:0x0E32
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E32
  ,simpleLowerCaseMapping:0x0E32
  ,simpleTitleCaseMapping:0x0E32
 },
 { code:0x0E33
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E33
  ,simpleLowerCaseMapping:0x0E33
  ,simpleTitleCaseMapping:0x0E33
 },
 { code:0x0E34
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0E34
  ,simpleLowerCaseMapping:0x0E34
  ,simpleTitleCaseMapping:0x0E34
 },
 { code:0x0E35
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0E35
  ,simpleLowerCaseMapping:0x0E35
  ,simpleTitleCaseMapping:0x0E35
 },
 { code:0x0E36
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0E36
  ,simpleLowerCaseMapping:0x0E36
  ,simpleTitleCaseMapping:0x0E36
 },
 { code:0x0E37
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0E37
  ,simpleLowerCaseMapping:0x0E37
  ,simpleTitleCaseMapping:0x0E37
 },
 { code:0x0E38
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0E38
  ,simpleLowerCaseMapping:0x0E38
  ,simpleTitleCaseMapping:0x0E38
 },
 { code:0x0E39
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0E39
  ,simpleLowerCaseMapping:0x0E39
  ,simpleTitleCaseMapping:0x0E39
 },
 { code:0x0E3A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0E3A
  ,simpleLowerCaseMapping:0x0E3A
  ,simpleTitleCaseMapping:0x0E3A
 },
 { code:0x0E3F
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x0E3F
  ,simpleLowerCaseMapping:0x0E3F
  ,simpleTitleCaseMapping:0x0E3F
 },
 { code:0x0E40
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E40
  ,simpleLowerCaseMapping:0x0E40
  ,simpleTitleCaseMapping:0x0E40
 },
 { code:0x0E41
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E41
  ,simpleLowerCaseMapping:0x0E41
  ,simpleTitleCaseMapping:0x0E41
 },
 { code:0x0E42
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E42
  ,simpleLowerCaseMapping:0x0E42
  ,simpleTitleCaseMapping:0x0E42
 },
 { code:0x0E43
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E43
  ,simpleLowerCaseMapping:0x0E43
  ,simpleTitleCaseMapping:0x0E43
 },
 { code:0x0E44
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E44
  ,simpleLowerCaseMapping:0x0E44
  ,simpleTitleCaseMapping:0x0E44
 },
 { code:0x0E45
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E45
  ,simpleLowerCaseMapping:0x0E45
  ,simpleTitleCaseMapping:0x0E45
 },
 { code:0x0E46
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x0E46
  ,simpleLowerCaseMapping:0x0E46
  ,simpleTitleCaseMapping:0x0E46
 },
 { code:0x0E47
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0E47
  ,simpleLowerCaseMapping:0x0E47
  ,simpleTitleCaseMapping:0x0E47
 },
 { code:0x0E48
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0E48
  ,simpleLowerCaseMapping:0x0E48
  ,simpleTitleCaseMapping:0x0E48
 },
 { code:0x0E49
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0E49
  ,simpleLowerCaseMapping:0x0E49
  ,simpleTitleCaseMapping:0x0E49
 },
 { code:0x0E4A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0E4A
  ,simpleLowerCaseMapping:0x0E4A
  ,simpleTitleCaseMapping:0x0E4A
 },
 { code:0x0E4B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0E4B
  ,simpleLowerCaseMapping:0x0E4B
  ,simpleTitleCaseMapping:0x0E4B
 },
 { code:0x0E4C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0E4C
  ,simpleLowerCaseMapping:0x0E4C
  ,simpleTitleCaseMapping:0x0E4C
 },
 { code:0x0E4D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0E4D
  ,simpleLowerCaseMapping:0x0E4D
  ,simpleTitleCaseMapping:0x0E4D
 },
 { code:0x0E4E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0E4E
  ,simpleLowerCaseMapping:0x0E4E
  ,simpleTitleCaseMapping:0x0E4E
 },
 { code:0x0E4F
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0E4F
  ,simpleLowerCaseMapping:0x0E4F
  ,simpleTitleCaseMapping:0x0E4F
 },
 { code:0x0E50
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0E50
  ,simpleLowerCaseMapping:0x0E50
  ,simpleTitleCaseMapping:0x0E50
 },
 { code:0x0E51
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0E51
  ,simpleLowerCaseMapping:0x0E51
  ,simpleTitleCaseMapping:0x0E51
 },
 { code:0x0E52
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0E52
  ,simpleLowerCaseMapping:0x0E52
  ,simpleTitleCaseMapping:0x0E52
 },
 { code:0x0E53
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0E53
  ,simpleLowerCaseMapping:0x0E53
  ,simpleTitleCaseMapping:0x0E53
 },
 { code:0x0E54
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0E54
  ,simpleLowerCaseMapping:0x0E54
  ,simpleTitleCaseMapping:0x0E54
 },
 { code:0x0E55
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0E55
  ,simpleLowerCaseMapping:0x0E55
  ,simpleTitleCaseMapping:0x0E55
 },
 { code:0x0E56
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0E56
  ,simpleLowerCaseMapping:0x0E56
  ,simpleTitleCaseMapping:0x0E56
 },
 { code:0x0E57
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0E57
  ,simpleLowerCaseMapping:0x0E57
  ,simpleTitleCaseMapping:0x0E57
 },
 { code:0x0E58
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0E58
  ,simpleLowerCaseMapping:0x0E58
  ,simpleTitleCaseMapping:0x0E58
 },
 { code:0x0E59
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0E59
  ,simpleLowerCaseMapping:0x0E59
  ,simpleTitleCaseMapping:0x0E59
 },
 { code:0x0E5A
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0E5A
  ,simpleLowerCaseMapping:0x0E5A
  ,simpleTitleCaseMapping:0x0E5A
 },
 { code:0x0E5B
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0E5B
  ,simpleLowerCaseMapping:0x0E5B
  ,simpleTitleCaseMapping:0x0E5B
 },
 { code:0x0E81
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E81
  ,simpleLowerCaseMapping:0x0E81
  ,simpleTitleCaseMapping:0x0E81
 },
 { code:0x0E82
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E82
  ,simpleLowerCaseMapping:0x0E82
  ,simpleTitleCaseMapping:0x0E82
 },
 { code:0x0E84
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E84
  ,simpleLowerCaseMapping:0x0E84
  ,simpleTitleCaseMapping:0x0E84
 },
 { code:0x0E87
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E87
  ,simpleLowerCaseMapping:0x0E87
  ,simpleTitleCaseMapping:0x0E87
 },
 { code:0x0E88
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E88
  ,simpleLowerCaseMapping:0x0E88
  ,simpleTitleCaseMapping:0x0E88
 },
 { code:0x0E8A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E8A
  ,simpleLowerCaseMapping:0x0E8A
  ,simpleTitleCaseMapping:0x0E8A
 },
 { code:0x0E8D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E8D
  ,simpleLowerCaseMapping:0x0E8D
  ,simpleTitleCaseMapping:0x0E8D
 },
 { code:0x0E94
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E94
  ,simpleLowerCaseMapping:0x0E94
  ,simpleTitleCaseMapping:0x0E94
 },
 { code:0x0E95
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E95
  ,simpleLowerCaseMapping:0x0E95
  ,simpleTitleCaseMapping:0x0E95
 },
 { code:0x0E96
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E96
  ,simpleLowerCaseMapping:0x0E96
  ,simpleTitleCaseMapping:0x0E96
 },
 { code:0x0E97
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E97
  ,simpleLowerCaseMapping:0x0E97
  ,simpleTitleCaseMapping:0x0E97
 },
 { code:0x0E99
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E99
  ,simpleLowerCaseMapping:0x0E99
  ,simpleTitleCaseMapping:0x0E99
 },
 { code:0x0E9A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E9A
  ,simpleLowerCaseMapping:0x0E9A
  ,simpleTitleCaseMapping:0x0E9A
 },
 { code:0x0E9B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E9B
  ,simpleLowerCaseMapping:0x0E9B
  ,simpleTitleCaseMapping:0x0E9B
 },
 { code:0x0E9C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E9C
  ,simpleLowerCaseMapping:0x0E9C
  ,simpleTitleCaseMapping:0x0E9C
 },
 { code:0x0E9D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E9D
  ,simpleLowerCaseMapping:0x0E9D
  ,simpleTitleCaseMapping:0x0E9D
 },
 { code:0x0E9E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E9E
  ,simpleLowerCaseMapping:0x0E9E
  ,simpleTitleCaseMapping:0x0E9E
 },
 { code:0x0E9F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0E9F
  ,simpleLowerCaseMapping:0x0E9F
  ,simpleTitleCaseMapping:0x0E9F
 },
 { code:0x0EA1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EA1
  ,simpleLowerCaseMapping:0x0EA1
  ,simpleTitleCaseMapping:0x0EA1
 },
 { code:0x0EA2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EA2
  ,simpleLowerCaseMapping:0x0EA2
  ,simpleTitleCaseMapping:0x0EA2
 },
 { code:0x0EA3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EA3
  ,simpleLowerCaseMapping:0x0EA3
  ,simpleTitleCaseMapping:0x0EA3
 },
 { code:0x0EA5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EA5
  ,simpleLowerCaseMapping:0x0EA5
  ,simpleTitleCaseMapping:0x0EA5
 },
 { code:0x0EA7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EA7
  ,simpleLowerCaseMapping:0x0EA7
  ,simpleTitleCaseMapping:0x0EA7
 },
 { code:0x0EAA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EAA
  ,simpleLowerCaseMapping:0x0EAA
  ,simpleTitleCaseMapping:0x0EAA
 },
 { code:0x0EAB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EAB
  ,simpleLowerCaseMapping:0x0EAB
  ,simpleTitleCaseMapping:0x0EAB
 },
 { code:0x0EAD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EAD
  ,simpleLowerCaseMapping:0x0EAD
  ,simpleTitleCaseMapping:0x0EAD
 },
 { code:0x0EAE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EAE
  ,simpleLowerCaseMapping:0x0EAE
  ,simpleTitleCaseMapping:0x0EAE
 },
 { code:0x0EAF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EAF
  ,simpleLowerCaseMapping:0x0EAF
  ,simpleTitleCaseMapping:0x0EAF
 },
 { code:0x0EB0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EB0
  ,simpleLowerCaseMapping:0x0EB0
  ,simpleTitleCaseMapping:0x0EB0
 },
 { code:0x0EB1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0EB1
  ,simpleLowerCaseMapping:0x0EB1
  ,simpleTitleCaseMapping:0x0EB1
 },
 { code:0x0EB2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EB2
  ,simpleLowerCaseMapping:0x0EB2
  ,simpleTitleCaseMapping:0x0EB2
 },
 { code:0x0EB3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EB3
  ,simpleLowerCaseMapping:0x0EB3
  ,simpleTitleCaseMapping:0x0EB3
 },
 { code:0x0EB4
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0EB4
  ,simpleLowerCaseMapping:0x0EB4
  ,simpleTitleCaseMapping:0x0EB4
 },
 { code:0x0EB5
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0EB5
  ,simpleLowerCaseMapping:0x0EB5
  ,simpleTitleCaseMapping:0x0EB5
 },
 { code:0x0EB6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0EB6
  ,simpleLowerCaseMapping:0x0EB6
  ,simpleTitleCaseMapping:0x0EB6
 },
 { code:0x0EB7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0EB7
  ,simpleLowerCaseMapping:0x0EB7
  ,simpleTitleCaseMapping:0x0EB7
 },
 { code:0x0EB8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0EB8
  ,simpleLowerCaseMapping:0x0EB8
  ,simpleTitleCaseMapping:0x0EB8
 },
 { code:0x0EB9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0EB9
  ,simpleLowerCaseMapping:0x0EB9
  ,simpleTitleCaseMapping:0x0EB9
 },
 { code:0x0EBB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0EBB
  ,simpleLowerCaseMapping:0x0EBB
  ,simpleTitleCaseMapping:0x0EBB
 },
 { code:0x0EBC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0EBC
  ,simpleLowerCaseMapping:0x0EBC
  ,simpleTitleCaseMapping:0x0EBC
 },
 { code:0x0EBD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EBD
  ,simpleLowerCaseMapping:0x0EBD
  ,simpleTitleCaseMapping:0x0EBD
 },
 { code:0x0EC0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EC0
  ,simpleLowerCaseMapping:0x0EC0
  ,simpleTitleCaseMapping:0x0EC0
 },
 { code:0x0EC1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EC1
  ,simpleLowerCaseMapping:0x0EC1
  ,simpleTitleCaseMapping:0x0EC1
 },
 { code:0x0EC2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EC2
  ,simpleLowerCaseMapping:0x0EC2
  ,simpleTitleCaseMapping:0x0EC2
 },
 { code:0x0EC3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EC3
  ,simpleLowerCaseMapping:0x0EC3
  ,simpleTitleCaseMapping:0x0EC3
 },
 { code:0x0EC4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EC4
  ,simpleLowerCaseMapping:0x0EC4
  ,simpleTitleCaseMapping:0x0EC4
 },
 { code:0x0EC6
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x0EC6
  ,simpleLowerCaseMapping:0x0EC6
  ,simpleTitleCaseMapping:0x0EC6
 },
 { code:0x0EC8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0EC8
  ,simpleLowerCaseMapping:0x0EC8
  ,simpleTitleCaseMapping:0x0EC8
 },
 { code:0x0EC9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0EC9
  ,simpleLowerCaseMapping:0x0EC9
  ,simpleTitleCaseMapping:0x0EC9
 },
 { code:0x0ECA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0ECA
  ,simpleLowerCaseMapping:0x0ECA
  ,simpleTitleCaseMapping:0x0ECA
 },
 { code:0x0ECB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0ECB
  ,simpleLowerCaseMapping:0x0ECB
  ,simpleTitleCaseMapping:0x0ECB
 },
 { code:0x0ECC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0ECC
  ,simpleLowerCaseMapping:0x0ECC
  ,simpleTitleCaseMapping:0x0ECC
 },
 { code:0x0ECD
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0ECD
  ,simpleLowerCaseMapping:0x0ECD
  ,simpleTitleCaseMapping:0x0ECD
 },
 { code:0x0ED0
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0ED0
  ,simpleLowerCaseMapping:0x0ED0
  ,simpleTitleCaseMapping:0x0ED0
 },
 { code:0x0ED1
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0ED1
  ,simpleLowerCaseMapping:0x0ED1
  ,simpleTitleCaseMapping:0x0ED1
 },
 { code:0x0ED2
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0ED2
  ,simpleLowerCaseMapping:0x0ED2
  ,simpleTitleCaseMapping:0x0ED2
 },
 { code:0x0ED3
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0ED3
  ,simpleLowerCaseMapping:0x0ED3
  ,simpleTitleCaseMapping:0x0ED3
 },
 { code:0x0ED4
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0ED4
  ,simpleLowerCaseMapping:0x0ED4
  ,simpleTitleCaseMapping:0x0ED4
 },
 { code:0x0ED5
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0ED5
  ,simpleLowerCaseMapping:0x0ED5
  ,simpleTitleCaseMapping:0x0ED5
 },
 { code:0x0ED6
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0ED6
  ,simpleLowerCaseMapping:0x0ED6
  ,simpleTitleCaseMapping:0x0ED6
 },
 { code:0x0ED7
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0ED7
  ,simpleLowerCaseMapping:0x0ED7
  ,simpleTitleCaseMapping:0x0ED7
 },
 { code:0x0ED8
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0ED8
  ,simpleLowerCaseMapping:0x0ED8
  ,simpleTitleCaseMapping:0x0ED8
 },
 { code:0x0ED9
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0ED9
  ,simpleLowerCaseMapping:0x0ED9
  ,simpleTitleCaseMapping:0x0ED9
 },
 { code:0x0EDC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EDC
  ,simpleLowerCaseMapping:0x0EDC
  ,simpleTitleCaseMapping:0x0EDC
 },
 { code:0x0EDD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0EDD
  ,simpleLowerCaseMapping:0x0EDD
  ,simpleTitleCaseMapping:0x0EDD
 },
 { code:0x0F00
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F00
  ,simpleLowerCaseMapping:0x0F00
  ,simpleTitleCaseMapping:0x0F00
 },
 { code:0x0F01
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0F01
  ,simpleLowerCaseMapping:0x0F01
  ,simpleTitleCaseMapping:0x0F01
 },
 { code:0x0F02
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0F02
  ,simpleLowerCaseMapping:0x0F02
  ,simpleTitleCaseMapping:0x0F02
 },
 { code:0x0F03
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0F03
  ,simpleLowerCaseMapping:0x0F03
  ,simpleTitleCaseMapping:0x0F03
 },
 { code:0x0F04
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0F04
  ,simpleLowerCaseMapping:0x0F04
  ,simpleTitleCaseMapping:0x0F04
 },
 { code:0x0F05
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0F05
  ,simpleLowerCaseMapping:0x0F05
  ,simpleTitleCaseMapping:0x0F05
 },
 { code:0x0F06
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0F06
  ,simpleLowerCaseMapping:0x0F06
  ,simpleTitleCaseMapping:0x0F06
 },
 { code:0x0F07
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0F07
  ,simpleLowerCaseMapping:0x0F07
  ,simpleTitleCaseMapping:0x0F07
 },
 { code:0x0F08
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0F08
  ,simpleLowerCaseMapping:0x0F08
  ,simpleTitleCaseMapping:0x0F08
 },
 { code:0x0F09
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0F09
  ,simpleLowerCaseMapping:0x0F09
  ,simpleTitleCaseMapping:0x0F09
 },
 { code:0x0F0A
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0F0A
  ,simpleLowerCaseMapping:0x0F0A
  ,simpleTitleCaseMapping:0x0F0A
 },
 { code:0x0F0B
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0F0B
  ,simpleLowerCaseMapping:0x0F0B
  ,simpleTitleCaseMapping:0x0F0B
 },
 { code:0x0F0C
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0F0C
  ,simpleLowerCaseMapping:0x0F0C
  ,simpleTitleCaseMapping:0x0F0C
 },
 { code:0x0F0D
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0F0D
  ,simpleLowerCaseMapping:0x0F0D
  ,simpleTitleCaseMapping:0x0F0D
 },
 { code:0x0F0E
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0F0E
  ,simpleLowerCaseMapping:0x0F0E
  ,simpleTitleCaseMapping:0x0F0E
 },
 { code:0x0F0F
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0F0F
  ,simpleLowerCaseMapping:0x0F0F
  ,simpleTitleCaseMapping:0x0F0F
 },
 { code:0x0F10
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0F10
  ,simpleLowerCaseMapping:0x0F10
  ,simpleTitleCaseMapping:0x0F10
 },
 { code:0x0F11
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0F11
  ,simpleLowerCaseMapping:0x0F11
  ,simpleTitleCaseMapping:0x0F11
 },
 { code:0x0F12
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0F12
  ,simpleLowerCaseMapping:0x0F12
  ,simpleTitleCaseMapping:0x0F12
 },
 { code:0x0F13
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0F13
  ,simpleLowerCaseMapping:0x0F13
  ,simpleTitleCaseMapping:0x0F13
 },
 { code:0x0F14
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0F14
  ,simpleLowerCaseMapping:0x0F14
  ,simpleTitleCaseMapping:0x0F14
 },
 { code:0x0F15
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0F15
  ,simpleLowerCaseMapping:0x0F15
  ,simpleTitleCaseMapping:0x0F15
 },
 { code:0x0F16
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0F16
  ,simpleLowerCaseMapping:0x0F16
  ,simpleTitleCaseMapping:0x0F16
 },
 { code:0x0F17
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0F17
  ,simpleLowerCaseMapping:0x0F17
  ,simpleTitleCaseMapping:0x0F17
 },
 { code:0x0F18
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F18
  ,simpleLowerCaseMapping:0x0F18
  ,simpleTitleCaseMapping:0x0F18
 },
 { code:0x0F19
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F19
  ,simpleLowerCaseMapping:0x0F19
  ,simpleTitleCaseMapping:0x0F19
 },
 { code:0x0F1A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0F1A
  ,simpleLowerCaseMapping:0x0F1A
  ,simpleTitleCaseMapping:0x0F1A
 },
 { code:0x0F1B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0F1B
  ,simpleLowerCaseMapping:0x0F1B
  ,simpleTitleCaseMapping:0x0F1B
 },
 { code:0x0F1C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0F1C
  ,simpleLowerCaseMapping:0x0F1C
  ,simpleTitleCaseMapping:0x0F1C
 },
 { code:0x0F1D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0F1D
  ,simpleLowerCaseMapping:0x0F1D
  ,simpleTitleCaseMapping:0x0F1D
 },
 { code:0x0F1E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0F1E
  ,simpleLowerCaseMapping:0x0F1E
  ,simpleTitleCaseMapping:0x0F1E
 },
 { code:0x0F1F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0F1F
  ,simpleLowerCaseMapping:0x0F1F
  ,simpleTitleCaseMapping:0x0F1F
 },
 { code:0x0F20
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0F20
  ,simpleLowerCaseMapping:0x0F20
  ,simpleTitleCaseMapping:0x0F20
 },
 { code:0x0F21
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0F21
  ,simpleLowerCaseMapping:0x0F21
  ,simpleTitleCaseMapping:0x0F21
 },
 { code:0x0F22
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0F22
  ,simpleLowerCaseMapping:0x0F22
  ,simpleTitleCaseMapping:0x0F22
 },
 { code:0x0F23
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0F23
  ,simpleLowerCaseMapping:0x0F23
  ,simpleTitleCaseMapping:0x0F23
 },
 { code:0x0F24
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0F24
  ,simpleLowerCaseMapping:0x0F24
  ,simpleTitleCaseMapping:0x0F24
 },
 { code:0x0F25
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0F25
  ,simpleLowerCaseMapping:0x0F25
  ,simpleTitleCaseMapping:0x0F25
 },
 { code:0x0F26
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0F26
  ,simpleLowerCaseMapping:0x0F26
  ,simpleTitleCaseMapping:0x0F26
 },
 { code:0x0F27
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0F27
  ,simpleLowerCaseMapping:0x0F27
  ,simpleTitleCaseMapping:0x0F27
 },
 { code:0x0F28
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0F28
  ,simpleLowerCaseMapping:0x0F28
  ,simpleTitleCaseMapping:0x0F28
 },
 { code:0x0F29
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x0F29
  ,simpleLowerCaseMapping:0x0F29
  ,simpleTitleCaseMapping:0x0F29
 },
 { code:0x0F2A
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x0F2A
  ,simpleLowerCaseMapping:0x0F2A
  ,simpleTitleCaseMapping:0x0F2A
 },
 { code:0x0F2B
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x0F2B
  ,simpleLowerCaseMapping:0x0F2B
  ,simpleTitleCaseMapping:0x0F2B
 },
 { code:0x0F2C
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x0F2C
  ,simpleLowerCaseMapping:0x0F2C
  ,simpleTitleCaseMapping:0x0F2C
 },
 { code:0x0F2D
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x0F2D
  ,simpleLowerCaseMapping:0x0F2D
  ,simpleTitleCaseMapping:0x0F2D
 },
 { code:0x0F2E
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x0F2E
  ,simpleLowerCaseMapping:0x0F2E
  ,simpleTitleCaseMapping:0x0F2E
 },
 { code:0x0F2F
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x0F2F
  ,simpleLowerCaseMapping:0x0F2F
  ,simpleTitleCaseMapping:0x0F2F
 },
 { code:0x0F30
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x0F30
  ,simpleLowerCaseMapping:0x0F30
  ,simpleTitleCaseMapping:0x0F30
 },
 { code:0x0F31
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x0F31
  ,simpleLowerCaseMapping:0x0F31
  ,simpleTitleCaseMapping:0x0F31
 },
 { code:0x0F32
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x0F32
  ,simpleLowerCaseMapping:0x0F32
  ,simpleTitleCaseMapping:0x0F32
 },
 { code:0x0F33
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x0F33
  ,simpleLowerCaseMapping:0x0F33
  ,simpleTitleCaseMapping:0x0F33
 },
 { code:0x0F34
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0F34
  ,simpleLowerCaseMapping:0x0F34
  ,simpleTitleCaseMapping:0x0F34
 },
 { code:0x0F35
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F35
  ,simpleLowerCaseMapping:0x0F35
  ,simpleTitleCaseMapping:0x0F35
 },
 { code:0x0F36
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0F36
  ,simpleLowerCaseMapping:0x0F36
  ,simpleTitleCaseMapping:0x0F36
 },
 { code:0x0F37
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F37
  ,simpleLowerCaseMapping:0x0F37
  ,simpleTitleCaseMapping:0x0F37
 },
 { code:0x0F38
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0F38
  ,simpleLowerCaseMapping:0x0F38
  ,simpleTitleCaseMapping:0x0F38
 },
 { code:0x0F39
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F39
  ,simpleLowerCaseMapping:0x0F39
  ,simpleTitleCaseMapping:0x0F39
 },
 { code:0x0F3A
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x0F3A
  ,simpleLowerCaseMapping:0x0F3A
  ,simpleTitleCaseMapping:0x0F3A
 },
 { code:0x0F3B
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x0F3B
  ,simpleLowerCaseMapping:0x0F3B
  ,simpleTitleCaseMapping:0x0F3B
 },
 { code:0x0F3C
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x0F3C
  ,simpleLowerCaseMapping:0x0F3C
  ,simpleTitleCaseMapping:0x0F3C
 },
 { code:0x0F3D
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x0F3D
  ,simpleLowerCaseMapping:0x0F3D
  ,simpleTitleCaseMapping:0x0F3D
 },
 { code:0x0F3E
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0F3E
  ,simpleLowerCaseMapping:0x0F3E
  ,simpleTitleCaseMapping:0x0F3E
 },
 { code:0x0F3F
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0F3F
  ,simpleLowerCaseMapping:0x0F3F
  ,simpleTitleCaseMapping:0x0F3F
 },
 { code:0x0F40
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F40
  ,simpleLowerCaseMapping:0x0F40
  ,simpleTitleCaseMapping:0x0F40
 },
 { code:0x0F41
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F41
  ,simpleLowerCaseMapping:0x0F41
  ,simpleTitleCaseMapping:0x0F41
 },
 { code:0x0F42
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F42
  ,simpleLowerCaseMapping:0x0F42
  ,simpleTitleCaseMapping:0x0F42
 },
 { code:0x0F43
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F43
  ,simpleLowerCaseMapping:0x0F43
  ,simpleTitleCaseMapping:0x0F43
 },
 { code:0x0F44
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F44
  ,simpleLowerCaseMapping:0x0F44
  ,simpleTitleCaseMapping:0x0F44
 },
 { code:0x0F45
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F45
  ,simpleLowerCaseMapping:0x0F45
  ,simpleTitleCaseMapping:0x0F45
 },
 { code:0x0F46
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F46
  ,simpleLowerCaseMapping:0x0F46
  ,simpleTitleCaseMapping:0x0F46
 },
 { code:0x0F47
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F47
  ,simpleLowerCaseMapping:0x0F47
  ,simpleTitleCaseMapping:0x0F47
 },
 { code:0x0F49
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F49
  ,simpleLowerCaseMapping:0x0F49
  ,simpleTitleCaseMapping:0x0F49
 },
 { code:0x0F4A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F4A
  ,simpleLowerCaseMapping:0x0F4A
  ,simpleTitleCaseMapping:0x0F4A
 },
 { code:0x0F4B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F4B
  ,simpleLowerCaseMapping:0x0F4B
  ,simpleTitleCaseMapping:0x0F4B
 },
 { code:0x0F4C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F4C
  ,simpleLowerCaseMapping:0x0F4C
  ,simpleTitleCaseMapping:0x0F4C
 },
 { code:0x0F4D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F4D
  ,simpleLowerCaseMapping:0x0F4D
  ,simpleTitleCaseMapping:0x0F4D
 },
 { code:0x0F4E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F4E
  ,simpleLowerCaseMapping:0x0F4E
  ,simpleTitleCaseMapping:0x0F4E
 },
 { code:0x0F4F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F4F
  ,simpleLowerCaseMapping:0x0F4F
  ,simpleTitleCaseMapping:0x0F4F
 },
 { code:0x0F50
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F50
  ,simpleLowerCaseMapping:0x0F50
  ,simpleTitleCaseMapping:0x0F50
 },
 { code:0x0F51
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F51
  ,simpleLowerCaseMapping:0x0F51
  ,simpleTitleCaseMapping:0x0F51
 },
 { code:0x0F52
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F52
  ,simpleLowerCaseMapping:0x0F52
  ,simpleTitleCaseMapping:0x0F52
 },
 { code:0x0F53
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F53
  ,simpleLowerCaseMapping:0x0F53
  ,simpleTitleCaseMapping:0x0F53
 },
 { code:0x0F54
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F54
  ,simpleLowerCaseMapping:0x0F54
  ,simpleTitleCaseMapping:0x0F54
 },
 { code:0x0F55
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F55
  ,simpleLowerCaseMapping:0x0F55
  ,simpleTitleCaseMapping:0x0F55
 },
 { code:0x0F56
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F56
  ,simpleLowerCaseMapping:0x0F56
  ,simpleTitleCaseMapping:0x0F56
 },
 { code:0x0F57
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F57
  ,simpleLowerCaseMapping:0x0F57
  ,simpleTitleCaseMapping:0x0F57
 },
 { code:0x0F58
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F58
  ,simpleLowerCaseMapping:0x0F58
  ,simpleTitleCaseMapping:0x0F58
 },
 { code:0x0F59
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F59
  ,simpleLowerCaseMapping:0x0F59
  ,simpleTitleCaseMapping:0x0F59
 },
 { code:0x0F5A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F5A
  ,simpleLowerCaseMapping:0x0F5A
  ,simpleTitleCaseMapping:0x0F5A
 },
 { code:0x0F5B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F5B
  ,simpleLowerCaseMapping:0x0F5B
  ,simpleTitleCaseMapping:0x0F5B
 },
 { code:0x0F5C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F5C
  ,simpleLowerCaseMapping:0x0F5C
  ,simpleTitleCaseMapping:0x0F5C
 },
 { code:0x0F5D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F5D
  ,simpleLowerCaseMapping:0x0F5D
  ,simpleTitleCaseMapping:0x0F5D
 },
 { code:0x0F5E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F5E
  ,simpleLowerCaseMapping:0x0F5E
  ,simpleTitleCaseMapping:0x0F5E
 },
 { code:0x0F5F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F5F
  ,simpleLowerCaseMapping:0x0F5F
  ,simpleTitleCaseMapping:0x0F5F
 },
 { code:0x0F60
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F60
  ,simpleLowerCaseMapping:0x0F60
  ,simpleTitleCaseMapping:0x0F60
 },
 { code:0x0F61
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F61
  ,simpleLowerCaseMapping:0x0F61
  ,simpleTitleCaseMapping:0x0F61
 },
 { code:0x0F62
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F62
  ,simpleLowerCaseMapping:0x0F62
  ,simpleTitleCaseMapping:0x0F62
 },
 { code:0x0F63
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F63
  ,simpleLowerCaseMapping:0x0F63
  ,simpleTitleCaseMapping:0x0F63
 },
 { code:0x0F64
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F64
  ,simpleLowerCaseMapping:0x0F64
  ,simpleTitleCaseMapping:0x0F64
 },
 { code:0x0F65
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F65
  ,simpleLowerCaseMapping:0x0F65
  ,simpleTitleCaseMapping:0x0F65
 },
 { code:0x0F66
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F66
  ,simpleLowerCaseMapping:0x0F66
  ,simpleTitleCaseMapping:0x0F66
 },
 { code:0x0F67
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F67
  ,simpleLowerCaseMapping:0x0F67
  ,simpleTitleCaseMapping:0x0F67
 },
 { code:0x0F68
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F68
  ,simpleLowerCaseMapping:0x0F68
  ,simpleTitleCaseMapping:0x0F68
 },
 { code:0x0F69
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F69
  ,simpleLowerCaseMapping:0x0F69
  ,simpleTitleCaseMapping:0x0F69
 },
 { code:0x0F6A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F6A
  ,simpleLowerCaseMapping:0x0F6A
  ,simpleTitleCaseMapping:0x0F6A
 },
 { code:0x0F71
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F71
  ,simpleLowerCaseMapping:0x0F71
  ,simpleTitleCaseMapping:0x0F71
 },
 { code:0x0F72
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F72
  ,simpleLowerCaseMapping:0x0F72
  ,simpleTitleCaseMapping:0x0F72
 },
 { code:0x0F73
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F73
  ,simpleLowerCaseMapping:0x0F73
  ,simpleTitleCaseMapping:0x0F73
 },
 { code:0x0F74
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F74
  ,simpleLowerCaseMapping:0x0F74
  ,simpleTitleCaseMapping:0x0F74
 },
 { code:0x0F75
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F75
  ,simpleLowerCaseMapping:0x0F75
  ,simpleTitleCaseMapping:0x0F75
 },
 { code:0x0F76
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F76
  ,simpleLowerCaseMapping:0x0F76
  ,simpleTitleCaseMapping:0x0F76
 },
 { code:0x0F77
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F77
  ,simpleLowerCaseMapping:0x0F77
  ,simpleTitleCaseMapping:0x0F77
 },
 { code:0x0F78
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F78
  ,simpleLowerCaseMapping:0x0F78
  ,simpleTitleCaseMapping:0x0F78
 },
 { code:0x0F79
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F79
  ,simpleLowerCaseMapping:0x0F79
  ,simpleTitleCaseMapping:0x0F79
 },
 { code:0x0F7A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F7A
  ,simpleLowerCaseMapping:0x0F7A
  ,simpleTitleCaseMapping:0x0F7A
 },
 { code:0x0F7B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F7B
  ,simpleLowerCaseMapping:0x0F7B
  ,simpleTitleCaseMapping:0x0F7B
 },
 { code:0x0F7C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F7C
  ,simpleLowerCaseMapping:0x0F7C
  ,simpleTitleCaseMapping:0x0F7C
 },
 { code:0x0F7D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F7D
  ,simpleLowerCaseMapping:0x0F7D
  ,simpleTitleCaseMapping:0x0F7D
 },
 { code:0x0F7E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F7E
  ,simpleLowerCaseMapping:0x0F7E
  ,simpleTitleCaseMapping:0x0F7E
 },
 { code:0x0F7F
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x0F7F
  ,simpleLowerCaseMapping:0x0F7F
  ,simpleTitleCaseMapping:0x0F7F
 },
 { code:0x0F80
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F80
  ,simpleLowerCaseMapping:0x0F80
  ,simpleTitleCaseMapping:0x0F80
 },
 { code:0x0F81
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F81
  ,simpleLowerCaseMapping:0x0F81
  ,simpleTitleCaseMapping:0x0F81
 },
 { code:0x0F82
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F82
  ,simpleLowerCaseMapping:0x0F82
  ,simpleTitleCaseMapping:0x0F82
 },
 { code:0x0F83
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F83
  ,simpleLowerCaseMapping:0x0F83
  ,simpleTitleCaseMapping:0x0F83
 },
 { code:0x0F84
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F84
  ,simpleLowerCaseMapping:0x0F84
  ,simpleTitleCaseMapping:0x0F84
 },
 { code:0x0F85
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0F85
  ,simpleLowerCaseMapping:0x0F85
  ,simpleTitleCaseMapping:0x0F85
 },
 { code:0x0F86
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F86
  ,simpleLowerCaseMapping:0x0F86
  ,simpleTitleCaseMapping:0x0F86
 },
 { code:0x0F87
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F87
  ,simpleLowerCaseMapping:0x0F87
  ,simpleTitleCaseMapping:0x0F87
 },
 { code:0x0F88
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F88
  ,simpleLowerCaseMapping:0x0F88
  ,simpleTitleCaseMapping:0x0F88
 },
 { code:0x0F89
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F89
  ,simpleLowerCaseMapping:0x0F89
  ,simpleTitleCaseMapping:0x0F89
 },
 { code:0x0F8A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F8A
  ,simpleLowerCaseMapping:0x0F8A
  ,simpleTitleCaseMapping:0x0F8A
 },
 { code:0x0F8B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x0F8B
  ,simpleLowerCaseMapping:0x0F8B
  ,simpleTitleCaseMapping:0x0F8B
 },
 { code:0x0F90
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F90
  ,simpleLowerCaseMapping:0x0F90
  ,simpleTitleCaseMapping:0x0F90
 },
 { code:0x0F91
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F91
  ,simpleLowerCaseMapping:0x0F91
  ,simpleTitleCaseMapping:0x0F91
 },
 { code:0x0F92
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F92
  ,simpleLowerCaseMapping:0x0F92
  ,simpleTitleCaseMapping:0x0F92
 },
 { code:0x0F93
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F93
  ,simpleLowerCaseMapping:0x0F93
  ,simpleTitleCaseMapping:0x0F93
 },
 { code:0x0F94
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F94
  ,simpleLowerCaseMapping:0x0F94
  ,simpleTitleCaseMapping:0x0F94
 },
 { code:0x0F95
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F95
  ,simpleLowerCaseMapping:0x0F95
  ,simpleTitleCaseMapping:0x0F95
 },
 { code:0x0F96
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F96
  ,simpleLowerCaseMapping:0x0F96
  ,simpleTitleCaseMapping:0x0F96
 },
 { code:0x0F97
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F97
  ,simpleLowerCaseMapping:0x0F97
  ,simpleTitleCaseMapping:0x0F97
 },
 { code:0x0F99
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F99
  ,simpleLowerCaseMapping:0x0F99
  ,simpleTitleCaseMapping:0x0F99
 },
 { code:0x0F9A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F9A
  ,simpleLowerCaseMapping:0x0F9A
  ,simpleTitleCaseMapping:0x0F9A
 },
 { code:0x0F9B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F9B
  ,simpleLowerCaseMapping:0x0F9B
  ,simpleTitleCaseMapping:0x0F9B
 },
 { code:0x0F9C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F9C
  ,simpleLowerCaseMapping:0x0F9C
  ,simpleTitleCaseMapping:0x0F9C
 },
 { code:0x0F9D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F9D
  ,simpleLowerCaseMapping:0x0F9D
  ,simpleTitleCaseMapping:0x0F9D
 },
 { code:0x0F9E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F9E
  ,simpleLowerCaseMapping:0x0F9E
  ,simpleTitleCaseMapping:0x0F9E
 },
 { code:0x0F9F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0F9F
  ,simpleLowerCaseMapping:0x0F9F
  ,simpleTitleCaseMapping:0x0F9F
 },
 { code:0x0FA0
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FA0
  ,simpleLowerCaseMapping:0x0FA0
  ,simpleTitleCaseMapping:0x0FA0
 },
 { code:0x0FA1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FA1
  ,simpleLowerCaseMapping:0x0FA1
  ,simpleTitleCaseMapping:0x0FA1
 },
 { code:0x0FA2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FA2
  ,simpleLowerCaseMapping:0x0FA2
  ,simpleTitleCaseMapping:0x0FA2
 },
 { code:0x0FA3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FA3
  ,simpleLowerCaseMapping:0x0FA3
  ,simpleTitleCaseMapping:0x0FA3
 },
 { code:0x0FA4
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FA4
  ,simpleLowerCaseMapping:0x0FA4
  ,simpleTitleCaseMapping:0x0FA4
 },
 { code:0x0FA5
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FA5
  ,simpleLowerCaseMapping:0x0FA5
  ,simpleTitleCaseMapping:0x0FA5
 },
 { code:0x0FA6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FA6
  ,simpleLowerCaseMapping:0x0FA6
  ,simpleTitleCaseMapping:0x0FA6
 },
 { code:0x0FA7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FA7
  ,simpleLowerCaseMapping:0x0FA7
  ,simpleTitleCaseMapping:0x0FA7
 },
 { code:0x0FA8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FA8
  ,simpleLowerCaseMapping:0x0FA8
  ,simpleTitleCaseMapping:0x0FA8
 },
 { code:0x0FA9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FA9
  ,simpleLowerCaseMapping:0x0FA9
  ,simpleTitleCaseMapping:0x0FA9
 },
 { code:0x0FAA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FAA
  ,simpleLowerCaseMapping:0x0FAA
  ,simpleTitleCaseMapping:0x0FAA
 },
 { code:0x0FAB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FAB
  ,simpleLowerCaseMapping:0x0FAB
  ,simpleTitleCaseMapping:0x0FAB
 },
 { code:0x0FAC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FAC
  ,simpleLowerCaseMapping:0x0FAC
  ,simpleTitleCaseMapping:0x0FAC
 },
 { code:0x0FAD
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FAD
  ,simpleLowerCaseMapping:0x0FAD
  ,simpleTitleCaseMapping:0x0FAD
 },
 { code:0x0FAE
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FAE
  ,simpleLowerCaseMapping:0x0FAE
  ,simpleTitleCaseMapping:0x0FAE
 },
 { code:0x0FAF
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FAF
  ,simpleLowerCaseMapping:0x0FAF
  ,simpleTitleCaseMapping:0x0FAF
 },
 { code:0x0FB0
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FB0
  ,simpleLowerCaseMapping:0x0FB0
  ,simpleTitleCaseMapping:0x0FB0
 },
 { code:0x0FB1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FB1
  ,simpleLowerCaseMapping:0x0FB1
  ,simpleTitleCaseMapping:0x0FB1
 },
 { code:0x0FB2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FB2
  ,simpleLowerCaseMapping:0x0FB2
  ,simpleTitleCaseMapping:0x0FB2
 },
 { code:0x0FB3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FB3
  ,simpleLowerCaseMapping:0x0FB3
  ,simpleTitleCaseMapping:0x0FB3
 },
 { code:0x0FB4
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FB4
  ,simpleLowerCaseMapping:0x0FB4
  ,simpleTitleCaseMapping:0x0FB4
 },
 { code:0x0FB5
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FB5
  ,simpleLowerCaseMapping:0x0FB5
  ,simpleTitleCaseMapping:0x0FB5
 },
 { code:0x0FB6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FB6
  ,simpleLowerCaseMapping:0x0FB6
  ,simpleTitleCaseMapping:0x0FB6
 },
 { code:0x0FB7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FB7
  ,simpleLowerCaseMapping:0x0FB7
  ,simpleTitleCaseMapping:0x0FB7
 },
 { code:0x0FB8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FB8
  ,simpleLowerCaseMapping:0x0FB8
  ,simpleTitleCaseMapping:0x0FB8
 },
 { code:0x0FB9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FB9
  ,simpleLowerCaseMapping:0x0FB9
  ,simpleTitleCaseMapping:0x0FB9
 },
 { code:0x0FBA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FBA
  ,simpleLowerCaseMapping:0x0FBA
  ,simpleTitleCaseMapping:0x0FBA
 },
 { code:0x0FBB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FBB
  ,simpleLowerCaseMapping:0x0FBB
  ,simpleTitleCaseMapping:0x0FBB
 },
 { code:0x0FBC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FBC
  ,simpleLowerCaseMapping:0x0FBC
  ,simpleTitleCaseMapping:0x0FBC
 },
 { code:0x0FBE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0FBE
  ,simpleLowerCaseMapping:0x0FBE
  ,simpleTitleCaseMapping:0x0FBE
 },
 { code:0x0FBF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0FBF
  ,simpleLowerCaseMapping:0x0FBF
  ,simpleTitleCaseMapping:0x0FBF
 },
 { code:0x0FC0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0FC0
  ,simpleLowerCaseMapping:0x0FC0
  ,simpleTitleCaseMapping:0x0FC0
 },
 { code:0x0FC1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0FC1
  ,simpleLowerCaseMapping:0x0FC1
  ,simpleTitleCaseMapping:0x0FC1
 },
 { code:0x0FC2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0FC2
  ,simpleLowerCaseMapping:0x0FC2
  ,simpleTitleCaseMapping:0x0FC2
 },
 { code:0x0FC3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0FC3
  ,simpleLowerCaseMapping:0x0FC3
  ,simpleTitleCaseMapping:0x0FC3
 },
 { code:0x0FC4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0FC4
  ,simpleLowerCaseMapping:0x0FC4
  ,simpleTitleCaseMapping:0x0FC4
 },
 { code:0x0FC5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0FC5
  ,simpleLowerCaseMapping:0x0FC5
  ,simpleTitleCaseMapping:0x0FC5
 },
 { code:0x0FC6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x0FC6
  ,simpleLowerCaseMapping:0x0FC6
  ,simpleTitleCaseMapping:0x0FC6
 },
 { code:0x0FC7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0FC7
  ,simpleLowerCaseMapping:0x0FC7
  ,simpleTitleCaseMapping:0x0FC7
 },
 { code:0x0FC8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0FC8
  ,simpleLowerCaseMapping:0x0FC8
  ,simpleTitleCaseMapping:0x0FC8
 },
 { code:0x0FC9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0FC9
  ,simpleLowerCaseMapping:0x0FC9
  ,simpleTitleCaseMapping:0x0FC9
 },
 { code:0x0FCA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0FCA
  ,simpleLowerCaseMapping:0x0FCA
  ,simpleTitleCaseMapping:0x0FCA
 },
 { code:0x0FCB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0FCB
  ,simpleLowerCaseMapping:0x0FCB
  ,simpleTitleCaseMapping:0x0FCB
 },
 { code:0x0FCC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0FCC
  ,simpleLowerCaseMapping:0x0FCC
  ,simpleTitleCaseMapping:0x0FCC
 },
 { code:0x0FCF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x0FCF
  ,simpleLowerCaseMapping:0x0FCF
  ,simpleTitleCaseMapping:0x0FCF
 },
 { code:0x0FD0
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0FD0
  ,simpleLowerCaseMapping:0x0FD0
  ,simpleTitleCaseMapping:0x0FD0
 },
 { code:0x0FD1
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x0FD1
  ,simpleLowerCaseMapping:0x0FD1
  ,simpleTitleCaseMapping:0x0FD1
 },
 { code:0x1000
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1000
  ,simpleLowerCaseMapping:0x1000
  ,simpleTitleCaseMapping:0x1000
 },
 { code:0x1001
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1001
  ,simpleLowerCaseMapping:0x1001
  ,simpleTitleCaseMapping:0x1001
 },
 { code:0x1002
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1002
  ,simpleLowerCaseMapping:0x1002
  ,simpleTitleCaseMapping:0x1002
 },
 { code:0x1003
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1003
  ,simpleLowerCaseMapping:0x1003
  ,simpleTitleCaseMapping:0x1003
 },
 { code:0x1004
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1004
  ,simpleLowerCaseMapping:0x1004
  ,simpleTitleCaseMapping:0x1004
 },
 { code:0x1005
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1005
  ,simpleLowerCaseMapping:0x1005
  ,simpleTitleCaseMapping:0x1005
 },
 { code:0x1006
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1006
  ,simpleLowerCaseMapping:0x1006
  ,simpleTitleCaseMapping:0x1006
 },
 { code:0x1007
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1007
  ,simpleLowerCaseMapping:0x1007
  ,simpleTitleCaseMapping:0x1007
 },
 { code:0x1008
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1008
  ,simpleLowerCaseMapping:0x1008
  ,simpleTitleCaseMapping:0x1008
 },
 { code:0x1009
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1009
  ,simpleLowerCaseMapping:0x1009
  ,simpleTitleCaseMapping:0x1009
 },
 { code:0x100A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100A
  ,simpleLowerCaseMapping:0x100A
  ,simpleTitleCaseMapping:0x100A
 },
 { code:0x100B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100B
  ,simpleLowerCaseMapping:0x100B
  ,simpleTitleCaseMapping:0x100B
 },
 { code:0x100C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100C
  ,simpleLowerCaseMapping:0x100C
  ,simpleTitleCaseMapping:0x100C
 },
 { code:0x100D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100D
  ,simpleLowerCaseMapping:0x100D
  ,simpleTitleCaseMapping:0x100D
 },
 { code:0x100E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100E
  ,simpleLowerCaseMapping:0x100E
  ,simpleTitleCaseMapping:0x100E
 },
 { code:0x100F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100F
  ,simpleLowerCaseMapping:0x100F
  ,simpleTitleCaseMapping:0x100F
 },
 { code:0x1010
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1010
  ,simpleLowerCaseMapping:0x1010
  ,simpleTitleCaseMapping:0x1010
 },
 { code:0x1011
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1011
  ,simpleLowerCaseMapping:0x1011
  ,simpleTitleCaseMapping:0x1011
 },
 { code:0x1012
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1012
  ,simpleLowerCaseMapping:0x1012
  ,simpleTitleCaseMapping:0x1012
 },
 { code:0x1013
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1013
  ,simpleLowerCaseMapping:0x1013
  ,simpleTitleCaseMapping:0x1013
 },
 { code:0x1014
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1014
  ,simpleLowerCaseMapping:0x1014
  ,simpleTitleCaseMapping:0x1014
 },
 { code:0x1015
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1015
  ,simpleLowerCaseMapping:0x1015
  ,simpleTitleCaseMapping:0x1015
 },
 { code:0x1016
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1016
  ,simpleLowerCaseMapping:0x1016
  ,simpleTitleCaseMapping:0x1016
 },
 { code:0x1017
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1017
  ,simpleLowerCaseMapping:0x1017
  ,simpleTitleCaseMapping:0x1017
 },
 { code:0x1018
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1018
  ,simpleLowerCaseMapping:0x1018
  ,simpleTitleCaseMapping:0x1018
 },
 { code:0x1019
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1019
  ,simpleLowerCaseMapping:0x1019
  ,simpleTitleCaseMapping:0x1019
 },
 { code:0x101A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x101A
  ,simpleLowerCaseMapping:0x101A
  ,simpleTitleCaseMapping:0x101A
 },
 { code:0x101B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x101B
  ,simpleLowerCaseMapping:0x101B
  ,simpleTitleCaseMapping:0x101B
 },
 { code:0x101C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x101C
  ,simpleLowerCaseMapping:0x101C
  ,simpleTitleCaseMapping:0x101C
 },
 { code:0x101D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x101D
  ,simpleLowerCaseMapping:0x101D
  ,simpleTitleCaseMapping:0x101D
 },
 { code:0x101E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x101E
  ,simpleLowerCaseMapping:0x101E
  ,simpleTitleCaseMapping:0x101E
 },
 { code:0x101F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x101F
  ,simpleLowerCaseMapping:0x101F
  ,simpleTitleCaseMapping:0x101F
 },
 { code:0x1020
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1020
  ,simpleLowerCaseMapping:0x1020
  ,simpleTitleCaseMapping:0x1020
 },
 { code:0x1021
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1021
  ,simpleLowerCaseMapping:0x1021
  ,simpleTitleCaseMapping:0x1021
 },
 { code:0x1023
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1023
  ,simpleLowerCaseMapping:0x1023
  ,simpleTitleCaseMapping:0x1023
 },
 { code:0x1024
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1024
  ,simpleLowerCaseMapping:0x1024
  ,simpleTitleCaseMapping:0x1024
 },
 { code:0x1025
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1025
  ,simpleLowerCaseMapping:0x1025
  ,simpleTitleCaseMapping:0x1025
 },
 { code:0x1026
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1026
  ,simpleLowerCaseMapping:0x1026
  ,simpleTitleCaseMapping:0x1026
 },
 { code:0x1027
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1027
  ,simpleLowerCaseMapping:0x1027
  ,simpleTitleCaseMapping:0x1027
 },
 { code:0x1029
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1029
  ,simpleLowerCaseMapping:0x1029
  ,simpleTitleCaseMapping:0x1029
 },
 { code:0x102A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x102A
  ,simpleLowerCaseMapping:0x102A
  ,simpleTitleCaseMapping:0x102A
 },
 { code:0x102C
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x102C
  ,simpleLowerCaseMapping:0x102C
  ,simpleTitleCaseMapping:0x102C
 },
 { code:0x102D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x102D
  ,simpleLowerCaseMapping:0x102D
  ,simpleTitleCaseMapping:0x102D
 },
 { code:0x102E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x102E
  ,simpleLowerCaseMapping:0x102E
  ,simpleTitleCaseMapping:0x102E
 },
 { code:0x102F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x102F
  ,simpleLowerCaseMapping:0x102F
  ,simpleTitleCaseMapping:0x102F
 },
 { code:0x1030
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1030
  ,simpleLowerCaseMapping:0x1030
  ,simpleTitleCaseMapping:0x1030
 },
 { code:0x1031
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1031
  ,simpleLowerCaseMapping:0x1031
  ,simpleTitleCaseMapping:0x1031
 },
 { code:0x1032
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1032
  ,simpleLowerCaseMapping:0x1032
  ,simpleTitleCaseMapping:0x1032
 },
 { code:0x1036
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1036
  ,simpleLowerCaseMapping:0x1036
  ,simpleTitleCaseMapping:0x1036
 },
 { code:0x1037
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1037
  ,simpleLowerCaseMapping:0x1037
  ,simpleTitleCaseMapping:0x1037
 },
 { code:0x1038
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1038
  ,simpleLowerCaseMapping:0x1038
  ,simpleTitleCaseMapping:0x1038
 },
 { code:0x1039
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1039
  ,simpleLowerCaseMapping:0x1039
  ,simpleTitleCaseMapping:0x1039
 },
 { code:0x1040
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1040
  ,simpleLowerCaseMapping:0x1040
  ,simpleTitleCaseMapping:0x1040
 },
 { code:0x1041
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1041
  ,simpleLowerCaseMapping:0x1041
  ,simpleTitleCaseMapping:0x1041
 },
 { code:0x1042
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1042
  ,simpleLowerCaseMapping:0x1042
  ,simpleTitleCaseMapping:0x1042
 },
 { code:0x1043
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1043
  ,simpleLowerCaseMapping:0x1043
  ,simpleTitleCaseMapping:0x1043
 },
 { code:0x1044
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1044
  ,simpleLowerCaseMapping:0x1044
  ,simpleTitleCaseMapping:0x1044
 },
 { code:0x1045
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1045
  ,simpleLowerCaseMapping:0x1045
  ,simpleTitleCaseMapping:0x1045
 },
 { code:0x1046
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1046
  ,simpleLowerCaseMapping:0x1046
  ,simpleTitleCaseMapping:0x1046
 },
 { code:0x1047
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1047
  ,simpleLowerCaseMapping:0x1047
  ,simpleTitleCaseMapping:0x1047
 },
 { code:0x1048
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1048
  ,simpleLowerCaseMapping:0x1048
  ,simpleTitleCaseMapping:0x1048
 },
 { code:0x1049
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1049
  ,simpleLowerCaseMapping:0x1049
  ,simpleTitleCaseMapping:0x1049
 },
 { code:0x104A
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x104A
  ,simpleLowerCaseMapping:0x104A
  ,simpleTitleCaseMapping:0x104A
 },
 { code:0x104B
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x104B
  ,simpleLowerCaseMapping:0x104B
  ,simpleTitleCaseMapping:0x104B
 },
 { code:0x104C
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x104C
  ,simpleLowerCaseMapping:0x104C
  ,simpleTitleCaseMapping:0x104C
 },
 { code:0x104D
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x104D
  ,simpleLowerCaseMapping:0x104D
  ,simpleTitleCaseMapping:0x104D
 },
 { code:0x104E
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x104E
  ,simpleLowerCaseMapping:0x104E
  ,simpleTitleCaseMapping:0x104E
 },
 { code:0x104F
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x104F
  ,simpleLowerCaseMapping:0x104F
  ,simpleTitleCaseMapping:0x104F
 },
 { code:0x1050
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1050
  ,simpleLowerCaseMapping:0x1050
  ,simpleTitleCaseMapping:0x1050
 },
 { code:0x1051
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1051
  ,simpleLowerCaseMapping:0x1051
  ,simpleTitleCaseMapping:0x1051
 },
 { code:0x1052
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1052
  ,simpleLowerCaseMapping:0x1052
  ,simpleTitleCaseMapping:0x1052
 },
 { code:0x1053
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1053
  ,simpleLowerCaseMapping:0x1053
  ,simpleTitleCaseMapping:0x1053
 },
 { code:0x1054
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1054
  ,simpleLowerCaseMapping:0x1054
  ,simpleTitleCaseMapping:0x1054
 },
 { code:0x1055
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1055
  ,simpleLowerCaseMapping:0x1055
  ,simpleTitleCaseMapping:0x1055
 },
 { code:0x1056
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1056
  ,simpleLowerCaseMapping:0x1056
  ,simpleTitleCaseMapping:0x1056
 },
 { code:0x1057
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1057
  ,simpleLowerCaseMapping:0x1057
  ,simpleTitleCaseMapping:0x1057
 },
 { code:0x1058
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1058
  ,simpleLowerCaseMapping:0x1058
  ,simpleTitleCaseMapping:0x1058
 },
 { code:0x1059
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1059
  ,simpleLowerCaseMapping:0x1059
  ,simpleTitleCaseMapping:0x1059
 },
 { code:0x10A0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10A0
  ,simpleLowerCaseMapping:0x2D00
  ,simpleTitleCaseMapping:0x10A0
 },
 { code:0x10A1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10A1
  ,simpleLowerCaseMapping:0x2D01
  ,simpleTitleCaseMapping:0x10A1
 },
 { code:0x10A2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10A2
  ,simpleLowerCaseMapping:0x2D02
  ,simpleTitleCaseMapping:0x10A2
 },
 { code:0x10A3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10A3
  ,simpleLowerCaseMapping:0x2D03
  ,simpleTitleCaseMapping:0x10A3
 },
 { code:0x10A4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10A4
  ,simpleLowerCaseMapping:0x2D04
  ,simpleTitleCaseMapping:0x10A4
 },
 { code:0x10A5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10A5
  ,simpleLowerCaseMapping:0x2D05
  ,simpleTitleCaseMapping:0x10A5
 },
 { code:0x10A6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10A6
  ,simpleLowerCaseMapping:0x2D06
  ,simpleTitleCaseMapping:0x10A6
 },
 { code:0x10A7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10A7
  ,simpleLowerCaseMapping:0x2D07
  ,simpleTitleCaseMapping:0x10A7
 },
 { code:0x10A8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10A8
  ,simpleLowerCaseMapping:0x2D08
  ,simpleTitleCaseMapping:0x10A8
 },
 { code:0x10A9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10A9
  ,simpleLowerCaseMapping:0x2D09
  ,simpleTitleCaseMapping:0x10A9
 },
 { code:0x10AA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10AA
  ,simpleLowerCaseMapping:0x2D0A
  ,simpleTitleCaseMapping:0x10AA
 },
 { code:0x10AB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10AB
  ,simpleLowerCaseMapping:0x2D0B
  ,simpleTitleCaseMapping:0x10AB
 },
 { code:0x10AC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10AC
  ,simpleLowerCaseMapping:0x2D0C
  ,simpleTitleCaseMapping:0x10AC
 },
 { code:0x10AD
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10AD
  ,simpleLowerCaseMapping:0x2D0D
  ,simpleTitleCaseMapping:0x10AD
 },
 { code:0x10AE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10AE
  ,simpleLowerCaseMapping:0x2D0E
  ,simpleTitleCaseMapping:0x10AE
 },
 { code:0x10AF
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10AF
  ,simpleLowerCaseMapping:0x2D0F
  ,simpleTitleCaseMapping:0x10AF
 },
 { code:0x10B0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10B0
  ,simpleLowerCaseMapping:0x2D10
  ,simpleTitleCaseMapping:0x10B0
 },
 { code:0x10B1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10B1
  ,simpleLowerCaseMapping:0x2D11
  ,simpleTitleCaseMapping:0x10B1
 },
 { code:0x10B2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10B2
  ,simpleLowerCaseMapping:0x2D12
  ,simpleTitleCaseMapping:0x10B2
 },
 { code:0x10B3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10B3
  ,simpleLowerCaseMapping:0x2D13
  ,simpleTitleCaseMapping:0x10B3
 },
 { code:0x10B4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10B4
  ,simpleLowerCaseMapping:0x2D14
  ,simpleTitleCaseMapping:0x10B4
 },
 { code:0x10B5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10B5
  ,simpleLowerCaseMapping:0x2D15
  ,simpleTitleCaseMapping:0x10B5
 },
 { code:0x10B6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10B6
  ,simpleLowerCaseMapping:0x2D16
  ,simpleTitleCaseMapping:0x10B6
 },
 { code:0x10B7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10B7
  ,simpleLowerCaseMapping:0x2D17
  ,simpleTitleCaseMapping:0x10B7
 },
 { code:0x10B8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10B8
  ,simpleLowerCaseMapping:0x2D18
  ,simpleTitleCaseMapping:0x10B8
 },
 { code:0x10B9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10B9
  ,simpleLowerCaseMapping:0x2D19
  ,simpleTitleCaseMapping:0x10B9
 },
 { code:0x10BA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10BA
  ,simpleLowerCaseMapping:0x2D1A
  ,simpleTitleCaseMapping:0x10BA
 },
 { code:0x10BB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10BB
  ,simpleLowerCaseMapping:0x2D1B
  ,simpleTitleCaseMapping:0x10BB
 },
 { code:0x10BC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10BC
  ,simpleLowerCaseMapping:0x2D1C
  ,simpleTitleCaseMapping:0x10BC
 },
 { code:0x10BD
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10BD
  ,simpleLowerCaseMapping:0x2D1D
  ,simpleTitleCaseMapping:0x10BD
 },
 { code:0x10BE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10BE
  ,simpleLowerCaseMapping:0x2D1E
  ,simpleTitleCaseMapping:0x10BE
 },
 { code:0x10BF
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10BF
  ,simpleLowerCaseMapping:0x2D1F
  ,simpleTitleCaseMapping:0x10BF
 },
 { code:0x10C0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10C0
  ,simpleLowerCaseMapping:0x2D20
  ,simpleTitleCaseMapping:0x10C0
 },
 { code:0x10C1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10C1
  ,simpleLowerCaseMapping:0x2D21
  ,simpleTitleCaseMapping:0x10C1
 },
 { code:0x10C2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10C2
  ,simpleLowerCaseMapping:0x2D22
  ,simpleTitleCaseMapping:0x10C2
 },
 { code:0x10C3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10C3
  ,simpleLowerCaseMapping:0x2D23
  ,simpleTitleCaseMapping:0x10C3
 },
 { code:0x10C4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10C4
  ,simpleLowerCaseMapping:0x2D24
  ,simpleTitleCaseMapping:0x10C4
 },
 { code:0x10C5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10C5
  ,simpleLowerCaseMapping:0x2D25
  ,simpleTitleCaseMapping:0x10C5
 },
 { code:0x10D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10D0
  ,simpleLowerCaseMapping:0x10D0
  ,simpleTitleCaseMapping:0x10D0
 },
 { code:0x10D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10D1
  ,simpleLowerCaseMapping:0x10D1
  ,simpleTitleCaseMapping:0x10D1
 },
 { code:0x10D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10D2
  ,simpleLowerCaseMapping:0x10D2
  ,simpleTitleCaseMapping:0x10D2
 },
 { code:0x10D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10D3
  ,simpleLowerCaseMapping:0x10D3
  ,simpleTitleCaseMapping:0x10D3
 },
 { code:0x10D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10D4
  ,simpleLowerCaseMapping:0x10D4
  ,simpleTitleCaseMapping:0x10D4
 },
 { code:0x10D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10D5
  ,simpleLowerCaseMapping:0x10D5
  ,simpleTitleCaseMapping:0x10D5
 },
 { code:0x10D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10D6
  ,simpleLowerCaseMapping:0x10D6
  ,simpleTitleCaseMapping:0x10D6
 },
 { code:0x10D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10D7
  ,simpleLowerCaseMapping:0x10D7
  ,simpleTitleCaseMapping:0x10D7
 },
 { code:0x10D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10D8
  ,simpleLowerCaseMapping:0x10D8
  ,simpleTitleCaseMapping:0x10D8
 },
 { code:0x10D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10D9
  ,simpleLowerCaseMapping:0x10D9
  ,simpleTitleCaseMapping:0x10D9
 },
 { code:0x10DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10DA
  ,simpleLowerCaseMapping:0x10DA
  ,simpleTitleCaseMapping:0x10DA
 },
 { code:0x10DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10DB
  ,simpleLowerCaseMapping:0x10DB
  ,simpleTitleCaseMapping:0x10DB
 },
 { code:0x10DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10DC
  ,simpleLowerCaseMapping:0x10DC
  ,simpleTitleCaseMapping:0x10DC
 },
 { code:0x10DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10DD
  ,simpleLowerCaseMapping:0x10DD
  ,simpleTitleCaseMapping:0x10DD
 },
 { code:0x10DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10DE
  ,simpleLowerCaseMapping:0x10DE
  ,simpleTitleCaseMapping:0x10DE
 },
 { code:0x10DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10DF
  ,simpleLowerCaseMapping:0x10DF
  ,simpleTitleCaseMapping:0x10DF
 },
 { code:0x10E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10E0
  ,simpleLowerCaseMapping:0x10E0
  ,simpleTitleCaseMapping:0x10E0
 },
 { code:0x10E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10E1
  ,simpleLowerCaseMapping:0x10E1
  ,simpleTitleCaseMapping:0x10E1
 },
 { code:0x10E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10E2
  ,simpleLowerCaseMapping:0x10E2
  ,simpleTitleCaseMapping:0x10E2
 },
 { code:0x10E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10E3
  ,simpleLowerCaseMapping:0x10E3
  ,simpleTitleCaseMapping:0x10E3
 },
 { code:0x10E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10E4
  ,simpleLowerCaseMapping:0x10E4
  ,simpleTitleCaseMapping:0x10E4
 },
 { code:0x10E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10E5
  ,simpleLowerCaseMapping:0x10E5
  ,simpleTitleCaseMapping:0x10E5
 },
 { code:0x10E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10E6
  ,simpleLowerCaseMapping:0x10E6
  ,simpleTitleCaseMapping:0x10E6
 },
 { code:0x10E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10E7
  ,simpleLowerCaseMapping:0x10E7
  ,simpleTitleCaseMapping:0x10E7
 },
 { code:0x10E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10E8
  ,simpleLowerCaseMapping:0x10E8
  ,simpleTitleCaseMapping:0x10E8
 },
 { code:0x10E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10E9
  ,simpleLowerCaseMapping:0x10E9
  ,simpleTitleCaseMapping:0x10E9
 },
 { code:0x10EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10EA
  ,simpleLowerCaseMapping:0x10EA
  ,simpleTitleCaseMapping:0x10EA
 },
 { code:0x10EB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10EB
  ,simpleLowerCaseMapping:0x10EB
  ,simpleTitleCaseMapping:0x10EB
 },
 { code:0x10EC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10EC
  ,simpleLowerCaseMapping:0x10EC
  ,simpleTitleCaseMapping:0x10EC
 },
 { code:0x10ED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10ED
  ,simpleLowerCaseMapping:0x10ED
  ,simpleTitleCaseMapping:0x10ED
 },
 { code:0x10EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10EE
  ,simpleLowerCaseMapping:0x10EE
  ,simpleTitleCaseMapping:0x10EE
 },
 { code:0x10EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10EF
  ,simpleLowerCaseMapping:0x10EF
  ,simpleTitleCaseMapping:0x10EF
 },
 { code:0x10F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10F0
  ,simpleLowerCaseMapping:0x10F0
  ,simpleTitleCaseMapping:0x10F0
 },
 { code:0x10F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10F1
  ,simpleLowerCaseMapping:0x10F1
  ,simpleTitleCaseMapping:0x10F1
 },
 { code:0x10F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10F2
  ,simpleLowerCaseMapping:0x10F2
  ,simpleTitleCaseMapping:0x10F2
 },
 { code:0x10F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10F3
  ,simpleLowerCaseMapping:0x10F3
  ,simpleTitleCaseMapping:0x10F3
 },
 { code:0x10F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10F4
  ,simpleLowerCaseMapping:0x10F4
  ,simpleTitleCaseMapping:0x10F4
 },
 { code:0x10F5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10F5
  ,simpleLowerCaseMapping:0x10F5
  ,simpleTitleCaseMapping:0x10F5
 },
 { code:0x10F6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10F6
  ,simpleLowerCaseMapping:0x10F6
  ,simpleTitleCaseMapping:0x10F6
 },
 { code:0x10F7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10F7
  ,simpleLowerCaseMapping:0x10F7
  ,simpleTitleCaseMapping:0x10F7
 },
 { code:0x10F8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10F8
  ,simpleLowerCaseMapping:0x10F8
  ,simpleTitleCaseMapping:0x10F8
 },
 { code:0x10F9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10F9
  ,simpleLowerCaseMapping:0x10F9
  ,simpleTitleCaseMapping:0x10F9
 },
 { code:0x10FA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10FA
  ,simpleLowerCaseMapping:0x10FA
  ,simpleTitleCaseMapping:0x10FA
 },
 { code:0x10FB
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x10FB
  ,simpleLowerCaseMapping:0x10FB
  ,simpleTitleCaseMapping:0x10FB
 },
 { code:0x10FC
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x10FC
  ,simpleLowerCaseMapping:0x10FC
  ,simpleTitleCaseMapping:0x10FC
 },
 { code:0x1100
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1100
  ,simpleLowerCaseMapping:0x1100
  ,simpleTitleCaseMapping:0x1100
 },
 { code:0x1101
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1101
  ,simpleLowerCaseMapping:0x1101
  ,simpleTitleCaseMapping:0x1101
 },
 { code:0x1102
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1102
  ,simpleLowerCaseMapping:0x1102
  ,simpleTitleCaseMapping:0x1102
 },
 { code:0x1103
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1103
  ,simpleLowerCaseMapping:0x1103
  ,simpleTitleCaseMapping:0x1103
 },
 { code:0x1104
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1104
  ,simpleLowerCaseMapping:0x1104
  ,simpleTitleCaseMapping:0x1104
 },
 { code:0x1105
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1105
  ,simpleLowerCaseMapping:0x1105
  ,simpleTitleCaseMapping:0x1105
 },
 { code:0x1106
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1106
  ,simpleLowerCaseMapping:0x1106
  ,simpleTitleCaseMapping:0x1106
 },
 { code:0x1107
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1107
  ,simpleLowerCaseMapping:0x1107
  ,simpleTitleCaseMapping:0x1107
 },
 { code:0x1108
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1108
  ,simpleLowerCaseMapping:0x1108
  ,simpleTitleCaseMapping:0x1108
 },
 { code:0x1109
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1109
  ,simpleLowerCaseMapping:0x1109
  ,simpleTitleCaseMapping:0x1109
 },
 { code:0x110A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x110A
  ,simpleLowerCaseMapping:0x110A
  ,simpleTitleCaseMapping:0x110A
 },
 { code:0x110B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x110B
  ,simpleLowerCaseMapping:0x110B
  ,simpleTitleCaseMapping:0x110B
 },
 { code:0x110C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x110C
  ,simpleLowerCaseMapping:0x110C
  ,simpleTitleCaseMapping:0x110C
 },
 { code:0x110D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x110D
  ,simpleLowerCaseMapping:0x110D
  ,simpleTitleCaseMapping:0x110D
 },
 { code:0x110E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x110E
  ,simpleLowerCaseMapping:0x110E
  ,simpleTitleCaseMapping:0x110E
 },
 { code:0x110F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x110F
  ,simpleLowerCaseMapping:0x110F
  ,simpleTitleCaseMapping:0x110F
 },
 { code:0x1110
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1110
  ,simpleLowerCaseMapping:0x1110
  ,simpleTitleCaseMapping:0x1110
 },
 { code:0x1111
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1111
  ,simpleLowerCaseMapping:0x1111
  ,simpleTitleCaseMapping:0x1111
 },
 { code:0x1112
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1112
  ,simpleLowerCaseMapping:0x1112
  ,simpleTitleCaseMapping:0x1112
 },
 { code:0x1113
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1113
  ,simpleLowerCaseMapping:0x1113
  ,simpleTitleCaseMapping:0x1113
 },
 { code:0x1114
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1114
  ,simpleLowerCaseMapping:0x1114
  ,simpleTitleCaseMapping:0x1114
 },
 { code:0x1115
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1115
  ,simpleLowerCaseMapping:0x1115
  ,simpleTitleCaseMapping:0x1115
 },
 { code:0x1116
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1116
  ,simpleLowerCaseMapping:0x1116
  ,simpleTitleCaseMapping:0x1116
 },
 { code:0x1117
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1117
  ,simpleLowerCaseMapping:0x1117
  ,simpleTitleCaseMapping:0x1117
 },
 { code:0x1118
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1118
  ,simpleLowerCaseMapping:0x1118
  ,simpleTitleCaseMapping:0x1118
 },
 { code:0x1119
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1119
  ,simpleLowerCaseMapping:0x1119
  ,simpleTitleCaseMapping:0x1119
 },
 { code:0x111A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x111A
  ,simpleLowerCaseMapping:0x111A
  ,simpleTitleCaseMapping:0x111A
 },
 { code:0x111B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x111B
  ,simpleLowerCaseMapping:0x111B
  ,simpleTitleCaseMapping:0x111B
 },
 { code:0x111C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x111C
  ,simpleLowerCaseMapping:0x111C
  ,simpleTitleCaseMapping:0x111C
 },
 { code:0x111D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x111D
  ,simpleLowerCaseMapping:0x111D
  ,simpleTitleCaseMapping:0x111D
 },
 { code:0x111E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x111E
  ,simpleLowerCaseMapping:0x111E
  ,simpleTitleCaseMapping:0x111E
 },
 { code:0x111F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x111F
  ,simpleLowerCaseMapping:0x111F
  ,simpleTitleCaseMapping:0x111F
 },
 { code:0x1120
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1120
  ,simpleLowerCaseMapping:0x1120
  ,simpleTitleCaseMapping:0x1120
 },
 { code:0x1121
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1121
  ,simpleLowerCaseMapping:0x1121
  ,simpleTitleCaseMapping:0x1121
 },
 { code:0x1122
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1122
  ,simpleLowerCaseMapping:0x1122
  ,simpleTitleCaseMapping:0x1122
 },
 { code:0x1123
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1123
  ,simpleLowerCaseMapping:0x1123
  ,simpleTitleCaseMapping:0x1123
 },
 { code:0x1124
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1124
  ,simpleLowerCaseMapping:0x1124
  ,simpleTitleCaseMapping:0x1124
 },
 { code:0x1125
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1125
  ,simpleLowerCaseMapping:0x1125
  ,simpleTitleCaseMapping:0x1125
 },
 { code:0x1126
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1126
  ,simpleLowerCaseMapping:0x1126
  ,simpleTitleCaseMapping:0x1126
 },
 { code:0x1127
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1127
  ,simpleLowerCaseMapping:0x1127
  ,simpleTitleCaseMapping:0x1127
 },
 { code:0x1128
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1128
  ,simpleLowerCaseMapping:0x1128
  ,simpleTitleCaseMapping:0x1128
 },
 { code:0x1129
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1129
  ,simpleLowerCaseMapping:0x1129
  ,simpleTitleCaseMapping:0x1129
 },
 { code:0x112A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x112A
  ,simpleLowerCaseMapping:0x112A
  ,simpleTitleCaseMapping:0x112A
 },
 { code:0x112B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x112B
  ,simpleLowerCaseMapping:0x112B
  ,simpleTitleCaseMapping:0x112B
 },
 { code:0x112C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x112C
  ,simpleLowerCaseMapping:0x112C
  ,simpleTitleCaseMapping:0x112C
 },
 { code:0x112D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x112D
  ,simpleLowerCaseMapping:0x112D
  ,simpleTitleCaseMapping:0x112D
 },
 { code:0x112E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x112E
  ,simpleLowerCaseMapping:0x112E
  ,simpleTitleCaseMapping:0x112E
 },
 { code:0x112F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x112F
  ,simpleLowerCaseMapping:0x112F
  ,simpleTitleCaseMapping:0x112F
 },
 { code:0x1130
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1130
  ,simpleLowerCaseMapping:0x1130
  ,simpleTitleCaseMapping:0x1130
 },
 { code:0x1131
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1131
  ,simpleLowerCaseMapping:0x1131
  ,simpleTitleCaseMapping:0x1131
 },
 { code:0x1132
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1132
  ,simpleLowerCaseMapping:0x1132
  ,simpleTitleCaseMapping:0x1132
 },
 { code:0x1133
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1133
  ,simpleLowerCaseMapping:0x1133
  ,simpleTitleCaseMapping:0x1133
 },
 { code:0x1134
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1134
  ,simpleLowerCaseMapping:0x1134
  ,simpleTitleCaseMapping:0x1134
 },
 { code:0x1135
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1135
  ,simpleLowerCaseMapping:0x1135
  ,simpleTitleCaseMapping:0x1135
 },
 { code:0x1136
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1136
  ,simpleLowerCaseMapping:0x1136
  ,simpleTitleCaseMapping:0x1136
 },
 { code:0x1137
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1137
  ,simpleLowerCaseMapping:0x1137
  ,simpleTitleCaseMapping:0x1137
 },
 { code:0x1138
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1138
  ,simpleLowerCaseMapping:0x1138
  ,simpleTitleCaseMapping:0x1138
 },
 { code:0x1139
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1139
  ,simpleLowerCaseMapping:0x1139
  ,simpleTitleCaseMapping:0x1139
 },
 { code:0x113A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x113A
  ,simpleLowerCaseMapping:0x113A
  ,simpleTitleCaseMapping:0x113A
 },
 { code:0x113B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x113B
  ,simpleLowerCaseMapping:0x113B
  ,simpleTitleCaseMapping:0x113B
 },
 { code:0x113C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x113C
  ,simpleLowerCaseMapping:0x113C
  ,simpleTitleCaseMapping:0x113C
 },
 { code:0x113D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x113D
  ,simpleLowerCaseMapping:0x113D
  ,simpleTitleCaseMapping:0x113D
 },
 { code:0x113E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x113E
  ,simpleLowerCaseMapping:0x113E
  ,simpleTitleCaseMapping:0x113E
 },
 { code:0x113F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x113F
  ,simpleLowerCaseMapping:0x113F
  ,simpleTitleCaseMapping:0x113F
 },
 { code:0x1140
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1140
  ,simpleLowerCaseMapping:0x1140
  ,simpleTitleCaseMapping:0x1140
 },
 { code:0x1141
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1141
  ,simpleLowerCaseMapping:0x1141
  ,simpleTitleCaseMapping:0x1141
 },
 { code:0x1142
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1142
  ,simpleLowerCaseMapping:0x1142
  ,simpleTitleCaseMapping:0x1142
 },
 { code:0x1143
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1143
  ,simpleLowerCaseMapping:0x1143
  ,simpleTitleCaseMapping:0x1143
 },
 { code:0x1144
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1144
  ,simpleLowerCaseMapping:0x1144
  ,simpleTitleCaseMapping:0x1144
 },
 { code:0x1145
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1145
  ,simpleLowerCaseMapping:0x1145
  ,simpleTitleCaseMapping:0x1145
 },
 { code:0x1146
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1146
  ,simpleLowerCaseMapping:0x1146
  ,simpleTitleCaseMapping:0x1146
 },
 { code:0x1147
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1147
  ,simpleLowerCaseMapping:0x1147
  ,simpleTitleCaseMapping:0x1147
 },
 { code:0x1148
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1148
  ,simpleLowerCaseMapping:0x1148
  ,simpleTitleCaseMapping:0x1148
 },
 { code:0x1149
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1149
  ,simpleLowerCaseMapping:0x1149
  ,simpleTitleCaseMapping:0x1149
 },
 { code:0x114A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x114A
  ,simpleLowerCaseMapping:0x114A
  ,simpleTitleCaseMapping:0x114A
 },
 { code:0x114B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x114B
  ,simpleLowerCaseMapping:0x114B
  ,simpleTitleCaseMapping:0x114B
 },
 { code:0x114C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x114C
  ,simpleLowerCaseMapping:0x114C
  ,simpleTitleCaseMapping:0x114C
 },
 { code:0x114D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x114D
  ,simpleLowerCaseMapping:0x114D
  ,simpleTitleCaseMapping:0x114D
 },
 { code:0x114E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x114E
  ,simpleLowerCaseMapping:0x114E
  ,simpleTitleCaseMapping:0x114E
 },
 { code:0x114F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x114F
  ,simpleLowerCaseMapping:0x114F
  ,simpleTitleCaseMapping:0x114F
 },
 { code:0x1150
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1150
  ,simpleLowerCaseMapping:0x1150
  ,simpleTitleCaseMapping:0x1150
 },
 { code:0x1151
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1151
  ,simpleLowerCaseMapping:0x1151
  ,simpleTitleCaseMapping:0x1151
 },
 { code:0x1152
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1152
  ,simpleLowerCaseMapping:0x1152
  ,simpleTitleCaseMapping:0x1152
 },
 { code:0x1153
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1153
  ,simpleLowerCaseMapping:0x1153
  ,simpleTitleCaseMapping:0x1153
 },
 { code:0x1154
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1154
  ,simpleLowerCaseMapping:0x1154
  ,simpleTitleCaseMapping:0x1154
 },
 { code:0x1155
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1155
  ,simpleLowerCaseMapping:0x1155
  ,simpleTitleCaseMapping:0x1155
 },
 { code:0x1156
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1156
  ,simpleLowerCaseMapping:0x1156
  ,simpleTitleCaseMapping:0x1156
 },
 { code:0x1157
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1157
  ,simpleLowerCaseMapping:0x1157
  ,simpleTitleCaseMapping:0x1157
 },
 { code:0x1158
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1158
  ,simpleLowerCaseMapping:0x1158
  ,simpleTitleCaseMapping:0x1158
 },
 { code:0x1159
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1159
  ,simpleLowerCaseMapping:0x1159
  ,simpleTitleCaseMapping:0x1159
 },
 { code:0x115F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x115F
  ,simpleLowerCaseMapping:0x115F
  ,simpleTitleCaseMapping:0x115F
 },
 { code:0x1160
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1160
  ,simpleLowerCaseMapping:0x1160
  ,simpleTitleCaseMapping:0x1160
 },
 { code:0x1161
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1161
  ,simpleLowerCaseMapping:0x1161
  ,simpleTitleCaseMapping:0x1161
 },
 { code:0x1162
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1162
  ,simpleLowerCaseMapping:0x1162
  ,simpleTitleCaseMapping:0x1162
 },
 { code:0x1163
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1163
  ,simpleLowerCaseMapping:0x1163
  ,simpleTitleCaseMapping:0x1163
 },
 { code:0x1164
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1164
  ,simpleLowerCaseMapping:0x1164
  ,simpleTitleCaseMapping:0x1164
 },
 { code:0x1165
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1165
  ,simpleLowerCaseMapping:0x1165
  ,simpleTitleCaseMapping:0x1165
 },
 { code:0x1166
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1166
  ,simpleLowerCaseMapping:0x1166
  ,simpleTitleCaseMapping:0x1166
 },
 { code:0x1167
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1167
  ,simpleLowerCaseMapping:0x1167
  ,simpleTitleCaseMapping:0x1167
 },
 { code:0x1168
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1168
  ,simpleLowerCaseMapping:0x1168
  ,simpleTitleCaseMapping:0x1168
 },
 { code:0x1169
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1169
  ,simpleLowerCaseMapping:0x1169
  ,simpleTitleCaseMapping:0x1169
 },
 { code:0x116A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x116A
  ,simpleLowerCaseMapping:0x116A
  ,simpleTitleCaseMapping:0x116A
 },
 { code:0x116B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x116B
  ,simpleLowerCaseMapping:0x116B
  ,simpleTitleCaseMapping:0x116B
 },
 { code:0x116C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x116C
  ,simpleLowerCaseMapping:0x116C
  ,simpleTitleCaseMapping:0x116C
 },
 { code:0x116D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x116D
  ,simpleLowerCaseMapping:0x116D
  ,simpleTitleCaseMapping:0x116D
 },
 { code:0x116E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x116E
  ,simpleLowerCaseMapping:0x116E
  ,simpleTitleCaseMapping:0x116E
 },
 { code:0x116F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x116F
  ,simpleLowerCaseMapping:0x116F
  ,simpleTitleCaseMapping:0x116F
 },
 { code:0x1170
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1170
  ,simpleLowerCaseMapping:0x1170
  ,simpleTitleCaseMapping:0x1170
 },
 { code:0x1171
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1171
  ,simpleLowerCaseMapping:0x1171
  ,simpleTitleCaseMapping:0x1171
 },
 { code:0x1172
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1172
  ,simpleLowerCaseMapping:0x1172
  ,simpleTitleCaseMapping:0x1172
 },
 { code:0x1173
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1173
  ,simpleLowerCaseMapping:0x1173
  ,simpleTitleCaseMapping:0x1173
 },
 { code:0x1174
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1174
  ,simpleLowerCaseMapping:0x1174
  ,simpleTitleCaseMapping:0x1174
 },
 { code:0x1175
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1175
  ,simpleLowerCaseMapping:0x1175
  ,simpleTitleCaseMapping:0x1175
 },
 { code:0x1176
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1176
  ,simpleLowerCaseMapping:0x1176
  ,simpleTitleCaseMapping:0x1176
 },
 { code:0x1177
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1177
  ,simpleLowerCaseMapping:0x1177
  ,simpleTitleCaseMapping:0x1177
 },
 { code:0x1178
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1178
  ,simpleLowerCaseMapping:0x1178
  ,simpleTitleCaseMapping:0x1178
 },
 { code:0x1179
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1179
  ,simpleLowerCaseMapping:0x1179
  ,simpleTitleCaseMapping:0x1179
 },
 { code:0x117A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x117A
  ,simpleLowerCaseMapping:0x117A
  ,simpleTitleCaseMapping:0x117A
 },
 { code:0x117B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x117B
  ,simpleLowerCaseMapping:0x117B
  ,simpleTitleCaseMapping:0x117B
 },
 { code:0x117C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x117C
  ,simpleLowerCaseMapping:0x117C
  ,simpleTitleCaseMapping:0x117C
 },
 { code:0x117D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x117D
  ,simpleLowerCaseMapping:0x117D
  ,simpleTitleCaseMapping:0x117D
 },
 { code:0x117E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x117E
  ,simpleLowerCaseMapping:0x117E
  ,simpleTitleCaseMapping:0x117E
 },
 { code:0x117F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x117F
  ,simpleLowerCaseMapping:0x117F
  ,simpleTitleCaseMapping:0x117F
 },
 { code:0x1180
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1180
  ,simpleLowerCaseMapping:0x1180
  ,simpleTitleCaseMapping:0x1180
 },
 { code:0x1181
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1181
  ,simpleLowerCaseMapping:0x1181
  ,simpleTitleCaseMapping:0x1181
 },
 { code:0x1182
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1182
  ,simpleLowerCaseMapping:0x1182
  ,simpleTitleCaseMapping:0x1182
 },
 { code:0x1183
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1183
  ,simpleLowerCaseMapping:0x1183
  ,simpleTitleCaseMapping:0x1183
 },
 { code:0x1184
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1184
  ,simpleLowerCaseMapping:0x1184
  ,simpleTitleCaseMapping:0x1184
 },
 { code:0x1185
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1185
  ,simpleLowerCaseMapping:0x1185
  ,simpleTitleCaseMapping:0x1185
 },
 { code:0x1186
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1186
  ,simpleLowerCaseMapping:0x1186
  ,simpleTitleCaseMapping:0x1186
 },
 { code:0x1187
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1187
  ,simpleLowerCaseMapping:0x1187
  ,simpleTitleCaseMapping:0x1187
 },
 { code:0x1188
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1188
  ,simpleLowerCaseMapping:0x1188
  ,simpleTitleCaseMapping:0x1188
 },
 { code:0x1189
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1189
  ,simpleLowerCaseMapping:0x1189
  ,simpleTitleCaseMapping:0x1189
 },
 { code:0x118A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x118A
  ,simpleLowerCaseMapping:0x118A
  ,simpleTitleCaseMapping:0x118A
 },
 { code:0x118B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x118B
  ,simpleLowerCaseMapping:0x118B
  ,simpleTitleCaseMapping:0x118B
 },
 { code:0x118C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x118C
  ,simpleLowerCaseMapping:0x118C
  ,simpleTitleCaseMapping:0x118C
 },
 { code:0x118D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x118D
  ,simpleLowerCaseMapping:0x118D
  ,simpleTitleCaseMapping:0x118D
 },
 { code:0x118E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x118E
  ,simpleLowerCaseMapping:0x118E
  ,simpleTitleCaseMapping:0x118E
 },
 { code:0x118F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x118F
  ,simpleLowerCaseMapping:0x118F
  ,simpleTitleCaseMapping:0x118F
 },
 { code:0x1190
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1190
  ,simpleLowerCaseMapping:0x1190
  ,simpleTitleCaseMapping:0x1190
 },
 { code:0x1191
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1191
  ,simpleLowerCaseMapping:0x1191
  ,simpleTitleCaseMapping:0x1191
 },
 { code:0x1192
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1192
  ,simpleLowerCaseMapping:0x1192
  ,simpleTitleCaseMapping:0x1192
 },
 { code:0x1193
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1193
  ,simpleLowerCaseMapping:0x1193
  ,simpleTitleCaseMapping:0x1193
 },
 { code:0x1194
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1194
  ,simpleLowerCaseMapping:0x1194
  ,simpleTitleCaseMapping:0x1194
 },
 { code:0x1195
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1195
  ,simpleLowerCaseMapping:0x1195
  ,simpleTitleCaseMapping:0x1195
 },
 { code:0x1196
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1196
  ,simpleLowerCaseMapping:0x1196
  ,simpleTitleCaseMapping:0x1196
 },
 { code:0x1197
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1197
  ,simpleLowerCaseMapping:0x1197
  ,simpleTitleCaseMapping:0x1197
 },
 { code:0x1198
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1198
  ,simpleLowerCaseMapping:0x1198
  ,simpleTitleCaseMapping:0x1198
 },
 { code:0x1199
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1199
  ,simpleLowerCaseMapping:0x1199
  ,simpleTitleCaseMapping:0x1199
 },
 { code:0x119A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x119A
  ,simpleLowerCaseMapping:0x119A
  ,simpleTitleCaseMapping:0x119A
 },
 { code:0x119B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x119B
  ,simpleLowerCaseMapping:0x119B
  ,simpleTitleCaseMapping:0x119B
 },
 { code:0x119C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x119C
  ,simpleLowerCaseMapping:0x119C
  ,simpleTitleCaseMapping:0x119C
 },
 { code:0x119D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x119D
  ,simpleLowerCaseMapping:0x119D
  ,simpleTitleCaseMapping:0x119D
 },
 { code:0x119E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x119E
  ,simpleLowerCaseMapping:0x119E
  ,simpleTitleCaseMapping:0x119E
 },
 { code:0x119F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x119F
  ,simpleLowerCaseMapping:0x119F
  ,simpleTitleCaseMapping:0x119F
 },
 { code:0x11A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11A0
  ,simpleLowerCaseMapping:0x11A0
  ,simpleTitleCaseMapping:0x11A0
 },
 { code:0x11A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11A1
  ,simpleLowerCaseMapping:0x11A1
  ,simpleTitleCaseMapping:0x11A1
 },
 { code:0x11A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11A2
  ,simpleLowerCaseMapping:0x11A2
  ,simpleTitleCaseMapping:0x11A2
 },
 { code:0x11A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11A8
  ,simpleLowerCaseMapping:0x11A8
  ,simpleTitleCaseMapping:0x11A8
 },
 { code:0x11A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11A9
  ,simpleLowerCaseMapping:0x11A9
  ,simpleTitleCaseMapping:0x11A9
 },
 { code:0x11AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11AA
  ,simpleLowerCaseMapping:0x11AA
  ,simpleTitleCaseMapping:0x11AA
 },
 { code:0x11AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11AB
  ,simpleLowerCaseMapping:0x11AB
  ,simpleTitleCaseMapping:0x11AB
 },
 { code:0x11AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11AC
  ,simpleLowerCaseMapping:0x11AC
  ,simpleTitleCaseMapping:0x11AC
 },
 { code:0x11AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11AD
  ,simpleLowerCaseMapping:0x11AD
  ,simpleTitleCaseMapping:0x11AD
 },
 { code:0x11AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11AE
  ,simpleLowerCaseMapping:0x11AE
  ,simpleTitleCaseMapping:0x11AE
 },
 { code:0x11AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11AF
  ,simpleLowerCaseMapping:0x11AF
  ,simpleTitleCaseMapping:0x11AF
 },
 { code:0x11B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11B0
  ,simpleLowerCaseMapping:0x11B0
  ,simpleTitleCaseMapping:0x11B0
 },
 { code:0x11B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11B1
  ,simpleLowerCaseMapping:0x11B1
  ,simpleTitleCaseMapping:0x11B1
 },
 { code:0x11B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11B2
  ,simpleLowerCaseMapping:0x11B2
  ,simpleTitleCaseMapping:0x11B2
 },
 { code:0x11B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11B3
  ,simpleLowerCaseMapping:0x11B3
  ,simpleTitleCaseMapping:0x11B3
 },
 { code:0x11B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11B4
  ,simpleLowerCaseMapping:0x11B4
  ,simpleTitleCaseMapping:0x11B4
 },
 { code:0x11B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11B5
  ,simpleLowerCaseMapping:0x11B5
  ,simpleTitleCaseMapping:0x11B5
 },
 { code:0x11B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11B6
  ,simpleLowerCaseMapping:0x11B6
  ,simpleTitleCaseMapping:0x11B6
 },
 { code:0x11B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11B7
  ,simpleLowerCaseMapping:0x11B7
  ,simpleTitleCaseMapping:0x11B7
 },
 { code:0x11B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11B8
  ,simpleLowerCaseMapping:0x11B8
  ,simpleTitleCaseMapping:0x11B8
 },
 { code:0x11B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11B9
  ,simpleLowerCaseMapping:0x11B9
  ,simpleTitleCaseMapping:0x11B9
 },
 { code:0x11BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11BA
  ,simpleLowerCaseMapping:0x11BA
  ,simpleTitleCaseMapping:0x11BA
 },
 { code:0x11BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11BB
  ,simpleLowerCaseMapping:0x11BB
  ,simpleTitleCaseMapping:0x11BB
 },
 { code:0x11BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11BC
  ,simpleLowerCaseMapping:0x11BC
  ,simpleTitleCaseMapping:0x11BC
 },
 { code:0x11BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11BD
  ,simpleLowerCaseMapping:0x11BD
  ,simpleTitleCaseMapping:0x11BD
 },
 { code:0x11BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11BE
  ,simpleLowerCaseMapping:0x11BE
  ,simpleTitleCaseMapping:0x11BE
 },
 { code:0x11BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11BF
  ,simpleLowerCaseMapping:0x11BF
  ,simpleTitleCaseMapping:0x11BF
 },
 { code:0x11C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11C0
  ,simpleLowerCaseMapping:0x11C0
  ,simpleTitleCaseMapping:0x11C0
 },
 { code:0x11C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11C1
  ,simpleLowerCaseMapping:0x11C1
  ,simpleTitleCaseMapping:0x11C1
 },
 { code:0x11C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11C2
  ,simpleLowerCaseMapping:0x11C2
  ,simpleTitleCaseMapping:0x11C2
 },
 { code:0x11C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11C3
  ,simpleLowerCaseMapping:0x11C3
  ,simpleTitleCaseMapping:0x11C3
 },
 { code:0x11C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11C4
  ,simpleLowerCaseMapping:0x11C4
  ,simpleTitleCaseMapping:0x11C4
 },
 { code:0x11C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11C5
  ,simpleLowerCaseMapping:0x11C5
  ,simpleTitleCaseMapping:0x11C5
 },
 { code:0x11C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11C6
  ,simpleLowerCaseMapping:0x11C6
  ,simpleTitleCaseMapping:0x11C6
 },
 { code:0x11C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11C7
  ,simpleLowerCaseMapping:0x11C7
  ,simpleTitleCaseMapping:0x11C7
 },
 { code:0x11C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11C8
  ,simpleLowerCaseMapping:0x11C8
  ,simpleTitleCaseMapping:0x11C8
 },
 { code:0x11C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11C9
  ,simpleLowerCaseMapping:0x11C9
  ,simpleTitleCaseMapping:0x11C9
 },
 { code:0x11CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11CA
  ,simpleLowerCaseMapping:0x11CA
  ,simpleTitleCaseMapping:0x11CA
 },
 { code:0x11CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11CB
  ,simpleLowerCaseMapping:0x11CB
  ,simpleTitleCaseMapping:0x11CB
 },
 { code:0x11CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11CC
  ,simpleLowerCaseMapping:0x11CC
  ,simpleTitleCaseMapping:0x11CC
 },
 { code:0x11CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11CD
  ,simpleLowerCaseMapping:0x11CD
  ,simpleTitleCaseMapping:0x11CD
 },
 { code:0x11CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11CE
  ,simpleLowerCaseMapping:0x11CE
  ,simpleTitleCaseMapping:0x11CE
 },
 { code:0x11CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11CF
  ,simpleLowerCaseMapping:0x11CF
  ,simpleTitleCaseMapping:0x11CF
 },
 { code:0x11D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11D0
  ,simpleLowerCaseMapping:0x11D0
  ,simpleTitleCaseMapping:0x11D0
 },
 { code:0x11D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11D1
  ,simpleLowerCaseMapping:0x11D1
  ,simpleTitleCaseMapping:0x11D1
 },
 { code:0x11D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11D2
  ,simpleLowerCaseMapping:0x11D2
  ,simpleTitleCaseMapping:0x11D2
 },
 { code:0x11D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11D3
  ,simpleLowerCaseMapping:0x11D3
  ,simpleTitleCaseMapping:0x11D3
 },
 { code:0x11D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11D4
  ,simpleLowerCaseMapping:0x11D4
  ,simpleTitleCaseMapping:0x11D4
 },
 { code:0x11D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11D5
  ,simpleLowerCaseMapping:0x11D5
  ,simpleTitleCaseMapping:0x11D5
 },
 { code:0x11D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11D6
  ,simpleLowerCaseMapping:0x11D6
  ,simpleTitleCaseMapping:0x11D6
 },
 { code:0x11D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11D7
  ,simpleLowerCaseMapping:0x11D7
  ,simpleTitleCaseMapping:0x11D7
 },
 { code:0x11D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11D8
  ,simpleLowerCaseMapping:0x11D8
  ,simpleTitleCaseMapping:0x11D8
 },
 { code:0x11D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11D9
  ,simpleLowerCaseMapping:0x11D9
  ,simpleTitleCaseMapping:0x11D9
 },
 { code:0x11DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11DA
  ,simpleLowerCaseMapping:0x11DA
  ,simpleTitleCaseMapping:0x11DA
 },
 { code:0x11DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11DB
  ,simpleLowerCaseMapping:0x11DB
  ,simpleTitleCaseMapping:0x11DB
 },
 { code:0x11DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11DC
  ,simpleLowerCaseMapping:0x11DC
  ,simpleTitleCaseMapping:0x11DC
 },
 { code:0x11DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11DD
  ,simpleLowerCaseMapping:0x11DD
  ,simpleTitleCaseMapping:0x11DD
 },
 { code:0x11DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11DE
  ,simpleLowerCaseMapping:0x11DE
  ,simpleTitleCaseMapping:0x11DE
 },
 { code:0x11DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11DF
  ,simpleLowerCaseMapping:0x11DF
  ,simpleTitleCaseMapping:0x11DF
 },
 { code:0x11E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11E0
  ,simpleLowerCaseMapping:0x11E0
  ,simpleTitleCaseMapping:0x11E0
 },
 { code:0x11E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11E1
  ,simpleLowerCaseMapping:0x11E1
  ,simpleTitleCaseMapping:0x11E1
 },
 { code:0x11E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11E2
  ,simpleLowerCaseMapping:0x11E2
  ,simpleTitleCaseMapping:0x11E2
 },
 { code:0x11E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11E3
  ,simpleLowerCaseMapping:0x11E3
  ,simpleTitleCaseMapping:0x11E3
 },
 { code:0x11E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11E4
  ,simpleLowerCaseMapping:0x11E4
  ,simpleTitleCaseMapping:0x11E4
 },
 { code:0x11E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11E5
  ,simpleLowerCaseMapping:0x11E5
  ,simpleTitleCaseMapping:0x11E5
 },
 { code:0x11E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11E6
  ,simpleLowerCaseMapping:0x11E6
  ,simpleTitleCaseMapping:0x11E6
 },
 { code:0x11E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11E7
  ,simpleLowerCaseMapping:0x11E7
  ,simpleTitleCaseMapping:0x11E7
 },
 { code:0x11E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11E8
  ,simpleLowerCaseMapping:0x11E8
  ,simpleTitleCaseMapping:0x11E8
 },
 { code:0x11E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11E9
  ,simpleLowerCaseMapping:0x11E9
  ,simpleTitleCaseMapping:0x11E9
 },
 { code:0x11EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11EA
  ,simpleLowerCaseMapping:0x11EA
  ,simpleTitleCaseMapping:0x11EA
 },
 { code:0x11EB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11EB
  ,simpleLowerCaseMapping:0x11EB
  ,simpleTitleCaseMapping:0x11EB
 },
 { code:0x11EC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11EC
  ,simpleLowerCaseMapping:0x11EC
  ,simpleTitleCaseMapping:0x11EC
 },
 { code:0x11ED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11ED
  ,simpleLowerCaseMapping:0x11ED
  ,simpleTitleCaseMapping:0x11ED
 },
 { code:0x11EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11EE
  ,simpleLowerCaseMapping:0x11EE
  ,simpleTitleCaseMapping:0x11EE
 },
 { code:0x11EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11EF
  ,simpleLowerCaseMapping:0x11EF
  ,simpleTitleCaseMapping:0x11EF
 },
 { code:0x11F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11F0
  ,simpleLowerCaseMapping:0x11F0
  ,simpleTitleCaseMapping:0x11F0
 },
 { code:0x11F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11F1
  ,simpleLowerCaseMapping:0x11F1
  ,simpleTitleCaseMapping:0x11F1
 },
 { code:0x11F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11F2
  ,simpleLowerCaseMapping:0x11F2
  ,simpleTitleCaseMapping:0x11F2
 },
 { code:0x11F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11F3
  ,simpleLowerCaseMapping:0x11F3
  ,simpleTitleCaseMapping:0x11F3
 },
 { code:0x11F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11F4
  ,simpleLowerCaseMapping:0x11F4
  ,simpleTitleCaseMapping:0x11F4
 },
 { code:0x11F5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11F5
  ,simpleLowerCaseMapping:0x11F5
  ,simpleTitleCaseMapping:0x11F5
 },
 { code:0x11F6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11F6
  ,simpleLowerCaseMapping:0x11F6
  ,simpleTitleCaseMapping:0x11F6
 },
 { code:0x11F7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11F7
  ,simpleLowerCaseMapping:0x11F7
  ,simpleTitleCaseMapping:0x11F7
 },
 { code:0x11F8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11F8
  ,simpleLowerCaseMapping:0x11F8
  ,simpleTitleCaseMapping:0x11F8
 },
 { code:0x11F9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x11F9
  ,simpleLowerCaseMapping:0x11F9
  ,simpleTitleCaseMapping:0x11F9
 },
 { code:0x1200
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1200
  ,simpleLowerCaseMapping:0x1200
  ,simpleTitleCaseMapping:0x1200
 },
 { code:0x1201
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1201
  ,simpleLowerCaseMapping:0x1201
  ,simpleTitleCaseMapping:0x1201
 },
 { code:0x1202
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1202
  ,simpleLowerCaseMapping:0x1202
  ,simpleTitleCaseMapping:0x1202
 },
 { code:0x1203
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1203
  ,simpleLowerCaseMapping:0x1203
  ,simpleTitleCaseMapping:0x1203
 },
 { code:0x1204
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1204
  ,simpleLowerCaseMapping:0x1204
  ,simpleTitleCaseMapping:0x1204
 },
 { code:0x1205
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1205
  ,simpleLowerCaseMapping:0x1205
  ,simpleTitleCaseMapping:0x1205
 },
 { code:0x1206
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1206
  ,simpleLowerCaseMapping:0x1206
  ,simpleTitleCaseMapping:0x1206
 },
 { code:0x1207
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1207
  ,simpleLowerCaseMapping:0x1207
  ,simpleTitleCaseMapping:0x1207
 },
 { code:0x1208
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1208
  ,simpleLowerCaseMapping:0x1208
  ,simpleTitleCaseMapping:0x1208
 },
 { code:0x1209
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1209
  ,simpleLowerCaseMapping:0x1209
  ,simpleTitleCaseMapping:0x1209
 },
 { code:0x120A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120A
  ,simpleLowerCaseMapping:0x120A
  ,simpleTitleCaseMapping:0x120A
 },
 { code:0x120B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120B
  ,simpleLowerCaseMapping:0x120B
  ,simpleTitleCaseMapping:0x120B
 },
 { code:0x120C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120C
  ,simpleLowerCaseMapping:0x120C
  ,simpleTitleCaseMapping:0x120C
 },
 { code:0x120D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120D
  ,simpleLowerCaseMapping:0x120D
  ,simpleTitleCaseMapping:0x120D
 },
 { code:0x120E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120E
  ,simpleLowerCaseMapping:0x120E
  ,simpleTitleCaseMapping:0x120E
 },
 { code:0x120F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120F
  ,simpleLowerCaseMapping:0x120F
  ,simpleTitleCaseMapping:0x120F
 },
 { code:0x1210
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1210
  ,simpleLowerCaseMapping:0x1210
  ,simpleTitleCaseMapping:0x1210
 },
 { code:0x1211
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1211
  ,simpleLowerCaseMapping:0x1211
  ,simpleTitleCaseMapping:0x1211
 },
 { code:0x1212
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1212
  ,simpleLowerCaseMapping:0x1212
  ,simpleTitleCaseMapping:0x1212
 },
 { code:0x1213
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1213
  ,simpleLowerCaseMapping:0x1213
  ,simpleTitleCaseMapping:0x1213
 },
 { code:0x1214
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1214
  ,simpleLowerCaseMapping:0x1214
  ,simpleTitleCaseMapping:0x1214
 },
 { code:0x1215
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1215
  ,simpleLowerCaseMapping:0x1215
  ,simpleTitleCaseMapping:0x1215
 },
 { code:0x1216
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1216
  ,simpleLowerCaseMapping:0x1216
  ,simpleTitleCaseMapping:0x1216
 },
 { code:0x1217
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1217
  ,simpleLowerCaseMapping:0x1217
  ,simpleTitleCaseMapping:0x1217
 },
 { code:0x1218
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1218
  ,simpleLowerCaseMapping:0x1218
  ,simpleTitleCaseMapping:0x1218
 },
 { code:0x1219
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1219
  ,simpleLowerCaseMapping:0x1219
  ,simpleTitleCaseMapping:0x1219
 },
 { code:0x121A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121A
  ,simpleLowerCaseMapping:0x121A
  ,simpleTitleCaseMapping:0x121A
 },
 { code:0x121B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121B
  ,simpleLowerCaseMapping:0x121B
  ,simpleTitleCaseMapping:0x121B
 },
 { code:0x121C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121C
  ,simpleLowerCaseMapping:0x121C
  ,simpleTitleCaseMapping:0x121C
 },
 { code:0x121D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121D
  ,simpleLowerCaseMapping:0x121D
  ,simpleTitleCaseMapping:0x121D
 },
 { code:0x121E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121E
  ,simpleLowerCaseMapping:0x121E
  ,simpleTitleCaseMapping:0x121E
 },
 { code:0x121F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121F
  ,simpleLowerCaseMapping:0x121F
  ,simpleTitleCaseMapping:0x121F
 },
 { code:0x1220
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1220
  ,simpleLowerCaseMapping:0x1220
  ,simpleTitleCaseMapping:0x1220
 },
 { code:0x1221
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1221
  ,simpleLowerCaseMapping:0x1221
  ,simpleTitleCaseMapping:0x1221
 },
 { code:0x1222
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1222
  ,simpleLowerCaseMapping:0x1222
  ,simpleTitleCaseMapping:0x1222
 },
 { code:0x1223
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1223
  ,simpleLowerCaseMapping:0x1223
  ,simpleTitleCaseMapping:0x1223
 },
 { code:0x1224
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1224
  ,simpleLowerCaseMapping:0x1224
  ,simpleTitleCaseMapping:0x1224
 },
 { code:0x1225
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1225
  ,simpleLowerCaseMapping:0x1225
  ,simpleTitleCaseMapping:0x1225
 },
 { code:0x1226
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1226
  ,simpleLowerCaseMapping:0x1226
  ,simpleTitleCaseMapping:0x1226
 },
 { code:0x1227
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1227
  ,simpleLowerCaseMapping:0x1227
  ,simpleTitleCaseMapping:0x1227
 },
 { code:0x1228
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1228
  ,simpleLowerCaseMapping:0x1228
  ,simpleTitleCaseMapping:0x1228
 },
 { code:0x1229
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1229
  ,simpleLowerCaseMapping:0x1229
  ,simpleTitleCaseMapping:0x1229
 },
 { code:0x122A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122A
  ,simpleLowerCaseMapping:0x122A
  ,simpleTitleCaseMapping:0x122A
 },
 { code:0x122B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122B
  ,simpleLowerCaseMapping:0x122B
  ,simpleTitleCaseMapping:0x122B
 },
 { code:0x122C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122C
  ,simpleLowerCaseMapping:0x122C
  ,simpleTitleCaseMapping:0x122C
 },
 { code:0x122D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122D
  ,simpleLowerCaseMapping:0x122D
  ,simpleTitleCaseMapping:0x122D
 },
 { code:0x122E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122E
  ,simpleLowerCaseMapping:0x122E
  ,simpleTitleCaseMapping:0x122E
 },
 { code:0x122F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122F
  ,simpleLowerCaseMapping:0x122F
  ,simpleTitleCaseMapping:0x122F
 },
 { code:0x1230
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1230
  ,simpleLowerCaseMapping:0x1230
  ,simpleTitleCaseMapping:0x1230
 },
 { code:0x1231
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1231
  ,simpleLowerCaseMapping:0x1231
  ,simpleTitleCaseMapping:0x1231
 },
 { code:0x1232
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1232
  ,simpleLowerCaseMapping:0x1232
  ,simpleTitleCaseMapping:0x1232
 },
 { code:0x1233
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1233
  ,simpleLowerCaseMapping:0x1233
  ,simpleTitleCaseMapping:0x1233
 },
 { code:0x1234
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1234
  ,simpleLowerCaseMapping:0x1234
  ,simpleTitleCaseMapping:0x1234
 },
 { code:0x1235
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1235
  ,simpleLowerCaseMapping:0x1235
  ,simpleTitleCaseMapping:0x1235
 },
 { code:0x1236
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1236
  ,simpleLowerCaseMapping:0x1236
  ,simpleTitleCaseMapping:0x1236
 },
 { code:0x1237
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1237
  ,simpleLowerCaseMapping:0x1237
  ,simpleTitleCaseMapping:0x1237
 },
 { code:0x1238
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1238
  ,simpleLowerCaseMapping:0x1238
  ,simpleTitleCaseMapping:0x1238
 },
 { code:0x1239
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1239
  ,simpleLowerCaseMapping:0x1239
  ,simpleTitleCaseMapping:0x1239
 },
 { code:0x123A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x123A
  ,simpleLowerCaseMapping:0x123A
  ,simpleTitleCaseMapping:0x123A
 },
 { code:0x123B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x123B
  ,simpleLowerCaseMapping:0x123B
  ,simpleTitleCaseMapping:0x123B
 },
 { code:0x123C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x123C
  ,simpleLowerCaseMapping:0x123C
  ,simpleTitleCaseMapping:0x123C
 },
 { code:0x123D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x123D
  ,simpleLowerCaseMapping:0x123D
  ,simpleTitleCaseMapping:0x123D
 },
 { code:0x123E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x123E
  ,simpleLowerCaseMapping:0x123E
  ,simpleTitleCaseMapping:0x123E
 },
 { code:0x123F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x123F
  ,simpleLowerCaseMapping:0x123F
  ,simpleTitleCaseMapping:0x123F
 },
 { code:0x1240
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1240
  ,simpleLowerCaseMapping:0x1240
  ,simpleTitleCaseMapping:0x1240
 },
 { code:0x1241
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1241
  ,simpleLowerCaseMapping:0x1241
  ,simpleTitleCaseMapping:0x1241
 },
 { code:0x1242
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1242
  ,simpleLowerCaseMapping:0x1242
  ,simpleTitleCaseMapping:0x1242
 },
 { code:0x1243
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1243
  ,simpleLowerCaseMapping:0x1243
  ,simpleTitleCaseMapping:0x1243
 },
 { code:0x1244
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1244
  ,simpleLowerCaseMapping:0x1244
  ,simpleTitleCaseMapping:0x1244
 },
 { code:0x1245
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1245
  ,simpleLowerCaseMapping:0x1245
  ,simpleTitleCaseMapping:0x1245
 },
 { code:0x1246
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1246
  ,simpleLowerCaseMapping:0x1246
  ,simpleTitleCaseMapping:0x1246
 },
 { code:0x1247
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1247
  ,simpleLowerCaseMapping:0x1247
  ,simpleTitleCaseMapping:0x1247
 },
 { code:0x1248
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1248
  ,simpleLowerCaseMapping:0x1248
  ,simpleTitleCaseMapping:0x1248
 },
 { code:0x124A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x124A
  ,simpleLowerCaseMapping:0x124A
  ,simpleTitleCaseMapping:0x124A
 },
 { code:0x124B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x124B
  ,simpleLowerCaseMapping:0x124B
  ,simpleTitleCaseMapping:0x124B
 },
 { code:0x124C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x124C
  ,simpleLowerCaseMapping:0x124C
  ,simpleTitleCaseMapping:0x124C
 },
 { code:0x124D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x124D
  ,simpleLowerCaseMapping:0x124D
  ,simpleTitleCaseMapping:0x124D
 },
 { code:0x1250
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1250
  ,simpleLowerCaseMapping:0x1250
  ,simpleTitleCaseMapping:0x1250
 },
 { code:0x1251
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1251
  ,simpleLowerCaseMapping:0x1251
  ,simpleTitleCaseMapping:0x1251
 },
 { code:0x1252
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1252
  ,simpleLowerCaseMapping:0x1252
  ,simpleTitleCaseMapping:0x1252
 },
 { code:0x1253
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1253
  ,simpleLowerCaseMapping:0x1253
  ,simpleTitleCaseMapping:0x1253
 },
 { code:0x1254
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1254
  ,simpleLowerCaseMapping:0x1254
  ,simpleTitleCaseMapping:0x1254
 },
 { code:0x1255
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1255
  ,simpleLowerCaseMapping:0x1255
  ,simpleTitleCaseMapping:0x1255
 },
 { code:0x1256
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1256
  ,simpleLowerCaseMapping:0x1256
  ,simpleTitleCaseMapping:0x1256
 },
 { code:0x1258
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1258
  ,simpleLowerCaseMapping:0x1258
  ,simpleTitleCaseMapping:0x1258
 },
 { code:0x125A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x125A
  ,simpleLowerCaseMapping:0x125A
  ,simpleTitleCaseMapping:0x125A
 },
 { code:0x125B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x125B
  ,simpleLowerCaseMapping:0x125B
  ,simpleTitleCaseMapping:0x125B
 },
 { code:0x125C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x125C
  ,simpleLowerCaseMapping:0x125C
  ,simpleTitleCaseMapping:0x125C
 },
 { code:0x125D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x125D
  ,simpleLowerCaseMapping:0x125D
  ,simpleTitleCaseMapping:0x125D
 },
 { code:0x1260
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1260
  ,simpleLowerCaseMapping:0x1260
  ,simpleTitleCaseMapping:0x1260
 },
 { code:0x1261
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1261
  ,simpleLowerCaseMapping:0x1261
  ,simpleTitleCaseMapping:0x1261
 },
 { code:0x1262
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1262
  ,simpleLowerCaseMapping:0x1262
  ,simpleTitleCaseMapping:0x1262
 },
 { code:0x1263
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1263
  ,simpleLowerCaseMapping:0x1263
  ,simpleTitleCaseMapping:0x1263
 },
 { code:0x1264
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1264
  ,simpleLowerCaseMapping:0x1264
  ,simpleTitleCaseMapping:0x1264
 },
 { code:0x1265
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1265
  ,simpleLowerCaseMapping:0x1265
  ,simpleTitleCaseMapping:0x1265
 },
 { code:0x1266
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1266
  ,simpleLowerCaseMapping:0x1266
  ,simpleTitleCaseMapping:0x1266
 },
 { code:0x1267
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1267
  ,simpleLowerCaseMapping:0x1267
  ,simpleTitleCaseMapping:0x1267
 },
 { code:0x1268
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1268
  ,simpleLowerCaseMapping:0x1268
  ,simpleTitleCaseMapping:0x1268
 },
 { code:0x1269
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1269
  ,simpleLowerCaseMapping:0x1269
  ,simpleTitleCaseMapping:0x1269
 },
 { code:0x126A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x126A
  ,simpleLowerCaseMapping:0x126A
  ,simpleTitleCaseMapping:0x126A
 },
 { code:0x126B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x126B
  ,simpleLowerCaseMapping:0x126B
  ,simpleTitleCaseMapping:0x126B
 },
 { code:0x126C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x126C
  ,simpleLowerCaseMapping:0x126C
  ,simpleTitleCaseMapping:0x126C
 },
 { code:0x126D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x126D
  ,simpleLowerCaseMapping:0x126D
  ,simpleTitleCaseMapping:0x126D
 },
 { code:0x126E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x126E
  ,simpleLowerCaseMapping:0x126E
  ,simpleTitleCaseMapping:0x126E
 },
 { code:0x126F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x126F
  ,simpleLowerCaseMapping:0x126F
  ,simpleTitleCaseMapping:0x126F
 },
 { code:0x1270
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1270
  ,simpleLowerCaseMapping:0x1270
  ,simpleTitleCaseMapping:0x1270
 },
 { code:0x1271
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1271
  ,simpleLowerCaseMapping:0x1271
  ,simpleTitleCaseMapping:0x1271
 },
 { code:0x1272
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1272
  ,simpleLowerCaseMapping:0x1272
  ,simpleTitleCaseMapping:0x1272
 },
 { code:0x1273
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1273
  ,simpleLowerCaseMapping:0x1273
  ,simpleTitleCaseMapping:0x1273
 },
 { code:0x1274
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1274
  ,simpleLowerCaseMapping:0x1274
  ,simpleTitleCaseMapping:0x1274
 },
 { code:0x1275
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1275
  ,simpleLowerCaseMapping:0x1275
  ,simpleTitleCaseMapping:0x1275
 },
 { code:0x1276
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1276
  ,simpleLowerCaseMapping:0x1276
  ,simpleTitleCaseMapping:0x1276
 },
 { code:0x1277
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1277
  ,simpleLowerCaseMapping:0x1277
  ,simpleTitleCaseMapping:0x1277
 },
 { code:0x1278
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1278
  ,simpleLowerCaseMapping:0x1278
  ,simpleTitleCaseMapping:0x1278
 },
 { code:0x1279
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1279
  ,simpleLowerCaseMapping:0x1279
  ,simpleTitleCaseMapping:0x1279
 },
 { code:0x127A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x127A
  ,simpleLowerCaseMapping:0x127A
  ,simpleTitleCaseMapping:0x127A
 },
 { code:0x127B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x127B
  ,simpleLowerCaseMapping:0x127B
  ,simpleTitleCaseMapping:0x127B
 },
 { code:0x127C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x127C
  ,simpleLowerCaseMapping:0x127C
  ,simpleTitleCaseMapping:0x127C
 },
 { code:0x127D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x127D
  ,simpleLowerCaseMapping:0x127D
  ,simpleTitleCaseMapping:0x127D
 },
 { code:0x127E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x127E
  ,simpleLowerCaseMapping:0x127E
  ,simpleTitleCaseMapping:0x127E
 },
 { code:0x127F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x127F
  ,simpleLowerCaseMapping:0x127F
  ,simpleTitleCaseMapping:0x127F
 },
 { code:0x1280
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1280
  ,simpleLowerCaseMapping:0x1280
  ,simpleTitleCaseMapping:0x1280
 },
 { code:0x1281
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1281
  ,simpleLowerCaseMapping:0x1281
  ,simpleTitleCaseMapping:0x1281
 },
 { code:0x1282
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1282
  ,simpleLowerCaseMapping:0x1282
  ,simpleTitleCaseMapping:0x1282
 },
 { code:0x1283
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1283
  ,simpleLowerCaseMapping:0x1283
  ,simpleTitleCaseMapping:0x1283
 },
 { code:0x1284
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1284
  ,simpleLowerCaseMapping:0x1284
  ,simpleTitleCaseMapping:0x1284
 },
 { code:0x1285
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1285
  ,simpleLowerCaseMapping:0x1285
  ,simpleTitleCaseMapping:0x1285
 },
 { code:0x1286
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1286
  ,simpleLowerCaseMapping:0x1286
  ,simpleTitleCaseMapping:0x1286
 },
 { code:0x1287
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1287
  ,simpleLowerCaseMapping:0x1287
  ,simpleTitleCaseMapping:0x1287
 },
 { code:0x1288
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1288
  ,simpleLowerCaseMapping:0x1288
  ,simpleTitleCaseMapping:0x1288
 },
 { code:0x128A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x128A
  ,simpleLowerCaseMapping:0x128A
  ,simpleTitleCaseMapping:0x128A
 },
 { code:0x128B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x128B
  ,simpleLowerCaseMapping:0x128B
  ,simpleTitleCaseMapping:0x128B
 },
 { code:0x128C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x128C
  ,simpleLowerCaseMapping:0x128C
  ,simpleTitleCaseMapping:0x128C
 },
 { code:0x128D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x128D
  ,simpleLowerCaseMapping:0x128D
  ,simpleTitleCaseMapping:0x128D
 },
 { code:0x1290
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1290
  ,simpleLowerCaseMapping:0x1290
  ,simpleTitleCaseMapping:0x1290
 },
 { code:0x1291
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1291
  ,simpleLowerCaseMapping:0x1291
  ,simpleTitleCaseMapping:0x1291
 },
 { code:0x1292
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1292
  ,simpleLowerCaseMapping:0x1292
  ,simpleTitleCaseMapping:0x1292
 },
 { code:0x1293
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1293
  ,simpleLowerCaseMapping:0x1293
  ,simpleTitleCaseMapping:0x1293
 },
 { code:0x1294
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1294
  ,simpleLowerCaseMapping:0x1294
  ,simpleTitleCaseMapping:0x1294
 },
 { code:0x1295
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1295
  ,simpleLowerCaseMapping:0x1295
  ,simpleTitleCaseMapping:0x1295
 },
 { code:0x1296
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1296
  ,simpleLowerCaseMapping:0x1296
  ,simpleTitleCaseMapping:0x1296
 },
 { code:0x1297
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1297
  ,simpleLowerCaseMapping:0x1297
  ,simpleTitleCaseMapping:0x1297
 },
 { code:0x1298
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1298
  ,simpleLowerCaseMapping:0x1298
  ,simpleTitleCaseMapping:0x1298
 },
 { code:0x1299
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1299
  ,simpleLowerCaseMapping:0x1299
  ,simpleTitleCaseMapping:0x1299
 },
 { code:0x129A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x129A
  ,simpleLowerCaseMapping:0x129A
  ,simpleTitleCaseMapping:0x129A
 },
 { code:0x129B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x129B
  ,simpleLowerCaseMapping:0x129B
  ,simpleTitleCaseMapping:0x129B
 },
 { code:0x129C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x129C
  ,simpleLowerCaseMapping:0x129C
  ,simpleTitleCaseMapping:0x129C
 },
 { code:0x129D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x129D
  ,simpleLowerCaseMapping:0x129D
  ,simpleTitleCaseMapping:0x129D
 },
 { code:0x129E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x129E
  ,simpleLowerCaseMapping:0x129E
  ,simpleTitleCaseMapping:0x129E
 },
 { code:0x129F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x129F
  ,simpleLowerCaseMapping:0x129F
  ,simpleTitleCaseMapping:0x129F
 },
 { code:0x12A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12A0
  ,simpleLowerCaseMapping:0x12A0
  ,simpleTitleCaseMapping:0x12A0
 },
 { code:0x12A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12A1
  ,simpleLowerCaseMapping:0x12A1
  ,simpleTitleCaseMapping:0x12A1
 },
 { code:0x12A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12A2
  ,simpleLowerCaseMapping:0x12A2
  ,simpleTitleCaseMapping:0x12A2
 },
 { code:0x12A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12A3
  ,simpleLowerCaseMapping:0x12A3
  ,simpleTitleCaseMapping:0x12A3
 },
 { code:0x12A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12A4
  ,simpleLowerCaseMapping:0x12A4
  ,simpleTitleCaseMapping:0x12A4
 },
 { code:0x12A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12A5
  ,simpleLowerCaseMapping:0x12A5
  ,simpleTitleCaseMapping:0x12A5
 },
 { code:0x12A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12A6
  ,simpleLowerCaseMapping:0x12A6
  ,simpleTitleCaseMapping:0x12A6
 },
 { code:0x12A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12A7
  ,simpleLowerCaseMapping:0x12A7
  ,simpleTitleCaseMapping:0x12A7
 },
 { code:0x12A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12A8
  ,simpleLowerCaseMapping:0x12A8
  ,simpleTitleCaseMapping:0x12A8
 },
 { code:0x12A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12A9
  ,simpleLowerCaseMapping:0x12A9
  ,simpleTitleCaseMapping:0x12A9
 },
 { code:0x12AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12AA
  ,simpleLowerCaseMapping:0x12AA
  ,simpleTitleCaseMapping:0x12AA
 },
 { code:0x12AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12AB
  ,simpleLowerCaseMapping:0x12AB
  ,simpleTitleCaseMapping:0x12AB
 },
 { code:0x12AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12AC
  ,simpleLowerCaseMapping:0x12AC
  ,simpleTitleCaseMapping:0x12AC
 },
 { code:0x12AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12AD
  ,simpleLowerCaseMapping:0x12AD
  ,simpleTitleCaseMapping:0x12AD
 },
 { code:0x12AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12AE
  ,simpleLowerCaseMapping:0x12AE
  ,simpleTitleCaseMapping:0x12AE
 },
 { code:0x12AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12AF
  ,simpleLowerCaseMapping:0x12AF
  ,simpleTitleCaseMapping:0x12AF
 },
 { code:0x12B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12B0
  ,simpleLowerCaseMapping:0x12B0
  ,simpleTitleCaseMapping:0x12B0
 },
 { code:0x12B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12B2
  ,simpleLowerCaseMapping:0x12B2
  ,simpleTitleCaseMapping:0x12B2
 },
 { code:0x12B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12B3
  ,simpleLowerCaseMapping:0x12B3
  ,simpleTitleCaseMapping:0x12B3
 },
 { code:0x12B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12B4
  ,simpleLowerCaseMapping:0x12B4
  ,simpleTitleCaseMapping:0x12B4
 },
 { code:0x12B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12B5
  ,simpleLowerCaseMapping:0x12B5
  ,simpleTitleCaseMapping:0x12B5
 },
 { code:0x12B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12B8
  ,simpleLowerCaseMapping:0x12B8
  ,simpleTitleCaseMapping:0x12B8
 },
 { code:0x12B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12B9
  ,simpleLowerCaseMapping:0x12B9
  ,simpleTitleCaseMapping:0x12B9
 },
 { code:0x12BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12BA
  ,simpleLowerCaseMapping:0x12BA
  ,simpleTitleCaseMapping:0x12BA
 },
 { code:0x12BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12BB
  ,simpleLowerCaseMapping:0x12BB
  ,simpleTitleCaseMapping:0x12BB
 },
 { code:0x12BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12BC
  ,simpleLowerCaseMapping:0x12BC
  ,simpleTitleCaseMapping:0x12BC
 },
 { code:0x12BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12BD
  ,simpleLowerCaseMapping:0x12BD
  ,simpleTitleCaseMapping:0x12BD
 },
 { code:0x12BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12BE
  ,simpleLowerCaseMapping:0x12BE
  ,simpleTitleCaseMapping:0x12BE
 },
 { code:0x12C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12C0
  ,simpleLowerCaseMapping:0x12C0
  ,simpleTitleCaseMapping:0x12C0
 },
 { code:0x12C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12C2
  ,simpleLowerCaseMapping:0x12C2
  ,simpleTitleCaseMapping:0x12C2
 },
 { code:0x12C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12C3
  ,simpleLowerCaseMapping:0x12C3
  ,simpleTitleCaseMapping:0x12C3
 },
 { code:0x12C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12C4
  ,simpleLowerCaseMapping:0x12C4
  ,simpleTitleCaseMapping:0x12C4
 },
 { code:0x12C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12C5
  ,simpleLowerCaseMapping:0x12C5
  ,simpleTitleCaseMapping:0x12C5
 },
 { code:0x12C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12C8
  ,simpleLowerCaseMapping:0x12C8
  ,simpleTitleCaseMapping:0x12C8
 },
 { code:0x12C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12C9
  ,simpleLowerCaseMapping:0x12C9
  ,simpleTitleCaseMapping:0x12C9
 },
 { code:0x12CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12CA
  ,simpleLowerCaseMapping:0x12CA
  ,simpleTitleCaseMapping:0x12CA
 },
 { code:0x12CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12CB
  ,simpleLowerCaseMapping:0x12CB
  ,simpleTitleCaseMapping:0x12CB
 },
 { code:0x12CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12CC
  ,simpleLowerCaseMapping:0x12CC
  ,simpleTitleCaseMapping:0x12CC
 },
 { code:0x12CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12CD
  ,simpleLowerCaseMapping:0x12CD
  ,simpleTitleCaseMapping:0x12CD
 },
 { code:0x12CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12CE
  ,simpleLowerCaseMapping:0x12CE
  ,simpleTitleCaseMapping:0x12CE
 },
 { code:0x12CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12CF
  ,simpleLowerCaseMapping:0x12CF
  ,simpleTitleCaseMapping:0x12CF
 },
 { code:0x12D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12D0
  ,simpleLowerCaseMapping:0x12D0
  ,simpleTitleCaseMapping:0x12D0
 },
 { code:0x12D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12D1
  ,simpleLowerCaseMapping:0x12D1
  ,simpleTitleCaseMapping:0x12D1
 },
 { code:0x12D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12D2
  ,simpleLowerCaseMapping:0x12D2
  ,simpleTitleCaseMapping:0x12D2
 },
 { code:0x12D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12D3
  ,simpleLowerCaseMapping:0x12D3
  ,simpleTitleCaseMapping:0x12D3
 },
 { code:0x12D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12D4
  ,simpleLowerCaseMapping:0x12D4
  ,simpleTitleCaseMapping:0x12D4
 },
 { code:0x12D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12D5
  ,simpleLowerCaseMapping:0x12D5
  ,simpleTitleCaseMapping:0x12D5
 },
 { code:0x12D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12D6
  ,simpleLowerCaseMapping:0x12D6
  ,simpleTitleCaseMapping:0x12D6
 },
 { code:0x12D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12D8
  ,simpleLowerCaseMapping:0x12D8
  ,simpleTitleCaseMapping:0x12D8
 },
 { code:0x12D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12D9
  ,simpleLowerCaseMapping:0x12D9
  ,simpleTitleCaseMapping:0x12D9
 },
 { code:0x12DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12DA
  ,simpleLowerCaseMapping:0x12DA
  ,simpleTitleCaseMapping:0x12DA
 },
 { code:0x12DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12DB
  ,simpleLowerCaseMapping:0x12DB
  ,simpleTitleCaseMapping:0x12DB
 },
 { code:0x12DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12DC
  ,simpleLowerCaseMapping:0x12DC
  ,simpleTitleCaseMapping:0x12DC
 },
 { code:0x12DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12DD
  ,simpleLowerCaseMapping:0x12DD
  ,simpleTitleCaseMapping:0x12DD
 },
 { code:0x12DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12DE
  ,simpleLowerCaseMapping:0x12DE
  ,simpleTitleCaseMapping:0x12DE
 },
 { code:0x12DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12DF
  ,simpleLowerCaseMapping:0x12DF
  ,simpleTitleCaseMapping:0x12DF
 },
 { code:0x12E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12E0
  ,simpleLowerCaseMapping:0x12E0
  ,simpleTitleCaseMapping:0x12E0
 },
 { code:0x12E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12E1
  ,simpleLowerCaseMapping:0x12E1
  ,simpleTitleCaseMapping:0x12E1
 },
 { code:0x12E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12E2
  ,simpleLowerCaseMapping:0x12E2
  ,simpleTitleCaseMapping:0x12E2
 },
 { code:0x12E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12E3
  ,simpleLowerCaseMapping:0x12E3
  ,simpleTitleCaseMapping:0x12E3
 },
 { code:0x12E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12E4
  ,simpleLowerCaseMapping:0x12E4
  ,simpleTitleCaseMapping:0x12E4
 },
 { code:0x12E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12E5
  ,simpleLowerCaseMapping:0x12E5
  ,simpleTitleCaseMapping:0x12E5
 },
 { code:0x12E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12E6
  ,simpleLowerCaseMapping:0x12E6
  ,simpleTitleCaseMapping:0x12E6
 },
 { code:0x12E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12E7
  ,simpleLowerCaseMapping:0x12E7
  ,simpleTitleCaseMapping:0x12E7
 },
 { code:0x12E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12E8
  ,simpleLowerCaseMapping:0x12E8
  ,simpleTitleCaseMapping:0x12E8
 },
 { code:0x12E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12E9
  ,simpleLowerCaseMapping:0x12E9
  ,simpleTitleCaseMapping:0x12E9
 },
 { code:0x12EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12EA
  ,simpleLowerCaseMapping:0x12EA
  ,simpleTitleCaseMapping:0x12EA
 },
 { code:0x12EB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12EB
  ,simpleLowerCaseMapping:0x12EB
  ,simpleTitleCaseMapping:0x12EB
 },
 { code:0x12EC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12EC
  ,simpleLowerCaseMapping:0x12EC
  ,simpleTitleCaseMapping:0x12EC
 },
 { code:0x12ED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12ED
  ,simpleLowerCaseMapping:0x12ED
  ,simpleTitleCaseMapping:0x12ED
 },
 { code:0x12EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12EE
  ,simpleLowerCaseMapping:0x12EE
  ,simpleTitleCaseMapping:0x12EE
 },
 { code:0x12EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12EF
  ,simpleLowerCaseMapping:0x12EF
  ,simpleTitleCaseMapping:0x12EF
 },
 { code:0x12F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12F0
  ,simpleLowerCaseMapping:0x12F0
  ,simpleTitleCaseMapping:0x12F0
 },
 { code:0x12F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12F1
  ,simpleLowerCaseMapping:0x12F1
  ,simpleTitleCaseMapping:0x12F1
 },
 { code:0x12F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12F2
  ,simpleLowerCaseMapping:0x12F2
  ,simpleTitleCaseMapping:0x12F2
 },
 { code:0x12F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12F3
  ,simpleLowerCaseMapping:0x12F3
  ,simpleTitleCaseMapping:0x12F3
 },
 { code:0x12F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12F4
  ,simpleLowerCaseMapping:0x12F4
  ,simpleTitleCaseMapping:0x12F4
 },
 { code:0x12F5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12F5
  ,simpleLowerCaseMapping:0x12F5
  ,simpleTitleCaseMapping:0x12F5
 },
 { code:0x12F6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12F6
  ,simpleLowerCaseMapping:0x12F6
  ,simpleTitleCaseMapping:0x12F6
 },
 { code:0x12F7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12F7
  ,simpleLowerCaseMapping:0x12F7
  ,simpleTitleCaseMapping:0x12F7
 },
 { code:0x12F8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12F8
  ,simpleLowerCaseMapping:0x12F8
  ,simpleTitleCaseMapping:0x12F8
 },
 { code:0x12F9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12F9
  ,simpleLowerCaseMapping:0x12F9
  ,simpleTitleCaseMapping:0x12F9
 },
 { code:0x12FA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12FA
  ,simpleLowerCaseMapping:0x12FA
  ,simpleTitleCaseMapping:0x12FA
 },
 { code:0x12FB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12FB
  ,simpleLowerCaseMapping:0x12FB
  ,simpleTitleCaseMapping:0x12FB
 },
 { code:0x12FC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12FC
  ,simpleLowerCaseMapping:0x12FC
  ,simpleTitleCaseMapping:0x12FC
 },
 { code:0x12FD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12FD
  ,simpleLowerCaseMapping:0x12FD
  ,simpleTitleCaseMapping:0x12FD
 },
 { code:0x12FE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12FE
  ,simpleLowerCaseMapping:0x12FE
  ,simpleTitleCaseMapping:0x12FE
 },
 { code:0x12FF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12FF
  ,simpleLowerCaseMapping:0x12FF
  ,simpleTitleCaseMapping:0x12FF
 },
 { code:0x1300
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1300
  ,simpleLowerCaseMapping:0x1300
  ,simpleTitleCaseMapping:0x1300
 },
 { code:0x1301
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1301
  ,simpleLowerCaseMapping:0x1301
  ,simpleTitleCaseMapping:0x1301
 },
 { code:0x1302
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1302
  ,simpleLowerCaseMapping:0x1302
  ,simpleTitleCaseMapping:0x1302
 },
 { code:0x1303
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1303
  ,simpleLowerCaseMapping:0x1303
  ,simpleTitleCaseMapping:0x1303
 },
 { code:0x1304
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1304
  ,simpleLowerCaseMapping:0x1304
  ,simpleTitleCaseMapping:0x1304
 },
 { code:0x1305
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1305
  ,simpleLowerCaseMapping:0x1305
  ,simpleTitleCaseMapping:0x1305
 },
 { code:0x1306
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1306
  ,simpleLowerCaseMapping:0x1306
  ,simpleTitleCaseMapping:0x1306
 },
 { code:0x1307
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1307
  ,simpleLowerCaseMapping:0x1307
  ,simpleTitleCaseMapping:0x1307
 },
 { code:0x1308
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1308
  ,simpleLowerCaseMapping:0x1308
  ,simpleTitleCaseMapping:0x1308
 },
 { code:0x1309
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1309
  ,simpleLowerCaseMapping:0x1309
  ,simpleTitleCaseMapping:0x1309
 },
 { code:0x130A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x130A
  ,simpleLowerCaseMapping:0x130A
  ,simpleTitleCaseMapping:0x130A
 },
 { code:0x130B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x130B
  ,simpleLowerCaseMapping:0x130B
  ,simpleTitleCaseMapping:0x130B
 },
 { code:0x130C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x130C
  ,simpleLowerCaseMapping:0x130C
  ,simpleTitleCaseMapping:0x130C
 },
 { code:0x130D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x130D
  ,simpleLowerCaseMapping:0x130D
  ,simpleTitleCaseMapping:0x130D
 },
 { code:0x130E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x130E
  ,simpleLowerCaseMapping:0x130E
  ,simpleTitleCaseMapping:0x130E
 },
 { code:0x130F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x130F
  ,simpleLowerCaseMapping:0x130F
  ,simpleTitleCaseMapping:0x130F
 },
 { code:0x1310
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1310
  ,simpleLowerCaseMapping:0x1310
  ,simpleTitleCaseMapping:0x1310
 },
 { code:0x1312
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1312
  ,simpleLowerCaseMapping:0x1312
  ,simpleTitleCaseMapping:0x1312
 },
 { code:0x1313
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1313
  ,simpleLowerCaseMapping:0x1313
  ,simpleTitleCaseMapping:0x1313
 },
 { code:0x1314
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1314
  ,simpleLowerCaseMapping:0x1314
  ,simpleTitleCaseMapping:0x1314
 },
 { code:0x1315
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1315
  ,simpleLowerCaseMapping:0x1315
  ,simpleTitleCaseMapping:0x1315
 },
 { code:0x1318
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1318
  ,simpleLowerCaseMapping:0x1318
  ,simpleTitleCaseMapping:0x1318
 },
 { code:0x1319
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1319
  ,simpleLowerCaseMapping:0x1319
  ,simpleTitleCaseMapping:0x1319
 },
 { code:0x131A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x131A
  ,simpleLowerCaseMapping:0x131A
  ,simpleTitleCaseMapping:0x131A
 },
 { code:0x131B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x131B
  ,simpleLowerCaseMapping:0x131B
  ,simpleTitleCaseMapping:0x131B
 },
 { code:0x131C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x131C
  ,simpleLowerCaseMapping:0x131C
  ,simpleTitleCaseMapping:0x131C
 },
 { code:0x131D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x131D
  ,simpleLowerCaseMapping:0x131D
  ,simpleTitleCaseMapping:0x131D
 },
 { code:0x131E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x131E
  ,simpleLowerCaseMapping:0x131E
  ,simpleTitleCaseMapping:0x131E
 },
 { code:0x131F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x131F
  ,simpleLowerCaseMapping:0x131F
  ,simpleTitleCaseMapping:0x131F
 },
 { code:0x1320
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1320
  ,simpleLowerCaseMapping:0x1320
  ,simpleTitleCaseMapping:0x1320
 },
 { code:0x1321
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1321
  ,simpleLowerCaseMapping:0x1321
  ,simpleTitleCaseMapping:0x1321
 },
 { code:0x1322
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1322
  ,simpleLowerCaseMapping:0x1322
  ,simpleTitleCaseMapping:0x1322
 },
 { code:0x1323
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1323
  ,simpleLowerCaseMapping:0x1323
  ,simpleTitleCaseMapping:0x1323
 },
 { code:0x1324
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1324
  ,simpleLowerCaseMapping:0x1324
  ,simpleTitleCaseMapping:0x1324
 },
 { code:0x1325
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1325
  ,simpleLowerCaseMapping:0x1325
  ,simpleTitleCaseMapping:0x1325
 },
 { code:0x1326
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1326
  ,simpleLowerCaseMapping:0x1326
  ,simpleTitleCaseMapping:0x1326
 },
 { code:0x1327
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1327
  ,simpleLowerCaseMapping:0x1327
  ,simpleTitleCaseMapping:0x1327
 },
 { code:0x1328
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1328
  ,simpleLowerCaseMapping:0x1328
  ,simpleTitleCaseMapping:0x1328
 },
 { code:0x1329
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1329
  ,simpleLowerCaseMapping:0x1329
  ,simpleTitleCaseMapping:0x1329
 },
 { code:0x132A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x132A
  ,simpleLowerCaseMapping:0x132A
  ,simpleTitleCaseMapping:0x132A
 },
 { code:0x132B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x132B
  ,simpleLowerCaseMapping:0x132B
  ,simpleTitleCaseMapping:0x132B
 },
 { code:0x132C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x132C
  ,simpleLowerCaseMapping:0x132C
  ,simpleTitleCaseMapping:0x132C
 },
 { code:0x132D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x132D
  ,simpleLowerCaseMapping:0x132D
  ,simpleTitleCaseMapping:0x132D
 },
 { code:0x132E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x132E
  ,simpleLowerCaseMapping:0x132E
  ,simpleTitleCaseMapping:0x132E
 },
 { code:0x132F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x132F
  ,simpleLowerCaseMapping:0x132F
  ,simpleTitleCaseMapping:0x132F
 },
 { code:0x1330
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1330
  ,simpleLowerCaseMapping:0x1330
  ,simpleTitleCaseMapping:0x1330
 },
 { code:0x1331
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1331
  ,simpleLowerCaseMapping:0x1331
  ,simpleTitleCaseMapping:0x1331
 },
 { code:0x1332
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1332
  ,simpleLowerCaseMapping:0x1332
  ,simpleTitleCaseMapping:0x1332
 },
 { code:0x1333
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1333
  ,simpleLowerCaseMapping:0x1333
  ,simpleTitleCaseMapping:0x1333
 },
 { code:0x1334
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1334
  ,simpleLowerCaseMapping:0x1334
  ,simpleTitleCaseMapping:0x1334
 },
 { code:0x1335
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1335
  ,simpleLowerCaseMapping:0x1335
  ,simpleTitleCaseMapping:0x1335
 },
 { code:0x1336
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1336
  ,simpleLowerCaseMapping:0x1336
  ,simpleTitleCaseMapping:0x1336
 },
 { code:0x1337
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1337
  ,simpleLowerCaseMapping:0x1337
  ,simpleTitleCaseMapping:0x1337
 },
 { code:0x1338
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1338
  ,simpleLowerCaseMapping:0x1338
  ,simpleTitleCaseMapping:0x1338
 },
 { code:0x1339
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1339
  ,simpleLowerCaseMapping:0x1339
  ,simpleTitleCaseMapping:0x1339
 },
 { code:0x133A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x133A
  ,simpleLowerCaseMapping:0x133A
  ,simpleTitleCaseMapping:0x133A
 },
 { code:0x133B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x133B
  ,simpleLowerCaseMapping:0x133B
  ,simpleTitleCaseMapping:0x133B
 },
 { code:0x133C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x133C
  ,simpleLowerCaseMapping:0x133C
  ,simpleTitleCaseMapping:0x133C
 },
 { code:0x133D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x133D
  ,simpleLowerCaseMapping:0x133D
  ,simpleTitleCaseMapping:0x133D
 },
 { code:0x133E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x133E
  ,simpleLowerCaseMapping:0x133E
  ,simpleTitleCaseMapping:0x133E
 },
 { code:0x133F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x133F
  ,simpleLowerCaseMapping:0x133F
  ,simpleTitleCaseMapping:0x133F
 },
 { code:0x1340
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1340
  ,simpleLowerCaseMapping:0x1340
  ,simpleTitleCaseMapping:0x1340
 },
 { code:0x1341
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1341
  ,simpleLowerCaseMapping:0x1341
  ,simpleTitleCaseMapping:0x1341
 },
 { code:0x1342
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1342
  ,simpleLowerCaseMapping:0x1342
  ,simpleTitleCaseMapping:0x1342
 },
 { code:0x1343
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1343
  ,simpleLowerCaseMapping:0x1343
  ,simpleTitleCaseMapping:0x1343
 },
 { code:0x1344
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1344
  ,simpleLowerCaseMapping:0x1344
  ,simpleTitleCaseMapping:0x1344
 },
 { code:0x1345
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1345
  ,simpleLowerCaseMapping:0x1345
  ,simpleTitleCaseMapping:0x1345
 },
 { code:0x1346
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1346
  ,simpleLowerCaseMapping:0x1346
  ,simpleTitleCaseMapping:0x1346
 },
 { code:0x1347
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1347
  ,simpleLowerCaseMapping:0x1347
  ,simpleTitleCaseMapping:0x1347
 },
 { code:0x1348
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1348
  ,simpleLowerCaseMapping:0x1348
  ,simpleTitleCaseMapping:0x1348
 },
 { code:0x1349
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1349
  ,simpleLowerCaseMapping:0x1349
  ,simpleTitleCaseMapping:0x1349
 },
 { code:0x134A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x134A
  ,simpleLowerCaseMapping:0x134A
  ,simpleTitleCaseMapping:0x134A
 },
 { code:0x134B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x134B
  ,simpleLowerCaseMapping:0x134B
  ,simpleTitleCaseMapping:0x134B
 },
 { code:0x134C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x134C
  ,simpleLowerCaseMapping:0x134C
  ,simpleTitleCaseMapping:0x134C
 },
 { code:0x134D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x134D
  ,simpleLowerCaseMapping:0x134D
  ,simpleTitleCaseMapping:0x134D
 },
 { code:0x134E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x134E
  ,simpleLowerCaseMapping:0x134E
  ,simpleTitleCaseMapping:0x134E
 },
 { code:0x134F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x134F
  ,simpleLowerCaseMapping:0x134F
  ,simpleTitleCaseMapping:0x134F
 },
 { code:0x1350
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1350
  ,simpleLowerCaseMapping:0x1350
  ,simpleTitleCaseMapping:0x1350
 },
 { code:0x1351
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1351
  ,simpleLowerCaseMapping:0x1351
  ,simpleTitleCaseMapping:0x1351
 },
 { code:0x1352
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1352
  ,simpleLowerCaseMapping:0x1352
  ,simpleTitleCaseMapping:0x1352
 },
 { code:0x1353
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1353
  ,simpleLowerCaseMapping:0x1353
  ,simpleTitleCaseMapping:0x1353
 },
 { code:0x1354
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1354
  ,simpleLowerCaseMapping:0x1354
  ,simpleTitleCaseMapping:0x1354
 },
 { code:0x1355
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1355
  ,simpleLowerCaseMapping:0x1355
  ,simpleTitleCaseMapping:0x1355
 },
 { code:0x1356
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1356
  ,simpleLowerCaseMapping:0x1356
  ,simpleTitleCaseMapping:0x1356
 },
 { code:0x1357
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1357
  ,simpleLowerCaseMapping:0x1357
  ,simpleTitleCaseMapping:0x1357
 },
 { code:0x1358
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1358
  ,simpleLowerCaseMapping:0x1358
  ,simpleTitleCaseMapping:0x1358
 },
 { code:0x1359
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1359
  ,simpleLowerCaseMapping:0x1359
  ,simpleTitleCaseMapping:0x1359
 },
 { code:0x135A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x135A
  ,simpleLowerCaseMapping:0x135A
  ,simpleTitleCaseMapping:0x135A
 },
 { code:0x135F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x135F
  ,simpleLowerCaseMapping:0x135F
  ,simpleTitleCaseMapping:0x135F
 },
 { code:0x1360
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1360
  ,simpleLowerCaseMapping:0x1360
  ,simpleTitleCaseMapping:0x1360
 },
 { code:0x1361
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1361
  ,simpleLowerCaseMapping:0x1361
  ,simpleTitleCaseMapping:0x1361
 },
 { code:0x1362
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1362
  ,simpleLowerCaseMapping:0x1362
  ,simpleTitleCaseMapping:0x1362
 },
 { code:0x1363
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1363
  ,simpleLowerCaseMapping:0x1363
  ,simpleTitleCaseMapping:0x1363
 },
 { code:0x1364
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1364
  ,simpleLowerCaseMapping:0x1364
  ,simpleTitleCaseMapping:0x1364
 },
 { code:0x1365
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1365
  ,simpleLowerCaseMapping:0x1365
  ,simpleTitleCaseMapping:0x1365
 },
 { code:0x1366
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1366
  ,simpleLowerCaseMapping:0x1366
  ,simpleTitleCaseMapping:0x1366
 },
 { code:0x1367
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1367
  ,simpleLowerCaseMapping:0x1367
  ,simpleTitleCaseMapping:0x1367
 },
 { code:0x1368
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1368
  ,simpleLowerCaseMapping:0x1368
  ,simpleTitleCaseMapping:0x1368
 },
 { code:0x1369
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1369
  ,simpleLowerCaseMapping:0x1369
  ,simpleTitleCaseMapping:0x1369
 },
 { code:0x136A
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x136A
  ,simpleLowerCaseMapping:0x136A
  ,simpleTitleCaseMapping:0x136A
 },
 { code:0x136B
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x136B
  ,simpleLowerCaseMapping:0x136B
  ,simpleTitleCaseMapping:0x136B
 },
 { code:0x136C
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x136C
  ,simpleLowerCaseMapping:0x136C
  ,simpleTitleCaseMapping:0x136C
 },
 { code:0x136D
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x136D
  ,simpleLowerCaseMapping:0x136D
  ,simpleTitleCaseMapping:0x136D
 },
 { code:0x136E
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x136E
  ,simpleLowerCaseMapping:0x136E
  ,simpleTitleCaseMapping:0x136E
 },
 { code:0x136F
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x136F
  ,simpleLowerCaseMapping:0x136F
  ,simpleTitleCaseMapping:0x136F
 },
 { code:0x1370
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1370
  ,simpleLowerCaseMapping:0x1370
  ,simpleTitleCaseMapping:0x1370
 },
 { code:0x1371
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1371
  ,simpleLowerCaseMapping:0x1371
  ,simpleTitleCaseMapping:0x1371
 },
 { code:0x1372
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1372
  ,simpleLowerCaseMapping:0x1372
  ,simpleTitleCaseMapping:0x1372
 },
 { code:0x1373
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1373
  ,simpleLowerCaseMapping:0x1373
  ,simpleTitleCaseMapping:0x1373
 },
 { code:0x1374
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1374
  ,simpleLowerCaseMapping:0x1374
  ,simpleTitleCaseMapping:0x1374
 },
 { code:0x1375
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1375
  ,simpleLowerCaseMapping:0x1375
  ,simpleTitleCaseMapping:0x1375
 },
 { code:0x1376
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1376
  ,simpleLowerCaseMapping:0x1376
  ,simpleTitleCaseMapping:0x1376
 },
 { code:0x1377
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1377
  ,simpleLowerCaseMapping:0x1377
  ,simpleTitleCaseMapping:0x1377
 },
 { code:0x1378
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1378
  ,simpleLowerCaseMapping:0x1378
  ,simpleTitleCaseMapping:0x1378
 },
 { code:0x1379
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1379
  ,simpleLowerCaseMapping:0x1379
  ,simpleTitleCaseMapping:0x1379
 },
 { code:0x137A
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x137A
  ,simpleLowerCaseMapping:0x137A
  ,simpleTitleCaseMapping:0x137A
 },
 { code:0x137B
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x137B
  ,simpleLowerCaseMapping:0x137B
  ,simpleTitleCaseMapping:0x137B
 },
 { code:0x137C
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x137C
  ,simpleLowerCaseMapping:0x137C
  ,simpleTitleCaseMapping:0x137C
 },
 { code:0x1380
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1380
  ,simpleLowerCaseMapping:0x1380
  ,simpleTitleCaseMapping:0x1380
 },
 { code:0x1381
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1381
  ,simpleLowerCaseMapping:0x1381
  ,simpleTitleCaseMapping:0x1381
 },
 { code:0x1382
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1382
  ,simpleLowerCaseMapping:0x1382
  ,simpleTitleCaseMapping:0x1382
 },
 { code:0x1383
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1383
  ,simpleLowerCaseMapping:0x1383
  ,simpleTitleCaseMapping:0x1383
 },
 { code:0x1384
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1384
  ,simpleLowerCaseMapping:0x1384
  ,simpleTitleCaseMapping:0x1384
 },
 { code:0x1385
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1385
  ,simpleLowerCaseMapping:0x1385
  ,simpleTitleCaseMapping:0x1385
 },
 { code:0x1386
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1386
  ,simpleLowerCaseMapping:0x1386
  ,simpleTitleCaseMapping:0x1386
 },
 { code:0x1387
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1387
  ,simpleLowerCaseMapping:0x1387
  ,simpleTitleCaseMapping:0x1387
 },
 { code:0x1388
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1388
  ,simpleLowerCaseMapping:0x1388
  ,simpleTitleCaseMapping:0x1388
 },
 { code:0x1389
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1389
  ,simpleLowerCaseMapping:0x1389
  ,simpleTitleCaseMapping:0x1389
 },
 { code:0x138A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x138A
  ,simpleLowerCaseMapping:0x138A
  ,simpleTitleCaseMapping:0x138A
 },
 { code:0x138B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x138B
  ,simpleLowerCaseMapping:0x138B
  ,simpleTitleCaseMapping:0x138B
 },
 { code:0x138C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x138C
  ,simpleLowerCaseMapping:0x138C
  ,simpleTitleCaseMapping:0x138C
 },
 { code:0x138D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x138D
  ,simpleLowerCaseMapping:0x138D
  ,simpleTitleCaseMapping:0x138D
 },
 { code:0x138E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x138E
  ,simpleLowerCaseMapping:0x138E
  ,simpleTitleCaseMapping:0x138E
 },
 { code:0x138F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x138F
  ,simpleLowerCaseMapping:0x138F
  ,simpleTitleCaseMapping:0x138F
 },
 { code:0x1390
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1390
  ,simpleLowerCaseMapping:0x1390
  ,simpleTitleCaseMapping:0x1390
 },
 { code:0x1391
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1391
  ,simpleLowerCaseMapping:0x1391
  ,simpleTitleCaseMapping:0x1391
 },
 { code:0x1392
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1392
  ,simpleLowerCaseMapping:0x1392
  ,simpleTitleCaseMapping:0x1392
 },
 { code:0x1393
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1393
  ,simpleLowerCaseMapping:0x1393
  ,simpleTitleCaseMapping:0x1393
 },
 { code:0x1394
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1394
  ,simpleLowerCaseMapping:0x1394
  ,simpleTitleCaseMapping:0x1394
 },
 { code:0x1395
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1395
  ,simpleLowerCaseMapping:0x1395
  ,simpleTitleCaseMapping:0x1395
 },
 { code:0x1396
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1396
  ,simpleLowerCaseMapping:0x1396
  ,simpleTitleCaseMapping:0x1396
 },
 { code:0x1397
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1397
  ,simpleLowerCaseMapping:0x1397
  ,simpleTitleCaseMapping:0x1397
 },
 { code:0x1398
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1398
  ,simpleLowerCaseMapping:0x1398
  ,simpleTitleCaseMapping:0x1398
 },
 { code:0x1399
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1399
  ,simpleLowerCaseMapping:0x1399
  ,simpleTitleCaseMapping:0x1399
 },
 { code:0x13A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13A0
  ,simpleLowerCaseMapping:0x13A0
  ,simpleTitleCaseMapping:0x13A0
 },
 { code:0x13A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13A1
  ,simpleLowerCaseMapping:0x13A1
  ,simpleTitleCaseMapping:0x13A1
 },
 { code:0x13A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13A2
  ,simpleLowerCaseMapping:0x13A2
  ,simpleTitleCaseMapping:0x13A2
 },
 { code:0x13A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13A3
  ,simpleLowerCaseMapping:0x13A3
  ,simpleTitleCaseMapping:0x13A3
 },
 { code:0x13A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13A4
  ,simpleLowerCaseMapping:0x13A4
  ,simpleTitleCaseMapping:0x13A4
 },
 { code:0x13A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13A5
  ,simpleLowerCaseMapping:0x13A5
  ,simpleTitleCaseMapping:0x13A5
 },
 { code:0x13A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13A6
  ,simpleLowerCaseMapping:0x13A6
  ,simpleTitleCaseMapping:0x13A6
 },
 { code:0x13A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13A7
  ,simpleLowerCaseMapping:0x13A7
  ,simpleTitleCaseMapping:0x13A7
 },
 { code:0x13A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13A8
  ,simpleLowerCaseMapping:0x13A8
  ,simpleTitleCaseMapping:0x13A8
 },
 { code:0x13A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13A9
  ,simpleLowerCaseMapping:0x13A9
  ,simpleTitleCaseMapping:0x13A9
 },
 { code:0x13AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13AA
  ,simpleLowerCaseMapping:0x13AA
  ,simpleTitleCaseMapping:0x13AA
 },
 { code:0x13AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13AB
  ,simpleLowerCaseMapping:0x13AB
  ,simpleTitleCaseMapping:0x13AB
 },
 { code:0x13AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13AC
  ,simpleLowerCaseMapping:0x13AC
  ,simpleTitleCaseMapping:0x13AC
 },
 { code:0x13AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13AD
  ,simpleLowerCaseMapping:0x13AD
  ,simpleTitleCaseMapping:0x13AD
 },
 { code:0x13AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13AE
  ,simpleLowerCaseMapping:0x13AE
  ,simpleTitleCaseMapping:0x13AE
 },
 { code:0x13AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13AF
  ,simpleLowerCaseMapping:0x13AF
  ,simpleTitleCaseMapping:0x13AF
 },
 { code:0x13B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13B0
  ,simpleLowerCaseMapping:0x13B0
  ,simpleTitleCaseMapping:0x13B0
 },
 { code:0x13B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13B1
  ,simpleLowerCaseMapping:0x13B1
  ,simpleTitleCaseMapping:0x13B1
 },
 { code:0x13B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13B2
  ,simpleLowerCaseMapping:0x13B2
  ,simpleTitleCaseMapping:0x13B2
 },
 { code:0x13B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13B3
  ,simpleLowerCaseMapping:0x13B3
  ,simpleTitleCaseMapping:0x13B3
 },
 { code:0x13B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13B4
  ,simpleLowerCaseMapping:0x13B4
  ,simpleTitleCaseMapping:0x13B4
 },
 { code:0x13B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13B5
  ,simpleLowerCaseMapping:0x13B5
  ,simpleTitleCaseMapping:0x13B5
 },
 { code:0x13B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13B6
  ,simpleLowerCaseMapping:0x13B6
  ,simpleTitleCaseMapping:0x13B6
 },
 { code:0x13B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13B7
  ,simpleLowerCaseMapping:0x13B7
  ,simpleTitleCaseMapping:0x13B7
 },
 { code:0x13B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13B8
  ,simpleLowerCaseMapping:0x13B8
  ,simpleTitleCaseMapping:0x13B8
 },
 { code:0x13B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13B9
  ,simpleLowerCaseMapping:0x13B9
  ,simpleTitleCaseMapping:0x13B9
 },
 { code:0x13BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13BA
  ,simpleLowerCaseMapping:0x13BA
  ,simpleTitleCaseMapping:0x13BA
 },
 { code:0x13BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13BB
  ,simpleLowerCaseMapping:0x13BB
  ,simpleTitleCaseMapping:0x13BB
 },
 { code:0x13BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13BC
  ,simpleLowerCaseMapping:0x13BC
  ,simpleTitleCaseMapping:0x13BC
 },
 { code:0x13BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13BD
  ,simpleLowerCaseMapping:0x13BD
  ,simpleTitleCaseMapping:0x13BD
 },
 { code:0x13BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13BE
  ,simpleLowerCaseMapping:0x13BE
  ,simpleTitleCaseMapping:0x13BE
 },
 { code:0x13BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13BF
  ,simpleLowerCaseMapping:0x13BF
  ,simpleTitleCaseMapping:0x13BF
 },
 { code:0x13C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13C0
  ,simpleLowerCaseMapping:0x13C0
  ,simpleTitleCaseMapping:0x13C0
 },
 { code:0x13C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13C1
  ,simpleLowerCaseMapping:0x13C1
  ,simpleTitleCaseMapping:0x13C1
 },
 { code:0x13C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13C2
  ,simpleLowerCaseMapping:0x13C2
  ,simpleTitleCaseMapping:0x13C2
 },
 { code:0x13C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13C3
  ,simpleLowerCaseMapping:0x13C3
  ,simpleTitleCaseMapping:0x13C3
 },
 { code:0x13C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13C4
  ,simpleLowerCaseMapping:0x13C4
  ,simpleTitleCaseMapping:0x13C4
 },
 { code:0x13C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13C5
  ,simpleLowerCaseMapping:0x13C5
  ,simpleTitleCaseMapping:0x13C5
 },
 { code:0x13C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13C6
  ,simpleLowerCaseMapping:0x13C6
  ,simpleTitleCaseMapping:0x13C6
 },
 { code:0x13C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13C7
  ,simpleLowerCaseMapping:0x13C7
  ,simpleTitleCaseMapping:0x13C7
 },
 { code:0x13C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13C8
  ,simpleLowerCaseMapping:0x13C8
  ,simpleTitleCaseMapping:0x13C8
 },
 { code:0x13C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13C9
  ,simpleLowerCaseMapping:0x13C9
  ,simpleTitleCaseMapping:0x13C9
 },
 { code:0x13CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13CA
  ,simpleLowerCaseMapping:0x13CA
  ,simpleTitleCaseMapping:0x13CA
 },
 { code:0x13CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13CB
  ,simpleLowerCaseMapping:0x13CB
  ,simpleTitleCaseMapping:0x13CB
 },
 { code:0x13CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13CC
  ,simpleLowerCaseMapping:0x13CC
  ,simpleTitleCaseMapping:0x13CC
 },
 { code:0x13CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13CD
  ,simpleLowerCaseMapping:0x13CD
  ,simpleTitleCaseMapping:0x13CD
 },
 { code:0x13CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13CE
  ,simpleLowerCaseMapping:0x13CE
  ,simpleTitleCaseMapping:0x13CE
 },
 { code:0x13CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13CF
  ,simpleLowerCaseMapping:0x13CF
  ,simpleTitleCaseMapping:0x13CF
 },
 { code:0x13D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13D0
  ,simpleLowerCaseMapping:0x13D0
  ,simpleTitleCaseMapping:0x13D0
 },
 { code:0x13D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13D1
  ,simpleLowerCaseMapping:0x13D1
  ,simpleTitleCaseMapping:0x13D1
 },
 { code:0x13D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13D2
  ,simpleLowerCaseMapping:0x13D2
  ,simpleTitleCaseMapping:0x13D2
 },
 { code:0x13D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13D3
  ,simpleLowerCaseMapping:0x13D3
  ,simpleTitleCaseMapping:0x13D3
 },
 { code:0x13D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13D4
  ,simpleLowerCaseMapping:0x13D4
  ,simpleTitleCaseMapping:0x13D4
 },
 { code:0x13D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13D5
  ,simpleLowerCaseMapping:0x13D5
  ,simpleTitleCaseMapping:0x13D5
 },
 { code:0x13D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13D6
  ,simpleLowerCaseMapping:0x13D6
  ,simpleTitleCaseMapping:0x13D6
 },
 { code:0x13D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13D7
  ,simpleLowerCaseMapping:0x13D7
  ,simpleTitleCaseMapping:0x13D7
 },
 { code:0x13D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13D8
  ,simpleLowerCaseMapping:0x13D8
  ,simpleTitleCaseMapping:0x13D8
 },
 { code:0x13D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13D9
  ,simpleLowerCaseMapping:0x13D9
  ,simpleTitleCaseMapping:0x13D9
 },
 { code:0x13DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13DA
  ,simpleLowerCaseMapping:0x13DA
  ,simpleTitleCaseMapping:0x13DA
 },
 { code:0x13DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13DB
  ,simpleLowerCaseMapping:0x13DB
  ,simpleTitleCaseMapping:0x13DB
 },
 { code:0x13DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13DC
  ,simpleLowerCaseMapping:0x13DC
  ,simpleTitleCaseMapping:0x13DC
 },
 { code:0x13DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13DD
  ,simpleLowerCaseMapping:0x13DD
  ,simpleTitleCaseMapping:0x13DD
 },
 { code:0x13DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13DE
  ,simpleLowerCaseMapping:0x13DE
  ,simpleTitleCaseMapping:0x13DE
 },
 { code:0x13DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13DF
  ,simpleLowerCaseMapping:0x13DF
  ,simpleTitleCaseMapping:0x13DF
 },
 { code:0x13E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13E0
  ,simpleLowerCaseMapping:0x13E0
  ,simpleTitleCaseMapping:0x13E0
 },
 { code:0x13E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13E1
  ,simpleLowerCaseMapping:0x13E1
  ,simpleTitleCaseMapping:0x13E1
 },
 { code:0x13E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13E2
  ,simpleLowerCaseMapping:0x13E2
  ,simpleTitleCaseMapping:0x13E2
 },
 { code:0x13E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13E3
  ,simpleLowerCaseMapping:0x13E3
  ,simpleTitleCaseMapping:0x13E3
 },
 { code:0x13E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13E4
  ,simpleLowerCaseMapping:0x13E4
  ,simpleTitleCaseMapping:0x13E4
 },
 { code:0x13E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13E5
  ,simpleLowerCaseMapping:0x13E5
  ,simpleTitleCaseMapping:0x13E5
 },
 { code:0x13E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13E6
  ,simpleLowerCaseMapping:0x13E6
  ,simpleTitleCaseMapping:0x13E6
 },
 { code:0x13E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13E7
  ,simpleLowerCaseMapping:0x13E7
  ,simpleTitleCaseMapping:0x13E7
 },
 { code:0x13E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13E8
  ,simpleLowerCaseMapping:0x13E8
  ,simpleTitleCaseMapping:0x13E8
 },
 { code:0x13E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13E9
  ,simpleLowerCaseMapping:0x13E9
  ,simpleTitleCaseMapping:0x13E9
 },
 { code:0x13EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13EA
  ,simpleLowerCaseMapping:0x13EA
  ,simpleTitleCaseMapping:0x13EA
 },
 { code:0x13EB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13EB
  ,simpleLowerCaseMapping:0x13EB
  ,simpleTitleCaseMapping:0x13EB
 },
 { code:0x13EC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13EC
  ,simpleLowerCaseMapping:0x13EC
  ,simpleTitleCaseMapping:0x13EC
 },
 { code:0x13ED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13ED
  ,simpleLowerCaseMapping:0x13ED
  ,simpleTitleCaseMapping:0x13ED
 },
 { code:0x13EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13EE
  ,simpleLowerCaseMapping:0x13EE
  ,simpleTitleCaseMapping:0x13EE
 },
 { code:0x13EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13EF
  ,simpleLowerCaseMapping:0x13EF
  ,simpleTitleCaseMapping:0x13EF
 },
 { code:0x13F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13F0
  ,simpleLowerCaseMapping:0x13F0
  ,simpleTitleCaseMapping:0x13F0
 },
 { code:0x13F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13F1
  ,simpleLowerCaseMapping:0x13F1
  ,simpleTitleCaseMapping:0x13F1
 },
 { code:0x13F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13F2
  ,simpleLowerCaseMapping:0x13F2
  ,simpleTitleCaseMapping:0x13F2
 },
 { code:0x13F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13F3
  ,simpleLowerCaseMapping:0x13F3
  ,simpleTitleCaseMapping:0x13F3
 },
 { code:0x13F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x13F4
  ,simpleLowerCaseMapping:0x13F4
  ,simpleTitleCaseMapping:0x13F4
 },
 { code:0x1401
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1401
  ,simpleLowerCaseMapping:0x1401
  ,simpleTitleCaseMapping:0x1401
 },
 { code:0x1402
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1402
  ,simpleLowerCaseMapping:0x1402
  ,simpleTitleCaseMapping:0x1402
 },
 { code:0x1403
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1403
  ,simpleLowerCaseMapping:0x1403
  ,simpleTitleCaseMapping:0x1403
 },
 { code:0x1404
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1404
  ,simpleLowerCaseMapping:0x1404
  ,simpleTitleCaseMapping:0x1404
 },
 { code:0x1405
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1405
  ,simpleLowerCaseMapping:0x1405
  ,simpleTitleCaseMapping:0x1405
 },
 { code:0x1406
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1406
  ,simpleLowerCaseMapping:0x1406
  ,simpleTitleCaseMapping:0x1406
 },
 { code:0x1407
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1407
  ,simpleLowerCaseMapping:0x1407
  ,simpleTitleCaseMapping:0x1407
 },
 { code:0x1408
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1408
  ,simpleLowerCaseMapping:0x1408
  ,simpleTitleCaseMapping:0x1408
 },
 { code:0x1409
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1409
  ,simpleLowerCaseMapping:0x1409
  ,simpleTitleCaseMapping:0x1409
 },
 { code:0x140A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x140A
  ,simpleLowerCaseMapping:0x140A
  ,simpleTitleCaseMapping:0x140A
 },
 { code:0x140B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x140B
  ,simpleLowerCaseMapping:0x140B
  ,simpleTitleCaseMapping:0x140B
 },
 { code:0x140C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x140C
  ,simpleLowerCaseMapping:0x140C
  ,simpleTitleCaseMapping:0x140C
 },
 { code:0x140D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x140D
  ,simpleLowerCaseMapping:0x140D
  ,simpleTitleCaseMapping:0x140D
 },
 { code:0x140E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x140E
  ,simpleLowerCaseMapping:0x140E
  ,simpleTitleCaseMapping:0x140E
 },
 { code:0x140F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x140F
  ,simpleLowerCaseMapping:0x140F
  ,simpleTitleCaseMapping:0x140F
 },
 { code:0x1410
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1410
  ,simpleLowerCaseMapping:0x1410
  ,simpleTitleCaseMapping:0x1410
 },
 { code:0x1411
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1411
  ,simpleLowerCaseMapping:0x1411
  ,simpleTitleCaseMapping:0x1411
 },
 { code:0x1412
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1412
  ,simpleLowerCaseMapping:0x1412
  ,simpleTitleCaseMapping:0x1412
 },
 { code:0x1413
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1413
  ,simpleLowerCaseMapping:0x1413
  ,simpleTitleCaseMapping:0x1413
 },
 { code:0x1414
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1414
  ,simpleLowerCaseMapping:0x1414
  ,simpleTitleCaseMapping:0x1414
 },
 { code:0x1415
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1415
  ,simpleLowerCaseMapping:0x1415
  ,simpleTitleCaseMapping:0x1415
 },
 { code:0x1416
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1416
  ,simpleLowerCaseMapping:0x1416
  ,simpleTitleCaseMapping:0x1416
 },
 { code:0x1417
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1417
  ,simpleLowerCaseMapping:0x1417
  ,simpleTitleCaseMapping:0x1417
 },
 { code:0x1418
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1418
  ,simpleLowerCaseMapping:0x1418
  ,simpleTitleCaseMapping:0x1418
 },
 { code:0x1419
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1419
  ,simpleLowerCaseMapping:0x1419
  ,simpleTitleCaseMapping:0x1419
 },
 { code:0x141A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x141A
  ,simpleLowerCaseMapping:0x141A
  ,simpleTitleCaseMapping:0x141A
 },
 { code:0x141B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x141B
  ,simpleLowerCaseMapping:0x141B
  ,simpleTitleCaseMapping:0x141B
 },
 { code:0x141C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x141C
  ,simpleLowerCaseMapping:0x141C
  ,simpleTitleCaseMapping:0x141C
 },
 { code:0x141D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x141D
  ,simpleLowerCaseMapping:0x141D
  ,simpleTitleCaseMapping:0x141D
 },
 { code:0x141E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x141E
  ,simpleLowerCaseMapping:0x141E
  ,simpleTitleCaseMapping:0x141E
 },
 { code:0x141F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x141F
  ,simpleLowerCaseMapping:0x141F
  ,simpleTitleCaseMapping:0x141F
 },
 { code:0x1420
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1420
  ,simpleLowerCaseMapping:0x1420
  ,simpleTitleCaseMapping:0x1420
 },
 { code:0x1421
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1421
  ,simpleLowerCaseMapping:0x1421
  ,simpleTitleCaseMapping:0x1421
 },
 { code:0x1422
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1422
  ,simpleLowerCaseMapping:0x1422
  ,simpleTitleCaseMapping:0x1422
 },
 { code:0x1423
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1423
  ,simpleLowerCaseMapping:0x1423
  ,simpleTitleCaseMapping:0x1423
 },
 { code:0x1424
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1424
  ,simpleLowerCaseMapping:0x1424
  ,simpleTitleCaseMapping:0x1424
 },
 { code:0x1425
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1425
  ,simpleLowerCaseMapping:0x1425
  ,simpleTitleCaseMapping:0x1425
 },
 { code:0x1426
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1426
  ,simpleLowerCaseMapping:0x1426
  ,simpleTitleCaseMapping:0x1426
 },
 { code:0x1427
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1427
  ,simpleLowerCaseMapping:0x1427
  ,simpleTitleCaseMapping:0x1427
 },
 { code:0x1428
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1428
  ,simpleLowerCaseMapping:0x1428
  ,simpleTitleCaseMapping:0x1428
 },
 { code:0x1429
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1429
  ,simpleLowerCaseMapping:0x1429
  ,simpleTitleCaseMapping:0x1429
 },
 { code:0x142A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x142A
  ,simpleLowerCaseMapping:0x142A
  ,simpleTitleCaseMapping:0x142A
 },
 { code:0x142B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x142B
  ,simpleLowerCaseMapping:0x142B
  ,simpleTitleCaseMapping:0x142B
 },
 { code:0x142C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x142C
  ,simpleLowerCaseMapping:0x142C
  ,simpleTitleCaseMapping:0x142C
 },
 { code:0x142D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x142D
  ,simpleLowerCaseMapping:0x142D
  ,simpleTitleCaseMapping:0x142D
 },
 { code:0x142E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x142E
  ,simpleLowerCaseMapping:0x142E
  ,simpleTitleCaseMapping:0x142E
 },
 { code:0x142F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x142F
  ,simpleLowerCaseMapping:0x142F
  ,simpleTitleCaseMapping:0x142F
 },
 { code:0x1430
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1430
  ,simpleLowerCaseMapping:0x1430
  ,simpleTitleCaseMapping:0x1430
 },
 { code:0x1431
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1431
  ,simpleLowerCaseMapping:0x1431
  ,simpleTitleCaseMapping:0x1431
 },
 { code:0x1432
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1432
  ,simpleLowerCaseMapping:0x1432
  ,simpleTitleCaseMapping:0x1432
 },
 { code:0x1433
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1433
  ,simpleLowerCaseMapping:0x1433
  ,simpleTitleCaseMapping:0x1433
 },
 { code:0x1434
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1434
  ,simpleLowerCaseMapping:0x1434
  ,simpleTitleCaseMapping:0x1434
 },
 { code:0x1435
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1435
  ,simpleLowerCaseMapping:0x1435
  ,simpleTitleCaseMapping:0x1435
 },
 { code:0x1436
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1436
  ,simpleLowerCaseMapping:0x1436
  ,simpleTitleCaseMapping:0x1436
 },
 { code:0x1437
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1437
  ,simpleLowerCaseMapping:0x1437
  ,simpleTitleCaseMapping:0x1437
 },
 { code:0x1438
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1438
  ,simpleLowerCaseMapping:0x1438
  ,simpleTitleCaseMapping:0x1438
 },
 { code:0x1439
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1439
  ,simpleLowerCaseMapping:0x1439
  ,simpleTitleCaseMapping:0x1439
 },
 { code:0x143A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x143A
  ,simpleLowerCaseMapping:0x143A
  ,simpleTitleCaseMapping:0x143A
 },
 { code:0x143B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x143B
  ,simpleLowerCaseMapping:0x143B
  ,simpleTitleCaseMapping:0x143B
 },
 { code:0x143C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x143C
  ,simpleLowerCaseMapping:0x143C
  ,simpleTitleCaseMapping:0x143C
 },
 { code:0x143D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x143D
  ,simpleLowerCaseMapping:0x143D
  ,simpleTitleCaseMapping:0x143D
 },
 { code:0x143E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x143E
  ,simpleLowerCaseMapping:0x143E
  ,simpleTitleCaseMapping:0x143E
 },
 { code:0x143F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x143F
  ,simpleLowerCaseMapping:0x143F
  ,simpleTitleCaseMapping:0x143F
 },
 { code:0x1440
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1440
  ,simpleLowerCaseMapping:0x1440
  ,simpleTitleCaseMapping:0x1440
 },
 { code:0x1441
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1441
  ,simpleLowerCaseMapping:0x1441
  ,simpleTitleCaseMapping:0x1441
 },
 { code:0x1442
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1442
  ,simpleLowerCaseMapping:0x1442
  ,simpleTitleCaseMapping:0x1442
 },
 { code:0x1443
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1443
  ,simpleLowerCaseMapping:0x1443
  ,simpleTitleCaseMapping:0x1443
 },
 { code:0x1444
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1444
  ,simpleLowerCaseMapping:0x1444
  ,simpleTitleCaseMapping:0x1444
 },
 { code:0x1445
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1445
  ,simpleLowerCaseMapping:0x1445
  ,simpleTitleCaseMapping:0x1445
 },
 { code:0x1446
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1446
  ,simpleLowerCaseMapping:0x1446
  ,simpleTitleCaseMapping:0x1446
 },
 { code:0x1447
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1447
  ,simpleLowerCaseMapping:0x1447
  ,simpleTitleCaseMapping:0x1447
 },
 { code:0x1448
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1448
  ,simpleLowerCaseMapping:0x1448
  ,simpleTitleCaseMapping:0x1448
 },
 { code:0x1449
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1449
  ,simpleLowerCaseMapping:0x1449
  ,simpleTitleCaseMapping:0x1449
 },
 { code:0x144A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x144A
  ,simpleLowerCaseMapping:0x144A
  ,simpleTitleCaseMapping:0x144A
 },
 { code:0x144B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x144B
  ,simpleLowerCaseMapping:0x144B
  ,simpleTitleCaseMapping:0x144B
 },
 { code:0x144C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x144C
  ,simpleLowerCaseMapping:0x144C
  ,simpleTitleCaseMapping:0x144C
 },
 { code:0x144D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x144D
  ,simpleLowerCaseMapping:0x144D
  ,simpleTitleCaseMapping:0x144D
 },
 { code:0x144E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x144E
  ,simpleLowerCaseMapping:0x144E
  ,simpleTitleCaseMapping:0x144E
 },
 { code:0x144F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x144F
  ,simpleLowerCaseMapping:0x144F
  ,simpleTitleCaseMapping:0x144F
 },
 { code:0x1450
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1450
  ,simpleLowerCaseMapping:0x1450
  ,simpleTitleCaseMapping:0x1450
 },
 { code:0x1451
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1451
  ,simpleLowerCaseMapping:0x1451
  ,simpleTitleCaseMapping:0x1451
 },
 { code:0x1452
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1452
  ,simpleLowerCaseMapping:0x1452
  ,simpleTitleCaseMapping:0x1452
 },
 { code:0x1453
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1453
  ,simpleLowerCaseMapping:0x1453
  ,simpleTitleCaseMapping:0x1453
 },
 { code:0x1454
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1454
  ,simpleLowerCaseMapping:0x1454
  ,simpleTitleCaseMapping:0x1454
 },
 { code:0x1455
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1455
  ,simpleLowerCaseMapping:0x1455
  ,simpleTitleCaseMapping:0x1455
 },
 { code:0x1456
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1456
  ,simpleLowerCaseMapping:0x1456
  ,simpleTitleCaseMapping:0x1456
 },
 { code:0x1457
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1457
  ,simpleLowerCaseMapping:0x1457
  ,simpleTitleCaseMapping:0x1457
 },
 { code:0x1458
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1458
  ,simpleLowerCaseMapping:0x1458
  ,simpleTitleCaseMapping:0x1458
 },
 { code:0x1459
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1459
  ,simpleLowerCaseMapping:0x1459
  ,simpleTitleCaseMapping:0x1459
 },
 { code:0x145A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x145A
  ,simpleLowerCaseMapping:0x145A
  ,simpleTitleCaseMapping:0x145A
 },
 { code:0x145B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x145B
  ,simpleLowerCaseMapping:0x145B
  ,simpleTitleCaseMapping:0x145B
 },
 { code:0x145C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x145C
  ,simpleLowerCaseMapping:0x145C
  ,simpleTitleCaseMapping:0x145C
 },
 { code:0x145D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x145D
  ,simpleLowerCaseMapping:0x145D
  ,simpleTitleCaseMapping:0x145D
 },
 { code:0x145E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x145E
  ,simpleLowerCaseMapping:0x145E
  ,simpleTitleCaseMapping:0x145E
 },
 { code:0x145F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x145F
  ,simpleLowerCaseMapping:0x145F
  ,simpleTitleCaseMapping:0x145F
 },
 { code:0x1460
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1460
  ,simpleLowerCaseMapping:0x1460
  ,simpleTitleCaseMapping:0x1460
 },
 { code:0x1461
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1461
  ,simpleLowerCaseMapping:0x1461
  ,simpleTitleCaseMapping:0x1461
 },
 { code:0x1462
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1462
  ,simpleLowerCaseMapping:0x1462
  ,simpleTitleCaseMapping:0x1462
 },
 { code:0x1463
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1463
  ,simpleLowerCaseMapping:0x1463
  ,simpleTitleCaseMapping:0x1463
 },
 { code:0x1464
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1464
  ,simpleLowerCaseMapping:0x1464
  ,simpleTitleCaseMapping:0x1464
 },
 { code:0x1465
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1465
  ,simpleLowerCaseMapping:0x1465
  ,simpleTitleCaseMapping:0x1465
 },
 { code:0x1466
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1466
  ,simpleLowerCaseMapping:0x1466
  ,simpleTitleCaseMapping:0x1466
 },
 { code:0x1467
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1467
  ,simpleLowerCaseMapping:0x1467
  ,simpleTitleCaseMapping:0x1467
 },
 { code:0x1468
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1468
  ,simpleLowerCaseMapping:0x1468
  ,simpleTitleCaseMapping:0x1468
 },
 { code:0x1469
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1469
  ,simpleLowerCaseMapping:0x1469
  ,simpleTitleCaseMapping:0x1469
 },
 { code:0x146A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x146A
  ,simpleLowerCaseMapping:0x146A
  ,simpleTitleCaseMapping:0x146A
 },
 { code:0x146B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x146B
  ,simpleLowerCaseMapping:0x146B
  ,simpleTitleCaseMapping:0x146B
 },
 { code:0x146C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x146C
  ,simpleLowerCaseMapping:0x146C
  ,simpleTitleCaseMapping:0x146C
 },
 { code:0x146D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x146D
  ,simpleLowerCaseMapping:0x146D
  ,simpleTitleCaseMapping:0x146D
 },
 { code:0x146E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x146E
  ,simpleLowerCaseMapping:0x146E
  ,simpleTitleCaseMapping:0x146E
 },
 { code:0x146F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x146F
  ,simpleLowerCaseMapping:0x146F
  ,simpleTitleCaseMapping:0x146F
 },
 { code:0x1470
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1470
  ,simpleLowerCaseMapping:0x1470
  ,simpleTitleCaseMapping:0x1470
 },
 { code:0x1471
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1471
  ,simpleLowerCaseMapping:0x1471
  ,simpleTitleCaseMapping:0x1471
 },
 { code:0x1472
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1472
  ,simpleLowerCaseMapping:0x1472
  ,simpleTitleCaseMapping:0x1472
 },
 { code:0x1473
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1473
  ,simpleLowerCaseMapping:0x1473
  ,simpleTitleCaseMapping:0x1473
 },
 { code:0x1474
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1474
  ,simpleLowerCaseMapping:0x1474
  ,simpleTitleCaseMapping:0x1474
 },
 { code:0x1475
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1475
  ,simpleLowerCaseMapping:0x1475
  ,simpleTitleCaseMapping:0x1475
 },
 { code:0x1476
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1476
  ,simpleLowerCaseMapping:0x1476
  ,simpleTitleCaseMapping:0x1476
 },
 { code:0x1477
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1477
  ,simpleLowerCaseMapping:0x1477
  ,simpleTitleCaseMapping:0x1477
 },
 { code:0x1478
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1478
  ,simpleLowerCaseMapping:0x1478
  ,simpleTitleCaseMapping:0x1478
 },
 { code:0x1479
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1479
  ,simpleLowerCaseMapping:0x1479
  ,simpleTitleCaseMapping:0x1479
 },
 { code:0x147A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x147A
  ,simpleLowerCaseMapping:0x147A
  ,simpleTitleCaseMapping:0x147A
 },
 { code:0x147B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x147B
  ,simpleLowerCaseMapping:0x147B
  ,simpleTitleCaseMapping:0x147B
 },
 { code:0x147C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x147C
  ,simpleLowerCaseMapping:0x147C
  ,simpleTitleCaseMapping:0x147C
 },
 { code:0x147D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x147D
  ,simpleLowerCaseMapping:0x147D
  ,simpleTitleCaseMapping:0x147D
 },
 { code:0x147E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x147E
  ,simpleLowerCaseMapping:0x147E
  ,simpleTitleCaseMapping:0x147E
 },
 { code:0x147F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x147F
  ,simpleLowerCaseMapping:0x147F
  ,simpleTitleCaseMapping:0x147F
 },
 { code:0x1480
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1480
  ,simpleLowerCaseMapping:0x1480
  ,simpleTitleCaseMapping:0x1480
 },
 { code:0x1481
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1481
  ,simpleLowerCaseMapping:0x1481
  ,simpleTitleCaseMapping:0x1481
 },
 { code:0x1482
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1482
  ,simpleLowerCaseMapping:0x1482
  ,simpleTitleCaseMapping:0x1482
 },
 { code:0x1483
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1483
  ,simpleLowerCaseMapping:0x1483
  ,simpleTitleCaseMapping:0x1483
 },
 { code:0x1484
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1484
  ,simpleLowerCaseMapping:0x1484
  ,simpleTitleCaseMapping:0x1484
 },
 { code:0x1485
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1485
  ,simpleLowerCaseMapping:0x1485
  ,simpleTitleCaseMapping:0x1485
 },
 { code:0x1486
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1486
  ,simpleLowerCaseMapping:0x1486
  ,simpleTitleCaseMapping:0x1486
 },
 { code:0x1487
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1487
  ,simpleLowerCaseMapping:0x1487
  ,simpleTitleCaseMapping:0x1487
 },
 { code:0x1488
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1488
  ,simpleLowerCaseMapping:0x1488
  ,simpleTitleCaseMapping:0x1488
 },
 { code:0x1489
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1489
  ,simpleLowerCaseMapping:0x1489
  ,simpleTitleCaseMapping:0x1489
 },
 { code:0x148A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x148A
  ,simpleLowerCaseMapping:0x148A
  ,simpleTitleCaseMapping:0x148A
 },
 { code:0x148B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x148B
  ,simpleLowerCaseMapping:0x148B
  ,simpleTitleCaseMapping:0x148B
 },
 { code:0x148C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x148C
  ,simpleLowerCaseMapping:0x148C
  ,simpleTitleCaseMapping:0x148C
 },
 { code:0x148D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x148D
  ,simpleLowerCaseMapping:0x148D
  ,simpleTitleCaseMapping:0x148D
 },
 { code:0x148E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x148E
  ,simpleLowerCaseMapping:0x148E
  ,simpleTitleCaseMapping:0x148E
 },
 { code:0x148F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x148F
  ,simpleLowerCaseMapping:0x148F
  ,simpleTitleCaseMapping:0x148F
 },
 { code:0x1490
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1490
  ,simpleLowerCaseMapping:0x1490
  ,simpleTitleCaseMapping:0x1490
 },
 { code:0x1491
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1491
  ,simpleLowerCaseMapping:0x1491
  ,simpleTitleCaseMapping:0x1491
 },
 { code:0x1492
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1492
  ,simpleLowerCaseMapping:0x1492
  ,simpleTitleCaseMapping:0x1492
 },
 { code:0x1493
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1493
  ,simpleLowerCaseMapping:0x1493
  ,simpleTitleCaseMapping:0x1493
 },
 { code:0x1494
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1494
  ,simpleLowerCaseMapping:0x1494
  ,simpleTitleCaseMapping:0x1494
 },
 { code:0x1495
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1495
  ,simpleLowerCaseMapping:0x1495
  ,simpleTitleCaseMapping:0x1495
 },
 { code:0x1496
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1496
  ,simpleLowerCaseMapping:0x1496
  ,simpleTitleCaseMapping:0x1496
 },
 { code:0x1497
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1497
  ,simpleLowerCaseMapping:0x1497
  ,simpleTitleCaseMapping:0x1497
 },
 { code:0x1498
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1498
  ,simpleLowerCaseMapping:0x1498
  ,simpleTitleCaseMapping:0x1498
 },
 { code:0x1499
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1499
  ,simpleLowerCaseMapping:0x1499
  ,simpleTitleCaseMapping:0x1499
 },
 { code:0x149A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x149A
  ,simpleLowerCaseMapping:0x149A
  ,simpleTitleCaseMapping:0x149A
 },
 { code:0x149B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x149B
  ,simpleLowerCaseMapping:0x149B
  ,simpleTitleCaseMapping:0x149B
 },
 { code:0x149C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x149C
  ,simpleLowerCaseMapping:0x149C
  ,simpleTitleCaseMapping:0x149C
 },
 { code:0x149D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x149D
  ,simpleLowerCaseMapping:0x149D
  ,simpleTitleCaseMapping:0x149D
 },
 { code:0x149E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x149E
  ,simpleLowerCaseMapping:0x149E
  ,simpleTitleCaseMapping:0x149E
 },
 { code:0x149F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x149F
  ,simpleLowerCaseMapping:0x149F
  ,simpleTitleCaseMapping:0x149F
 },
 { code:0x14A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14A0
  ,simpleLowerCaseMapping:0x14A0
  ,simpleTitleCaseMapping:0x14A0
 },
 { code:0x14A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14A1
  ,simpleLowerCaseMapping:0x14A1
  ,simpleTitleCaseMapping:0x14A1
 },
 { code:0x14A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14A2
  ,simpleLowerCaseMapping:0x14A2
  ,simpleTitleCaseMapping:0x14A2
 },
 { code:0x14A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14A3
  ,simpleLowerCaseMapping:0x14A3
  ,simpleTitleCaseMapping:0x14A3
 },
 { code:0x14A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14A4
  ,simpleLowerCaseMapping:0x14A4
  ,simpleTitleCaseMapping:0x14A4
 },
 { code:0x14A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14A5
  ,simpleLowerCaseMapping:0x14A5
  ,simpleTitleCaseMapping:0x14A5
 },
 { code:0x14A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14A6
  ,simpleLowerCaseMapping:0x14A6
  ,simpleTitleCaseMapping:0x14A6
 },
 { code:0x14A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14A7
  ,simpleLowerCaseMapping:0x14A7
  ,simpleTitleCaseMapping:0x14A7
 },
 { code:0x14A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14A8
  ,simpleLowerCaseMapping:0x14A8
  ,simpleTitleCaseMapping:0x14A8
 },
 { code:0x14A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14A9
  ,simpleLowerCaseMapping:0x14A9
  ,simpleTitleCaseMapping:0x14A9
 },
 { code:0x14AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14AA
  ,simpleLowerCaseMapping:0x14AA
  ,simpleTitleCaseMapping:0x14AA
 },
 { code:0x14AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14AB
  ,simpleLowerCaseMapping:0x14AB
  ,simpleTitleCaseMapping:0x14AB
 },
 { code:0x14AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14AC
  ,simpleLowerCaseMapping:0x14AC
  ,simpleTitleCaseMapping:0x14AC
 },
 { code:0x14AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14AD
  ,simpleLowerCaseMapping:0x14AD
  ,simpleTitleCaseMapping:0x14AD
 },
 { code:0x14AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14AE
  ,simpleLowerCaseMapping:0x14AE
  ,simpleTitleCaseMapping:0x14AE
 },
 { code:0x14AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14AF
  ,simpleLowerCaseMapping:0x14AF
  ,simpleTitleCaseMapping:0x14AF
 },
 { code:0x14B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14B0
  ,simpleLowerCaseMapping:0x14B0
  ,simpleTitleCaseMapping:0x14B0
 },
 { code:0x14B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14B1
  ,simpleLowerCaseMapping:0x14B1
  ,simpleTitleCaseMapping:0x14B1
 },
 { code:0x14B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14B2
  ,simpleLowerCaseMapping:0x14B2
  ,simpleTitleCaseMapping:0x14B2
 },
 { code:0x14B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14B3
  ,simpleLowerCaseMapping:0x14B3
  ,simpleTitleCaseMapping:0x14B3
 },
 { code:0x14B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14B4
  ,simpleLowerCaseMapping:0x14B4
  ,simpleTitleCaseMapping:0x14B4
 },
 { code:0x14B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14B5
  ,simpleLowerCaseMapping:0x14B5
  ,simpleTitleCaseMapping:0x14B5
 },
 { code:0x14B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14B6
  ,simpleLowerCaseMapping:0x14B6
  ,simpleTitleCaseMapping:0x14B6
 },
 { code:0x14B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14B7
  ,simpleLowerCaseMapping:0x14B7
  ,simpleTitleCaseMapping:0x14B7
 },
 { code:0x14B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14B8
  ,simpleLowerCaseMapping:0x14B8
  ,simpleTitleCaseMapping:0x14B8
 },
 { code:0x14B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14B9
  ,simpleLowerCaseMapping:0x14B9
  ,simpleTitleCaseMapping:0x14B9
 },
 { code:0x14BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14BA
  ,simpleLowerCaseMapping:0x14BA
  ,simpleTitleCaseMapping:0x14BA
 },
 { code:0x14BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14BB
  ,simpleLowerCaseMapping:0x14BB
  ,simpleTitleCaseMapping:0x14BB
 },
 { code:0x14BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14BC
  ,simpleLowerCaseMapping:0x14BC
  ,simpleTitleCaseMapping:0x14BC
 },
 { code:0x14BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14BD
  ,simpleLowerCaseMapping:0x14BD
  ,simpleTitleCaseMapping:0x14BD
 },
 { code:0x14BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14BE
  ,simpleLowerCaseMapping:0x14BE
  ,simpleTitleCaseMapping:0x14BE
 },
 { code:0x14BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14BF
  ,simpleLowerCaseMapping:0x14BF
  ,simpleTitleCaseMapping:0x14BF
 },
 { code:0x14C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14C0
  ,simpleLowerCaseMapping:0x14C0
  ,simpleTitleCaseMapping:0x14C0
 },
 { code:0x14C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14C1
  ,simpleLowerCaseMapping:0x14C1
  ,simpleTitleCaseMapping:0x14C1
 },
 { code:0x14C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14C2
  ,simpleLowerCaseMapping:0x14C2
  ,simpleTitleCaseMapping:0x14C2
 },
 { code:0x14C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14C3
  ,simpleLowerCaseMapping:0x14C3
  ,simpleTitleCaseMapping:0x14C3
 },
 { code:0x14C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14C4
  ,simpleLowerCaseMapping:0x14C4
  ,simpleTitleCaseMapping:0x14C4
 },
 { code:0x14C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14C5
  ,simpleLowerCaseMapping:0x14C5
  ,simpleTitleCaseMapping:0x14C5
 },
 { code:0x14C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14C6
  ,simpleLowerCaseMapping:0x14C6
  ,simpleTitleCaseMapping:0x14C6
 },
 { code:0x14C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14C7
  ,simpleLowerCaseMapping:0x14C7
  ,simpleTitleCaseMapping:0x14C7
 },
 { code:0x14C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14C8
  ,simpleLowerCaseMapping:0x14C8
  ,simpleTitleCaseMapping:0x14C8
 },
 { code:0x14C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14C9
  ,simpleLowerCaseMapping:0x14C9
  ,simpleTitleCaseMapping:0x14C9
 },
 { code:0x14CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14CA
  ,simpleLowerCaseMapping:0x14CA
  ,simpleTitleCaseMapping:0x14CA
 },
 { code:0x14CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14CB
  ,simpleLowerCaseMapping:0x14CB
  ,simpleTitleCaseMapping:0x14CB
 },
 { code:0x14CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14CC
  ,simpleLowerCaseMapping:0x14CC
  ,simpleTitleCaseMapping:0x14CC
 },
 { code:0x14CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14CD
  ,simpleLowerCaseMapping:0x14CD
  ,simpleTitleCaseMapping:0x14CD
 },
 { code:0x14CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14CE
  ,simpleLowerCaseMapping:0x14CE
  ,simpleTitleCaseMapping:0x14CE
 },
 { code:0x14CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14CF
  ,simpleLowerCaseMapping:0x14CF
  ,simpleTitleCaseMapping:0x14CF
 },
 { code:0x14D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14D0
  ,simpleLowerCaseMapping:0x14D0
  ,simpleTitleCaseMapping:0x14D0
 },
 { code:0x14D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14D1
  ,simpleLowerCaseMapping:0x14D1
  ,simpleTitleCaseMapping:0x14D1
 },
 { code:0x14D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14D2
  ,simpleLowerCaseMapping:0x14D2
  ,simpleTitleCaseMapping:0x14D2
 },
 { code:0x14D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14D3
  ,simpleLowerCaseMapping:0x14D3
  ,simpleTitleCaseMapping:0x14D3
 },
 { code:0x14D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14D4
  ,simpleLowerCaseMapping:0x14D4
  ,simpleTitleCaseMapping:0x14D4
 },
 { code:0x14D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14D5
  ,simpleLowerCaseMapping:0x14D5
  ,simpleTitleCaseMapping:0x14D5
 },
 { code:0x14D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14D6
  ,simpleLowerCaseMapping:0x14D6
  ,simpleTitleCaseMapping:0x14D6
 },
 { code:0x14D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14D7
  ,simpleLowerCaseMapping:0x14D7
  ,simpleTitleCaseMapping:0x14D7
 },
 { code:0x14D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14D8
  ,simpleLowerCaseMapping:0x14D8
  ,simpleTitleCaseMapping:0x14D8
 },
 { code:0x14D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14D9
  ,simpleLowerCaseMapping:0x14D9
  ,simpleTitleCaseMapping:0x14D9
 },
 { code:0x14DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14DA
  ,simpleLowerCaseMapping:0x14DA
  ,simpleTitleCaseMapping:0x14DA
 },
 { code:0x14DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14DB
  ,simpleLowerCaseMapping:0x14DB
  ,simpleTitleCaseMapping:0x14DB
 },
 { code:0x14DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14DC
  ,simpleLowerCaseMapping:0x14DC
  ,simpleTitleCaseMapping:0x14DC
 },
 { code:0x14DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14DD
  ,simpleLowerCaseMapping:0x14DD
  ,simpleTitleCaseMapping:0x14DD
 },
 { code:0x14DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14DE
  ,simpleLowerCaseMapping:0x14DE
  ,simpleTitleCaseMapping:0x14DE
 },
 { code:0x14DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14DF
  ,simpleLowerCaseMapping:0x14DF
  ,simpleTitleCaseMapping:0x14DF
 },
 { code:0x14E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14E0
  ,simpleLowerCaseMapping:0x14E0
  ,simpleTitleCaseMapping:0x14E0
 },
 { code:0x14E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14E1
  ,simpleLowerCaseMapping:0x14E1
  ,simpleTitleCaseMapping:0x14E1
 },
 { code:0x14E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14E2
  ,simpleLowerCaseMapping:0x14E2
  ,simpleTitleCaseMapping:0x14E2
 },
 { code:0x14E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14E3
  ,simpleLowerCaseMapping:0x14E3
  ,simpleTitleCaseMapping:0x14E3
 },
 { code:0x14E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14E4
  ,simpleLowerCaseMapping:0x14E4
  ,simpleTitleCaseMapping:0x14E4
 },
 { code:0x14E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14E5
  ,simpleLowerCaseMapping:0x14E5
  ,simpleTitleCaseMapping:0x14E5
 },
 { code:0x14E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14E6
  ,simpleLowerCaseMapping:0x14E6
  ,simpleTitleCaseMapping:0x14E6
 },
 { code:0x14E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14E7
  ,simpleLowerCaseMapping:0x14E7
  ,simpleTitleCaseMapping:0x14E7
 },
 { code:0x14E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14E8
  ,simpleLowerCaseMapping:0x14E8
  ,simpleTitleCaseMapping:0x14E8
 },
 { code:0x14E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14E9
  ,simpleLowerCaseMapping:0x14E9
  ,simpleTitleCaseMapping:0x14E9
 },
 { code:0x14EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14EA
  ,simpleLowerCaseMapping:0x14EA
  ,simpleTitleCaseMapping:0x14EA
 },
 { code:0x14EB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14EB
  ,simpleLowerCaseMapping:0x14EB
  ,simpleTitleCaseMapping:0x14EB
 },
 { code:0x14EC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14EC
  ,simpleLowerCaseMapping:0x14EC
  ,simpleTitleCaseMapping:0x14EC
 },
 { code:0x14ED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14ED
  ,simpleLowerCaseMapping:0x14ED
  ,simpleTitleCaseMapping:0x14ED
 },
 { code:0x14EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14EE
  ,simpleLowerCaseMapping:0x14EE
  ,simpleTitleCaseMapping:0x14EE
 },
 { code:0x14EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14EF
  ,simpleLowerCaseMapping:0x14EF
  ,simpleTitleCaseMapping:0x14EF
 },
 { code:0x14F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14F0
  ,simpleLowerCaseMapping:0x14F0
  ,simpleTitleCaseMapping:0x14F0
 },
 { code:0x14F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14F1
  ,simpleLowerCaseMapping:0x14F1
  ,simpleTitleCaseMapping:0x14F1
 },
 { code:0x14F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14F2
  ,simpleLowerCaseMapping:0x14F2
  ,simpleTitleCaseMapping:0x14F2
 },
 { code:0x14F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14F3
  ,simpleLowerCaseMapping:0x14F3
  ,simpleTitleCaseMapping:0x14F3
 },
 { code:0x14F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14F4
  ,simpleLowerCaseMapping:0x14F4
  ,simpleTitleCaseMapping:0x14F4
 },
 { code:0x14F5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14F5
  ,simpleLowerCaseMapping:0x14F5
  ,simpleTitleCaseMapping:0x14F5
 },
 { code:0x14F6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14F6
  ,simpleLowerCaseMapping:0x14F6
  ,simpleTitleCaseMapping:0x14F6
 },
 { code:0x14F7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14F7
  ,simpleLowerCaseMapping:0x14F7
  ,simpleTitleCaseMapping:0x14F7
 },
 { code:0x14F8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14F8
  ,simpleLowerCaseMapping:0x14F8
  ,simpleTitleCaseMapping:0x14F8
 },
 { code:0x14F9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14F9
  ,simpleLowerCaseMapping:0x14F9
  ,simpleTitleCaseMapping:0x14F9
 },
 { code:0x14FA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14FA
  ,simpleLowerCaseMapping:0x14FA
  ,simpleTitleCaseMapping:0x14FA
 },
 { code:0x14FB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14FB
  ,simpleLowerCaseMapping:0x14FB
  ,simpleTitleCaseMapping:0x14FB
 },
 { code:0x14FC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14FC
  ,simpleLowerCaseMapping:0x14FC
  ,simpleTitleCaseMapping:0x14FC
 },
 { code:0x14FD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14FD
  ,simpleLowerCaseMapping:0x14FD
  ,simpleTitleCaseMapping:0x14FD
 },
 { code:0x14FE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14FE
  ,simpleLowerCaseMapping:0x14FE
  ,simpleTitleCaseMapping:0x14FE
 },
 { code:0x14FF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x14FF
  ,simpleLowerCaseMapping:0x14FF
  ,simpleTitleCaseMapping:0x14FF
 },
 { code:0x1500
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1500
  ,simpleLowerCaseMapping:0x1500
  ,simpleTitleCaseMapping:0x1500
 },
 { code:0x1501
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1501
  ,simpleLowerCaseMapping:0x1501
  ,simpleTitleCaseMapping:0x1501
 },
 { code:0x1502
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1502
  ,simpleLowerCaseMapping:0x1502
  ,simpleTitleCaseMapping:0x1502
 },
 { code:0x1503
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1503
  ,simpleLowerCaseMapping:0x1503
  ,simpleTitleCaseMapping:0x1503
 },
 { code:0x1504
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1504
  ,simpleLowerCaseMapping:0x1504
  ,simpleTitleCaseMapping:0x1504
 },
 { code:0x1505
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1505
  ,simpleLowerCaseMapping:0x1505
  ,simpleTitleCaseMapping:0x1505
 },
 { code:0x1506
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1506
  ,simpleLowerCaseMapping:0x1506
  ,simpleTitleCaseMapping:0x1506
 },
 { code:0x1507
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1507
  ,simpleLowerCaseMapping:0x1507
  ,simpleTitleCaseMapping:0x1507
 },
 { code:0x1508
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1508
  ,simpleLowerCaseMapping:0x1508
  ,simpleTitleCaseMapping:0x1508
 },
 { code:0x1509
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1509
  ,simpleLowerCaseMapping:0x1509
  ,simpleTitleCaseMapping:0x1509
 },
 { code:0x150A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x150A
  ,simpleLowerCaseMapping:0x150A
  ,simpleTitleCaseMapping:0x150A
 },
 { code:0x150B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x150B
  ,simpleLowerCaseMapping:0x150B
  ,simpleTitleCaseMapping:0x150B
 },
 { code:0x150C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x150C
  ,simpleLowerCaseMapping:0x150C
  ,simpleTitleCaseMapping:0x150C
 },
 { code:0x150D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x150D
  ,simpleLowerCaseMapping:0x150D
  ,simpleTitleCaseMapping:0x150D
 },
 { code:0x150E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x150E
  ,simpleLowerCaseMapping:0x150E
  ,simpleTitleCaseMapping:0x150E
 },
 { code:0x150F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x150F
  ,simpleLowerCaseMapping:0x150F
  ,simpleTitleCaseMapping:0x150F
 },
 { code:0x1510
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1510
  ,simpleLowerCaseMapping:0x1510
  ,simpleTitleCaseMapping:0x1510
 },
 { code:0x1511
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1511
  ,simpleLowerCaseMapping:0x1511
  ,simpleTitleCaseMapping:0x1511
 },
 { code:0x1512
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1512
  ,simpleLowerCaseMapping:0x1512
  ,simpleTitleCaseMapping:0x1512
 },
 { code:0x1513
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1513
  ,simpleLowerCaseMapping:0x1513
  ,simpleTitleCaseMapping:0x1513
 },
 { code:0x1514
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1514
  ,simpleLowerCaseMapping:0x1514
  ,simpleTitleCaseMapping:0x1514
 },
 { code:0x1515
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1515
  ,simpleLowerCaseMapping:0x1515
  ,simpleTitleCaseMapping:0x1515
 },
 { code:0x1516
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1516
  ,simpleLowerCaseMapping:0x1516
  ,simpleTitleCaseMapping:0x1516
 },
 { code:0x1517
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1517
  ,simpleLowerCaseMapping:0x1517
  ,simpleTitleCaseMapping:0x1517
 },
 { code:0x1518
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1518
  ,simpleLowerCaseMapping:0x1518
  ,simpleTitleCaseMapping:0x1518
 },
 { code:0x1519
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1519
  ,simpleLowerCaseMapping:0x1519
  ,simpleTitleCaseMapping:0x1519
 },
 { code:0x151A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x151A
  ,simpleLowerCaseMapping:0x151A
  ,simpleTitleCaseMapping:0x151A
 },
 { code:0x151B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x151B
  ,simpleLowerCaseMapping:0x151B
  ,simpleTitleCaseMapping:0x151B
 },
 { code:0x151C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x151C
  ,simpleLowerCaseMapping:0x151C
  ,simpleTitleCaseMapping:0x151C
 },
 { code:0x151D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x151D
  ,simpleLowerCaseMapping:0x151D
  ,simpleTitleCaseMapping:0x151D
 },
 { code:0x151E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x151E
  ,simpleLowerCaseMapping:0x151E
  ,simpleTitleCaseMapping:0x151E
 },
 { code:0x151F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x151F
  ,simpleLowerCaseMapping:0x151F
  ,simpleTitleCaseMapping:0x151F
 },
 { code:0x1520
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1520
  ,simpleLowerCaseMapping:0x1520
  ,simpleTitleCaseMapping:0x1520
 },
 { code:0x1521
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1521
  ,simpleLowerCaseMapping:0x1521
  ,simpleTitleCaseMapping:0x1521
 },
 { code:0x1522
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1522
  ,simpleLowerCaseMapping:0x1522
  ,simpleTitleCaseMapping:0x1522
 },
 { code:0x1523
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1523
  ,simpleLowerCaseMapping:0x1523
  ,simpleTitleCaseMapping:0x1523
 },
 { code:0x1524
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1524
  ,simpleLowerCaseMapping:0x1524
  ,simpleTitleCaseMapping:0x1524
 },
 { code:0x1525
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1525
  ,simpleLowerCaseMapping:0x1525
  ,simpleTitleCaseMapping:0x1525
 },
 { code:0x1526
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1526
  ,simpleLowerCaseMapping:0x1526
  ,simpleTitleCaseMapping:0x1526
 },
 { code:0x1527
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1527
  ,simpleLowerCaseMapping:0x1527
  ,simpleTitleCaseMapping:0x1527
 },
 { code:0x1528
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1528
  ,simpleLowerCaseMapping:0x1528
  ,simpleTitleCaseMapping:0x1528
 },
 { code:0x1529
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1529
  ,simpleLowerCaseMapping:0x1529
  ,simpleTitleCaseMapping:0x1529
 },
 { code:0x152A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x152A
  ,simpleLowerCaseMapping:0x152A
  ,simpleTitleCaseMapping:0x152A
 },
 { code:0x152B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x152B
  ,simpleLowerCaseMapping:0x152B
  ,simpleTitleCaseMapping:0x152B
 },
 { code:0x152C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x152C
  ,simpleLowerCaseMapping:0x152C
  ,simpleTitleCaseMapping:0x152C
 },
 { code:0x152D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x152D
  ,simpleLowerCaseMapping:0x152D
  ,simpleTitleCaseMapping:0x152D
 },
 { code:0x152E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x152E
  ,simpleLowerCaseMapping:0x152E
  ,simpleTitleCaseMapping:0x152E
 },
 { code:0x152F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x152F
  ,simpleLowerCaseMapping:0x152F
  ,simpleTitleCaseMapping:0x152F
 },
 { code:0x1530
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1530
  ,simpleLowerCaseMapping:0x1530
  ,simpleTitleCaseMapping:0x1530
 },
 { code:0x1531
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1531
  ,simpleLowerCaseMapping:0x1531
  ,simpleTitleCaseMapping:0x1531
 },
 { code:0x1532
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1532
  ,simpleLowerCaseMapping:0x1532
  ,simpleTitleCaseMapping:0x1532
 },
 { code:0x1533
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1533
  ,simpleLowerCaseMapping:0x1533
  ,simpleTitleCaseMapping:0x1533
 },
 { code:0x1534
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1534
  ,simpleLowerCaseMapping:0x1534
  ,simpleTitleCaseMapping:0x1534
 },
 { code:0x1535
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1535
  ,simpleLowerCaseMapping:0x1535
  ,simpleTitleCaseMapping:0x1535
 },
 { code:0x1536
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1536
  ,simpleLowerCaseMapping:0x1536
  ,simpleTitleCaseMapping:0x1536
 },
 { code:0x1537
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1537
  ,simpleLowerCaseMapping:0x1537
  ,simpleTitleCaseMapping:0x1537
 },
 { code:0x1538
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1538
  ,simpleLowerCaseMapping:0x1538
  ,simpleTitleCaseMapping:0x1538
 },
 { code:0x1539
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1539
  ,simpleLowerCaseMapping:0x1539
  ,simpleTitleCaseMapping:0x1539
 },
 { code:0x153A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x153A
  ,simpleLowerCaseMapping:0x153A
  ,simpleTitleCaseMapping:0x153A
 },
 { code:0x153B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x153B
  ,simpleLowerCaseMapping:0x153B
  ,simpleTitleCaseMapping:0x153B
 },
 { code:0x153C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x153C
  ,simpleLowerCaseMapping:0x153C
  ,simpleTitleCaseMapping:0x153C
 },
 { code:0x153D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x153D
  ,simpleLowerCaseMapping:0x153D
  ,simpleTitleCaseMapping:0x153D
 },
 { code:0x153E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x153E
  ,simpleLowerCaseMapping:0x153E
  ,simpleTitleCaseMapping:0x153E
 },
 { code:0x153F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x153F
  ,simpleLowerCaseMapping:0x153F
  ,simpleTitleCaseMapping:0x153F
 },
 { code:0x1540
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1540
  ,simpleLowerCaseMapping:0x1540
  ,simpleTitleCaseMapping:0x1540
 },
 { code:0x1541
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1541
  ,simpleLowerCaseMapping:0x1541
  ,simpleTitleCaseMapping:0x1541
 },
 { code:0x1542
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1542
  ,simpleLowerCaseMapping:0x1542
  ,simpleTitleCaseMapping:0x1542
 },
 { code:0x1543
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1543
  ,simpleLowerCaseMapping:0x1543
  ,simpleTitleCaseMapping:0x1543
 },
 { code:0x1544
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1544
  ,simpleLowerCaseMapping:0x1544
  ,simpleTitleCaseMapping:0x1544
 },
 { code:0x1545
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1545
  ,simpleLowerCaseMapping:0x1545
  ,simpleTitleCaseMapping:0x1545
 },
 { code:0x1546
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1546
  ,simpleLowerCaseMapping:0x1546
  ,simpleTitleCaseMapping:0x1546
 },
 { code:0x1547
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1547
  ,simpleLowerCaseMapping:0x1547
  ,simpleTitleCaseMapping:0x1547
 },
 { code:0x1548
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1548
  ,simpleLowerCaseMapping:0x1548
  ,simpleTitleCaseMapping:0x1548
 },
 { code:0x1549
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1549
  ,simpleLowerCaseMapping:0x1549
  ,simpleTitleCaseMapping:0x1549
 },
 { code:0x154A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x154A
  ,simpleLowerCaseMapping:0x154A
  ,simpleTitleCaseMapping:0x154A
 },
 { code:0x154B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x154B
  ,simpleLowerCaseMapping:0x154B
  ,simpleTitleCaseMapping:0x154B
 },
 { code:0x154C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x154C
  ,simpleLowerCaseMapping:0x154C
  ,simpleTitleCaseMapping:0x154C
 },
 { code:0x154D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x154D
  ,simpleLowerCaseMapping:0x154D
  ,simpleTitleCaseMapping:0x154D
 },
 { code:0x154E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x154E
  ,simpleLowerCaseMapping:0x154E
  ,simpleTitleCaseMapping:0x154E
 },
 { code:0x154F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x154F
  ,simpleLowerCaseMapping:0x154F
  ,simpleTitleCaseMapping:0x154F
 },
 { code:0x1550
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1550
  ,simpleLowerCaseMapping:0x1550
  ,simpleTitleCaseMapping:0x1550
 },
 { code:0x1551
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1551
  ,simpleLowerCaseMapping:0x1551
  ,simpleTitleCaseMapping:0x1551
 },
 { code:0x1552
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1552
  ,simpleLowerCaseMapping:0x1552
  ,simpleTitleCaseMapping:0x1552
 },
 { code:0x1553
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1553
  ,simpleLowerCaseMapping:0x1553
  ,simpleTitleCaseMapping:0x1553
 },
 { code:0x1554
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1554
  ,simpleLowerCaseMapping:0x1554
  ,simpleTitleCaseMapping:0x1554
 },
 { code:0x1555
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1555
  ,simpleLowerCaseMapping:0x1555
  ,simpleTitleCaseMapping:0x1555
 },
 { code:0x1556
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1556
  ,simpleLowerCaseMapping:0x1556
  ,simpleTitleCaseMapping:0x1556
 },
 { code:0x1557
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1557
  ,simpleLowerCaseMapping:0x1557
  ,simpleTitleCaseMapping:0x1557
 },
 { code:0x1558
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1558
  ,simpleLowerCaseMapping:0x1558
  ,simpleTitleCaseMapping:0x1558
 },
 { code:0x1559
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1559
  ,simpleLowerCaseMapping:0x1559
  ,simpleTitleCaseMapping:0x1559
 },
 { code:0x155A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x155A
  ,simpleLowerCaseMapping:0x155A
  ,simpleTitleCaseMapping:0x155A
 },
 { code:0x155B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x155B
  ,simpleLowerCaseMapping:0x155B
  ,simpleTitleCaseMapping:0x155B
 },
 { code:0x155C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x155C
  ,simpleLowerCaseMapping:0x155C
  ,simpleTitleCaseMapping:0x155C
 },
 { code:0x155D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x155D
  ,simpleLowerCaseMapping:0x155D
  ,simpleTitleCaseMapping:0x155D
 },
 { code:0x155E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x155E
  ,simpleLowerCaseMapping:0x155E
  ,simpleTitleCaseMapping:0x155E
 },
 { code:0x155F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x155F
  ,simpleLowerCaseMapping:0x155F
  ,simpleTitleCaseMapping:0x155F
 },
 { code:0x1560
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1560
  ,simpleLowerCaseMapping:0x1560
  ,simpleTitleCaseMapping:0x1560
 },
 { code:0x1561
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1561
  ,simpleLowerCaseMapping:0x1561
  ,simpleTitleCaseMapping:0x1561
 },
 { code:0x1562
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1562
  ,simpleLowerCaseMapping:0x1562
  ,simpleTitleCaseMapping:0x1562
 },
 { code:0x1563
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1563
  ,simpleLowerCaseMapping:0x1563
  ,simpleTitleCaseMapping:0x1563
 },
 { code:0x1564
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1564
  ,simpleLowerCaseMapping:0x1564
  ,simpleTitleCaseMapping:0x1564
 },
 { code:0x1565
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1565
  ,simpleLowerCaseMapping:0x1565
  ,simpleTitleCaseMapping:0x1565
 },
 { code:0x1566
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1566
  ,simpleLowerCaseMapping:0x1566
  ,simpleTitleCaseMapping:0x1566
 },
 { code:0x1567
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1567
  ,simpleLowerCaseMapping:0x1567
  ,simpleTitleCaseMapping:0x1567
 },
 { code:0x1568
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1568
  ,simpleLowerCaseMapping:0x1568
  ,simpleTitleCaseMapping:0x1568
 },
 { code:0x1569
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1569
  ,simpleLowerCaseMapping:0x1569
  ,simpleTitleCaseMapping:0x1569
 },
 { code:0x156A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x156A
  ,simpleLowerCaseMapping:0x156A
  ,simpleTitleCaseMapping:0x156A
 },
 { code:0x156B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x156B
  ,simpleLowerCaseMapping:0x156B
  ,simpleTitleCaseMapping:0x156B
 },
 { code:0x156C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x156C
  ,simpleLowerCaseMapping:0x156C
  ,simpleTitleCaseMapping:0x156C
 },
 { code:0x156D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x156D
  ,simpleLowerCaseMapping:0x156D
  ,simpleTitleCaseMapping:0x156D
 },
 { code:0x156E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x156E
  ,simpleLowerCaseMapping:0x156E
  ,simpleTitleCaseMapping:0x156E
 },
 { code:0x156F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x156F
  ,simpleLowerCaseMapping:0x156F
  ,simpleTitleCaseMapping:0x156F
 },
 { code:0x1570
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1570
  ,simpleLowerCaseMapping:0x1570
  ,simpleTitleCaseMapping:0x1570
 },
 { code:0x1571
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1571
  ,simpleLowerCaseMapping:0x1571
  ,simpleTitleCaseMapping:0x1571
 },
 { code:0x1572
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1572
  ,simpleLowerCaseMapping:0x1572
  ,simpleTitleCaseMapping:0x1572
 },
 { code:0x1573
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1573
  ,simpleLowerCaseMapping:0x1573
  ,simpleTitleCaseMapping:0x1573
 },
 { code:0x1574
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1574
  ,simpleLowerCaseMapping:0x1574
  ,simpleTitleCaseMapping:0x1574
 },
 { code:0x1575
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1575
  ,simpleLowerCaseMapping:0x1575
  ,simpleTitleCaseMapping:0x1575
 },
 { code:0x1576
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1576
  ,simpleLowerCaseMapping:0x1576
  ,simpleTitleCaseMapping:0x1576
 },
 { code:0x1577
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1577
  ,simpleLowerCaseMapping:0x1577
  ,simpleTitleCaseMapping:0x1577
 },
 { code:0x1578
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1578
  ,simpleLowerCaseMapping:0x1578
  ,simpleTitleCaseMapping:0x1578
 },
 { code:0x1579
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1579
  ,simpleLowerCaseMapping:0x1579
  ,simpleTitleCaseMapping:0x1579
 },
 { code:0x157A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x157A
  ,simpleLowerCaseMapping:0x157A
  ,simpleTitleCaseMapping:0x157A
 },
 { code:0x157B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x157B
  ,simpleLowerCaseMapping:0x157B
  ,simpleTitleCaseMapping:0x157B
 },
 { code:0x157C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x157C
  ,simpleLowerCaseMapping:0x157C
  ,simpleTitleCaseMapping:0x157C
 },
 { code:0x157D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x157D
  ,simpleLowerCaseMapping:0x157D
  ,simpleTitleCaseMapping:0x157D
 },
 { code:0x157E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x157E
  ,simpleLowerCaseMapping:0x157E
  ,simpleTitleCaseMapping:0x157E
 },
 { code:0x157F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x157F
  ,simpleLowerCaseMapping:0x157F
  ,simpleTitleCaseMapping:0x157F
 },
 { code:0x1580
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1580
  ,simpleLowerCaseMapping:0x1580
  ,simpleTitleCaseMapping:0x1580
 },
 { code:0x1581
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1581
  ,simpleLowerCaseMapping:0x1581
  ,simpleTitleCaseMapping:0x1581
 },
 { code:0x1582
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1582
  ,simpleLowerCaseMapping:0x1582
  ,simpleTitleCaseMapping:0x1582
 },
 { code:0x1583
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1583
  ,simpleLowerCaseMapping:0x1583
  ,simpleTitleCaseMapping:0x1583
 },
 { code:0x1584
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1584
  ,simpleLowerCaseMapping:0x1584
  ,simpleTitleCaseMapping:0x1584
 },
 { code:0x1585
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1585
  ,simpleLowerCaseMapping:0x1585
  ,simpleTitleCaseMapping:0x1585
 },
 { code:0x1586
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1586
  ,simpleLowerCaseMapping:0x1586
  ,simpleTitleCaseMapping:0x1586
 },
 { code:0x1587
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1587
  ,simpleLowerCaseMapping:0x1587
  ,simpleTitleCaseMapping:0x1587
 },
 { code:0x1588
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1588
  ,simpleLowerCaseMapping:0x1588
  ,simpleTitleCaseMapping:0x1588
 },
 { code:0x1589
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1589
  ,simpleLowerCaseMapping:0x1589
  ,simpleTitleCaseMapping:0x1589
 },
 { code:0x158A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x158A
  ,simpleLowerCaseMapping:0x158A
  ,simpleTitleCaseMapping:0x158A
 },
 { code:0x158B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x158B
  ,simpleLowerCaseMapping:0x158B
  ,simpleTitleCaseMapping:0x158B
 },
 { code:0x158C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x158C
  ,simpleLowerCaseMapping:0x158C
  ,simpleTitleCaseMapping:0x158C
 },
 { code:0x158D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x158D
  ,simpleLowerCaseMapping:0x158D
  ,simpleTitleCaseMapping:0x158D
 },
 { code:0x158E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x158E
  ,simpleLowerCaseMapping:0x158E
  ,simpleTitleCaseMapping:0x158E
 },
 { code:0x158F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x158F
  ,simpleLowerCaseMapping:0x158F
  ,simpleTitleCaseMapping:0x158F
 },
 { code:0x1590
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1590
  ,simpleLowerCaseMapping:0x1590
  ,simpleTitleCaseMapping:0x1590
 },
 { code:0x1591
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1591
  ,simpleLowerCaseMapping:0x1591
  ,simpleTitleCaseMapping:0x1591
 },
 { code:0x1592
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1592
  ,simpleLowerCaseMapping:0x1592
  ,simpleTitleCaseMapping:0x1592
 },
 { code:0x1593
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1593
  ,simpleLowerCaseMapping:0x1593
  ,simpleTitleCaseMapping:0x1593
 },
 { code:0x1594
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1594
  ,simpleLowerCaseMapping:0x1594
  ,simpleTitleCaseMapping:0x1594
 },
 { code:0x1595
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1595
  ,simpleLowerCaseMapping:0x1595
  ,simpleTitleCaseMapping:0x1595
 },
 { code:0x1596
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1596
  ,simpleLowerCaseMapping:0x1596
  ,simpleTitleCaseMapping:0x1596
 },
 { code:0x1597
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1597
  ,simpleLowerCaseMapping:0x1597
  ,simpleTitleCaseMapping:0x1597
 },
 { code:0x1598
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1598
  ,simpleLowerCaseMapping:0x1598
  ,simpleTitleCaseMapping:0x1598
 },
 { code:0x1599
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1599
  ,simpleLowerCaseMapping:0x1599
  ,simpleTitleCaseMapping:0x1599
 },
 { code:0x159A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x159A
  ,simpleLowerCaseMapping:0x159A
  ,simpleTitleCaseMapping:0x159A
 },
 { code:0x159B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x159B
  ,simpleLowerCaseMapping:0x159B
  ,simpleTitleCaseMapping:0x159B
 },
 { code:0x159C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x159C
  ,simpleLowerCaseMapping:0x159C
  ,simpleTitleCaseMapping:0x159C
 },
 { code:0x159D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x159D
  ,simpleLowerCaseMapping:0x159D
  ,simpleTitleCaseMapping:0x159D
 },
 { code:0x159E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x159E
  ,simpleLowerCaseMapping:0x159E
  ,simpleTitleCaseMapping:0x159E
 },
 { code:0x159F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x159F
  ,simpleLowerCaseMapping:0x159F
  ,simpleTitleCaseMapping:0x159F
 },
 { code:0x15A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15A0
  ,simpleLowerCaseMapping:0x15A0
  ,simpleTitleCaseMapping:0x15A0
 },
 { code:0x15A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15A1
  ,simpleLowerCaseMapping:0x15A1
  ,simpleTitleCaseMapping:0x15A1
 },
 { code:0x15A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15A2
  ,simpleLowerCaseMapping:0x15A2
  ,simpleTitleCaseMapping:0x15A2
 },
 { code:0x15A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15A3
  ,simpleLowerCaseMapping:0x15A3
  ,simpleTitleCaseMapping:0x15A3
 },
 { code:0x15A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15A4
  ,simpleLowerCaseMapping:0x15A4
  ,simpleTitleCaseMapping:0x15A4
 },
 { code:0x15A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15A5
  ,simpleLowerCaseMapping:0x15A5
  ,simpleTitleCaseMapping:0x15A5
 },
 { code:0x15A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15A6
  ,simpleLowerCaseMapping:0x15A6
  ,simpleTitleCaseMapping:0x15A6
 },
 { code:0x15A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15A7
  ,simpleLowerCaseMapping:0x15A7
  ,simpleTitleCaseMapping:0x15A7
 },
 { code:0x15A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15A8
  ,simpleLowerCaseMapping:0x15A8
  ,simpleTitleCaseMapping:0x15A8
 },
 { code:0x15A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15A9
  ,simpleLowerCaseMapping:0x15A9
  ,simpleTitleCaseMapping:0x15A9
 },
 { code:0x15AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15AA
  ,simpleLowerCaseMapping:0x15AA
  ,simpleTitleCaseMapping:0x15AA
 },
 { code:0x15AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15AB
  ,simpleLowerCaseMapping:0x15AB
  ,simpleTitleCaseMapping:0x15AB
 },
 { code:0x15AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15AC
  ,simpleLowerCaseMapping:0x15AC
  ,simpleTitleCaseMapping:0x15AC
 },
 { code:0x15AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15AD
  ,simpleLowerCaseMapping:0x15AD
  ,simpleTitleCaseMapping:0x15AD
 },
 { code:0x15AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15AE
  ,simpleLowerCaseMapping:0x15AE
  ,simpleTitleCaseMapping:0x15AE
 },
 { code:0x15AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15AF
  ,simpleLowerCaseMapping:0x15AF
  ,simpleTitleCaseMapping:0x15AF
 },
 { code:0x15B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15B0
  ,simpleLowerCaseMapping:0x15B0
  ,simpleTitleCaseMapping:0x15B0
 },
 { code:0x15B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15B1
  ,simpleLowerCaseMapping:0x15B1
  ,simpleTitleCaseMapping:0x15B1
 },
 { code:0x15B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15B2
  ,simpleLowerCaseMapping:0x15B2
  ,simpleTitleCaseMapping:0x15B2
 },
 { code:0x15B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15B3
  ,simpleLowerCaseMapping:0x15B3
  ,simpleTitleCaseMapping:0x15B3
 },
 { code:0x15B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15B4
  ,simpleLowerCaseMapping:0x15B4
  ,simpleTitleCaseMapping:0x15B4
 },
 { code:0x15B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15B5
  ,simpleLowerCaseMapping:0x15B5
  ,simpleTitleCaseMapping:0x15B5
 },
 { code:0x15B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15B6
  ,simpleLowerCaseMapping:0x15B6
  ,simpleTitleCaseMapping:0x15B6
 },
 { code:0x15B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15B7
  ,simpleLowerCaseMapping:0x15B7
  ,simpleTitleCaseMapping:0x15B7
 },
 { code:0x15B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15B8
  ,simpleLowerCaseMapping:0x15B8
  ,simpleTitleCaseMapping:0x15B8
 },
 { code:0x15B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15B9
  ,simpleLowerCaseMapping:0x15B9
  ,simpleTitleCaseMapping:0x15B9
 },
 { code:0x15BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15BA
  ,simpleLowerCaseMapping:0x15BA
  ,simpleTitleCaseMapping:0x15BA
 },
 { code:0x15BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15BB
  ,simpleLowerCaseMapping:0x15BB
  ,simpleTitleCaseMapping:0x15BB
 },
 { code:0x15BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15BC
  ,simpleLowerCaseMapping:0x15BC
  ,simpleTitleCaseMapping:0x15BC
 },
 { code:0x15BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15BD
  ,simpleLowerCaseMapping:0x15BD
  ,simpleTitleCaseMapping:0x15BD
 },
 { code:0x15BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15BE
  ,simpleLowerCaseMapping:0x15BE
  ,simpleTitleCaseMapping:0x15BE
 },
 { code:0x15BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15BF
  ,simpleLowerCaseMapping:0x15BF
  ,simpleTitleCaseMapping:0x15BF
 },
 { code:0x15C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15C0
  ,simpleLowerCaseMapping:0x15C0
  ,simpleTitleCaseMapping:0x15C0
 },
 { code:0x15C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15C1
  ,simpleLowerCaseMapping:0x15C1
  ,simpleTitleCaseMapping:0x15C1
 },
 { code:0x15C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15C2
  ,simpleLowerCaseMapping:0x15C2
  ,simpleTitleCaseMapping:0x15C2
 },
 { code:0x15C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15C3
  ,simpleLowerCaseMapping:0x15C3
  ,simpleTitleCaseMapping:0x15C3
 },
 { code:0x15C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15C4
  ,simpleLowerCaseMapping:0x15C4
  ,simpleTitleCaseMapping:0x15C4
 },
 { code:0x15C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15C5
  ,simpleLowerCaseMapping:0x15C5
  ,simpleTitleCaseMapping:0x15C5
 },
 { code:0x15C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15C6
  ,simpleLowerCaseMapping:0x15C6
  ,simpleTitleCaseMapping:0x15C6
 },
 { code:0x15C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15C7
  ,simpleLowerCaseMapping:0x15C7
  ,simpleTitleCaseMapping:0x15C7
 },
 { code:0x15C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15C8
  ,simpleLowerCaseMapping:0x15C8
  ,simpleTitleCaseMapping:0x15C8
 },
 { code:0x15C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15C9
  ,simpleLowerCaseMapping:0x15C9
  ,simpleTitleCaseMapping:0x15C9
 },
 { code:0x15CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15CA
  ,simpleLowerCaseMapping:0x15CA
  ,simpleTitleCaseMapping:0x15CA
 },
 { code:0x15CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15CB
  ,simpleLowerCaseMapping:0x15CB
  ,simpleTitleCaseMapping:0x15CB
 },
 { code:0x15CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15CC
  ,simpleLowerCaseMapping:0x15CC
  ,simpleTitleCaseMapping:0x15CC
 },
 { code:0x15CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15CD
  ,simpleLowerCaseMapping:0x15CD
  ,simpleTitleCaseMapping:0x15CD
 },
 { code:0x15CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15CE
  ,simpleLowerCaseMapping:0x15CE
  ,simpleTitleCaseMapping:0x15CE
 },
 { code:0x15CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15CF
  ,simpleLowerCaseMapping:0x15CF
  ,simpleTitleCaseMapping:0x15CF
 },
 { code:0x15D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15D0
  ,simpleLowerCaseMapping:0x15D0
  ,simpleTitleCaseMapping:0x15D0
 },
 { code:0x15D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15D1
  ,simpleLowerCaseMapping:0x15D1
  ,simpleTitleCaseMapping:0x15D1
 },
 { code:0x15D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15D2
  ,simpleLowerCaseMapping:0x15D2
  ,simpleTitleCaseMapping:0x15D2
 },
 { code:0x15D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15D3
  ,simpleLowerCaseMapping:0x15D3
  ,simpleTitleCaseMapping:0x15D3
 },
 { code:0x15D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15D4
  ,simpleLowerCaseMapping:0x15D4
  ,simpleTitleCaseMapping:0x15D4
 },
 { code:0x15D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15D5
  ,simpleLowerCaseMapping:0x15D5
  ,simpleTitleCaseMapping:0x15D5
 },
 { code:0x15D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15D6
  ,simpleLowerCaseMapping:0x15D6
  ,simpleTitleCaseMapping:0x15D6
 },
 { code:0x15D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15D7
  ,simpleLowerCaseMapping:0x15D7
  ,simpleTitleCaseMapping:0x15D7
 },
 { code:0x15D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15D8
  ,simpleLowerCaseMapping:0x15D8
  ,simpleTitleCaseMapping:0x15D8
 },
 { code:0x15D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15D9
  ,simpleLowerCaseMapping:0x15D9
  ,simpleTitleCaseMapping:0x15D9
 },
 { code:0x15DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15DA
  ,simpleLowerCaseMapping:0x15DA
  ,simpleTitleCaseMapping:0x15DA
 },
 { code:0x15DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15DB
  ,simpleLowerCaseMapping:0x15DB
  ,simpleTitleCaseMapping:0x15DB
 },
 { code:0x15DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15DC
  ,simpleLowerCaseMapping:0x15DC
  ,simpleTitleCaseMapping:0x15DC
 },
 { code:0x15DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15DD
  ,simpleLowerCaseMapping:0x15DD
  ,simpleTitleCaseMapping:0x15DD
 },
 { code:0x15DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15DE
  ,simpleLowerCaseMapping:0x15DE
  ,simpleTitleCaseMapping:0x15DE
 },
 { code:0x15DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15DF
  ,simpleLowerCaseMapping:0x15DF
  ,simpleTitleCaseMapping:0x15DF
 },
 { code:0x15E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15E0
  ,simpleLowerCaseMapping:0x15E0
  ,simpleTitleCaseMapping:0x15E0
 },
 { code:0x15E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15E1
  ,simpleLowerCaseMapping:0x15E1
  ,simpleTitleCaseMapping:0x15E1
 },
 { code:0x15E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15E2
  ,simpleLowerCaseMapping:0x15E2
  ,simpleTitleCaseMapping:0x15E2
 },
 { code:0x15E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15E3
  ,simpleLowerCaseMapping:0x15E3
  ,simpleTitleCaseMapping:0x15E3
 },
 { code:0x15E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15E4
  ,simpleLowerCaseMapping:0x15E4
  ,simpleTitleCaseMapping:0x15E4
 },
 { code:0x15E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15E5
  ,simpleLowerCaseMapping:0x15E5
  ,simpleTitleCaseMapping:0x15E5
 },
 { code:0x15E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15E6
  ,simpleLowerCaseMapping:0x15E6
  ,simpleTitleCaseMapping:0x15E6
 },
 { code:0x15E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15E7
  ,simpleLowerCaseMapping:0x15E7
  ,simpleTitleCaseMapping:0x15E7
 },
 { code:0x15E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15E8
  ,simpleLowerCaseMapping:0x15E8
  ,simpleTitleCaseMapping:0x15E8
 },
 { code:0x15E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15E9
  ,simpleLowerCaseMapping:0x15E9
  ,simpleTitleCaseMapping:0x15E9
 },
 { code:0x15EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15EA
  ,simpleLowerCaseMapping:0x15EA
  ,simpleTitleCaseMapping:0x15EA
 },
 { code:0x15EB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15EB
  ,simpleLowerCaseMapping:0x15EB
  ,simpleTitleCaseMapping:0x15EB
 },
 { code:0x15EC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15EC
  ,simpleLowerCaseMapping:0x15EC
  ,simpleTitleCaseMapping:0x15EC
 },
 { code:0x15ED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15ED
  ,simpleLowerCaseMapping:0x15ED
  ,simpleTitleCaseMapping:0x15ED
 },
 { code:0x15EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15EE
  ,simpleLowerCaseMapping:0x15EE
  ,simpleTitleCaseMapping:0x15EE
 },
 { code:0x15EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15EF
  ,simpleLowerCaseMapping:0x15EF
  ,simpleTitleCaseMapping:0x15EF
 },
 { code:0x15F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15F0
  ,simpleLowerCaseMapping:0x15F0
  ,simpleTitleCaseMapping:0x15F0
 },
 { code:0x15F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15F1
  ,simpleLowerCaseMapping:0x15F1
  ,simpleTitleCaseMapping:0x15F1
 },
 { code:0x15F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15F2
  ,simpleLowerCaseMapping:0x15F2
  ,simpleTitleCaseMapping:0x15F2
 },
 { code:0x15F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15F3
  ,simpleLowerCaseMapping:0x15F3
  ,simpleTitleCaseMapping:0x15F3
 },
 { code:0x15F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15F4
  ,simpleLowerCaseMapping:0x15F4
  ,simpleTitleCaseMapping:0x15F4
 },
 { code:0x15F5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15F5
  ,simpleLowerCaseMapping:0x15F5
  ,simpleTitleCaseMapping:0x15F5
 },
 { code:0x15F6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15F6
  ,simpleLowerCaseMapping:0x15F6
  ,simpleTitleCaseMapping:0x15F6
 },
 { code:0x15F7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15F7
  ,simpleLowerCaseMapping:0x15F7
  ,simpleTitleCaseMapping:0x15F7
 },
 { code:0x15F8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15F8
  ,simpleLowerCaseMapping:0x15F8
  ,simpleTitleCaseMapping:0x15F8
 },
 { code:0x15F9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15F9
  ,simpleLowerCaseMapping:0x15F9
  ,simpleTitleCaseMapping:0x15F9
 },
 { code:0x15FA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15FA
  ,simpleLowerCaseMapping:0x15FA
  ,simpleTitleCaseMapping:0x15FA
 },
 { code:0x15FB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15FB
  ,simpleLowerCaseMapping:0x15FB
  ,simpleTitleCaseMapping:0x15FB
 },
 { code:0x15FC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15FC
  ,simpleLowerCaseMapping:0x15FC
  ,simpleTitleCaseMapping:0x15FC
 },
 { code:0x15FD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15FD
  ,simpleLowerCaseMapping:0x15FD
  ,simpleTitleCaseMapping:0x15FD
 },
 { code:0x15FE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15FE
  ,simpleLowerCaseMapping:0x15FE
  ,simpleTitleCaseMapping:0x15FE
 },
 { code:0x15FF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x15FF
  ,simpleLowerCaseMapping:0x15FF
  ,simpleTitleCaseMapping:0x15FF
 },
 { code:0x1600
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1600
  ,simpleLowerCaseMapping:0x1600
  ,simpleTitleCaseMapping:0x1600
 },
 { code:0x1601
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1601
  ,simpleLowerCaseMapping:0x1601
  ,simpleTitleCaseMapping:0x1601
 },
 { code:0x1602
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1602
  ,simpleLowerCaseMapping:0x1602
  ,simpleTitleCaseMapping:0x1602
 },
 { code:0x1603
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1603
  ,simpleLowerCaseMapping:0x1603
  ,simpleTitleCaseMapping:0x1603
 },
 { code:0x1604
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1604
  ,simpleLowerCaseMapping:0x1604
  ,simpleTitleCaseMapping:0x1604
 },
 { code:0x1605
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1605
  ,simpleLowerCaseMapping:0x1605
  ,simpleTitleCaseMapping:0x1605
 },
 { code:0x1606
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1606
  ,simpleLowerCaseMapping:0x1606
  ,simpleTitleCaseMapping:0x1606
 },
 { code:0x1607
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1607
  ,simpleLowerCaseMapping:0x1607
  ,simpleTitleCaseMapping:0x1607
 },
 { code:0x1608
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1608
  ,simpleLowerCaseMapping:0x1608
  ,simpleTitleCaseMapping:0x1608
 },
 { code:0x1609
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1609
  ,simpleLowerCaseMapping:0x1609
  ,simpleTitleCaseMapping:0x1609
 },
 { code:0x160A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x160A
  ,simpleLowerCaseMapping:0x160A
  ,simpleTitleCaseMapping:0x160A
 },
 { code:0x160B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x160B
  ,simpleLowerCaseMapping:0x160B
  ,simpleTitleCaseMapping:0x160B
 },
 { code:0x160C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x160C
  ,simpleLowerCaseMapping:0x160C
  ,simpleTitleCaseMapping:0x160C
 },
 { code:0x160D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x160D
  ,simpleLowerCaseMapping:0x160D
  ,simpleTitleCaseMapping:0x160D
 },
 { code:0x160E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x160E
  ,simpleLowerCaseMapping:0x160E
  ,simpleTitleCaseMapping:0x160E
 },
 { code:0x160F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x160F
  ,simpleLowerCaseMapping:0x160F
  ,simpleTitleCaseMapping:0x160F
 },
 { code:0x1610
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1610
  ,simpleLowerCaseMapping:0x1610
  ,simpleTitleCaseMapping:0x1610
 },
 { code:0x1611
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1611
  ,simpleLowerCaseMapping:0x1611
  ,simpleTitleCaseMapping:0x1611
 },
 { code:0x1612
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1612
  ,simpleLowerCaseMapping:0x1612
  ,simpleTitleCaseMapping:0x1612
 },
 { code:0x1613
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1613
  ,simpleLowerCaseMapping:0x1613
  ,simpleTitleCaseMapping:0x1613
 },
 { code:0x1614
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1614
  ,simpleLowerCaseMapping:0x1614
  ,simpleTitleCaseMapping:0x1614
 },
 { code:0x1615
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1615
  ,simpleLowerCaseMapping:0x1615
  ,simpleTitleCaseMapping:0x1615
 },
 { code:0x1616
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1616
  ,simpleLowerCaseMapping:0x1616
  ,simpleTitleCaseMapping:0x1616
 },
 { code:0x1617
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1617
  ,simpleLowerCaseMapping:0x1617
  ,simpleTitleCaseMapping:0x1617
 },
 { code:0x1618
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1618
  ,simpleLowerCaseMapping:0x1618
  ,simpleTitleCaseMapping:0x1618
 },
 { code:0x1619
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1619
  ,simpleLowerCaseMapping:0x1619
  ,simpleTitleCaseMapping:0x1619
 },
 { code:0x161A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x161A
  ,simpleLowerCaseMapping:0x161A
  ,simpleTitleCaseMapping:0x161A
 },
 { code:0x161B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x161B
  ,simpleLowerCaseMapping:0x161B
  ,simpleTitleCaseMapping:0x161B
 },
 { code:0x161C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x161C
  ,simpleLowerCaseMapping:0x161C
  ,simpleTitleCaseMapping:0x161C
 },
 { code:0x161D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x161D
  ,simpleLowerCaseMapping:0x161D
  ,simpleTitleCaseMapping:0x161D
 },
 { code:0x161E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x161E
  ,simpleLowerCaseMapping:0x161E
  ,simpleTitleCaseMapping:0x161E
 },
 { code:0x161F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x161F
  ,simpleLowerCaseMapping:0x161F
  ,simpleTitleCaseMapping:0x161F
 },
 { code:0x1620
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1620
  ,simpleLowerCaseMapping:0x1620
  ,simpleTitleCaseMapping:0x1620
 },
 { code:0x1621
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1621
  ,simpleLowerCaseMapping:0x1621
  ,simpleTitleCaseMapping:0x1621
 },
 { code:0x1622
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1622
  ,simpleLowerCaseMapping:0x1622
  ,simpleTitleCaseMapping:0x1622
 },
 { code:0x1623
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1623
  ,simpleLowerCaseMapping:0x1623
  ,simpleTitleCaseMapping:0x1623
 },
 { code:0x1624
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1624
  ,simpleLowerCaseMapping:0x1624
  ,simpleTitleCaseMapping:0x1624
 },
 { code:0x1625
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1625
  ,simpleLowerCaseMapping:0x1625
  ,simpleTitleCaseMapping:0x1625
 },
 { code:0x1626
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1626
  ,simpleLowerCaseMapping:0x1626
  ,simpleTitleCaseMapping:0x1626
 },
 { code:0x1627
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1627
  ,simpleLowerCaseMapping:0x1627
  ,simpleTitleCaseMapping:0x1627
 },
 { code:0x1628
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1628
  ,simpleLowerCaseMapping:0x1628
  ,simpleTitleCaseMapping:0x1628
 },
 { code:0x1629
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1629
  ,simpleLowerCaseMapping:0x1629
  ,simpleTitleCaseMapping:0x1629
 },
 { code:0x162A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x162A
  ,simpleLowerCaseMapping:0x162A
  ,simpleTitleCaseMapping:0x162A
 },
 { code:0x162B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x162B
  ,simpleLowerCaseMapping:0x162B
  ,simpleTitleCaseMapping:0x162B
 },
 { code:0x162C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x162C
  ,simpleLowerCaseMapping:0x162C
  ,simpleTitleCaseMapping:0x162C
 },
 { code:0x162D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x162D
  ,simpleLowerCaseMapping:0x162D
  ,simpleTitleCaseMapping:0x162D
 },
 { code:0x162E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x162E
  ,simpleLowerCaseMapping:0x162E
  ,simpleTitleCaseMapping:0x162E
 },
 { code:0x162F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x162F
  ,simpleLowerCaseMapping:0x162F
  ,simpleTitleCaseMapping:0x162F
 },
 { code:0x1630
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1630
  ,simpleLowerCaseMapping:0x1630
  ,simpleTitleCaseMapping:0x1630
 },
 { code:0x1631
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1631
  ,simpleLowerCaseMapping:0x1631
  ,simpleTitleCaseMapping:0x1631
 },
 { code:0x1632
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1632
  ,simpleLowerCaseMapping:0x1632
  ,simpleTitleCaseMapping:0x1632
 },
 { code:0x1633
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1633
  ,simpleLowerCaseMapping:0x1633
  ,simpleTitleCaseMapping:0x1633
 },
 { code:0x1634
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1634
  ,simpleLowerCaseMapping:0x1634
  ,simpleTitleCaseMapping:0x1634
 },
 { code:0x1635
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1635
  ,simpleLowerCaseMapping:0x1635
  ,simpleTitleCaseMapping:0x1635
 },
 { code:0x1636
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1636
  ,simpleLowerCaseMapping:0x1636
  ,simpleTitleCaseMapping:0x1636
 },
 { code:0x1637
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1637
  ,simpleLowerCaseMapping:0x1637
  ,simpleTitleCaseMapping:0x1637
 },
 { code:0x1638
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1638
  ,simpleLowerCaseMapping:0x1638
  ,simpleTitleCaseMapping:0x1638
 },
 { code:0x1639
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1639
  ,simpleLowerCaseMapping:0x1639
  ,simpleTitleCaseMapping:0x1639
 },
 { code:0x163A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x163A
  ,simpleLowerCaseMapping:0x163A
  ,simpleTitleCaseMapping:0x163A
 },
 { code:0x163B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x163B
  ,simpleLowerCaseMapping:0x163B
  ,simpleTitleCaseMapping:0x163B
 },
 { code:0x163C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x163C
  ,simpleLowerCaseMapping:0x163C
  ,simpleTitleCaseMapping:0x163C
 },
 { code:0x163D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x163D
  ,simpleLowerCaseMapping:0x163D
  ,simpleTitleCaseMapping:0x163D
 },
 { code:0x163E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x163E
  ,simpleLowerCaseMapping:0x163E
  ,simpleTitleCaseMapping:0x163E
 },
 { code:0x163F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x163F
  ,simpleLowerCaseMapping:0x163F
  ,simpleTitleCaseMapping:0x163F
 },
 { code:0x1640
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1640
  ,simpleLowerCaseMapping:0x1640
  ,simpleTitleCaseMapping:0x1640
 },
 { code:0x1641
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1641
  ,simpleLowerCaseMapping:0x1641
  ,simpleTitleCaseMapping:0x1641
 },
 { code:0x1642
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1642
  ,simpleLowerCaseMapping:0x1642
  ,simpleTitleCaseMapping:0x1642
 },
 { code:0x1643
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1643
  ,simpleLowerCaseMapping:0x1643
  ,simpleTitleCaseMapping:0x1643
 },
 { code:0x1644
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1644
  ,simpleLowerCaseMapping:0x1644
  ,simpleTitleCaseMapping:0x1644
 },
 { code:0x1645
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1645
  ,simpleLowerCaseMapping:0x1645
  ,simpleTitleCaseMapping:0x1645
 },
 { code:0x1646
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1646
  ,simpleLowerCaseMapping:0x1646
  ,simpleTitleCaseMapping:0x1646
 },
 { code:0x1647
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1647
  ,simpleLowerCaseMapping:0x1647
  ,simpleTitleCaseMapping:0x1647
 },
 { code:0x1648
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1648
  ,simpleLowerCaseMapping:0x1648
  ,simpleTitleCaseMapping:0x1648
 },
 { code:0x1649
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1649
  ,simpleLowerCaseMapping:0x1649
  ,simpleTitleCaseMapping:0x1649
 },
 { code:0x164A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x164A
  ,simpleLowerCaseMapping:0x164A
  ,simpleTitleCaseMapping:0x164A
 },
 { code:0x164B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x164B
  ,simpleLowerCaseMapping:0x164B
  ,simpleTitleCaseMapping:0x164B
 },
 { code:0x164C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x164C
  ,simpleLowerCaseMapping:0x164C
  ,simpleTitleCaseMapping:0x164C
 },
 { code:0x164D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x164D
  ,simpleLowerCaseMapping:0x164D
  ,simpleTitleCaseMapping:0x164D
 },
 { code:0x164E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x164E
  ,simpleLowerCaseMapping:0x164E
  ,simpleTitleCaseMapping:0x164E
 },
 { code:0x164F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x164F
  ,simpleLowerCaseMapping:0x164F
  ,simpleTitleCaseMapping:0x164F
 },
 { code:0x1650
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1650
  ,simpleLowerCaseMapping:0x1650
  ,simpleTitleCaseMapping:0x1650
 },
 { code:0x1651
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1651
  ,simpleLowerCaseMapping:0x1651
  ,simpleTitleCaseMapping:0x1651
 },
 { code:0x1652
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1652
  ,simpleLowerCaseMapping:0x1652
  ,simpleTitleCaseMapping:0x1652
 },
 { code:0x1653
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1653
  ,simpleLowerCaseMapping:0x1653
  ,simpleTitleCaseMapping:0x1653
 },
 { code:0x1654
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1654
  ,simpleLowerCaseMapping:0x1654
  ,simpleTitleCaseMapping:0x1654
 },
 { code:0x1655
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1655
  ,simpleLowerCaseMapping:0x1655
  ,simpleTitleCaseMapping:0x1655
 },
 { code:0x1656
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1656
  ,simpleLowerCaseMapping:0x1656
  ,simpleTitleCaseMapping:0x1656
 },
 { code:0x1657
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1657
  ,simpleLowerCaseMapping:0x1657
  ,simpleTitleCaseMapping:0x1657
 },
 { code:0x1658
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1658
  ,simpleLowerCaseMapping:0x1658
  ,simpleTitleCaseMapping:0x1658
 },
 { code:0x1659
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1659
  ,simpleLowerCaseMapping:0x1659
  ,simpleTitleCaseMapping:0x1659
 },
 { code:0x165A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x165A
  ,simpleLowerCaseMapping:0x165A
  ,simpleTitleCaseMapping:0x165A
 },
 { code:0x165B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x165B
  ,simpleLowerCaseMapping:0x165B
  ,simpleTitleCaseMapping:0x165B
 },
 { code:0x165C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x165C
  ,simpleLowerCaseMapping:0x165C
  ,simpleTitleCaseMapping:0x165C
 },
 { code:0x165D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x165D
  ,simpleLowerCaseMapping:0x165D
  ,simpleTitleCaseMapping:0x165D
 },
 { code:0x165E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x165E
  ,simpleLowerCaseMapping:0x165E
  ,simpleTitleCaseMapping:0x165E
 },
 { code:0x165F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x165F
  ,simpleLowerCaseMapping:0x165F
  ,simpleTitleCaseMapping:0x165F
 },
 { code:0x1660
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1660
  ,simpleLowerCaseMapping:0x1660
  ,simpleTitleCaseMapping:0x1660
 },
 { code:0x1661
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1661
  ,simpleLowerCaseMapping:0x1661
  ,simpleTitleCaseMapping:0x1661
 },
 { code:0x1662
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1662
  ,simpleLowerCaseMapping:0x1662
  ,simpleTitleCaseMapping:0x1662
 },
 { code:0x1663
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1663
  ,simpleLowerCaseMapping:0x1663
  ,simpleTitleCaseMapping:0x1663
 },
 { code:0x1664
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1664
  ,simpleLowerCaseMapping:0x1664
  ,simpleTitleCaseMapping:0x1664
 },
 { code:0x1665
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1665
  ,simpleLowerCaseMapping:0x1665
  ,simpleTitleCaseMapping:0x1665
 },
 { code:0x1666
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1666
  ,simpleLowerCaseMapping:0x1666
  ,simpleTitleCaseMapping:0x1666
 },
 { code:0x1667
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1667
  ,simpleLowerCaseMapping:0x1667
  ,simpleTitleCaseMapping:0x1667
 },
 { code:0x1668
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1668
  ,simpleLowerCaseMapping:0x1668
  ,simpleTitleCaseMapping:0x1668
 },
 { code:0x1669
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1669
  ,simpleLowerCaseMapping:0x1669
  ,simpleTitleCaseMapping:0x1669
 },
 { code:0x166A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x166A
  ,simpleLowerCaseMapping:0x166A
  ,simpleTitleCaseMapping:0x166A
 },
 { code:0x166B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x166B
  ,simpleLowerCaseMapping:0x166B
  ,simpleTitleCaseMapping:0x166B
 },
 { code:0x166C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x166C
  ,simpleLowerCaseMapping:0x166C
  ,simpleTitleCaseMapping:0x166C
 },
 { code:0x166D
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x166D
  ,simpleLowerCaseMapping:0x166D
  ,simpleTitleCaseMapping:0x166D
 },
 { code:0x166E
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x166E
  ,simpleLowerCaseMapping:0x166E
  ,simpleTitleCaseMapping:0x166E
 },
 { code:0x166F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x166F
  ,simpleLowerCaseMapping:0x166F
  ,simpleTitleCaseMapping:0x166F
 },
 { code:0x1670
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1670
  ,simpleLowerCaseMapping:0x1670
  ,simpleTitleCaseMapping:0x1670
 },
 { code:0x1671
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1671
  ,simpleLowerCaseMapping:0x1671
  ,simpleTitleCaseMapping:0x1671
 },
 { code:0x1672
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1672
  ,simpleLowerCaseMapping:0x1672
  ,simpleTitleCaseMapping:0x1672
 },
 { code:0x1673
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1673
  ,simpleLowerCaseMapping:0x1673
  ,simpleTitleCaseMapping:0x1673
 },
 { code:0x1674
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1674
  ,simpleLowerCaseMapping:0x1674
  ,simpleTitleCaseMapping:0x1674
 },
 { code:0x1675
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1675
  ,simpleLowerCaseMapping:0x1675
  ,simpleTitleCaseMapping:0x1675
 },
 { code:0x1676
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1676
  ,simpleLowerCaseMapping:0x1676
  ,simpleTitleCaseMapping:0x1676
 },
 { code:0x1680
  ,generalCategory:UnicodeData.GeneralCategory.Zs
  ,simpleUpperCaseMapping:0x1680
  ,simpleLowerCaseMapping:0x1680
  ,simpleTitleCaseMapping:0x1680
 },
 { code:0x1681
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1681
  ,simpleLowerCaseMapping:0x1681
  ,simpleTitleCaseMapping:0x1681
 },
 { code:0x1682
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1682
  ,simpleLowerCaseMapping:0x1682
  ,simpleTitleCaseMapping:0x1682
 },
 { code:0x1683
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1683
  ,simpleLowerCaseMapping:0x1683
  ,simpleTitleCaseMapping:0x1683
 },
 { code:0x1684
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1684
  ,simpleLowerCaseMapping:0x1684
  ,simpleTitleCaseMapping:0x1684
 },
 { code:0x1685
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1685
  ,simpleLowerCaseMapping:0x1685
  ,simpleTitleCaseMapping:0x1685
 },
 { code:0x1686
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1686
  ,simpleLowerCaseMapping:0x1686
  ,simpleTitleCaseMapping:0x1686
 },
 { code:0x1687
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1687
  ,simpleLowerCaseMapping:0x1687
  ,simpleTitleCaseMapping:0x1687
 },
 { code:0x1688
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1688
  ,simpleLowerCaseMapping:0x1688
  ,simpleTitleCaseMapping:0x1688
 },
 { code:0x1689
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1689
  ,simpleLowerCaseMapping:0x1689
  ,simpleTitleCaseMapping:0x1689
 },
 { code:0x168A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x168A
  ,simpleLowerCaseMapping:0x168A
  ,simpleTitleCaseMapping:0x168A
 },
 { code:0x168B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x168B
  ,simpleLowerCaseMapping:0x168B
  ,simpleTitleCaseMapping:0x168B
 },
 { code:0x168C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x168C
  ,simpleLowerCaseMapping:0x168C
  ,simpleTitleCaseMapping:0x168C
 },
 { code:0x168D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x168D
  ,simpleLowerCaseMapping:0x168D
  ,simpleTitleCaseMapping:0x168D
 },
 { code:0x168E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x168E
  ,simpleLowerCaseMapping:0x168E
  ,simpleTitleCaseMapping:0x168E
 },
 { code:0x168F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x168F
  ,simpleLowerCaseMapping:0x168F
  ,simpleTitleCaseMapping:0x168F
 },
 { code:0x1690
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1690
  ,simpleLowerCaseMapping:0x1690
  ,simpleTitleCaseMapping:0x1690
 },
 { code:0x1691
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1691
  ,simpleLowerCaseMapping:0x1691
  ,simpleTitleCaseMapping:0x1691
 },
 { code:0x1692
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1692
  ,simpleLowerCaseMapping:0x1692
  ,simpleTitleCaseMapping:0x1692
 },
 { code:0x1693
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1693
  ,simpleLowerCaseMapping:0x1693
  ,simpleTitleCaseMapping:0x1693
 },
 { code:0x1694
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1694
  ,simpleLowerCaseMapping:0x1694
  ,simpleTitleCaseMapping:0x1694
 },
 { code:0x1695
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1695
  ,simpleLowerCaseMapping:0x1695
  ,simpleTitleCaseMapping:0x1695
 },
 { code:0x1696
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1696
  ,simpleLowerCaseMapping:0x1696
  ,simpleTitleCaseMapping:0x1696
 },
 { code:0x1697
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1697
  ,simpleLowerCaseMapping:0x1697
  ,simpleTitleCaseMapping:0x1697
 },
 { code:0x1698
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1698
  ,simpleLowerCaseMapping:0x1698
  ,simpleTitleCaseMapping:0x1698
 },
 { code:0x1699
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1699
  ,simpleLowerCaseMapping:0x1699
  ,simpleTitleCaseMapping:0x1699
 },
 { code:0x169A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x169A
  ,simpleLowerCaseMapping:0x169A
  ,simpleTitleCaseMapping:0x169A
 },
 { code:0x169B
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x169B
  ,simpleLowerCaseMapping:0x169B
  ,simpleTitleCaseMapping:0x169B
 },
 { code:0x169C
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x169C
  ,simpleLowerCaseMapping:0x169C
  ,simpleTitleCaseMapping:0x169C
 },
 { code:0x16A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16A0
  ,simpleLowerCaseMapping:0x16A0
  ,simpleTitleCaseMapping:0x16A0
 },
 { code:0x16A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16A1
  ,simpleLowerCaseMapping:0x16A1
  ,simpleTitleCaseMapping:0x16A1
 },
 { code:0x16A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16A2
  ,simpleLowerCaseMapping:0x16A2
  ,simpleTitleCaseMapping:0x16A2
 },
 { code:0x16A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16A3
  ,simpleLowerCaseMapping:0x16A3
  ,simpleTitleCaseMapping:0x16A3
 },
 { code:0x16A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16A4
  ,simpleLowerCaseMapping:0x16A4
  ,simpleTitleCaseMapping:0x16A4
 },
 { code:0x16A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16A5
  ,simpleLowerCaseMapping:0x16A5
  ,simpleTitleCaseMapping:0x16A5
 },
 { code:0x16A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16A6
  ,simpleLowerCaseMapping:0x16A6
  ,simpleTitleCaseMapping:0x16A6
 },
 { code:0x16A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16A7
  ,simpleLowerCaseMapping:0x16A7
  ,simpleTitleCaseMapping:0x16A7
 },
 { code:0x16A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16A8
  ,simpleLowerCaseMapping:0x16A8
  ,simpleTitleCaseMapping:0x16A8
 },
 { code:0x16A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16A9
  ,simpleLowerCaseMapping:0x16A9
  ,simpleTitleCaseMapping:0x16A9
 },
 { code:0x16AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16AA
  ,simpleLowerCaseMapping:0x16AA
  ,simpleTitleCaseMapping:0x16AA
 },
 { code:0x16AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16AB
  ,simpleLowerCaseMapping:0x16AB
  ,simpleTitleCaseMapping:0x16AB
 },
 { code:0x16AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16AC
  ,simpleLowerCaseMapping:0x16AC
  ,simpleTitleCaseMapping:0x16AC
 },
 { code:0x16AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16AD
  ,simpleLowerCaseMapping:0x16AD
  ,simpleTitleCaseMapping:0x16AD
 },
 { code:0x16AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16AE
  ,simpleLowerCaseMapping:0x16AE
  ,simpleTitleCaseMapping:0x16AE
 },
 { code:0x16AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16AF
  ,simpleLowerCaseMapping:0x16AF
  ,simpleTitleCaseMapping:0x16AF
 },
 { code:0x16B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16B0
  ,simpleLowerCaseMapping:0x16B0
  ,simpleTitleCaseMapping:0x16B0
 },
 { code:0x16B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16B1
  ,simpleLowerCaseMapping:0x16B1
  ,simpleTitleCaseMapping:0x16B1
 },
 { code:0x16B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16B2
  ,simpleLowerCaseMapping:0x16B2
  ,simpleTitleCaseMapping:0x16B2
 },
 { code:0x16B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16B3
  ,simpleLowerCaseMapping:0x16B3
  ,simpleTitleCaseMapping:0x16B3
 },
 { code:0x16B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16B4
  ,simpleLowerCaseMapping:0x16B4
  ,simpleTitleCaseMapping:0x16B4
 },
 { code:0x16B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16B5
  ,simpleLowerCaseMapping:0x16B5
  ,simpleTitleCaseMapping:0x16B5
 },
 { code:0x16B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16B6
  ,simpleLowerCaseMapping:0x16B6
  ,simpleTitleCaseMapping:0x16B6
 },
 { code:0x16B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16B7
  ,simpleLowerCaseMapping:0x16B7
  ,simpleTitleCaseMapping:0x16B7
 },
 { code:0x16B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16B8
  ,simpleLowerCaseMapping:0x16B8
  ,simpleTitleCaseMapping:0x16B8
 },
 { code:0x16B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16B9
  ,simpleLowerCaseMapping:0x16B9
  ,simpleTitleCaseMapping:0x16B9
 },
 { code:0x16BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16BA
  ,simpleLowerCaseMapping:0x16BA
  ,simpleTitleCaseMapping:0x16BA
 },
 { code:0x16BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16BB
  ,simpleLowerCaseMapping:0x16BB
  ,simpleTitleCaseMapping:0x16BB
 },
 { code:0x16BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16BC
  ,simpleLowerCaseMapping:0x16BC
  ,simpleTitleCaseMapping:0x16BC
 },
 { code:0x16BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16BD
  ,simpleLowerCaseMapping:0x16BD
  ,simpleTitleCaseMapping:0x16BD
 },
 { code:0x16BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16BE
  ,simpleLowerCaseMapping:0x16BE
  ,simpleTitleCaseMapping:0x16BE
 },
 { code:0x16BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16BF
  ,simpleLowerCaseMapping:0x16BF
  ,simpleTitleCaseMapping:0x16BF
 },
 { code:0x16C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16C0
  ,simpleLowerCaseMapping:0x16C0
  ,simpleTitleCaseMapping:0x16C0
 },
 { code:0x16C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16C1
  ,simpleLowerCaseMapping:0x16C1
  ,simpleTitleCaseMapping:0x16C1
 },
 { code:0x16C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16C2
  ,simpleLowerCaseMapping:0x16C2
  ,simpleTitleCaseMapping:0x16C2
 },
 { code:0x16C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16C3
  ,simpleLowerCaseMapping:0x16C3
  ,simpleTitleCaseMapping:0x16C3
 },
 { code:0x16C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16C4
  ,simpleLowerCaseMapping:0x16C4
  ,simpleTitleCaseMapping:0x16C4
 },
 { code:0x16C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16C5
  ,simpleLowerCaseMapping:0x16C5
  ,simpleTitleCaseMapping:0x16C5
 },
 { code:0x16C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16C6
  ,simpleLowerCaseMapping:0x16C6
  ,simpleTitleCaseMapping:0x16C6
 },
 { code:0x16C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16C7
  ,simpleLowerCaseMapping:0x16C7
  ,simpleTitleCaseMapping:0x16C7
 },
 { code:0x16C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16C8
  ,simpleLowerCaseMapping:0x16C8
  ,simpleTitleCaseMapping:0x16C8
 },
 { code:0x16C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16C9
  ,simpleLowerCaseMapping:0x16C9
  ,simpleTitleCaseMapping:0x16C9
 },
 { code:0x16CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16CA
  ,simpleLowerCaseMapping:0x16CA
  ,simpleTitleCaseMapping:0x16CA
 },
 { code:0x16CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16CB
  ,simpleLowerCaseMapping:0x16CB
  ,simpleTitleCaseMapping:0x16CB
 },
 { code:0x16CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16CC
  ,simpleLowerCaseMapping:0x16CC
  ,simpleTitleCaseMapping:0x16CC
 },
 { code:0x16CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16CD
  ,simpleLowerCaseMapping:0x16CD
  ,simpleTitleCaseMapping:0x16CD
 },
 { code:0x16CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16CE
  ,simpleLowerCaseMapping:0x16CE
  ,simpleTitleCaseMapping:0x16CE
 },
 { code:0x16CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16CF
  ,simpleLowerCaseMapping:0x16CF
  ,simpleTitleCaseMapping:0x16CF
 },
 { code:0x16D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16D0
  ,simpleLowerCaseMapping:0x16D0
  ,simpleTitleCaseMapping:0x16D0
 },
 { code:0x16D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16D1
  ,simpleLowerCaseMapping:0x16D1
  ,simpleTitleCaseMapping:0x16D1
 },
 { code:0x16D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16D2
  ,simpleLowerCaseMapping:0x16D2
  ,simpleTitleCaseMapping:0x16D2
 },
 { code:0x16D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16D3
  ,simpleLowerCaseMapping:0x16D3
  ,simpleTitleCaseMapping:0x16D3
 },
 { code:0x16D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16D4
  ,simpleLowerCaseMapping:0x16D4
  ,simpleTitleCaseMapping:0x16D4
 },
 { code:0x16D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16D5
  ,simpleLowerCaseMapping:0x16D5
  ,simpleTitleCaseMapping:0x16D5
 },
 { code:0x16D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16D6
  ,simpleLowerCaseMapping:0x16D6
  ,simpleTitleCaseMapping:0x16D6
 },
 { code:0x16D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16D7
  ,simpleLowerCaseMapping:0x16D7
  ,simpleTitleCaseMapping:0x16D7
 },
 { code:0x16D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16D8
  ,simpleLowerCaseMapping:0x16D8
  ,simpleTitleCaseMapping:0x16D8
 },
 { code:0x16D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16D9
  ,simpleLowerCaseMapping:0x16D9
  ,simpleTitleCaseMapping:0x16D9
 },
 { code:0x16DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16DA
  ,simpleLowerCaseMapping:0x16DA
  ,simpleTitleCaseMapping:0x16DA
 },
 { code:0x16DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16DB
  ,simpleLowerCaseMapping:0x16DB
  ,simpleTitleCaseMapping:0x16DB
 },
 { code:0x16DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16DC
  ,simpleLowerCaseMapping:0x16DC
  ,simpleTitleCaseMapping:0x16DC
 },
 { code:0x16DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16DD
  ,simpleLowerCaseMapping:0x16DD
  ,simpleTitleCaseMapping:0x16DD
 },
 { code:0x16DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16DE
  ,simpleLowerCaseMapping:0x16DE
  ,simpleTitleCaseMapping:0x16DE
 },
 { code:0x16DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16DF
  ,simpleLowerCaseMapping:0x16DF
  ,simpleTitleCaseMapping:0x16DF
 },
 { code:0x16E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16E0
  ,simpleLowerCaseMapping:0x16E0
  ,simpleTitleCaseMapping:0x16E0
 },
 { code:0x16E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16E1
  ,simpleLowerCaseMapping:0x16E1
  ,simpleTitleCaseMapping:0x16E1
 },
 { code:0x16E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16E2
  ,simpleLowerCaseMapping:0x16E2
  ,simpleTitleCaseMapping:0x16E2
 },
 { code:0x16E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16E3
  ,simpleLowerCaseMapping:0x16E3
  ,simpleTitleCaseMapping:0x16E3
 },
 { code:0x16E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16E4
  ,simpleLowerCaseMapping:0x16E4
  ,simpleTitleCaseMapping:0x16E4
 },
 { code:0x16E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16E5
  ,simpleLowerCaseMapping:0x16E5
  ,simpleTitleCaseMapping:0x16E5
 },
 { code:0x16E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16E6
  ,simpleLowerCaseMapping:0x16E6
  ,simpleTitleCaseMapping:0x16E6
 },
 { code:0x16E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16E7
  ,simpleLowerCaseMapping:0x16E7
  ,simpleTitleCaseMapping:0x16E7
 },
 { code:0x16E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16E8
  ,simpleLowerCaseMapping:0x16E8
  ,simpleTitleCaseMapping:0x16E8
 },
 { code:0x16E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16E9
  ,simpleLowerCaseMapping:0x16E9
  ,simpleTitleCaseMapping:0x16E9
 },
 { code:0x16EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x16EA
  ,simpleLowerCaseMapping:0x16EA
  ,simpleTitleCaseMapping:0x16EA
 },
 { code:0x16EB
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x16EB
  ,simpleLowerCaseMapping:0x16EB
  ,simpleTitleCaseMapping:0x16EB
 },
 { code:0x16EC
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x16EC
  ,simpleLowerCaseMapping:0x16EC
  ,simpleTitleCaseMapping:0x16EC
 },
 { code:0x16ED
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x16ED
  ,simpleLowerCaseMapping:0x16ED
  ,simpleTitleCaseMapping:0x16ED
 },
 { code:0x16EE
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x16EE
  ,simpleLowerCaseMapping:0x16EE
  ,simpleTitleCaseMapping:0x16EE
 },
 { code:0x16EF
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x16EF
  ,simpleLowerCaseMapping:0x16EF
  ,simpleTitleCaseMapping:0x16EF
 },
 { code:0x16F0
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x16F0
  ,simpleLowerCaseMapping:0x16F0
  ,simpleTitleCaseMapping:0x16F0
 },
 { code:0x1700
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1700
  ,simpleLowerCaseMapping:0x1700
  ,simpleTitleCaseMapping:0x1700
 },
 { code:0x1701
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1701
  ,simpleLowerCaseMapping:0x1701
  ,simpleTitleCaseMapping:0x1701
 },
 { code:0x1702
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1702
  ,simpleLowerCaseMapping:0x1702
  ,simpleTitleCaseMapping:0x1702
 },
 { code:0x1703
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1703
  ,simpleLowerCaseMapping:0x1703
  ,simpleTitleCaseMapping:0x1703
 },
 { code:0x1704
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1704
  ,simpleLowerCaseMapping:0x1704
  ,simpleTitleCaseMapping:0x1704
 },
 { code:0x1705
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1705
  ,simpleLowerCaseMapping:0x1705
  ,simpleTitleCaseMapping:0x1705
 },
 { code:0x1706
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1706
  ,simpleLowerCaseMapping:0x1706
  ,simpleTitleCaseMapping:0x1706
 },
 { code:0x1707
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1707
  ,simpleLowerCaseMapping:0x1707
  ,simpleTitleCaseMapping:0x1707
 },
 { code:0x1708
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1708
  ,simpleLowerCaseMapping:0x1708
  ,simpleTitleCaseMapping:0x1708
 },
 { code:0x1709
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1709
  ,simpleLowerCaseMapping:0x1709
  ,simpleTitleCaseMapping:0x1709
 },
 { code:0x170A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x170A
  ,simpleLowerCaseMapping:0x170A
  ,simpleTitleCaseMapping:0x170A
 },
 { code:0x170B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x170B
  ,simpleLowerCaseMapping:0x170B
  ,simpleTitleCaseMapping:0x170B
 },
 { code:0x170C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x170C
  ,simpleLowerCaseMapping:0x170C
  ,simpleTitleCaseMapping:0x170C
 },
 { code:0x170E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x170E
  ,simpleLowerCaseMapping:0x170E
  ,simpleTitleCaseMapping:0x170E
 },
 { code:0x170F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x170F
  ,simpleLowerCaseMapping:0x170F
  ,simpleTitleCaseMapping:0x170F
 },
 { code:0x1710
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1710
  ,simpleLowerCaseMapping:0x1710
  ,simpleTitleCaseMapping:0x1710
 },
 { code:0x1711
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1711
  ,simpleLowerCaseMapping:0x1711
  ,simpleTitleCaseMapping:0x1711
 },
 { code:0x1712
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1712
  ,simpleLowerCaseMapping:0x1712
  ,simpleTitleCaseMapping:0x1712
 },
 { code:0x1713
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1713
  ,simpleLowerCaseMapping:0x1713
  ,simpleTitleCaseMapping:0x1713
 },
 { code:0x1714
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1714
  ,simpleLowerCaseMapping:0x1714
  ,simpleTitleCaseMapping:0x1714
 },
 { code:0x1720
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1720
  ,simpleLowerCaseMapping:0x1720
  ,simpleTitleCaseMapping:0x1720
 },
 { code:0x1721
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1721
  ,simpleLowerCaseMapping:0x1721
  ,simpleTitleCaseMapping:0x1721
 },
 { code:0x1722
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1722
  ,simpleLowerCaseMapping:0x1722
  ,simpleTitleCaseMapping:0x1722
 },
 { code:0x1723
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1723
  ,simpleLowerCaseMapping:0x1723
  ,simpleTitleCaseMapping:0x1723
 },
 { code:0x1724
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1724
  ,simpleLowerCaseMapping:0x1724
  ,simpleTitleCaseMapping:0x1724
 },
 { code:0x1725
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1725
  ,simpleLowerCaseMapping:0x1725
  ,simpleTitleCaseMapping:0x1725
 },
 { code:0x1726
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1726
  ,simpleLowerCaseMapping:0x1726
  ,simpleTitleCaseMapping:0x1726
 },
 { code:0x1727
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1727
  ,simpleLowerCaseMapping:0x1727
  ,simpleTitleCaseMapping:0x1727
 },
 { code:0x1728
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1728
  ,simpleLowerCaseMapping:0x1728
  ,simpleTitleCaseMapping:0x1728
 },
 { code:0x1729
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1729
  ,simpleLowerCaseMapping:0x1729
  ,simpleTitleCaseMapping:0x1729
 },
 { code:0x172A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x172A
  ,simpleLowerCaseMapping:0x172A
  ,simpleTitleCaseMapping:0x172A
 },
 { code:0x172B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x172B
  ,simpleLowerCaseMapping:0x172B
  ,simpleTitleCaseMapping:0x172B
 },
 { code:0x172C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x172C
  ,simpleLowerCaseMapping:0x172C
  ,simpleTitleCaseMapping:0x172C
 },
 { code:0x172D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x172D
  ,simpleLowerCaseMapping:0x172D
  ,simpleTitleCaseMapping:0x172D
 },
 { code:0x172E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x172E
  ,simpleLowerCaseMapping:0x172E
  ,simpleTitleCaseMapping:0x172E
 },
 { code:0x172F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x172F
  ,simpleLowerCaseMapping:0x172F
  ,simpleTitleCaseMapping:0x172F
 },
 { code:0x1730
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1730
  ,simpleLowerCaseMapping:0x1730
  ,simpleTitleCaseMapping:0x1730
 },
 { code:0x1731
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1731
  ,simpleLowerCaseMapping:0x1731
  ,simpleTitleCaseMapping:0x1731
 },
 { code:0x1732
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1732
  ,simpleLowerCaseMapping:0x1732
  ,simpleTitleCaseMapping:0x1732
 },
 { code:0x1733
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1733
  ,simpleLowerCaseMapping:0x1733
  ,simpleTitleCaseMapping:0x1733
 },
 { code:0x1734
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1734
  ,simpleLowerCaseMapping:0x1734
  ,simpleTitleCaseMapping:0x1734
 },
 { code:0x1735
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1735
  ,simpleLowerCaseMapping:0x1735
  ,simpleTitleCaseMapping:0x1735
 },
 { code:0x1736
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1736
  ,simpleLowerCaseMapping:0x1736
  ,simpleTitleCaseMapping:0x1736
 },
 { code:0x1740
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1740
  ,simpleLowerCaseMapping:0x1740
  ,simpleTitleCaseMapping:0x1740
 },
 { code:0x1741
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1741
  ,simpleLowerCaseMapping:0x1741
  ,simpleTitleCaseMapping:0x1741
 },
 { code:0x1742
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1742
  ,simpleLowerCaseMapping:0x1742
  ,simpleTitleCaseMapping:0x1742
 },
 { code:0x1743
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1743
  ,simpleLowerCaseMapping:0x1743
  ,simpleTitleCaseMapping:0x1743
 },
 { code:0x1744
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1744
  ,simpleLowerCaseMapping:0x1744
  ,simpleTitleCaseMapping:0x1744
 },
 { code:0x1745
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1745
  ,simpleLowerCaseMapping:0x1745
  ,simpleTitleCaseMapping:0x1745
 },
 { code:0x1746
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1746
  ,simpleLowerCaseMapping:0x1746
  ,simpleTitleCaseMapping:0x1746
 },
 { code:0x1747
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1747
  ,simpleLowerCaseMapping:0x1747
  ,simpleTitleCaseMapping:0x1747
 },
 { code:0x1748
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1748
  ,simpleLowerCaseMapping:0x1748
  ,simpleTitleCaseMapping:0x1748
 },
 { code:0x1749
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1749
  ,simpleLowerCaseMapping:0x1749
  ,simpleTitleCaseMapping:0x1749
 },
 { code:0x174A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x174A
  ,simpleLowerCaseMapping:0x174A
  ,simpleTitleCaseMapping:0x174A
 },
 { code:0x174B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x174B
  ,simpleLowerCaseMapping:0x174B
  ,simpleTitleCaseMapping:0x174B
 },
 { code:0x174C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x174C
  ,simpleLowerCaseMapping:0x174C
  ,simpleTitleCaseMapping:0x174C
 },
 { code:0x174D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x174D
  ,simpleLowerCaseMapping:0x174D
  ,simpleTitleCaseMapping:0x174D
 },
 { code:0x174E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x174E
  ,simpleLowerCaseMapping:0x174E
  ,simpleTitleCaseMapping:0x174E
 },
 { code:0x174F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x174F
  ,simpleLowerCaseMapping:0x174F
  ,simpleTitleCaseMapping:0x174F
 },
 { code:0x1750
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1750
  ,simpleLowerCaseMapping:0x1750
  ,simpleTitleCaseMapping:0x1750
 },
 { code:0x1751
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1751
  ,simpleLowerCaseMapping:0x1751
  ,simpleTitleCaseMapping:0x1751
 },
 { code:0x1752
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1752
  ,simpleLowerCaseMapping:0x1752
  ,simpleTitleCaseMapping:0x1752
 },
 { code:0x1753
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1753
  ,simpleLowerCaseMapping:0x1753
  ,simpleTitleCaseMapping:0x1753
 },
 { code:0x1760
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1760
  ,simpleLowerCaseMapping:0x1760
  ,simpleTitleCaseMapping:0x1760
 },
 { code:0x1761
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1761
  ,simpleLowerCaseMapping:0x1761
  ,simpleTitleCaseMapping:0x1761
 },
 { code:0x1762
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1762
  ,simpleLowerCaseMapping:0x1762
  ,simpleTitleCaseMapping:0x1762
 },
 { code:0x1763
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1763
  ,simpleLowerCaseMapping:0x1763
  ,simpleTitleCaseMapping:0x1763
 },
 { code:0x1764
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1764
  ,simpleLowerCaseMapping:0x1764
  ,simpleTitleCaseMapping:0x1764
 },
 { code:0x1765
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1765
  ,simpleLowerCaseMapping:0x1765
  ,simpleTitleCaseMapping:0x1765
 },
 { code:0x1766
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1766
  ,simpleLowerCaseMapping:0x1766
  ,simpleTitleCaseMapping:0x1766
 },
 { code:0x1767
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1767
  ,simpleLowerCaseMapping:0x1767
  ,simpleTitleCaseMapping:0x1767
 },
 { code:0x1768
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1768
  ,simpleLowerCaseMapping:0x1768
  ,simpleTitleCaseMapping:0x1768
 },
 { code:0x1769
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1769
  ,simpleLowerCaseMapping:0x1769
  ,simpleTitleCaseMapping:0x1769
 },
 { code:0x176A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x176A
  ,simpleLowerCaseMapping:0x176A
  ,simpleTitleCaseMapping:0x176A
 },
 { code:0x176B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x176B
  ,simpleLowerCaseMapping:0x176B
  ,simpleTitleCaseMapping:0x176B
 },
 { code:0x176C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x176C
  ,simpleLowerCaseMapping:0x176C
  ,simpleTitleCaseMapping:0x176C
 },
 { code:0x176E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x176E
  ,simpleLowerCaseMapping:0x176E
  ,simpleTitleCaseMapping:0x176E
 },
 { code:0x176F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x176F
  ,simpleLowerCaseMapping:0x176F
  ,simpleTitleCaseMapping:0x176F
 },
 { code:0x1770
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1770
  ,simpleLowerCaseMapping:0x1770
  ,simpleTitleCaseMapping:0x1770
 },
 { code:0x1772
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1772
  ,simpleLowerCaseMapping:0x1772
  ,simpleTitleCaseMapping:0x1772
 },
 { code:0x1773
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1773
  ,simpleLowerCaseMapping:0x1773
  ,simpleTitleCaseMapping:0x1773
 },
 { code:0x1780
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1780
  ,simpleLowerCaseMapping:0x1780
  ,simpleTitleCaseMapping:0x1780
 },
 { code:0x1781
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1781
  ,simpleLowerCaseMapping:0x1781
  ,simpleTitleCaseMapping:0x1781
 },
 { code:0x1782
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1782
  ,simpleLowerCaseMapping:0x1782
  ,simpleTitleCaseMapping:0x1782
 },
 { code:0x1783
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1783
  ,simpleLowerCaseMapping:0x1783
  ,simpleTitleCaseMapping:0x1783
 },
 { code:0x1784
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1784
  ,simpleLowerCaseMapping:0x1784
  ,simpleTitleCaseMapping:0x1784
 },
 { code:0x1785
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1785
  ,simpleLowerCaseMapping:0x1785
  ,simpleTitleCaseMapping:0x1785
 },
 { code:0x1786
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1786
  ,simpleLowerCaseMapping:0x1786
  ,simpleTitleCaseMapping:0x1786
 },
 { code:0x1787
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1787
  ,simpleLowerCaseMapping:0x1787
  ,simpleTitleCaseMapping:0x1787
 },
 { code:0x1788
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1788
  ,simpleLowerCaseMapping:0x1788
  ,simpleTitleCaseMapping:0x1788
 },
 { code:0x1789
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1789
  ,simpleLowerCaseMapping:0x1789
  ,simpleTitleCaseMapping:0x1789
 },
 { code:0x178A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x178A
  ,simpleLowerCaseMapping:0x178A
  ,simpleTitleCaseMapping:0x178A
 },
 { code:0x178B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x178B
  ,simpleLowerCaseMapping:0x178B
  ,simpleTitleCaseMapping:0x178B
 },
 { code:0x178C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x178C
  ,simpleLowerCaseMapping:0x178C
  ,simpleTitleCaseMapping:0x178C
 },
 { code:0x178D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x178D
  ,simpleLowerCaseMapping:0x178D
  ,simpleTitleCaseMapping:0x178D
 },
 { code:0x178E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x178E
  ,simpleLowerCaseMapping:0x178E
  ,simpleTitleCaseMapping:0x178E
 },
 { code:0x178F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x178F
  ,simpleLowerCaseMapping:0x178F
  ,simpleTitleCaseMapping:0x178F
 },
 { code:0x1790
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1790
  ,simpleLowerCaseMapping:0x1790
  ,simpleTitleCaseMapping:0x1790
 },
 { code:0x1791
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1791
  ,simpleLowerCaseMapping:0x1791
  ,simpleTitleCaseMapping:0x1791
 },
 { code:0x1792
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1792
  ,simpleLowerCaseMapping:0x1792
  ,simpleTitleCaseMapping:0x1792
 },
 { code:0x1793
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1793
  ,simpleLowerCaseMapping:0x1793
  ,simpleTitleCaseMapping:0x1793
 },
 { code:0x1794
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1794
  ,simpleLowerCaseMapping:0x1794
  ,simpleTitleCaseMapping:0x1794
 },
 { code:0x1795
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1795
  ,simpleLowerCaseMapping:0x1795
  ,simpleTitleCaseMapping:0x1795
 },
 { code:0x1796
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1796
  ,simpleLowerCaseMapping:0x1796
  ,simpleTitleCaseMapping:0x1796
 },
 { code:0x1797
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1797
  ,simpleLowerCaseMapping:0x1797
  ,simpleTitleCaseMapping:0x1797
 },
 { code:0x1798
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1798
  ,simpleLowerCaseMapping:0x1798
  ,simpleTitleCaseMapping:0x1798
 },
 { code:0x1799
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1799
  ,simpleLowerCaseMapping:0x1799
  ,simpleTitleCaseMapping:0x1799
 },
 { code:0x179A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x179A
  ,simpleLowerCaseMapping:0x179A
  ,simpleTitleCaseMapping:0x179A
 },
 { code:0x179B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x179B
  ,simpleLowerCaseMapping:0x179B
  ,simpleTitleCaseMapping:0x179B
 },
 { code:0x179C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x179C
  ,simpleLowerCaseMapping:0x179C
  ,simpleTitleCaseMapping:0x179C
 },
 { code:0x179D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x179D
  ,simpleLowerCaseMapping:0x179D
  ,simpleTitleCaseMapping:0x179D
 },
 { code:0x179E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x179E
  ,simpleLowerCaseMapping:0x179E
  ,simpleTitleCaseMapping:0x179E
 },
 { code:0x179F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x179F
  ,simpleLowerCaseMapping:0x179F
  ,simpleTitleCaseMapping:0x179F
 },
 { code:0x17A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17A0
  ,simpleLowerCaseMapping:0x17A0
  ,simpleTitleCaseMapping:0x17A0
 },
 { code:0x17A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17A1
  ,simpleLowerCaseMapping:0x17A1
  ,simpleTitleCaseMapping:0x17A1
 },
 { code:0x17A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17A2
  ,simpleLowerCaseMapping:0x17A2
  ,simpleTitleCaseMapping:0x17A2
 },
 { code:0x17A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17A3
  ,simpleLowerCaseMapping:0x17A3
  ,simpleTitleCaseMapping:0x17A3
 },
 { code:0x17A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17A4
  ,simpleLowerCaseMapping:0x17A4
  ,simpleTitleCaseMapping:0x17A4
 },
 { code:0x17A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17A5
  ,simpleLowerCaseMapping:0x17A5
  ,simpleTitleCaseMapping:0x17A5
 },
 { code:0x17A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17A6
  ,simpleLowerCaseMapping:0x17A6
  ,simpleTitleCaseMapping:0x17A6
 },
 { code:0x17A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17A7
  ,simpleLowerCaseMapping:0x17A7
  ,simpleTitleCaseMapping:0x17A7
 },
 { code:0x17A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17A8
  ,simpleLowerCaseMapping:0x17A8
  ,simpleTitleCaseMapping:0x17A8
 },
 { code:0x17A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17A9
  ,simpleLowerCaseMapping:0x17A9
  ,simpleTitleCaseMapping:0x17A9
 },
 { code:0x17AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17AA
  ,simpleLowerCaseMapping:0x17AA
  ,simpleTitleCaseMapping:0x17AA
 },
 { code:0x17AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17AB
  ,simpleLowerCaseMapping:0x17AB
  ,simpleTitleCaseMapping:0x17AB
 },
 { code:0x17AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17AC
  ,simpleLowerCaseMapping:0x17AC
  ,simpleTitleCaseMapping:0x17AC
 },
 { code:0x17AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17AD
  ,simpleLowerCaseMapping:0x17AD
  ,simpleTitleCaseMapping:0x17AD
 },
 { code:0x17AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17AE
  ,simpleLowerCaseMapping:0x17AE
  ,simpleTitleCaseMapping:0x17AE
 },
 { code:0x17AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17AF
  ,simpleLowerCaseMapping:0x17AF
  ,simpleTitleCaseMapping:0x17AF
 },
 { code:0x17B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17B0
  ,simpleLowerCaseMapping:0x17B0
  ,simpleTitleCaseMapping:0x17B0
 },
 { code:0x17B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17B1
  ,simpleLowerCaseMapping:0x17B1
  ,simpleTitleCaseMapping:0x17B1
 },
 { code:0x17B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17B2
  ,simpleLowerCaseMapping:0x17B2
  ,simpleTitleCaseMapping:0x17B2
 },
 { code:0x17B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17B3
  ,simpleLowerCaseMapping:0x17B3
  ,simpleTitleCaseMapping:0x17B3
 },
 { code:0x17B4
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x17B4
  ,simpleLowerCaseMapping:0x17B4
  ,simpleTitleCaseMapping:0x17B4
 },
 { code:0x17B5
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x17B5
  ,simpleLowerCaseMapping:0x17B5
  ,simpleTitleCaseMapping:0x17B5
 },
 { code:0x17B6
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x17B6
  ,simpleLowerCaseMapping:0x17B6
  ,simpleTitleCaseMapping:0x17B6
 },
 { code:0x17B7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17B7
  ,simpleLowerCaseMapping:0x17B7
  ,simpleTitleCaseMapping:0x17B7
 },
 { code:0x17B8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17B8
  ,simpleLowerCaseMapping:0x17B8
  ,simpleTitleCaseMapping:0x17B8
 },
 { code:0x17B9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17B9
  ,simpleLowerCaseMapping:0x17B9
  ,simpleTitleCaseMapping:0x17B9
 },
 { code:0x17BA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17BA
  ,simpleLowerCaseMapping:0x17BA
  ,simpleTitleCaseMapping:0x17BA
 },
 { code:0x17BB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17BB
  ,simpleLowerCaseMapping:0x17BB
  ,simpleTitleCaseMapping:0x17BB
 },
 { code:0x17BC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17BC
  ,simpleLowerCaseMapping:0x17BC
  ,simpleTitleCaseMapping:0x17BC
 },
 { code:0x17BD
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17BD
  ,simpleLowerCaseMapping:0x17BD
  ,simpleTitleCaseMapping:0x17BD
 },
 { code:0x17BE
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x17BE
  ,simpleLowerCaseMapping:0x17BE
  ,simpleTitleCaseMapping:0x17BE
 },
 { code:0x17BF
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x17BF
  ,simpleLowerCaseMapping:0x17BF
  ,simpleTitleCaseMapping:0x17BF
 },
 { code:0x17C0
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x17C0
  ,simpleLowerCaseMapping:0x17C0
  ,simpleTitleCaseMapping:0x17C0
 },
 { code:0x17C1
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x17C1
  ,simpleLowerCaseMapping:0x17C1
  ,simpleTitleCaseMapping:0x17C1
 },
 { code:0x17C2
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x17C2
  ,simpleLowerCaseMapping:0x17C2
  ,simpleTitleCaseMapping:0x17C2
 },
 { code:0x17C3
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x17C3
  ,simpleLowerCaseMapping:0x17C3
  ,simpleTitleCaseMapping:0x17C3
 },
 { code:0x17C4
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x17C4
  ,simpleLowerCaseMapping:0x17C4
  ,simpleTitleCaseMapping:0x17C4
 },
 { code:0x17C5
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x17C5
  ,simpleLowerCaseMapping:0x17C5
  ,simpleTitleCaseMapping:0x17C5
 },
 { code:0x17C6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17C6
  ,simpleLowerCaseMapping:0x17C6
  ,simpleTitleCaseMapping:0x17C6
 },
 { code:0x17C7
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x17C7
  ,simpleLowerCaseMapping:0x17C7
  ,simpleTitleCaseMapping:0x17C7
 },
 { code:0x17C8
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x17C8
  ,simpleLowerCaseMapping:0x17C8
  ,simpleTitleCaseMapping:0x17C8
 },
 { code:0x17C9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17C9
  ,simpleLowerCaseMapping:0x17C9
  ,simpleTitleCaseMapping:0x17C9
 },
 { code:0x17CA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17CA
  ,simpleLowerCaseMapping:0x17CA
  ,simpleTitleCaseMapping:0x17CA
 },
 { code:0x17CB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17CB
  ,simpleLowerCaseMapping:0x17CB
  ,simpleTitleCaseMapping:0x17CB
 },
 { code:0x17CC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17CC
  ,simpleLowerCaseMapping:0x17CC
  ,simpleTitleCaseMapping:0x17CC
 },
 { code:0x17CD
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17CD
  ,simpleLowerCaseMapping:0x17CD
  ,simpleTitleCaseMapping:0x17CD
 },
 { code:0x17CE
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17CE
  ,simpleLowerCaseMapping:0x17CE
  ,simpleTitleCaseMapping:0x17CE
 },
 { code:0x17CF
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17CF
  ,simpleLowerCaseMapping:0x17CF
  ,simpleTitleCaseMapping:0x17CF
 },
 { code:0x17D0
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17D0
  ,simpleLowerCaseMapping:0x17D0
  ,simpleTitleCaseMapping:0x17D0
 },
 { code:0x17D1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17D1
  ,simpleLowerCaseMapping:0x17D1
  ,simpleTitleCaseMapping:0x17D1
 },
 { code:0x17D2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17D2
  ,simpleLowerCaseMapping:0x17D2
  ,simpleTitleCaseMapping:0x17D2
 },
 { code:0x17D3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17D3
  ,simpleLowerCaseMapping:0x17D3
  ,simpleTitleCaseMapping:0x17D3
 },
 { code:0x17D4
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x17D4
  ,simpleLowerCaseMapping:0x17D4
  ,simpleTitleCaseMapping:0x17D4
 },
 { code:0x17D5
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x17D5
  ,simpleLowerCaseMapping:0x17D5
  ,simpleTitleCaseMapping:0x17D5
 },
 { code:0x17D6
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x17D6
  ,simpleLowerCaseMapping:0x17D6
  ,simpleTitleCaseMapping:0x17D6
 },
 { code:0x17D7
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x17D7
  ,simpleLowerCaseMapping:0x17D7
  ,simpleTitleCaseMapping:0x17D7
 },
 { code:0x17D8
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x17D8
  ,simpleLowerCaseMapping:0x17D8
  ,simpleTitleCaseMapping:0x17D8
 },
 { code:0x17D9
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x17D9
  ,simpleLowerCaseMapping:0x17D9
  ,simpleTitleCaseMapping:0x17D9
 },
 { code:0x17DA
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x17DA
  ,simpleLowerCaseMapping:0x17DA
  ,simpleTitleCaseMapping:0x17DA
 },
 { code:0x17DB
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x17DB
  ,simpleLowerCaseMapping:0x17DB
  ,simpleTitleCaseMapping:0x17DB
 },
 { code:0x17DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x17DC
  ,simpleLowerCaseMapping:0x17DC
  ,simpleTitleCaseMapping:0x17DC
 },
 { code:0x17DD
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x17DD
  ,simpleLowerCaseMapping:0x17DD
  ,simpleTitleCaseMapping:0x17DD
 },
 { code:0x17E0
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x17E0
  ,simpleLowerCaseMapping:0x17E0
  ,simpleTitleCaseMapping:0x17E0
 },
 { code:0x17E1
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x17E1
  ,simpleLowerCaseMapping:0x17E1
  ,simpleTitleCaseMapping:0x17E1
 },
 { code:0x17E2
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x17E2
  ,simpleLowerCaseMapping:0x17E2
  ,simpleTitleCaseMapping:0x17E2
 },
 { code:0x17E3
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x17E3
  ,simpleLowerCaseMapping:0x17E3
  ,simpleTitleCaseMapping:0x17E3
 },
 { code:0x17E4
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x17E4
  ,simpleLowerCaseMapping:0x17E4
  ,simpleTitleCaseMapping:0x17E4
 },
 { code:0x17E5
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x17E5
  ,simpleLowerCaseMapping:0x17E5
  ,simpleTitleCaseMapping:0x17E5
 },
 { code:0x17E6
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x17E6
  ,simpleLowerCaseMapping:0x17E6
  ,simpleTitleCaseMapping:0x17E6
 },
 { code:0x17E7
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x17E7
  ,simpleLowerCaseMapping:0x17E7
  ,simpleTitleCaseMapping:0x17E7
 },
 { code:0x17E8
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x17E8
  ,simpleLowerCaseMapping:0x17E8
  ,simpleTitleCaseMapping:0x17E8
 },
 { code:0x17E9
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x17E9
  ,simpleLowerCaseMapping:0x17E9
  ,simpleTitleCaseMapping:0x17E9
 },
 { code:0x17F0
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x17F0
  ,simpleLowerCaseMapping:0x17F0
  ,simpleTitleCaseMapping:0x17F0
 },
 { code:0x17F1
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x17F1
  ,simpleLowerCaseMapping:0x17F1
  ,simpleTitleCaseMapping:0x17F1
 },
 { code:0x17F2
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x17F2
  ,simpleLowerCaseMapping:0x17F2
  ,simpleTitleCaseMapping:0x17F2
 },
 { code:0x17F3
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x17F3
  ,simpleLowerCaseMapping:0x17F3
  ,simpleTitleCaseMapping:0x17F3
 },
 { code:0x17F4
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x17F4
  ,simpleLowerCaseMapping:0x17F4
  ,simpleTitleCaseMapping:0x17F4
 },
 { code:0x17F5
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x17F5
  ,simpleLowerCaseMapping:0x17F5
  ,simpleTitleCaseMapping:0x17F5
 },
 { code:0x17F6
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x17F6
  ,simpleLowerCaseMapping:0x17F6
  ,simpleTitleCaseMapping:0x17F6
 },
 { code:0x17F7
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x17F7
  ,simpleLowerCaseMapping:0x17F7
  ,simpleTitleCaseMapping:0x17F7
 },
 { code:0x17F8
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x17F8
  ,simpleLowerCaseMapping:0x17F8
  ,simpleTitleCaseMapping:0x17F8
 },
 { code:0x17F9
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x17F9
  ,simpleLowerCaseMapping:0x17F9
  ,simpleTitleCaseMapping:0x17F9
 },
 { code:0x1800
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1800
  ,simpleLowerCaseMapping:0x1800
  ,simpleTitleCaseMapping:0x1800
 },
 { code:0x1801
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1801
  ,simpleLowerCaseMapping:0x1801
  ,simpleTitleCaseMapping:0x1801
 },
 { code:0x1802
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1802
  ,simpleLowerCaseMapping:0x1802
  ,simpleTitleCaseMapping:0x1802
 },
 { code:0x1803
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1803
  ,simpleLowerCaseMapping:0x1803
  ,simpleTitleCaseMapping:0x1803
 },
 { code:0x1804
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1804
  ,simpleLowerCaseMapping:0x1804
  ,simpleTitleCaseMapping:0x1804
 },
 { code:0x1805
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1805
  ,simpleLowerCaseMapping:0x1805
  ,simpleTitleCaseMapping:0x1805
 },
 { code:0x1806
  ,generalCategory:UnicodeData.GeneralCategory.Pd
  ,simpleUpperCaseMapping:0x1806
  ,simpleLowerCaseMapping:0x1806
  ,simpleTitleCaseMapping:0x1806
 },
 { code:0x1807
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1807
  ,simpleLowerCaseMapping:0x1807
  ,simpleTitleCaseMapping:0x1807
 },
 { code:0x1808
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1808
  ,simpleLowerCaseMapping:0x1808
  ,simpleTitleCaseMapping:0x1808
 },
 { code:0x1809
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1809
  ,simpleLowerCaseMapping:0x1809
  ,simpleTitleCaseMapping:0x1809
 },
 { code:0x180A
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x180A
  ,simpleLowerCaseMapping:0x180A
  ,simpleTitleCaseMapping:0x180A
 },
 { code:0x180B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x180B
  ,simpleLowerCaseMapping:0x180B
  ,simpleTitleCaseMapping:0x180B
 },
 { code:0x180C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x180C
  ,simpleLowerCaseMapping:0x180C
  ,simpleTitleCaseMapping:0x180C
 },
 { code:0x180D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x180D
  ,simpleLowerCaseMapping:0x180D
  ,simpleTitleCaseMapping:0x180D
 },
 { code:0x180E
  ,generalCategory:UnicodeData.GeneralCategory.Zs
  ,simpleUpperCaseMapping:0x180E
  ,simpleLowerCaseMapping:0x180E
  ,simpleTitleCaseMapping:0x180E
 },
 { code:0x1810
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1810
  ,simpleLowerCaseMapping:0x1810
  ,simpleTitleCaseMapping:0x1810
 },
 { code:0x1811
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1811
  ,simpleLowerCaseMapping:0x1811
  ,simpleTitleCaseMapping:0x1811
 },
 { code:0x1812
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1812
  ,simpleLowerCaseMapping:0x1812
  ,simpleTitleCaseMapping:0x1812
 },
 { code:0x1813
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1813
  ,simpleLowerCaseMapping:0x1813
  ,simpleTitleCaseMapping:0x1813
 },
 { code:0x1814
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1814
  ,simpleLowerCaseMapping:0x1814
  ,simpleTitleCaseMapping:0x1814
 },
 { code:0x1815
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1815
  ,simpleLowerCaseMapping:0x1815
  ,simpleTitleCaseMapping:0x1815
 },
 { code:0x1816
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1816
  ,simpleLowerCaseMapping:0x1816
  ,simpleTitleCaseMapping:0x1816
 },
 { code:0x1817
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1817
  ,simpleLowerCaseMapping:0x1817
  ,simpleTitleCaseMapping:0x1817
 },
 { code:0x1818
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1818
  ,simpleLowerCaseMapping:0x1818
  ,simpleTitleCaseMapping:0x1818
 },
 { code:0x1819
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1819
  ,simpleLowerCaseMapping:0x1819
  ,simpleTitleCaseMapping:0x1819
 },
 { code:0x1820
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1820
  ,simpleLowerCaseMapping:0x1820
  ,simpleTitleCaseMapping:0x1820
 },
 { code:0x1821
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1821
  ,simpleLowerCaseMapping:0x1821
  ,simpleTitleCaseMapping:0x1821
 },
 { code:0x1822
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1822
  ,simpleLowerCaseMapping:0x1822
  ,simpleTitleCaseMapping:0x1822
 },
 { code:0x1823
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1823
  ,simpleLowerCaseMapping:0x1823
  ,simpleTitleCaseMapping:0x1823
 },
 { code:0x1824
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1824
  ,simpleLowerCaseMapping:0x1824
  ,simpleTitleCaseMapping:0x1824
 },
 { code:0x1825
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1825
  ,simpleLowerCaseMapping:0x1825
  ,simpleTitleCaseMapping:0x1825
 },
 { code:0x1826
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1826
  ,simpleLowerCaseMapping:0x1826
  ,simpleTitleCaseMapping:0x1826
 },
 { code:0x1827
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1827
  ,simpleLowerCaseMapping:0x1827
  ,simpleTitleCaseMapping:0x1827
 },
 { code:0x1828
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1828
  ,simpleLowerCaseMapping:0x1828
  ,simpleTitleCaseMapping:0x1828
 },
 { code:0x1829
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1829
  ,simpleLowerCaseMapping:0x1829
  ,simpleTitleCaseMapping:0x1829
 },
 { code:0x182A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x182A
  ,simpleLowerCaseMapping:0x182A
  ,simpleTitleCaseMapping:0x182A
 },
 { code:0x182B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x182B
  ,simpleLowerCaseMapping:0x182B
  ,simpleTitleCaseMapping:0x182B
 },
 { code:0x182C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x182C
  ,simpleLowerCaseMapping:0x182C
  ,simpleTitleCaseMapping:0x182C
 },
 { code:0x182D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x182D
  ,simpleLowerCaseMapping:0x182D
  ,simpleTitleCaseMapping:0x182D
 },
 { code:0x182E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x182E
  ,simpleLowerCaseMapping:0x182E
  ,simpleTitleCaseMapping:0x182E
 },
 { code:0x182F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x182F
  ,simpleLowerCaseMapping:0x182F
  ,simpleTitleCaseMapping:0x182F
 },
 { code:0x1830
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1830
  ,simpleLowerCaseMapping:0x1830
  ,simpleTitleCaseMapping:0x1830
 },
 { code:0x1831
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1831
  ,simpleLowerCaseMapping:0x1831
  ,simpleTitleCaseMapping:0x1831
 },
 { code:0x1832
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1832
  ,simpleLowerCaseMapping:0x1832
  ,simpleTitleCaseMapping:0x1832
 },
 { code:0x1833
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1833
  ,simpleLowerCaseMapping:0x1833
  ,simpleTitleCaseMapping:0x1833
 },
 { code:0x1834
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1834
  ,simpleLowerCaseMapping:0x1834
  ,simpleTitleCaseMapping:0x1834
 },
 { code:0x1835
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1835
  ,simpleLowerCaseMapping:0x1835
  ,simpleTitleCaseMapping:0x1835
 },
 { code:0x1836
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1836
  ,simpleLowerCaseMapping:0x1836
  ,simpleTitleCaseMapping:0x1836
 },
 { code:0x1837
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1837
  ,simpleLowerCaseMapping:0x1837
  ,simpleTitleCaseMapping:0x1837
 },
 { code:0x1838
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1838
  ,simpleLowerCaseMapping:0x1838
  ,simpleTitleCaseMapping:0x1838
 },
 { code:0x1839
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1839
  ,simpleLowerCaseMapping:0x1839
  ,simpleTitleCaseMapping:0x1839
 },
 { code:0x183A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x183A
  ,simpleLowerCaseMapping:0x183A
  ,simpleTitleCaseMapping:0x183A
 },
 { code:0x183B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x183B
  ,simpleLowerCaseMapping:0x183B
  ,simpleTitleCaseMapping:0x183B
 },
 { code:0x183C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x183C
  ,simpleLowerCaseMapping:0x183C
  ,simpleTitleCaseMapping:0x183C
 },
 { code:0x183D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x183D
  ,simpleLowerCaseMapping:0x183D
  ,simpleTitleCaseMapping:0x183D
 },
 { code:0x183E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x183E
  ,simpleLowerCaseMapping:0x183E
  ,simpleTitleCaseMapping:0x183E
 },
 { code:0x183F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x183F
  ,simpleLowerCaseMapping:0x183F
  ,simpleTitleCaseMapping:0x183F
 },
 { code:0x1840
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1840
  ,simpleLowerCaseMapping:0x1840
  ,simpleTitleCaseMapping:0x1840
 },
 { code:0x1841
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1841
  ,simpleLowerCaseMapping:0x1841
  ,simpleTitleCaseMapping:0x1841
 },
 { code:0x1842
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1842
  ,simpleLowerCaseMapping:0x1842
  ,simpleTitleCaseMapping:0x1842
 },
 { code:0x1843
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1843
  ,simpleLowerCaseMapping:0x1843
  ,simpleTitleCaseMapping:0x1843
 },
 { code:0x1844
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1844
  ,simpleLowerCaseMapping:0x1844
  ,simpleTitleCaseMapping:0x1844
 },
 { code:0x1845
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1845
  ,simpleLowerCaseMapping:0x1845
  ,simpleTitleCaseMapping:0x1845
 },
 { code:0x1846
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1846
  ,simpleLowerCaseMapping:0x1846
  ,simpleTitleCaseMapping:0x1846
 },
 { code:0x1847
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1847
  ,simpleLowerCaseMapping:0x1847
  ,simpleTitleCaseMapping:0x1847
 },
 { code:0x1848
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1848
  ,simpleLowerCaseMapping:0x1848
  ,simpleTitleCaseMapping:0x1848
 },
 { code:0x1849
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1849
  ,simpleLowerCaseMapping:0x1849
  ,simpleTitleCaseMapping:0x1849
 },
 { code:0x184A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x184A
  ,simpleLowerCaseMapping:0x184A
  ,simpleTitleCaseMapping:0x184A
 },
 { code:0x184B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x184B
  ,simpleLowerCaseMapping:0x184B
  ,simpleTitleCaseMapping:0x184B
 },
 { code:0x184C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x184C
  ,simpleLowerCaseMapping:0x184C
  ,simpleTitleCaseMapping:0x184C
 },
 { code:0x184D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x184D
  ,simpleLowerCaseMapping:0x184D
  ,simpleTitleCaseMapping:0x184D
 },
 { code:0x184E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x184E
  ,simpleLowerCaseMapping:0x184E
  ,simpleTitleCaseMapping:0x184E
 },
 { code:0x184F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x184F
  ,simpleLowerCaseMapping:0x184F
  ,simpleTitleCaseMapping:0x184F
 },
 { code:0x1850
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1850
  ,simpleLowerCaseMapping:0x1850
  ,simpleTitleCaseMapping:0x1850
 },
 { code:0x1851
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1851
  ,simpleLowerCaseMapping:0x1851
  ,simpleTitleCaseMapping:0x1851
 },
 { code:0x1852
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1852
  ,simpleLowerCaseMapping:0x1852
  ,simpleTitleCaseMapping:0x1852
 },
 { code:0x1853
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1853
  ,simpleLowerCaseMapping:0x1853
  ,simpleTitleCaseMapping:0x1853
 },
 { code:0x1854
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1854
  ,simpleLowerCaseMapping:0x1854
  ,simpleTitleCaseMapping:0x1854
 },
 { code:0x1855
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1855
  ,simpleLowerCaseMapping:0x1855
  ,simpleTitleCaseMapping:0x1855
 },
 { code:0x1856
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1856
  ,simpleLowerCaseMapping:0x1856
  ,simpleTitleCaseMapping:0x1856
 },
 { code:0x1857
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1857
  ,simpleLowerCaseMapping:0x1857
  ,simpleTitleCaseMapping:0x1857
 },
 { code:0x1858
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1858
  ,simpleLowerCaseMapping:0x1858
  ,simpleTitleCaseMapping:0x1858
 },
 { code:0x1859
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1859
  ,simpleLowerCaseMapping:0x1859
  ,simpleTitleCaseMapping:0x1859
 },
 { code:0x185A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x185A
  ,simpleLowerCaseMapping:0x185A
  ,simpleTitleCaseMapping:0x185A
 },
 { code:0x185B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x185B
  ,simpleLowerCaseMapping:0x185B
  ,simpleTitleCaseMapping:0x185B
 },
 { code:0x185C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x185C
  ,simpleLowerCaseMapping:0x185C
  ,simpleTitleCaseMapping:0x185C
 },
 { code:0x185D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x185D
  ,simpleLowerCaseMapping:0x185D
  ,simpleTitleCaseMapping:0x185D
 },
 { code:0x185E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x185E
  ,simpleLowerCaseMapping:0x185E
  ,simpleTitleCaseMapping:0x185E
 },
 { code:0x185F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x185F
  ,simpleLowerCaseMapping:0x185F
  ,simpleTitleCaseMapping:0x185F
 },
 { code:0x1860
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1860
  ,simpleLowerCaseMapping:0x1860
  ,simpleTitleCaseMapping:0x1860
 },
 { code:0x1861
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1861
  ,simpleLowerCaseMapping:0x1861
  ,simpleTitleCaseMapping:0x1861
 },
 { code:0x1862
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1862
  ,simpleLowerCaseMapping:0x1862
  ,simpleTitleCaseMapping:0x1862
 },
 { code:0x1863
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1863
  ,simpleLowerCaseMapping:0x1863
  ,simpleTitleCaseMapping:0x1863
 },
 { code:0x1864
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1864
  ,simpleLowerCaseMapping:0x1864
  ,simpleTitleCaseMapping:0x1864
 },
 { code:0x1865
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1865
  ,simpleLowerCaseMapping:0x1865
  ,simpleTitleCaseMapping:0x1865
 },
 { code:0x1866
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1866
  ,simpleLowerCaseMapping:0x1866
  ,simpleTitleCaseMapping:0x1866
 },
 { code:0x1867
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1867
  ,simpleLowerCaseMapping:0x1867
  ,simpleTitleCaseMapping:0x1867
 },
 { code:0x1868
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1868
  ,simpleLowerCaseMapping:0x1868
  ,simpleTitleCaseMapping:0x1868
 },
 { code:0x1869
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1869
  ,simpleLowerCaseMapping:0x1869
  ,simpleTitleCaseMapping:0x1869
 },
 { code:0x186A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x186A
  ,simpleLowerCaseMapping:0x186A
  ,simpleTitleCaseMapping:0x186A
 },
 { code:0x186B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x186B
  ,simpleLowerCaseMapping:0x186B
  ,simpleTitleCaseMapping:0x186B
 },
 { code:0x186C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x186C
  ,simpleLowerCaseMapping:0x186C
  ,simpleTitleCaseMapping:0x186C
 },
 { code:0x186D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x186D
  ,simpleLowerCaseMapping:0x186D
  ,simpleTitleCaseMapping:0x186D
 },
 { code:0x186E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x186E
  ,simpleLowerCaseMapping:0x186E
  ,simpleTitleCaseMapping:0x186E
 },
 { code:0x186F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x186F
  ,simpleLowerCaseMapping:0x186F
  ,simpleTitleCaseMapping:0x186F
 },
 { code:0x1870
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1870
  ,simpleLowerCaseMapping:0x1870
  ,simpleTitleCaseMapping:0x1870
 },
 { code:0x1871
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1871
  ,simpleLowerCaseMapping:0x1871
  ,simpleTitleCaseMapping:0x1871
 },
 { code:0x1872
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1872
  ,simpleLowerCaseMapping:0x1872
  ,simpleTitleCaseMapping:0x1872
 },
 { code:0x1873
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1873
  ,simpleLowerCaseMapping:0x1873
  ,simpleTitleCaseMapping:0x1873
 },
 { code:0x1874
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1874
  ,simpleLowerCaseMapping:0x1874
  ,simpleTitleCaseMapping:0x1874
 },
 { code:0x1875
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1875
  ,simpleLowerCaseMapping:0x1875
  ,simpleTitleCaseMapping:0x1875
 },
 { code:0x1876
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1876
  ,simpleLowerCaseMapping:0x1876
  ,simpleTitleCaseMapping:0x1876
 },
 { code:0x1877
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1877
  ,simpleLowerCaseMapping:0x1877
  ,simpleTitleCaseMapping:0x1877
 },
 { code:0x1880
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1880
  ,simpleLowerCaseMapping:0x1880
  ,simpleTitleCaseMapping:0x1880
 },
 { code:0x1881
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1881
  ,simpleLowerCaseMapping:0x1881
  ,simpleTitleCaseMapping:0x1881
 },
 { code:0x1882
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1882
  ,simpleLowerCaseMapping:0x1882
  ,simpleTitleCaseMapping:0x1882
 },
 { code:0x1883
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1883
  ,simpleLowerCaseMapping:0x1883
  ,simpleTitleCaseMapping:0x1883
 },
 { code:0x1884
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1884
  ,simpleLowerCaseMapping:0x1884
  ,simpleTitleCaseMapping:0x1884
 },
 { code:0x1885
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1885
  ,simpleLowerCaseMapping:0x1885
  ,simpleTitleCaseMapping:0x1885
 },
 { code:0x1886
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1886
  ,simpleLowerCaseMapping:0x1886
  ,simpleTitleCaseMapping:0x1886
 },
 { code:0x1887
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1887
  ,simpleLowerCaseMapping:0x1887
  ,simpleTitleCaseMapping:0x1887
 },
 { code:0x1888
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1888
  ,simpleLowerCaseMapping:0x1888
  ,simpleTitleCaseMapping:0x1888
 },
 { code:0x1889
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1889
  ,simpleLowerCaseMapping:0x1889
  ,simpleTitleCaseMapping:0x1889
 },
 { code:0x188A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x188A
  ,simpleLowerCaseMapping:0x188A
  ,simpleTitleCaseMapping:0x188A
 },
 { code:0x188B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x188B
  ,simpleLowerCaseMapping:0x188B
  ,simpleTitleCaseMapping:0x188B
 },
 { code:0x188C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x188C
  ,simpleLowerCaseMapping:0x188C
  ,simpleTitleCaseMapping:0x188C
 },
 { code:0x188D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x188D
  ,simpleLowerCaseMapping:0x188D
  ,simpleTitleCaseMapping:0x188D
 },
 { code:0x188E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x188E
  ,simpleLowerCaseMapping:0x188E
  ,simpleTitleCaseMapping:0x188E
 },
 { code:0x188F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x188F
  ,simpleLowerCaseMapping:0x188F
  ,simpleTitleCaseMapping:0x188F
 },
 { code:0x1890
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1890
  ,simpleLowerCaseMapping:0x1890
  ,simpleTitleCaseMapping:0x1890
 },
 { code:0x1891
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1891
  ,simpleLowerCaseMapping:0x1891
  ,simpleTitleCaseMapping:0x1891
 },
 { code:0x1892
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1892
  ,simpleLowerCaseMapping:0x1892
  ,simpleTitleCaseMapping:0x1892
 },
 { code:0x1893
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1893
  ,simpleLowerCaseMapping:0x1893
  ,simpleTitleCaseMapping:0x1893
 },
 { code:0x1894
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1894
  ,simpleLowerCaseMapping:0x1894
  ,simpleTitleCaseMapping:0x1894
 },
 { code:0x1895
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1895
  ,simpleLowerCaseMapping:0x1895
  ,simpleTitleCaseMapping:0x1895
 },
 { code:0x1896
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1896
  ,simpleLowerCaseMapping:0x1896
  ,simpleTitleCaseMapping:0x1896
 },
 { code:0x1897
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1897
  ,simpleLowerCaseMapping:0x1897
  ,simpleTitleCaseMapping:0x1897
 },
 { code:0x1898
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1898
  ,simpleLowerCaseMapping:0x1898
  ,simpleTitleCaseMapping:0x1898
 },
 { code:0x1899
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1899
  ,simpleLowerCaseMapping:0x1899
  ,simpleTitleCaseMapping:0x1899
 },
 { code:0x189A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x189A
  ,simpleLowerCaseMapping:0x189A
  ,simpleTitleCaseMapping:0x189A
 },
 { code:0x189B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x189B
  ,simpleLowerCaseMapping:0x189B
  ,simpleTitleCaseMapping:0x189B
 },
 { code:0x189C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x189C
  ,simpleLowerCaseMapping:0x189C
  ,simpleTitleCaseMapping:0x189C
 },
 { code:0x189D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x189D
  ,simpleLowerCaseMapping:0x189D
  ,simpleTitleCaseMapping:0x189D
 },
 { code:0x189E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x189E
  ,simpleLowerCaseMapping:0x189E
  ,simpleTitleCaseMapping:0x189E
 },
 { code:0x189F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x189F
  ,simpleLowerCaseMapping:0x189F
  ,simpleTitleCaseMapping:0x189F
 },
 { code:0x18A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x18A0
  ,simpleLowerCaseMapping:0x18A0
  ,simpleTitleCaseMapping:0x18A0
 },
 { code:0x18A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x18A1
  ,simpleLowerCaseMapping:0x18A1
  ,simpleTitleCaseMapping:0x18A1
 },
 { code:0x18A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x18A2
  ,simpleLowerCaseMapping:0x18A2
  ,simpleTitleCaseMapping:0x18A2
 },
 { code:0x18A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x18A3
  ,simpleLowerCaseMapping:0x18A3
  ,simpleTitleCaseMapping:0x18A3
 },
 { code:0x18A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x18A4
  ,simpleLowerCaseMapping:0x18A4
  ,simpleTitleCaseMapping:0x18A4
 },
 { code:0x18A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x18A5
  ,simpleLowerCaseMapping:0x18A5
  ,simpleTitleCaseMapping:0x18A5
 },
 { code:0x18A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x18A6
  ,simpleLowerCaseMapping:0x18A6
  ,simpleTitleCaseMapping:0x18A6
 },
 { code:0x18A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x18A7
  ,simpleLowerCaseMapping:0x18A7
  ,simpleTitleCaseMapping:0x18A7
 },
 { code:0x18A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x18A8
  ,simpleLowerCaseMapping:0x18A8
  ,simpleTitleCaseMapping:0x18A8
 },
 { code:0x18A9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x18A9
  ,simpleLowerCaseMapping:0x18A9
  ,simpleTitleCaseMapping:0x18A9
 },
 { code:0x1900
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1900
  ,simpleLowerCaseMapping:0x1900
  ,simpleTitleCaseMapping:0x1900
 },
 { code:0x1901
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1901
  ,simpleLowerCaseMapping:0x1901
  ,simpleTitleCaseMapping:0x1901
 },
 { code:0x1902
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1902
  ,simpleLowerCaseMapping:0x1902
  ,simpleTitleCaseMapping:0x1902
 },
 { code:0x1903
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1903
  ,simpleLowerCaseMapping:0x1903
  ,simpleTitleCaseMapping:0x1903
 },
 { code:0x1904
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1904
  ,simpleLowerCaseMapping:0x1904
  ,simpleTitleCaseMapping:0x1904
 },
 { code:0x1905
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1905
  ,simpleLowerCaseMapping:0x1905
  ,simpleTitleCaseMapping:0x1905
 },
 { code:0x1906
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1906
  ,simpleLowerCaseMapping:0x1906
  ,simpleTitleCaseMapping:0x1906
 },
 { code:0x1907
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1907
  ,simpleLowerCaseMapping:0x1907
  ,simpleTitleCaseMapping:0x1907
 },
 { code:0x1908
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1908
  ,simpleLowerCaseMapping:0x1908
  ,simpleTitleCaseMapping:0x1908
 },
 { code:0x1909
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1909
  ,simpleLowerCaseMapping:0x1909
  ,simpleTitleCaseMapping:0x1909
 },
 { code:0x190A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x190A
  ,simpleLowerCaseMapping:0x190A
  ,simpleTitleCaseMapping:0x190A
 },
 { code:0x190B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x190B
  ,simpleLowerCaseMapping:0x190B
  ,simpleTitleCaseMapping:0x190B
 },
 { code:0x190C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x190C
  ,simpleLowerCaseMapping:0x190C
  ,simpleTitleCaseMapping:0x190C
 },
 { code:0x190D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x190D
  ,simpleLowerCaseMapping:0x190D
  ,simpleTitleCaseMapping:0x190D
 },
 { code:0x190E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x190E
  ,simpleLowerCaseMapping:0x190E
  ,simpleTitleCaseMapping:0x190E
 },
 { code:0x190F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x190F
  ,simpleLowerCaseMapping:0x190F
  ,simpleTitleCaseMapping:0x190F
 },
 { code:0x1910
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1910
  ,simpleLowerCaseMapping:0x1910
  ,simpleTitleCaseMapping:0x1910
 },
 { code:0x1911
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1911
  ,simpleLowerCaseMapping:0x1911
  ,simpleTitleCaseMapping:0x1911
 },
 { code:0x1912
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1912
  ,simpleLowerCaseMapping:0x1912
  ,simpleTitleCaseMapping:0x1912
 },
 { code:0x1913
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1913
  ,simpleLowerCaseMapping:0x1913
  ,simpleTitleCaseMapping:0x1913
 },
 { code:0x1914
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1914
  ,simpleLowerCaseMapping:0x1914
  ,simpleTitleCaseMapping:0x1914
 },
 { code:0x1915
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1915
  ,simpleLowerCaseMapping:0x1915
  ,simpleTitleCaseMapping:0x1915
 },
 { code:0x1916
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1916
  ,simpleLowerCaseMapping:0x1916
  ,simpleTitleCaseMapping:0x1916
 },
 { code:0x1917
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1917
  ,simpleLowerCaseMapping:0x1917
  ,simpleTitleCaseMapping:0x1917
 },
 { code:0x1918
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1918
  ,simpleLowerCaseMapping:0x1918
  ,simpleTitleCaseMapping:0x1918
 },
 { code:0x1919
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1919
  ,simpleLowerCaseMapping:0x1919
  ,simpleTitleCaseMapping:0x1919
 },
 { code:0x191A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x191A
  ,simpleLowerCaseMapping:0x191A
  ,simpleTitleCaseMapping:0x191A
 },
 { code:0x191B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x191B
  ,simpleLowerCaseMapping:0x191B
  ,simpleTitleCaseMapping:0x191B
 },
 { code:0x191C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x191C
  ,simpleLowerCaseMapping:0x191C
  ,simpleTitleCaseMapping:0x191C
 },
 { code:0x1920
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1920
  ,simpleLowerCaseMapping:0x1920
  ,simpleTitleCaseMapping:0x1920
 },
 { code:0x1921
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1921
  ,simpleLowerCaseMapping:0x1921
  ,simpleTitleCaseMapping:0x1921
 },
 { code:0x1922
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1922
  ,simpleLowerCaseMapping:0x1922
  ,simpleTitleCaseMapping:0x1922
 },
 { code:0x1923
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1923
  ,simpleLowerCaseMapping:0x1923
  ,simpleTitleCaseMapping:0x1923
 },
 { code:0x1924
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1924
  ,simpleLowerCaseMapping:0x1924
  ,simpleTitleCaseMapping:0x1924
 },
 { code:0x1925
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1925
  ,simpleLowerCaseMapping:0x1925
  ,simpleTitleCaseMapping:0x1925
 },
 { code:0x1926
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1926
  ,simpleLowerCaseMapping:0x1926
  ,simpleTitleCaseMapping:0x1926
 },
 { code:0x1927
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1927
  ,simpleLowerCaseMapping:0x1927
  ,simpleTitleCaseMapping:0x1927
 },
 { code:0x1928
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1928
  ,simpleLowerCaseMapping:0x1928
  ,simpleTitleCaseMapping:0x1928
 },
 { code:0x1929
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1929
  ,simpleLowerCaseMapping:0x1929
  ,simpleTitleCaseMapping:0x1929
 },
 { code:0x192A
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x192A
  ,simpleLowerCaseMapping:0x192A
  ,simpleTitleCaseMapping:0x192A
 },
 { code:0x192B
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x192B
  ,simpleLowerCaseMapping:0x192B
  ,simpleTitleCaseMapping:0x192B
 },
 { code:0x1930
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1930
  ,simpleLowerCaseMapping:0x1930
  ,simpleTitleCaseMapping:0x1930
 },
 { code:0x1931
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1931
  ,simpleLowerCaseMapping:0x1931
  ,simpleTitleCaseMapping:0x1931
 },
 { code:0x1932
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1932
  ,simpleLowerCaseMapping:0x1932
  ,simpleTitleCaseMapping:0x1932
 },
 { code:0x1933
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1933
  ,simpleLowerCaseMapping:0x1933
  ,simpleTitleCaseMapping:0x1933
 },
 { code:0x1934
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1934
  ,simpleLowerCaseMapping:0x1934
  ,simpleTitleCaseMapping:0x1934
 },
 { code:0x1935
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1935
  ,simpleLowerCaseMapping:0x1935
  ,simpleTitleCaseMapping:0x1935
 },
 { code:0x1936
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1936
  ,simpleLowerCaseMapping:0x1936
  ,simpleTitleCaseMapping:0x1936
 },
 { code:0x1937
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1937
  ,simpleLowerCaseMapping:0x1937
  ,simpleTitleCaseMapping:0x1937
 },
 { code:0x1938
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1938
  ,simpleLowerCaseMapping:0x1938
  ,simpleTitleCaseMapping:0x1938
 },
 { code:0x1939
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1939
  ,simpleLowerCaseMapping:0x1939
  ,simpleTitleCaseMapping:0x1939
 },
 { code:0x193A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x193A
  ,simpleLowerCaseMapping:0x193A
  ,simpleTitleCaseMapping:0x193A
 },
 { code:0x193B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x193B
  ,simpleLowerCaseMapping:0x193B
  ,simpleTitleCaseMapping:0x193B
 },
 { code:0x1940
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1940
  ,simpleLowerCaseMapping:0x1940
  ,simpleTitleCaseMapping:0x1940
 },
 { code:0x1944
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1944
  ,simpleLowerCaseMapping:0x1944
  ,simpleTitleCaseMapping:0x1944
 },
 { code:0x1945
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1945
  ,simpleLowerCaseMapping:0x1945
  ,simpleTitleCaseMapping:0x1945
 },
 { code:0x1946
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1946
  ,simpleLowerCaseMapping:0x1946
  ,simpleTitleCaseMapping:0x1946
 },
 { code:0x1947
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1947
  ,simpleLowerCaseMapping:0x1947
  ,simpleTitleCaseMapping:0x1947
 },
 { code:0x1948
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1948
  ,simpleLowerCaseMapping:0x1948
  ,simpleTitleCaseMapping:0x1948
 },
 { code:0x1949
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1949
  ,simpleLowerCaseMapping:0x1949
  ,simpleTitleCaseMapping:0x1949
 },
 { code:0x194A
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x194A
  ,simpleLowerCaseMapping:0x194A
  ,simpleTitleCaseMapping:0x194A
 },
 { code:0x194B
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x194B
  ,simpleLowerCaseMapping:0x194B
  ,simpleTitleCaseMapping:0x194B
 },
 { code:0x194C
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x194C
  ,simpleLowerCaseMapping:0x194C
  ,simpleTitleCaseMapping:0x194C
 },
 { code:0x194D
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x194D
  ,simpleLowerCaseMapping:0x194D
  ,simpleTitleCaseMapping:0x194D
 },
 { code:0x194E
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x194E
  ,simpleLowerCaseMapping:0x194E
  ,simpleTitleCaseMapping:0x194E
 },
 { code:0x194F
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x194F
  ,simpleLowerCaseMapping:0x194F
  ,simpleTitleCaseMapping:0x194F
 },
 { code:0x1950
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1950
  ,simpleLowerCaseMapping:0x1950
  ,simpleTitleCaseMapping:0x1950
 },
 { code:0x1951
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1951
  ,simpleLowerCaseMapping:0x1951
  ,simpleTitleCaseMapping:0x1951
 },
 { code:0x1952
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1952
  ,simpleLowerCaseMapping:0x1952
  ,simpleTitleCaseMapping:0x1952
 },
 { code:0x1953
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1953
  ,simpleLowerCaseMapping:0x1953
  ,simpleTitleCaseMapping:0x1953
 },
 { code:0x1954
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1954
  ,simpleLowerCaseMapping:0x1954
  ,simpleTitleCaseMapping:0x1954
 },
 { code:0x1955
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1955
  ,simpleLowerCaseMapping:0x1955
  ,simpleTitleCaseMapping:0x1955
 },
 { code:0x1956
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1956
  ,simpleLowerCaseMapping:0x1956
  ,simpleTitleCaseMapping:0x1956
 },
 { code:0x1957
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1957
  ,simpleLowerCaseMapping:0x1957
  ,simpleTitleCaseMapping:0x1957
 },
 { code:0x1958
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1958
  ,simpleLowerCaseMapping:0x1958
  ,simpleTitleCaseMapping:0x1958
 },
 { code:0x1959
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1959
  ,simpleLowerCaseMapping:0x1959
  ,simpleTitleCaseMapping:0x1959
 },
 { code:0x195A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x195A
  ,simpleLowerCaseMapping:0x195A
  ,simpleTitleCaseMapping:0x195A
 },
 { code:0x195B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x195B
  ,simpleLowerCaseMapping:0x195B
  ,simpleTitleCaseMapping:0x195B
 },
 { code:0x195C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x195C
  ,simpleLowerCaseMapping:0x195C
  ,simpleTitleCaseMapping:0x195C
 },
 { code:0x195D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x195D
  ,simpleLowerCaseMapping:0x195D
  ,simpleTitleCaseMapping:0x195D
 },
 { code:0x195E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x195E
  ,simpleLowerCaseMapping:0x195E
  ,simpleTitleCaseMapping:0x195E
 },
 { code:0x195F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x195F
  ,simpleLowerCaseMapping:0x195F
  ,simpleTitleCaseMapping:0x195F
 },
 { code:0x1960
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1960
  ,simpleLowerCaseMapping:0x1960
  ,simpleTitleCaseMapping:0x1960
 },
 { code:0x1961
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1961
  ,simpleLowerCaseMapping:0x1961
  ,simpleTitleCaseMapping:0x1961
 },
 { code:0x1962
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1962
  ,simpleLowerCaseMapping:0x1962
  ,simpleTitleCaseMapping:0x1962
 },
 { code:0x1963
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1963
  ,simpleLowerCaseMapping:0x1963
  ,simpleTitleCaseMapping:0x1963
 },
 { code:0x1964
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1964
  ,simpleLowerCaseMapping:0x1964
  ,simpleTitleCaseMapping:0x1964
 },
 { code:0x1965
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1965
  ,simpleLowerCaseMapping:0x1965
  ,simpleTitleCaseMapping:0x1965
 },
 { code:0x1966
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1966
  ,simpleLowerCaseMapping:0x1966
  ,simpleTitleCaseMapping:0x1966
 },
 { code:0x1967
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1967
  ,simpleLowerCaseMapping:0x1967
  ,simpleTitleCaseMapping:0x1967
 },
 { code:0x1968
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1968
  ,simpleLowerCaseMapping:0x1968
  ,simpleTitleCaseMapping:0x1968
 },
 { code:0x1969
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1969
  ,simpleLowerCaseMapping:0x1969
  ,simpleTitleCaseMapping:0x1969
 },
 { code:0x196A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x196A
  ,simpleLowerCaseMapping:0x196A
  ,simpleTitleCaseMapping:0x196A
 },
 { code:0x196B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x196B
  ,simpleLowerCaseMapping:0x196B
  ,simpleTitleCaseMapping:0x196B
 },
 { code:0x196C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x196C
  ,simpleLowerCaseMapping:0x196C
  ,simpleTitleCaseMapping:0x196C
 },
 { code:0x196D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x196D
  ,simpleLowerCaseMapping:0x196D
  ,simpleTitleCaseMapping:0x196D
 },
 { code:0x1970
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1970
  ,simpleLowerCaseMapping:0x1970
  ,simpleTitleCaseMapping:0x1970
 },
 { code:0x1971
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1971
  ,simpleLowerCaseMapping:0x1971
  ,simpleTitleCaseMapping:0x1971
 },
 { code:0x1972
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1972
  ,simpleLowerCaseMapping:0x1972
  ,simpleTitleCaseMapping:0x1972
 },
 { code:0x1973
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1973
  ,simpleLowerCaseMapping:0x1973
  ,simpleTitleCaseMapping:0x1973
 },
 { code:0x1974
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1974
  ,simpleLowerCaseMapping:0x1974
  ,simpleTitleCaseMapping:0x1974
 },
 { code:0x1980
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1980
  ,simpleLowerCaseMapping:0x1980
  ,simpleTitleCaseMapping:0x1980
 },
 { code:0x1981
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1981
  ,simpleLowerCaseMapping:0x1981
  ,simpleTitleCaseMapping:0x1981
 },
 { code:0x1982
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1982
  ,simpleLowerCaseMapping:0x1982
  ,simpleTitleCaseMapping:0x1982
 },
 { code:0x1983
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1983
  ,simpleLowerCaseMapping:0x1983
  ,simpleTitleCaseMapping:0x1983
 },
 { code:0x1984
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1984
  ,simpleLowerCaseMapping:0x1984
  ,simpleTitleCaseMapping:0x1984
 },
 { code:0x1985
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1985
  ,simpleLowerCaseMapping:0x1985
  ,simpleTitleCaseMapping:0x1985
 },
 { code:0x1986
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1986
  ,simpleLowerCaseMapping:0x1986
  ,simpleTitleCaseMapping:0x1986
 },
 { code:0x1987
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1987
  ,simpleLowerCaseMapping:0x1987
  ,simpleTitleCaseMapping:0x1987
 },
 { code:0x1988
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1988
  ,simpleLowerCaseMapping:0x1988
  ,simpleTitleCaseMapping:0x1988
 },
 { code:0x1989
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1989
  ,simpleLowerCaseMapping:0x1989
  ,simpleTitleCaseMapping:0x1989
 },
 { code:0x198A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x198A
  ,simpleLowerCaseMapping:0x198A
  ,simpleTitleCaseMapping:0x198A
 },
 { code:0x198B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x198B
  ,simpleLowerCaseMapping:0x198B
  ,simpleTitleCaseMapping:0x198B
 },
 { code:0x198C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x198C
  ,simpleLowerCaseMapping:0x198C
  ,simpleTitleCaseMapping:0x198C
 },
 { code:0x198D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x198D
  ,simpleLowerCaseMapping:0x198D
  ,simpleTitleCaseMapping:0x198D
 },
 { code:0x198E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x198E
  ,simpleLowerCaseMapping:0x198E
  ,simpleTitleCaseMapping:0x198E
 },
 { code:0x198F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x198F
  ,simpleLowerCaseMapping:0x198F
  ,simpleTitleCaseMapping:0x198F
 },
 { code:0x1990
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1990
  ,simpleLowerCaseMapping:0x1990
  ,simpleTitleCaseMapping:0x1990
 },
 { code:0x1991
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1991
  ,simpleLowerCaseMapping:0x1991
  ,simpleTitleCaseMapping:0x1991
 },
 { code:0x1992
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1992
  ,simpleLowerCaseMapping:0x1992
  ,simpleTitleCaseMapping:0x1992
 },
 { code:0x1993
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1993
  ,simpleLowerCaseMapping:0x1993
  ,simpleTitleCaseMapping:0x1993
 },
 { code:0x1994
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1994
  ,simpleLowerCaseMapping:0x1994
  ,simpleTitleCaseMapping:0x1994
 },
 { code:0x1995
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1995
  ,simpleLowerCaseMapping:0x1995
  ,simpleTitleCaseMapping:0x1995
 },
 { code:0x1996
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1996
  ,simpleLowerCaseMapping:0x1996
  ,simpleTitleCaseMapping:0x1996
 },
 { code:0x1997
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1997
  ,simpleLowerCaseMapping:0x1997
  ,simpleTitleCaseMapping:0x1997
 },
 { code:0x1998
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1998
  ,simpleLowerCaseMapping:0x1998
  ,simpleTitleCaseMapping:0x1998
 },
 { code:0x1999
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1999
  ,simpleLowerCaseMapping:0x1999
  ,simpleTitleCaseMapping:0x1999
 },
 { code:0x199A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x199A
  ,simpleLowerCaseMapping:0x199A
  ,simpleTitleCaseMapping:0x199A
 },
 { code:0x199B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x199B
  ,simpleLowerCaseMapping:0x199B
  ,simpleTitleCaseMapping:0x199B
 },
 { code:0x199C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x199C
  ,simpleLowerCaseMapping:0x199C
  ,simpleTitleCaseMapping:0x199C
 },
 { code:0x199D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x199D
  ,simpleLowerCaseMapping:0x199D
  ,simpleTitleCaseMapping:0x199D
 },
 { code:0x199E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x199E
  ,simpleLowerCaseMapping:0x199E
  ,simpleTitleCaseMapping:0x199E
 },
 { code:0x199F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x199F
  ,simpleLowerCaseMapping:0x199F
  ,simpleTitleCaseMapping:0x199F
 },
 { code:0x19A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x19A0
  ,simpleLowerCaseMapping:0x19A0
  ,simpleTitleCaseMapping:0x19A0
 },
 { code:0x19A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x19A1
  ,simpleLowerCaseMapping:0x19A1
  ,simpleTitleCaseMapping:0x19A1
 },
 { code:0x19A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x19A2
  ,simpleLowerCaseMapping:0x19A2
  ,simpleTitleCaseMapping:0x19A2
 },
 { code:0x19A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x19A3
  ,simpleLowerCaseMapping:0x19A3
  ,simpleTitleCaseMapping:0x19A3
 },
 { code:0x19A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x19A4
  ,simpleLowerCaseMapping:0x19A4
  ,simpleTitleCaseMapping:0x19A4
 },
 { code:0x19A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x19A5
  ,simpleLowerCaseMapping:0x19A5
  ,simpleTitleCaseMapping:0x19A5
 },
 { code:0x19A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x19A6
  ,simpleLowerCaseMapping:0x19A6
  ,simpleTitleCaseMapping:0x19A6
 },
 { code:0x19A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x19A7
  ,simpleLowerCaseMapping:0x19A7
  ,simpleTitleCaseMapping:0x19A7
 },
 { code:0x19A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x19A8
  ,simpleLowerCaseMapping:0x19A8
  ,simpleTitleCaseMapping:0x19A8
 },
 { code:0x19A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x19A9
  ,simpleLowerCaseMapping:0x19A9
  ,simpleTitleCaseMapping:0x19A9
 },
 { code:0x19B0
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19B0
  ,simpleLowerCaseMapping:0x19B0
  ,simpleTitleCaseMapping:0x19B0
 },
 { code:0x19B1
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19B1
  ,simpleLowerCaseMapping:0x19B1
  ,simpleTitleCaseMapping:0x19B1
 },
 { code:0x19B2
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19B2
  ,simpleLowerCaseMapping:0x19B2
  ,simpleTitleCaseMapping:0x19B2
 },
 { code:0x19B3
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19B3
  ,simpleLowerCaseMapping:0x19B3
  ,simpleTitleCaseMapping:0x19B3
 },
 { code:0x19B4
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19B4
  ,simpleLowerCaseMapping:0x19B4
  ,simpleTitleCaseMapping:0x19B4
 },
 { code:0x19B5
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19B5
  ,simpleLowerCaseMapping:0x19B5
  ,simpleTitleCaseMapping:0x19B5
 },
 { code:0x19B6
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19B6
  ,simpleLowerCaseMapping:0x19B6
  ,simpleTitleCaseMapping:0x19B6
 },
 { code:0x19B7
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19B7
  ,simpleLowerCaseMapping:0x19B7
  ,simpleTitleCaseMapping:0x19B7
 },
 { code:0x19B8
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19B8
  ,simpleLowerCaseMapping:0x19B8
  ,simpleTitleCaseMapping:0x19B8
 },
 { code:0x19B9
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19B9
  ,simpleLowerCaseMapping:0x19B9
  ,simpleTitleCaseMapping:0x19B9
 },
 { code:0x19BA
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19BA
  ,simpleLowerCaseMapping:0x19BA
  ,simpleTitleCaseMapping:0x19BA
 },
 { code:0x19BB
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19BB
  ,simpleLowerCaseMapping:0x19BB
  ,simpleTitleCaseMapping:0x19BB
 },
 { code:0x19BC
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19BC
  ,simpleLowerCaseMapping:0x19BC
  ,simpleTitleCaseMapping:0x19BC
 },
 { code:0x19BD
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19BD
  ,simpleLowerCaseMapping:0x19BD
  ,simpleTitleCaseMapping:0x19BD
 },
 { code:0x19BE
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19BE
  ,simpleLowerCaseMapping:0x19BE
  ,simpleTitleCaseMapping:0x19BE
 },
 { code:0x19BF
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19BF
  ,simpleLowerCaseMapping:0x19BF
  ,simpleTitleCaseMapping:0x19BF
 },
 { code:0x19C0
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19C0
  ,simpleLowerCaseMapping:0x19C0
  ,simpleTitleCaseMapping:0x19C0
 },
 { code:0x19C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x19C1
  ,simpleLowerCaseMapping:0x19C1
  ,simpleTitleCaseMapping:0x19C1
 },
 { code:0x19C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x19C2
  ,simpleLowerCaseMapping:0x19C2
  ,simpleTitleCaseMapping:0x19C2
 },
 { code:0x19C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x19C3
  ,simpleLowerCaseMapping:0x19C3
  ,simpleTitleCaseMapping:0x19C3
 },
 { code:0x19C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x19C4
  ,simpleLowerCaseMapping:0x19C4
  ,simpleTitleCaseMapping:0x19C4
 },
 { code:0x19C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x19C5
  ,simpleLowerCaseMapping:0x19C5
  ,simpleTitleCaseMapping:0x19C5
 },
 { code:0x19C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x19C6
  ,simpleLowerCaseMapping:0x19C6
  ,simpleTitleCaseMapping:0x19C6
 },
 { code:0x19C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x19C7
  ,simpleLowerCaseMapping:0x19C7
  ,simpleTitleCaseMapping:0x19C7
 },
 { code:0x19C8
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19C8
  ,simpleLowerCaseMapping:0x19C8
  ,simpleTitleCaseMapping:0x19C8
 },
 { code:0x19C9
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x19C9
  ,simpleLowerCaseMapping:0x19C9
  ,simpleTitleCaseMapping:0x19C9
 },
 { code:0x19D0
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x19D0
  ,simpleLowerCaseMapping:0x19D0
  ,simpleTitleCaseMapping:0x19D0
 },
 { code:0x19D1
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x19D1
  ,simpleLowerCaseMapping:0x19D1
  ,simpleTitleCaseMapping:0x19D1
 },
 { code:0x19D2
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x19D2
  ,simpleLowerCaseMapping:0x19D2
  ,simpleTitleCaseMapping:0x19D2
 },
 { code:0x19D3
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x19D3
  ,simpleLowerCaseMapping:0x19D3
  ,simpleTitleCaseMapping:0x19D3
 },
 { code:0x19D4
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x19D4
  ,simpleLowerCaseMapping:0x19D4
  ,simpleTitleCaseMapping:0x19D4
 },
 { code:0x19D5
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x19D5
  ,simpleLowerCaseMapping:0x19D5
  ,simpleTitleCaseMapping:0x19D5
 },
 { code:0x19D6
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x19D6
  ,simpleLowerCaseMapping:0x19D6
  ,simpleTitleCaseMapping:0x19D6
 },
 { code:0x19D7
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x19D7
  ,simpleLowerCaseMapping:0x19D7
  ,simpleTitleCaseMapping:0x19D7
 },
 { code:0x19D8
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x19D8
  ,simpleLowerCaseMapping:0x19D8
  ,simpleTitleCaseMapping:0x19D8
 },
 { code:0x19D9
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x19D9
  ,simpleLowerCaseMapping:0x19D9
  ,simpleTitleCaseMapping:0x19D9
 },
 { code:0x19DE
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x19DE
  ,simpleLowerCaseMapping:0x19DE
  ,simpleTitleCaseMapping:0x19DE
 },
 { code:0x19DF
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x19DF
  ,simpleLowerCaseMapping:0x19DF
  ,simpleTitleCaseMapping:0x19DF
 },
 { code:0x19E0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19E0
  ,simpleLowerCaseMapping:0x19E0
  ,simpleTitleCaseMapping:0x19E0
 },
 { code:0x19E1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19E1
  ,simpleLowerCaseMapping:0x19E1
  ,simpleTitleCaseMapping:0x19E1
 },
 { code:0x19E2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19E2
  ,simpleLowerCaseMapping:0x19E2
  ,simpleTitleCaseMapping:0x19E2
 },
 { code:0x19E3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19E3
  ,simpleLowerCaseMapping:0x19E3
  ,simpleTitleCaseMapping:0x19E3
 },
 { code:0x19E4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19E4
  ,simpleLowerCaseMapping:0x19E4
  ,simpleTitleCaseMapping:0x19E4
 },
 { code:0x19E5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19E5
  ,simpleLowerCaseMapping:0x19E5
  ,simpleTitleCaseMapping:0x19E5
 },
 { code:0x19E6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19E6
  ,simpleLowerCaseMapping:0x19E6
  ,simpleTitleCaseMapping:0x19E6
 },
 { code:0x19E7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19E7
  ,simpleLowerCaseMapping:0x19E7
  ,simpleTitleCaseMapping:0x19E7
 },
 { code:0x19E8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19E8
  ,simpleLowerCaseMapping:0x19E8
  ,simpleTitleCaseMapping:0x19E8
 },
 { code:0x19E9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19E9
  ,simpleLowerCaseMapping:0x19E9
  ,simpleTitleCaseMapping:0x19E9
 },
 { code:0x19EA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19EA
  ,simpleLowerCaseMapping:0x19EA
  ,simpleTitleCaseMapping:0x19EA
 },
 { code:0x19EB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19EB
  ,simpleLowerCaseMapping:0x19EB
  ,simpleTitleCaseMapping:0x19EB
 },
 { code:0x19EC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19EC
  ,simpleLowerCaseMapping:0x19EC
  ,simpleTitleCaseMapping:0x19EC
 },
 { code:0x19ED
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19ED
  ,simpleLowerCaseMapping:0x19ED
  ,simpleTitleCaseMapping:0x19ED
 },
 { code:0x19EE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19EE
  ,simpleLowerCaseMapping:0x19EE
  ,simpleTitleCaseMapping:0x19EE
 },
 { code:0x19EF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19EF
  ,simpleLowerCaseMapping:0x19EF
  ,simpleTitleCaseMapping:0x19EF
 },
 { code:0x19F0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19F0
  ,simpleLowerCaseMapping:0x19F0
  ,simpleTitleCaseMapping:0x19F0
 },
 { code:0x19F1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19F1
  ,simpleLowerCaseMapping:0x19F1
  ,simpleTitleCaseMapping:0x19F1
 },
 { code:0x19F2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19F2
  ,simpleLowerCaseMapping:0x19F2
  ,simpleTitleCaseMapping:0x19F2
 },
 { code:0x19F3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19F3
  ,simpleLowerCaseMapping:0x19F3
  ,simpleTitleCaseMapping:0x19F3
 },
 { code:0x19F4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19F4
  ,simpleLowerCaseMapping:0x19F4
  ,simpleTitleCaseMapping:0x19F4
 },
 { code:0x19F5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19F5
  ,simpleLowerCaseMapping:0x19F5
  ,simpleTitleCaseMapping:0x19F5
 },
 { code:0x19F6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19F6
  ,simpleLowerCaseMapping:0x19F6
  ,simpleTitleCaseMapping:0x19F6
 },
 { code:0x19F7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19F7
  ,simpleLowerCaseMapping:0x19F7
  ,simpleTitleCaseMapping:0x19F7
 },
 { code:0x19F8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19F8
  ,simpleLowerCaseMapping:0x19F8
  ,simpleTitleCaseMapping:0x19F8
 },
 { code:0x19F9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19F9
  ,simpleLowerCaseMapping:0x19F9
  ,simpleTitleCaseMapping:0x19F9
 },
 { code:0x19FA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19FA
  ,simpleLowerCaseMapping:0x19FA
  ,simpleTitleCaseMapping:0x19FA
 },
 { code:0x19FB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19FB
  ,simpleLowerCaseMapping:0x19FB
  ,simpleTitleCaseMapping:0x19FB
 },
 { code:0x19FC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19FC
  ,simpleLowerCaseMapping:0x19FC
  ,simpleTitleCaseMapping:0x19FC
 },
 { code:0x19FD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19FD
  ,simpleLowerCaseMapping:0x19FD
  ,simpleTitleCaseMapping:0x19FD
 },
 { code:0x19FE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19FE
  ,simpleLowerCaseMapping:0x19FE
  ,simpleTitleCaseMapping:0x19FE
 },
 { code:0x19FF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x19FF
  ,simpleLowerCaseMapping:0x19FF
  ,simpleTitleCaseMapping:0x19FF
 },
 { code:0x1A00
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A00
  ,simpleLowerCaseMapping:0x1A00
  ,simpleTitleCaseMapping:0x1A00
 },
 { code:0x1A01
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A01
  ,simpleLowerCaseMapping:0x1A01
  ,simpleTitleCaseMapping:0x1A01
 },
 { code:0x1A02
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A02
  ,simpleLowerCaseMapping:0x1A02
  ,simpleTitleCaseMapping:0x1A02
 },
 { code:0x1A03
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A03
  ,simpleLowerCaseMapping:0x1A03
  ,simpleTitleCaseMapping:0x1A03
 },
 { code:0x1A04
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A04
  ,simpleLowerCaseMapping:0x1A04
  ,simpleTitleCaseMapping:0x1A04
 },
 { code:0x1A05
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A05
  ,simpleLowerCaseMapping:0x1A05
  ,simpleTitleCaseMapping:0x1A05
 },
 { code:0x1A06
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A06
  ,simpleLowerCaseMapping:0x1A06
  ,simpleTitleCaseMapping:0x1A06
 },
 { code:0x1A07
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A07
  ,simpleLowerCaseMapping:0x1A07
  ,simpleTitleCaseMapping:0x1A07
 },
 { code:0x1A08
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A08
  ,simpleLowerCaseMapping:0x1A08
  ,simpleTitleCaseMapping:0x1A08
 },
 { code:0x1A09
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A09
  ,simpleLowerCaseMapping:0x1A09
  ,simpleTitleCaseMapping:0x1A09
 },
 { code:0x1A0A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A0A
  ,simpleLowerCaseMapping:0x1A0A
  ,simpleTitleCaseMapping:0x1A0A
 },
 { code:0x1A0B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A0B
  ,simpleLowerCaseMapping:0x1A0B
  ,simpleTitleCaseMapping:0x1A0B
 },
 { code:0x1A0C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A0C
  ,simpleLowerCaseMapping:0x1A0C
  ,simpleTitleCaseMapping:0x1A0C
 },
 { code:0x1A0D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A0D
  ,simpleLowerCaseMapping:0x1A0D
  ,simpleTitleCaseMapping:0x1A0D
 },
 { code:0x1A0E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A0E
  ,simpleLowerCaseMapping:0x1A0E
  ,simpleTitleCaseMapping:0x1A0E
 },
 { code:0x1A0F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A0F
  ,simpleLowerCaseMapping:0x1A0F
  ,simpleTitleCaseMapping:0x1A0F
 },
 { code:0x1A10
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A10
  ,simpleLowerCaseMapping:0x1A10
  ,simpleTitleCaseMapping:0x1A10
 },
 { code:0x1A11
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A11
  ,simpleLowerCaseMapping:0x1A11
  ,simpleTitleCaseMapping:0x1A11
 },
 { code:0x1A12
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A12
  ,simpleLowerCaseMapping:0x1A12
  ,simpleTitleCaseMapping:0x1A12
 },
 { code:0x1A13
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A13
  ,simpleLowerCaseMapping:0x1A13
  ,simpleTitleCaseMapping:0x1A13
 },
 { code:0x1A14
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A14
  ,simpleLowerCaseMapping:0x1A14
  ,simpleTitleCaseMapping:0x1A14
 },
 { code:0x1A15
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A15
  ,simpleLowerCaseMapping:0x1A15
  ,simpleTitleCaseMapping:0x1A15
 },
 { code:0x1A16
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1A16
  ,simpleLowerCaseMapping:0x1A16
  ,simpleTitleCaseMapping:0x1A16
 },
 { code:0x1A17
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1A17
  ,simpleLowerCaseMapping:0x1A17
  ,simpleTitleCaseMapping:0x1A17
 },
 { code:0x1A18
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1A18
  ,simpleLowerCaseMapping:0x1A18
  ,simpleTitleCaseMapping:0x1A18
 },
 { code:0x1A19
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1A19
  ,simpleLowerCaseMapping:0x1A19
  ,simpleTitleCaseMapping:0x1A19
 },
 { code:0x1A1A
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1A1A
  ,simpleLowerCaseMapping:0x1A1A
  ,simpleTitleCaseMapping:0x1A1A
 },
 { code:0x1A1B
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1A1B
  ,simpleLowerCaseMapping:0x1A1B
  ,simpleTitleCaseMapping:0x1A1B
 },
 { code:0x1A1E
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1A1E
  ,simpleLowerCaseMapping:0x1A1E
  ,simpleTitleCaseMapping:0x1A1E
 },
 { code:0x1A1F
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1A1F
  ,simpleLowerCaseMapping:0x1A1F
  ,simpleTitleCaseMapping:0x1A1F
 },
 { code:0x1B00
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B00
  ,simpleLowerCaseMapping:0x1B00
  ,simpleTitleCaseMapping:0x1B00
 },
 { code:0x1B01
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B01
  ,simpleLowerCaseMapping:0x1B01
  ,simpleTitleCaseMapping:0x1B01
 },
 { code:0x1B02
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B02
  ,simpleLowerCaseMapping:0x1B02
  ,simpleTitleCaseMapping:0x1B02
 },
 { code:0x1B03
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B03
  ,simpleLowerCaseMapping:0x1B03
  ,simpleTitleCaseMapping:0x1B03
 },
 { code:0x1B04
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1B04
  ,simpleLowerCaseMapping:0x1B04
  ,simpleTitleCaseMapping:0x1B04
 },
 { code:0x1B05
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B05
  ,simpleLowerCaseMapping:0x1B05
  ,simpleTitleCaseMapping:0x1B05
 },
 { code:0x1B06
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B06
  ,simpleLowerCaseMapping:0x1B06
  ,simpleTitleCaseMapping:0x1B06
 },
 { code:0x1B07
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B07
  ,simpleLowerCaseMapping:0x1B07
  ,simpleTitleCaseMapping:0x1B07
 },
 { code:0x1B08
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B08
  ,simpleLowerCaseMapping:0x1B08
  ,simpleTitleCaseMapping:0x1B08
 },
 { code:0x1B09
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B09
  ,simpleLowerCaseMapping:0x1B09
  ,simpleTitleCaseMapping:0x1B09
 },
 { code:0x1B0A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B0A
  ,simpleLowerCaseMapping:0x1B0A
  ,simpleTitleCaseMapping:0x1B0A
 },
 { code:0x1B0B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B0B
  ,simpleLowerCaseMapping:0x1B0B
  ,simpleTitleCaseMapping:0x1B0B
 },
 { code:0x1B0C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B0C
  ,simpleLowerCaseMapping:0x1B0C
  ,simpleTitleCaseMapping:0x1B0C
 },
 { code:0x1B0D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B0D
  ,simpleLowerCaseMapping:0x1B0D
  ,simpleTitleCaseMapping:0x1B0D
 },
 { code:0x1B0E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B0E
  ,simpleLowerCaseMapping:0x1B0E
  ,simpleTitleCaseMapping:0x1B0E
 },
 { code:0x1B0F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B0F
  ,simpleLowerCaseMapping:0x1B0F
  ,simpleTitleCaseMapping:0x1B0F
 },
 { code:0x1B10
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B10
  ,simpleLowerCaseMapping:0x1B10
  ,simpleTitleCaseMapping:0x1B10
 },
 { code:0x1B11
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B11
  ,simpleLowerCaseMapping:0x1B11
  ,simpleTitleCaseMapping:0x1B11
 },
 { code:0x1B12
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B12
  ,simpleLowerCaseMapping:0x1B12
  ,simpleTitleCaseMapping:0x1B12
 },
 { code:0x1B13
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B13
  ,simpleLowerCaseMapping:0x1B13
  ,simpleTitleCaseMapping:0x1B13
 },
 { code:0x1B14
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B14
  ,simpleLowerCaseMapping:0x1B14
  ,simpleTitleCaseMapping:0x1B14
 },
 { code:0x1B15
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B15
  ,simpleLowerCaseMapping:0x1B15
  ,simpleTitleCaseMapping:0x1B15
 },
 { code:0x1B16
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B16
  ,simpleLowerCaseMapping:0x1B16
  ,simpleTitleCaseMapping:0x1B16
 },
 { code:0x1B17
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B17
  ,simpleLowerCaseMapping:0x1B17
  ,simpleTitleCaseMapping:0x1B17
 },
 { code:0x1B18
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B18
  ,simpleLowerCaseMapping:0x1B18
  ,simpleTitleCaseMapping:0x1B18
 },
 { code:0x1B19
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B19
  ,simpleLowerCaseMapping:0x1B19
  ,simpleTitleCaseMapping:0x1B19
 },
 { code:0x1B1A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B1A
  ,simpleLowerCaseMapping:0x1B1A
  ,simpleTitleCaseMapping:0x1B1A
 },
 { code:0x1B1B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B1B
  ,simpleLowerCaseMapping:0x1B1B
  ,simpleTitleCaseMapping:0x1B1B
 },
 { code:0x1B1C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B1C
  ,simpleLowerCaseMapping:0x1B1C
  ,simpleTitleCaseMapping:0x1B1C
 },
 { code:0x1B1D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B1D
  ,simpleLowerCaseMapping:0x1B1D
  ,simpleTitleCaseMapping:0x1B1D
 },
 { code:0x1B1E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B1E
  ,simpleLowerCaseMapping:0x1B1E
  ,simpleTitleCaseMapping:0x1B1E
 },
 { code:0x1B1F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B1F
  ,simpleLowerCaseMapping:0x1B1F
  ,simpleTitleCaseMapping:0x1B1F
 },
 { code:0x1B20
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B20
  ,simpleLowerCaseMapping:0x1B20
  ,simpleTitleCaseMapping:0x1B20
 },
 { code:0x1B21
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B21
  ,simpleLowerCaseMapping:0x1B21
  ,simpleTitleCaseMapping:0x1B21
 },
 { code:0x1B22
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B22
  ,simpleLowerCaseMapping:0x1B22
  ,simpleTitleCaseMapping:0x1B22
 },
 { code:0x1B23
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B23
  ,simpleLowerCaseMapping:0x1B23
  ,simpleTitleCaseMapping:0x1B23
 },
 { code:0x1B24
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B24
  ,simpleLowerCaseMapping:0x1B24
  ,simpleTitleCaseMapping:0x1B24
 },
 { code:0x1B25
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B25
  ,simpleLowerCaseMapping:0x1B25
  ,simpleTitleCaseMapping:0x1B25
 },
 { code:0x1B26
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B26
  ,simpleLowerCaseMapping:0x1B26
  ,simpleTitleCaseMapping:0x1B26
 },
 { code:0x1B27
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B27
  ,simpleLowerCaseMapping:0x1B27
  ,simpleTitleCaseMapping:0x1B27
 },
 { code:0x1B28
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B28
  ,simpleLowerCaseMapping:0x1B28
  ,simpleTitleCaseMapping:0x1B28
 },
 { code:0x1B29
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B29
  ,simpleLowerCaseMapping:0x1B29
  ,simpleTitleCaseMapping:0x1B29
 },
 { code:0x1B2A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B2A
  ,simpleLowerCaseMapping:0x1B2A
  ,simpleTitleCaseMapping:0x1B2A
 },
 { code:0x1B2B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B2B
  ,simpleLowerCaseMapping:0x1B2B
  ,simpleTitleCaseMapping:0x1B2B
 },
 { code:0x1B2C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B2C
  ,simpleLowerCaseMapping:0x1B2C
  ,simpleTitleCaseMapping:0x1B2C
 },
 { code:0x1B2D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B2D
  ,simpleLowerCaseMapping:0x1B2D
  ,simpleTitleCaseMapping:0x1B2D
 },
 { code:0x1B2E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B2E
  ,simpleLowerCaseMapping:0x1B2E
  ,simpleTitleCaseMapping:0x1B2E
 },
 { code:0x1B2F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B2F
  ,simpleLowerCaseMapping:0x1B2F
  ,simpleTitleCaseMapping:0x1B2F
 },
 { code:0x1B30
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B30
  ,simpleLowerCaseMapping:0x1B30
  ,simpleTitleCaseMapping:0x1B30
 },
 { code:0x1B31
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B31
  ,simpleLowerCaseMapping:0x1B31
  ,simpleTitleCaseMapping:0x1B31
 },
 { code:0x1B32
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B32
  ,simpleLowerCaseMapping:0x1B32
  ,simpleTitleCaseMapping:0x1B32
 },
 { code:0x1B33
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B33
  ,simpleLowerCaseMapping:0x1B33
  ,simpleTitleCaseMapping:0x1B33
 },
 { code:0x1B34
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B34
  ,simpleLowerCaseMapping:0x1B34
  ,simpleTitleCaseMapping:0x1B34
 },
 { code:0x1B35
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1B35
  ,simpleLowerCaseMapping:0x1B35
  ,simpleTitleCaseMapping:0x1B35
 },
 { code:0x1B36
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B36
  ,simpleLowerCaseMapping:0x1B36
  ,simpleTitleCaseMapping:0x1B36
 },
 { code:0x1B37
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B37
  ,simpleLowerCaseMapping:0x1B37
  ,simpleTitleCaseMapping:0x1B37
 },
 { code:0x1B38
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B38
  ,simpleLowerCaseMapping:0x1B38
  ,simpleTitleCaseMapping:0x1B38
 },
 { code:0x1B39
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B39
  ,simpleLowerCaseMapping:0x1B39
  ,simpleTitleCaseMapping:0x1B39
 },
 { code:0x1B3A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B3A
  ,simpleLowerCaseMapping:0x1B3A
  ,simpleTitleCaseMapping:0x1B3A
 },
 { code:0x1B3B
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1B3B
  ,simpleLowerCaseMapping:0x1B3B
  ,simpleTitleCaseMapping:0x1B3B
 },
 { code:0x1B3C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B3C
  ,simpleLowerCaseMapping:0x1B3C
  ,simpleTitleCaseMapping:0x1B3C
 },
 { code:0x1B3D
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1B3D
  ,simpleLowerCaseMapping:0x1B3D
  ,simpleTitleCaseMapping:0x1B3D
 },
 { code:0x1B3E
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1B3E
  ,simpleLowerCaseMapping:0x1B3E
  ,simpleTitleCaseMapping:0x1B3E
 },
 { code:0x1B3F
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1B3F
  ,simpleLowerCaseMapping:0x1B3F
  ,simpleTitleCaseMapping:0x1B3F
 },
 { code:0x1B40
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1B40
  ,simpleLowerCaseMapping:0x1B40
  ,simpleTitleCaseMapping:0x1B40
 },
 { code:0x1B41
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1B41
  ,simpleLowerCaseMapping:0x1B41
  ,simpleTitleCaseMapping:0x1B41
 },
 { code:0x1B42
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B42
  ,simpleLowerCaseMapping:0x1B42
  ,simpleTitleCaseMapping:0x1B42
 },
 { code:0x1B43
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1B43
  ,simpleLowerCaseMapping:0x1B43
  ,simpleTitleCaseMapping:0x1B43
 },
 { code:0x1B44
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1B44
  ,simpleLowerCaseMapping:0x1B44
  ,simpleTitleCaseMapping:0x1B44
 },
 { code:0x1B45
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B45
  ,simpleLowerCaseMapping:0x1B45
  ,simpleTitleCaseMapping:0x1B45
 },
 { code:0x1B46
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B46
  ,simpleLowerCaseMapping:0x1B46
  ,simpleTitleCaseMapping:0x1B46
 },
 { code:0x1B47
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B47
  ,simpleLowerCaseMapping:0x1B47
  ,simpleTitleCaseMapping:0x1B47
 },
 { code:0x1B48
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B48
  ,simpleLowerCaseMapping:0x1B48
  ,simpleTitleCaseMapping:0x1B48
 },
 { code:0x1B49
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B49
  ,simpleLowerCaseMapping:0x1B49
  ,simpleTitleCaseMapping:0x1B49
 },
 { code:0x1B4A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B4A
  ,simpleLowerCaseMapping:0x1B4A
  ,simpleTitleCaseMapping:0x1B4A
 },
 { code:0x1B4B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1B4B
  ,simpleLowerCaseMapping:0x1B4B
  ,simpleTitleCaseMapping:0x1B4B
 },
 { code:0x1B50
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1B50
  ,simpleLowerCaseMapping:0x1B50
  ,simpleTitleCaseMapping:0x1B50
 },
 { code:0x1B51
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1B51
  ,simpleLowerCaseMapping:0x1B51
  ,simpleTitleCaseMapping:0x1B51
 },
 { code:0x1B52
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1B52
  ,simpleLowerCaseMapping:0x1B52
  ,simpleTitleCaseMapping:0x1B52
 },
 { code:0x1B53
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1B53
  ,simpleLowerCaseMapping:0x1B53
  ,simpleTitleCaseMapping:0x1B53
 },
 { code:0x1B54
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1B54
  ,simpleLowerCaseMapping:0x1B54
  ,simpleTitleCaseMapping:0x1B54
 },
 { code:0x1B55
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1B55
  ,simpleLowerCaseMapping:0x1B55
  ,simpleTitleCaseMapping:0x1B55
 },
 { code:0x1B56
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1B56
  ,simpleLowerCaseMapping:0x1B56
  ,simpleTitleCaseMapping:0x1B56
 },
 { code:0x1B57
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1B57
  ,simpleLowerCaseMapping:0x1B57
  ,simpleTitleCaseMapping:0x1B57
 },
 { code:0x1B58
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1B58
  ,simpleLowerCaseMapping:0x1B58
  ,simpleTitleCaseMapping:0x1B58
 },
 { code:0x1B59
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1B59
  ,simpleLowerCaseMapping:0x1B59
  ,simpleTitleCaseMapping:0x1B59
 },
 { code:0x1B5A
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1B5A
  ,simpleLowerCaseMapping:0x1B5A
  ,simpleTitleCaseMapping:0x1B5A
 },
 { code:0x1B5B
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1B5B
  ,simpleLowerCaseMapping:0x1B5B
  ,simpleTitleCaseMapping:0x1B5B
 },
 { code:0x1B5C
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1B5C
  ,simpleLowerCaseMapping:0x1B5C
  ,simpleTitleCaseMapping:0x1B5C
 },
 { code:0x1B5D
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1B5D
  ,simpleLowerCaseMapping:0x1B5D
  ,simpleTitleCaseMapping:0x1B5D
 },
 { code:0x1B5E
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1B5E
  ,simpleLowerCaseMapping:0x1B5E
  ,simpleTitleCaseMapping:0x1B5E
 },
 { code:0x1B5F
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1B5F
  ,simpleLowerCaseMapping:0x1B5F
  ,simpleTitleCaseMapping:0x1B5F
 },
 { code:0x1B60
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1B60
  ,simpleLowerCaseMapping:0x1B60
  ,simpleTitleCaseMapping:0x1B60
 },
 { code:0x1B61
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B61
  ,simpleLowerCaseMapping:0x1B61
  ,simpleTitleCaseMapping:0x1B61
 },
 { code:0x1B62
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B62
  ,simpleLowerCaseMapping:0x1B62
  ,simpleTitleCaseMapping:0x1B62
 },
 { code:0x1B63
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B63
  ,simpleLowerCaseMapping:0x1B63
  ,simpleTitleCaseMapping:0x1B63
 },
 { code:0x1B64
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B64
  ,simpleLowerCaseMapping:0x1B64
  ,simpleTitleCaseMapping:0x1B64
 },
 { code:0x1B65
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B65
  ,simpleLowerCaseMapping:0x1B65
  ,simpleTitleCaseMapping:0x1B65
 },
 { code:0x1B66
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B66
  ,simpleLowerCaseMapping:0x1B66
  ,simpleTitleCaseMapping:0x1B66
 },
 { code:0x1B67
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B67
  ,simpleLowerCaseMapping:0x1B67
  ,simpleTitleCaseMapping:0x1B67
 },
 { code:0x1B68
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B68
  ,simpleLowerCaseMapping:0x1B68
  ,simpleTitleCaseMapping:0x1B68
 },
 { code:0x1B69
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B69
  ,simpleLowerCaseMapping:0x1B69
  ,simpleTitleCaseMapping:0x1B69
 },
 { code:0x1B6A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B6A
  ,simpleLowerCaseMapping:0x1B6A
  ,simpleTitleCaseMapping:0x1B6A
 },
 { code:0x1B6B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B6B
  ,simpleLowerCaseMapping:0x1B6B
  ,simpleTitleCaseMapping:0x1B6B
 },
 { code:0x1B6C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B6C
  ,simpleLowerCaseMapping:0x1B6C
  ,simpleTitleCaseMapping:0x1B6C
 },
 { code:0x1B6D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B6D
  ,simpleLowerCaseMapping:0x1B6D
  ,simpleTitleCaseMapping:0x1B6D
 },
 { code:0x1B6E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B6E
  ,simpleLowerCaseMapping:0x1B6E
  ,simpleTitleCaseMapping:0x1B6E
 },
 { code:0x1B6F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B6F
  ,simpleLowerCaseMapping:0x1B6F
  ,simpleTitleCaseMapping:0x1B6F
 },
 { code:0x1B70
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B70
  ,simpleLowerCaseMapping:0x1B70
  ,simpleTitleCaseMapping:0x1B70
 },
 { code:0x1B71
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B71
  ,simpleLowerCaseMapping:0x1B71
  ,simpleTitleCaseMapping:0x1B71
 },
 { code:0x1B72
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B72
  ,simpleLowerCaseMapping:0x1B72
  ,simpleTitleCaseMapping:0x1B72
 },
 { code:0x1B73
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1B73
  ,simpleLowerCaseMapping:0x1B73
  ,simpleTitleCaseMapping:0x1B73
 },
 { code:0x1B74
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B74
  ,simpleLowerCaseMapping:0x1B74
  ,simpleTitleCaseMapping:0x1B74
 },
 { code:0x1B75
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B75
  ,simpleLowerCaseMapping:0x1B75
  ,simpleTitleCaseMapping:0x1B75
 },
 { code:0x1B76
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B76
  ,simpleLowerCaseMapping:0x1B76
  ,simpleTitleCaseMapping:0x1B76
 },
 { code:0x1B77
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B77
  ,simpleLowerCaseMapping:0x1B77
  ,simpleTitleCaseMapping:0x1B77
 },
 { code:0x1B78
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B78
  ,simpleLowerCaseMapping:0x1B78
  ,simpleTitleCaseMapping:0x1B78
 },
 { code:0x1B79
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B79
  ,simpleLowerCaseMapping:0x1B79
  ,simpleTitleCaseMapping:0x1B79
 },
 { code:0x1B7A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B7A
  ,simpleLowerCaseMapping:0x1B7A
  ,simpleTitleCaseMapping:0x1B7A
 },
 { code:0x1B7B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B7B
  ,simpleLowerCaseMapping:0x1B7B
  ,simpleTitleCaseMapping:0x1B7B
 },
 { code:0x1B7C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1B7C
  ,simpleLowerCaseMapping:0x1B7C
  ,simpleTitleCaseMapping:0x1B7C
 },
 { code:0x1D00
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D00
  ,simpleLowerCaseMapping:0x1D00
  ,simpleTitleCaseMapping:0x1D00
 },
 { code:0x1D01
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D01
  ,simpleLowerCaseMapping:0x1D01
  ,simpleTitleCaseMapping:0x1D01
 },
 { code:0x1D02
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D02
  ,simpleLowerCaseMapping:0x1D02
  ,simpleTitleCaseMapping:0x1D02
 },
 { code:0x1D03
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D03
  ,simpleLowerCaseMapping:0x1D03
  ,simpleTitleCaseMapping:0x1D03
 },
 { code:0x1D04
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D04
  ,simpleLowerCaseMapping:0x1D04
  ,simpleTitleCaseMapping:0x1D04
 },
 { code:0x1D05
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D05
  ,simpleLowerCaseMapping:0x1D05
  ,simpleTitleCaseMapping:0x1D05
 },
 { code:0x1D06
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D06
  ,simpleLowerCaseMapping:0x1D06
  ,simpleTitleCaseMapping:0x1D06
 },
 { code:0x1D07
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D07
  ,simpleLowerCaseMapping:0x1D07
  ,simpleTitleCaseMapping:0x1D07
 },
 { code:0x1D08
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D08
  ,simpleLowerCaseMapping:0x1D08
  ,simpleTitleCaseMapping:0x1D08
 },
 { code:0x1D09
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D09
  ,simpleLowerCaseMapping:0x1D09
  ,simpleTitleCaseMapping:0x1D09
 },
 { code:0x1D0A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D0A
  ,simpleLowerCaseMapping:0x1D0A
  ,simpleTitleCaseMapping:0x1D0A
 },
 { code:0x1D0B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D0B
  ,simpleLowerCaseMapping:0x1D0B
  ,simpleTitleCaseMapping:0x1D0B
 },
 { code:0x1D0C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D0C
  ,simpleLowerCaseMapping:0x1D0C
  ,simpleTitleCaseMapping:0x1D0C
 },
 { code:0x1D0D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D0D
  ,simpleLowerCaseMapping:0x1D0D
  ,simpleTitleCaseMapping:0x1D0D
 },
 { code:0x1D0E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D0E
  ,simpleLowerCaseMapping:0x1D0E
  ,simpleTitleCaseMapping:0x1D0E
 },
 { code:0x1D0F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D0F
  ,simpleLowerCaseMapping:0x1D0F
  ,simpleTitleCaseMapping:0x1D0F
 },
 { code:0x1D10
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D10
  ,simpleLowerCaseMapping:0x1D10
  ,simpleTitleCaseMapping:0x1D10
 },
 { code:0x1D11
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D11
  ,simpleLowerCaseMapping:0x1D11
  ,simpleTitleCaseMapping:0x1D11
 },
 { code:0x1D12
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D12
  ,simpleLowerCaseMapping:0x1D12
  ,simpleTitleCaseMapping:0x1D12
 },
 { code:0x1D13
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D13
  ,simpleLowerCaseMapping:0x1D13
  ,simpleTitleCaseMapping:0x1D13
 },
 { code:0x1D14
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D14
  ,simpleLowerCaseMapping:0x1D14
  ,simpleTitleCaseMapping:0x1D14
 },
 { code:0x1D15
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D15
  ,simpleLowerCaseMapping:0x1D15
  ,simpleTitleCaseMapping:0x1D15
 },
 { code:0x1D16
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D16
  ,simpleLowerCaseMapping:0x1D16
  ,simpleTitleCaseMapping:0x1D16
 },
 { code:0x1D17
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D17
  ,simpleLowerCaseMapping:0x1D17
  ,simpleTitleCaseMapping:0x1D17
 },
 { code:0x1D18
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D18
  ,simpleLowerCaseMapping:0x1D18
  ,simpleTitleCaseMapping:0x1D18
 },
 { code:0x1D19
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D19
  ,simpleLowerCaseMapping:0x1D19
  ,simpleTitleCaseMapping:0x1D19
 },
 { code:0x1D1A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D1A
  ,simpleLowerCaseMapping:0x1D1A
  ,simpleTitleCaseMapping:0x1D1A
 },
 { code:0x1D1B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D1B
  ,simpleLowerCaseMapping:0x1D1B
  ,simpleTitleCaseMapping:0x1D1B
 },
 { code:0x1D1C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D1C
  ,simpleLowerCaseMapping:0x1D1C
  ,simpleTitleCaseMapping:0x1D1C
 },
 { code:0x1D1D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D1D
  ,simpleLowerCaseMapping:0x1D1D
  ,simpleTitleCaseMapping:0x1D1D
 },
 { code:0x1D1E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D1E
  ,simpleLowerCaseMapping:0x1D1E
  ,simpleTitleCaseMapping:0x1D1E
 },
 { code:0x1D1F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D1F
  ,simpleLowerCaseMapping:0x1D1F
  ,simpleTitleCaseMapping:0x1D1F
 },
 { code:0x1D20
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D20
  ,simpleLowerCaseMapping:0x1D20
  ,simpleTitleCaseMapping:0x1D20
 },
 { code:0x1D21
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D21
  ,simpleLowerCaseMapping:0x1D21
  ,simpleTitleCaseMapping:0x1D21
 },
 { code:0x1D22
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D22
  ,simpleLowerCaseMapping:0x1D22
  ,simpleTitleCaseMapping:0x1D22
 },
 { code:0x1D23
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D23
  ,simpleLowerCaseMapping:0x1D23
  ,simpleTitleCaseMapping:0x1D23
 },
 { code:0x1D24
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D24
  ,simpleLowerCaseMapping:0x1D24
  ,simpleTitleCaseMapping:0x1D24
 },
 { code:0x1D25
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D25
  ,simpleLowerCaseMapping:0x1D25
  ,simpleTitleCaseMapping:0x1D25
 },
 { code:0x1D26
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D26
  ,simpleLowerCaseMapping:0x1D26
  ,simpleTitleCaseMapping:0x1D26
 },
 { code:0x1D27
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D27
  ,simpleLowerCaseMapping:0x1D27
  ,simpleTitleCaseMapping:0x1D27
 },
 { code:0x1D28
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D28
  ,simpleLowerCaseMapping:0x1D28
  ,simpleTitleCaseMapping:0x1D28
 },
 { code:0x1D29
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D29
  ,simpleLowerCaseMapping:0x1D29
  ,simpleTitleCaseMapping:0x1D29
 },
 { code:0x1D2A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D2A
  ,simpleLowerCaseMapping:0x1D2A
  ,simpleTitleCaseMapping:0x1D2A
 },
 { code:0x1D2B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D2B
  ,simpleLowerCaseMapping:0x1D2B
  ,simpleTitleCaseMapping:0x1D2B
 },
 { code:0x1D2C
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D2C
  ,simpleLowerCaseMapping:0x1D2C
  ,simpleTitleCaseMapping:0x1D2C
 },
 { code:0x1D2D
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D2D
  ,simpleLowerCaseMapping:0x1D2D
  ,simpleTitleCaseMapping:0x1D2D
 },
 { code:0x1D2E
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D2E
  ,simpleLowerCaseMapping:0x1D2E
  ,simpleTitleCaseMapping:0x1D2E
 },
 { code:0x1D2F
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D2F
  ,simpleLowerCaseMapping:0x1D2F
  ,simpleTitleCaseMapping:0x1D2F
 },
 { code:0x1D30
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D30
  ,simpleLowerCaseMapping:0x1D30
  ,simpleTitleCaseMapping:0x1D30
 },
 { code:0x1D31
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D31
  ,simpleLowerCaseMapping:0x1D31
  ,simpleTitleCaseMapping:0x1D31
 },
 { code:0x1D32
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D32
  ,simpleLowerCaseMapping:0x1D32
  ,simpleTitleCaseMapping:0x1D32
 },
 { code:0x1D33
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D33
  ,simpleLowerCaseMapping:0x1D33
  ,simpleTitleCaseMapping:0x1D33
 },
 { code:0x1D34
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D34
  ,simpleLowerCaseMapping:0x1D34
  ,simpleTitleCaseMapping:0x1D34
 },
 { code:0x1D35
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D35
  ,simpleLowerCaseMapping:0x1D35
  ,simpleTitleCaseMapping:0x1D35
 },
 { code:0x1D36
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D36
  ,simpleLowerCaseMapping:0x1D36
  ,simpleTitleCaseMapping:0x1D36
 },
 { code:0x1D37
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D37
  ,simpleLowerCaseMapping:0x1D37
  ,simpleTitleCaseMapping:0x1D37
 },
 { code:0x1D38
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D38
  ,simpleLowerCaseMapping:0x1D38
  ,simpleTitleCaseMapping:0x1D38
 },
 { code:0x1D39
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D39
  ,simpleLowerCaseMapping:0x1D39
  ,simpleTitleCaseMapping:0x1D39
 },
 { code:0x1D3A
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D3A
  ,simpleLowerCaseMapping:0x1D3A
  ,simpleTitleCaseMapping:0x1D3A
 },
 { code:0x1D3B
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D3B
  ,simpleLowerCaseMapping:0x1D3B
  ,simpleTitleCaseMapping:0x1D3B
 },
 { code:0x1D3C
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D3C
  ,simpleLowerCaseMapping:0x1D3C
  ,simpleTitleCaseMapping:0x1D3C
 },
 { code:0x1D3D
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D3D
  ,simpleLowerCaseMapping:0x1D3D
  ,simpleTitleCaseMapping:0x1D3D
 },
 { code:0x1D3E
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D3E
  ,simpleLowerCaseMapping:0x1D3E
  ,simpleTitleCaseMapping:0x1D3E
 },
 { code:0x1D3F
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D3F
  ,simpleLowerCaseMapping:0x1D3F
  ,simpleTitleCaseMapping:0x1D3F
 },
 { code:0x1D40
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D40
  ,simpleLowerCaseMapping:0x1D40
  ,simpleTitleCaseMapping:0x1D40
 },
 { code:0x1D41
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D41
  ,simpleLowerCaseMapping:0x1D41
  ,simpleTitleCaseMapping:0x1D41
 },
 { code:0x1D42
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D42
  ,simpleLowerCaseMapping:0x1D42
  ,simpleTitleCaseMapping:0x1D42
 },
 { code:0x1D43
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D43
  ,simpleLowerCaseMapping:0x1D43
  ,simpleTitleCaseMapping:0x1D43
 },
 { code:0x1D44
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D44
  ,simpleLowerCaseMapping:0x1D44
  ,simpleTitleCaseMapping:0x1D44
 },
 { code:0x1D45
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D45
  ,simpleLowerCaseMapping:0x1D45
  ,simpleTitleCaseMapping:0x1D45
 },
 { code:0x1D46
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D46
  ,simpleLowerCaseMapping:0x1D46
  ,simpleTitleCaseMapping:0x1D46
 },
 { code:0x1D47
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D47
  ,simpleLowerCaseMapping:0x1D47
  ,simpleTitleCaseMapping:0x1D47
 },
 { code:0x1D48
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D48
  ,simpleLowerCaseMapping:0x1D48
  ,simpleTitleCaseMapping:0x1D48
 },
 { code:0x1D49
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D49
  ,simpleLowerCaseMapping:0x1D49
  ,simpleTitleCaseMapping:0x1D49
 },
 { code:0x1D4A
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D4A
  ,simpleLowerCaseMapping:0x1D4A
  ,simpleTitleCaseMapping:0x1D4A
 },
 { code:0x1D4B
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D4B
  ,simpleLowerCaseMapping:0x1D4B
  ,simpleTitleCaseMapping:0x1D4B
 },
 { code:0x1D4C
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D4C
  ,simpleLowerCaseMapping:0x1D4C
  ,simpleTitleCaseMapping:0x1D4C
 },
 { code:0x1D4D
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D4D
  ,simpleLowerCaseMapping:0x1D4D
  ,simpleTitleCaseMapping:0x1D4D
 },
 { code:0x1D4E
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D4E
  ,simpleLowerCaseMapping:0x1D4E
  ,simpleTitleCaseMapping:0x1D4E
 },
 { code:0x1D4F
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D4F
  ,simpleLowerCaseMapping:0x1D4F
  ,simpleTitleCaseMapping:0x1D4F
 },
 { code:0x1D50
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D50
  ,simpleLowerCaseMapping:0x1D50
  ,simpleTitleCaseMapping:0x1D50
 },
 { code:0x1D51
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D51
  ,simpleLowerCaseMapping:0x1D51
  ,simpleTitleCaseMapping:0x1D51
 },
 { code:0x1D52
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D52
  ,simpleLowerCaseMapping:0x1D52
  ,simpleTitleCaseMapping:0x1D52
 },
 { code:0x1D53
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D53
  ,simpleLowerCaseMapping:0x1D53
  ,simpleTitleCaseMapping:0x1D53
 },
 { code:0x1D54
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D54
  ,simpleLowerCaseMapping:0x1D54
  ,simpleTitleCaseMapping:0x1D54
 },
 { code:0x1D55
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D55
  ,simpleLowerCaseMapping:0x1D55
  ,simpleTitleCaseMapping:0x1D55
 },
 { code:0x1D56
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D56
  ,simpleLowerCaseMapping:0x1D56
  ,simpleTitleCaseMapping:0x1D56
 },
 { code:0x1D57
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D57
  ,simpleLowerCaseMapping:0x1D57
  ,simpleTitleCaseMapping:0x1D57
 },
 { code:0x1D58
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D58
  ,simpleLowerCaseMapping:0x1D58
  ,simpleTitleCaseMapping:0x1D58
 },
 { code:0x1D59
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D59
  ,simpleLowerCaseMapping:0x1D59
  ,simpleTitleCaseMapping:0x1D59
 },
 { code:0x1D5A
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D5A
  ,simpleLowerCaseMapping:0x1D5A
  ,simpleTitleCaseMapping:0x1D5A
 },
 { code:0x1D5B
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D5B
  ,simpleLowerCaseMapping:0x1D5B
  ,simpleTitleCaseMapping:0x1D5B
 },
 { code:0x1D5C
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D5C
  ,simpleLowerCaseMapping:0x1D5C
  ,simpleTitleCaseMapping:0x1D5C
 },
 { code:0x1D5D
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D5D
  ,simpleLowerCaseMapping:0x1D5D
  ,simpleTitleCaseMapping:0x1D5D
 },
 { code:0x1D5E
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D5E
  ,simpleLowerCaseMapping:0x1D5E
  ,simpleTitleCaseMapping:0x1D5E
 },
 { code:0x1D5F
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D5F
  ,simpleLowerCaseMapping:0x1D5F
  ,simpleTitleCaseMapping:0x1D5F
 },
 { code:0x1D60
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D60
  ,simpleLowerCaseMapping:0x1D60
  ,simpleTitleCaseMapping:0x1D60
 },
 { code:0x1D61
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D61
  ,simpleLowerCaseMapping:0x1D61
  ,simpleTitleCaseMapping:0x1D61
 },
 { code:0x1D62
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D62
  ,simpleLowerCaseMapping:0x1D62
  ,simpleTitleCaseMapping:0x1D62
 },
 { code:0x1D63
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D63
  ,simpleLowerCaseMapping:0x1D63
  ,simpleTitleCaseMapping:0x1D63
 },
 { code:0x1D64
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D64
  ,simpleLowerCaseMapping:0x1D64
  ,simpleTitleCaseMapping:0x1D64
 },
 { code:0x1D65
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D65
  ,simpleLowerCaseMapping:0x1D65
  ,simpleTitleCaseMapping:0x1D65
 },
 { code:0x1D66
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D66
  ,simpleLowerCaseMapping:0x1D66
  ,simpleTitleCaseMapping:0x1D66
 },
 { code:0x1D67
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D67
  ,simpleLowerCaseMapping:0x1D67
  ,simpleTitleCaseMapping:0x1D67
 },
 { code:0x1D68
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D68
  ,simpleLowerCaseMapping:0x1D68
  ,simpleTitleCaseMapping:0x1D68
 },
 { code:0x1D69
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D69
  ,simpleLowerCaseMapping:0x1D69
  ,simpleTitleCaseMapping:0x1D69
 },
 { code:0x1D6A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6A
  ,simpleLowerCaseMapping:0x1D6A
  ,simpleTitleCaseMapping:0x1D6A
 },
 { code:0x1D6B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6B
  ,simpleLowerCaseMapping:0x1D6B
  ,simpleTitleCaseMapping:0x1D6B
 },
 { code:0x1D6C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6C
  ,simpleLowerCaseMapping:0x1D6C
  ,simpleTitleCaseMapping:0x1D6C
 },
 { code:0x1D6D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6D
  ,simpleLowerCaseMapping:0x1D6D
  ,simpleTitleCaseMapping:0x1D6D
 },
 { code:0x1D6E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6E
  ,simpleLowerCaseMapping:0x1D6E
  ,simpleTitleCaseMapping:0x1D6E
 },
 { code:0x1D6F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6F
  ,simpleLowerCaseMapping:0x1D6F
  ,simpleTitleCaseMapping:0x1D6F
 },
 { code:0x1D70
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D70
  ,simpleLowerCaseMapping:0x1D70
  ,simpleTitleCaseMapping:0x1D70
 },
 { code:0x1D71
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D71
  ,simpleLowerCaseMapping:0x1D71
  ,simpleTitleCaseMapping:0x1D71
 },
 { code:0x1D72
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D72
  ,simpleLowerCaseMapping:0x1D72
  ,simpleTitleCaseMapping:0x1D72
 },
 { code:0x1D73
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D73
  ,simpleLowerCaseMapping:0x1D73
  ,simpleTitleCaseMapping:0x1D73
 },
 { code:0x1D74
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D74
  ,simpleLowerCaseMapping:0x1D74
  ,simpleTitleCaseMapping:0x1D74
 },
 { code:0x1D75
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D75
  ,simpleLowerCaseMapping:0x1D75
  ,simpleTitleCaseMapping:0x1D75
 },
 { code:0x1D76
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D76
  ,simpleLowerCaseMapping:0x1D76
  ,simpleTitleCaseMapping:0x1D76
 },
 { code:0x1D77
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D77
  ,simpleLowerCaseMapping:0x1D77
  ,simpleTitleCaseMapping:0x1D77
 },
 { code:0x1D78
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D78
  ,simpleLowerCaseMapping:0x1D78
  ,simpleTitleCaseMapping:0x1D78
 },
 { code:0x1D79
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D79
  ,simpleLowerCaseMapping:0x1D79
  ,simpleTitleCaseMapping:0x1D79
 },
 { code:0x1D7A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7A
  ,simpleLowerCaseMapping:0x1D7A
  ,simpleTitleCaseMapping:0x1D7A
 },
 { code:0x1D7B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7B
  ,simpleLowerCaseMapping:0x1D7B
  ,simpleTitleCaseMapping:0x1D7B
 },
 { code:0x1D7C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7C
  ,simpleLowerCaseMapping:0x1D7C
  ,simpleTitleCaseMapping:0x1D7C
 },
 { code:0x1D7D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C63
  ,simpleLowerCaseMapping:0x1D7D
  ,simpleTitleCaseMapping:0x2C63
 },
 { code:0x1D7E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7E
  ,simpleLowerCaseMapping:0x1D7E
  ,simpleTitleCaseMapping:0x1D7E
 },
 { code:0x1D7F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7F
  ,simpleLowerCaseMapping:0x1D7F
  ,simpleTitleCaseMapping:0x1D7F
 },
 { code:0x1D80
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D80
  ,simpleLowerCaseMapping:0x1D80
  ,simpleTitleCaseMapping:0x1D80
 },
 { code:0x1D81
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D81
  ,simpleLowerCaseMapping:0x1D81
  ,simpleTitleCaseMapping:0x1D81
 },
 { code:0x1D82
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D82
  ,simpleLowerCaseMapping:0x1D82
  ,simpleTitleCaseMapping:0x1D82
 },
 { code:0x1D83
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D83
  ,simpleLowerCaseMapping:0x1D83
  ,simpleTitleCaseMapping:0x1D83
 },
 { code:0x1D84
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D84
  ,simpleLowerCaseMapping:0x1D84
  ,simpleTitleCaseMapping:0x1D84
 },
 { code:0x1D85
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D85
  ,simpleLowerCaseMapping:0x1D85
  ,simpleTitleCaseMapping:0x1D85
 },
 { code:0x1D86
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D86
  ,simpleLowerCaseMapping:0x1D86
  ,simpleTitleCaseMapping:0x1D86
 },
 { code:0x1D87
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D87
  ,simpleLowerCaseMapping:0x1D87
  ,simpleTitleCaseMapping:0x1D87
 },
 { code:0x1D88
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D88
  ,simpleLowerCaseMapping:0x1D88
  ,simpleTitleCaseMapping:0x1D88
 },
 { code:0x1D89
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D89
  ,simpleLowerCaseMapping:0x1D89
  ,simpleTitleCaseMapping:0x1D89
 },
 { code:0x1D8A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D8A
  ,simpleLowerCaseMapping:0x1D8A
  ,simpleTitleCaseMapping:0x1D8A
 },
 { code:0x1D8B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D8B
  ,simpleLowerCaseMapping:0x1D8B
  ,simpleTitleCaseMapping:0x1D8B
 },
 { code:0x1D8C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D8C
  ,simpleLowerCaseMapping:0x1D8C
  ,simpleTitleCaseMapping:0x1D8C
 },
 { code:0x1D8D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D8D
  ,simpleLowerCaseMapping:0x1D8D
  ,simpleTitleCaseMapping:0x1D8D
 },
 { code:0x1D8E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D8E
  ,simpleLowerCaseMapping:0x1D8E
  ,simpleTitleCaseMapping:0x1D8E
 },
 { code:0x1D8F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D8F
  ,simpleLowerCaseMapping:0x1D8F
  ,simpleTitleCaseMapping:0x1D8F
 },
 { code:0x1D90
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D90
  ,simpleLowerCaseMapping:0x1D90
  ,simpleTitleCaseMapping:0x1D90
 },
 { code:0x1D91
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D91
  ,simpleLowerCaseMapping:0x1D91
  ,simpleTitleCaseMapping:0x1D91
 },
 { code:0x1D92
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D92
  ,simpleLowerCaseMapping:0x1D92
  ,simpleTitleCaseMapping:0x1D92
 },
 { code:0x1D93
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D93
  ,simpleLowerCaseMapping:0x1D93
  ,simpleTitleCaseMapping:0x1D93
 },
 { code:0x1D94
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D94
  ,simpleLowerCaseMapping:0x1D94
  ,simpleTitleCaseMapping:0x1D94
 },
 { code:0x1D95
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D95
  ,simpleLowerCaseMapping:0x1D95
  ,simpleTitleCaseMapping:0x1D95
 },
 { code:0x1D96
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D96
  ,simpleLowerCaseMapping:0x1D96
  ,simpleTitleCaseMapping:0x1D96
 },
 { code:0x1D97
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D97
  ,simpleLowerCaseMapping:0x1D97
  ,simpleTitleCaseMapping:0x1D97
 },
 { code:0x1D98
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D98
  ,simpleLowerCaseMapping:0x1D98
  ,simpleTitleCaseMapping:0x1D98
 },
 { code:0x1D99
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D99
  ,simpleLowerCaseMapping:0x1D99
  ,simpleTitleCaseMapping:0x1D99
 },
 { code:0x1D9A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D9A
  ,simpleLowerCaseMapping:0x1D9A
  ,simpleTitleCaseMapping:0x1D9A
 },
 { code:0x1D9B
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D9B
  ,simpleLowerCaseMapping:0x1D9B
  ,simpleTitleCaseMapping:0x1D9B
 },
 { code:0x1D9C
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D9C
  ,simpleLowerCaseMapping:0x1D9C
  ,simpleTitleCaseMapping:0x1D9C
 },
 { code:0x1D9D
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D9D
  ,simpleLowerCaseMapping:0x1D9D
  ,simpleTitleCaseMapping:0x1D9D
 },
 { code:0x1D9E
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D9E
  ,simpleLowerCaseMapping:0x1D9E
  ,simpleTitleCaseMapping:0x1D9E
 },
 { code:0x1D9F
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1D9F
  ,simpleLowerCaseMapping:0x1D9F
  ,simpleTitleCaseMapping:0x1D9F
 },
 { code:0x1DA0
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DA0
  ,simpleLowerCaseMapping:0x1DA0
  ,simpleTitleCaseMapping:0x1DA0
 },
 { code:0x1DA1
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DA1
  ,simpleLowerCaseMapping:0x1DA1
  ,simpleTitleCaseMapping:0x1DA1
 },
 { code:0x1DA2
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DA2
  ,simpleLowerCaseMapping:0x1DA2
  ,simpleTitleCaseMapping:0x1DA2
 },
 { code:0x1DA3
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DA3
  ,simpleLowerCaseMapping:0x1DA3
  ,simpleTitleCaseMapping:0x1DA3
 },
 { code:0x1DA4
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DA4
  ,simpleLowerCaseMapping:0x1DA4
  ,simpleTitleCaseMapping:0x1DA4
 },
 { code:0x1DA5
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DA5
  ,simpleLowerCaseMapping:0x1DA5
  ,simpleTitleCaseMapping:0x1DA5
 },
 { code:0x1DA6
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DA6
  ,simpleLowerCaseMapping:0x1DA6
  ,simpleTitleCaseMapping:0x1DA6
 },
 { code:0x1DA7
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DA7
  ,simpleLowerCaseMapping:0x1DA7
  ,simpleTitleCaseMapping:0x1DA7
 },
 { code:0x1DA8
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DA8
  ,simpleLowerCaseMapping:0x1DA8
  ,simpleTitleCaseMapping:0x1DA8
 },
 { code:0x1DA9
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DA9
  ,simpleLowerCaseMapping:0x1DA9
  ,simpleTitleCaseMapping:0x1DA9
 },
 { code:0x1DAA
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DAA
  ,simpleLowerCaseMapping:0x1DAA
  ,simpleTitleCaseMapping:0x1DAA
 },
 { code:0x1DAB
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DAB
  ,simpleLowerCaseMapping:0x1DAB
  ,simpleTitleCaseMapping:0x1DAB
 },
 { code:0x1DAC
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DAC
  ,simpleLowerCaseMapping:0x1DAC
  ,simpleTitleCaseMapping:0x1DAC
 },
 { code:0x1DAD
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DAD
  ,simpleLowerCaseMapping:0x1DAD
  ,simpleTitleCaseMapping:0x1DAD
 },
 { code:0x1DAE
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DAE
  ,simpleLowerCaseMapping:0x1DAE
  ,simpleTitleCaseMapping:0x1DAE
 },
 { code:0x1DAF
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DAF
  ,simpleLowerCaseMapping:0x1DAF
  ,simpleTitleCaseMapping:0x1DAF
 },
 { code:0x1DB0
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DB0
  ,simpleLowerCaseMapping:0x1DB0
  ,simpleTitleCaseMapping:0x1DB0
 },
 { code:0x1DB1
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DB1
  ,simpleLowerCaseMapping:0x1DB1
  ,simpleTitleCaseMapping:0x1DB1
 },
 { code:0x1DB2
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DB2
  ,simpleLowerCaseMapping:0x1DB2
  ,simpleTitleCaseMapping:0x1DB2
 },
 { code:0x1DB3
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DB3
  ,simpleLowerCaseMapping:0x1DB3
  ,simpleTitleCaseMapping:0x1DB3
 },
 { code:0x1DB4
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DB4
  ,simpleLowerCaseMapping:0x1DB4
  ,simpleTitleCaseMapping:0x1DB4
 },
 { code:0x1DB5
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DB5
  ,simpleLowerCaseMapping:0x1DB5
  ,simpleTitleCaseMapping:0x1DB5
 },
 { code:0x1DB6
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DB6
  ,simpleLowerCaseMapping:0x1DB6
  ,simpleTitleCaseMapping:0x1DB6
 },
 { code:0x1DB7
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DB7
  ,simpleLowerCaseMapping:0x1DB7
  ,simpleTitleCaseMapping:0x1DB7
 },
 { code:0x1DB8
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DB8
  ,simpleLowerCaseMapping:0x1DB8
  ,simpleTitleCaseMapping:0x1DB8
 },
 { code:0x1DB9
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DB9
  ,simpleLowerCaseMapping:0x1DB9
  ,simpleTitleCaseMapping:0x1DB9
 },
 { code:0x1DBA
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DBA
  ,simpleLowerCaseMapping:0x1DBA
  ,simpleTitleCaseMapping:0x1DBA
 },
 { code:0x1DBB
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DBB
  ,simpleLowerCaseMapping:0x1DBB
  ,simpleTitleCaseMapping:0x1DBB
 },
 { code:0x1DBC
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DBC
  ,simpleLowerCaseMapping:0x1DBC
  ,simpleTitleCaseMapping:0x1DBC
 },
 { code:0x1DBD
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DBD
  ,simpleLowerCaseMapping:0x1DBD
  ,simpleTitleCaseMapping:0x1DBD
 },
 { code:0x1DBE
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DBE
  ,simpleLowerCaseMapping:0x1DBE
  ,simpleTitleCaseMapping:0x1DBE
 },
 { code:0x1DBF
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x1DBF
  ,simpleLowerCaseMapping:0x1DBF
  ,simpleTitleCaseMapping:0x1DBF
 },
 { code:0x1DC0
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1DC0
  ,simpleLowerCaseMapping:0x1DC0
  ,simpleTitleCaseMapping:0x1DC0
 },
 { code:0x1DC1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1DC1
  ,simpleLowerCaseMapping:0x1DC1
  ,simpleTitleCaseMapping:0x1DC1
 },
 { code:0x1DC2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1DC2
  ,simpleLowerCaseMapping:0x1DC2
  ,simpleTitleCaseMapping:0x1DC2
 },
 { code:0x1DC3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1DC3
  ,simpleLowerCaseMapping:0x1DC3
  ,simpleTitleCaseMapping:0x1DC3
 },
 { code:0x1DC4
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1DC4
  ,simpleLowerCaseMapping:0x1DC4
  ,simpleTitleCaseMapping:0x1DC4
 },
 { code:0x1DC5
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1DC5
  ,simpleLowerCaseMapping:0x1DC5
  ,simpleTitleCaseMapping:0x1DC5
 },
 { code:0x1DC6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1DC6
  ,simpleLowerCaseMapping:0x1DC6
  ,simpleTitleCaseMapping:0x1DC6
 },
 { code:0x1DC7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1DC7
  ,simpleLowerCaseMapping:0x1DC7
  ,simpleTitleCaseMapping:0x1DC7
 },
 { code:0x1DC8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1DC8
  ,simpleLowerCaseMapping:0x1DC8
  ,simpleTitleCaseMapping:0x1DC8
 },
 { code:0x1DC9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1DC9
  ,simpleLowerCaseMapping:0x1DC9
  ,simpleTitleCaseMapping:0x1DC9
 },
 { code:0x1DCA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1DCA
  ,simpleLowerCaseMapping:0x1DCA
  ,simpleTitleCaseMapping:0x1DCA
 },
 { code:0x1DFE
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1DFE
  ,simpleLowerCaseMapping:0x1DFE
  ,simpleTitleCaseMapping:0x1DFE
 },
 { code:0x1DFF
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1DFF
  ,simpleLowerCaseMapping:0x1DFF
  ,simpleTitleCaseMapping:0x1DFF
 },
 { code:0x1E00
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E00
  ,simpleLowerCaseMapping:0x1E01
  ,simpleTitleCaseMapping:0x1E00
 },
 { code:0x1E01
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E00
  ,simpleLowerCaseMapping:0x1E01
  ,simpleTitleCaseMapping:0x1E00
 },
 { code:0x1E02
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E02
  ,simpleLowerCaseMapping:0x1E03
  ,simpleTitleCaseMapping:0x1E02
 },
 { code:0x1E03
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E02
  ,simpleLowerCaseMapping:0x1E03
  ,simpleTitleCaseMapping:0x1E02
 },
 { code:0x1E04
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E04
  ,simpleLowerCaseMapping:0x1E05
  ,simpleTitleCaseMapping:0x1E04
 },
 { code:0x1E05
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E04
  ,simpleLowerCaseMapping:0x1E05
  ,simpleTitleCaseMapping:0x1E04
 },
 { code:0x1E06
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E06
  ,simpleLowerCaseMapping:0x1E07
  ,simpleTitleCaseMapping:0x1E06
 },
 { code:0x1E07
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E06
  ,simpleLowerCaseMapping:0x1E07
  ,simpleTitleCaseMapping:0x1E06
 },
 { code:0x1E08
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E08
  ,simpleLowerCaseMapping:0x1E09
  ,simpleTitleCaseMapping:0x1E08
 },
 { code:0x1E09
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E08
  ,simpleLowerCaseMapping:0x1E09
  ,simpleTitleCaseMapping:0x1E08
 },
 { code:0x1E0A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E0A
  ,simpleLowerCaseMapping:0x1E0B
  ,simpleTitleCaseMapping:0x1E0A
 },
 { code:0x1E0B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E0A
  ,simpleLowerCaseMapping:0x1E0B
  ,simpleTitleCaseMapping:0x1E0A
 },
 { code:0x1E0C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E0C
  ,simpleLowerCaseMapping:0x1E0D
  ,simpleTitleCaseMapping:0x1E0C
 },
 { code:0x1E0D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E0C
  ,simpleLowerCaseMapping:0x1E0D
  ,simpleTitleCaseMapping:0x1E0C
 },
 { code:0x1E0E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E0E
  ,simpleLowerCaseMapping:0x1E0F
  ,simpleTitleCaseMapping:0x1E0E
 },
 { code:0x1E0F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E0E
  ,simpleLowerCaseMapping:0x1E0F
  ,simpleTitleCaseMapping:0x1E0E
 },
 { code:0x1E10
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E10
  ,simpleLowerCaseMapping:0x1E11
  ,simpleTitleCaseMapping:0x1E10
 },
 { code:0x1E11
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E10
  ,simpleLowerCaseMapping:0x1E11
  ,simpleTitleCaseMapping:0x1E10
 },
 { code:0x1E12
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E12
  ,simpleLowerCaseMapping:0x1E13
  ,simpleTitleCaseMapping:0x1E12
 },
 { code:0x1E13
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E12
  ,simpleLowerCaseMapping:0x1E13
  ,simpleTitleCaseMapping:0x1E12
 },
 { code:0x1E14
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E14
  ,simpleLowerCaseMapping:0x1E15
  ,simpleTitleCaseMapping:0x1E14
 },
 { code:0x1E15
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E14
  ,simpleLowerCaseMapping:0x1E15
  ,simpleTitleCaseMapping:0x1E14
 },
 { code:0x1E16
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E16
  ,simpleLowerCaseMapping:0x1E17
  ,simpleTitleCaseMapping:0x1E16
 },
 { code:0x1E17
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E16
  ,simpleLowerCaseMapping:0x1E17
  ,simpleTitleCaseMapping:0x1E16
 },
 { code:0x1E18
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E18
  ,simpleLowerCaseMapping:0x1E19
  ,simpleTitleCaseMapping:0x1E18
 },
 { code:0x1E19
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E18
  ,simpleLowerCaseMapping:0x1E19
  ,simpleTitleCaseMapping:0x1E18
 },
 { code:0x1E1A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E1A
  ,simpleLowerCaseMapping:0x1E1B
  ,simpleTitleCaseMapping:0x1E1A
 },
 { code:0x1E1B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E1A
  ,simpleLowerCaseMapping:0x1E1B
  ,simpleTitleCaseMapping:0x1E1A
 },
 { code:0x1E1C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E1C
  ,simpleLowerCaseMapping:0x1E1D
  ,simpleTitleCaseMapping:0x1E1C
 },
 { code:0x1E1D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E1C
  ,simpleLowerCaseMapping:0x1E1D
  ,simpleTitleCaseMapping:0x1E1C
 },
 { code:0x1E1E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E1E
  ,simpleLowerCaseMapping:0x1E1F
  ,simpleTitleCaseMapping:0x1E1E
 },
 { code:0x1E1F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E1E
  ,simpleLowerCaseMapping:0x1E1F
  ,simpleTitleCaseMapping:0x1E1E
 },
 { code:0x1E20
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E20
  ,simpleLowerCaseMapping:0x1E21
  ,simpleTitleCaseMapping:0x1E20
 },
 { code:0x1E21
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E20
  ,simpleLowerCaseMapping:0x1E21
  ,simpleTitleCaseMapping:0x1E20
 },
 { code:0x1E22
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E22
  ,simpleLowerCaseMapping:0x1E23
  ,simpleTitleCaseMapping:0x1E22
 },
 { code:0x1E23
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E22
  ,simpleLowerCaseMapping:0x1E23
  ,simpleTitleCaseMapping:0x1E22
 },
 { code:0x1E24
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E24
  ,simpleLowerCaseMapping:0x1E25
  ,simpleTitleCaseMapping:0x1E24
 },
 { code:0x1E25
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E24
  ,simpleLowerCaseMapping:0x1E25
  ,simpleTitleCaseMapping:0x1E24
 },
 { code:0x1E26
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E26
  ,simpleLowerCaseMapping:0x1E27
  ,simpleTitleCaseMapping:0x1E26
 },
 { code:0x1E27
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E26
  ,simpleLowerCaseMapping:0x1E27
  ,simpleTitleCaseMapping:0x1E26
 },
 { code:0x1E28
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E28
  ,simpleLowerCaseMapping:0x1E29
  ,simpleTitleCaseMapping:0x1E28
 },
 { code:0x1E29
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E28
  ,simpleLowerCaseMapping:0x1E29
  ,simpleTitleCaseMapping:0x1E28
 },
 { code:0x1E2A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E2A
  ,simpleLowerCaseMapping:0x1E2B
  ,simpleTitleCaseMapping:0x1E2A
 },
 { code:0x1E2B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E2A
  ,simpleLowerCaseMapping:0x1E2B
  ,simpleTitleCaseMapping:0x1E2A
 },
 { code:0x1E2C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E2C
  ,simpleLowerCaseMapping:0x1E2D
  ,simpleTitleCaseMapping:0x1E2C
 },
 { code:0x1E2D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E2C
  ,simpleLowerCaseMapping:0x1E2D
  ,simpleTitleCaseMapping:0x1E2C
 },
 { code:0x1E2E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E2E
  ,simpleLowerCaseMapping:0x1E2F
  ,simpleTitleCaseMapping:0x1E2E
 },
 { code:0x1E2F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E2E
  ,simpleLowerCaseMapping:0x1E2F
  ,simpleTitleCaseMapping:0x1E2E
 },
 { code:0x1E30
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E30
  ,simpleLowerCaseMapping:0x1E31
  ,simpleTitleCaseMapping:0x1E30
 },
 { code:0x1E31
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E30
  ,simpleLowerCaseMapping:0x1E31
  ,simpleTitleCaseMapping:0x1E30
 },
 { code:0x1E32
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E32
  ,simpleLowerCaseMapping:0x1E33
  ,simpleTitleCaseMapping:0x1E32
 },
 { code:0x1E33
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E32
  ,simpleLowerCaseMapping:0x1E33
  ,simpleTitleCaseMapping:0x1E32
 },
 { code:0x1E34
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E34
  ,simpleLowerCaseMapping:0x1E35
  ,simpleTitleCaseMapping:0x1E34
 },
 { code:0x1E35
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E34
  ,simpleLowerCaseMapping:0x1E35
  ,simpleTitleCaseMapping:0x1E34
 },
 { code:0x1E36
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E36
  ,simpleLowerCaseMapping:0x1E37
  ,simpleTitleCaseMapping:0x1E36
 },
 { code:0x1E37
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E36
  ,simpleLowerCaseMapping:0x1E37
  ,simpleTitleCaseMapping:0x1E36
 },
 { code:0x1E38
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E38
  ,simpleLowerCaseMapping:0x1E39
  ,simpleTitleCaseMapping:0x1E38
 },
 { code:0x1E39
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E38
  ,simpleLowerCaseMapping:0x1E39
  ,simpleTitleCaseMapping:0x1E38
 },
 { code:0x1E3A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E3A
  ,simpleLowerCaseMapping:0x1E3B
  ,simpleTitleCaseMapping:0x1E3A
 },
 { code:0x1E3B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E3A
  ,simpleLowerCaseMapping:0x1E3B
  ,simpleTitleCaseMapping:0x1E3A
 },
 { code:0x1E3C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E3C
  ,simpleLowerCaseMapping:0x1E3D
  ,simpleTitleCaseMapping:0x1E3C
 },
 { code:0x1E3D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E3C
  ,simpleLowerCaseMapping:0x1E3D
  ,simpleTitleCaseMapping:0x1E3C
 },
 { code:0x1E3E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E3E
  ,simpleLowerCaseMapping:0x1E3F
  ,simpleTitleCaseMapping:0x1E3E
 },
 { code:0x1E3F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E3E
  ,simpleLowerCaseMapping:0x1E3F
  ,simpleTitleCaseMapping:0x1E3E
 },
 { code:0x1E40
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E40
  ,simpleLowerCaseMapping:0x1E41
  ,simpleTitleCaseMapping:0x1E40
 },
 { code:0x1E41
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E40
  ,simpleLowerCaseMapping:0x1E41
  ,simpleTitleCaseMapping:0x1E40
 },
 { code:0x1E42
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E42
  ,simpleLowerCaseMapping:0x1E43
  ,simpleTitleCaseMapping:0x1E42
 },
 { code:0x1E43
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E42
  ,simpleLowerCaseMapping:0x1E43
  ,simpleTitleCaseMapping:0x1E42
 },
 { code:0x1E44
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E44
  ,simpleLowerCaseMapping:0x1E45
  ,simpleTitleCaseMapping:0x1E44
 },
 { code:0x1E45
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E44
  ,simpleLowerCaseMapping:0x1E45
  ,simpleTitleCaseMapping:0x1E44
 },
 { code:0x1E46
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E46
  ,simpleLowerCaseMapping:0x1E47
  ,simpleTitleCaseMapping:0x1E46
 },
 { code:0x1E47
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E46
  ,simpleLowerCaseMapping:0x1E47
  ,simpleTitleCaseMapping:0x1E46
 },
 { code:0x1E48
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E48
  ,simpleLowerCaseMapping:0x1E49
  ,simpleTitleCaseMapping:0x1E48
 },
 { code:0x1E49
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E48
  ,simpleLowerCaseMapping:0x1E49
  ,simpleTitleCaseMapping:0x1E48
 },
 { code:0x1E4A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E4A
  ,simpleLowerCaseMapping:0x1E4B
  ,simpleTitleCaseMapping:0x1E4A
 },
 { code:0x1E4B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E4A
  ,simpleLowerCaseMapping:0x1E4B
  ,simpleTitleCaseMapping:0x1E4A
 },
 { code:0x1E4C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E4C
  ,simpleLowerCaseMapping:0x1E4D
  ,simpleTitleCaseMapping:0x1E4C
 },
 { code:0x1E4D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E4C
  ,simpleLowerCaseMapping:0x1E4D
  ,simpleTitleCaseMapping:0x1E4C
 },
 { code:0x1E4E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E4E
  ,simpleLowerCaseMapping:0x1E4F
  ,simpleTitleCaseMapping:0x1E4E
 },
 { code:0x1E4F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E4E
  ,simpleLowerCaseMapping:0x1E4F
  ,simpleTitleCaseMapping:0x1E4E
 },
 { code:0x1E50
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E50
  ,simpleLowerCaseMapping:0x1E51
  ,simpleTitleCaseMapping:0x1E50
 },
 { code:0x1E51
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E50
  ,simpleLowerCaseMapping:0x1E51
  ,simpleTitleCaseMapping:0x1E50
 },
 { code:0x1E52
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E52
  ,simpleLowerCaseMapping:0x1E53
  ,simpleTitleCaseMapping:0x1E52
 },
 { code:0x1E53
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E52
  ,simpleLowerCaseMapping:0x1E53
  ,simpleTitleCaseMapping:0x1E52
 },
 { code:0x1E54
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E54
  ,simpleLowerCaseMapping:0x1E55
  ,simpleTitleCaseMapping:0x1E54
 },
 { code:0x1E55
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E54
  ,simpleLowerCaseMapping:0x1E55
  ,simpleTitleCaseMapping:0x1E54
 },
 { code:0x1E56
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E56
  ,simpleLowerCaseMapping:0x1E57
  ,simpleTitleCaseMapping:0x1E56
 },
 { code:0x1E57
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E56
  ,simpleLowerCaseMapping:0x1E57
  ,simpleTitleCaseMapping:0x1E56
 },
 { code:0x1E58
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E58
  ,simpleLowerCaseMapping:0x1E59
  ,simpleTitleCaseMapping:0x1E58
 },
 { code:0x1E59
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E58
  ,simpleLowerCaseMapping:0x1E59
  ,simpleTitleCaseMapping:0x1E58
 },
 { code:0x1E5A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E5A
  ,simpleLowerCaseMapping:0x1E5B
  ,simpleTitleCaseMapping:0x1E5A
 },
 { code:0x1E5B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E5A
  ,simpleLowerCaseMapping:0x1E5B
  ,simpleTitleCaseMapping:0x1E5A
 },
 { code:0x1E5C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E5C
  ,simpleLowerCaseMapping:0x1E5D
  ,simpleTitleCaseMapping:0x1E5C
 },
 { code:0x1E5D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E5C
  ,simpleLowerCaseMapping:0x1E5D
  ,simpleTitleCaseMapping:0x1E5C
 },
 { code:0x1E5E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E5E
  ,simpleLowerCaseMapping:0x1E5F
  ,simpleTitleCaseMapping:0x1E5E
 },
 { code:0x1E5F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E5E
  ,simpleLowerCaseMapping:0x1E5F
  ,simpleTitleCaseMapping:0x1E5E
 },
 { code:0x1E60
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E60
  ,simpleLowerCaseMapping:0x1E61
  ,simpleTitleCaseMapping:0x1E60
 },
 { code:0x1E61
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E60
  ,simpleLowerCaseMapping:0x1E61
  ,simpleTitleCaseMapping:0x1E60
 },
 { code:0x1E62
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E62
  ,simpleLowerCaseMapping:0x1E63
  ,simpleTitleCaseMapping:0x1E62
 },
 { code:0x1E63
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E62
  ,simpleLowerCaseMapping:0x1E63
  ,simpleTitleCaseMapping:0x1E62
 },
 { code:0x1E64
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E64
  ,simpleLowerCaseMapping:0x1E65
  ,simpleTitleCaseMapping:0x1E64
 },
 { code:0x1E65
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E64
  ,simpleLowerCaseMapping:0x1E65
  ,simpleTitleCaseMapping:0x1E64
 },
 { code:0x1E66
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E66
  ,simpleLowerCaseMapping:0x1E67
  ,simpleTitleCaseMapping:0x1E66
 },
 { code:0x1E67
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E66
  ,simpleLowerCaseMapping:0x1E67
  ,simpleTitleCaseMapping:0x1E66
 },
 { code:0x1E68
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E68
  ,simpleLowerCaseMapping:0x1E69
  ,simpleTitleCaseMapping:0x1E68
 },
 { code:0x1E69
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E68
  ,simpleLowerCaseMapping:0x1E69
  ,simpleTitleCaseMapping:0x1E68
 },
 { code:0x1E6A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E6A
  ,simpleLowerCaseMapping:0x1E6B
  ,simpleTitleCaseMapping:0x1E6A
 },
 { code:0x1E6B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E6A
  ,simpleLowerCaseMapping:0x1E6B
  ,simpleTitleCaseMapping:0x1E6A
 },
 { code:0x1E6C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E6C
  ,simpleLowerCaseMapping:0x1E6D
  ,simpleTitleCaseMapping:0x1E6C
 },
 { code:0x1E6D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E6C
  ,simpleLowerCaseMapping:0x1E6D
  ,simpleTitleCaseMapping:0x1E6C
 },
 { code:0x1E6E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E6E
  ,simpleLowerCaseMapping:0x1E6F
  ,simpleTitleCaseMapping:0x1E6E
 },
 { code:0x1E6F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E6E
  ,simpleLowerCaseMapping:0x1E6F
  ,simpleTitleCaseMapping:0x1E6E
 },
 { code:0x1E70
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E70
  ,simpleLowerCaseMapping:0x1E71
  ,simpleTitleCaseMapping:0x1E70
 },
 { code:0x1E71
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E70
  ,simpleLowerCaseMapping:0x1E71
  ,simpleTitleCaseMapping:0x1E70
 },
 { code:0x1E72
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E72
  ,simpleLowerCaseMapping:0x1E73
  ,simpleTitleCaseMapping:0x1E72
 },
 { code:0x1E73
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E72
  ,simpleLowerCaseMapping:0x1E73
  ,simpleTitleCaseMapping:0x1E72
 },
 { code:0x1E74
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E74
  ,simpleLowerCaseMapping:0x1E75
  ,simpleTitleCaseMapping:0x1E74
 },
 { code:0x1E75
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E74
  ,simpleLowerCaseMapping:0x1E75
  ,simpleTitleCaseMapping:0x1E74
 },
 { code:0x1E76
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E76
  ,simpleLowerCaseMapping:0x1E77
  ,simpleTitleCaseMapping:0x1E76
 },
 { code:0x1E77
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E76
  ,simpleLowerCaseMapping:0x1E77
  ,simpleTitleCaseMapping:0x1E76
 },
 { code:0x1E78
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E78
  ,simpleLowerCaseMapping:0x1E79
  ,simpleTitleCaseMapping:0x1E78
 },
 { code:0x1E79
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E78
  ,simpleLowerCaseMapping:0x1E79
  ,simpleTitleCaseMapping:0x1E78
 },
 { code:0x1E7A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E7A
  ,simpleLowerCaseMapping:0x1E7B
  ,simpleTitleCaseMapping:0x1E7A
 },
 { code:0x1E7B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E7A
  ,simpleLowerCaseMapping:0x1E7B
  ,simpleTitleCaseMapping:0x1E7A
 },
 { code:0x1E7C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E7C
  ,simpleLowerCaseMapping:0x1E7D
  ,simpleTitleCaseMapping:0x1E7C
 },
 { code:0x1E7D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E7C
  ,simpleLowerCaseMapping:0x1E7D
  ,simpleTitleCaseMapping:0x1E7C
 },
 { code:0x1E7E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E7E
  ,simpleLowerCaseMapping:0x1E7F
  ,simpleTitleCaseMapping:0x1E7E
 },
 { code:0x1E7F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E7E
  ,simpleLowerCaseMapping:0x1E7F
  ,simpleTitleCaseMapping:0x1E7E
 },
 { code:0x1E80
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E80
  ,simpleLowerCaseMapping:0x1E81
  ,simpleTitleCaseMapping:0x1E80
 },
 { code:0x1E81
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E80
  ,simpleLowerCaseMapping:0x1E81
  ,simpleTitleCaseMapping:0x1E80
 },
 { code:0x1E82
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E82
  ,simpleLowerCaseMapping:0x1E83
  ,simpleTitleCaseMapping:0x1E82
 },
 { code:0x1E83
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E82
  ,simpleLowerCaseMapping:0x1E83
  ,simpleTitleCaseMapping:0x1E82
 },
 { code:0x1E84
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E84
  ,simpleLowerCaseMapping:0x1E85
  ,simpleTitleCaseMapping:0x1E84
 },
 { code:0x1E85
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E84
  ,simpleLowerCaseMapping:0x1E85
  ,simpleTitleCaseMapping:0x1E84
 },
 { code:0x1E86
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E86
  ,simpleLowerCaseMapping:0x1E87
  ,simpleTitleCaseMapping:0x1E86
 },
 { code:0x1E87
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E86
  ,simpleLowerCaseMapping:0x1E87
  ,simpleTitleCaseMapping:0x1E86
 },
 { code:0x1E88
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E88
  ,simpleLowerCaseMapping:0x1E89
  ,simpleTitleCaseMapping:0x1E88
 },
 { code:0x1E89
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E88
  ,simpleLowerCaseMapping:0x1E89
  ,simpleTitleCaseMapping:0x1E88
 },
 { code:0x1E8A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E8A
  ,simpleLowerCaseMapping:0x1E8B
  ,simpleTitleCaseMapping:0x1E8A
 },
 { code:0x1E8B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E8A
  ,simpleLowerCaseMapping:0x1E8B
  ,simpleTitleCaseMapping:0x1E8A
 },
 { code:0x1E8C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E8C
  ,simpleLowerCaseMapping:0x1E8D
  ,simpleTitleCaseMapping:0x1E8C
 },
 { code:0x1E8D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E8C
  ,simpleLowerCaseMapping:0x1E8D
  ,simpleTitleCaseMapping:0x1E8C
 },
 { code:0x1E8E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E8E
  ,simpleLowerCaseMapping:0x1E8F
  ,simpleTitleCaseMapping:0x1E8E
 },
 { code:0x1E8F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E8E
  ,simpleLowerCaseMapping:0x1E8F
  ,simpleTitleCaseMapping:0x1E8E
 },
 { code:0x1E90
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E90
  ,simpleLowerCaseMapping:0x1E91
  ,simpleTitleCaseMapping:0x1E90
 },
 { code:0x1E91
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E90
  ,simpleLowerCaseMapping:0x1E91
  ,simpleTitleCaseMapping:0x1E90
 },
 { code:0x1E92
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E92
  ,simpleLowerCaseMapping:0x1E93
  ,simpleTitleCaseMapping:0x1E92
 },
 { code:0x1E93
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E92
  ,simpleLowerCaseMapping:0x1E93
  ,simpleTitleCaseMapping:0x1E92
 },
 { code:0x1E94
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1E94
  ,simpleLowerCaseMapping:0x1E95
  ,simpleTitleCaseMapping:0x1E94
 },
 { code:0x1E95
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E94
  ,simpleLowerCaseMapping:0x1E95
  ,simpleTitleCaseMapping:0x1E94
 },
 { code:0x1E96
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1E96
  ,simpleLowerCaseMapping:0x1E96
  ,simpleTitleCaseMapping:0x1E96
 },
 { code:0x1E97
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1E97
  ,simpleLowerCaseMapping:0x1E97
  ,simpleTitleCaseMapping:0x1E97
 },
 { code:0x1E98
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1E98
  ,simpleLowerCaseMapping:0x1E98
  ,simpleTitleCaseMapping:0x1E98
 },
 { code:0x1E99
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1E99
  ,simpleLowerCaseMapping:0x1E99
  ,simpleTitleCaseMapping:0x1E99
 },
 { code:0x1E9A
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1E9A
  ,simpleLowerCaseMapping:0x1E9A
  ,simpleTitleCaseMapping:0x1E9A
 },
 { code:0x1E9B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1E60
  ,simpleLowerCaseMapping:0x1E9B
  ,simpleTitleCaseMapping:0x1E60
 },
 { code:0x1EA0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EA0
  ,simpleLowerCaseMapping:0x1EA1
  ,simpleTitleCaseMapping:0x1EA0
 },
 { code:0x1EA1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EA0
  ,simpleLowerCaseMapping:0x1EA1
  ,simpleTitleCaseMapping:0x1EA0
 },
 { code:0x1EA2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EA2
  ,simpleLowerCaseMapping:0x1EA3
  ,simpleTitleCaseMapping:0x1EA2
 },
 { code:0x1EA3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EA2
  ,simpleLowerCaseMapping:0x1EA3
  ,simpleTitleCaseMapping:0x1EA2
 },
 { code:0x1EA4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EA4
  ,simpleLowerCaseMapping:0x1EA5
  ,simpleTitleCaseMapping:0x1EA4
 },
 { code:0x1EA5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EA4
  ,simpleLowerCaseMapping:0x1EA5
  ,simpleTitleCaseMapping:0x1EA4
 },
 { code:0x1EA6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EA6
  ,simpleLowerCaseMapping:0x1EA7
  ,simpleTitleCaseMapping:0x1EA6
 },
 { code:0x1EA7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EA6
  ,simpleLowerCaseMapping:0x1EA7
  ,simpleTitleCaseMapping:0x1EA6
 },
 { code:0x1EA8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EA8
  ,simpleLowerCaseMapping:0x1EA9
  ,simpleTitleCaseMapping:0x1EA8
 },
 { code:0x1EA9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EA8
  ,simpleLowerCaseMapping:0x1EA9
  ,simpleTitleCaseMapping:0x1EA8
 },
 { code:0x1EAA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EAA
  ,simpleLowerCaseMapping:0x1EAB
  ,simpleTitleCaseMapping:0x1EAA
 },
 { code:0x1EAB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EAA
  ,simpleLowerCaseMapping:0x1EAB
  ,simpleTitleCaseMapping:0x1EAA
 },
 { code:0x1EAC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EAC
  ,simpleLowerCaseMapping:0x1EAD
  ,simpleTitleCaseMapping:0x1EAC
 },
 { code:0x1EAD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EAC
  ,simpleLowerCaseMapping:0x1EAD
  ,simpleTitleCaseMapping:0x1EAC
 },
 { code:0x1EAE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EAE
  ,simpleLowerCaseMapping:0x1EAF
  ,simpleTitleCaseMapping:0x1EAE
 },
 { code:0x1EAF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EAE
  ,simpleLowerCaseMapping:0x1EAF
  ,simpleTitleCaseMapping:0x1EAE
 },
 { code:0x1EB0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EB0
  ,simpleLowerCaseMapping:0x1EB1
  ,simpleTitleCaseMapping:0x1EB0
 },
 { code:0x1EB1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EB0
  ,simpleLowerCaseMapping:0x1EB1
  ,simpleTitleCaseMapping:0x1EB0
 },
 { code:0x1EB2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EB2
  ,simpleLowerCaseMapping:0x1EB3
  ,simpleTitleCaseMapping:0x1EB2
 },
 { code:0x1EB3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EB2
  ,simpleLowerCaseMapping:0x1EB3
  ,simpleTitleCaseMapping:0x1EB2
 },
 { code:0x1EB4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EB4
  ,simpleLowerCaseMapping:0x1EB5
  ,simpleTitleCaseMapping:0x1EB4
 },
 { code:0x1EB5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EB4
  ,simpleLowerCaseMapping:0x1EB5
  ,simpleTitleCaseMapping:0x1EB4
 },
 { code:0x1EB6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EB6
  ,simpleLowerCaseMapping:0x1EB7
  ,simpleTitleCaseMapping:0x1EB6
 },
 { code:0x1EB7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EB6
  ,simpleLowerCaseMapping:0x1EB7
  ,simpleTitleCaseMapping:0x1EB6
 },
 { code:0x1EB8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EB8
  ,simpleLowerCaseMapping:0x1EB9
  ,simpleTitleCaseMapping:0x1EB8
 },
 { code:0x1EB9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EB8
  ,simpleLowerCaseMapping:0x1EB9
  ,simpleTitleCaseMapping:0x1EB8
 },
 { code:0x1EBA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EBA
  ,simpleLowerCaseMapping:0x1EBB
  ,simpleTitleCaseMapping:0x1EBA
 },
 { code:0x1EBB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EBA
  ,simpleLowerCaseMapping:0x1EBB
  ,simpleTitleCaseMapping:0x1EBA
 },
 { code:0x1EBC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EBC
  ,simpleLowerCaseMapping:0x1EBD
  ,simpleTitleCaseMapping:0x1EBC
 },
 { code:0x1EBD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EBC
  ,simpleLowerCaseMapping:0x1EBD
  ,simpleTitleCaseMapping:0x1EBC
 },
 { code:0x1EBE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EBE
  ,simpleLowerCaseMapping:0x1EBF
  ,simpleTitleCaseMapping:0x1EBE
 },
 { code:0x1EBF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EBE
  ,simpleLowerCaseMapping:0x1EBF
  ,simpleTitleCaseMapping:0x1EBE
 },
 { code:0x1EC0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EC0
  ,simpleLowerCaseMapping:0x1EC1
  ,simpleTitleCaseMapping:0x1EC0
 },
 { code:0x1EC1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EC0
  ,simpleLowerCaseMapping:0x1EC1
  ,simpleTitleCaseMapping:0x1EC0
 },
 { code:0x1EC2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EC2
  ,simpleLowerCaseMapping:0x1EC3
  ,simpleTitleCaseMapping:0x1EC2
 },
 { code:0x1EC3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EC2
  ,simpleLowerCaseMapping:0x1EC3
  ,simpleTitleCaseMapping:0x1EC2
 },
 { code:0x1EC4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EC4
  ,simpleLowerCaseMapping:0x1EC5
  ,simpleTitleCaseMapping:0x1EC4
 },
 { code:0x1EC5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EC4
  ,simpleLowerCaseMapping:0x1EC5
  ,simpleTitleCaseMapping:0x1EC4
 },
 { code:0x1EC6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EC6
  ,simpleLowerCaseMapping:0x1EC7
  ,simpleTitleCaseMapping:0x1EC6
 },
 { code:0x1EC7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EC6
  ,simpleLowerCaseMapping:0x1EC7
  ,simpleTitleCaseMapping:0x1EC6
 },
 { code:0x1EC8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EC8
  ,simpleLowerCaseMapping:0x1EC9
  ,simpleTitleCaseMapping:0x1EC8
 },
 { code:0x1EC9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EC8
  ,simpleLowerCaseMapping:0x1EC9
  ,simpleTitleCaseMapping:0x1EC8
 },
 { code:0x1ECA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1ECA
  ,simpleLowerCaseMapping:0x1ECB
  ,simpleTitleCaseMapping:0x1ECA
 },
 { code:0x1ECB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1ECA
  ,simpleLowerCaseMapping:0x1ECB
  ,simpleTitleCaseMapping:0x1ECA
 },
 { code:0x1ECC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1ECC
  ,simpleLowerCaseMapping:0x1ECD
  ,simpleTitleCaseMapping:0x1ECC
 },
 { code:0x1ECD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1ECC
  ,simpleLowerCaseMapping:0x1ECD
  ,simpleTitleCaseMapping:0x1ECC
 },
 { code:0x1ECE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1ECE
  ,simpleLowerCaseMapping:0x1ECF
  ,simpleTitleCaseMapping:0x1ECE
 },
 { code:0x1ECF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1ECE
  ,simpleLowerCaseMapping:0x1ECF
  ,simpleTitleCaseMapping:0x1ECE
 },
 { code:0x1ED0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1ED0
  ,simpleLowerCaseMapping:0x1ED1
  ,simpleTitleCaseMapping:0x1ED0
 },
 { code:0x1ED1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1ED0
  ,simpleLowerCaseMapping:0x1ED1
  ,simpleTitleCaseMapping:0x1ED0
 },
 { code:0x1ED2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1ED2
  ,simpleLowerCaseMapping:0x1ED3
  ,simpleTitleCaseMapping:0x1ED2
 },
 { code:0x1ED3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1ED2
  ,simpleLowerCaseMapping:0x1ED3
  ,simpleTitleCaseMapping:0x1ED2
 },
 { code:0x1ED4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1ED4
  ,simpleLowerCaseMapping:0x1ED5
  ,simpleTitleCaseMapping:0x1ED4
 },
 { code:0x1ED5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1ED4
  ,simpleLowerCaseMapping:0x1ED5
  ,simpleTitleCaseMapping:0x1ED4
 },
 { code:0x1ED6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1ED6
  ,simpleLowerCaseMapping:0x1ED7
  ,simpleTitleCaseMapping:0x1ED6
 },
 { code:0x1ED7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1ED6
  ,simpleLowerCaseMapping:0x1ED7
  ,simpleTitleCaseMapping:0x1ED6
 },
 { code:0x1ED8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1ED8
  ,simpleLowerCaseMapping:0x1ED9
  ,simpleTitleCaseMapping:0x1ED8
 },
 { code:0x1ED9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1ED8
  ,simpleLowerCaseMapping:0x1ED9
  ,simpleTitleCaseMapping:0x1ED8
 },
 { code:0x1EDA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EDA
  ,simpleLowerCaseMapping:0x1EDB
  ,simpleTitleCaseMapping:0x1EDA
 },
 { code:0x1EDB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EDA
  ,simpleLowerCaseMapping:0x1EDB
  ,simpleTitleCaseMapping:0x1EDA
 },
 { code:0x1EDC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EDC
  ,simpleLowerCaseMapping:0x1EDD
  ,simpleTitleCaseMapping:0x1EDC
 },
 { code:0x1EDD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EDC
  ,simpleLowerCaseMapping:0x1EDD
  ,simpleTitleCaseMapping:0x1EDC
 },
 { code:0x1EDE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EDE
  ,simpleLowerCaseMapping:0x1EDF
  ,simpleTitleCaseMapping:0x1EDE
 },
 { code:0x1EDF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EDE
  ,simpleLowerCaseMapping:0x1EDF
  ,simpleTitleCaseMapping:0x1EDE
 },
 { code:0x1EE0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EE0
  ,simpleLowerCaseMapping:0x1EE1
  ,simpleTitleCaseMapping:0x1EE0
 },
 { code:0x1EE1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EE0
  ,simpleLowerCaseMapping:0x1EE1
  ,simpleTitleCaseMapping:0x1EE0
 },
 { code:0x1EE2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EE2
  ,simpleLowerCaseMapping:0x1EE3
  ,simpleTitleCaseMapping:0x1EE2
 },
 { code:0x1EE3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EE2
  ,simpleLowerCaseMapping:0x1EE3
  ,simpleTitleCaseMapping:0x1EE2
 },
 { code:0x1EE4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EE4
  ,simpleLowerCaseMapping:0x1EE5
  ,simpleTitleCaseMapping:0x1EE4
 },
 { code:0x1EE5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EE4
  ,simpleLowerCaseMapping:0x1EE5
  ,simpleTitleCaseMapping:0x1EE4
 },
 { code:0x1EE6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EE6
  ,simpleLowerCaseMapping:0x1EE7
  ,simpleTitleCaseMapping:0x1EE6
 },
 { code:0x1EE7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EE6
  ,simpleLowerCaseMapping:0x1EE7
  ,simpleTitleCaseMapping:0x1EE6
 },
 { code:0x1EE8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EE8
  ,simpleLowerCaseMapping:0x1EE9
  ,simpleTitleCaseMapping:0x1EE8
 },
 { code:0x1EE9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EE8
  ,simpleLowerCaseMapping:0x1EE9
  ,simpleTitleCaseMapping:0x1EE8
 },
 { code:0x1EEA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EEA
  ,simpleLowerCaseMapping:0x1EEB
  ,simpleTitleCaseMapping:0x1EEA
 },
 { code:0x1EEB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EEA
  ,simpleLowerCaseMapping:0x1EEB
  ,simpleTitleCaseMapping:0x1EEA
 },
 { code:0x1EEC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EEC
  ,simpleLowerCaseMapping:0x1EED
  ,simpleTitleCaseMapping:0x1EEC
 },
 { code:0x1EED
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EEC
  ,simpleLowerCaseMapping:0x1EED
  ,simpleTitleCaseMapping:0x1EEC
 },
 { code:0x1EEE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EEE
  ,simpleLowerCaseMapping:0x1EEF
  ,simpleTitleCaseMapping:0x1EEE
 },
 { code:0x1EEF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EEE
  ,simpleLowerCaseMapping:0x1EEF
  ,simpleTitleCaseMapping:0x1EEE
 },
 { code:0x1EF0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EF0
  ,simpleLowerCaseMapping:0x1EF1
  ,simpleTitleCaseMapping:0x1EF0
 },
 { code:0x1EF1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EF0
  ,simpleLowerCaseMapping:0x1EF1
  ,simpleTitleCaseMapping:0x1EF0
 },
 { code:0x1EF2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EF2
  ,simpleLowerCaseMapping:0x1EF3
  ,simpleTitleCaseMapping:0x1EF2
 },
 { code:0x1EF3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EF2
  ,simpleLowerCaseMapping:0x1EF3
  ,simpleTitleCaseMapping:0x1EF2
 },
 { code:0x1EF4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EF4
  ,simpleLowerCaseMapping:0x1EF5
  ,simpleTitleCaseMapping:0x1EF4
 },
 { code:0x1EF5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EF4
  ,simpleLowerCaseMapping:0x1EF5
  ,simpleTitleCaseMapping:0x1EF4
 },
 { code:0x1EF6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EF6
  ,simpleLowerCaseMapping:0x1EF7
  ,simpleTitleCaseMapping:0x1EF6
 },
 { code:0x1EF7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EF6
  ,simpleLowerCaseMapping:0x1EF7
  ,simpleTitleCaseMapping:0x1EF6
 },
 { code:0x1EF8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1EF8
  ,simpleLowerCaseMapping:0x1EF9
  ,simpleTitleCaseMapping:0x1EF8
 },
 { code:0x1EF9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1EF8
  ,simpleLowerCaseMapping:0x1EF9
  ,simpleTitleCaseMapping:0x1EF8
 },
 { code:0x1F00
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F08
  ,simpleLowerCaseMapping:0x1F00
  ,simpleTitleCaseMapping:0x1F08
 },
 { code:0x1F01
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F09
  ,simpleLowerCaseMapping:0x1F01
  ,simpleTitleCaseMapping:0x1F09
 },
 { code:0x1F02
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F0A
  ,simpleLowerCaseMapping:0x1F02
  ,simpleTitleCaseMapping:0x1F0A
 },
 { code:0x1F03
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F0B
  ,simpleLowerCaseMapping:0x1F03
  ,simpleTitleCaseMapping:0x1F0B
 },
 { code:0x1F04
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F0C
  ,simpleLowerCaseMapping:0x1F04
  ,simpleTitleCaseMapping:0x1F0C
 },
 { code:0x1F05
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F0D
  ,simpleLowerCaseMapping:0x1F05
  ,simpleTitleCaseMapping:0x1F0D
 },
 { code:0x1F06
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F0E
  ,simpleLowerCaseMapping:0x1F06
  ,simpleTitleCaseMapping:0x1F0E
 },
 { code:0x1F07
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F0F
  ,simpleLowerCaseMapping:0x1F07
  ,simpleTitleCaseMapping:0x1F0F
 },
 { code:0x1F08
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F08
  ,simpleLowerCaseMapping:0x1F00
  ,simpleTitleCaseMapping:0x1F08
 },
 { code:0x1F09
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F09
  ,simpleLowerCaseMapping:0x1F01
  ,simpleTitleCaseMapping:0x1F09
 },
 { code:0x1F0A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F0A
  ,simpleLowerCaseMapping:0x1F02
  ,simpleTitleCaseMapping:0x1F0A
 },
 { code:0x1F0B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F0B
  ,simpleLowerCaseMapping:0x1F03
  ,simpleTitleCaseMapping:0x1F0B
 },
 { code:0x1F0C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F0C
  ,simpleLowerCaseMapping:0x1F04
  ,simpleTitleCaseMapping:0x1F0C
 },
 { code:0x1F0D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F0D
  ,simpleLowerCaseMapping:0x1F05
  ,simpleTitleCaseMapping:0x1F0D
 },
 { code:0x1F0E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F0E
  ,simpleLowerCaseMapping:0x1F06
  ,simpleTitleCaseMapping:0x1F0E
 },
 { code:0x1F0F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F0F
  ,simpleLowerCaseMapping:0x1F07
  ,simpleTitleCaseMapping:0x1F0F
 },
 { code:0x1F10
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F18
  ,simpleLowerCaseMapping:0x1F10
  ,simpleTitleCaseMapping:0x1F18
 },
 { code:0x1F11
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F19
  ,simpleLowerCaseMapping:0x1F11
  ,simpleTitleCaseMapping:0x1F19
 },
 { code:0x1F12
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F1A
  ,simpleLowerCaseMapping:0x1F12
  ,simpleTitleCaseMapping:0x1F1A
 },
 { code:0x1F13
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F1B
  ,simpleLowerCaseMapping:0x1F13
  ,simpleTitleCaseMapping:0x1F1B
 },
 { code:0x1F14
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F1C
  ,simpleLowerCaseMapping:0x1F14
  ,simpleTitleCaseMapping:0x1F1C
 },
 { code:0x1F15
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F1D
  ,simpleLowerCaseMapping:0x1F15
  ,simpleTitleCaseMapping:0x1F1D
 },
 { code:0x1F18
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F18
  ,simpleLowerCaseMapping:0x1F10
  ,simpleTitleCaseMapping:0x1F18
 },
 { code:0x1F19
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F19
  ,simpleLowerCaseMapping:0x1F11
  ,simpleTitleCaseMapping:0x1F19
 },
 { code:0x1F1A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F1A
  ,simpleLowerCaseMapping:0x1F12
  ,simpleTitleCaseMapping:0x1F1A
 },
 { code:0x1F1B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F1B
  ,simpleLowerCaseMapping:0x1F13
  ,simpleTitleCaseMapping:0x1F1B
 },
 { code:0x1F1C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F1C
  ,simpleLowerCaseMapping:0x1F14
  ,simpleTitleCaseMapping:0x1F1C
 },
 { code:0x1F1D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F1D
  ,simpleLowerCaseMapping:0x1F15
  ,simpleTitleCaseMapping:0x1F1D
 },
 { code:0x1F20
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F28
  ,simpleLowerCaseMapping:0x1F20
  ,simpleTitleCaseMapping:0x1F28
 },
 { code:0x1F21
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F29
  ,simpleLowerCaseMapping:0x1F21
  ,simpleTitleCaseMapping:0x1F29
 },
 { code:0x1F22
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F2A
  ,simpleLowerCaseMapping:0x1F22
  ,simpleTitleCaseMapping:0x1F2A
 },
 { code:0x1F23
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F2B
  ,simpleLowerCaseMapping:0x1F23
  ,simpleTitleCaseMapping:0x1F2B
 },
 { code:0x1F24
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F2C
  ,simpleLowerCaseMapping:0x1F24
  ,simpleTitleCaseMapping:0x1F2C
 },
 { code:0x1F25
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F2D
  ,simpleLowerCaseMapping:0x1F25
  ,simpleTitleCaseMapping:0x1F2D
 },
 { code:0x1F26
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F2E
  ,simpleLowerCaseMapping:0x1F26
  ,simpleTitleCaseMapping:0x1F2E
 },
 { code:0x1F27
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F2F
  ,simpleLowerCaseMapping:0x1F27
  ,simpleTitleCaseMapping:0x1F2F
 },
 { code:0x1F28
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F28
  ,simpleLowerCaseMapping:0x1F20
  ,simpleTitleCaseMapping:0x1F28
 },
 { code:0x1F29
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F29
  ,simpleLowerCaseMapping:0x1F21
  ,simpleTitleCaseMapping:0x1F29
 },
 { code:0x1F2A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F2A
  ,simpleLowerCaseMapping:0x1F22
  ,simpleTitleCaseMapping:0x1F2A
 },
 { code:0x1F2B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F2B
  ,simpleLowerCaseMapping:0x1F23
  ,simpleTitleCaseMapping:0x1F2B
 },
 { code:0x1F2C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F2C
  ,simpleLowerCaseMapping:0x1F24
  ,simpleTitleCaseMapping:0x1F2C
 },
 { code:0x1F2D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F2D
  ,simpleLowerCaseMapping:0x1F25
  ,simpleTitleCaseMapping:0x1F2D
 },
 { code:0x1F2E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F2E
  ,simpleLowerCaseMapping:0x1F26
  ,simpleTitleCaseMapping:0x1F2E
 },
 { code:0x1F2F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F2F
  ,simpleLowerCaseMapping:0x1F27
  ,simpleTitleCaseMapping:0x1F2F
 },
 { code:0x1F30
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F38
  ,simpleLowerCaseMapping:0x1F30
  ,simpleTitleCaseMapping:0x1F38
 },
 { code:0x1F31
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F39
  ,simpleLowerCaseMapping:0x1F31
  ,simpleTitleCaseMapping:0x1F39
 },
 { code:0x1F32
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F3A
  ,simpleLowerCaseMapping:0x1F32
  ,simpleTitleCaseMapping:0x1F3A
 },
 { code:0x1F33
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F3B
  ,simpleLowerCaseMapping:0x1F33
  ,simpleTitleCaseMapping:0x1F3B
 },
 { code:0x1F34
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F3C
  ,simpleLowerCaseMapping:0x1F34
  ,simpleTitleCaseMapping:0x1F3C
 },
 { code:0x1F35
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F3D
  ,simpleLowerCaseMapping:0x1F35
  ,simpleTitleCaseMapping:0x1F3D
 },
 { code:0x1F36
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F3E
  ,simpleLowerCaseMapping:0x1F36
  ,simpleTitleCaseMapping:0x1F3E
 },
 { code:0x1F37
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F3F
  ,simpleLowerCaseMapping:0x1F37
  ,simpleTitleCaseMapping:0x1F3F
 },
 { code:0x1F38
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F38
  ,simpleLowerCaseMapping:0x1F30
  ,simpleTitleCaseMapping:0x1F38
 },
 { code:0x1F39
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F39
  ,simpleLowerCaseMapping:0x1F31
  ,simpleTitleCaseMapping:0x1F39
 },
 { code:0x1F3A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F3A
  ,simpleLowerCaseMapping:0x1F32
  ,simpleTitleCaseMapping:0x1F3A
 },
 { code:0x1F3B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F3B
  ,simpleLowerCaseMapping:0x1F33
  ,simpleTitleCaseMapping:0x1F3B
 },
 { code:0x1F3C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F3C
  ,simpleLowerCaseMapping:0x1F34
  ,simpleTitleCaseMapping:0x1F3C
 },
 { code:0x1F3D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F3D
  ,simpleLowerCaseMapping:0x1F35
  ,simpleTitleCaseMapping:0x1F3D
 },
 { code:0x1F3E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F3E
  ,simpleLowerCaseMapping:0x1F36
  ,simpleTitleCaseMapping:0x1F3E
 },
 { code:0x1F3F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F3F
  ,simpleLowerCaseMapping:0x1F37
  ,simpleTitleCaseMapping:0x1F3F
 },
 { code:0x1F40
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F48
  ,simpleLowerCaseMapping:0x1F40
  ,simpleTitleCaseMapping:0x1F48
 },
 { code:0x1F41
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F49
  ,simpleLowerCaseMapping:0x1F41
  ,simpleTitleCaseMapping:0x1F49
 },
 { code:0x1F42
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F4A
  ,simpleLowerCaseMapping:0x1F42
  ,simpleTitleCaseMapping:0x1F4A
 },
 { code:0x1F43
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F4B
  ,simpleLowerCaseMapping:0x1F43
  ,simpleTitleCaseMapping:0x1F4B
 },
 { code:0x1F44
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F4C
  ,simpleLowerCaseMapping:0x1F44
  ,simpleTitleCaseMapping:0x1F4C
 },
 { code:0x1F45
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F4D
  ,simpleLowerCaseMapping:0x1F45
  ,simpleTitleCaseMapping:0x1F4D
 },
 { code:0x1F48
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F48
  ,simpleLowerCaseMapping:0x1F40
  ,simpleTitleCaseMapping:0x1F48
 },
 { code:0x1F49
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F49
  ,simpleLowerCaseMapping:0x1F41
  ,simpleTitleCaseMapping:0x1F49
 },
 { code:0x1F4A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F4A
  ,simpleLowerCaseMapping:0x1F42
  ,simpleTitleCaseMapping:0x1F4A
 },
 { code:0x1F4B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F4B
  ,simpleLowerCaseMapping:0x1F43
  ,simpleTitleCaseMapping:0x1F4B
 },
 { code:0x1F4C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F4C
  ,simpleLowerCaseMapping:0x1F44
  ,simpleTitleCaseMapping:0x1F4C
 },
 { code:0x1F4D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F4D
  ,simpleLowerCaseMapping:0x1F45
  ,simpleTitleCaseMapping:0x1F4D
 },
 { code:0x1F50
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F50
  ,simpleLowerCaseMapping:0x1F50
  ,simpleTitleCaseMapping:0x1F50
 },
 { code:0x1F51
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F59
  ,simpleLowerCaseMapping:0x1F51
  ,simpleTitleCaseMapping:0x1F59
 },
 { code:0x1F52
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F52
  ,simpleLowerCaseMapping:0x1F52
  ,simpleTitleCaseMapping:0x1F52
 },
 { code:0x1F53
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F5B
  ,simpleLowerCaseMapping:0x1F53
  ,simpleTitleCaseMapping:0x1F5B
 },
 { code:0x1F54
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F54
  ,simpleLowerCaseMapping:0x1F54
  ,simpleTitleCaseMapping:0x1F54
 },
 { code:0x1F55
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F5D
  ,simpleLowerCaseMapping:0x1F55
  ,simpleTitleCaseMapping:0x1F5D
 },
 { code:0x1F56
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F56
  ,simpleLowerCaseMapping:0x1F56
  ,simpleTitleCaseMapping:0x1F56
 },
 { code:0x1F57
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F5F
  ,simpleLowerCaseMapping:0x1F57
  ,simpleTitleCaseMapping:0x1F5F
 },
 { code:0x1F59
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F59
  ,simpleLowerCaseMapping:0x1F51
  ,simpleTitleCaseMapping:0x1F59
 },
 { code:0x1F5B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F5B
  ,simpleLowerCaseMapping:0x1F53
  ,simpleTitleCaseMapping:0x1F5B
 },
 { code:0x1F5D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F5D
  ,simpleLowerCaseMapping:0x1F55
  ,simpleTitleCaseMapping:0x1F5D
 },
 { code:0x1F5F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F5F
  ,simpleLowerCaseMapping:0x1F57
  ,simpleTitleCaseMapping:0x1F5F
 },
 { code:0x1F60
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F68
  ,simpleLowerCaseMapping:0x1F60
  ,simpleTitleCaseMapping:0x1F68
 },
 { code:0x1F61
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F69
  ,simpleLowerCaseMapping:0x1F61
  ,simpleTitleCaseMapping:0x1F69
 },
 { code:0x1F62
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F6A
  ,simpleLowerCaseMapping:0x1F62
  ,simpleTitleCaseMapping:0x1F6A
 },
 { code:0x1F63
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F6B
  ,simpleLowerCaseMapping:0x1F63
  ,simpleTitleCaseMapping:0x1F6B
 },
 { code:0x1F64
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F6C
  ,simpleLowerCaseMapping:0x1F64
  ,simpleTitleCaseMapping:0x1F6C
 },
 { code:0x1F65
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F6D
  ,simpleLowerCaseMapping:0x1F65
  ,simpleTitleCaseMapping:0x1F6D
 },
 { code:0x1F66
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F6E
  ,simpleLowerCaseMapping:0x1F66
  ,simpleTitleCaseMapping:0x1F6E
 },
 { code:0x1F67
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1F6F
  ,simpleLowerCaseMapping:0x1F67
  ,simpleTitleCaseMapping:0x1F6F
 },
 { code:0x1F68
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F68
  ,simpleLowerCaseMapping:0x1F60
  ,simpleTitleCaseMapping:0x1F68
 },
 { code:0x1F69
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F69
  ,simpleLowerCaseMapping:0x1F61
  ,simpleTitleCaseMapping:0x1F69
 },
 { code:0x1F6A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F6A
  ,simpleLowerCaseMapping:0x1F62
  ,simpleTitleCaseMapping:0x1F6A
 },
 { code:0x1F6B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F6B
  ,simpleLowerCaseMapping:0x1F63
  ,simpleTitleCaseMapping:0x1F6B
 },
 { code:0x1F6C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F6C
  ,simpleLowerCaseMapping:0x1F64
  ,simpleTitleCaseMapping:0x1F6C
 },
 { code:0x1F6D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F6D
  ,simpleLowerCaseMapping:0x1F65
  ,simpleTitleCaseMapping:0x1F6D
 },
 { code:0x1F6E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F6E
  ,simpleLowerCaseMapping:0x1F66
  ,simpleTitleCaseMapping:0x1F6E
 },
 { code:0x1F6F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1F6F
  ,simpleLowerCaseMapping:0x1F67
  ,simpleTitleCaseMapping:0x1F6F
 },
 { code:0x1F70
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FBA
  ,simpleLowerCaseMapping:0x1F70
  ,simpleTitleCaseMapping:0x1FBA
 },
 { code:0x1F71
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FBB
  ,simpleLowerCaseMapping:0x1F71
  ,simpleTitleCaseMapping:0x1FBB
 },
 { code:0x1F72
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FC8
  ,simpleLowerCaseMapping:0x1F72
  ,simpleTitleCaseMapping:0x1FC8
 },
 { code:0x1F73
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FC9
  ,simpleLowerCaseMapping:0x1F73
  ,simpleTitleCaseMapping:0x1FC9
 },
 { code:0x1F74
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FCA
  ,simpleLowerCaseMapping:0x1F74
  ,simpleTitleCaseMapping:0x1FCA
 },
 { code:0x1F75
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FCB
  ,simpleLowerCaseMapping:0x1F75
  ,simpleTitleCaseMapping:0x1FCB
 },
 { code:0x1F76
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FDA
  ,simpleLowerCaseMapping:0x1F76
  ,simpleTitleCaseMapping:0x1FDA
 },
 { code:0x1F77
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FDB
  ,simpleLowerCaseMapping:0x1F77
  ,simpleTitleCaseMapping:0x1FDB
 },
 { code:0x1F78
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FF8
  ,simpleLowerCaseMapping:0x1F78
  ,simpleTitleCaseMapping:0x1FF8
 },
 { code:0x1F79
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FF9
  ,simpleLowerCaseMapping:0x1F79
  ,simpleTitleCaseMapping:0x1FF9
 },
 { code:0x1F7A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FEA
  ,simpleLowerCaseMapping:0x1F7A
  ,simpleTitleCaseMapping:0x1FEA
 },
 { code:0x1F7B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FEB
  ,simpleLowerCaseMapping:0x1F7B
  ,simpleTitleCaseMapping:0x1FEB
 },
 { code:0x1F7C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FFA
  ,simpleLowerCaseMapping:0x1F7C
  ,simpleTitleCaseMapping:0x1FFA
 },
 { code:0x1F7D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FFB
  ,simpleLowerCaseMapping:0x1F7D
  ,simpleTitleCaseMapping:0x1FFB
 },
 { code:0x1F80
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F88
  ,simpleLowerCaseMapping:0x1F80
  ,simpleTitleCaseMapping:0x1F88
 },
 { code:0x1F81
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F89
  ,simpleLowerCaseMapping:0x1F81
  ,simpleTitleCaseMapping:0x1F89
 },
 { code:0x1F82
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F8A
  ,simpleLowerCaseMapping:0x1F82
  ,simpleTitleCaseMapping:0x1F8A
 },
 { code:0x1F83
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F8B
  ,simpleLowerCaseMapping:0x1F83
  ,simpleTitleCaseMapping:0x1F8B
 },
 { code:0x1F84
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F8C
  ,simpleLowerCaseMapping:0x1F84
  ,simpleTitleCaseMapping:0x1F8C
 },
 { code:0x1F85
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F8D
  ,simpleLowerCaseMapping:0x1F85
  ,simpleTitleCaseMapping:0x1F8D
 },
 { code:0x1F86
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F8E
  ,simpleLowerCaseMapping:0x1F86
  ,simpleTitleCaseMapping:0x1F8E
 },
 { code:0x1F87
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F8F
  ,simpleLowerCaseMapping:0x1F87
  ,simpleTitleCaseMapping:0x1F8F
 },
 { code:0x1F88
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F88
  ,simpleLowerCaseMapping:0x1F80
  ,simpleTitleCaseMapping:0x1F88
 },
 { code:0x1F89
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F89
  ,simpleLowerCaseMapping:0x1F81
  ,simpleTitleCaseMapping:0x1F89
 },
 { code:0x1F8A
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F8A
  ,simpleLowerCaseMapping:0x1F82
  ,simpleTitleCaseMapping:0x1F8A
 },
 { code:0x1F8B
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F8B
  ,simpleLowerCaseMapping:0x1F83
  ,simpleTitleCaseMapping:0x1F8B
 },
 { code:0x1F8C
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F8C
  ,simpleLowerCaseMapping:0x1F84
  ,simpleTitleCaseMapping:0x1F8C
 },
 { code:0x1F8D
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F8D
  ,simpleLowerCaseMapping:0x1F85
  ,simpleTitleCaseMapping:0x1F8D
 },
 { code:0x1F8E
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F8E
  ,simpleLowerCaseMapping:0x1F86
  ,simpleTitleCaseMapping:0x1F8E
 },
 { code:0x1F8F
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F8F
  ,simpleLowerCaseMapping:0x1F87
  ,simpleTitleCaseMapping:0x1F8F
 },
 { code:0x1F90
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F98
  ,simpleLowerCaseMapping:0x1F90
  ,simpleTitleCaseMapping:0x1F98
 },
 { code:0x1F91
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F99
  ,simpleLowerCaseMapping:0x1F91
  ,simpleTitleCaseMapping:0x1F99
 },
 { code:0x1F92
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F9A
  ,simpleLowerCaseMapping:0x1F92
  ,simpleTitleCaseMapping:0x1F9A
 },
 { code:0x1F93
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F9B
  ,simpleLowerCaseMapping:0x1F93
  ,simpleTitleCaseMapping:0x1F9B
 },
 { code:0x1F94
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F9C
  ,simpleLowerCaseMapping:0x1F94
  ,simpleTitleCaseMapping:0x1F9C
 },
 { code:0x1F95
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F9D
  ,simpleLowerCaseMapping:0x1F95
  ,simpleTitleCaseMapping:0x1F9D
 },
 { code:0x1F96
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F9E
  ,simpleLowerCaseMapping:0x1F96
  ,simpleTitleCaseMapping:0x1F9E
 },
 { code:0x1F97
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F9F
  ,simpleLowerCaseMapping:0x1F97
  ,simpleTitleCaseMapping:0x1F9F
 },
 { code:0x1F98
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F98
  ,simpleLowerCaseMapping:0x1F90
  ,simpleTitleCaseMapping:0x1F98
 },
 { code:0x1F99
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F99
  ,simpleLowerCaseMapping:0x1F91
  ,simpleTitleCaseMapping:0x1F99
 },
 { code:0x1F9A
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F9A
  ,simpleLowerCaseMapping:0x1F92
  ,simpleTitleCaseMapping:0x1F9A
 },
 { code:0x1F9B
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F9B
  ,simpleLowerCaseMapping:0x1F93
  ,simpleTitleCaseMapping:0x1F9B
 },
 { code:0x1F9C
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F9C
  ,simpleLowerCaseMapping:0x1F94
  ,simpleTitleCaseMapping:0x1F9C
 },
 { code:0x1F9D
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F9D
  ,simpleLowerCaseMapping:0x1F95
  ,simpleTitleCaseMapping:0x1F9D
 },
 { code:0x1F9E
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F9E
  ,simpleLowerCaseMapping:0x1F96
  ,simpleTitleCaseMapping:0x1F9E
 },
 { code:0x1F9F
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1F9F
  ,simpleLowerCaseMapping:0x1F97
  ,simpleTitleCaseMapping:0x1F9F
 },
 { code:0x1FA0
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FA8
  ,simpleLowerCaseMapping:0x1FA0
  ,simpleTitleCaseMapping:0x1FA8
 },
 { code:0x1FA1
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FA9
  ,simpleLowerCaseMapping:0x1FA1
  ,simpleTitleCaseMapping:0x1FA9
 },
 { code:0x1FA2
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FAA
  ,simpleLowerCaseMapping:0x1FA2
  ,simpleTitleCaseMapping:0x1FAA
 },
 { code:0x1FA3
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FAB
  ,simpleLowerCaseMapping:0x1FA3
  ,simpleTitleCaseMapping:0x1FAB
 },
 { code:0x1FA4
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FAC
  ,simpleLowerCaseMapping:0x1FA4
  ,simpleTitleCaseMapping:0x1FAC
 },
 { code:0x1FA5
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FAD
  ,simpleLowerCaseMapping:0x1FA5
  ,simpleTitleCaseMapping:0x1FAD
 },
 { code:0x1FA6
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FAE
  ,simpleLowerCaseMapping:0x1FA6
  ,simpleTitleCaseMapping:0x1FAE
 },
 { code:0x1FA7
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FAF
  ,simpleLowerCaseMapping:0x1FA7
  ,simpleTitleCaseMapping:0x1FAF
 },
 { code:0x1FA8
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FA8
  ,simpleLowerCaseMapping:0x1FA0
  ,simpleTitleCaseMapping:0x1FA8
 },
 { code:0x1FA9
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FA9
  ,simpleLowerCaseMapping:0x1FA1
  ,simpleTitleCaseMapping:0x1FA9
 },
 { code:0x1FAA
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FAA
  ,simpleLowerCaseMapping:0x1FA2
  ,simpleTitleCaseMapping:0x1FAA
 },
 { code:0x1FAB
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FAB
  ,simpleLowerCaseMapping:0x1FA3
  ,simpleTitleCaseMapping:0x1FAB
 },
 { code:0x1FAC
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FAC
  ,simpleLowerCaseMapping:0x1FA4
  ,simpleTitleCaseMapping:0x1FAC
 },
 { code:0x1FAD
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FAD
  ,simpleLowerCaseMapping:0x1FA5
  ,simpleTitleCaseMapping:0x1FAD
 },
 { code:0x1FAE
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FAE
  ,simpleLowerCaseMapping:0x1FA6
  ,simpleTitleCaseMapping:0x1FAE
 },
 { code:0x1FAF
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FAF
  ,simpleLowerCaseMapping:0x1FA7
  ,simpleTitleCaseMapping:0x1FAF
 },
 { code:0x1FB0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FB8
  ,simpleLowerCaseMapping:0x1FB0
  ,simpleTitleCaseMapping:0x1FB8
 },
 { code:0x1FB1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FB9
  ,simpleLowerCaseMapping:0x1FB1
  ,simpleTitleCaseMapping:0x1FB9
 },
 { code:0x1FB2
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FB2
  ,simpleLowerCaseMapping:0x1FB2
  ,simpleTitleCaseMapping:0x1FB2
 },
 { code:0x1FB3
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FBC
  ,simpleLowerCaseMapping:0x1FB3
  ,simpleTitleCaseMapping:0x1FBC
 },
 { code:0x1FB4
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FB4
  ,simpleLowerCaseMapping:0x1FB4
  ,simpleTitleCaseMapping:0x1FB4
 },
 { code:0x1FB6
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FB6
  ,simpleLowerCaseMapping:0x1FB6
  ,simpleTitleCaseMapping:0x1FB6
 },
 { code:0x1FB7
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FB7
  ,simpleLowerCaseMapping:0x1FB7
  ,simpleTitleCaseMapping:0x1FB7
 },
 { code:0x1FB8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FB8
  ,simpleLowerCaseMapping:0x1FB0
  ,simpleTitleCaseMapping:0x1FB8
 },
 { code:0x1FB9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FB9
  ,simpleLowerCaseMapping:0x1FB1
  ,simpleTitleCaseMapping:0x1FB9
 },
 { code:0x1FBA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FBA
  ,simpleLowerCaseMapping:0x1F70
  ,simpleTitleCaseMapping:0x1FBA
 },
 { code:0x1FBB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FBB
  ,simpleLowerCaseMapping:0x1F71
  ,simpleTitleCaseMapping:0x1FBB
 },
 { code:0x1FBC
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FBC
  ,simpleLowerCaseMapping:0x1FB3
  ,simpleTitleCaseMapping:0x1FBC
 },
 { code:0x1FBD
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x1FBD
  ,simpleLowerCaseMapping:0x1FBD
  ,simpleTitleCaseMapping:0x1FBD
 },
 { code:0x1FBE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x0399
  ,simpleLowerCaseMapping:0x1FBE
  ,simpleTitleCaseMapping:0x0399
 },
 { code:0x1FBF
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x1FBF
  ,simpleLowerCaseMapping:0x1FBF
  ,simpleTitleCaseMapping:0x1FBF
 },
 { code:0x1FC0
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x1FC0
  ,simpleLowerCaseMapping:0x1FC0
  ,simpleTitleCaseMapping:0x1FC0
 },
 { code:0x1FC1
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x1FC1
  ,simpleLowerCaseMapping:0x1FC1
  ,simpleTitleCaseMapping:0x1FC1
 },
 { code:0x1FC2
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FC2
  ,simpleLowerCaseMapping:0x1FC2
  ,simpleTitleCaseMapping:0x1FC2
 },
 { code:0x1FC3
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FCC
  ,simpleLowerCaseMapping:0x1FC3
  ,simpleTitleCaseMapping:0x1FCC
 },
 { code:0x1FC4
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FC4
  ,simpleLowerCaseMapping:0x1FC4
  ,simpleTitleCaseMapping:0x1FC4
 },
 { code:0x1FC6
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FC6
  ,simpleLowerCaseMapping:0x1FC6
  ,simpleTitleCaseMapping:0x1FC6
 },
 { code:0x1FC7
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FC7
  ,simpleLowerCaseMapping:0x1FC7
  ,simpleTitleCaseMapping:0x1FC7
 },
 { code:0x1FC8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FC8
  ,simpleLowerCaseMapping:0x1F72
  ,simpleTitleCaseMapping:0x1FC8
 },
 { code:0x1FC9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FC9
  ,simpleLowerCaseMapping:0x1F73
  ,simpleTitleCaseMapping:0x1FC9
 },
 { code:0x1FCA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FCA
  ,simpleLowerCaseMapping:0x1F74
  ,simpleTitleCaseMapping:0x1FCA
 },
 { code:0x1FCB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FCB
  ,simpleLowerCaseMapping:0x1F75
  ,simpleTitleCaseMapping:0x1FCB
 },
 { code:0x1FCC
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FCC
  ,simpleLowerCaseMapping:0x1FC3
  ,simpleTitleCaseMapping:0x1FCC
 },
 { code:0x1FCD
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x1FCD
  ,simpleLowerCaseMapping:0x1FCD
  ,simpleTitleCaseMapping:0x1FCD
 },
 { code:0x1FCE
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x1FCE
  ,simpleLowerCaseMapping:0x1FCE
  ,simpleTitleCaseMapping:0x1FCE
 },
 { code:0x1FCF
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x1FCF
  ,simpleLowerCaseMapping:0x1FCF
  ,simpleTitleCaseMapping:0x1FCF
 },
 { code:0x1FD0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FD8
  ,simpleLowerCaseMapping:0x1FD0
  ,simpleTitleCaseMapping:0x1FD8
 },
 { code:0x1FD1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FD9
  ,simpleLowerCaseMapping:0x1FD1
  ,simpleTitleCaseMapping:0x1FD9
 },
 { code:0x1FD2
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FD2
  ,simpleLowerCaseMapping:0x1FD2
  ,simpleTitleCaseMapping:0x1FD2
 },
 { code:0x1FD3
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FD3
  ,simpleLowerCaseMapping:0x1FD3
  ,simpleTitleCaseMapping:0x1FD3
 },
 { code:0x1FD6
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FD6
  ,simpleLowerCaseMapping:0x1FD6
  ,simpleTitleCaseMapping:0x1FD6
 },
 { code:0x1FD7
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FD7
  ,simpleLowerCaseMapping:0x1FD7
  ,simpleTitleCaseMapping:0x1FD7
 },
 { code:0x1FD8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FD8
  ,simpleLowerCaseMapping:0x1FD0
  ,simpleTitleCaseMapping:0x1FD8
 },
 { code:0x1FD9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FD9
  ,simpleLowerCaseMapping:0x1FD1
  ,simpleTitleCaseMapping:0x1FD9
 },
 { code:0x1FDA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FDA
  ,simpleLowerCaseMapping:0x1F76
  ,simpleTitleCaseMapping:0x1FDA
 },
 { code:0x1FDB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FDB
  ,simpleLowerCaseMapping:0x1F77
  ,simpleTitleCaseMapping:0x1FDB
 },
 { code:0x1FDD
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x1FDD
  ,simpleLowerCaseMapping:0x1FDD
  ,simpleTitleCaseMapping:0x1FDD
 },
 { code:0x1FDE
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x1FDE
  ,simpleLowerCaseMapping:0x1FDE
  ,simpleTitleCaseMapping:0x1FDE
 },
 { code:0x1FDF
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x1FDF
  ,simpleLowerCaseMapping:0x1FDF
  ,simpleTitleCaseMapping:0x1FDF
 },
 { code:0x1FE0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FE8
  ,simpleLowerCaseMapping:0x1FE0
  ,simpleTitleCaseMapping:0x1FE8
 },
 { code:0x1FE1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FE9
  ,simpleLowerCaseMapping:0x1FE1
  ,simpleTitleCaseMapping:0x1FE9
 },
 { code:0x1FE2
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FE2
  ,simpleLowerCaseMapping:0x1FE2
  ,simpleTitleCaseMapping:0x1FE2
 },
 { code:0x1FE3
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FE3
  ,simpleLowerCaseMapping:0x1FE3
  ,simpleTitleCaseMapping:0x1FE3
 },
 { code:0x1FE4
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FE4
  ,simpleLowerCaseMapping:0x1FE4
  ,simpleTitleCaseMapping:0x1FE4
 },
 { code:0x1FE5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1FEC
  ,simpleLowerCaseMapping:0x1FE5
  ,simpleTitleCaseMapping:0x1FEC
 },
 { code:0x1FE6
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FE6
  ,simpleLowerCaseMapping:0x1FE6
  ,simpleTitleCaseMapping:0x1FE6
 },
 { code:0x1FE7
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FE7
  ,simpleLowerCaseMapping:0x1FE7
  ,simpleTitleCaseMapping:0x1FE7
 },
 { code:0x1FE8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FE8
  ,simpleLowerCaseMapping:0x1FE0
  ,simpleTitleCaseMapping:0x1FE8
 },
 { code:0x1FE9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FE9
  ,simpleLowerCaseMapping:0x1FE1
  ,simpleTitleCaseMapping:0x1FE9
 },
 { code:0x1FEA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FEA
  ,simpleLowerCaseMapping:0x1F7A
  ,simpleTitleCaseMapping:0x1FEA
 },
 { code:0x1FEB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FEB
  ,simpleLowerCaseMapping:0x1F7B
  ,simpleTitleCaseMapping:0x1FEB
 },
 { code:0x1FEC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FEC
  ,simpleLowerCaseMapping:0x1FE5
  ,simpleTitleCaseMapping:0x1FEC
 },
 { code:0x1FED
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x1FED
  ,simpleLowerCaseMapping:0x1FED
  ,simpleTitleCaseMapping:0x1FED
 },
 { code:0x1FEE
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x1FEE
  ,simpleLowerCaseMapping:0x1FEE
  ,simpleTitleCaseMapping:0x1FEE
 },
 { code:0x1FEF
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x1FEF
  ,simpleLowerCaseMapping:0x1FEF
  ,simpleTitleCaseMapping:0x1FEF
 },
 { code:0x1FF2
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FF2
  ,simpleLowerCaseMapping:0x1FF2
  ,simpleTitleCaseMapping:0x1FF2
 },
 { code:0x1FF3
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FFC
  ,simpleLowerCaseMapping:0x1FF3
  ,simpleTitleCaseMapping:0x1FFC
 },
 { code:0x1FF4
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FF4
  ,simpleLowerCaseMapping:0x1FF4
  ,simpleTitleCaseMapping:0x1FF4
 },
 { code:0x1FF6
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FF6
  ,simpleLowerCaseMapping:0x1FF6
  ,simpleTitleCaseMapping:0x1FF6
 },
 { code:0x1FF7
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FF7
  ,simpleLowerCaseMapping:0x1FF7
  ,simpleTitleCaseMapping:0x1FF7
 },
 { code:0x1FF8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FF8
  ,simpleLowerCaseMapping:0x1F78
  ,simpleTitleCaseMapping:0x1FF8
 },
 { code:0x1FF9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FF9
  ,simpleLowerCaseMapping:0x1F79
  ,simpleTitleCaseMapping:0x1FF9
 },
 { code:0x1FFA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FFA
  ,simpleLowerCaseMapping:0x1F7C
  ,simpleTitleCaseMapping:0x1FFA
 },
 { code:0x1FFB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1FFB
  ,simpleLowerCaseMapping:0x1F7D
  ,simpleTitleCaseMapping:0x1FFB
 },
 { code:0x1FFC
  ,generalCategory:UnicodeData.GeneralCategory.Lt | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0x1FFC
  ,simpleLowerCaseMapping:0x1FF3
  ,simpleTitleCaseMapping:0x1FFC
 },
 { code:0x1FFD
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x1FFD
  ,simpleLowerCaseMapping:0x1FFD
  ,simpleTitleCaseMapping:0x1FFD
 },
 { code:0x1FFE
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x1FFE
  ,simpleLowerCaseMapping:0x1FFE
  ,simpleTitleCaseMapping:0x1FFE
 },
 { code:0x2000
  ,generalCategory:UnicodeData.GeneralCategory.Zs
  ,simpleUpperCaseMapping:0x2000
  ,simpleLowerCaseMapping:0x2000
  ,simpleTitleCaseMapping:0x2000
 },
 { code:0x2001
  ,generalCategory:UnicodeData.GeneralCategory.Zs
  ,simpleUpperCaseMapping:0x2001
  ,simpleLowerCaseMapping:0x2001
  ,simpleTitleCaseMapping:0x2001
 },
 { code:0x2002
  ,generalCategory:UnicodeData.GeneralCategory.Zs
  ,simpleUpperCaseMapping:0x2002
  ,simpleLowerCaseMapping:0x2002
  ,simpleTitleCaseMapping:0x2002
 },
 { code:0x2003
  ,generalCategory:UnicodeData.GeneralCategory.Zs
  ,simpleUpperCaseMapping:0x2003
  ,simpleLowerCaseMapping:0x2003
  ,simpleTitleCaseMapping:0x2003
 },
 { code:0x2004
  ,generalCategory:UnicodeData.GeneralCategory.Zs
  ,simpleUpperCaseMapping:0x2004
  ,simpleLowerCaseMapping:0x2004
  ,simpleTitleCaseMapping:0x2004
 },
 { code:0x2005
  ,generalCategory:UnicodeData.GeneralCategory.Zs
  ,simpleUpperCaseMapping:0x2005
  ,simpleLowerCaseMapping:0x2005
  ,simpleTitleCaseMapping:0x2005
 },
 { code:0x2006
  ,generalCategory:UnicodeData.GeneralCategory.Zs
  ,simpleUpperCaseMapping:0x2006
  ,simpleLowerCaseMapping:0x2006
  ,simpleTitleCaseMapping:0x2006
 },
 { code:0x2007
  ,generalCategory:UnicodeData.GeneralCategory.Zs
  ,simpleUpperCaseMapping:0x2007
  ,simpleLowerCaseMapping:0x2007
  ,simpleTitleCaseMapping:0x2007
 },
 { code:0x2008
  ,generalCategory:UnicodeData.GeneralCategory.Zs
  ,simpleUpperCaseMapping:0x2008
  ,simpleLowerCaseMapping:0x2008
  ,simpleTitleCaseMapping:0x2008
 },
 { code:0x2009
  ,generalCategory:UnicodeData.GeneralCategory.Zs
  ,simpleUpperCaseMapping:0x2009
  ,simpleLowerCaseMapping:0x2009
  ,simpleTitleCaseMapping:0x2009
 },
 { code:0x200A
  ,generalCategory:UnicodeData.GeneralCategory.Zs
  ,simpleUpperCaseMapping:0x200A
  ,simpleLowerCaseMapping:0x200A
  ,simpleTitleCaseMapping:0x200A
 },
 { code:0x200B
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x200B
  ,simpleLowerCaseMapping:0x200B
  ,simpleTitleCaseMapping:0x200B
 },
 { code:0x200C
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x200C
  ,simpleLowerCaseMapping:0x200C
  ,simpleTitleCaseMapping:0x200C
 },
 { code:0x200D
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x200D
  ,simpleLowerCaseMapping:0x200D
  ,simpleTitleCaseMapping:0x200D
 },
 { code:0x200E
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x200E
  ,simpleLowerCaseMapping:0x200E
  ,simpleTitleCaseMapping:0x200E
 },
 { code:0x200F
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x200F
  ,simpleLowerCaseMapping:0x200F
  ,simpleTitleCaseMapping:0x200F
 },
 { code:0x2010
  ,generalCategory:UnicodeData.GeneralCategory.Pd
  ,simpleUpperCaseMapping:0x2010
  ,simpleLowerCaseMapping:0x2010
  ,simpleTitleCaseMapping:0x2010
 },
 { code:0x2011
  ,generalCategory:UnicodeData.GeneralCategory.Pd
  ,simpleUpperCaseMapping:0x2011
  ,simpleLowerCaseMapping:0x2011
  ,simpleTitleCaseMapping:0x2011
 },
 { code:0x2012
  ,generalCategory:UnicodeData.GeneralCategory.Pd
  ,simpleUpperCaseMapping:0x2012
  ,simpleLowerCaseMapping:0x2012
  ,simpleTitleCaseMapping:0x2012
 },
 { code:0x2013
  ,generalCategory:UnicodeData.GeneralCategory.Pd
  ,simpleUpperCaseMapping:0x2013
  ,simpleLowerCaseMapping:0x2013
  ,simpleTitleCaseMapping:0x2013
 },
 { code:0x2014
  ,generalCategory:UnicodeData.GeneralCategory.Pd
  ,simpleUpperCaseMapping:0x2014
  ,simpleLowerCaseMapping:0x2014
  ,simpleTitleCaseMapping:0x2014
 },
 { code:0x2015
  ,generalCategory:UnicodeData.GeneralCategory.Pd
  ,simpleUpperCaseMapping:0x2015
  ,simpleLowerCaseMapping:0x2015
  ,simpleTitleCaseMapping:0x2015
 },
 { code:0x2016
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2016
  ,simpleLowerCaseMapping:0x2016
  ,simpleTitleCaseMapping:0x2016
 },
 { code:0x2017
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2017
  ,simpleLowerCaseMapping:0x2017
  ,simpleTitleCaseMapping:0x2017
 },
 { code:0x2018
  ,generalCategory:UnicodeData.GeneralCategory.Pi
  ,simpleUpperCaseMapping:0x2018
  ,simpleLowerCaseMapping:0x2018
  ,simpleTitleCaseMapping:0x2018
 },
 { code:0x2019
  ,generalCategory:UnicodeData.GeneralCategory.Pf
  ,simpleUpperCaseMapping:0x2019
  ,simpleLowerCaseMapping:0x2019
  ,simpleTitleCaseMapping:0x2019
 },
 { code:0x201A
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x201A
  ,simpleLowerCaseMapping:0x201A
  ,simpleTitleCaseMapping:0x201A
 },
 { code:0x201B
  ,generalCategory:UnicodeData.GeneralCategory.Pi
  ,simpleUpperCaseMapping:0x201B
  ,simpleLowerCaseMapping:0x201B
  ,simpleTitleCaseMapping:0x201B
 },
 { code:0x201C
  ,generalCategory:UnicodeData.GeneralCategory.Pi
  ,simpleUpperCaseMapping:0x201C
  ,simpleLowerCaseMapping:0x201C
  ,simpleTitleCaseMapping:0x201C
 },
 { code:0x201D
  ,generalCategory:UnicodeData.GeneralCategory.Pf
  ,simpleUpperCaseMapping:0x201D
  ,simpleLowerCaseMapping:0x201D
  ,simpleTitleCaseMapping:0x201D
 },
 { code:0x201E
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x201E
  ,simpleLowerCaseMapping:0x201E
  ,simpleTitleCaseMapping:0x201E
 },
 { code:0x201F
  ,generalCategory:UnicodeData.GeneralCategory.Pi
  ,simpleUpperCaseMapping:0x201F
  ,simpleLowerCaseMapping:0x201F
  ,simpleTitleCaseMapping:0x201F
 },
 { code:0x2020
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2020
  ,simpleLowerCaseMapping:0x2020
  ,simpleTitleCaseMapping:0x2020
 },
 { code:0x2021
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2021
  ,simpleLowerCaseMapping:0x2021
  ,simpleTitleCaseMapping:0x2021
 },
 { code:0x2022
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2022
  ,simpleLowerCaseMapping:0x2022
  ,simpleTitleCaseMapping:0x2022
 },
 { code:0x2023
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2023
  ,simpleLowerCaseMapping:0x2023
  ,simpleTitleCaseMapping:0x2023
 },
 { code:0x2024
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2024
  ,simpleLowerCaseMapping:0x2024
  ,simpleTitleCaseMapping:0x2024
 },
 { code:0x2025
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2025
  ,simpleLowerCaseMapping:0x2025
  ,simpleTitleCaseMapping:0x2025
 },
 { code:0x2026
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2026
  ,simpleLowerCaseMapping:0x2026
  ,simpleTitleCaseMapping:0x2026
 },
 { code:0x2027
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2027
  ,simpleLowerCaseMapping:0x2027
  ,simpleTitleCaseMapping:0x2027
 },
 { code:0x2028
  ,generalCategory:UnicodeData.GeneralCategory.Zl
  ,simpleUpperCaseMapping:0x2028
  ,simpleLowerCaseMapping:0x2028
  ,simpleTitleCaseMapping:0x2028
 },
 { code:0x2029
  ,generalCategory:UnicodeData.GeneralCategory.Zp
  ,simpleUpperCaseMapping:0x2029
  ,simpleLowerCaseMapping:0x2029
  ,simpleTitleCaseMapping:0x2029
 },
 { code:0x202A
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x202A
  ,simpleLowerCaseMapping:0x202A
  ,simpleTitleCaseMapping:0x202A
 },
 { code:0x202B
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x202B
  ,simpleLowerCaseMapping:0x202B
  ,simpleTitleCaseMapping:0x202B
 },
 { code:0x202C
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x202C
  ,simpleLowerCaseMapping:0x202C
  ,simpleTitleCaseMapping:0x202C
 },
 { code:0x202D
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x202D
  ,simpleLowerCaseMapping:0x202D
  ,simpleTitleCaseMapping:0x202D
 },
 { code:0x202E
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x202E
  ,simpleLowerCaseMapping:0x202E
  ,simpleTitleCaseMapping:0x202E
 },
 { code:0x202F
  ,generalCategory:UnicodeData.GeneralCategory.Zs
  ,simpleUpperCaseMapping:0x202F
  ,simpleLowerCaseMapping:0x202F
  ,simpleTitleCaseMapping:0x202F
 },
 { code:0x2030
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2030
  ,simpleLowerCaseMapping:0x2030
  ,simpleTitleCaseMapping:0x2030
 },
 { code:0x2031
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2031
  ,simpleLowerCaseMapping:0x2031
  ,simpleTitleCaseMapping:0x2031
 },
 { code:0x2032
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2032
  ,simpleLowerCaseMapping:0x2032
  ,simpleTitleCaseMapping:0x2032
 },
 { code:0x2033
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2033
  ,simpleLowerCaseMapping:0x2033
  ,simpleTitleCaseMapping:0x2033
 },
 { code:0x2034
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2034
  ,simpleLowerCaseMapping:0x2034
  ,simpleTitleCaseMapping:0x2034
 },
 { code:0x2035
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2035
  ,simpleLowerCaseMapping:0x2035
  ,simpleTitleCaseMapping:0x2035
 },
 { code:0x2036
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2036
  ,simpleLowerCaseMapping:0x2036
  ,simpleTitleCaseMapping:0x2036
 },
 { code:0x2037
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2037
  ,simpleLowerCaseMapping:0x2037
  ,simpleTitleCaseMapping:0x2037
 },
 { code:0x2038
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2038
  ,simpleLowerCaseMapping:0x2038
  ,simpleTitleCaseMapping:0x2038
 },
 { code:0x2039
  ,generalCategory:UnicodeData.GeneralCategory.Pi
  ,simpleUpperCaseMapping:0x2039
  ,simpleLowerCaseMapping:0x2039
  ,simpleTitleCaseMapping:0x2039
 },
 { code:0x203A
  ,generalCategory:UnicodeData.GeneralCategory.Pf
  ,simpleUpperCaseMapping:0x203A
  ,simpleLowerCaseMapping:0x203A
  ,simpleTitleCaseMapping:0x203A
 },
 { code:0x203B
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x203B
  ,simpleLowerCaseMapping:0x203B
  ,simpleTitleCaseMapping:0x203B
 },
 { code:0x203C
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x203C
  ,simpleLowerCaseMapping:0x203C
  ,simpleTitleCaseMapping:0x203C
 },
 { code:0x203D
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x203D
  ,simpleLowerCaseMapping:0x203D
  ,simpleTitleCaseMapping:0x203D
 },
 { code:0x203E
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x203E
  ,simpleLowerCaseMapping:0x203E
  ,simpleTitleCaseMapping:0x203E
 },
 { code:0x203F
  ,generalCategory:UnicodeData.GeneralCategory.Pc
  ,simpleUpperCaseMapping:0x203F
  ,simpleLowerCaseMapping:0x203F
  ,simpleTitleCaseMapping:0x203F
 },
 { code:0x2040
  ,generalCategory:UnicodeData.GeneralCategory.Pc
  ,simpleUpperCaseMapping:0x2040
  ,simpleLowerCaseMapping:0x2040
  ,simpleTitleCaseMapping:0x2040
 },
 { code:0x2041
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2041
  ,simpleLowerCaseMapping:0x2041
  ,simpleTitleCaseMapping:0x2041
 },
 { code:0x2042
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2042
  ,simpleLowerCaseMapping:0x2042
  ,simpleTitleCaseMapping:0x2042
 },
 { code:0x2043
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2043
  ,simpleLowerCaseMapping:0x2043
  ,simpleTitleCaseMapping:0x2043
 },
 { code:0x2044
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2044
  ,simpleLowerCaseMapping:0x2044
  ,simpleTitleCaseMapping:0x2044
 },
 { code:0x2045
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x2045
  ,simpleLowerCaseMapping:0x2045
  ,simpleTitleCaseMapping:0x2045
 },
 { code:0x2046
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x2046
  ,simpleLowerCaseMapping:0x2046
  ,simpleTitleCaseMapping:0x2046
 },
 { code:0x2047
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2047
  ,simpleLowerCaseMapping:0x2047
  ,simpleTitleCaseMapping:0x2047
 },
 { code:0x2048
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2048
  ,simpleLowerCaseMapping:0x2048
  ,simpleTitleCaseMapping:0x2048
 },
 { code:0x2049
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2049
  ,simpleLowerCaseMapping:0x2049
  ,simpleTitleCaseMapping:0x2049
 },
 { code:0x204A
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x204A
  ,simpleLowerCaseMapping:0x204A
  ,simpleTitleCaseMapping:0x204A
 },
 { code:0x204B
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x204B
  ,simpleLowerCaseMapping:0x204B
  ,simpleTitleCaseMapping:0x204B
 },
 { code:0x204C
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x204C
  ,simpleLowerCaseMapping:0x204C
  ,simpleTitleCaseMapping:0x204C
 },
 { code:0x204D
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x204D
  ,simpleLowerCaseMapping:0x204D
  ,simpleTitleCaseMapping:0x204D
 },
 { code:0x204E
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x204E
  ,simpleLowerCaseMapping:0x204E
  ,simpleTitleCaseMapping:0x204E
 },
 { code:0x204F
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x204F
  ,simpleLowerCaseMapping:0x204F
  ,simpleTitleCaseMapping:0x204F
 },
 { code:0x2050
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2050
  ,simpleLowerCaseMapping:0x2050
  ,simpleTitleCaseMapping:0x2050
 },
 { code:0x2051
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2051
  ,simpleLowerCaseMapping:0x2051
  ,simpleTitleCaseMapping:0x2051
 },
 { code:0x2052
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2052
  ,simpleLowerCaseMapping:0x2052
  ,simpleTitleCaseMapping:0x2052
 },
 { code:0x2053
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2053
  ,simpleLowerCaseMapping:0x2053
  ,simpleTitleCaseMapping:0x2053
 },
 { code:0x2054
  ,generalCategory:UnicodeData.GeneralCategory.Pc
  ,simpleUpperCaseMapping:0x2054
  ,simpleLowerCaseMapping:0x2054
  ,simpleTitleCaseMapping:0x2054
 },
 { code:0x2055
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2055
  ,simpleLowerCaseMapping:0x2055
  ,simpleTitleCaseMapping:0x2055
 },
 { code:0x2056
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2056
  ,simpleLowerCaseMapping:0x2056
  ,simpleTitleCaseMapping:0x2056
 },
 { code:0x2057
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2057
  ,simpleLowerCaseMapping:0x2057
  ,simpleTitleCaseMapping:0x2057
 },
 { code:0x2058
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2058
  ,simpleLowerCaseMapping:0x2058
  ,simpleTitleCaseMapping:0x2058
 },
 { code:0x2059
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2059
  ,simpleLowerCaseMapping:0x2059
  ,simpleTitleCaseMapping:0x2059
 },
 { code:0x205A
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x205A
  ,simpleLowerCaseMapping:0x205A
  ,simpleTitleCaseMapping:0x205A
 },
 { code:0x205B
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x205B
  ,simpleLowerCaseMapping:0x205B
  ,simpleTitleCaseMapping:0x205B
 },
 { code:0x205C
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x205C
  ,simpleLowerCaseMapping:0x205C
  ,simpleTitleCaseMapping:0x205C
 },
 { code:0x205D
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x205D
  ,simpleLowerCaseMapping:0x205D
  ,simpleTitleCaseMapping:0x205D
 },
 { code:0x205E
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x205E
  ,simpleLowerCaseMapping:0x205E
  ,simpleTitleCaseMapping:0x205E
 },
 { code:0x205F
  ,generalCategory:UnicodeData.GeneralCategory.Zs
  ,simpleUpperCaseMapping:0x205F
  ,simpleLowerCaseMapping:0x205F
  ,simpleTitleCaseMapping:0x205F
 },
 { code:0x2060
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x2060
  ,simpleLowerCaseMapping:0x2060
  ,simpleTitleCaseMapping:0x2060
 },
 { code:0x2061
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x2061
  ,simpleLowerCaseMapping:0x2061
  ,simpleTitleCaseMapping:0x2061
 },
 { code:0x2062
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x2062
  ,simpleLowerCaseMapping:0x2062
  ,simpleTitleCaseMapping:0x2062
 },
 { code:0x2063
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x2063
  ,simpleLowerCaseMapping:0x2063
  ,simpleTitleCaseMapping:0x2063
 },
 { code:0x206A
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x206A
  ,simpleLowerCaseMapping:0x206A
  ,simpleTitleCaseMapping:0x206A
 },
 { code:0x206B
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x206B
  ,simpleLowerCaseMapping:0x206B
  ,simpleTitleCaseMapping:0x206B
 },
 { code:0x206C
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x206C
  ,simpleLowerCaseMapping:0x206C
  ,simpleTitleCaseMapping:0x206C
 },
 { code:0x206D
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x206D
  ,simpleLowerCaseMapping:0x206D
  ,simpleTitleCaseMapping:0x206D
 },
 { code:0x206E
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x206E
  ,simpleLowerCaseMapping:0x206E
  ,simpleTitleCaseMapping:0x206E
 },
 { code:0x206F
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x206F
  ,simpleLowerCaseMapping:0x206F
  ,simpleTitleCaseMapping:0x206F
 },
 { code:0x2070
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2070
  ,simpleLowerCaseMapping:0x2070
  ,simpleTitleCaseMapping:0x2070
 },
 { code:0x2071
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2071
  ,simpleLowerCaseMapping:0x2071
  ,simpleTitleCaseMapping:0x2071
 },
 { code:0x2074
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2074
  ,simpleLowerCaseMapping:0x2074
  ,simpleTitleCaseMapping:0x2074
 },
 { code:0x2075
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2075
  ,simpleLowerCaseMapping:0x2075
  ,simpleTitleCaseMapping:0x2075
 },
 { code:0x2076
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2076
  ,simpleLowerCaseMapping:0x2076
  ,simpleTitleCaseMapping:0x2076
 },
 { code:0x2077
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2077
  ,simpleLowerCaseMapping:0x2077
  ,simpleTitleCaseMapping:0x2077
 },
 { code:0x2078
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2078
  ,simpleLowerCaseMapping:0x2078
  ,simpleTitleCaseMapping:0x2078
 },
 { code:0x2079
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2079
  ,simpleLowerCaseMapping:0x2079
  ,simpleTitleCaseMapping:0x2079
 },
 { code:0x207A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x207A
  ,simpleLowerCaseMapping:0x207A
  ,simpleTitleCaseMapping:0x207A
 },
 { code:0x207B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x207B
  ,simpleLowerCaseMapping:0x207B
  ,simpleTitleCaseMapping:0x207B
 },
 { code:0x207C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x207C
  ,simpleLowerCaseMapping:0x207C
  ,simpleTitleCaseMapping:0x207C
 },
 { code:0x207D
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x207D
  ,simpleLowerCaseMapping:0x207D
  ,simpleTitleCaseMapping:0x207D
 },
 { code:0x207E
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x207E
  ,simpleLowerCaseMapping:0x207E
  ,simpleTitleCaseMapping:0x207E
 },
 { code:0x207F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x207F
  ,simpleLowerCaseMapping:0x207F
  ,simpleTitleCaseMapping:0x207F
 },
 { code:0x2080
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2080
  ,simpleLowerCaseMapping:0x2080
  ,simpleTitleCaseMapping:0x2080
 },
 { code:0x2081
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2081
  ,simpleLowerCaseMapping:0x2081
  ,simpleTitleCaseMapping:0x2081
 },
 { code:0x2082
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2082
  ,simpleLowerCaseMapping:0x2082
  ,simpleTitleCaseMapping:0x2082
 },
 { code:0x2083
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2083
  ,simpleLowerCaseMapping:0x2083
  ,simpleTitleCaseMapping:0x2083
 },
 { code:0x2084
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2084
  ,simpleLowerCaseMapping:0x2084
  ,simpleTitleCaseMapping:0x2084
 },
 { code:0x2085
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2085
  ,simpleLowerCaseMapping:0x2085
  ,simpleTitleCaseMapping:0x2085
 },
 { code:0x2086
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2086
  ,simpleLowerCaseMapping:0x2086
  ,simpleTitleCaseMapping:0x2086
 },
 { code:0x2087
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2087
  ,simpleLowerCaseMapping:0x2087
  ,simpleTitleCaseMapping:0x2087
 },
 { code:0x2088
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2088
  ,simpleLowerCaseMapping:0x2088
  ,simpleTitleCaseMapping:0x2088
 },
 { code:0x2089
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2089
  ,simpleLowerCaseMapping:0x2089
  ,simpleTitleCaseMapping:0x2089
 },
 { code:0x208A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x208A
  ,simpleLowerCaseMapping:0x208A
  ,simpleTitleCaseMapping:0x208A
 },
 { code:0x208B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x208B
  ,simpleLowerCaseMapping:0x208B
  ,simpleTitleCaseMapping:0x208B
 },
 { code:0x208C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x208C
  ,simpleLowerCaseMapping:0x208C
  ,simpleTitleCaseMapping:0x208C
 },
 { code:0x208D
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x208D
  ,simpleLowerCaseMapping:0x208D
  ,simpleTitleCaseMapping:0x208D
 },
 { code:0x208E
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x208E
  ,simpleLowerCaseMapping:0x208E
  ,simpleTitleCaseMapping:0x208E
 },
 { code:0x2090
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x2090
  ,simpleLowerCaseMapping:0x2090
  ,simpleTitleCaseMapping:0x2090
 },
 { code:0x2091
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x2091
  ,simpleLowerCaseMapping:0x2091
  ,simpleTitleCaseMapping:0x2091
 },
 { code:0x2092
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x2092
  ,simpleLowerCaseMapping:0x2092
  ,simpleTitleCaseMapping:0x2092
 },
 { code:0x2093
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x2093
  ,simpleLowerCaseMapping:0x2093
  ,simpleTitleCaseMapping:0x2093
 },
 { code:0x2094
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x2094
  ,simpleLowerCaseMapping:0x2094
  ,simpleTitleCaseMapping:0x2094
 },
 { code:0x20A0
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20A0
  ,simpleLowerCaseMapping:0x20A0
  ,simpleTitleCaseMapping:0x20A0
 },
 { code:0x20A1
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20A1
  ,simpleLowerCaseMapping:0x20A1
  ,simpleTitleCaseMapping:0x20A1
 },
 { code:0x20A2
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20A2
  ,simpleLowerCaseMapping:0x20A2
  ,simpleTitleCaseMapping:0x20A2
 },
 { code:0x20A3
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20A3
  ,simpleLowerCaseMapping:0x20A3
  ,simpleTitleCaseMapping:0x20A3
 },
 { code:0x20A4
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20A4
  ,simpleLowerCaseMapping:0x20A4
  ,simpleTitleCaseMapping:0x20A4
 },
 { code:0x20A5
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20A5
  ,simpleLowerCaseMapping:0x20A5
  ,simpleTitleCaseMapping:0x20A5
 },
 { code:0x20A6
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20A6
  ,simpleLowerCaseMapping:0x20A6
  ,simpleTitleCaseMapping:0x20A6
 },
 { code:0x20A7
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20A7
  ,simpleLowerCaseMapping:0x20A7
  ,simpleTitleCaseMapping:0x20A7
 },
 { code:0x20A8
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20A8
  ,simpleLowerCaseMapping:0x20A8
  ,simpleTitleCaseMapping:0x20A8
 },
 { code:0x20A9
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20A9
  ,simpleLowerCaseMapping:0x20A9
  ,simpleTitleCaseMapping:0x20A9
 },
 { code:0x20AA
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20AA
  ,simpleLowerCaseMapping:0x20AA
  ,simpleTitleCaseMapping:0x20AA
 },
 { code:0x20AB
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20AB
  ,simpleLowerCaseMapping:0x20AB
  ,simpleTitleCaseMapping:0x20AB
 },
 { code:0x20AC
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20AC
  ,simpleLowerCaseMapping:0x20AC
  ,simpleTitleCaseMapping:0x20AC
 },
 { code:0x20AD
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20AD
  ,simpleLowerCaseMapping:0x20AD
  ,simpleTitleCaseMapping:0x20AD
 },
 { code:0x20AE
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20AE
  ,simpleLowerCaseMapping:0x20AE
  ,simpleTitleCaseMapping:0x20AE
 },
 { code:0x20AF
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20AF
  ,simpleLowerCaseMapping:0x20AF
  ,simpleTitleCaseMapping:0x20AF
 },
 { code:0x20B0
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20B0
  ,simpleLowerCaseMapping:0x20B0
  ,simpleTitleCaseMapping:0x20B0
 },
 { code:0x20B1
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20B1
  ,simpleLowerCaseMapping:0x20B1
  ,simpleTitleCaseMapping:0x20B1
 },
 { code:0x20B2
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20B2
  ,simpleLowerCaseMapping:0x20B2
  ,simpleTitleCaseMapping:0x20B2
 },
 { code:0x20B3
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20B3
  ,simpleLowerCaseMapping:0x20B3
  ,simpleTitleCaseMapping:0x20B3
 },
 { code:0x20B4
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20B4
  ,simpleLowerCaseMapping:0x20B4
  ,simpleTitleCaseMapping:0x20B4
 },
 { code:0x20B5
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0x20B5
  ,simpleLowerCaseMapping:0x20B5
  ,simpleTitleCaseMapping:0x20B5
 },
 { code:0x20D0
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20D0
  ,simpleLowerCaseMapping:0x20D0
  ,simpleTitleCaseMapping:0x20D0
 },
 { code:0x20D1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20D1
  ,simpleLowerCaseMapping:0x20D1
  ,simpleTitleCaseMapping:0x20D1
 },
 { code:0x20D2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20D2
  ,simpleLowerCaseMapping:0x20D2
  ,simpleTitleCaseMapping:0x20D2
 },
 { code:0x20D3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20D3
  ,simpleLowerCaseMapping:0x20D3
  ,simpleTitleCaseMapping:0x20D3
 },
 { code:0x20D4
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20D4
  ,simpleLowerCaseMapping:0x20D4
  ,simpleTitleCaseMapping:0x20D4
 },
 { code:0x20D5
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20D5
  ,simpleLowerCaseMapping:0x20D5
  ,simpleTitleCaseMapping:0x20D5
 },
 { code:0x20D6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20D6
  ,simpleLowerCaseMapping:0x20D6
  ,simpleTitleCaseMapping:0x20D6
 },
 { code:0x20D7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20D7
  ,simpleLowerCaseMapping:0x20D7
  ,simpleTitleCaseMapping:0x20D7
 },
 { code:0x20D8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20D8
  ,simpleLowerCaseMapping:0x20D8
  ,simpleTitleCaseMapping:0x20D8
 },
 { code:0x20D9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20D9
  ,simpleLowerCaseMapping:0x20D9
  ,simpleTitleCaseMapping:0x20D9
 },
 { code:0x20DA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20DA
  ,simpleLowerCaseMapping:0x20DA
  ,simpleTitleCaseMapping:0x20DA
 },
 { code:0x20DB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20DB
  ,simpleLowerCaseMapping:0x20DB
  ,simpleTitleCaseMapping:0x20DB
 },
 { code:0x20DC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20DC
  ,simpleLowerCaseMapping:0x20DC
  ,simpleTitleCaseMapping:0x20DC
 },
 { code:0x20DD
  ,generalCategory:UnicodeData.GeneralCategory.Me
  ,simpleUpperCaseMapping:0x20DD
  ,simpleLowerCaseMapping:0x20DD
  ,simpleTitleCaseMapping:0x20DD
 },
 { code:0x20DE
  ,generalCategory:UnicodeData.GeneralCategory.Me
  ,simpleUpperCaseMapping:0x20DE
  ,simpleLowerCaseMapping:0x20DE
  ,simpleTitleCaseMapping:0x20DE
 },
 { code:0x20DF
  ,generalCategory:UnicodeData.GeneralCategory.Me
  ,simpleUpperCaseMapping:0x20DF
  ,simpleLowerCaseMapping:0x20DF
  ,simpleTitleCaseMapping:0x20DF
 },
 { code:0x20E0
  ,generalCategory:UnicodeData.GeneralCategory.Me
  ,simpleUpperCaseMapping:0x20E0
  ,simpleLowerCaseMapping:0x20E0
  ,simpleTitleCaseMapping:0x20E0
 },
 { code:0x20E1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20E1
  ,simpleLowerCaseMapping:0x20E1
  ,simpleTitleCaseMapping:0x20E1
 },
 { code:0x20E2
  ,generalCategory:UnicodeData.GeneralCategory.Me
  ,simpleUpperCaseMapping:0x20E2
  ,simpleLowerCaseMapping:0x20E2
  ,simpleTitleCaseMapping:0x20E2
 },
 { code:0x20E3
  ,generalCategory:UnicodeData.GeneralCategory.Me
  ,simpleUpperCaseMapping:0x20E3
  ,simpleLowerCaseMapping:0x20E3
  ,simpleTitleCaseMapping:0x20E3
 },
 { code:0x20E4
  ,generalCategory:UnicodeData.GeneralCategory.Me
  ,simpleUpperCaseMapping:0x20E4
  ,simpleLowerCaseMapping:0x20E4
  ,simpleTitleCaseMapping:0x20E4
 },
 { code:0x20E5
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20E5
  ,simpleLowerCaseMapping:0x20E5
  ,simpleTitleCaseMapping:0x20E5
 },
 { code:0x20E6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20E6
  ,simpleLowerCaseMapping:0x20E6
  ,simpleTitleCaseMapping:0x20E6
 },
 { code:0x20E7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20E7
  ,simpleLowerCaseMapping:0x20E7
  ,simpleTitleCaseMapping:0x20E7
 },
 { code:0x20E8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20E8
  ,simpleLowerCaseMapping:0x20E8
  ,simpleTitleCaseMapping:0x20E8
 },
 { code:0x20E9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20E9
  ,simpleLowerCaseMapping:0x20E9
  ,simpleTitleCaseMapping:0x20E9
 },
 { code:0x20EA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20EA
  ,simpleLowerCaseMapping:0x20EA
  ,simpleTitleCaseMapping:0x20EA
 },
 { code:0x20EB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20EB
  ,simpleLowerCaseMapping:0x20EB
  ,simpleTitleCaseMapping:0x20EB
 },
 { code:0x20EC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20EC
  ,simpleLowerCaseMapping:0x20EC
  ,simpleTitleCaseMapping:0x20EC
 },
 { code:0x20ED
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20ED
  ,simpleLowerCaseMapping:0x20ED
  ,simpleTitleCaseMapping:0x20ED
 },
 { code:0x20EE
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20EE
  ,simpleLowerCaseMapping:0x20EE
  ,simpleTitleCaseMapping:0x20EE
 },
 { code:0x20EF
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x20EF
  ,simpleLowerCaseMapping:0x20EF
  ,simpleTitleCaseMapping:0x20EF
 },
 { code:0x2100
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2100
  ,simpleLowerCaseMapping:0x2100
  ,simpleTitleCaseMapping:0x2100
 },
 { code:0x2101
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2101
  ,simpleLowerCaseMapping:0x2101
  ,simpleTitleCaseMapping:0x2101
 },
 { code:0x2102
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2102
  ,simpleLowerCaseMapping:0x2102
  ,simpleTitleCaseMapping:0x2102
 },
 { code:0x2103
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2103
  ,simpleLowerCaseMapping:0x2103
  ,simpleTitleCaseMapping:0x2103
 },
 { code:0x2104
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2104
  ,simpleLowerCaseMapping:0x2104
  ,simpleTitleCaseMapping:0x2104
 },
 { code:0x2105
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2105
  ,simpleLowerCaseMapping:0x2105
  ,simpleTitleCaseMapping:0x2105
 },
 { code:0x2106
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2106
  ,simpleLowerCaseMapping:0x2106
  ,simpleTitleCaseMapping:0x2106
 },
 { code:0x2107
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2107
  ,simpleLowerCaseMapping:0x2107
  ,simpleTitleCaseMapping:0x2107
 },
 { code:0x2108
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2108
  ,simpleLowerCaseMapping:0x2108
  ,simpleTitleCaseMapping:0x2108
 },
 { code:0x2109
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2109
  ,simpleLowerCaseMapping:0x2109
  ,simpleTitleCaseMapping:0x2109
 },
 { code:0x210A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x210A
  ,simpleLowerCaseMapping:0x210A
  ,simpleTitleCaseMapping:0x210A
 },
 { code:0x210B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x210B
  ,simpleLowerCaseMapping:0x210B
  ,simpleTitleCaseMapping:0x210B
 },
 { code:0x210C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x210C
  ,simpleLowerCaseMapping:0x210C
  ,simpleTitleCaseMapping:0x210C
 },
 { code:0x210D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x210D
  ,simpleLowerCaseMapping:0x210D
  ,simpleTitleCaseMapping:0x210D
 },
 { code:0x210E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x210E
  ,simpleLowerCaseMapping:0x210E
  ,simpleTitleCaseMapping:0x210E
 },
 { code:0x210F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x210F
  ,simpleLowerCaseMapping:0x210F
  ,simpleTitleCaseMapping:0x210F
 },
 { code:0x2110
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2110
  ,simpleLowerCaseMapping:0x2110
  ,simpleTitleCaseMapping:0x2110
 },
 { code:0x2111
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2111
  ,simpleLowerCaseMapping:0x2111
  ,simpleTitleCaseMapping:0x2111
 },
 { code:0x2112
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2112
  ,simpleLowerCaseMapping:0x2112
  ,simpleTitleCaseMapping:0x2112
 },
 { code:0x2113
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2113
  ,simpleLowerCaseMapping:0x2113
  ,simpleTitleCaseMapping:0x2113
 },
 { code:0x2114
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2114
  ,simpleLowerCaseMapping:0x2114
  ,simpleTitleCaseMapping:0x2114
 },
 { code:0x2115
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2115
  ,simpleLowerCaseMapping:0x2115
  ,simpleTitleCaseMapping:0x2115
 },
 { code:0x2116
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2116
  ,simpleLowerCaseMapping:0x2116
  ,simpleTitleCaseMapping:0x2116
 },
 { code:0x2117
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2117
  ,simpleLowerCaseMapping:0x2117
  ,simpleTitleCaseMapping:0x2117
 },
 { code:0x2118
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2118
  ,simpleLowerCaseMapping:0x2118
  ,simpleTitleCaseMapping:0x2118
 },
 { code:0x2119
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2119
  ,simpleLowerCaseMapping:0x2119
  ,simpleTitleCaseMapping:0x2119
 },
 { code:0x211A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x211A
  ,simpleLowerCaseMapping:0x211A
  ,simpleTitleCaseMapping:0x211A
 },
 { code:0x211B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x211B
  ,simpleLowerCaseMapping:0x211B
  ,simpleTitleCaseMapping:0x211B
 },
 { code:0x211C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x211C
  ,simpleLowerCaseMapping:0x211C
  ,simpleTitleCaseMapping:0x211C
 },
 { code:0x211D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x211D
  ,simpleLowerCaseMapping:0x211D
  ,simpleTitleCaseMapping:0x211D
 },
 { code:0x211E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x211E
  ,simpleLowerCaseMapping:0x211E
  ,simpleTitleCaseMapping:0x211E
 },
 { code:0x211F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x211F
  ,simpleLowerCaseMapping:0x211F
  ,simpleTitleCaseMapping:0x211F
 },
 { code:0x2120
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2120
  ,simpleLowerCaseMapping:0x2120
  ,simpleTitleCaseMapping:0x2120
 },
 { code:0x2121
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2121
  ,simpleLowerCaseMapping:0x2121
  ,simpleTitleCaseMapping:0x2121
 },
 { code:0x2122
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2122
  ,simpleLowerCaseMapping:0x2122
  ,simpleTitleCaseMapping:0x2122
 },
 { code:0x2123
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2123
  ,simpleLowerCaseMapping:0x2123
  ,simpleTitleCaseMapping:0x2123
 },
 { code:0x2124
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2124
  ,simpleLowerCaseMapping:0x2124
  ,simpleTitleCaseMapping:0x2124
 },
 { code:0x2125
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2125
  ,simpleLowerCaseMapping:0x2125
  ,simpleTitleCaseMapping:0x2125
 },
 { code:0x2126
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2126
  ,simpleLowerCaseMapping:0x03C9
  ,simpleTitleCaseMapping:0x2126
 },
 { code:0x2127
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2127
  ,simpleLowerCaseMapping:0x2127
  ,simpleTitleCaseMapping:0x2127
 },
 { code:0x2128
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2128
  ,simpleLowerCaseMapping:0x2128
  ,simpleTitleCaseMapping:0x2128
 },
 { code:0x2129
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2129
  ,simpleLowerCaseMapping:0x2129
  ,simpleTitleCaseMapping:0x2129
 },
 { code:0x212A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x212A
  ,simpleLowerCaseMapping:0x006B
  ,simpleTitleCaseMapping:0x212A
 },
 { code:0x212B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x212B
  ,simpleLowerCaseMapping:0x00E5
  ,simpleTitleCaseMapping:0x212B
 },
 { code:0x212C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x212C
  ,simpleLowerCaseMapping:0x212C
  ,simpleTitleCaseMapping:0x212C
 },
 { code:0x212D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x212D
  ,simpleLowerCaseMapping:0x212D
  ,simpleTitleCaseMapping:0x212D
 },
 { code:0x212E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x212E
  ,simpleLowerCaseMapping:0x212E
  ,simpleTitleCaseMapping:0x212E
 },
 { code:0x212F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x212F
  ,simpleLowerCaseMapping:0x212F
  ,simpleTitleCaseMapping:0x212F
 },
 { code:0x2130
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2130
  ,simpleLowerCaseMapping:0x2130
  ,simpleTitleCaseMapping:0x2130
 },
 { code:0x2131
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2131
  ,simpleLowerCaseMapping:0x2131
  ,simpleTitleCaseMapping:0x2131
 },
 { code:0x2132
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2132
  ,simpleLowerCaseMapping:0x214E
  ,simpleTitleCaseMapping:0x2132
 },
 { code:0x2133
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2133
  ,simpleLowerCaseMapping:0x2133
  ,simpleTitleCaseMapping:0x2133
 },
 { code:0x2134
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2134
  ,simpleLowerCaseMapping:0x2134
  ,simpleTitleCaseMapping:0x2134
 },
 { code:0x2135
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2135
  ,simpleLowerCaseMapping:0x2135
  ,simpleTitleCaseMapping:0x2135
 },
 { code:0x2136
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2136
  ,simpleLowerCaseMapping:0x2136
  ,simpleTitleCaseMapping:0x2136
 },
 { code:0x2137
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2137
  ,simpleLowerCaseMapping:0x2137
  ,simpleTitleCaseMapping:0x2137
 },
 { code:0x2138
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2138
  ,simpleLowerCaseMapping:0x2138
  ,simpleTitleCaseMapping:0x2138
 },
 { code:0x2139
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2139
  ,simpleLowerCaseMapping:0x2139
  ,simpleTitleCaseMapping:0x2139
 },
 { code:0x213A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x213A
  ,simpleLowerCaseMapping:0x213A
  ,simpleTitleCaseMapping:0x213A
 },
 { code:0x213B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x213B
  ,simpleLowerCaseMapping:0x213B
  ,simpleTitleCaseMapping:0x213B
 },
 { code:0x213C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x213C
  ,simpleLowerCaseMapping:0x213C
  ,simpleTitleCaseMapping:0x213C
 },
 { code:0x213D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x213D
  ,simpleLowerCaseMapping:0x213D
  ,simpleTitleCaseMapping:0x213D
 },
 { code:0x213E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x213E
  ,simpleLowerCaseMapping:0x213E
  ,simpleTitleCaseMapping:0x213E
 },
 { code:0x213F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x213F
  ,simpleLowerCaseMapping:0x213F
  ,simpleTitleCaseMapping:0x213F
 },
 { code:0x2140
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2140
  ,simpleLowerCaseMapping:0x2140
  ,simpleTitleCaseMapping:0x2140
 },
 { code:0x2141
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2141
  ,simpleLowerCaseMapping:0x2141
  ,simpleTitleCaseMapping:0x2141
 },
 { code:0x2142
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2142
  ,simpleLowerCaseMapping:0x2142
  ,simpleTitleCaseMapping:0x2142
 },
 { code:0x2143
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2143
  ,simpleLowerCaseMapping:0x2143
  ,simpleTitleCaseMapping:0x2143
 },
 { code:0x2144
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2144
  ,simpleLowerCaseMapping:0x2144
  ,simpleTitleCaseMapping:0x2144
 },
 { code:0x2145
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2145
  ,simpleLowerCaseMapping:0x2145
  ,simpleTitleCaseMapping:0x2145
 },
 { code:0x2146
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2146
  ,simpleLowerCaseMapping:0x2146
  ,simpleTitleCaseMapping:0x2146
 },
 { code:0x2147
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2147
  ,simpleLowerCaseMapping:0x2147
  ,simpleTitleCaseMapping:0x2147
 },
 { code:0x2148
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2148
  ,simpleLowerCaseMapping:0x2148
  ,simpleTitleCaseMapping:0x2148
 },
 { code:0x2149
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2149
  ,simpleLowerCaseMapping:0x2149
  ,simpleTitleCaseMapping:0x2149
 },
 { code:0x214A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x214A
  ,simpleLowerCaseMapping:0x214A
  ,simpleTitleCaseMapping:0x214A
 },
 { code:0x214B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x214B
  ,simpleLowerCaseMapping:0x214B
  ,simpleTitleCaseMapping:0x214B
 },
 { code:0x214C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x214C
  ,simpleLowerCaseMapping:0x214C
  ,simpleTitleCaseMapping:0x214C
 },
 { code:0x214D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x214D
  ,simpleLowerCaseMapping:0x214D
  ,simpleTitleCaseMapping:0x214D
 },
 { code:0x214E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2132
  ,simpleLowerCaseMapping:0x214E
  ,simpleTitleCaseMapping:0x2132
 },
 { code:0x2153
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2153
  ,simpleLowerCaseMapping:0x2153
  ,simpleTitleCaseMapping:0x2153
 },
 { code:0x2154
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2154
  ,simpleLowerCaseMapping:0x2154
  ,simpleTitleCaseMapping:0x2154
 },
 { code:0x2155
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2155
  ,simpleLowerCaseMapping:0x2155
  ,simpleTitleCaseMapping:0x2155
 },
 { code:0x2156
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2156
  ,simpleLowerCaseMapping:0x2156
  ,simpleTitleCaseMapping:0x2156
 },
 { code:0x2157
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2157
  ,simpleLowerCaseMapping:0x2157
  ,simpleTitleCaseMapping:0x2157
 },
 { code:0x2158
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2158
  ,simpleLowerCaseMapping:0x2158
  ,simpleTitleCaseMapping:0x2158
 },
 { code:0x2159
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2159
  ,simpleLowerCaseMapping:0x2159
  ,simpleTitleCaseMapping:0x2159
 },
 { code:0x215A
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x215A
  ,simpleLowerCaseMapping:0x215A
  ,simpleTitleCaseMapping:0x215A
 },
 { code:0x215B
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x215B
  ,simpleLowerCaseMapping:0x215B
  ,simpleTitleCaseMapping:0x215B
 },
 { code:0x215C
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x215C
  ,simpleLowerCaseMapping:0x215C
  ,simpleTitleCaseMapping:0x215C
 },
 { code:0x215D
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x215D
  ,simpleLowerCaseMapping:0x215D
  ,simpleTitleCaseMapping:0x215D
 },
 { code:0x215E
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x215E
  ,simpleLowerCaseMapping:0x215E
  ,simpleTitleCaseMapping:0x215E
 },
 { code:0x215F
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x215F
  ,simpleLowerCaseMapping:0x215F
  ,simpleTitleCaseMapping:0x215F
 },
 { code:0x2160
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2160
  ,simpleLowerCaseMapping:0x2170
  ,simpleTitleCaseMapping:0x2160
 },
 { code:0x2161
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2161
  ,simpleLowerCaseMapping:0x2171
  ,simpleTitleCaseMapping:0x2161
 },
 { code:0x2162
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2162
  ,simpleLowerCaseMapping:0x2172
  ,simpleTitleCaseMapping:0x2162
 },
 { code:0x2163
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2163
  ,simpleLowerCaseMapping:0x2173
  ,simpleTitleCaseMapping:0x2163
 },
 { code:0x2164
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2164
  ,simpleLowerCaseMapping:0x2174
  ,simpleTitleCaseMapping:0x2164
 },
 { code:0x2165
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2165
  ,simpleLowerCaseMapping:0x2175
  ,simpleTitleCaseMapping:0x2165
 },
 { code:0x2166
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2166
  ,simpleLowerCaseMapping:0x2176
  ,simpleTitleCaseMapping:0x2166
 },
 { code:0x2167
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2167
  ,simpleLowerCaseMapping:0x2177
  ,simpleTitleCaseMapping:0x2167
 },
 { code:0x2168
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2168
  ,simpleLowerCaseMapping:0x2178
  ,simpleTitleCaseMapping:0x2168
 },
 { code:0x2169
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2169
  ,simpleLowerCaseMapping:0x2179
  ,simpleTitleCaseMapping:0x2169
 },
 { code:0x216A
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x216A
  ,simpleLowerCaseMapping:0x217A
  ,simpleTitleCaseMapping:0x216A
 },
 { code:0x216B
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x216B
  ,simpleLowerCaseMapping:0x217B
  ,simpleTitleCaseMapping:0x216B
 },
 { code:0x216C
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x216C
  ,simpleLowerCaseMapping:0x217C
  ,simpleTitleCaseMapping:0x216C
 },
 { code:0x216D
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x216D
  ,simpleLowerCaseMapping:0x217D
  ,simpleTitleCaseMapping:0x216D
 },
 { code:0x216E
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x216E
  ,simpleLowerCaseMapping:0x217E
  ,simpleTitleCaseMapping:0x216E
 },
 { code:0x216F
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x216F
  ,simpleLowerCaseMapping:0x217F
  ,simpleTitleCaseMapping:0x216F
 },
 { code:0x2170
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2160
  ,simpleLowerCaseMapping:0x2170
  ,simpleTitleCaseMapping:0x2160
 },
 { code:0x2171
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2161
  ,simpleLowerCaseMapping:0x2171
  ,simpleTitleCaseMapping:0x2161
 },
 { code:0x2172
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2162
  ,simpleLowerCaseMapping:0x2172
  ,simpleTitleCaseMapping:0x2162
 },
 { code:0x2173
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2163
  ,simpleLowerCaseMapping:0x2173
  ,simpleTitleCaseMapping:0x2163
 },
 { code:0x2174
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2164
  ,simpleLowerCaseMapping:0x2174
  ,simpleTitleCaseMapping:0x2164
 },
 { code:0x2175
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2165
  ,simpleLowerCaseMapping:0x2175
  ,simpleTitleCaseMapping:0x2165
 },
 { code:0x2176
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2166
  ,simpleLowerCaseMapping:0x2176
  ,simpleTitleCaseMapping:0x2166
 },
 { code:0x2177
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2167
  ,simpleLowerCaseMapping:0x2177
  ,simpleTitleCaseMapping:0x2167
 },
 { code:0x2178
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2168
  ,simpleLowerCaseMapping:0x2178
  ,simpleTitleCaseMapping:0x2168
 },
 { code:0x2179
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2169
  ,simpleLowerCaseMapping:0x2179
  ,simpleTitleCaseMapping:0x2169
 },
 { code:0x217A
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x216A
  ,simpleLowerCaseMapping:0x217A
  ,simpleTitleCaseMapping:0x216A
 },
 { code:0x217B
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x216B
  ,simpleLowerCaseMapping:0x217B
  ,simpleTitleCaseMapping:0x216B
 },
 { code:0x217C
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x216C
  ,simpleLowerCaseMapping:0x217C
  ,simpleTitleCaseMapping:0x216C
 },
 { code:0x217D
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x216D
  ,simpleLowerCaseMapping:0x217D
  ,simpleTitleCaseMapping:0x216D
 },
 { code:0x217E
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x216E
  ,simpleLowerCaseMapping:0x217E
  ,simpleTitleCaseMapping:0x216E
 },
 { code:0x217F
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x216F
  ,simpleLowerCaseMapping:0x217F
  ,simpleTitleCaseMapping:0x216F
 },
 { code:0x2180
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2180
  ,simpleLowerCaseMapping:0x2180
  ,simpleTitleCaseMapping:0x2180
 },
 { code:0x2181
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2181
  ,simpleLowerCaseMapping:0x2181
  ,simpleTitleCaseMapping:0x2181
 },
 { code:0x2182
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x2182
  ,simpleLowerCaseMapping:0x2182
  ,simpleTitleCaseMapping:0x2182
 },
 { code:0x2183
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2183
  ,simpleLowerCaseMapping:0x2184
  ,simpleTitleCaseMapping:0x2183
 },
 { code:0x2184
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2183
  ,simpleLowerCaseMapping:0x2184
  ,simpleTitleCaseMapping:0x2183
 },
 { code:0x2190
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2190
  ,simpleLowerCaseMapping:0x2190
  ,simpleTitleCaseMapping:0x2190
 },
 { code:0x2191
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2191
  ,simpleLowerCaseMapping:0x2191
  ,simpleTitleCaseMapping:0x2191
 },
 { code:0x2192
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2192
  ,simpleLowerCaseMapping:0x2192
  ,simpleTitleCaseMapping:0x2192
 },
 { code:0x2193
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2193
  ,simpleLowerCaseMapping:0x2193
  ,simpleTitleCaseMapping:0x2193
 },
 { code:0x2194
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2194
  ,simpleLowerCaseMapping:0x2194
  ,simpleTitleCaseMapping:0x2194
 },
 { code:0x2195
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2195
  ,simpleLowerCaseMapping:0x2195
  ,simpleTitleCaseMapping:0x2195
 },
 { code:0x2196
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2196
  ,simpleLowerCaseMapping:0x2196
  ,simpleTitleCaseMapping:0x2196
 },
 { code:0x2197
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2197
  ,simpleLowerCaseMapping:0x2197
  ,simpleTitleCaseMapping:0x2197
 },
 { code:0x2198
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2198
  ,simpleLowerCaseMapping:0x2198
  ,simpleTitleCaseMapping:0x2198
 },
 { code:0x2199
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2199
  ,simpleLowerCaseMapping:0x2199
  ,simpleTitleCaseMapping:0x2199
 },
 { code:0x219A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x219A
  ,simpleLowerCaseMapping:0x219A
  ,simpleTitleCaseMapping:0x219A
 },
 { code:0x219B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x219B
  ,simpleLowerCaseMapping:0x219B
  ,simpleTitleCaseMapping:0x219B
 },
 { code:0x219C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x219C
  ,simpleLowerCaseMapping:0x219C
  ,simpleTitleCaseMapping:0x219C
 },
 { code:0x219D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x219D
  ,simpleLowerCaseMapping:0x219D
  ,simpleTitleCaseMapping:0x219D
 },
 { code:0x219E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x219E
  ,simpleLowerCaseMapping:0x219E
  ,simpleTitleCaseMapping:0x219E
 },
 { code:0x219F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x219F
  ,simpleLowerCaseMapping:0x219F
  ,simpleTitleCaseMapping:0x219F
 },
 { code:0x21A0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21A0
  ,simpleLowerCaseMapping:0x21A0
  ,simpleTitleCaseMapping:0x21A0
 },
 { code:0x21A1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21A1
  ,simpleLowerCaseMapping:0x21A1
  ,simpleTitleCaseMapping:0x21A1
 },
 { code:0x21A2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21A2
  ,simpleLowerCaseMapping:0x21A2
  ,simpleTitleCaseMapping:0x21A2
 },
 { code:0x21A3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21A3
  ,simpleLowerCaseMapping:0x21A3
  ,simpleTitleCaseMapping:0x21A3
 },
 { code:0x21A4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21A4
  ,simpleLowerCaseMapping:0x21A4
  ,simpleTitleCaseMapping:0x21A4
 },
 { code:0x21A5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21A5
  ,simpleLowerCaseMapping:0x21A5
  ,simpleTitleCaseMapping:0x21A5
 },
 { code:0x21A6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21A6
  ,simpleLowerCaseMapping:0x21A6
  ,simpleTitleCaseMapping:0x21A6
 },
 { code:0x21A7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21A7
  ,simpleLowerCaseMapping:0x21A7
  ,simpleTitleCaseMapping:0x21A7
 },
 { code:0x21A8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21A8
  ,simpleLowerCaseMapping:0x21A8
  ,simpleTitleCaseMapping:0x21A8
 },
 { code:0x21A9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21A9
  ,simpleLowerCaseMapping:0x21A9
  ,simpleTitleCaseMapping:0x21A9
 },
 { code:0x21AA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21AA
  ,simpleLowerCaseMapping:0x21AA
  ,simpleTitleCaseMapping:0x21AA
 },
 { code:0x21AB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21AB
  ,simpleLowerCaseMapping:0x21AB
  ,simpleTitleCaseMapping:0x21AB
 },
 { code:0x21AC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21AC
  ,simpleLowerCaseMapping:0x21AC
  ,simpleTitleCaseMapping:0x21AC
 },
 { code:0x21AD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21AD
  ,simpleLowerCaseMapping:0x21AD
  ,simpleTitleCaseMapping:0x21AD
 },
 { code:0x21AE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21AE
  ,simpleLowerCaseMapping:0x21AE
  ,simpleTitleCaseMapping:0x21AE
 },
 { code:0x21AF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21AF
  ,simpleLowerCaseMapping:0x21AF
  ,simpleTitleCaseMapping:0x21AF
 },
 { code:0x21B0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21B0
  ,simpleLowerCaseMapping:0x21B0
  ,simpleTitleCaseMapping:0x21B0
 },
 { code:0x21B1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21B1
  ,simpleLowerCaseMapping:0x21B1
  ,simpleTitleCaseMapping:0x21B1
 },
 { code:0x21B2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21B2
  ,simpleLowerCaseMapping:0x21B2
  ,simpleTitleCaseMapping:0x21B2
 },
 { code:0x21B3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21B3
  ,simpleLowerCaseMapping:0x21B3
  ,simpleTitleCaseMapping:0x21B3
 },
 { code:0x21B4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21B4
  ,simpleLowerCaseMapping:0x21B4
  ,simpleTitleCaseMapping:0x21B4
 },
 { code:0x21B5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21B5
  ,simpleLowerCaseMapping:0x21B5
  ,simpleTitleCaseMapping:0x21B5
 },
 { code:0x21B6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21B6
  ,simpleLowerCaseMapping:0x21B6
  ,simpleTitleCaseMapping:0x21B6
 },
 { code:0x21B7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21B7
  ,simpleLowerCaseMapping:0x21B7
  ,simpleTitleCaseMapping:0x21B7
 },
 { code:0x21B8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21B8
  ,simpleLowerCaseMapping:0x21B8
  ,simpleTitleCaseMapping:0x21B8
 },
 { code:0x21B9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21B9
  ,simpleLowerCaseMapping:0x21B9
  ,simpleTitleCaseMapping:0x21B9
 },
 { code:0x21BA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21BA
  ,simpleLowerCaseMapping:0x21BA
  ,simpleTitleCaseMapping:0x21BA
 },
 { code:0x21BB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21BB
  ,simpleLowerCaseMapping:0x21BB
  ,simpleTitleCaseMapping:0x21BB
 },
 { code:0x21BC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21BC
  ,simpleLowerCaseMapping:0x21BC
  ,simpleTitleCaseMapping:0x21BC
 },
 { code:0x21BD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21BD
  ,simpleLowerCaseMapping:0x21BD
  ,simpleTitleCaseMapping:0x21BD
 },
 { code:0x21BE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21BE
  ,simpleLowerCaseMapping:0x21BE
  ,simpleTitleCaseMapping:0x21BE
 },
 { code:0x21BF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21BF
  ,simpleLowerCaseMapping:0x21BF
  ,simpleTitleCaseMapping:0x21BF
 },
 { code:0x21C0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21C0
  ,simpleLowerCaseMapping:0x21C0
  ,simpleTitleCaseMapping:0x21C0
 },
 { code:0x21C1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21C1
  ,simpleLowerCaseMapping:0x21C1
  ,simpleTitleCaseMapping:0x21C1
 },
 { code:0x21C2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21C2
  ,simpleLowerCaseMapping:0x21C2
  ,simpleTitleCaseMapping:0x21C2
 },
 { code:0x21C3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21C3
  ,simpleLowerCaseMapping:0x21C3
  ,simpleTitleCaseMapping:0x21C3
 },
 { code:0x21C4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21C4
  ,simpleLowerCaseMapping:0x21C4
  ,simpleTitleCaseMapping:0x21C4
 },
 { code:0x21C5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21C5
  ,simpleLowerCaseMapping:0x21C5
  ,simpleTitleCaseMapping:0x21C5
 },
 { code:0x21C6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21C6
  ,simpleLowerCaseMapping:0x21C6
  ,simpleTitleCaseMapping:0x21C6
 },
 { code:0x21C7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21C7
  ,simpleLowerCaseMapping:0x21C7
  ,simpleTitleCaseMapping:0x21C7
 },
 { code:0x21C8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21C8
  ,simpleLowerCaseMapping:0x21C8
  ,simpleTitleCaseMapping:0x21C8
 },
 { code:0x21C9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21C9
  ,simpleLowerCaseMapping:0x21C9
  ,simpleTitleCaseMapping:0x21C9
 },
 { code:0x21CA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21CA
  ,simpleLowerCaseMapping:0x21CA
  ,simpleTitleCaseMapping:0x21CA
 },
 { code:0x21CB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21CB
  ,simpleLowerCaseMapping:0x21CB
  ,simpleTitleCaseMapping:0x21CB
 },
 { code:0x21CC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21CC
  ,simpleLowerCaseMapping:0x21CC
  ,simpleTitleCaseMapping:0x21CC
 },
 { code:0x21CD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21CD
  ,simpleLowerCaseMapping:0x21CD
  ,simpleTitleCaseMapping:0x21CD
 },
 { code:0x21CE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21CE
  ,simpleLowerCaseMapping:0x21CE
  ,simpleTitleCaseMapping:0x21CE
 },
 { code:0x21CF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21CF
  ,simpleLowerCaseMapping:0x21CF
  ,simpleTitleCaseMapping:0x21CF
 },
 { code:0x21D0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21D0
  ,simpleLowerCaseMapping:0x21D0
  ,simpleTitleCaseMapping:0x21D0
 },
 { code:0x21D1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21D1
  ,simpleLowerCaseMapping:0x21D1
  ,simpleTitleCaseMapping:0x21D1
 },
 { code:0x21D2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21D2
  ,simpleLowerCaseMapping:0x21D2
  ,simpleTitleCaseMapping:0x21D2
 },
 { code:0x21D3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21D3
  ,simpleLowerCaseMapping:0x21D3
  ,simpleTitleCaseMapping:0x21D3
 },
 { code:0x21D4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21D4
  ,simpleLowerCaseMapping:0x21D4
  ,simpleTitleCaseMapping:0x21D4
 },
 { code:0x21D5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21D5
  ,simpleLowerCaseMapping:0x21D5
  ,simpleTitleCaseMapping:0x21D5
 },
 { code:0x21D6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21D6
  ,simpleLowerCaseMapping:0x21D6
  ,simpleTitleCaseMapping:0x21D6
 },
 { code:0x21D7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21D7
  ,simpleLowerCaseMapping:0x21D7
  ,simpleTitleCaseMapping:0x21D7
 },
 { code:0x21D8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21D8
  ,simpleLowerCaseMapping:0x21D8
  ,simpleTitleCaseMapping:0x21D8
 },
 { code:0x21D9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21D9
  ,simpleLowerCaseMapping:0x21D9
  ,simpleTitleCaseMapping:0x21D9
 },
 { code:0x21DA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21DA
  ,simpleLowerCaseMapping:0x21DA
  ,simpleTitleCaseMapping:0x21DA
 },
 { code:0x21DB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21DB
  ,simpleLowerCaseMapping:0x21DB
  ,simpleTitleCaseMapping:0x21DB
 },
 { code:0x21DC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21DC
  ,simpleLowerCaseMapping:0x21DC
  ,simpleTitleCaseMapping:0x21DC
 },
 { code:0x21DD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21DD
  ,simpleLowerCaseMapping:0x21DD
  ,simpleTitleCaseMapping:0x21DD
 },
 { code:0x21DE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21DE
  ,simpleLowerCaseMapping:0x21DE
  ,simpleTitleCaseMapping:0x21DE
 },
 { code:0x21DF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21DF
  ,simpleLowerCaseMapping:0x21DF
  ,simpleTitleCaseMapping:0x21DF
 },
 { code:0x21E0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21E0
  ,simpleLowerCaseMapping:0x21E0
  ,simpleTitleCaseMapping:0x21E0
 },
 { code:0x21E1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21E1
  ,simpleLowerCaseMapping:0x21E1
  ,simpleTitleCaseMapping:0x21E1
 },
 { code:0x21E2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21E2
  ,simpleLowerCaseMapping:0x21E2
  ,simpleTitleCaseMapping:0x21E2
 },
 { code:0x21E3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21E3
  ,simpleLowerCaseMapping:0x21E3
  ,simpleTitleCaseMapping:0x21E3
 },
 { code:0x21E4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21E4
  ,simpleLowerCaseMapping:0x21E4
  ,simpleTitleCaseMapping:0x21E4
 },
 { code:0x21E5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21E5
  ,simpleLowerCaseMapping:0x21E5
  ,simpleTitleCaseMapping:0x21E5
 },
 { code:0x21E6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21E6
  ,simpleLowerCaseMapping:0x21E6
  ,simpleTitleCaseMapping:0x21E6
 },
 { code:0x21E7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21E7
  ,simpleLowerCaseMapping:0x21E7
  ,simpleTitleCaseMapping:0x21E7
 },
 { code:0x21E8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21E8
  ,simpleLowerCaseMapping:0x21E8
  ,simpleTitleCaseMapping:0x21E8
 },
 { code:0x21E9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21E9
  ,simpleLowerCaseMapping:0x21E9
  ,simpleTitleCaseMapping:0x21E9
 },
 { code:0x21EA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21EA
  ,simpleLowerCaseMapping:0x21EA
  ,simpleTitleCaseMapping:0x21EA
 },
 { code:0x21EB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21EB
  ,simpleLowerCaseMapping:0x21EB
  ,simpleTitleCaseMapping:0x21EB
 },
 { code:0x21EC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21EC
  ,simpleLowerCaseMapping:0x21EC
  ,simpleTitleCaseMapping:0x21EC
 },
 { code:0x21ED
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21ED
  ,simpleLowerCaseMapping:0x21ED
  ,simpleTitleCaseMapping:0x21ED
 },
 { code:0x21EE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21EE
  ,simpleLowerCaseMapping:0x21EE
  ,simpleTitleCaseMapping:0x21EE
 },
 { code:0x21EF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21EF
  ,simpleLowerCaseMapping:0x21EF
  ,simpleTitleCaseMapping:0x21EF
 },
 { code:0x21F0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21F0
  ,simpleLowerCaseMapping:0x21F0
  ,simpleTitleCaseMapping:0x21F0
 },
 { code:0x21F1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21F1
  ,simpleLowerCaseMapping:0x21F1
  ,simpleTitleCaseMapping:0x21F1
 },
 { code:0x21F2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21F2
  ,simpleLowerCaseMapping:0x21F2
  ,simpleTitleCaseMapping:0x21F2
 },
 { code:0x21F3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x21F3
  ,simpleLowerCaseMapping:0x21F3
  ,simpleTitleCaseMapping:0x21F3
 },
 { code:0x21F4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21F4
  ,simpleLowerCaseMapping:0x21F4
  ,simpleTitleCaseMapping:0x21F4
 },
 { code:0x21F5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21F5
  ,simpleLowerCaseMapping:0x21F5
  ,simpleTitleCaseMapping:0x21F5
 },
 { code:0x21F6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21F6
  ,simpleLowerCaseMapping:0x21F6
  ,simpleTitleCaseMapping:0x21F6
 },
 { code:0x21F7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21F7
  ,simpleLowerCaseMapping:0x21F7
  ,simpleTitleCaseMapping:0x21F7
 },
 { code:0x21F8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21F8
  ,simpleLowerCaseMapping:0x21F8
  ,simpleTitleCaseMapping:0x21F8
 },
 { code:0x21F9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21F9
  ,simpleLowerCaseMapping:0x21F9
  ,simpleTitleCaseMapping:0x21F9
 },
 { code:0x21FA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21FA
  ,simpleLowerCaseMapping:0x21FA
  ,simpleTitleCaseMapping:0x21FA
 },
 { code:0x21FB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21FB
  ,simpleLowerCaseMapping:0x21FB
  ,simpleTitleCaseMapping:0x21FB
 },
 { code:0x21FC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21FC
  ,simpleLowerCaseMapping:0x21FC
  ,simpleTitleCaseMapping:0x21FC
 },
 { code:0x21FD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21FD
  ,simpleLowerCaseMapping:0x21FD
  ,simpleTitleCaseMapping:0x21FD
 },
 { code:0x21FE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21FE
  ,simpleLowerCaseMapping:0x21FE
  ,simpleTitleCaseMapping:0x21FE
 },
 { code:0x21FF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x21FF
  ,simpleLowerCaseMapping:0x21FF
  ,simpleTitleCaseMapping:0x21FF
 },
 { code:0x2200
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2200
  ,simpleLowerCaseMapping:0x2200
  ,simpleTitleCaseMapping:0x2200
 },
 { code:0x2201
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2201
  ,simpleLowerCaseMapping:0x2201
  ,simpleTitleCaseMapping:0x2201
 },
 { code:0x2202
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2202
  ,simpleLowerCaseMapping:0x2202
  ,simpleTitleCaseMapping:0x2202
 },
 { code:0x2203
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2203
  ,simpleLowerCaseMapping:0x2203
  ,simpleTitleCaseMapping:0x2203
 },
 { code:0x2204
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2204
  ,simpleLowerCaseMapping:0x2204
  ,simpleTitleCaseMapping:0x2204
 },
 { code:0x2205
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2205
  ,simpleLowerCaseMapping:0x2205
  ,simpleTitleCaseMapping:0x2205
 },
 { code:0x2206
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2206
  ,simpleLowerCaseMapping:0x2206
  ,simpleTitleCaseMapping:0x2206
 },
 { code:0x2207
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2207
  ,simpleLowerCaseMapping:0x2207
  ,simpleTitleCaseMapping:0x2207
 },
 { code:0x2208
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2208
  ,simpleLowerCaseMapping:0x2208
  ,simpleTitleCaseMapping:0x2208
 },
 { code:0x2209
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2209
  ,simpleLowerCaseMapping:0x2209
  ,simpleTitleCaseMapping:0x2209
 },
 { code:0x220A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x220A
  ,simpleLowerCaseMapping:0x220A
  ,simpleTitleCaseMapping:0x220A
 },
 { code:0x220B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x220B
  ,simpleLowerCaseMapping:0x220B
  ,simpleTitleCaseMapping:0x220B
 },
 { code:0x220C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x220C
  ,simpleLowerCaseMapping:0x220C
  ,simpleTitleCaseMapping:0x220C
 },
 { code:0x220D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x220D
  ,simpleLowerCaseMapping:0x220D
  ,simpleTitleCaseMapping:0x220D
 },
 { code:0x220E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x220E
  ,simpleLowerCaseMapping:0x220E
  ,simpleTitleCaseMapping:0x220E
 },
 { code:0x220F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x220F
  ,simpleLowerCaseMapping:0x220F
  ,simpleTitleCaseMapping:0x220F
 },
 { code:0x2210
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2210
  ,simpleLowerCaseMapping:0x2210
  ,simpleTitleCaseMapping:0x2210
 },
 { code:0x2211
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2211
  ,simpleLowerCaseMapping:0x2211
  ,simpleTitleCaseMapping:0x2211
 },
 { code:0x2212
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2212
  ,simpleLowerCaseMapping:0x2212
  ,simpleTitleCaseMapping:0x2212
 },
 { code:0x2213
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2213
  ,simpleLowerCaseMapping:0x2213
  ,simpleTitleCaseMapping:0x2213
 },
 { code:0x2214
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2214
  ,simpleLowerCaseMapping:0x2214
  ,simpleTitleCaseMapping:0x2214
 },
 { code:0x2215
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2215
  ,simpleLowerCaseMapping:0x2215
  ,simpleTitleCaseMapping:0x2215
 },
 { code:0x2216
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2216
  ,simpleLowerCaseMapping:0x2216
  ,simpleTitleCaseMapping:0x2216
 },
 { code:0x2217
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2217
  ,simpleLowerCaseMapping:0x2217
  ,simpleTitleCaseMapping:0x2217
 },
 { code:0x2218
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2218
  ,simpleLowerCaseMapping:0x2218
  ,simpleTitleCaseMapping:0x2218
 },
 { code:0x2219
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2219
  ,simpleLowerCaseMapping:0x2219
  ,simpleTitleCaseMapping:0x2219
 },
 { code:0x221A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x221A
  ,simpleLowerCaseMapping:0x221A
  ,simpleTitleCaseMapping:0x221A
 },
 { code:0x221B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x221B
  ,simpleLowerCaseMapping:0x221B
  ,simpleTitleCaseMapping:0x221B
 },
 { code:0x221C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x221C
  ,simpleLowerCaseMapping:0x221C
  ,simpleTitleCaseMapping:0x221C
 },
 { code:0x221D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x221D
  ,simpleLowerCaseMapping:0x221D
  ,simpleTitleCaseMapping:0x221D
 },
 { code:0x221E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x221E
  ,simpleLowerCaseMapping:0x221E
  ,simpleTitleCaseMapping:0x221E
 },
 { code:0x221F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x221F
  ,simpleLowerCaseMapping:0x221F
  ,simpleTitleCaseMapping:0x221F
 },
 { code:0x2220
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2220
  ,simpleLowerCaseMapping:0x2220
  ,simpleTitleCaseMapping:0x2220
 },
 { code:0x2221
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2221
  ,simpleLowerCaseMapping:0x2221
  ,simpleTitleCaseMapping:0x2221
 },
 { code:0x2222
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2222
  ,simpleLowerCaseMapping:0x2222
  ,simpleTitleCaseMapping:0x2222
 },
 { code:0x2223
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2223
  ,simpleLowerCaseMapping:0x2223
  ,simpleTitleCaseMapping:0x2223
 },
 { code:0x2224
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2224
  ,simpleLowerCaseMapping:0x2224
  ,simpleTitleCaseMapping:0x2224
 },
 { code:0x2225
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2225
  ,simpleLowerCaseMapping:0x2225
  ,simpleTitleCaseMapping:0x2225
 },
 { code:0x2226
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2226
  ,simpleLowerCaseMapping:0x2226
  ,simpleTitleCaseMapping:0x2226
 },
 { code:0x2227
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2227
  ,simpleLowerCaseMapping:0x2227
  ,simpleTitleCaseMapping:0x2227
 },
 { code:0x2228
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2228
  ,simpleLowerCaseMapping:0x2228
  ,simpleTitleCaseMapping:0x2228
 },
 { code:0x2229
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2229
  ,simpleLowerCaseMapping:0x2229
  ,simpleTitleCaseMapping:0x2229
 },
 { code:0x222A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x222A
  ,simpleLowerCaseMapping:0x222A
  ,simpleTitleCaseMapping:0x222A
 },
 { code:0x222B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x222B
  ,simpleLowerCaseMapping:0x222B
  ,simpleTitleCaseMapping:0x222B
 },
 { code:0x222C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x222C
  ,simpleLowerCaseMapping:0x222C
  ,simpleTitleCaseMapping:0x222C
 },
 { code:0x222D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x222D
  ,simpleLowerCaseMapping:0x222D
  ,simpleTitleCaseMapping:0x222D
 },
 { code:0x222E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x222E
  ,simpleLowerCaseMapping:0x222E
  ,simpleTitleCaseMapping:0x222E
 },
 { code:0x222F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x222F
  ,simpleLowerCaseMapping:0x222F
  ,simpleTitleCaseMapping:0x222F
 },
 { code:0x2230
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2230
  ,simpleLowerCaseMapping:0x2230
  ,simpleTitleCaseMapping:0x2230
 },
 { code:0x2231
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2231
  ,simpleLowerCaseMapping:0x2231
  ,simpleTitleCaseMapping:0x2231
 },
 { code:0x2232
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2232
  ,simpleLowerCaseMapping:0x2232
  ,simpleTitleCaseMapping:0x2232
 },
 { code:0x2233
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2233
  ,simpleLowerCaseMapping:0x2233
  ,simpleTitleCaseMapping:0x2233
 },
 { code:0x2234
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2234
  ,simpleLowerCaseMapping:0x2234
  ,simpleTitleCaseMapping:0x2234
 },
 { code:0x2235
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2235
  ,simpleLowerCaseMapping:0x2235
  ,simpleTitleCaseMapping:0x2235
 },
 { code:0x2236
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2236
  ,simpleLowerCaseMapping:0x2236
  ,simpleTitleCaseMapping:0x2236
 },
 { code:0x2237
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2237
  ,simpleLowerCaseMapping:0x2237
  ,simpleTitleCaseMapping:0x2237
 },
 { code:0x2238
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2238
  ,simpleLowerCaseMapping:0x2238
  ,simpleTitleCaseMapping:0x2238
 },
 { code:0x2239
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2239
  ,simpleLowerCaseMapping:0x2239
  ,simpleTitleCaseMapping:0x2239
 },
 { code:0x223A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x223A
  ,simpleLowerCaseMapping:0x223A
  ,simpleTitleCaseMapping:0x223A
 },
 { code:0x223B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x223B
  ,simpleLowerCaseMapping:0x223B
  ,simpleTitleCaseMapping:0x223B
 },
 { code:0x223C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x223C
  ,simpleLowerCaseMapping:0x223C
  ,simpleTitleCaseMapping:0x223C
 },
 { code:0x223D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x223D
  ,simpleLowerCaseMapping:0x223D
  ,simpleTitleCaseMapping:0x223D
 },
 { code:0x223E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x223E
  ,simpleLowerCaseMapping:0x223E
  ,simpleTitleCaseMapping:0x223E
 },
 { code:0x223F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x223F
  ,simpleLowerCaseMapping:0x223F
  ,simpleTitleCaseMapping:0x223F
 },
 { code:0x2240
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2240
  ,simpleLowerCaseMapping:0x2240
  ,simpleTitleCaseMapping:0x2240
 },
 { code:0x2241
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2241
  ,simpleLowerCaseMapping:0x2241
  ,simpleTitleCaseMapping:0x2241
 },
 { code:0x2242
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2242
  ,simpleLowerCaseMapping:0x2242
  ,simpleTitleCaseMapping:0x2242
 },
 { code:0x2243
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2243
  ,simpleLowerCaseMapping:0x2243
  ,simpleTitleCaseMapping:0x2243
 },
 { code:0x2244
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2244
  ,simpleLowerCaseMapping:0x2244
  ,simpleTitleCaseMapping:0x2244
 },
 { code:0x2245
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2245
  ,simpleLowerCaseMapping:0x2245
  ,simpleTitleCaseMapping:0x2245
 },
 { code:0x2246
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2246
  ,simpleLowerCaseMapping:0x2246
  ,simpleTitleCaseMapping:0x2246
 },
 { code:0x2247
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2247
  ,simpleLowerCaseMapping:0x2247
  ,simpleTitleCaseMapping:0x2247
 },
 { code:0x2248
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2248
  ,simpleLowerCaseMapping:0x2248
  ,simpleTitleCaseMapping:0x2248
 },
 { code:0x2249
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2249
  ,simpleLowerCaseMapping:0x2249
  ,simpleTitleCaseMapping:0x2249
 },
 { code:0x224A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x224A
  ,simpleLowerCaseMapping:0x224A
  ,simpleTitleCaseMapping:0x224A
 },
 { code:0x224B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x224B
  ,simpleLowerCaseMapping:0x224B
  ,simpleTitleCaseMapping:0x224B
 },
 { code:0x224C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x224C
  ,simpleLowerCaseMapping:0x224C
  ,simpleTitleCaseMapping:0x224C
 },
 { code:0x224D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x224D
  ,simpleLowerCaseMapping:0x224D
  ,simpleTitleCaseMapping:0x224D
 },
 { code:0x224E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x224E
  ,simpleLowerCaseMapping:0x224E
  ,simpleTitleCaseMapping:0x224E
 },
 { code:0x224F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x224F
  ,simpleLowerCaseMapping:0x224F
  ,simpleTitleCaseMapping:0x224F
 },
 { code:0x2250
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2250
  ,simpleLowerCaseMapping:0x2250
  ,simpleTitleCaseMapping:0x2250
 },
 { code:0x2251
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2251
  ,simpleLowerCaseMapping:0x2251
  ,simpleTitleCaseMapping:0x2251
 },
 { code:0x2252
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2252
  ,simpleLowerCaseMapping:0x2252
  ,simpleTitleCaseMapping:0x2252
 },
 { code:0x2253
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2253
  ,simpleLowerCaseMapping:0x2253
  ,simpleTitleCaseMapping:0x2253
 },
 { code:0x2254
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2254
  ,simpleLowerCaseMapping:0x2254
  ,simpleTitleCaseMapping:0x2254
 },
 { code:0x2255
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2255
  ,simpleLowerCaseMapping:0x2255
  ,simpleTitleCaseMapping:0x2255
 },
 { code:0x2256
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2256
  ,simpleLowerCaseMapping:0x2256
  ,simpleTitleCaseMapping:0x2256
 },
 { code:0x2257
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2257
  ,simpleLowerCaseMapping:0x2257
  ,simpleTitleCaseMapping:0x2257
 },
 { code:0x2258
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2258
  ,simpleLowerCaseMapping:0x2258
  ,simpleTitleCaseMapping:0x2258
 },
 { code:0x2259
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2259
  ,simpleLowerCaseMapping:0x2259
  ,simpleTitleCaseMapping:0x2259
 },
 { code:0x225A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x225A
  ,simpleLowerCaseMapping:0x225A
  ,simpleTitleCaseMapping:0x225A
 },
 { code:0x225B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x225B
  ,simpleLowerCaseMapping:0x225B
  ,simpleTitleCaseMapping:0x225B
 },
 { code:0x225C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x225C
  ,simpleLowerCaseMapping:0x225C
  ,simpleTitleCaseMapping:0x225C
 },
 { code:0x225D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x225D
  ,simpleLowerCaseMapping:0x225D
  ,simpleTitleCaseMapping:0x225D
 },
 { code:0x225E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x225E
  ,simpleLowerCaseMapping:0x225E
  ,simpleTitleCaseMapping:0x225E
 },
 { code:0x225F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x225F
  ,simpleLowerCaseMapping:0x225F
  ,simpleTitleCaseMapping:0x225F
 },
 { code:0x2260
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2260
  ,simpleLowerCaseMapping:0x2260
  ,simpleTitleCaseMapping:0x2260
 },
 { code:0x2261
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2261
  ,simpleLowerCaseMapping:0x2261
  ,simpleTitleCaseMapping:0x2261
 },
 { code:0x2262
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2262
  ,simpleLowerCaseMapping:0x2262
  ,simpleTitleCaseMapping:0x2262
 },
 { code:0x2263
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2263
  ,simpleLowerCaseMapping:0x2263
  ,simpleTitleCaseMapping:0x2263
 },
 { code:0x2264
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2264
  ,simpleLowerCaseMapping:0x2264
  ,simpleTitleCaseMapping:0x2264
 },
 { code:0x2265
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2265
  ,simpleLowerCaseMapping:0x2265
  ,simpleTitleCaseMapping:0x2265
 },
 { code:0x2266
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2266
  ,simpleLowerCaseMapping:0x2266
  ,simpleTitleCaseMapping:0x2266
 },
 { code:0x2267
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2267
  ,simpleLowerCaseMapping:0x2267
  ,simpleTitleCaseMapping:0x2267
 },
 { code:0x2268
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2268
  ,simpleLowerCaseMapping:0x2268
  ,simpleTitleCaseMapping:0x2268
 },
 { code:0x2269
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2269
  ,simpleLowerCaseMapping:0x2269
  ,simpleTitleCaseMapping:0x2269
 },
 { code:0x226A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x226A
  ,simpleLowerCaseMapping:0x226A
  ,simpleTitleCaseMapping:0x226A
 },
 { code:0x226B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x226B
  ,simpleLowerCaseMapping:0x226B
  ,simpleTitleCaseMapping:0x226B
 },
 { code:0x226C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x226C
  ,simpleLowerCaseMapping:0x226C
  ,simpleTitleCaseMapping:0x226C
 },
 { code:0x226D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x226D
  ,simpleLowerCaseMapping:0x226D
  ,simpleTitleCaseMapping:0x226D
 },
 { code:0x226E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x226E
  ,simpleLowerCaseMapping:0x226E
  ,simpleTitleCaseMapping:0x226E
 },
 { code:0x226F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x226F
  ,simpleLowerCaseMapping:0x226F
  ,simpleTitleCaseMapping:0x226F
 },
 { code:0x2270
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2270
  ,simpleLowerCaseMapping:0x2270
  ,simpleTitleCaseMapping:0x2270
 },
 { code:0x2271
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2271
  ,simpleLowerCaseMapping:0x2271
  ,simpleTitleCaseMapping:0x2271
 },
 { code:0x2272
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2272
  ,simpleLowerCaseMapping:0x2272
  ,simpleTitleCaseMapping:0x2272
 },
 { code:0x2273
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2273
  ,simpleLowerCaseMapping:0x2273
  ,simpleTitleCaseMapping:0x2273
 },
 { code:0x2274
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2274
  ,simpleLowerCaseMapping:0x2274
  ,simpleTitleCaseMapping:0x2274
 },
 { code:0x2275
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2275
  ,simpleLowerCaseMapping:0x2275
  ,simpleTitleCaseMapping:0x2275
 },
 { code:0x2276
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2276
  ,simpleLowerCaseMapping:0x2276
  ,simpleTitleCaseMapping:0x2276
 },
 { code:0x2277
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2277
  ,simpleLowerCaseMapping:0x2277
  ,simpleTitleCaseMapping:0x2277
 },
 { code:0x2278
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2278
  ,simpleLowerCaseMapping:0x2278
  ,simpleTitleCaseMapping:0x2278
 },
 { code:0x2279
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2279
  ,simpleLowerCaseMapping:0x2279
  ,simpleTitleCaseMapping:0x2279
 },
 { code:0x227A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x227A
  ,simpleLowerCaseMapping:0x227A
  ,simpleTitleCaseMapping:0x227A
 },
 { code:0x227B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x227B
  ,simpleLowerCaseMapping:0x227B
  ,simpleTitleCaseMapping:0x227B
 },
 { code:0x227C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x227C
  ,simpleLowerCaseMapping:0x227C
  ,simpleTitleCaseMapping:0x227C
 },
 { code:0x227D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x227D
  ,simpleLowerCaseMapping:0x227D
  ,simpleTitleCaseMapping:0x227D
 },
 { code:0x227E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x227E
  ,simpleLowerCaseMapping:0x227E
  ,simpleTitleCaseMapping:0x227E
 },
 { code:0x227F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x227F
  ,simpleLowerCaseMapping:0x227F
  ,simpleTitleCaseMapping:0x227F
 },
 { code:0x2280
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2280
  ,simpleLowerCaseMapping:0x2280
  ,simpleTitleCaseMapping:0x2280
 },
 { code:0x2281
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2281
  ,simpleLowerCaseMapping:0x2281
  ,simpleTitleCaseMapping:0x2281
 },
 { code:0x2282
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2282
  ,simpleLowerCaseMapping:0x2282
  ,simpleTitleCaseMapping:0x2282
 },
 { code:0x2283
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2283
  ,simpleLowerCaseMapping:0x2283
  ,simpleTitleCaseMapping:0x2283
 },
 { code:0x2284
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2284
  ,simpleLowerCaseMapping:0x2284
  ,simpleTitleCaseMapping:0x2284
 },
 { code:0x2285
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2285
  ,simpleLowerCaseMapping:0x2285
  ,simpleTitleCaseMapping:0x2285
 },
 { code:0x2286
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2286
  ,simpleLowerCaseMapping:0x2286
  ,simpleTitleCaseMapping:0x2286
 },
 { code:0x2287
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2287
  ,simpleLowerCaseMapping:0x2287
  ,simpleTitleCaseMapping:0x2287
 },
 { code:0x2288
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2288
  ,simpleLowerCaseMapping:0x2288
  ,simpleTitleCaseMapping:0x2288
 },
 { code:0x2289
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2289
  ,simpleLowerCaseMapping:0x2289
  ,simpleTitleCaseMapping:0x2289
 },
 { code:0x228A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x228A
  ,simpleLowerCaseMapping:0x228A
  ,simpleTitleCaseMapping:0x228A
 },
 { code:0x228B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x228B
  ,simpleLowerCaseMapping:0x228B
  ,simpleTitleCaseMapping:0x228B
 },
 { code:0x228C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x228C
  ,simpleLowerCaseMapping:0x228C
  ,simpleTitleCaseMapping:0x228C
 },
 { code:0x228D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x228D
  ,simpleLowerCaseMapping:0x228D
  ,simpleTitleCaseMapping:0x228D
 },
 { code:0x228E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x228E
  ,simpleLowerCaseMapping:0x228E
  ,simpleTitleCaseMapping:0x228E
 },
 { code:0x228F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x228F
  ,simpleLowerCaseMapping:0x228F
  ,simpleTitleCaseMapping:0x228F
 },
 { code:0x2290
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2290
  ,simpleLowerCaseMapping:0x2290
  ,simpleTitleCaseMapping:0x2290
 },
 { code:0x2291
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2291
  ,simpleLowerCaseMapping:0x2291
  ,simpleTitleCaseMapping:0x2291
 },
 { code:0x2292
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2292
  ,simpleLowerCaseMapping:0x2292
  ,simpleTitleCaseMapping:0x2292
 },
 { code:0x2293
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2293
  ,simpleLowerCaseMapping:0x2293
  ,simpleTitleCaseMapping:0x2293
 },
 { code:0x2294
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2294
  ,simpleLowerCaseMapping:0x2294
  ,simpleTitleCaseMapping:0x2294
 },
 { code:0x2295
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2295
  ,simpleLowerCaseMapping:0x2295
  ,simpleTitleCaseMapping:0x2295
 },
 { code:0x2296
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2296
  ,simpleLowerCaseMapping:0x2296
  ,simpleTitleCaseMapping:0x2296
 },
 { code:0x2297
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2297
  ,simpleLowerCaseMapping:0x2297
  ,simpleTitleCaseMapping:0x2297
 },
 { code:0x2298
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2298
  ,simpleLowerCaseMapping:0x2298
  ,simpleTitleCaseMapping:0x2298
 },
 { code:0x2299
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2299
  ,simpleLowerCaseMapping:0x2299
  ,simpleTitleCaseMapping:0x2299
 },
 { code:0x229A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x229A
  ,simpleLowerCaseMapping:0x229A
  ,simpleTitleCaseMapping:0x229A
 },
 { code:0x229B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x229B
  ,simpleLowerCaseMapping:0x229B
  ,simpleTitleCaseMapping:0x229B
 },
 { code:0x229C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x229C
  ,simpleLowerCaseMapping:0x229C
  ,simpleTitleCaseMapping:0x229C
 },
 { code:0x229D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x229D
  ,simpleLowerCaseMapping:0x229D
  ,simpleTitleCaseMapping:0x229D
 },
 { code:0x229E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x229E
  ,simpleLowerCaseMapping:0x229E
  ,simpleTitleCaseMapping:0x229E
 },
 { code:0x229F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x229F
  ,simpleLowerCaseMapping:0x229F
  ,simpleTitleCaseMapping:0x229F
 },
 { code:0x22A0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22A0
  ,simpleLowerCaseMapping:0x22A0
  ,simpleTitleCaseMapping:0x22A0
 },
 { code:0x22A1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22A1
  ,simpleLowerCaseMapping:0x22A1
  ,simpleTitleCaseMapping:0x22A1
 },
 { code:0x22A2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22A2
  ,simpleLowerCaseMapping:0x22A2
  ,simpleTitleCaseMapping:0x22A2
 },
 { code:0x22A3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22A3
  ,simpleLowerCaseMapping:0x22A3
  ,simpleTitleCaseMapping:0x22A3
 },
 { code:0x22A4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22A4
  ,simpleLowerCaseMapping:0x22A4
  ,simpleTitleCaseMapping:0x22A4
 },
 { code:0x22A5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22A5
  ,simpleLowerCaseMapping:0x22A5
  ,simpleTitleCaseMapping:0x22A5
 },
 { code:0x22A6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22A6
  ,simpleLowerCaseMapping:0x22A6
  ,simpleTitleCaseMapping:0x22A6
 },
 { code:0x22A7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22A7
  ,simpleLowerCaseMapping:0x22A7
  ,simpleTitleCaseMapping:0x22A7
 },
 { code:0x22A8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22A8
  ,simpleLowerCaseMapping:0x22A8
  ,simpleTitleCaseMapping:0x22A8
 },
 { code:0x22A9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22A9
  ,simpleLowerCaseMapping:0x22A9
  ,simpleTitleCaseMapping:0x22A9
 },
 { code:0x22AA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22AA
  ,simpleLowerCaseMapping:0x22AA
  ,simpleTitleCaseMapping:0x22AA
 },
 { code:0x22AB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22AB
  ,simpleLowerCaseMapping:0x22AB
  ,simpleTitleCaseMapping:0x22AB
 },
 { code:0x22AC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22AC
  ,simpleLowerCaseMapping:0x22AC
  ,simpleTitleCaseMapping:0x22AC
 },
 { code:0x22AD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22AD
  ,simpleLowerCaseMapping:0x22AD
  ,simpleTitleCaseMapping:0x22AD
 },
 { code:0x22AE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22AE
  ,simpleLowerCaseMapping:0x22AE
  ,simpleTitleCaseMapping:0x22AE
 },
 { code:0x22AF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22AF
  ,simpleLowerCaseMapping:0x22AF
  ,simpleTitleCaseMapping:0x22AF
 },
 { code:0x22B0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22B0
  ,simpleLowerCaseMapping:0x22B0
  ,simpleTitleCaseMapping:0x22B0
 },
 { code:0x22B1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22B1
  ,simpleLowerCaseMapping:0x22B1
  ,simpleTitleCaseMapping:0x22B1
 },
 { code:0x22B2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22B2
  ,simpleLowerCaseMapping:0x22B2
  ,simpleTitleCaseMapping:0x22B2
 },
 { code:0x22B3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22B3
  ,simpleLowerCaseMapping:0x22B3
  ,simpleTitleCaseMapping:0x22B3
 },
 { code:0x22B4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22B4
  ,simpleLowerCaseMapping:0x22B4
  ,simpleTitleCaseMapping:0x22B4
 },
 { code:0x22B5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22B5
  ,simpleLowerCaseMapping:0x22B5
  ,simpleTitleCaseMapping:0x22B5
 },
 { code:0x22B6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22B6
  ,simpleLowerCaseMapping:0x22B6
  ,simpleTitleCaseMapping:0x22B6
 },
 { code:0x22B7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22B7
  ,simpleLowerCaseMapping:0x22B7
  ,simpleTitleCaseMapping:0x22B7
 },
 { code:0x22B8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22B8
  ,simpleLowerCaseMapping:0x22B8
  ,simpleTitleCaseMapping:0x22B8
 },
 { code:0x22B9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22B9
  ,simpleLowerCaseMapping:0x22B9
  ,simpleTitleCaseMapping:0x22B9
 },
 { code:0x22BA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22BA
  ,simpleLowerCaseMapping:0x22BA
  ,simpleTitleCaseMapping:0x22BA
 },
 { code:0x22BB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22BB
  ,simpleLowerCaseMapping:0x22BB
  ,simpleTitleCaseMapping:0x22BB
 },
 { code:0x22BC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22BC
  ,simpleLowerCaseMapping:0x22BC
  ,simpleTitleCaseMapping:0x22BC
 },
 { code:0x22BD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22BD
  ,simpleLowerCaseMapping:0x22BD
  ,simpleTitleCaseMapping:0x22BD
 },
 { code:0x22BE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22BE
  ,simpleLowerCaseMapping:0x22BE
  ,simpleTitleCaseMapping:0x22BE
 },
 { code:0x22BF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22BF
  ,simpleLowerCaseMapping:0x22BF
  ,simpleTitleCaseMapping:0x22BF
 },
 { code:0x22C0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22C0
  ,simpleLowerCaseMapping:0x22C0
  ,simpleTitleCaseMapping:0x22C0
 },
 { code:0x22C1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22C1
  ,simpleLowerCaseMapping:0x22C1
  ,simpleTitleCaseMapping:0x22C1
 },
 { code:0x22C2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22C2
  ,simpleLowerCaseMapping:0x22C2
  ,simpleTitleCaseMapping:0x22C2
 },
 { code:0x22C3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22C3
  ,simpleLowerCaseMapping:0x22C3
  ,simpleTitleCaseMapping:0x22C3
 },
 { code:0x22C4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22C4
  ,simpleLowerCaseMapping:0x22C4
  ,simpleTitleCaseMapping:0x22C4
 },
 { code:0x22C5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22C5
  ,simpleLowerCaseMapping:0x22C5
  ,simpleTitleCaseMapping:0x22C5
 },
 { code:0x22C6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22C6
  ,simpleLowerCaseMapping:0x22C6
  ,simpleTitleCaseMapping:0x22C6
 },
 { code:0x22C7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22C7
  ,simpleLowerCaseMapping:0x22C7
  ,simpleTitleCaseMapping:0x22C7
 },
 { code:0x22C8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22C8
  ,simpleLowerCaseMapping:0x22C8
  ,simpleTitleCaseMapping:0x22C8
 },
 { code:0x22C9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22C9
  ,simpleLowerCaseMapping:0x22C9
  ,simpleTitleCaseMapping:0x22C9
 },
 { code:0x22CA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22CA
  ,simpleLowerCaseMapping:0x22CA
  ,simpleTitleCaseMapping:0x22CA
 },
 { code:0x22CB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22CB
  ,simpleLowerCaseMapping:0x22CB
  ,simpleTitleCaseMapping:0x22CB
 },
 { code:0x22CC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22CC
  ,simpleLowerCaseMapping:0x22CC
  ,simpleTitleCaseMapping:0x22CC
 },
 { code:0x22CD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22CD
  ,simpleLowerCaseMapping:0x22CD
  ,simpleTitleCaseMapping:0x22CD
 },
 { code:0x22CE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22CE
  ,simpleLowerCaseMapping:0x22CE
  ,simpleTitleCaseMapping:0x22CE
 },
 { code:0x22CF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22CF
  ,simpleLowerCaseMapping:0x22CF
  ,simpleTitleCaseMapping:0x22CF
 },
 { code:0x22D0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22D0
  ,simpleLowerCaseMapping:0x22D0
  ,simpleTitleCaseMapping:0x22D0
 },
 { code:0x22D1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22D1
  ,simpleLowerCaseMapping:0x22D1
  ,simpleTitleCaseMapping:0x22D1
 },
 { code:0x22D2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22D2
  ,simpleLowerCaseMapping:0x22D2
  ,simpleTitleCaseMapping:0x22D2
 },
 { code:0x22D3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22D3
  ,simpleLowerCaseMapping:0x22D3
  ,simpleTitleCaseMapping:0x22D3
 },
 { code:0x22D4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22D4
  ,simpleLowerCaseMapping:0x22D4
  ,simpleTitleCaseMapping:0x22D4
 },
 { code:0x22D5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22D5
  ,simpleLowerCaseMapping:0x22D5
  ,simpleTitleCaseMapping:0x22D5
 },
 { code:0x22D6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22D6
  ,simpleLowerCaseMapping:0x22D6
  ,simpleTitleCaseMapping:0x22D6
 },
 { code:0x22D7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22D7
  ,simpleLowerCaseMapping:0x22D7
  ,simpleTitleCaseMapping:0x22D7
 },
 { code:0x22D8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22D8
  ,simpleLowerCaseMapping:0x22D8
  ,simpleTitleCaseMapping:0x22D8
 },
 { code:0x22D9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22D9
  ,simpleLowerCaseMapping:0x22D9
  ,simpleTitleCaseMapping:0x22D9
 },
 { code:0x22DA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22DA
  ,simpleLowerCaseMapping:0x22DA
  ,simpleTitleCaseMapping:0x22DA
 },
 { code:0x22DB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22DB
  ,simpleLowerCaseMapping:0x22DB
  ,simpleTitleCaseMapping:0x22DB
 },
 { code:0x22DC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22DC
  ,simpleLowerCaseMapping:0x22DC
  ,simpleTitleCaseMapping:0x22DC
 },
 { code:0x22DD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22DD
  ,simpleLowerCaseMapping:0x22DD
  ,simpleTitleCaseMapping:0x22DD
 },
 { code:0x22DE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22DE
  ,simpleLowerCaseMapping:0x22DE
  ,simpleTitleCaseMapping:0x22DE
 },
 { code:0x22DF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22DF
  ,simpleLowerCaseMapping:0x22DF
  ,simpleTitleCaseMapping:0x22DF
 },
 { code:0x22E0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22E0
  ,simpleLowerCaseMapping:0x22E0
  ,simpleTitleCaseMapping:0x22E0
 },
 { code:0x22E1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22E1
  ,simpleLowerCaseMapping:0x22E1
  ,simpleTitleCaseMapping:0x22E1
 },
 { code:0x22E2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22E2
  ,simpleLowerCaseMapping:0x22E2
  ,simpleTitleCaseMapping:0x22E2
 },
 { code:0x22E3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22E3
  ,simpleLowerCaseMapping:0x22E3
  ,simpleTitleCaseMapping:0x22E3
 },
 { code:0x22E4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22E4
  ,simpleLowerCaseMapping:0x22E4
  ,simpleTitleCaseMapping:0x22E4
 },
 { code:0x22E5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22E5
  ,simpleLowerCaseMapping:0x22E5
  ,simpleTitleCaseMapping:0x22E5
 },
 { code:0x22E6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22E6
  ,simpleLowerCaseMapping:0x22E6
  ,simpleTitleCaseMapping:0x22E6
 },
 { code:0x22E7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22E7
  ,simpleLowerCaseMapping:0x22E7
  ,simpleTitleCaseMapping:0x22E7
 },
 { code:0x22E8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22E8
  ,simpleLowerCaseMapping:0x22E8
  ,simpleTitleCaseMapping:0x22E8
 },
 { code:0x22E9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22E9
  ,simpleLowerCaseMapping:0x22E9
  ,simpleTitleCaseMapping:0x22E9
 },
 { code:0x22EA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22EA
  ,simpleLowerCaseMapping:0x22EA
  ,simpleTitleCaseMapping:0x22EA
 },
 { code:0x22EB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22EB
  ,simpleLowerCaseMapping:0x22EB
  ,simpleTitleCaseMapping:0x22EB
 },
 { code:0x22EC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22EC
  ,simpleLowerCaseMapping:0x22EC
  ,simpleTitleCaseMapping:0x22EC
 },
 { code:0x22ED
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22ED
  ,simpleLowerCaseMapping:0x22ED
  ,simpleTitleCaseMapping:0x22ED
 },
 { code:0x22EE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22EE
  ,simpleLowerCaseMapping:0x22EE
  ,simpleTitleCaseMapping:0x22EE
 },
 { code:0x22EF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22EF
  ,simpleLowerCaseMapping:0x22EF
  ,simpleTitleCaseMapping:0x22EF
 },
 { code:0x22F0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22F0
  ,simpleLowerCaseMapping:0x22F0
  ,simpleTitleCaseMapping:0x22F0
 },
 { code:0x22F1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22F1
  ,simpleLowerCaseMapping:0x22F1
  ,simpleTitleCaseMapping:0x22F1
 },
 { code:0x22F2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22F2
  ,simpleLowerCaseMapping:0x22F2
  ,simpleTitleCaseMapping:0x22F2
 },
 { code:0x22F3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22F3
  ,simpleLowerCaseMapping:0x22F3
  ,simpleTitleCaseMapping:0x22F3
 },
 { code:0x22F4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22F4
  ,simpleLowerCaseMapping:0x22F4
  ,simpleTitleCaseMapping:0x22F4
 },
 { code:0x22F5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22F5
  ,simpleLowerCaseMapping:0x22F5
  ,simpleTitleCaseMapping:0x22F5
 },
 { code:0x22F6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22F6
  ,simpleLowerCaseMapping:0x22F6
  ,simpleTitleCaseMapping:0x22F6
 },
 { code:0x22F7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22F7
  ,simpleLowerCaseMapping:0x22F7
  ,simpleTitleCaseMapping:0x22F7
 },
 { code:0x22F8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22F8
  ,simpleLowerCaseMapping:0x22F8
  ,simpleTitleCaseMapping:0x22F8
 },
 { code:0x22F9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22F9
  ,simpleLowerCaseMapping:0x22F9
  ,simpleTitleCaseMapping:0x22F9
 },
 { code:0x22FA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22FA
  ,simpleLowerCaseMapping:0x22FA
  ,simpleTitleCaseMapping:0x22FA
 },
 { code:0x22FB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22FB
  ,simpleLowerCaseMapping:0x22FB
  ,simpleTitleCaseMapping:0x22FB
 },
 { code:0x22FC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22FC
  ,simpleLowerCaseMapping:0x22FC
  ,simpleTitleCaseMapping:0x22FC
 },
 { code:0x22FD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22FD
  ,simpleLowerCaseMapping:0x22FD
  ,simpleTitleCaseMapping:0x22FD
 },
 { code:0x22FE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22FE
  ,simpleLowerCaseMapping:0x22FE
  ,simpleTitleCaseMapping:0x22FE
 },
 { code:0x22FF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x22FF
  ,simpleLowerCaseMapping:0x22FF
  ,simpleTitleCaseMapping:0x22FF
 },
 { code:0x2300
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2300
  ,simpleLowerCaseMapping:0x2300
  ,simpleTitleCaseMapping:0x2300
 },
 { code:0x2301
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2301
  ,simpleLowerCaseMapping:0x2301
  ,simpleTitleCaseMapping:0x2301
 },
 { code:0x2302
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2302
  ,simpleLowerCaseMapping:0x2302
  ,simpleTitleCaseMapping:0x2302
 },
 { code:0x2303
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2303
  ,simpleLowerCaseMapping:0x2303
  ,simpleTitleCaseMapping:0x2303
 },
 { code:0x2304
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2304
  ,simpleLowerCaseMapping:0x2304
  ,simpleTitleCaseMapping:0x2304
 },
 { code:0x2305
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2305
  ,simpleLowerCaseMapping:0x2305
  ,simpleTitleCaseMapping:0x2305
 },
 { code:0x2306
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2306
  ,simpleLowerCaseMapping:0x2306
  ,simpleTitleCaseMapping:0x2306
 },
 { code:0x2307
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2307
  ,simpleLowerCaseMapping:0x2307
  ,simpleTitleCaseMapping:0x2307
 },
 { code:0x2308
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2308
  ,simpleLowerCaseMapping:0x2308
  ,simpleTitleCaseMapping:0x2308
 },
 { code:0x2309
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2309
  ,simpleLowerCaseMapping:0x2309
  ,simpleTitleCaseMapping:0x2309
 },
 { code:0x230A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x230A
  ,simpleLowerCaseMapping:0x230A
  ,simpleTitleCaseMapping:0x230A
 },
 { code:0x230B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x230B
  ,simpleLowerCaseMapping:0x230B
  ,simpleTitleCaseMapping:0x230B
 },
 { code:0x230C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x230C
  ,simpleLowerCaseMapping:0x230C
  ,simpleTitleCaseMapping:0x230C
 },
 { code:0x230D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x230D
  ,simpleLowerCaseMapping:0x230D
  ,simpleTitleCaseMapping:0x230D
 },
 { code:0x230E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x230E
  ,simpleLowerCaseMapping:0x230E
  ,simpleTitleCaseMapping:0x230E
 },
 { code:0x230F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x230F
  ,simpleLowerCaseMapping:0x230F
  ,simpleTitleCaseMapping:0x230F
 },
 { code:0x2310
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2310
  ,simpleLowerCaseMapping:0x2310
  ,simpleTitleCaseMapping:0x2310
 },
 { code:0x2311
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2311
  ,simpleLowerCaseMapping:0x2311
  ,simpleTitleCaseMapping:0x2311
 },
 { code:0x2312
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2312
  ,simpleLowerCaseMapping:0x2312
  ,simpleTitleCaseMapping:0x2312
 },
 { code:0x2313
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2313
  ,simpleLowerCaseMapping:0x2313
  ,simpleTitleCaseMapping:0x2313
 },
 { code:0x2314
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2314
  ,simpleLowerCaseMapping:0x2314
  ,simpleTitleCaseMapping:0x2314
 },
 { code:0x2315
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2315
  ,simpleLowerCaseMapping:0x2315
  ,simpleTitleCaseMapping:0x2315
 },
 { code:0x2316
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2316
  ,simpleLowerCaseMapping:0x2316
  ,simpleTitleCaseMapping:0x2316
 },
 { code:0x2317
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2317
  ,simpleLowerCaseMapping:0x2317
  ,simpleTitleCaseMapping:0x2317
 },
 { code:0x2318
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2318
  ,simpleLowerCaseMapping:0x2318
  ,simpleTitleCaseMapping:0x2318
 },
 { code:0x2319
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2319
  ,simpleLowerCaseMapping:0x2319
  ,simpleTitleCaseMapping:0x2319
 },
 { code:0x231A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x231A
  ,simpleLowerCaseMapping:0x231A
  ,simpleTitleCaseMapping:0x231A
 },
 { code:0x231B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x231B
  ,simpleLowerCaseMapping:0x231B
  ,simpleTitleCaseMapping:0x231B
 },
 { code:0x231C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x231C
  ,simpleLowerCaseMapping:0x231C
  ,simpleTitleCaseMapping:0x231C
 },
 { code:0x231D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x231D
  ,simpleLowerCaseMapping:0x231D
  ,simpleTitleCaseMapping:0x231D
 },
 { code:0x231E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x231E
  ,simpleLowerCaseMapping:0x231E
  ,simpleTitleCaseMapping:0x231E
 },
 { code:0x231F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x231F
  ,simpleLowerCaseMapping:0x231F
  ,simpleTitleCaseMapping:0x231F
 },
 { code:0x2320
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2320
  ,simpleLowerCaseMapping:0x2320
  ,simpleTitleCaseMapping:0x2320
 },
 { code:0x2321
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2321
  ,simpleLowerCaseMapping:0x2321
  ,simpleTitleCaseMapping:0x2321
 },
 { code:0x2322
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2322
  ,simpleLowerCaseMapping:0x2322
  ,simpleTitleCaseMapping:0x2322
 },
 { code:0x2323
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2323
  ,simpleLowerCaseMapping:0x2323
  ,simpleTitleCaseMapping:0x2323
 },
 { code:0x2324
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2324
  ,simpleLowerCaseMapping:0x2324
  ,simpleTitleCaseMapping:0x2324
 },
 { code:0x2325
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2325
  ,simpleLowerCaseMapping:0x2325
  ,simpleTitleCaseMapping:0x2325
 },
 { code:0x2326
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2326
  ,simpleLowerCaseMapping:0x2326
  ,simpleTitleCaseMapping:0x2326
 },
 { code:0x2327
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2327
  ,simpleLowerCaseMapping:0x2327
  ,simpleTitleCaseMapping:0x2327
 },
 { code:0x2328
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2328
  ,simpleLowerCaseMapping:0x2328
  ,simpleTitleCaseMapping:0x2328
 },
 { code:0x2329
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x2329
  ,simpleLowerCaseMapping:0x2329
  ,simpleTitleCaseMapping:0x2329
 },
 { code:0x232A
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x232A
  ,simpleLowerCaseMapping:0x232A
  ,simpleTitleCaseMapping:0x232A
 },
 { code:0x232B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x232B
  ,simpleLowerCaseMapping:0x232B
  ,simpleTitleCaseMapping:0x232B
 },
 { code:0x232C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x232C
  ,simpleLowerCaseMapping:0x232C
  ,simpleTitleCaseMapping:0x232C
 },
 { code:0x232D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x232D
  ,simpleLowerCaseMapping:0x232D
  ,simpleTitleCaseMapping:0x232D
 },
 { code:0x232E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x232E
  ,simpleLowerCaseMapping:0x232E
  ,simpleTitleCaseMapping:0x232E
 },
 { code:0x232F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x232F
  ,simpleLowerCaseMapping:0x232F
  ,simpleTitleCaseMapping:0x232F
 },
 { code:0x2330
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2330
  ,simpleLowerCaseMapping:0x2330
  ,simpleTitleCaseMapping:0x2330
 },
 { code:0x2331
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2331
  ,simpleLowerCaseMapping:0x2331
  ,simpleTitleCaseMapping:0x2331
 },
 { code:0x2332
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2332
  ,simpleLowerCaseMapping:0x2332
  ,simpleTitleCaseMapping:0x2332
 },
 { code:0x2333
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2333
  ,simpleLowerCaseMapping:0x2333
  ,simpleTitleCaseMapping:0x2333
 },
 { code:0x2334
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2334
  ,simpleLowerCaseMapping:0x2334
  ,simpleTitleCaseMapping:0x2334
 },
 { code:0x2335
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2335
  ,simpleLowerCaseMapping:0x2335
  ,simpleTitleCaseMapping:0x2335
 },
 { code:0x2336
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2336
  ,simpleLowerCaseMapping:0x2336
  ,simpleTitleCaseMapping:0x2336
 },
 { code:0x2337
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2337
  ,simpleLowerCaseMapping:0x2337
  ,simpleTitleCaseMapping:0x2337
 },
 { code:0x2338
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2338
  ,simpleLowerCaseMapping:0x2338
  ,simpleTitleCaseMapping:0x2338
 },
 { code:0x2339
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2339
  ,simpleLowerCaseMapping:0x2339
  ,simpleTitleCaseMapping:0x2339
 },
 { code:0x233A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x233A
  ,simpleLowerCaseMapping:0x233A
  ,simpleTitleCaseMapping:0x233A
 },
 { code:0x233B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x233B
  ,simpleLowerCaseMapping:0x233B
  ,simpleTitleCaseMapping:0x233B
 },
 { code:0x233C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x233C
  ,simpleLowerCaseMapping:0x233C
  ,simpleTitleCaseMapping:0x233C
 },
 { code:0x233D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x233D
  ,simpleLowerCaseMapping:0x233D
  ,simpleTitleCaseMapping:0x233D
 },
 { code:0x233E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x233E
  ,simpleLowerCaseMapping:0x233E
  ,simpleTitleCaseMapping:0x233E
 },
 { code:0x233F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x233F
  ,simpleLowerCaseMapping:0x233F
  ,simpleTitleCaseMapping:0x233F
 },
 { code:0x2340
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2340
  ,simpleLowerCaseMapping:0x2340
  ,simpleTitleCaseMapping:0x2340
 },
 { code:0x2341
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2341
  ,simpleLowerCaseMapping:0x2341
  ,simpleTitleCaseMapping:0x2341
 },
 { code:0x2342
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2342
  ,simpleLowerCaseMapping:0x2342
  ,simpleTitleCaseMapping:0x2342
 },
 { code:0x2343
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2343
  ,simpleLowerCaseMapping:0x2343
  ,simpleTitleCaseMapping:0x2343
 },
 { code:0x2344
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2344
  ,simpleLowerCaseMapping:0x2344
  ,simpleTitleCaseMapping:0x2344
 },
 { code:0x2345
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2345
  ,simpleLowerCaseMapping:0x2345
  ,simpleTitleCaseMapping:0x2345
 },
 { code:0x2346
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2346
  ,simpleLowerCaseMapping:0x2346
  ,simpleTitleCaseMapping:0x2346
 },
 { code:0x2347
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2347
  ,simpleLowerCaseMapping:0x2347
  ,simpleTitleCaseMapping:0x2347
 },
 { code:0x2348
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2348
  ,simpleLowerCaseMapping:0x2348
  ,simpleTitleCaseMapping:0x2348
 },
 { code:0x2349
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2349
  ,simpleLowerCaseMapping:0x2349
  ,simpleTitleCaseMapping:0x2349
 },
 { code:0x234A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x234A
  ,simpleLowerCaseMapping:0x234A
  ,simpleTitleCaseMapping:0x234A
 },
 { code:0x234B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x234B
  ,simpleLowerCaseMapping:0x234B
  ,simpleTitleCaseMapping:0x234B
 },
 { code:0x234C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x234C
  ,simpleLowerCaseMapping:0x234C
  ,simpleTitleCaseMapping:0x234C
 },
 { code:0x234D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x234D
  ,simpleLowerCaseMapping:0x234D
  ,simpleTitleCaseMapping:0x234D
 },
 { code:0x234E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x234E
  ,simpleLowerCaseMapping:0x234E
  ,simpleTitleCaseMapping:0x234E
 },
 { code:0x234F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x234F
  ,simpleLowerCaseMapping:0x234F
  ,simpleTitleCaseMapping:0x234F
 },
 { code:0x2350
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2350
  ,simpleLowerCaseMapping:0x2350
  ,simpleTitleCaseMapping:0x2350
 },
 { code:0x2351
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2351
  ,simpleLowerCaseMapping:0x2351
  ,simpleTitleCaseMapping:0x2351
 },
 { code:0x2352
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2352
  ,simpleLowerCaseMapping:0x2352
  ,simpleTitleCaseMapping:0x2352
 },
 { code:0x2353
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2353
  ,simpleLowerCaseMapping:0x2353
  ,simpleTitleCaseMapping:0x2353
 },
 { code:0x2354
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2354
  ,simpleLowerCaseMapping:0x2354
  ,simpleTitleCaseMapping:0x2354
 },
 { code:0x2355
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2355
  ,simpleLowerCaseMapping:0x2355
  ,simpleTitleCaseMapping:0x2355
 },
 { code:0x2356
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2356
  ,simpleLowerCaseMapping:0x2356
  ,simpleTitleCaseMapping:0x2356
 },
 { code:0x2357
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2357
  ,simpleLowerCaseMapping:0x2357
  ,simpleTitleCaseMapping:0x2357
 },
 { code:0x2358
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2358
  ,simpleLowerCaseMapping:0x2358
  ,simpleTitleCaseMapping:0x2358
 },
 { code:0x2359
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2359
  ,simpleLowerCaseMapping:0x2359
  ,simpleTitleCaseMapping:0x2359
 },
 { code:0x235A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x235A
  ,simpleLowerCaseMapping:0x235A
  ,simpleTitleCaseMapping:0x235A
 },
 { code:0x235B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x235B
  ,simpleLowerCaseMapping:0x235B
  ,simpleTitleCaseMapping:0x235B
 },
 { code:0x235C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x235C
  ,simpleLowerCaseMapping:0x235C
  ,simpleTitleCaseMapping:0x235C
 },
 { code:0x235D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x235D
  ,simpleLowerCaseMapping:0x235D
  ,simpleTitleCaseMapping:0x235D
 },
 { code:0x235E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x235E
  ,simpleLowerCaseMapping:0x235E
  ,simpleTitleCaseMapping:0x235E
 },
 { code:0x235F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x235F
  ,simpleLowerCaseMapping:0x235F
  ,simpleTitleCaseMapping:0x235F
 },
 { code:0x2360
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2360
  ,simpleLowerCaseMapping:0x2360
  ,simpleTitleCaseMapping:0x2360
 },
 { code:0x2361
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2361
  ,simpleLowerCaseMapping:0x2361
  ,simpleTitleCaseMapping:0x2361
 },
 { code:0x2362
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2362
  ,simpleLowerCaseMapping:0x2362
  ,simpleTitleCaseMapping:0x2362
 },
 { code:0x2363
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2363
  ,simpleLowerCaseMapping:0x2363
  ,simpleTitleCaseMapping:0x2363
 },
 { code:0x2364
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2364
  ,simpleLowerCaseMapping:0x2364
  ,simpleTitleCaseMapping:0x2364
 },
 { code:0x2365
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2365
  ,simpleLowerCaseMapping:0x2365
  ,simpleTitleCaseMapping:0x2365
 },
 { code:0x2366
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2366
  ,simpleLowerCaseMapping:0x2366
  ,simpleTitleCaseMapping:0x2366
 },
 { code:0x2367
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2367
  ,simpleLowerCaseMapping:0x2367
  ,simpleTitleCaseMapping:0x2367
 },
 { code:0x2368
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2368
  ,simpleLowerCaseMapping:0x2368
  ,simpleTitleCaseMapping:0x2368
 },
 { code:0x2369
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2369
  ,simpleLowerCaseMapping:0x2369
  ,simpleTitleCaseMapping:0x2369
 },
 { code:0x236A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x236A
  ,simpleLowerCaseMapping:0x236A
  ,simpleTitleCaseMapping:0x236A
 },
 { code:0x236B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x236B
  ,simpleLowerCaseMapping:0x236B
  ,simpleTitleCaseMapping:0x236B
 },
 { code:0x236C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x236C
  ,simpleLowerCaseMapping:0x236C
  ,simpleTitleCaseMapping:0x236C
 },
 { code:0x236D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x236D
  ,simpleLowerCaseMapping:0x236D
  ,simpleTitleCaseMapping:0x236D
 },
 { code:0x236E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x236E
  ,simpleLowerCaseMapping:0x236E
  ,simpleTitleCaseMapping:0x236E
 },
 { code:0x236F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x236F
  ,simpleLowerCaseMapping:0x236F
  ,simpleTitleCaseMapping:0x236F
 },
 { code:0x2370
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2370
  ,simpleLowerCaseMapping:0x2370
  ,simpleTitleCaseMapping:0x2370
 },
 { code:0x2371
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2371
  ,simpleLowerCaseMapping:0x2371
  ,simpleTitleCaseMapping:0x2371
 },
 { code:0x2372
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2372
  ,simpleLowerCaseMapping:0x2372
  ,simpleTitleCaseMapping:0x2372
 },
 { code:0x2373
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2373
  ,simpleLowerCaseMapping:0x2373
  ,simpleTitleCaseMapping:0x2373
 },
 { code:0x2374
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2374
  ,simpleLowerCaseMapping:0x2374
  ,simpleTitleCaseMapping:0x2374
 },
 { code:0x2375
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2375
  ,simpleLowerCaseMapping:0x2375
  ,simpleTitleCaseMapping:0x2375
 },
 { code:0x2376
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2376
  ,simpleLowerCaseMapping:0x2376
  ,simpleTitleCaseMapping:0x2376
 },
 { code:0x2377
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2377
  ,simpleLowerCaseMapping:0x2377
  ,simpleTitleCaseMapping:0x2377
 },
 { code:0x2378
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2378
  ,simpleLowerCaseMapping:0x2378
  ,simpleTitleCaseMapping:0x2378
 },
 { code:0x2379
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2379
  ,simpleLowerCaseMapping:0x2379
  ,simpleTitleCaseMapping:0x2379
 },
 { code:0x237A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x237A
  ,simpleLowerCaseMapping:0x237A
  ,simpleTitleCaseMapping:0x237A
 },
 { code:0x237B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x237B
  ,simpleLowerCaseMapping:0x237B
  ,simpleTitleCaseMapping:0x237B
 },
 { code:0x237C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x237C
  ,simpleLowerCaseMapping:0x237C
  ,simpleTitleCaseMapping:0x237C
 },
 { code:0x237D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x237D
  ,simpleLowerCaseMapping:0x237D
  ,simpleTitleCaseMapping:0x237D
 },
 { code:0x237E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x237E
  ,simpleLowerCaseMapping:0x237E
  ,simpleTitleCaseMapping:0x237E
 },
 { code:0x237F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x237F
  ,simpleLowerCaseMapping:0x237F
  ,simpleTitleCaseMapping:0x237F
 },
 { code:0x2380
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2380
  ,simpleLowerCaseMapping:0x2380
  ,simpleTitleCaseMapping:0x2380
 },
 { code:0x2381
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2381
  ,simpleLowerCaseMapping:0x2381
  ,simpleTitleCaseMapping:0x2381
 },
 { code:0x2382
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2382
  ,simpleLowerCaseMapping:0x2382
  ,simpleTitleCaseMapping:0x2382
 },
 { code:0x2383
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2383
  ,simpleLowerCaseMapping:0x2383
  ,simpleTitleCaseMapping:0x2383
 },
 { code:0x2384
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2384
  ,simpleLowerCaseMapping:0x2384
  ,simpleTitleCaseMapping:0x2384
 },
 { code:0x2385
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2385
  ,simpleLowerCaseMapping:0x2385
  ,simpleTitleCaseMapping:0x2385
 },
 { code:0x2386
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2386
  ,simpleLowerCaseMapping:0x2386
  ,simpleTitleCaseMapping:0x2386
 },
 { code:0x2387
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2387
  ,simpleLowerCaseMapping:0x2387
  ,simpleTitleCaseMapping:0x2387
 },
 { code:0x2388
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2388
  ,simpleLowerCaseMapping:0x2388
  ,simpleTitleCaseMapping:0x2388
 },
 { code:0x2389
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2389
  ,simpleLowerCaseMapping:0x2389
  ,simpleTitleCaseMapping:0x2389
 },
 { code:0x238A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x238A
  ,simpleLowerCaseMapping:0x238A
  ,simpleTitleCaseMapping:0x238A
 },
 { code:0x238B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x238B
  ,simpleLowerCaseMapping:0x238B
  ,simpleTitleCaseMapping:0x238B
 },
 { code:0x238C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x238C
  ,simpleLowerCaseMapping:0x238C
  ,simpleTitleCaseMapping:0x238C
 },
 { code:0x238D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x238D
  ,simpleLowerCaseMapping:0x238D
  ,simpleTitleCaseMapping:0x238D
 },
 { code:0x238E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x238E
  ,simpleLowerCaseMapping:0x238E
  ,simpleTitleCaseMapping:0x238E
 },
 { code:0x238F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x238F
  ,simpleLowerCaseMapping:0x238F
  ,simpleTitleCaseMapping:0x238F
 },
 { code:0x2390
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2390
  ,simpleLowerCaseMapping:0x2390
  ,simpleTitleCaseMapping:0x2390
 },
 { code:0x2391
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2391
  ,simpleLowerCaseMapping:0x2391
  ,simpleTitleCaseMapping:0x2391
 },
 { code:0x2392
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2392
  ,simpleLowerCaseMapping:0x2392
  ,simpleTitleCaseMapping:0x2392
 },
 { code:0x2393
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2393
  ,simpleLowerCaseMapping:0x2393
  ,simpleTitleCaseMapping:0x2393
 },
 { code:0x2394
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2394
  ,simpleLowerCaseMapping:0x2394
  ,simpleTitleCaseMapping:0x2394
 },
 { code:0x2395
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2395
  ,simpleLowerCaseMapping:0x2395
  ,simpleTitleCaseMapping:0x2395
 },
 { code:0x2396
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2396
  ,simpleLowerCaseMapping:0x2396
  ,simpleTitleCaseMapping:0x2396
 },
 { code:0x2397
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2397
  ,simpleLowerCaseMapping:0x2397
  ,simpleTitleCaseMapping:0x2397
 },
 { code:0x2398
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2398
  ,simpleLowerCaseMapping:0x2398
  ,simpleTitleCaseMapping:0x2398
 },
 { code:0x2399
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2399
  ,simpleLowerCaseMapping:0x2399
  ,simpleTitleCaseMapping:0x2399
 },
 { code:0x239A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x239A
  ,simpleLowerCaseMapping:0x239A
  ,simpleTitleCaseMapping:0x239A
 },
 { code:0x239B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x239B
  ,simpleLowerCaseMapping:0x239B
  ,simpleTitleCaseMapping:0x239B
 },
 { code:0x239C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x239C
  ,simpleLowerCaseMapping:0x239C
  ,simpleTitleCaseMapping:0x239C
 },
 { code:0x239D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x239D
  ,simpleLowerCaseMapping:0x239D
  ,simpleTitleCaseMapping:0x239D
 },
 { code:0x239E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x239E
  ,simpleLowerCaseMapping:0x239E
  ,simpleTitleCaseMapping:0x239E
 },
 { code:0x239F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x239F
  ,simpleLowerCaseMapping:0x239F
  ,simpleTitleCaseMapping:0x239F
 },
 { code:0x23A0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23A0
  ,simpleLowerCaseMapping:0x23A0
  ,simpleTitleCaseMapping:0x23A0
 },
 { code:0x23A1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23A1
  ,simpleLowerCaseMapping:0x23A1
  ,simpleTitleCaseMapping:0x23A1
 },
 { code:0x23A2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23A2
  ,simpleLowerCaseMapping:0x23A2
  ,simpleTitleCaseMapping:0x23A2
 },
 { code:0x23A3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23A3
  ,simpleLowerCaseMapping:0x23A3
  ,simpleTitleCaseMapping:0x23A3
 },
 { code:0x23A4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23A4
  ,simpleLowerCaseMapping:0x23A4
  ,simpleTitleCaseMapping:0x23A4
 },
 { code:0x23A5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23A5
  ,simpleLowerCaseMapping:0x23A5
  ,simpleTitleCaseMapping:0x23A5
 },
 { code:0x23A6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23A6
  ,simpleLowerCaseMapping:0x23A6
  ,simpleTitleCaseMapping:0x23A6
 },
 { code:0x23A7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23A7
  ,simpleLowerCaseMapping:0x23A7
  ,simpleTitleCaseMapping:0x23A7
 },
 { code:0x23A8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23A8
  ,simpleLowerCaseMapping:0x23A8
  ,simpleTitleCaseMapping:0x23A8
 },
 { code:0x23A9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23A9
  ,simpleLowerCaseMapping:0x23A9
  ,simpleTitleCaseMapping:0x23A9
 },
 { code:0x23AA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23AA
  ,simpleLowerCaseMapping:0x23AA
  ,simpleTitleCaseMapping:0x23AA
 },
 { code:0x23AB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23AB
  ,simpleLowerCaseMapping:0x23AB
  ,simpleTitleCaseMapping:0x23AB
 },
 { code:0x23AC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23AC
  ,simpleLowerCaseMapping:0x23AC
  ,simpleTitleCaseMapping:0x23AC
 },
 { code:0x23AD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23AD
  ,simpleLowerCaseMapping:0x23AD
  ,simpleTitleCaseMapping:0x23AD
 },
 { code:0x23AE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23AE
  ,simpleLowerCaseMapping:0x23AE
  ,simpleTitleCaseMapping:0x23AE
 },
 { code:0x23AF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23AF
  ,simpleLowerCaseMapping:0x23AF
  ,simpleTitleCaseMapping:0x23AF
 },
 { code:0x23B0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23B0
  ,simpleLowerCaseMapping:0x23B0
  ,simpleTitleCaseMapping:0x23B0
 },
 { code:0x23B1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23B1
  ,simpleLowerCaseMapping:0x23B1
  ,simpleTitleCaseMapping:0x23B1
 },
 { code:0x23B2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23B2
  ,simpleLowerCaseMapping:0x23B2
  ,simpleTitleCaseMapping:0x23B2
 },
 { code:0x23B3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23B3
  ,simpleLowerCaseMapping:0x23B3
  ,simpleTitleCaseMapping:0x23B3
 },
 { code:0x23B4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23B4
  ,simpleLowerCaseMapping:0x23B4
  ,simpleTitleCaseMapping:0x23B4
 },
 { code:0x23B5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23B5
  ,simpleLowerCaseMapping:0x23B5
  ,simpleTitleCaseMapping:0x23B5
 },
 { code:0x23B6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23B6
  ,simpleLowerCaseMapping:0x23B6
  ,simpleTitleCaseMapping:0x23B6
 },
 { code:0x23B7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23B7
  ,simpleLowerCaseMapping:0x23B7
  ,simpleTitleCaseMapping:0x23B7
 },
 { code:0x23B8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23B8
  ,simpleLowerCaseMapping:0x23B8
  ,simpleTitleCaseMapping:0x23B8
 },
 { code:0x23B9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23B9
  ,simpleLowerCaseMapping:0x23B9
  ,simpleTitleCaseMapping:0x23B9
 },
 { code:0x23BA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23BA
  ,simpleLowerCaseMapping:0x23BA
  ,simpleTitleCaseMapping:0x23BA
 },
 { code:0x23BB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23BB
  ,simpleLowerCaseMapping:0x23BB
  ,simpleTitleCaseMapping:0x23BB
 },
 { code:0x23BC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23BC
  ,simpleLowerCaseMapping:0x23BC
  ,simpleTitleCaseMapping:0x23BC
 },
 { code:0x23BD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23BD
  ,simpleLowerCaseMapping:0x23BD
  ,simpleTitleCaseMapping:0x23BD
 },
 { code:0x23BE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23BE
  ,simpleLowerCaseMapping:0x23BE
  ,simpleTitleCaseMapping:0x23BE
 },
 { code:0x23BF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23BF
  ,simpleLowerCaseMapping:0x23BF
  ,simpleTitleCaseMapping:0x23BF
 },
 { code:0x23C0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23C0
  ,simpleLowerCaseMapping:0x23C0
  ,simpleTitleCaseMapping:0x23C0
 },
 { code:0x23C1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23C1
  ,simpleLowerCaseMapping:0x23C1
  ,simpleTitleCaseMapping:0x23C1
 },
 { code:0x23C2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23C2
  ,simpleLowerCaseMapping:0x23C2
  ,simpleTitleCaseMapping:0x23C2
 },
 { code:0x23C3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23C3
  ,simpleLowerCaseMapping:0x23C3
  ,simpleTitleCaseMapping:0x23C3
 },
 { code:0x23C4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23C4
  ,simpleLowerCaseMapping:0x23C4
  ,simpleTitleCaseMapping:0x23C4
 },
 { code:0x23C5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23C5
  ,simpleLowerCaseMapping:0x23C5
  ,simpleTitleCaseMapping:0x23C5
 },
 { code:0x23C6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23C6
  ,simpleLowerCaseMapping:0x23C6
  ,simpleTitleCaseMapping:0x23C6
 },
 { code:0x23C7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23C7
  ,simpleLowerCaseMapping:0x23C7
  ,simpleTitleCaseMapping:0x23C7
 },
 { code:0x23C8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23C8
  ,simpleLowerCaseMapping:0x23C8
  ,simpleTitleCaseMapping:0x23C8
 },
 { code:0x23C9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23C9
  ,simpleLowerCaseMapping:0x23C9
  ,simpleTitleCaseMapping:0x23C9
 },
 { code:0x23CA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23CA
  ,simpleLowerCaseMapping:0x23CA
  ,simpleTitleCaseMapping:0x23CA
 },
 { code:0x23CB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23CB
  ,simpleLowerCaseMapping:0x23CB
  ,simpleTitleCaseMapping:0x23CB
 },
 { code:0x23CC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23CC
  ,simpleLowerCaseMapping:0x23CC
  ,simpleTitleCaseMapping:0x23CC
 },
 { code:0x23CD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23CD
  ,simpleLowerCaseMapping:0x23CD
  ,simpleTitleCaseMapping:0x23CD
 },
 { code:0x23CE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23CE
  ,simpleLowerCaseMapping:0x23CE
  ,simpleTitleCaseMapping:0x23CE
 },
 { code:0x23CF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23CF
  ,simpleLowerCaseMapping:0x23CF
  ,simpleTitleCaseMapping:0x23CF
 },
 { code:0x23D0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23D0
  ,simpleLowerCaseMapping:0x23D0
  ,simpleTitleCaseMapping:0x23D0
 },
 { code:0x23D1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23D1
  ,simpleLowerCaseMapping:0x23D1
  ,simpleTitleCaseMapping:0x23D1
 },
 { code:0x23D2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23D2
  ,simpleLowerCaseMapping:0x23D2
  ,simpleTitleCaseMapping:0x23D2
 },
 { code:0x23D3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23D3
  ,simpleLowerCaseMapping:0x23D3
  ,simpleTitleCaseMapping:0x23D3
 },
 { code:0x23D4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23D4
  ,simpleLowerCaseMapping:0x23D4
  ,simpleTitleCaseMapping:0x23D4
 },
 { code:0x23D5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23D5
  ,simpleLowerCaseMapping:0x23D5
  ,simpleTitleCaseMapping:0x23D5
 },
 { code:0x23D6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23D6
  ,simpleLowerCaseMapping:0x23D6
  ,simpleTitleCaseMapping:0x23D6
 },
 { code:0x23D7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23D7
  ,simpleLowerCaseMapping:0x23D7
  ,simpleTitleCaseMapping:0x23D7
 },
 { code:0x23D8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23D8
  ,simpleLowerCaseMapping:0x23D8
  ,simpleTitleCaseMapping:0x23D8
 },
 { code:0x23D9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23D9
  ,simpleLowerCaseMapping:0x23D9
  ,simpleTitleCaseMapping:0x23D9
 },
 { code:0x23DA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23DA
  ,simpleLowerCaseMapping:0x23DA
  ,simpleTitleCaseMapping:0x23DA
 },
 { code:0x23DB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23DB
  ,simpleLowerCaseMapping:0x23DB
  ,simpleTitleCaseMapping:0x23DB
 },
 { code:0x23DC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23DC
  ,simpleLowerCaseMapping:0x23DC
  ,simpleTitleCaseMapping:0x23DC
 },
 { code:0x23DD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23DD
  ,simpleLowerCaseMapping:0x23DD
  ,simpleTitleCaseMapping:0x23DD
 },
 { code:0x23DE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23DE
  ,simpleLowerCaseMapping:0x23DE
  ,simpleTitleCaseMapping:0x23DE
 },
 { code:0x23DF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23DF
  ,simpleLowerCaseMapping:0x23DF
  ,simpleTitleCaseMapping:0x23DF
 },
 { code:0x23E0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23E0
  ,simpleLowerCaseMapping:0x23E0
  ,simpleTitleCaseMapping:0x23E0
 },
 { code:0x23E1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x23E1
  ,simpleLowerCaseMapping:0x23E1
  ,simpleTitleCaseMapping:0x23E1
 },
 { code:0x23E2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23E2
  ,simpleLowerCaseMapping:0x23E2
  ,simpleTitleCaseMapping:0x23E2
 },
 { code:0x23E3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23E3
  ,simpleLowerCaseMapping:0x23E3
  ,simpleTitleCaseMapping:0x23E3
 },
 { code:0x23E4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23E4
  ,simpleLowerCaseMapping:0x23E4
  ,simpleTitleCaseMapping:0x23E4
 },
 { code:0x23E5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23E5
  ,simpleLowerCaseMapping:0x23E5
  ,simpleTitleCaseMapping:0x23E5
 },
 { code:0x23E6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23E6
  ,simpleLowerCaseMapping:0x23E6
  ,simpleTitleCaseMapping:0x23E6
 },
 { code:0x23E7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x23E7
  ,simpleLowerCaseMapping:0x23E7
  ,simpleTitleCaseMapping:0x23E7
 },
 { code:0x2400
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2400
  ,simpleLowerCaseMapping:0x2400
  ,simpleTitleCaseMapping:0x2400
 },
 { code:0x2401
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2401
  ,simpleLowerCaseMapping:0x2401
  ,simpleTitleCaseMapping:0x2401
 },
 { code:0x2402
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2402
  ,simpleLowerCaseMapping:0x2402
  ,simpleTitleCaseMapping:0x2402
 },
 { code:0x2403
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2403
  ,simpleLowerCaseMapping:0x2403
  ,simpleTitleCaseMapping:0x2403
 },
 { code:0x2404
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2404
  ,simpleLowerCaseMapping:0x2404
  ,simpleTitleCaseMapping:0x2404
 },
 { code:0x2405
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2405
  ,simpleLowerCaseMapping:0x2405
  ,simpleTitleCaseMapping:0x2405
 },
 { code:0x2406
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2406
  ,simpleLowerCaseMapping:0x2406
  ,simpleTitleCaseMapping:0x2406
 },
 { code:0x2407
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2407
  ,simpleLowerCaseMapping:0x2407
  ,simpleTitleCaseMapping:0x2407
 },
 { code:0x2408
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2408
  ,simpleLowerCaseMapping:0x2408
  ,simpleTitleCaseMapping:0x2408
 },
 { code:0x2409
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2409
  ,simpleLowerCaseMapping:0x2409
  ,simpleTitleCaseMapping:0x2409
 },
 { code:0x240A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x240A
  ,simpleLowerCaseMapping:0x240A
  ,simpleTitleCaseMapping:0x240A
 },
 { code:0x240B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x240B
  ,simpleLowerCaseMapping:0x240B
  ,simpleTitleCaseMapping:0x240B
 },
 { code:0x240C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x240C
  ,simpleLowerCaseMapping:0x240C
  ,simpleTitleCaseMapping:0x240C
 },
 { code:0x240D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x240D
  ,simpleLowerCaseMapping:0x240D
  ,simpleTitleCaseMapping:0x240D
 },
 { code:0x240E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x240E
  ,simpleLowerCaseMapping:0x240E
  ,simpleTitleCaseMapping:0x240E
 },
 { code:0x240F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x240F
  ,simpleLowerCaseMapping:0x240F
  ,simpleTitleCaseMapping:0x240F
 },
 { code:0x2410
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2410
  ,simpleLowerCaseMapping:0x2410
  ,simpleTitleCaseMapping:0x2410
 },
 { code:0x2411
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2411
  ,simpleLowerCaseMapping:0x2411
  ,simpleTitleCaseMapping:0x2411
 },
 { code:0x2412
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2412
  ,simpleLowerCaseMapping:0x2412
  ,simpleTitleCaseMapping:0x2412
 },
 { code:0x2413
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2413
  ,simpleLowerCaseMapping:0x2413
  ,simpleTitleCaseMapping:0x2413
 },
 { code:0x2414
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2414
  ,simpleLowerCaseMapping:0x2414
  ,simpleTitleCaseMapping:0x2414
 },
 { code:0x2415
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2415
  ,simpleLowerCaseMapping:0x2415
  ,simpleTitleCaseMapping:0x2415
 },
 { code:0x2416
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2416
  ,simpleLowerCaseMapping:0x2416
  ,simpleTitleCaseMapping:0x2416
 },
 { code:0x2417
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2417
  ,simpleLowerCaseMapping:0x2417
  ,simpleTitleCaseMapping:0x2417
 },
 { code:0x2418
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2418
  ,simpleLowerCaseMapping:0x2418
  ,simpleTitleCaseMapping:0x2418
 },
 { code:0x2419
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2419
  ,simpleLowerCaseMapping:0x2419
  ,simpleTitleCaseMapping:0x2419
 },
 { code:0x241A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x241A
  ,simpleLowerCaseMapping:0x241A
  ,simpleTitleCaseMapping:0x241A
 },
 { code:0x241B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x241B
  ,simpleLowerCaseMapping:0x241B
  ,simpleTitleCaseMapping:0x241B
 },
 { code:0x241C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x241C
  ,simpleLowerCaseMapping:0x241C
  ,simpleTitleCaseMapping:0x241C
 },
 { code:0x241D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x241D
  ,simpleLowerCaseMapping:0x241D
  ,simpleTitleCaseMapping:0x241D
 },
 { code:0x241E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x241E
  ,simpleLowerCaseMapping:0x241E
  ,simpleTitleCaseMapping:0x241E
 },
 { code:0x241F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x241F
  ,simpleLowerCaseMapping:0x241F
  ,simpleTitleCaseMapping:0x241F
 },
 { code:0x2420
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2420
  ,simpleLowerCaseMapping:0x2420
  ,simpleTitleCaseMapping:0x2420
 },
 { code:0x2421
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2421
  ,simpleLowerCaseMapping:0x2421
  ,simpleTitleCaseMapping:0x2421
 },
 { code:0x2422
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2422
  ,simpleLowerCaseMapping:0x2422
  ,simpleTitleCaseMapping:0x2422
 },
 { code:0x2423
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2423
  ,simpleLowerCaseMapping:0x2423
  ,simpleTitleCaseMapping:0x2423
 },
 { code:0x2424
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2424
  ,simpleLowerCaseMapping:0x2424
  ,simpleTitleCaseMapping:0x2424
 },
 { code:0x2425
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2425
  ,simpleLowerCaseMapping:0x2425
  ,simpleTitleCaseMapping:0x2425
 },
 { code:0x2426
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2426
  ,simpleLowerCaseMapping:0x2426
  ,simpleTitleCaseMapping:0x2426
 },
 { code:0x2440
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2440
  ,simpleLowerCaseMapping:0x2440
  ,simpleTitleCaseMapping:0x2440
 },
 { code:0x2441
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2441
  ,simpleLowerCaseMapping:0x2441
  ,simpleTitleCaseMapping:0x2441
 },
 { code:0x2442
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2442
  ,simpleLowerCaseMapping:0x2442
  ,simpleTitleCaseMapping:0x2442
 },
 { code:0x2443
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2443
  ,simpleLowerCaseMapping:0x2443
  ,simpleTitleCaseMapping:0x2443
 },
 { code:0x2444
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2444
  ,simpleLowerCaseMapping:0x2444
  ,simpleTitleCaseMapping:0x2444
 },
 { code:0x2445
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2445
  ,simpleLowerCaseMapping:0x2445
  ,simpleTitleCaseMapping:0x2445
 },
 { code:0x2446
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2446
  ,simpleLowerCaseMapping:0x2446
  ,simpleTitleCaseMapping:0x2446
 },
 { code:0x2447
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2447
  ,simpleLowerCaseMapping:0x2447
  ,simpleTitleCaseMapping:0x2447
 },
 { code:0x2448
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2448
  ,simpleLowerCaseMapping:0x2448
  ,simpleTitleCaseMapping:0x2448
 },
 { code:0x2449
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2449
  ,simpleLowerCaseMapping:0x2449
  ,simpleTitleCaseMapping:0x2449
 },
 { code:0x244A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x244A
  ,simpleLowerCaseMapping:0x244A
  ,simpleTitleCaseMapping:0x244A
 },
 { code:0x2460
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2460
  ,simpleLowerCaseMapping:0x2460
  ,simpleTitleCaseMapping:0x2460
 },
 { code:0x2461
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2461
  ,simpleLowerCaseMapping:0x2461
  ,simpleTitleCaseMapping:0x2461
 },
 { code:0x2462
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2462
  ,simpleLowerCaseMapping:0x2462
  ,simpleTitleCaseMapping:0x2462
 },
 { code:0x2463
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2463
  ,simpleLowerCaseMapping:0x2463
  ,simpleTitleCaseMapping:0x2463
 },
 { code:0x2464
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2464
  ,simpleLowerCaseMapping:0x2464
  ,simpleTitleCaseMapping:0x2464
 },
 { code:0x2465
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2465
  ,simpleLowerCaseMapping:0x2465
  ,simpleTitleCaseMapping:0x2465
 },
 { code:0x2466
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2466
  ,simpleLowerCaseMapping:0x2466
  ,simpleTitleCaseMapping:0x2466
 },
 { code:0x2467
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2467
  ,simpleLowerCaseMapping:0x2467
  ,simpleTitleCaseMapping:0x2467
 },
 { code:0x2468
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2468
  ,simpleLowerCaseMapping:0x2468
  ,simpleTitleCaseMapping:0x2468
 },
 { code:0x2469
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2469
  ,simpleLowerCaseMapping:0x2469
  ,simpleTitleCaseMapping:0x2469
 },
 { code:0x246A
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x246A
  ,simpleLowerCaseMapping:0x246A
  ,simpleTitleCaseMapping:0x246A
 },
 { code:0x246B
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x246B
  ,simpleLowerCaseMapping:0x246B
  ,simpleTitleCaseMapping:0x246B
 },
 { code:0x246C
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x246C
  ,simpleLowerCaseMapping:0x246C
  ,simpleTitleCaseMapping:0x246C
 },
 { code:0x246D
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x246D
  ,simpleLowerCaseMapping:0x246D
  ,simpleTitleCaseMapping:0x246D
 },
 { code:0x246E
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x246E
  ,simpleLowerCaseMapping:0x246E
  ,simpleTitleCaseMapping:0x246E
 },
 { code:0x246F
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x246F
  ,simpleLowerCaseMapping:0x246F
  ,simpleTitleCaseMapping:0x246F
 },
 { code:0x2470
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2470
  ,simpleLowerCaseMapping:0x2470
  ,simpleTitleCaseMapping:0x2470
 },
 { code:0x2471
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2471
  ,simpleLowerCaseMapping:0x2471
  ,simpleTitleCaseMapping:0x2471
 },
 { code:0x2472
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2472
  ,simpleLowerCaseMapping:0x2472
  ,simpleTitleCaseMapping:0x2472
 },
 { code:0x2473
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2473
  ,simpleLowerCaseMapping:0x2473
  ,simpleTitleCaseMapping:0x2473
 },
 { code:0x2474
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2474
  ,simpleLowerCaseMapping:0x2474
  ,simpleTitleCaseMapping:0x2474
 },
 { code:0x2475
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2475
  ,simpleLowerCaseMapping:0x2475
  ,simpleTitleCaseMapping:0x2475
 },
 { code:0x2476
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2476
  ,simpleLowerCaseMapping:0x2476
  ,simpleTitleCaseMapping:0x2476
 },
 { code:0x2477
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2477
  ,simpleLowerCaseMapping:0x2477
  ,simpleTitleCaseMapping:0x2477
 },
 { code:0x2478
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2478
  ,simpleLowerCaseMapping:0x2478
  ,simpleTitleCaseMapping:0x2478
 },
 { code:0x2479
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2479
  ,simpleLowerCaseMapping:0x2479
  ,simpleTitleCaseMapping:0x2479
 },
 { code:0x247A
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x247A
  ,simpleLowerCaseMapping:0x247A
  ,simpleTitleCaseMapping:0x247A
 },
 { code:0x247B
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x247B
  ,simpleLowerCaseMapping:0x247B
  ,simpleTitleCaseMapping:0x247B
 },
 { code:0x247C
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x247C
  ,simpleLowerCaseMapping:0x247C
  ,simpleTitleCaseMapping:0x247C
 },
 { code:0x247D
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x247D
  ,simpleLowerCaseMapping:0x247D
  ,simpleTitleCaseMapping:0x247D
 },
 { code:0x247E
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x247E
  ,simpleLowerCaseMapping:0x247E
  ,simpleTitleCaseMapping:0x247E
 },
 { code:0x247F
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x247F
  ,simpleLowerCaseMapping:0x247F
  ,simpleTitleCaseMapping:0x247F
 },
 { code:0x2480
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2480
  ,simpleLowerCaseMapping:0x2480
  ,simpleTitleCaseMapping:0x2480
 },
 { code:0x2481
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2481
  ,simpleLowerCaseMapping:0x2481
  ,simpleTitleCaseMapping:0x2481
 },
 { code:0x2482
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2482
  ,simpleLowerCaseMapping:0x2482
  ,simpleTitleCaseMapping:0x2482
 },
 { code:0x2483
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2483
  ,simpleLowerCaseMapping:0x2483
  ,simpleTitleCaseMapping:0x2483
 },
 { code:0x2484
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2484
  ,simpleLowerCaseMapping:0x2484
  ,simpleTitleCaseMapping:0x2484
 },
 { code:0x2485
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2485
  ,simpleLowerCaseMapping:0x2485
  ,simpleTitleCaseMapping:0x2485
 },
 { code:0x2486
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2486
  ,simpleLowerCaseMapping:0x2486
  ,simpleTitleCaseMapping:0x2486
 },
 { code:0x2487
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2487
  ,simpleLowerCaseMapping:0x2487
  ,simpleTitleCaseMapping:0x2487
 },
 { code:0x2488
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2488
  ,simpleLowerCaseMapping:0x2488
  ,simpleTitleCaseMapping:0x2488
 },
 { code:0x2489
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2489
  ,simpleLowerCaseMapping:0x2489
  ,simpleTitleCaseMapping:0x2489
 },
 { code:0x248A
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x248A
  ,simpleLowerCaseMapping:0x248A
  ,simpleTitleCaseMapping:0x248A
 },
 { code:0x248B
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x248B
  ,simpleLowerCaseMapping:0x248B
  ,simpleTitleCaseMapping:0x248B
 },
 { code:0x248C
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x248C
  ,simpleLowerCaseMapping:0x248C
  ,simpleTitleCaseMapping:0x248C
 },
 { code:0x248D
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x248D
  ,simpleLowerCaseMapping:0x248D
  ,simpleTitleCaseMapping:0x248D
 },
 { code:0x248E
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x248E
  ,simpleLowerCaseMapping:0x248E
  ,simpleTitleCaseMapping:0x248E
 },
 { code:0x248F
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x248F
  ,simpleLowerCaseMapping:0x248F
  ,simpleTitleCaseMapping:0x248F
 },
 { code:0x2490
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2490
  ,simpleLowerCaseMapping:0x2490
  ,simpleTitleCaseMapping:0x2490
 },
 { code:0x2491
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2491
  ,simpleLowerCaseMapping:0x2491
  ,simpleTitleCaseMapping:0x2491
 },
 { code:0x2492
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2492
  ,simpleLowerCaseMapping:0x2492
  ,simpleTitleCaseMapping:0x2492
 },
 { code:0x2493
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2493
  ,simpleLowerCaseMapping:0x2493
  ,simpleTitleCaseMapping:0x2493
 },
 { code:0x2494
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2494
  ,simpleLowerCaseMapping:0x2494
  ,simpleTitleCaseMapping:0x2494
 },
 { code:0x2495
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2495
  ,simpleLowerCaseMapping:0x2495
  ,simpleTitleCaseMapping:0x2495
 },
 { code:0x2496
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2496
  ,simpleLowerCaseMapping:0x2496
  ,simpleTitleCaseMapping:0x2496
 },
 { code:0x2497
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2497
  ,simpleLowerCaseMapping:0x2497
  ,simpleTitleCaseMapping:0x2497
 },
 { code:0x2498
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2498
  ,simpleLowerCaseMapping:0x2498
  ,simpleTitleCaseMapping:0x2498
 },
 { code:0x2499
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2499
  ,simpleLowerCaseMapping:0x2499
  ,simpleTitleCaseMapping:0x2499
 },
 { code:0x249A
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x249A
  ,simpleLowerCaseMapping:0x249A
  ,simpleTitleCaseMapping:0x249A
 },
 { code:0x249B
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x249B
  ,simpleLowerCaseMapping:0x249B
  ,simpleTitleCaseMapping:0x249B
 },
 { code:0x249C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x249C
  ,simpleLowerCaseMapping:0x249C
  ,simpleTitleCaseMapping:0x249C
 },
 { code:0x249D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x249D
  ,simpleLowerCaseMapping:0x249D
  ,simpleTitleCaseMapping:0x249D
 },
 { code:0x249E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x249E
  ,simpleLowerCaseMapping:0x249E
  ,simpleTitleCaseMapping:0x249E
 },
 { code:0x249F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x249F
  ,simpleLowerCaseMapping:0x249F
  ,simpleTitleCaseMapping:0x249F
 },
 { code:0x24A0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24A0
  ,simpleLowerCaseMapping:0x24A0
  ,simpleTitleCaseMapping:0x24A0
 },
 { code:0x24A1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24A1
  ,simpleLowerCaseMapping:0x24A1
  ,simpleTitleCaseMapping:0x24A1
 },
 { code:0x24A2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24A2
  ,simpleLowerCaseMapping:0x24A2
  ,simpleTitleCaseMapping:0x24A2
 },
 { code:0x24A3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24A3
  ,simpleLowerCaseMapping:0x24A3
  ,simpleTitleCaseMapping:0x24A3
 },
 { code:0x24A4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24A4
  ,simpleLowerCaseMapping:0x24A4
  ,simpleTitleCaseMapping:0x24A4
 },
 { code:0x24A5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24A5
  ,simpleLowerCaseMapping:0x24A5
  ,simpleTitleCaseMapping:0x24A5
 },
 { code:0x24A6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24A6
  ,simpleLowerCaseMapping:0x24A6
  ,simpleTitleCaseMapping:0x24A6
 },
 { code:0x24A7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24A7
  ,simpleLowerCaseMapping:0x24A7
  ,simpleTitleCaseMapping:0x24A7
 },
 { code:0x24A8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24A8
  ,simpleLowerCaseMapping:0x24A8
  ,simpleTitleCaseMapping:0x24A8
 },
 { code:0x24A9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24A9
  ,simpleLowerCaseMapping:0x24A9
  ,simpleTitleCaseMapping:0x24A9
 },
 { code:0x24AA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24AA
  ,simpleLowerCaseMapping:0x24AA
  ,simpleTitleCaseMapping:0x24AA
 },
 { code:0x24AB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24AB
  ,simpleLowerCaseMapping:0x24AB
  ,simpleTitleCaseMapping:0x24AB
 },
 { code:0x24AC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24AC
  ,simpleLowerCaseMapping:0x24AC
  ,simpleTitleCaseMapping:0x24AC
 },
 { code:0x24AD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24AD
  ,simpleLowerCaseMapping:0x24AD
  ,simpleTitleCaseMapping:0x24AD
 },
 { code:0x24AE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24AE
  ,simpleLowerCaseMapping:0x24AE
  ,simpleTitleCaseMapping:0x24AE
 },
 { code:0x24AF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24AF
  ,simpleLowerCaseMapping:0x24AF
  ,simpleTitleCaseMapping:0x24AF
 },
 { code:0x24B0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24B0
  ,simpleLowerCaseMapping:0x24B0
  ,simpleTitleCaseMapping:0x24B0
 },
 { code:0x24B1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24B1
  ,simpleLowerCaseMapping:0x24B1
  ,simpleTitleCaseMapping:0x24B1
 },
 { code:0x24B2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24B2
  ,simpleLowerCaseMapping:0x24B2
  ,simpleTitleCaseMapping:0x24B2
 },
 { code:0x24B3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24B3
  ,simpleLowerCaseMapping:0x24B3
  ,simpleTitleCaseMapping:0x24B3
 },
 { code:0x24B4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24B4
  ,simpleLowerCaseMapping:0x24B4
  ,simpleTitleCaseMapping:0x24B4
 },
 { code:0x24B5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24B5
  ,simpleLowerCaseMapping:0x24B5
  ,simpleTitleCaseMapping:0x24B5
 },
 { code:0x24B6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24B6
  ,simpleLowerCaseMapping:0x24D0
  ,simpleTitleCaseMapping:0x24B6
 },
 { code:0x24B7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24B7
  ,simpleLowerCaseMapping:0x24D1
  ,simpleTitleCaseMapping:0x24B7
 },
 { code:0x24B8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24B8
  ,simpleLowerCaseMapping:0x24D2
  ,simpleTitleCaseMapping:0x24B8
 },
 { code:0x24B9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24B9
  ,simpleLowerCaseMapping:0x24D3
  ,simpleTitleCaseMapping:0x24B9
 },
 { code:0x24BA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24BA
  ,simpleLowerCaseMapping:0x24D4
  ,simpleTitleCaseMapping:0x24BA
 },
 { code:0x24BB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24BB
  ,simpleLowerCaseMapping:0x24D5
  ,simpleTitleCaseMapping:0x24BB
 },
 { code:0x24BC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24BC
  ,simpleLowerCaseMapping:0x24D6
  ,simpleTitleCaseMapping:0x24BC
 },
 { code:0x24BD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24BD
  ,simpleLowerCaseMapping:0x24D7
  ,simpleTitleCaseMapping:0x24BD
 },
 { code:0x24BE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24BE
  ,simpleLowerCaseMapping:0x24D8
  ,simpleTitleCaseMapping:0x24BE
 },
 { code:0x24BF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24BF
  ,simpleLowerCaseMapping:0x24D9
  ,simpleTitleCaseMapping:0x24BF
 },
 { code:0x24C0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C0
  ,simpleLowerCaseMapping:0x24DA
  ,simpleTitleCaseMapping:0x24C0
 },
 { code:0x24C1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C1
  ,simpleLowerCaseMapping:0x24DB
  ,simpleTitleCaseMapping:0x24C1
 },
 { code:0x24C2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C2
  ,simpleLowerCaseMapping:0x24DC
  ,simpleTitleCaseMapping:0x24C2
 },
 { code:0x24C3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C3
  ,simpleLowerCaseMapping:0x24DD
  ,simpleTitleCaseMapping:0x24C3
 },
 { code:0x24C4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C4
  ,simpleLowerCaseMapping:0x24DE
  ,simpleTitleCaseMapping:0x24C4
 },
 { code:0x24C5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C5
  ,simpleLowerCaseMapping:0x24DF
  ,simpleTitleCaseMapping:0x24C5
 },
 { code:0x24C6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C6
  ,simpleLowerCaseMapping:0x24E0
  ,simpleTitleCaseMapping:0x24C6
 },
 { code:0x24C7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C7
  ,simpleLowerCaseMapping:0x24E1
  ,simpleTitleCaseMapping:0x24C7
 },
 { code:0x24C8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C8
  ,simpleLowerCaseMapping:0x24E2
  ,simpleTitleCaseMapping:0x24C8
 },
 { code:0x24C9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C9
  ,simpleLowerCaseMapping:0x24E3
  ,simpleTitleCaseMapping:0x24C9
 },
 { code:0x24CA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24CA
  ,simpleLowerCaseMapping:0x24E4
  ,simpleTitleCaseMapping:0x24CA
 },
 { code:0x24CB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24CB
  ,simpleLowerCaseMapping:0x24E5
  ,simpleTitleCaseMapping:0x24CB
 },
 { code:0x24CC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24CC
  ,simpleLowerCaseMapping:0x24E6
  ,simpleTitleCaseMapping:0x24CC
 },
 { code:0x24CD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24CD
  ,simpleLowerCaseMapping:0x24E7
  ,simpleTitleCaseMapping:0x24CD
 },
 { code:0x24CE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24CE
  ,simpleLowerCaseMapping:0x24E8
  ,simpleTitleCaseMapping:0x24CE
 },
 { code:0x24CF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24CF
  ,simpleLowerCaseMapping:0x24E9
  ,simpleTitleCaseMapping:0x24CF
 },
 { code:0x24D0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24B6
  ,simpleLowerCaseMapping:0x24D0
  ,simpleTitleCaseMapping:0x24B6
 },
 { code:0x24D1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24B7
  ,simpleLowerCaseMapping:0x24D1
  ,simpleTitleCaseMapping:0x24B7
 },
 { code:0x24D2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24B8
  ,simpleLowerCaseMapping:0x24D2
  ,simpleTitleCaseMapping:0x24B8
 },
 { code:0x24D3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24B9
  ,simpleLowerCaseMapping:0x24D3
  ,simpleTitleCaseMapping:0x24B9
 },
 { code:0x24D4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24BA
  ,simpleLowerCaseMapping:0x24D4
  ,simpleTitleCaseMapping:0x24BA
 },
 { code:0x24D5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24BB
  ,simpleLowerCaseMapping:0x24D5
  ,simpleTitleCaseMapping:0x24BB
 },
 { code:0x24D6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24BC
  ,simpleLowerCaseMapping:0x24D6
  ,simpleTitleCaseMapping:0x24BC
 },
 { code:0x24D7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24BD
  ,simpleLowerCaseMapping:0x24D7
  ,simpleTitleCaseMapping:0x24BD
 },
 { code:0x24D8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24BE
  ,simpleLowerCaseMapping:0x24D8
  ,simpleTitleCaseMapping:0x24BE
 },
 { code:0x24D9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24BF
  ,simpleLowerCaseMapping:0x24D9
  ,simpleTitleCaseMapping:0x24BF
 },
 { code:0x24DA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C0
  ,simpleLowerCaseMapping:0x24DA
  ,simpleTitleCaseMapping:0x24C0
 },
 { code:0x24DB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C1
  ,simpleLowerCaseMapping:0x24DB
  ,simpleTitleCaseMapping:0x24C1
 },
 { code:0x24DC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C2
  ,simpleLowerCaseMapping:0x24DC
  ,simpleTitleCaseMapping:0x24C2
 },
 { code:0x24DD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C3
  ,simpleLowerCaseMapping:0x24DD
  ,simpleTitleCaseMapping:0x24C3
 },
 { code:0x24DE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C4
  ,simpleLowerCaseMapping:0x24DE
  ,simpleTitleCaseMapping:0x24C4
 },
 { code:0x24DF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C5
  ,simpleLowerCaseMapping:0x24DF
  ,simpleTitleCaseMapping:0x24C5
 },
 { code:0x24E0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C6
  ,simpleLowerCaseMapping:0x24E0
  ,simpleTitleCaseMapping:0x24C6
 },
 { code:0x24E1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C7
  ,simpleLowerCaseMapping:0x24E1
  ,simpleTitleCaseMapping:0x24C7
 },
 { code:0x24E2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C8
  ,simpleLowerCaseMapping:0x24E2
  ,simpleTitleCaseMapping:0x24C8
 },
 { code:0x24E3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24C9
  ,simpleLowerCaseMapping:0x24E3
  ,simpleTitleCaseMapping:0x24C9
 },
 { code:0x24E4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24CA
  ,simpleLowerCaseMapping:0x24E4
  ,simpleTitleCaseMapping:0x24CA
 },
 { code:0x24E5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24CB
  ,simpleLowerCaseMapping:0x24E5
  ,simpleTitleCaseMapping:0x24CB
 },
 { code:0x24E6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24CC
  ,simpleLowerCaseMapping:0x24E6
  ,simpleTitleCaseMapping:0x24CC
 },
 { code:0x24E7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24CD
  ,simpleLowerCaseMapping:0x24E7
  ,simpleTitleCaseMapping:0x24CD
 },
 { code:0x24E8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24CE
  ,simpleLowerCaseMapping:0x24E8
  ,simpleTitleCaseMapping:0x24CE
 },
 { code:0x24E9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x24CF
  ,simpleLowerCaseMapping:0x24E9
  ,simpleTitleCaseMapping:0x24CF
 },
 { code:0x24EA
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24EA
  ,simpleLowerCaseMapping:0x24EA
  ,simpleTitleCaseMapping:0x24EA
 },
 { code:0x24EB
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24EB
  ,simpleLowerCaseMapping:0x24EB
  ,simpleTitleCaseMapping:0x24EB
 },
 { code:0x24EC
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24EC
  ,simpleLowerCaseMapping:0x24EC
  ,simpleTitleCaseMapping:0x24EC
 },
 { code:0x24ED
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24ED
  ,simpleLowerCaseMapping:0x24ED
  ,simpleTitleCaseMapping:0x24ED
 },
 { code:0x24EE
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24EE
  ,simpleLowerCaseMapping:0x24EE
  ,simpleTitleCaseMapping:0x24EE
 },
 { code:0x24EF
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24EF
  ,simpleLowerCaseMapping:0x24EF
  ,simpleTitleCaseMapping:0x24EF
 },
 { code:0x24F0
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24F0
  ,simpleLowerCaseMapping:0x24F0
  ,simpleTitleCaseMapping:0x24F0
 },
 { code:0x24F1
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24F1
  ,simpleLowerCaseMapping:0x24F1
  ,simpleTitleCaseMapping:0x24F1
 },
 { code:0x24F2
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24F2
  ,simpleLowerCaseMapping:0x24F2
  ,simpleTitleCaseMapping:0x24F2
 },
 { code:0x24F3
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24F3
  ,simpleLowerCaseMapping:0x24F3
  ,simpleTitleCaseMapping:0x24F3
 },
 { code:0x24F4
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24F4
  ,simpleLowerCaseMapping:0x24F4
  ,simpleTitleCaseMapping:0x24F4
 },
 { code:0x24F5
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24F5
  ,simpleLowerCaseMapping:0x24F5
  ,simpleTitleCaseMapping:0x24F5
 },
 { code:0x24F6
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24F6
  ,simpleLowerCaseMapping:0x24F6
  ,simpleTitleCaseMapping:0x24F6
 },
 { code:0x24F7
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24F7
  ,simpleLowerCaseMapping:0x24F7
  ,simpleTitleCaseMapping:0x24F7
 },
 { code:0x24F8
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24F8
  ,simpleLowerCaseMapping:0x24F8
  ,simpleTitleCaseMapping:0x24F8
 },
 { code:0x24F9
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24F9
  ,simpleLowerCaseMapping:0x24F9
  ,simpleTitleCaseMapping:0x24F9
 },
 { code:0x24FA
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24FA
  ,simpleLowerCaseMapping:0x24FA
  ,simpleTitleCaseMapping:0x24FA
 },
 { code:0x24FB
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24FB
  ,simpleLowerCaseMapping:0x24FB
  ,simpleTitleCaseMapping:0x24FB
 },
 { code:0x24FC
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24FC
  ,simpleLowerCaseMapping:0x24FC
  ,simpleTitleCaseMapping:0x24FC
 },
 { code:0x24FD
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24FD
  ,simpleLowerCaseMapping:0x24FD
  ,simpleTitleCaseMapping:0x24FD
 },
 { code:0x24FE
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24FE
  ,simpleLowerCaseMapping:0x24FE
  ,simpleTitleCaseMapping:0x24FE
 },
 { code:0x24FF
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x24FF
  ,simpleLowerCaseMapping:0x24FF
  ,simpleTitleCaseMapping:0x24FF
 },
 { code:0x2500
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2500
  ,simpleLowerCaseMapping:0x2500
  ,simpleTitleCaseMapping:0x2500
 },
 { code:0x2501
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2501
  ,simpleLowerCaseMapping:0x2501
  ,simpleTitleCaseMapping:0x2501
 },
 { code:0x2502
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2502
  ,simpleLowerCaseMapping:0x2502
  ,simpleTitleCaseMapping:0x2502
 },
 { code:0x2503
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2503
  ,simpleLowerCaseMapping:0x2503
  ,simpleTitleCaseMapping:0x2503
 },
 { code:0x2504
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2504
  ,simpleLowerCaseMapping:0x2504
  ,simpleTitleCaseMapping:0x2504
 },
 { code:0x2505
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2505
  ,simpleLowerCaseMapping:0x2505
  ,simpleTitleCaseMapping:0x2505
 },
 { code:0x2506
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2506
  ,simpleLowerCaseMapping:0x2506
  ,simpleTitleCaseMapping:0x2506
 },
 { code:0x2507
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2507
  ,simpleLowerCaseMapping:0x2507
  ,simpleTitleCaseMapping:0x2507
 },
 { code:0x2508
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2508
  ,simpleLowerCaseMapping:0x2508
  ,simpleTitleCaseMapping:0x2508
 },
 { code:0x2509
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2509
  ,simpleLowerCaseMapping:0x2509
  ,simpleTitleCaseMapping:0x2509
 },
 { code:0x250A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x250A
  ,simpleLowerCaseMapping:0x250A
  ,simpleTitleCaseMapping:0x250A
 },
 { code:0x250B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x250B
  ,simpleLowerCaseMapping:0x250B
  ,simpleTitleCaseMapping:0x250B
 },
 { code:0x250C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x250C
  ,simpleLowerCaseMapping:0x250C
  ,simpleTitleCaseMapping:0x250C
 },
 { code:0x250D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x250D
  ,simpleLowerCaseMapping:0x250D
  ,simpleTitleCaseMapping:0x250D
 },
 { code:0x250E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x250E
  ,simpleLowerCaseMapping:0x250E
  ,simpleTitleCaseMapping:0x250E
 },
 { code:0x250F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x250F
  ,simpleLowerCaseMapping:0x250F
  ,simpleTitleCaseMapping:0x250F
 },
 { code:0x2510
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2510
  ,simpleLowerCaseMapping:0x2510
  ,simpleTitleCaseMapping:0x2510
 },
 { code:0x2511
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2511
  ,simpleLowerCaseMapping:0x2511
  ,simpleTitleCaseMapping:0x2511
 },
 { code:0x2512
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2512
  ,simpleLowerCaseMapping:0x2512
  ,simpleTitleCaseMapping:0x2512
 },
 { code:0x2513
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2513
  ,simpleLowerCaseMapping:0x2513
  ,simpleTitleCaseMapping:0x2513
 },
 { code:0x2514
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2514
  ,simpleLowerCaseMapping:0x2514
  ,simpleTitleCaseMapping:0x2514
 },
 { code:0x2515
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2515
  ,simpleLowerCaseMapping:0x2515
  ,simpleTitleCaseMapping:0x2515
 },
 { code:0x2516
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2516
  ,simpleLowerCaseMapping:0x2516
  ,simpleTitleCaseMapping:0x2516
 },
 { code:0x2517
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2517
  ,simpleLowerCaseMapping:0x2517
  ,simpleTitleCaseMapping:0x2517
 },
 { code:0x2518
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2518
  ,simpleLowerCaseMapping:0x2518
  ,simpleTitleCaseMapping:0x2518
 },
 { code:0x2519
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2519
  ,simpleLowerCaseMapping:0x2519
  ,simpleTitleCaseMapping:0x2519
 },
 { code:0x251A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x251A
  ,simpleLowerCaseMapping:0x251A
  ,simpleTitleCaseMapping:0x251A
 },
 { code:0x251B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x251B
  ,simpleLowerCaseMapping:0x251B
  ,simpleTitleCaseMapping:0x251B
 },
 { code:0x251C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x251C
  ,simpleLowerCaseMapping:0x251C
  ,simpleTitleCaseMapping:0x251C
 },
 { code:0x251D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x251D
  ,simpleLowerCaseMapping:0x251D
  ,simpleTitleCaseMapping:0x251D
 },
 { code:0x251E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x251E
  ,simpleLowerCaseMapping:0x251E
  ,simpleTitleCaseMapping:0x251E
 },
 { code:0x251F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x251F
  ,simpleLowerCaseMapping:0x251F
  ,simpleTitleCaseMapping:0x251F
 },
 { code:0x2520
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2520
  ,simpleLowerCaseMapping:0x2520
  ,simpleTitleCaseMapping:0x2520
 },
 { code:0x2521
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2521
  ,simpleLowerCaseMapping:0x2521
  ,simpleTitleCaseMapping:0x2521
 },
 { code:0x2522
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2522
  ,simpleLowerCaseMapping:0x2522
  ,simpleTitleCaseMapping:0x2522
 },
 { code:0x2523
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2523
  ,simpleLowerCaseMapping:0x2523
  ,simpleTitleCaseMapping:0x2523
 },
 { code:0x2524
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2524
  ,simpleLowerCaseMapping:0x2524
  ,simpleTitleCaseMapping:0x2524
 },
 { code:0x2525
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2525
  ,simpleLowerCaseMapping:0x2525
  ,simpleTitleCaseMapping:0x2525
 },
 { code:0x2526
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2526
  ,simpleLowerCaseMapping:0x2526
  ,simpleTitleCaseMapping:0x2526
 },
 { code:0x2527
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2527
  ,simpleLowerCaseMapping:0x2527
  ,simpleTitleCaseMapping:0x2527
 },
 { code:0x2528
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2528
  ,simpleLowerCaseMapping:0x2528
  ,simpleTitleCaseMapping:0x2528
 },
 { code:0x2529
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2529
  ,simpleLowerCaseMapping:0x2529
  ,simpleTitleCaseMapping:0x2529
 },
 { code:0x252A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x252A
  ,simpleLowerCaseMapping:0x252A
  ,simpleTitleCaseMapping:0x252A
 },
 { code:0x252B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x252B
  ,simpleLowerCaseMapping:0x252B
  ,simpleTitleCaseMapping:0x252B
 },
 { code:0x252C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x252C
  ,simpleLowerCaseMapping:0x252C
  ,simpleTitleCaseMapping:0x252C
 },
 { code:0x252D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x252D
  ,simpleLowerCaseMapping:0x252D
  ,simpleTitleCaseMapping:0x252D
 },
 { code:0x252E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x252E
  ,simpleLowerCaseMapping:0x252E
  ,simpleTitleCaseMapping:0x252E
 },
 { code:0x252F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x252F
  ,simpleLowerCaseMapping:0x252F
  ,simpleTitleCaseMapping:0x252F
 },
 { code:0x2530
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2530
  ,simpleLowerCaseMapping:0x2530
  ,simpleTitleCaseMapping:0x2530
 },
 { code:0x2531
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2531
  ,simpleLowerCaseMapping:0x2531
  ,simpleTitleCaseMapping:0x2531
 },
 { code:0x2532
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2532
  ,simpleLowerCaseMapping:0x2532
  ,simpleTitleCaseMapping:0x2532
 },
 { code:0x2533
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2533
  ,simpleLowerCaseMapping:0x2533
  ,simpleTitleCaseMapping:0x2533
 },
 { code:0x2534
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2534
  ,simpleLowerCaseMapping:0x2534
  ,simpleTitleCaseMapping:0x2534
 },
 { code:0x2535
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2535
  ,simpleLowerCaseMapping:0x2535
  ,simpleTitleCaseMapping:0x2535
 },
 { code:0x2536
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2536
  ,simpleLowerCaseMapping:0x2536
  ,simpleTitleCaseMapping:0x2536
 },
 { code:0x2537
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2537
  ,simpleLowerCaseMapping:0x2537
  ,simpleTitleCaseMapping:0x2537
 },
 { code:0x2538
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2538
  ,simpleLowerCaseMapping:0x2538
  ,simpleTitleCaseMapping:0x2538
 },
 { code:0x2539
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2539
  ,simpleLowerCaseMapping:0x2539
  ,simpleTitleCaseMapping:0x2539
 },
 { code:0x253A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x253A
  ,simpleLowerCaseMapping:0x253A
  ,simpleTitleCaseMapping:0x253A
 },
 { code:0x253B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x253B
  ,simpleLowerCaseMapping:0x253B
  ,simpleTitleCaseMapping:0x253B
 },
 { code:0x253C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x253C
  ,simpleLowerCaseMapping:0x253C
  ,simpleTitleCaseMapping:0x253C
 },
 { code:0x253D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x253D
  ,simpleLowerCaseMapping:0x253D
  ,simpleTitleCaseMapping:0x253D
 },
 { code:0x253E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x253E
  ,simpleLowerCaseMapping:0x253E
  ,simpleTitleCaseMapping:0x253E
 },
 { code:0x253F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x253F
  ,simpleLowerCaseMapping:0x253F
  ,simpleTitleCaseMapping:0x253F
 },
 { code:0x2540
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2540
  ,simpleLowerCaseMapping:0x2540
  ,simpleTitleCaseMapping:0x2540
 },
 { code:0x2541
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2541
  ,simpleLowerCaseMapping:0x2541
  ,simpleTitleCaseMapping:0x2541
 },
 { code:0x2542
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2542
  ,simpleLowerCaseMapping:0x2542
  ,simpleTitleCaseMapping:0x2542
 },
 { code:0x2543
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2543
  ,simpleLowerCaseMapping:0x2543
  ,simpleTitleCaseMapping:0x2543
 },
 { code:0x2544
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2544
  ,simpleLowerCaseMapping:0x2544
  ,simpleTitleCaseMapping:0x2544
 },
 { code:0x2545
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2545
  ,simpleLowerCaseMapping:0x2545
  ,simpleTitleCaseMapping:0x2545
 },
 { code:0x2546
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2546
  ,simpleLowerCaseMapping:0x2546
  ,simpleTitleCaseMapping:0x2546
 },
 { code:0x2547
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2547
  ,simpleLowerCaseMapping:0x2547
  ,simpleTitleCaseMapping:0x2547
 },
 { code:0x2548
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2548
  ,simpleLowerCaseMapping:0x2548
  ,simpleTitleCaseMapping:0x2548
 },
 { code:0x2549
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2549
  ,simpleLowerCaseMapping:0x2549
  ,simpleTitleCaseMapping:0x2549
 },
 { code:0x254A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x254A
  ,simpleLowerCaseMapping:0x254A
  ,simpleTitleCaseMapping:0x254A
 },
 { code:0x254B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x254B
  ,simpleLowerCaseMapping:0x254B
  ,simpleTitleCaseMapping:0x254B
 },
 { code:0x254C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x254C
  ,simpleLowerCaseMapping:0x254C
  ,simpleTitleCaseMapping:0x254C
 },
 { code:0x254D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x254D
  ,simpleLowerCaseMapping:0x254D
  ,simpleTitleCaseMapping:0x254D
 },
 { code:0x254E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x254E
  ,simpleLowerCaseMapping:0x254E
  ,simpleTitleCaseMapping:0x254E
 },
 { code:0x254F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x254F
  ,simpleLowerCaseMapping:0x254F
  ,simpleTitleCaseMapping:0x254F
 },
 { code:0x2550
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2550
  ,simpleLowerCaseMapping:0x2550
  ,simpleTitleCaseMapping:0x2550
 },
 { code:0x2551
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2551
  ,simpleLowerCaseMapping:0x2551
  ,simpleTitleCaseMapping:0x2551
 },
 { code:0x2552
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2552
  ,simpleLowerCaseMapping:0x2552
  ,simpleTitleCaseMapping:0x2552
 },
 { code:0x2553
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2553
  ,simpleLowerCaseMapping:0x2553
  ,simpleTitleCaseMapping:0x2553
 },
 { code:0x2554
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2554
  ,simpleLowerCaseMapping:0x2554
  ,simpleTitleCaseMapping:0x2554
 },
 { code:0x2555
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2555
  ,simpleLowerCaseMapping:0x2555
  ,simpleTitleCaseMapping:0x2555
 },
 { code:0x2556
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2556
  ,simpleLowerCaseMapping:0x2556
  ,simpleTitleCaseMapping:0x2556
 },
 { code:0x2557
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2557
  ,simpleLowerCaseMapping:0x2557
  ,simpleTitleCaseMapping:0x2557
 },
 { code:0x2558
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2558
  ,simpleLowerCaseMapping:0x2558
  ,simpleTitleCaseMapping:0x2558
 },
 { code:0x2559
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2559
  ,simpleLowerCaseMapping:0x2559
  ,simpleTitleCaseMapping:0x2559
 },
 { code:0x255A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x255A
  ,simpleLowerCaseMapping:0x255A
  ,simpleTitleCaseMapping:0x255A
 },
 { code:0x255B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x255B
  ,simpleLowerCaseMapping:0x255B
  ,simpleTitleCaseMapping:0x255B
 },
 { code:0x255C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x255C
  ,simpleLowerCaseMapping:0x255C
  ,simpleTitleCaseMapping:0x255C
 },
 { code:0x255D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x255D
  ,simpleLowerCaseMapping:0x255D
  ,simpleTitleCaseMapping:0x255D
 },
 { code:0x255E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x255E
  ,simpleLowerCaseMapping:0x255E
  ,simpleTitleCaseMapping:0x255E
 },
 { code:0x255F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x255F
  ,simpleLowerCaseMapping:0x255F
  ,simpleTitleCaseMapping:0x255F
 },
 { code:0x2560
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2560
  ,simpleLowerCaseMapping:0x2560
  ,simpleTitleCaseMapping:0x2560
 },
 { code:0x2561
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2561
  ,simpleLowerCaseMapping:0x2561
  ,simpleTitleCaseMapping:0x2561
 },
 { code:0x2562
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2562
  ,simpleLowerCaseMapping:0x2562
  ,simpleTitleCaseMapping:0x2562
 },
 { code:0x2563
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2563
  ,simpleLowerCaseMapping:0x2563
  ,simpleTitleCaseMapping:0x2563
 },
 { code:0x2564
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2564
  ,simpleLowerCaseMapping:0x2564
  ,simpleTitleCaseMapping:0x2564
 },
 { code:0x2565
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2565
  ,simpleLowerCaseMapping:0x2565
  ,simpleTitleCaseMapping:0x2565
 },
 { code:0x2566
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2566
  ,simpleLowerCaseMapping:0x2566
  ,simpleTitleCaseMapping:0x2566
 },
 { code:0x2567
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2567
  ,simpleLowerCaseMapping:0x2567
  ,simpleTitleCaseMapping:0x2567
 },
 { code:0x2568
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2568
  ,simpleLowerCaseMapping:0x2568
  ,simpleTitleCaseMapping:0x2568
 },
 { code:0x2569
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2569
  ,simpleLowerCaseMapping:0x2569
  ,simpleTitleCaseMapping:0x2569
 },
 { code:0x256A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x256A
  ,simpleLowerCaseMapping:0x256A
  ,simpleTitleCaseMapping:0x256A
 },
 { code:0x256B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x256B
  ,simpleLowerCaseMapping:0x256B
  ,simpleTitleCaseMapping:0x256B
 },
 { code:0x256C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x256C
  ,simpleLowerCaseMapping:0x256C
  ,simpleTitleCaseMapping:0x256C
 },
 { code:0x256D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x256D
  ,simpleLowerCaseMapping:0x256D
  ,simpleTitleCaseMapping:0x256D
 },
 { code:0x256E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x256E
  ,simpleLowerCaseMapping:0x256E
  ,simpleTitleCaseMapping:0x256E
 },
 { code:0x256F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x256F
  ,simpleLowerCaseMapping:0x256F
  ,simpleTitleCaseMapping:0x256F
 },
 { code:0x2570
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2570
  ,simpleLowerCaseMapping:0x2570
  ,simpleTitleCaseMapping:0x2570
 },
 { code:0x2571
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2571
  ,simpleLowerCaseMapping:0x2571
  ,simpleTitleCaseMapping:0x2571
 },
 { code:0x2572
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2572
  ,simpleLowerCaseMapping:0x2572
  ,simpleTitleCaseMapping:0x2572
 },
 { code:0x2573
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2573
  ,simpleLowerCaseMapping:0x2573
  ,simpleTitleCaseMapping:0x2573
 },
 { code:0x2574
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2574
  ,simpleLowerCaseMapping:0x2574
  ,simpleTitleCaseMapping:0x2574
 },
 { code:0x2575
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2575
  ,simpleLowerCaseMapping:0x2575
  ,simpleTitleCaseMapping:0x2575
 },
 { code:0x2576
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2576
  ,simpleLowerCaseMapping:0x2576
  ,simpleTitleCaseMapping:0x2576
 },
 { code:0x2577
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2577
  ,simpleLowerCaseMapping:0x2577
  ,simpleTitleCaseMapping:0x2577
 },
 { code:0x2578
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2578
  ,simpleLowerCaseMapping:0x2578
  ,simpleTitleCaseMapping:0x2578
 },
 { code:0x2579
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2579
  ,simpleLowerCaseMapping:0x2579
  ,simpleTitleCaseMapping:0x2579
 },
 { code:0x257A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x257A
  ,simpleLowerCaseMapping:0x257A
  ,simpleTitleCaseMapping:0x257A
 },
 { code:0x257B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x257B
  ,simpleLowerCaseMapping:0x257B
  ,simpleTitleCaseMapping:0x257B
 },
 { code:0x257C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x257C
  ,simpleLowerCaseMapping:0x257C
  ,simpleTitleCaseMapping:0x257C
 },
 { code:0x257D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x257D
  ,simpleLowerCaseMapping:0x257D
  ,simpleTitleCaseMapping:0x257D
 },
 { code:0x257E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x257E
  ,simpleLowerCaseMapping:0x257E
  ,simpleTitleCaseMapping:0x257E
 },
 { code:0x257F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x257F
  ,simpleLowerCaseMapping:0x257F
  ,simpleTitleCaseMapping:0x257F
 },
 { code:0x2580
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2580
  ,simpleLowerCaseMapping:0x2580
  ,simpleTitleCaseMapping:0x2580
 },
 { code:0x2581
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2581
  ,simpleLowerCaseMapping:0x2581
  ,simpleTitleCaseMapping:0x2581
 },
 { code:0x2582
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2582
  ,simpleLowerCaseMapping:0x2582
  ,simpleTitleCaseMapping:0x2582
 },
 { code:0x2583
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2583
  ,simpleLowerCaseMapping:0x2583
  ,simpleTitleCaseMapping:0x2583
 },
 { code:0x2584
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2584
  ,simpleLowerCaseMapping:0x2584
  ,simpleTitleCaseMapping:0x2584
 },
 { code:0x2585
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2585
  ,simpleLowerCaseMapping:0x2585
  ,simpleTitleCaseMapping:0x2585
 },
 { code:0x2586
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2586
  ,simpleLowerCaseMapping:0x2586
  ,simpleTitleCaseMapping:0x2586
 },
 { code:0x2587
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2587
  ,simpleLowerCaseMapping:0x2587
  ,simpleTitleCaseMapping:0x2587
 },
 { code:0x2588
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2588
  ,simpleLowerCaseMapping:0x2588
  ,simpleTitleCaseMapping:0x2588
 },
 { code:0x2589
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2589
  ,simpleLowerCaseMapping:0x2589
  ,simpleTitleCaseMapping:0x2589
 },
 { code:0x258A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x258A
  ,simpleLowerCaseMapping:0x258A
  ,simpleTitleCaseMapping:0x258A
 },
 { code:0x258B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x258B
  ,simpleLowerCaseMapping:0x258B
  ,simpleTitleCaseMapping:0x258B
 },
 { code:0x258C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x258C
  ,simpleLowerCaseMapping:0x258C
  ,simpleTitleCaseMapping:0x258C
 },
 { code:0x258D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x258D
  ,simpleLowerCaseMapping:0x258D
  ,simpleTitleCaseMapping:0x258D
 },
 { code:0x258E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x258E
  ,simpleLowerCaseMapping:0x258E
  ,simpleTitleCaseMapping:0x258E
 },
 { code:0x258F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x258F
  ,simpleLowerCaseMapping:0x258F
  ,simpleTitleCaseMapping:0x258F
 },
 { code:0x2590
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2590
  ,simpleLowerCaseMapping:0x2590
  ,simpleTitleCaseMapping:0x2590
 },
 { code:0x2591
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2591
  ,simpleLowerCaseMapping:0x2591
  ,simpleTitleCaseMapping:0x2591
 },
 { code:0x2592
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2592
  ,simpleLowerCaseMapping:0x2592
  ,simpleTitleCaseMapping:0x2592
 },
 { code:0x2593
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2593
  ,simpleLowerCaseMapping:0x2593
  ,simpleTitleCaseMapping:0x2593
 },
 { code:0x2594
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2594
  ,simpleLowerCaseMapping:0x2594
  ,simpleTitleCaseMapping:0x2594
 },
 { code:0x2595
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2595
  ,simpleLowerCaseMapping:0x2595
  ,simpleTitleCaseMapping:0x2595
 },
 { code:0x2596
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2596
  ,simpleLowerCaseMapping:0x2596
  ,simpleTitleCaseMapping:0x2596
 },
 { code:0x2597
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2597
  ,simpleLowerCaseMapping:0x2597
  ,simpleTitleCaseMapping:0x2597
 },
 { code:0x2598
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2598
  ,simpleLowerCaseMapping:0x2598
  ,simpleTitleCaseMapping:0x2598
 },
 { code:0x2599
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2599
  ,simpleLowerCaseMapping:0x2599
  ,simpleTitleCaseMapping:0x2599
 },
 { code:0x259A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x259A
  ,simpleLowerCaseMapping:0x259A
  ,simpleTitleCaseMapping:0x259A
 },
 { code:0x259B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x259B
  ,simpleLowerCaseMapping:0x259B
  ,simpleTitleCaseMapping:0x259B
 },
 { code:0x259C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x259C
  ,simpleLowerCaseMapping:0x259C
  ,simpleTitleCaseMapping:0x259C
 },
 { code:0x259D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x259D
  ,simpleLowerCaseMapping:0x259D
  ,simpleTitleCaseMapping:0x259D
 },
 { code:0x259E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x259E
  ,simpleLowerCaseMapping:0x259E
  ,simpleTitleCaseMapping:0x259E
 },
 { code:0x259F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x259F
  ,simpleLowerCaseMapping:0x259F
  ,simpleTitleCaseMapping:0x259F
 },
 { code:0x25A0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25A0
  ,simpleLowerCaseMapping:0x25A0
  ,simpleTitleCaseMapping:0x25A0
 },
 { code:0x25A1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25A1
  ,simpleLowerCaseMapping:0x25A1
  ,simpleTitleCaseMapping:0x25A1
 },
 { code:0x25A2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25A2
  ,simpleLowerCaseMapping:0x25A2
  ,simpleTitleCaseMapping:0x25A2
 },
 { code:0x25A3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25A3
  ,simpleLowerCaseMapping:0x25A3
  ,simpleTitleCaseMapping:0x25A3
 },
 { code:0x25A4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25A4
  ,simpleLowerCaseMapping:0x25A4
  ,simpleTitleCaseMapping:0x25A4
 },
 { code:0x25A5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25A5
  ,simpleLowerCaseMapping:0x25A5
  ,simpleTitleCaseMapping:0x25A5
 },
 { code:0x25A6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25A6
  ,simpleLowerCaseMapping:0x25A6
  ,simpleTitleCaseMapping:0x25A6
 },
 { code:0x25A7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25A7
  ,simpleLowerCaseMapping:0x25A7
  ,simpleTitleCaseMapping:0x25A7
 },
 { code:0x25A8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25A8
  ,simpleLowerCaseMapping:0x25A8
  ,simpleTitleCaseMapping:0x25A8
 },
 { code:0x25A9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25A9
  ,simpleLowerCaseMapping:0x25A9
  ,simpleTitleCaseMapping:0x25A9
 },
 { code:0x25AA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25AA
  ,simpleLowerCaseMapping:0x25AA
  ,simpleTitleCaseMapping:0x25AA
 },
 { code:0x25AB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25AB
  ,simpleLowerCaseMapping:0x25AB
  ,simpleTitleCaseMapping:0x25AB
 },
 { code:0x25AC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25AC
  ,simpleLowerCaseMapping:0x25AC
  ,simpleTitleCaseMapping:0x25AC
 },
 { code:0x25AD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25AD
  ,simpleLowerCaseMapping:0x25AD
  ,simpleTitleCaseMapping:0x25AD
 },
 { code:0x25AE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25AE
  ,simpleLowerCaseMapping:0x25AE
  ,simpleTitleCaseMapping:0x25AE
 },
 { code:0x25AF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25AF
  ,simpleLowerCaseMapping:0x25AF
  ,simpleTitleCaseMapping:0x25AF
 },
 { code:0x25B0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25B0
  ,simpleLowerCaseMapping:0x25B0
  ,simpleTitleCaseMapping:0x25B0
 },
 { code:0x25B1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25B1
  ,simpleLowerCaseMapping:0x25B1
  ,simpleTitleCaseMapping:0x25B1
 },
 { code:0x25B2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25B2
  ,simpleLowerCaseMapping:0x25B2
  ,simpleTitleCaseMapping:0x25B2
 },
 { code:0x25B3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25B3
  ,simpleLowerCaseMapping:0x25B3
  ,simpleTitleCaseMapping:0x25B3
 },
 { code:0x25B4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25B4
  ,simpleLowerCaseMapping:0x25B4
  ,simpleTitleCaseMapping:0x25B4
 },
 { code:0x25B5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25B5
  ,simpleLowerCaseMapping:0x25B5
  ,simpleTitleCaseMapping:0x25B5
 },
 { code:0x25B6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25B6
  ,simpleLowerCaseMapping:0x25B6
  ,simpleTitleCaseMapping:0x25B6
 },
 { code:0x25B7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x25B7
  ,simpleLowerCaseMapping:0x25B7
  ,simpleTitleCaseMapping:0x25B7
 },
 { code:0x25B8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25B8
  ,simpleLowerCaseMapping:0x25B8
  ,simpleTitleCaseMapping:0x25B8
 },
 { code:0x25B9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25B9
  ,simpleLowerCaseMapping:0x25B9
  ,simpleTitleCaseMapping:0x25B9
 },
 { code:0x25BA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25BA
  ,simpleLowerCaseMapping:0x25BA
  ,simpleTitleCaseMapping:0x25BA
 },
 { code:0x25BB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25BB
  ,simpleLowerCaseMapping:0x25BB
  ,simpleTitleCaseMapping:0x25BB
 },
 { code:0x25BC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25BC
  ,simpleLowerCaseMapping:0x25BC
  ,simpleTitleCaseMapping:0x25BC
 },
 { code:0x25BD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25BD
  ,simpleLowerCaseMapping:0x25BD
  ,simpleTitleCaseMapping:0x25BD
 },
 { code:0x25BE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25BE
  ,simpleLowerCaseMapping:0x25BE
  ,simpleTitleCaseMapping:0x25BE
 },
 { code:0x25BF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25BF
  ,simpleLowerCaseMapping:0x25BF
  ,simpleTitleCaseMapping:0x25BF
 },
 { code:0x25C0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25C0
  ,simpleLowerCaseMapping:0x25C0
  ,simpleTitleCaseMapping:0x25C0
 },
 { code:0x25C1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x25C1
  ,simpleLowerCaseMapping:0x25C1
  ,simpleTitleCaseMapping:0x25C1
 },
 { code:0x25C2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25C2
  ,simpleLowerCaseMapping:0x25C2
  ,simpleTitleCaseMapping:0x25C2
 },
 { code:0x25C3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25C3
  ,simpleLowerCaseMapping:0x25C3
  ,simpleTitleCaseMapping:0x25C3
 },
 { code:0x25C4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25C4
  ,simpleLowerCaseMapping:0x25C4
  ,simpleTitleCaseMapping:0x25C4
 },
 { code:0x25C5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25C5
  ,simpleLowerCaseMapping:0x25C5
  ,simpleTitleCaseMapping:0x25C5
 },
 { code:0x25C6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25C6
  ,simpleLowerCaseMapping:0x25C6
  ,simpleTitleCaseMapping:0x25C6
 },
 { code:0x25C7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25C7
  ,simpleLowerCaseMapping:0x25C7
  ,simpleTitleCaseMapping:0x25C7
 },
 { code:0x25C8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25C8
  ,simpleLowerCaseMapping:0x25C8
  ,simpleTitleCaseMapping:0x25C8
 },
 { code:0x25C9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25C9
  ,simpleLowerCaseMapping:0x25C9
  ,simpleTitleCaseMapping:0x25C9
 },
 { code:0x25CA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25CA
  ,simpleLowerCaseMapping:0x25CA
  ,simpleTitleCaseMapping:0x25CA
 },
 { code:0x25CB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25CB
  ,simpleLowerCaseMapping:0x25CB
  ,simpleTitleCaseMapping:0x25CB
 },
 { code:0x25CC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25CC
  ,simpleLowerCaseMapping:0x25CC
  ,simpleTitleCaseMapping:0x25CC
 },
 { code:0x25CD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25CD
  ,simpleLowerCaseMapping:0x25CD
  ,simpleTitleCaseMapping:0x25CD
 },
 { code:0x25CE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25CE
  ,simpleLowerCaseMapping:0x25CE
  ,simpleTitleCaseMapping:0x25CE
 },
 { code:0x25CF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25CF
  ,simpleLowerCaseMapping:0x25CF
  ,simpleTitleCaseMapping:0x25CF
 },
 { code:0x25D0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25D0
  ,simpleLowerCaseMapping:0x25D0
  ,simpleTitleCaseMapping:0x25D0
 },
 { code:0x25D1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25D1
  ,simpleLowerCaseMapping:0x25D1
  ,simpleTitleCaseMapping:0x25D1
 },
 { code:0x25D2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25D2
  ,simpleLowerCaseMapping:0x25D2
  ,simpleTitleCaseMapping:0x25D2
 },
 { code:0x25D3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25D3
  ,simpleLowerCaseMapping:0x25D3
  ,simpleTitleCaseMapping:0x25D3
 },
 { code:0x25D4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25D4
  ,simpleLowerCaseMapping:0x25D4
  ,simpleTitleCaseMapping:0x25D4
 },
 { code:0x25D5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25D5
  ,simpleLowerCaseMapping:0x25D5
  ,simpleTitleCaseMapping:0x25D5
 },
 { code:0x25D6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25D6
  ,simpleLowerCaseMapping:0x25D6
  ,simpleTitleCaseMapping:0x25D6
 },
 { code:0x25D7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25D7
  ,simpleLowerCaseMapping:0x25D7
  ,simpleTitleCaseMapping:0x25D7
 },
 { code:0x25D8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25D8
  ,simpleLowerCaseMapping:0x25D8
  ,simpleTitleCaseMapping:0x25D8
 },
 { code:0x25D9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25D9
  ,simpleLowerCaseMapping:0x25D9
  ,simpleTitleCaseMapping:0x25D9
 },
 { code:0x25DA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25DA
  ,simpleLowerCaseMapping:0x25DA
  ,simpleTitleCaseMapping:0x25DA
 },
 { code:0x25DB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25DB
  ,simpleLowerCaseMapping:0x25DB
  ,simpleTitleCaseMapping:0x25DB
 },
 { code:0x25DC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25DC
  ,simpleLowerCaseMapping:0x25DC
  ,simpleTitleCaseMapping:0x25DC
 },
 { code:0x25DD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25DD
  ,simpleLowerCaseMapping:0x25DD
  ,simpleTitleCaseMapping:0x25DD
 },
 { code:0x25DE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25DE
  ,simpleLowerCaseMapping:0x25DE
  ,simpleTitleCaseMapping:0x25DE
 },
 { code:0x25DF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25DF
  ,simpleLowerCaseMapping:0x25DF
  ,simpleTitleCaseMapping:0x25DF
 },
 { code:0x25E0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25E0
  ,simpleLowerCaseMapping:0x25E0
  ,simpleTitleCaseMapping:0x25E0
 },
 { code:0x25E1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25E1
  ,simpleLowerCaseMapping:0x25E1
  ,simpleTitleCaseMapping:0x25E1
 },
 { code:0x25E2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25E2
  ,simpleLowerCaseMapping:0x25E2
  ,simpleTitleCaseMapping:0x25E2
 },
 { code:0x25E3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25E3
  ,simpleLowerCaseMapping:0x25E3
  ,simpleTitleCaseMapping:0x25E3
 },
 { code:0x25E4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25E4
  ,simpleLowerCaseMapping:0x25E4
  ,simpleTitleCaseMapping:0x25E4
 },
 { code:0x25E5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25E5
  ,simpleLowerCaseMapping:0x25E5
  ,simpleTitleCaseMapping:0x25E5
 },
 { code:0x25E6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25E6
  ,simpleLowerCaseMapping:0x25E6
  ,simpleTitleCaseMapping:0x25E6
 },
 { code:0x25E7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25E7
  ,simpleLowerCaseMapping:0x25E7
  ,simpleTitleCaseMapping:0x25E7
 },
 { code:0x25E8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25E8
  ,simpleLowerCaseMapping:0x25E8
  ,simpleTitleCaseMapping:0x25E8
 },
 { code:0x25E9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25E9
  ,simpleLowerCaseMapping:0x25E9
  ,simpleTitleCaseMapping:0x25E9
 },
 { code:0x25EA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25EA
  ,simpleLowerCaseMapping:0x25EA
  ,simpleTitleCaseMapping:0x25EA
 },
 { code:0x25EB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25EB
  ,simpleLowerCaseMapping:0x25EB
  ,simpleTitleCaseMapping:0x25EB
 },
 { code:0x25EC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25EC
  ,simpleLowerCaseMapping:0x25EC
  ,simpleTitleCaseMapping:0x25EC
 },
 { code:0x25ED
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25ED
  ,simpleLowerCaseMapping:0x25ED
  ,simpleTitleCaseMapping:0x25ED
 },
 { code:0x25EE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25EE
  ,simpleLowerCaseMapping:0x25EE
  ,simpleTitleCaseMapping:0x25EE
 },
 { code:0x25EF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25EF
  ,simpleLowerCaseMapping:0x25EF
  ,simpleTitleCaseMapping:0x25EF
 },
 { code:0x25F0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25F0
  ,simpleLowerCaseMapping:0x25F0
  ,simpleTitleCaseMapping:0x25F0
 },
 { code:0x25F1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25F1
  ,simpleLowerCaseMapping:0x25F1
  ,simpleTitleCaseMapping:0x25F1
 },
 { code:0x25F2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25F2
  ,simpleLowerCaseMapping:0x25F2
  ,simpleTitleCaseMapping:0x25F2
 },
 { code:0x25F3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25F3
  ,simpleLowerCaseMapping:0x25F3
  ,simpleTitleCaseMapping:0x25F3
 },
 { code:0x25F4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25F4
  ,simpleLowerCaseMapping:0x25F4
  ,simpleTitleCaseMapping:0x25F4
 },
 { code:0x25F5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25F5
  ,simpleLowerCaseMapping:0x25F5
  ,simpleTitleCaseMapping:0x25F5
 },
 { code:0x25F6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25F6
  ,simpleLowerCaseMapping:0x25F6
  ,simpleTitleCaseMapping:0x25F6
 },
 { code:0x25F7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x25F7
  ,simpleLowerCaseMapping:0x25F7
  ,simpleTitleCaseMapping:0x25F7
 },
 { code:0x25F8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x25F8
  ,simpleLowerCaseMapping:0x25F8
  ,simpleTitleCaseMapping:0x25F8
 },
 { code:0x25F9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x25F9
  ,simpleLowerCaseMapping:0x25F9
  ,simpleTitleCaseMapping:0x25F9
 },
 { code:0x25FA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x25FA
  ,simpleLowerCaseMapping:0x25FA
  ,simpleTitleCaseMapping:0x25FA
 },
 { code:0x25FB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x25FB
  ,simpleLowerCaseMapping:0x25FB
  ,simpleTitleCaseMapping:0x25FB
 },
 { code:0x25FC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x25FC
  ,simpleLowerCaseMapping:0x25FC
  ,simpleTitleCaseMapping:0x25FC
 },
 { code:0x25FD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x25FD
  ,simpleLowerCaseMapping:0x25FD
  ,simpleTitleCaseMapping:0x25FD
 },
 { code:0x25FE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x25FE
  ,simpleLowerCaseMapping:0x25FE
  ,simpleTitleCaseMapping:0x25FE
 },
 { code:0x25FF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x25FF
  ,simpleLowerCaseMapping:0x25FF
  ,simpleTitleCaseMapping:0x25FF
 },
 { code:0x2600
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2600
  ,simpleLowerCaseMapping:0x2600
  ,simpleTitleCaseMapping:0x2600
 },
 { code:0x2601
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2601
  ,simpleLowerCaseMapping:0x2601
  ,simpleTitleCaseMapping:0x2601
 },
 { code:0x2602
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2602
  ,simpleLowerCaseMapping:0x2602
  ,simpleTitleCaseMapping:0x2602
 },
 { code:0x2603
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2603
  ,simpleLowerCaseMapping:0x2603
  ,simpleTitleCaseMapping:0x2603
 },
 { code:0x2604
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2604
  ,simpleLowerCaseMapping:0x2604
  ,simpleTitleCaseMapping:0x2604
 },
 { code:0x2605
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2605
  ,simpleLowerCaseMapping:0x2605
  ,simpleTitleCaseMapping:0x2605
 },
 { code:0x2606
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2606
  ,simpleLowerCaseMapping:0x2606
  ,simpleTitleCaseMapping:0x2606
 },
 { code:0x2607
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2607
  ,simpleLowerCaseMapping:0x2607
  ,simpleTitleCaseMapping:0x2607
 },
 { code:0x2608
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2608
  ,simpleLowerCaseMapping:0x2608
  ,simpleTitleCaseMapping:0x2608
 },
 { code:0x2609
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2609
  ,simpleLowerCaseMapping:0x2609
  ,simpleTitleCaseMapping:0x2609
 },
 { code:0x260A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x260A
  ,simpleLowerCaseMapping:0x260A
  ,simpleTitleCaseMapping:0x260A
 },
 { code:0x260B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x260B
  ,simpleLowerCaseMapping:0x260B
  ,simpleTitleCaseMapping:0x260B
 },
 { code:0x260C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x260C
  ,simpleLowerCaseMapping:0x260C
  ,simpleTitleCaseMapping:0x260C
 },
 { code:0x260D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x260D
  ,simpleLowerCaseMapping:0x260D
  ,simpleTitleCaseMapping:0x260D
 },
 { code:0x260E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x260E
  ,simpleLowerCaseMapping:0x260E
  ,simpleTitleCaseMapping:0x260E
 },
 { code:0x260F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x260F
  ,simpleLowerCaseMapping:0x260F
  ,simpleTitleCaseMapping:0x260F
 },
 { code:0x2610
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2610
  ,simpleLowerCaseMapping:0x2610
  ,simpleTitleCaseMapping:0x2610
 },
 { code:0x2611
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2611
  ,simpleLowerCaseMapping:0x2611
  ,simpleTitleCaseMapping:0x2611
 },
 { code:0x2612
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2612
  ,simpleLowerCaseMapping:0x2612
  ,simpleTitleCaseMapping:0x2612
 },
 { code:0x2613
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2613
  ,simpleLowerCaseMapping:0x2613
  ,simpleTitleCaseMapping:0x2613
 },
 { code:0x2614
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2614
  ,simpleLowerCaseMapping:0x2614
  ,simpleTitleCaseMapping:0x2614
 },
 { code:0x2615
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2615
  ,simpleLowerCaseMapping:0x2615
  ,simpleTitleCaseMapping:0x2615
 },
 { code:0x2616
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2616
  ,simpleLowerCaseMapping:0x2616
  ,simpleTitleCaseMapping:0x2616
 },
 { code:0x2617
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2617
  ,simpleLowerCaseMapping:0x2617
  ,simpleTitleCaseMapping:0x2617
 },
 { code:0x2618
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2618
  ,simpleLowerCaseMapping:0x2618
  ,simpleTitleCaseMapping:0x2618
 },
 { code:0x2619
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2619
  ,simpleLowerCaseMapping:0x2619
  ,simpleTitleCaseMapping:0x2619
 },
 { code:0x261A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x261A
  ,simpleLowerCaseMapping:0x261A
  ,simpleTitleCaseMapping:0x261A
 },
 { code:0x261B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x261B
  ,simpleLowerCaseMapping:0x261B
  ,simpleTitleCaseMapping:0x261B
 },
 { code:0x261C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x261C
  ,simpleLowerCaseMapping:0x261C
  ,simpleTitleCaseMapping:0x261C
 },
 { code:0x261D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x261D
  ,simpleLowerCaseMapping:0x261D
  ,simpleTitleCaseMapping:0x261D
 },
 { code:0x261E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x261E
  ,simpleLowerCaseMapping:0x261E
  ,simpleTitleCaseMapping:0x261E
 },
 { code:0x261F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x261F
  ,simpleLowerCaseMapping:0x261F
  ,simpleTitleCaseMapping:0x261F
 },
 { code:0x2620
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2620
  ,simpleLowerCaseMapping:0x2620
  ,simpleTitleCaseMapping:0x2620
 },
 { code:0x2621
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2621
  ,simpleLowerCaseMapping:0x2621
  ,simpleTitleCaseMapping:0x2621
 },
 { code:0x2622
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2622
  ,simpleLowerCaseMapping:0x2622
  ,simpleTitleCaseMapping:0x2622
 },
 { code:0x2623
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2623
  ,simpleLowerCaseMapping:0x2623
  ,simpleTitleCaseMapping:0x2623
 },
 { code:0x2624
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2624
  ,simpleLowerCaseMapping:0x2624
  ,simpleTitleCaseMapping:0x2624
 },
 { code:0x2625
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2625
  ,simpleLowerCaseMapping:0x2625
  ,simpleTitleCaseMapping:0x2625
 },
 { code:0x2626
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2626
  ,simpleLowerCaseMapping:0x2626
  ,simpleTitleCaseMapping:0x2626
 },
 { code:0x2627
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2627
  ,simpleLowerCaseMapping:0x2627
  ,simpleTitleCaseMapping:0x2627
 },
 { code:0x2628
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2628
  ,simpleLowerCaseMapping:0x2628
  ,simpleTitleCaseMapping:0x2628
 },
 { code:0x2629
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2629
  ,simpleLowerCaseMapping:0x2629
  ,simpleTitleCaseMapping:0x2629
 },
 { code:0x262A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x262A
  ,simpleLowerCaseMapping:0x262A
  ,simpleTitleCaseMapping:0x262A
 },
 { code:0x262B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x262B
  ,simpleLowerCaseMapping:0x262B
  ,simpleTitleCaseMapping:0x262B
 },
 { code:0x262C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x262C
  ,simpleLowerCaseMapping:0x262C
  ,simpleTitleCaseMapping:0x262C
 },
 { code:0x262D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x262D
  ,simpleLowerCaseMapping:0x262D
  ,simpleTitleCaseMapping:0x262D
 },
 { code:0x262E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x262E
  ,simpleLowerCaseMapping:0x262E
  ,simpleTitleCaseMapping:0x262E
 },
 { code:0x262F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x262F
  ,simpleLowerCaseMapping:0x262F
  ,simpleTitleCaseMapping:0x262F
 },
 { code:0x2630
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2630
  ,simpleLowerCaseMapping:0x2630
  ,simpleTitleCaseMapping:0x2630
 },
 { code:0x2631
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2631
  ,simpleLowerCaseMapping:0x2631
  ,simpleTitleCaseMapping:0x2631
 },
 { code:0x2632
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2632
  ,simpleLowerCaseMapping:0x2632
  ,simpleTitleCaseMapping:0x2632
 },
 { code:0x2633
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2633
  ,simpleLowerCaseMapping:0x2633
  ,simpleTitleCaseMapping:0x2633
 },
 { code:0x2634
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2634
  ,simpleLowerCaseMapping:0x2634
  ,simpleTitleCaseMapping:0x2634
 },
 { code:0x2635
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2635
  ,simpleLowerCaseMapping:0x2635
  ,simpleTitleCaseMapping:0x2635
 },
 { code:0x2636
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2636
  ,simpleLowerCaseMapping:0x2636
  ,simpleTitleCaseMapping:0x2636
 },
 { code:0x2637
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2637
  ,simpleLowerCaseMapping:0x2637
  ,simpleTitleCaseMapping:0x2637
 },
 { code:0x2638
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2638
  ,simpleLowerCaseMapping:0x2638
  ,simpleTitleCaseMapping:0x2638
 },
 { code:0x2639
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2639
  ,simpleLowerCaseMapping:0x2639
  ,simpleTitleCaseMapping:0x2639
 },
 { code:0x263A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x263A
  ,simpleLowerCaseMapping:0x263A
  ,simpleTitleCaseMapping:0x263A
 },
 { code:0x263B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x263B
  ,simpleLowerCaseMapping:0x263B
  ,simpleTitleCaseMapping:0x263B
 },
 { code:0x263C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x263C
  ,simpleLowerCaseMapping:0x263C
  ,simpleTitleCaseMapping:0x263C
 },
 { code:0x263D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x263D
  ,simpleLowerCaseMapping:0x263D
  ,simpleTitleCaseMapping:0x263D
 },
 { code:0x263E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x263E
  ,simpleLowerCaseMapping:0x263E
  ,simpleTitleCaseMapping:0x263E
 },
 { code:0x263F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x263F
  ,simpleLowerCaseMapping:0x263F
  ,simpleTitleCaseMapping:0x263F
 },
 { code:0x2640
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2640
  ,simpleLowerCaseMapping:0x2640
  ,simpleTitleCaseMapping:0x2640
 },
 { code:0x2641
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2641
  ,simpleLowerCaseMapping:0x2641
  ,simpleTitleCaseMapping:0x2641
 },
 { code:0x2642
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2642
  ,simpleLowerCaseMapping:0x2642
  ,simpleTitleCaseMapping:0x2642
 },
 { code:0x2643
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2643
  ,simpleLowerCaseMapping:0x2643
  ,simpleTitleCaseMapping:0x2643
 },
 { code:0x2644
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2644
  ,simpleLowerCaseMapping:0x2644
  ,simpleTitleCaseMapping:0x2644
 },
 { code:0x2645
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2645
  ,simpleLowerCaseMapping:0x2645
  ,simpleTitleCaseMapping:0x2645
 },
 { code:0x2646
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2646
  ,simpleLowerCaseMapping:0x2646
  ,simpleTitleCaseMapping:0x2646
 },
 { code:0x2647
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2647
  ,simpleLowerCaseMapping:0x2647
  ,simpleTitleCaseMapping:0x2647
 },
 { code:0x2648
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2648
  ,simpleLowerCaseMapping:0x2648
  ,simpleTitleCaseMapping:0x2648
 },
 { code:0x2649
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2649
  ,simpleLowerCaseMapping:0x2649
  ,simpleTitleCaseMapping:0x2649
 },
 { code:0x264A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x264A
  ,simpleLowerCaseMapping:0x264A
  ,simpleTitleCaseMapping:0x264A
 },
 { code:0x264B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x264B
  ,simpleLowerCaseMapping:0x264B
  ,simpleTitleCaseMapping:0x264B
 },
 { code:0x264C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x264C
  ,simpleLowerCaseMapping:0x264C
  ,simpleTitleCaseMapping:0x264C
 },
 { code:0x264D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x264D
  ,simpleLowerCaseMapping:0x264D
  ,simpleTitleCaseMapping:0x264D
 },
 { code:0x264E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x264E
  ,simpleLowerCaseMapping:0x264E
  ,simpleTitleCaseMapping:0x264E
 },
 { code:0x264F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x264F
  ,simpleLowerCaseMapping:0x264F
  ,simpleTitleCaseMapping:0x264F
 },
 { code:0x2650
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2650
  ,simpleLowerCaseMapping:0x2650
  ,simpleTitleCaseMapping:0x2650
 },
 { code:0x2651
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2651
  ,simpleLowerCaseMapping:0x2651
  ,simpleTitleCaseMapping:0x2651
 },
 { code:0x2652
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2652
  ,simpleLowerCaseMapping:0x2652
  ,simpleTitleCaseMapping:0x2652
 },
 { code:0x2653
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2653
  ,simpleLowerCaseMapping:0x2653
  ,simpleTitleCaseMapping:0x2653
 },
 { code:0x2654
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2654
  ,simpleLowerCaseMapping:0x2654
  ,simpleTitleCaseMapping:0x2654
 },
 { code:0x2655
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2655
  ,simpleLowerCaseMapping:0x2655
  ,simpleTitleCaseMapping:0x2655
 },
 { code:0x2656
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2656
  ,simpleLowerCaseMapping:0x2656
  ,simpleTitleCaseMapping:0x2656
 },
 { code:0x2657
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2657
  ,simpleLowerCaseMapping:0x2657
  ,simpleTitleCaseMapping:0x2657
 },
 { code:0x2658
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2658
  ,simpleLowerCaseMapping:0x2658
  ,simpleTitleCaseMapping:0x2658
 },
 { code:0x2659
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2659
  ,simpleLowerCaseMapping:0x2659
  ,simpleTitleCaseMapping:0x2659
 },
 { code:0x265A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x265A
  ,simpleLowerCaseMapping:0x265A
  ,simpleTitleCaseMapping:0x265A
 },
 { code:0x265B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x265B
  ,simpleLowerCaseMapping:0x265B
  ,simpleTitleCaseMapping:0x265B
 },
 { code:0x265C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x265C
  ,simpleLowerCaseMapping:0x265C
  ,simpleTitleCaseMapping:0x265C
 },
 { code:0x265D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x265D
  ,simpleLowerCaseMapping:0x265D
  ,simpleTitleCaseMapping:0x265D
 },
 { code:0x265E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x265E
  ,simpleLowerCaseMapping:0x265E
  ,simpleTitleCaseMapping:0x265E
 },
 { code:0x265F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x265F
  ,simpleLowerCaseMapping:0x265F
  ,simpleTitleCaseMapping:0x265F
 },
 { code:0x2660
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2660
  ,simpleLowerCaseMapping:0x2660
  ,simpleTitleCaseMapping:0x2660
 },
 { code:0x2661
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2661
  ,simpleLowerCaseMapping:0x2661
  ,simpleTitleCaseMapping:0x2661
 },
 { code:0x2662
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2662
  ,simpleLowerCaseMapping:0x2662
  ,simpleTitleCaseMapping:0x2662
 },
 { code:0x2663
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2663
  ,simpleLowerCaseMapping:0x2663
  ,simpleTitleCaseMapping:0x2663
 },
 { code:0x2664
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2664
  ,simpleLowerCaseMapping:0x2664
  ,simpleTitleCaseMapping:0x2664
 },
 { code:0x2665
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2665
  ,simpleLowerCaseMapping:0x2665
  ,simpleTitleCaseMapping:0x2665
 },
 { code:0x2666
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2666
  ,simpleLowerCaseMapping:0x2666
  ,simpleTitleCaseMapping:0x2666
 },
 { code:0x2667
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2667
  ,simpleLowerCaseMapping:0x2667
  ,simpleTitleCaseMapping:0x2667
 },
 { code:0x2668
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2668
  ,simpleLowerCaseMapping:0x2668
  ,simpleTitleCaseMapping:0x2668
 },
 { code:0x2669
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2669
  ,simpleLowerCaseMapping:0x2669
  ,simpleTitleCaseMapping:0x2669
 },
 { code:0x266A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x266A
  ,simpleLowerCaseMapping:0x266A
  ,simpleTitleCaseMapping:0x266A
 },
 { code:0x266B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x266B
  ,simpleLowerCaseMapping:0x266B
  ,simpleTitleCaseMapping:0x266B
 },
 { code:0x266C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x266C
  ,simpleLowerCaseMapping:0x266C
  ,simpleTitleCaseMapping:0x266C
 },
 { code:0x266D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x266D
  ,simpleLowerCaseMapping:0x266D
  ,simpleTitleCaseMapping:0x266D
 },
 { code:0x266E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x266E
  ,simpleLowerCaseMapping:0x266E
  ,simpleTitleCaseMapping:0x266E
 },
 { code:0x266F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x266F
  ,simpleLowerCaseMapping:0x266F
  ,simpleTitleCaseMapping:0x266F
 },
 { code:0x2670
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2670
  ,simpleLowerCaseMapping:0x2670
  ,simpleTitleCaseMapping:0x2670
 },
 { code:0x2671
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2671
  ,simpleLowerCaseMapping:0x2671
  ,simpleTitleCaseMapping:0x2671
 },
 { code:0x2672
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2672
  ,simpleLowerCaseMapping:0x2672
  ,simpleTitleCaseMapping:0x2672
 },
 { code:0x2673
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2673
  ,simpleLowerCaseMapping:0x2673
  ,simpleTitleCaseMapping:0x2673
 },
 { code:0x2674
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2674
  ,simpleLowerCaseMapping:0x2674
  ,simpleTitleCaseMapping:0x2674
 },
 { code:0x2675
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2675
  ,simpleLowerCaseMapping:0x2675
  ,simpleTitleCaseMapping:0x2675
 },
 { code:0x2676
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2676
  ,simpleLowerCaseMapping:0x2676
  ,simpleTitleCaseMapping:0x2676
 },
 { code:0x2677
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2677
  ,simpleLowerCaseMapping:0x2677
  ,simpleTitleCaseMapping:0x2677
 },
 { code:0x2678
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2678
  ,simpleLowerCaseMapping:0x2678
  ,simpleTitleCaseMapping:0x2678
 },
 { code:0x2679
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2679
  ,simpleLowerCaseMapping:0x2679
  ,simpleTitleCaseMapping:0x2679
 },
 { code:0x267A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x267A
  ,simpleLowerCaseMapping:0x267A
  ,simpleTitleCaseMapping:0x267A
 },
 { code:0x267B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x267B
  ,simpleLowerCaseMapping:0x267B
  ,simpleTitleCaseMapping:0x267B
 },
 { code:0x267C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x267C
  ,simpleLowerCaseMapping:0x267C
  ,simpleTitleCaseMapping:0x267C
 },
 { code:0x267D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x267D
  ,simpleLowerCaseMapping:0x267D
  ,simpleTitleCaseMapping:0x267D
 },
 { code:0x267E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x267E
  ,simpleLowerCaseMapping:0x267E
  ,simpleTitleCaseMapping:0x267E
 },
 { code:0x267F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x267F
  ,simpleLowerCaseMapping:0x267F
  ,simpleTitleCaseMapping:0x267F
 },
 { code:0x2680
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2680
  ,simpleLowerCaseMapping:0x2680
  ,simpleTitleCaseMapping:0x2680
 },
 { code:0x2681
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2681
  ,simpleLowerCaseMapping:0x2681
  ,simpleTitleCaseMapping:0x2681
 },
 { code:0x2682
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2682
  ,simpleLowerCaseMapping:0x2682
  ,simpleTitleCaseMapping:0x2682
 },
 { code:0x2683
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2683
  ,simpleLowerCaseMapping:0x2683
  ,simpleTitleCaseMapping:0x2683
 },
 { code:0x2684
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2684
  ,simpleLowerCaseMapping:0x2684
  ,simpleTitleCaseMapping:0x2684
 },
 { code:0x2685
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2685
  ,simpleLowerCaseMapping:0x2685
  ,simpleTitleCaseMapping:0x2685
 },
 { code:0x2686
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2686
  ,simpleLowerCaseMapping:0x2686
  ,simpleTitleCaseMapping:0x2686
 },
 { code:0x2687
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2687
  ,simpleLowerCaseMapping:0x2687
  ,simpleTitleCaseMapping:0x2687
 },
 { code:0x2688
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2688
  ,simpleLowerCaseMapping:0x2688
  ,simpleTitleCaseMapping:0x2688
 },
 { code:0x2689
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2689
  ,simpleLowerCaseMapping:0x2689
  ,simpleTitleCaseMapping:0x2689
 },
 { code:0x268A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x268A
  ,simpleLowerCaseMapping:0x268A
  ,simpleTitleCaseMapping:0x268A
 },
 { code:0x268B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x268B
  ,simpleLowerCaseMapping:0x268B
  ,simpleTitleCaseMapping:0x268B
 },
 { code:0x268C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x268C
  ,simpleLowerCaseMapping:0x268C
  ,simpleTitleCaseMapping:0x268C
 },
 { code:0x268D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x268D
  ,simpleLowerCaseMapping:0x268D
  ,simpleTitleCaseMapping:0x268D
 },
 { code:0x268E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x268E
  ,simpleLowerCaseMapping:0x268E
  ,simpleTitleCaseMapping:0x268E
 },
 { code:0x268F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x268F
  ,simpleLowerCaseMapping:0x268F
  ,simpleTitleCaseMapping:0x268F
 },
 { code:0x2690
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2690
  ,simpleLowerCaseMapping:0x2690
  ,simpleTitleCaseMapping:0x2690
 },
 { code:0x2691
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2691
  ,simpleLowerCaseMapping:0x2691
  ,simpleTitleCaseMapping:0x2691
 },
 { code:0x2692
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2692
  ,simpleLowerCaseMapping:0x2692
  ,simpleTitleCaseMapping:0x2692
 },
 { code:0x2693
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2693
  ,simpleLowerCaseMapping:0x2693
  ,simpleTitleCaseMapping:0x2693
 },
 { code:0x2694
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2694
  ,simpleLowerCaseMapping:0x2694
  ,simpleTitleCaseMapping:0x2694
 },
 { code:0x2695
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2695
  ,simpleLowerCaseMapping:0x2695
  ,simpleTitleCaseMapping:0x2695
 },
 { code:0x2696
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2696
  ,simpleLowerCaseMapping:0x2696
  ,simpleTitleCaseMapping:0x2696
 },
 { code:0x2697
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2697
  ,simpleLowerCaseMapping:0x2697
  ,simpleTitleCaseMapping:0x2697
 },
 { code:0x2698
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2698
  ,simpleLowerCaseMapping:0x2698
  ,simpleTitleCaseMapping:0x2698
 },
 { code:0x2699
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2699
  ,simpleLowerCaseMapping:0x2699
  ,simpleTitleCaseMapping:0x2699
 },
 { code:0x269A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x269A
  ,simpleLowerCaseMapping:0x269A
  ,simpleTitleCaseMapping:0x269A
 },
 { code:0x269B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x269B
  ,simpleLowerCaseMapping:0x269B
  ,simpleTitleCaseMapping:0x269B
 },
 { code:0x269C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x269C
  ,simpleLowerCaseMapping:0x269C
  ,simpleTitleCaseMapping:0x269C
 },
 { code:0x26A0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26A0
  ,simpleLowerCaseMapping:0x26A0
  ,simpleTitleCaseMapping:0x26A0
 },
 { code:0x26A1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26A1
  ,simpleLowerCaseMapping:0x26A1
  ,simpleTitleCaseMapping:0x26A1
 },
 { code:0x26A2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26A2
  ,simpleLowerCaseMapping:0x26A2
  ,simpleTitleCaseMapping:0x26A2
 },
 { code:0x26A3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26A3
  ,simpleLowerCaseMapping:0x26A3
  ,simpleTitleCaseMapping:0x26A3
 },
 { code:0x26A4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26A4
  ,simpleLowerCaseMapping:0x26A4
  ,simpleTitleCaseMapping:0x26A4
 },
 { code:0x26A5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26A5
  ,simpleLowerCaseMapping:0x26A5
  ,simpleTitleCaseMapping:0x26A5
 },
 { code:0x26A6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26A6
  ,simpleLowerCaseMapping:0x26A6
  ,simpleTitleCaseMapping:0x26A6
 },
 { code:0x26A7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26A7
  ,simpleLowerCaseMapping:0x26A7
  ,simpleTitleCaseMapping:0x26A7
 },
 { code:0x26A8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26A8
  ,simpleLowerCaseMapping:0x26A8
  ,simpleTitleCaseMapping:0x26A8
 },
 { code:0x26A9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26A9
  ,simpleLowerCaseMapping:0x26A9
  ,simpleTitleCaseMapping:0x26A9
 },
 { code:0x26AA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26AA
  ,simpleLowerCaseMapping:0x26AA
  ,simpleTitleCaseMapping:0x26AA
 },
 { code:0x26AB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26AB
  ,simpleLowerCaseMapping:0x26AB
  ,simpleTitleCaseMapping:0x26AB
 },
 { code:0x26AC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26AC
  ,simpleLowerCaseMapping:0x26AC
  ,simpleTitleCaseMapping:0x26AC
 },
 { code:0x26AD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26AD
  ,simpleLowerCaseMapping:0x26AD
  ,simpleTitleCaseMapping:0x26AD
 },
 { code:0x26AE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26AE
  ,simpleLowerCaseMapping:0x26AE
  ,simpleTitleCaseMapping:0x26AE
 },
 { code:0x26AF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26AF
  ,simpleLowerCaseMapping:0x26AF
  ,simpleTitleCaseMapping:0x26AF
 },
 { code:0x26B0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26B0
  ,simpleLowerCaseMapping:0x26B0
  ,simpleTitleCaseMapping:0x26B0
 },
 { code:0x26B1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26B1
  ,simpleLowerCaseMapping:0x26B1
  ,simpleTitleCaseMapping:0x26B1
 },
 { code:0x26B2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x26B2
  ,simpleLowerCaseMapping:0x26B2
  ,simpleTitleCaseMapping:0x26B2
 },
 { code:0x2701
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2701
  ,simpleLowerCaseMapping:0x2701
  ,simpleTitleCaseMapping:0x2701
 },
 { code:0x2702
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2702
  ,simpleLowerCaseMapping:0x2702
  ,simpleTitleCaseMapping:0x2702
 },
 { code:0x2703
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2703
  ,simpleLowerCaseMapping:0x2703
  ,simpleTitleCaseMapping:0x2703
 },
 { code:0x2704
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2704
  ,simpleLowerCaseMapping:0x2704
  ,simpleTitleCaseMapping:0x2704
 },
 { code:0x2706
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2706
  ,simpleLowerCaseMapping:0x2706
  ,simpleTitleCaseMapping:0x2706
 },
 { code:0x2707
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2707
  ,simpleLowerCaseMapping:0x2707
  ,simpleTitleCaseMapping:0x2707
 },
 { code:0x2708
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2708
  ,simpleLowerCaseMapping:0x2708
  ,simpleTitleCaseMapping:0x2708
 },
 { code:0x2709
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2709
  ,simpleLowerCaseMapping:0x2709
  ,simpleTitleCaseMapping:0x2709
 },
 { code:0x270C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x270C
  ,simpleLowerCaseMapping:0x270C
  ,simpleTitleCaseMapping:0x270C
 },
 { code:0x270D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x270D
  ,simpleLowerCaseMapping:0x270D
  ,simpleTitleCaseMapping:0x270D
 },
 { code:0x270E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x270E
  ,simpleLowerCaseMapping:0x270E
  ,simpleTitleCaseMapping:0x270E
 },
 { code:0x270F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x270F
  ,simpleLowerCaseMapping:0x270F
  ,simpleTitleCaseMapping:0x270F
 },
 { code:0x2710
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2710
  ,simpleLowerCaseMapping:0x2710
  ,simpleTitleCaseMapping:0x2710
 },
 { code:0x2711
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2711
  ,simpleLowerCaseMapping:0x2711
  ,simpleTitleCaseMapping:0x2711
 },
 { code:0x2712
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2712
  ,simpleLowerCaseMapping:0x2712
  ,simpleTitleCaseMapping:0x2712
 },
 { code:0x2713
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2713
  ,simpleLowerCaseMapping:0x2713
  ,simpleTitleCaseMapping:0x2713
 },
 { code:0x2714
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2714
  ,simpleLowerCaseMapping:0x2714
  ,simpleTitleCaseMapping:0x2714
 },
 { code:0x2715
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2715
  ,simpleLowerCaseMapping:0x2715
  ,simpleTitleCaseMapping:0x2715
 },
 { code:0x2716
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2716
  ,simpleLowerCaseMapping:0x2716
  ,simpleTitleCaseMapping:0x2716
 },
 { code:0x2717
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2717
  ,simpleLowerCaseMapping:0x2717
  ,simpleTitleCaseMapping:0x2717
 },
 { code:0x2718
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2718
  ,simpleLowerCaseMapping:0x2718
  ,simpleTitleCaseMapping:0x2718
 },
 { code:0x2719
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2719
  ,simpleLowerCaseMapping:0x2719
  ,simpleTitleCaseMapping:0x2719
 },
 { code:0x271A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x271A
  ,simpleLowerCaseMapping:0x271A
  ,simpleTitleCaseMapping:0x271A
 },
 { code:0x271B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x271B
  ,simpleLowerCaseMapping:0x271B
  ,simpleTitleCaseMapping:0x271B
 },
 { code:0x271C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x271C
  ,simpleLowerCaseMapping:0x271C
  ,simpleTitleCaseMapping:0x271C
 },
 { code:0x271D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x271D
  ,simpleLowerCaseMapping:0x271D
  ,simpleTitleCaseMapping:0x271D
 },
 { code:0x271E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x271E
  ,simpleLowerCaseMapping:0x271E
  ,simpleTitleCaseMapping:0x271E
 },
 { code:0x271F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x271F
  ,simpleLowerCaseMapping:0x271F
  ,simpleTitleCaseMapping:0x271F
 },
 { code:0x2720
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2720
  ,simpleLowerCaseMapping:0x2720
  ,simpleTitleCaseMapping:0x2720
 },
 { code:0x2721
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2721
  ,simpleLowerCaseMapping:0x2721
  ,simpleTitleCaseMapping:0x2721
 },
 { code:0x2722
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2722
  ,simpleLowerCaseMapping:0x2722
  ,simpleTitleCaseMapping:0x2722
 },
 { code:0x2723
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2723
  ,simpleLowerCaseMapping:0x2723
  ,simpleTitleCaseMapping:0x2723
 },
 { code:0x2724
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2724
  ,simpleLowerCaseMapping:0x2724
  ,simpleTitleCaseMapping:0x2724
 },
 { code:0x2725
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2725
  ,simpleLowerCaseMapping:0x2725
  ,simpleTitleCaseMapping:0x2725
 },
 { code:0x2726
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2726
  ,simpleLowerCaseMapping:0x2726
  ,simpleTitleCaseMapping:0x2726
 },
 { code:0x2727
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2727
  ,simpleLowerCaseMapping:0x2727
  ,simpleTitleCaseMapping:0x2727
 },
 { code:0x2729
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2729
  ,simpleLowerCaseMapping:0x2729
  ,simpleTitleCaseMapping:0x2729
 },
 { code:0x272A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x272A
  ,simpleLowerCaseMapping:0x272A
  ,simpleTitleCaseMapping:0x272A
 },
 { code:0x272B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x272B
  ,simpleLowerCaseMapping:0x272B
  ,simpleTitleCaseMapping:0x272B
 },
 { code:0x272C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x272C
  ,simpleLowerCaseMapping:0x272C
  ,simpleTitleCaseMapping:0x272C
 },
 { code:0x272D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x272D
  ,simpleLowerCaseMapping:0x272D
  ,simpleTitleCaseMapping:0x272D
 },
 { code:0x272E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x272E
  ,simpleLowerCaseMapping:0x272E
  ,simpleTitleCaseMapping:0x272E
 },
 { code:0x272F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x272F
  ,simpleLowerCaseMapping:0x272F
  ,simpleTitleCaseMapping:0x272F
 },
 { code:0x2730
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2730
  ,simpleLowerCaseMapping:0x2730
  ,simpleTitleCaseMapping:0x2730
 },
 { code:0x2731
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2731
  ,simpleLowerCaseMapping:0x2731
  ,simpleTitleCaseMapping:0x2731
 },
 { code:0x2732
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2732
  ,simpleLowerCaseMapping:0x2732
  ,simpleTitleCaseMapping:0x2732
 },
 { code:0x2733
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2733
  ,simpleLowerCaseMapping:0x2733
  ,simpleTitleCaseMapping:0x2733
 },
 { code:0x2734
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2734
  ,simpleLowerCaseMapping:0x2734
  ,simpleTitleCaseMapping:0x2734
 },
 { code:0x2735
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2735
  ,simpleLowerCaseMapping:0x2735
  ,simpleTitleCaseMapping:0x2735
 },
 { code:0x2736
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2736
  ,simpleLowerCaseMapping:0x2736
  ,simpleTitleCaseMapping:0x2736
 },
 { code:0x2737
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2737
  ,simpleLowerCaseMapping:0x2737
  ,simpleTitleCaseMapping:0x2737
 },
 { code:0x2738
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2738
  ,simpleLowerCaseMapping:0x2738
  ,simpleTitleCaseMapping:0x2738
 },
 { code:0x2739
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2739
  ,simpleLowerCaseMapping:0x2739
  ,simpleTitleCaseMapping:0x2739
 },
 { code:0x273A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x273A
  ,simpleLowerCaseMapping:0x273A
  ,simpleTitleCaseMapping:0x273A
 },
 { code:0x273B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x273B
  ,simpleLowerCaseMapping:0x273B
  ,simpleTitleCaseMapping:0x273B
 },
 { code:0x273C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x273C
  ,simpleLowerCaseMapping:0x273C
  ,simpleTitleCaseMapping:0x273C
 },
 { code:0x273D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x273D
  ,simpleLowerCaseMapping:0x273D
  ,simpleTitleCaseMapping:0x273D
 },
 { code:0x273E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x273E
  ,simpleLowerCaseMapping:0x273E
  ,simpleTitleCaseMapping:0x273E
 },
 { code:0x273F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x273F
  ,simpleLowerCaseMapping:0x273F
  ,simpleTitleCaseMapping:0x273F
 },
 { code:0x2740
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2740
  ,simpleLowerCaseMapping:0x2740
  ,simpleTitleCaseMapping:0x2740
 },
 { code:0x2741
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2741
  ,simpleLowerCaseMapping:0x2741
  ,simpleTitleCaseMapping:0x2741
 },
 { code:0x2742
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2742
  ,simpleLowerCaseMapping:0x2742
  ,simpleTitleCaseMapping:0x2742
 },
 { code:0x2743
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2743
  ,simpleLowerCaseMapping:0x2743
  ,simpleTitleCaseMapping:0x2743
 },
 { code:0x2744
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2744
  ,simpleLowerCaseMapping:0x2744
  ,simpleTitleCaseMapping:0x2744
 },
 { code:0x2745
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2745
  ,simpleLowerCaseMapping:0x2745
  ,simpleTitleCaseMapping:0x2745
 },
 { code:0x2746
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2746
  ,simpleLowerCaseMapping:0x2746
  ,simpleTitleCaseMapping:0x2746
 },
 { code:0x2747
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2747
  ,simpleLowerCaseMapping:0x2747
  ,simpleTitleCaseMapping:0x2747
 },
 { code:0x2748
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2748
  ,simpleLowerCaseMapping:0x2748
  ,simpleTitleCaseMapping:0x2748
 },
 { code:0x2749
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2749
  ,simpleLowerCaseMapping:0x2749
  ,simpleTitleCaseMapping:0x2749
 },
 { code:0x274A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x274A
  ,simpleLowerCaseMapping:0x274A
  ,simpleTitleCaseMapping:0x274A
 },
 { code:0x274B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x274B
  ,simpleLowerCaseMapping:0x274B
  ,simpleTitleCaseMapping:0x274B
 },
 { code:0x274D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x274D
  ,simpleLowerCaseMapping:0x274D
  ,simpleTitleCaseMapping:0x274D
 },
 { code:0x274F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x274F
  ,simpleLowerCaseMapping:0x274F
  ,simpleTitleCaseMapping:0x274F
 },
 { code:0x2750
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2750
  ,simpleLowerCaseMapping:0x2750
  ,simpleTitleCaseMapping:0x2750
 },
 { code:0x2751
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2751
  ,simpleLowerCaseMapping:0x2751
  ,simpleTitleCaseMapping:0x2751
 },
 { code:0x2752
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2752
  ,simpleLowerCaseMapping:0x2752
  ,simpleTitleCaseMapping:0x2752
 },
 { code:0x2756
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2756
  ,simpleLowerCaseMapping:0x2756
  ,simpleTitleCaseMapping:0x2756
 },
 { code:0x2758
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2758
  ,simpleLowerCaseMapping:0x2758
  ,simpleTitleCaseMapping:0x2758
 },
 { code:0x2759
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2759
  ,simpleLowerCaseMapping:0x2759
  ,simpleTitleCaseMapping:0x2759
 },
 { code:0x275A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x275A
  ,simpleLowerCaseMapping:0x275A
  ,simpleTitleCaseMapping:0x275A
 },
 { code:0x275B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x275B
  ,simpleLowerCaseMapping:0x275B
  ,simpleTitleCaseMapping:0x275B
 },
 { code:0x275C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x275C
  ,simpleLowerCaseMapping:0x275C
  ,simpleTitleCaseMapping:0x275C
 },
 { code:0x275D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x275D
  ,simpleLowerCaseMapping:0x275D
  ,simpleTitleCaseMapping:0x275D
 },
 { code:0x275E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x275E
  ,simpleLowerCaseMapping:0x275E
  ,simpleTitleCaseMapping:0x275E
 },
 { code:0x2761
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2761
  ,simpleLowerCaseMapping:0x2761
  ,simpleTitleCaseMapping:0x2761
 },
 { code:0x2762
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2762
  ,simpleLowerCaseMapping:0x2762
  ,simpleTitleCaseMapping:0x2762
 },
 { code:0x2763
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2763
  ,simpleLowerCaseMapping:0x2763
  ,simpleTitleCaseMapping:0x2763
 },
 { code:0x2764
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2764
  ,simpleLowerCaseMapping:0x2764
  ,simpleTitleCaseMapping:0x2764
 },
 { code:0x2765
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2765
  ,simpleLowerCaseMapping:0x2765
  ,simpleTitleCaseMapping:0x2765
 },
 { code:0x2766
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2766
  ,simpleLowerCaseMapping:0x2766
  ,simpleTitleCaseMapping:0x2766
 },
 { code:0x2767
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2767
  ,simpleLowerCaseMapping:0x2767
  ,simpleTitleCaseMapping:0x2767
 },
 { code:0x2768
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x2768
  ,simpleLowerCaseMapping:0x2768
  ,simpleTitleCaseMapping:0x2768
 },
 { code:0x2769
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x2769
  ,simpleLowerCaseMapping:0x2769
  ,simpleTitleCaseMapping:0x2769
 },
 { code:0x276A
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x276A
  ,simpleLowerCaseMapping:0x276A
  ,simpleTitleCaseMapping:0x276A
 },
 { code:0x276B
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x276B
  ,simpleLowerCaseMapping:0x276B
  ,simpleTitleCaseMapping:0x276B
 },
 { code:0x276C
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x276C
  ,simpleLowerCaseMapping:0x276C
  ,simpleTitleCaseMapping:0x276C
 },
 { code:0x276D
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x276D
  ,simpleLowerCaseMapping:0x276D
  ,simpleTitleCaseMapping:0x276D
 },
 { code:0x276E
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x276E
  ,simpleLowerCaseMapping:0x276E
  ,simpleTitleCaseMapping:0x276E
 },
 { code:0x276F
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x276F
  ,simpleLowerCaseMapping:0x276F
  ,simpleTitleCaseMapping:0x276F
 },
 { code:0x2770
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x2770
  ,simpleLowerCaseMapping:0x2770
  ,simpleTitleCaseMapping:0x2770
 },
 { code:0x2771
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x2771
  ,simpleLowerCaseMapping:0x2771
  ,simpleTitleCaseMapping:0x2771
 },
 { code:0x2772
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x2772
  ,simpleLowerCaseMapping:0x2772
  ,simpleTitleCaseMapping:0x2772
 },
 { code:0x2773
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x2773
  ,simpleLowerCaseMapping:0x2773
  ,simpleTitleCaseMapping:0x2773
 },
 { code:0x2774
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x2774
  ,simpleLowerCaseMapping:0x2774
  ,simpleTitleCaseMapping:0x2774
 },
 { code:0x2775
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x2775
  ,simpleLowerCaseMapping:0x2775
  ,simpleTitleCaseMapping:0x2775
 },
 { code:0x2776
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2776
  ,simpleLowerCaseMapping:0x2776
  ,simpleTitleCaseMapping:0x2776
 },
 { code:0x2777
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2777
  ,simpleLowerCaseMapping:0x2777
  ,simpleTitleCaseMapping:0x2777
 },
 { code:0x2778
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2778
  ,simpleLowerCaseMapping:0x2778
  ,simpleTitleCaseMapping:0x2778
 },
 { code:0x2779
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2779
  ,simpleLowerCaseMapping:0x2779
  ,simpleTitleCaseMapping:0x2779
 },
 { code:0x277A
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x277A
  ,simpleLowerCaseMapping:0x277A
  ,simpleTitleCaseMapping:0x277A
 },
 { code:0x277B
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x277B
  ,simpleLowerCaseMapping:0x277B
  ,simpleTitleCaseMapping:0x277B
 },
 { code:0x277C
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x277C
  ,simpleLowerCaseMapping:0x277C
  ,simpleTitleCaseMapping:0x277C
 },
 { code:0x277D
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x277D
  ,simpleLowerCaseMapping:0x277D
  ,simpleTitleCaseMapping:0x277D
 },
 { code:0x277E
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x277E
  ,simpleLowerCaseMapping:0x277E
  ,simpleTitleCaseMapping:0x277E
 },
 { code:0x277F
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x277F
  ,simpleLowerCaseMapping:0x277F
  ,simpleTitleCaseMapping:0x277F
 },
 { code:0x2780
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2780
  ,simpleLowerCaseMapping:0x2780
  ,simpleTitleCaseMapping:0x2780
 },
 { code:0x2781
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2781
  ,simpleLowerCaseMapping:0x2781
  ,simpleTitleCaseMapping:0x2781
 },
 { code:0x2782
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2782
  ,simpleLowerCaseMapping:0x2782
  ,simpleTitleCaseMapping:0x2782
 },
 { code:0x2783
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2783
  ,simpleLowerCaseMapping:0x2783
  ,simpleTitleCaseMapping:0x2783
 },
 { code:0x2784
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2784
  ,simpleLowerCaseMapping:0x2784
  ,simpleTitleCaseMapping:0x2784
 },
 { code:0x2785
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2785
  ,simpleLowerCaseMapping:0x2785
  ,simpleTitleCaseMapping:0x2785
 },
 { code:0x2786
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2786
  ,simpleLowerCaseMapping:0x2786
  ,simpleTitleCaseMapping:0x2786
 },
 { code:0x2787
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2787
  ,simpleLowerCaseMapping:0x2787
  ,simpleTitleCaseMapping:0x2787
 },
 { code:0x2788
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2788
  ,simpleLowerCaseMapping:0x2788
  ,simpleTitleCaseMapping:0x2788
 },
 { code:0x2789
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2789
  ,simpleLowerCaseMapping:0x2789
  ,simpleTitleCaseMapping:0x2789
 },
 { code:0x278A
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x278A
  ,simpleLowerCaseMapping:0x278A
  ,simpleTitleCaseMapping:0x278A
 },
 { code:0x278B
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x278B
  ,simpleLowerCaseMapping:0x278B
  ,simpleTitleCaseMapping:0x278B
 },
 { code:0x278C
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x278C
  ,simpleLowerCaseMapping:0x278C
  ,simpleTitleCaseMapping:0x278C
 },
 { code:0x278D
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x278D
  ,simpleLowerCaseMapping:0x278D
  ,simpleTitleCaseMapping:0x278D
 },
 { code:0x278E
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x278E
  ,simpleLowerCaseMapping:0x278E
  ,simpleTitleCaseMapping:0x278E
 },
 { code:0x278F
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x278F
  ,simpleLowerCaseMapping:0x278F
  ,simpleTitleCaseMapping:0x278F
 },
 { code:0x2790
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2790
  ,simpleLowerCaseMapping:0x2790
  ,simpleTitleCaseMapping:0x2790
 },
 { code:0x2791
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2791
  ,simpleLowerCaseMapping:0x2791
  ,simpleTitleCaseMapping:0x2791
 },
 { code:0x2792
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2792
  ,simpleLowerCaseMapping:0x2792
  ,simpleTitleCaseMapping:0x2792
 },
 { code:0x2793
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2793
  ,simpleLowerCaseMapping:0x2793
  ,simpleTitleCaseMapping:0x2793
 },
 { code:0x2794
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2794
  ,simpleLowerCaseMapping:0x2794
  ,simpleTitleCaseMapping:0x2794
 },
 { code:0x2798
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2798
  ,simpleLowerCaseMapping:0x2798
  ,simpleTitleCaseMapping:0x2798
 },
 { code:0x2799
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2799
  ,simpleLowerCaseMapping:0x2799
  ,simpleTitleCaseMapping:0x2799
 },
 { code:0x279A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x279A
  ,simpleLowerCaseMapping:0x279A
  ,simpleTitleCaseMapping:0x279A
 },
 { code:0x279B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x279B
  ,simpleLowerCaseMapping:0x279B
  ,simpleTitleCaseMapping:0x279B
 },
 { code:0x279C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x279C
  ,simpleLowerCaseMapping:0x279C
  ,simpleTitleCaseMapping:0x279C
 },
 { code:0x279D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x279D
  ,simpleLowerCaseMapping:0x279D
  ,simpleTitleCaseMapping:0x279D
 },
 { code:0x279E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x279E
  ,simpleLowerCaseMapping:0x279E
  ,simpleTitleCaseMapping:0x279E
 },
 { code:0x279F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x279F
  ,simpleLowerCaseMapping:0x279F
  ,simpleTitleCaseMapping:0x279F
 },
 { code:0x27A0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27A0
  ,simpleLowerCaseMapping:0x27A0
  ,simpleTitleCaseMapping:0x27A0
 },
 { code:0x27A1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27A1
  ,simpleLowerCaseMapping:0x27A1
  ,simpleTitleCaseMapping:0x27A1
 },
 { code:0x27A2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27A2
  ,simpleLowerCaseMapping:0x27A2
  ,simpleTitleCaseMapping:0x27A2
 },
 { code:0x27A3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27A3
  ,simpleLowerCaseMapping:0x27A3
  ,simpleTitleCaseMapping:0x27A3
 },
 { code:0x27A4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27A4
  ,simpleLowerCaseMapping:0x27A4
  ,simpleTitleCaseMapping:0x27A4
 },
 { code:0x27A5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27A5
  ,simpleLowerCaseMapping:0x27A5
  ,simpleTitleCaseMapping:0x27A5
 },
 { code:0x27A6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27A6
  ,simpleLowerCaseMapping:0x27A6
  ,simpleTitleCaseMapping:0x27A6
 },
 { code:0x27A7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27A7
  ,simpleLowerCaseMapping:0x27A7
  ,simpleTitleCaseMapping:0x27A7
 },
 { code:0x27A8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27A8
  ,simpleLowerCaseMapping:0x27A8
  ,simpleTitleCaseMapping:0x27A8
 },
 { code:0x27A9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27A9
  ,simpleLowerCaseMapping:0x27A9
  ,simpleTitleCaseMapping:0x27A9
 },
 { code:0x27AA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27AA
  ,simpleLowerCaseMapping:0x27AA
  ,simpleTitleCaseMapping:0x27AA
 },
 { code:0x27AB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27AB
  ,simpleLowerCaseMapping:0x27AB
  ,simpleTitleCaseMapping:0x27AB
 },
 { code:0x27AC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27AC
  ,simpleLowerCaseMapping:0x27AC
  ,simpleTitleCaseMapping:0x27AC
 },
 { code:0x27AD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27AD
  ,simpleLowerCaseMapping:0x27AD
  ,simpleTitleCaseMapping:0x27AD
 },
 { code:0x27AE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27AE
  ,simpleLowerCaseMapping:0x27AE
  ,simpleTitleCaseMapping:0x27AE
 },
 { code:0x27AF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27AF
  ,simpleLowerCaseMapping:0x27AF
  ,simpleTitleCaseMapping:0x27AF
 },
 { code:0x27B1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27B1
  ,simpleLowerCaseMapping:0x27B1
  ,simpleTitleCaseMapping:0x27B1
 },
 { code:0x27B2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27B2
  ,simpleLowerCaseMapping:0x27B2
  ,simpleTitleCaseMapping:0x27B2
 },
 { code:0x27B3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27B3
  ,simpleLowerCaseMapping:0x27B3
  ,simpleTitleCaseMapping:0x27B3
 },
 { code:0x27B4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27B4
  ,simpleLowerCaseMapping:0x27B4
  ,simpleTitleCaseMapping:0x27B4
 },
 { code:0x27B5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27B5
  ,simpleLowerCaseMapping:0x27B5
  ,simpleTitleCaseMapping:0x27B5
 },
 { code:0x27B6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27B6
  ,simpleLowerCaseMapping:0x27B6
  ,simpleTitleCaseMapping:0x27B6
 },
 { code:0x27B7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27B7
  ,simpleLowerCaseMapping:0x27B7
  ,simpleTitleCaseMapping:0x27B7
 },
 { code:0x27B8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27B8
  ,simpleLowerCaseMapping:0x27B8
  ,simpleTitleCaseMapping:0x27B8
 },
 { code:0x27B9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27B9
  ,simpleLowerCaseMapping:0x27B9
  ,simpleTitleCaseMapping:0x27B9
 },
 { code:0x27BA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27BA
  ,simpleLowerCaseMapping:0x27BA
  ,simpleTitleCaseMapping:0x27BA
 },
 { code:0x27BB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27BB
  ,simpleLowerCaseMapping:0x27BB
  ,simpleTitleCaseMapping:0x27BB
 },
 { code:0x27BC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27BC
  ,simpleLowerCaseMapping:0x27BC
  ,simpleTitleCaseMapping:0x27BC
 },
 { code:0x27BD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27BD
  ,simpleLowerCaseMapping:0x27BD
  ,simpleTitleCaseMapping:0x27BD
 },
 { code:0x27BE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x27BE
  ,simpleLowerCaseMapping:0x27BE
  ,simpleTitleCaseMapping:0x27BE
 },
 { code:0x27C0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27C0
  ,simpleLowerCaseMapping:0x27C0
  ,simpleTitleCaseMapping:0x27C0
 },
 { code:0x27C1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27C1
  ,simpleLowerCaseMapping:0x27C1
  ,simpleTitleCaseMapping:0x27C1
 },
 { code:0x27C2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27C2
  ,simpleLowerCaseMapping:0x27C2
  ,simpleTitleCaseMapping:0x27C2
 },
 { code:0x27C3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27C3
  ,simpleLowerCaseMapping:0x27C3
  ,simpleTitleCaseMapping:0x27C3
 },
 { code:0x27C4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27C4
  ,simpleLowerCaseMapping:0x27C4
  ,simpleTitleCaseMapping:0x27C4
 },
 { code:0x27C5
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x27C5
  ,simpleLowerCaseMapping:0x27C5
  ,simpleTitleCaseMapping:0x27C5
 },
 { code:0x27C6
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x27C6
  ,simpleLowerCaseMapping:0x27C6
  ,simpleTitleCaseMapping:0x27C6
 },
 { code:0x27C7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27C7
  ,simpleLowerCaseMapping:0x27C7
  ,simpleTitleCaseMapping:0x27C7
 },
 { code:0x27C8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27C8
  ,simpleLowerCaseMapping:0x27C8
  ,simpleTitleCaseMapping:0x27C8
 },
 { code:0x27C9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27C9
  ,simpleLowerCaseMapping:0x27C9
  ,simpleTitleCaseMapping:0x27C9
 },
 { code:0x27CA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27CA
  ,simpleLowerCaseMapping:0x27CA
  ,simpleTitleCaseMapping:0x27CA
 },
 { code:0x27D0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27D0
  ,simpleLowerCaseMapping:0x27D0
  ,simpleTitleCaseMapping:0x27D0
 },
 { code:0x27D1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27D1
  ,simpleLowerCaseMapping:0x27D1
  ,simpleTitleCaseMapping:0x27D1
 },
 { code:0x27D2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27D2
  ,simpleLowerCaseMapping:0x27D2
  ,simpleTitleCaseMapping:0x27D2
 },
 { code:0x27D3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27D3
  ,simpleLowerCaseMapping:0x27D3
  ,simpleTitleCaseMapping:0x27D3
 },
 { code:0x27D4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27D4
  ,simpleLowerCaseMapping:0x27D4
  ,simpleTitleCaseMapping:0x27D4
 },
 { code:0x27D5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27D5
  ,simpleLowerCaseMapping:0x27D5
  ,simpleTitleCaseMapping:0x27D5
 },
 { code:0x27D6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27D6
  ,simpleLowerCaseMapping:0x27D6
  ,simpleTitleCaseMapping:0x27D6
 },
 { code:0x27D7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27D7
  ,simpleLowerCaseMapping:0x27D7
  ,simpleTitleCaseMapping:0x27D7
 },
 { code:0x27D8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27D8
  ,simpleLowerCaseMapping:0x27D8
  ,simpleTitleCaseMapping:0x27D8
 },
 { code:0x27D9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27D9
  ,simpleLowerCaseMapping:0x27D9
  ,simpleTitleCaseMapping:0x27D9
 },
 { code:0x27DA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27DA
  ,simpleLowerCaseMapping:0x27DA
  ,simpleTitleCaseMapping:0x27DA
 },
 { code:0x27DB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27DB
  ,simpleLowerCaseMapping:0x27DB
  ,simpleTitleCaseMapping:0x27DB
 },
 { code:0x27DC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27DC
  ,simpleLowerCaseMapping:0x27DC
  ,simpleTitleCaseMapping:0x27DC
 },
 { code:0x27DD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27DD
  ,simpleLowerCaseMapping:0x27DD
  ,simpleTitleCaseMapping:0x27DD
 },
 { code:0x27DE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27DE
  ,simpleLowerCaseMapping:0x27DE
  ,simpleTitleCaseMapping:0x27DE
 },
 { code:0x27DF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27DF
  ,simpleLowerCaseMapping:0x27DF
  ,simpleTitleCaseMapping:0x27DF
 },
 { code:0x27E0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27E0
  ,simpleLowerCaseMapping:0x27E0
  ,simpleTitleCaseMapping:0x27E0
 },
 { code:0x27E1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27E1
  ,simpleLowerCaseMapping:0x27E1
  ,simpleTitleCaseMapping:0x27E1
 },
 { code:0x27E2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27E2
  ,simpleLowerCaseMapping:0x27E2
  ,simpleTitleCaseMapping:0x27E2
 },
 { code:0x27E3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27E3
  ,simpleLowerCaseMapping:0x27E3
  ,simpleTitleCaseMapping:0x27E3
 },
 { code:0x27E4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27E4
  ,simpleLowerCaseMapping:0x27E4
  ,simpleTitleCaseMapping:0x27E4
 },
 { code:0x27E5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27E5
  ,simpleLowerCaseMapping:0x27E5
  ,simpleTitleCaseMapping:0x27E5
 },
 { code:0x27E6
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x27E6
  ,simpleLowerCaseMapping:0x27E6
  ,simpleTitleCaseMapping:0x27E6
 },
 { code:0x27E7
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x27E7
  ,simpleLowerCaseMapping:0x27E7
  ,simpleTitleCaseMapping:0x27E7
 },
 { code:0x27E8
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x27E8
  ,simpleLowerCaseMapping:0x27E8
  ,simpleTitleCaseMapping:0x27E8
 },
 { code:0x27E9
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x27E9
  ,simpleLowerCaseMapping:0x27E9
  ,simpleTitleCaseMapping:0x27E9
 },
 { code:0x27EA
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x27EA
  ,simpleLowerCaseMapping:0x27EA
  ,simpleTitleCaseMapping:0x27EA
 },
 { code:0x27EB
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x27EB
  ,simpleLowerCaseMapping:0x27EB
  ,simpleTitleCaseMapping:0x27EB
 },
 { code:0x27F0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27F0
  ,simpleLowerCaseMapping:0x27F0
  ,simpleTitleCaseMapping:0x27F0
 },
 { code:0x27F1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27F1
  ,simpleLowerCaseMapping:0x27F1
  ,simpleTitleCaseMapping:0x27F1
 },
 { code:0x27F2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27F2
  ,simpleLowerCaseMapping:0x27F2
  ,simpleTitleCaseMapping:0x27F2
 },
 { code:0x27F3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27F3
  ,simpleLowerCaseMapping:0x27F3
  ,simpleTitleCaseMapping:0x27F3
 },
 { code:0x27F4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27F4
  ,simpleLowerCaseMapping:0x27F4
  ,simpleTitleCaseMapping:0x27F4
 },
 { code:0x27F5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27F5
  ,simpleLowerCaseMapping:0x27F5
  ,simpleTitleCaseMapping:0x27F5
 },
 { code:0x27F6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27F6
  ,simpleLowerCaseMapping:0x27F6
  ,simpleTitleCaseMapping:0x27F6
 },
 { code:0x27F7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27F7
  ,simpleLowerCaseMapping:0x27F7
  ,simpleTitleCaseMapping:0x27F7
 },
 { code:0x27F8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27F8
  ,simpleLowerCaseMapping:0x27F8
  ,simpleTitleCaseMapping:0x27F8
 },
 { code:0x27F9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27F9
  ,simpleLowerCaseMapping:0x27F9
  ,simpleTitleCaseMapping:0x27F9
 },
 { code:0x27FA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27FA
  ,simpleLowerCaseMapping:0x27FA
  ,simpleTitleCaseMapping:0x27FA
 },
 { code:0x27FB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27FB
  ,simpleLowerCaseMapping:0x27FB
  ,simpleTitleCaseMapping:0x27FB
 },
 { code:0x27FC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27FC
  ,simpleLowerCaseMapping:0x27FC
  ,simpleTitleCaseMapping:0x27FC
 },
 { code:0x27FD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27FD
  ,simpleLowerCaseMapping:0x27FD
  ,simpleTitleCaseMapping:0x27FD
 },
 { code:0x27FE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27FE
  ,simpleLowerCaseMapping:0x27FE
  ,simpleTitleCaseMapping:0x27FE
 },
 { code:0x27FF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x27FF
  ,simpleLowerCaseMapping:0x27FF
  ,simpleTitleCaseMapping:0x27FF
 },
 { code:0x2800
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2800
  ,simpleLowerCaseMapping:0x2800
  ,simpleTitleCaseMapping:0x2800
 },
 { code:0x2801
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2801
  ,simpleLowerCaseMapping:0x2801
  ,simpleTitleCaseMapping:0x2801
 },
 { code:0x2802
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2802
  ,simpleLowerCaseMapping:0x2802
  ,simpleTitleCaseMapping:0x2802
 },
 { code:0x2803
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2803
  ,simpleLowerCaseMapping:0x2803
  ,simpleTitleCaseMapping:0x2803
 },
 { code:0x2804
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2804
  ,simpleLowerCaseMapping:0x2804
  ,simpleTitleCaseMapping:0x2804
 },
 { code:0x2805
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2805
  ,simpleLowerCaseMapping:0x2805
  ,simpleTitleCaseMapping:0x2805
 },
 { code:0x2806
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2806
  ,simpleLowerCaseMapping:0x2806
  ,simpleTitleCaseMapping:0x2806
 },
 { code:0x2807
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2807
  ,simpleLowerCaseMapping:0x2807
  ,simpleTitleCaseMapping:0x2807
 },
 { code:0x2808
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2808
  ,simpleLowerCaseMapping:0x2808
  ,simpleTitleCaseMapping:0x2808
 },
 { code:0x2809
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2809
  ,simpleLowerCaseMapping:0x2809
  ,simpleTitleCaseMapping:0x2809
 },
 { code:0x280A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x280A
  ,simpleLowerCaseMapping:0x280A
  ,simpleTitleCaseMapping:0x280A
 },
 { code:0x280B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x280B
  ,simpleLowerCaseMapping:0x280B
  ,simpleTitleCaseMapping:0x280B
 },
 { code:0x280C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x280C
  ,simpleLowerCaseMapping:0x280C
  ,simpleTitleCaseMapping:0x280C
 },
 { code:0x280D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x280D
  ,simpleLowerCaseMapping:0x280D
  ,simpleTitleCaseMapping:0x280D
 },
 { code:0x280E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x280E
  ,simpleLowerCaseMapping:0x280E
  ,simpleTitleCaseMapping:0x280E
 },
 { code:0x280F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x280F
  ,simpleLowerCaseMapping:0x280F
  ,simpleTitleCaseMapping:0x280F
 },
 { code:0x2810
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2810
  ,simpleLowerCaseMapping:0x2810
  ,simpleTitleCaseMapping:0x2810
 },
 { code:0x2811
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2811
  ,simpleLowerCaseMapping:0x2811
  ,simpleTitleCaseMapping:0x2811
 },
 { code:0x2812
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2812
  ,simpleLowerCaseMapping:0x2812
  ,simpleTitleCaseMapping:0x2812
 },
 { code:0x2813
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2813
  ,simpleLowerCaseMapping:0x2813
  ,simpleTitleCaseMapping:0x2813
 },
 { code:0x2814
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2814
  ,simpleLowerCaseMapping:0x2814
  ,simpleTitleCaseMapping:0x2814
 },
 { code:0x2815
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2815
  ,simpleLowerCaseMapping:0x2815
  ,simpleTitleCaseMapping:0x2815
 },
 { code:0x2816
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2816
  ,simpleLowerCaseMapping:0x2816
  ,simpleTitleCaseMapping:0x2816
 },
 { code:0x2817
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2817
  ,simpleLowerCaseMapping:0x2817
  ,simpleTitleCaseMapping:0x2817
 },
 { code:0x2818
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2818
  ,simpleLowerCaseMapping:0x2818
  ,simpleTitleCaseMapping:0x2818
 },
 { code:0x2819
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2819
  ,simpleLowerCaseMapping:0x2819
  ,simpleTitleCaseMapping:0x2819
 },
 { code:0x281A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x281A
  ,simpleLowerCaseMapping:0x281A
  ,simpleTitleCaseMapping:0x281A
 },
 { code:0x281B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x281B
  ,simpleLowerCaseMapping:0x281B
  ,simpleTitleCaseMapping:0x281B
 },
 { code:0x281C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x281C
  ,simpleLowerCaseMapping:0x281C
  ,simpleTitleCaseMapping:0x281C
 },
 { code:0x281D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x281D
  ,simpleLowerCaseMapping:0x281D
  ,simpleTitleCaseMapping:0x281D
 },
 { code:0x281E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x281E
  ,simpleLowerCaseMapping:0x281E
  ,simpleTitleCaseMapping:0x281E
 },
 { code:0x281F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x281F
  ,simpleLowerCaseMapping:0x281F
  ,simpleTitleCaseMapping:0x281F
 },
 { code:0x2820
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2820
  ,simpleLowerCaseMapping:0x2820
  ,simpleTitleCaseMapping:0x2820
 },
 { code:0x2821
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2821
  ,simpleLowerCaseMapping:0x2821
  ,simpleTitleCaseMapping:0x2821
 },
 { code:0x2822
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2822
  ,simpleLowerCaseMapping:0x2822
  ,simpleTitleCaseMapping:0x2822
 },
 { code:0x2823
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2823
  ,simpleLowerCaseMapping:0x2823
  ,simpleTitleCaseMapping:0x2823
 },
 { code:0x2824
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2824
  ,simpleLowerCaseMapping:0x2824
  ,simpleTitleCaseMapping:0x2824
 },
 { code:0x2825
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2825
  ,simpleLowerCaseMapping:0x2825
  ,simpleTitleCaseMapping:0x2825
 },
 { code:0x2826
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2826
  ,simpleLowerCaseMapping:0x2826
  ,simpleTitleCaseMapping:0x2826
 },
 { code:0x2827
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2827
  ,simpleLowerCaseMapping:0x2827
  ,simpleTitleCaseMapping:0x2827
 },
 { code:0x2828
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2828
  ,simpleLowerCaseMapping:0x2828
  ,simpleTitleCaseMapping:0x2828
 },
 { code:0x2829
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2829
  ,simpleLowerCaseMapping:0x2829
  ,simpleTitleCaseMapping:0x2829
 },
 { code:0x282A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x282A
  ,simpleLowerCaseMapping:0x282A
  ,simpleTitleCaseMapping:0x282A
 },
 { code:0x282B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x282B
  ,simpleLowerCaseMapping:0x282B
  ,simpleTitleCaseMapping:0x282B
 },
 { code:0x282C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x282C
  ,simpleLowerCaseMapping:0x282C
  ,simpleTitleCaseMapping:0x282C
 },
 { code:0x282D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x282D
  ,simpleLowerCaseMapping:0x282D
  ,simpleTitleCaseMapping:0x282D
 },
 { code:0x282E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x282E
  ,simpleLowerCaseMapping:0x282E
  ,simpleTitleCaseMapping:0x282E
 },
 { code:0x282F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x282F
  ,simpleLowerCaseMapping:0x282F
  ,simpleTitleCaseMapping:0x282F
 },
 { code:0x2830
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2830
  ,simpleLowerCaseMapping:0x2830
  ,simpleTitleCaseMapping:0x2830
 },
 { code:0x2831
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2831
  ,simpleLowerCaseMapping:0x2831
  ,simpleTitleCaseMapping:0x2831
 },
 { code:0x2832
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2832
  ,simpleLowerCaseMapping:0x2832
  ,simpleTitleCaseMapping:0x2832
 },
 { code:0x2833
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2833
  ,simpleLowerCaseMapping:0x2833
  ,simpleTitleCaseMapping:0x2833
 },
 { code:0x2834
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2834
  ,simpleLowerCaseMapping:0x2834
  ,simpleTitleCaseMapping:0x2834
 },
 { code:0x2835
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2835
  ,simpleLowerCaseMapping:0x2835
  ,simpleTitleCaseMapping:0x2835
 },
 { code:0x2836
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2836
  ,simpleLowerCaseMapping:0x2836
  ,simpleTitleCaseMapping:0x2836
 },
 { code:0x2837
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2837
  ,simpleLowerCaseMapping:0x2837
  ,simpleTitleCaseMapping:0x2837
 },
 { code:0x2838
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2838
  ,simpleLowerCaseMapping:0x2838
  ,simpleTitleCaseMapping:0x2838
 },
 { code:0x2839
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2839
  ,simpleLowerCaseMapping:0x2839
  ,simpleTitleCaseMapping:0x2839
 },
 { code:0x283A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x283A
  ,simpleLowerCaseMapping:0x283A
  ,simpleTitleCaseMapping:0x283A
 },
 { code:0x283B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x283B
  ,simpleLowerCaseMapping:0x283B
  ,simpleTitleCaseMapping:0x283B
 },
 { code:0x283C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x283C
  ,simpleLowerCaseMapping:0x283C
  ,simpleTitleCaseMapping:0x283C
 },
 { code:0x283D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x283D
  ,simpleLowerCaseMapping:0x283D
  ,simpleTitleCaseMapping:0x283D
 },
 { code:0x283E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x283E
  ,simpleLowerCaseMapping:0x283E
  ,simpleTitleCaseMapping:0x283E
 },
 { code:0x283F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x283F
  ,simpleLowerCaseMapping:0x283F
  ,simpleTitleCaseMapping:0x283F
 },
 { code:0x2840
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2840
  ,simpleLowerCaseMapping:0x2840
  ,simpleTitleCaseMapping:0x2840
 },
 { code:0x2841
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2841
  ,simpleLowerCaseMapping:0x2841
  ,simpleTitleCaseMapping:0x2841
 },
 { code:0x2842
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2842
  ,simpleLowerCaseMapping:0x2842
  ,simpleTitleCaseMapping:0x2842
 },
 { code:0x2843
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2843
  ,simpleLowerCaseMapping:0x2843
  ,simpleTitleCaseMapping:0x2843
 },
 { code:0x2844
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2844
  ,simpleLowerCaseMapping:0x2844
  ,simpleTitleCaseMapping:0x2844
 },
 { code:0x2845
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2845
  ,simpleLowerCaseMapping:0x2845
  ,simpleTitleCaseMapping:0x2845
 },
 { code:0x2846
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2846
  ,simpleLowerCaseMapping:0x2846
  ,simpleTitleCaseMapping:0x2846
 },
 { code:0x2847
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2847
  ,simpleLowerCaseMapping:0x2847
  ,simpleTitleCaseMapping:0x2847
 },
 { code:0x2848
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2848
  ,simpleLowerCaseMapping:0x2848
  ,simpleTitleCaseMapping:0x2848
 },
 { code:0x2849
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2849
  ,simpleLowerCaseMapping:0x2849
  ,simpleTitleCaseMapping:0x2849
 },
 { code:0x284A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x284A
  ,simpleLowerCaseMapping:0x284A
  ,simpleTitleCaseMapping:0x284A
 },
 { code:0x284B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x284B
  ,simpleLowerCaseMapping:0x284B
  ,simpleTitleCaseMapping:0x284B
 },
 { code:0x284C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x284C
  ,simpleLowerCaseMapping:0x284C
  ,simpleTitleCaseMapping:0x284C
 },
 { code:0x284D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x284D
  ,simpleLowerCaseMapping:0x284D
  ,simpleTitleCaseMapping:0x284D
 },
 { code:0x284E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x284E
  ,simpleLowerCaseMapping:0x284E
  ,simpleTitleCaseMapping:0x284E
 },
 { code:0x284F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x284F
  ,simpleLowerCaseMapping:0x284F
  ,simpleTitleCaseMapping:0x284F
 },
 { code:0x2850
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2850
  ,simpleLowerCaseMapping:0x2850
  ,simpleTitleCaseMapping:0x2850
 },
 { code:0x2851
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2851
  ,simpleLowerCaseMapping:0x2851
  ,simpleTitleCaseMapping:0x2851
 },
 { code:0x2852
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2852
  ,simpleLowerCaseMapping:0x2852
  ,simpleTitleCaseMapping:0x2852
 },
 { code:0x2853
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2853
  ,simpleLowerCaseMapping:0x2853
  ,simpleTitleCaseMapping:0x2853
 },
 { code:0x2854
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2854
  ,simpleLowerCaseMapping:0x2854
  ,simpleTitleCaseMapping:0x2854
 },
 { code:0x2855
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2855
  ,simpleLowerCaseMapping:0x2855
  ,simpleTitleCaseMapping:0x2855
 },
 { code:0x2856
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2856
  ,simpleLowerCaseMapping:0x2856
  ,simpleTitleCaseMapping:0x2856
 },
 { code:0x2857
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2857
  ,simpleLowerCaseMapping:0x2857
  ,simpleTitleCaseMapping:0x2857
 },
 { code:0x2858
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2858
  ,simpleLowerCaseMapping:0x2858
  ,simpleTitleCaseMapping:0x2858
 },
 { code:0x2859
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2859
  ,simpleLowerCaseMapping:0x2859
  ,simpleTitleCaseMapping:0x2859
 },
 { code:0x285A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x285A
  ,simpleLowerCaseMapping:0x285A
  ,simpleTitleCaseMapping:0x285A
 },
 { code:0x285B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x285B
  ,simpleLowerCaseMapping:0x285B
  ,simpleTitleCaseMapping:0x285B
 },
 { code:0x285C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x285C
  ,simpleLowerCaseMapping:0x285C
  ,simpleTitleCaseMapping:0x285C
 },
 { code:0x285D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x285D
  ,simpleLowerCaseMapping:0x285D
  ,simpleTitleCaseMapping:0x285D
 },
 { code:0x285E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x285E
  ,simpleLowerCaseMapping:0x285E
  ,simpleTitleCaseMapping:0x285E
 },
 { code:0x285F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x285F
  ,simpleLowerCaseMapping:0x285F
  ,simpleTitleCaseMapping:0x285F
 },
 { code:0x2860
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2860
  ,simpleLowerCaseMapping:0x2860
  ,simpleTitleCaseMapping:0x2860
 },
 { code:0x2861
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2861
  ,simpleLowerCaseMapping:0x2861
  ,simpleTitleCaseMapping:0x2861
 },
 { code:0x2862
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2862
  ,simpleLowerCaseMapping:0x2862
  ,simpleTitleCaseMapping:0x2862
 },
 { code:0x2863
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2863
  ,simpleLowerCaseMapping:0x2863
  ,simpleTitleCaseMapping:0x2863
 },
 { code:0x2864
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2864
  ,simpleLowerCaseMapping:0x2864
  ,simpleTitleCaseMapping:0x2864
 },
 { code:0x2865
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2865
  ,simpleLowerCaseMapping:0x2865
  ,simpleTitleCaseMapping:0x2865
 },
 { code:0x2866
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2866
  ,simpleLowerCaseMapping:0x2866
  ,simpleTitleCaseMapping:0x2866
 },
 { code:0x2867
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2867
  ,simpleLowerCaseMapping:0x2867
  ,simpleTitleCaseMapping:0x2867
 },
 { code:0x2868
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2868
  ,simpleLowerCaseMapping:0x2868
  ,simpleTitleCaseMapping:0x2868
 },
 { code:0x2869
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2869
  ,simpleLowerCaseMapping:0x2869
  ,simpleTitleCaseMapping:0x2869
 },
 { code:0x286A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x286A
  ,simpleLowerCaseMapping:0x286A
  ,simpleTitleCaseMapping:0x286A
 },
 { code:0x286B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x286B
  ,simpleLowerCaseMapping:0x286B
  ,simpleTitleCaseMapping:0x286B
 },
 { code:0x286C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x286C
  ,simpleLowerCaseMapping:0x286C
  ,simpleTitleCaseMapping:0x286C
 },
 { code:0x286D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x286D
  ,simpleLowerCaseMapping:0x286D
  ,simpleTitleCaseMapping:0x286D
 },
 { code:0x286E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x286E
  ,simpleLowerCaseMapping:0x286E
  ,simpleTitleCaseMapping:0x286E
 },
 { code:0x286F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x286F
  ,simpleLowerCaseMapping:0x286F
  ,simpleTitleCaseMapping:0x286F
 },
 { code:0x2870
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2870
  ,simpleLowerCaseMapping:0x2870
  ,simpleTitleCaseMapping:0x2870
 },
 { code:0x2871
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2871
  ,simpleLowerCaseMapping:0x2871
  ,simpleTitleCaseMapping:0x2871
 },
 { code:0x2872
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2872
  ,simpleLowerCaseMapping:0x2872
  ,simpleTitleCaseMapping:0x2872
 },
 { code:0x2873
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2873
  ,simpleLowerCaseMapping:0x2873
  ,simpleTitleCaseMapping:0x2873
 },
 { code:0x2874
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2874
  ,simpleLowerCaseMapping:0x2874
  ,simpleTitleCaseMapping:0x2874
 },
 { code:0x2875
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2875
  ,simpleLowerCaseMapping:0x2875
  ,simpleTitleCaseMapping:0x2875
 },
 { code:0x2876
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2876
  ,simpleLowerCaseMapping:0x2876
  ,simpleTitleCaseMapping:0x2876
 },
 { code:0x2877
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2877
  ,simpleLowerCaseMapping:0x2877
  ,simpleTitleCaseMapping:0x2877
 },
 { code:0x2878
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2878
  ,simpleLowerCaseMapping:0x2878
  ,simpleTitleCaseMapping:0x2878
 },
 { code:0x2879
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2879
  ,simpleLowerCaseMapping:0x2879
  ,simpleTitleCaseMapping:0x2879
 },
 { code:0x287A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x287A
  ,simpleLowerCaseMapping:0x287A
  ,simpleTitleCaseMapping:0x287A
 },
 { code:0x287B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x287B
  ,simpleLowerCaseMapping:0x287B
  ,simpleTitleCaseMapping:0x287B
 },
 { code:0x287C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x287C
  ,simpleLowerCaseMapping:0x287C
  ,simpleTitleCaseMapping:0x287C
 },
 { code:0x287D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x287D
  ,simpleLowerCaseMapping:0x287D
  ,simpleTitleCaseMapping:0x287D
 },
 { code:0x287E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x287E
  ,simpleLowerCaseMapping:0x287E
  ,simpleTitleCaseMapping:0x287E
 },
 { code:0x287F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x287F
  ,simpleLowerCaseMapping:0x287F
  ,simpleTitleCaseMapping:0x287F
 },
 { code:0x2880
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2880
  ,simpleLowerCaseMapping:0x2880
  ,simpleTitleCaseMapping:0x2880
 },
 { code:0x2881
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2881
  ,simpleLowerCaseMapping:0x2881
  ,simpleTitleCaseMapping:0x2881
 },
 { code:0x2882
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2882
  ,simpleLowerCaseMapping:0x2882
  ,simpleTitleCaseMapping:0x2882
 },
 { code:0x2883
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2883
  ,simpleLowerCaseMapping:0x2883
  ,simpleTitleCaseMapping:0x2883
 },
 { code:0x2884
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2884
  ,simpleLowerCaseMapping:0x2884
  ,simpleTitleCaseMapping:0x2884
 },
 { code:0x2885
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2885
  ,simpleLowerCaseMapping:0x2885
  ,simpleTitleCaseMapping:0x2885
 },
 { code:0x2886
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2886
  ,simpleLowerCaseMapping:0x2886
  ,simpleTitleCaseMapping:0x2886
 },
 { code:0x2887
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2887
  ,simpleLowerCaseMapping:0x2887
  ,simpleTitleCaseMapping:0x2887
 },
 { code:0x2888
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2888
  ,simpleLowerCaseMapping:0x2888
  ,simpleTitleCaseMapping:0x2888
 },
 { code:0x2889
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2889
  ,simpleLowerCaseMapping:0x2889
  ,simpleTitleCaseMapping:0x2889
 },
 { code:0x288A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x288A
  ,simpleLowerCaseMapping:0x288A
  ,simpleTitleCaseMapping:0x288A
 },
 { code:0x288B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x288B
  ,simpleLowerCaseMapping:0x288B
  ,simpleTitleCaseMapping:0x288B
 },
 { code:0x288C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x288C
  ,simpleLowerCaseMapping:0x288C
  ,simpleTitleCaseMapping:0x288C
 },
 { code:0x288D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x288D
  ,simpleLowerCaseMapping:0x288D
  ,simpleTitleCaseMapping:0x288D
 },
 { code:0x288E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x288E
  ,simpleLowerCaseMapping:0x288E
  ,simpleTitleCaseMapping:0x288E
 },
 { code:0x288F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x288F
  ,simpleLowerCaseMapping:0x288F
  ,simpleTitleCaseMapping:0x288F
 },
 { code:0x2890
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2890
  ,simpleLowerCaseMapping:0x2890
  ,simpleTitleCaseMapping:0x2890
 },
 { code:0x2891
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2891
  ,simpleLowerCaseMapping:0x2891
  ,simpleTitleCaseMapping:0x2891
 },
 { code:0x2892
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2892
  ,simpleLowerCaseMapping:0x2892
  ,simpleTitleCaseMapping:0x2892
 },
 { code:0x2893
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2893
  ,simpleLowerCaseMapping:0x2893
  ,simpleTitleCaseMapping:0x2893
 },
 { code:0x2894
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2894
  ,simpleLowerCaseMapping:0x2894
  ,simpleTitleCaseMapping:0x2894
 },
 { code:0x2895
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2895
  ,simpleLowerCaseMapping:0x2895
  ,simpleTitleCaseMapping:0x2895
 },
 { code:0x2896
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2896
  ,simpleLowerCaseMapping:0x2896
  ,simpleTitleCaseMapping:0x2896
 },
 { code:0x2897
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2897
  ,simpleLowerCaseMapping:0x2897
  ,simpleTitleCaseMapping:0x2897
 },
 { code:0x2898
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2898
  ,simpleLowerCaseMapping:0x2898
  ,simpleTitleCaseMapping:0x2898
 },
 { code:0x2899
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2899
  ,simpleLowerCaseMapping:0x2899
  ,simpleTitleCaseMapping:0x2899
 },
 { code:0x289A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x289A
  ,simpleLowerCaseMapping:0x289A
  ,simpleTitleCaseMapping:0x289A
 },
 { code:0x289B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x289B
  ,simpleLowerCaseMapping:0x289B
  ,simpleTitleCaseMapping:0x289B
 },
 { code:0x289C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x289C
  ,simpleLowerCaseMapping:0x289C
  ,simpleTitleCaseMapping:0x289C
 },
 { code:0x289D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x289D
  ,simpleLowerCaseMapping:0x289D
  ,simpleTitleCaseMapping:0x289D
 },
 { code:0x289E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x289E
  ,simpleLowerCaseMapping:0x289E
  ,simpleTitleCaseMapping:0x289E
 },
 { code:0x289F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x289F
  ,simpleLowerCaseMapping:0x289F
  ,simpleTitleCaseMapping:0x289F
 },
 { code:0x28A0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28A0
  ,simpleLowerCaseMapping:0x28A0
  ,simpleTitleCaseMapping:0x28A0
 },
 { code:0x28A1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28A1
  ,simpleLowerCaseMapping:0x28A1
  ,simpleTitleCaseMapping:0x28A1
 },
 { code:0x28A2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28A2
  ,simpleLowerCaseMapping:0x28A2
  ,simpleTitleCaseMapping:0x28A2
 },
 { code:0x28A3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28A3
  ,simpleLowerCaseMapping:0x28A3
  ,simpleTitleCaseMapping:0x28A3
 },
 { code:0x28A4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28A4
  ,simpleLowerCaseMapping:0x28A4
  ,simpleTitleCaseMapping:0x28A4
 },
 { code:0x28A5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28A5
  ,simpleLowerCaseMapping:0x28A5
  ,simpleTitleCaseMapping:0x28A5
 },
 { code:0x28A6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28A6
  ,simpleLowerCaseMapping:0x28A6
  ,simpleTitleCaseMapping:0x28A6
 },
 { code:0x28A7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28A7
  ,simpleLowerCaseMapping:0x28A7
  ,simpleTitleCaseMapping:0x28A7
 },
 { code:0x28A8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28A8
  ,simpleLowerCaseMapping:0x28A8
  ,simpleTitleCaseMapping:0x28A8
 },
 { code:0x28A9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28A9
  ,simpleLowerCaseMapping:0x28A9
  ,simpleTitleCaseMapping:0x28A9
 },
 { code:0x28AA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28AA
  ,simpleLowerCaseMapping:0x28AA
  ,simpleTitleCaseMapping:0x28AA
 },
 { code:0x28AB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28AB
  ,simpleLowerCaseMapping:0x28AB
  ,simpleTitleCaseMapping:0x28AB
 },
 { code:0x28AC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28AC
  ,simpleLowerCaseMapping:0x28AC
  ,simpleTitleCaseMapping:0x28AC
 },
 { code:0x28AD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28AD
  ,simpleLowerCaseMapping:0x28AD
  ,simpleTitleCaseMapping:0x28AD
 },
 { code:0x28AE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28AE
  ,simpleLowerCaseMapping:0x28AE
  ,simpleTitleCaseMapping:0x28AE
 },
 { code:0x28AF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28AF
  ,simpleLowerCaseMapping:0x28AF
  ,simpleTitleCaseMapping:0x28AF
 },
 { code:0x28B0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28B0
  ,simpleLowerCaseMapping:0x28B0
  ,simpleTitleCaseMapping:0x28B0
 },
 { code:0x28B1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28B1
  ,simpleLowerCaseMapping:0x28B1
  ,simpleTitleCaseMapping:0x28B1
 },
 { code:0x28B2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28B2
  ,simpleLowerCaseMapping:0x28B2
  ,simpleTitleCaseMapping:0x28B2
 },
 { code:0x28B3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28B3
  ,simpleLowerCaseMapping:0x28B3
  ,simpleTitleCaseMapping:0x28B3
 },
 { code:0x28B4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28B4
  ,simpleLowerCaseMapping:0x28B4
  ,simpleTitleCaseMapping:0x28B4
 },
 { code:0x28B5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28B5
  ,simpleLowerCaseMapping:0x28B5
  ,simpleTitleCaseMapping:0x28B5
 },
 { code:0x28B6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28B6
  ,simpleLowerCaseMapping:0x28B6
  ,simpleTitleCaseMapping:0x28B6
 },
 { code:0x28B7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28B7
  ,simpleLowerCaseMapping:0x28B7
  ,simpleTitleCaseMapping:0x28B7
 },
 { code:0x28B8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28B8
  ,simpleLowerCaseMapping:0x28B8
  ,simpleTitleCaseMapping:0x28B8
 },
 { code:0x28B9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28B9
  ,simpleLowerCaseMapping:0x28B9
  ,simpleTitleCaseMapping:0x28B9
 },
 { code:0x28BA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28BA
  ,simpleLowerCaseMapping:0x28BA
  ,simpleTitleCaseMapping:0x28BA
 },
 { code:0x28BB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28BB
  ,simpleLowerCaseMapping:0x28BB
  ,simpleTitleCaseMapping:0x28BB
 },
 { code:0x28BC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28BC
  ,simpleLowerCaseMapping:0x28BC
  ,simpleTitleCaseMapping:0x28BC
 },
 { code:0x28BD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28BD
  ,simpleLowerCaseMapping:0x28BD
  ,simpleTitleCaseMapping:0x28BD
 },
 { code:0x28BE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28BE
  ,simpleLowerCaseMapping:0x28BE
  ,simpleTitleCaseMapping:0x28BE
 },
 { code:0x28BF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28BF
  ,simpleLowerCaseMapping:0x28BF
  ,simpleTitleCaseMapping:0x28BF
 },
 { code:0x28C0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28C0
  ,simpleLowerCaseMapping:0x28C0
  ,simpleTitleCaseMapping:0x28C0
 },
 { code:0x28C1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28C1
  ,simpleLowerCaseMapping:0x28C1
  ,simpleTitleCaseMapping:0x28C1
 },
 { code:0x28C2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28C2
  ,simpleLowerCaseMapping:0x28C2
  ,simpleTitleCaseMapping:0x28C2
 },
 { code:0x28C3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28C3
  ,simpleLowerCaseMapping:0x28C3
  ,simpleTitleCaseMapping:0x28C3
 },
 { code:0x28C4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28C4
  ,simpleLowerCaseMapping:0x28C4
  ,simpleTitleCaseMapping:0x28C4
 },
 { code:0x28C5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28C5
  ,simpleLowerCaseMapping:0x28C5
  ,simpleTitleCaseMapping:0x28C5
 },
 { code:0x28C6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28C6
  ,simpleLowerCaseMapping:0x28C6
  ,simpleTitleCaseMapping:0x28C6
 },
 { code:0x28C7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28C7
  ,simpleLowerCaseMapping:0x28C7
  ,simpleTitleCaseMapping:0x28C7
 },
 { code:0x28C8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28C8
  ,simpleLowerCaseMapping:0x28C8
  ,simpleTitleCaseMapping:0x28C8
 },
 { code:0x28C9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28C9
  ,simpleLowerCaseMapping:0x28C9
  ,simpleTitleCaseMapping:0x28C9
 },
 { code:0x28CA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28CA
  ,simpleLowerCaseMapping:0x28CA
  ,simpleTitleCaseMapping:0x28CA
 },
 { code:0x28CB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28CB
  ,simpleLowerCaseMapping:0x28CB
  ,simpleTitleCaseMapping:0x28CB
 },
 { code:0x28CC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28CC
  ,simpleLowerCaseMapping:0x28CC
  ,simpleTitleCaseMapping:0x28CC
 },
 { code:0x28CD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28CD
  ,simpleLowerCaseMapping:0x28CD
  ,simpleTitleCaseMapping:0x28CD
 },
 { code:0x28CE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28CE
  ,simpleLowerCaseMapping:0x28CE
  ,simpleTitleCaseMapping:0x28CE
 },
 { code:0x28CF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28CF
  ,simpleLowerCaseMapping:0x28CF
  ,simpleTitleCaseMapping:0x28CF
 },
 { code:0x28D0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28D0
  ,simpleLowerCaseMapping:0x28D0
  ,simpleTitleCaseMapping:0x28D0
 },
 { code:0x28D1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28D1
  ,simpleLowerCaseMapping:0x28D1
  ,simpleTitleCaseMapping:0x28D1
 },
 { code:0x28D2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28D2
  ,simpleLowerCaseMapping:0x28D2
  ,simpleTitleCaseMapping:0x28D2
 },
 { code:0x28D3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28D3
  ,simpleLowerCaseMapping:0x28D3
  ,simpleTitleCaseMapping:0x28D3
 },
 { code:0x28D4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28D4
  ,simpleLowerCaseMapping:0x28D4
  ,simpleTitleCaseMapping:0x28D4
 },
 { code:0x28D5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28D5
  ,simpleLowerCaseMapping:0x28D5
  ,simpleTitleCaseMapping:0x28D5
 },
 { code:0x28D6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28D6
  ,simpleLowerCaseMapping:0x28D6
  ,simpleTitleCaseMapping:0x28D6
 },
 { code:0x28D7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28D7
  ,simpleLowerCaseMapping:0x28D7
  ,simpleTitleCaseMapping:0x28D7
 },
 { code:0x28D8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28D8
  ,simpleLowerCaseMapping:0x28D8
  ,simpleTitleCaseMapping:0x28D8
 },
 { code:0x28D9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28D9
  ,simpleLowerCaseMapping:0x28D9
  ,simpleTitleCaseMapping:0x28D9
 },
 { code:0x28DA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28DA
  ,simpleLowerCaseMapping:0x28DA
  ,simpleTitleCaseMapping:0x28DA
 },
 { code:0x28DB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28DB
  ,simpleLowerCaseMapping:0x28DB
  ,simpleTitleCaseMapping:0x28DB
 },
 { code:0x28DC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28DC
  ,simpleLowerCaseMapping:0x28DC
  ,simpleTitleCaseMapping:0x28DC
 },
 { code:0x28DD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28DD
  ,simpleLowerCaseMapping:0x28DD
  ,simpleTitleCaseMapping:0x28DD
 },
 { code:0x28DE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28DE
  ,simpleLowerCaseMapping:0x28DE
  ,simpleTitleCaseMapping:0x28DE
 },
 { code:0x28DF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28DF
  ,simpleLowerCaseMapping:0x28DF
  ,simpleTitleCaseMapping:0x28DF
 },
 { code:0x28E0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28E0
  ,simpleLowerCaseMapping:0x28E0
  ,simpleTitleCaseMapping:0x28E0
 },
 { code:0x28E1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28E1
  ,simpleLowerCaseMapping:0x28E1
  ,simpleTitleCaseMapping:0x28E1
 },
 { code:0x28E2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28E2
  ,simpleLowerCaseMapping:0x28E2
  ,simpleTitleCaseMapping:0x28E2
 },
 { code:0x28E3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28E3
  ,simpleLowerCaseMapping:0x28E3
  ,simpleTitleCaseMapping:0x28E3
 },
 { code:0x28E4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28E4
  ,simpleLowerCaseMapping:0x28E4
  ,simpleTitleCaseMapping:0x28E4
 },
 { code:0x28E5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28E5
  ,simpleLowerCaseMapping:0x28E5
  ,simpleTitleCaseMapping:0x28E5
 },
 { code:0x28E6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28E6
  ,simpleLowerCaseMapping:0x28E6
  ,simpleTitleCaseMapping:0x28E6
 },
 { code:0x28E7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28E7
  ,simpleLowerCaseMapping:0x28E7
  ,simpleTitleCaseMapping:0x28E7
 },
 { code:0x28E8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28E8
  ,simpleLowerCaseMapping:0x28E8
  ,simpleTitleCaseMapping:0x28E8
 },
 { code:0x28E9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28E9
  ,simpleLowerCaseMapping:0x28E9
  ,simpleTitleCaseMapping:0x28E9
 },
 { code:0x28EA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28EA
  ,simpleLowerCaseMapping:0x28EA
  ,simpleTitleCaseMapping:0x28EA
 },
 { code:0x28EB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28EB
  ,simpleLowerCaseMapping:0x28EB
  ,simpleTitleCaseMapping:0x28EB
 },
 { code:0x28EC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28EC
  ,simpleLowerCaseMapping:0x28EC
  ,simpleTitleCaseMapping:0x28EC
 },
 { code:0x28ED
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28ED
  ,simpleLowerCaseMapping:0x28ED
  ,simpleTitleCaseMapping:0x28ED
 },
 { code:0x28EE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28EE
  ,simpleLowerCaseMapping:0x28EE
  ,simpleTitleCaseMapping:0x28EE
 },
 { code:0x28EF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28EF
  ,simpleLowerCaseMapping:0x28EF
  ,simpleTitleCaseMapping:0x28EF
 },
 { code:0x28F0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28F0
  ,simpleLowerCaseMapping:0x28F0
  ,simpleTitleCaseMapping:0x28F0
 },
 { code:0x28F1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28F1
  ,simpleLowerCaseMapping:0x28F1
  ,simpleTitleCaseMapping:0x28F1
 },
 { code:0x28F2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28F2
  ,simpleLowerCaseMapping:0x28F2
  ,simpleTitleCaseMapping:0x28F2
 },
 { code:0x28F3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28F3
  ,simpleLowerCaseMapping:0x28F3
  ,simpleTitleCaseMapping:0x28F3
 },
 { code:0x28F4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28F4
  ,simpleLowerCaseMapping:0x28F4
  ,simpleTitleCaseMapping:0x28F4
 },
 { code:0x28F5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28F5
  ,simpleLowerCaseMapping:0x28F5
  ,simpleTitleCaseMapping:0x28F5
 },
 { code:0x28F6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28F6
  ,simpleLowerCaseMapping:0x28F6
  ,simpleTitleCaseMapping:0x28F6
 },
 { code:0x28F7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28F7
  ,simpleLowerCaseMapping:0x28F7
  ,simpleTitleCaseMapping:0x28F7
 },
 { code:0x28F8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28F8
  ,simpleLowerCaseMapping:0x28F8
  ,simpleTitleCaseMapping:0x28F8
 },
 { code:0x28F9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28F9
  ,simpleLowerCaseMapping:0x28F9
  ,simpleTitleCaseMapping:0x28F9
 },
 { code:0x28FA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28FA
  ,simpleLowerCaseMapping:0x28FA
  ,simpleTitleCaseMapping:0x28FA
 },
 { code:0x28FB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28FB
  ,simpleLowerCaseMapping:0x28FB
  ,simpleTitleCaseMapping:0x28FB
 },
 { code:0x28FC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28FC
  ,simpleLowerCaseMapping:0x28FC
  ,simpleTitleCaseMapping:0x28FC
 },
 { code:0x28FD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28FD
  ,simpleLowerCaseMapping:0x28FD
  ,simpleTitleCaseMapping:0x28FD
 },
 { code:0x28FE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28FE
  ,simpleLowerCaseMapping:0x28FE
  ,simpleTitleCaseMapping:0x28FE
 },
 { code:0x28FF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x28FF
  ,simpleLowerCaseMapping:0x28FF
  ,simpleTitleCaseMapping:0x28FF
 },
 { code:0x2900
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2900
  ,simpleLowerCaseMapping:0x2900
  ,simpleTitleCaseMapping:0x2900
 },
 { code:0x2901
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2901
  ,simpleLowerCaseMapping:0x2901
  ,simpleTitleCaseMapping:0x2901
 },
 { code:0x2902
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2902
  ,simpleLowerCaseMapping:0x2902
  ,simpleTitleCaseMapping:0x2902
 },
 { code:0x2903
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2903
  ,simpleLowerCaseMapping:0x2903
  ,simpleTitleCaseMapping:0x2903
 },
 { code:0x2904
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2904
  ,simpleLowerCaseMapping:0x2904
  ,simpleTitleCaseMapping:0x2904
 },
 { code:0x2905
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2905
  ,simpleLowerCaseMapping:0x2905
  ,simpleTitleCaseMapping:0x2905
 },
 { code:0x2906
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2906
  ,simpleLowerCaseMapping:0x2906
  ,simpleTitleCaseMapping:0x2906
 },
 { code:0x2907
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2907
  ,simpleLowerCaseMapping:0x2907
  ,simpleTitleCaseMapping:0x2907
 },
 { code:0x2908
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2908
  ,simpleLowerCaseMapping:0x2908
  ,simpleTitleCaseMapping:0x2908
 },
 { code:0x2909
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2909
  ,simpleLowerCaseMapping:0x2909
  ,simpleTitleCaseMapping:0x2909
 },
 { code:0x290A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x290A
  ,simpleLowerCaseMapping:0x290A
  ,simpleTitleCaseMapping:0x290A
 },
 { code:0x290B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x290B
  ,simpleLowerCaseMapping:0x290B
  ,simpleTitleCaseMapping:0x290B
 },
 { code:0x290C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x290C
  ,simpleLowerCaseMapping:0x290C
  ,simpleTitleCaseMapping:0x290C
 },
 { code:0x290D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x290D
  ,simpleLowerCaseMapping:0x290D
  ,simpleTitleCaseMapping:0x290D
 },
 { code:0x290E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x290E
  ,simpleLowerCaseMapping:0x290E
  ,simpleTitleCaseMapping:0x290E
 },
 { code:0x290F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x290F
  ,simpleLowerCaseMapping:0x290F
  ,simpleTitleCaseMapping:0x290F
 },
 { code:0x2910
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2910
  ,simpleLowerCaseMapping:0x2910
  ,simpleTitleCaseMapping:0x2910
 },
 { code:0x2911
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2911
  ,simpleLowerCaseMapping:0x2911
  ,simpleTitleCaseMapping:0x2911
 },
 { code:0x2912
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2912
  ,simpleLowerCaseMapping:0x2912
  ,simpleTitleCaseMapping:0x2912
 },
 { code:0x2913
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2913
  ,simpleLowerCaseMapping:0x2913
  ,simpleTitleCaseMapping:0x2913
 },
 { code:0x2914
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2914
  ,simpleLowerCaseMapping:0x2914
  ,simpleTitleCaseMapping:0x2914
 },
 { code:0x2915
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2915
  ,simpleLowerCaseMapping:0x2915
  ,simpleTitleCaseMapping:0x2915
 },
 { code:0x2916
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2916
  ,simpleLowerCaseMapping:0x2916
  ,simpleTitleCaseMapping:0x2916
 },
 { code:0x2917
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2917
  ,simpleLowerCaseMapping:0x2917
  ,simpleTitleCaseMapping:0x2917
 },
 { code:0x2918
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2918
  ,simpleLowerCaseMapping:0x2918
  ,simpleTitleCaseMapping:0x2918
 },
 { code:0x2919
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2919
  ,simpleLowerCaseMapping:0x2919
  ,simpleTitleCaseMapping:0x2919
 },
 { code:0x291A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x291A
  ,simpleLowerCaseMapping:0x291A
  ,simpleTitleCaseMapping:0x291A
 },
 { code:0x291B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x291B
  ,simpleLowerCaseMapping:0x291B
  ,simpleTitleCaseMapping:0x291B
 },
 { code:0x291C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x291C
  ,simpleLowerCaseMapping:0x291C
  ,simpleTitleCaseMapping:0x291C
 },
 { code:0x291D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x291D
  ,simpleLowerCaseMapping:0x291D
  ,simpleTitleCaseMapping:0x291D
 },
 { code:0x291E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x291E
  ,simpleLowerCaseMapping:0x291E
  ,simpleTitleCaseMapping:0x291E
 },
 { code:0x291F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x291F
  ,simpleLowerCaseMapping:0x291F
  ,simpleTitleCaseMapping:0x291F
 },
 { code:0x2920
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2920
  ,simpleLowerCaseMapping:0x2920
  ,simpleTitleCaseMapping:0x2920
 },
 { code:0x2921
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2921
  ,simpleLowerCaseMapping:0x2921
  ,simpleTitleCaseMapping:0x2921
 },
 { code:0x2922
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2922
  ,simpleLowerCaseMapping:0x2922
  ,simpleTitleCaseMapping:0x2922
 },
 { code:0x2923
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2923
  ,simpleLowerCaseMapping:0x2923
  ,simpleTitleCaseMapping:0x2923
 },
 { code:0x2924
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2924
  ,simpleLowerCaseMapping:0x2924
  ,simpleTitleCaseMapping:0x2924
 },
 { code:0x2925
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2925
  ,simpleLowerCaseMapping:0x2925
  ,simpleTitleCaseMapping:0x2925
 },
 { code:0x2926
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2926
  ,simpleLowerCaseMapping:0x2926
  ,simpleTitleCaseMapping:0x2926
 },
 { code:0x2927
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2927
  ,simpleLowerCaseMapping:0x2927
  ,simpleTitleCaseMapping:0x2927
 },
 { code:0x2928
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2928
  ,simpleLowerCaseMapping:0x2928
  ,simpleTitleCaseMapping:0x2928
 },
 { code:0x2929
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2929
  ,simpleLowerCaseMapping:0x2929
  ,simpleTitleCaseMapping:0x2929
 },
 { code:0x292A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x292A
  ,simpleLowerCaseMapping:0x292A
  ,simpleTitleCaseMapping:0x292A
 },
 { code:0x292B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x292B
  ,simpleLowerCaseMapping:0x292B
  ,simpleTitleCaseMapping:0x292B
 },
 { code:0x292C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x292C
  ,simpleLowerCaseMapping:0x292C
  ,simpleTitleCaseMapping:0x292C
 },
 { code:0x292D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x292D
  ,simpleLowerCaseMapping:0x292D
  ,simpleTitleCaseMapping:0x292D
 },
 { code:0x292E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x292E
  ,simpleLowerCaseMapping:0x292E
  ,simpleTitleCaseMapping:0x292E
 },
 { code:0x292F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x292F
  ,simpleLowerCaseMapping:0x292F
  ,simpleTitleCaseMapping:0x292F
 },
 { code:0x2930
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2930
  ,simpleLowerCaseMapping:0x2930
  ,simpleTitleCaseMapping:0x2930
 },
 { code:0x2931
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2931
  ,simpleLowerCaseMapping:0x2931
  ,simpleTitleCaseMapping:0x2931
 },
 { code:0x2932
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2932
  ,simpleLowerCaseMapping:0x2932
  ,simpleTitleCaseMapping:0x2932
 },
 { code:0x2933
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2933
  ,simpleLowerCaseMapping:0x2933
  ,simpleTitleCaseMapping:0x2933
 },
 { code:0x2934
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2934
  ,simpleLowerCaseMapping:0x2934
  ,simpleTitleCaseMapping:0x2934
 },
 { code:0x2935
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2935
  ,simpleLowerCaseMapping:0x2935
  ,simpleTitleCaseMapping:0x2935
 },
 { code:0x2936
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2936
  ,simpleLowerCaseMapping:0x2936
  ,simpleTitleCaseMapping:0x2936
 },
 { code:0x2937
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2937
  ,simpleLowerCaseMapping:0x2937
  ,simpleTitleCaseMapping:0x2937
 },
 { code:0x2938
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2938
  ,simpleLowerCaseMapping:0x2938
  ,simpleTitleCaseMapping:0x2938
 },
 { code:0x2939
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2939
  ,simpleLowerCaseMapping:0x2939
  ,simpleTitleCaseMapping:0x2939
 },
 { code:0x293A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x293A
  ,simpleLowerCaseMapping:0x293A
  ,simpleTitleCaseMapping:0x293A
 },
 { code:0x293B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x293B
  ,simpleLowerCaseMapping:0x293B
  ,simpleTitleCaseMapping:0x293B
 },
 { code:0x293C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x293C
  ,simpleLowerCaseMapping:0x293C
  ,simpleTitleCaseMapping:0x293C
 },
 { code:0x293D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x293D
  ,simpleLowerCaseMapping:0x293D
  ,simpleTitleCaseMapping:0x293D
 },
 { code:0x293E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x293E
  ,simpleLowerCaseMapping:0x293E
  ,simpleTitleCaseMapping:0x293E
 },
 { code:0x293F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x293F
  ,simpleLowerCaseMapping:0x293F
  ,simpleTitleCaseMapping:0x293F
 },
 { code:0x2940
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2940
  ,simpleLowerCaseMapping:0x2940
  ,simpleTitleCaseMapping:0x2940
 },
 { code:0x2941
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2941
  ,simpleLowerCaseMapping:0x2941
  ,simpleTitleCaseMapping:0x2941
 },
 { code:0x2942
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2942
  ,simpleLowerCaseMapping:0x2942
  ,simpleTitleCaseMapping:0x2942
 },
 { code:0x2943
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2943
  ,simpleLowerCaseMapping:0x2943
  ,simpleTitleCaseMapping:0x2943
 },
 { code:0x2944
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2944
  ,simpleLowerCaseMapping:0x2944
  ,simpleTitleCaseMapping:0x2944
 },
 { code:0x2945
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2945
  ,simpleLowerCaseMapping:0x2945
  ,simpleTitleCaseMapping:0x2945
 },
 { code:0x2946
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2946
  ,simpleLowerCaseMapping:0x2946
  ,simpleTitleCaseMapping:0x2946
 },
 { code:0x2947
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2947
  ,simpleLowerCaseMapping:0x2947
  ,simpleTitleCaseMapping:0x2947
 },
 { code:0x2948
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2948
  ,simpleLowerCaseMapping:0x2948
  ,simpleTitleCaseMapping:0x2948
 },
 { code:0x2949
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2949
  ,simpleLowerCaseMapping:0x2949
  ,simpleTitleCaseMapping:0x2949
 },
 { code:0x294A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x294A
  ,simpleLowerCaseMapping:0x294A
  ,simpleTitleCaseMapping:0x294A
 },
 { code:0x294B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x294B
  ,simpleLowerCaseMapping:0x294B
  ,simpleTitleCaseMapping:0x294B
 },
 { code:0x294C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x294C
  ,simpleLowerCaseMapping:0x294C
  ,simpleTitleCaseMapping:0x294C
 },
 { code:0x294D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x294D
  ,simpleLowerCaseMapping:0x294D
  ,simpleTitleCaseMapping:0x294D
 },
 { code:0x294E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x294E
  ,simpleLowerCaseMapping:0x294E
  ,simpleTitleCaseMapping:0x294E
 },
 { code:0x294F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x294F
  ,simpleLowerCaseMapping:0x294F
  ,simpleTitleCaseMapping:0x294F
 },
 { code:0x2950
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2950
  ,simpleLowerCaseMapping:0x2950
  ,simpleTitleCaseMapping:0x2950
 },
 { code:0x2951
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2951
  ,simpleLowerCaseMapping:0x2951
  ,simpleTitleCaseMapping:0x2951
 },
 { code:0x2952
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2952
  ,simpleLowerCaseMapping:0x2952
  ,simpleTitleCaseMapping:0x2952
 },
 { code:0x2953
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2953
  ,simpleLowerCaseMapping:0x2953
  ,simpleTitleCaseMapping:0x2953
 },
 { code:0x2954
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2954
  ,simpleLowerCaseMapping:0x2954
  ,simpleTitleCaseMapping:0x2954
 },
 { code:0x2955
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2955
  ,simpleLowerCaseMapping:0x2955
  ,simpleTitleCaseMapping:0x2955
 },
 { code:0x2956
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2956
  ,simpleLowerCaseMapping:0x2956
  ,simpleTitleCaseMapping:0x2956
 },
 { code:0x2957
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2957
  ,simpleLowerCaseMapping:0x2957
  ,simpleTitleCaseMapping:0x2957
 },
 { code:0x2958
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2958
  ,simpleLowerCaseMapping:0x2958
  ,simpleTitleCaseMapping:0x2958
 },
 { code:0x2959
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2959
  ,simpleLowerCaseMapping:0x2959
  ,simpleTitleCaseMapping:0x2959
 },
 { code:0x295A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x295A
  ,simpleLowerCaseMapping:0x295A
  ,simpleTitleCaseMapping:0x295A
 },
 { code:0x295B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x295B
  ,simpleLowerCaseMapping:0x295B
  ,simpleTitleCaseMapping:0x295B
 },
 { code:0x295C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x295C
  ,simpleLowerCaseMapping:0x295C
  ,simpleTitleCaseMapping:0x295C
 },
 { code:0x295D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x295D
  ,simpleLowerCaseMapping:0x295D
  ,simpleTitleCaseMapping:0x295D
 },
 { code:0x295E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x295E
  ,simpleLowerCaseMapping:0x295E
  ,simpleTitleCaseMapping:0x295E
 },
 { code:0x295F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x295F
  ,simpleLowerCaseMapping:0x295F
  ,simpleTitleCaseMapping:0x295F
 },
 { code:0x2960
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2960
  ,simpleLowerCaseMapping:0x2960
  ,simpleTitleCaseMapping:0x2960
 },
 { code:0x2961
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2961
  ,simpleLowerCaseMapping:0x2961
  ,simpleTitleCaseMapping:0x2961
 },
 { code:0x2962
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2962
  ,simpleLowerCaseMapping:0x2962
  ,simpleTitleCaseMapping:0x2962
 },
 { code:0x2963
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2963
  ,simpleLowerCaseMapping:0x2963
  ,simpleTitleCaseMapping:0x2963
 },
 { code:0x2964
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2964
  ,simpleLowerCaseMapping:0x2964
  ,simpleTitleCaseMapping:0x2964
 },
 { code:0x2965
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2965
  ,simpleLowerCaseMapping:0x2965
  ,simpleTitleCaseMapping:0x2965
 },
 { code:0x2966
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2966
  ,simpleLowerCaseMapping:0x2966
  ,simpleTitleCaseMapping:0x2966
 },
 { code:0x2967
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2967
  ,simpleLowerCaseMapping:0x2967
  ,simpleTitleCaseMapping:0x2967
 },
 { code:0x2968
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2968
  ,simpleLowerCaseMapping:0x2968
  ,simpleTitleCaseMapping:0x2968
 },
 { code:0x2969
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2969
  ,simpleLowerCaseMapping:0x2969
  ,simpleTitleCaseMapping:0x2969
 },
 { code:0x296A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x296A
  ,simpleLowerCaseMapping:0x296A
  ,simpleTitleCaseMapping:0x296A
 },
 { code:0x296B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x296B
  ,simpleLowerCaseMapping:0x296B
  ,simpleTitleCaseMapping:0x296B
 },
 { code:0x296C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x296C
  ,simpleLowerCaseMapping:0x296C
  ,simpleTitleCaseMapping:0x296C
 },
 { code:0x296D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x296D
  ,simpleLowerCaseMapping:0x296D
  ,simpleTitleCaseMapping:0x296D
 },
 { code:0x296E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x296E
  ,simpleLowerCaseMapping:0x296E
  ,simpleTitleCaseMapping:0x296E
 },
 { code:0x296F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x296F
  ,simpleLowerCaseMapping:0x296F
  ,simpleTitleCaseMapping:0x296F
 },
 { code:0x2970
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2970
  ,simpleLowerCaseMapping:0x2970
  ,simpleTitleCaseMapping:0x2970
 },
 { code:0x2971
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2971
  ,simpleLowerCaseMapping:0x2971
  ,simpleTitleCaseMapping:0x2971
 },
 { code:0x2972
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2972
  ,simpleLowerCaseMapping:0x2972
  ,simpleTitleCaseMapping:0x2972
 },
 { code:0x2973
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2973
  ,simpleLowerCaseMapping:0x2973
  ,simpleTitleCaseMapping:0x2973
 },
 { code:0x2974
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2974
  ,simpleLowerCaseMapping:0x2974
  ,simpleTitleCaseMapping:0x2974
 },
 { code:0x2975
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2975
  ,simpleLowerCaseMapping:0x2975
  ,simpleTitleCaseMapping:0x2975
 },
 { code:0x2976
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2976
  ,simpleLowerCaseMapping:0x2976
  ,simpleTitleCaseMapping:0x2976
 },
 { code:0x2977
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2977
  ,simpleLowerCaseMapping:0x2977
  ,simpleTitleCaseMapping:0x2977
 },
 { code:0x2978
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2978
  ,simpleLowerCaseMapping:0x2978
  ,simpleTitleCaseMapping:0x2978
 },
 { code:0x2979
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2979
  ,simpleLowerCaseMapping:0x2979
  ,simpleTitleCaseMapping:0x2979
 },
 { code:0x297A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x297A
  ,simpleLowerCaseMapping:0x297A
  ,simpleTitleCaseMapping:0x297A
 },
 { code:0x297B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x297B
  ,simpleLowerCaseMapping:0x297B
  ,simpleTitleCaseMapping:0x297B
 },
 { code:0x297C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x297C
  ,simpleLowerCaseMapping:0x297C
  ,simpleTitleCaseMapping:0x297C
 },
 { code:0x297D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x297D
  ,simpleLowerCaseMapping:0x297D
  ,simpleTitleCaseMapping:0x297D
 },
 { code:0x297E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x297E
  ,simpleLowerCaseMapping:0x297E
  ,simpleTitleCaseMapping:0x297E
 },
 { code:0x297F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x297F
  ,simpleLowerCaseMapping:0x297F
  ,simpleTitleCaseMapping:0x297F
 },
 { code:0x2980
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2980
  ,simpleLowerCaseMapping:0x2980
  ,simpleTitleCaseMapping:0x2980
 },
 { code:0x2981
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2981
  ,simpleLowerCaseMapping:0x2981
  ,simpleTitleCaseMapping:0x2981
 },
 { code:0x2982
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2982
  ,simpleLowerCaseMapping:0x2982
  ,simpleTitleCaseMapping:0x2982
 },
 { code:0x2983
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x2983
  ,simpleLowerCaseMapping:0x2983
  ,simpleTitleCaseMapping:0x2983
 },
 { code:0x2984
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x2984
  ,simpleLowerCaseMapping:0x2984
  ,simpleTitleCaseMapping:0x2984
 },
 { code:0x2985
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x2985
  ,simpleLowerCaseMapping:0x2985
  ,simpleTitleCaseMapping:0x2985
 },
 { code:0x2986
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x2986
  ,simpleLowerCaseMapping:0x2986
  ,simpleTitleCaseMapping:0x2986
 },
 { code:0x2987
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x2987
  ,simpleLowerCaseMapping:0x2987
  ,simpleTitleCaseMapping:0x2987
 },
 { code:0x2988
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x2988
  ,simpleLowerCaseMapping:0x2988
  ,simpleTitleCaseMapping:0x2988
 },
 { code:0x2989
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x2989
  ,simpleLowerCaseMapping:0x2989
  ,simpleTitleCaseMapping:0x2989
 },
 { code:0x298A
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x298A
  ,simpleLowerCaseMapping:0x298A
  ,simpleTitleCaseMapping:0x298A
 },
 { code:0x298B
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x298B
  ,simpleLowerCaseMapping:0x298B
  ,simpleTitleCaseMapping:0x298B
 },
 { code:0x298C
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x298C
  ,simpleLowerCaseMapping:0x298C
  ,simpleTitleCaseMapping:0x298C
 },
 { code:0x298D
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x298D
  ,simpleLowerCaseMapping:0x298D
  ,simpleTitleCaseMapping:0x298D
 },
 { code:0x298E
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x298E
  ,simpleLowerCaseMapping:0x298E
  ,simpleTitleCaseMapping:0x298E
 },
 { code:0x298F
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x298F
  ,simpleLowerCaseMapping:0x298F
  ,simpleTitleCaseMapping:0x298F
 },
 { code:0x2990
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x2990
  ,simpleLowerCaseMapping:0x2990
  ,simpleTitleCaseMapping:0x2990
 },
 { code:0x2991
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x2991
  ,simpleLowerCaseMapping:0x2991
  ,simpleTitleCaseMapping:0x2991
 },
 { code:0x2992
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x2992
  ,simpleLowerCaseMapping:0x2992
  ,simpleTitleCaseMapping:0x2992
 },
 { code:0x2993
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x2993
  ,simpleLowerCaseMapping:0x2993
  ,simpleTitleCaseMapping:0x2993
 },
 { code:0x2994
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x2994
  ,simpleLowerCaseMapping:0x2994
  ,simpleTitleCaseMapping:0x2994
 },
 { code:0x2995
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x2995
  ,simpleLowerCaseMapping:0x2995
  ,simpleTitleCaseMapping:0x2995
 },
 { code:0x2996
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x2996
  ,simpleLowerCaseMapping:0x2996
  ,simpleTitleCaseMapping:0x2996
 },
 { code:0x2997
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x2997
  ,simpleLowerCaseMapping:0x2997
  ,simpleTitleCaseMapping:0x2997
 },
 { code:0x2998
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x2998
  ,simpleLowerCaseMapping:0x2998
  ,simpleTitleCaseMapping:0x2998
 },
 { code:0x2999
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2999
  ,simpleLowerCaseMapping:0x2999
  ,simpleTitleCaseMapping:0x2999
 },
 { code:0x299A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x299A
  ,simpleLowerCaseMapping:0x299A
  ,simpleTitleCaseMapping:0x299A
 },
 { code:0x299B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x299B
  ,simpleLowerCaseMapping:0x299B
  ,simpleTitleCaseMapping:0x299B
 },
 { code:0x299C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x299C
  ,simpleLowerCaseMapping:0x299C
  ,simpleTitleCaseMapping:0x299C
 },
 { code:0x299D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x299D
  ,simpleLowerCaseMapping:0x299D
  ,simpleTitleCaseMapping:0x299D
 },
 { code:0x299E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x299E
  ,simpleLowerCaseMapping:0x299E
  ,simpleTitleCaseMapping:0x299E
 },
 { code:0x299F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x299F
  ,simpleLowerCaseMapping:0x299F
  ,simpleTitleCaseMapping:0x299F
 },
 { code:0x29A0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29A0
  ,simpleLowerCaseMapping:0x29A0
  ,simpleTitleCaseMapping:0x29A0
 },
 { code:0x29A1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29A1
  ,simpleLowerCaseMapping:0x29A1
  ,simpleTitleCaseMapping:0x29A1
 },
 { code:0x29A2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29A2
  ,simpleLowerCaseMapping:0x29A2
  ,simpleTitleCaseMapping:0x29A2
 },
 { code:0x29A3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29A3
  ,simpleLowerCaseMapping:0x29A3
  ,simpleTitleCaseMapping:0x29A3
 },
 { code:0x29A4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29A4
  ,simpleLowerCaseMapping:0x29A4
  ,simpleTitleCaseMapping:0x29A4
 },
 { code:0x29A5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29A5
  ,simpleLowerCaseMapping:0x29A5
  ,simpleTitleCaseMapping:0x29A5
 },
 { code:0x29A6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29A6
  ,simpleLowerCaseMapping:0x29A6
  ,simpleTitleCaseMapping:0x29A6
 },
 { code:0x29A7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29A7
  ,simpleLowerCaseMapping:0x29A7
  ,simpleTitleCaseMapping:0x29A7
 },
 { code:0x29A8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29A8
  ,simpleLowerCaseMapping:0x29A8
  ,simpleTitleCaseMapping:0x29A8
 },
 { code:0x29A9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29A9
  ,simpleLowerCaseMapping:0x29A9
  ,simpleTitleCaseMapping:0x29A9
 },
 { code:0x29AA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29AA
  ,simpleLowerCaseMapping:0x29AA
  ,simpleTitleCaseMapping:0x29AA
 },
 { code:0x29AB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29AB
  ,simpleLowerCaseMapping:0x29AB
  ,simpleTitleCaseMapping:0x29AB
 },
 { code:0x29AC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29AC
  ,simpleLowerCaseMapping:0x29AC
  ,simpleTitleCaseMapping:0x29AC
 },
 { code:0x29AD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29AD
  ,simpleLowerCaseMapping:0x29AD
  ,simpleTitleCaseMapping:0x29AD
 },
 { code:0x29AE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29AE
  ,simpleLowerCaseMapping:0x29AE
  ,simpleTitleCaseMapping:0x29AE
 },
 { code:0x29AF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29AF
  ,simpleLowerCaseMapping:0x29AF
  ,simpleTitleCaseMapping:0x29AF
 },
 { code:0x29B0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29B0
  ,simpleLowerCaseMapping:0x29B0
  ,simpleTitleCaseMapping:0x29B0
 },
 { code:0x29B1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29B1
  ,simpleLowerCaseMapping:0x29B1
  ,simpleTitleCaseMapping:0x29B1
 },
 { code:0x29B2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29B2
  ,simpleLowerCaseMapping:0x29B2
  ,simpleTitleCaseMapping:0x29B2
 },
 { code:0x29B3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29B3
  ,simpleLowerCaseMapping:0x29B3
  ,simpleTitleCaseMapping:0x29B3
 },
 { code:0x29B4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29B4
  ,simpleLowerCaseMapping:0x29B4
  ,simpleTitleCaseMapping:0x29B4
 },
 { code:0x29B5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29B5
  ,simpleLowerCaseMapping:0x29B5
  ,simpleTitleCaseMapping:0x29B5
 },
 { code:0x29B6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29B6
  ,simpleLowerCaseMapping:0x29B6
  ,simpleTitleCaseMapping:0x29B6
 },
 { code:0x29B7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29B7
  ,simpleLowerCaseMapping:0x29B7
  ,simpleTitleCaseMapping:0x29B7
 },
 { code:0x29B8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29B8
  ,simpleLowerCaseMapping:0x29B8
  ,simpleTitleCaseMapping:0x29B8
 },
 { code:0x29B9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29B9
  ,simpleLowerCaseMapping:0x29B9
  ,simpleTitleCaseMapping:0x29B9
 },
 { code:0x29BA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29BA
  ,simpleLowerCaseMapping:0x29BA
  ,simpleTitleCaseMapping:0x29BA
 },
 { code:0x29BB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29BB
  ,simpleLowerCaseMapping:0x29BB
  ,simpleTitleCaseMapping:0x29BB
 },
 { code:0x29BC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29BC
  ,simpleLowerCaseMapping:0x29BC
  ,simpleTitleCaseMapping:0x29BC
 },
 { code:0x29BD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29BD
  ,simpleLowerCaseMapping:0x29BD
  ,simpleTitleCaseMapping:0x29BD
 },
 { code:0x29BE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29BE
  ,simpleLowerCaseMapping:0x29BE
  ,simpleTitleCaseMapping:0x29BE
 },
 { code:0x29BF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29BF
  ,simpleLowerCaseMapping:0x29BF
  ,simpleTitleCaseMapping:0x29BF
 },
 { code:0x29C0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29C0
  ,simpleLowerCaseMapping:0x29C0
  ,simpleTitleCaseMapping:0x29C0
 },
 { code:0x29C1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29C1
  ,simpleLowerCaseMapping:0x29C1
  ,simpleTitleCaseMapping:0x29C1
 },
 { code:0x29C2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29C2
  ,simpleLowerCaseMapping:0x29C2
  ,simpleTitleCaseMapping:0x29C2
 },
 { code:0x29C3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29C3
  ,simpleLowerCaseMapping:0x29C3
  ,simpleTitleCaseMapping:0x29C3
 },
 { code:0x29C4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29C4
  ,simpleLowerCaseMapping:0x29C4
  ,simpleTitleCaseMapping:0x29C4
 },
 { code:0x29C5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29C5
  ,simpleLowerCaseMapping:0x29C5
  ,simpleTitleCaseMapping:0x29C5
 },
 { code:0x29C6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29C6
  ,simpleLowerCaseMapping:0x29C6
  ,simpleTitleCaseMapping:0x29C6
 },
 { code:0x29C7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29C7
  ,simpleLowerCaseMapping:0x29C7
  ,simpleTitleCaseMapping:0x29C7
 },
 { code:0x29C8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29C8
  ,simpleLowerCaseMapping:0x29C8
  ,simpleTitleCaseMapping:0x29C8
 },
 { code:0x29C9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29C9
  ,simpleLowerCaseMapping:0x29C9
  ,simpleTitleCaseMapping:0x29C9
 },
 { code:0x29CA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29CA
  ,simpleLowerCaseMapping:0x29CA
  ,simpleTitleCaseMapping:0x29CA
 },
 { code:0x29CB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29CB
  ,simpleLowerCaseMapping:0x29CB
  ,simpleTitleCaseMapping:0x29CB
 },
 { code:0x29CC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29CC
  ,simpleLowerCaseMapping:0x29CC
  ,simpleTitleCaseMapping:0x29CC
 },
 { code:0x29CD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29CD
  ,simpleLowerCaseMapping:0x29CD
  ,simpleTitleCaseMapping:0x29CD
 },
 { code:0x29CE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29CE
  ,simpleLowerCaseMapping:0x29CE
  ,simpleTitleCaseMapping:0x29CE
 },
 { code:0x29CF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29CF
  ,simpleLowerCaseMapping:0x29CF
  ,simpleTitleCaseMapping:0x29CF
 },
 { code:0x29D0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29D0
  ,simpleLowerCaseMapping:0x29D0
  ,simpleTitleCaseMapping:0x29D0
 },
 { code:0x29D1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29D1
  ,simpleLowerCaseMapping:0x29D1
  ,simpleTitleCaseMapping:0x29D1
 },
 { code:0x29D2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29D2
  ,simpleLowerCaseMapping:0x29D2
  ,simpleTitleCaseMapping:0x29D2
 },
 { code:0x29D3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29D3
  ,simpleLowerCaseMapping:0x29D3
  ,simpleTitleCaseMapping:0x29D3
 },
 { code:0x29D4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29D4
  ,simpleLowerCaseMapping:0x29D4
  ,simpleTitleCaseMapping:0x29D4
 },
 { code:0x29D5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29D5
  ,simpleLowerCaseMapping:0x29D5
  ,simpleTitleCaseMapping:0x29D5
 },
 { code:0x29D6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29D6
  ,simpleLowerCaseMapping:0x29D6
  ,simpleTitleCaseMapping:0x29D6
 },
 { code:0x29D7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29D7
  ,simpleLowerCaseMapping:0x29D7
  ,simpleTitleCaseMapping:0x29D7
 },
 { code:0x29D8
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x29D8
  ,simpleLowerCaseMapping:0x29D8
  ,simpleTitleCaseMapping:0x29D8
 },
 { code:0x29D9
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x29D9
  ,simpleLowerCaseMapping:0x29D9
  ,simpleTitleCaseMapping:0x29D9
 },
 { code:0x29DA
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x29DA
  ,simpleLowerCaseMapping:0x29DA
  ,simpleTitleCaseMapping:0x29DA
 },
 { code:0x29DB
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x29DB
  ,simpleLowerCaseMapping:0x29DB
  ,simpleTitleCaseMapping:0x29DB
 },
 { code:0x29DC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29DC
  ,simpleLowerCaseMapping:0x29DC
  ,simpleTitleCaseMapping:0x29DC
 },
 { code:0x29DD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29DD
  ,simpleLowerCaseMapping:0x29DD
  ,simpleTitleCaseMapping:0x29DD
 },
 { code:0x29DE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29DE
  ,simpleLowerCaseMapping:0x29DE
  ,simpleTitleCaseMapping:0x29DE
 },
 { code:0x29DF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29DF
  ,simpleLowerCaseMapping:0x29DF
  ,simpleTitleCaseMapping:0x29DF
 },
 { code:0x29E0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29E0
  ,simpleLowerCaseMapping:0x29E0
  ,simpleTitleCaseMapping:0x29E0
 },
 { code:0x29E1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29E1
  ,simpleLowerCaseMapping:0x29E1
  ,simpleTitleCaseMapping:0x29E1
 },
 { code:0x29E2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29E2
  ,simpleLowerCaseMapping:0x29E2
  ,simpleTitleCaseMapping:0x29E2
 },
 { code:0x29E3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29E3
  ,simpleLowerCaseMapping:0x29E3
  ,simpleTitleCaseMapping:0x29E3
 },
 { code:0x29E4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29E4
  ,simpleLowerCaseMapping:0x29E4
  ,simpleTitleCaseMapping:0x29E4
 },
 { code:0x29E5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29E5
  ,simpleLowerCaseMapping:0x29E5
  ,simpleTitleCaseMapping:0x29E5
 },
 { code:0x29E6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29E6
  ,simpleLowerCaseMapping:0x29E6
  ,simpleTitleCaseMapping:0x29E6
 },
 { code:0x29E7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29E7
  ,simpleLowerCaseMapping:0x29E7
  ,simpleTitleCaseMapping:0x29E7
 },
 { code:0x29E8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29E8
  ,simpleLowerCaseMapping:0x29E8
  ,simpleTitleCaseMapping:0x29E8
 },
 { code:0x29E9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29E9
  ,simpleLowerCaseMapping:0x29E9
  ,simpleTitleCaseMapping:0x29E9
 },
 { code:0x29EA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29EA
  ,simpleLowerCaseMapping:0x29EA
  ,simpleTitleCaseMapping:0x29EA
 },
 { code:0x29EB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29EB
  ,simpleLowerCaseMapping:0x29EB
  ,simpleTitleCaseMapping:0x29EB
 },
 { code:0x29EC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29EC
  ,simpleLowerCaseMapping:0x29EC
  ,simpleTitleCaseMapping:0x29EC
 },
 { code:0x29ED
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29ED
  ,simpleLowerCaseMapping:0x29ED
  ,simpleTitleCaseMapping:0x29ED
 },
 { code:0x29EE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29EE
  ,simpleLowerCaseMapping:0x29EE
  ,simpleTitleCaseMapping:0x29EE
 },
 { code:0x29EF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29EF
  ,simpleLowerCaseMapping:0x29EF
  ,simpleTitleCaseMapping:0x29EF
 },
 { code:0x29F0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29F0
  ,simpleLowerCaseMapping:0x29F0
  ,simpleTitleCaseMapping:0x29F0
 },
 { code:0x29F1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29F1
  ,simpleLowerCaseMapping:0x29F1
  ,simpleTitleCaseMapping:0x29F1
 },
 { code:0x29F2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29F2
  ,simpleLowerCaseMapping:0x29F2
  ,simpleTitleCaseMapping:0x29F2
 },
 { code:0x29F3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29F3
  ,simpleLowerCaseMapping:0x29F3
  ,simpleTitleCaseMapping:0x29F3
 },
 { code:0x29F4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29F4
  ,simpleLowerCaseMapping:0x29F4
  ,simpleTitleCaseMapping:0x29F4
 },
 { code:0x29F5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29F5
  ,simpleLowerCaseMapping:0x29F5
  ,simpleTitleCaseMapping:0x29F5
 },
 { code:0x29F6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29F6
  ,simpleLowerCaseMapping:0x29F6
  ,simpleTitleCaseMapping:0x29F6
 },
 { code:0x29F7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29F7
  ,simpleLowerCaseMapping:0x29F7
  ,simpleTitleCaseMapping:0x29F7
 },
 { code:0x29F8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29F8
  ,simpleLowerCaseMapping:0x29F8
  ,simpleTitleCaseMapping:0x29F8
 },
 { code:0x29F9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29F9
  ,simpleLowerCaseMapping:0x29F9
  ,simpleTitleCaseMapping:0x29F9
 },
 { code:0x29FA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29FA
  ,simpleLowerCaseMapping:0x29FA
  ,simpleTitleCaseMapping:0x29FA
 },
 { code:0x29FB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29FB
  ,simpleLowerCaseMapping:0x29FB
  ,simpleTitleCaseMapping:0x29FB
 },
 { code:0x29FC
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x29FC
  ,simpleLowerCaseMapping:0x29FC
  ,simpleTitleCaseMapping:0x29FC
 },
 { code:0x29FD
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x29FD
  ,simpleLowerCaseMapping:0x29FD
  ,simpleTitleCaseMapping:0x29FD
 },
 { code:0x29FE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29FE
  ,simpleLowerCaseMapping:0x29FE
  ,simpleTitleCaseMapping:0x29FE
 },
 { code:0x29FF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x29FF
  ,simpleLowerCaseMapping:0x29FF
  ,simpleTitleCaseMapping:0x29FF
 },
 { code:0x2A00
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A00
  ,simpleLowerCaseMapping:0x2A00
  ,simpleTitleCaseMapping:0x2A00
 },
 { code:0x2A01
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A01
  ,simpleLowerCaseMapping:0x2A01
  ,simpleTitleCaseMapping:0x2A01
 },
 { code:0x2A02
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A02
  ,simpleLowerCaseMapping:0x2A02
  ,simpleTitleCaseMapping:0x2A02
 },
 { code:0x2A03
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A03
  ,simpleLowerCaseMapping:0x2A03
  ,simpleTitleCaseMapping:0x2A03
 },
 { code:0x2A04
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A04
  ,simpleLowerCaseMapping:0x2A04
  ,simpleTitleCaseMapping:0x2A04
 },
 { code:0x2A05
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A05
  ,simpleLowerCaseMapping:0x2A05
  ,simpleTitleCaseMapping:0x2A05
 },
 { code:0x2A06
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A06
  ,simpleLowerCaseMapping:0x2A06
  ,simpleTitleCaseMapping:0x2A06
 },
 { code:0x2A07
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A07
  ,simpleLowerCaseMapping:0x2A07
  ,simpleTitleCaseMapping:0x2A07
 },
 { code:0x2A08
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A08
  ,simpleLowerCaseMapping:0x2A08
  ,simpleTitleCaseMapping:0x2A08
 },
 { code:0x2A09
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A09
  ,simpleLowerCaseMapping:0x2A09
  ,simpleTitleCaseMapping:0x2A09
 },
 { code:0x2A0A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A0A
  ,simpleLowerCaseMapping:0x2A0A
  ,simpleTitleCaseMapping:0x2A0A
 },
 { code:0x2A0B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A0B
  ,simpleLowerCaseMapping:0x2A0B
  ,simpleTitleCaseMapping:0x2A0B
 },
 { code:0x2A0C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A0C
  ,simpleLowerCaseMapping:0x2A0C
  ,simpleTitleCaseMapping:0x2A0C
 },
 { code:0x2A0D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A0D
  ,simpleLowerCaseMapping:0x2A0D
  ,simpleTitleCaseMapping:0x2A0D
 },
 { code:0x2A0E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A0E
  ,simpleLowerCaseMapping:0x2A0E
  ,simpleTitleCaseMapping:0x2A0E
 },
 { code:0x2A0F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A0F
  ,simpleLowerCaseMapping:0x2A0F
  ,simpleTitleCaseMapping:0x2A0F
 },
 { code:0x2A10
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A10
  ,simpleLowerCaseMapping:0x2A10
  ,simpleTitleCaseMapping:0x2A10
 },
 { code:0x2A11
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A11
  ,simpleLowerCaseMapping:0x2A11
  ,simpleTitleCaseMapping:0x2A11
 },
 { code:0x2A12
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A12
  ,simpleLowerCaseMapping:0x2A12
  ,simpleTitleCaseMapping:0x2A12
 },
 { code:0x2A13
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A13
  ,simpleLowerCaseMapping:0x2A13
  ,simpleTitleCaseMapping:0x2A13
 },
 { code:0x2A14
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A14
  ,simpleLowerCaseMapping:0x2A14
  ,simpleTitleCaseMapping:0x2A14
 },
 { code:0x2A15
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A15
  ,simpleLowerCaseMapping:0x2A15
  ,simpleTitleCaseMapping:0x2A15
 },
 { code:0x2A16
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A16
  ,simpleLowerCaseMapping:0x2A16
  ,simpleTitleCaseMapping:0x2A16
 },
 { code:0x2A17
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A17
  ,simpleLowerCaseMapping:0x2A17
  ,simpleTitleCaseMapping:0x2A17
 },
 { code:0x2A18
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A18
  ,simpleLowerCaseMapping:0x2A18
  ,simpleTitleCaseMapping:0x2A18
 },
 { code:0x2A19
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A19
  ,simpleLowerCaseMapping:0x2A19
  ,simpleTitleCaseMapping:0x2A19
 },
 { code:0x2A1A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A1A
  ,simpleLowerCaseMapping:0x2A1A
  ,simpleTitleCaseMapping:0x2A1A
 },
 { code:0x2A1B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A1B
  ,simpleLowerCaseMapping:0x2A1B
  ,simpleTitleCaseMapping:0x2A1B
 },
 { code:0x2A1C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A1C
  ,simpleLowerCaseMapping:0x2A1C
  ,simpleTitleCaseMapping:0x2A1C
 },
 { code:0x2A1D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A1D
  ,simpleLowerCaseMapping:0x2A1D
  ,simpleTitleCaseMapping:0x2A1D
 },
 { code:0x2A1E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A1E
  ,simpleLowerCaseMapping:0x2A1E
  ,simpleTitleCaseMapping:0x2A1E
 },
 { code:0x2A1F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A1F
  ,simpleLowerCaseMapping:0x2A1F
  ,simpleTitleCaseMapping:0x2A1F
 },
 { code:0x2A20
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A20
  ,simpleLowerCaseMapping:0x2A20
  ,simpleTitleCaseMapping:0x2A20
 },
 { code:0x2A21
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A21
  ,simpleLowerCaseMapping:0x2A21
  ,simpleTitleCaseMapping:0x2A21
 },
 { code:0x2A22
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A22
  ,simpleLowerCaseMapping:0x2A22
  ,simpleTitleCaseMapping:0x2A22
 },
 { code:0x2A23
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A23
  ,simpleLowerCaseMapping:0x2A23
  ,simpleTitleCaseMapping:0x2A23
 },
 { code:0x2A24
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A24
  ,simpleLowerCaseMapping:0x2A24
  ,simpleTitleCaseMapping:0x2A24
 },
 { code:0x2A25
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A25
  ,simpleLowerCaseMapping:0x2A25
  ,simpleTitleCaseMapping:0x2A25
 },
 { code:0x2A26
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A26
  ,simpleLowerCaseMapping:0x2A26
  ,simpleTitleCaseMapping:0x2A26
 },
 { code:0x2A27
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A27
  ,simpleLowerCaseMapping:0x2A27
  ,simpleTitleCaseMapping:0x2A27
 },
 { code:0x2A28
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A28
  ,simpleLowerCaseMapping:0x2A28
  ,simpleTitleCaseMapping:0x2A28
 },
 { code:0x2A29
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A29
  ,simpleLowerCaseMapping:0x2A29
  ,simpleTitleCaseMapping:0x2A29
 },
 { code:0x2A2A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A2A
  ,simpleLowerCaseMapping:0x2A2A
  ,simpleTitleCaseMapping:0x2A2A
 },
 { code:0x2A2B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A2B
  ,simpleLowerCaseMapping:0x2A2B
  ,simpleTitleCaseMapping:0x2A2B
 },
 { code:0x2A2C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A2C
  ,simpleLowerCaseMapping:0x2A2C
  ,simpleTitleCaseMapping:0x2A2C
 },
 { code:0x2A2D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A2D
  ,simpleLowerCaseMapping:0x2A2D
  ,simpleTitleCaseMapping:0x2A2D
 },
 { code:0x2A2E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A2E
  ,simpleLowerCaseMapping:0x2A2E
  ,simpleTitleCaseMapping:0x2A2E
 },
 { code:0x2A2F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A2F
  ,simpleLowerCaseMapping:0x2A2F
  ,simpleTitleCaseMapping:0x2A2F
 },
 { code:0x2A30
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A30
  ,simpleLowerCaseMapping:0x2A30
  ,simpleTitleCaseMapping:0x2A30
 },
 { code:0x2A31
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A31
  ,simpleLowerCaseMapping:0x2A31
  ,simpleTitleCaseMapping:0x2A31
 },
 { code:0x2A32
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A32
  ,simpleLowerCaseMapping:0x2A32
  ,simpleTitleCaseMapping:0x2A32
 },
 { code:0x2A33
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A33
  ,simpleLowerCaseMapping:0x2A33
  ,simpleTitleCaseMapping:0x2A33
 },
 { code:0x2A34
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A34
  ,simpleLowerCaseMapping:0x2A34
  ,simpleTitleCaseMapping:0x2A34
 },
 { code:0x2A35
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A35
  ,simpleLowerCaseMapping:0x2A35
  ,simpleTitleCaseMapping:0x2A35
 },
 { code:0x2A36
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A36
  ,simpleLowerCaseMapping:0x2A36
  ,simpleTitleCaseMapping:0x2A36
 },
 { code:0x2A37
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A37
  ,simpleLowerCaseMapping:0x2A37
  ,simpleTitleCaseMapping:0x2A37
 },
 { code:0x2A38
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A38
  ,simpleLowerCaseMapping:0x2A38
  ,simpleTitleCaseMapping:0x2A38
 },
 { code:0x2A39
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A39
  ,simpleLowerCaseMapping:0x2A39
  ,simpleTitleCaseMapping:0x2A39
 },
 { code:0x2A3A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A3A
  ,simpleLowerCaseMapping:0x2A3A
  ,simpleTitleCaseMapping:0x2A3A
 },
 { code:0x2A3B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A3B
  ,simpleLowerCaseMapping:0x2A3B
  ,simpleTitleCaseMapping:0x2A3B
 },
 { code:0x2A3C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A3C
  ,simpleLowerCaseMapping:0x2A3C
  ,simpleTitleCaseMapping:0x2A3C
 },
 { code:0x2A3D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A3D
  ,simpleLowerCaseMapping:0x2A3D
  ,simpleTitleCaseMapping:0x2A3D
 },
 { code:0x2A3E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A3E
  ,simpleLowerCaseMapping:0x2A3E
  ,simpleTitleCaseMapping:0x2A3E
 },
 { code:0x2A3F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A3F
  ,simpleLowerCaseMapping:0x2A3F
  ,simpleTitleCaseMapping:0x2A3F
 },
 { code:0x2A40
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A40
  ,simpleLowerCaseMapping:0x2A40
  ,simpleTitleCaseMapping:0x2A40
 },
 { code:0x2A41
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A41
  ,simpleLowerCaseMapping:0x2A41
  ,simpleTitleCaseMapping:0x2A41
 },
 { code:0x2A42
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A42
  ,simpleLowerCaseMapping:0x2A42
  ,simpleTitleCaseMapping:0x2A42
 },
 { code:0x2A43
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A43
  ,simpleLowerCaseMapping:0x2A43
  ,simpleTitleCaseMapping:0x2A43
 },
 { code:0x2A44
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A44
  ,simpleLowerCaseMapping:0x2A44
  ,simpleTitleCaseMapping:0x2A44
 },
 { code:0x2A45
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A45
  ,simpleLowerCaseMapping:0x2A45
  ,simpleTitleCaseMapping:0x2A45
 },
 { code:0x2A46
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A46
  ,simpleLowerCaseMapping:0x2A46
  ,simpleTitleCaseMapping:0x2A46
 },
 { code:0x2A47
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A47
  ,simpleLowerCaseMapping:0x2A47
  ,simpleTitleCaseMapping:0x2A47
 },
 { code:0x2A48
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A48
  ,simpleLowerCaseMapping:0x2A48
  ,simpleTitleCaseMapping:0x2A48
 },
 { code:0x2A49
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A49
  ,simpleLowerCaseMapping:0x2A49
  ,simpleTitleCaseMapping:0x2A49
 },
 { code:0x2A4A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A4A
  ,simpleLowerCaseMapping:0x2A4A
  ,simpleTitleCaseMapping:0x2A4A
 },
 { code:0x2A4B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A4B
  ,simpleLowerCaseMapping:0x2A4B
  ,simpleTitleCaseMapping:0x2A4B
 },
 { code:0x2A4C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A4C
  ,simpleLowerCaseMapping:0x2A4C
  ,simpleTitleCaseMapping:0x2A4C
 },
 { code:0x2A4D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A4D
  ,simpleLowerCaseMapping:0x2A4D
  ,simpleTitleCaseMapping:0x2A4D
 },
 { code:0x2A4E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A4E
  ,simpleLowerCaseMapping:0x2A4E
  ,simpleTitleCaseMapping:0x2A4E
 },
 { code:0x2A4F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A4F
  ,simpleLowerCaseMapping:0x2A4F
  ,simpleTitleCaseMapping:0x2A4F
 },
 { code:0x2A50
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A50
  ,simpleLowerCaseMapping:0x2A50
  ,simpleTitleCaseMapping:0x2A50
 },
 { code:0x2A51
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A51
  ,simpleLowerCaseMapping:0x2A51
  ,simpleTitleCaseMapping:0x2A51
 },
 { code:0x2A52
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A52
  ,simpleLowerCaseMapping:0x2A52
  ,simpleTitleCaseMapping:0x2A52
 },
 { code:0x2A53
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A53
  ,simpleLowerCaseMapping:0x2A53
  ,simpleTitleCaseMapping:0x2A53
 },
 { code:0x2A54
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A54
  ,simpleLowerCaseMapping:0x2A54
  ,simpleTitleCaseMapping:0x2A54
 },
 { code:0x2A55
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A55
  ,simpleLowerCaseMapping:0x2A55
  ,simpleTitleCaseMapping:0x2A55
 },
 { code:0x2A56
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A56
  ,simpleLowerCaseMapping:0x2A56
  ,simpleTitleCaseMapping:0x2A56
 },
 { code:0x2A57
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A57
  ,simpleLowerCaseMapping:0x2A57
  ,simpleTitleCaseMapping:0x2A57
 },
 { code:0x2A58
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A58
  ,simpleLowerCaseMapping:0x2A58
  ,simpleTitleCaseMapping:0x2A58
 },
 { code:0x2A59
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A59
  ,simpleLowerCaseMapping:0x2A59
  ,simpleTitleCaseMapping:0x2A59
 },
 { code:0x2A5A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A5A
  ,simpleLowerCaseMapping:0x2A5A
  ,simpleTitleCaseMapping:0x2A5A
 },
 { code:0x2A5B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A5B
  ,simpleLowerCaseMapping:0x2A5B
  ,simpleTitleCaseMapping:0x2A5B
 },
 { code:0x2A5C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A5C
  ,simpleLowerCaseMapping:0x2A5C
  ,simpleTitleCaseMapping:0x2A5C
 },
 { code:0x2A5D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A5D
  ,simpleLowerCaseMapping:0x2A5D
  ,simpleTitleCaseMapping:0x2A5D
 },
 { code:0x2A5E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A5E
  ,simpleLowerCaseMapping:0x2A5E
  ,simpleTitleCaseMapping:0x2A5E
 },
 { code:0x2A5F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A5F
  ,simpleLowerCaseMapping:0x2A5F
  ,simpleTitleCaseMapping:0x2A5F
 },
 { code:0x2A60
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A60
  ,simpleLowerCaseMapping:0x2A60
  ,simpleTitleCaseMapping:0x2A60
 },
 { code:0x2A61
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A61
  ,simpleLowerCaseMapping:0x2A61
  ,simpleTitleCaseMapping:0x2A61
 },
 { code:0x2A62
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A62
  ,simpleLowerCaseMapping:0x2A62
  ,simpleTitleCaseMapping:0x2A62
 },
 { code:0x2A63
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A63
  ,simpleLowerCaseMapping:0x2A63
  ,simpleTitleCaseMapping:0x2A63
 },
 { code:0x2A64
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A64
  ,simpleLowerCaseMapping:0x2A64
  ,simpleTitleCaseMapping:0x2A64
 },
 { code:0x2A65
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A65
  ,simpleLowerCaseMapping:0x2A65
  ,simpleTitleCaseMapping:0x2A65
 },
 { code:0x2A66
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A66
  ,simpleLowerCaseMapping:0x2A66
  ,simpleTitleCaseMapping:0x2A66
 },
 { code:0x2A67
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A67
  ,simpleLowerCaseMapping:0x2A67
  ,simpleTitleCaseMapping:0x2A67
 },
 { code:0x2A68
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A68
  ,simpleLowerCaseMapping:0x2A68
  ,simpleTitleCaseMapping:0x2A68
 },
 { code:0x2A69
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A69
  ,simpleLowerCaseMapping:0x2A69
  ,simpleTitleCaseMapping:0x2A69
 },
 { code:0x2A6A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A6A
  ,simpleLowerCaseMapping:0x2A6A
  ,simpleTitleCaseMapping:0x2A6A
 },
 { code:0x2A6B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A6B
  ,simpleLowerCaseMapping:0x2A6B
  ,simpleTitleCaseMapping:0x2A6B
 },
 { code:0x2A6C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A6C
  ,simpleLowerCaseMapping:0x2A6C
  ,simpleTitleCaseMapping:0x2A6C
 },
 { code:0x2A6D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A6D
  ,simpleLowerCaseMapping:0x2A6D
  ,simpleTitleCaseMapping:0x2A6D
 },
 { code:0x2A6E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A6E
  ,simpleLowerCaseMapping:0x2A6E
  ,simpleTitleCaseMapping:0x2A6E
 },
 { code:0x2A6F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A6F
  ,simpleLowerCaseMapping:0x2A6F
  ,simpleTitleCaseMapping:0x2A6F
 },
 { code:0x2A70
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A70
  ,simpleLowerCaseMapping:0x2A70
  ,simpleTitleCaseMapping:0x2A70
 },
 { code:0x2A71
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A71
  ,simpleLowerCaseMapping:0x2A71
  ,simpleTitleCaseMapping:0x2A71
 },
 { code:0x2A72
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A72
  ,simpleLowerCaseMapping:0x2A72
  ,simpleTitleCaseMapping:0x2A72
 },
 { code:0x2A73
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A73
  ,simpleLowerCaseMapping:0x2A73
  ,simpleTitleCaseMapping:0x2A73
 },
 { code:0x2A74
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A74
  ,simpleLowerCaseMapping:0x2A74
  ,simpleTitleCaseMapping:0x2A74
 },
 { code:0x2A75
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A75
  ,simpleLowerCaseMapping:0x2A75
  ,simpleTitleCaseMapping:0x2A75
 },
 { code:0x2A76
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A76
  ,simpleLowerCaseMapping:0x2A76
  ,simpleTitleCaseMapping:0x2A76
 },
 { code:0x2A77
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A77
  ,simpleLowerCaseMapping:0x2A77
  ,simpleTitleCaseMapping:0x2A77
 },
 { code:0x2A78
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A78
  ,simpleLowerCaseMapping:0x2A78
  ,simpleTitleCaseMapping:0x2A78
 },
 { code:0x2A79
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A79
  ,simpleLowerCaseMapping:0x2A79
  ,simpleTitleCaseMapping:0x2A79
 },
 { code:0x2A7A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A7A
  ,simpleLowerCaseMapping:0x2A7A
  ,simpleTitleCaseMapping:0x2A7A
 },
 { code:0x2A7B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A7B
  ,simpleLowerCaseMapping:0x2A7B
  ,simpleTitleCaseMapping:0x2A7B
 },
 { code:0x2A7C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A7C
  ,simpleLowerCaseMapping:0x2A7C
  ,simpleTitleCaseMapping:0x2A7C
 },
 { code:0x2A7D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A7D
  ,simpleLowerCaseMapping:0x2A7D
  ,simpleTitleCaseMapping:0x2A7D
 },
 { code:0x2A7E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A7E
  ,simpleLowerCaseMapping:0x2A7E
  ,simpleTitleCaseMapping:0x2A7E
 },
 { code:0x2A7F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A7F
  ,simpleLowerCaseMapping:0x2A7F
  ,simpleTitleCaseMapping:0x2A7F
 },
 { code:0x2A80
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A80
  ,simpleLowerCaseMapping:0x2A80
  ,simpleTitleCaseMapping:0x2A80
 },
 { code:0x2A81
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A81
  ,simpleLowerCaseMapping:0x2A81
  ,simpleTitleCaseMapping:0x2A81
 },
 { code:0x2A82
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A82
  ,simpleLowerCaseMapping:0x2A82
  ,simpleTitleCaseMapping:0x2A82
 },
 { code:0x2A83
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A83
  ,simpleLowerCaseMapping:0x2A83
  ,simpleTitleCaseMapping:0x2A83
 },
 { code:0x2A84
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A84
  ,simpleLowerCaseMapping:0x2A84
  ,simpleTitleCaseMapping:0x2A84
 },
 { code:0x2A85
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A85
  ,simpleLowerCaseMapping:0x2A85
  ,simpleTitleCaseMapping:0x2A85
 },
 { code:0x2A86
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A86
  ,simpleLowerCaseMapping:0x2A86
  ,simpleTitleCaseMapping:0x2A86
 },
 { code:0x2A87
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A87
  ,simpleLowerCaseMapping:0x2A87
  ,simpleTitleCaseMapping:0x2A87
 },
 { code:0x2A88
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A88
  ,simpleLowerCaseMapping:0x2A88
  ,simpleTitleCaseMapping:0x2A88
 },
 { code:0x2A89
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A89
  ,simpleLowerCaseMapping:0x2A89
  ,simpleTitleCaseMapping:0x2A89
 },
 { code:0x2A8A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A8A
  ,simpleLowerCaseMapping:0x2A8A
  ,simpleTitleCaseMapping:0x2A8A
 },
 { code:0x2A8B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A8B
  ,simpleLowerCaseMapping:0x2A8B
  ,simpleTitleCaseMapping:0x2A8B
 },
 { code:0x2A8C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A8C
  ,simpleLowerCaseMapping:0x2A8C
  ,simpleTitleCaseMapping:0x2A8C
 },
 { code:0x2A8D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A8D
  ,simpleLowerCaseMapping:0x2A8D
  ,simpleTitleCaseMapping:0x2A8D
 },
 { code:0x2A8E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A8E
  ,simpleLowerCaseMapping:0x2A8E
  ,simpleTitleCaseMapping:0x2A8E
 },
 { code:0x2A8F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A8F
  ,simpleLowerCaseMapping:0x2A8F
  ,simpleTitleCaseMapping:0x2A8F
 },
 { code:0x2A90
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A90
  ,simpleLowerCaseMapping:0x2A90
  ,simpleTitleCaseMapping:0x2A90
 },
 { code:0x2A91
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A91
  ,simpleLowerCaseMapping:0x2A91
  ,simpleTitleCaseMapping:0x2A91
 },
 { code:0x2A92
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A92
  ,simpleLowerCaseMapping:0x2A92
  ,simpleTitleCaseMapping:0x2A92
 },
 { code:0x2A93
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A93
  ,simpleLowerCaseMapping:0x2A93
  ,simpleTitleCaseMapping:0x2A93
 },
 { code:0x2A94
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A94
  ,simpleLowerCaseMapping:0x2A94
  ,simpleTitleCaseMapping:0x2A94
 },
 { code:0x2A95
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A95
  ,simpleLowerCaseMapping:0x2A95
  ,simpleTitleCaseMapping:0x2A95
 },
 { code:0x2A96
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A96
  ,simpleLowerCaseMapping:0x2A96
  ,simpleTitleCaseMapping:0x2A96
 },
 { code:0x2A97
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A97
  ,simpleLowerCaseMapping:0x2A97
  ,simpleTitleCaseMapping:0x2A97
 },
 { code:0x2A98
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A98
  ,simpleLowerCaseMapping:0x2A98
  ,simpleTitleCaseMapping:0x2A98
 },
 { code:0x2A99
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A99
  ,simpleLowerCaseMapping:0x2A99
  ,simpleTitleCaseMapping:0x2A99
 },
 { code:0x2A9A
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A9A
  ,simpleLowerCaseMapping:0x2A9A
  ,simpleTitleCaseMapping:0x2A9A
 },
 { code:0x2A9B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A9B
  ,simpleLowerCaseMapping:0x2A9B
  ,simpleTitleCaseMapping:0x2A9B
 },
 { code:0x2A9C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A9C
  ,simpleLowerCaseMapping:0x2A9C
  ,simpleTitleCaseMapping:0x2A9C
 },
 { code:0x2A9D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A9D
  ,simpleLowerCaseMapping:0x2A9D
  ,simpleTitleCaseMapping:0x2A9D
 },
 { code:0x2A9E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A9E
  ,simpleLowerCaseMapping:0x2A9E
  ,simpleTitleCaseMapping:0x2A9E
 },
 { code:0x2A9F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2A9F
  ,simpleLowerCaseMapping:0x2A9F
  ,simpleTitleCaseMapping:0x2A9F
 },
 { code:0x2AA0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AA0
  ,simpleLowerCaseMapping:0x2AA0
  ,simpleTitleCaseMapping:0x2AA0
 },
 { code:0x2AA1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AA1
  ,simpleLowerCaseMapping:0x2AA1
  ,simpleTitleCaseMapping:0x2AA1
 },
 { code:0x2AA2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AA2
  ,simpleLowerCaseMapping:0x2AA2
  ,simpleTitleCaseMapping:0x2AA2
 },
 { code:0x2AA3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AA3
  ,simpleLowerCaseMapping:0x2AA3
  ,simpleTitleCaseMapping:0x2AA3
 },
 { code:0x2AA4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AA4
  ,simpleLowerCaseMapping:0x2AA4
  ,simpleTitleCaseMapping:0x2AA4
 },
 { code:0x2AA5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AA5
  ,simpleLowerCaseMapping:0x2AA5
  ,simpleTitleCaseMapping:0x2AA5
 },
 { code:0x2AA6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AA6
  ,simpleLowerCaseMapping:0x2AA6
  ,simpleTitleCaseMapping:0x2AA6
 },
 { code:0x2AA7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AA7
  ,simpleLowerCaseMapping:0x2AA7
  ,simpleTitleCaseMapping:0x2AA7
 },
 { code:0x2AA8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AA8
  ,simpleLowerCaseMapping:0x2AA8
  ,simpleTitleCaseMapping:0x2AA8
 },
 { code:0x2AA9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AA9
  ,simpleLowerCaseMapping:0x2AA9
  ,simpleTitleCaseMapping:0x2AA9
 },
 { code:0x2AAA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AAA
  ,simpleLowerCaseMapping:0x2AAA
  ,simpleTitleCaseMapping:0x2AAA
 },
 { code:0x2AAB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AAB
  ,simpleLowerCaseMapping:0x2AAB
  ,simpleTitleCaseMapping:0x2AAB
 },
 { code:0x2AAC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AAC
  ,simpleLowerCaseMapping:0x2AAC
  ,simpleTitleCaseMapping:0x2AAC
 },
 { code:0x2AAD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AAD
  ,simpleLowerCaseMapping:0x2AAD
  ,simpleTitleCaseMapping:0x2AAD
 },
 { code:0x2AAE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AAE
  ,simpleLowerCaseMapping:0x2AAE
  ,simpleTitleCaseMapping:0x2AAE
 },
 { code:0x2AAF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AAF
  ,simpleLowerCaseMapping:0x2AAF
  ,simpleTitleCaseMapping:0x2AAF
 },
 { code:0x2AB0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AB0
  ,simpleLowerCaseMapping:0x2AB0
  ,simpleTitleCaseMapping:0x2AB0
 },
 { code:0x2AB1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AB1
  ,simpleLowerCaseMapping:0x2AB1
  ,simpleTitleCaseMapping:0x2AB1
 },
 { code:0x2AB2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AB2
  ,simpleLowerCaseMapping:0x2AB2
  ,simpleTitleCaseMapping:0x2AB2
 },
 { code:0x2AB3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AB3
  ,simpleLowerCaseMapping:0x2AB3
  ,simpleTitleCaseMapping:0x2AB3
 },
 { code:0x2AB4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AB4
  ,simpleLowerCaseMapping:0x2AB4
  ,simpleTitleCaseMapping:0x2AB4
 },
 { code:0x2AB5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AB5
  ,simpleLowerCaseMapping:0x2AB5
  ,simpleTitleCaseMapping:0x2AB5
 },
 { code:0x2AB6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AB6
  ,simpleLowerCaseMapping:0x2AB6
  ,simpleTitleCaseMapping:0x2AB6
 },
 { code:0x2AB7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AB7
  ,simpleLowerCaseMapping:0x2AB7
  ,simpleTitleCaseMapping:0x2AB7
 },
 { code:0x2AB8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AB8
  ,simpleLowerCaseMapping:0x2AB8
  ,simpleTitleCaseMapping:0x2AB8
 },
 { code:0x2AB9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AB9
  ,simpleLowerCaseMapping:0x2AB9
  ,simpleTitleCaseMapping:0x2AB9
 },
 { code:0x2ABA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2ABA
  ,simpleLowerCaseMapping:0x2ABA
  ,simpleTitleCaseMapping:0x2ABA
 },
 { code:0x2ABB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2ABB
  ,simpleLowerCaseMapping:0x2ABB
  ,simpleTitleCaseMapping:0x2ABB
 },
 { code:0x2ABC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2ABC
  ,simpleLowerCaseMapping:0x2ABC
  ,simpleTitleCaseMapping:0x2ABC
 },
 { code:0x2ABD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2ABD
  ,simpleLowerCaseMapping:0x2ABD
  ,simpleTitleCaseMapping:0x2ABD
 },
 { code:0x2ABE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2ABE
  ,simpleLowerCaseMapping:0x2ABE
  ,simpleTitleCaseMapping:0x2ABE
 },
 { code:0x2ABF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2ABF
  ,simpleLowerCaseMapping:0x2ABF
  ,simpleTitleCaseMapping:0x2ABF
 },
 { code:0x2AC0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AC0
  ,simpleLowerCaseMapping:0x2AC0
  ,simpleTitleCaseMapping:0x2AC0
 },
 { code:0x2AC1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AC1
  ,simpleLowerCaseMapping:0x2AC1
  ,simpleTitleCaseMapping:0x2AC1
 },
 { code:0x2AC2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AC2
  ,simpleLowerCaseMapping:0x2AC2
  ,simpleTitleCaseMapping:0x2AC2
 },
 { code:0x2AC3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AC3
  ,simpleLowerCaseMapping:0x2AC3
  ,simpleTitleCaseMapping:0x2AC3
 },
 { code:0x2AC4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AC4
  ,simpleLowerCaseMapping:0x2AC4
  ,simpleTitleCaseMapping:0x2AC4
 },
 { code:0x2AC5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AC5
  ,simpleLowerCaseMapping:0x2AC5
  ,simpleTitleCaseMapping:0x2AC5
 },
 { code:0x2AC6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AC6
  ,simpleLowerCaseMapping:0x2AC6
  ,simpleTitleCaseMapping:0x2AC6
 },
 { code:0x2AC7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AC7
  ,simpleLowerCaseMapping:0x2AC7
  ,simpleTitleCaseMapping:0x2AC7
 },
 { code:0x2AC8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AC8
  ,simpleLowerCaseMapping:0x2AC8
  ,simpleTitleCaseMapping:0x2AC8
 },
 { code:0x2AC9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AC9
  ,simpleLowerCaseMapping:0x2AC9
  ,simpleTitleCaseMapping:0x2AC9
 },
 { code:0x2ACA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2ACA
  ,simpleLowerCaseMapping:0x2ACA
  ,simpleTitleCaseMapping:0x2ACA
 },
 { code:0x2ACB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2ACB
  ,simpleLowerCaseMapping:0x2ACB
  ,simpleTitleCaseMapping:0x2ACB
 },
 { code:0x2ACC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2ACC
  ,simpleLowerCaseMapping:0x2ACC
  ,simpleTitleCaseMapping:0x2ACC
 },
 { code:0x2ACD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2ACD
  ,simpleLowerCaseMapping:0x2ACD
  ,simpleTitleCaseMapping:0x2ACD
 },
 { code:0x2ACE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2ACE
  ,simpleLowerCaseMapping:0x2ACE
  ,simpleTitleCaseMapping:0x2ACE
 },
 { code:0x2ACF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2ACF
  ,simpleLowerCaseMapping:0x2ACF
  ,simpleTitleCaseMapping:0x2ACF
 },
 { code:0x2AD0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AD0
  ,simpleLowerCaseMapping:0x2AD0
  ,simpleTitleCaseMapping:0x2AD0
 },
 { code:0x2AD1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AD1
  ,simpleLowerCaseMapping:0x2AD1
  ,simpleTitleCaseMapping:0x2AD1
 },
 { code:0x2AD2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AD2
  ,simpleLowerCaseMapping:0x2AD2
  ,simpleTitleCaseMapping:0x2AD2
 },
 { code:0x2AD3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AD3
  ,simpleLowerCaseMapping:0x2AD3
  ,simpleTitleCaseMapping:0x2AD3
 },
 { code:0x2AD4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AD4
  ,simpleLowerCaseMapping:0x2AD4
  ,simpleTitleCaseMapping:0x2AD4
 },
 { code:0x2AD5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AD5
  ,simpleLowerCaseMapping:0x2AD5
  ,simpleTitleCaseMapping:0x2AD5
 },
 { code:0x2AD6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AD6
  ,simpleLowerCaseMapping:0x2AD6
  ,simpleTitleCaseMapping:0x2AD6
 },
 { code:0x2AD7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AD7
  ,simpleLowerCaseMapping:0x2AD7
  ,simpleTitleCaseMapping:0x2AD7
 },
 { code:0x2AD8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AD8
  ,simpleLowerCaseMapping:0x2AD8
  ,simpleTitleCaseMapping:0x2AD8
 },
 { code:0x2AD9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AD9
  ,simpleLowerCaseMapping:0x2AD9
  ,simpleTitleCaseMapping:0x2AD9
 },
 { code:0x2ADA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2ADA
  ,simpleLowerCaseMapping:0x2ADA
  ,simpleTitleCaseMapping:0x2ADA
 },
 { code:0x2ADB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2ADB
  ,simpleLowerCaseMapping:0x2ADB
  ,simpleTitleCaseMapping:0x2ADB
 },
 { code:0x2ADC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2ADC
  ,simpleLowerCaseMapping:0x2ADC
  ,simpleTitleCaseMapping:0x2ADC
 },
 { code:0x2ADD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2ADD
  ,simpleLowerCaseMapping:0x2ADD
  ,simpleTitleCaseMapping:0x2ADD
 },
 { code:0x2ADE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2ADE
  ,simpleLowerCaseMapping:0x2ADE
  ,simpleTitleCaseMapping:0x2ADE
 },
 { code:0x2ADF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2ADF
  ,simpleLowerCaseMapping:0x2ADF
  ,simpleTitleCaseMapping:0x2ADF
 },
 { code:0x2AE0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AE0
  ,simpleLowerCaseMapping:0x2AE0
  ,simpleTitleCaseMapping:0x2AE0
 },
 { code:0x2AE1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AE1
  ,simpleLowerCaseMapping:0x2AE1
  ,simpleTitleCaseMapping:0x2AE1
 },
 { code:0x2AE2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AE2
  ,simpleLowerCaseMapping:0x2AE2
  ,simpleTitleCaseMapping:0x2AE2
 },
 { code:0x2AE3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AE3
  ,simpleLowerCaseMapping:0x2AE3
  ,simpleTitleCaseMapping:0x2AE3
 },
 { code:0x2AE4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AE4
  ,simpleLowerCaseMapping:0x2AE4
  ,simpleTitleCaseMapping:0x2AE4
 },
 { code:0x2AE5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AE5
  ,simpleLowerCaseMapping:0x2AE5
  ,simpleTitleCaseMapping:0x2AE5
 },
 { code:0x2AE6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AE6
  ,simpleLowerCaseMapping:0x2AE6
  ,simpleTitleCaseMapping:0x2AE6
 },
 { code:0x2AE7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AE7
  ,simpleLowerCaseMapping:0x2AE7
  ,simpleTitleCaseMapping:0x2AE7
 },
 { code:0x2AE8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AE8
  ,simpleLowerCaseMapping:0x2AE8
  ,simpleTitleCaseMapping:0x2AE8
 },
 { code:0x2AE9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AE9
  ,simpleLowerCaseMapping:0x2AE9
  ,simpleTitleCaseMapping:0x2AE9
 },
 { code:0x2AEA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AEA
  ,simpleLowerCaseMapping:0x2AEA
  ,simpleTitleCaseMapping:0x2AEA
 },
 { code:0x2AEB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AEB
  ,simpleLowerCaseMapping:0x2AEB
  ,simpleTitleCaseMapping:0x2AEB
 },
 { code:0x2AEC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AEC
  ,simpleLowerCaseMapping:0x2AEC
  ,simpleTitleCaseMapping:0x2AEC
 },
 { code:0x2AED
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AED
  ,simpleLowerCaseMapping:0x2AED
  ,simpleTitleCaseMapping:0x2AED
 },
 { code:0x2AEE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AEE
  ,simpleLowerCaseMapping:0x2AEE
  ,simpleTitleCaseMapping:0x2AEE
 },
 { code:0x2AEF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AEF
  ,simpleLowerCaseMapping:0x2AEF
  ,simpleTitleCaseMapping:0x2AEF
 },
 { code:0x2AF0
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AF0
  ,simpleLowerCaseMapping:0x2AF0
  ,simpleTitleCaseMapping:0x2AF0
 },
 { code:0x2AF1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AF1
  ,simpleLowerCaseMapping:0x2AF1
  ,simpleTitleCaseMapping:0x2AF1
 },
 { code:0x2AF2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AF2
  ,simpleLowerCaseMapping:0x2AF2
  ,simpleTitleCaseMapping:0x2AF2
 },
 { code:0x2AF3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AF3
  ,simpleLowerCaseMapping:0x2AF3
  ,simpleTitleCaseMapping:0x2AF3
 },
 { code:0x2AF4
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AF4
  ,simpleLowerCaseMapping:0x2AF4
  ,simpleTitleCaseMapping:0x2AF4
 },
 { code:0x2AF5
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AF5
  ,simpleLowerCaseMapping:0x2AF5
  ,simpleTitleCaseMapping:0x2AF5
 },
 { code:0x2AF6
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AF6
  ,simpleLowerCaseMapping:0x2AF6
  ,simpleTitleCaseMapping:0x2AF6
 },
 { code:0x2AF7
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AF7
  ,simpleLowerCaseMapping:0x2AF7
  ,simpleTitleCaseMapping:0x2AF7
 },
 { code:0x2AF8
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AF8
  ,simpleLowerCaseMapping:0x2AF8
  ,simpleTitleCaseMapping:0x2AF8
 },
 { code:0x2AF9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AF9
  ,simpleLowerCaseMapping:0x2AF9
  ,simpleTitleCaseMapping:0x2AF9
 },
 { code:0x2AFA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AFA
  ,simpleLowerCaseMapping:0x2AFA
  ,simpleTitleCaseMapping:0x2AFA
 },
 { code:0x2AFB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AFB
  ,simpleLowerCaseMapping:0x2AFB
  ,simpleTitleCaseMapping:0x2AFB
 },
 { code:0x2AFC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AFC
  ,simpleLowerCaseMapping:0x2AFC
  ,simpleTitleCaseMapping:0x2AFC
 },
 { code:0x2AFD
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AFD
  ,simpleLowerCaseMapping:0x2AFD
  ,simpleTitleCaseMapping:0x2AFD
 },
 { code:0x2AFE
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AFE
  ,simpleLowerCaseMapping:0x2AFE
  ,simpleTitleCaseMapping:0x2AFE
 },
 { code:0x2AFF
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x2AFF
  ,simpleLowerCaseMapping:0x2AFF
  ,simpleTitleCaseMapping:0x2AFF
 },
 { code:0x2B00
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B00
  ,simpleLowerCaseMapping:0x2B00
  ,simpleTitleCaseMapping:0x2B00
 },
 { code:0x2B01
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B01
  ,simpleLowerCaseMapping:0x2B01
  ,simpleTitleCaseMapping:0x2B01
 },
 { code:0x2B02
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B02
  ,simpleLowerCaseMapping:0x2B02
  ,simpleTitleCaseMapping:0x2B02
 },
 { code:0x2B03
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B03
  ,simpleLowerCaseMapping:0x2B03
  ,simpleTitleCaseMapping:0x2B03
 },
 { code:0x2B04
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B04
  ,simpleLowerCaseMapping:0x2B04
  ,simpleTitleCaseMapping:0x2B04
 },
 { code:0x2B05
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B05
  ,simpleLowerCaseMapping:0x2B05
  ,simpleTitleCaseMapping:0x2B05
 },
 { code:0x2B06
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B06
  ,simpleLowerCaseMapping:0x2B06
  ,simpleTitleCaseMapping:0x2B06
 },
 { code:0x2B07
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B07
  ,simpleLowerCaseMapping:0x2B07
  ,simpleTitleCaseMapping:0x2B07
 },
 { code:0x2B08
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B08
  ,simpleLowerCaseMapping:0x2B08
  ,simpleTitleCaseMapping:0x2B08
 },
 { code:0x2B09
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B09
  ,simpleLowerCaseMapping:0x2B09
  ,simpleTitleCaseMapping:0x2B09
 },
 { code:0x2B0A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B0A
  ,simpleLowerCaseMapping:0x2B0A
  ,simpleTitleCaseMapping:0x2B0A
 },
 { code:0x2B0B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B0B
  ,simpleLowerCaseMapping:0x2B0B
  ,simpleTitleCaseMapping:0x2B0B
 },
 { code:0x2B0C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B0C
  ,simpleLowerCaseMapping:0x2B0C
  ,simpleTitleCaseMapping:0x2B0C
 },
 { code:0x2B0D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B0D
  ,simpleLowerCaseMapping:0x2B0D
  ,simpleTitleCaseMapping:0x2B0D
 },
 { code:0x2B0E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B0E
  ,simpleLowerCaseMapping:0x2B0E
  ,simpleTitleCaseMapping:0x2B0E
 },
 { code:0x2B0F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B0F
  ,simpleLowerCaseMapping:0x2B0F
  ,simpleTitleCaseMapping:0x2B0F
 },
 { code:0x2B10
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B10
  ,simpleLowerCaseMapping:0x2B10
  ,simpleTitleCaseMapping:0x2B10
 },
 { code:0x2B11
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B11
  ,simpleLowerCaseMapping:0x2B11
  ,simpleTitleCaseMapping:0x2B11
 },
 { code:0x2B12
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B12
  ,simpleLowerCaseMapping:0x2B12
  ,simpleTitleCaseMapping:0x2B12
 },
 { code:0x2B13
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B13
  ,simpleLowerCaseMapping:0x2B13
  ,simpleTitleCaseMapping:0x2B13
 },
 { code:0x2B14
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B14
  ,simpleLowerCaseMapping:0x2B14
  ,simpleTitleCaseMapping:0x2B14
 },
 { code:0x2B15
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B15
  ,simpleLowerCaseMapping:0x2B15
  ,simpleTitleCaseMapping:0x2B15
 },
 { code:0x2B16
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B16
  ,simpleLowerCaseMapping:0x2B16
  ,simpleTitleCaseMapping:0x2B16
 },
 { code:0x2B17
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B17
  ,simpleLowerCaseMapping:0x2B17
  ,simpleTitleCaseMapping:0x2B17
 },
 { code:0x2B18
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B18
  ,simpleLowerCaseMapping:0x2B18
  ,simpleTitleCaseMapping:0x2B18
 },
 { code:0x2B19
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B19
  ,simpleLowerCaseMapping:0x2B19
  ,simpleTitleCaseMapping:0x2B19
 },
 { code:0x2B1A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B1A
  ,simpleLowerCaseMapping:0x2B1A
  ,simpleTitleCaseMapping:0x2B1A
 },
 { code:0x2B20
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B20
  ,simpleLowerCaseMapping:0x2B20
  ,simpleTitleCaseMapping:0x2B20
 },
 { code:0x2B21
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B21
  ,simpleLowerCaseMapping:0x2B21
  ,simpleTitleCaseMapping:0x2B21
 },
 { code:0x2B22
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B22
  ,simpleLowerCaseMapping:0x2B22
  ,simpleTitleCaseMapping:0x2B22
 },
 { code:0x2B23
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2B23
  ,simpleLowerCaseMapping:0x2B23
  ,simpleTitleCaseMapping:0x2B23
 },
 { code:0x2C00
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C00
  ,simpleLowerCaseMapping:0x2C30
  ,simpleTitleCaseMapping:0x2C00
 },
 { code:0x2C01
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C01
  ,simpleLowerCaseMapping:0x2C31
  ,simpleTitleCaseMapping:0x2C01
 },
 { code:0x2C02
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C02
  ,simpleLowerCaseMapping:0x2C32
  ,simpleTitleCaseMapping:0x2C02
 },
 { code:0x2C03
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C03
  ,simpleLowerCaseMapping:0x2C33
  ,simpleTitleCaseMapping:0x2C03
 },
 { code:0x2C04
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C04
  ,simpleLowerCaseMapping:0x2C34
  ,simpleTitleCaseMapping:0x2C04
 },
 { code:0x2C05
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C05
  ,simpleLowerCaseMapping:0x2C35
  ,simpleTitleCaseMapping:0x2C05
 },
 { code:0x2C06
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C06
  ,simpleLowerCaseMapping:0x2C36
  ,simpleTitleCaseMapping:0x2C06
 },
 { code:0x2C07
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C07
  ,simpleLowerCaseMapping:0x2C37
  ,simpleTitleCaseMapping:0x2C07
 },
 { code:0x2C08
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C08
  ,simpleLowerCaseMapping:0x2C38
  ,simpleTitleCaseMapping:0x2C08
 },
 { code:0x2C09
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C09
  ,simpleLowerCaseMapping:0x2C39
  ,simpleTitleCaseMapping:0x2C09
 },
 { code:0x2C0A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C0A
  ,simpleLowerCaseMapping:0x2C3A
  ,simpleTitleCaseMapping:0x2C0A
 },
 { code:0x2C0B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C0B
  ,simpleLowerCaseMapping:0x2C3B
  ,simpleTitleCaseMapping:0x2C0B
 },
 { code:0x2C0C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C0C
  ,simpleLowerCaseMapping:0x2C3C
  ,simpleTitleCaseMapping:0x2C0C
 },
 { code:0x2C0D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C0D
  ,simpleLowerCaseMapping:0x2C3D
  ,simpleTitleCaseMapping:0x2C0D
 },
 { code:0x2C0E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C0E
  ,simpleLowerCaseMapping:0x2C3E
  ,simpleTitleCaseMapping:0x2C0E
 },
 { code:0x2C0F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C0F
  ,simpleLowerCaseMapping:0x2C3F
  ,simpleTitleCaseMapping:0x2C0F
 },
 { code:0x2C10
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C10
  ,simpleLowerCaseMapping:0x2C40
  ,simpleTitleCaseMapping:0x2C10
 },
 { code:0x2C11
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C11
  ,simpleLowerCaseMapping:0x2C41
  ,simpleTitleCaseMapping:0x2C11
 },
 { code:0x2C12
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C12
  ,simpleLowerCaseMapping:0x2C42
  ,simpleTitleCaseMapping:0x2C12
 },
 { code:0x2C13
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C13
  ,simpleLowerCaseMapping:0x2C43
  ,simpleTitleCaseMapping:0x2C13
 },
 { code:0x2C14
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C14
  ,simpleLowerCaseMapping:0x2C44
  ,simpleTitleCaseMapping:0x2C14
 },
 { code:0x2C15
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C15
  ,simpleLowerCaseMapping:0x2C45
  ,simpleTitleCaseMapping:0x2C15
 },
 { code:0x2C16
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C16
  ,simpleLowerCaseMapping:0x2C46
  ,simpleTitleCaseMapping:0x2C16
 },
 { code:0x2C17
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C17
  ,simpleLowerCaseMapping:0x2C47
  ,simpleTitleCaseMapping:0x2C17
 },
 { code:0x2C18
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C18
  ,simpleLowerCaseMapping:0x2C48
  ,simpleTitleCaseMapping:0x2C18
 },
 { code:0x2C19
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C19
  ,simpleLowerCaseMapping:0x2C49
  ,simpleTitleCaseMapping:0x2C19
 },
 { code:0x2C1A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C1A
  ,simpleLowerCaseMapping:0x2C4A
  ,simpleTitleCaseMapping:0x2C1A
 },
 { code:0x2C1B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C1B
  ,simpleLowerCaseMapping:0x2C4B
  ,simpleTitleCaseMapping:0x2C1B
 },
 { code:0x2C1C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C1C
  ,simpleLowerCaseMapping:0x2C4C
  ,simpleTitleCaseMapping:0x2C1C
 },
 { code:0x2C1D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C1D
  ,simpleLowerCaseMapping:0x2C4D
  ,simpleTitleCaseMapping:0x2C1D
 },
 { code:0x2C1E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C1E
  ,simpleLowerCaseMapping:0x2C4E
  ,simpleTitleCaseMapping:0x2C1E
 },
 { code:0x2C1F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C1F
  ,simpleLowerCaseMapping:0x2C4F
  ,simpleTitleCaseMapping:0x2C1F
 },
 { code:0x2C20
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C20
  ,simpleLowerCaseMapping:0x2C50
  ,simpleTitleCaseMapping:0x2C20
 },
 { code:0x2C21
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C21
  ,simpleLowerCaseMapping:0x2C51
  ,simpleTitleCaseMapping:0x2C21
 },
 { code:0x2C22
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C22
  ,simpleLowerCaseMapping:0x2C52
  ,simpleTitleCaseMapping:0x2C22
 },
 { code:0x2C23
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C23
  ,simpleLowerCaseMapping:0x2C53
  ,simpleTitleCaseMapping:0x2C23
 },
 { code:0x2C24
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C24
  ,simpleLowerCaseMapping:0x2C54
  ,simpleTitleCaseMapping:0x2C24
 },
 { code:0x2C25
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C25
  ,simpleLowerCaseMapping:0x2C55
  ,simpleTitleCaseMapping:0x2C25
 },
 { code:0x2C26
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C26
  ,simpleLowerCaseMapping:0x2C56
  ,simpleTitleCaseMapping:0x2C26
 },
 { code:0x2C27
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C27
  ,simpleLowerCaseMapping:0x2C57
  ,simpleTitleCaseMapping:0x2C27
 },
 { code:0x2C28
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C28
  ,simpleLowerCaseMapping:0x2C58
  ,simpleTitleCaseMapping:0x2C28
 },
 { code:0x2C29
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C29
  ,simpleLowerCaseMapping:0x2C59
  ,simpleTitleCaseMapping:0x2C29
 },
 { code:0x2C2A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C2A
  ,simpleLowerCaseMapping:0x2C5A
  ,simpleTitleCaseMapping:0x2C2A
 },
 { code:0x2C2B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C2B
  ,simpleLowerCaseMapping:0x2C5B
  ,simpleTitleCaseMapping:0x2C2B
 },
 { code:0x2C2C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C2C
  ,simpleLowerCaseMapping:0x2C5C
  ,simpleTitleCaseMapping:0x2C2C
 },
 { code:0x2C2D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C2D
  ,simpleLowerCaseMapping:0x2C5D
  ,simpleTitleCaseMapping:0x2C2D
 },
 { code:0x2C2E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C2E
  ,simpleLowerCaseMapping:0x2C5E
  ,simpleTitleCaseMapping:0x2C2E
 },
 { code:0x2C30
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C00
  ,simpleLowerCaseMapping:0x2C30
  ,simpleTitleCaseMapping:0x2C00
 },
 { code:0x2C31
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C01
  ,simpleLowerCaseMapping:0x2C31
  ,simpleTitleCaseMapping:0x2C01
 },
 { code:0x2C32
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C02
  ,simpleLowerCaseMapping:0x2C32
  ,simpleTitleCaseMapping:0x2C02
 },
 { code:0x2C33
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C03
  ,simpleLowerCaseMapping:0x2C33
  ,simpleTitleCaseMapping:0x2C03
 },
 { code:0x2C34
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C04
  ,simpleLowerCaseMapping:0x2C34
  ,simpleTitleCaseMapping:0x2C04
 },
 { code:0x2C35
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C05
  ,simpleLowerCaseMapping:0x2C35
  ,simpleTitleCaseMapping:0x2C05
 },
 { code:0x2C36
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C06
  ,simpleLowerCaseMapping:0x2C36
  ,simpleTitleCaseMapping:0x2C06
 },
 { code:0x2C37
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C07
  ,simpleLowerCaseMapping:0x2C37
  ,simpleTitleCaseMapping:0x2C07
 },
 { code:0x2C38
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C08
  ,simpleLowerCaseMapping:0x2C38
  ,simpleTitleCaseMapping:0x2C08
 },
 { code:0x2C39
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C09
  ,simpleLowerCaseMapping:0x2C39
  ,simpleTitleCaseMapping:0x2C09
 },
 { code:0x2C3A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C0A
  ,simpleLowerCaseMapping:0x2C3A
  ,simpleTitleCaseMapping:0x2C0A
 },
 { code:0x2C3B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C0B
  ,simpleLowerCaseMapping:0x2C3B
  ,simpleTitleCaseMapping:0x2C0B
 },
 { code:0x2C3C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C0C
  ,simpleLowerCaseMapping:0x2C3C
  ,simpleTitleCaseMapping:0x2C0C
 },
 { code:0x2C3D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C0D
  ,simpleLowerCaseMapping:0x2C3D
  ,simpleTitleCaseMapping:0x2C0D
 },
 { code:0x2C3E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C0E
  ,simpleLowerCaseMapping:0x2C3E
  ,simpleTitleCaseMapping:0x2C0E
 },
 { code:0x2C3F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C0F
  ,simpleLowerCaseMapping:0x2C3F
  ,simpleTitleCaseMapping:0x2C0F
 },
 { code:0x2C40
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C10
  ,simpleLowerCaseMapping:0x2C40
  ,simpleTitleCaseMapping:0x2C10
 },
 { code:0x2C41
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C11
  ,simpleLowerCaseMapping:0x2C41
  ,simpleTitleCaseMapping:0x2C11
 },
 { code:0x2C42
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C12
  ,simpleLowerCaseMapping:0x2C42
  ,simpleTitleCaseMapping:0x2C12
 },
 { code:0x2C43
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C13
  ,simpleLowerCaseMapping:0x2C43
  ,simpleTitleCaseMapping:0x2C13
 },
 { code:0x2C44
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C14
  ,simpleLowerCaseMapping:0x2C44
  ,simpleTitleCaseMapping:0x2C14
 },
 { code:0x2C45
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C15
  ,simpleLowerCaseMapping:0x2C45
  ,simpleTitleCaseMapping:0x2C15
 },
 { code:0x2C46
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C16
  ,simpleLowerCaseMapping:0x2C46
  ,simpleTitleCaseMapping:0x2C16
 },
 { code:0x2C47
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C17
  ,simpleLowerCaseMapping:0x2C47
  ,simpleTitleCaseMapping:0x2C17
 },
 { code:0x2C48
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C18
  ,simpleLowerCaseMapping:0x2C48
  ,simpleTitleCaseMapping:0x2C18
 },
 { code:0x2C49
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C19
  ,simpleLowerCaseMapping:0x2C49
  ,simpleTitleCaseMapping:0x2C19
 },
 { code:0x2C4A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C1A
  ,simpleLowerCaseMapping:0x2C4A
  ,simpleTitleCaseMapping:0x2C1A
 },
 { code:0x2C4B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C1B
  ,simpleLowerCaseMapping:0x2C4B
  ,simpleTitleCaseMapping:0x2C1B
 },
 { code:0x2C4C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C1C
  ,simpleLowerCaseMapping:0x2C4C
  ,simpleTitleCaseMapping:0x2C1C
 },
 { code:0x2C4D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C1D
  ,simpleLowerCaseMapping:0x2C4D
  ,simpleTitleCaseMapping:0x2C1D
 },
 { code:0x2C4E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C1E
  ,simpleLowerCaseMapping:0x2C4E
  ,simpleTitleCaseMapping:0x2C1E
 },
 { code:0x2C4F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C1F
  ,simpleLowerCaseMapping:0x2C4F
  ,simpleTitleCaseMapping:0x2C1F
 },
 { code:0x2C50
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C20
  ,simpleLowerCaseMapping:0x2C50
  ,simpleTitleCaseMapping:0x2C20
 },
 { code:0x2C51
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C21
  ,simpleLowerCaseMapping:0x2C51
  ,simpleTitleCaseMapping:0x2C21
 },
 { code:0x2C52
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C22
  ,simpleLowerCaseMapping:0x2C52
  ,simpleTitleCaseMapping:0x2C22
 },
 { code:0x2C53
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C23
  ,simpleLowerCaseMapping:0x2C53
  ,simpleTitleCaseMapping:0x2C23
 },
 { code:0x2C54
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C24
  ,simpleLowerCaseMapping:0x2C54
  ,simpleTitleCaseMapping:0x2C24
 },
 { code:0x2C55
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C25
  ,simpleLowerCaseMapping:0x2C55
  ,simpleTitleCaseMapping:0x2C25
 },
 { code:0x2C56
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C26
  ,simpleLowerCaseMapping:0x2C56
  ,simpleTitleCaseMapping:0x2C26
 },
 { code:0x2C57
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C27
  ,simpleLowerCaseMapping:0x2C57
  ,simpleTitleCaseMapping:0x2C27
 },
 { code:0x2C58
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C28
  ,simpleLowerCaseMapping:0x2C58
  ,simpleTitleCaseMapping:0x2C28
 },
 { code:0x2C59
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C29
  ,simpleLowerCaseMapping:0x2C59
  ,simpleTitleCaseMapping:0x2C29
 },
 { code:0x2C5A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C2A
  ,simpleLowerCaseMapping:0x2C5A
  ,simpleTitleCaseMapping:0x2C2A
 },
 { code:0x2C5B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C2B
  ,simpleLowerCaseMapping:0x2C5B
  ,simpleTitleCaseMapping:0x2C2B
 },
 { code:0x2C5C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C2C
  ,simpleLowerCaseMapping:0x2C5C
  ,simpleTitleCaseMapping:0x2C2C
 },
 { code:0x2C5D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C2D
  ,simpleLowerCaseMapping:0x2C5D
  ,simpleTitleCaseMapping:0x2C2D
 },
 { code:0x2C5E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C2E
  ,simpleLowerCaseMapping:0x2C5E
  ,simpleTitleCaseMapping:0x2C2E
 },
 { code:0x2C60
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C60
  ,simpleLowerCaseMapping:0x2C61
  ,simpleTitleCaseMapping:0x2C60
 },
 { code:0x2C61
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C60
  ,simpleLowerCaseMapping:0x2C61
  ,simpleTitleCaseMapping:0x2C60
 },
 { code:0x2C62
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C62
  ,simpleLowerCaseMapping:0x026B
  ,simpleTitleCaseMapping:0x2C62
 },
 { code:0x2C63
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C63
  ,simpleLowerCaseMapping:0x1D7D
  ,simpleTitleCaseMapping:0x2C63
 },
 { code:0x2C64
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C64
  ,simpleLowerCaseMapping:0x027D
  ,simpleTitleCaseMapping:0x2C64
 },
 { code:0x2C65
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x023A
  ,simpleLowerCaseMapping:0x2C65
  ,simpleTitleCaseMapping:0x023A
 },
 { code:0x2C66
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x023E
  ,simpleLowerCaseMapping:0x2C66
  ,simpleTitleCaseMapping:0x023E
 },
 { code:0x2C67
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C67
  ,simpleLowerCaseMapping:0x2C68
  ,simpleTitleCaseMapping:0x2C67
 },
 { code:0x2C68
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C67
  ,simpleLowerCaseMapping:0x2C68
  ,simpleTitleCaseMapping:0x2C67
 },
 { code:0x2C69
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C69
  ,simpleLowerCaseMapping:0x2C6A
  ,simpleTitleCaseMapping:0x2C69
 },
 { code:0x2C6A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C69
  ,simpleLowerCaseMapping:0x2C6A
  ,simpleTitleCaseMapping:0x2C69
 },
 { code:0x2C6B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C6B
  ,simpleLowerCaseMapping:0x2C6C
  ,simpleTitleCaseMapping:0x2C6B
 },
 { code:0x2C6C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C6B
  ,simpleLowerCaseMapping:0x2C6C
  ,simpleTitleCaseMapping:0x2C6B
 },
 { code:0x2C74
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C74
  ,simpleLowerCaseMapping:0x2C74
  ,simpleTitleCaseMapping:0x2C74
 },
 { code:0x2C75
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C75
  ,simpleLowerCaseMapping:0x2C76
  ,simpleTitleCaseMapping:0x2C75
 },
 { code:0x2C76
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C75
  ,simpleLowerCaseMapping:0x2C76
  ,simpleTitleCaseMapping:0x2C75
 },
 { code:0x2C77
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C77
  ,simpleLowerCaseMapping:0x2C77
  ,simpleTitleCaseMapping:0x2C77
 },
 { code:0x2C80
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C80
  ,simpleLowerCaseMapping:0x2C81
  ,simpleTitleCaseMapping:0x2C80
 },
 { code:0x2C81
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C80
  ,simpleLowerCaseMapping:0x2C81
  ,simpleTitleCaseMapping:0x2C80
 },
 { code:0x2C82
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C82
  ,simpleLowerCaseMapping:0x2C83
  ,simpleTitleCaseMapping:0x2C82
 },
 { code:0x2C83
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C82
  ,simpleLowerCaseMapping:0x2C83
  ,simpleTitleCaseMapping:0x2C82
 },
 { code:0x2C84
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C84
  ,simpleLowerCaseMapping:0x2C85
  ,simpleTitleCaseMapping:0x2C84
 },
 { code:0x2C85
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C84
  ,simpleLowerCaseMapping:0x2C85
  ,simpleTitleCaseMapping:0x2C84
 },
 { code:0x2C86
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C86
  ,simpleLowerCaseMapping:0x2C87
  ,simpleTitleCaseMapping:0x2C86
 },
 { code:0x2C87
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C86
  ,simpleLowerCaseMapping:0x2C87
  ,simpleTitleCaseMapping:0x2C86
 },
 { code:0x2C88
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C88
  ,simpleLowerCaseMapping:0x2C89
  ,simpleTitleCaseMapping:0x2C88
 },
 { code:0x2C89
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C88
  ,simpleLowerCaseMapping:0x2C89
  ,simpleTitleCaseMapping:0x2C88
 },
 { code:0x2C8A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C8A
  ,simpleLowerCaseMapping:0x2C8B
  ,simpleTitleCaseMapping:0x2C8A
 },
 { code:0x2C8B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C8A
  ,simpleLowerCaseMapping:0x2C8B
  ,simpleTitleCaseMapping:0x2C8A
 },
 { code:0x2C8C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C8C
  ,simpleLowerCaseMapping:0x2C8D
  ,simpleTitleCaseMapping:0x2C8C
 },
 { code:0x2C8D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C8C
  ,simpleLowerCaseMapping:0x2C8D
  ,simpleTitleCaseMapping:0x2C8C
 },
 { code:0x2C8E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C8E
  ,simpleLowerCaseMapping:0x2C8F
  ,simpleTitleCaseMapping:0x2C8E
 },
 { code:0x2C8F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C8E
  ,simpleLowerCaseMapping:0x2C8F
  ,simpleTitleCaseMapping:0x2C8E
 },
 { code:0x2C90
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C90
  ,simpleLowerCaseMapping:0x2C91
  ,simpleTitleCaseMapping:0x2C90
 },
 { code:0x2C91
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C90
  ,simpleLowerCaseMapping:0x2C91
  ,simpleTitleCaseMapping:0x2C90
 },
 { code:0x2C92
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C92
  ,simpleLowerCaseMapping:0x2C93
  ,simpleTitleCaseMapping:0x2C92
 },
 { code:0x2C93
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C92
  ,simpleLowerCaseMapping:0x2C93
  ,simpleTitleCaseMapping:0x2C92
 },
 { code:0x2C94
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C94
  ,simpleLowerCaseMapping:0x2C95
  ,simpleTitleCaseMapping:0x2C94
 },
 { code:0x2C95
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C94
  ,simpleLowerCaseMapping:0x2C95
  ,simpleTitleCaseMapping:0x2C94
 },
 { code:0x2C96
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C96
  ,simpleLowerCaseMapping:0x2C97
  ,simpleTitleCaseMapping:0x2C96
 },
 { code:0x2C97
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C96
  ,simpleLowerCaseMapping:0x2C97
  ,simpleTitleCaseMapping:0x2C96
 },
 { code:0x2C98
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C98
  ,simpleLowerCaseMapping:0x2C99
  ,simpleTitleCaseMapping:0x2C98
 },
 { code:0x2C99
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C98
  ,simpleLowerCaseMapping:0x2C99
  ,simpleTitleCaseMapping:0x2C98
 },
 { code:0x2C9A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C9A
  ,simpleLowerCaseMapping:0x2C9B
  ,simpleTitleCaseMapping:0x2C9A
 },
 { code:0x2C9B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C9A
  ,simpleLowerCaseMapping:0x2C9B
  ,simpleTitleCaseMapping:0x2C9A
 },
 { code:0x2C9C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C9C
  ,simpleLowerCaseMapping:0x2C9D
  ,simpleTitleCaseMapping:0x2C9C
 },
 { code:0x2C9D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C9C
  ,simpleLowerCaseMapping:0x2C9D
  ,simpleTitleCaseMapping:0x2C9C
 },
 { code:0x2C9E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2C9E
  ,simpleLowerCaseMapping:0x2C9F
  ,simpleTitleCaseMapping:0x2C9E
 },
 { code:0x2C9F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2C9E
  ,simpleLowerCaseMapping:0x2C9F
  ,simpleTitleCaseMapping:0x2C9E
 },
 { code:0x2CA0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CA0
  ,simpleLowerCaseMapping:0x2CA1
  ,simpleTitleCaseMapping:0x2CA0
 },
 { code:0x2CA1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CA0
  ,simpleLowerCaseMapping:0x2CA1
  ,simpleTitleCaseMapping:0x2CA0
 },
 { code:0x2CA2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CA2
  ,simpleLowerCaseMapping:0x2CA3
  ,simpleTitleCaseMapping:0x2CA2
 },
 { code:0x2CA3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CA2
  ,simpleLowerCaseMapping:0x2CA3
  ,simpleTitleCaseMapping:0x2CA2
 },
 { code:0x2CA4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CA4
  ,simpleLowerCaseMapping:0x2CA5
  ,simpleTitleCaseMapping:0x2CA4
 },
 { code:0x2CA5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CA4
  ,simpleLowerCaseMapping:0x2CA5
  ,simpleTitleCaseMapping:0x2CA4
 },
 { code:0x2CA6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CA6
  ,simpleLowerCaseMapping:0x2CA7
  ,simpleTitleCaseMapping:0x2CA6
 },
 { code:0x2CA7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CA6
  ,simpleLowerCaseMapping:0x2CA7
  ,simpleTitleCaseMapping:0x2CA6
 },
 { code:0x2CA8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CA8
  ,simpleLowerCaseMapping:0x2CA9
  ,simpleTitleCaseMapping:0x2CA8
 },
 { code:0x2CA9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CA8
  ,simpleLowerCaseMapping:0x2CA9
  ,simpleTitleCaseMapping:0x2CA8
 },
 { code:0x2CAA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CAA
  ,simpleLowerCaseMapping:0x2CAB
  ,simpleTitleCaseMapping:0x2CAA
 },
 { code:0x2CAB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CAA
  ,simpleLowerCaseMapping:0x2CAB
  ,simpleTitleCaseMapping:0x2CAA
 },
 { code:0x2CAC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CAC
  ,simpleLowerCaseMapping:0x2CAD
  ,simpleTitleCaseMapping:0x2CAC
 },
 { code:0x2CAD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CAC
  ,simpleLowerCaseMapping:0x2CAD
  ,simpleTitleCaseMapping:0x2CAC
 },
 { code:0x2CAE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CAE
  ,simpleLowerCaseMapping:0x2CAF
  ,simpleTitleCaseMapping:0x2CAE
 },
 { code:0x2CAF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CAE
  ,simpleLowerCaseMapping:0x2CAF
  ,simpleTitleCaseMapping:0x2CAE
 },
 { code:0x2CB0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CB0
  ,simpleLowerCaseMapping:0x2CB1
  ,simpleTitleCaseMapping:0x2CB0
 },
 { code:0x2CB1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CB0
  ,simpleLowerCaseMapping:0x2CB1
  ,simpleTitleCaseMapping:0x2CB0
 },
 { code:0x2CB2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CB2
  ,simpleLowerCaseMapping:0x2CB3
  ,simpleTitleCaseMapping:0x2CB2
 },
 { code:0x2CB3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CB2
  ,simpleLowerCaseMapping:0x2CB3
  ,simpleTitleCaseMapping:0x2CB2
 },
 { code:0x2CB4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CB4
  ,simpleLowerCaseMapping:0x2CB5
  ,simpleTitleCaseMapping:0x2CB4
 },
 { code:0x2CB5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CB4
  ,simpleLowerCaseMapping:0x2CB5
  ,simpleTitleCaseMapping:0x2CB4
 },
 { code:0x2CB6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CB6
  ,simpleLowerCaseMapping:0x2CB7
  ,simpleTitleCaseMapping:0x2CB6
 },
 { code:0x2CB7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CB6
  ,simpleLowerCaseMapping:0x2CB7
  ,simpleTitleCaseMapping:0x2CB6
 },
 { code:0x2CB8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CB8
  ,simpleLowerCaseMapping:0x2CB9
  ,simpleTitleCaseMapping:0x2CB8
 },
 { code:0x2CB9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CB8
  ,simpleLowerCaseMapping:0x2CB9
  ,simpleTitleCaseMapping:0x2CB8
 },
 { code:0x2CBA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CBA
  ,simpleLowerCaseMapping:0x2CBB
  ,simpleTitleCaseMapping:0x2CBA
 },
 { code:0x2CBB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CBA
  ,simpleLowerCaseMapping:0x2CBB
  ,simpleTitleCaseMapping:0x2CBA
 },
 { code:0x2CBC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CBC
  ,simpleLowerCaseMapping:0x2CBD
  ,simpleTitleCaseMapping:0x2CBC
 },
 { code:0x2CBD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CBC
  ,simpleLowerCaseMapping:0x2CBD
  ,simpleTitleCaseMapping:0x2CBC
 },
 { code:0x2CBE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CBE
  ,simpleLowerCaseMapping:0x2CBF
  ,simpleTitleCaseMapping:0x2CBE
 },
 { code:0x2CBF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CBE
  ,simpleLowerCaseMapping:0x2CBF
  ,simpleTitleCaseMapping:0x2CBE
 },
 { code:0x2CC0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CC0
  ,simpleLowerCaseMapping:0x2CC1
  ,simpleTitleCaseMapping:0x2CC0
 },
 { code:0x2CC1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CC0
  ,simpleLowerCaseMapping:0x2CC1
  ,simpleTitleCaseMapping:0x2CC0
 },
 { code:0x2CC2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CC2
  ,simpleLowerCaseMapping:0x2CC3
  ,simpleTitleCaseMapping:0x2CC2
 },
 { code:0x2CC3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CC2
  ,simpleLowerCaseMapping:0x2CC3
  ,simpleTitleCaseMapping:0x2CC2
 },
 { code:0x2CC4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CC4
  ,simpleLowerCaseMapping:0x2CC5
  ,simpleTitleCaseMapping:0x2CC4
 },
 { code:0x2CC5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CC4
  ,simpleLowerCaseMapping:0x2CC5
  ,simpleTitleCaseMapping:0x2CC4
 },
 { code:0x2CC6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CC6
  ,simpleLowerCaseMapping:0x2CC7
  ,simpleTitleCaseMapping:0x2CC6
 },
 { code:0x2CC7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CC6
  ,simpleLowerCaseMapping:0x2CC7
  ,simpleTitleCaseMapping:0x2CC6
 },
 { code:0x2CC8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CC8
  ,simpleLowerCaseMapping:0x2CC9
  ,simpleTitleCaseMapping:0x2CC8
 },
 { code:0x2CC9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CC8
  ,simpleLowerCaseMapping:0x2CC9
  ,simpleTitleCaseMapping:0x2CC8
 },
 { code:0x2CCA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CCA
  ,simpleLowerCaseMapping:0x2CCB
  ,simpleTitleCaseMapping:0x2CCA
 },
 { code:0x2CCB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CCA
  ,simpleLowerCaseMapping:0x2CCB
  ,simpleTitleCaseMapping:0x2CCA
 },
 { code:0x2CCC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CCC
  ,simpleLowerCaseMapping:0x2CCD
  ,simpleTitleCaseMapping:0x2CCC
 },
 { code:0x2CCD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CCC
  ,simpleLowerCaseMapping:0x2CCD
  ,simpleTitleCaseMapping:0x2CCC
 },
 { code:0x2CCE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CCE
  ,simpleLowerCaseMapping:0x2CCF
  ,simpleTitleCaseMapping:0x2CCE
 },
 { code:0x2CCF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CCE
  ,simpleLowerCaseMapping:0x2CCF
  ,simpleTitleCaseMapping:0x2CCE
 },
 { code:0x2CD0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CD0
  ,simpleLowerCaseMapping:0x2CD1
  ,simpleTitleCaseMapping:0x2CD0
 },
 { code:0x2CD1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CD0
  ,simpleLowerCaseMapping:0x2CD1
  ,simpleTitleCaseMapping:0x2CD0
 },
 { code:0x2CD2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CD2
  ,simpleLowerCaseMapping:0x2CD3
  ,simpleTitleCaseMapping:0x2CD2
 },
 { code:0x2CD3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CD2
  ,simpleLowerCaseMapping:0x2CD3
  ,simpleTitleCaseMapping:0x2CD2
 },
 { code:0x2CD4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CD4
  ,simpleLowerCaseMapping:0x2CD5
  ,simpleTitleCaseMapping:0x2CD4
 },
 { code:0x2CD5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CD4
  ,simpleLowerCaseMapping:0x2CD5
  ,simpleTitleCaseMapping:0x2CD4
 },
 { code:0x2CD6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CD6
  ,simpleLowerCaseMapping:0x2CD7
  ,simpleTitleCaseMapping:0x2CD6
 },
 { code:0x2CD7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CD6
  ,simpleLowerCaseMapping:0x2CD7
  ,simpleTitleCaseMapping:0x2CD6
 },
 { code:0x2CD8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CD8
  ,simpleLowerCaseMapping:0x2CD9
  ,simpleTitleCaseMapping:0x2CD8
 },
 { code:0x2CD9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CD8
  ,simpleLowerCaseMapping:0x2CD9
  ,simpleTitleCaseMapping:0x2CD8
 },
 { code:0x2CDA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CDA
  ,simpleLowerCaseMapping:0x2CDB
  ,simpleTitleCaseMapping:0x2CDA
 },
 { code:0x2CDB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CDA
  ,simpleLowerCaseMapping:0x2CDB
  ,simpleTitleCaseMapping:0x2CDA
 },
 { code:0x2CDC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CDC
  ,simpleLowerCaseMapping:0x2CDD
  ,simpleTitleCaseMapping:0x2CDC
 },
 { code:0x2CDD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CDC
  ,simpleLowerCaseMapping:0x2CDD
  ,simpleTitleCaseMapping:0x2CDC
 },
 { code:0x2CDE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CDE
  ,simpleLowerCaseMapping:0x2CDF
  ,simpleTitleCaseMapping:0x2CDE
 },
 { code:0x2CDF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CDE
  ,simpleLowerCaseMapping:0x2CDF
  ,simpleTitleCaseMapping:0x2CDE
 },
 { code:0x2CE0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CE0
  ,simpleLowerCaseMapping:0x2CE1
  ,simpleTitleCaseMapping:0x2CE0
 },
 { code:0x2CE1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CE0
  ,simpleLowerCaseMapping:0x2CE1
  ,simpleTitleCaseMapping:0x2CE0
 },
 { code:0x2CE2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x2CE2
  ,simpleLowerCaseMapping:0x2CE3
  ,simpleTitleCaseMapping:0x2CE2
 },
 { code:0x2CE3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CE2
  ,simpleLowerCaseMapping:0x2CE3
  ,simpleTitleCaseMapping:0x2CE2
 },
 { code:0x2CE4
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x2CE4
  ,simpleLowerCaseMapping:0x2CE4
  ,simpleTitleCaseMapping:0x2CE4
 },
 { code:0x2CE5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2CE5
  ,simpleLowerCaseMapping:0x2CE5
  ,simpleTitleCaseMapping:0x2CE5
 },
 { code:0x2CE6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2CE6
  ,simpleLowerCaseMapping:0x2CE6
  ,simpleTitleCaseMapping:0x2CE6
 },
 { code:0x2CE7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2CE7
  ,simpleLowerCaseMapping:0x2CE7
  ,simpleTitleCaseMapping:0x2CE7
 },
 { code:0x2CE8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2CE8
  ,simpleLowerCaseMapping:0x2CE8
  ,simpleTitleCaseMapping:0x2CE8
 },
 { code:0x2CE9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2CE9
  ,simpleLowerCaseMapping:0x2CE9
  ,simpleTitleCaseMapping:0x2CE9
 },
 { code:0x2CEA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2CEA
  ,simpleLowerCaseMapping:0x2CEA
  ,simpleTitleCaseMapping:0x2CEA
 },
 { code:0x2CF9
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2CF9
  ,simpleLowerCaseMapping:0x2CF9
  ,simpleTitleCaseMapping:0x2CF9
 },
 { code:0x2CFA
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2CFA
  ,simpleLowerCaseMapping:0x2CFA
  ,simpleTitleCaseMapping:0x2CFA
 },
 { code:0x2CFB
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2CFB
  ,simpleLowerCaseMapping:0x2CFB
  ,simpleTitleCaseMapping:0x2CFB
 },
 { code:0x2CFC
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2CFC
  ,simpleLowerCaseMapping:0x2CFC
  ,simpleTitleCaseMapping:0x2CFC
 },
 { code:0x2CFD
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x2CFD
  ,simpleLowerCaseMapping:0x2CFD
  ,simpleTitleCaseMapping:0x2CFD
 },
 { code:0x2CFE
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2CFE
  ,simpleLowerCaseMapping:0x2CFE
  ,simpleTitleCaseMapping:0x2CFE
 },
 { code:0x2CFF
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2CFF
  ,simpleLowerCaseMapping:0x2CFF
  ,simpleTitleCaseMapping:0x2CFF
 },
 { code:0x2D00
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10A0
  ,simpleLowerCaseMapping:0x2D00
  ,simpleTitleCaseMapping:0x10A0
 },
 { code:0x2D01
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10A1
  ,simpleLowerCaseMapping:0x2D01
  ,simpleTitleCaseMapping:0x10A1
 },
 { code:0x2D02
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10A2
  ,simpleLowerCaseMapping:0x2D02
  ,simpleTitleCaseMapping:0x10A2
 },
 { code:0x2D03
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10A3
  ,simpleLowerCaseMapping:0x2D03
  ,simpleTitleCaseMapping:0x10A3
 },
 { code:0x2D04
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10A4
  ,simpleLowerCaseMapping:0x2D04
  ,simpleTitleCaseMapping:0x10A4
 },
 { code:0x2D05
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10A5
  ,simpleLowerCaseMapping:0x2D05
  ,simpleTitleCaseMapping:0x10A5
 },
 { code:0x2D06
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10A6
  ,simpleLowerCaseMapping:0x2D06
  ,simpleTitleCaseMapping:0x10A6
 },
 { code:0x2D07
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10A7
  ,simpleLowerCaseMapping:0x2D07
  ,simpleTitleCaseMapping:0x10A7
 },
 { code:0x2D08
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10A8
  ,simpleLowerCaseMapping:0x2D08
  ,simpleTitleCaseMapping:0x10A8
 },
 { code:0x2D09
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10A9
  ,simpleLowerCaseMapping:0x2D09
  ,simpleTitleCaseMapping:0x10A9
 },
 { code:0x2D0A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10AA
  ,simpleLowerCaseMapping:0x2D0A
  ,simpleTitleCaseMapping:0x10AA
 },
 { code:0x2D0B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10AB
  ,simpleLowerCaseMapping:0x2D0B
  ,simpleTitleCaseMapping:0x10AB
 },
 { code:0x2D0C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10AC
  ,simpleLowerCaseMapping:0x2D0C
  ,simpleTitleCaseMapping:0x10AC
 },
 { code:0x2D0D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10AD
  ,simpleLowerCaseMapping:0x2D0D
  ,simpleTitleCaseMapping:0x10AD
 },
 { code:0x2D0E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10AE
  ,simpleLowerCaseMapping:0x2D0E
  ,simpleTitleCaseMapping:0x10AE
 },
 { code:0x2D0F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10AF
  ,simpleLowerCaseMapping:0x2D0F
  ,simpleTitleCaseMapping:0x10AF
 },
 { code:0x2D10
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10B0
  ,simpleLowerCaseMapping:0x2D10
  ,simpleTitleCaseMapping:0x10B0
 },
 { code:0x2D11
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10B1
  ,simpleLowerCaseMapping:0x2D11
  ,simpleTitleCaseMapping:0x10B1
 },
 { code:0x2D12
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10B2
  ,simpleLowerCaseMapping:0x2D12
  ,simpleTitleCaseMapping:0x10B2
 },
 { code:0x2D13
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10B3
  ,simpleLowerCaseMapping:0x2D13
  ,simpleTitleCaseMapping:0x10B3
 },
 { code:0x2D14
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10B4
  ,simpleLowerCaseMapping:0x2D14
  ,simpleTitleCaseMapping:0x10B4
 },
 { code:0x2D15
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10B5
  ,simpleLowerCaseMapping:0x2D15
  ,simpleTitleCaseMapping:0x10B5
 },
 { code:0x2D16
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10B6
  ,simpleLowerCaseMapping:0x2D16
  ,simpleTitleCaseMapping:0x10B6
 },
 { code:0x2D17
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10B7
  ,simpleLowerCaseMapping:0x2D17
  ,simpleTitleCaseMapping:0x10B7
 },
 { code:0x2D18
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10B8
  ,simpleLowerCaseMapping:0x2D18
  ,simpleTitleCaseMapping:0x10B8
 },
 { code:0x2D19
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10B9
  ,simpleLowerCaseMapping:0x2D19
  ,simpleTitleCaseMapping:0x10B9
 },
 { code:0x2D1A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10BA
  ,simpleLowerCaseMapping:0x2D1A
  ,simpleTitleCaseMapping:0x10BA
 },
 { code:0x2D1B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10BB
  ,simpleLowerCaseMapping:0x2D1B
  ,simpleTitleCaseMapping:0x10BB
 },
 { code:0x2D1C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10BC
  ,simpleLowerCaseMapping:0x2D1C
  ,simpleTitleCaseMapping:0x10BC
 },
 { code:0x2D1D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10BD
  ,simpleLowerCaseMapping:0x2D1D
  ,simpleTitleCaseMapping:0x10BD
 },
 { code:0x2D1E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10BE
  ,simpleLowerCaseMapping:0x2D1E
  ,simpleTitleCaseMapping:0x10BE
 },
 { code:0x2D1F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10BF
  ,simpleLowerCaseMapping:0x2D1F
  ,simpleTitleCaseMapping:0x10BF
 },
 { code:0x2D20
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10C0
  ,simpleLowerCaseMapping:0x2D20
  ,simpleTitleCaseMapping:0x10C0
 },
 { code:0x2D21
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10C1
  ,simpleLowerCaseMapping:0x2D21
  ,simpleTitleCaseMapping:0x10C1
 },
 { code:0x2D22
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10C2
  ,simpleLowerCaseMapping:0x2D22
  ,simpleTitleCaseMapping:0x10C2
 },
 { code:0x2D23
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10C3
  ,simpleLowerCaseMapping:0x2D23
  ,simpleTitleCaseMapping:0x10C3
 },
 { code:0x2D24
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10C4
  ,simpleLowerCaseMapping:0x2D24
  ,simpleTitleCaseMapping:0x10C4
 },
 { code:0x2D25
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10C5
  ,simpleLowerCaseMapping:0x2D25
  ,simpleTitleCaseMapping:0x10C5
 },
 { code:0x2D30
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D30
  ,simpleLowerCaseMapping:0x2D30
  ,simpleTitleCaseMapping:0x2D30
 },
 { code:0x2D31
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D31
  ,simpleLowerCaseMapping:0x2D31
  ,simpleTitleCaseMapping:0x2D31
 },
 { code:0x2D32
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D32
  ,simpleLowerCaseMapping:0x2D32
  ,simpleTitleCaseMapping:0x2D32
 },
 { code:0x2D33
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D33
  ,simpleLowerCaseMapping:0x2D33
  ,simpleTitleCaseMapping:0x2D33
 },
 { code:0x2D34
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D34
  ,simpleLowerCaseMapping:0x2D34
  ,simpleTitleCaseMapping:0x2D34
 },
 { code:0x2D35
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D35
  ,simpleLowerCaseMapping:0x2D35
  ,simpleTitleCaseMapping:0x2D35
 },
 { code:0x2D36
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D36
  ,simpleLowerCaseMapping:0x2D36
  ,simpleTitleCaseMapping:0x2D36
 },
 { code:0x2D37
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D37
  ,simpleLowerCaseMapping:0x2D37
  ,simpleTitleCaseMapping:0x2D37
 },
 { code:0x2D38
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D38
  ,simpleLowerCaseMapping:0x2D38
  ,simpleTitleCaseMapping:0x2D38
 },
 { code:0x2D39
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D39
  ,simpleLowerCaseMapping:0x2D39
  ,simpleTitleCaseMapping:0x2D39
 },
 { code:0x2D3A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D3A
  ,simpleLowerCaseMapping:0x2D3A
  ,simpleTitleCaseMapping:0x2D3A
 },
 { code:0x2D3B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D3B
  ,simpleLowerCaseMapping:0x2D3B
  ,simpleTitleCaseMapping:0x2D3B
 },
 { code:0x2D3C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D3C
  ,simpleLowerCaseMapping:0x2D3C
  ,simpleTitleCaseMapping:0x2D3C
 },
 { code:0x2D3D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D3D
  ,simpleLowerCaseMapping:0x2D3D
  ,simpleTitleCaseMapping:0x2D3D
 },
 { code:0x2D3E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D3E
  ,simpleLowerCaseMapping:0x2D3E
  ,simpleTitleCaseMapping:0x2D3E
 },
 { code:0x2D3F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D3F
  ,simpleLowerCaseMapping:0x2D3F
  ,simpleTitleCaseMapping:0x2D3F
 },
 { code:0x2D40
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D40
  ,simpleLowerCaseMapping:0x2D40
  ,simpleTitleCaseMapping:0x2D40
 },
 { code:0x2D41
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D41
  ,simpleLowerCaseMapping:0x2D41
  ,simpleTitleCaseMapping:0x2D41
 },
 { code:0x2D42
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D42
  ,simpleLowerCaseMapping:0x2D42
  ,simpleTitleCaseMapping:0x2D42
 },
 { code:0x2D43
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D43
  ,simpleLowerCaseMapping:0x2D43
  ,simpleTitleCaseMapping:0x2D43
 },
 { code:0x2D44
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D44
  ,simpleLowerCaseMapping:0x2D44
  ,simpleTitleCaseMapping:0x2D44
 },
 { code:0x2D45
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D45
  ,simpleLowerCaseMapping:0x2D45
  ,simpleTitleCaseMapping:0x2D45
 },
 { code:0x2D46
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D46
  ,simpleLowerCaseMapping:0x2D46
  ,simpleTitleCaseMapping:0x2D46
 },
 { code:0x2D47
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D47
  ,simpleLowerCaseMapping:0x2D47
  ,simpleTitleCaseMapping:0x2D47
 },
 { code:0x2D48
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D48
  ,simpleLowerCaseMapping:0x2D48
  ,simpleTitleCaseMapping:0x2D48
 },
 { code:0x2D49
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D49
  ,simpleLowerCaseMapping:0x2D49
  ,simpleTitleCaseMapping:0x2D49
 },
 { code:0x2D4A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D4A
  ,simpleLowerCaseMapping:0x2D4A
  ,simpleTitleCaseMapping:0x2D4A
 },
 { code:0x2D4B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D4B
  ,simpleLowerCaseMapping:0x2D4B
  ,simpleTitleCaseMapping:0x2D4B
 },
 { code:0x2D4C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D4C
  ,simpleLowerCaseMapping:0x2D4C
  ,simpleTitleCaseMapping:0x2D4C
 },
 { code:0x2D4D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D4D
  ,simpleLowerCaseMapping:0x2D4D
  ,simpleTitleCaseMapping:0x2D4D
 },
 { code:0x2D4E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D4E
  ,simpleLowerCaseMapping:0x2D4E
  ,simpleTitleCaseMapping:0x2D4E
 },
 { code:0x2D4F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D4F
  ,simpleLowerCaseMapping:0x2D4F
  ,simpleTitleCaseMapping:0x2D4F
 },
 { code:0x2D50
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D50
  ,simpleLowerCaseMapping:0x2D50
  ,simpleTitleCaseMapping:0x2D50
 },
 { code:0x2D51
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D51
  ,simpleLowerCaseMapping:0x2D51
  ,simpleTitleCaseMapping:0x2D51
 },
 { code:0x2D52
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D52
  ,simpleLowerCaseMapping:0x2D52
  ,simpleTitleCaseMapping:0x2D52
 },
 { code:0x2D53
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D53
  ,simpleLowerCaseMapping:0x2D53
  ,simpleTitleCaseMapping:0x2D53
 },
 { code:0x2D54
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D54
  ,simpleLowerCaseMapping:0x2D54
  ,simpleTitleCaseMapping:0x2D54
 },
 { code:0x2D55
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D55
  ,simpleLowerCaseMapping:0x2D55
  ,simpleTitleCaseMapping:0x2D55
 },
 { code:0x2D56
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D56
  ,simpleLowerCaseMapping:0x2D56
  ,simpleTitleCaseMapping:0x2D56
 },
 { code:0x2D57
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D57
  ,simpleLowerCaseMapping:0x2D57
  ,simpleTitleCaseMapping:0x2D57
 },
 { code:0x2D58
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D58
  ,simpleLowerCaseMapping:0x2D58
  ,simpleTitleCaseMapping:0x2D58
 },
 { code:0x2D59
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D59
  ,simpleLowerCaseMapping:0x2D59
  ,simpleTitleCaseMapping:0x2D59
 },
 { code:0x2D5A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D5A
  ,simpleLowerCaseMapping:0x2D5A
  ,simpleTitleCaseMapping:0x2D5A
 },
 { code:0x2D5B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D5B
  ,simpleLowerCaseMapping:0x2D5B
  ,simpleTitleCaseMapping:0x2D5B
 },
 { code:0x2D5C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D5C
  ,simpleLowerCaseMapping:0x2D5C
  ,simpleTitleCaseMapping:0x2D5C
 },
 { code:0x2D5D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D5D
  ,simpleLowerCaseMapping:0x2D5D
  ,simpleTitleCaseMapping:0x2D5D
 },
 { code:0x2D5E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D5E
  ,simpleLowerCaseMapping:0x2D5E
  ,simpleTitleCaseMapping:0x2D5E
 },
 { code:0x2D5F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D5F
  ,simpleLowerCaseMapping:0x2D5F
  ,simpleTitleCaseMapping:0x2D5F
 },
 { code:0x2D60
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D60
  ,simpleLowerCaseMapping:0x2D60
  ,simpleTitleCaseMapping:0x2D60
 },
 { code:0x2D61
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D61
  ,simpleLowerCaseMapping:0x2D61
  ,simpleTitleCaseMapping:0x2D61
 },
 { code:0x2D62
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D62
  ,simpleLowerCaseMapping:0x2D62
  ,simpleTitleCaseMapping:0x2D62
 },
 { code:0x2D63
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D63
  ,simpleLowerCaseMapping:0x2D63
  ,simpleTitleCaseMapping:0x2D63
 },
 { code:0x2D64
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D64
  ,simpleLowerCaseMapping:0x2D64
  ,simpleTitleCaseMapping:0x2D64
 },
 { code:0x2D65
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D65
  ,simpleLowerCaseMapping:0x2D65
  ,simpleTitleCaseMapping:0x2D65
 },
 { code:0x2D6F
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x2D6F
  ,simpleLowerCaseMapping:0x2D6F
  ,simpleTitleCaseMapping:0x2D6F
 },
 { code:0x2D80
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D80
  ,simpleLowerCaseMapping:0x2D80
  ,simpleTitleCaseMapping:0x2D80
 },
 { code:0x2D81
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D81
  ,simpleLowerCaseMapping:0x2D81
  ,simpleTitleCaseMapping:0x2D81
 },
 { code:0x2D82
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D82
  ,simpleLowerCaseMapping:0x2D82
  ,simpleTitleCaseMapping:0x2D82
 },
 { code:0x2D83
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D83
  ,simpleLowerCaseMapping:0x2D83
  ,simpleTitleCaseMapping:0x2D83
 },
 { code:0x2D84
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D84
  ,simpleLowerCaseMapping:0x2D84
  ,simpleTitleCaseMapping:0x2D84
 },
 { code:0x2D85
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D85
  ,simpleLowerCaseMapping:0x2D85
  ,simpleTitleCaseMapping:0x2D85
 },
 { code:0x2D86
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D86
  ,simpleLowerCaseMapping:0x2D86
  ,simpleTitleCaseMapping:0x2D86
 },
 { code:0x2D87
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D87
  ,simpleLowerCaseMapping:0x2D87
  ,simpleTitleCaseMapping:0x2D87
 },
 { code:0x2D88
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D88
  ,simpleLowerCaseMapping:0x2D88
  ,simpleTitleCaseMapping:0x2D88
 },
 { code:0x2D89
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D89
  ,simpleLowerCaseMapping:0x2D89
  ,simpleTitleCaseMapping:0x2D89
 },
 { code:0x2D8A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D8A
  ,simpleLowerCaseMapping:0x2D8A
  ,simpleTitleCaseMapping:0x2D8A
 },
 { code:0x2D8B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D8B
  ,simpleLowerCaseMapping:0x2D8B
  ,simpleTitleCaseMapping:0x2D8B
 },
 { code:0x2D8C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D8C
  ,simpleLowerCaseMapping:0x2D8C
  ,simpleTitleCaseMapping:0x2D8C
 },
 { code:0x2D8D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D8D
  ,simpleLowerCaseMapping:0x2D8D
  ,simpleTitleCaseMapping:0x2D8D
 },
 { code:0x2D8E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D8E
  ,simpleLowerCaseMapping:0x2D8E
  ,simpleTitleCaseMapping:0x2D8E
 },
 { code:0x2D8F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D8F
  ,simpleLowerCaseMapping:0x2D8F
  ,simpleTitleCaseMapping:0x2D8F
 },
 { code:0x2D90
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D90
  ,simpleLowerCaseMapping:0x2D90
  ,simpleTitleCaseMapping:0x2D90
 },
 { code:0x2D91
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D91
  ,simpleLowerCaseMapping:0x2D91
  ,simpleTitleCaseMapping:0x2D91
 },
 { code:0x2D92
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D92
  ,simpleLowerCaseMapping:0x2D92
  ,simpleTitleCaseMapping:0x2D92
 },
 { code:0x2D93
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D93
  ,simpleLowerCaseMapping:0x2D93
  ,simpleTitleCaseMapping:0x2D93
 },
 { code:0x2D94
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D94
  ,simpleLowerCaseMapping:0x2D94
  ,simpleTitleCaseMapping:0x2D94
 },
 { code:0x2D95
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D95
  ,simpleLowerCaseMapping:0x2D95
  ,simpleTitleCaseMapping:0x2D95
 },
 { code:0x2D96
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2D96
  ,simpleLowerCaseMapping:0x2D96
  ,simpleTitleCaseMapping:0x2D96
 },
 { code:0x2DA0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DA0
  ,simpleLowerCaseMapping:0x2DA0
  ,simpleTitleCaseMapping:0x2DA0
 },
 { code:0x2DA1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DA1
  ,simpleLowerCaseMapping:0x2DA1
  ,simpleTitleCaseMapping:0x2DA1
 },
 { code:0x2DA2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DA2
  ,simpleLowerCaseMapping:0x2DA2
  ,simpleTitleCaseMapping:0x2DA2
 },
 { code:0x2DA3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DA3
  ,simpleLowerCaseMapping:0x2DA3
  ,simpleTitleCaseMapping:0x2DA3
 },
 { code:0x2DA4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DA4
  ,simpleLowerCaseMapping:0x2DA4
  ,simpleTitleCaseMapping:0x2DA4
 },
 { code:0x2DA5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DA5
  ,simpleLowerCaseMapping:0x2DA5
  ,simpleTitleCaseMapping:0x2DA5
 },
 { code:0x2DA6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DA6
  ,simpleLowerCaseMapping:0x2DA6
  ,simpleTitleCaseMapping:0x2DA6
 },
 { code:0x2DA8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DA8
  ,simpleLowerCaseMapping:0x2DA8
  ,simpleTitleCaseMapping:0x2DA8
 },
 { code:0x2DA9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DA9
  ,simpleLowerCaseMapping:0x2DA9
  ,simpleTitleCaseMapping:0x2DA9
 },
 { code:0x2DAA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DAA
  ,simpleLowerCaseMapping:0x2DAA
  ,simpleTitleCaseMapping:0x2DAA
 },
 { code:0x2DAB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DAB
  ,simpleLowerCaseMapping:0x2DAB
  ,simpleTitleCaseMapping:0x2DAB
 },
 { code:0x2DAC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DAC
  ,simpleLowerCaseMapping:0x2DAC
  ,simpleTitleCaseMapping:0x2DAC
 },
 { code:0x2DAD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DAD
  ,simpleLowerCaseMapping:0x2DAD
  ,simpleTitleCaseMapping:0x2DAD
 },
 { code:0x2DAE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DAE
  ,simpleLowerCaseMapping:0x2DAE
  ,simpleTitleCaseMapping:0x2DAE
 },
 { code:0x2DB0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DB0
  ,simpleLowerCaseMapping:0x2DB0
  ,simpleTitleCaseMapping:0x2DB0
 },
 { code:0x2DB1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DB1
  ,simpleLowerCaseMapping:0x2DB1
  ,simpleTitleCaseMapping:0x2DB1
 },
 { code:0x2DB2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DB2
  ,simpleLowerCaseMapping:0x2DB2
  ,simpleTitleCaseMapping:0x2DB2
 },
 { code:0x2DB3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DB3
  ,simpleLowerCaseMapping:0x2DB3
  ,simpleTitleCaseMapping:0x2DB3
 },
 { code:0x2DB4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DB4
  ,simpleLowerCaseMapping:0x2DB4
  ,simpleTitleCaseMapping:0x2DB4
 },
 { code:0x2DB5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DB5
  ,simpleLowerCaseMapping:0x2DB5
  ,simpleTitleCaseMapping:0x2DB5
 },
 { code:0x2DB6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DB6
  ,simpleLowerCaseMapping:0x2DB6
  ,simpleTitleCaseMapping:0x2DB6
 },
 { code:0x2DB8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DB8
  ,simpleLowerCaseMapping:0x2DB8
  ,simpleTitleCaseMapping:0x2DB8
 },
 { code:0x2DB9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DB9
  ,simpleLowerCaseMapping:0x2DB9
  ,simpleTitleCaseMapping:0x2DB9
 },
 { code:0x2DBA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DBA
  ,simpleLowerCaseMapping:0x2DBA
  ,simpleTitleCaseMapping:0x2DBA
 },
 { code:0x2DBB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DBB
  ,simpleLowerCaseMapping:0x2DBB
  ,simpleTitleCaseMapping:0x2DBB
 },
 { code:0x2DBC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DBC
  ,simpleLowerCaseMapping:0x2DBC
  ,simpleTitleCaseMapping:0x2DBC
 },
 { code:0x2DBD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DBD
  ,simpleLowerCaseMapping:0x2DBD
  ,simpleTitleCaseMapping:0x2DBD
 },
 { code:0x2DBE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DBE
  ,simpleLowerCaseMapping:0x2DBE
  ,simpleTitleCaseMapping:0x2DBE
 },
 { code:0x2DC0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DC0
  ,simpleLowerCaseMapping:0x2DC0
  ,simpleTitleCaseMapping:0x2DC0
 },
 { code:0x2DC1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DC1
  ,simpleLowerCaseMapping:0x2DC1
  ,simpleTitleCaseMapping:0x2DC1
 },
 { code:0x2DC2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DC2
  ,simpleLowerCaseMapping:0x2DC2
  ,simpleTitleCaseMapping:0x2DC2
 },
 { code:0x2DC3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DC3
  ,simpleLowerCaseMapping:0x2DC3
  ,simpleTitleCaseMapping:0x2DC3
 },
 { code:0x2DC4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DC4
  ,simpleLowerCaseMapping:0x2DC4
  ,simpleTitleCaseMapping:0x2DC4
 },
 { code:0x2DC5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DC5
  ,simpleLowerCaseMapping:0x2DC5
  ,simpleTitleCaseMapping:0x2DC5
 },
 { code:0x2DC6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DC6
  ,simpleLowerCaseMapping:0x2DC6
  ,simpleTitleCaseMapping:0x2DC6
 },
 { code:0x2DC8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DC8
  ,simpleLowerCaseMapping:0x2DC8
  ,simpleTitleCaseMapping:0x2DC8
 },
 { code:0x2DC9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DC9
  ,simpleLowerCaseMapping:0x2DC9
  ,simpleTitleCaseMapping:0x2DC9
 },
 { code:0x2DCA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DCA
  ,simpleLowerCaseMapping:0x2DCA
  ,simpleTitleCaseMapping:0x2DCA
 },
 { code:0x2DCB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DCB
  ,simpleLowerCaseMapping:0x2DCB
  ,simpleTitleCaseMapping:0x2DCB
 },
 { code:0x2DCC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DCC
  ,simpleLowerCaseMapping:0x2DCC
  ,simpleTitleCaseMapping:0x2DCC
 },
 { code:0x2DCD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DCD
  ,simpleLowerCaseMapping:0x2DCD
  ,simpleTitleCaseMapping:0x2DCD
 },
 { code:0x2DCE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DCE
  ,simpleLowerCaseMapping:0x2DCE
  ,simpleTitleCaseMapping:0x2DCE
 },
 { code:0x2DD0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DD0
  ,simpleLowerCaseMapping:0x2DD0
  ,simpleTitleCaseMapping:0x2DD0
 },
 { code:0x2DD1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DD1
  ,simpleLowerCaseMapping:0x2DD1
  ,simpleTitleCaseMapping:0x2DD1
 },
 { code:0x2DD2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DD2
  ,simpleLowerCaseMapping:0x2DD2
  ,simpleTitleCaseMapping:0x2DD2
 },
 { code:0x2DD3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DD3
  ,simpleLowerCaseMapping:0x2DD3
  ,simpleTitleCaseMapping:0x2DD3
 },
 { code:0x2DD4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DD4
  ,simpleLowerCaseMapping:0x2DD4
  ,simpleTitleCaseMapping:0x2DD4
 },
 { code:0x2DD5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DD5
  ,simpleLowerCaseMapping:0x2DD5
  ,simpleTitleCaseMapping:0x2DD5
 },
 { code:0x2DD6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DD6
  ,simpleLowerCaseMapping:0x2DD6
  ,simpleTitleCaseMapping:0x2DD6
 },
 { code:0x2DD8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DD8
  ,simpleLowerCaseMapping:0x2DD8
  ,simpleTitleCaseMapping:0x2DD8
 },
 { code:0x2DD9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DD9
  ,simpleLowerCaseMapping:0x2DD9
  ,simpleTitleCaseMapping:0x2DD9
 },
 { code:0x2DDA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DDA
  ,simpleLowerCaseMapping:0x2DDA
  ,simpleTitleCaseMapping:0x2DDA
 },
 { code:0x2DDB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DDB
  ,simpleLowerCaseMapping:0x2DDB
  ,simpleTitleCaseMapping:0x2DDB
 },
 { code:0x2DDC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DDC
  ,simpleLowerCaseMapping:0x2DDC
  ,simpleTitleCaseMapping:0x2DDC
 },
 { code:0x2DDD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DDD
  ,simpleLowerCaseMapping:0x2DDD
  ,simpleTitleCaseMapping:0x2DDD
 },
 { code:0x2DDE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2DDE
  ,simpleLowerCaseMapping:0x2DDE
  ,simpleTitleCaseMapping:0x2DDE
 },
 { code:0x2E00
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2E00
  ,simpleLowerCaseMapping:0x2E00
  ,simpleTitleCaseMapping:0x2E00
 },
 { code:0x2E01
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2E01
  ,simpleLowerCaseMapping:0x2E01
  ,simpleTitleCaseMapping:0x2E01
 },
 { code:0x2E02
  ,generalCategory:UnicodeData.GeneralCategory.Pi
  ,simpleUpperCaseMapping:0x2E02
  ,simpleLowerCaseMapping:0x2E02
  ,simpleTitleCaseMapping:0x2E02
 },
 { code:0x2E03
  ,generalCategory:UnicodeData.GeneralCategory.Pf
  ,simpleUpperCaseMapping:0x2E03
  ,simpleLowerCaseMapping:0x2E03
  ,simpleTitleCaseMapping:0x2E03
 },
 { code:0x2E04
  ,generalCategory:UnicodeData.GeneralCategory.Pi
  ,simpleUpperCaseMapping:0x2E04
  ,simpleLowerCaseMapping:0x2E04
  ,simpleTitleCaseMapping:0x2E04
 },
 { code:0x2E05
  ,generalCategory:UnicodeData.GeneralCategory.Pf
  ,simpleUpperCaseMapping:0x2E05
  ,simpleLowerCaseMapping:0x2E05
  ,simpleTitleCaseMapping:0x2E05
 },
 { code:0x2E06
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2E06
  ,simpleLowerCaseMapping:0x2E06
  ,simpleTitleCaseMapping:0x2E06
 },
 { code:0x2E07
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2E07
  ,simpleLowerCaseMapping:0x2E07
  ,simpleTitleCaseMapping:0x2E07
 },
 { code:0x2E08
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2E08
  ,simpleLowerCaseMapping:0x2E08
  ,simpleTitleCaseMapping:0x2E08
 },
 { code:0x2E09
  ,generalCategory:UnicodeData.GeneralCategory.Pi
  ,simpleUpperCaseMapping:0x2E09
  ,simpleLowerCaseMapping:0x2E09
  ,simpleTitleCaseMapping:0x2E09
 },
 { code:0x2E0A
  ,generalCategory:UnicodeData.GeneralCategory.Pf
  ,simpleUpperCaseMapping:0x2E0A
  ,simpleLowerCaseMapping:0x2E0A
  ,simpleTitleCaseMapping:0x2E0A
 },
 { code:0x2E0B
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2E0B
  ,simpleLowerCaseMapping:0x2E0B
  ,simpleTitleCaseMapping:0x2E0B
 },
 { code:0x2E0C
  ,generalCategory:UnicodeData.GeneralCategory.Pi
  ,simpleUpperCaseMapping:0x2E0C
  ,simpleLowerCaseMapping:0x2E0C
  ,simpleTitleCaseMapping:0x2E0C
 },
 { code:0x2E0D
  ,generalCategory:UnicodeData.GeneralCategory.Pf
  ,simpleUpperCaseMapping:0x2E0D
  ,simpleLowerCaseMapping:0x2E0D
  ,simpleTitleCaseMapping:0x2E0D
 },
 { code:0x2E0E
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2E0E
  ,simpleLowerCaseMapping:0x2E0E
  ,simpleTitleCaseMapping:0x2E0E
 },
 { code:0x2E0F
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2E0F
  ,simpleLowerCaseMapping:0x2E0F
  ,simpleTitleCaseMapping:0x2E0F
 },
 { code:0x2E10
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2E10
  ,simpleLowerCaseMapping:0x2E10
  ,simpleTitleCaseMapping:0x2E10
 },
 { code:0x2E11
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2E11
  ,simpleLowerCaseMapping:0x2E11
  ,simpleTitleCaseMapping:0x2E11
 },
 { code:0x2E12
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2E12
  ,simpleLowerCaseMapping:0x2E12
  ,simpleTitleCaseMapping:0x2E12
 },
 { code:0x2E13
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2E13
  ,simpleLowerCaseMapping:0x2E13
  ,simpleTitleCaseMapping:0x2E13
 },
 { code:0x2E14
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2E14
  ,simpleLowerCaseMapping:0x2E14
  ,simpleTitleCaseMapping:0x2E14
 },
 { code:0x2E15
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2E15
  ,simpleLowerCaseMapping:0x2E15
  ,simpleTitleCaseMapping:0x2E15
 },
 { code:0x2E16
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x2E16
  ,simpleLowerCaseMapping:0x2E16
  ,simpleTitleCaseMapping:0x2E16
 },
 { code:0x2E17
  ,generalCategory:UnicodeData.GeneralCategory.Pd
  ,simpleUpperCaseMapping:0x2E17
  ,simpleLowerCaseMapping:0x2E17
  ,simpleTitleCaseMapping:0x2E17
 },
 { code:0x2E1C
  ,generalCategory:UnicodeData.GeneralCategory.Pi
  ,simpleUpperCaseMapping:0x2E1C
  ,simpleLowerCaseMapping:0x2E1C
  ,simpleTitleCaseMapping:0x2E1C
 },
 { code:0x2E1D
  ,generalCategory:UnicodeData.GeneralCategory.Pf
  ,simpleUpperCaseMapping:0x2E1D
  ,simpleLowerCaseMapping:0x2E1D
  ,simpleTitleCaseMapping:0x2E1D
 },
 { code:0x2E80
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E80
  ,simpleLowerCaseMapping:0x2E80
  ,simpleTitleCaseMapping:0x2E80
 },
 { code:0x2E81
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E81
  ,simpleLowerCaseMapping:0x2E81
  ,simpleTitleCaseMapping:0x2E81
 },
 { code:0x2E82
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E82
  ,simpleLowerCaseMapping:0x2E82
  ,simpleTitleCaseMapping:0x2E82
 },
 { code:0x2E83
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E83
  ,simpleLowerCaseMapping:0x2E83
  ,simpleTitleCaseMapping:0x2E83
 },
 { code:0x2E84
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E84
  ,simpleLowerCaseMapping:0x2E84
  ,simpleTitleCaseMapping:0x2E84
 },
 { code:0x2E85
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E85
  ,simpleLowerCaseMapping:0x2E85
  ,simpleTitleCaseMapping:0x2E85
 },
 { code:0x2E86
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E86
  ,simpleLowerCaseMapping:0x2E86
  ,simpleTitleCaseMapping:0x2E86
 },
 { code:0x2E87
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E87
  ,simpleLowerCaseMapping:0x2E87
  ,simpleTitleCaseMapping:0x2E87
 },
 { code:0x2E88
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E88
  ,simpleLowerCaseMapping:0x2E88
  ,simpleTitleCaseMapping:0x2E88
 },
 { code:0x2E89
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E89
  ,simpleLowerCaseMapping:0x2E89
  ,simpleTitleCaseMapping:0x2E89
 },
 { code:0x2E8A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E8A
  ,simpleLowerCaseMapping:0x2E8A
  ,simpleTitleCaseMapping:0x2E8A
 },
 { code:0x2E8B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E8B
  ,simpleLowerCaseMapping:0x2E8B
  ,simpleTitleCaseMapping:0x2E8B
 },
 { code:0x2E8C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E8C
  ,simpleLowerCaseMapping:0x2E8C
  ,simpleTitleCaseMapping:0x2E8C
 },
 { code:0x2E8D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E8D
  ,simpleLowerCaseMapping:0x2E8D
  ,simpleTitleCaseMapping:0x2E8D
 },
 { code:0x2E8E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E8E
  ,simpleLowerCaseMapping:0x2E8E
  ,simpleTitleCaseMapping:0x2E8E
 },
 { code:0x2E8F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E8F
  ,simpleLowerCaseMapping:0x2E8F
  ,simpleTitleCaseMapping:0x2E8F
 },
 { code:0x2E90
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E90
  ,simpleLowerCaseMapping:0x2E90
  ,simpleTitleCaseMapping:0x2E90
 },
 { code:0x2E91
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E91
  ,simpleLowerCaseMapping:0x2E91
  ,simpleTitleCaseMapping:0x2E91
 },
 { code:0x2E92
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E92
  ,simpleLowerCaseMapping:0x2E92
  ,simpleTitleCaseMapping:0x2E92
 },
 { code:0x2E93
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E93
  ,simpleLowerCaseMapping:0x2E93
  ,simpleTitleCaseMapping:0x2E93
 },
 { code:0x2E94
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E94
  ,simpleLowerCaseMapping:0x2E94
  ,simpleTitleCaseMapping:0x2E94
 },
 { code:0x2E95
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E95
  ,simpleLowerCaseMapping:0x2E95
  ,simpleTitleCaseMapping:0x2E95
 },
 { code:0x2E96
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E96
  ,simpleLowerCaseMapping:0x2E96
  ,simpleTitleCaseMapping:0x2E96
 },
 { code:0x2E97
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E97
  ,simpleLowerCaseMapping:0x2E97
  ,simpleTitleCaseMapping:0x2E97
 },
 { code:0x2E98
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E98
  ,simpleLowerCaseMapping:0x2E98
  ,simpleTitleCaseMapping:0x2E98
 },
 { code:0x2E99
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E99
  ,simpleLowerCaseMapping:0x2E99
  ,simpleTitleCaseMapping:0x2E99
 },
 { code:0x2E9B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E9B
  ,simpleLowerCaseMapping:0x2E9B
  ,simpleTitleCaseMapping:0x2E9B
 },
 { code:0x2E9C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E9C
  ,simpleLowerCaseMapping:0x2E9C
  ,simpleTitleCaseMapping:0x2E9C
 },
 { code:0x2E9D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E9D
  ,simpleLowerCaseMapping:0x2E9D
  ,simpleTitleCaseMapping:0x2E9D
 },
 { code:0x2E9E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E9E
  ,simpleLowerCaseMapping:0x2E9E
  ,simpleTitleCaseMapping:0x2E9E
 },
 { code:0x2E9F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2E9F
  ,simpleLowerCaseMapping:0x2E9F
  ,simpleTitleCaseMapping:0x2E9F
 },
 { code:0x2EA0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EA0
  ,simpleLowerCaseMapping:0x2EA0
  ,simpleTitleCaseMapping:0x2EA0
 },
 { code:0x2EA1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EA1
  ,simpleLowerCaseMapping:0x2EA1
  ,simpleTitleCaseMapping:0x2EA1
 },
 { code:0x2EA2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EA2
  ,simpleLowerCaseMapping:0x2EA2
  ,simpleTitleCaseMapping:0x2EA2
 },
 { code:0x2EA3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EA3
  ,simpleLowerCaseMapping:0x2EA3
  ,simpleTitleCaseMapping:0x2EA3
 },
 { code:0x2EA4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EA4
  ,simpleLowerCaseMapping:0x2EA4
  ,simpleTitleCaseMapping:0x2EA4
 },
 { code:0x2EA5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EA5
  ,simpleLowerCaseMapping:0x2EA5
  ,simpleTitleCaseMapping:0x2EA5
 },
 { code:0x2EA6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EA6
  ,simpleLowerCaseMapping:0x2EA6
  ,simpleTitleCaseMapping:0x2EA6
 },
 { code:0x2EA7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EA7
  ,simpleLowerCaseMapping:0x2EA7
  ,simpleTitleCaseMapping:0x2EA7
 },
 { code:0x2EA8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EA8
  ,simpleLowerCaseMapping:0x2EA8
  ,simpleTitleCaseMapping:0x2EA8
 },
 { code:0x2EA9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EA9
  ,simpleLowerCaseMapping:0x2EA9
  ,simpleTitleCaseMapping:0x2EA9
 },
 { code:0x2EAA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EAA
  ,simpleLowerCaseMapping:0x2EAA
  ,simpleTitleCaseMapping:0x2EAA
 },
 { code:0x2EAB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EAB
  ,simpleLowerCaseMapping:0x2EAB
  ,simpleTitleCaseMapping:0x2EAB
 },
 { code:0x2EAC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EAC
  ,simpleLowerCaseMapping:0x2EAC
  ,simpleTitleCaseMapping:0x2EAC
 },
 { code:0x2EAD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EAD
  ,simpleLowerCaseMapping:0x2EAD
  ,simpleTitleCaseMapping:0x2EAD
 },
 { code:0x2EAE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EAE
  ,simpleLowerCaseMapping:0x2EAE
  ,simpleTitleCaseMapping:0x2EAE
 },
 { code:0x2EAF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EAF
  ,simpleLowerCaseMapping:0x2EAF
  ,simpleTitleCaseMapping:0x2EAF
 },
 { code:0x2EB0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EB0
  ,simpleLowerCaseMapping:0x2EB0
  ,simpleTitleCaseMapping:0x2EB0
 },
 { code:0x2EB1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EB1
  ,simpleLowerCaseMapping:0x2EB1
  ,simpleTitleCaseMapping:0x2EB1
 },
 { code:0x2EB2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EB2
  ,simpleLowerCaseMapping:0x2EB2
  ,simpleTitleCaseMapping:0x2EB2
 },
 { code:0x2EB3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EB3
  ,simpleLowerCaseMapping:0x2EB3
  ,simpleTitleCaseMapping:0x2EB3
 },
 { code:0x2EB4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EB4
  ,simpleLowerCaseMapping:0x2EB4
  ,simpleTitleCaseMapping:0x2EB4
 },
 { code:0x2EB5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EB5
  ,simpleLowerCaseMapping:0x2EB5
  ,simpleTitleCaseMapping:0x2EB5
 },
 { code:0x2EB6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EB6
  ,simpleLowerCaseMapping:0x2EB6
  ,simpleTitleCaseMapping:0x2EB6
 },
 { code:0x2EB7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EB7
  ,simpleLowerCaseMapping:0x2EB7
  ,simpleTitleCaseMapping:0x2EB7
 },
 { code:0x2EB8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EB8
  ,simpleLowerCaseMapping:0x2EB8
  ,simpleTitleCaseMapping:0x2EB8
 },
 { code:0x2EB9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EB9
  ,simpleLowerCaseMapping:0x2EB9
  ,simpleTitleCaseMapping:0x2EB9
 },
 { code:0x2EBA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EBA
  ,simpleLowerCaseMapping:0x2EBA
  ,simpleTitleCaseMapping:0x2EBA
 },
 { code:0x2EBB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EBB
  ,simpleLowerCaseMapping:0x2EBB
  ,simpleTitleCaseMapping:0x2EBB
 },
 { code:0x2EBC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EBC
  ,simpleLowerCaseMapping:0x2EBC
  ,simpleTitleCaseMapping:0x2EBC
 },
 { code:0x2EBD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EBD
  ,simpleLowerCaseMapping:0x2EBD
  ,simpleTitleCaseMapping:0x2EBD
 },
 { code:0x2EBE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EBE
  ,simpleLowerCaseMapping:0x2EBE
  ,simpleTitleCaseMapping:0x2EBE
 },
 { code:0x2EBF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EBF
  ,simpleLowerCaseMapping:0x2EBF
  ,simpleTitleCaseMapping:0x2EBF
 },
 { code:0x2EC0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EC0
  ,simpleLowerCaseMapping:0x2EC0
  ,simpleTitleCaseMapping:0x2EC0
 },
 { code:0x2EC1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EC1
  ,simpleLowerCaseMapping:0x2EC1
  ,simpleTitleCaseMapping:0x2EC1
 },
 { code:0x2EC2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EC2
  ,simpleLowerCaseMapping:0x2EC2
  ,simpleTitleCaseMapping:0x2EC2
 },
 { code:0x2EC3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EC3
  ,simpleLowerCaseMapping:0x2EC3
  ,simpleTitleCaseMapping:0x2EC3
 },
 { code:0x2EC4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EC4
  ,simpleLowerCaseMapping:0x2EC4
  ,simpleTitleCaseMapping:0x2EC4
 },
 { code:0x2EC5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EC5
  ,simpleLowerCaseMapping:0x2EC5
  ,simpleTitleCaseMapping:0x2EC5
 },
 { code:0x2EC6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EC6
  ,simpleLowerCaseMapping:0x2EC6
  ,simpleTitleCaseMapping:0x2EC6
 },
 { code:0x2EC7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EC7
  ,simpleLowerCaseMapping:0x2EC7
  ,simpleTitleCaseMapping:0x2EC7
 },
 { code:0x2EC8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EC8
  ,simpleLowerCaseMapping:0x2EC8
  ,simpleTitleCaseMapping:0x2EC8
 },
 { code:0x2EC9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EC9
  ,simpleLowerCaseMapping:0x2EC9
  ,simpleTitleCaseMapping:0x2EC9
 },
 { code:0x2ECA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2ECA
  ,simpleLowerCaseMapping:0x2ECA
  ,simpleTitleCaseMapping:0x2ECA
 },
 { code:0x2ECB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2ECB
  ,simpleLowerCaseMapping:0x2ECB
  ,simpleTitleCaseMapping:0x2ECB
 },
 { code:0x2ECC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2ECC
  ,simpleLowerCaseMapping:0x2ECC
  ,simpleTitleCaseMapping:0x2ECC
 },
 { code:0x2ECD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2ECD
  ,simpleLowerCaseMapping:0x2ECD
  ,simpleTitleCaseMapping:0x2ECD
 },
 { code:0x2ECE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2ECE
  ,simpleLowerCaseMapping:0x2ECE
  ,simpleTitleCaseMapping:0x2ECE
 },
 { code:0x2ECF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2ECF
  ,simpleLowerCaseMapping:0x2ECF
  ,simpleTitleCaseMapping:0x2ECF
 },
 { code:0x2ED0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2ED0
  ,simpleLowerCaseMapping:0x2ED0
  ,simpleTitleCaseMapping:0x2ED0
 },
 { code:0x2ED1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2ED1
  ,simpleLowerCaseMapping:0x2ED1
  ,simpleTitleCaseMapping:0x2ED1
 },
 { code:0x2ED2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2ED2
  ,simpleLowerCaseMapping:0x2ED2
  ,simpleTitleCaseMapping:0x2ED2
 },
 { code:0x2ED3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2ED3
  ,simpleLowerCaseMapping:0x2ED3
  ,simpleTitleCaseMapping:0x2ED3
 },
 { code:0x2ED4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2ED4
  ,simpleLowerCaseMapping:0x2ED4
  ,simpleTitleCaseMapping:0x2ED4
 },
 { code:0x2ED5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2ED5
  ,simpleLowerCaseMapping:0x2ED5
  ,simpleTitleCaseMapping:0x2ED5
 },
 { code:0x2ED6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2ED6
  ,simpleLowerCaseMapping:0x2ED6
  ,simpleTitleCaseMapping:0x2ED6
 },
 { code:0x2ED7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2ED7
  ,simpleLowerCaseMapping:0x2ED7
  ,simpleTitleCaseMapping:0x2ED7
 },
 { code:0x2ED8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2ED8
  ,simpleLowerCaseMapping:0x2ED8
  ,simpleTitleCaseMapping:0x2ED8
 },
 { code:0x2ED9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2ED9
  ,simpleLowerCaseMapping:0x2ED9
  ,simpleTitleCaseMapping:0x2ED9
 },
 { code:0x2EDA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EDA
  ,simpleLowerCaseMapping:0x2EDA
  ,simpleTitleCaseMapping:0x2EDA
 },
 { code:0x2EDB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EDB
  ,simpleLowerCaseMapping:0x2EDB
  ,simpleTitleCaseMapping:0x2EDB
 },
 { code:0x2EDC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EDC
  ,simpleLowerCaseMapping:0x2EDC
  ,simpleTitleCaseMapping:0x2EDC
 },
 { code:0x2EDD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EDD
  ,simpleLowerCaseMapping:0x2EDD
  ,simpleTitleCaseMapping:0x2EDD
 },
 { code:0x2EDE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EDE
  ,simpleLowerCaseMapping:0x2EDE
  ,simpleTitleCaseMapping:0x2EDE
 },
 { code:0x2EDF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EDF
  ,simpleLowerCaseMapping:0x2EDF
  ,simpleTitleCaseMapping:0x2EDF
 },
 { code:0x2EE0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EE0
  ,simpleLowerCaseMapping:0x2EE0
  ,simpleTitleCaseMapping:0x2EE0
 },
 { code:0x2EE1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EE1
  ,simpleLowerCaseMapping:0x2EE1
  ,simpleTitleCaseMapping:0x2EE1
 },
 { code:0x2EE2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EE2
  ,simpleLowerCaseMapping:0x2EE2
  ,simpleTitleCaseMapping:0x2EE2
 },
 { code:0x2EE3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EE3
  ,simpleLowerCaseMapping:0x2EE3
  ,simpleTitleCaseMapping:0x2EE3
 },
 { code:0x2EE4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EE4
  ,simpleLowerCaseMapping:0x2EE4
  ,simpleTitleCaseMapping:0x2EE4
 },
 { code:0x2EE5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EE5
  ,simpleLowerCaseMapping:0x2EE5
  ,simpleTitleCaseMapping:0x2EE5
 },
 { code:0x2EE6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EE6
  ,simpleLowerCaseMapping:0x2EE6
  ,simpleTitleCaseMapping:0x2EE6
 },
 { code:0x2EE7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EE7
  ,simpleLowerCaseMapping:0x2EE7
  ,simpleTitleCaseMapping:0x2EE7
 },
 { code:0x2EE8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EE8
  ,simpleLowerCaseMapping:0x2EE8
  ,simpleTitleCaseMapping:0x2EE8
 },
 { code:0x2EE9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EE9
  ,simpleLowerCaseMapping:0x2EE9
  ,simpleTitleCaseMapping:0x2EE9
 },
 { code:0x2EEA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EEA
  ,simpleLowerCaseMapping:0x2EEA
  ,simpleTitleCaseMapping:0x2EEA
 },
 { code:0x2EEB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EEB
  ,simpleLowerCaseMapping:0x2EEB
  ,simpleTitleCaseMapping:0x2EEB
 },
 { code:0x2EEC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EEC
  ,simpleLowerCaseMapping:0x2EEC
  ,simpleTitleCaseMapping:0x2EEC
 },
 { code:0x2EED
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EED
  ,simpleLowerCaseMapping:0x2EED
  ,simpleTitleCaseMapping:0x2EED
 },
 { code:0x2EEE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EEE
  ,simpleLowerCaseMapping:0x2EEE
  ,simpleTitleCaseMapping:0x2EEE
 },
 { code:0x2EEF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EEF
  ,simpleLowerCaseMapping:0x2EEF
  ,simpleTitleCaseMapping:0x2EEF
 },
 { code:0x2EF0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EF0
  ,simpleLowerCaseMapping:0x2EF0
  ,simpleTitleCaseMapping:0x2EF0
 },
 { code:0x2EF1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EF1
  ,simpleLowerCaseMapping:0x2EF1
  ,simpleTitleCaseMapping:0x2EF1
 },
 { code:0x2EF2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EF2
  ,simpleLowerCaseMapping:0x2EF2
  ,simpleTitleCaseMapping:0x2EF2
 },
 { code:0x2EF3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2EF3
  ,simpleLowerCaseMapping:0x2EF3
  ,simpleTitleCaseMapping:0x2EF3
 },
 { code:0x2F00
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F00
  ,simpleLowerCaseMapping:0x2F00
  ,simpleTitleCaseMapping:0x2F00
 },
 { code:0x2F01
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F01
  ,simpleLowerCaseMapping:0x2F01
  ,simpleTitleCaseMapping:0x2F01
 },
 { code:0x2F02
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F02
  ,simpleLowerCaseMapping:0x2F02
  ,simpleTitleCaseMapping:0x2F02
 },
 { code:0x2F03
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F03
  ,simpleLowerCaseMapping:0x2F03
  ,simpleTitleCaseMapping:0x2F03
 },
 { code:0x2F04
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F04
  ,simpleLowerCaseMapping:0x2F04
  ,simpleTitleCaseMapping:0x2F04
 },
 { code:0x2F05
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F05
  ,simpleLowerCaseMapping:0x2F05
  ,simpleTitleCaseMapping:0x2F05
 },
 { code:0x2F06
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F06
  ,simpleLowerCaseMapping:0x2F06
  ,simpleTitleCaseMapping:0x2F06
 },
 { code:0x2F07
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F07
  ,simpleLowerCaseMapping:0x2F07
  ,simpleTitleCaseMapping:0x2F07
 },
 { code:0x2F08
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F08
  ,simpleLowerCaseMapping:0x2F08
  ,simpleTitleCaseMapping:0x2F08
 },
 { code:0x2F09
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F09
  ,simpleLowerCaseMapping:0x2F09
  ,simpleTitleCaseMapping:0x2F09
 },
 { code:0x2F0A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F0A
  ,simpleLowerCaseMapping:0x2F0A
  ,simpleTitleCaseMapping:0x2F0A
 },
 { code:0x2F0B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F0B
  ,simpleLowerCaseMapping:0x2F0B
  ,simpleTitleCaseMapping:0x2F0B
 },
 { code:0x2F0C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F0C
  ,simpleLowerCaseMapping:0x2F0C
  ,simpleTitleCaseMapping:0x2F0C
 },
 { code:0x2F0D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F0D
  ,simpleLowerCaseMapping:0x2F0D
  ,simpleTitleCaseMapping:0x2F0D
 },
 { code:0x2F0E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F0E
  ,simpleLowerCaseMapping:0x2F0E
  ,simpleTitleCaseMapping:0x2F0E
 },
 { code:0x2F0F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F0F
  ,simpleLowerCaseMapping:0x2F0F
  ,simpleTitleCaseMapping:0x2F0F
 },
 { code:0x2F10
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F10
  ,simpleLowerCaseMapping:0x2F10
  ,simpleTitleCaseMapping:0x2F10
 },
 { code:0x2F11
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F11
  ,simpleLowerCaseMapping:0x2F11
  ,simpleTitleCaseMapping:0x2F11
 },
 { code:0x2F12
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F12
  ,simpleLowerCaseMapping:0x2F12
  ,simpleTitleCaseMapping:0x2F12
 },
 { code:0x2F13
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F13
  ,simpleLowerCaseMapping:0x2F13
  ,simpleTitleCaseMapping:0x2F13
 },
 { code:0x2F14
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F14
  ,simpleLowerCaseMapping:0x2F14
  ,simpleTitleCaseMapping:0x2F14
 },
 { code:0x2F15
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F15
  ,simpleLowerCaseMapping:0x2F15
  ,simpleTitleCaseMapping:0x2F15
 },
 { code:0x2F16
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F16
  ,simpleLowerCaseMapping:0x2F16
  ,simpleTitleCaseMapping:0x2F16
 },
 { code:0x2F17
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F17
  ,simpleLowerCaseMapping:0x2F17
  ,simpleTitleCaseMapping:0x2F17
 },
 { code:0x2F18
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F18
  ,simpleLowerCaseMapping:0x2F18
  ,simpleTitleCaseMapping:0x2F18
 },
 { code:0x2F19
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F19
  ,simpleLowerCaseMapping:0x2F19
  ,simpleTitleCaseMapping:0x2F19
 },
 { code:0x2F1A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F1A
  ,simpleLowerCaseMapping:0x2F1A
  ,simpleTitleCaseMapping:0x2F1A
 },
 { code:0x2F1B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F1B
  ,simpleLowerCaseMapping:0x2F1B
  ,simpleTitleCaseMapping:0x2F1B
 },
 { code:0x2F1C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F1C
  ,simpleLowerCaseMapping:0x2F1C
  ,simpleTitleCaseMapping:0x2F1C
 },
 { code:0x2F1D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F1D
  ,simpleLowerCaseMapping:0x2F1D
  ,simpleTitleCaseMapping:0x2F1D
 },
 { code:0x2F1E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F1E
  ,simpleLowerCaseMapping:0x2F1E
  ,simpleTitleCaseMapping:0x2F1E
 },
 { code:0x2F1F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F1F
  ,simpleLowerCaseMapping:0x2F1F
  ,simpleTitleCaseMapping:0x2F1F
 },
 { code:0x2F20
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F20
  ,simpleLowerCaseMapping:0x2F20
  ,simpleTitleCaseMapping:0x2F20
 },
 { code:0x2F21
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F21
  ,simpleLowerCaseMapping:0x2F21
  ,simpleTitleCaseMapping:0x2F21
 },
 { code:0x2F22
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F22
  ,simpleLowerCaseMapping:0x2F22
  ,simpleTitleCaseMapping:0x2F22
 },
 { code:0x2F23
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F23
  ,simpleLowerCaseMapping:0x2F23
  ,simpleTitleCaseMapping:0x2F23
 },
 { code:0x2F24
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F24
  ,simpleLowerCaseMapping:0x2F24
  ,simpleTitleCaseMapping:0x2F24
 },
 { code:0x2F25
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F25
  ,simpleLowerCaseMapping:0x2F25
  ,simpleTitleCaseMapping:0x2F25
 },
 { code:0x2F26
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F26
  ,simpleLowerCaseMapping:0x2F26
  ,simpleTitleCaseMapping:0x2F26
 },
 { code:0x2F27
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F27
  ,simpleLowerCaseMapping:0x2F27
  ,simpleTitleCaseMapping:0x2F27
 },
 { code:0x2F28
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F28
  ,simpleLowerCaseMapping:0x2F28
  ,simpleTitleCaseMapping:0x2F28
 },
 { code:0x2F29
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F29
  ,simpleLowerCaseMapping:0x2F29
  ,simpleTitleCaseMapping:0x2F29
 },
 { code:0x2F2A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F2A
  ,simpleLowerCaseMapping:0x2F2A
  ,simpleTitleCaseMapping:0x2F2A
 },
 { code:0x2F2B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F2B
  ,simpleLowerCaseMapping:0x2F2B
  ,simpleTitleCaseMapping:0x2F2B
 },
 { code:0x2F2C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F2C
  ,simpleLowerCaseMapping:0x2F2C
  ,simpleTitleCaseMapping:0x2F2C
 },
 { code:0x2F2D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F2D
  ,simpleLowerCaseMapping:0x2F2D
  ,simpleTitleCaseMapping:0x2F2D
 },
 { code:0x2F2E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F2E
  ,simpleLowerCaseMapping:0x2F2E
  ,simpleTitleCaseMapping:0x2F2E
 },
 { code:0x2F2F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F2F
  ,simpleLowerCaseMapping:0x2F2F
  ,simpleTitleCaseMapping:0x2F2F
 },
 { code:0x2F30
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F30
  ,simpleLowerCaseMapping:0x2F30
  ,simpleTitleCaseMapping:0x2F30
 },
 { code:0x2F31
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F31
  ,simpleLowerCaseMapping:0x2F31
  ,simpleTitleCaseMapping:0x2F31
 },
 { code:0x2F32
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F32
  ,simpleLowerCaseMapping:0x2F32
  ,simpleTitleCaseMapping:0x2F32
 },
 { code:0x2F33
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F33
  ,simpleLowerCaseMapping:0x2F33
  ,simpleTitleCaseMapping:0x2F33
 },
 { code:0x2F34
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F34
  ,simpleLowerCaseMapping:0x2F34
  ,simpleTitleCaseMapping:0x2F34
 },
 { code:0x2F35
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F35
  ,simpleLowerCaseMapping:0x2F35
  ,simpleTitleCaseMapping:0x2F35
 },
 { code:0x2F36
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F36
  ,simpleLowerCaseMapping:0x2F36
  ,simpleTitleCaseMapping:0x2F36
 },
 { code:0x2F37
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F37
  ,simpleLowerCaseMapping:0x2F37
  ,simpleTitleCaseMapping:0x2F37
 },
 { code:0x2F38
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F38
  ,simpleLowerCaseMapping:0x2F38
  ,simpleTitleCaseMapping:0x2F38
 },
 { code:0x2F39
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F39
  ,simpleLowerCaseMapping:0x2F39
  ,simpleTitleCaseMapping:0x2F39
 },
 { code:0x2F3A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F3A
  ,simpleLowerCaseMapping:0x2F3A
  ,simpleTitleCaseMapping:0x2F3A
 },
 { code:0x2F3B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F3B
  ,simpleLowerCaseMapping:0x2F3B
  ,simpleTitleCaseMapping:0x2F3B
 },
 { code:0x2F3C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F3C
  ,simpleLowerCaseMapping:0x2F3C
  ,simpleTitleCaseMapping:0x2F3C
 },
 { code:0x2F3D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F3D
  ,simpleLowerCaseMapping:0x2F3D
  ,simpleTitleCaseMapping:0x2F3D
 },
 { code:0x2F3E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F3E
  ,simpleLowerCaseMapping:0x2F3E
  ,simpleTitleCaseMapping:0x2F3E
 },
 { code:0x2F3F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F3F
  ,simpleLowerCaseMapping:0x2F3F
  ,simpleTitleCaseMapping:0x2F3F
 },
 { code:0x2F40
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F40
  ,simpleLowerCaseMapping:0x2F40
  ,simpleTitleCaseMapping:0x2F40
 },
 { code:0x2F41
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F41
  ,simpleLowerCaseMapping:0x2F41
  ,simpleTitleCaseMapping:0x2F41
 },
 { code:0x2F42
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F42
  ,simpleLowerCaseMapping:0x2F42
  ,simpleTitleCaseMapping:0x2F42
 },
 { code:0x2F43
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F43
  ,simpleLowerCaseMapping:0x2F43
  ,simpleTitleCaseMapping:0x2F43
 },
 { code:0x2F44
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F44
  ,simpleLowerCaseMapping:0x2F44
  ,simpleTitleCaseMapping:0x2F44
 },
 { code:0x2F45
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F45
  ,simpleLowerCaseMapping:0x2F45
  ,simpleTitleCaseMapping:0x2F45
 },
 { code:0x2F46
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F46
  ,simpleLowerCaseMapping:0x2F46
  ,simpleTitleCaseMapping:0x2F46
 },
 { code:0x2F47
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F47
  ,simpleLowerCaseMapping:0x2F47
  ,simpleTitleCaseMapping:0x2F47
 },
 { code:0x2F48
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F48
  ,simpleLowerCaseMapping:0x2F48
  ,simpleTitleCaseMapping:0x2F48
 },
 { code:0x2F49
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F49
  ,simpleLowerCaseMapping:0x2F49
  ,simpleTitleCaseMapping:0x2F49
 },
 { code:0x2F4A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F4A
  ,simpleLowerCaseMapping:0x2F4A
  ,simpleTitleCaseMapping:0x2F4A
 },
 { code:0x2F4B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F4B
  ,simpleLowerCaseMapping:0x2F4B
  ,simpleTitleCaseMapping:0x2F4B
 },
 { code:0x2F4C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F4C
  ,simpleLowerCaseMapping:0x2F4C
  ,simpleTitleCaseMapping:0x2F4C
 },
 { code:0x2F4D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F4D
  ,simpleLowerCaseMapping:0x2F4D
  ,simpleTitleCaseMapping:0x2F4D
 },
 { code:0x2F4E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F4E
  ,simpleLowerCaseMapping:0x2F4E
  ,simpleTitleCaseMapping:0x2F4E
 },
 { code:0x2F4F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F4F
  ,simpleLowerCaseMapping:0x2F4F
  ,simpleTitleCaseMapping:0x2F4F
 },
 { code:0x2F50
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F50
  ,simpleLowerCaseMapping:0x2F50
  ,simpleTitleCaseMapping:0x2F50
 },
 { code:0x2F51
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F51
  ,simpleLowerCaseMapping:0x2F51
  ,simpleTitleCaseMapping:0x2F51
 },
 { code:0x2F52
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F52
  ,simpleLowerCaseMapping:0x2F52
  ,simpleTitleCaseMapping:0x2F52
 },
 { code:0x2F53
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F53
  ,simpleLowerCaseMapping:0x2F53
  ,simpleTitleCaseMapping:0x2F53
 },
 { code:0x2F54
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F54
  ,simpleLowerCaseMapping:0x2F54
  ,simpleTitleCaseMapping:0x2F54
 },
 { code:0x2F55
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F55
  ,simpleLowerCaseMapping:0x2F55
  ,simpleTitleCaseMapping:0x2F55
 },
 { code:0x2F56
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F56
  ,simpleLowerCaseMapping:0x2F56
  ,simpleTitleCaseMapping:0x2F56
 },
 { code:0x2F57
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F57
  ,simpleLowerCaseMapping:0x2F57
  ,simpleTitleCaseMapping:0x2F57
 },
 { code:0x2F58
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F58
  ,simpleLowerCaseMapping:0x2F58
  ,simpleTitleCaseMapping:0x2F58
 },
 { code:0x2F59
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F59
  ,simpleLowerCaseMapping:0x2F59
  ,simpleTitleCaseMapping:0x2F59
 },
 { code:0x2F5A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F5A
  ,simpleLowerCaseMapping:0x2F5A
  ,simpleTitleCaseMapping:0x2F5A
 },
 { code:0x2F5B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F5B
  ,simpleLowerCaseMapping:0x2F5B
  ,simpleTitleCaseMapping:0x2F5B
 },
 { code:0x2F5C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F5C
  ,simpleLowerCaseMapping:0x2F5C
  ,simpleTitleCaseMapping:0x2F5C
 },
 { code:0x2F5D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F5D
  ,simpleLowerCaseMapping:0x2F5D
  ,simpleTitleCaseMapping:0x2F5D
 },
 { code:0x2F5E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F5E
  ,simpleLowerCaseMapping:0x2F5E
  ,simpleTitleCaseMapping:0x2F5E
 },
 { code:0x2F5F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F5F
  ,simpleLowerCaseMapping:0x2F5F
  ,simpleTitleCaseMapping:0x2F5F
 },
 { code:0x2F60
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F60
  ,simpleLowerCaseMapping:0x2F60
  ,simpleTitleCaseMapping:0x2F60
 },
 { code:0x2F61
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F61
  ,simpleLowerCaseMapping:0x2F61
  ,simpleTitleCaseMapping:0x2F61
 },
 { code:0x2F62
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F62
  ,simpleLowerCaseMapping:0x2F62
  ,simpleTitleCaseMapping:0x2F62
 },
 { code:0x2F63
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F63
  ,simpleLowerCaseMapping:0x2F63
  ,simpleTitleCaseMapping:0x2F63
 },
 { code:0x2F64
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F64
  ,simpleLowerCaseMapping:0x2F64
  ,simpleTitleCaseMapping:0x2F64
 },
 { code:0x2F65
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F65
  ,simpleLowerCaseMapping:0x2F65
  ,simpleTitleCaseMapping:0x2F65
 },
 { code:0x2F66
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F66
  ,simpleLowerCaseMapping:0x2F66
  ,simpleTitleCaseMapping:0x2F66
 },
 { code:0x2F67
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F67
  ,simpleLowerCaseMapping:0x2F67
  ,simpleTitleCaseMapping:0x2F67
 },
 { code:0x2F68
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F68
  ,simpleLowerCaseMapping:0x2F68
  ,simpleTitleCaseMapping:0x2F68
 },
 { code:0x2F69
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F69
  ,simpleLowerCaseMapping:0x2F69
  ,simpleTitleCaseMapping:0x2F69
 },
 { code:0x2F6A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F6A
  ,simpleLowerCaseMapping:0x2F6A
  ,simpleTitleCaseMapping:0x2F6A
 },
 { code:0x2F6B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F6B
  ,simpleLowerCaseMapping:0x2F6B
  ,simpleTitleCaseMapping:0x2F6B
 },
 { code:0x2F6C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F6C
  ,simpleLowerCaseMapping:0x2F6C
  ,simpleTitleCaseMapping:0x2F6C
 },
 { code:0x2F6D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F6D
  ,simpleLowerCaseMapping:0x2F6D
  ,simpleTitleCaseMapping:0x2F6D
 },
 { code:0x2F6E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F6E
  ,simpleLowerCaseMapping:0x2F6E
  ,simpleTitleCaseMapping:0x2F6E
 },
 { code:0x2F6F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F6F
  ,simpleLowerCaseMapping:0x2F6F
  ,simpleTitleCaseMapping:0x2F6F
 },
 { code:0x2F70
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F70
  ,simpleLowerCaseMapping:0x2F70
  ,simpleTitleCaseMapping:0x2F70
 },
 { code:0x2F71
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F71
  ,simpleLowerCaseMapping:0x2F71
  ,simpleTitleCaseMapping:0x2F71
 },
 { code:0x2F72
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F72
  ,simpleLowerCaseMapping:0x2F72
  ,simpleTitleCaseMapping:0x2F72
 },
 { code:0x2F73
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F73
  ,simpleLowerCaseMapping:0x2F73
  ,simpleTitleCaseMapping:0x2F73
 },
 { code:0x2F74
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F74
  ,simpleLowerCaseMapping:0x2F74
  ,simpleTitleCaseMapping:0x2F74
 },
 { code:0x2F75
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F75
  ,simpleLowerCaseMapping:0x2F75
  ,simpleTitleCaseMapping:0x2F75
 },
 { code:0x2F76
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F76
  ,simpleLowerCaseMapping:0x2F76
  ,simpleTitleCaseMapping:0x2F76
 },
 { code:0x2F77
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F77
  ,simpleLowerCaseMapping:0x2F77
  ,simpleTitleCaseMapping:0x2F77
 },
 { code:0x2F78
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F78
  ,simpleLowerCaseMapping:0x2F78
  ,simpleTitleCaseMapping:0x2F78
 },
 { code:0x2F79
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F79
  ,simpleLowerCaseMapping:0x2F79
  ,simpleTitleCaseMapping:0x2F79
 },
 { code:0x2F7A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F7A
  ,simpleLowerCaseMapping:0x2F7A
  ,simpleTitleCaseMapping:0x2F7A
 },
 { code:0x2F7B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F7B
  ,simpleLowerCaseMapping:0x2F7B
  ,simpleTitleCaseMapping:0x2F7B
 },
 { code:0x2F7C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F7C
  ,simpleLowerCaseMapping:0x2F7C
  ,simpleTitleCaseMapping:0x2F7C
 },
 { code:0x2F7D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F7D
  ,simpleLowerCaseMapping:0x2F7D
  ,simpleTitleCaseMapping:0x2F7D
 },
 { code:0x2F7E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F7E
  ,simpleLowerCaseMapping:0x2F7E
  ,simpleTitleCaseMapping:0x2F7E
 },
 { code:0x2F7F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F7F
  ,simpleLowerCaseMapping:0x2F7F
  ,simpleTitleCaseMapping:0x2F7F
 },
 { code:0x2F80
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F80
  ,simpleLowerCaseMapping:0x2F80
  ,simpleTitleCaseMapping:0x2F80
 },
 { code:0x2F81
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F81
  ,simpleLowerCaseMapping:0x2F81
  ,simpleTitleCaseMapping:0x2F81
 },
 { code:0x2F82
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F82
  ,simpleLowerCaseMapping:0x2F82
  ,simpleTitleCaseMapping:0x2F82
 },
 { code:0x2F83
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F83
  ,simpleLowerCaseMapping:0x2F83
  ,simpleTitleCaseMapping:0x2F83
 },
 { code:0x2F84
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F84
  ,simpleLowerCaseMapping:0x2F84
  ,simpleTitleCaseMapping:0x2F84
 },
 { code:0x2F85
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F85
  ,simpleLowerCaseMapping:0x2F85
  ,simpleTitleCaseMapping:0x2F85
 },
 { code:0x2F86
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F86
  ,simpleLowerCaseMapping:0x2F86
  ,simpleTitleCaseMapping:0x2F86
 },
 { code:0x2F87
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F87
  ,simpleLowerCaseMapping:0x2F87
  ,simpleTitleCaseMapping:0x2F87
 },
 { code:0x2F88
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F88
  ,simpleLowerCaseMapping:0x2F88
  ,simpleTitleCaseMapping:0x2F88
 },
 { code:0x2F89
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F89
  ,simpleLowerCaseMapping:0x2F89
  ,simpleTitleCaseMapping:0x2F89
 },
 { code:0x2F8A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F8A
  ,simpleLowerCaseMapping:0x2F8A
  ,simpleTitleCaseMapping:0x2F8A
 },
 { code:0x2F8B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F8B
  ,simpleLowerCaseMapping:0x2F8B
  ,simpleTitleCaseMapping:0x2F8B
 },
 { code:0x2F8C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F8C
  ,simpleLowerCaseMapping:0x2F8C
  ,simpleTitleCaseMapping:0x2F8C
 },
 { code:0x2F8D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F8D
  ,simpleLowerCaseMapping:0x2F8D
  ,simpleTitleCaseMapping:0x2F8D
 },
 { code:0x2F8E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F8E
  ,simpleLowerCaseMapping:0x2F8E
  ,simpleTitleCaseMapping:0x2F8E
 },
 { code:0x2F8F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F8F
  ,simpleLowerCaseMapping:0x2F8F
  ,simpleTitleCaseMapping:0x2F8F
 },
 { code:0x2F90
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F90
  ,simpleLowerCaseMapping:0x2F90
  ,simpleTitleCaseMapping:0x2F90
 },
 { code:0x2F91
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F91
  ,simpleLowerCaseMapping:0x2F91
  ,simpleTitleCaseMapping:0x2F91
 },
 { code:0x2F92
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F92
  ,simpleLowerCaseMapping:0x2F92
  ,simpleTitleCaseMapping:0x2F92
 },
 { code:0x2F93
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F93
  ,simpleLowerCaseMapping:0x2F93
  ,simpleTitleCaseMapping:0x2F93
 },
 { code:0x2F94
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F94
  ,simpleLowerCaseMapping:0x2F94
  ,simpleTitleCaseMapping:0x2F94
 },
 { code:0x2F95
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F95
  ,simpleLowerCaseMapping:0x2F95
  ,simpleTitleCaseMapping:0x2F95
 },
 { code:0x2F96
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F96
  ,simpleLowerCaseMapping:0x2F96
  ,simpleTitleCaseMapping:0x2F96
 },
 { code:0x2F97
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F97
  ,simpleLowerCaseMapping:0x2F97
  ,simpleTitleCaseMapping:0x2F97
 },
 { code:0x2F98
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F98
  ,simpleLowerCaseMapping:0x2F98
  ,simpleTitleCaseMapping:0x2F98
 },
 { code:0x2F99
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F99
  ,simpleLowerCaseMapping:0x2F99
  ,simpleTitleCaseMapping:0x2F99
 },
 { code:0x2F9A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F9A
  ,simpleLowerCaseMapping:0x2F9A
  ,simpleTitleCaseMapping:0x2F9A
 },
 { code:0x2F9B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F9B
  ,simpleLowerCaseMapping:0x2F9B
  ,simpleTitleCaseMapping:0x2F9B
 },
 { code:0x2F9C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F9C
  ,simpleLowerCaseMapping:0x2F9C
  ,simpleTitleCaseMapping:0x2F9C
 },
 { code:0x2F9D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F9D
  ,simpleLowerCaseMapping:0x2F9D
  ,simpleTitleCaseMapping:0x2F9D
 },
 { code:0x2F9E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F9E
  ,simpleLowerCaseMapping:0x2F9E
  ,simpleTitleCaseMapping:0x2F9E
 },
 { code:0x2F9F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2F9F
  ,simpleLowerCaseMapping:0x2F9F
  ,simpleTitleCaseMapping:0x2F9F
 },
 { code:0x2FA0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FA0
  ,simpleLowerCaseMapping:0x2FA0
  ,simpleTitleCaseMapping:0x2FA0
 },
 { code:0x2FA1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FA1
  ,simpleLowerCaseMapping:0x2FA1
  ,simpleTitleCaseMapping:0x2FA1
 },
 { code:0x2FA2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FA2
  ,simpleLowerCaseMapping:0x2FA2
  ,simpleTitleCaseMapping:0x2FA2
 },
 { code:0x2FA3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FA3
  ,simpleLowerCaseMapping:0x2FA3
  ,simpleTitleCaseMapping:0x2FA3
 },
 { code:0x2FA4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FA4
  ,simpleLowerCaseMapping:0x2FA4
  ,simpleTitleCaseMapping:0x2FA4
 },
 { code:0x2FA5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FA5
  ,simpleLowerCaseMapping:0x2FA5
  ,simpleTitleCaseMapping:0x2FA5
 },
 { code:0x2FA6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FA6
  ,simpleLowerCaseMapping:0x2FA6
  ,simpleTitleCaseMapping:0x2FA6
 },
 { code:0x2FA7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FA7
  ,simpleLowerCaseMapping:0x2FA7
  ,simpleTitleCaseMapping:0x2FA7
 },
 { code:0x2FA8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FA8
  ,simpleLowerCaseMapping:0x2FA8
  ,simpleTitleCaseMapping:0x2FA8
 },
 { code:0x2FA9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FA9
  ,simpleLowerCaseMapping:0x2FA9
  ,simpleTitleCaseMapping:0x2FA9
 },
 { code:0x2FAA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FAA
  ,simpleLowerCaseMapping:0x2FAA
  ,simpleTitleCaseMapping:0x2FAA
 },
 { code:0x2FAB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FAB
  ,simpleLowerCaseMapping:0x2FAB
  ,simpleTitleCaseMapping:0x2FAB
 },
 { code:0x2FAC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FAC
  ,simpleLowerCaseMapping:0x2FAC
  ,simpleTitleCaseMapping:0x2FAC
 },
 { code:0x2FAD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FAD
  ,simpleLowerCaseMapping:0x2FAD
  ,simpleTitleCaseMapping:0x2FAD
 },
 { code:0x2FAE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FAE
  ,simpleLowerCaseMapping:0x2FAE
  ,simpleTitleCaseMapping:0x2FAE
 },
 { code:0x2FAF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FAF
  ,simpleLowerCaseMapping:0x2FAF
  ,simpleTitleCaseMapping:0x2FAF
 },
 { code:0x2FB0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FB0
  ,simpleLowerCaseMapping:0x2FB0
  ,simpleTitleCaseMapping:0x2FB0
 },
 { code:0x2FB1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FB1
  ,simpleLowerCaseMapping:0x2FB1
  ,simpleTitleCaseMapping:0x2FB1
 },
 { code:0x2FB2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FB2
  ,simpleLowerCaseMapping:0x2FB2
  ,simpleTitleCaseMapping:0x2FB2
 },
 { code:0x2FB3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FB3
  ,simpleLowerCaseMapping:0x2FB3
  ,simpleTitleCaseMapping:0x2FB3
 },
 { code:0x2FB4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FB4
  ,simpleLowerCaseMapping:0x2FB4
  ,simpleTitleCaseMapping:0x2FB4
 },
 { code:0x2FB5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FB5
  ,simpleLowerCaseMapping:0x2FB5
  ,simpleTitleCaseMapping:0x2FB5
 },
 { code:0x2FB6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FB6
  ,simpleLowerCaseMapping:0x2FB6
  ,simpleTitleCaseMapping:0x2FB6
 },
 { code:0x2FB7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FB7
  ,simpleLowerCaseMapping:0x2FB7
  ,simpleTitleCaseMapping:0x2FB7
 },
 { code:0x2FB8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FB8
  ,simpleLowerCaseMapping:0x2FB8
  ,simpleTitleCaseMapping:0x2FB8
 },
 { code:0x2FB9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FB9
  ,simpleLowerCaseMapping:0x2FB9
  ,simpleTitleCaseMapping:0x2FB9
 },
 { code:0x2FBA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FBA
  ,simpleLowerCaseMapping:0x2FBA
  ,simpleTitleCaseMapping:0x2FBA
 },
 { code:0x2FBB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FBB
  ,simpleLowerCaseMapping:0x2FBB
  ,simpleTitleCaseMapping:0x2FBB
 },
 { code:0x2FBC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FBC
  ,simpleLowerCaseMapping:0x2FBC
  ,simpleTitleCaseMapping:0x2FBC
 },
 { code:0x2FBD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FBD
  ,simpleLowerCaseMapping:0x2FBD
  ,simpleTitleCaseMapping:0x2FBD
 },
 { code:0x2FBE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FBE
  ,simpleLowerCaseMapping:0x2FBE
  ,simpleTitleCaseMapping:0x2FBE
 },
 { code:0x2FBF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FBF
  ,simpleLowerCaseMapping:0x2FBF
  ,simpleTitleCaseMapping:0x2FBF
 },
 { code:0x2FC0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FC0
  ,simpleLowerCaseMapping:0x2FC0
  ,simpleTitleCaseMapping:0x2FC0
 },
 { code:0x2FC1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FC1
  ,simpleLowerCaseMapping:0x2FC1
  ,simpleTitleCaseMapping:0x2FC1
 },
 { code:0x2FC2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FC2
  ,simpleLowerCaseMapping:0x2FC2
  ,simpleTitleCaseMapping:0x2FC2
 },
 { code:0x2FC3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FC3
  ,simpleLowerCaseMapping:0x2FC3
  ,simpleTitleCaseMapping:0x2FC3
 },
 { code:0x2FC4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FC4
  ,simpleLowerCaseMapping:0x2FC4
  ,simpleTitleCaseMapping:0x2FC4
 },
 { code:0x2FC5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FC5
  ,simpleLowerCaseMapping:0x2FC5
  ,simpleTitleCaseMapping:0x2FC5
 },
 { code:0x2FC6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FC6
  ,simpleLowerCaseMapping:0x2FC6
  ,simpleTitleCaseMapping:0x2FC6
 },
 { code:0x2FC7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FC7
  ,simpleLowerCaseMapping:0x2FC7
  ,simpleTitleCaseMapping:0x2FC7
 },
 { code:0x2FC8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FC8
  ,simpleLowerCaseMapping:0x2FC8
  ,simpleTitleCaseMapping:0x2FC8
 },
 { code:0x2FC9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FC9
  ,simpleLowerCaseMapping:0x2FC9
  ,simpleTitleCaseMapping:0x2FC9
 },
 { code:0x2FCA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FCA
  ,simpleLowerCaseMapping:0x2FCA
  ,simpleTitleCaseMapping:0x2FCA
 },
 { code:0x2FCB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FCB
  ,simpleLowerCaseMapping:0x2FCB
  ,simpleTitleCaseMapping:0x2FCB
 },
 { code:0x2FCC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FCC
  ,simpleLowerCaseMapping:0x2FCC
  ,simpleTitleCaseMapping:0x2FCC
 },
 { code:0x2FCD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FCD
  ,simpleLowerCaseMapping:0x2FCD
  ,simpleTitleCaseMapping:0x2FCD
 },
 { code:0x2FCE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FCE
  ,simpleLowerCaseMapping:0x2FCE
  ,simpleTitleCaseMapping:0x2FCE
 },
 { code:0x2FCF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FCF
  ,simpleLowerCaseMapping:0x2FCF
  ,simpleTitleCaseMapping:0x2FCF
 },
 { code:0x2FD0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FD0
  ,simpleLowerCaseMapping:0x2FD0
  ,simpleTitleCaseMapping:0x2FD0
 },
 { code:0x2FD1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FD1
  ,simpleLowerCaseMapping:0x2FD1
  ,simpleTitleCaseMapping:0x2FD1
 },
 { code:0x2FD2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FD2
  ,simpleLowerCaseMapping:0x2FD2
  ,simpleTitleCaseMapping:0x2FD2
 },
 { code:0x2FD3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FD3
  ,simpleLowerCaseMapping:0x2FD3
  ,simpleTitleCaseMapping:0x2FD3
 },
 { code:0x2FD4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FD4
  ,simpleLowerCaseMapping:0x2FD4
  ,simpleTitleCaseMapping:0x2FD4
 },
 { code:0x2FD5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FD5
  ,simpleLowerCaseMapping:0x2FD5
  ,simpleTitleCaseMapping:0x2FD5
 },
 { code:0x2FF0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FF0
  ,simpleLowerCaseMapping:0x2FF0
  ,simpleTitleCaseMapping:0x2FF0
 },
 { code:0x2FF1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FF1
  ,simpleLowerCaseMapping:0x2FF1
  ,simpleTitleCaseMapping:0x2FF1
 },
 { code:0x2FF2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FF2
  ,simpleLowerCaseMapping:0x2FF2
  ,simpleTitleCaseMapping:0x2FF2
 },
 { code:0x2FF3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FF3
  ,simpleLowerCaseMapping:0x2FF3
  ,simpleTitleCaseMapping:0x2FF3
 },
 { code:0x2FF4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FF4
  ,simpleLowerCaseMapping:0x2FF4
  ,simpleTitleCaseMapping:0x2FF4
 },
 { code:0x2FF5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FF5
  ,simpleLowerCaseMapping:0x2FF5
  ,simpleTitleCaseMapping:0x2FF5
 },
 { code:0x2FF6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FF6
  ,simpleLowerCaseMapping:0x2FF6
  ,simpleTitleCaseMapping:0x2FF6
 },
 { code:0x2FF7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FF7
  ,simpleLowerCaseMapping:0x2FF7
  ,simpleTitleCaseMapping:0x2FF7
 },
 { code:0x2FF8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FF8
  ,simpleLowerCaseMapping:0x2FF8
  ,simpleTitleCaseMapping:0x2FF8
 },
 { code:0x2FF9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FF9
  ,simpleLowerCaseMapping:0x2FF9
  ,simpleTitleCaseMapping:0x2FF9
 },
 { code:0x2FFA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FFA
  ,simpleLowerCaseMapping:0x2FFA
  ,simpleTitleCaseMapping:0x2FFA
 },
 { code:0x2FFB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x2FFB
  ,simpleLowerCaseMapping:0x2FFB
  ,simpleTitleCaseMapping:0x2FFB
 },
 { code:0x3000
  ,generalCategory:UnicodeData.GeneralCategory.Zs
  ,simpleUpperCaseMapping:0x3000
  ,simpleLowerCaseMapping:0x3000
  ,simpleTitleCaseMapping:0x3000
 },
 { code:0x3001
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x3001
  ,simpleLowerCaseMapping:0x3001
  ,simpleTitleCaseMapping:0x3001
 },
 { code:0x3002
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x3002
  ,simpleLowerCaseMapping:0x3002
  ,simpleTitleCaseMapping:0x3002
 },
 { code:0x3003
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x3003
  ,simpleLowerCaseMapping:0x3003
  ,simpleTitleCaseMapping:0x3003
 },
 { code:0x3004
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3004
  ,simpleLowerCaseMapping:0x3004
  ,simpleTitleCaseMapping:0x3004
 },
 { code:0x3005
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x3005
  ,simpleLowerCaseMapping:0x3005
  ,simpleTitleCaseMapping:0x3005
 },
 { code:0x3006
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3006
  ,simpleLowerCaseMapping:0x3006
  ,simpleTitleCaseMapping:0x3006
 },
 { code:0x3007
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x3007
  ,simpleLowerCaseMapping:0x3007
  ,simpleTitleCaseMapping:0x3007
 },
 { code:0x3008
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x3008
  ,simpleLowerCaseMapping:0x3008
  ,simpleTitleCaseMapping:0x3008
 },
 { code:0x3009
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x3009
  ,simpleLowerCaseMapping:0x3009
  ,simpleTitleCaseMapping:0x3009
 },
 { code:0x300A
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x300A
  ,simpleLowerCaseMapping:0x300A
  ,simpleTitleCaseMapping:0x300A
 },
 { code:0x300B
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x300B
  ,simpleLowerCaseMapping:0x300B
  ,simpleTitleCaseMapping:0x300B
 },
 { code:0x300C
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x300C
  ,simpleLowerCaseMapping:0x300C
  ,simpleTitleCaseMapping:0x300C
 },
 { code:0x300D
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x300D
  ,simpleLowerCaseMapping:0x300D
  ,simpleTitleCaseMapping:0x300D
 },
 { code:0x300E
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x300E
  ,simpleLowerCaseMapping:0x300E
  ,simpleTitleCaseMapping:0x300E
 },
 { code:0x300F
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x300F
  ,simpleLowerCaseMapping:0x300F
  ,simpleTitleCaseMapping:0x300F
 },
 { code:0x3010
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x3010
  ,simpleLowerCaseMapping:0x3010
  ,simpleTitleCaseMapping:0x3010
 },
 { code:0x3011
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x3011
  ,simpleLowerCaseMapping:0x3011
  ,simpleTitleCaseMapping:0x3011
 },
 { code:0x3012
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3012
  ,simpleLowerCaseMapping:0x3012
  ,simpleTitleCaseMapping:0x3012
 },
 { code:0x3013
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3013
  ,simpleLowerCaseMapping:0x3013
  ,simpleTitleCaseMapping:0x3013
 },
 { code:0x3014
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x3014
  ,simpleLowerCaseMapping:0x3014
  ,simpleTitleCaseMapping:0x3014
 },
 { code:0x3015
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x3015
  ,simpleLowerCaseMapping:0x3015
  ,simpleTitleCaseMapping:0x3015
 },
 { code:0x3016
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x3016
  ,simpleLowerCaseMapping:0x3016
  ,simpleTitleCaseMapping:0x3016
 },
 { code:0x3017
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x3017
  ,simpleLowerCaseMapping:0x3017
  ,simpleTitleCaseMapping:0x3017
 },
 { code:0x3018
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x3018
  ,simpleLowerCaseMapping:0x3018
  ,simpleTitleCaseMapping:0x3018
 },
 { code:0x3019
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x3019
  ,simpleLowerCaseMapping:0x3019
  ,simpleTitleCaseMapping:0x3019
 },
 { code:0x301A
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x301A
  ,simpleLowerCaseMapping:0x301A
  ,simpleTitleCaseMapping:0x301A
 },
 { code:0x301B
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x301B
  ,simpleLowerCaseMapping:0x301B
  ,simpleTitleCaseMapping:0x301B
 },
 { code:0x301C
  ,generalCategory:UnicodeData.GeneralCategory.Pd
  ,simpleUpperCaseMapping:0x301C
  ,simpleLowerCaseMapping:0x301C
  ,simpleTitleCaseMapping:0x301C
 },
 { code:0x301D
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0x301D
  ,simpleLowerCaseMapping:0x301D
  ,simpleTitleCaseMapping:0x301D
 },
 { code:0x301E
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x301E
  ,simpleLowerCaseMapping:0x301E
  ,simpleTitleCaseMapping:0x301E
 },
 { code:0x301F
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0x301F
  ,simpleLowerCaseMapping:0x301F
  ,simpleTitleCaseMapping:0x301F
 },
 { code:0x3020
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3020
  ,simpleLowerCaseMapping:0x3020
  ,simpleTitleCaseMapping:0x3020
 },
 { code:0x3021
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x3021
  ,simpleLowerCaseMapping:0x3021
  ,simpleTitleCaseMapping:0x3021
 },
 { code:0x3022
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x3022
  ,simpleLowerCaseMapping:0x3022
  ,simpleTitleCaseMapping:0x3022
 },
 { code:0x3023
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x3023
  ,simpleLowerCaseMapping:0x3023
  ,simpleTitleCaseMapping:0x3023
 },
 { code:0x3024
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x3024
  ,simpleLowerCaseMapping:0x3024
  ,simpleTitleCaseMapping:0x3024
 },
 { code:0x3025
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x3025
  ,simpleLowerCaseMapping:0x3025
  ,simpleTitleCaseMapping:0x3025
 },
 { code:0x3026
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x3026
  ,simpleLowerCaseMapping:0x3026
  ,simpleTitleCaseMapping:0x3026
 },
 { code:0x3027
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x3027
  ,simpleLowerCaseMapping:0x3027
  ,simpleTitleCaseMapping:0x3027
 },
 { code:0x3028
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x3028
  ,simpleLowerCaseMapping:0x3028
  ,simpleTitleCaseMapping:0x3028
 },
 { code:0x3029
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x3029
  ,simpleLowerCaseMapping:0x3029
  ,simpleTitleCaseMapping:0x3029
 },
 { code:0x302A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x302A
  ,simpleLowerCaseMapping:0x302A
  ,simpleTitleCaseMapping:0x302A
 },
 { code:0x302B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x302B
  ,simpleLowerCaseMapping:0x302B
  ,simpleTitleCaseMapping:0x302B
 },
 { code:0x302C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x302C
  ,simpleLowerCaseMapping:0x302C
  ,simpleTitleCaseMapping:0x302C
 },
 { code:0x302D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x302D
  ,simpleLowerCaseMapping:0x302D
  ,simpleTitleCaseMapping:0x302D
 },
 { code:0x302E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x302E
  ,simpleLowerCaseMapping:0x302E
  ,simpleTitleCaseMapping:0x302E
 },
 { code:0x302F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x302F
  ,simpleLowerCaseMapping:0x302F
  ,simpleTitleCaseMapping:0x302F
 },
 { code:0x3030
  ,generalCategory:UnicodeData.GeneralCategory.Pd
  ,simpleUpperCaseMapping:0x3030
  ,simpleLowerCaseMapping:0x3030
  ,simpleTitleCaseMapping:0x3030
 },
 { code:0x3031
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x3031
  ,simpleLowerCaseMapping:0x3031
  ,simpleTitleCaseMapping:0x3031
 },
 { code:0x3032
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x3032
  ,simpleLowerCaseMapping:0x3032
  ,simpleTitleCaseMapping:0x3032
 },
 { code:0x3033
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x3033
  ,simpleLowerCaseMapping:0x3033
  ,simpleTitleCaseMapping:0x3033
 },
 { code:0x3034
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x3034
  ,simpleLowerCaseMapping:0x3034
  ,simpleTitleCaseMapping:0x3034
 },
 { code:0x3035
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x3035
  ,simpleLowerCaseMapping:0x3035
  ,simpleTitleCaseMapping:0x3035
 },
 { code:0x3036
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3036
  ,simpleLowerCaseMapping:0x3036
  ,simpleTitleCaseMapping:0x3036
 },
 { code:0x3037
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3037
  ,simpleLowerCaseMapping:0x3037
  ,simpleTitleCaseMapping:0x3037
 },
 { code:0x3038
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x3038
  ,simpleLowerCaseMapping:0x3038
  ,simpleTitleCaseMapping:0x3038
 },
 { code:0x3039
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x3039
  ,simpleLowerCaseMapping:0x3039
  ,simpleTitleCaseMapping:0x3039
 },
 { code:0x303A
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x303A
  ,simpleLowerCaseMapping:0x303A
  ,simpleTitleCaseMapping:0x303A
 },
 { code:0x303B
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x303B
  ,simpleLowerCaseMapping:0x303B
  ,simpleTitleCaseMapping:0x303B
 },
 { code:0x303C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x303C
  ,simpleLowerCaseMapping:0x303C
  ,simpleTitleCaseMapping:0x303C
 },
 { code:0x303D
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x303D
  ,simpleLowerCaseMapping:0x303D
  ,simpleTitleCaseMapping:0x303D
 },
 { code:0x303E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x303E
  ,simpleLowerCaseMapping:0x303E
  ,simpleTitleCaseMapping:0x303E
 },
 { code:0x303F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x303F
  ,simpleLowerCaseMapping:0x303F
  ,simpleTitleCaseMapping:0x303F
 },
 { code:0x3041
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3041
  ,simpleLowerCaseMapping:0x3041
  ,simpleTitleCaseMapping:0x3041
 },
 { code:0x3042
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3042
  ,simpleLowerCaseMapping:0x3042
  ,simpleTitleCaseMapping:0x3042
 },
 { code:0x3043
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3043
  ,simpleLowerCaseMapping:0x3043
  ,simpleTitleCaseMapping:0x3043
 },
 { code:0x3044
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3044
  ,simpleLowerCaseMapping:0x3044
  ,simpleTitleCaseMapping:0x3044
 },
 { code:0x3045
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3045
  ,simpleLowerCaseMapping:0x3045
  ,simpleTitleCaseMapping:0x3045
 },
 { code:0x3046
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3046
  ,simpleLowerCaseMapping:0x3046
  ,simpleTitleCaseMapping:0x3046
 },
 { code:0x3047
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3047
  ,simpleLowerCaseMapping:0x3047
  ,simpleTitleCaseMapping:0x3047
 },
 { code:0x3048
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3048
  ,simpleLowerCaseMapping:0x3048
  ,simpleTitleCaseMapping:0x3048
 },
 { code:0x3049
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3049
  ,simpleLowerCaseMapping:0x3049
  ,simpleTitleCaseMapping:0x3049
 },
 { code:0x304A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x304A
  ,simpleLowerCaseMapping:0x304A
  ,simpleTitleCaseMapping:0x304A
 },
 { code:0x304B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x304B
  ,simpleLowerCaseMapping:0x304B
  ,simpleTitleCaseMapping:0x304B
 },
 { code:0x304C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x304C
  ,simpleLowerCaseMapping:0x304C
  ,simpleTitleCaseMapping:0x304C
 },
 { code:0x304D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x304D
  ,simpleLowerCaseMapping:0x304D
  ,simpleTitleCaseMapping:0x304D
 },
 { code:0x304E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x304E
  ,simpleLowerCaseMapping:0x304E
  ,simpleTitleCaseMapping:0x304E
 },
 { code:0x304F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x304F
  ,simpleLowerCaseMapping:0x304F
  ,simpleTitleCaseMapping:0x304F
 },
 { code:0x3050
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3050
  ,simpleLowerCaseMapping:0x3050
  ,simpleTitleCaseMapping:0x3050
 },
 { code:0x3051
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3051
  ,simpleLowerCaseMapping:0x3051
  ,simpleTitleCaseMapping:0x3051
 },
 { code:0x3052
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3052
  ,simpleLowerCaseMapping:0x3052
  ,simpleTitleCaseMapping:0x3052
 },
 { code:0x3053
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3053
  ,simpleLowerCaseMapping:0x3053
  ,simpleTitleCaseMapping:0x3053
 },
 { code:0x3054
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3054
  ,simpleLowerCaseMapping:0x3054
  ,simpleTitleCaseMapping:0x3054
 },
 { code:0x3055
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3055
  ,simpleLowerCaseMapping:0x3055
  ,simpleTitleCaseMapping:0x3055
 },
 { code:0x3056
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3056
  ,simpleLowerCaseMapping:0x3056
  ,simpleTitleCaseMapping:0x3056
 },
 { code:0x3057
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3057
  ,simpleLowerCaseMapping:0x3057
  ,simpleTitleCaseMapping:0x3057
 },
 { code:0x3058
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3058
  ,simpleLowerCaseMapping:0x3058
  ,simpleTitleCaseMapping:0x3058
 },
 { code:0x3059
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3059
  ,simpleLowerCaseMapping:0x3059
  ,simpleTitleCaseMapping:0x3059
 },
 { code:0x305A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x305A
  ,simpleLowerCaseMapping:0x305A
  ,simpleTitleCaseMapping:0x305A
 },
 { code:0x305B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x305B
  ,simpleLowerCaseMapping:0x305B
  ,simpleTitleCaseMapping:0x305B
 },
 { code:0x305C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x305C
  ,simpleLowerCaseMapping:0x305C
  ,simpleTitleCaseMapping:0x305C
 },
 { code:0x305D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x305D
  ,simpleLowerCaseMapping:0x305D
  ,simpleTitleCaseMapping:0x305D
 },
 { code:0x305E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x305E
  ,simpleLowerCaseMapping:0x305E
  ,simpleTitleCaseMapping:0x305E
 },
 { code:0x305F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x305F
  ,simpleLowerCaseMapping:0x305F
  ,simpleTitleCaseMapping:0x305F
 },
 { code:0x3060
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3060
  ,simpleLowerCaseMapping:0x3060
  ,simpleTitleCaseMapping:0x3060
 },
 { code:0x3061
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3061
  ,simpleLowerCaseMapping:0x3061
  ,simpleTitleCaseMapping:0x3061
 },
 { code:0x3062
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3062
  ,simpleLowerCaseMapping:0x3062
  ,simpleTitleCaseMapping:0x3062
 },
 { code:0x3063
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3063
  ,simpleLowerCaseMapping:0x3063
  ,simpleTitleCaseMapping:0x3063
 },
 { code:0x3064
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3064
  ,simpleLowerCaseMapping:0x3064
  ,simpleTitleCaseMapping:0x3064
 },
 { code:0x3065
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3065
  ,simpleLowerCaseMapping:0x3065
  ,simpleTitleCaseMapping:0x3065
 },
 { code:0x3066
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3066
  ,simpleLowerCaseMapping:0x3066
  ,simpleTitleCaseMapping:0x3066
 },
 { code:0x3067
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3067
  ,simpleLowerCaseMapping:0x3067
  ,simpleTitleCaseMapping:0x3067
 },
 { code:0x3068
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3068
  ,simpleLowerCaseMapping:0x3068
  ,simpleTitleCaseMapping:0x3068
 },
 { code:0x3069
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3069
  ,simpleLowerCaseMapping:0x3069
  ,simpleTitleCaseMapping:0x3069
 },
 { code:0x306A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x306A
  ,simpleLowerCaseMapping:0x306A
  ,simpleTitleCaseMapping:0x306A
 },
 { code:0x306B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x306B
  ,simpleLowerCaseMapping:0x306B
  ,simpleTitleCaseMapping:0x306B
 },
 { code:0x306C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x306C
  ,simpleLowerCaseMapping:0x306C
  ,simpleTitleCaseMapping:0x306C
 },
 { code:0x306D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x306D
  ,simpleLowerCaseMapping:0x306D
  ,simpleTitleCaseMapping:0x306D
 },
 { code:0x306E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x306E
  ,simpleLowerCaseMapping:0x306E
  ,simpleTitleCaseMapping:0x306E
 },
 { code:0x306F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x306F
  ,simpleLowerCaseMapping:0x306F
  ,simpleTitleCaseMapping:0x306F
 },
 { code:0x3070
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3070
  ,simpleLowerCaseMapping:0x3070
  ,simpleTitleCaseMapping:0x3070
 },
 { code:0x3071
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3071
  ,simpleLowerCaseMapping:0x3071
  ,simpleTitleCaseMapping:0x3071
 },
 { code:0x3072
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3072
  ,simpleLowerCaseMapping:0x3072
  ,simpleTitleCaseMapping:0x3072
 },
 { code:0x3073
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3073
  ,simpleLowerCaseMapping:0x3073
  ,simpleTitleCaseMapping:0x3073
 },
 { code:0x3074
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3074
  ,simpleLowerCaseMapping:0x3074
  ,simpleTitleCaseMapping:0x3074
 },
 { code:0x3075
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3075
  ,simpleLowerCaseMapping:0x3075
  ,simpleTitleCaseMapping:0x3075
 },
 { code:0x3076
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3076
  ,simpleLowerCaseMapping:0x3076
  ,simpleTitleCaseMapping:0x3076
 },
 { code:0x3077
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3077
  ,simpleLowerCaseMapping:0x3077
  ,simpleTitleCaseMapping:0x3077
 },
 { code:0x3078
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3078
  ,simpleLowerCaseMapping:0x3078
  ,simpleTitleCaseMapping:0x3078
 },
 { code:0x3079
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3079
  ,simpleLowerCaseMapping:0x3079
  ,simpleTitleCaseMapping:0x3079
 },
 { code:0x307A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x307A
  ,simpleLowerCaseMapping:0x307A
  ,simpleTitleCaseMapping:0x307A
 },
 { code:0x307B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x307B
  ,simpleLowerCaseMapping:0x307B
  ,simpleTitleCaseMapping:0x307B
 },
 { code:0x307C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x307C
  ,simpleLowerCaseMapping:0x307C
  ,simpleTitleCaseMapping:0x307C
 },
 { code:0x307D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x307D
  ,simpleLowerCaseMapping:0x307D
  ,simpleTitleCaseMapping:0x307D
 },
 { code:0x307E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x307E
  ,simpleLowerCaseMapping:0x307E
  ,simpleTitleCaseMapping:0x307E
 },
 { code:0x307F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x307F
  ,simpleLowerCaseMapping:0x307F
  ,simpleTitleCaseMapping:0x307F
 },
 { code:0x3080
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3080
  ,simpleLowerCaseMapping:0x3080
  ,simpleTitleCaseMapping:0x3080
 },
 { code:0x3081
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3081
  ,simpleLowerCaseMapping:0x3081
  ,simpleTitleCaseMapping:0x3081
 },
 { code:0x3082
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3082
  ,simpleLowerCaseMapping:0x3082
  ,simpleTitleCaseMapping:0x3082
 },
 { code:0x3083
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3083
  ,simpleLowerCaseMapping:0x3083
  ,simpleTitleCaseMapping:0x3083
 },
 { code:0x3084
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3084
  ,simpleLowerCaseMapping:0x3084
  ,simpleTitleCaseMapping:0x3084
 },
 { code:0x3085
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3085
  ,simpleLowerCaseMapping:0x3085
  ,simpleTitleCaseMapping:0x3085
 },
 { code:0x3086
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3086
  ,simpleLowerCaseMapping:0x3086
  ,simpleTitleCaseMapping:0x3086
 },
 { code:0x3087
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3087
  ,simpleLowerCaseMapping:0x3087
  ,simpleTitleCaseMapping:0x3087
 },
 { code:0x3088
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3088
  ,simpleLowerCaseMapping:0x3088
  ,simpleTitleCaseMapping:0x3088
 },
 { code:0x3089
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3089
  ,simpleLowerCaseMapping:0x3089
  ,simpleTitleCaseMapping:0x3089
 },
 { code:0x308A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x308A
  ,simpleLowerCaseMapping:0x308A
  ,simpleTitleCaseMapping:0x308A
 },
 { code:0x308B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x308B
  ,simpleLowerCaseMapping:0x308B
  ,simpleTitleCaseMapping:0x308B
 },
 { code:0x308C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x308C
  ,simpleLowerCaseMapping:0x308C
  ,simpleTitleCaseMapping:0x308C
 },
 { code:0x308D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x308D
  ,simpleLowerCaseMapping:0x308D
  ,simpleTitleCaseMapping:0x308D
 },
 { code:0x308E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x308E
  ,simpleLowerCaseMapping:0x308E
  ,simpleTitleCaseMapping:0x308E
 },
 { code:0x308F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x308F
  ,simpleLowerCaseMapping:0x308F
  ,simpleTitleCaseMapping:0x308F
 },
 { code:0x3090
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3090
  ,simpleLowerCaseMapping:0x3090
  ,simpleTitleCaseMapping:0x3090
 },
 { code:0x3091
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3091
  ,simpleLowerCaseMapping:0x3091
  ,simpleTitleCaseMapping:0x3091
 },
 { code:0x3092
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3092
  ,simpleLowerCaseMapping:0x3092
  ,simpleTitleCaseMapping:0x3092
 },
 { code:0x3093
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3093
  ,simpleLowerCaseMapping:0x3093
  ,simpleTitleCaseMapping:0x3093
 },
 { code:0x3094
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3094
  ,simpleLowerCaseMapping:0x3094
  ,simpleTitleCaseMapping:0x3094
 },
 { code:0x3095
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3095
  ,simpleLowerCaseMapping:0x3095
  ,simpleTitleCaseMapping:0x3095
 },
 { code:0x3096
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3096
  ,simpleLowerCaseMapping:0x3096
  ,simpleTitleCaseMapping:0x3096
 },
 { code:0x3099
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x3099
  ,simpleLowerCaseMapping:0x3099
  ,simpleTitleCaseMapping:0x3099
 },
 { code:0x309A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x309A
  ,simpleLowerCaseMapping:0x309A
  ,simpleTitleCaseMapping:0x309A
 },
 { code:0x309B
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x309B
  ,simpleLowerCaseMapping:0x309B
  ,simpleTitleCaseMapping:0x309B
 },
 { code:0x309C
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0x309C
  ,simpleLowerCaseMapping:0x309C
  ,simpleTitleCaseMapping:0x309C
 },
 { code:0x309D
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x309D
  ,simpleLowerCaseMapping:0x309D
  ,simpleTitleCaseMapping:0x309D
 },
 { code:0x309E
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x309E
  ,simpleLowerCaseMapping:0x309E
  ,simpleTitleCaseMapping:0x309E
 },
 { code:0x309F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x309F
  ,simpleLowerCaseMapping:0x309F
  ,simpleTitleCaseMapping:0x309F
 },
 { code:0x30A0
  ,generalCategory:UnicodeData.GeneralCategory.Pd
  ,simpleUpperCaseMapping:0x30A0
  ,simpleLowerCaseMapping:0x30A0
  ,simpleTitleCaseMapping:0x30A0
 },
 { code:0x30A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30A1
  ,simpleLowerCaseMapping:0x30A1
  ,simpleTitleCaseMapping:0x30A1
 },
 { code:0x30A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30A2
  ,simpleLowerCaseMapping:0x30A2
  ,simpleTitleCaseMapping:0x30A2
 },
 { code:0x30A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30A3
  ,simpleLowerCaseMapping:0x30A3
  ,simpleTitleCaseMapping:0x30A3
 },
 { code:0x30A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30A4
  ,simpleLowerCaseMapping:0x30A4
  ,simpleTitleCaseMapping:0x30A4
 },
 { code:0x30A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30A5
  ,simpleLowerCaseMapping:0x30A5
  ,simpleTitleCaseMapping:0x30A5
 },
 { code:0x30A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30A6
  ,simpleLowerCaseMapping:0x30A6
  ,simpleTitleCaseMapping:0x30A6
 },
 { code:0x30A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30A7
  ,simpleLowerCaseMapping:0x30A7
  ,simpleTitleCaseMapping:0x30A7
 },
 { code:0x30A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30A8
  ,simpleLowerCaseMapping:0x30A8
  ,simpleTitleCaseMapping:0x30A8
 },
 { code:0x30A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30A9
  ,simpleLowerCaseMapping:0x30A9
  ,simpleTitleCaseMapping:0x30A9
 },
 { code:0x30AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30AA
  ,simpleLowerCaseMapping:0x30AA
  ,simpleTitleCaseMapping:0x30AA
 },
 { code:0x30AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30AB
  ,simpleLowerCaseMapping:0x30AB
  ,simpleTitleCaseMapping:0x30AB
 },
 { code:0x30AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30AC
  ,simpleLowerCaseMapping:0x30AC
  ,simpleTitleCaseMapping:0x30AC
 },
 { code:0x30AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30AD
  ,simpleLowerCaseMapping:0x30AD
  ,simpleTitleCaseMapping:0x30AD
 },
 { code:0x30AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30AE
  ,simpleLowerCaseMapping:0x30AE
  ,simpleTitleCaseMapping:0x30AE
 },
 { code:0x30AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30AF
  ,simpleLowerCaseMapping:0x30AF
  ,simpleTitleCaseMapping:0x30AF
 },
 { code:0x30B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30B0
  ,simpleLowerCaseMapping:0x30B0
  ,simpleTitleCaseMapping:0x30B0
 },
 { code:0x30B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30B1
  ,simpleLowerCaseMapping:0x30B1
  ,simpleTitleCaseMapping:0x30B1
 },
 { code:0x30B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30B2
  ,simpleLowerCaseMapping:0x30B2
  ,simpleTitleCaseMapping:0x30B2
 },
 { code:0x30B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30B3
  ,simpleLowerCaseMapping:0x30B3
  ,simpleTitleCaseMapping:0x30B3
 },
 { code:0x30B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30B4
  ,simpleLowerCaseMapping:0x30B4
  ,simpleTitleCaseMapping:0x30B4
 },
 { code:0x30B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30B5
  ,simpleLowerCaseMapping:0x30B5
  ,simpleTitleCaseMapping:0x30B5
 },
 { code:0x30B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30B6
  ,simpleLowerCaseMapping:0x30B6
  ,simpleTitleCaseMapping:0x30B6
 },
 { code:0x30B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30B7
  ,simpleLowerCaseMapping:0x30B7
  ,simpleTitleCaseMapping:0x30B7
 },
 { code:0x30B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30B8
  ,simpleLowerCaseMapping:0x30B8
  ,simpleTitleCaseMapping:0x30B8
 },
 { code:0x30B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30B9
  ,simpleLowerCaseMapping:0x30B9
  ,simpleTitleCaseMapping:0x30B9
 },
 { code:0x30BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30BA
  ,simpleLowerCaseMapping:0x30BA
  ,simpleTitleCaseMapping:0x30BA
 },
 { code:0x30BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30BB
  ,simpleLowerCaseMapping:0x30BB
  ,simpleTitleCaseMapping:0x30BB
 },
 { code:0x30BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30BC
  ,simpleLowerCaseMapping:0x30BC
  ,simpleTitleCaseMapping:0x30BC
 },
 { code:0x30BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30BD
  ,simpleLowerCaseMapping:0x30BD
  ,simpleTitleCaseMapping:0x30BD
 },
 { code:0x30BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30BE
  ,simpleLowerCaseMapping:0x30BE
  ,simpleTitleCaseMapping:0x30BE
 },
 { code:0x30BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30BF
  ,simpleLowerCaseMapping:0x30BF
  ,simpleTitleCaseMapping:0x30BF
 },
 { code:0x30C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30C0
  ,simpleLowerCaseMapping:0x30C0
  ,simpleTitleCaseMapping:0x30C0
 },
 { code:0x30C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30C1
  ,simpleLowerCaseMapping:0x30C1
  ,simpleTitleCaseMapping:0x30C1
 },
 { code:0x30C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30C2
  ,simpleLowerCaseMapping:0x30C2
  ,simpleTitleCaseMapping:0x30C2
 },
 { code:0x30C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30C3
  ,simpleLowerCaseMapping:0x30C3
  ,simpleTitleCaseMapping:0x30C3
 },
 { code:0x30C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30C4
  ,simpleLowerCaseMapping:0x30C4
  ,simpleTitleCaseMapping:0x30C4
 },
 { code:0x30C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30C5
  ,simpleLowerCaseMapping:0x30C5
  ,simpleTitleCaseMapping:0x30C5
 },
 { code:0x30C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30C6
  ,simpleLowerCaseMapping:0x30C6
  ,simpleTitleCaseMapping:0x30C6
 },
 { code:0x30C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30C7
  ,simpleLowerCaseMapping:0x30C7
  ,simpleTitleCaseMapping:0x30C7
 },
 { code:0x30C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30C8
  ,simpleLowerCaseMapping:0x30C8
  ,simpleTitleCaseMapping:0x30C8
 },
 { code:0x30C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30C9
  ,simpleLowerCaseMapping:0x30C9
  ,simpleTitleCaseMapping:0x30C9
 },
 { code:0x30CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30CA
  ,simpleLowerCaseMapping:0x30CA
  ,simpleTitleCaseMapping:0x30CA
 },
 { code:0x30CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30CB
  ,simpleLowerCaseMapping:0x30CB
  ,simpleTitleCaseMapping:0x30CB
 },
 { code:0x30CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30CC
  ,simpleLowerCaseMapping:0x30CC
  ,simpleTitleCaseMapping:0x30CC
 },
 { code:0x30CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30CD
  ,simpleLowerCaseMapping:0x30CD
  ,simpleTitleCaseMapping:0x30CD
 },
 { code:0x30CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30CE
  ,simpleLowerCaseMapping:0x30CE
  ,simpleTitleCaseMapping:0x30CE
 },
 { code:0x30CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30CF
  ,simpleLowerCaseMapping:0x30CF
  ,simpleTitleCaseMapping:0x30CF
 },
 { code:0x30D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30D0
  ,simpleLowerCaseMapping:0x30D0
  ,simpleTitleCaseMapping:0x30D0
 },
 { code:0x30D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30D1
  ,simpleLowerCaseMapping:0x30D1
  ,simpleTitleCaseMapping:0x30D1
 },
 { code:0x30D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30D2
  ,simpleLowerCaseMapping:0x30D2
  ,simpleTitleCaseMapping:0x30D2
 },
 { code:0x30D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30D3
  ,simpleLowerCaseMapping:0x30D3
  ,simpleTitleCaseMapping:0x30D3
 },
 { code:0x30D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30D4
  ,simpleLowerCaseMapping:0x30D4
  ,simpleTitleCaseMapping:0x30D4
 },
 { code:0x30D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30D5
  ,simpleLowerCaseMapping:0x30D5
  ,simpleTitleCaseMapping:0x30D5
 },
 { code:0x30D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30D6
  ,simpleLowerCaseMapping:0x30D6
  ,simpleTitleCaseMapping:0x30D6
 },
 { code:0x30D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30D7
  ,simpleLowerCaseMapping:0x30D7
  ,simpleTitleCaseMapping:0x30D7
 },
 { code:0x30D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30D8
  ,simpleLowerCaseMapping:0x30D8
  ,simpleTitleCaseMapping:0x30D8
 },
 { code:0x30D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30D9
  ,simpleLowerCaseMapping:0x30D9
  ,simpleTitleCaseMapping:0x30D9
 },
 { code:0x30DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30DA
  ,simpleLowerCaseMapping:0x30DA
  ,simpleTitleCaseMapping:0x30DA
 },
 { code:0x30DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30DB
  ,simpleLowerCaseMapping:0x30DB
  ,simpleTitleCaseMapping:0x30DB
 },
 { code:0x30DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30DC
  ,simpleLowerCaseMapping:0x30DC
  ,simpleTitleCaseMapping:0x30DC
 },
 { code:0x30DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30DD
  ,simpleLowerCaseMapping:0x30DD
  ,simpleTitleCaseMapping:0x30DD
 },
 { code:0x30DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30DE
  ,simpleLowerCaseMapping:0x30DE
  ,simpleTitleCaseMapping:0x30DE
 },
 { code:0x30DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30DF
  ,simpleLowerCaseMapping:0x30DF
  ,simpleTitleCaseMapping:0x30DF
 },
 { code:0x30E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30E0
  ,simpleLowerCaseMapping:0x30E0
  ,simpleTitleCaseMapping:0x30E0
 },
 { code:0x30E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30E1
  ,simpleLowerCaseMapping:0x30E1
  ,simpleTitleCaseMapping:0x30E1
 },
 { code:0x30E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30E2
  ,simpleLowerCaseMapping:0x30E2
  ,simpleTitleCaseMapping:0x30E2
 },
 { code:0x30E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30E3
  ,simpleLowerCaseMapping:0x30E3
  ,simpleTitleCaseMapping:0x30E3
 },
 { code:0x30E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30E4
  ,simpleLowerCaseMapping:0x30E4
  ,simpleTitleCaseMapping:0x30E4
 },
 { code:0x30E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30E5
  ,simpleLowerCaseMapping:0x30E5
  ,simpleTitleCaseMapping:0x30E5
 },
 { code:0x30E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30E6
  ,simpleLowerCaseMapping:0x30E6
  ,simpleTitleCaseMapping:0x30E6
 },
 { code:0x30E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30E7
  ,simpleLowerCaseMapping:0x30E7
  ,simpleTitleCaseMapping:0x30E7
 },
 { code:0x30E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30E8
  ,simpleLowerCaseMapping:0x30E8
  ,simpleTitleCaseMapping:0x30E8
 },
 { code:0x30E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30E9
  ,simpleLowerCaseMapping:0x30E9
  ,simpleTitleCaseMapping:0x30E9
 },
 { code:0x30EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30EA
  ,simpleLowerCaseMapping:0x30EA
  ,simpleTitleCaseMapping:0x30EA
 },
 { code:0x30EB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30EB
  ,simpleLowerCaseMapping:0x30EB
  ,simpleTitleCaseMapping:0x30EB
 },
 { code:0x30EC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30EC
  ,simpleLowerCaseMapping:0x30EC
  ,simpleTitleCaseMapping:0x30EC
 },
 { code:0x30ED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30ED
  ,simpleLowerCaseMapping:0x30ED
  ,simpleTitleCaseMapping:0x30ED
 },
 { code:0x30EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30EE
  ,simpleLowerCaseMapping:0x30EE
  ,simpleTitleCaseMapping:0x30EE
 },
 { code:0x30EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30EF
  ,simpleLowerCaseMapping:0x30EF
  ,simpleTitleCaseMapping:0x30EF
 },
 { code:0x30F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30F0
  ,simpleLowerCaseMapping:0x30F0
  ,simpleTitleCaseMapping:0x30F0
 },
 { code:0x30F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30F1
  ,simpleLowerCaseMapping:0x30F1
  ,simpleTitleCaseMapping:0x30F1
 },
 { code:0x30F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30F2
  ,simpleLowerCaseMapping:0x30F2
  ,simpleTitleCaseMapping:0x30F2
 },
 { code:0x30F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30F3
  ,simpleLowerCaseMapping:0x30F3
  ,simpleTitleCaseMapping:0x30F3
 },
 { code:0x30F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30F4
  ,simpleLowerCaseMapping:0x30F4
  ,simpleTitleCaseMapping:0x30F4
 },
 { code:0x30F5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30F5
  ,simpleLowerCaseMapping:0x30F5
  ,simpleTitleCaseMapping:0x30F5
 },
 { code:0x30F6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30F6
  ,simpleLowerCaseMapping:0x30F6
  ,simpleTitleCaseMapping:0x30F6
 },
 { code:0x30F7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30F7
  ,simpleLowerCaseMapping:0x30F7
  ,simpleTitleCaseMapping:0x30F7
 },
 { code:0x30F8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30F8
  ,simpleLowerCaseMapping:0x30F8
  ,simpleTitleCaseMapping:0x30F8
 },
 { code:0x30F9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30F9
  ,simpleLowerCaseMapping:0x30F9
  ,simpleTitleCaseMapping:0x30F9
 },
 { code:0x30FA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30FA
  ,simpleLowerCaseMapping:0x30FA
  ,simpleTitleCaseMapping:0x30FA
 },
 { code:0x30FB
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x30FB
  ,simpleLowerCaseMapping:0x30FB
  ,simpleTitleCaseMapping:0x30FB
 },
 { code:0x30FC
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x30FC
  ,simpleLowerCaseMapping:0x30FC
  ,simpleTitleCaseMapping:0x30FC
 },
 { code:0x30FD
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x30FD
  ,simpleLowerCaseMapping:0x30FD
  ,simpleTitleCaseMapping:0x30FD
 },
 { code:0x30FE
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0x30FE
  ,simpleLowerCaseMapping:0x30FE
  ,simpleTitleCaseMapping:0x30FE
 },
 { code:0x30FF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x30FF
  ,simpleLowerCaseMapping:0x30FF
  ,simpleTitleCaseMapping:0x30FF
 },
 { code:0x3105
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3105
  ,simpleLowerCaseMapping:0x3105
  ,simpleTitleCaseMapping:0x3105
 },
 { code:0x3106
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3106
  ,simpleLowerCaseMapping:0x3106
  ,simpleTitleCaseMapping:0x3106
 },
 { code:0x3107
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3107
  ,simpleLowerCaseMapping:0x3107
  ,simpleTitleCaseMapping:0x3107
 },
 { code:0x3108
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3108
  ,simpleLowerCaseMapping:0x3108
  ,simpleTitleCaseMapping:0x3108
 },
 { code:0x3109
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3109
  ,simpleLowerCaseMapping:0x3109
  ,simpleTitleCaseMapping:0x3109
 },
 { code:0x310A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x310A
  ,simpleLowerCaseMapping:0x310A
  ,simpleTitleCaseMapping:0x310A
 },
 { code:0x310B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x310B
  ,simpleLowerCaseMapping:0x310B
  ,simpleTitleCaseMapping:0x310B
 },
 { code:0x310C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x310C
  ,simpleLowerCaseMapping:0x310C
  ,simpleTitleCaseMapping:0x310C
 },
 { code:0x310D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x310D
  ,simpleLowerCaseMapping:0x310D
  ,simpleTitleCaseMapping:0x310D
 },
 { code:0x310E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x310E
  ,simpleLowerCaseMapping:0x310E
  ,simpleTitleCaseMapping:0x310E
 },
 { code:0x310F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x310F
  ,simpleLowerCaseMapping:0x310F
  ,simpleTitleCaseMapping:0x310F
 },
 { code:0x3110
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3110
  ,simpleLowerCaseMapping:0x3110
  ,simpleTitleCaseMapping:0x3110
 },
 { code:0x3111
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3111
  ,simpleLowerCaseMapping:0x3111
  ,simpleTitleCaseMapping:0x3111
 },
 { code:0x3112
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3112
  ,simpleLowerCaseMapping:0x3112
  ,simpleTitleCaseMapping:0x3112
 },
 { code:0x3113
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3113
  ,simpleLowerCaseMapping:0x3113
  ,simpleTitleCaseMapping:0x3113
 },
 { code:0x3114
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3114
  ,simpleLowerCaseMapping:0x3114
  ,simpleTitleCaseMapping:0x3114
 },
 { code:0x3115
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3115
  ,simpleLowerCaseMapping:0x3115
  ,simpleTitleCaseMapping:0x3115
 },
 { code:0x3116
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3116
  ,simpleLowerCaseMapping:0x3116
  ,simpleTitleCaseMapping:0x3116
 },
 { code:0x3117
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3117
  ,simpleLowerCaseMapping:0x3117
  ,simpleTitleCaseMapping:0x3117
 },
 { code:0x3118
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3118
  ,simpleLowerCaseMapping:0x3118
  ,simpleTitleCaseMapping:0x3118
 },
 { code:0x3119
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3119
  ,simpleLowerCaseMapping:0x3119
  ,simpleTitleCaseMapping:0x3119
 },
 { code:0x311A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x311A
  ,simpleLowerCaseMapping:0x311A
  ,simpleTitleCaseMapping:0x311A
 },
 { code:0x311B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x311B
  ,simpleLowerCaseMapping:0x311B
  ,simpleTitleCaseMapping:0x311B
 },
 { code:0x311C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x311C
  ,simpleLowerCaseMapping:0x311C
  ,simpleTitleCaseMapping:0x311C
 },
 { code:0x311D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x311D
  ,simpleLowerCaseMapping:0x311D
  ,simpleTitleCaseMapping:0x311D
 },
 { code:0x311E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x311E
  ,simpleLowerCaseMapping:0x311E
  ,simpleTitleCaseMapping:0x311E
 },
 { code:0x311F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x311F
  ,simpleLowerCaseMapping:0x311F
  ,simpleTitleCaseMapping:0x311F
 },
 { code:0x3120
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3120
  ,simpleLowerCaseMapping:0x3120
  ,simpleTitleCaseMapping:0x3120
 },
 { code:0x3121
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3121
  ,simpleLowerCaseMapping:0x3121
  ,simpleTitleCaseMapping:0x3121
 },
 { code:0x3122
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3122
  ,simpleLowerCaseMapping:0x3122
  ,simpleTitleCaseMapping:0x3122
 },
 { code:0x3123
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3123
  ,simpleLowerCaseMapping:0x3123
  ,simpleTitleCaseMapping:0x3123
 },
 { code:0x3124
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3124
  ,simpleLowerCaseMapping:0x3124
  ,simpleTitleCaseMapping:0x3124
 },
 { code:0x3125
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3125
  ,simpleLowerCaseMapping:0x3125
  ,simpleTitleCaseMapping:0x3125
 },
 { code:0x3126
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3126
  ,simpleLowerCaseMapping:0x3126
  ,simpleTitleCaseMapping:0x3126
 },
 { code:0x3127
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3127
  ,simpleLowerCaseMapping:0x3127
  ,simpleTitleCaseMapping:0x3127
 },
 { code:0x3128
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3128
  ,simpleLowerCaseMapping:0x3128
  ,simpleTitleCaseMapping:0x3128
 },
 { code:0x3129
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3129
  ,simpleLowerCaseMapping:0x3129
  ,simpleTitleCaseMapping:0x3129
 },
 { code:0x312A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x312A
  ,simpleLowerCaseMapping:0x312A
  ,simpleTitleCaseMapping:0x312A
 },
 { code:0x312B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x312B
  ,simpleLowerCaseMapping:0x312B
  ,simpleTitleCaseMapping:0x312B
 },
 { code:0x312C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x312C
  ,simpleLowerCaseMapping:0x312C
  ,simpleTitleCaseMapping:0x312C
 },
 { code:0x3131
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3131
  ,simpleLowerCaseMapping:0x3131
  ,simpleTitleCaseMapping:0x3131
 },
 { code:0x3132
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3132
  ,simpleLowerCaseMapping:0x3132
  ,simpleTitleCaseMapping:0x3132
 },
 { code:0x3133
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3133
  ,simpleLowerCaseMapping:0x3133
  ,simpleTitleCaseMapping:0x3133
 },
 { code:0x3134
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3134
  ,simpleLowerCaseMapping:0x3134
  ,simpleTitleCaseMapping:0x3134
 },
 { code:0x3135
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3135
  ,simpleLowerCaseMapping:0x3135
  ,simpleTitleCaseMapping:0x3135
 },
 { code:0x3136
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3136
  ,simpleLowerCaseMapping:0x3136
  ,simpleTitleCaseMapping:0x3136
 },
 { code:0x3137
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3137
  ,simpleLowerCaseMapping:0x3137
  ,simpleTitleCaseMapping:0x3137
 },
 { code:0x3138
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3138
  ,simpleLowerCaseMapping:0x3138
  ,simpleTitleCaseMapping:0x3138
 },
 { code:0x3139
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3139
  ,simpleLowerCaseMapping:0x3139
  ,simpleTitleCaseMapping:0x3139
 },
 { code:0x313A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x313A
  ,simpleLowerCaseMapping:0x313A
  ,simpleTitleCaseMapping:0x313A
 },
 { code:0x313B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x313B
  ,simpleLowerCaseMapping:0x313B
  ,simpleTitleCaseMapping:0x313B
 },
 { code:0x313C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x313C
  ,simpleLowerCaseMapping:0x313C
  ,simpleTitleCaseMapping:0x313C
 },
 { code:0x313D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x313D
  ,simpleLowerCaseMapping:0x313D
  ,simpleTitleCaseMapping:0x313D
 },
 { code:0x313E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x313E
  ,simpleLowerCaseMapping:0x313E
  ,simpleTitleCaseMapping:0x313E
 },
 { code:0x313F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x313F
  ,simpleLowerCaseMapping:0x313F
  ,simpleTitleCaseMapping:0x313F
 },
 { code:0x3140
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3140
  ,simpleLowerCaseMapping:0x3140
  ,simpleTitleCaseMapping:0x3140
 },
 { code:0x3141
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3141
  ,simpleLowerCaseMapping:0x3141
  ,simpleTitleCaseMapping:0x3141
 },
 { code:0x3142
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3142
  ,simpleLowerCaseMapping:0x3142
  ,simpleTitleCaseMapping:0x3142
 },
 { code:0x3143
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3143
  ,simpleLowerCaseMapping:0x3143
  ,simpleTitleCaseMapping:0x3143
 },
 { code:0x3144
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3144
  ,simpleLowerCaseMapping:0x3144
  ,simpleTitleCaseMapping:0x3144
 },
 { code:0x3145
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3145
  ,simpleLowerCaseMapping:0x3145
  ,simpleTitleCaseMapping:0x3145
 },
 { code:0x3146
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3146
  ,simpleLowerCaseMapping:0x3146
  ,simpleTitleCaseMapping:0x3146
 },
 { code:0x3147
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3147
  ,simpleLowerCaseMapping:0x3147
  ,simpleTitleCaseMapping:0x3147
 },
 { code:0x3148
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3148
  ,simpleLowerCaseMapping:0x3148
  ,simpleTitleCaseMapping:0x3148
 },
 { code:0x3149
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3149
  ,simpleLowerCaseMapping:0x3149
  ,simpleTitleCaseMapping:0x3149
 },
 { code:0x314A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x314A
  ,simpleLowerCaseMapping:0x314A
  ,simpleTitleCaseMapping:0x314A
 },
 { code:0x314B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x314B
  ,simpleLowerCaseMapping:0x314B
  ,simpleTitleCaseMapping:0x314B
 },
 { code:0x314C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x314C
  ,simpleLowerCaseMapping:0x314C
  ,simpleTitleCaseMapping:0x314C
 },
 { code:0x314D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x314D
  ,simpleLowerCaseMapping:0x314D
  ,simpleTitleCaseMapping:0x314D
 },
 { code:0x314E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x314E
  ,simpleLowerCaseMapping:0x314E
  ,simpleTitleCaseMapping:0x314E
 },
 { code:0x314F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x314F
  ,simpleLowerCaseMapping:0x314F
  ,simpleTitleCaseMapping:0x314F
 },
 { code:0x3150
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3150
  ,simpleLowerCaseMapping:0x3150
  ,simpleTitleCaseMapping:0x3150
 },
 { code:0x3151
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3151
  ,simpleLowerCaseMapping:0x3151
  ,simpleTitleCaseMapping:0x3151
 },
 { code:0x3152
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3152
  ,simpleLowerCaseMapping:0x3152
  ,simpleTitleCaseMapping:0x3152
 },
 { code:0x3153
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3153
  ,simpleLowerCaseMapping:0x3153
  ,simpleTitleCaseMapping:0x3153
 },
 { code:0x3154
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3154
  ,simpleLowerCaseMapping:0x3154
  ,simpleTitleCaseMapping:0x3154
 },
 { code:0x3155
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3155
  ,simpleLowerCaseMapping:0x3155
  ,simpleTitleCaseMapping:0x3155
 },
 { code:0x3156
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3156
  ,simpleLowerCaseMapping:0x3156
  ,simpleTitleCaseMapping:0x3156
 },
 { code:0x3157
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3157
  ,simpleLowerCaseMapping:0x3157
  ,simpleTitleCaseMapping:0x3157
 },
 { code:0x3158
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3158
  ,simpleLowerCaseMapping:0x3158
  ,simpleTitleCaseMapping:0x3158
 },
 { code:0x3159
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3159
  ,simpleLowerCaseMapping:0x3159
  ,simpleTitleCaseMapping:0x3159
 },
 { code:0x315A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x315A
  ,simpleLowerCaseMapping:0x315A
  ,simpleTitleCaseMapping:0x315A
 },
 { code:0x315B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x315B
  ,simpleLowerCaseMapping:0x315B
  ,simpleTitleCaseMapping:0x315B
 },
 { code:0x315C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x315C
  ,simpleLowerCaseMapping:0x315C
  ,simpleTitleCaseMapping:0x315C
 },
 { code:0x315D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x315D
  ,simpleLowerCaseMapping:0x315D
  ,simpleTitleCaseMapping:0x315D
 },
 { code:0x315E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x315E
  ,simpleLowerCaseMapping:0x315E
  ,simpleTitleCaseMapping:0x315E
 },
 { code:0x315F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x315F
  ,simpleLowerCaseMapping:0x315F
  ,simpleTitleCaseMapping:0x315F
 },
 { code:0x3160
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3160
  ,simpleLowerCaseMapping:0x3160
  ,simpleTitleCaseMapping:0x3160
 },
 { code:0x3161
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3161
  ,simpleLowerCaseMapping:0x3161
  ,simpleTitleCaseMapping:0x3161
 },
 { code:0x3162
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3162
  ,simpleLowerCaseMapping:0x3162
  ,simpleTitleCaseMapping:0x3162
 },
 { code:0x3163
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3163
  ,simpleLowerCaseMapping:0x3163
  ,simpleTitleCaseMapping:0x3163
 },
 { code:0x3164
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3164
  ,simpleLowerCaseMapping:0x3164
  ,simpleTitleCaseMapping:0x3164
 },
 { code:0x3165
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3165
  ,simpleLowerCaseMapping:0x3165
  ,simpleTitleCaseMapping:0x3165
 },
 { code:0x3166
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3166
  ,simpleLowerCaseMapping:0x3166
  ,simpleTitleCaseMapping:0x3166
 },
 { code:0x3167
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3167
  ,simpleLowerCaseMapping:0x3167
  ,simpleTitleCaseMapping:0x3167
 },
 { code:0x3168
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3168
  ,simpleLowerCaseMapping:0x3168
  ,simpleTitleCaseMapping:0x3168
 },
 { code:0x3169
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3169
  ,simpleLowerCaseMapping:0x3169
  ,simpleTitleCaseMapping:0x3169
 },
 { code:0x316A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x316A
  ,simpleLowerCaseMapping:0x316A
  ,simpleTitleCaseMapping:0x316A
 },
 { code:0x316B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x316B
  ,simpleLowerCaseMapping:0x316B
  ,simpleTitleCaseMapping:0x316B
 },
 { code:0x316C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x316C
  ,simpleLowerCaseMapping:0x316C
  ,simpleTitleCaseMapping:0x316C
 },
 { code:0x316D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x316D
  ,simpleLowerCaseMapping:0x316D
  ,simpleTitleCaseMapping:0x316D
 },
 { code:0x316E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x316E
  ,simpleLowerCaseMapping:0x316E
  ,simpleTitleCaseMapping:0x316E
 },
 { code:0x316F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x316F
  ,simpleLowerCaseMapping:0x316F
  ,simpleTitleCaseMapping:0x316F
 },
 { code:0x3170
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3170
  ,simpleLowerCaseMapping:0x3170
  ,simpleTitleCaseMapping:0x3170
 },
 { code:0x3171
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3171
  ,simpleLowerCaseMapping:0x3171
  ,simpleTitleCaseMapping:0x3171
 },
 { code:0x3172
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3172
  ,simpleLowerCaseMapping:0x3172
  ,simpleTitleCaseMapping:0x3172
 },
 { code:0x3173
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3173
  ,simpleLowerCaseMapping:0x3173
  ,simpleTitleCaseMapping:0x3173
 },
 { code:0x3174
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3174
  ,simpleLowerCaseMapping:0x3174
  ,simpleTitleCaseMapping:0x3174
 },
 { code:0x3175
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3175
  ,simpleLowerCaseMapping:0x3175
  ,simpleTitleCaseMapping:0x3175
 },
 { code:0x3176
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3176
  ,simpleLowerCaseMapping:0x3176
  ,simpleTitleCaseMapping:0x3176
 },
 { code:0x3177
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3177
  ,simpleLowerCaseMapping:0x3177
  ,simpleTitleCaseMapping:0x3177
 },
 { code:0x3178
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3178
  ,simpleLowerCaseMapping:0x3178
  ,simpleTitleCaseMapping:0x3178
 },
 { code:0x3179
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3179
  ,simpleLowerCaseMapping:0x3179
  ,simpleTitleCaseMapping:0x3179
 },
 { code:0x317A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x317A
  ,simpleLowerCaseMapping:0x317A
  ,simpleTitleCaseMapping:0x317A
 },
 { code:0x317B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x317B
  ,simpleLowerCaseMapping:0x317B
  ,simpleTitleCaseMapping:0x317B
 },
 { code:0x317C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x317C
  ,simpleLowerCaseMapping:0x317C
  ,simpleTitleCaseMapping:0x317C
 },
 { code:0x317D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x317D
  ,simpleLowerCaseMapping:0x317D
  ,simpleTitleCaseMapping:0x317D
 },
 { code:0x317E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x317E
  ,simpleLowerCaseMapping:0x317E
  ,simpleTitleCaseMapping:0x317E
 },
 { code:0x317F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x317F
  ,simpleLowerCaseMapping:0x317F
  ,simpleTitleCaseMapping:0x317F
 },
 { code:0x3180
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3180
  ,simpleLowerCaseMapping:0x3180
  ,simpleTitleCaseMapping:0x3180
 },
 { code:0x3181
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3181
  ,simpleLowerCaseMapping:0x3181
  ,simpleTitleCaseMapping:0x3181
 },
 { code:0x3182
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3182
  ,simpleLowerCaseMapping:0x3182
  ,simpleTitleCaseMapping:0x3182
 },
 { code:0x3183
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3183
  ,simpleLowerCaseMapping:0x3183
  ,simpleTitleCaseMapping:0x3183
 },
 { code:0x3184
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3184
  ,simpleLowerCaseMapping:0x3184
  ,simpleTitleCaseMapping:0x3184
 },
 { code:0x3185
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3185
  ,simpleLowerCaseMapping:0x3185
  ,simpleTitleCaseMapping:0x3185
 },
 { code:0x3186
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3186
  ,simpleLowerCaseMapping:0x3186
  ,simpleTitleCaseMapping:0x3186
 },
 { code:0x3187
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3187
  ,simpleLowerCaseMapping:0x3187
  ,simpleTitleCaseMapping:0x3187
 },
 { code:0x3188
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3188
  ,simpleLowerCaseMapping:0x3188
  ,simpleTitleCaseMapping:0x3188
 },
 { code:0x3189
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3189
  ,simpleLowerCaseMapping:0x3189
  ,simpleTitleCaseMapping:0x3189
 },
 { code:0x318A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x318A
  ,simpleLowerCaseMapping:0x318A
  ,simpleTitleCaseMapping:0x318A
 },
 { code:0x318B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x318B
  ,simpleLowerCaseMapping:0x318B
  ,simpleTitleCaseMapping:0x318B
 },
 { code:0x318C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x318C
  ,simpleLowerCaseMapping:0x318C
  ,simpleTitleCaseMapping:0x318C
 },
 { code:0x318D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x318D
  ,simpleLowerCaseMapping:0x318D
  ,simpleTitleCaseMapping:0x318D
 },
 { code:0x318E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x318E
  ,simpleLowerCaseMapping:0x318E
  ,simpleTitleCaseMapping:0x318E
 },
 { code:0x3190
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3190
  ,simpleLowerCaseMapping:0x3190
  ,simpleTitleCaseMapping:0x3190
 },
 { code:0x3191
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3191
  ,simpleLowerCaseMapping:0x3191
  ,simpleTitleCaseMapping:0x3191
 },
 { code:0x3192
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3192
  ,simpleLowerCaseMapping:0x3192
  ,simpleTitleCaseMapping:0x3192
 },
 { code:0x3193
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3193
  ,simpleLowerCaseMapping:0x3193
  ,simpleTitleCaseMapping:0x3193
 },
 { code:0x3194
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3194
  ,simpleLowerCaseMapping:0x3194
  ,simpleTitleCaseMapping:0x3194
 },
 { code:0x3195
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3195
  ,simpleLowerCaseMapping:0x3195
  ,simpleTitleCaseMapping:0x3195
 },
 { code:0x3196
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3196
  ,simpleLowerCaseMapping:0x3196
  ,simpleTitleCaseMapping:0x3196
 },
 { code:0x3197
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3197
  ,simpleLowerCaseMapping:0x3197
  ,simpleTitleCaseMapping:0x3197
 },
 { code:0x3198
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3198
  ,simpleLowerCaseMapping:0x3198
  ,simpleTitleCaseMapping:0x3198
 },
 { code:0x3199
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3199
  ,simpleLowerCaseMapping:0x3199
  ,simpleTitleCaseMapping:0x3199
 },
 { code:0x319A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x319A
  ,simpleLowerCaseMapping:0x319A
  ,simpleTitleCaseMapping:0x319A
 },
 { code:0x319B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x319B
  ,simpleLowerCaseMapping:0x319B
  ,simpleTitleCaseMapping:0x319B
 },
 { code:0x319C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x319C
  ,simpleLowerCaseMapping:0x319C
  ,simpleTitleCaseMapping:0x319C
 },
 { code:0x319D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x319D
  ,simpleLowerCaseMapping:0x319D
  ,simpleTitleCaseMapping:0x319D
 },
 { code:0x319E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x319E
  ,simpleLowerCaseMapping:0x319E
  ,simpleTitleCaseMapping:0x319E
 },
 { code:0x319F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x319F
  ,simpleLowerCaseMapping:0x319F
  ,simpleTitleCaseMapping:0x319F
 },
 { code:0x31A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31A0
  ,simpleLowerCaseMapping:0x31A0
  ,simpleTitleCaseMapping:0x31A0
 },
 { code:0x31A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31A1
  ,simpleLowerCaseMapping:0x31A1
  ,simpleTitleCaseMapping:0x31A1
 },
 { code:0x31A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31A2
  ,simpleLowerCaseMapping:0x31A2
  ,simpleTitleCaseMapping:0x31A2
 },
 { code:0x31A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31A3
  ,simpleLowerCaseMapping:0x31A3
  ,simpleTitleCaseMapping:0x31A3
 },
 { code:0x31A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31A4
  ,simpleLowerCaseMapping:0x31A4
  ,simpleTitleCaseMapping:0x31A4
 },
 { code:0x31A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31A5
  ,simpleLowerCaseMapping:0x31A5
  ,simpleTitleCaseMapping:0x31A5
 },
 { code:0x31A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31A6
  ,simpleLowerCaseMapping:0x31A6
  ,simpleTitleCaseMapping:0x31A6
 },
 { code:0x31A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31A7
  ,simpleLowerCaseMapping:0x31A7
  ,simpleTitleCaseMapping:0x31A7
 },
 { code:0x31A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31A8
  ,simpleLowerCaseMapping:0x31A8
  ,simpleTitleCaseMapping:0x31A8
 },
 { code:0x31A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31A9
  ,simpleLowerCaseMapping:0x31A9
  ,simpleTitleCaseMapping:0x31A9
 },
 { code:0x31AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31AA
  ,simpleLowerCaseMapping:0x31AA
  ,simpleTitleCaseMapping:0x31AA
 },
 { code:0x31AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31AB
  ,simpleLowerCaseMapping:0x31AB
  ,simpleTitleCaseMapping:0x31AB
 },
 { code:0x31AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31AC
  ,simpleLowerCaseMapping:0x31AC
  ,simpleTitleCaseMapping:0x31AC
 },
 { code:0x31AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31AD
  ,simpleLowerCaseMapping:0x31AD
  ,simpleTitleCaseMapping:0x31AD
 },
 { code:0x31AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31AE
  ,simpleLowerCaseMapping:0x31AE
  ,simpleTitleCaseMapping:0x31AE
 },
 { code:0x31AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31AF
  ,simpleLowerCaseMapping:0x31AF
  ,simpleTitleCaseMapping:0x31AF
 },
 { code:0x31B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31B0
  ,simpleLowerCaseMapping:0x31B0
  ,simpleTitleCaseMapping:0x31B0
 },
 { code:0x31B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31B1
  ,simpleLowerCaseMapping:0x31B1
  ,simpleTitleCaseMapping:0x31B1
 },
 { code:0x31B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31B2
  ,simpleLowerCaseMapping:0x31B2
  ,simpleTitleCaseMapping:0x31B2
 },
 { code:0x31B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31B3
  ,simpleLowerCaseMapping:0x31B3
  ,simpleTitleCaseMapping:0x31B3
 },
 { code:0x31B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31B4
  ,simpleLowerCaseMapping:0x31B4
  ,simpleTitleCaseMapping:0x31B4
 },
 { code:0x31B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31B5
  ,simpleLowerCaseMapping:0x31B5
  ,simpleTitleCaseMapping:0x31B5
 },
 { code:0x31B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31B6
  ,simpleLowerCaseMapping:0x31B6
  ,simpleTitleCaseMapping:0x31B6
 },
 { code:0x31B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31B7
  ,simpleLowerCaseMapping:0x31B7
  ,simpleTitleCaseMapping:0x31B7
 },
 { code:0x31C0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x31C0
  ,simpleLowerCaseMapping:0x31C0
  ,simpleTitleCaseMapping:0x31C0
 },
 { code:0x31C1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x31C1
  ,simpleLowerCaseMapping:0x31C1
  ,simpleTitleCaseMapping:0x31C1
 },
 { code:0x31C2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x31C2
  ,simpleLowerCaseMapping:0x31C2
  ,simpleTitleCaseMapping:0x31C2
 },
 { code:0x31C3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x31C3
  ,simpleLowerCaseMapping:0x31C3
  ,simpleTitleCaseMapping:0x31C3
 },
 { code:0x31C4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x31C4
  ,simpleLowerCaseMapping:0x31C4
  ,simpleTitleCaseMapping:0x31C4
 },
 { code:0x31C5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x31C5
  ,simpleLowerCaseMapping:0x31C5
  ,simpleTitleCaseMapping:0x31C5
 },
 { code:0x31C6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x31C6
  ,simpleLowerCaseMapping:0x31C6
  ,simpleTitleCaseMapping:0x31C6
 },
 { code:0x31C7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x31C7
  ,simpleLowerCaseMapping:0x31C7
  ,simpleTitleCaseMapping:0x31C7
 },
 { code:0x31C8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x31C8
  ,simpleLowerCaseMapping:0x31C8
  ,simpleTitleCaseMapping:0x31C8
 },
 { code:0x31C9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x31C9
  ,simpleLowerCaseMapping:0x31C9
  ,simpleTitleCaseMapping:0x31C9
 },
 { code:0x31CA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x31CA
  ,simpleLowerCaseMapping:0x31CA
  ,simpleTitleCaseMapping:0x31CA
 },
 { code:0x31CB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x31CB
  ,simpleLowerCaseMapping:0x31CB
  ,simpleTitleCaseMapping:0x31CB
 },
 { code:0x31CC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x31CC
  ,simpleLowerCaseMapping:0x31CC
  ,simpleTitleCaseMapping:0x31CC
 },
 { code:0x31CD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x31CD
  ,simpleLowerCaseMapping:0x31CD
  ,simpleTitleCaseMapping:0x31CD
 },
 { code:0x31CE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x31CE
  ,simpleLowerCaseMapping:0x31CE
  ,simpleTitleCaseMapping:0x31CE
 },
 { code:0x31CF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x31CF
  ,simpleLowerCaseMapping:0x31CF
  ,simpleTitleCaseMapping:0x31CF
 },
 { code:0x31F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31F0
  ,simpleLowerCaseMapping:0x31F0
  ,simpleTitleCaseMapping:0x31F0
 },
 { code:0x31F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31F1
  ,simpleLowerCaseMapping:0x31F1
  ,simpleTitleCaseMapping:0x31F1
 },
 { code:0x31F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31F2
  ,simpleLowerCaseMapping:0x31F2
  ,simpleTitleCaseMapping:0x31F2
 },
 { code:0x31F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31F3
  ,simpleLowerCaseMapping:0x31F3
  ,simpleTitleCaseMapping:0x31F3
 },
 { code:0x31F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31F4
  ,simpleLowerCaseMapping:0x31F4
  ,simpleTitleCaseMapping:0x31F4
 },
 { code:0x31F5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31F5
  ,simpleLowerCaseMapping:0x31F5
  ,simpleTitleCaseMapping:0x31F5
 },
 { code:0x31F6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31F6
  ,simpleLowerCaseMapping:0x31F6
  ,simpleTitleCaseMapping:0x31F6
 },
 { code:0x31F7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31F7
  ,simpleLowerCaseMapping:0x31F7
  ,simpleTitleCaseMapping:0x31F7
 },
 { code:0x31F8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31F8
  ,simpleLowerCaseMapping:0x31F8
  ,simpleTitleCaseMapping:0x31F8
 },
 { code:0x31F9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31F9
  ,simpleLowerCaseMapping:0x31F9
  ,simpleTitleCaseMapping:0x31F9
 },
 { code:0x31FA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31FA
  ,simpleLowerCaseMapping:0x31FA
  ,simpleTitleCaseMapping:0x31FA
 },
 { code:0x31FB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31FB
  ,simpleLowerCaseMapping:0x31FB
  ,simpleTitleCaseMapping:0x31FB
 },
 { code:0x31FC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31FC
  ,simpleLowerCaseMapping:0x31FC
  ,simpleTitleCaseMapping:0x31FC
 },
 { code:0x31FD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31FD
  ,simpleLowerCaseMapping:0x31FD
  ,simpleTitleCaseMapping:0x31FD
 },
 { code:0x31FE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31FE
  ,simpleLowerCaseMapping:0x31FE
  ,simpleTitleCaseMapping:0x31FE
 },
 { code:0x31FF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x31FF
  ,simpleLowerCaseMapping:0x31FF
  ,simpleTitleCaseMapping:0x31FF
 },
 { code:0x3200
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3200
  ,simpleLowerCaseMapping:0x3200
  ,simpleTitleCaseMapping:0x3200
 },
 { code:0x3201
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3201
  ,simpleLowerCaseMapping:0x3201
  ,simpleTitleCaseMapping:0x3201
 },
 { code:0x3202
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3202
  ,simpleLowerCaseMapping:0x3202
  ,simpleTitleCaseMapping:0x3202
 },
 { code:0x3203
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3203
  ,simpleLowerCaseMapping:0x3203
  ,simpleTitleCaseMapping:0x3203
 },
 { code:0x3204
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3204
  ,simpleLowerCaseMapping:0x3204
  ,simpleTitleCaseMapping:0x3204
 },
 { code:0x3205
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3205
  ,simpleLowerCaseMapping:0x3205
  ,simpleTitleCaseMapping:0x3205
 },
 { code:0x3206
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3206
  ,simpleLowerCaseMapping:0x3206
  ,simpleTitleCaseMapping:0x3206
 },
 { code:0x3207
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3207
  ,simpleLowerCaseMapping:0x3207
  ,simpleTitleCaseMapping:0x3207
 },
 { code:0x3208
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3208
  ,simpleLowerCaseMapping:0x3208
  ,simpleTitleCaseMapping:0x3208
 },
 { code:0x3209
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3209
  ,simpleLowerCaseMapping:0x3209
  ,simpleTitleCaseMapping:0x3209
 },
 { code:0x320A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x320A
  ,simpleLowerCaseMapping:0x320A
  ,simpleTitleCaseMapping:0x320A
 },
 { code:0x320B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x320B
  ,simpleLowerCaseMapping:0x320B
  ,simpleTitleCaseMapping:0x320B
 },
 { code:0x320C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x320C
  ,simpleLowerCaseMapping:0x320C
  ,simpleTitleCaseMapping:0x320C
 },
 { code:0x320D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x320D
  ,simpleLowerCaseMapping:0x320D
  ,simpleTitleCaseMapping:0x320D
 },
 { code:0x320E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x320E
  ,simpleLowerCaseMapping:0x320E
  ,simpleTitleCaseMapping:0x320E
 },
 { code:0x320F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x320F
  ,simpleLowerCaseMapping:0x320F
  ,simpleTitleCaseMapping:0x320F
 },
 { code:0x3210
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3210
  ,simpleLowerCaseMapping:0x3210
  ,simpleTitleCaseMapping:0x3210
 },
 { code:0x3211
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3211
  ,simpleLowerCaseMapping:0x3211
  ,simpleTitleCaseMapping:0x3211
 },
 { code:0x3212
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3212
  ,simpleLowerCaseMapping:0x3212
  ,simpleTitleCaseMapping:0x3212
 },
 { code:0x3213
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3213
  ,simpleLowerCaseMapping:0x3213
  ,simpleTitleCaseMapping:0x3213
 },
 { code:0x3214
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3214
  ,simpleLowerCaseMapping:0x3214
  ,simpleTitleCaseMapping:0x3214
 },
 { code:0x3215
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3215
  ,simpleLowerCaseMapping:0x3215
  ,simpleTitleCaseMapping:0x3215
 },
 { code:0x3216
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3216
  ,simpleLowerCaseMapping:0x3216
  ,simpleTitleCaseMapping:0x3216
 },
 { code:0x3217
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3217
  ,simpleLowerCaseMapping:0x3217
  ,simpleTitleCaseMapping:0x3217
 },
 { code:0x3218
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3218
  ,simpleLowerCaseMapping:0x3218
  ,simpleTitleCaseMapping:0x3218
 },
 { code:0x3219
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3219
  ,simpleLowerCaseMapping:0x3219
  ,simpleTitleCaseMapping:0x3219
 },
 { code:0x321A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x321A
  ,simpleLowerCaseMapping:0x321A
  ,simpleTitleCaseMapping:0x321A
 },
 { code:0x321B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x321B
  ,simpleLowerCaseMapping:0x321B
  ,simpleTitleCaseMapping:0x321B
 },
 { code:0x321C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x321C
  ,simpleLowerCaseMapping:0x321C
  ,simpleTitleCaseMapping:0x321C
 },
 { code:0x321D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x321D
  ,simpleLowerCaseMapping:0x321D
  ,simpleTitleCaseMapping:0x321D
 },
 { code:0x321E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x321E
  ,simpleLowerCaseMapping:0x321E
  ,simpleTitleCaseMapping:0x321E
 },
 { code:0x3220
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3220
  ,simpleLowerCaseMapping:0x3220
  ,simpleTitleCaseMapping:0x3220
 },
 { code:0x3221
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3221
  ,simpleLowerCaseMapping:0x3221
  ,simpleTitleCaseMapping:0x3221
 },
 { code:0x3222
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3222
  ,simpleLowerCaseMapping:0x3222
  ,simpleTitleCaseMapping:0x3222
 },
 { code:0x3223
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3223
  ,simpleLowerCaseMapping:0x3223
  ,simpleTitleCaseMapping:0x3223
 },
 { code:0x3224
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3224
  ,simpleLowerCaseMapping:0x3224
  ,simpleTitleCaseMapping:0x3224
 },
 { code:0x3225
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3225
  ,simpleLowerCaseMapping:0x3225
  ,simpleTitleCaseMapping:0x3225
 },
 { code:0x3226
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3226
  ,simpleLowerCaseMapping:0x3226
  ,simpleTitleCaseMapping:0x3226
 },
 { code:0x3227
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3227
  ,simpleLowerCaseMapping:0x3227
  ,simpleTitleCaseMapping:0x3227
 },
 { code:0x3228
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3228
  ,simpleLowerCaseMapping:0x3228
  ,simpleTitleCaseMapping:0x3228
 },
 { code:0x3229
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3229
  ,simpleLowerCaseMapping:0x3229
  ,simpleTitleCaseMapping:0x3229
 },
 { code:0x322A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x322A
  ,simpleLowerCaseMapping:0x322A
  ,simpleTitleCaseMapping:0x322A
 },
 { code:0x322B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x322B
  ,simpleLowerCaseMapping:0x322B
  ,simpleTitleCaseMapping:0x322B
 },
 { code:0x322C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x322C
  ,simpleLowerCaseMapping:0x322C
  ,simpleTitleCaseMapping:0x322C
 },
 { code:0x322D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x322D
  ,simpleLowerCaseMapping:0x322D
  ,simpleTitleCaseMapping:0x322D
 },
 { code:0x322E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x322E
  ,simpleLowerCaseMapping:0x322E
  ,simpleTitleCaseMapping:0x322E
 },
 { code:0x322F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x322F
  ,simpleLowerCaseMapping:0x322F
  ,simpleTitleCaseMapping:0x322F
 },
 { code:0x3230
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3230
  ,simpleLowerCaseMapping:0x3230
  ,simpleTitleCaseMapping:0x3230
 },
 { code:0x3231
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3231
  ,simpleLowerCaseMapping:0x3231
  ,simpleTitleCaseMapping:0x3231
 },
 { code:0x3232
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3232
  ,simpleLowerCaseMapping:0x3232
  ,simpleTitleCaseMapping:0x3232
 },
 { code:0x3233
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3233
  ,simpleLowerCaseMapping:0x3233
  ,simpleTitleCaseMapping:0x3233
 },
 { code:0x3234
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3234
  ,simpleLowerCaseMapping:0x3234
  ,simpleTitleCaseMapping:0x3234
 },
 { code:0x3235
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3235
  ,simpleLowerCaseMapping:0x3235
  ,simpleTitleCaseMapping:0x3235
 },
 { code:0x3236
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3236
  ,simpleLowerCaseMapping:0x3236
  ,simpleTitleCaseMapping:0x3236
 },
 { code:0x3237
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3237
  ,simpleLowerCaseMapping:0x3237
  ,simpleTitleCaseMapping:0x3237
 },
 { code:0x3238
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3238
  ,simpleLowerCaseMapping:0x3238
  ,simpleTitleCaseMapping:0x3238
 },
 { code:0x3239
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3239
  ,simpleLowerCaseMapping:0x3239
  ,simpleTitleCaseMapping:0x3239
 },
 { code:0x323A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x323A
  ,simpleLowerCaseMapping:0x323A
  ,simpleTitleCaseMapping:0x323A
 },
 { code:0x323B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x323B
  ,simpleLowerCaseMapping:0x323B
  ,simpleTitleCaseMapping:0x323B
 },
 { code:0x323C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x323C
  ,simpleLowerCaseMapping:0x323C
  ,simpleTitleCaseMapping:0x323C
 },
 { code:0x323D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x323D
  ,simpleLowerCaseMapping:0x323D
  ,simpleTitleCaseMapping:0x323D
 },
 { code:0x323E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x323E
  ,simpleLowerCaseMapping:0x323E
  ,simpleTitleCaseMapping:0x323E
 },
 { code:0x323F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x323F
  ,simpleLowerCaseMapping:0x323F
  ,simpleTitleCaseMapping:0x323F
 },
 { code:0x3240
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3240
  ,simpleLowerCaseMapping:0x3240
  ,simpleTitleCaseMapping:0x3240
 },
 { code:0x3241
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3241
  ,simpleLowerCaseMapping:0x3241
  ,simpleTitleCaseMapping:0x3241
 },
 { code:0x3242
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3242
  ,simpleLowerCaseMapping:0x3242
  ,simpleTitleCaseMapping:0x3242
 },
 { code:0x3243
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3243
  ,simpleLowerCaseMapping:0x3243
  ,simpleTitleCaseMapping:0x3243
 },
 { code:0x3250
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3250
  ,simpleLowerCaseMapping:0x3250
  ,simpleTitleCaseMapping:0x3250
 },
 { code:0x3251
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3251
  ,simpleLowerCaseMapping:0x3251
  ,simpleTitleCaseMapping:0x3251
 },
 { code:0x3252
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3252
  ,simpleLowerCaseMapping:0x3252
  ,simpleTitleCaseMapping:0x3252
 },
 { code:0x3253
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3253
  ,simpleLowerCaseMapping:0x3253
  ,simpleTitleCaseMapping:0x3253
 },
 { code:0x3254
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3254
  ,simpleLowerCaseMapping:0x3254
  ,simpleTitleCaseMapping:0x3254
 },
 { code:0x3255
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3255
  ,simpleLowerCaseMapping:0x3255
  ,simpleTitleCaseMapping:0x3255
 },
 { code:0x3256
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3256
  ,simpleLowerCaseMapping:0x3256
  ,simpleTitleCaseMapping:0x3256
 },
 { code:0x3257
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3257
  ,simpleLowerCaseMapping:0x3257
  ,simpleTitleCaseMapping:0x3257
 },
 { code:0x3258
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3258
  ,simpleLowerCaseMapping:0x3258
  ,simpleTitleCaseMapping:0x3258
 },
 { code:0x3259
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3259
  ,simpleLowerCaseMapping:0x3259
  ,simpleTitleCaseMapping:0x3259
 },
 { code:0x325A
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x325A
  ,simpleLowerCaseMapping:0x325A
  ,simpleTitleCaseMapping:0x325A
 },
 { code:0x325B
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x325B
  ,simpleLowerCaseMapping:0x325B
  ,simpleTitleCaseMapping:0x325B
 },
 { code:0x325C
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x325C
  ,simpleLowerCaseMapping:0x325C
  ,simpleTitleCaseMapping:0x325C
 },
 { code:0x325D
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x325D
  ,simpleLowerCaseMapping:0x325D
  ,simpleTitleCaseMapping:0x325D
 },
 { code:0x325E
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x325E
  ,simpleLowerCaseMapping:0x325E
  ,simpleTitleCaseMapping:0x325E
 },
 { code:0x325F
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x325F
  ,simpleLowerCaseMapping:0x325F
  ,simpleTitleCaseMapping:0x325F
 },
 { code:0x3260
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3260
  ,simpleLowerCaseMapping:0x3260
  ,simpleTitleCaseMapping:0x3260
 },
 { code:0x3261
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3261
  ,simpleLowerCaseMapping:0x3261
  ,simpleTitleCaseMapping:0x3261
 },
 { code:0x3262
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3262
  ,simpleLowerCaseMapping:0x3262
  ,simpleTitleCaseMapping:0x3262
 },
 { code:0x3263
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3263
  ,simpleLowerCaseMapping:0x3263
  ,simpleTitleCaseMapping:0x3263
 },
 { code:0x3264
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3264
  ,simpleLowerCaseMapping:0x3264
  ,simpleTitleCaseMapping:0x3264
 },
 { code:0x3265
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3265
  ,simpleLowerCaseMapping:0x3265
  ,simpleTitleCaseMapping:0x3265
 },
 { code:0x3266
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3266
  ,simpleLowerCaseMapping:0x3266
  ,simpleTitleCaseMapping:0x3266
 },
 { code:0x3267
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3267
  ,simpleLowerCaseMapping:0x3267
  ,simpleTitleCaseMapping:0x3267
 },
 { code:0x3268
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3268
  ,simpleLowerCaseMapping:0x3268
  ,simpleTitleCaseMapping:0x3268
 },
 { code:0x3269
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3269
  ,simpleLowerCaseMapping:0x3269
  ,simpleTitleCaseMapping:0x3269
 },
 { code:0x326A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x326A
  ,simpleLowerCaseMapping:0x326A
  ,simpleTitleCaseMapping:0x326A
 },
 { code:0x326B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x326B
  ,simpleLowerCaseMapping:0x326B
  ,simpleTitleCaseMapping:0x326B
 },
 { code:0x326C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x326C
  ,simpleLowerCaseMapping:0x326C
  ,simpleTitleCaseMapping:0x326C
 },
 { code:0x326D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x326D
  ,simpleLowerCaseMapping:0x326D
  ,simpleTitleCaseMapping:0x326D
 },
 { code:0x326E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x326E
  ,simpleLowerCaseMapping:0x326E
  ,simpleTitleCaseMapping:0x326E
 },
 { code:0x326F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x326F
  ,simpleLowerCaseMapping:0x326F
  ,simpleTitleCaseMapping:0x326F
 },
 { code:0x3270
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3270
  ,simpleLowerCaseMapping:0x3270
  ,simpleTitleCaseMapping:0x3270
 },
 { code:0x3271
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3271
  ,simpleLowerCaseMapping:0x3271
  ,simpleTitleCaseMapping:0x3271
 },
 { code:0x3272
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3272
  ,simpleLowerCaseMapping:0x3272
  ,simpleTitleCaseMapping:0x3272
 },
 { code:0x3273
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3273
  ,simpleLowerCaseMapping:0x3273
  ,simpleTitleCaseMapping:0x3273
 },
 { code:0x3274
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3274
  ,simpleLowerCaseMapping:0x3274
  ,simpleTitleCaseMapping:0x3274
 },
 { code:0x3275
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3275
  ,simpleLowerCaseMapping:0x3275
  ,simpleTitleCaseMapping:0x3275
 },
 { code:0x3276
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3276
  ,simpleLowerCaseMapping:0x3276
  ,simpleTitleCaseMapping:0x3276
 },
 { code:0x3277
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3277
  ,simpleLowerCaseMapping:0x3277
  ,simpleTitleCaseMapping:0x3277
 },
 { code:0x3278
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3278
  ,simpleLowerCaseMapping:0x3278
  ,simpleTitleCaseMapping:0x3278
 },
 { code:0x3279
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3279
  ,simpleLowerCaseMapping:0x3279
  ,simpleTitleCaseMapping:0x3279
 },
 { code:0x327A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x327A
  ,simpleLowerCaseMapping:0x327A
  ,simpleTitleCaseMapping:0x327A
 },
 { code:0x327B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x327B
  ,simpleLowerCaseMapping:0x327B
  ,simpleTitleCaseMapping:0x327B
 },
 { code:0x327C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x327C
  ,simpleLowerCaseMapping:0x327C
  ,simpleTitleCaseMapping:0x327C
 },
 { code:0x327D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x327D
  ,simpleLowerCaseMapping:0x327D
  ,simpleTitleCaseMapping:0x327D
 },
 { code:0x327E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x327E
  ,simpleLowerCaseMapping:0x327E
  ,simpleTitleCaseMapping:0x327E
 },
 { code:0x327F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x327F
  ,simpleLowerCaseMapping:0x327F
  ,simpleTitleCaseMapping:0x327F
 },
 { code:0x3280
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3280
  ,simpleLowerCaseMapping:0x3280
  ,simpleTitleCaseMapping:0x3280
 },
 { code:0x3281
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3281
  ,simpleLowerCaseMapping:0x3281
  ,simpleTitleCaseMapping:0x3281
 },
 { code:0x3282
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3282
  ,simpleLowerCaseMapping:0x3282
  ,simpleTitleCaseMapping:0x3282
 },
 { code:0x3283
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3283
  ,simpleLowerCaseMapping:0x3283
  ,simpleTitleCaseMapping:0x3283
 },
 { code:0x3284
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3284
  ,simpleLowerCaseMapping:0x3284
  ,simpleTitleCaseMapping:0x3284
 },
 { code:0x3285
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3285
  ,simpleLowerCaseMapping:0x3285
  ,simpleTitleCaseMapping:0x3285
 },
 { code:0x3286
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3286
  ,simpleLowerCaseMapping:0x3286
  ,simpleTitleCaseMapping:0x3286
 },
 { code:0x3287
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3287
  ,simpleLowerCaseMapping:0x3287
  ,simpleTitleCaseMapping:0x3287
 },
 { code:0x3288
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3288
  ,simpleLowerCaseMapping:0x3288
  ,simpleTitleCaseMapping:0x3288
 },
 { code:0x3289
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x3289
  ,simpleLowerCaseMapping:0x3289
  ,simpleTitleCaseMapping:0x3289
 },
 { code:0x328A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x328A
  ,simpleLowerCaseMapping:0x328A
  ,simpleTitleCaseMapping:0x328A
 },
 { code:0x328B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x328B
  ,simpleLowerCaseMapping:0x328B
  ,simpleTitleCaseMapping:0x328B
 },
 { code:0x328C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x328C
  ,simpleLowerCaseMapping:0x328C
  ,simpleTitleCaseMapping:0x328C
 },
 { code:0x328D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x328D
  ,simpleLowerCaseMapping:0x328D
  ,simpleTitleCaseMapping:0x328D
 },
 { code:0x328E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x328E
  ,simpleLowerCaseMapping:0x328E
  ,simpleTitleCaseMapping:0x328E
 },
 { code:0x328F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x328F
  ,simpleLowerCaseMapping:0x328F
  ,simpleTitleCaseMapping:0x328F
 },
 { code:0x3290
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3290
  ,simpleLowerCaseMapping:0x3290
  ,simpleTitleCaseMapping:0x3290
 },
 { code:0x3291
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3291
  ,simpleLowerCaseMapping:0x3291
  ,simpleTitleCaseMapping:0x3291
 },
 { code:0x3292
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3292
  ,simpleLowerCaseMapping:0x3292
  ,simpleTitleCaseMapping:0x3292
 },
 { code:0x3293
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3293
  ,simpleLowerCaseMapping:0x3293
  ,simpleTitleCaseMapping:0x3293
 },
 { code:0x3294
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3294
  ,simpleLowerCaseMapping:0x3294
  ,simpleTitleCaseMapping:0x3294
 },
 { code:0x3295
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3295
  ,simpleLowerCaseMapping:0x3295
  ,simpleTitleCaseMapping:0x3295
 },
 { code:0x3296
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3296
  ,simpleLowerCaseMapping:0x3296
  ,simpleTitleCaseMapping:0x3296
 },
 { code:0x3297
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3297
  ,simpleLowerCaseMapping:0x3297
  ,simpleTitleCaseMapping:0x3297
 },
 { code:0x3298
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3298
  ,simpleLowerCaseMapping:0x3298
  ,simpleTitleCaseMapping:0x3298
 },
 { code:0x3299
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3299
  ,simpleLowerCaseMapping:0x3299
  ,simpleTitleCaseMapping:0x3299
 },
 { code:0x329A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x329A
  ,simpleLowerCaseMapping:0x329A
  ,simpleTitleCaseMapping:0x329A
 },
 { code:0x329B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x329B
  ,simpleLowerCaseMapping:0x329B
  ,simpleTitleCaseMapping:0x329B
 },
 { code:0x329C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x329C
  ,simpleLowerCaseMapping:0x329C
  ,simpleTitleCaseMapping:0x329C
 },
 { code:0x329D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x329D
  ,simpleLowerCaseMapping:0x329D
  ,simpleTitleCaseMapping:0x329D
 },
 { code:0x329E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x329E
  ,simpleLowerCaseMapping:0x329E
  ,simpleTitleCaseMapping:0x329E
 },
 { code:0x329F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x329F
  ,simpleLowerCaseMapping:0x329F
  ,simpleTitleCaseMapping:0x329F
 },
 { code:0x32A0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32A0
  ,simpleLowerCaseMapping:0x32A0
  ,simpleTitleCaseMapping:0x32A0
 },
 { code:0x32A1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32A1
  ,simpleLowerCaseMapping:0x32A1
  ,simpleTitleCaseMapping:0x32A1
 },
 { code:0x32A2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32A2
  ,simpleLowerCaseMapping:0x32A2
  ,simpleTitleCaseMapping:0x32A2
 },
 { code:0x32A3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32A3
  ,simpleLowerCaseMapping:0x32A3
  ,simpleTitleCaseMapping:0x32A3
 },
 { code:0x32A4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32A4
  ,simpleLowerCaseMapping:0x32A4
  ,simpleTitleCaseMapping:0x32A4
 },
 { code:0x32A5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32A5
  ,simpleLowerCaseMapping:0x32A5
  ,simpleTitleCaseMapping:0x32A5
 },
 { code:0x32A6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32A6
  ,simpleLowerCaseMapping:0x32A6
  ,simpleTitleCaseMapping:0x32A6
 },
 { code:0x32A7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32A7
  ,simpleLowerCaseMapping:0x32A7
  ,simpleTitleCaseMapping:0x32A7
 },
 { code:0x32A8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32A8
  ,simpleLowerCaseMapping:0x32A8
  ,simpleTitleCaseMapping:0x32A8
 },
 { code:0x32A9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32A9
  ,simpleLowerCaseMapping:0x32A9
  ,simpleTitleCaseMapping:0x32A9
 },
 { code:0x32AA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32AA
  ,simpleLowerCaseMapping:0x32AA
  ,simpleTitleCaseMapping:0x32AA
 },
 { code:0x32AB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32AB
  ,simpleLowerCaseMapping:0x32AB
  ,simpleTitleCaseMapping:0x32AB
 },
 { code:0x32AC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32AC
  ,simpleLowerCaseMapping:0x32AC
  ,simpleTitleCaseMapping:0x32AC
 },
 { code:0x32AD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32AD
  ,simpleLowerCaseMapping:0x32AD
  ,simpleTitleCaseMapping:0x32AD
 },
 { code:0x32AE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32AE
  ,simpleLowerCaseMapping:0x32AE
  ,simpleTitleCaseMapping:0x32AE
 },
 { code:0x32AF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32AF
  ,simpleLowerCaseMapping:0x32AF
  ,simpleTitleCaseMapping:0x32AF
 },
 { code:0x32B0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32B0
  ,simpleLowerCaseMapping:0x32B0
  ,simpleTitleCaseMapping:0x32B0
 },
 { code:0x32B1
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x32B1
  ,simpleLowerCaseMapping:0x32B1
  ,simpleTitleCaseMapping:0x32B1
 },
 { code:0x32B2
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x32B2
  ,simpleLowerCaseMapping:0x32B2
  ,simpleTitleCaseMapping:0x32B2
 },
 { code:0x32B3
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x32B3
  ,simpleLowerCaseMapping:0x32B3
  ,simpleTitleCaseMapping:0x32B3
 },
 { code:0x32B4
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x32B4
  ,simpleLowerCaseMapping:0x32B4
  ,simpleTitleCaseMapping:0x32B4
 },
 { code:0x32B5
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x32B5
  ,simpleLowerCaseMapping:0x32B5
  ,simpleTitleCaseMapping:0x32B5
 },
 { code:0x32B6
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x32B6
  ,simpleLowerCaseMapping:0x32B6
  ,simpleTitleCaseMapping:0x32B6
 },
 { code:0x32B7
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x32B7
  ,simpleLowerCaseMapping:0x32B7
  ,simpleTitleCaseMapping:0x32B7
 },
 { code:0x32B8
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x32B8
  ,simpleLowerCaseMapping:0x32B8
  ,simpleTitleCaseMapping:0x32B8
 },
 { code:0x32B9
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x32B9
  ,simpleLowerCaseMapping:0x32B9
  ,simpleTitleCaseMapping:0x32B9
 },
 { code:0x32BA
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x32BA
  ,simpleLowerCaseMapping:0x32BA
  ,simpleTitleCaseMapping:0x32BA
 },
 { code:0x32BB
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x32BB
  ,simpleLowerCaseMapping:0x32BB
  ,simpleTitleCaseMapping:0x32BB
 },
 { code:0x32BC
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x32BC
  ,simpleLowerCaseMapping:0x32BC
  ,simpleTitleCaseMapping:0x32BC
 },
 { code:0x32BD
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x32BD
  ,simpleLowerCaseMapping:0x32BD
  ,simpleTitleCaseMapping:0x32BD
 },
 { code:0x32BE
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x32BE
  ,simpleLowerCaseMapping:0x32BE
  ,simpleTitleCaseMapping:0x32BE
 },
 { code:0x32BF
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x32BF
  ,simpleLowerCaseMapping:0x32BF
  ,simpleTitleCaseMapping:0x32BF
 },
 { code:0x32C0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32C0
  ,simpleLowerCaseMapping:0x32C0
  ,simpleTitleCaseMapping:0x32C0
 },
 { code:0x32C1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32C1
  ,simpleLowerCaseMapping:0x32C1
  ,simpleTitleCaseMapping:0x32C1
 },
 { code:0x32C2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32C2
  ,simpleLowerCaseMapping:0x32C2
  ,simpleTitleCaseMapping:0x32C2
 },
 { code:0x32C3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32C3
  ,simpleLowerCaseMapping:0x32C3
  ,simpleTitleCaseMapping:0x32C3
 },
 { code:0x32C4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32C4
  ,simpleLowerCaseMapping:0x32C4
  ,simpleTitleCaseMapping:0x32C4
 },
 { code:0x32C5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32C5
  ,simpleLowerCaseMapping:0x32C5
  ,simpleTitleCaseMapping:0x32C5
 },
 { code:0x32C6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32C6
  ,simpleLowerCaseMapping:0x32C6
  ,simpleTitleCaseMapping:0x32C6
 },
 { code:0x32C7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32C7
  ,simpleLowerCaseMapping:0x32C7
  ,simpleTitleCaseMapping:0x32C7
 },
 { code:0x32C8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32C8
  ,simpleLowerCaseMapping:0x32C8
  ,simpleTitleCaseMapping:0x32C8
 },
 { code:0x32C9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32C9
  ,simpleLowerCaseMapping:0x32C9
  ,simpleTitleCaseMapping:0x32C9
 },
 { code:0x32CA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32CA
  ,simpleLowerCaseMapping:0x32CA
  ,simpleTitleCaseMapping:0x32CA
 },
 { code:0x32CB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32CB
  ,simpleLowerCaseMapping:0x32CB
  ,simpleTitleCaseMapping:0x32CB
 },
 { code:0x32CC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32CC
  ,simpleLowerCaseMapping:0x32CC
  ,simpleTitleCaseMapping:0x32CC
 },
 { code:0x32CD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32CD
  ,simpleLowerCaseMapping:0x32CD
  ,simpleTitleCaseMapping:0x32CD
 },
 { code:0x32CE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32CE
  ,simpleLowerCaseMapping:0x32CE
  ,simpleTitleCaseMapping:0x32CE
 },
 { code:0x32CF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32CF
  ,simpleLowerCaseMapping:0x32CF
  ,simpleTitleCaseMapping:0x32CF
 },
 { code:0x32D0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32D0
  ,simpleLowerCaseMapping:0x32D0
  ,simpleTitleCaseMapping:0x32D0
 },
 { code:0x32D1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32D1
  ,simpleLowerCaseMapping:0x32D1
  ,simpleTitleCaseMapping:0x32D1
 },
 { code:0x32D2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32D2
  ,simpleLowerCaseMapping:0x32D2
  ,simpleTitleCaseMapping:0x32D2
 },
 { code:0x32D3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32D3
  ,simpleLowerCaseMapping:0x32D3
  ,simpleTitleCaseMapping:0x32D3
 },
 { code:0x32D4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32D4
  ,simpleLowerCaseMapping:0x32D4
  ,simpleTitleCaseMapping:0x32D4
 },
 { code:0x32D5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32D5
  ,simpleLowerCaseMapping:0x32D5
  ,simpleTitleCaseMapping:0x32D5
 },
 { code:0x32D6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32D6
  ,simpleLowerCaseMapping:0x32D6
  ,simpleTitleCaseMapping:0x32D6
 },
 { code:0x32D7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32D7
  ,simpleLowerCaseMapping:0x32D7
  ,simpleTitleCaseMapping:0x32D7
 },
 { code:0x32D8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32D8
  ,simpleLowerCaseMapping:0x32D8
  ,simpleTitleCaseMapping:0x32D8
 },
 { code:0x32D9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32D9
  ,simpleLowerCaseMapping:0x32D9
  ,simpleTitleCaseMapping:0x32D9
 },
 { code:0x32DA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32DA
  ,simpleLowerCaseMapping:0x32DA
  ,simpleTitleCaseMapping:0x32DA
 },
 { code:0x32DB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32DB
  ,simpleLowerCaseMapping:0x32DB
  ,simpleTitleCaseMapping:0x32DB
 },
 { code:0x32DC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32DC
  ,simpleLowerCaseMapping:0x32DC
  ,simpleTitleCaseMapping:0x32DC
 },
 { code:0x32DD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32DD
  ,simpleLowerCaseMapping:0x32DD
  ,simpleTitleCaseMapping:0x32DD
 },
 { code:0x32DE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32DE
  ,simpleLowerCaseMapping:0x32DE
  ,simpleTitleCaseMapping:0x32DE
 },
 { code:0x32DF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32DF
  ,simpleLowerCaseMapping:0x32DF
  ,simpleTitleCaseMapping:0x32DF
 },
 { code:0x32E0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32E0
  ,simpleLowerCaseMapping:0x32E0
  ,simpleTitleCaseMapping:0x32E0
 },
 { code:0x32E1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32E1
  ,simpleLowerCaseMapping:0x32E1
  ,simpleTitleCaseMapping:0x32E1
 },
 { code:0x32E2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32E2
  ,simpleLowerCaseMapping:0x32E2
  ,simpleTitleCaseMapping:0x32E2
 },
 { code:0x32E3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32E3
  ,simpleLowerCaseMapping:0x32E3
  ,simpleTitleCaseMapping:0x32E3
 },
 { code:0x32E4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32E4
  ,simpleLowerCaseMapping:0x32E4
  ,simpleTitleCaseMapping:0x32E4
 },
 { code:0x32E5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32E5
  ,simpleLowerCaseMapping:0x32E5
  ,simpleTitleCaseMapping:0x32E5
 },
 { code:0x32E6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32E6
  ,simpleLowerCaseMapping:0x32E6
  ,simpleTitleCaseMapping:0x32E6
 },
 { code:0x32E7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32E7
  ,simpleLowerCaseMapping:0x32E7
  ,simpleTitleCaseMapping:0x32E7
 },
 { code:0x32E8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32E8
  ,simpleLowerCaseMapping:0x32E8
  ,simpleTitleCaseMapping:0x32E8
 },
 { code:0x32E9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32E9
  ,simpleLowerCaseMapping:0x32E9
  ,simpleTitleCaseMapping:0x32E9
 },
 { code:0x32EA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32EA
  ,simpleLowerCaseMapping:0x32EA
  ,simpleTitleCaseMapping:0x32EA
 },
 { code:0x32EB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32EB
  ,simpleLowerCaseMapping:0x32EB
  ,simpleTitleCaseMapping:0x32EB
 },
 { code:0x32EC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32EC
  ,simpleLowerCaseMapping:0x32EC
  ,simpleTitleCaseMapping:0x32EC
 },
 { code:0x32ED
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32ED
  ,simpleLowerCaseMapping:0x32ED
  ,simpleTitleCaseMapping:0x32ED
 },
 { code:0x32EE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32EE
  ,simpleLowerCaseMapping:0x32EE
  ,simpleTitleCaseMapping:0x32EE
 },
 { code:0x32EF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32EF
  ,simpleLowerCaseMapping:0x32EF
  ,simpleTitleCaseMapping:0x32EF
 },
 { code:0x32F0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32F0
  ,simpleLowerCaseMapping:0x32F0
  ,simpleTitleCaseMapping:0x32F0
 },
 { code:0x32F1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32F1
  ,simpleLowerCaseMapping:0x32F1
  ,simpleTitleCaseMapping:0x32F1
 },
 { code:0x32F2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32F2
  ,simpleLowerCaseMapping:0x32F2
  ,simpleTitleCaseMapping:0x32F2
 },
 { code:0x32F3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32F3
  ,simpleLowerCaseMapping:0x32F3
  ,simpleTitleCaseMapping:0x32F3
 },
 { code:0x32F4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32F4
  ,simpleLowerCaseMapping:0x32F4
  ,simpleTitleCaseMapping:0x32F4
 },
 { code:0x32F5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32F5
  ,simpleLowerCaseMapping:0x32F5
  ,simpleTitleCaseMapping:0x32F5
 },
 { code:0x32F6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32F6
  ,simpleLowerCaseMapping:0x32F6
  ,simpleTitleCaseMapping:0x32F6
 },
 { code:0x32F7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32F7
  ,simpleLowerCaseMapping:0x32F7
  ,simpleTitleCaseMapping:0x32F7
 },
 { code:0x32F8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32F8
  ,simpleLowerCaseMapping:0x32F8
  ,simpleTitleCaseMapping:0x32F8
 },
 { code:0x32F9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32F9
  ,simpleLowerCaseMapping:0x32F9
  ,simpleTitleCaseMapping:0x32F9
 },
 { code:0x32FA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32FA
  ,simpleLowerCaseMapping:0x32FA
  ,simpleTitleCaseMapping:0x32FA
 },
 { code:0x32FB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32FB
  ,simpleLowerCaseMapping:0x32FB
  ,simpleTitleCaseMapping:0x32FB
 },
 { code:0x32FC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32FC
  ,simpleLowerCaseMapping:0x32FC
  ,simpleTitleCaseMapping:0x32FC
 },
 { code:0x32FD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32FD
  ,simpleLowerCaseMapping:0x32FD
  ,simpleTitleCaseMapping:0x32FD
 },
 { code:0x32FE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x32FE
  ,simpleLowerCaseMapping:0x32FE
  ,simpleTitleCaseMapping:0x32FE
 },
 { code:0x3300
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3300
  ,simpleLowerCaseMapping:0x3300
  ,simpleTitleCaseMapping:0x3300
 },
 { code:0x3301
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3301
  ,simpleLowerCaseMapping:0x3301
  ,simpleTitleCaseMapping:0x3301
 },
 { code:0x3302
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3302
  ,simpleLowerCaseMapping:0x3302
  ,simpleTitleCaseMapping:0x3302
 },
 { code:0x3303
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3303
  ,simpleLowerCaseMapping:0x3303
  ,simpleTitleCaseMapping:0x3303
 },
 { code:0x3304
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3304
  ,simpleLowerCaseMapping:0x3304
  ,simpleTitleCaseMapping:0x3304
 },
 { code:0x3305
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3305
  ,simpleLowerCaseMapping:0x3305
  ,simpleTitleCaseMapping:0x3305
 },
 { code:0x3306
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3306
  ,simpleLowerCaseMapping:0x3306
  ,simpleTitleCaseMapping:0x3306
 },
 { code:0x3307
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3307
  ,simpleLowerCaseMapping:0x3307
  ,simpleTitleCaseMapping:0x3307
 },
 { code:0x3308
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3308
  ,simpleLowerCaseMapping:0x3308
  ,simpleTitleCaseMapping:0x3308
 },
 { code:0x3309
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3309
  ,simpleLowerCaseMapping:0x3309
  ,simpleTitleCaseMapping:0x3309
 },
 { code:0x330A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x330A
  ,simpleLowerCaseMapping:0x330A
  ,simpleTitleCaseMapping:0x330A
 },
 { code:0x330B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x330B
  ,simpleLowerCaseMapping:0x330B
  ,simpleTitleCaseMapping:0x330B
 },
 { code:0x330C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x330C
  ,simpleLowerCaseMapping:0x330C
  ,simpleTitleCaseMapping:0x330C
 },
 { code:0x330D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x330D
  ,simpleLowerCaseMapping:0x330D
  ,simpleTitleCaseMapping:0x330D
 },
 { code:0x330E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x330E
  ,simpleLowerCaseMapping:0x330E
  ,simpleTitleCaseMapping:0x330E
 },
 { code:0x330F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x330F
  ,simpleLowerCaseMapping:0x330F
  ,simpleTitleCaseMapping:0x330F
 },
 { code:0x3310
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3310
  ,simpleLowerCaseMapping:0x3310
  ,simpleTitleCaseMapping:0x3310
 },
 { code:0x3311
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3311
  ,simpleLowerCaseMapping:0x3311
  ,simpleTitleCaseMapping:0x3311
 },
 { code:0x3312
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3312
  ,simpleLowerCaseMapping:0x3312
  ,simpleTitleCaseMapping:0x3312
 },
 { code:0x3313
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3313
  ,simpleLowerCaseMapping:0x3313
  ,simpleTitleCaseMapping:0x3313
 },
 { code:0x3314
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3314
  ,simpleLowerCaseMapping:0x3314
  ,simpleTitleCaseMapping:0x3314
 },
 { code:0x3315
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3315
  ,simpleLowerCaseMapping:0x3315
  ,simpleTitleCaseMapping:0x3315
 },
 { code:0x3316
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3316
  ,simpleLowerCaseMapping:0x3316
  ,simpleTitleCaseMapping:0x3316
 },
 { code:0x3317
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3317
  ,simpleLowerCaseMapping:0x3317
  ,simpleTitleCaseMapping:0x3317
 },
 { code:0x3318
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3318
  ,simpleLowerCaseMapping:0x3318
  ,simpleTitleCaseMapping:0x3318
 },
 { code:0x3319
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3319
  ,simpleLowerCaseMapping:0x3319
  ,simpleTitleCaseMapping:0x3319
 },
 { code:0x331A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x331A
  ,simpleLowerCaseMapping:0x331A
  ,simpleTitleCaseMapping:0x331A
 },
 { code:0x331B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x331B
  ,simpleLowerCaseMapping:0x331B
  ,simpleTitleCaseMapping:0x331B
 },
 { code:0x331C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x331C
  ,simpleLowerCaseMapping:0x331C
  ,simpleTitleCaseMapping:0x331C
 },
 { code:0x331D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x331D
  ,simpleLowerCaseMapping:0x331D
  ,simpleTitleCaseMapping:0x331D
 },
 { code:0x331E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x331E
  ,simpleLowerCaseMapping:0x331E
  ,simpleTitleCaseMapping:0x331E
 },
 { code:0x331F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x331F
  ,simpleLowerCaseMapping:0x331F
  ,simpleTitleCaseMapping:0x331F
 },
 { code:0x3320
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3320
  ,simpleLowerCaseMapping:0x3320
  ,simpleTitleCaseMapping:0x3320
 },
 { code:0x3321
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3321
  ,simpleLowerCaseMapping:0x3321
  ,simpleTitleCaseMapping:0x3321
 },
 { code:0x3322
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3322
  ,simpleLowerCaseMapping:0x3322
  ,simpleTitleCaseMapping:0x3322
 },
 { code:0x3323
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3323
  ,simpleLowerCaseMapping:0x3323
  ,simpleTitleCaseMapping:0x3323
 },
 { code:0x3324
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3324
  ,simpleLowerCaseMapping:0x3324
  ,simpleTitleCaseMapping:0x3324
 },
 { code:0x3325
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3325
  ,simpleLowerCaseMapping:0x3325
  ,simpleTitleCaseMapping:0x3325
 },
 { code:0x3326
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3326
  ,simpleLowerCaseMapping:0x3326
  ,simpleTitleCaseMapping:0x3326
 },
 { code:0x3327
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3327
  ,simpleLowerCaseMapping:0x3327
  ,simpleTitleCaseMapping:0x3327
 },
 { code:0x3328
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3328
  ,simpleLowerCaseMapping:0x3328
  ,simpleTitleCaseMapping:0x3328
 },
 { code:0x3329
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3329
  ,simpleLowerCaseMapping:0x3329
  ,simpleTitleCaseMapping:0x3329
 },
 { code:0x332A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x332A
  ,simpleLowerCaseMapping:0x332A
  ,simpleTitleCaseMapping:0x332A
 },
 { code:0x332B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x332B
  ,simpleLowerCaseMapping:0x332B
  ,simpleTitleCaseMapping:0x332B
 },
 { code:0x332C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x332C
  ,simpleLowerCaseMapping:0x332C
  ,simpleTitleCaseMapping:0x332C
 },
 { code:0x332D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x332D
  ,simpleLowerCaseMapping:0x332D
  ,simpleTitleCaseMapping:0x332D
 },
 { code:0x332E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x332E
  ,simpleLowerCaseMapping:0x332E
  ,simpleTitleCaseMapping:0x332E
 },
 { code:0x332F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x332F
  ,simpleLowerCaseMapping:0x332F
  ,simpleTitleCaseMapping:0x332F
 },
 { code:0x3330
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3330
  ,simpleLowerCaseMapping:0x3330
  ,simpleTitleCaseMapping:0x3330
 },
 { code:0x3331
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3331
  ,simpleLowerCaseMapping:0x3331
  ,simpleTitleCaseMapping:0x3331
 },
 { code:0x3332
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3332
  ,simpleLowerCaseMapping:0x3332
  ,simpleTitleCaseMapping:0x3332
 },
 { code:0x3333
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3333
  ,simpleLowerCaseMapping:0x3333
  ,simpleTitleCaseMapping:0x3333
 },
 { code:0x3334
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3334
  ,simpleLowerCaseMapping:0x3334
  ,simpleTitleCaseMapping:0x3334
 },
 { code:0x3335
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3335
  ,simpleLowerCaseMapping:0x3335
  ,simpleTitleCaseMapping:0x3335
 },
 { code:0x3336
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3336
  ,simpleLowerCaseMapping:0x3336
  ,simpleTitleCaseMapping:0x3336
 },
 { code:0x3337
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3337
  ,simpleLowerCaseMapping:0x3337
  ,simpleTitleCaseMapping:0x3337
 },
 { code:0x3338
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3338
  ,simpleLowerCaseMapping:0x3338
  ,simpleTitleCaseMapping:0x3338
 },
 { code:0x3339
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3339
  ,simpleLowerCaseMapping:0x3339
  ,simpleTitleCaseMapping:0x3339
 },
 { code:0x333A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x333A
  ,simpleLowerCaseMapping:0x333A
  ,simpleTitleCaseMapping:0x333A
 },
 { code:0x333B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x333B
  ,simpleLowerCaseMapping:0x333B
  ,simpleTitleCaseMapping:0x333B
 },
 { code:0x333C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x333C
  ,simpleLowerCaseMapping:0x333C
  ,simpleTitleCaseMapping:0x333C
 },
 { code:0x333D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x333D
  ,simpleLowerCaseMapping:0x333D
  ,simpleTitleCaseMapping:0x333D
 },
 { code:0x333E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x333E
  ,simpleLowerCaseMapping:0x333E
  ,simpleTitleCaseMapping:0x333E
 },
 { code:0x333F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x333F
  ,simpleLowerCaseMapping:0x333F
  ,simpleTitleCaseMapping:0x333F
 },
 { code:0x3340
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3340
  ,simpleLowerCaseMapping:0x3340
  ,simpleTitleCaseMapping:0x3340
 },
 { code:0x3341
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3341
  ,simpleLowerCaseMapping:0x3341
  ,simpleTitleCaseMapping:0x3341
 },
 { code:0x3342
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3342
  ,simpleLowerCaseMapping:0x3342
  ,simpleTitleCaseMapping:0x3342
 },
 { code:0x3343
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3343
  ,simpleLowerCaseMapping:0x3343
  ,simpleTitleCaseMapping:0x3343
 },
 { code:0x3344
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3344
  ,simpleLowerCaseMapping:0x3344
  ,simpleTitleCaseMapping:0x3344
 },
 { code:0x3345
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3345
  ,simpleLowerCaseMapping:0x3345
  ,simpleTitleCaseMapping:0x3345
 },
 { code:0x3346
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3346
  ,simpleLowerCaseMapping:0x3346
  ,simpleTitleCaseMapping:0x3346
 },
 { code:0x3347
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3347
  ,simpleLowerCaseMapping:0x3347
  ,simpleTitleCaseMapping:0x3347
 },
 { code:0x3348
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3348
  ,simpleLowerCaseMapping:0x3348
  ,simpleTitleCaseMapping:0x3348
 },
 { code:0x3349
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3349
  ,simpleLowerCaseMapping:0x3349
  ,simpleTitleCaseMapping:0x3349
 },
 { code:0x334A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x334A
  ,simpleLowerCaseMapping:0x334A
  ,simpleTitleCaseMapping:0x334A
 },
 { code:0x334B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x334B
  ,simpleLowerCaseMapping:0x334B
  ,simpleTitleCaseMapping:0x334B
 },
 { code:0x334C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x334C
  ,simpleLowerCaseMapping:0x334C
  ,simpleTitleCaseMapping:0x334C
 },
 { code:0x334D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x334D
  ,simpleLowerCaseMapping:0x334D
  ,simpleTitleCaseMapping:0x334D
 },
 { code:0x334E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x334E
  ,simpleLowerCaseMapping:0x334E
  ,simpleTitleCaseMapping:0x334E
 },
 { code:0x334F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x334F
  ,simpleLowerCaseMapping:0x334F
  ,simpleTitleCaseMapping:0x334F
 },
 { code:0x3350
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3350
  ,simpleLowerCaseMapping:0x3350
  ,simpleTitleCaseMapping:0x3350
 },
 { code:0x3351
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3351
  ,simpleLowerCaseMapping:0x3351
  ,simpleTitleCaseMapping:0x3351
 },
 { code:0x3352
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3352
  ,simpleLowerCaseMapping:0x3352
  ,simpleTitleCaseMapping:0x3352
 },
 { code:0x3353
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3353
  ,simpleLowerCaseMapping:0x3353
  ,simpleTitleCaseMapping:0x3353
 },
 { code:0x3354
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3354
  ,simpleLowerCaseMapping:0x3354
  ,simpleTitleCaseMapping:0x3354
 },
 { code:0x3355
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3355
  ,simpleLowerCaseMapping:0x3355
  ,simpleTitleCaseMapping:0x3355
 },
 { code:0x3356
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3356
  ,simpleLowerCaseMapping:0x3356
  ,simpleTitleCaseMapping:0x3356
 },
 { code:0x3357
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3357
  ,simpleLowerCaseMapping:0x3357
  ,simpleTitleCaseMapping:0x3357
 },
 { code:0x3358
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3358
  ,simpleLowerCaseMapping:0x3358
  ,simpleTitleCaseMapping:0x3358
 },
 { code:0x3359
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3359
  ,simpleLowerCaseMapping:0x3359
  ,simpleTitleCaseMapping:0x3359
 },
 { code:0x335A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x335A
  ,simpleLowerCaseMapping:0x335A
  ,simpleTitleCaseMapping:0x335A
 },
 { code:0x335B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x335B
  ,simpleLowerCaseMapping:0x335B
  ,simpleTitleCaseMapping:0x335B
 },
 { code:0x335C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x335C
  ,simpleLowerCaseMapping:0x335C
  ,simpleTitleCaseMapping:0x335C
 },
 { code:0x335D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x335D
  ,simpleLowerCaseMapping:0x335D
  ,simpleTitleCaseMapping:0x335D
 },
 { code:0x335E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x335E
  ,simpleLowerCaseMapping:0x335E
  ,simpleTitleCaseMapping:0x335E
 },
 { code:0x335F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x335F
  ,simpleLowerCaseMapping:0x335F
  ,simpleTitleCaseMapping:0x335F
 },
 { code:0x3360
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3360
  ,simpleLowerCaseMapping:0x3360
  ,simpleTitleCaseMapping:0x3360
 },
 { code:0x3361
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3361
  ,simpleLowerCaseMapping:0x3361
  ,simpleTitleCaseMapping:0x3361
 },
 { code:0x3362
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3362
  ,simpleLowerCaseMapping:0x3362
  ,simpleTitleCaseMapping:0x3362
 },
 { code:0x3363
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3363
  ,simpleLowerCaseMapping:0x3363
  ,simpleTitleCaseMapping:0x3363
 },
 { code:0x3364
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3364
  ,simpleLowerCaseMapping:0x3364
  ,simpleTitleCaseMapping:0x3364
 },
 { code:0x3365
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3365
  ,simpleLowerCaseMapping:0x3365
  ,simpleTitleCaseMapping:0x3365
 },
 { code:0x3366
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3366
  ,simpleLowerCaseMapping:0x3366
  ,simpleTitleCaseMapping:0x3366
 },
 { code:0x3367
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3367
  ,simpleLowerCaseMapping:0x3367
  ,simpleTitleCaseMapping:0x3367
 },
 { code:0x3368
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3368
  ,simpleLowerCaseMapping:0x3368
  ,simpleTitleCaseMapping:0x3368
 },
 { code:0x3369
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3369
  ,simpleLowerCaseMapping:0x3369
  ,simpleTitleCaseMapping:0x3369
 },
 { code:0x336A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x336A
  ,simpleLowerCaseMapping:0x336A
  ,simpleTitleCaseMapping:0x336A
 },
 { code:0x336B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x336B
  ,simpleLowerCaseMapping:0x336B
  ,simpleTitleCaseMapping:0x336B
 },
 { code:0x336C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x336C
  ,simpleLowerCaseMapping:0x336C
  ,simpleTitleCaseMapping:0x336C
 },
 { code:0x336D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x336D
  ,simpleLowerCaseMapping:0x336D
  ,simpleTitleCaseMapping:0x336D
 },
 { code:0x336E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x336E
  ,simpleLowerCaseMapping:0x336E
  ,simpleTitleCaseMapping:0x336E
 },
 { code:0x336F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x336F
  ,simpleLowerCaseMapping:0x336F
  ,simpleTitleCaseMapping:0x336F
 },
 { code:0x3370
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3370
  ,simpleLowerCaseMapping:0x3370
  ,simpleTitleCaseMapping:0x3370
 },
 { code:0x3371
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3371
  ,simpleLowerCaseMapping:0x3371
  ,simpleTitleCaseMapping:0x3371
 },
 { code:0x3372
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3372
  ,simpleLowerCaseMapping:0x3372
  ,simpleTitleCaseMapping:0x3372
 },
 { code:0x3373
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3373
  ,simpleLowerCaseMapping:0x3373
  ,simpleTitleCaseMapping:0x3373
 },
 { code:0x3374
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3374
  ,simpleLowerCaseMapping:0x3374
  ,simpleTitleCaseMapping:0x3374
 },
 { code:0x3375
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3375
  ,simpleLowerCaseMapping:0x3375
  ,simpleTitleCaseMapping:0x3375
 },
 { code:0x3376
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3376
  ,simpleLowerCaseMapping:0x3376
  ,simpleTitleCaseMapping:0x3376
 },
 { code:0x3377
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3377
  ,simpleLowerCaseMapping:0x3377
  ,simpleTitleCaseMapping:0x3377
 },
 { code:0x3378
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3378
  ,simpleLowerCaseMapping:0x3378
  ,simpleTitleCaseMapping:0x3378
 },
 { code:0x3379
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3379
  ,simpleLowerCaseMapping:0x3379
  ,simpleTitleCaseMapping:0x3379
 },
 { code:0x337A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x337A
  ,simpleLowerCaseMapping:0x337A
  ,simpleTitleCaseMapping:0x337A
 },
 { code:0x337B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x337B
  ,simpleLowerCaseMapping:0x337B
  ,simpleTitleCaseMapping:0x337B
 },
 { code:0x337C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x337C
  ,simpleLowerCaseMapping:0x337C
  ,simpleTitleCaseMapping:0x337C
 },
 { code:0x337D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x337D
  ,simpleLowerCaseMapping:0x337D
  ,simpleTitleCaseMapping:0x337D
 },
 { code:0x337E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x337E
  ,simpleLowerCaseMapping:0x337E
  ,simpleTitleCaseMapping:0x337E
 },
 { code:0x337F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x337F
  ,simpleLowerCaseMapping:0x337F
  ,simpleTitleCaseMapping:0x337F
 },
 { code:0x3380
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3380
  ,simpleLowerCaseMapping:0x3380
  ,simpleTitleCaseMapping:0x3380
 },
 { code:0x3381
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3381
  ,simpleLowerCaseMapping:0x3381
  ,simpleTitleCaseMapping:0x3381
 },
 { code:0x3382
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3382
  ,simpleLowerCaseMapping:0x3382
  ,simpleTitleCaseMapping:0x3382
 },
 { code:0x3383
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3383
  ,simpleLowerCaseMapping:0x3383
  ,simpleTitleCaseMapping:0x3383
 },
 { code:0x3384
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3384
  ,simpleLowerCaseMapping:0x3384
  ,simpleTitleCaseMapping:0x3384
 },
 { code:0x3385
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3385
  ,simpleLowerCaseMapping:0x3385
  ,simpleTitleCaseMapping:0x3385
 },
 { code:0x3386
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3386
  ,simpleLowerCaseMapping:0x3386
  ,simpleTitleCaseMapping:0x3386
 },
 { code:0x3387
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3387
  ,simpleLowerCaseMapping:0x3387
  ,simpleTitleCaseMapping:0x3387
 },
 { code:0x3388
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3388
  ,simpleLowerCaseMapping:0x3388
  ,simpleTitleCaseMapping:0x3388
 },
 { code:0x3389
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3389
  ,simpleLowerCaseMapping:0x3389
  ,simpleTitleCaseMapping:0x3389
 },
 { code:0x338A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x338A
  ,simpleLowerCaseMapping:0x338A
  ,simpleTitleCaseMapping:0x338A
 },
 { code:0x338B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x338B
  ,simpleLowerCaseMapping:0x338B
  ,simpleTitleCaseMapping:0x338B
 },
 { code:0x338C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x338C
  ,simpleLowerCaseMapping:0x338C
  ,simpleTitleCaseMapping:0x338C
 },
 { code:0x338D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x338D
  ,simpleLowerCaseMapping:0x338D
  ,simpleTitleCaseMapping:0x338D
 },
 { code:0x338E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x338E
  ,simpleLowerCaseMapping:0x338E
  ,simpleTitleCaseMapping:0x338E
 },
 { code:0x338F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x338F
  ,simpleLowerCaseMapping:0x338F
  ,simpleTitleCaseMapping:0x338F
 },
 { code:0x3390
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3390
  ,simpleLowerCaseMapping:0x3390
  ,simpleTitleCaseMapping:0x3390
 },
 { code:0x3391
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3391
  ,simpleLowerCaseMapping:0x3391
  ,simpleTitleCaseMapping:0x3391
 },
 { code:0x3392
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3392
  ,simpleLowerCaseMapping:0x3392
  ,simpleTitleCaseMapping:0x3392
 },
 { code:0x3393
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3393
  ,simpleLowerCaseMapping:0x3393
  ,simpleTitleCaseMapping:0x3393
 },
 { code:0x3394
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3394
  ,simpleLowerCaseMapping:0x3394
  ,simpleTitleCaseMapping:0x3394
 },
 { code:0x3395
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3395
  ,simpleLowerCaseMapping:0x3395
  ,simpleTitleCaseMapping:0x3395
 },
 { code:0x3396
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3396
  ,simpleLowerCaseMapping:0x3396
  ,simpleTitleCaseMapping:0x3396
 },
 { code:0x3397
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3397
  ,simpleLowerCaseMapping:0x3397
  ,simpleTitleCaseMapping:0x3397
 },
 { code:0x3398
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3398
  ,simpleLowerCaseMapping:0x3398
  ,simpleTitleCaseMapping:0x3398
 },
 { code:0x3399
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x3399
  ,simpleLowerCaseMapping:0x3399
  ,simpleTitleCaseMapping:0x3399
 },
 { code:0x339A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x339A
  ,simpleLowerCaseMapping:0x339A
  ,simpleTitleCaseMapping:0x339A
 },
 { code:0x339B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x339B
  ,simpleLowerCaseMapping:0x339B
  ,simpleTitleCaseMapping:0x339B
 },
 { code:0x339C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x339C
  ,simpleLowerCaseMapping:0x339C
  ,simpleTitleCaseMapping:0x339C
 },
 { code:0x339D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x339D
  ,simpleLowerCaseMapping:0x339D
  ,simpleTitleCaseMapping:0x339D
 },
 { code:0x339E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x339E
  ,simpleLowerCaseMapping:0x339E
  ,simpleTitleCaseMapping:0x339E
 },
 { code:0x339F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x339F
  ,simpleLowerCaseMapping:0x339F
  ,simpleTitleCaseMapping:0x339F
 },
 { code:0x33A0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33A0
  ,simpleLowerCaseMapping:0x33A0
  ,simpleTitleCaseMapping:0x33A0
 },
 { code:0x33A1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33A1
  ,simpleLowerCaseMapping:0x33A1
  ,simpleTitleCaseMapping:0x33A1
 },
 { code:0x33A2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33A2
  ,simpleLowerCaseMapping:0x33A2
  ,simpleTitleCaseMapping:0x33A2
 },
 { code:0x33A3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33A3
  ,simpleLowerCaseMapping:0x33A3
  ,simpleTitleCaseMapping:0x33A3
 },
 { code:0x33A4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33A4
  ,simpleLowerCaseMapping:0x33A4
  ,simpleTitleCaseMapping:0x33A4
 },
 { code:0x33A5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33A5
  ,simpleLowerCaseMapping:0x33A5
  ,simpleTitleCaseMapping:0x33A5
 },
 { code:0x33A6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33A6
  ,simpleLowerCaseMapping:0x33A6
  ,simpleTitleCaseMapping:0x33A6
 },
 { code:0x33A7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33A7
  ,simpleLowerCaseMapping:0x33A7
  ,simpleTitleCaseMapping:0x33A7
 },
 { code:0x33A8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33A8
  ,simpleLowerCaseMapping:0x33A8
  ,simpleTitleCaseMapping:0x33A8
 },
 { code:0x33A9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33A9
  ,simpleLowerCaseMapping:0x33A9
  ,simpleTitleCaseMapping:0x33A9
 },
 { code:0x33AA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33AA
  ,simpleLowerCaseMapping:0x33AA
  ,simpleTitleCaseMapping:0x33AA
 },
 { code:0x33AB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33AB
  ,simpleLowerCaseMapping:0x33AB
  ,simpleTitleCaseMapping:0x33AB
 },
 { code:0x33AC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33AC
  ,simpleLowerCaseMapping:0x33AC
  ,simpleTitleCaseMapping:0x33AC
 },
 { code:0x33AD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33AD
  ,simpleLowerCaseMapping:0x33AD
  ,simpleTitleCaseMapping:0x33AD
 },
 { code:0x33AE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33AE
  ,simpleLowerCaseMapping:0x33AE
  ,simpleTitleCaseMapping:0x33AE
 },
 { code:0x33AF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33AF
  ,simpleLowerCaseMapping:0x33AF
  ,simpleTitleCaseMapping:0x33AF
 },
 { code:0x33B0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33B0
  ,simpleLowerCaseMapping:0x33B0
  ,simpleTitleCaseMapping:0x33B0
 },
 { code:0x33B1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33B1
  ,simpleLowerCaseMapping:0x33B1
  ,simpleTitleCaseMapping:0x33B1
 },
 { code:0x33B2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33B2
  ,simpleLowerCaseMapping:0x33B2
  ,simpleTitleCaseMapping:0x33B2
 },
 { code:0x33B3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33B3
  ,simpleLowerCaseMapping:0x33B3
  ,simpleTitleCaseMapping:0x33B3
 },
 { code:0x33B4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33B4
  ,simpleLowerCaseMapping:0x33B4
  ,simpleTitleCaseMapping:0x33B4
 },
 { code:0x33B5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33B5
  ,simpleLowerCaseMapping:0x33B5
  ,simpleTitleCaseMapping:0x33B5
 },
 { code:0x33B6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33B6
  ,simpleLowerCaseMapping:0x33B6
  ,simpleTitleCaseMapping:0x33B6
 },
 { code:0x33B7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33B7
  ,simpleLowerCaseMapping:0x33B7
  ,simpleTitleCaseMapping:0x33B7
 },
 { code:0x33B8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33B8
  ,simpleLowerCaseMapping:0x33B8
  ,simpleTitleCaseMapping:0x33B8
 },
 { code:0x33B9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33B9
  ,simpleLowerCaseMapping:0x33B9
  ,simpleTitleCaseMapping:0x33B9
 },
 { code:0x33BA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33BA
  ,simpleLowerCaseMapping:0x33BA
  ,simpleTitleCaseMapping:0x33BA
 },
 { code:0x33BB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33BB
  ,simpleLowerCaseMapping:0x33BB
  ,simpleTitleCaseMapping:0x33BB
 },
 { code:0x33BC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33BC
  ,simpleLowerCaseMapping:0x33BC
  ,simpleTitleCaseMapping:0x33BC
 },
 { code:0x33BD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33BD
  ,simpleLowerCaseMapping:0x33BD
  ,simpleTitleCaseMapping:0x33BD
 },
 { code:0x33BE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33BE
  ,simpleLowerCaseMapping:0x33BE
  ,simpleTitleCaseMapping:0x33BE
 },
 { code:0x33BF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33BF
  ,simpleLowerCaseMapping:0x33BF
  ,simpleTitleCaseMapping:0x33BF
 },
 { code:0x33C0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33C0
  ,simpleLowerCaseMapping:0x33C0
  ,simpleTitleCaseMapping:0x33C0
 },
 { code:0x33C1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33C1
  ,simpleLowerCaseMapping:0x33C1
  ,simpleTitleCaseMapping:0x33C1
 },
 { code:0x33C2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33C2
  ,simpleLowerCaseMapping:0x33C2
  ,simpleTitleCaseMapping:0x33C2
 },
 { code:0x33C3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33C3
  ,simpleLowerCaseMapping:0x33C3
  ,simpleTitleCaseMapping:0x33C3
 },
 { code:0x33C4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33C4
  ,simpleLowerCaseMapping:0x33C4
  ,simpleTitleCaseMapping:0x33C4
 },
 { code:0x33C5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33C5
  ,simpleLowerCaseMapping:0x33C5
  ,simpleTitleCaseMapping:0x33C5
 },
 { code:0x33C6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33C6
  ,simpleLowerCaseMapping:0x33C6
  ,simpleTitleCaseMapping:0x33C6
 },
 { code:0x33C7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33C7
  ,simpleLowerCaseMapping:0x33C7
  ,simpleTitleCaseMapping:0x33C7
 },
 { code:0x33C8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33C8
  ,simpleLowerCaseMapping:0x33C8
  ,simpleTitleCaseMapping:0x33C8
 },
 { code:0x33C9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33C9
  ,simpleLowerCaseMapping:0x33C9
  ,simpleTitleCaseMapping:0x33C9
 },
 { code:0x33CA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33CA
  ,simpleLowerCaseMapping:0x33CA
  ,simpleTitleCaseMapping:0x33CA
 },
 { code:0x33CB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33CB
  ,simpleLowerCaseMapping:0x33CB
  ,simpleTitleCaseMapping:0x33CB
 },
 { code:0x33CC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33CC
  ,simpleLowerCaseMapping:0x33CC
  ,simpleTitleCaseMapping:0x33CC
 },
 { code:0x33CD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33CD
  ,simpleLowerCaseMapping:0x33CD
  ,simpleTitleCaseMapping:0x33CD
 },
 { code:0x33CE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33CE
  ,simpleLowerCaseMapping:0x33CE
  ,simpleTitleCaseMapping:0x33CE
 },
 { code:0x33CF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33CF
  ,simpleLowerCaseMapping:0x33CF
  ,simpleTitleCaseMapping:0x33CF
 },
 { code:0x33D0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33D0
  ,simpleLowerCaseMapping:0x33D0
  ,simpleTitleCaseMapping:0x33D0
 },
 { code:0x33D1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33D1
  ,simpleLowerCaseMapping:0x33D1
  ,simpleTitleCaseMapping:0x33D1
 },
 { code:0x33D2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33D2
  ,simpleLowerCaseMapping:0x33D2
  ,simpleTitleCaseMapping:0x33D2
 },
 { code:0x33D3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33D3
  ,simpleLowerCaseMapping:0x33D3
  ,simpleTitleCaseMapping:0x33D3
 },
 { code:0x33D4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33D4
  ,simpleLowerCaseMapping:0x33D4
  ,simpleTitleCaseMapping:0x33D4
 },
 { code:0x33D5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33D5
  ,simpleLowerCaseMapping:0x33D5
  ,simpleTitleCaseMapping:0x33D5
 },
 { code:0x33D6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33D6
  ,simpleLowerCaseMapping:0x33D6
  ,simpleTitleCaseMapping:0x33D6
 },
 { code:0x33D7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33D7
  ,simpleLowerCaseMapping:0x33D7
  ,simpleTitleCaseMapping:0x33D7
 },
 { code:0x33D8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33D8
  ,simpleLowerCaseMapping:0x33D8
  ,simpleTitleCaseMapping:0x33D8
 },
 { code:0x33D9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33D9
  ,simpleLowerCaseMapping:0x33D9
  ,simpleTitleCaseMapping:0x33D9
 },
 { code:0x33DA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33DA
  ,simpleLowerCaseMapping:0x33DA
  ,simpleTitleCaseMapping:0x33DA
 },
 { code:0x33DB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33DB
  ,simpleLowerCaseMapping:0x33DB
  ,simpleTitleCaseMapping:0x33DB
 },
 { code:0x33DC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33DC
  ,simpleLowerCaseMapping:0x33DC
  ,simpleTitleCaseMapping:0x33DC
 },
 { code:0x33DD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33DD
  ,simpleLowerCaseMapping:0x33DD
  ,simpleTitleCaseMapping:0x33DD
 },
 { code:0x33DE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33DE
  ,simpleLowerCaseMapping:0x33DE
  ,simpleTitleCaseMapping:0x33DE
 },
 { code:0x33DF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33DF
  ,simpleLowerCaseMapping:0x33DF
  ,simpleTitleCaseMapping:0x33DF
 },
 { code:0x33E0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33E0
  ,simpleLowerCaseMapping:0x33E0
  ,simpleTitleCaseMapping:0x33E0
 },
 { code:0x33E1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33E1
  ,simpleLowerCaseMapping:0x33E1
  ,simpleTitleCaseMapping:0x33E1
 },
 { code:0x33E2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33E2
  ,simpleLowerCaseMapping:0x33E2
  ,simpleTitleCaseMapping:0x33E2
 },
 { code:0x33E3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33E3
  ,simpleLowerCaseMapping:0x33E3
  ,simpleTitleCaseMapping:0x33E3
 },
 { code:0x33E4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33E4
  ,simpleLowerCaseMapping:0x33E4
  ,simpleTitleCaseMapping:0x33E4
 },
 { code:0x33E5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33E5
  ,simpleLowerCaseMapping:0x33E5
  ,simpleTitleCaseMapping:0x33E5
 },
 { code:0x33E6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33E6
  ,simpleLowerCaseMapping:0x33E6
  ,simpleTitleCaseMapping:0x33E6
 },
 { code:0x33E7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33E7
  ,simpleLowerCaseMapping:0x33E7
  ,simpleTitleCaseMapping:0x33E7
 },
 { code:0x33E8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33E8
  ,simpleLowerCaseMapping:0x33E8
  ,simpleTitleCaseMapping:0x33E8
 },
 { code:0x33E9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33E9
  ,simpleLowerCaseMapping:0x33E9
  ,simpleTitleCaseMapping:0x33E9
 },
 { code:0x33EA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33EA
  ,simpleLowerCaseMapping:0x33EA
  ,simpleTitleCaseMapping:0x33EA
 },
 { code:0x33EB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33EB
  ,simpleLowerCaseMapping:0x33EB
  ,simpleTitleCaseMapping:0x33EB
 },
 { code:0x33EC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33EC
  ,simpleLowerCaseMapping:0x33EC
  ,simpleTitleCaseMapping:0x33EC
 },
 { code:0x33ED
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33ED
  ,simpleLowerCaseMapping:0x33ED
  ,simpleTitleCaseMapping:0x33ED
 },
 { code:0x33EE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33EE
  ,simpleLowerCaseMapping:0x33EE
  ,simpleTitleCaseMapping:0x33EE
 },
 { code:0x33EF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33EF
  ,simpleLowerCaseMapping:0x33EF
  ,simpleTitleCaseMapping:0x33EF
 },
 { code:0x33F0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33F0
  ,simpleLowerCaseMapping:0x33F0
  ,simpleTitleCaseMapping:0x33F0
 },
 { code:0x33F1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33F1
  ,simpleLowerCaseMapping:0x33F1
  ,simpleTitleCaseMapping:0x33F1
 },
 { code:0x33F2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33F2
  ,simpleLowerCaseMapping:0x33F2
  ,simpleTitleCaseMapping:0x33F2
 },
 { code:0x33F3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33F3
  ,simpleLowerCaseMapping:0x33F3
  ,simpleTitleCaseMapping:0x33F3
 },
 { code:0x33F4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33F4
  ,simpleLowerCaseMapping:0x33F4
  ,simpleTitleCaseMapping:0x33F4
 },
 { code:0x33F5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33F5
  ,simpleLowerCaseMapping:0x33F5
  ,simpleTitleCaseMapping:0x33F5
 },
 { code:0x33F6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33F6
  ,simpleLowerCaseMapping:0x33F6
  ,simpleTitleCaseMapping:0x33F6
 },
 { code:0x33F7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33F7
  ,simpleLowerCaseMapping:0x33F7
  ,simpleTitleCaseMapping:0x33F7
 },
 { code:0x33F8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33F8
  ,simpleLowerCaseMapping:0x33F8
  ,simpleTitleCaseMapping:0x33F8
 },
 { code:0x33F9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33F9
  ,simpleLowerCaseMapping:0x33F9
  ,simpleTitleCaseMapping:0x33F9
 },
 { code:0x33FA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33FA
  ,simpleLowerCaseMapping:0x33FA
  ,simpleTitleCaseMapping:0x33FA
 },
 { code:0x33FB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33FB
  ,simpleLowerCaseMapping:0x33FB
  ,simpleTitleCaseMapping:0x33FB
 },
 { code:0x33FC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33FC
  ,simpleLowerCaseMapping:0x33FC
  ,simpleTitleCaseMapping:0x33FC
 },
 { code:0x33FD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33FD
  ,simpleLowerCaseMapping:0x33FD
  ,simpleTitleCaseMapping:0x33FD
 },
 { code:0x33FE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33FE
  ,simpleLowerCaseMapping:0x33FE
  ,simpleTitleCaseMapping:0x33FE
 },
 { code:0x33FF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x33FF
  ,simpleLowerCaseMapping:0x33FF
  ,simpleTitleCaseMapping:0x33FF
 },
 { code:0x3400
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x3400
  ,simpleLowerCaseMapping:0x3400
  ,simpleTitleCaseMapping:0x3400
 },
 { code:0x4DB5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x4DB5
  ,simpleLowerCaseMapping:0x4DB5
  ,simpleTitleCaseMapping:0x4DB5
 },
 { code:0x4DC0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DC0
  ,simpleLowerCaseMapping:0x4DC0
  ,simpleTitleCaseMapping:0x4DC0
 },
 { code:0x4DC1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DC1
  ,simpleLowerCaseMapping:0x4DC1
  ,simpleTitleCaseMapping:0x4DC1
 },
 { code:0x4DC2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DC2
  ,simpleLowerCaseMapping:0x4DC2
  ,simpleTitleCaseMapping:0x4DC2
 },
 { code:0x4DC3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DC3
  ,simpleLowerCaseMapping:0x4DC3
  ,simpleTitleCaseMapping:0x4DC3
 },
 { code:0x4DC4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DC4
  ,simpleLowerCaseMapping:0x4DC4
  ,simpleTitleCaseMapping:0x4DC4
 },
 { code:0x4DC5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DC5
  ,simpleLowerCaseMapping:0x4DC5
  ,simpleTitleCaseMapping:0x4DC5
 },
 { code:0x4DC6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DC6
  ,simpleLowerCaseMapping:0x4DC6
  ,simpleTitleCaseMapping:0x4DC6
 },
 { code:0x4DC7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DC7
  ,simpleLowerCaseMapping:0x4DC7
  ,simpleTitleCaseMapping:0x4DC7
 },
 { code:0x4DC8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DC8
  ,simpleLowerCaseMapping:0x4DC8
  ,simpleTitleCaseMapping:0x4DC8
 },
 { code:0x4DC9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DC9
  ,simpleLowerCaseMapping:0x4DC9
  ,simpleTitleCaseMapping:0x4DC9
 },
 { code:0x4DCA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DCA
  ,simpleLowerCaseMapping:0x4DCA
  ,simpleTitleCaseMapping:0x4DCA
 },
 { code:0x4DCB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DCB
  ,simpleLowerCaseMapping:0x4DCB
  ,simpleTitleCaseMapping:0x4DCB
 },
 { code:0x4DCC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DCC
  ,simpleLowerCaseMapping:0x4DCC
  ,simpleTitleCaseMapping:0x4DCC
 },
 { code:0x4DCD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DCD
  ,simpleLowerCaseMapping:0x4DCD
  ,simpleTitleCaseMapping:0x4DCD
 },
 { code:0x4DCE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DCE
  ,simpleLowerCaseMapping:0x4DCE
  ,simpleTitleCaseMapping:0x4DCE
 },
 { code:0x4DCF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DCF
  ,simpleLowerCaseMapping:0x4DCF
  ,simpleTitleCaseMapping:0x4DCF
 },
 { code:0x4DD0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DD0
  ,simpleLowerCaseMapping:0x4DD0
  ,simpleTitleCaseMapping:0x4DD0
 },
 { code:0x4DD1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DD1
  ,simpleLowerCaseMapping:0x4DD1
  ,simpleTitleCaseMapping:0x4DD1
 },
 { code:0x4DD2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DD2
  ,simpleLowerCaseMapping:0x4DD2
  ,simpleTitleCaseMapping:0x4DD2
 },
 { code:0x4DD3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DD3
  ,simpleLowerCaseMapping:0x4DD3
  ,simpleTitleCaseMapping:0x4DD3
 },
 { code:0x4DD4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DD4
  ,simpleLowerCaseMapping:0x4DD4
  ,simpleTitleCaseMapping:0x4DD4
 },
 { code:0x4DD5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DD5
  ,simpleLowerCaseMapping:0x4DD5
  ,simpleTitleCaseMapping:0x4DD5
 },
 { code:0x4DD6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DD6
  ,simpleLowerCaseMapping:0x4DD6
  ,simpleTitleCaseMapping:0x4DD6
 },
 { code:0x4DD7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DD7
  ,simpleLowerCaseMapping:0x4DD7
  ,simpleTitleCaseMapping:0x4DD7
 },
 { code:0x4DD8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DD8
  ,simpleLowerCaseMapping:0x4DD8
  ,simpleTitleCaseMapping:0x4DD8
 },
 { code:0x4DD9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DD9
  ,simpleLowerCaseMapping:0x4DD9
  ,simpleTitleCaseMapping:0x4DD9
 },
 { code:0x4DDA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DDA
  ,simpleLowerCaseMapping:0x4DDA
  ,simpleTitleCaseMapping:0x4DDA
 },
 { code:0x4DDB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DDB
  ,simpleLowerCaseMapping:0x4DDB
  ,simpleTitleCaseMapping:0x4DDB
 },
 { code:0x4DDC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DDC
  ,simpleLowerCaseMapping:0x4DDC
  ,simpleTitleCaseMapping:0x4DDC
 },
 { code:0x4DDD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DDD
  ,simpleLowerCaseMapping:0x4DDD
  ,simpleTitleCaseMapping:0x4DDD
 },
 { code:0x4DDE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DDE
  ,simpleLowerCaseMapping:0x4DDE
  ,simpleTitleCaseMapping:0x4DDE
 },
 { code:0x4DDF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DDF
  ,simpleLowerCaseMapping:0x4DDF
  ,simpleTitleCaseMapping:0x4DDF
 },
 { code:0x4DE0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DE0
  ,simpleLowerCaseMapping:0x4DE0
  ,simpleTitleCaseMapping:0x4DE0
 },
 { code:0x4DE1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DE1
  ,simpleLowerCaseMapping:0x4DE1
  ,simpleTitleCaseMapping:0x4DE1
 },
 { code:0x4DE2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DE2
  ,simpleLowerCaseMapping:0x4DE2
  ,simpleTitleCaseMapping:0x4DE2
 },
 { code:0x4DE3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DE3
  ,simpleLowerCaseMapping:0x4DE3
  ,simpleTitleCaseMapping:0x4DE3
 },
 { code:0x4DE4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DE4
  ,simpleLowerCaseMapping:0x4DE4
  ,simpleTitleCaseMapping:0x4DE4
 },
 { code:0x4DE5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DE5
  ,simpleLowerCaseMapping:0x4DE5
  ,simpleTitleCaseMapping:0x4DE5
 },
 { code:0x4DE6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DE6
  ,simpleLowerCaseMapping:0x4DE6
  ,simpleTitleCaseMapping:0x4DE6
 },
 { code:0x4DE7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DE7
  ,simpleLowerCaseMapping:0x4DE7
  ,simpleTitleCaseMapping:0x4DE7
 },
 { code:0x4DE8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DE8
  ,simpleLowerCaseMapping:0x4DE8
  ,simpleTitleCaseMapping:0x4DE8
 },
 { code:0x4DE9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DE9
  ,simpleLowerCaseMapping:0x4DE9
  ,simpleTitleCaseMapping:0x4DE9
 },
 { code:0x4DEA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DEA
  ,simpleLowerCaseMapping:0x4DEA
  ,simpleTitleCaseMapping:0x4DEA
 },
 { code:0x4DEB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DEB
  ,simpleLowerCaseMapping:0x4DEB
  ,simpleTitleCaseMapping:0x4DEB
 },
 { code:0x4DEC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DEC
  ,simpleLowerCaseMapping:0x4DEC
  ,simpleTitleCaseMapping:0x4DEC
 },
 { code:0x4DED
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DED
  ,simpleLowerCaseMapping:0x4DED
  ,simpleTitleCaseMapping:0x4DED
 },
 { code:0x4DEE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DEE
  ,simpleLowerCaseMapping:0x4DEE
  ,simpleTitleCaseMapping:0x4DEE
 },
 { code:0x4DEF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DEF
  ,simpleLowerCaseMapping:0x4DEF
  ,simpleTitleCaseMapping:0x4DEF
 },
 { code:0x4DF0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DF0
  ,simpleLowerCaseMapping:0x4DF0
  ,simpleTitleCaseMapping:0x4DF0
 },
 { code:0x4DF1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DF1
  ,simpleLowerCaseMapping:0x4DF1
  ,simpleTitleCaseMapping:0x4DF1
 },
 { code:0x4DF2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DF2
  ,simpleLowerCaseMapping:0x4DF2
  ,simpleTitleCaseMapping:0x4DF2
 },
 { code:0x4DF3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DF3
  ,simpleLowerCaseMapping:0x4DF3
  ,simpleTitleCaseMapping:0x4DF3
 },
 { code:0x4DF4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DF4
  ,simpleLowerCaseMapping:0x4DF4
  ,simpleTitleCaseMapping:0x4DF4
 },
 { code:0x4DF5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DF5
  ,simpleLowerCaseMapping:0x4DF5
  ,simpleTitleCaseMapping:0x4DF5
 },
 { code:0x4DF6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DF6
  ,simpleLowerCaseMapping:0x4DF6
  ,simpleTitleCaseMapping:0x4DF6
 },
 { code:0x4DF7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DF7
  ,simpleLowerCaseMapping:0x4DF7
  ,simpleTitleCaseMapping:0x4DF7
 },
 { code:0x4DF8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DF8
  ,simpleLowerCaseMapping:0x4DF8
  ,simpleTitleCaseMapping:0x4DF8
 },
 { code:0x4DF9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DF9
  ,simpleLowerCaseMapping:0x4DF9
  ,simpleTitleCaseMapping:0x4DF9
 },
 { code:0x4DFA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DFA
  ,simpleLowerCaseMapping:0x4DFA
  ,simpleTitleCaseMapping:0x4DFA
 },
 { code:0x4DFB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DFB
  ,simpleLowerCaseMapping:0x4DFB
  ,simpleTitleCaseMapping:0x4DFB
 },
 { code:0x4DFC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DFC
  ,simpleLowerCaseMapping:0x4DFC
  ,simpleTitleCaseMapping:0x4DFC
 },
 { code:0x4DFD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DFD
  ,simpleLowerCaseMapping:0x4DFD
  ,simpleTitleCaseMapping:0x4DFD
 },
 { code:0x4DFE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DFE
  ,simpleLowerCaseMapping:0x4DFE
  ,simpleTitleCaseMapping:0x4DFE
 },
 { code:0x4DFF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x4DFF
  ,simpleLowerCaseMapping:0x4DFF
  ,simpleTitleCaseMapping:0x4DFF
 },
 { code:0x4E00
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x4E00
  ,simpleLowerCaseMapping:0x4E00
  ,simpleTitleCaseMapping:0x4E00
 },
 { code:0x9FBB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x9FBB
  ,simpleLowerCaseMapping:0x9FBB
  ,simpleTitleCaseMapping:0x9FBB
 },
 { code:0xA000
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA000
  ,simpleLowerCaseMapping:0xA000
  ,simpleTitleCaseMapping:0xA000
 },
 { code:0xA001
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA001
  ,simpleLowerCaseMapping:0xA001
  ,simpleTitleCaseMapping:0xA001
 },
 { code:0xA002
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA002
  ,simpleLowerCaseMapping:0xA002
  ,simpleTitleCaseMapping:0xA002
 },
 { code:0xA003
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA003
  ,simpleLowerCaseMapping:0xA003
  ,simpleTitleCaseMapping:0xA003
 },
 { code:0xA004
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA004
  ,simpleLowerCaseMapping:0xA004
  ,simpleTitleCaseMapping:0xA004
 },
 { code:0xA005
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA005
  ,simpleLowerCaseMapping:0xA005
  ,simpleTitleCaseMapping:0xA005
 },
 { code:0xA006
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA006
  ,simpleLowerCaseMapping:0xA006
  ,simpleTitleCaseMapping:0xA006
 },
 { code:0xA007
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA007
  ,simpleLowerCaseMapping:0xA007
  ,simpleTitleCaseMapping:0xA007
 },
 { code:0xA008
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA008
  ,simpleLowerCaseMapping:0xA008
  ,simpleTitleCaseMapping:0xA008
 },
 { code:0xA009
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA009
  ,simpleLowerCaseMapping:0xA009
  ,simpleTitleCaseMapping:0xA009
 },
 { code:0xA00A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA00A
  ,simpleLowerCaseMapping:0xA00A
  ,simpleTitleCaseMapping:0xA00A
 },
 { code:0xA00B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA00B
  ,simpleLowerCaseMapping:0xA00B
  ,simpleTitleCaseMapping:0xA00B
 },
 { code:0xA00C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA00C
  ,simpleLowerCaseMapping:0xA00C
  ,simpleTitleCaseMapping:0xA00C
 },
 { code:0xA00D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA00D
  ,simpleLowerCaseMapping:0xA00D
  ,simpleTitleCaseMapping:0xA00D
 },
 { code:0xA00E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA00E
  ,simpleLowerCaseMapping:0xA00E
  ,simpleTitleCaseMapping:0xA00E
 },
 { code:0xA00F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA00F
  ,simpleLowerCaseMapping:0xA00F
  ,simpleTitleCaseMapping:0xA00F
 },
 { code:0xA010
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA010
  ,simpleLowerCaseMapping:0xA010
  ,simpleTitleCaseMapping:0xA010
 },
 { code:0xA011
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA011
  ,simpleLowerCaseMapping:0xA011
  ,simpleTitleCaseMapping:0xA011
 },
 { code:0xA012
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA012
  ,simpleLowerCaseMapping:0xA012
  ,simpleTitleCaseMapping:0xA012
 },
 { code:0xA013
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA013
  ,simpleLowerCaseMapping:0xA013
  ,simpleTitleCaseMapping:0xA013
 },
 { code:0xA014
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA014
  ,simpleLowerCaseMapping:0xA014
  ,simpleTitleCaseMapping:0xA014
 },
 { code:0xA015
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0xA015
  ,simpleLowerCaseMapping:0xA015
  ,simpleTitleCaseMapping:0xA015
 },
 { code:0xA016
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA016
  ,simpleLowerCaseMapping:0xA016
  ,simpleTitleCaseMapping:0xA016
 },
 { code:0xA017
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA017
  ,simpleLowerCaseMapping:0xA017
  ,simpleTitleCaseMapping:0xA017
 },
 { code:0xA018
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA018
  ,simpleLowerCaseMapping:0xA018
  ,simpleTitleCaseMapping:0xA018
 },
 { code:0xA019
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA019
  ,simpleLowerCaseMapping:0xA019
  ,simpleTitleCaseMapping:0xA019
 },
 { code:0xA01A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA01A
  ,simpleLowerCaseMapping:0xA01A
  ,simpleTitleCaseMapping:0xA01A
 },
 { code:0xA01B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA01B
  ,simpleLowerCaseMapping:0xA01B
  ,simpleTitleCaseMapping:0xA01B
 },
 { code:0xA01C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA01C
  ,simpleLowerCaseMapping:0xA01C
  ,simpleTitleCaseMapping:0xA01C
 },
 { code:0xA01D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA01D
  ,simpleLowerCaseMapping:0xA01D
  ,simpleTitleCaseMapping:0xA01D
 },
 { code:0xA01E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA01E
  ,simpleLowerCaseMapping:0xA01E
  ,simpleTitleCaseMapping:0xA01E
 },
 { code:0xA01F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA01F
  ,simpleLowerCaseMapping:0xA01F
  ,simpleTitleCaseMapping:0xA01F
 },
 { code:0xA020
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA020
  ,simpleLowerCaseMapping:0xA020
  ,simpleTitleCaseMapping:0xA020
 },
 { code:0xA021
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA021
  ,simpleLowerCaseMapping:0xA021
  ,simpleTitleCaseMapping:0xA021
 },
 { code:0xA022
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA022
  ,simpleLowerCaseMapping:0xA022
  ,simpleTitleCaseMapping:0xA022
 },
 { code:0xA023
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA023
  ,simpleLowerCaseMapping:0xA023
  ,simpleTitleCaseMapping:0xA023
 },
 { code:0xA024
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA024
  ,simpleLowerCaseMapping:0xA024
  ,simpleTitleCaseMapping:0xA024
 },
 { code:0xA025
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA025
  ,simpleLowerCaseMapping:0xA025
  ,simpleTitleCaseMapping:0xA025
 },
 { code:0xA026
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA026
  ,simpleLowerCaseMapping:0xA026
  ,simpleTitleCaseMapping:0xA026
 },
 { code:0xA027
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA027
  ,simpleLowerCaseMapping:0xA027
  ,simpleTitleCaseMapping:0xA027
 },
 { code:0xA028
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA028
  ,simpleLowerCaseMapping:0xA028
  ,simpleTitleCaseMapping:0xA028
 },
 { code:0xA029
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA029
  ,simpleLowerCaseMapping:0xA029
  ,simpleTitleCaseMapping:0xA029
 },
 { code:0xA02A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA02A
  ,simpleLowerCaseMapping:0xA02A
  ,simpleTitleCaseMapping:0xA02A
 },
 { code:0xA02B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA02B
  ,simpleLowerCaseMapping:0xA02B
  ,simpleTitleCaseMapping:0xA02B
 },
 { code:0xA02C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA02C
  ,simpleLowerCaseMapping:0xA02C
  ,simpleTitleCaseMapping:0xA02C
 },
 { code:0xA02D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA02D
  ,simpleLowerCaseMapping:0xA02D
  ,simpleTitleCaseMapping:0xA02D
 },
 { code:0xA02E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA02E
  ,simpleLowerCaseMapping:0xA02E
  ,simpleTitleCaseMapping:0xA02E
 },
 { code:0xA02F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA02F
  ,simpleLowerCaseMapping:0xA02F
  ,simpleTitleCaseMapping:0xA02F
 },
 { code:0xA030
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA030
  ,simpleLowerCaseMapping:0xA030
  ,simpleTitleCaseMapping:0xA030
 },
 { code:0xA031
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA031
  ,simpleLowerCaseMapping:0xA031
  ,simpleTitleCaseMapping:0xA031
 },
 { code:0xA032
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA032
  ,simpleLowerCaseMapping:0xA032
  ,simpleTitleCaseMapping:0xA032
 },
 { code:0xA033
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA033
  ,simpleLowerCaseMapping:0xA033
  ,simpleTitleCaseMapping:0xA033
 },
 { code:0xA034
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA034
  ,simpleLowerCaseMapping:0xA034
  ,simpleTitleCaseMapping:0xA034
 },
 { code:0xA035
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA035
  ,simpleLowerCaseMapping:0xA035
  ,simpleTitleCaseMapping:0xA035
 },
 { code:0xA036
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA036
  ,simpleLowerCaseMapping:0xA036
  ,simpleTitleCaseMapping:0xA036
 },
 { code:0xA037
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA037
  ,simpleLowerCaseMapping:0xA037
  ,simpleTitleCaseMapping:0xA037
 },
 { code:0xA038
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA038
  ,simpleLowerCaseMapping:0xA038
  ,simpleTitleCaseMapping:0xA038
 },
 { code:0xA039
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA039
  ,simpleLowerCaseMapping:0xA039
  ,simpleTitleCaseMapping:0xA039
 },
 { code:0xA03A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA03A
  ,simpleLowerCaseMapping:0xA03A
  ,simpleTitleCaseMapping:0xA03A
 },
 { code:0xA03B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA03B
  ,simpleLowerCaseMapping:0xA03B
  ,simpleTitleCaseMapping:0xA03B
 },
 { code:0xA03C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA03C
  ,simpleLowerCaseMapping:0xA03C
  ,simpleTitleCaseMapping:0xA03C
 },
 { code:0xA03D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA03D
  ,simpleLowerCaseMapping:0xA03D
  ,simpleTitleCaseMapping:0xA03D
 },
 { code:0xA03E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA03E
  ,simpleLowerCaseMapping:0xA03E
  ,simpleTitleCaseMapping:0xA03E
 },
 { code:0xA03F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA03F
  ,simpleLowerCaseMapping:0xA03F
  ,simpleTitleCaseMapping:0xA03F
 },
 { code:0xA040
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA040
  ,simpleLowerCaseMapping:0xA040
  ,simpleTitleCaseMapping:0xA040
 },
 { code:0xA041
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA041
  ,simpleLowerCaseMapping:0xA041
  ,simpleTitleCaseMapping:0xA041
 },
 { code:0xA042
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA042
  ,simpleLowerCaseMapping:0xA042
  ,simpleTitleCaseMapping:0xA042
 },
 { code:0xA043
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA043
  ,simpleLowerCaseMapping:0xA043
  ,simpleTitleCaseMapping:0xA043
 },
 { code:0xA044
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA044
  ,simpleLowerCaseMapping:0xA044
  ,simpleTitleCaseMapping:0xA044
 },
 { code:0xA045
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA045
  ,simpleLowerCaseMapping:0xA045
  ,simpleTitleCaseMapping:0xA045
 },
 { code:0xA046
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA046
  ,simpleLowerCaseMapping:0xA046
  ,simpleTitleCaseMapping:0xA046
 },
 { code:0xA047
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA047
  ,simpleLowerCaseMapping:0xA047
  ,simpleTitleCaseMapping:0xA047
 },
 { code:0xA048
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA048
  ,simpleLowerCaseMapping:0xA048
  ,simpleTitleCaseMapping:0xA048
 },
 { code:0xA049
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA049
  ,simpleLowerCaseMapping:0xA049
  ,simpleTitleCaseMapping:0xA049
 },
 { code:0xA04A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA04A
  ,simpleLowerCaseMapping:0xA04A
  ,simpleTitleCaseMapping:0xA04A
 },
 { code:0xA04B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA04B
  ,simpleLowerCaseMapping:0xA04B
  ,simpleTitleCaseMapping:0xA04B
 },
 { code:0xA04C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA04C
  ,simpleLowerCaseMapping:0xA04C
  ,simpleTitleCaseMapping:0xA04C
 },
 { code:0xA04D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA04D
  ,simpleLowerCaseMapping:0xA04D
  ,simpleTitleCaseMapping:0xA04D
 },
 { code:0xA04E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA04E
  ,simpleLowerCaseMapping:0xA04E
  ,simpleTitleCaseMapping:0xA04E
 },
 { code:0xA04F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA04F
  ,simpleLowerCaseMapping:0xA04F
  ,simpleTitleCaseMapping:0xA04F
 },
 { code:0xA050
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA050
  ,simpleLowerCaseMapping:0xA050
  ,simpleTitleCaseMapping:0xA050
 },
 { code:0xA051
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA051
  ,simpleLowerCaseMapping:0xA051
  ,simpleTitleCaseMapping:0xA051
 },
 { code:0xA052
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA052
  ,simpleLowerCaseMapping:0xA052
  ,simpleTitleCaseMapping:0xA052
 },
 { code:0xA053
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA053
  ,simpleLowerCaseMapping:0xA053
  ,simpleTitleCaseMapping:0xA053
 },
 { code:0xA054
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA054
  ,simpleLowerCaseMapping:0xA054
  ,simpleTitleCaseMapping:0xA054
 },
 { code:0xA055
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA055
  ,simpleLowerCaseMapping:0xA055
  ,simpleTitleCaseMapping:0xA055
 },
 { code:0xA056
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA056
  ,simpleLowerCaseMapping:0xA056
  ,simpleTitleCaseMapping:0xA056
 },
 { code:0xA057
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA057
  ,simpleLowerCaseMapping:0xA057
  ,simpleTitleCaseMapping:0xA057
 },
 { code:0xA058
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA058
  ,simpleLowerCaseMapping:0xA058
  ,simpleTitleCaseMapping:0xA058
 },
 { code:0xA059
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA059
  ,simpleLowerCaseMapping:0xA059
  ,simpleTitleCaseMapping:0xA059
 },
 { code:0xA05A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA05A
  ,simpleLowerCaseMapping:0xA05A
  ,simpleTitleCaseMapping:0xA05A
 },
 { code:0xA05B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA05B
  ,simpleLowerCaseMapping:0xA05B
  ,simpleTitleCaseMapping:0xA05B
 },
 { code:0xA05C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA05C
  ,simpleLowerCaseMapping:0xA05C
  ,simpleTitleCaseMapping:0xA05C
 },
 { code:0xA05D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA05D
  ,simpleLowerCaseMapping:0xA05D
  ,simpleTitleCaseMapping:0xA05D
 },
 { code:0xA05E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA05E
  ,simpleLowerCaseMapping:0xA05E
  ,simpleTitleCaseMapping:0xA05E
 },
 { code:0xA05F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA05F
  ,simpleLowerCaseMapping:0xA05F
  ,simpleTitleCaseMapping:0xA05F
 },
 { code:0xA060
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA060
  ,simpleLowerCaseMapping:0xA060
  ,simpleTitleCaseMapping:0xA060
 },
 { code:0xA061
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA061
  ,simpleLowerCaseMapping:0xA061
  ,simpleTitleCaseMapping:0xA061
 },
 { code:0xA062
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA062
  ,simpleLowerCaseMapping:0xA062
  ,simpleTitleCaseMapping:0xA062
 },
 { code:0xA063
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA063
  ,simpleLowerCaseMapping:0xA063
  ,simpleTitleCaseMapping:0xA063
 },
 { code:0xA064
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA064
  ,simpleLowerCaseMapping:0xA064
  ,simpleTitleCaseMapping:0xA064
 },
 { code:0xA065
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA065
  ,simpleLowerCaseMapping:0xA065
  ,simpleTitleCaseMapping:0xA065
 },
 { code:0xA066
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA066
  ,simpleLowerCaseMapping:0xA066
  ,simpleTitleCaseMapping:0xA066
 },
 { code:0xA067
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA067
  ,simpleLowerCaseMapping:0xA067
  ,simpleTitleCaseMapping:0xA067
 },
 { code:0xA068
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA068
  ,simpleLowerCaseMapping:0xA068
  ,simpleTitleCaseMapping:0xA068
 },
 { code:0xA069
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA069
  ,simpleLowerCaseMapping:0xA069
  ,simpleTitleCaseMapping:0xA069
 },
 { code:0xA06A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA06A
  ,simpleLowerCaseMapping:0xA06A
  ,simpleTitleCaseMapping:0xA06A
 },
 { code:0xA06B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA06B
  ,simpleLowerCaseMapping:0xA06B
  ,simpleTitleCaseMapping:0xA06B
 },
 { code:0xA06C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA06C
  ,simpleLowerCaseMapping:0xA06C
  ,simpleTitleCaseMapping:0xA06C
 },
 { code:0xA06D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA06D
  ,simpleLowerCaseMapping:0xA06D
  ,simpleTitleCaseMapping:0xA06D
 },
 { code:0xA06E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA06E
  ,simpleLowerCaseMapping:0xA06E
  ,simpleTitleCaseMapping:0xA06E
 },
 { code:0xA06F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA06F
  ,simpleLowerCaseMapping:0xA06F
  ,simpleTitleCaseMapping:0xA06F
 },
 { code:0xA070
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA070
  ,simpleLowerCaseMapping:0xA070
  ,simpleTitleCaseMapping:0xA070
 },
 { code:0xA071
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA071
  ,simpleLowerCaseMapping:0xA071
  ,simpleTitleCaseMapping:0xA071
 },
 { code:0xA072
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA072
  ,simpleLowerCaseMapping:0xA072
  ,simpleTitleCaseMapping:0xA072
 },
 { code:0xA073
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA073
  ,simpleLowerCaseMapping:0xA073
  ,simpleTitleCaseMapping:0xA073
 },
 { code:0xA074
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA074
  ,simpleLowerCaseMapping:0xA074
  ,simpleTitleCaseMapping:0xA074
 },
 { code:0xA075
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA075
  ,simpleLowerCaseMapping:0xA075
  ,simpleTitleCaseMapping:0xA075
 },
 { code:0xA076
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA076
  ,simpleLowerCaseMapping:0xA076
  ,simpleTitleCaseMapping:0xA076
 },
 { code:0xA077
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA077
  ,simpleLowerCaseMapping:0xA077
  ,simpleTitleCaseMapping:0xA077
 },
 { code:0xA078
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA078
  ,simpleLowerCaseMapping:0xA078
  ,simpleTitleCaseMapping:0xA078
 },
 { code:0xA079
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA079
  ,simpleLowerCaseMapping:0xA079
  ,simpleTitleCaseMapping:0xA079
 },
 { code:0xA07A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA07A
  ,simpleLowerCaseMapping:0xA07A
  ,simpleTitleCaseMapping:0xA07A
 },
 { code:0xA07B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA07B
  ,simpleLowerCaseMapping:0xA07B
  ,simpleTitleCaseMapping:0xA07B
 },
 { code:0xA07C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA07C
  ,simpleLowerCaseMapping:0xA07C
  ,simpleTitleCaseMapping:0xA07C
 },
 { code:0xA07D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA07D
  ,simpleLowerCaseMapping:0xA07D
  ,simpleTitleCaseMapping:0xA07D
 },
 { code:0xA07E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA07E
  ,simpleLowerCaseMapping:0xA07E
  ,simpleTitleCaseMapping:0xA07E
 },
 { code:0xA07F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA07F
  ,simpleLowerCaseMapping:0xA07F
  ,simpleTitleCaseMapping:0xA07F
 },
 { code:0xA080
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA080
  ,simpleLowerCaseMapping:0xA080
  ,simpleTitleCaseMapping:0xA080
 },
 { code:0xA081
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA081
  ,simpleLowerCaseMapping:0xA081
  ,simpleTitleCaseMapping:0xA081
 },
 { code:0xA082
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA082
  ,simpleLowerCaseMapping:0xA082
  ,simpleTitleCaseMapping:0xA082
 },
 { code:0xA083
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA083
  ,simpleLowerCaseMapping:0xA083
  ,simpleTitleCaseMapping:0xA083
 },
 { code:0xA084
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA084
  ,simpleLowerCaseMapping:0xA084
  ,simpleTitleCaseMapping:0xA084
 },
 { code:0xA085
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA085
  ,simpleLowerCaseMapping:0xA085
  ,simpleTitleCaseMapping:0xA085
 },
 { code:0xA086
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA086
  ,simpleLowerCaseMapping:0xA086
  ,simpleTitleCaseMapping:0xA086
 },
 { code:0xA087
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA087
  ,simpleLowerCaseMapping:0xA087
  ,simpleTitleCaseMapping:0xA087
 },
 { code:0xA088
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA088
  ,simpleLowerCaseMapping:0xA088
  ,simpleTitleCaseMapping:0xA088
 },
 { code:0xA089
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA089
  ,simpleLowerCaseMapping:0xA089
  ,simpleTitleCaseMapping:0xA089
 },
 { code:0xA08A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA08A
  ,simpleLowerCaseMapping:0xA08A
  ,simpleTitleCaseMapping:0xA08A
 },
 { code:0xA08B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA08B
  ,simpleLowerCaseMapping:0xA08B
  ,simpleTitleCaseMapping:0xA08B
 },
 { code:0xA08C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA08C
  ,simpleLowerCaseMapping:0xA08C
  ,simpleTitleCaseMapping:0xA08C
 },
 { code:0xA08D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA08D
  ,simpleLowerCaseMapping:0xA08D
  ,simpleTitleCaseMapping:0xA08D
 },
 { code:0xA08E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA08E
  ,simpleLowerCaseMapping:0xA08E
  ,simpleTitleCaseMapping:0xA08E
 },
 { code:0xA08F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA08F
  ,simpleLowerCaseMapping:0xA08F
  ,simpleTitleCaseMapping:0xA08F
 },
 { code:0xA090
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA090
  ,simpleLowerCaseMapping:0xA090
  ,simpleTitleCaseMapping:0xA090
 },
 { code:0xA091
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA091
  ,simpleLowerCaseMapping:0xA091
  ,simpleTitleCaseMapping:0xA091
 },
 { code:0xA092
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA092
  ,simpleLowerCaseMapping:0xA092
  ,simpleTitleCaseMapping:0xA092
 },
 { code:0xA093
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA093
  ,simpleLowerCaseMapping:0xA093
  ,simpleTitleCaseMapping:0xA093
 },
 { code:0xA094
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA094
  ,simpleLowerCaseMapping:0xA094
  ,simpleTitleCaseMapping:0xA094
 },
 { code:0xA095
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA095
  ,simpleLowerCaseMapping:0xA095
  ,simpleTitleCaseMapping:0xA095
 },
 { code:0xA096
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA096
  ,simpleLowerCaseMapping:0xA096
  ,simpleTitleCaseMapping:0xA096
 },
 { code:0xA097
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA097
  ,simpleLowerCaseMapping:0xA097
  ,simpleTitleCaseMapping:0xA097
 },
 { code:0xA098
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA098
  ,simpleLowerCaseMapping:0xA098
  ,simpleTitleCaseMapping:0xA098
 },
 { code:0xA099
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA099
  ,simpleLowerCaseMapping:0xA099
  ,simpleTitleCaseMapping:0xA099
 },
 { code:0xA09A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA09A
  ,simpleLowerCaseMapping:0xA09A
  ,simpleTitleCaseMapping:0xA09A
 },
 { code:0xA09B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA09B
  ,simpleLowerCaseMapping:0xA09B
  ,simpleTitleCaseMapping:0xA09B
 },
 { code:0xA09C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA09C
  ,simpleLowerCaseMapping:0xA09C
  ,simpleTitleCaseMapping:0xA09C
 },
 { code:0xA09D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA09D
  ,simpleLowerCaseMapping:0xA09D
  ,simpleTitleCaseMapping:0xA09D
 },
 { code:0xA09E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA09E
  ,simpleLowerCaseMapping:0xA09E
  ,simpleTitleCaseMapping:0xA09E
 },
 { code:0xA09F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA09F
  ,simpleLowerCaseMapping:0xA09F
  ,simpleTitleCaseMapping:0xA09F
 },
 { code:0xA0A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0A0
  ,simpleLowerCaseMapping:0xA0A0
  ,simpleTitleCaseMapping:0xA0A0
 },
 { code:0xA0A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0A1
  ,simpleLowerCaseMapping:0xA0A1
  ,simpleTitleCaseMapping:0xA0A1
 },
 { code:0xA0A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0A2
  ,simpleLowerCaseMapping:0xA0A2
  ,simpleTitleCaseMapping:0xA0A2
 },
 { code:0xA0A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0A3
  ,simpleLowerCaseMapping:0xA0A3
  ,simpleTitleCaseMapping:0xA0A3
 },
 { code:0xA0A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0A4
  ,simpleLowerCaseMapping:0xA0A4
  ,simpleTitleCaseMapping:0xA0A4
 },
 { code:0xA0A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0A5
  ,simpleLowerCaseMapping:0xA0A5
  ,simpleTitleCaseMapping:0xA0A5
 },
 { code:0xA0A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0A6
  ,simpleLowerCaseMapping:0xA0A6
  ,simpleTitleCaseMapping:0xA0A6
 },
 { code:0xA0A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0A7
  ,simpleLowerCaseMapping:0xA0A7
  ,simpleTitleCaseMapping:0xA0A7
 },
 { code:0xA0A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0A8
  ,simpleLowerCaseMapping:0xA0A8
  ,simpleTitleCaseMapping:0xA0A8
 },
 { code:0xA0A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0A9
  ,simpleLowerCaseMapping:0xA0A9
  ,simpleTitleCaseMapping:0xA0A9
 },
 { code:0xA0AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0AA
  ,simpleLowerCaseMapping:0xA0AA
  ,simpleTitleCaseMapping:0xA0AA
 },
 { code:0xA0AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0AB
  ,simpleLowerCaseMapping:0xA0AB
  ,simpleTitleCaseMapping:0xA0AB
 },
 { code:0xA0AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0AC
  ,simpleLowerCaseMapping:0xA0AC
  ,simpleTitleCaseMapping:0xA0AC
 },
 { code:0xA0AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0AD
  ,simpleLowerCaseMapping:0xA0AD
  ,simpleTitleCaseMapping:0xA0AD
 },
 { code:0xA0AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0AE
  ,simpleLowerCaseMapping:0xA0AE
  ,simpleTitleCaseMapping:0xA0AE
 },
 { code:0xA0AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0AF
  ,simpleLowerCaseMapping:0xA0AF
  ,simpleTitleCaseMapping:0xA0AF
 },
 { code:0xA0B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0B0
  ,simpleLowerCaseMapping:0xA0B0
  ,simpleTitleCaseMapping:0xA0B0
 },
 { code:0xA0B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0B1
  ,simpleLowerCaseMapping:0xA0B1
  ,simpleTitleCaseMapping:0xA0B1
 },
 { code:0xA0B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0B2
  ,simpleLowerCaseMapping:0xA0B2
  ,simpleTitleCaseMapping:0xA0B2
 },
 { code:0xA0B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0B3
  ,simpleLowerCaseMapping:0xA0B3
  ,simpleTitleCaseMapping:0xA0B3
 },
 { code:0xA0B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0B4
  ,simpleLowerCaseMapping:0xA0B4
  ,simpleTitleCaseMapping:0xA0B4
 },
 { code:0xA0B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0B5
  ,simpleLowerCaseMapping:0xA0B5
  ,simpleTitleCaseMapping:0xA0B5
 },
 { code:0xA0B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0B6
  ,simpleLowerCaseMapping:0xA0B6
  ,simpleTitleCaseMapping:0xA0B6
 },
 { code:0xA0B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0B7
  ,simpleLowerCaseMapping:0xA0B7
  ,simpleTitleCaseMapping:0xA0B7
 },
 { code:0xA0B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0B8
  ,simpleLowerCaseMapping:0xA0B8
  ,simpleTitleCaseMapping:0xA0B8
 },
 { code:0xA0B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0B9
  ,simpleLowerCaseMapping:0xA0B9
  ,simpleTitleCaseMapping:0xA0B9
 },
 { code:0xA0BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0BA
  ,simpleLowerCaseMapping:0xA0BA
  ,simpleTitleCaseMapping:0xA0BA
 },
 { code:0xA0BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0BB
  ,simpleLowerCaseMapping:0xA0BB
  ,simpleTitleCaseMapping:0xA0BB
 },
 { code:0xA0BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0BC
  ,simpleLowerCaseMapping:0xA0BC
  ,simpleTitleCaseMapping:0xA0BC
 },
 { code:0xA0BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0BD
  ,simpleLowerCaseMapping:0xA0BD
  ,simpleTitleCaseMapping:0xA0BD
 },
 { code:0xA0BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0BE
  ,simpleLowerCaseMapping:0xA0BE
  ,simpleTitleCaseMapping:0xA0BE
 },
 { code:0xA0BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0BF
  ,simpleLowerCaseMapping:0xA0BF
  ,simpleTitleCaseMapping:0xA0BF
 },
 { code:0xA0C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0C0
  ,simpleLowerCaseMapping:0xA0C0
  ,simpleTitleCaseMapping:0xA0C0
 },
 { code:0xA0C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0C1
  ,simpleLowerCaseMapping:0xA0C1
  ,simpleTitleCaseMapping:0xA0C1
 },
 { code:0xA0C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0C2
  ,simpleLowerCaseMapping:0xA0C2
  ,simpleTitleCaseMapping:0xA0C2
 },
 { code:0xA0C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0C3
  ,simpleLowerCaseMapping:0xA0C3
  ,simpleTitleCaseMapping:0xA0C3
 },
 { code:0xA0C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0C4
  ,simpleLowerCaseMapping:0xA0C4
  ,simpleTitleCaseMapping:0xA0C4
 },
 { code:0xA0C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0C5
  ,simpleLowerCaseMapping:0xA0C5
  ,simpleTitleCaseMapping:0xA0C5
 },
 { code:0xA0C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0C6
  ,simpleLowerCaseMapping:0xA0C6
  ,simpleTitleCaseMapping:0xA0C6
 },
 { code:0xA0C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0C7
  ,simpleLowerCaseMapping:0xA0C7
  ,simpleTitleCaseMapping:0xA0C7
 },
 { code:0xA0C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0C8
  ,simpleLowerCaseMapping:0xA0C8
  ,simpleTitleCaseMapping:0xA0C8
 },
 { code:0xA0C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0C9
  ,simpleLowerCaseMapping:0xA0C9
  ,simpleTitleCaseMapping:0xA0C9
 },
 { code:0xA0CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0CA
  ,simpleLowerCaseMapping:0xA0CA
  ,simpleTitleCaseMapping:0xA0CA
 },
 { code:0xA0CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0CB
  ,simpleLowerCaseMapping:0xA0CB
  ,simpleTitleCaseMapping:0xA0CB
 },
 { code:0xA0CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0CC
  ,simpleLowerCaseMapping:0xA0CC
  ,simpleTitleCaseMapping:0xA0CC
 },
 { code:0xA0CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0CD
  ,simpleLowerCaseMapping:0xA0CD
  ,simpleTitleCaseMapping:0xA0CD
 },
 { code:0xA0CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0CE
  ,simpleLowerCaseMapping:0xA0CE
  ,simpleTitleCaseMapping:0xA0CE
 },
 { code:0xA0CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0CF
  ,simpleLowerCaseMapping:0xA0CF
  ,simpleTitleCaseMapping:0xA0CF
 },
 { code:0xA0D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0D0
  ,simpleLowerCaseMapping:0xA0D0
  ,simpleTitleCaseMapping:0xA0D0
 },
 { code:0xA0D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0D1
  ,simpleLowerCaseMapping:0xA0D1
  ,simpleTitleCaseMapping:0xA0D1
 },
 { code:0xA0D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0D2
  ,simpleLowerCaseMapping:0xA0D2
  ,simpleTitleCaseMapping:0xA0D2
 },
 { code:0xA0D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0D3
  ,simpleLowerCaseMapping:0xA0D3
  ,simpleTitleCaseMapping:0xA0D3
 },
 { code:0xA0D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0D4
  ,simpleLowerCaseMapping:0xA0D4
  ,simpleTitleCaseMapping:0xA0D4
 },
 { code:0xA0D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0D5
  ,simpleLowerCaseMapping:0xA0D5
  ,simpleTitleCaseMapping:0xA0D5
 },
 { code:0xA0D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0D6
  ,simpleLowerCaseMapping:0xA0D6
  ,simpleTitleCaseMapping:0xA0D6
 },
 { code:0xA0D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0D7
  ,simpleLowerCaseMapping:0xA0D7
  ,simpleTitleCaseMapping:0xA0D7
 },
 { code:0xA0D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0D8
  ,simpleLowerCaseMapping:0xA0D8
  ,simpleTitleCaseMapping:0xA0D8
 },
 { code:0xA0D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0D9
  ,simpleLowerCaseMapping:0xA0D9
  ,simpleTitleCaseMapping:0xA0D9
 },
 { code:0xA0DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0DA
  ,simpleLowerCaseMapping:0xA0DA
  ,simpleTitleCaseMapping:0xA0DA
 },
 { code:0xA0DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0DB
  ,simpleLowerCaseMapping:0xA0DB
  ,simpleTitleCaseMapping:0xA0DB
 },
 { code:0xA0DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0DC
  ,simpleLowerCaseMapping:0xA0DC
  ,simpleTitleCaseMapping:0xA0DC
 },
 { code:0xA0DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0DD
  ,simpleLowerCaseMapping:0xA0DD
  ,simpleTitleCaseMapping:0xA0DD
 },
 { code:0xA0DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0DE
  ,simpleLowerCaseMapping:0xA0DE
  ,simpleTitleCaseMapping:0xA0DE
 },
 { code:0xA0DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0DF
  ,simpleLowerCaseMapping:0xA0DF
  ,simpleTitleCaseMapping:0xA0DF
 },
 { code:0xA0E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0E0
  ,simpleLowerCaseMapping:0xA0E0
  ,simpleTitleCaseMapping:0xA0E0
 },
 { code:0xA0E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0E1
  ,simpleLowerCaseMapping:0xA0E1
  ,simpleTitleCaseMapping:0xA0E1
 },
 { code:0xA0E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0E2
  ,simpleLowerCaseMapping:0xA0E2
  ,simpleTitleCaseMapping:0xA0E2
 },
 { code:0xA0E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0E3
  ,simpleLowerCaseMapping:0xA0E3
  ,simpleTitleCaseMapping:0xA0E3
 },
 { code:0xA0E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0E4
  ,simpleLowerCaseMapping:0xA0E4
  ,simpleTitleCaseMapping:0xA0E4
 },
 { code:0xA0E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0E5
  ,simpleLowerCaseMapping:0xA0E5
  ,simpleTitleCaseMapping:0xA0E5
 },
 { code:0xA0E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0E6
  ,simpleLowerCaseMapping:0xA0E6
  ,simpleTitleCaseMapping:0xA0E6
 },
 { code:0xA0E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0E7
  ,simpleLowerCaseMapping:0xA0E7
  ,simpleTitleCaseMapping:0xA0E7
 },
 { code:0xA0E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0E8
  ,simpleLowerCaseMapping:0xA0E8
  ,simpleTitleCaseMapping:0xA0E8
 },
 { code:0xA0E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0E9
  ,simpleLowerCaseMapping:0xA0E9
  ,simpleTitleCaseMapping:0xA0E9
 },
 { code:0xA0EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0EA
  ,simpleLowerCaseMapping:0xA0EA
  ,simpleTitleCaseMapping:0xA0EA
 },
 { code:0xA0EB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0EB
  ,simpleLowerCaseMapping:0xA0EB
  ,simpleTitleCaseMapping:0xA0EB
 },
 { code:0xA0EC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0EC
  ,simpleLowerCaseMapping:0xA0EC
  ,simpleTitleCaseMapping:0xA0EC
 },
 { code:0xA0ED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0ED
  ,simpleLowerCaseMapping:0xA0ED
  ,simpleTitleCaseMapping:0xA0ED
 },
 { code:0xA0EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0EE
  ,simpleLowerCaseMapping:0xA0EE
  ,simpleTitleCaseMapping:0xA0EE
 },
 { code:0xA0EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0EF
  ,simpleLowerCaseMapping:0xA0EF
  ,simpleTitleCaseMapping:0xA0EF
 },
 { code:0xA0F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0F0
  ,simpleLowerCaseMapping:0xA0F0
  ,simpleTitleCaseMapping:0xA0F0
 },
 { code:0xA0F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0F1
  ,simpleLowerCaseMapping:0xA0F1
  ,simpleTitleCaseMapping:0xA0F1
 },
 { code:0xA0F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0F2
  ,simpleLowerCaseMapping:0xA0F2
  ,simpleTitleCaseMapping:0xA0F2
 },
 { code:0xA0F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0F3
  ,simpleLowerCaseMapping:0xA0F3
  ,simpleTitleCaseMapping:0xA0F3
 },
 { code:0xA0F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0F4
  ,simpleLowerCaseMapping:0xA0F4
  ,simpleTitleCaseMapping:0xA0F4
 },
 { code:0xA0F5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0F5
  ,simpleLowerCaseMapping:0xA0F5
  ,simpleTitleCaseMapping:0xA0F5
 },
 { code:0xA0F6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0F6
  ,simpleLowerCaseMapping:0xA0F6
  ,simpleTitleCaseMapping:0xA0F6
 },
 { code:0xA0F7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0F7
  ,simpleLowerCaseMapping:0xA0F7
  ,simpleTitleCaseMapping:0xA0F7
 },
 { code:0xA0F8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0F8
  ,simpleLowerCaseMapping:0xA0F8
  ,simpleTitleCaseMapping:0xA0F8
 },
 { code:0xA0F9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0F9
  ,simpleLowerCaseMapping:0xA0F9
  ,simpleTitleCaseMapping:0xA0F9
 },
 { code:0xA0FA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0FA
  ,simpleLowerCaseMapping:0xA0FA
  ,simpleTitleCaseMapping:0xA0FA
 },
 { code:0xA0FB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0FB
  ,simpleLowerCaseMapping:0xA0FB
  ,simpleTitleCaseMapping:0xA0FB
 },
 { code:0xA0FC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0FC
  ,simpleLowerCaseMapping:0xA0FC
  ,simpleTitleCaseMapping:0xA0FC
 },
 { code:0xA0FD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0FD
  ,simpleLowerCaseMapping:0xA0FD
  ,simpleTitleCaseMapping:0xA0FD
 },
 { code:0xA0FE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0FE
  ,simpleLowerCaseMapping:0xA0FE
  ,simpleTitleCaseMapping:0xA0FE
 },
 { code:0xA0FF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA0FF
  ,simpleLowerCaseMapping:0xA0FF
  ,simpleTitleCaseMapping:0xA0FF
 },
 { code:0xA100
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA100
  ,simpleLowerCaseMapping:0xA100
  ,simpleTitleCaseMapping:0xA100
 },
 { code:0xA101
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA101
  ,simpleLowerCaseMapping:0xA101
  ,simpleTitleCaseMapping:0xA101
 },
 { code:0xA102
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA102
  ,simpleLowerCaseMapping:0xA102
  ,simpleTitleCaseMapping:0xA102
 },
 { code:0xA103
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA103
  ,simpleLowerCaseMapping:0xA103
  ,simpleTitleCaseMapping:0xA103
 },
 { code:0xA104
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA104
  ,simpleLowerCaseMapping:0xA104
  ,simpleTitleCaseMapping:0xA104
 },
 { code:0xA105
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA105
  ,simpleLowerCaseMapping:0xA105
  ,simpleTitleCaseMapping:0xA105
 },
 { code:0xA106
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA106
  ,simpleLowerCaseMapping:0xA106
  ,simpleTitleCaseMapping:0xA106
 },
 { code:0xA107
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA107
  ,simpleLowerCaseMapping:0xA107
  ,simpleTitleCaseMapping:0xA107
 },
 { code:0xA108
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA108
  ,simpleLowerCaseMapping:0xA108
  ,simpleTitleCaseMapping:0xA108
 },
 { code:0xA109
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA109
  ,simpleLowerCaseMapping:0xA109
  ,simpleTitleCaseMapping:0xA109
 },
 { code:0xA10A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA10A
  ,simpleLowerCaseMapping:0xA10A
  ,simpleTitleCaseMapping:0xA10A
 },
 { code:0xA10B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA10B
  ,simpleLowerCaseMapping:0xA10B
  ,simpleTitleCaseMapping:0xA10B
 },
 { code:0xA10C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA10C
  ,simpleLowerCaseMapping:0xA10C
  ,simpleTitleCaseMapping:0xA10C
 },
 { code:0xA10D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA10D
  ,simpleLowerCaseMapping:0xA10D
  ,simpleTitleCaseMapping:0xA10D
 },
 { code:0xA10E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA10E
  ,simpleLowerCaseMapping:0xA10E
  ,simpleTitleCaseMapping:0xA10E
 },
 { code:0xA10F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA10F
  ,simpleLowerCaseMapping:0xA10F
  ,simpleTitleCaseMapping:0xA10F
 },
 { code:0xA110
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA110
  ,simpleLowerCaseMapping:0xA110
  ,simpleTitleCaseMapping:0xA110
 },
 { code:0xA111
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA111
  ,simpleLowerCaseMapping:0xA111
  ,simpleTitleCaseMapping:0xA111
 },
 { code:0xA112
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA112
  ,simpleLowerCaseMapping:0xA112
  ,simpleTitleCaseMapping:0xA112
 },
 { code:0xA113
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA113
  ,simpleLowerCaseMapping:0xA113
  ,simpleTitleCaseMapping:0xA113
 },
 { code:0xA114
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA114
  ,simpleLowerCaseMapping:0xA114
  ,simpleTitleCaseMapping:0xA114
 },
 { code:0xA115
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA115
  ,simpleLowerCaseMapping:0xA115
  ,simpleTitleCaseMapping:0xA115
 },
 { code:0xA116
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA116
  ,simpleLowerCaseMapping:0xA116
  ,simpleTitleCaseMapping:0xA116
 },
 { code:0xA117
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA117
  ,simpleLowerCaseMapping:0xA117
  ,simpleTitleCaseMapping:0xA117
 },
 { code:0xA118
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA118
  ,simpleLowerCaseMapping:0xA118
  ,simpleTitleCaseMapping:0xA118
 },
 { code:0xA119
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA119
  ,simpleLowerCaseMapping:0xA119
  ,simpleTitleCaseMapping:0xA119
 },
 { code:0xA11A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA11A
  ,simpleLowerCaseMapping:0xA11A
  ,simpleTitleCaseMapping:0xA11A
 },
 { code:0xA11B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA11B
  ,simpleLowerCaseMapping:0xA11B
  ,simpleTitleCaseMapping:0xA11B
 },
 { code:0xA11C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA11C
  ,simpleLowerCaseMapping:0xA11C
  ,simpleTitleCaseMapping:0xA11C
 },
 { code:0xA11D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA11D
  ,simpleLowerCaseMapping:0xA11D
  ,simpleTitleCaseMapping:0xA11D
 },
 { code:0xA11E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA11E
  ,simpleLowerCaseMapping:0xA11E
  ,simpleTitleCaseMapping:0xA11E
 },
 { code:0xA11F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA11F
  ,simpleLowerCaseMapping:0xA11F
  ,simpleTitleCaseMapping:0xA11F
 },
 { code:0xA120
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA120
  ,simpleLowerCaseMapping:0xA120
  ,simpleTitleCaseMapping:0xA120
 },
 { code:0xA121
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA121
  ,simpleLowerCaseMapping:0xA121
  ,simpleTitleCaseMapping:0xA121
 },
 { code:0xA122
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA122
  ,simpleLowerCaseMapping:0xA122
  ,simpleTitleCaseMapping:0xA122
 },
 { code:0xA123
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA123
  ,simpleLowerCaseMapping:0xA123
  ,simpleTitleCaseMapping:0xA123
 },
 { code:0xA124
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA124
  ,simpleLowerCaseMapping:0xA124
  ,simpleTitleCaseMapping:0xA124
 },
 { code:0xA125
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA125
  ,simpleLowerCaseMapping:0xA125
  ,simpleTitleCaseMapping:0xA125
 },
 { code:0xA126
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA126
  ,simpleLowerCaseMapping:0xA126
  ,simpleTitleCaseMapping:0xA126
 },
 { code:0xA127
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA127
  ,simpleLowerCaseMapping:0xA127
  ,simpleTitleCaseMapping:0xA127
 },
 { code:0xA128
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA128
  ,simpleLowerCaseMapping:0xA128
  ,simpleTitleCaseMapping:0xA128
 },
 { code:0xA129
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA129
  ,simpleLowerCaseMapping:0xA129
  ,simpleTitleCaseMapping:0xA129
 },
 { code:0xA12A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA12A
  ,simpleLowerCaseMapping:0xA12A
  ,simpleTitleCaseMapping:0xA12A
 },
 { code:0xA12B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA12B
  ,simpleLowerCaseMapping:0xA12B
  ,simpleTitleCaseMapping:0xA12B
 },
 { code:0xA12C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA12C
  ,simpleLowerCaseMapping:0xA12C
  ,simpleTitleCaseMapping:0xA12C
 },
 { code:0xA12D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA12D
  ,simpleLowerCaseMapping:0xA12D
  ,simpleTitleCaseMapping:0xA12D
 },
 { code:0xA12E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA12E
  ,simpleLowerCaseMapping:0xA12E
  ,simpleTitleCaseMapping:0xA12E
 },
 { code:0xA12F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA12F
  ,simpleLowerCaseMapping:0xA12F
  ,simpleTitleCaseMapping:0xA12F
 },
 { code:0xA130
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA130
  ,simpleLowerCaseMapping:0xA130
  ,simpleTitleCaseMapping:0xA130
 },
 { code:0xA131
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA131
  ,simpleLowerCaseMapping:0xA131
  ,simpleTitleCaseMapping:0xA131
 },
 { code:0xA132
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA132
  ,simpleLowerCaseMapping:0xA132
  ,simpleTitleCaseMapping:0xA132
 },
 { code:0xA133
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA133
  ,simpleLowerCaseMapping:0xA133
  ,simpleTitleCaseMapping:0xA133
 },
 { code:0xA134
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA134
  ,simpleLowerCaseMapping:0xA134
  ,simpleTitleCaseMapping:0xA134
 },
 { code:0xA135
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA135
  ,simpleLowerCaseMapping:0xA135
  ,simpleTitleCaseMapping:0xA135
 },
 { code:0xA136
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA136
  ,simpleLowerCaseMapping:0xA136
  ,simpleTitleCaseMapping:0xA136
 },
 { code:0xA137
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA137
  ,simpleLowerCaseMapping:0xA137
  ,simpleTitleCaseMapping:0xA137
 },
 { code:0xA138
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA138
  ,simpleLowerCaseMapping:0xA138
  ,simpleTitleCaseMapping:0xA138
 },
 { code:0xA139
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA139
  ,simpleLowerCaseMapping:0xA139
  ,simpleTitleCaseMapping:0xA139
 },
 { code:0xA13A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA13A
  ,simpleLowerCaseMapping:0xA13A
  ,simpleTitleCaseMapping:0xA13A
 },
 { code:0xA13B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA13B
  ,simpleLowerCaseMapping:0xA13B
  ,simpleTitleCaseMapping:0xA13B
 },
 { code:0xA13C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA13C
  ,simpleLowerCaseMapping:0xA13C
  ,simpleTitleCaseMapping:0xA13C
 },
 { code:0xA13D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA13D
  ,simpleLowerCaseMapping:0xA13D
  ,simpleTitleCaseMapping:0xA13D
 },
 { code:0xA13E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA13E
  ,simpleLowerCaseMapping:0xA13E
  ,simpleTitleCaseMapping:0xA13E
 },
 { code:0xA13F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA13F
  ,simpleLowerCaseMapping:0xA13F
  ,simpleTitleCaseMapping:0xA13F
 },
 { code:0xA140
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA140
  ,simpleLowerCaseMapping:0xA140
  ,simpleTitleCaseMapping:0xA140
 },
 { code:0xA141
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA141
  ,simpleLowerCaseMapping:0xA141
  ,simpleTitleCaseMapping:0xA141
 },
 { code:0xA142
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA142
  ,simpleLowerCaseMapping:0xA142
  ,simpleTitleCaseMapping:0xA142
 },
 { code:0xA143
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA143
  ,simpleLowerCaseMapping:0xA143
  ,simpleTitleCaseMapping:0xA143
 },
 { code:0xA144
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA144
  ,simpleLowerCaseMapping:0xA144
  ,simpleTitleCaseMapping:0xA144
 },
 { code:0xA145
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA145
  ,simpleLowerCaseMapping:0xA145
  ,simpleTitleCaseMapping:0xA145
 },
 { code:0xA146
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA146
  ,simpleLowerCaseMapping:0xA146
  ,simpleTitleCaseMapping:0xA146
 },
 { code:0xA147
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA147
  ,simpleLowerCaseMapping:0xA147
  ,simpleTitleCaseMapping:0xA147
 },
 { code:0xA148
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA148
  ,simpleLowerCaseMapping:0xA148
  ,simpleTitleCaseMapping:0xA148
 },
 { code:0xA149
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA149
  ,simpleLowerCaseMapping:0xA149
  ,simpleTitleCaseMapping:0xA149
 },
 { code:0xA14A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA14A
  ,simpleLowerCaseMapping:0xA14A
  ,simpleTitleCaseMapping:0xA14A
 },
 { code:0xA14B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA14B
  ,simpleLowerCaseMapping:0xA14B
  ,simpleTitleCaseMapping:0xA14B
 },
 { code:0xA14C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA14C
  ,simpleLowerCaseMapping:0xA14C
  ,simpleTitleCaseMapping:0xA14C
 },
 { code:0xA14D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA14D
  ,simpleLowerCaseMapping:0xA14D
  ,simpleTitleCaseMapping:0xA14D
 },
 { code:0xA14E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA14E
  ,simpleLowerCaseMapping:0xA14E
  ,simpleTitleCaseMapping:0xA14E
 },
 { code:0xA14F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA14F
  ,simpleLowerCaseMapping:0xA14F
  ,simpleTitleCaseMapping:0xA14F
 },
 { code:0xA150
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA150
  ,simpleLowerCaseMapping:0xA150
  ,simpleTitleCaseMapping:0xA150
 },
 { code:0xA151
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA151
  ,simpleLowerCaseMapping:0xA151
  ,simpleTitleCaseMapping:0xA151
 },
 { code:0xA152
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA152
  ,simpleLowerCaseMapping:0xA152
  ,simpleTitleCaseMapping:0xA152
 },
 { code:0xA153
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA153
  ,simpleLowerCaseMapping:0xA153
  ,simpleTitleCaseMapping:0xA153
 },
 { code:0xA154
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA154
  ,simpleLowerCaseMapping:0xA154
  ,simpleTitleCaseMapping:0xA154
 },
 { code:0xA155
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA155
  ,simpleLowerCaseMapping:0xA155
  ,simpleTitleCaseMapping:0xA155
 },
 { code:0xA156
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA156
  ,simpleLowerCaseMapping:0xA156
  ,simpleTitleCaseMapping:0xA156
 },
 { code:0xA157
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA157
  ,simpleLowerCaseMapping:0xA157
  ,simpleTitleCaseMapping:0xA157
 },
 { code:0xA158
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA158
  ,simpleLowerCaseMapping:0xA158
  ,simpleTitleCaseMapping:0xA158
 },
 { code:0xA159
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA159
  ,simpleLowerCaseMapping:0xA159
  ,simpleTitleCaseMapping:0xA159
 },
 { code:0xA15A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA15A
  ,simpleLowerCaseMapping:0xA15A
  ,simpleTitleCaseMapping:0xA15A
 },
 { code:0xA15B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA15B
  ,simpleLowerCaseMapping:0xA15B
  ,simpleTitleCaseMapping:0xA15B
 },
 { code:0xA15C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA15C
  ,simpleLowerCaseMapping:0xA15C
  ,simpleTitleCaseMapping:0xA15C
 },
 { code:0xA15D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA15D
  ,simpleLowerCaseMapping:0xA15D
  ,simpleTitleCaseMapping:0xA15D
 },
 { code:0xA15E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA15E
  ,simpleLowerCaseMapping:0xA15E
  ,simpleTitleCaseMapping:0xA15E
 },
 { code:0xA15F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA15F
  ,simpleLowerCaseMapping:0xA15F
  ,simpleTitleCaseMapping:0xA15F
 },
 { code:0xA160
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA160
  ,simpleLowerCaseMapping:0xA160
  ,simpleTitleCaseMapping:0xA160
 },
 { code:0xA161
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA161
  ,simpleLowerCaseMapping:0xA161
  ,simpleTitleCaseMapping:0xA161
 },
 { code:0xA162
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA162
  ,simpleLowerCaseMapping:0xA162
  ,simpleTitleCaseMapping:0xA162
 },
 { code:0xA163
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA163
  ,simpleLowerCaseMapping:0xA163
  ,simpleTitleCaseMapping:0xA163
 },
 { code:0xA164
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA164
  ,simpleLowerCaseMapping:0xA164
  ,simpleTitleCaseMapping:0xA164
 },
 { code:0xA165
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA165
  ,simpleLowerCaseMapping:0xA165
  ,simpleTitleCaseMapping:0xA165
 },
 { code:0xA166
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA166
  ,simpleLowerCaseMapping:0xA166
  ,simpleTitleCaseMapping:0xA166
 },
 { code:0xA167
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA167
  ,simpleLowerCaseMapping:0xA167
  ,simpleTitleCaseMapping:0xA167
 },
 { code:0xA168
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA168
  ,simpleLowerCaseMapping:0xA168
  ,simpleTitleCaseMapping:0xA168
 },
 { code:0xA169
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA169
  ,simpleLowerCaseMapping:0xA169
  ,simpleTitleCaseMapping:0xA169
 },
 { code:0xA16A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA16A
  ,simpleLowerCaseMapping:0xA16A
  ,simpleTitleCaseMapping:0xA16A
 },
 { code:0xA16B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA16B
  ,simpleLowerCaseMapping:0xA16B
  ,simpleTitleCaseMapping:0xA16B
 },
 { code:0xA16C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA16C
  ,simpleLowerCaseMapping:0xA16C
  ,simpleTitleCaseMapping:0xA16C
 },
 { code:0xA16D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA16D
  ,simpleLowerCaseMapping:0xA16D
  ,simpleTitleCaseMapping:0xA16D
 },
 { code:0xA16E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA16E
  ,simpleLowerCaseMapping:0xA16E
  ,simpleTitleCaseMapping:0xA16E
 },
 { code:0xA16F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA16F
  ,simpleLowerCaseMapping:0xA16F
  ,simpleTitleCaseMapping:0xA16F
 },
 { code:0xA170
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA170
  ,simpleLowerCaseMapping:0xA170
  ,simpleTitleCaseMapping:0xA170
 },
 { code:0xA171
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA171
  ,simpleLowerCaseMapping:0xA171
  ,simpleTitleCaseMapping:0xA171
 },
 { code:0xA172
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA172
  ,simpleLowerCaseMapping:0xA172
  ,simpleTitleCaseMapping:0xA172
 },
 { code:0xA173
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA173
  ,simpleLowerCaseMapping:0xA173
  ,simpleTitleCaseMapping:0xA173
 },
 { code:0xA174
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA174
  ,simpleLowerCaseMapping:0xA174
  ,simpleTitleCaseMapping:0xA174
 },
 { code:0xA175
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA175
  ,simpleLowerCaseMapping:0xA175
  ,simpleTitleCaseMapping:0xA175
 },
 { code:0xA176
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA176
  ,simpleLowerCaseMapping:0xA176
  ,simpleTitleCaseMapping:0xA176
 },
 { code:0xA177
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA177
  ,simpleLowerCaseMapping:0xA177
  ,simpleTitleCaseMapping:0xA177
 },
 { code:0xA178
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA178
  ,simpleLowerCaseMapping:0xA178
  ,simpleTitleCaseMapping:0xA178
 },
 { code:0xA179
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA179
  ,simpleLowerCaseMapping:0xA179
  ,simpleTitleCaseMapping:0xA179
 },
 { code:0xA17A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA17A
  ,simpleLowerCaseMapping:0xA17A
  ,simpleTitleCaseMapping:0xA17A
 },
 { code:0xA17B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA17B
  ,simpleLowerCaseMapping:0xA17B
  ,simpleTitleCaseMapping:0xA17B
 },
 { code:0xA17C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA17C
  ,simpleLowerCaseMapping:0xA17C
  ,simpleTitleCaseMapping:0xA17C
 },
 { code:0xA17D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA17D
  ,simpleLowerCaseMapping:0xA17D
  ,simpleTitleCaseMapping:0xA17D
 },
 { code:0xA17E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA17E
  ,simpleLowerCaseMapping:0xA17E
  ,simpleTitleCaseMapping:0xA17E
 },
 { code:0xA17F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA17F
  ,simpleLowerCaseMapping:0xA17F
  ,simpleTitleCaseMapping:0xA17F
 },
 { code:0xA180
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA180
  ,simpleLowerCaseMapping:0xA180
  ,simpleTitleCaseMapping:0xA180
 },
 { code:0xA181
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA181
  ,simpleLowerCaseMapping:0xA181
  ,simpleTitleCaseMapping:0xA181
 },
 { code:0xA182
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA182
  ,simpleLowerCaseMapping:0xA182
  ,simpleTitleCaseMapping:0xA182
 },
 { code:0xA183
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA183
  ,simpleLowerCaseMapping:0xA183
  ,simpleTitleCaseMapping:0xA183
 },
 { code:0xA184
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA184
  ,simpleLowerCaseMapping:0xA184
  ,simpleTitleCaseMapping:0xA184
 },
 { code:0xA185
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA185
  ,simpleLowerCaseMapping:0xA185
  ,simpleTitleCaseMapping:0xA185
 },
 { code:0xA186
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA186
  ,simpleLowerCaseMapping:0xA186
  ,simpleTitleCaseMapping:0xA186
 },
 { code:0xA187
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA187
  ,simpleLowerCaseMapping:0xA187
  ,simpleTitleCaseMapping:0xA187
 },
 { code:0xA188
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA188
  ,simpleLowerCaseMapping:0xA188
  ,simpleTitleCaseMapping:0xA188
 },
 { code:0xA189
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA189
  ,simpleLowerCaseMapping:0xA189
  ,simpleTitleCaseMapping:0xA189
 },
 { code:0xA18A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA18A
  ,simpleLowerCaseMapping:0xA18A
  ,simpleTitleCaseMapping:0xA18A
 },
 { code:0xA18B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA18B
  ,simpleLowerCaseMapping:0xA18B
  ,simpleTitleCaseMapping:0xA18B
 },
 { code:0xA18C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA18C
  ,simpleLowerCaseMapping:0xA18C
  ,simpleTitleCaseMapping:0xA18C
 },
 { code:0xA18D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA18D
  ,simpleLowerCaseMapping:0xA18D
  ,simpleTitleCaseMapping:0xA18D
 },
 { code:0xA18E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA18E
  ,simpleLowerCaseMapping:0xA18E
  ,simpleTitleCaseMapping:0xA18E
 },
 { code:0xA18F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA18F
  ,simpleLowerCaseMapping:0xA18F
  ,simpleTitleCaseMapping:0xA18F
 },
 { code:0xA190
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA190
  ,simpleLowerCaseMapping:0xA190
  ,simpleTitleCaseMapping:0xA190
 },
 { code:0xA191
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA191
  ,simpleLowerCaseMapping:0xA191
  ,simpleTitleCaseMapping:0xA191
 },
 { code:0xA192
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA192
  ,simpleLowerCaseMapping:0xA192
  ,simpleTitleCaseMapping:0xA192
 },
 { code:0xA193
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA193
  ,simpleLowerCaseMapping:0xA193
  ,simpleTitleCaseMapping:0xA193
 },
 { code:0xA194
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA194
  ,simpleLowerCaseMapping:0xA194
  ,simpleTitleCaseMapping:0xA194
 },
 { code:0xA195
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA195
  ,simpleLowerCaseMapping:0xA195
  ,simpleTitleCaseMapping:0xA195
 },
 { code:0xA196
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA196
  ,simpleLowerCaseMapping:0xA196
  ,simpleTitleCaseMapping:0xA196
 },
 { code:0xA197
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA197
  ,simpleLowerCaseMapping:0xA197
  ,simpleTitleCaseMapping:0xA197
 },
 { code:0xA198
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA198
  ,simpleLowerCaseMapping:0xA198
  ,simpleTitleCaseMapping:0xA198
 },
 { code:0xA199
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA199
  ,simpleLowerCaseMapping:0xA199
  ,simpleTitleCaseMapping:0xA199
 },
 { code:0xA19A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA19A
  ,simpleLowerCaseMapping:0xA19A
  ,simpleTitleCaseMapping:0xA19A
 },
 { code:0xA19B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA19B
  ,simpleLowerCaseMapping:0xA19B
  ,simpleTitleCaseMapping:0xA19B
 },
 { code:0xA19C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA19C
  ,simpleLowerCaseMapping:0xA19C
  ,simpleTitleCaseMapping:0xA19C
 },
 { code:0xA19D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA19D
  ,simpleLowerCaseMapping:0xA19D
  ,simpleTitleCaseMapping:0xA19D
 },
 { code:0xA19E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA19E
  ,simpleLowerCaseMapping:0xA19E
  ,simpleTitleCaseMapping:0xA19E
 },
 { code:0xA19F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA19F
  ,simpleLowerCaseMapping:0xA19F
  ,simpleTitleCaseMapping:0xA19F
 },
 { code:0xA1A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1A0
  ,simpleLowerCaseMapping:0xA1A0
  ,simpleTitleCaseMapping:0xA1A0
 },
 { code:0xA1A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1A1
  ,simpleLowerCaseMapping:0xA1A1
  ,simpleTitleCaseMapping:0xA1A1
 },
 { code:0xA1A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1A2
  ,simpleLowerCaseMapping:0xA1A2
  ,simpleTitleCaseMapping:0xA1A2
 },
 { code:0xA1A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1A3
  ,simpleLowerCaseMapping:0xA1A3
  ,simpleTitleCaseMapping:0xA1A3
 },
 { code:0xA1A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1A4
  ,simpleLowerCaseMapping:0xA1A4
  ,simpleTitleCaseMapping:0xA1A4
 },
 { code:0xA1A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1A5
  ,simpleLowerCaseMapping:0xA1A5
  ,simpleTitleCaseMapping:0xA1A5
 },
 { code:0xA1A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1A6
  ,simpleLowerCaseMapping:0xA1A6
  ,simpleTitleCaseMapping:0xA1A6
 },
 { code:0xA1A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1A7
  ,simpleLowerCaseMapping:0xA1A7
  ,simpleTitleCaseMapping:0xA1A7
 },
 { code:0xA1A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1A8
  ,simpleLowerCaseMapping:0xA1A8
  ,simpleTitleCaseMapping:0xA1A8
 },
 { code:0xA1A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1A9
  ,simpleLowerCaseMapping:0xA1A9
  ,simpleTitleCaseMapping:0xA1A9
 },
 { code:0xA1AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1AA
  ,simpleLowerCaseMapping:0xA1AA
  ,simpleTitleCaseMapping:0xA1AA
 },
 { code:0xA1AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1AB
  ,simpleLowerCaseMapping:0xA1AB
  ,simpleTitleCaseMapping:0xA1AB
 },
 { code:0xA1AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1AC
  ,simpleLowerCaseMapping:0xA1AC
  ,simpleTitleCaseMapping:0xA1AC
 },
 { code:0xA1AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1AD
  ,simpleLowerCaseMapping:0xA1AD
  ,simpleTitleCaseMapping:0xA1AD
 },
 { code:0xA1AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1AE
  ,simpleLowerCaseMapping:0xA1AE
  ,simpleTitleCaseMapping:0xA1AE
 },
 { code:0xA1AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1AF
  ,simpleLowerCaseMapping:0xA1AF
  ,simpleTitleCaseMapping:0xA1AF
 },
 { code:0xA1B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1B0
  ,simpleLowerCaseMapping:0xA1B0
  ,simpleTitleCaseMapping:0xA1B0
 },
 { code:0xA1B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1B1
  ,simpleLowerCaseMapping:0xA1B1
  ,simpleTitleCaseMapping:0xA1B1
 },
 { code:0xA1B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1B2
  ,simpleLowerCaseMapping:0xA1B2
  ,simpleTitleCaseMapping:0xA1B2
 },
 { code:0xA1B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1B3
  ,simpleLowerCaseMapping:0xA1B3
  ,simpleTitleCaseMapping:0xA1B3
 },
 { code:0xA1B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1B4
  ,simpleLowerCaseMapping:0xA1B4
  ,simpleTitleCaseMapping:0xA1B4
 },
 { code:0xA1B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1B5
  ,simpleLowerCaseMapping:0xA1B5
  ,simpleTitleCaseMapping:0xA1B5
 },
 { code:0xA1B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1B6
  ,simpleLowerCaseMapping:0xA1B6
  ,simpleTitleCaseMapping:0xA1B6
 },
 { code:0xA1B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1B7
  ,simpleLowerCaseMapping:0xA1B7
  ,simpleTitleCaseMapping:0xA1B7
 },
 { code:0xA1B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1B8
  ,simpleLowerCaseMapping:0xA1B8
  ,simpleTitleCaseMapping:0xA1B8
 },
 { code:0xA1B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1B9
  ,simpleLowerCaseMapping:0xA1B9
  ,simpleTitleCaseMapping:0xA1B9
 },
 { code:0xA1BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1BA
  ,simpleLowerCaseMapping:0xA1BA
  ,simpleTitleCaseMapping:0xA1BA
 },
 { code:0xA1BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1BB
  ,simpleLowerCaseMapping:0xA1BB
  ,simpleTitleCaseMapping:0xA1BB
 },
 { code:0xA1BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1BC
  ,simpleLowerCaseMapping:0xA1BC
  ,simpleTitleCaseMapping:0xA1BC
 },
 { code:0xA1BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1BD
  ,simpleLowerCaseMapping:0xA1BD
  ,simpleTitleCaseMapping:0xA1BD
 },
 { code:0xA1BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1BE
  ,simpleLowerCaseMapping:0xA1BE
  ,simpleTitleCaseMapping:0xA1BE
 },
 { code:0xA1BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1BF
  ,simpleLowerCaseMapping:0xA1BF
  ,simpleTitleCaseMapping:0xA1BF
 },
 { code:0xA1C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1C0
  ,simpleLowerCaseMapping:0xA1C0
  ,simpleTitleCaseMapping:0xA1C0
 },
 { code:0xA1C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1C1
  ,simpleLowerCaseMapping:0xA1C1
  ,simpleTitleCaseMapping:0xA1C1
 },
 { code:0xA1C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1C2
  ,simpleLowerCaseMapping:0xA1C2
  ,simpleTitleCaseMapping:0xA1C2
 },
 { code:0xA1C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1C3
  ,simpleLowerCaseMapping:0xA1C3
  ,simpleTitleCaseMapping:0xA1C3
 },
 { code:0xA1C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1C4
  ,simpleLowerCaseMapping:0xA1C4
  ,simpleTitleCaseMapping:0xA1C4
 },
 { code:0xA1C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1C5
  ,simpleLowerCaseMapping:0xA1C5
  ,simpleTitleCaseMapping:0xA1C5
 },
 { code:0xA1C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1C6
  ,simpleLowerCaseMapping:0xA1C6
  ,simpleTitleCaseMapping:0xA1C6
 },
 { code:0xA1C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1C7
  ,simpleLowerCaseMapping:0xA1C7
  ,simpleTitleCaseMapping:0xA1C7
 },
 { code:0xA1C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1C8
  ,simpleLowerCaseMapping:0xA1C8
  ,simpleTitleCaseMapping:0xA1C8
 },
 { code:0xA1C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1C9
  ,simpleLowerCaseMapping:0xA1C9
  ,simpleTitleCaseMapping:0xA1C9
 },
 { code:0xA1CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1CA
  ,simpleLowerCaseMapping:0xA1CA
  ,simpleTitleCaseMapping:0xA1CA
 },
 { code:0xA1CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1CB
  ,simpleLowerCaseMapping:0xA1CB
  ,simpleTitleCaseMapping:0xA1CB
 },
 { code:0xA1CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1CC
  ,simpleLowerCaseMapping:0xA1CC
  ,simpleTitleCaseMapping:0xA1CC
 },
 { code:0xA1CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1CD
  ,simpleLowerCaseMapping:0xA1CD
  ,simpleTitleCaseMapping:0xA1CD
 },
 { code:0xA1CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1CE
  ,simpleLowerCaseMapping:0xA1CE
  ,simpleTitleCaseMapping:0xA1CE
 },
 { code:0xA1CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1CF
  ,simpleLowerCaseMapping:0xA1CF
  ,simpleTitleCaseMapping:0xA1CF
 },
 { code:0xA1D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1D0
  ,simpleLowerCaseMapping:0xA1D0
  ,simpleTitleCaseMapping:0xA1D0
 },
 { code:0xA1D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1D1
  ,simpleLowerCaseMapping:0xA1D1
  ,simpleTitleCaseMapping:0xA1D1
 },
 { code:0xA1D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1D2
  ,simpleLowerCaseMapping:0xA1D2
  ,simpleTitleCaseMapping:0xA1D2
 },
 { code:0xA1D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1D3
  ,simpleLowerCaseMapping:0xA1D3
  ,simpleTitleCaseMapping:0xA1D3
 },
 { code:0xA1D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1D4
  ,simpleLowerCaseMapping:0xA1D4
  ,simpleTitleCaseMapping:0xA1D4
 },
 { code:0xA1D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1D5
  ,simpleLowerCaseMapping:0xA1D5
  ,simpleTitleCaseMapping:0xA1D5
 },
 { code:0xA1D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1D6
  ,simpleLowerCaseMapping:0xA1D6
  ,simpleTitleCaseMapping:0xA1D6
 },
 { code:0xA1D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1D7
  ,simpleLowerCaseMapping:0xA1D7
  ,simpleTitleCaseMapping:0xA1D7
 },
 { code:0xA1D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1D8
  ,simpleLowerCaseMapping:0xA1D8
  ,simpleTitleCaseMapping:0xA1D8
 },
 { code:0xA1D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1D9
  ,simpleLowerCaseMapping:0xA1D9
  ,simpleTitleCaseMapping:0xA1D9
 },
 { code:0xA1DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1DA
  ,simpleLowerCaseMapping:0xA1DA
  ,simpleTitleCaseMapping:0xA1DA
 },
 { code:0xA1DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1DB
  ,simpleLowerCaseMapping:0xA1DB
  ,simpleTitleCaseMapping:0xA1DB
 },
 { code:0xA1DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1DC
  ,simpleLowerCaseMapping:0xA1DC
  ,simpleTitleCaseMapping:0xA1DC
 },
 { code:0xA1DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1DD
  ,simpleLowerCaseMapping:0xA1DD
  ,simpleTitleCaseMapping:0xA1DD
 },
 { code:0xA1DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1DE
  ,simpleLowerCaseMapping:0xA1DE
  ,simpleTitleCaseMapping:0xA1DE
 },
 { code:0xA1DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1DF
  ,simpleLowerCaseMapping:0xA1DF
  ,simpleTitleCaseMapping:0xA1DF
 },
 { code:0xA1E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1E0
  ,simpleLowerCaseMapping:0xA1E0
  ,simpleTitleCaseMapping:0xA1E0
 },
 { code:0xA1E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1E1
  ,simpleLowerCaseMapping:0xA1E1
  ,simpleTitleCaseMapping:0xA1E1
 },
 { code:0xA1E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1E2
  ,simpleLowerCaseMapping:0xA1E2
  ,simpleTitleCaseMapping:0xA1E2
 },
 { code:0xA1E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1E3
  ,simpleLowerCaseMapping:0xA1E3
  ,simpleTitleCaseMapping:0xA1E3
 },
 { code:0xA1E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1E4
  ,simpleLowerCaseMapping:0xA1E4
  ,simpleTitleCaseMapping:0xA1E4
 },
 { code:0xA1E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1E5
  ,simpleLowerCaseMapping:0xA1E5
  ,simpleTitleCaseMapping:0xA1E5
 },
 { code:0xA1E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1E6
  ,simpleLowerCaseMapping:0xA1E6
  ,simpleTitleCaseMapping:0xA1E6
 },
 { code:0xA1E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1E7
  ,simpleLowerCaseMapping:0xA1E7
  ,simpleTitleCaseMapping:0xA1E7
 },
 { code:0xA1E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1E8
  ,simpleLowerCaseMapping:0xA1E8
  ,simpleTitleCaseMapping:0xA1E8
 },
 { code:0xA1E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1E9
  ,simpleLowerCaseMapping:0xA1E9
  ,simpleTitleCaseMapping:0xA1E9
 },
 { code:0xA1EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1EA
  ,simpleLowerCaseMapping:0xA1EA
  ,simpleTitleCaseMapping:0xA1EA
 },
 { code:0xA1EB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1EB
  ,simpleLowerCaseMapping:0xA1EB
  ,simpleTitleCaseMapping:0xA1EB
 },
 { code:0xA1EC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1EC
  ,simpleLowerCaseMapping:0xA1EC
  ,simpleTitleCaseMapping:0xA1EC
 },
 { code:0xA1ED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1ED
  ,simpleLowerCaseMapping:0xA1ED
  ,simpleTitleCaseMapping:0xA1ED
 },
 { code:0xA1EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1EE
  ,simpleLowerCaseMapping:0xA1EE
  ,simpleTitleCaseMapping:0xA1EE
 },
 { code:0xA1EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1EF
  ,simpleLowerCaseMapping:0xA1EF
  ,simpleTitleCaseMapping:0xA1EF
 },
 { code:0xA1F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1F0
  ,simpleLowerCaseMapping:0xA1F0
  ,simpleTitleCaseMapping:0xA1F0
 },
 { code:0xA1F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1F1
  ,simpleLowerCaseMapping:0xA1F1
  ,simpleTitleCaseMapping:0xA1F1
 },
 { code:0xA1F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1F2
  ,simpleLowerCaseMapping:0xA1F2
  ,simpleTitleCaseMapping:0xA1F2
 },
 { code:0xA1F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1F3
  ,simpleLowerCaseMapping:0xA1F3
  ,simpleTitleCaseMapping:0xA1F3
 },
 { code:0xA1F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1F4
  ,simpleLowerCaseMapping:0xA1F4
  ,simpleTitleCaseMapping:0xA1F4
 },
 { code:0xA1F5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1F5
  ,simpleLowerCaseMapping:0xA1F5
  ,simpleTitleCaseMapping:0xA1F5
 },
 { code:0xA1F6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1F6
  ,simpleLowerCaseMapping:0xA1F6
  ,simpleTitleCaseMapping:0xA1F6
 },
 { code:0xA1F7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1F7
  ,simpleLowerCaseMapping:0xA1F7
  ,simpleTitleCaseMapping:0xA1F7
 },
 { code:0xA1F8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1F8
  ,simpleLowerCaseMapping:0xA1F8
  ,simpleTitleCaseMapping:0xA1F8
 },
 { code:0xA1F9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1F9
  ,simpleLowerCaseMapping:0xA1F9
  ,simpleTitleCaseMapping:0xA1F9
 },
 { code:0xA1FA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1FA
  ,simpleLowerCaseMapping:0xA1FA
  ,simpleTitleCaseMapping:0xA1FA
 },
 { code:0xA1FB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1FB
  ,simpleLowerCaseMapping:0xA1FB
  ,simpleTitleCaseMapping:0xA1FB
 },
 { code:0xA1FC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1FC
  ,simpleLowerCaseMapping:0xA1FC
  ,simpleTitleCaseMapping:0xA1FC
 },
 { code:0xA1FD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1FD
  ,simpleLowerCaseMapping:0xA1FD
  ,simpleTitleCaseMapping:0xA1FD
 },
 { code:0xA1FE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1FE
  ,simpleLowerCaseMapping:0xA1FE
  ,simpleTitleCaseMapping:0xA1FE
 },
 { code:0xA1FF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA1FF
  ,simpleLowerCaseMapping:0xA1FF
  ,simpleTitleCaseMapping:0xA1FF
 },
 { code:0xA200
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA200
  ,simpleLowerCaseMapping:0xA200
  ,simpleTitleCaseMapping:0xA200
 },
 { code:0xA201
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA201
  ,simpleLowerCaseMapping:0xA201
  ,simpleTitleCaseMapping:0xA201
 },
 { code:0xA202
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA202
  ,simpleLowerCaseMapping:0xA202
  ,simpleTitleCaseMapping:0xA202
 },
 { code:0xA203
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA203
  ,simpleLowerCaseMapping:0xA203
  ,simpleTitleCaseMapping:0xA203
 },
 { code:0xA204
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA204
  ,simpleLowerCaseMapping:0xA204
  ,simpleTitleCaseMapping:0xA204
 },
 { code:0xA205
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA205
  ,simpleLowerCaseMapping:0xA205
  ,simpleTitleCaseMapping:0xA205
 },
 { code:0xA206
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA206
  ,simpleLowerCaseMapping:0xA206
  ,simpleTitleCaseMapping:0xA206
 },
 { code:0xA207
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA207
  ,simpleLowerCaseMapping:0xA207
  ,simpleTitleCaseMapping:0xA207
 },
 { code:0xA208
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA208
  ,simpleLowerCaseMapping:0xA208
  ,simpleTitleCaseMapping:0xA208
 },
 { code:0xA209
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA209
  ,simpleLowerCaseMapping:0xA209
  ,simpleTitleCaseMapping:0xA209
 },
 { code:0xA20A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA20A
  ,simpleLowerCaseMapping:0xA20A
  ,simpleTitleCaseMapping:0xA20A
 },
 { code:0xA20B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA20B
  ,simpleLowerCaseMapping:0xA20B
  ,simpleTitleCaseMapping:0xA20B
 },
 { code:0xA20C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA20C
  ,simpleLowerCaseMapping:0xA20C
  ,simpleTitleCaseMapping:0xA20C
 },
 { code:0xA20D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA20D
  ,simpleLowerCaseMapping:0xA20D
  ,simpleTitleCaseMapping:0xA20D
 },
 { code:0xA20E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA20E
  ,simpleLowerCaseMapping:0xA20E
  ,simpleTitleCaseMapping:0xA20E
 },
 { code:0xA20F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA20F
  ,simpleLowerCaseMapping:0xA20F
  ,simpleTitleCaseMapping:0xA20F
 },
 { code:0xA210
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA210
  ,simpleLowerCaseMapping:0xA210
  ,simpleTitleCaseMapping:0xA210
 },
 { code:0xA211
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA211
  ,simpleLowerCaseMapping:0xA211
  ,simpleTitleCaseMapping:0xA211
 },
 { code:0xA212
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA212
  ,simpleLowerCaseMapping:0xA212
  ,simpleTitleCaseMapping:0xA212
 },
 { code:0xA213
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA213
  ,simpleLowerCaseMapping:0xA213
  ,simpleTitleCaseMapping:0xA213
 },
 { code:0xA214
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA214
  ,simpleLowerCaseMapping:0xA214
  ,simpleTitleCaseMapping:0xA214
 },
 { code:0xA215
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA215
  ,simpleLowerCaseMapping:0xA215
  ,simpleTitleCaseMapping:0xA215
 },
 { code:0xA216
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA216
  ,simpleLowerCaseMapping:0xA216
  ,simpleTitleCaseMapping:0xA216
 },
 { code:0xA217
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA217
  ,simpleLowerCaseMapping:0xA217
  ,simpleTitleCaseMapping:0xA217
 },
 { code:0xA218
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA218
  ,simpleLowerCaseMapping:0xA218
  ,simpleTitleCaseMapping:0xA218
 },
 { code:0xA219
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA219
  ,simpleLowerCaseMapping:0xA219
  ,simpleTitleCaseMapping:0xA219
 },
 { code:0xA21A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA21A
  ,simpleLowerCaseMapping:0xA21A
  ,simpleTitleCaseMapping:0xA21A
 },
 { code:0xA21B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA21B
  ,simpleLowerCaseMapping:0xA21B
  ,simpleTitleCaseMapping:0xA21B
 },
 { code:0xA21C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA21C
  ,simpleLowerCaseMapping:0xA21C
  ,simpleTitleCaseMapping:0xA21C
 },
 { code:0xA21D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA21D
  ,simpleLowerCaseMapping:0xA21D
  ,simpleTitleCaseMapping:0xA21D
 },
 { code:0xA21E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA21E
  ,simpleLowerCaseMapping:0xA21E
  ,simpleTitleCaseMapping:0xA21E
 },
 { code:0xA21F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA21F
  ,simpleLowerCaseMapping:0xA21F
  ,simpleTitleCaseMapping:0xA21F
 },
 { code:0xA220
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA220
  ,simpleLowerCaseMapping:0xA220
  ,simpleTitleCaseMapping:0xA220
 },
 { code:0xA221
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA221
  ,simpleLowerCaseMapping:0xA221
  ,simpleTitleCaseMapping:0xA221
 },
 { code:0xA222
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA222
  ,simpleLowerCaseMapping:0xA222
  ,simpleTitleCaseMapping:0xA222
 },
 { code:0xA223
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA223
  ,simpleLowerCaseMapping:0xA223
  ,simpleTitleCaseMapping:0xA223
 },
 { code:0xA224
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA224
  ,simpleLowerCaseMapping:0xA224
  ,simpleTitleCaseMapping:0xA224
 },
 { code:0xA225
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA225
  ,simpleLowerCaseMapping:0xA225
  ,simpleTitleCaseMapping:0xA225
 },
 { code:0xA226
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA226
  ,simpleLowerCaseMapping:0xA226
  ,simpleTitleCaseMapping:0xA226
 },
 { code:0xA227
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA227
  ,simpleLowerCaseMapping:0xA227
  ,simpleTitleCaseMapping:0xA227
 },
 { code:0xA228
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA228
  ,simpleLowerCaseMapping:0xA228
  ,simpleTitleCaseMapping:0xA228
 },
 { code:0xA229
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA229
  ,simpleLowerCaseMapping:0xA229
  ,simpleTitleCaseMapping:0xA229
 },
 { code:0xA22A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA22A
  ,simpleLowerCaseMapping:0xA22A
  ,simpleTitleCaseMapping:0xA22A
 },
 { code:0xA22B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA22B
  ,simpleLowerCaseMapping:0xA22B
  ,simpleTitleCaseMapping:0xA22B
 },
 { code:0xA22C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA22C
  ,simpleLowerCaseMapping:0xA22C
  ,simpleTitleCaseMapping:0xA22C
 },
 { code:0xA22D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA22D
  ,simpleLowerCaseMapping:0xA22D
  ,simpleTitleCaseMapping:0xA22D
 },
 { code:0xA22E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA22E
  ,simpleLowerCaseMapping:0xA22E
  ,simpleTitleCaseMapping:0xA22E
 },
 { code:0xA22F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA22F
  ,simpleLowerCaseMapping:0xA22F
  ,simpleTitleCaseMapping:0xA22F
 },
 { code:0xA230
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA230
  ,simpleLowerCaseMapping:0xA230
  ,simpleTitleCaseMapping:0xA230
 },
 { code:0xA231
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA231
  ,simpleLowerCaseMapping:0xA231
  ,simpleTitleCaseMapping:0xA231
 },
 { code:0xA232
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA232
  ,simpleLowerCaseMapping:0xA232
  ,simpleTitleCaseMapping:0xA232
 },
 { code:0xA233
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA233
  ,simpleLowerCaseMapping:0xA233
  ,simpleTitleCaseMapping:0xA233
 },
 { code:0xA234
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA234
  ,simpleLowerCaseMapping:0xA234
  ,simpleTitleCaseMapping:0xA234
 },
 { code:0xA235
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA235
  ,simpleLowerCaseMapping:0xA235
  ,simpleTitleCaseMapping:0xA235
 },
 { code:0xA236
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA236
  ,simpleLowerCaseMapping:0xA236
  ,simpleTitleCaseMapping:0xA236
 },
 { code:0xA237
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA237
  ,simpleLowerCaseMapping:0xA237
  ,simpleTitleCaseMapping:0xA237
 },
 { code:0xA238
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA238
  ,simpleLowerCaseMapping:0xA238
  ,simpleTitleCaseMapping:0xA238
 },
 { code:0xA239
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA239
  ,simpleLowerCaseMapping:0xA239
  ,simpleTitleCaseMapping:0xA239
 },
 { code:0xA23A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA23A
  ,simpleLowerCaseMapping:0xA23A
  ,simpleTitleCaseMapping:0xA23A
 },
 { code:0xA23B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA23B
  ,simpleLowerCaseMapping:0xA23B
  ,simpleTitleCaseMapping:0xA23B
 },
 { code:0xA23C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA23C
  ,simpleLowerCaseMapping:0xA23C
  ,simpleTitleCaseMapping:0xA23C
 },
 { code:0xA23D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA23D
  ,simpleLowerCaseMapping:0xA23D
  ,simpleTitleCaseMapping:0xA23D
 },
 { code:0xA23E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA23E
  ,simpleLowerCaseMapping:0xA23E
  ,simpleTitleCaseMapping:0xA23E
 },
 { code:0xA23F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA23F
  ,simpleLowerCaseMapping:0xA23F
  ,simpleTitleCaseMapping:0xA23F
 },
 { code:0xA240
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA240
  ,simpleLowerCaseMapping:0xA240
  ,simpleTitleCaseMapping:0xA240
 },
 { code:0xA241
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA241
  ,simpleLowerCaseMapping:0xA241
  ,simpleTitleCaseMapping:0xA241
 },
 { code:0xA242
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA242
  ,simpleLowerCaseMapping:0xA242
  ,simpleTitleCaseMapping:0xA242
 },
 { code:0xA243
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA243
  ,simpleLowerCaseMapping:0xA243
  ,simpleTitleCaseMapping:0xA243
 },
 { code:0xA244
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA244
  ,simpleLowerCaseMapping:0xA244
  ,simpleTitleCaseMapping:0xA244
 },
 { code:0xA245
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA245
  ,simpleLowerCaseMapping:0xA245
  ,simpleTitleCaseMapping:0xA245
 },
 { code:0xA246
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA246
  ,simpleLowerCaseMapping:0xA246
  ,simpleTitleCaseMapping:0xA246
 },
 { code:0xA247
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA247
  ,simpleLowerCaseMapping:0xA247
  ,simpleTitleCaseMapping:0xA247
 },
 { code:0xA248
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA248
  ,simpleLowerCaseMapping:0xA248
  ,simpleTitleCaseMapping:0xA248
 },
 { code:0xA249
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA249
  ,simpleLowerCaseMapping:0xA249
  ,simpleTitleCaseMapping:0xA249
 },
 { code:0xA24A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA24A
  ,simpleLowerCaseMapping:0xA24A
  ,simpleTitleCaseMapping:0xA24A
 },
 { code:0xA24B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA24B
  ,simpleLowerCaseMapping:0xA24B
  ,simpleTitleCaseMapping:0xA24B
 },
 { code:0xA24C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA24C
  ,simpleLowerCaseMapping:0xA24C
  ,simpleTitleCaseMapping:0xA24C
 },
 { code:0xA24D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA24D
  ,simpleLowerCaseMapping:0xA24D
  ,simpleTitleCaseMapping:0xA24D
 },
 { code:0xA24E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA24E
  ,simpleLowerCaseMapping:0xA24E
  ,simpleTitleCaseMapping:0xA24E
 },
 { code:0xA24F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA24F
  ,simpleLowerCaseMapping:0xA24F
  ,simpleTitleCaseMapping:0xA24F
 },
 { code:0xA250
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA250
  ,simpleLowerCaseMapping:0xA250
  ,simpleTitleCaseMapping:0xA250
 },
 { code:0xA251
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA251
  ,simpleLowerCaseMapping:0xA251
  ,simpleTitleCaseMapping:0xA251
 },
 { code:0xA252
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA252
  ,simpleLowerCaseMapping:0xA252
  ,simpleTitleCaseMapping:0xA252
 },
 { code:0xA253
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA253
  ,simpleLowerCaseMapping:0xA253
  ,simpleTitleCaseMapping:0xA253
 },
 { code:0xA254
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA254
  ,simpleLowerCaseMapping:0xA254
  ,simpleTitleCaseMapping:0xA254
 },
 { code:0xA255
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA255
  ,simpleLowerCaseMapping:0xA255
  ,simpleTitleCaseMapping:0xA255
 },
 { code:0xA256
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA256
  ,simpleLowerCaseMapping:0xA256
  ,simpleTitleCaseMapping:0xA256
 },
 { code:0xA257
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA257
  ,simpleLowerCaseMapping:0xA257
  ,simpleTitleCaseMapping:0xA257
 },
 { code:0xA258
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA258
  ,simpleLowerCaseMapping:0xA258
  ,simpleTitleCaseMapping:0xA258
 },
 { code:0xA259
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA259
  ,simpleLowerCaseMapping:0xA259
  ,simpleTitleCaseMapping:0xA259
 },
 { code:0xA25A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA25A
  ,simpleLowerCaseMapping:0xA25A
  ,simpleTitleCaseMapping:0xA25A
 },
 { code:0xA25B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA25B
  ,simpleLowerCaseMapping:0xA25B
  ,simpleTitleCaseMapping:0xA25B
 },
 { code:0xA25C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA25C
  ,simpleLowerCaseMapping:0xA25C
  ,simpleTitleCaseMapping:0xA25C
 },
 { code:0xA25D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA25D
  ,simpleLowerCaseMapping:0xA25D
  ,simpleTitleCaseMapping:0xA25D
 },
 { code:0xA25E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA25E
  ,simpleLowerCaseMapping:0xA25E
  ,simpleTitleCaseMapping:0xA25E
 },
 { code:0xA25F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA25F
  ,simpleLowerCaseMapping:0xA25F
  ,simpleTitleCaseMapping:0xA25F
 },
 { code:0xA260
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA260
  ,simpleLowerCaseMapping:0xA260
  ,simpleTitleCaseMapping:0xA260
 },
 { code:0xA261
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA261
  ,simpleLowerCaseMapping:0xA261
  ,simpleTitleCaseMapping:0xA261
 },
 { code:0xA262
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA262
  ,simpleLowerCaseMapping:0xA262
  ,simpleTitleCaseMapping:0xA262
 },
 { code:0xA263
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA263
  ,simpleLowerCaseMapping:0xA263
  ,simpleTitleCaseMapping:0xA263
 },
 { code:0xA264
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA264
  ,simpleLowerCaseMapping:0xA264
  ,simpleTitleCaseMapping:0xA264
 },
 { code:0xA265
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA265
  ,simpleLowerCaseMapping:0xA265
  ,simpleTitleCaseMapping:0xA265
 },
 { code:0xA266
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA266
  ,simpleLowerCaseMapping:0xA266
  ,simpleTitleCaseMapping:0xA266
 },
 { code:0xA267
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA267
  ,simpleLowerCaseMapping:0xA267
  ,simpleTitleCaseMapping:0xA267
 },
 { code:0xA268
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA268
  ,simpleLowerCaseMapping:0xA268
  ,simpleTitleCaseMapping:0xA268
 },
 { code:0xA269
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA269
  ,simpleLowerCaseMapping:0xA269
  ,simpleTitleCaseMapping:0xA269
 },
 { code:0xA26A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA26A
  ,simpleLowerCaseMapping:0xA26A
  ,simpleTitleCaseMapping:0xA26A
 },
 { code:0xA26B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA26B
  ,simpleLowerCaseMapping:0xA26B
  ,simpleTitleCaseMapping:0xA26B
 },
 { code:0xA26C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA26C
  ,simpleLowerCaseMapping:0xA26C
  ,simpleTitleCaseMapping:0xA26C
 },
 { code:0xA26D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA26D
  ,simpleLowerCaseMapping:0xA26D
  ,simpleTitleCaseMapping:0xA26D
 },
 { code:0xA26E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA26E
  ,simpleLowerCaseMapping:0xA26E
  ,simpleTitleCaseMapping:0xA26E
 },
 { code:0xA26F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA26F
  ,simpleLowerCaseMapping:0xA26F
  ,simpleTitleCaseMapping:0xA26F
 },
 { code:0xA270
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA270
  ,simpleLowerCaseMapping:0xA270
  ,simpleTitleCaseMapping:0xA270
 },
 { code:0xA271
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA271
  ,simpleLowerCaseMapping:0xA271
  ,simpleTitleCaseMapping:0xA271
 },
 { code:0xA272
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA272
  ,simpleLowerCaseMapping:0xA272
  ,simpleTitleCaseMapping:0xA272
 },
 { code:0xA273
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA273
  ,simpleLowerCaseMapping:0xA273
  ,simpleTitleCaseMapping:0xA273
 },
 { code:0xA274
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA274
  ,simpleLowerCaseMapping:0xA274
  ,simpleTitleCaseMapping:0xA274
 },
 { code:0xA275
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA275
  ,simpleLowerCaseMapping:0xA275
  ,simpleTitleCaseMapping:0xA275
 },
 { code:0xA276
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA276
  ,simpleLowerCaseMapping:0xA276
  ,simpleTitleCaseMapping:0xA276
 },
 { code:0xA277
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA277
  ,simpleLowerCaseMapping:0xA277
  ,simpleTitleCaseMapping:0xA277
 },
 { code:0xA278
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA278
  ,simpleLowerCaseMapping:0xA278
  ,simpleTitleCaseMapping:0xA278
 },
 { code:0xA279
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA279
  ,simpleLowerCaseMapping:0xA279
  ,simpleTitleCaseMapping:0xA279
 },
 { code:0xA27A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA27A
  ,simpleLowerCaseMapping:0xA27A
  ,simpleTitleCaseMapping:0xA27A
 },
 { code:0xA27B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA27B
  ,simpleLowerCaseMapping:0xA27B
  ,simpleTitleCaseMapping:0xA27B
 },
 { code:0xA27C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA27C
  ,simpleLowerCaseMapping:0xA27C
  ,simpleTitleCaseMapping:0xA27C
 },
 { code:0xA27D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA27D
  ,simpleLowerCaseMapping:0xA27D
  ,simpleTitleCaseMapping:0xA27D
 },
 { code:0xA27E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA27E
  ,simpleLowerCaseMapping:0xA27E
  ,simpleTitleCaseMapping:0xA27E
 },
 { code:0xA27F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA27F
  ,simpleLowerCaseMapping:0xA27F
  ,simpleTitleCaseMapping:0xA27F
 },
 { code:0xA280
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA280
  ,simpleLowerCaseMapping:0xA280
  ,simpleTitleCaseMapping:0xA280
 },
 { code:0xA281
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA281
  ,simpleLowerCaseMapping:0xA281
  ,simpleTitleCaseMapping:0xA281
 },
 { code:0xA282
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA282
  ,simpleLowerCaseMapping:0xA282
  ,simpleTitleCaseMapping:0xA282
 },
 { code:0xA283
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA283
  ,simpleLowerCaseMapping:0xA283
  ,simpleTitleCaseMapping:0xA283
 },
 { code:0xA284
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA284
  ,simpleLowerCaseMapping:0xA284
  ,simpleTitleCaseMapping:0xA284
 },
 { code:0xA285
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA285
  ,simpleLowerCaseMapping:0xA285
  ,simpleTitleCaseMapping:0xA285
 },
 { code:0xA286
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA286
  ,simpleLowerCaseMapping:0xA286
  ,simpleTitleCaseMapping:0xA286
 },
 { code:0xA287
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA287
  ,simpleLowerCaseMapping:0xA287
  ,simpleTitleCaseMapping:0xA287
 },
 { code:0xA288
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA288
  ,simpleLowerCaseMapping:0xA288
  ,simpleTitleCaseMapping:0xA288
 },
 { code:0xA289
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA289
  ,simpleLowerCaseMapping:0xA289
  ,simpleTitleCaseMapping:0xA289
 },
 { code:0xA28A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA28A
  ,simpleLowerCaseMapping:0xA28A
  ,simpleTitleCaseMapping:0xA28A
 },
 { code:0xA28B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA28B
  ,simpleLowerCaseMapping:0xA28B
  ,simpleTitleCaseMapping:0xA28B
 },
 { code:0xA28C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA28C
  ,simpleLowerCaseMapping:0xA28C
  ,simpleTitleCaseMapping:0xA28C
 },
 { code:0xA28D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA28D
  ,simpleLowerCaseMapping:0xA28D
  ,simpleTitleCaseMapping:0xA28D
 },
 { code:0xA28E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA28E
  ,simpleLowerCaseMapping:0xA28E
  ,simpleTitleCaseMapping:0xA28E
 },
 { code:0xA28F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA28F
  ,simpleLowerCaseMapping:0xA28F
  ,simpleTitleCaseMapping:0xA28F
 },
 { code:0xA290
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA290
  ,simpleLowerCaseMapping:0xA290
  ,simpleTitleCaseMapping:0xA290
 },
 { code:0xA291
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA291
  ,simpleLowerCaseMapping:0xA291
  ,simpleTitleCaseMapping:0xA291
 },
 { code:0xA292
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA292
  ,simpleLowerCaseMapping:0xA292
  ,simpleTitleCaseMapping:0xA292
 },
 { code:0xA293
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA293
  ,simpleLowerCaseMapping:0xA293
  ,simpleTitleCaseMapping:0xA293
 },
 { code:0xA294
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA294
  ,simpleLowerCaseMapping:0xA294
  ,simpleTitleCaseMapping:0xA294
 },
 { code:0xA295
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA295
  ,simpleLowerCaseMapping:0xA295
  ,simpleTitleCaseMapping:0xA295
 },
 { code:0xA296
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA296
  ,simpleLowerCaseMapping:0xA296
  ,simpleTitleCaseMapping:0xA296
 },
 { code:0xA297
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA297
  ,simpleLowerCaseMapping:0xA297
  ,simpleTitleCaseMapping:0xA297
 },
 { code:0xA298
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA298
  ,simpleLowerCaseMapping:0xA298
  ,simpleTitleCaseMapping:0xA298
 },
 { code:0xA299
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA299
  ,simpleLowerCaseMapping:0xA299
  ,simpleTitleCaseMapping:0xA299
 },
 { code:0xA29A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA29A
  ,simpleLowerCaseMapping:0xA29A
  ,simpleTitleCaseMapping:0xA29A
 },
 { code:0xA29B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA29B
  ,simpleLowerCaseMapping:0xA29B
  ,simpleTitleCaseMapping:0xA29B
 },
 { code:0xA29C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA29C
  ,simpleLowerCaseMapping:0xA29C
  ,simpleTitleCaseMapping:0xA29C
 },
 { code:0xA29D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA29D
  ,simpleLowerCaseMapping:0xA29D
  ,simpleTitleCaseMapping:0xA29D
 },
 { code:0xA29E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA29E
  ,simpleLowerCaseMapping:0xA29E
  ,simpleTitleCaseMapping:0xA29E
 },
 { code:0xA29F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA29F
  ,simpleLowerCaseMapping:0xA29F
  ,simpleTitleCaseMapping:0xA29F
 },
 { code:0xA2A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2A0
  ,simpleLowerCaseMapping:0xA2A0
  ,simpleTitleCaseMapping:0xA2A0
 },
 { code:0xA2A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2A1
  ,simpleLowerCaseMapping:0xA2A1
  ,simpleTitleCaseMapping:0xA2A1
 },
 { code:0xA2A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2A2
  ,simpleLowerCaseMapping:0xA2A2
  ,simpleTitleCaseMapping:0xA2A2
 },
 { code:0xA2A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2A3
  ,simpleLowerCaseMapping:0xA2A3
  ,simpleTitleCaseMapping:0xA2A3
 },
 { code:0xA2A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2A4
  ,simpleLowerCaseMapping:0xA2A4
  ,simpleTitleCaseMapping:0xA2A4
 },
 { code:0xA2A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2A5
  ,simpleLowerCaseMapping:0xA2A5
  ,simpleTitleCaseMapping:0xA2A5
 },
 { code:0xA2A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2A6
  ,simpleLowerCaseMapping:0xA2A6
  ,simpleTitleCaseMapping:0xA2A6
 },
 { code:0xA2A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2A7
  ,simpleLowerCaseMapping:0xA2A7
  ,simpleTitleCaseMapping:0xA2A7
 },
 { code:0xA2A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2A8
  ,simpleLowerCaseMapping:0xA2A8
  ,simpleTitleCaseMapping:0xA2A8
 },
 { code:0xA2A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2A9
  ,simpleLowerCaseMapping:0xA2A9
  ,simpleTitleCaseMapping:0xA2A9
 },
 { code:0xA2AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2AA
  ,simpleLowerCaseMapping:0xA2AA
  ,simpleTitleCaseMapping:0xA2AA
 },
 { code:0xA2AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2AB
  ,simpleLowerCaseMapping:0xA2AB
  ,simpleTitleCaseMapping:0xA2AB
 },
 { code:0xA2AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2AC
  ,simpleLowerCaseMapping:0xA2AC
  ,simpleTitleCaseMapping:0xA2AC
 },
 { code:0xA2AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2AD
  ,simpleLowerCaseMapping:0xA2AD
  ,simpleTitleCaseMapping:0xA2AD
 },
 { code:0xA2AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2AE
  ,simpleLowerCaseMapping:0xA2AE
  ,simpleTitleCaseMapping:0xA2AE
 },
 { code:0xA2AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2AF
  ,simpleLowerCaseMapping:0xA2AF
  ,simpleTitleCaseMapping:0xA2AF
 },
 { code:0xA2B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2B0
  ,simpleLowerCaseMapping:0xA2B0
  ,simpleTitleCaseMapping:0xA2B0
 },
 { code:0xA2B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2B1
  ,simpleLowerCaseMapping:0xA2B1
  ,simpleTitleCaseMapping:0xA2B1
 },
 { code:0xA2B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2B2
  ,simpleLowerCaseMapping:0xA2B2
  ,simpleTitleCaseMapping:0xA2B2
 },
 { code:0xA2B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2B3
  ,simpleLowerCaseMapping:0xA2B3
  ,simpleTitleCaseMapping:0xA2B3
 },
 { code:0xA2B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2B4
  ,simpleLowerCaseMapping:0xA2B4
  ,simpleTitleCaseMapping:0xA2B4
 },
 { code:0xA2B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2B5
  ,simpleLowerCaseMapping:0xA2B5
  ,simpleTitleCaseMapping:0xA2B5
 },
 { code:0xA2B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2B6
  ,simpleLowerCaseMapping:0xA2B6
  ,simpleTitleCaseMapping:0xA2B6
 },
 { code:0xA2B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2B7
  ,simpleLowerCaseMapping:0xA2B7
  ,simpleTitleCaseMapping:0xA2B7
 },
 { code:0xA2B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2B8
  ,simpleLowerCaseMapping:0xA2B8
  ,simpleTitleCaseMapping:0xA2B8
 },
 { code:0xA2B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2B9
  ,simpleLowerCaseMapping:0xA2B9
  ,simpleTitleCaseMapping:0xA2B9
 },
 { code:0xA2BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2BA
  ,simpleLowerCaseMapping:0xA2BA
  ,simpleTitleCaseMapping:0xA2BA
 },
 { code:0xA2BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2BB
  ,simpleLowerCaseMapping:0xA2BB
  ,simpleTitleCaseMapping:0xA2BB
 },
 { code:0xA2BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2BC
  ,simpleLowerCaseMapping:0xA2BC
  ,simpleTitleCaseMapping:0xA2BC
 },
 { code:0xA2BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2BD
  ,simpleLowerCaseMapping:0xA2BD
  ,simpleTitleCaseMapping:0xA2BD
 },
 { code:0xA2BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2BE
  ,simpleLowerCaseMapping:0xA2BE
  ,simpleTitleCaseMapping:0xA2BE
 },
 { code:0xA2BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2BF
  ,simpleLowerCaseMapping:0xA2BF
  ,simpleTitleCaseMapping:0xA2BF
 },
 { code:0xA2C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2C0
  ,simpleLowerCaseMapping:0xA2C0
  ,simpleTitleCaseMapping:0xA2C0
 },
 { code:0xA2C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2C1
  ,simpleLowerCaseMapping:0xA2C1
  ,simpleTitleCaseMapping:0xA2C1
 },
 { code:0xA2C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2C2
  ,simpleLowerCaseMapping:0xA2C2
  ,simpleTitleCaseMapping:0xA2C2
 },
 { code:0xA2C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2C3
  ,simpleLowerCaseMapping:0xA2C3
  ,simpleTitleCaseMapping:0xA2C3
 },
 { code:0xA2C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2C4
  ,simpleLowerCaseMapping:0xA2C4
  ,simpleTitleCaseMapping:0xA2C4
 },
 { code:0xA2C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2C5
  ,simpleLowerCaseMapping:0xA2C5
  ,simpleTitleCaseMapping:0xA2C5
 },
 { code:0xA2C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2C6
  ,simpleLowerCaseMapping:0xA2C6
  ,simpleTitleCaseMapping:0xA2C6
 },
 { code:0xA2C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2C7
  ,simpleLowerCaseMapping:0xA2C7
  ,simpleTitleCaseMapping:0xA2C7
 },
 { code:0xA2C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2C8
  ,simpleLowerCaseMapping:0xA2C8
  ,simpleTitleCaseMapping:0xA2C8
 },
 { code:0xA2C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2C9
  ,simpleLowerCaseMapping:0xA2C9
  ,simpleTitleCaseMapping:0xA2C9
 },
 { code:0xA2CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2CA
  ,simpleLowerCaseMapping:0xA2CA
  ,simpleTitleCaseMapping:0xA2CA
 },
 { code:0xA2CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2CB
  ,simpleLowerCaseMapping:0xA2CB
  ,simpleTitleCaseMapping:0xA2CB
 },
 { code:0xA2CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2CC
  ,simpleLowerCaseMapping:0xA2CC
  ,simpleTitleCaseMapping:0xA2CC
 },
 { code:0xA2CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2CD
  ,simpleLowerCaseMapping:0xA2CD
  ,simpleTitleCaseMapping:0xA2CD
 },
 { code:0xA2CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2CE
  ,simpleLowerCaseMapping:0xA2CE
  ,simpleTitleCaseMapping:0xA2CE
 },
 { code:0xA2CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2CF
  ,simpleLowerCaseMapping:0xA2CF
  ,simpleTitleCaseMapping:0xA2CF
 },
 { code:0xA2D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2D0
  ,simpleLowerCaseMapping:0xA2D0
  ,simpleTitleCaseMapping:0xA2D0
 },
 { code:0xA2D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2D1
  ,simpleLowerCaseMapping:0xA2D1
  ,simpleTitleCaseMapping:0xA2D1
 },
 { code:0xA2D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2D2
  ,simpleLowerCaseMapping:0xA2D2
  ,simpleTitleCaseMapping:0xA2D2
 },
 { code:0xA2D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2D3
  ,simpleLowerCaseMapping:0xA2D3
  ,simpleTitleCaseMapping:0xA2D3
 },
 { code:0xA2D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2D4
  ,simpleLowerCaseMapping:0xA2D4
  ,simpleTitleCaseMapping:0xA2D4
 },
 { code:0xA2D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2D5
  ,simpleLowerCaseMapping:0xA2D5
  ,simpleTitleCaseMapping:0xA2D5
 },
 { code:0xA2D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2D6
  ,simpleLowerCaseMapping:0xA2D6
  ,simpleTitleCaseMapping:0xA2D6
 },
 { code:0xA2D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2D7
  ,simpleLowerCaseMapping:0xA2D7
  ,simpleTitleCaseMapping:0xA2D7
 },
 { code:0xA2D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2D8
  ,simpleLowerCaseMapping:0xA2D8
  ,simpleTitleCaseMapping:0xA2D8
 },
 { code:0xA2D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2D9
  ,simpleLowerCaseMapping:0xA2D9
  ,simpleTitleCaseMapping:0xA2D9
 },
 { code:0xA2DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2DA
  ,simpleLowerCaseMapping:0xA2DA
  ,simpleTitleCaseMapping:0xA2DA
 },
 { code:0xA2DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2DB
  ,simpleLowerCaseMapping:0xA2DB
  ,simpleTitleCaseMapping:0xA2DB
 },
 { code:0xA2DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2DC
  ,simpleLowerCaseMapping:0xA2DC
  ,simpleTitleCaseMapping:0xA2DC
 },
 { code:0xA2DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2DD
  ,simpleLowerCaseMapping:0xA2DD
  ,simpleTitleCaseMapping:0xA2DD
 },
 { code:0xA2DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2DE
  ,simpleLowerCaseMapping:0xA2DE
  ,simpleTitleCaseMapping:0xA2DE
 },
 { code:0xA2DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2DF
  ,simpleLowerCaseMapping:0xA2DF
  ,simpleTitleCaseMapping:0xA2DF
 },
 { code:0xA2E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2E0
  ,simpleLowerCaseMapping:0xA2E0
  ,simpleTitleCaseMapping:0xA2E0
 },
 { code:0xA2E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2E1
  ,simpleLowerCaseMapping:0xA2E1
  ,simpleTitleCaseMapping:0xA2E1
 },
 { code:0xA2E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2E2
  ,simpleLowerCaseMapping:0xA2E2
  ,simpleTitleCaseMapping:0xA2E2
 },
 { code:0xA2E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2E3
  ,simpleLowerCaseMapping:0xA2E3
  ,simpleTitleCaseMapping:0xA2E3
 },
 { code:0xA2E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2E4
  ,simpleLowerCaseMapping:0xA2E4
  ,simpleTitleCaseMapping:0xA2E4
 },
 { code:0xA2E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2E5
  ,simpleLowerCaseMapping:0xA2E5
  ,simpleTitleCaseMapping:0xA2E5
 },
 { code:0xA2E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2E6
  ,simpleLowerCaseMapping:0xA2E6
  ,simpleTitleCaseMapping:0xA2E6
 },
 { code:0xA2E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2E7
  ,simpleLowerCaseMapping:0xA2E7
  ,simpleTitleCaseMapping:0xA2E7
 },
 { code:0xA2E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2E8
  ,simpleLowerCaseMapping:0xA2E8
  ,simpleTitleCaseMapping:0xA2E8
 },
 { code:0xA2E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2E9
  ,simpleLowerCaseMapping:0xA2E9
  ,simpleTitleCaseMapping:0xA2E9
 },
 { code:0xA2EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2EA
  ,simpleLowerCaseMapping:0xA2EA
  ,simpleTitleCaseMapping:0xA2EA
 },
 { code:0xA2EB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2EB
  ,simpleLowerCaseMapping:0xA2EB
  ,simpleTitleCaseMapping:0xA2EB
 },
 { code:0xA2EC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2EC
  ,simpleLowerCaseMapping:0xA2EC
  ,simpleTitleCaseMapping:0xA2EC
 },
 { code:0xA2ED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2ED
  ,simpleLowerCaseMapping:0xA2ED
  ,simpleTitleCaseMapping:0xA2ED
 },
 { code:0xA2EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2EE
  ,simpleLowerCaseMapping:0xA2EE
  ,simpleTitleCaseMapping:0xA2EE
 },
 { code:0xA2EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2EF
  ,simpleLowerCaseMapping:0xA2EF
  ,simpleTitleCaseMapping:0xA2EF
 },
 { code:0xA2F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2F0
  ,simpleLowerCaseMapping:0xA2F0
  ,simpleTitleCaseMapping:0xA2F0
 },
 { code:0xA2F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2F1
  ,simpleLowerCaseMapping:0xA2F1
  ,simpleTitleCaseMapping:0xA2F1
 },
 { code:0xA2F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2F2
  ,simpleLowerCaseMapping:0xA2F2
  ,simpleTitleCaseMapping:0xA2F2
 },
 { code:0xA2F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2F3
  ,simpleLowerCaseMapping:0xA2F3
  ,simpleTitleCaseMapping:0xA2F3
 },
 { code:0xA2F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2F4
  ,simpleLowerCaseMapping:0xA2F4
  ,simpleTitleCaseMapping:0xA2F4
 },
 { code:0xA2F5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2F5
  ,simpleLowerCaseMapping:0xA2F5
  ,simpleTitleCaseMapping:0xA2F5
 },
 { code:0xA2F6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2F6
  ,simpleLowerCaseMapping:0xA2F6
  ,simpleTitleCaseMapping:0xA2F6
 },
 { code:0xA2F7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2F7
  ,simpleLowerCaseMapping:0xA2F7
  ,simpleTitleCaseMapping:0xA2F7
 },
 { code:0xA2F8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2F8
  ,simpleLowerCaseMapping:0xA2F8
  ,simpleTitleCaseMapping:0xA2F8
 },
 { code:0xA2F9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2F9
  ,simpleLowerCaseMapping:0xA2F9
  ,simpleTitleCaseMapping:0xA2F9
 },
 { code:0xA2FA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2FA
  ,simpleLowerCaseMapping:0xA2FA
  ,simpleTitleCaseMapping:0xA2FA
 },
 { code:0xA2FB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2FB
  ,simpleLowerCaseMapping:0xA2FB
  ,simpleTitleCaseMapping:0xA2FB
 },
 { code:0xA2FC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2FC
  ,simpleLowerCaseMapping:0xA2FC
  ,simpleTitleCaseMapping:0xA2FC
 },
 { code:0xA2FD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2FD
  ,simpleLowerCaseMapping:0xA2FD
  ,simpleTitleCaseMapping:0xA2FD
 },
 { code:0xA2FE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2FE
  ,simpleLowerCaseMapping:0xA2FE
  ,simpleTitleCaseMapping:0xA2FE
 },
 { code:0xA2FF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA2FF
  ,simpleLowerCaseMapping:0xA2FF
  ,simpleTitleCaseMapping:0xA2FF
 },
 { code:0xA300
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA300
  ,simpleLowerCaseMapping:0xA300
  ,simpleTitleCaseMapping:0xA300
 },
 { code:0xA301
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA301
  ,simpleLowerCaseMapping:0xA301
  ,simpleTitleCaseMapping:0xA301
 },
 { code:0xA302
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA302
  ,simpleLowerCaseMapping:0xA302
  ,simpleTitleCaseMapping:0xA302
 },
 { code:0xA303
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA303
  ,simpleLowerCaseMapping:0xA303
  ,simpleTitleCaseMapping:0xA303
 },
 { code:0xA304
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA304
  ,simpleLowerCaseMapping:0xA304
  ,simpleTitleCaseMapping:0xA304
 },
 { code:0xA305
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA305
  ,simpleLowerCaseMapping:0xA305
  ,simpleTitleCaseMapping:0xA305
 },
 { code:0xA306
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA306
  ,simpleLowerCaseMapping:0xA306
  ,simpleTitleCaseMapping:0xA306
 },
 { code:0xA307
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA307
  ,simpleLowerCaseMapping:0xA307
  ,simpleTitleCaseMapping:0xA307
 },
 { code:0xA308
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA308
  ,simpleLowerCaseMapping:0xA308
  ,simpleTitleCaseMapping:0xA308
 },
 { code:0xA309
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA309
  ,simpleLowerCaseMapping:0xA309
  ,simpleTitleCaseMapping:0xA309
 },
 { code:0xA30A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA30A
  ,simpleLowerCaseMapping:0xA30A
  ,simpleTitleCaseMapping:0xA30A
 },
 { code:0xA30B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA30B
  ,simpleLowerCaseMapping:0xA30B
  ,simpleTitleCaseMapping:0xA30B
 },
 { code:0xA30C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA30C
  ,simpleLowerCaseMapping:0xA30C
  ,simpleTitleCaseMapping:0xA30C
 },
 { code:0xA30D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA30D
  ,simpleLowerCaseMapping:0xA30D
  ,simpleTitleCaseMapping:0xA30D
 },
 { code:0xA30E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA30E
  ,simpleLowerCaseMapping:0xA30E
  ,simpleTitleCaseMapping:0xA30E
 },
 { code:0xA30F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA30F
  ,simpleLowerCaseMapping:0xA30F
  ,simpleTitleCaseMapping:0xA30F
 },
 { code:0xA310
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA310
  ,simpleLowerCaseMapping:0xA310
  ,simpleTitleCaseMapping:0xA310
 },
 { code:0xA311
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA311
  ,simpleLowerCaseMapping:0xA311
  ,simpleTitleCaseMapping:0xA311
 },
 { code:0xA312
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA312
  ,simpleLowerCaseMapping:0xA312
  ,simpleTitleCaseMapping:0xA312
 },
 { code:0xA313
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA313
  ,simpleLowerCaseMapping:0xA313
  ,simpleTitleCaseMapping:0xA313
 },
 { code:0xA314
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA314
  ,simpleLowerCaseMapping:0xA314
  ,simpleTitleCaseMapping:0xA314
 },
 { code:0xA315
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA315
  ,simpleLowerCaseMapping:0xA315
  ,simpleTitleCaseMapping:0xA315
 },
 { code:0xA316
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA316
  ,simpleLowerCaseMapping:0xA316
  ,simpleTitleCaseMapping:0xA316
 },
 { code:0xA317
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA317
  ,simpleLowerCaseMapping:0xA317
  ,simpleTitleCaseMapping:0xA317
 },
 { code:0xA318
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA318
  ,simpleLowerCaseMapping:0xA318
  ,simpleTitleCaseMapping:0xA318
 },
 { code:0xA319
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA319
  ,simpleLowerCaseMapping:0xA319
  ,simpleTitleCaseMapping:0xA319
 },
 { code:0xA31A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA31A
  ,simpleLowerCaseMapping:0xA31A
  ,simpleTitleCaseMapping:0xA31A
 },
 { code:0xA31B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA31B
  ,simpleLowerCaseMapping:0xA31B
  ,simpleTitleCaseMapping:0xA31B
 },
 { code:0xA31C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA31C
  ,simpleLowerCaseMapping:0xA31C
  ,simpleTitleCaseMapping:0xA31C
 },
 { code:0xA31D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA31D
  ,simpleLowerCaseMapping:0xA31D
  ,simpleTitleCaseMapping:0xA31D
 },
 { code:0xA31E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA31E
  ,simpleLowerCaseMapping:0xA31E
  ,simpleTitleCaseMapping:0xA31E
 },
 { code:0xA31F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA31F
  ,simpleLowerCaseMapping:0xA31F
  ,simpleTitleCaseMapping:0xA31F
 },
 { code:0xA320
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA320
  ,simpleLowerCaseMapping:0xA320
  ,simpleTitleCaseMapping:0xA320
 },
 { code:0xA321
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA321
  ,simpleLowerCaseMapping:0xA321
  ,simpleTitleCaseMapping:0xA321
 },
 { code:0xA322
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA322
  ,simpleLowerCaseMapping:0xA322
  ,simpleTitleCaseMapping:0xA322
 },
 { code:0xA323
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA323
  ,simpleLowerCaseMapping:0xA323
  ,simpleTitleCaseMapping:0xA323
 },
 { code:0xA324
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA324
  ,simpleLowerCaseMapping:0xA324
  ,simpleTitleCaseMapping:0xA324
 },
 { code:0xA325
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA325
  ,simpleLowerCaseMapping:0xA325
  ,simpleTitleCaseMapping:0xA325
 },
 { code:0xA326
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA326
  ,simpleLowerCaseMapping:0xA326
  ,simpleTitleCaseMapping:0xA326
 },
 { code:0xA327
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA327
  ,simpleLowerCaseMapping:0xA327
  ,simpleTitleCaseMapping:0xA327
 },
 { code:0xA328
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA328
  ,simpleLowerCaseMapping:0xA328
  ,simpleTitleCaseMapping:0xA328
 },
 { code:0xA329
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA329
  ,simpleLowerCaseMapping:0xA329
  ,simpleTitleCaseMapping:0xA329
 },
 { code:0xA32A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA32A
  ,simpleLowerCaseMapping:0xA32A
  ,simpleTitleCaseMapping:0xA32A
 },
 { code:0xA32B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA32B
  ,simpleLowerCaseMapping:0xA32B
  ,simpleTitleCaseMapping:0xA32B
 },
 { code:0xA32C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA32C
  ,simpleLowerCaseMapping:0xA32C
  ,simpleTitleCaseMapping:0xA32C
 },
 { code:0xA32D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA32D
  ,simpleLowerCaseMapping:0xA32D
  ,simpleTitleCaseMapping:0xA32D
 },
 { code:0xA32E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA32E
  ,simpleLowerCaseMapping:0xA32E
  ,simpleTitleCaseMapping:0xA32E
 },
 { code:0xA32F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA32F
  ,simpleLowerCaseMapping:0xA32F
  ,simpleTitleCaseMapping:0xA32F
 },
 { code:0xA330
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA330
  ,simpleLowerCaseMapping:0xA330
  ,simpleTitleCaseMapping:0xA330
 },
 { code:0xA331
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA331
  ,simpleLowerCaseMapping:0xA331
  ,simpleTitleCaseMapping:0xA331
 },
 { code:0xA332
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA332
  ,simpleLowerCaseMapping:0xA332
  ,simpleTitleCaseMapping:0xA332
 },
 { code:0xA333
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA333
  ,simpleLowerCaseMapping:0xA333
  ,simpleTitleCaseMapping:0xA333
 },
 { code:0xA334
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA334
  ,simpleLowerCaseMapping:0xA334
  ,simpleTitleCaseMapping:0xA334
 },
 { code:0xA335
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA335
  ,simpleLowerCaseMapping:0xA335
  ,simpleTitleCaseMapping:0xA335
 },
 { code:0xA336
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA336
  ,simpleLowerCaseMapping:0xA336
  ,simpleTitleCaseMapping:0xA336
 },
 { code:0xA337
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA337
  ,simpleLowerCaseMapping:0xA337
  ,simpleTitleCaseMapping:0xA337
 },
 { code:0xA338
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA338
  ,simpleLowerCaseMapping:0xA338
  ,simpleTitleCaseMapping:0xA338
 },
 { code:0xA339
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA339
  ,simpleLowerCaseMapping:0xA339
  ,simpleTitleCaseMapping:0xA339
 },
 { code:0xA33A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA33A
  ,simpleLowerCaseMapping:0xA33A
  ,simpleTitleCaseMapping:0xA33A
 },
 { code:0xA33B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA33B
  ,simpleLowerCaseMapping:0xA33B
  ,simpleTitleCaseMapping:0xA33B
 },
 { code:0xA33C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA33C
  ,simpleLowerCaseMapping:0xA33C
  ,simpleTitleCaseMapping:0xA33C
 },
 { code:0xA33D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA33D
  ,simpleLowerCaseMapping:0xA33D
  ,simpleTitleCaseMapping:0xA33D
 },
 { code:0xA33E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA33E
  ,simpleLowerCaseMapping:0xA33E
  ,simpleTitleCaseMapping:0xA33E
 },
 { code:0xA33F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA33F
  ,simpleLowerCaseMapping:0xA33F
  ,simpleTitleCaseMapping:0xA33F
 },
 { code:0xA340
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA340
  ,simpleLowerCaseMapping:0xA340
  ,simpleTitleCaseMapping:0xA340
 },
 { code:0xA341
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA341
  ,simpleLowerCaseMapping:0xA341
  ,simpleTitleCaseMapping:0xA341
 },
 { code:0xA342
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA342
  ,simpleLowerCaseMapping:0xA342
  ,simpleTitleCaseMapping:0xA342
 },
 { code:0xA343
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA343
  ,simpleLowerCaseMapping:0xA343
  ,simpleTitleCaseMapping:0xA343
 },
 { code:0xA344
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA344
  ,simpleLowerCaseMapping:0xA344
  ,simpleTitleCaseMapping:0xA344
 },
 { code:0xA345
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA345
  ,simpleLowerCaseMapping:0xA345
  ,simpleTitleCaseMapping:0xA345
 },
 { code:0xA346
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA346
  ,simpleLowerCaseMapping:0xA346
  ,simpleTitleCaseMapping:0xA346
 },
 { code:0xA347
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA347
  ,simpleLowerCaseMapping:0xA347
  ,simpleTitleCaseMapping:0xA347
 },
 { code:0xA348
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA348
  ,simpleLowerCaseMapping:0xA348
  ,simpleTitleCaseMapping:0xA348
 },
 { code:0xA349
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA349
  ,simpleLowerCaseMapping:0xA349
  ,simpleTitleCaseMapping:0xA349
 },
 { code:0xA34A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA34A
  ,simpleLowerCaseMapping:0xA34A
  ,simpleTitleCaseMapping:0xA34A
 },
 { code:0xA34B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA34B
  ,simpleLowerCaseMapping:0xA34B
  ,simpleTitleCaseMapping:0xA34B
 },
 { code:0xA34C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA34C
  ,simpleLowerCaseMapping:0xA34C
  ,simpleTitleCaseMapping:0xA34C
 },
 { code:0xA34D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA34D
  ,simpleLowerCaseMapping:0xA34D
  ,simpleTitleCaseMapping:0xA34D
 },
 { code:0xA34E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA34E
  ,simpleLowerCaseMapping:0xA34E
  ,simpleTitleCaseMapping:0xA34E
 },
 { code:0xA34F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA34F
  ,simpleLowerCaseMapping:0xA34F
  ,simpleTitleCaseMapping:0xA34F
 },
 { code:0xA350
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA350
  ,simpleLowerCaseMapping:0xA350
  ,simpleTitleCaseMapping:0xA350
 },
 { code:0xA351
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA351
  ,simpleLowerCaseMapping:0xA351
  ,simpleTitleCaseMapping:0xA351
 },
 { code:0xA352
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA352
  ,simpleLowerCaseMapping:0xA352
  ,simpleTitleCaseMapping:0xA352
 },
 { code:0xA353
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA353
  ,simpleLowerCaseMapping:0xA353
  ,simpleTitleCaseMapping:0xA353
 },
 { code:0xA354
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA354
  ,simpleLowerCaseMapping:0xA354
  ,simpleTitleCaseMapping:0xA354
 },
 { code:0xA355
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA355
  ,simpleLowerCaseMapping:0xA355
  ,simpleTitleCaseMapping:0xA355
 },
 { code:0xA356
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA356
  ,simpleLowerCaseMapping:0xA356
  ,simpleTitleCaseMapping:0xA356
 },
 { code:0xA357
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA357
  ,simpleLowerCaseMapping:0xA357
  ,simpleTitleCaseMapping:0xA357
 },
 { code:0xA358
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA358
  ,simpleLowerCaseMapping:0xA358
  ,simpleTitleCaseMapping:0xA358
 },
 { code:0xA359
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA359
  ,simpleLowerCaseMapping:0xA359
  ,simpleTitleCaseMapping:0xA359
 },
 { code:0xA35A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA35A
  ,simpleLowerCaseMapping:0xA35A
  ,simpleTitleCaseMapping:0xA35A
 },
 { code:0xA35B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA35B
  ,simpleLowerCaseMapping:0xA35B
  ,simpleTitleCaseMapping:0xA35B
 },
 { code:0xA35C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA35C
  ,simpleLowerCaseMapping:0xA35C
  ,simpleTitleCaseMapping:0xA35C
 },
 { code:0xA35D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA35D
  ,simpleLowerCaseMapping:0xA35D
  ,simpleTitleCaseMapping:0xA35D
 },
 { code:0xA35E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA35E
  ,simpleLowerCaseMapping:0xA35E
  ,simpleTitleCaseMapping:0xA35E
 },
 { code:0xA35F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA35F
  ,simpleLowerCaseMapping:0xA35F
  ,simpleTitleCaseMapping:0xA35F
 },
 { code:0xA360
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA360
  ,simpleLowerCaseMapping:0xA360
  ,simpleTitleCaseMapping:0xA360
 },
 { code:0xA361
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA361
  ,simpleLowerCaseMapping:0xA361
  ,simpleTitleCaseMapping:0xA361
 },
 { code:0xA362
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA362
  ,simpleLowerCaseMapping:0xA362
  ,simpleTitleCaseMapping:0xA362
 },
 { code:0xA363
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA363
  ,simpleLowerCaseMapping:0xA363
  ,simpleTitleCaseMapping:0xA363
 },
 { code:0xA364
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA364
  ,simpleLowerCaseMapping:0xA364
  ,simpleTitleCaseMapping:0xA364
 },
 { code:0xA365
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA365
  ,simpleLowerCaseMapping:0xA365
  ,simpleTitleCaseMapping:0xA365
 },
 { code:0xA366
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA366
  ,simpleLowerCaseMapping:0xA366
  ,simpleTitleCaseMapping:0xA366
 },
 { code:0xA367
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA367
  ,simpleLowerCaseMapping:0xA367
  ,simpleTitleCaseMapping:0xA367
 },
 { code:0xA368
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA368
  ,simpleLowerCaseMapping:0xA368
  ,simpleTitleCaseMapping:0xA368
 },
 { code:0xA369
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA369
  ,simpleLowerCaseMapping:0xA369
  ,simpleTitleCaseMapping:0xA369
 },
 { code:0xA36A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA36A
  ,simpleLowerCaseMapping:0xA36A
  ,simpleTitleCaseMapping:0xA36A
 },
 { code:0xA36B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA36B
  ,simpleLowerCaseMapping:0xA36B
  ,simpleTitleCaseMapping:0xA36B
 },
 { code:0xA36C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA36C
  ,simpleLowerCaseMapping:0xA36C
  ,simpleTitleCaseMapping:0xA36C
 },
 { code:0xA36D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA36D
  ,simpleLowerCaseMapping:0xA36D
  ,simpleTitleCaseMapping:0xA36D
 },
 { code:0xA36E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA36E
  ,simpleLowerCaseMapping:0xA36E
  ,simpleTitleCaseMapping:0xA36E
 },
 { code:0xA36F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA36F
  ,simpleLowerCaseMapping:0xA36F
  ,simpleTitleCaseMapping:0xA36F
 },
 { code:0xA370
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA370
  ,simpleLowerCaseMapping:0xA370
  ,simpleTitleCaseMapping:0xA370
 },
 { code:0xA371
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA371
  ,simpleLowerCaseMapping:0xA371
  ,simpleTitleCaseMapping:0xA371
 },
 { code:0xA372
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA372
  ,simpleLowerCaseMapping:0xA372
  ,simpleTitleCaseMapping:0xA372
 },
 { code:0xA373
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA373
  ,simpleLowerCaseMapping:0xA373
  ,simpleTitleCaseMapping:0xA373
 },
 { code:0xA374
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA374
  ,simpleLowerCaseMapping:0xA374
  ,simpleTitleCaseMapping:0xA374
 },
 { code:0xA375
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA375
  ,simpleLowerCaseMapping:0xA375
  ,simpleTitleCaseMapping:0xA375
 },
 { code:0xA376
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA376
  ,simpleLowerCaseMapping:0xA376
  ,simpleTitleCaseMapping:0xA376
 },
 { code:0xA377
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA377
  ,simpleLowerCaseMapping:0xA377
  ,simpleTitleCaseMapping:0xA377
 },
 { code:0xA378
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA378
  ,simpleLowerCaseMapping:0xA378
  ,simpleTitleCaseMapping:0xA378
 },
 { code:0xA379
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA379
  ,simpleLowerCaseMapping:0xA379
  ,simpleTitleCaseMapping:0xA379
 },
 { code:0xA37A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA37A
  ,simpleLowerCaseMapping:0xA37A
  ,simpleTitleCaseMapping:0xA37A
 },
 { code:0xA37B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA37B
  ,simpleLowerCaseMapping:0xA37B
  ,simpleTitleCaseMapping:0xA37B
 },
 { code:0xA37C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA37C
  ,simpleLowerCaseMapping:0xA37C
  ,simpleTitleCaseMapping:0xA37C
 },
 { code:0xA37D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA37D
  ,simpleLowerCaseMapping:0xA37D
  ,simpleTitleCaseMapping:0xA37D
 },
 { code:0xA37E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA37E
  ,simpleLowerCaseMapping:0xA37E
  ,simpleTitleCaseMapping:0xA37E
 },
 { code:0xA37F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA37F
  ,simpleLowerCaseMapping:0xA37F
  ,simpleTitleCaseMapping:0xA37F
 },
 { code:0xA380
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA380
  ,simpleLowerCaseMapping:0xA380
  ,simpleTitleCaseMapping:0xA380
 },
 { code:0xA381
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA381
  ,simpleLowerCaseMapping:0xA381
  ,simpleTitleCaseMapping:0xA381
 },
 { code:0xA382
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA382
  ,simpleLowerCaseMapping:0xA382
  ,simpleTitleCaseMapping:0xA382
 },
 { code:0xA383
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA383
  ,simpleLowerCaseMapping:0xA383
  ,simpleTitleCaseMapping:0xA383
 },
 { code:0xA384
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA384
  ,simpleLowerCaseMapping:0xA384
  ,simpleTitleCaseMapping:0xA384
 },
 { code:0xA385
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA385
  ,simpleLowerCaseMapping:0xA385
  ,simpleTitleCaseMapping:0xA385
 },
 { code:0xA386
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA386
  ,simpleLowerCaseMapping:0xA386
  ,simpleTitleCaseMapping:0xA386
 },
 { code:0xA387
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA387
  ,simpleLowerCaseMapping:0xA387
  ,simpleTitleCaseMapping:0xA387
 },
 { code:0xA388
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA388
  ,simpleLowerCaseMapping:0xA388
  ,simpleTitleCaseMapping:0xA388
 },
 { code:0xA389
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA389
  ,simpleLowerCaseMapping:0xA389
  ,simpleTitleCaseMapping:0xA389
 },
 { code:0xA38A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA38A
  ,simpleLowerCaseMapping:0xA38A
  ,simpleTitleCaseMapping:0xA38A
 },
 { code:0xA38B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA38B
  ,simpleLowerCaseMapping:0xA38B
  ,simpleTitleCaseMapping:0xA38B
 },
 { code:0xA38C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA38C
  ,simpleLowerCaseMapping:0xA38C
  ,simpleTitleCaseMapping:0xA38C
 },
 { code:0xA38D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA38D
  ,simpleLowerCaseMapping:0xA38D
  ,simpleTitleCaseMapping:0xA38D
 },
 { code:0xA38E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA38E
  ,simpleLowerCaseMapping:0xA38E
  ,simpleTitleCaseMapping:0xA38E
 },
 { code:0xA38F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA38F
  ,simpleLowerCaseMapping:0xA38F
  ,simpleTitleCaseMapping:0xA38F
 },
 { code:0xA390
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA390
  ,simpleLowerCaseMapping:0xA390
  ,simpleTitleCaseMapping:0xA390
 },
 { code:0xA391
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA391
  ,simpleLowerCaseMapping:0xA391
  ,simpleTitleCaseMapping:0xA391
 },
 { code:0xA392
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA392
  ,simpleLowerCaseMapping:0xA392
  ,simpleTitleCaseMapping:0xA392
 },
 { code:0xA393
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA393
  ,simpleLowerCaseMapping:0xA393
  ,simpleTitleCaseMapping:0xA393
 },
 { code:0xA394
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA394
  ,simpleLowerCaseMapping:0xA394
  ,simpleTitleCaseMapping:0xA394
 },
 { code:0xA395
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA395
  ,simpleLowerCaseMapping:0xA395
  ,simpleTitleCaseMapping:0xA395
 },
 { code:0xA396
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA396
  ,simpleLowerCaseMapping:0xA396
  ,simpleTitleCaseMapping:0xA396
 },
 { code:0xA397
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA397
  ,simpleLowerCaseMapping:0xA397
  ,simpleTitleCaseMapping:0xA397
 },
 { code:0xA398
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA398
  ,simpleLowerCaseMapping:0xA398
  ,simpleTitleCaseMapping:0xA398
 },
 { code:0xA399
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA399
  ,simpleLowerCaseMapping:0xA399
  ,simpleTitleCaseMapping:0xA399
 },
 { code:0xA39A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA39A
  ,simpleLowerCaseMapping:0xA39A
  ,simpleTitleCaseMapping:0xA39A
 },
 { code:0xA39B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA39B
  ,simpleLowerCaseMapping:0xA39B
  ,simpleTitleCaseMapping:0xA39B
 },
 { code:0xA39C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA39C
  ,simpleLowerCaseMapping:0xA39C
  ,simpleTitleCaseMapping:0xA39C
 },
 { code:0xA39D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA39D
  ,simpleLowerCaseMapping:0xA39D
  ,simpleTitleCaseMapping:0xA39D
 },
 { code:0xA39E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA39E
  ,simpleLowerCaseMapping:0xA39E
  ,simpleTitleCaseMapping:0xA39E
 },
 { code:0xA39F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA39F
  ,simpleLowerCaseMapping:0xA39F
  ,simpleTitleCaseMapping:0xA39F
 },
 { code:0xA3A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3A0
  ,simpleLowerCaseMapping:0xA3A0
  ,simpleTitleCaseMapping:0xA3A0
 },
 { code:0xA3A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3A1
  ,simpleLowerCaseMapping:0xA3A1
  ,simpleTitleCaseMapping:0xA3A1
 },
 { code:0xA3A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3A2
  ,simpleLowerCaseMapping:0xA3A2
  ,simpleTitleCaseMapping:0xA3A2
 },
 { code:0xA3A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3A3
  ,simpleLowerCaseMapping:0xA3A3
  ,simpleTitleCaseMapping:0xA3A3
 },
 { code:0xA3A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3A4
  ,simpleLowerCaseMapping:0xA3A4
  ,simpleTitleCaseMapping:0xA3A4
 },
 { code:0xA3A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3A5
  ,simpleLowerCaseMapping:0xA3A5
  ,simpleTitleCaseMapping:0xA3A5
 },
 { code:0xA3A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3A6
  ,simpleLowerCaseMapping:0xA3A6
  ,simpleTitleCaseMapping:0xA3A6
 },
 { code:0xA3A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3A7
  ,simpleLowerCaseMapping:0xA3A7
  ,simpleTitleCaseMapping:0xA3A7
 },
 { code:0xA3A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3A8
  ,simpleLowerCaseMapping:0xA3A8
  ,simpleTitleCaseMapping:0xA3A8
 },
 { code:0xA3A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3A9
  ,simpleLowerCaseMapping:0xA3A9
  ,simpleTitleCaseMapping:0xA3A9
 },
 { code:0xA3AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3AA
  ,simpleLowerCaseMapping:0xA3AA
  ,simpleTitleCaseMapping:0xA3AA
 },
 { code:0xA3AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3AB
  ,simpleLowerCaseMapping:0xA3AB
  ,simpleTitleCaseMapping:0xA3AB
 },
 { code:0xA3AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3AC
  ,simpleLowerCaseMapping:0xA3AC
  ,simpleTitleCaseMapping:0xA3AC
 },
 { code:0xA3AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3AD
  ,simpleLowerCaseMapping:0xA3AD
  ,simpleTitleCaseMapping:0xA3AD
 },
 { code:0xA3AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3AE
  ,simpleLowerCaseMapping:0xA3AE
  ,simpleTitleCaseMapping:0xA3AE
 },
 { code:0xA3AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3AF
  ,simpleLowerCaseMapping:0xA3AF
  ,simpleTitleCaseMapping:0xA3AF
 },
 { code:0xA3B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3B0
  ,simpleLowerCaseMapping:0xA3B0
  ,simpleTitleCaseMapping:0xA3B0
 },
 { code:0xA3B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3B1
  ,simpleLowerCaseMapping:0xA3B1
  ,simpleTitleCaseMapping:0xA3B1
 },
 { code:0xA3B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3B2
  ,simpleLowerCaseMapping:0xA3B2
  ,simpleTitleCaseMapping:0xA3B2
 },
 { code:0xA3B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3B3
  ,simpleLowerCaseMapping:0xA3B3
  ,simpleTitleCaseMapping:0xA3B3
 },
 { code:0xA3B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3B4
  ,simpleLowerCaseMapping:0xA3B4
  ,simpleTitleCaseMapping:0xA3B4
 },
 { code:0xA3B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3B5
  ,simpleLowerCaseMapping:0xA3B5
  ,simpleTitleCaseMapping:0xA3B5
 },
 { code:0xA3B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3B6
  ,simpleLowerCaseMapping:0xA3B6
  ,simpleTitleCaseMapping:0xA3B6
 },
 { code:0xA3B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3B7
  ,simpleLowerCaseMapping:0xA3B7
  ,simpleTitleCaseMapping:0xA3B7
 },
 { code:0xA3B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3B8
  ,simpleLowerCaseMapping:0xA3B8
  ,simpleTitleCaseMapping:0xA3B8
 },
 { code:0xA3B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3B9
  ,simpleLowerCaseMapping:0xA3B9
  ,simpleTitleCaseMapping:0xA3B9
 },
 { code:0xA3BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3BA
  ,simpleLowerCaseMapping:0xA3BA
  ,simpleTitleCaseMapping:0xA3BA
 },
 { code:0xA3BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3BB
  ,simpleLowerCaseMapping:0xA3BB
  ,simpleTitleCaseMapping:0xA3BB
 },
 { code:0xA3BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3BC
  ,simpleLowerCaseMapping:0xA3BC
  ,simpleTitleCaseMapping:0xA3BC
 },
 { code:0xA3BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3BD
  ,simpleLowerCaseMapping:0xA3BD
  ,simpleTitleCaseMapping:0xA3BD
 },
 { code:0xA3BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3BE
  ,simpleLowerCaseMapping:0xA3BE
  ,simpleTitleCaseMapping:0xA3BE
 },
 { code:0xA3BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3BF
  ,simpleLowerCaseMapping:0xA3BF
  ,simpleTitleCaseMapping:0xA3BF
 },
 { code:0xA3C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3C0
  ,simpleLowerCaseMapping:0xA3C0
  ,simpleTitleCaseMapping:0xA3C0
 },
 { code:0xA3C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3C1
  ,simpleLowerCaseMapping:0xA3C1
  ,simpleTitleCaseMapping:0xA3C1
 },
 { code:0xA3C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3C2
  ,simpleLowerCaseMapping:0xA3C2
  ,simpleTitleCaseMapping:0xA3C2
 },
 { code:0xA3C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3C3
  ,simpleLowerCaseMapping:0xA3C3
  ,simpleTitleCaseMapping:0xA3C3
 },
 { code:0xA3C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3C4
  ,simpleLowerCaseMapping:0xA3C4
  ,simpleTitleCaseMapping:0xA3C4
 },
 { code:0xA3C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3C5
  ,simpleLowerCaseMapping:0xA3C5
  ,simpleTitleCaseMapping:0xA3C5
 },
 { code:0xA3C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3C6
  ,simpleLowerCaseMapping:0xA3C6
  ,simpleTitleCaseMapping:0xA3C6
 },
 { code:0xA3C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3C7
  ,simpleLowerCaseMapping:0xA3C7
  ,simpleTitleCaseMapping:0xA3C7
 },
 { code:0xA3C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3C8
  ,simpleLowerCaseMapping:0xA3C8
  ,simpleTitleCaseMapping:0xA3C8
 },
 { code:0xA3C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3C9
  ,simpleLowerCaseMapping:0xA3C9
  ,simpleTitleCaseMapping:0xA3C9
 },
 { code:0xA3CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3CA
  ,simpleLowerCaseMapping:0xA3CA
  ,simpleTitleCaseMapping:0xA3CA
 },
 { code:0xA3CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3CB
  ,simpleLowerCaseMapping:0xA3CB
  ,simpleTitleCaseMapping:0xA3CB
 },
 { code:0xA3CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3CC
  ,simpleLowerCaseMapping:0xA3CC
  ,simpleTitleCaseMapping:0xA3CC
 },
 { code:0xA3CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3CD
  ,simpleLowerCaseMapping:0xA3CD
  ,simpleTitleCaseMapping:0xA3CD
 },
 { code:0xA3CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3CE
  ,simpleLowerCaseMapping:0xA3CE
  ,simpleTitleCaseMapping:0xA3CE
 },
 { code:0xA3CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3CF
  ,simpleLowerCaseMapping:0xA3CF
  ,simpleTitleCaseMapping:0xA3CF
 },
 { code:0xA3D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3D0
  ,simpleLowerCaseMapping:0xA3D0
  ,simpleTitleCaseMapping:0xA3D0
 },
 { code:0xA3D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3D1
  ,simpleLowerCaseMapping:0xA3D1
  ,simpleTitleCaseMapping:0xA3D1
 },
 { code:0xA3D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3D2
  ,simpleLowerCaseMapping:0xA3D2
  ,simpleTitleCaseMapping:0xA3D2
 },
 { code:0xA3D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3D3
  ,simpleLowerCaseMapping:0xA3D3
  ,simpleTitleCaseMapping:0xA3D3
 },
 { code:0xA3D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3D4
  ,simpleLowerCaseMapping:0xA3D4
  ,simpleTitleCaseMapping:0xA3D4
 },
 { code:0xA3D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3D5
  ,simpleLowerCaseMapping:0xA3D5
  ,simpleTitleCaseMapping:0xA3D5
 },
 { code:0xA3D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3D6
  ,simpleLowerCaseMapping:0xA3D6
  ,simpleTitleCaseMapping:0xA3D6
 },
 { code:0xA3D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3D7
  ,simpleLowerCaseMapping:0xA3D7
  ,simpleTitleCaseMapping:0xA3D7
 },
 { code:0xA3D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3D8
  ,simpleLowerCaseMapping:0xA3D8
  ,simpleTitleCaseMapping:0xA3D8
 },
 { code:0xA3D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3D9
  ,simpleLowerCaseMapping:0xA3D9
  ,simpleTitleCaseMapping:0xA3D9
 },
 { code:0xA3DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3DA
  ,simpleLowerCaseMapping:0xA3DA
  ,simpleTitleCaseMapping:0xA3DA
 },
 { code:0xA3DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3DB
  ,simpleLowerCaseMapping:0xA3DB
  ,simpleTitleCaseMapping:0xA3DB
 },
 { code:0xA3DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3DC
  ,simpleLowerCaseMapping:0xA3DC
  ,simpleTitleCaseMapping:0xA3DC
 },
 { code:0xA3DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3DD
  ,simpleLowerCaseMapping:0xA3DD
  ,simpleTitleCaseMapping:0xA3DD
 },
 { code:0xA3DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3DE
  ,simpleLowerCaseMapping:0xA3DE
  ,simpleTitleCaseMapping:0xA3DE
 },
 { code:0xA3DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3DF
  ,simpleLowerCaseMapping:0xA3DF
  ,simpleTitleCaseMapping:0xA3DF
 },
 { code:0xA3E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3E0
  ,simpleLowerCaseMapping:0xA3E0
  ,simpleTitleCaseMapping:0xA3E0
 },
 { code:0xA3E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3E1
  ,simpleLowerCaseMapping:0xA3E1
  ,simpleTitleCaseMapping:0xA3E1
 },
 { code:0xA3E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3E2
  ,simpleLowerCaseMapping:0xA3E2
  ,simpleTitleCaseMapping:0xA3E2
 },
 { code:0xA3E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3E3
  ,simpleLowerCaseMapping:0xA3E3
  ,simpleTitleCaseMapping:0xA3E3
 },
 { code:0xA3E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3E4
  ,simpleLowerCaseMapping:0xA3E4
  ,simpleTitleCaseMapping:0xA3E4
 },
 { code:0xA3E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3E5
  ,simpleLowerCaseMapping:0xA3E5
  ,simpleTitleCaseMapping:0xA3E5
 },
 { code:0xA3E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3E6
  ,simpleLowerCaseMapping:0xA3E6
  ,simpleTitleCaseMapping:0xA3E6
 },
 { code:0xA3E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3E7
  ,simpleLowerCaseMapping:0xA3E7
  ,simpleTitleCaseMapping:0xA3E7
 },
 { code:0xA3E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3E8
  ,simpleLowerCaseMapping:0xA3E8
  ,simpleTitleCaseMapping:0xA3E8
 },
 { code:0xA3E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3E9
  ,simpleLowerCaseMapping:0xA3E9
  ,simpleTitleCaseMapping:0xA3E9
 },
 { code:0xA3EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3EA
  ,simpleLowerCaseMapping:0xA3EA
  ,simpleTitleCaseMapping:0xA3EA
 },
 { code:0xA3EB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3EB
  ,simpleLowerCaseMapping:0xA3EB
  ,simpleTitleCaseMapping:0xA3EB
 },
 { code:0xA3EC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3EC
  ,simpleLowerCaseMapping:0xA3EC
  ,simpleTitleCaseMapping:0xA3EC
 },
 { code:0xA3ED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3ED
  ,simpleLowerCaseMapping:0xA3ED
  ,simpleTitleCaseMapping:0xA3ED
 },
 { code:0xA3EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3EE
  ,simpleLowerCaseMapping:0xA3EE
  ,simpleTitleCaseMapping:0xA3EE
 },
 { code:0xA3EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3EF
  ,simpleLowerCaseMapping:0xA3EF
  ,simpleTitleCaseMapping:0xA3EF
 },
 { code:0xA3F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3F0
  ,simpleLowerCaseMapping:0xA3F0
  ,simpleTitleCaseMapping:0xA3F0
 },
 { code:0xA3F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3F1
  ,simpleLowerCaseMapping:0xA3F1
  ,simpleTitleCaseMapping:0xA3F1
 },
 { code:0xA3F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3F2
  ,simpleLowerCaseMapping:0xA3F2
  ,simpleTitleCaseMapping:0xA3F2
 },
 { code:0xA3F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3F3
  ,simpleLowerCaseMapping:0xA3F3
  ,simpleTitleCaseMapping:0xA3F3
 },
 { code:0xA3F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3F4
  ,simpleLowerCaseMapping:0xA3F4
  ,simpleTitleCaseMapping:0xA3F4
 },
 { code:0xA3F5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3F5
  ,simpleLowerCaseMapping:0xA3F5
  ,simpleTitleCaseMapping:0xA3F5
 },
 { code:0xA3F6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3F6
  ,simpleLowerCaseMapping:0xA3F6
  ,simpleTitleCaseMapping:0xA3F6
 },
 { code:0xA3F7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3F7
  ,simpleLowerCaseMapping:0xA3F7
  ,simpleTitleCaseMapping:0xA3F7
 },
 { code:0xA3F8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3F8
  ,simpleLowerCaseMapping:0xA3F8
  ,simpleTitleCaseMapping:0xA3F8
 },
 { code:0xA3F9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3F9
  ,simpleLowerCaseMapping:0xA3F9
  ,simpleTitleCaseMapping:0xA3F9
 },
 { code:0xA3FA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3FA
  ,simpleLowerCaseMapping:0xA3FA
  ,simpleTitleCaseMapping:0xA3FA
 },
 { code:0xA3FB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3FB
  ,simpleLowerCaseMapping:0xA3FB
  ,simpleTitleCaseMapping:0xA3FB
 },
 { code:0xA3FC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3FC
  ,simpleLowerCaseMapping:0xA3FC
  ,simpleTitleCaseMapping:0xA3FC
 },
 { code:0xA3FD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3FD
  ,simpleLowerCaseMapping:0xA3FD
  ,simpleTitleCaseMapping:0xA3FD
 },
 { code:0xA3FE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3FE
  ,simpleLowerCaseMapping:0xA3FE
  ,simpleTitleCaseMapping:0xA3FE
 },
 { code:0xA3FF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA3FF
  ,simpleLowerCaseMapping:0xA3FF
  ,simpleTitleCaseMapping:0xA3FF
 },
 { code:0xA400
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA400
  ,simpleLowerCaseMapping:0xA400
  ,simpleTitleCaseMapping:0xA400
 },
 { code:0xA401
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA401
  ,simpleLowerCaseMapping:0xA401
  ,simpleTitleCaseMapping:0xA401
 },
 { code:0xA402
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA402
  ,simpleLowerCaseMapping:0xA402
  ,simpleTitleCaseMapping:0xA402
 },
 { code:0xA403
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA403
  ,simpleLowerCaseMapping:0xA403
  ,simpleTitleCaseMapping:0xA403
 },
 { code:0xA404
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA404
  ,simpleLowerCaseMapping:0xA404
  ,simpleTitleCaseMapping:0xA404
 },
 { code:0xA405
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA405
  ,simpleLowerCaseMapping:0xA405
  ,simpleTitleCaseMapping:0xA405
 },
 { code:0xA406
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA406
  ,simpleLowerCaseMapping:0xA406
  ,simpleTitleCaseMapping:0xA406
 },
 { code:0xA407
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA407
  ,simpleLowerCaseMapping:0xA407
  ,simpleTitleCaseMapping:0xA407
 },
 { code:0xA408
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA408
  ,simpleLowerCaseMapping:0xA408
  ,simpleTitleCaseMapping:0xA408
 },
 { code:0xA409
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA409
  ,simpleLowerCaseMapping:0xA409
  ,simpleTitleCaseMapping:0xA409
 },
 { code:0xA40A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA40A
  ,simpleLowerCaseMapping:0xA40A
  ,simpleTitleCaseMapping:0xA40A
 },
 { code:0xA40B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA40B
  ,simpleLowerCaseMapping:0xA40B
  ,simpleTitleCaseMapping:0xA40B
 },
 { code:0xA40C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA40C
  ,simpleLowerCaseMapping:0xA40C
  ,simpleTitleCaseMapping:0xA40C
 },
 { code:0xA40D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA40D
  ,simpleLowerCaseMapping:0xA40D
  ,simpleTitleCaseMapping:0xA40D
 },
 { code:0xA40E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA40E
  ,simpleLowerCaseMapping:0xA40E
  ,simpleTitleCaseMapping:0xA40E
 },
 { code:0xA40F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA40F
  ,simpleLowerCaseMapping:0xA40F
  ,simpleTitleCaseMapping:0xA40F
 },
 { code:0xA410
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA410
  ,simpleLowerCaseMapping:0xA410
  ,simpleTitleCaseMapping:0xA410
 },
 { code:0xA411
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA411
  ,simpleLowerCaseMapping:0xA411
  ,simpleTitleCaseMapping:0xA411
 },
 { code:0xA412
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA412
  ,simpleLowerCaseMapping:0xA412
  ,simpleTitleCaseMapping:0xA412
 },
 { code:0xA413
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA413
  ,simpleLowerCaseMapping:0xA413
  ,simpleTitleCaseMapping:0xA413
 },
 { code:0xA414
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA414
  ,simpleLowerCaseMapping:0xA414
  ,simpleTitleCaseMapping:0xA414
 },
 { code:0xA415
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA415
  ,simpleLowerCaseMapping:0xA415
  ,simpleTitleCaseMapping:0xA415
 },
 { code:0xA416
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA416
  ,simpleLowerCaseMapping:0xA416
  ,simpleTitleCaseMapping:0xA416
 },
 { code:0xA417
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA417
  ,simpleLowerCaseMapping:0xA417
  ,simpleTitleCaseMapping:0xA417
 },
 { code:0xA418
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA418
  ,simpleLowerCaseMapping:0xA418
  ,simpleTitleCaseMapping:0xA418
 },
 { code:0xA419
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA419
  ,simpleLowerCaseMapping:0xA419
  ,simpleTitleCaseMapping:0xA419
 },
 { code:0xA41A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA41A
  ,simpleLowerCaseMapping:0xA41A
  ,simpleTitleCaseMapping:0xA41A
 },
 { code:0xA41B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA41B
  ,simpleLowerCaseMapping:0xA41B
  ,simpleTitleCaseMapping:0xA41B
 },
 { code:0xA41C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA41C
  ,simpleLowerCaseMapping:0xA41C
  ,simpleTitleCaseMapping:0xA41C
 },
 { code:0xA41D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA41D
  ,simpleLowerCaseMapping:0xA41D
  ,simpleTitleCaseMapping:0xA41D
 },
 { code:0xA41E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA41E
  ,simpleLowerCaseMapping:0xA41E
  ,simpleTitleCaseMapping:0xA41E
 },
 { code:0xA41F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA41F
  ,simpleLowerCaseMapping:0xA41F
  ,simpleTitleCaseMapping:0xA41F
 },
 { code:0xA420
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA420
  ,simpleLowerCaseMapping:0xA420
  ,simpleTitleCaseMapping:0xA420
 },
 { code:0xA421
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA421
  ,simpleLowerCaseMapping:0xA421
  ,simpleTitleCaseMapping:0xA421
 },
 { code:0xA422
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA422
  ,simpleLowerCaseMapping:0xA422
  ,simpleTitleCaseMapping:0xA422
 },
 { code:0xA423
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA423
  ,simpleLowerCaseMapping:0xA423
  ,simpleTitleCaseMapping:0xA423
 },
 { code:0xA424
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA424
  ,simpleLowerCaseMapping:0xA424
  ,simpleTitleCaseMapping:0xA424
 },
 { code:0xA425
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA425
  ,simpleLowerCaseMapping:0xA425
  ,simpleTitleCaseMapping:0xA425
 },
 { code:0xA426
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA426
  ,simpleLowerCaseMapping:0xA426
  ,simpleTitleCaseMapping:0xA426
 },
 { code:0xA427
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA427
  ,simpleLowerCaseMapping:0xA427
  ,simpleTitleCaseMapping:0xA427
 },
 { code:0xA428
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA428
  ,simpleLowerCaseMapping:0xA428
  ,simpleTitleCaseMapping:0xA428
 },
 { code:0xA429
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA429
  ,simpleLowerCaseMapping:0xA429
  ,simpleTitleCaseMapping:0xA429
 },
 { code:0xA42A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA42A
  ,simpleLowerCaseMapping:0xA42A
  ,simpleTitleCaseMapping:0xA42A
 },
 { code:0xA42B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA42B
  ,simpleLowerCaseMapping:0xA42B
  ,simpleTitleCaseMapping:0xA42B
 },
 { code:0xA42C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA42C
  ,simpleLowerCaseMapping:0xA42C
  ,simpleTitleCaseMapping:0xA42C
 },
 { code:0xA42D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA42D
  ,simpleLowerCaseMapping:0xA42D
  ,simpleTitleCaseMapping:0xA42D
 },
 { code:0xA42E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA42E
  ,simpleLowerCaseMapping:0xA42E
  ,simpleTitleCaseMapping:0xA42E
 },
 { code:0xA42F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA42F
  ,simpleLowerCaseMapping:0xA42F
  ,simpleTitleCaseMapping:0xA42F
 },
 { code:0xA430
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA430
  ,simpleLowerCaseMapping:0xA430
  ,simpleTitleCaseMapping:0xA430
 },
 { code:0xA431
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA431
  ,simpleLowerCaseMapping:0xA431
  ,simpleTitleCaseMapping:0xA431
 },
 { code:0xA432
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA432
  ,simpleLowerCaseMapping:0xA432
  ,simpleTitleCaseMapping:0xA432
 },
 { code:0xA433
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA433
  ,simpleLowerCaseMapping:0xA433
  ,simpleTitleCaseMapping:0xA433
 },
 { code:0xA434
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA434
  ,simpleLowerCaseMapping:0xA434
  ,simpleTitleCaseMapping:0xA434
 },
 { code:0xA435
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA435
  ,simpleLowerCaseMapping:0xA435
  ,simpleTitleCaseMapping:0xA435
 },
 { code:0xA436
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA436
  ,simpleLowerCaseMapping:0xA436
  ,simpleTitleCaseMapping:0xA436
 },
 { code:0xA437
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA437
  ,simpleLowerCaseMapping:0xA437
  ,simpleTitleCaseMapping:0xA437
 },
 { code:0xA438
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA438
  ,simpleLowerCaseMapping:0xA438
  ,simpleTitleCaseMapping:0xA438
 },
 { code:0xA439
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA439
  ,simpleLowerCaseMapping:0xA439
  ,simpleTitleCaseMapping:0xA439
 },
 { code:0xA43A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA43A
  ,simpleLowerCaseMapping:0xA43A
  ,simpleTitleCaseMapping:0xA43A
 },
 { code:0xA43B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA43B
  ,simpleLowerCaseMapping:0xA43B
  ,simpleTitleCaseMapping:0xA43B
 },
 { code:0xA43C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA43C
  ,simpleLowerCaseMapping:0xA43C
  ,simpleTitleCaseMapping:0xA43C
 },
 { code:0xA43D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA43D
  ,simpleLowerCaseMapping:0xA43D
  ,simpleTitleCaseMapping:0xA43D
 },
 { code:0xA43E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA43E
  ,simpleLowerCaseMapping:0xA43E
  ,simpleTitleCaseMapping:0xA43E
 },
 { code:0xA43F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA43F
  ,simpleLowerCaseMapping:0xA43F
  ,simpleTitleCaseMapping:0xA43F
 },
 { code:0xA440
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA440
  ,simpleLowerCaseMapping:0xA440
  ,simpleTitleCaseMapping:0xA440
 },
 { code:0xA441
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA441
  ,simpleLowerCaseMapping:0xA441
  ,simpleTitleCaseMapping:0xA441
 },
 { code:0xA442
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA442
  ,simpleLowerCaseMapping:0xA442
  ,simpleTitleCaseMapping:0xA442
 },
 { code:0xA443
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA443
  ,simpleLowerCaseMapping:0xA443
  ,simpleTitleCaseMapping:0xA443
 },
 { code:0xA444
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA444
  ,simpleLowerCaseMapping:0xA444
  ,simpleTitleCaseMapping:0xA444
 },
 { code:0xA445
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA445
  ,simpleLowerCaseMapping:0xA445
  ,simpleTitleCaseMapping:0xA445
 },
 { code:0xA446
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA446
  ,simpleLowerCaseMapping:0xA446
  ,simpleTitleCaseMapping:0xA446
 },
 { code:0xA447
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA447
  ,simpleLowerCaseMapping:0xA447
  ,simpleTitleCaseMapping:0xA447
 },
 { code:0xA448
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA448
  ,simpleLowerCaseMapping:0xA448
  ,simpleTitleCaseMapping:0xA448
 },
 { code:0xA449
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA449
  ,simpleLowerCaseMapping:0xA449
  ,simpleTitleCaseMapping:0xA449
 },
 { code:0xA44A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA44A
  ,simpleLowerCaseMapping:0xA44A
  ,simpleTitleCaseMapping:0xA44A
 },
 { code:0xA44B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA44B
  ,simpleLowerCaseMapping:0xA44B
  ,simpleTitleCaseMapping:0xA44B
 },
 { code:0xA44C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA44C
  ,simpleLowerCaseMapping:0xA44C
  ,simpleTitleCaseMapping:0xA44C
 },
 { code:0xA44D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA44D
  ,simpleLowerCaseMapping:0xA44D
  ,simpleTitleCaseMapping:0xA44D
 },
 { code:0xA44E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA44E
  ,simpleLowerCaseMapping:0xA44E
  ,simpleTitleCaseMapping:0xA44E
 },
 { code:0xA44F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA44F
  ,simpleLowerCaseMapping:0xA44F
  ,simpleTitleCaseMapping:0xA44F
 },
 { code:0xA450
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA450
  ,simpleLowerCaseMapping:0xA450
  ,simpleTitleCaseMapping:0xA450
 },
 { code:0xA451
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA451
  ,simpleLowerCaseMapping:0xA451
  ,simpleTitleCaseMapping:0xA451
 },
 { code:0xA452
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA452
  ,simpleLowerCaseMapping:0xA452
  ,simpleTitleCaseMapping:0xA452
 },
 { code:0xA453
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA453
  ,simpleLowerCaseMapping:0xA453
  ,simpleTitleCaseMapping:0xA453
 },
 { code:0xA454
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA454
  ,simpleLowerCaseMapping:0xA454
  ,simpleTitleCaseMapping:0xA454
 },
 { code:0xA455
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA455
  ,simpleLowerCaseMapping:0xA455
  ,simpleTitleCaseMapping:0xA455
 },
 { code:0xA456
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA456
  ,simpleLowerCaseMapping:0xA456
  ,simpleTitleCaseMapping:0xA456
 },
 { code:0xA457
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA457
  ,simpleLowerCaseMapping:0xA457
  ,simpleTitleCaseMapping:0xA457
 },
 { code:0xA458
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA458
  ,simpleLowerCaseMapping:0xA458
  ,simpleTitleCaseMapping:0xA458
 },
 { code:0xA459
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA459
  ,simpleLowerCaseMapping:0xA459
  ,simpleTitleCaseMapping:0xA459
 },
 { code:0xA45A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA45A
  ,simpleLowerCaseMapping:0xA45A
  ,simpleTitleCaseMapping:0xA45A
 },
 { code:0xA45B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA45B
  ,simpleLowerCaseMapping:0xA45B
  ,simpleTitleCaseMapping:0xA45B
 },
 { code:0xA45C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA45C
  ,simpleLowerCaseMapping:0xA45C
  ,simpleTitleCaseMapping:0xA45C
 },
 { code:0xA45D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA45D
  ,simpleLowerCaseMapping:0xA45D
  ,simpleTitleCaseMapping:0xA45D
 },
 { code:0xA45E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA45E
  ,simpleLowerCaseMapping:0xA45E
  ,simpleTitleCaseMapping:0xA45E
 },
 { code:0xA45F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA45F
  ,simpleLowerCaseMapping:0xA45F
  ,simpleTitleCaseMapping:0xA45F
 },
 { code:0xA460
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA460
  ,simpleLowerCaseMapping:0xA460
  ,simpleTitleCaseMapping:0xA460
 },
 { code:0xA461
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA461
  ,simpleLowerCaseMapping:0xA461
  ,simpleTitleCaseMapping:0xA461
 },
 { code:0xA462
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA462
  ,simpleLowerCaseMapping:0xA462
  ,simpleTitleCaseMapping:0xA462
 },
 { code:0xA463
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA463
  ,simpleLowerCaseMapping:0xA463
  ,simpleTitleCaseMapping:0xA463
 },
 { code:0xA464
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA464
  ,simpleLowerCaseMapping:0xA464
  ,simpleTitleCaseMapping:0xA464
 },
 { code:0xA465
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA465
  ,simpleLowerCaseMapping:0xA465
  ,simpleTitleCaseMapping:0xA465
 },
 { code:0xA466
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA466
  ,simpleLowerCaseMapping:0xA466
  ,simpleTitleCaseMapping:0xA466
 },
 { code:0xA467
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA467
  ,simpleLowerCaseMapping:0xA467
  ,simpleTitleCaseMapping:0xA467
 },
 { code:0xA468
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA468
  ,simpleLowerCaseMapping:0xA468
  ,simpleTitleCaseMapping:0xA468
 },
 { code:0xA469
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA469
  ,simpleLowerCaseMapping:0xA469
  ,simpleTitleCaseMapping:0xA469
 },
 { code:0xA46A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA46A
  ,simpleLowerCaseMapping:0xA46A
  ,simpleTitleCaseMapping:0xA46A
 },
 { code:0xA46B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA46B
  ,simpleLowerCaseMapping:0xA46B
  ,simpleTitleCaseMapping:0xA46B
 },
 { code:0xA46C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA46C
  ,simpleLowerCaseMapping:0xA46C
  ,simpleTitleCaseMapping:0xA46C
 },
 { code:0xA46D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA46D
  ,simpleLowerCaseMapping:0xA46D
  ,simpleTitleCaseMapping:0xA46D
 },
 { code:0xA46E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA46E
  ,simpleLowerCaseMapping:0xA46E
  ,simpleTitleCaseMapping:0xA46E
 },
 { code:0xA46F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA46F
  ,simpleLowerCaseMapping:0xA46F
  ,simpleTitleCaseMapping:0xA46F
 },
 { code:0xA470
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA470
  ,simpleLowerCaseMapping:0xA470
  ,simpleTitleCaseMapping:0xA470
 },
 { code:0xA471
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA471
  ,simpleLowerCaseMapping:0xA471
  ,simpleTitleCaseMapping:0xA471
 },
 { code:0xA472
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA472
  ,simpleLowerCaseMapping:0xA472
  ,simpleTitleCaseMapping:0xA472
 },
 { code:0xA473
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA473
  ,simpleLowerCaseMapping:0xA473
  ,simpleTitleCaseMapping:0xA473
 },
 { code:0xA474
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA474
  ,simpleLowerCaseMapping:0xA474
  ,simpleTitleCaseMapping:0xA474
 },
 { code:0xA475
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA475
  ,simpleLowerCaseMapping:0xA475
  ,simpleTitleCaseMapping:0xA475
 },
 { code:0xA476
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA476
  ,simpleLowerCaseMapping:0xA476
  ,simpleTitleCaseMapping:0xA476
 },
 { code:0xA477
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA477
  ,simpleLowerCaseMapping:0xA477
  ,simpleTitleCaseMapping:0xA477
 },
 { code:0xA478
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA478
  ,simpleLowerCaseMapping:0xA478
  ,simpleTitleCaseMapping:0xA478
 },
 { code:0xA479
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA479
  ,simpleLowerCaseMapping:0xA479
  ,simpleTitleCaseMapping:0xA479
 },
 { code:0xA47A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA47A
  ,simpleLowerCaseMapping:0xA47A
  ,simpleTitleCaseMapping:0xA47A
 },
 { code:0xA47B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA47B
  ,simpleLowerCaseMapping:0xA47B
  ,simpleTitleCaseMapping:0xA47B
 },
 { code:0xA47C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA47C
  ,simpleLowerCaseMapping:0xA47C
  ,simpleTitleCaseMapping:0xA47C
 },
 { code:0xA47D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA47D
  ,simpleLowerCaseMapping:0xA47D
  ,simpleTitleCaseMapping:0xA47D
 },
 { code:0xA47E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA47E
  ,simpleLowerCaseMapping:0xA47E
  ,simpleTitleCaseMapping:0xA47E
 },
 { code:0xA47F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA47F
  ,simpleLowerCaseMapping:0xA47F
  ,simpleTitleCaseMapping:0xA47F
 },
 { code:0xA480
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA480
  ,simpleLowerCaseMapping:0xA480
  ,simpleTitleCaseMapping:0xA480
 },
 { code:0xA481
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA481
  ,simpleLowerCaseMapping:0xA481
  ,simpleTitleCaseMapping:0xA481
 },
 { code:0xA482
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA482
  ,simpleLowerCaseMapping:0xA482
  ,simpleTitleCaseMapping:0xA482
 },
 { code:0xA483
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA483
  ,simpleLowerCaseMapping:0xA483
  ,simpleTitleCaseMapping:0xA483
 },
 { code:0xA484
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA484
  ,simpleLowerCaseMapping:0xA484
  ,simpleTitleCaseMapping:0xA484
 },
 { code:0xA485
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA485
  ,simpleLowerCaseMapping:0xA485
  ,simpleTitleCaseMapping:0xA485
 },
 { code:0xA486
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA486
  ,simpleLowerCaseMapping:0xA486
  ,simpleTitleCaseMapping:0xA486
 },
 { code:0xA487
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA487
  ,simpleLowerCaseMapping:0xA487
  ,simpleTitleCaseMapping:0xA487
 },
 { code:0xA488
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA488
  ,simpleLowerCaseMapping:0xA488
  ,simpleTitleCaseMapping:0xA488
 },
 { code:0xA489
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA489
  ,simpleLowerCaseMapping:0xA489
  ,simpleTitleCaseMapping:0xA489
 },
 { code:0xA48A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA48A
  ,simpleLowerCaseMapping:0xA48A
  ,simpleTitleCaseMapping:0xA48A
 },
 { code:0xA48B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA48B
  ,simpleLowerCaseMapping:0xA48B
  ,simpleTitleCaseMapping:0xA48B
 },
 { code:0xA48C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA48C
  ,simpleLowerCaseMapping:0xA48C
  ,simpleTitleCaseMapping:0xA48C
 },
 { code:0xA490
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA490
  ,simpleLowerCaseMapping:0xA490
  ,simpleTitleCaseMapping:0xA490
 },
 { code:0xA491
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA491
  ,simpleLowerCaseMapping:0xA491
  ,simpleTitleCaseMapping:0xA491
 },
 { code:0xA492
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA492
  ,simpleLowerCaseMapping:0xA492
  ,simpleTitleCaseMapping:0xA492
 },
 { code:0xA493
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA493
  ,simpleLowerCaseMapping:0xA493
  ,simpleTitleCaseMapping:0xA493
 },
 { code:0xA494
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA494
  ,simpleLowerCaseMapping:0xA494
  ,simpleTitleCaseMapping:0xA494
 },
 { code:0xA495
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA495
  ,simpleLowerCaseMapping:0xA495
  ,simpleTitleCaseMapping:0xA495
 },
 { code:0xA496
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA496
  ,simpleLowerCaseMapping:0xA496
  ,simpleTitleCaseMapping:0xA496
 },
 { code:0xA497
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA497
  ,simpleLowerCaseMapping:0xA497
  ,simpleTitleCaseMapping:0xA497
 },
 { code:0xA498
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA498
  ,simpleLowerCaseMapping:0xA498
  ,simpleTitleCaseMapping:0xA498
 },
 { code:0xA499
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA499
  ,simpleLowerCaseMapping:0xA499
  ,simpleTitleCaseMapping:0xA499
 },
 { code:0xA49A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA49A
  ,simpleLowerCaseMapping:0xA49A
  ,simpleTitleCaseMapping:0xA49A
 },
 { code:0xA49B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA49B
  ,simpleLowerCaseMapping:0xA49B
  ,simpleTitleCaseMapping:0xA49B
 },
 { code:0xA49C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA49C
  ,simpleLowerCaseMapping:0xA49C
  ,simpleTitleCaseMapping:0xA49C
 },
 { code:0xA49D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA49D
  ,simpleLowerCaseMapping:0xA49D
  ,simpleTitleCaseMapping:0xA49D
 },
 { code:0xA49E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA49E
  ,simpleLowerCaseMapping:0xA49E
  ,simpleTitleCaseMapping:0xA49E
 },
 { code:0xA49F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA49F
  ,simpleLowerCaseMapping:0xA49F
  ,simpleTitleCaseMapping:0xA49F
 },
 { code:0xA4A0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4A0
  ,simpleLowerCaseMapping:0xA4A0
  ,simpleTitleCaseMapping:0xA4A0
 },
 { code:0xA4A1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4A1
  ,simpleLowerCaseMapping:0xA4A1
  ,simpleTitleCaseMapping:0xA4A1
 },
 { code:0xA4A2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4A2
  ,simpleLowerCaseMapping:0xA4A2
  ,simpleTitleCaseMapping:0xA4A2
 },
 { code:0xA4A3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4A3
  ,simpleLowerCaseMapping:0xA4A3
  ,simpleTitleCaseMapping:0xA4A3
 },
 { code:0xA4A4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4A4
  ,simpleLowerCaseMapping:0xA4A4
  ,simpleTitleCaseMapping:0xA4A4
 },
 { code:0xA4A5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4A5
  ,simpleLowerCaseMapping:0xA4A5
  ,simpleTitleCaseMapping:0xA4A5
 },
 { code:0xA4A6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4A6
  ,simpleLowerCaseMapping:0xA4A6
  ,simpleTitleCaseMapping:0xA4A6
 },
 { code:0xA4A7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4A7
  ,simpleLowerCaseMapping:0xA4A7
  ,simpleTitleCaseMapping:0xA4A7
 },
 { code:0xA4A8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4A8
  ,simpleLowerCaseMapping:0xA4A8
  ,simpleTitleCaseMapping:0xA4A8
 },
 { code:0xA4A9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4A9
  ,simpleLowerCaseMapping:0xA4A9
  ,simpleTitleCaseMapping:0xA4A9
 },
 { code:0xA4AA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4AA
  ,simpleLowerCaseMapping:0xA4AA
  ,simpleTitleCaseMapping:0xA4AA
 },
 { code:0xA4AB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4AB
  ,simpleLowerCaseMapping:0xA4AB
  ,simpleTitleCaseMapping:0xA4AB
 },
 { code:0xA4AC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4AC
  ,simpleLowerCaseMapping:0xA4AC
  ,simpleTitleCaseMapping:0xA4AC
 },
 { code:0xA4AD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4AD
  ,simpleLowerCaseMapping:0xA4AD
  ,simpleTitleCaseMapping:0xA4AD
 },
 { code:0xA4AE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4AE
  ,simpleLowerCaseMapping:0xA4AE
  ,simpleTitleCaseMapping:0xA4AE
 },
 { code:0xA4AF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4AF
  ,simpleLowerCaseMapping:0xA4AF
  ,simpleTitleCaseMapping:0xA4AF
 },
 { code:0xA4B0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4B0
  ,simpleLowerCaseMapping:0xA4B0
  ,simpleTitleCaseMapping:0xA4B0
 },
 { code:0xA4B1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4B1
  ,simpleLowerCaseMapping:0xA4B1
  ,simpleTitleCaseMapping:0xA4B1
 },
 { code:0xA4B2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4B2
  ,simpleLowerCaseMapping:0xA4B2
  ,simpleTitleCaseMapping:0xA4B2
 },
 { code:0xA4B3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4B3
  ,simpleLowerCaseMapping:0xA4B3
  ,simpleTitleCaseMapping:0xA4B3
 },
 { code:0xA4B4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4B4
  ,simpleLowerCaseMapping:0xA4B4
  ,simpleTitleCaseMapping:0xA4B4
 },
 { code:0xA4B5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4B5
  ,simpleLowerCaseMapping:0xA4B5
  ,simpleTitleCaseMapping:0xA4B5
 },
 { code:0xA4B6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4B6
  ,simpleLowerCaseMapping:0xA4B6
  ,simpleTitleCaseMapping:0xA4B6
 },
 { code:0xA4B7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4B7
  ,simpleLowerCaseMapping:0xA4B7
  ,simpleTitleCaseMapping:0xA4B7
 },
 { code:0xA4B8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4B8
  ,simpleLowerCaseMapping:0xA4B8
  ,simpleTitleCaseMapping:0xA4B8
 },
 { code:0xA4B9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4B9
  ,simpleLowerCaseMapping:0xA4B9
  ,simpleTitleCaseMapping:0xA4B9
 },
 { code:0xA4BA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4BA
  ,simpleLowerCaseMapping:0xA4BA
  ,simpleTitleCaseMapping:0xA4BA
 },
 { code:0xA4BB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4BB
  ,simpleLowerCaseMapping:0xA4BB
  ,simpleTitleCaseMapping:0xA4BB
 },
 { code:0xA4BC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4BC
  ,simpleLowerCaseMapping:0xA4BC
  ,simpleTitleCaseMapping:0xA4BC
 },
 { code:0xA4BD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4BD
  ,simpleLowerCaseMapping:0xA4BD
  ,simpleTitleCaseMapping:0xA4BD
 },
 { code:0xA4BE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4BE
  ,simpleLowerCaseMapping:0xA4BE
  ,simpleTitleCaseMapping:0xA4BE
 },
 { code:0xA4BF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4BF
  ,simpleLowerCaseMapping:0xA4BF
  ,simpleTitleCaseMapping:0xA4BF
 },
 { code:0xA4C0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4C0
  ,simpleLowerCaseMapping:0xA4C0
  ,simpleTitleCaseMapping:0xA4C0
 },
 { code:0xA4C1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4C1
  ,simpleLowerCaseMapping:0xA4C1
  ,simpleTitleCaseMapping:0xA4C1
 },
 { code:0xA4C2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4C2
  ,simpleLowerCaseMapping:0xA4C2
  ,simpleTitleCaseMapping:0xA4C2
 },
 { code:0xA4C3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4C3
  ,simpleLowerCaseMapping:0xA4C3
  ,simpleTitleCaseMapping:0xA4C3
 },
 { code:0xA4C4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4C4
  ,simpleLowerCaseMapping:0xA4C4
  ,simpleTitleCaseMapping:0xA4C4
 },
 { code:0xA4C5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4C5
  ,simpleLowerCaseMapping:0xA4C5
  ,simpleTitleCaseMapping:0xA4C5
 },
 { code:0xA4C6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA4C6
  ,simpleLowerCaseMapping:0xA4C6
  ,simpleTitleCaseMapping:0xA4C6
 },
 { code:0xA700
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA700
  ,simpleLowerCaseMapping:0xA700
  ,simpleTitleCaseMapping:0xA700
 },
 { code:0xA701
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA701
  ,simpleLowerCaseMapping:0xA701
  ,simpleTitleCaseMapping:0xA701
 },
 { code:0xA702
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA702
  ,simpleLowerCaseMapping:0xA702
  ,simpleTitleCaseMapping:0xA702
 },
 { code:0xA703
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA703
  ,simpleLowerCaseMapping:0xA703
  ,simpleTitleCaseMapping:0xA703
 },
 { code:0xA704
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA704
  ,simpleLowerCaseMapping:0xA704
  ,simpleTitleCaseMapping:0xA704
 },
 { code:0xA705
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA705
  ,simpleLowerCaseMapping:0xA705
  ,simpleTitleCaseMapping:0xA705
 },
 { code:0xA706
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA706
  ,simpleLowerCaseMapping:0xA706
  ,simpleTitleCaseMapping:0xA706
 },
 { code:0xA707
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA707
  ,simpleLowerCaseMapping:0xA707
  ,simpleTitleCaseMapping:0xA707
 },
 { code:0xA708
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA708
  ,simpleLowerCaseMapping:0xA708
  ,simpleTitleCaseMapping:0xA708
 },
 { code:0xA709
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA709
  ,simpleLowerCaseMapping:0xA709
  ,simpleTitleCaseMapping:0xA709
 },
 { code:0xA70A
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA70A
  ,simpleLowerCaseMapping:0xA70A
  ,simpleTitleCaseMapping:0xA70A
 },
 { code:0xA70B
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA70B
  ,simpleLowerCaseMapping:0xA70B
  ,simpleTitleCaseMapping:0xA70B
 },
 { code:0xA70C
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA70C
  ,simpleLowerCaseMapping:0xA70C
  ,simpleTitleCaseMapping:0xA70C
 },
 { code:0xA70D
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA70D
  ,simpleLowerCaseMapping:0xA70D
  ,simpleTitleCaseMapping:0xA70D
 },
 { code:0xA70E
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA70E
  ,simpleLowerCaseMapping:0xA70E
  ,simpleTitleCaseMapping:0xA70E
 },
 { code:0xA70F
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA70F
  ,simpleLowerCaseMapping:0xA70F
  ,simpleTitleCaseMapping:0xA70F
 },
 { code:0xA710
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA710
  ,simpleLowerCaseMapping:0xA710
  ,simpleTitleCaseMapping:0xA710
 },
 { code:0xA711
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA711
  ,simpleLowerCaseMapping:0xA711
  ,simpleTitleCaseMapping:0xA711
 },
 { code:0xA712
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA712
  ,simpleLowerCaseMapping:0xA712
  ,simpleTitleCaseMapping:0xA712
 },
 { code:0xA713
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA713
  ,simpleLowerCaseMapping:0xA713
  ,simpleTitleCaseMapping:0xA713
 },
 { code:0xA714
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA714
  ,simpleLowerCaseMapping:0xA714
  ,simpleTitleCaseMapping:0xA714
 },
 { code:0xA715
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA715
  ,simpleLowerCaseMapping:0xA715
  ,simpleTitleCaseMapping:0xA715
 },
 { code:0xA716
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA716
  ,simpleLowerCaseMapping:0xA716
  ,simpleTitleCaseMapping:0xA716
 },
 { code:0xA717
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0xA717
  ,simpleLowerCaseMapping:0xA717
  ,simpleTitleCaseMapping:0xA717
 },
 { code:0xA718
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0xA718
  ,simpleLowerCaseMapping:0xA718
  ,simpleTitleCaseMapping:0xA718
 },
 { code:0xA719
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0xA719
  ,simpleLowerCaseMapping:0xA719
  ,simpleTitleCaseMapping:0xA719
 },
 { code:0xA71A
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0xA71A
  ,simpleLowerCaseMapping:0xA71A
  ,simpleTitleCaseMapping:0xA71A
 },
 { code:0xA720
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA720
  ,simpleLowerCaseMapping:0xA720
  ,simpleTitleCaseMapping:0xA720
 },
 { code:0xA721
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xA721
  ,simpleLowerCaseMapping:0xA721
  ,simpleTitleCaseMapping:0xA721
 },
 { code:0xA800
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA800
  ,simpleLowerCaseMapping:0xA800
  ,simpleTitleCaseMapping:0xA800
 },
 { code:0xA801
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA801
  ,simpleLowerCaseMapping:0xA801
  ,simpleTitleCaseMapping:0xA801
 },
 { code:0xA802
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0xA802
  ,simpleLowerCaseMapping:0xA802
  ,simpleTitleCaseMapping:0xA802
 },
 { code:0xA803
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA803
  ,simpleLowerCaseMapping:0xA803
  ,simpleTitleCaseMapping:0xA803
 },
 { code:0xA804
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA804
  ,simpleLowerCaseMapping:0xA804
  ,simpleTitleCaseMapping:0xA804
 },
 { code:0xA805
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA805
  ,simpleLowerCaseMapping:0xA805
  ,simpleTitleCaseMapping:0xA805
 },
 { code:0xA806
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xA806
  ,simpleLowerCaseMapping:0xA806
  ,simpleTitleCaseMapping:0xA806
 },
 { code:0xA807
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA807
  ,simpleLowerCaseMapping:0xA807
  ,simpleTitleCaseMapping:0xA807
 },
 { code:0xA808
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA808
  ,simpleLowerCaseMapping:0xA808
  ,simpleTitleCaseMapping:0xA808
 },
 { code:0xA809
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA809
  ,simpleLowerCaseMapping:0xA809
  ,simpleTitleCaseMapping:0xA809
 },
 { code:0xA80A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA80A
  ,simpleLowerCaseMapping:0xA80A
  ,simpleTitleCaseMapping:0xA80A
 },
 { code:0xA80B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xA80B
  ,simpleLowerCaseMapping:0xA80B
  ,simpleTitleCaseMapping:0xA80B
 },
 { code:0xA80C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA80C
  ,simpleLowerCaseMapping:0xA80C
  ,simpleTitleCaseMapping:0xA80C
 },
 { code:0xA80D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA80D
  ,simpleLowerCaseMapping:0xA80D
  ,simpleTitleCaseMapping:0xA80D
 },
 { code:0xA80E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA80E
  ,simpleLowerCaseMapping:0xA80E
  ,simpleTitleCaseMapping:0xA80E
 },
 { code:0xA80F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA80F
  ,simpleLowerCaseMapping:0xA80F
  ,simpleTitleCaseMapping:0xA80F
 },
 { code:0xA810
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA810
  ,simpleLowerCaseMapping:0xA810
  ,simpleTitleCaseMapping:0xA810
 },
 { code:0xA811
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA811
  ,simpleLowerCaseMapping:0xA811
  ,simpleTitleCaseMapping:0xA811
 },
 { code:0xA812
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA812
  ,simpleLowerCaseMapping:0xA812
  ,simpleTitleCaseMapping:0xA812
 },
 { code:0xA813
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA813
  ,simpleLowerCaseMapping:0xA813
  ,simpleTitleCaseMapping:0xA813
 },
 { code:0xA814
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA814
  ,simpleLowerCaseMapping:0xA814
  ,simpleTitleCaseMapping:0xA814
 },
 { code:0xA815
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA815
  ,simpleLowerCaseMapping:0xA815
  ,simpleTitleCaseMapping:0xA815
 },
 { code:0xA816
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA816
  ,simpleLowerCaseMapping:0xA816
  ,simpleTitleCaseMapping:0xA816
 },
 { code:0xA817
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA817
  ,simpleLowerCaseMapping:0xA817
  ,simpleTitleCaseMapping:0xA817
 },
 { code:0xA818
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA818
  ,simpleLowerCaseMapping:0xA818
  ,simpleTitleCaseMapping:0xA818
 },
 { code:0xA819
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA819
  ,simpleLowerCaseMapping:0xA819
  ,simpleTitleCaseMapping:0xA819
 },
 { code:0xA81A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA81A
  ,simpleLowerCaseMapping:0xA81A
  ,simpleTitleCaseMapping:0xA81A
 },
 { code:0xA81B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA81B
  ,simpleLowerCaseMapping:0xA81B
  ,simpleTitleCaseMapping:0xA81B
 },
 { code:0xA81C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA81C
  ,simpleLowerCaseMapping:0xA81C
  ,simpleTitleCaseMapping:0xA81C
 },
 { code:0xA81D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA81D
  ,simpleLowerCaseMapping:0xA81D
  ,simpleTitleCaseMapping:0xA81D
 },
 { code:0xA81E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA81E
  ,simpleLowerCaseMapping:0xA81E
  ,simpleTitleCaseMapping:0xA81E
 },
 { code:0xA81F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA81F
  ,simpleLowerCaseMapping:0xA81F
  ,simpleTitleCaseMapping:0xA81F
 },
 { code:0xA820
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA820
  ,simpleLowerCaseMapping:0xA820
  ,simpleTitleCaseMapping:0xA820
 },
 { code:0xA821
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA821
  ,simpleLowerCaseMapping:0xA821
  ,simpleTitleCaseMapping:0xA821
 },
 { code:0xA822
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA822
  ,simpleLowerCaseMapping:0xA822
  ,simpleTitleCaseMapping:0xA822
 },
 { code:0xA823
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0xA823
  ,simpleLowerCaseMapping:0xA823
  ,simpleTitleCaseMapping:0xA823
 },
 { code:0xA824
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0xA824
  ,simpleLowerCaseMapping:0xA824
  ,simpleTitleCaseMapping:0xA824
 },
 { code:0xA825
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xA825
  ,simpleLowerCaseMapping:0xA825
  ,simpleTitleCaseMapping:0xA825
 },
 { code:0xA826
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xA826
  ,simpleLowerCaseMapping:0xA826
  ,simpleTitleCaseMapping:0xA826
 },
 { code:0xA827
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0xA827
  ,simpleLowerCaseMapping:0xA827
  ,simpleTitleCaseMapping:0xA827
 },
 { code:0xA828
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA828
  ,simpleLowerCaseMapping:0xA828
  ,simpleTitleCaseMapping:0xA828
 },
 { code:0xA829
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA829
  ,simpleLowerCaseMapping:0xA829
  ,simpleTitleCaseMapping:0xA829
 },
 { code:0xA82A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA82A
  ,simpleLowerCaseMapping:0xA82A
  ,simpleTitleCaseMapping:0xA82A
 },
 { code:0xA82B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xA82B
  ,simpleLowerCaseMapping:0xA82B
  ,simpleTitleCaseMapping:0xA82B
 },
 { code:0xA840
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA840
  ,simpleLowerCaseMapping:0xA840
  ,simpleTitleCaseMapping:0xA840
 },
 { code:0xA841
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA841
  ,simpleLowerCaseMapping:0xA841
  ,simpleTitleCaseMapping:0xA841
 },
 { code:0xA842
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA842
  ,simpleLowerCaseMapping:0xA842
  ,simpleTitleCaseMapping:0xA842
 },
 { code:0xA843
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA843
  ,simpleLowerCaseMapping:0xA843
  ,simpleTitleCaseMapping:0xA843
 },
 { code:0xA844
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA844
  ,simpleLowerCaseMapping:0xA844
  ,simpleTitleCaseMapping:0xA844
 },
 { code:0xA845
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA845
  ,simpleLowerCaseMapping:0xA845
  ,simpleTitleCaseMapping:0xA845
 },
 { code:0xA846
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA846
  ,simpleLowerCaseMapping:0xA846
  ,simpleTitleCaseMapping:0xA846
 },
 { code:0xA847
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA847
  ,simpleLowerCaseMapping:0xA847
  ,simpleTitleCaseMapping:0xA847
 },
 { code:0xA848
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA848
  ,simpleLowerCaseMapping:0xA848
  ,simpleTitleCaseMapping:0xA848
 },
 { code:0xA849
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA849
  ,simpleLowerCaseMapping:0xA849
  ,simpleTitleCaseMapping:0xA849
 },
 { code:0xA84A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA84A
  ,simpleLowerCaseMapping:0xA84A
  ,simpleTitleCaseMapping:0xA84A
 },
 { code:0xA84B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA84B
  ,simpleLowerCaseMapping:0xA84B
  ,simpleTitleCaseMapping:0xA84B
 },
 { code:0xA84C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA84C
  ,simpleLowerCaseMapping:0xA84C
  ,simpleTitleCaseMapping:0xA84C
 },
 { code:0xA84D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA84D
  ,simpleLowerCaseMapping:0xA84D
  ,simpleTitleCaseMapping:0xA84D
 },
 { code:0xA84E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA84E
  ,simpleLowerCaseMapping:0xA84E
  ,simpleTitleCaseMapping:0xA84E
 },
 { code:0xA84F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA84F
  ,simpleLowerCaseMapping:0xA84F
  ,simpleTitleCaseMapping:0xA84F
 },
 { code:0xA850
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA850
  ,simpleLowerCaseMapping:0xA850
  ,simpleTitleCaseMapping:0xA850
 },
 { code:0xA851
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA851
  ,simpleLowerCaseMapping:0xA851
  ,simpleTitleCaseMapping:0xA851
 },
 { code:0xA852
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA852
  ,simpleLowerCaseMapping:0xA852
  ,simpleTitleCaseMapping:0xA852
 },
 { code:0xA853
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA853
  ,simpleLowerCaseMapping:0xA853
  ,simpleTitleCaseMapping:0xA853
 },
 { code:0xA854
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA854
  ,simpleLowerCaseMapping:0xA854
  ,simpleTitleCaseMapping:0xA854
 },
 { code:0xA855
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA855
  ,simpleLowerCaseMapping:0xA855
  ,simpleTitleCaseMapping:0xA855
 },
 { code:0xA856
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA856
  ,simpleLowerCaseMapping:0xA856
  ,simpleTitleCaseMapping:0xA856
 },
 { code:0xA857
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA857
  ,simpleLowerCaseMapping:0xA857
  ,simpleTitleCaseMapping:0xA857
 },
 { code:0xA858
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA858
  ,simpleLowerCaseMapping:0xA858
  ,simpleTitleCaseMapping:0xA858
 },
 { code:0xA859
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA859
  ,simpleLowerCaseMapping:0xA859
  ,simpleTitleCaseMapping:0xA859
 },
 { code:0xA85A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA85A
  ,simpleLowerCaseMapping:0xA85A
  ,simpleTitleCaseMapping:0xA85A
 },
 { code:0xA85B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA85B
  ,simpleLowerCaseMapping:0xA85B
  ,simpleTitleCaseMapping:0xA85B
 },
 { code:0xA85C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA85C
  ,simpleLowerCaseMapping:0xA85C
  ,simpleTitleCaseMapping:0xA85C
 },
 { code:0xA85D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA85D
  ,simpleLowerCaseMapping:0xA85D
  ,simpleTitleCaseMapping:0xA85D
 },
 { code:0xA85E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA85E
  ,simpleLowerCaseMapping:0xA85E
  ,simpleTitleCaseMapping:0xA85E
 },
 { code:0xA85F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA85F
  ,simpleLowerCaseMapping:0xA85F
  ,simpleTitleCaseMapping:0xA85F
 },
 { code:0xA860
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA860
  ,simpleLowerCaseMapping:0xA860
  ,simpleTitleCaseMapping:0xA860
 },
 { code:0xA861
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA861
  ,simpleLowerCaseMapping:0xA861
  ,simpleTitleCaseMapping:0xA861
 },
 { code:0xA862
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA862
  ,simpleLowerCaseMapping:0xA862
  ,simpleTitleCaseMapping:0xA862
 },
 { code:0xA863
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA863
  ,simpleLowerCaseMapping:0xA863
  ,simpleTitleCaseMapping:0xA863
 },
 { code:0xA864
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA864
  ,simpleLowerCaseMapping:0xA864
  ,simpleTitleCaseMapping:0xA864
 },
 { code:0xA865
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA865
  ,simpleLowerCaseMapping:0xA865
  ,simpleTitleCaseMapping:0xA865
 },
 { code:0xA866
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA866
  ,simpleLowerCaseMapping:0xA866
  ,simpleTitleCaseMapping:0xA866
 },
 { code:0xA867
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA867
  ,simpleLowerCaseMapping:0xA867
  ,simpleTitleCaseMapping:0xA867
 },
 { code:0xA868
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA868
  ,simpleLowerCaseMapping:0xA868
  ,simpleTitleCaseMapping:0xA868
 },
 { code:0xA869
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA869
  ,simpleLowerCaseMapping:0xA869
  ,simpleTitleCaseMapping:0xA869
 },
 { code:0xA86A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA86A
  ,simpleLowerCaseMapping:0xA86A
  ,simpleTitleCaseMapping:0xA86A
 },
 { code:0xA86B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA86B
  ,simpleLowerCaseMapping:0xA86B
  ,simpleTitleCaseMapping:0xA86B
 },
 { code:0xA86C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA86C
  ,simpleLowerCaseMapping:0xA86C
  ,simpleTitleCaseMapping:0xA86C
 },
 { code:0xA86D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA86D
  ,simpleLowerCaseMapping:0xA86D
  ,simpleTitleCaseMapping:0xA86D
 },
 { code:0xA86E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA86E
  ,simpleLowerCaseMapping:0xA86E
  ,simpleTitleCaseMapping:0xA86E
 },
 { code:0xA86F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA86F
  ,simpleLowerCaseMapping:0xA86F
  ,simpleTitleCaseMapping:0xA86F
 },
 { code:0xA870
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA870
  ,simpleLowerCaseMapping:0xA870
  ,simpleTitleCaseMapping:0xA870
 },
 { code:0xA871
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA871
  ,simpleLowerCaseMapping:0xA871
  ,simpleTitleCaseMapping:0xA871
 },
 { code:0xA872
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA872
  ,simpleLowerCaseMapping:0xA872
  ,simpleTitleCaseMapping:0xA872
 },
 { code:0xA873
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xA873
  ,simpleLowerCaseMapping:0xA873
  ,simpleTitleCaseMapping:0xA873
 },
 { code:0xA874
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xA874
  ,simpleLowerCaseMapping:0xA874
  ,simpleTitleCaseMapping:0xA874
 },
 { code:0xA875
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xA875
  ,simpleLowerCaseMapping:0xA875
  ,simpleTitleCaseMapping:0xA875
 },
 { code:0xA876
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xA876
  ,simpleLowerCaseMapping:0xA876
  ,simpleTitleCaseMapping:0xA876
 },
 { code:0xA877
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xA877
  ,simpleLowerCaseMapping:0xA877
  ,simpleTitleCaseMapping:0xA877
 },
 { code:0xAC00
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xAC00
  ,simpleLowerCaseMapping:0xAC00
  ,simpleTitleCaseMapping:0xAC00
 },
 { code:0xD7A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xD7A3
  ,simpleLowerCaseMapping:0xD7A3
  ,simpleTitleCaseMapping:0xD7A3
 },
 { code:0xD800
  ,generalCategory:UnicodeData.GeneralCategory.Cs
  ,simpleUpperCaseMapping:0xD800
  ,simpleLowerCaseMapping:0xD800
  ,simpleTitleCaseMapping:0xD800
 },
 { code:0xDB7F
  ,generalCategory:UnicodeData.GeneralCategory.Cs
  ,simpleUpperCaseMapping:0xDB7F
  ,simpleLowerCaseMapping:0xDB7F
  ,simpleTitleCaseMapping:0xDB7F
 },
 { code:0xDB80
  ,generalCategory:UnicodeData.GeneralCategory.Cs
  ,simpleUpperCaseMapping:0xDB80
  ,simpleLowerCaseMapping:0xDB80
  ,simpleTitleCaseMapping:0xDB80
 },
 { code:0xDBFF
  ,generalCategory:UnicodeData.GeneralCategory.Cs
  ,simpleUpperCaseMapping:0xDBFF
  ,simpleLowerCaseMapping:0xDBFF
  ,simpleTitleCaseMapping:0xDBFF
 },
 { code:0xDC00
  ,generalCategory:UnicodeData.GeneralCategory.Cs
  ,simpleUpperCaseMapping:0xDC00
  ,simpleLowerCaseMapping:0xDC00
  ,simpleTitleCaseMapping:0xDC00
 },
 { code:0xDFFF
  ,generalCategory:UnicodeData.GeneralCategory.Cs
  ,simpleUpperCaseMapping:0xDFFF
  ,simpleLowerCaseMapping:0xDFFF
  ,simpleTitleCaseMapping:0xDFFF
 },
 { code:0xE000
  ,generalCategory:UnicodeData.GeneralCategory.Co
  ,simpleUpperCaseMapping:0xE000
  ,simpleLowerCaseMapping:0xE000
  ,simpleTitleCaseMapping:0xE000
 },
 { code:0xF8FF
  ,generalCategory:UnicodeData.GeneralCategory.Co
  ,simpleUpperCaseMapping:0xF8FF
  ,simpleLowerCaseMapping:0xF8FF
  ,simpleTitleCaseMapping:0xF8FF
 },
 { code:0xF900
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF900
  ,simpleLowerCaseMapping:0xF900
  ,simpleTitleCaseMapping:0xF900
 },
 { code:0xF901
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF901
  ,simpleLowerCaseMapping:0xF901
  ,simpleTitleCaseMapping:0xF901
 },
 { code:0xF902
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF902
  ,simpleLowerCaseMapping:0xF902
  ,simpleTitleCaseMapping:0xF902
 },
 { code:0xF903
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF903
  ,simpleLowerCaseMapping:0xF903
  ,simpleTitleCaseMapping:0xF903
 },
 { code:0xF904
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF904
  ,simpleLowerCaseMapping:0xF904
  ,simpleTitleCaseMapping:0xF904
 },
 { code:0xF905
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF905
  ,simpleLowerCaseMapping:0xF905
  ,simpleTitleCaseMapping:0xF905
 },
 { code:0xF906
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF906
  ,simpleLowerCaseMapping:0xF906
  ,simpleTitleCaseMapping:0xF906
 },
 { code:0xF907
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF907
  ,simpleLowerCaseMapping:0xF907
  ,simpleTitleCaseMapping:0xF907
 },
 { code:0xF908
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF908
  ,simpleLowerCaseMapping:0xF908
  ,simpleTitleCaseMapping:0xF908
 },
 { code:0xF909
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF909
  ,simpleLowerCaseMapping:0xF909
  ,simpleTitleCaseMapping:0xF909
 },
 { code:0xF90A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF90A
  ,simpleLowerCaseMapping:0xF90A
  ,simpleTitleCaseMapping:0xF90A
 },
 { code:0xF90B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF90B
  ,simpleLowerCaseMapping:0xF90B
  ,simpleTitleCaseMapping:0xF90B
 },
 { code:0xF90C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF90C
  ,simpleLowerCaseMapping:0xF90C
  ,simpleTitleCaseMapping:0xF90C
 },
 { code:0xF90D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF90D
  ,simpleLowerCaseMapping:0xF90D
  ,simpleTitleCaseMapping:0xF90D
 },
 { code:0xF90E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF90E
  ,simpleLowerCaseMapping:0xF90E
  ,simpleTitleCaseMapping:0xF90E
 },
 { code:0xF90F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF90F
  ,simpleLowerCaseMapping:0xF90F
  ,simpleTitleCaseMapping:0xF90F
 },
 { code:0xF910
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF910
  ,simpleLowerCaseMapping:0xF910
  ,simpleTitleCaseMapping:0xF910
 },
 { code:0xF911
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF911
  ,simpleLowerCaseMapping:0xF911
  ,simpleTitleCaseMapping:0xF911
 },
 { code:0xF912
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF912
  ,simpleLowerCaseMapping:0xF912
  ,simpleTitleCaseMapping:0xF912
 },
 { code:0xF913
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF913
  ,simpleLowerCaseMapping:0xF913
  ,simpleTitleCaseMapping:0xF913
 },
 { code:0xF914
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF914
  ,simpleLowerCaseMapping:0xF914
  ,simpleTitleCaseMapping:0xF914
 },
 { code:0xF915
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF915
  ,simpleLowerCaseMapping:0xF915
  ,simpleTitleCaseMapping:0xF915
 },
 { code:0xF916
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF916
  ,simpleLowerCaseMapping:0xF916
  ,simpleTitleCaseMapping:0xF916
 },
 { code:0xF917
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF917
  ,simpleLowerCaseMapping:0xF917
  ,simpleTitleCaseMapping:0xF917
 },
 { code:0xF918
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF918
  ,simpleLowerCaseMapping:0xF918
  ,simpleTitleCaseMapping:0xF918
 },
 { code:0xF919
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF919
  ,simpleLowerCaseMapping:0xF919
  ,simpleTitleCaseMapping:0xF919
 },
 { code:0xF91A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF91A
  ,simpleLowerCaseMapping:0xF91A
  ,simpleTitleCaseMapping:0xF91A
 },
 { code:0xF91B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF91B
  ,simpleLowerCaseMapping:0xF91B
  ,simpleTitleCaseMapping:0xF91B
 },
 { code:0xF91C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF91C
  ,simpleLowerCaseMapping:0xF91C
  ,simpleTitleCaseMapping:0xF91C
 },
 { code:0xF91D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF91D
  ,simpleLowerCaseMapping:0xF91D
  ,simpleTitleCaseMapping:0xF91D
 },
 { code:0xF91E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF91E
  ,simpleLowerCaseMapping:0xF91E
  ,simpleTitleCaseMapping:0xF91E
 },
 { code:0xF91F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF91F
  ,simpleLowerCaseMapping:0xF91F
  ,simpleTitleCaseMapping:0xF91F
 },
 { code:0xF920
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF920
  ,simpleLowerCaseMapping:0xF920
  ,simpleTitleCaseMapping:0xF920
 },
 { code:0xF921
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF921
  ,simpleLowerCaseMapping:0xF921
  ,simpleTitleCaseMapping:0xF921
 },
 { code:0xF922
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF922
  ,simpleLowerCaseMapping:0xF922
  ,simpleTitleCaseMapping:0xF922
 },
 { code:0xF923
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF923
  ,simpleLowerCaseMapping:0xF923
  ,simpleTitleCaseMapping:0xF923
 },
 { code:0xF924
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF924
  ,simpleLowerCaseMapping:0xF924
  ,simpleTitleCaseMapping:0xF924
 },
 { code:0xF925
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF925
  ,simpleLowerCaseMapping:0xF925
  ,simpleTitleCaseMapping:0xF925
 },
 { code:0xF926
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF926
  ,simpleLowerCaseMapping:0xF926
  ,simpleTitleCaseMapping:0xF926
 },
 { code:0xF927
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF927
  ,simpleLowerCaseMapping:0xF927
  ,simpleTitleCaseMapping:0xF927
 },
 { code:0xF928
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF928
  ,simpleLowerCaseMapping:0xF928
  ,simpleTitleCaseMapping:0xF928
 },
 { code:0xF929
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF929
  ,simpleLowerCaseMapping:0xF929
  ,simpleTitleCaseMapping:0xF929
 },
 { code:0xF92A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF92A
  ,simpleLowerCaseMapping:0xF92A
  ,simpleTitleCaseMapping:0xF92A
 },
 { code:0xF92B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF92B
  ,simpleLowerCaseMapping:0xF92B
  ,simpleTitleCaseMapping:0xF92B
 },
 { code:0xF92C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF92C
  ,simpleLowerCaseMapping:0xF92C
  ,simpleTitleCaseMapping:0xF92C
 },
 { code:0xF92D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF92D
  ,simpleLowerCaseMapping:0xF92D
  ,simpleTitleCaseMapping:0xF92D
 },
 { code:0xF92E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF92E
  ,simpleLowerCaseMapping:0xF92E
  ,simpleTitleCaseMapping:0xF92E
 },
 { code:0xF92F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF92F
  ,simpleLowerCaseMapping:0xF92F
  ,simpleTitleCaseMapping:0xF92F
 },
 { code:0xF930
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF930
  ,simpleLowerCaseMapping:0xF930
  ,simpleTitleCaseMapping:0xF930
 },
 { code:0xF931
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF931
  ,simpleLowerCaseMapping:0xF931
  ,simpleTitleCaseMapping:0xF931
 },
 { code:0xF932
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF932
  ,simpleLowerCaseMapping:0xF932
  ,simpleTitleCaseMapping:0xF932
 },
 { code:0xF933
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF933
  ,simpleLowerCaseMapping:0xF933
  ,simpleTitleCaseMapping:0xF933
 },
 { code:0xF934
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF934
  ,simpleLowerCaseMapping:0xF934
  ,simpleTitleCaseMapping:0xF934
 },
 { code:0xF935
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF935
  ,simpleLowerCaseMapping:0xF935
  ,simpleTitleCaseMapping:0xF935
 },
 { code:0xF936
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF936
  ,simpleLowerCaseMapping:0xF936
  ,simpleTitleCaseMapping:0xF936
 },
 { code:0xF937
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF937
  ,simpleLowerCaseMapping:0xF937
  ,simpleTitleCaseMapping:0xF937
 },
 { code:0xF938
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF938
  ,simpleLowerCaseMapping:0xF938
  ,simpleTitleCaseMapping:0xF938
 },
 { code:0xF939
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF939
  ,simpleLowerCaseMapping:0xF939
  ,simpleTitleCaseMapping:0xF939
 },
 { code:0xF93A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF93A
  ,simpleLowerCaseMapping:0xF93A
  ,simpleTitleCaseMapping:0xF93A
 },
 { code:0xF93B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF93B
  ,simpleLowerCaseMapping:0xF93B
  ,simpleTitleCaseMapping:0xF93B
 },
 { code:0xF93C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF93C
  ,simpleLowerCaseMapping:0xF93C
  ,simpleTitleCaseMapping:0xF93C
 },
 { code:0xF93D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF93D
  ,simpleLowerCaseMapping:0xF93D
  ,simpleTitleCaseMapping:0xF93D
 },
 { code:0xF93E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF93E
  ,simpleLowerCaseMapping:0xF93E
  ,simpleTitleCaseMapping:0xF93E
 },
 { code:0xF93F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF93F
  ,simpleLowerCaseMapping:0xF93F
  ,simpleTitleCaseMapping:0xF93F
 },
 { code:0xF940
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF940
  ,simpleLowerCaseMapping:0xF940
  ,simpleTitleCaseMapping:0xF940
 },
 { code:0xF941
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF941
  ,simpleLowerCaseMapping:0xF941
  ,simpleTitleCaseMapping:0xF941
 },
 { code:0xF942
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF942
  ,simpleLowerCaseMapping:0xF942
  ,simpleTitleCaseMapping:0xF942
 },
 { code:0xF943
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF943
  ,simpleLowerCaseMapping:0xF943
  ,simpleTitleCaseMapping:0xF943
 },
 { code:0xF944
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF944
  ,simpleLowerCaseMapping:0xF944
  ,simpleTitleCaseMapping:0xF944
 },
 { code:0xF945
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF945
  ,simpleLowerCaseMapping:0xF945
  ,simpleTitleCaseMapping:0xF945
 },
 { code:0xF946
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF946
  ,simpleLowerCaseMapping:0xF946
  ,simpleTitleCaseMapping:0xF946
 },
 { code:0xF947
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF947
  ,simpleLowerCaseMapping:0xF947
  ,simpleTitleCaseMapping:0xF947
 },
 { code:0xF948
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF948
  ,simpleLowerCaseMapping:0xF948
  ,simpleTitleCaseMapping:0xF948
 },
 { code:0xF949
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF949
  ,simpleLowerCaseMapping:0xF949
  ,simpleTitleCaseMapping:0xF949
 },
 { code:0xF94A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF94A
  ,simpleLowerCaseMapping:0xF94A
  ,simpleTitleCaseMapping:0xF94A
 },
 { code:0xF94B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF94B
  ,simpleLowerCaseMapping:0xF94B
  ,simpleTitleCaseMapping:0xF94B
 },
 { code:0xF94C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF94C
  ,simpleLowerCaseMapping:0xF94C
  ,simpleTitleCaseMapping:0xF94C
 },
 { code:0xF94D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF94D
  ,simpleLowerCaseMapping:0xF94D
  ,simpleTitleCaseMapping:0xF94D
 },
 { code:0xF94E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF94E
  ,simpleLowerCaseMapping:0xF94E
  ,simpleTitleCaseMapping:0xF94E
 },
 { code:0xF94F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF94F
  ,simpleLowerCaseMapping:0xF94F
  ,simpleTitleCaseMapping:0xF94F
 },
 { code:0xF950
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF950
  ,simpleLowerCaseMapping:0xF950
  ,simpleTitleCaseMapping:0xF950
 },
 { code:0xF951
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF951
  ,simpleLowerCaseMapping:0xF951
  ,simpleTitleCaseMapping:0xF951
 },
 { code:0xF952
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF952
  ,simpleLowerCaseMapping:0xF952
  ,simpleTitleCaseMapping:0xF952
 },
 { code:0xF953
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF953
  ,simpleLowerCaseMapping:0xF953
  ,simpleTitleCaseMapping:0xF953
 },
 { code:0xF954
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF954
  ,simpleLowerCaseMapping:0xF954
  ,simpleTitleCaseMapping:0xF954
 },
 { code:0xF955
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF955
  ,simpleLowerCaseMapping:0xF955
  ,simpleTitleCaseMapping:0xF955
 },
 { code:0xF956
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF956
  ,simpleLowerCaseMapping:0xF956
  ,simpleTitleCaseMapping:0xF956
 },
 { code:0xF957
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF957
  ,simpleLowerCaseMapping:0xF957
  ,simpleTitleCaseMapping:0xF957
 },
 { code:0xF958
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF958
  ,simpleLowerCaseMapping:0xF958
  ,simpleTitleCaseMapping:0xF958
 },
 { code:0xF959
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF959
  ,simpleLowerCaseMapping:0xF959
  ,simpleTitleCaseMapping:0xF959
 },
 { code:0xF95A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF95A
  ,simpleLowerCaseMapping:0xF95A
  ,simpleTitleCaseMapping:0xF95A
 },
 { code:0xF95B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF95B
  ,simpleLowerCaseMapping:0xF95B
  ,simpleTitleCaseMapping:0xF95B
 },
 { code:0xF95C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF95C
  ,simpleLowerCaseMapping:0xF95C
  ,simpleTitleCaseMapping:0xF95C
 },
 { code:0xF95D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF95D
  ,simpleLowerCaseMapping:0xF95D
  ,simpleTitleCaseMapping:0xF95D
 },
 { code:0xF95E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF95E
  ,simpleLowerCaseMapping:0xF95E
  ,simpleTitleCaseMapping:0xF95E
 },
 { code:0xF95F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF95F
  ,simpleLowerCaseMapping:0xF95F
  ,simpleTitleCaseMapping:0xF95F
 },
 { code:0xF960
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF960
  ,simpleLowerCaseMapping:0xF960
  ,simpleTitleCaseMapping:0xF960
 },
 { code:0xF961
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF961
  ,simpleLowerCaseMapping:0xF961
  ,simpleTitleCaseMapping:0xF961
 },
 { code:0xF962
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF962
  ,simpleLowerCaseMapping:0xF962
  ,simpleTitleCaseMapping:0xF962
 },
 { code:0xF963
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF963
  ,simpleLowerCaseMapping:0xF963
  ,simpleTitleCaseMapping:0xF963
 },
 { code:0xF964
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF964
  ,simpleLowerCaseMapping:0xF964
  ,simpleTitleCaseMapping:0xF964
 },
 { code:0xF965
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF965
  ,simpleLowerCaseMapping:0xF965
  ,simpleTitleCaseMapping:0xF965
 },
 { code:0xF966
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF966
  ,simpleLowerCaseMapping:0xF966
  ,simpleTitleCaseMapping:0xF966
 },
 { code:0xF967
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF967
  ,simpleLowerCaseMapping:0xF967
  ,simpleTitleCaseMapping:0xF967
 },
 { code:0xF968
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF968
  ,simpleLowerCaseMapping:0xF968
  ,simpleTitleCaseMapping:0xF968
 },
 { code:0xF969
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF969
  ,simpleLowerCaseMapping:0xF969
  ,simpleTitleCaseMapping:0xF969
 },
 { code:0xF96A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF96A
  ,simpleLowerCaseMapping:0xF96A
  ,simpleTitleCaseMapping:0xF96A
 },
 { code:0xF96B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF96B
  ,simpleLowerCaseMapping:0xF96B
  ,simpleTitleCaseMapping:0xF96B
 },
 { code:0xF96C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF96C
  ,simpleLowerCaseMapping:0xF96C
  ,simpleTitleCaseMapping:0xF96C
 },
 { code:0xF96D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF96D
  ,simpleLowerCaseMapping:0xF96D
  ,simpleTitleCaseMapping:0xF96D
 },
 { code:0xF96E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF96E
  ,simpleLowerCaseMapping:0xF96E
  ,simpleTitleCaseMapping:0xF96E
 },
 { code:0xF96F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF96F
  ,simpleLowerCaseMapping:0xF96F
  ,simpleTitleCaseMapping:0xF96F
 },
 { code:0xF970
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF970
  ,simpleLowerCaseMapping:0xF970
  ,simpleTitleCaseMapping:0xF970
 },
 { code:0xF971
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF971
  ,simpleLowerCaseMapping:0xF971
  ,simpleTitleCaseMapping:0xF971
 },
 { code:0xF972
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF972
  ,simpleLowerCaseMapping:0xF972
  ,simpleTitleCaseMapping:0xF972
 },
 { code:0xF973
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF973
  ,simpleLowerCaseMapping:0xF973
  ,simpleTitleCaseMapping:0xF973
 },
 { code:0xF974
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF974
  ,simpleLowerCaseMapping:0xF974
  ,simpleTitleCaseMapping:0xF974
 },
 { code:0xF975
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF975
  ,simpleLowerCaseMapping:0xF975
  ,simpleTitleCaseMapping:0xF975
 },
 { code:0xF976
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF976
  ,simpleLowerCaseMapping:0xF976
  ,simpleTitleCaseMapping:0xF976
 },
 { code:0xF977
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF977
  ,simpleLowerCaseMapping:0xF977
  ,simpleTitleCaseMapping:0xF977
 },
 { code:0xF978
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF978
  ,simpleLowerCaseMapping:0xF978
  ,simpleTitleCaseMapping:0xF978
 },
 { code:0xF979
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF979
  ,simpleLowerCaseMapping:0xF979
  ,simpleTitleCaseMapping:0xF979
 },
 { code:0xF97A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF97A
  ,simpleLowerCaseMapping:0xF97A
  ,simpleTitleCaseMapping:0xF97A
 },
 { code:0xF97B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF97B
  ,simpleLowerCaseMapping:0xF97B
  ,simpleTitleCaseMapping:0xF97B
 },
 { code:0xF97C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF97C
  ,simpleLowerCaseMapping:0xF97C
  ,simpleTitleCaseMapping:0xF97C
 },
 { code:0xF97D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF97D
  ,simpleLowerCaseMapping:0xF97D
  ,simpleTitleCaseMapping:0xF97D
 },
 { code:0xF97E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF97E
  ,simpleLowerCaseMapping:0xF97E
  ,simpleTitleCaseMapping:0xF97E
 },
 { code:0xF97F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF97F
  ,simpleLowerCaseMapping:0xF97F
  ,simpleTitleCaseMapping:0xF97F
 },
 { code:0xF980
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF980
  ,simpleLowerCaseMapping:0xF980
  ,simpleTitleCaseMapping:0xF980
 },
 { code:0xF981
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF981
  ,simpleLowerCaseMapping:0xF981
  ,simpleTitleCaseMapping:0xF981
 },
 { code:0xF982
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF982
  ,simpleLowerCaseMapping:0xF982
  ,simpleTitleCaseMapping:0xF982
 },
 { code:0xF983
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF983
  ,simpleLowerCaseMapping:0xF983
  ,simpleTitleCaseMapping:0xF983
 },
 { code:0xF984
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF984
  ,simpleLowerCaseMapping:0xF984
  ,simpleTitleCaseMapping:0xF984
 },
 { code:0xF985
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF985
  ,simpleLowerCaseMapping:0xF985
  ,simpleTitleCaseMapping:0xF985
 },
 { code:0xF986
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF986
  ,simpleLowerCaseMapping:0xF986
  ,simpleTitleCaseMapping:0xF986
 },
 { code:0xF987
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF987
  ,simpleLowerCaseMapping:0xF987
  ,simpleTitleCaseMapping:0xF987
 },
 { code:0xF988
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF988
  ,simpleLowerCaseMapping:0xF988
  ,simpleTitleCaseMapping:0xF988
 },
 { code:0xF989
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF989
  ,simpleLowerCaseMapping:0xF989
  ,simpleTitleCaseMapping:0xF989
 },
 { code:0xF98A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF98A
  ,simpleLowerCaseMapping:0xF98A
  ,simpleTitleCaseMapping:0xF98A
 },
 { code:0xF98B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF98B
  ,simpleLowerCaseMapping:0xF98B
  ,simpleTitleCaseMapping:0xF98B
 },
 { code:0xF98C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF98C
  ,simpleLowerCaseMapping:0xF98C
  ,simpleTitleCaseMapping:0xF98C
 },
 { code:0xF98D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF98D
  ,simpleLowerCaseMapping:0xF98D
  ,simpleTitleCaseMapping:0xF98D
 },
 { code:0xF98E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF98E
  ,simpleLowerCaseMapping:0xF98E
  ,simpleTitleCaseMapping:0xF98E
 },
 { code:0xF98F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF98F
  ,simpleLowerCaseMapping:0xF98F
  ,simpleTitleCaseMapping:0xF98F
 },
 { code:0xF990
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF990
  ,simpleLowerCaseMapping:0xF990
  ,simpleTitleCaseMapping:0xF990
 },
 { code:0xF991
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF991
  ,simpleLowerCaseMapping:0xF991
  ,simpleTitleCaseMapping:0xF991
 },
 { code:0xF992
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF992
  ,simpleLowerCaseMapping:0xF992
  ,simpleTitleCaseMapping:0xF992
 },
 { code:0xF993
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF993
  ,simpleLowerCaseMapping:0xF993
  ,simpleTitleCaseMapping:0xF993
 },
 { code:0xF994
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF994
  ,simpleLowerCaseMapping:0xF994
  ,simpleTitleCaseMapping:0xF994
 },
 { code:0xF995
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF995
  ,simpleLowerCaseMapping:0xF995
  ,simpleTitleCaseMapping:0xF995
 },
 { code:0xF996
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF996
  ,simpleLowerCaseMapping:0xF996
  ,simpleTitleCaseMapping:0xF996
 },
 { code:0xF997
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF997
  ,simpleLowerCaseMapping:0xF997
  ,simpleTitleCaseMapping:0xF997
 },
 { code:0xF998
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF998
  ,simpleLowerCaseMapping:0xF998
  ,simpleTitleCaseMapping:0xF998
 },
 { code:0xF999
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF999
  ,simpleLowerCaseMapping:0xF999
  ,simpleTitleCaseMapping:0xF999
 },
 { code:0xF99A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF99A
  ,simpleLowerCaseMapping:0xF99A
  ,simpleTitleCaseMapping:0xF99A
 },
 { code:0xF99B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF99B
  ,simpleLowerCaseMapping:0xF99B
  ,simpleTitleCaseMapping:0xF99B
 },
 { code:0xF99C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF99C
  ,simpleLowerCaseMapping:0xF99C
  ,simpleTitleCaseMapping:0xF99C
 },
 { code:0xF99D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF99D
  ,simpleLowerCaseMapping:0xF99D
  ,simpleTitleCaseMapping:0xF99D
 },
 { code:0xF99E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF99E
  ,simpleLowerCaseMapping:0xF99E
  ,simpleTitleCaseMapping:0xF99E
 },
 { code:0xF99F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF99F
  ,simpleLowerCaseMapping:0xF99F
  ,simpleTitleCaseMapping:0xF99F
 },
 { code:0xF9A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9A0
  ,simpleLowerCaseMapping:0xF9A0
  ,simpleTitleCaseMapping:0xF9A0
 },
 { code:0xF9A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9A1
  ,simpleLowerCaseMapping:0xF9A1
  ,simpleTitleCaseMapping:0xF9A1
 },
 { code:0xF9A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9A2
  ,simpleLowerCaseMapping:0xF9A2
  ,simpleTitleCaseMapping:0xF9A2
 },
 { code:0xF9A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9A3
  ,simpleLowerCaseMapping:0xF9A3
  ,simpleTitleCaseMapping:0xF9A3
 },
 { code:0xF9A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9A4
  ,simpleLowerCaseMapping:0xF9A4
  ,simpleTitleCaseMapping:0xF9A4
 },
 { code:0xF9A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9A5
  ,simpleLowerCaseMapping:0xF9A5
  ,simpleTitleCaseMapping:0xF9A5
 },
 { code:0xF9A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9A6
  ,simpleLowerCaseMapping:0xF9A6
  ,simpleTitleCaseMapping:0xF9A6
 },
 { code:0xF9A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9A7
  ,simpleLowerCaseMapping:0xF9A7
  ,simpleTitleCaseMapping:0xF9A7
 },
 { code:0xF9A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9A8
  ,simpleLowerCaseMapping:0xF9A8
  ,simpleTitleCaseMapping:0xF9A8
 },
 { code:0xF9A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9A9
  ,simpleLowerCaseMapping:0xF9A9
  ,simpleTitleCaseMapping:0xF9A9
 },
 { code:0xF9AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9AA
  ,simpleLowerCaseMapping:0xF9AA
  ,simpleTitleCaseMapping:0xF9AA
 },
 { code:0xF9AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9AB
  ,simpleLowerCaseMapping:0xF9AB
  ,simpleTitleCaseMapping:0xF9AB
 },
 { code:0xF9AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9AC
  ,simpleLowerCaseMapping:0xF9AC
  ,simpleTitleCaseMapping:0xF9AC
 },
 { code:0xF9AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9AD
  ,simpleLowerCaseMapping:0xF9AD
  ,simpleTitleCaseMapping:0xF9AD
 },
 { code:0xF9AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9AE
  ,simpleLowerCaseMapping:0xF9AE
  ,simpleTitleCaseMapping:0xF9AE
 },
 { code:0xF9AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9AF
  ,simpleLowerCaseMapping:0xF9AF
  ,simpleTitleCaseMapping:0xF9AF
 },
 { code:0xF9B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9B0
  ,simpleLowerCaseMapping:0xF9B0
  ,simpleTitleCaseMapping:0xF9B0
 },
 { code:0xF9B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9B1
  ,simpleLowerCaseMapping:0xF9B1
  ,simpleTitleCaseMapping:0xF9B1
 },
 { code:0xF9B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9B2
  ,simpleLowerCaseMapping:0xF9B2
  ,simpleTitleCaseMapping:0xF9B2
 },
 { code:0xF9B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9B3
  ,simpleLowerCaseMapping:0xF9B3
  ,simpleTitleCaseMapping:0xF9B3
 },
 { code:0xF9B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9B4
  ,simpleLowerCaseMapping:0xF9B4
  ,simpleTitleCaseMapping:0xF9B4
 },
 { code:0xF9B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9B5
  ,simpleLowerCaseMapping:0xF9B5
  ,simpleTitleCaseMapping:0xF9B5
 },
 { code:0xF9B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9B6
  ,simpleLowerCaseMapping:0xF9B6
  ,simpleTitleCaseMapping:0xF9B6
 },
 { code:0xF9B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9B7
  ,simpleLowerCaseMapping:0xF9B7
  ,simpleTitleCaseMapping:0xF9B7
 },
 { code:0xF9B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9B8
  ,simpleLowerCaseMapping:0xF9B8
  ,simpleTitleCaseMapping:0xF9B8
 },
 { code:0xF9B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9B9
  ,simpleLowerCaseMapping:0xF9B9
  ,simpleTitleCaseMapping:0xF9B9
 },
 { code:0xF9BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9BA
  ,simpleLowerCaseMapping:0xF9BA
  ,simpleTitleCaseMapping:0xF9BA
 },
 { code:0xF9BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9BB
  ,simpleLowerCaseMapping:0xF9BB
  ,simpleTitleCaseMapping:0xF9BB
 },
 { code:0xF9BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9BC
  ,simpleLowerCaseMapping:0xF9BC
  ,simpleTitleCaseMapping:0xF9BC
 },
 { code:0xF9BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9BD
  ,simpleLowerCaseMapping:0xF9BD
  ,simpleTitleCaseMapping:0xF9BD
 },
 { code:0xF9BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9BE
  ,simpleLowerCaseMapping:0xF9BE
  ,simpleTitleCaseMapping:0xF9BE
 },
 { code:0xF9BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9BF
  ,simpleLowerCaseMapping:0xF9BF
  ,simpleTitleCaseMapping:0xF9BF
 },
 { code:0xF9C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9C0
  ,simpleLowerCaseMapping:0xF9C0
  ,simpleTitleCaseMapping:0xF9C0
 },
 { code:0xF9C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9C1
  ,simpleLowerCaseMapping:0xF9C1
  ,simpleTitleCaseMapping:0xF9C1
 },
 { code:0xF9C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9C2
  ,simpleLowerCaseMapping:0xF9C2
  ,simpleTitleCaseMapping:0xF9C2
 },
 { code:0xF9C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9C3
  ,simpleLowerCaseMapping:0xF9C3
  ,simpleTitleCaseMapping:0xF9C3
 },
 { code:0xF9C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9C4
  ,simpleLowerCaseMapping:0xF9C4
  ,simpleTitleCaseMapping:0xF9C4
 },
 { code:0xF9C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9C5
  ,simpleLowerCaseMapping:0xF9C5
  ,simpleTitleCaseMapping:0xF9C5
 },
 { code:0xF9C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9C6
  ,simpleLowerCaseMapping:0xF9C6
  ,simpleTitleCaseMapping:0xF9C6
 },
 { code:0xF9C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9C7
  ,simpleLowerCaseMapping:0xF9C7
  ,simpleTitleCaseMapping:0xF9C7
 },
 { code:0xF9C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9C8
  ,simpleLowerCaseMapping:0xF9C8
  ,simpleTitleCaseMapping:0xF9C8
 },
 { code:0xF9C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9C9
  ,simpleLowerCaseMapping:0xF9C9
  ,simpleTitleCaseMapping:0xF9C9
 },
 { code:0xF9CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9CA
  ,simpleLowerCaseMapping:0xF9CA
  ,simpleTitleCaseMapping:0xF9CA
 },
 { code:0xF9CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9CB
  ,simpleLowerCaseMapping:0xF9CB
  ,simpleTitleCaseMapping:0xF9CB
 },
 { code:0xF9CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9CC
  ,simpleLowerCaseMapping:0xF9CC
  ,simpleTitleCaseMapping:0xF9CC
 },
 { code:0xF9CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9CD
  ,simpleLowerCaseMapping:0xF9CD
  ,simpleTitleCaseMapping:0xF9CD
 },
 { code:0xF9CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9CE
  ,simpleLowerCaseMapping:0xF9CE
  ,simpleTitleCaseMapping:0xF9CE
 },
 { code:0xF9CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9CF
  ,simpleLowerCaseMapping:0xF9CF
  ,simpleTitleCaseMapping:0xF9CF
 },
 { code:0xF9D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9D0
  ,simpleLowerCaseMapping:0xF9D0
  ,simpleTitleCaseMapping:0xF9D0
 },
 { code:0xF9D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9D1
  ,simpleLowerCaseMapping:0xF9D1
  ,simpleTitleCaseMapping:0xF9D1
 },
 { code:0xF9D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9D2
  ,simpleLowerCaseMapping:0xF9D2
  ,simpleTitleCaseMapping:0xF9D2
 },
 { code:0xF9D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9D3
  ,simpleLowerCaseMapping:0xF9D3
  ,simpleTitleCaseMapping:0xF9D3
 },
 { code:0xF9D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9D4
  ,simpleLowerCaseMapping:0xF9D4
  ,simpleTitleCaseMapping:0xF9D4
 },
 { code:0xF9D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9D5
  ,simpleLowerCaseMapping:0xF9D5
  ,simpleTitleCaseMapping:0xF9D5
 },
 { code:0xF9D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9D6
  ,simpleLowerCaseMapping:0xF9D6
  ,simpleTitleCaseMapping:0xF9D6
 },
 { code:0xF9D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9D7
  ,simpleLowerCaseMapping:0xF9D7
  ,simpleTitleCaseMapping:0xF9D7
 },
 { code:0xF9D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9D8
  ,simpleLowerCaseMapping:0xF9D8
  ,simpleTitleCaseMapping:0xF9D8
 },
 { code:0xF9D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9D9
  ,simpleLowerCaseMapping:0xF9D9
  ,simpleTitleCaseMapping:0xF9D9
 },
 { code:0xF9DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9DA
  ,simpleLowerCaseMapping:0xF9DA
  ,simpleTitleCaseMapping:0xF9DA
 },
 { code:0xF9DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9DB
  ,simpleLowerCaseMapping:0xF9DB
  ,simpleTitleCaseMapping:0xF9DB
 },
 { code:0xF9DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9DC
  ,simpleLowerCaseMapping:0xF9DC
  ,simpleTitleCaseMapping:0xF9DC
 },
 { code:0xF9DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9DD
  ,simpleLowerCaseMapping:0xF9DD
  ,simpleTitleCaseMapping:0xF9DD
 },
 { code:0xF9DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9DE
  ,simpleLowerCaseMapping:0xF9DE
  ,simpleTitleCaseMapping:0xF9DE
 },
 { code:0xF9DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9DF
  ,simpleLowerCaseMapping:0xF9DF
  ,simpleTitleCaseMapping:0xF9DF
 },
 { code:0xF9E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9E0
  ,simpleLowerCaseMapping:0xF9E0
  ,simpleTitleCaseMapping:0xF9E0
 },
 { code:0xF9E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9E1
  ,simpleLowerCaseMapping:0xF9E1
  ,simpleTitleCaseMapping:0xF9E1
 },
 { code:0xF9E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9E2
  ,simpleLowerCaseMapping:0xF9E2
  ,simpleTitleCaseMapping:0xF9E2
 },
 { code:0xF9E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9E3
  ,simpleLowerCaseMapping:0xF9E3
  ,simpleTitleCaseMapping:0xF9E3
 },
 { code:0xF9E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9E4
  ,simpleLowerCaseMapping:0xF9E4
  ,simpleTitleCaseMapping:0xF9E4
 },
 { code:0xF9E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9E5
  ,simpleLowerCaseMapping:0xF9E5
  ,simpleTitleCaseMapping:0xF9E5
 },
 { code:0xF9E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9E6
  ,simpleLowerCaseMapping:0xF9E6
  ,simpleTitleCaseMapping:0xF9E6
 },
 { code:0xF9E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9E7
  ,simpleLowerCaseMapping:0xF9E7
  ,simpleTitleCaseMapping:0xF9E7
 },
 { code:0xF9E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9E8
  ,simpleLowerCaseMapping:0xF9E8
  ,simpleTitleCaseMapping:0xF9E8
 },
 { code:0xF9E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9E9
  ,simpleLowerCaseMapping:0xF9E9
  ,simpleTitleCaseMapping:0xF9E9
 },
 { code:0xF9EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9EA
  ,simpleLowerCaseMapping:0xF9EA
  ,simpleTitleCaseMapping:0xF9EA
 },
 { code:0xF9EB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9EB
  ,simpleLowerCaseMapping:0xF9EB
  ,simpleTitleCaseMapping:0xF9EB
 },
 { code:0xF9EC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9EC
  ,simpleLowerCaseMapping:0xF9EC
  ,simpleTitleCaseMapping:0xF9EC
 },
 { code:0xF9ED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9ED
  ,simpleLowerCaseMapping:0xF9ED
  ,simpleTitleCaseMapping:0xF9ED
 },
 { code:0xF9EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9EE
  ,simpleLowerCaseMapping:0xF9EE
  ,simpleTitleCaseMapping:0xF9EE
 },
 { code:0xF9EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9EF
  ,simpleLowerCaseMapping:0xF9EF
  ,simpleTitleCaseMapping:0xF9EF
 },
 { code:0xF9F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9F0
  ,simpleLowerCaseMapping:0xF9F0
  ,simpleTitleCaseMapping:0xF9F0
 },
 { code:0xF9F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9F1
  ,simpleLowerCaseMapping:0xF9F1
  ,simpleTitleCaseMapping:0xF9F1
 },
 { code:0xF9F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9F2
  ,simpleLowerCaseMapping:0xF9F2
  ,simpleTitleCaseMapping:0xF9F2
 },
 { code:0xF9F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9F3
  ,simpleLowerCaseMapping:0xF9F3
  ,simpleTitleCaseMapping:0xF9F3
 },
 { code:0xF9F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9F4
  ,simpleLowerCaseMapping:0xF9F4
  ,simpleTitleCaseMapping:0xF9F4
 },
 { code:0xF9F5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9F5
  ,simpleLowerCaseMapping:0xF9F5
  ,simpleTitleCaseMapping:0xF9F5
 },
 { code:0xF9F6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9F6
  ,simpleLowerCaseMapping:0xF9F6
  ,simpleTitleCaseMapping:0xF9F6
 },
 { code:0xF9F7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9F7
  ,simpleLowerCaseMapping:0xF9F7
  ,simpleTitleCaseMapping:0xF9F7
 },
 { code:0xF9F8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9F8
  ,simpleLowerCaseMapping:0xF9F8
  ,simpleTitleCaseMapping:0xF9F8
 },
 { code:0xF9F9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9F9
  ,simpleLowerCaseMapping:0xF9F9
  ,simpleTitleCaseMapping:0xF9F9
 },
 { code:0xF9FA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9FA
  ,simpleLowerCaseMapping:0xF9FA
  ,simpleTitleCaseMapping:0xF9FA
 },
 { code:0xF9FB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9FB
  ,simpleLowerCaseMapping:0xF9FB
  ,simpleTitleCaseMapping:0xF9FB
 },
 { code:0xF9FC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9FC
  ,simpleLowerCaseMapping:0xF9FC
  ,simpleTitleCaseMapping:0xF9FC
 },
 { code:0xF9FD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9FD
  ,simpleLowerCaseMapping:0xF9FD
  ,simpleTitleCaseMapping:0xF9FD
 },
 { code:0xF9FE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9FE
  ,simpleLowerCaseMapping:0xF9FE
  ,simpleTitleCaseMapping:0xF9FE
 },
 { code:0xF9FF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xF9FF
  ,simpleLowerCaseMapping:0xF9FF
  ,simpleTitleCaseMapping:0xF9FF
 },
 { code:0xFA00
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA00
  ,simpleLowerCaseMapping:0xFA00
  ,simpleTitleCaseMapping:0xFA00
 },
 { code:0xFA01
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA01
  ,simpleLowerCaseMapping:0xFA01
  ,simpleTitleCaseMapping:0xFA01
 },
 { code:0xFA02
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA02
  ,simpleLowerCaseMapping:0xFA02
  ,simpleTitleCaseMapping:0xFA02
 },
 { code:0xFA03
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA03
  ,simpleLowerCaseMapping:0xFA03
  ,simpleTitleCaseMapping:0xFA03
 },
 { code:0xFA04
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA04
  ,simpleLowerCaseMapping:0xFA04
  ,simpleTitleCaseMapping:0xFA04
 },
 { code:0xFA05
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA05
  ,simpleLowerCaseMapping:0xFA05
  ,simpleTitleCaseMapping:0xFA05
 },
 { code:0xFA06
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA06
  ,simpleLowerCaseMapping:0xFA06
  ,simpleTitleCaseMapping:0xFA06
 },
 { code:0xFA07
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA07
  ,simpleLowerCaseMapping:0xFA07
  ,simpleTitleCaseMapping:0xFA07
 },
 { code:0xFA08
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA08
  ,simpleLowerCaseMapping:0xFA08
  ,simpleTitleCaseMapping:0xFA08
 },
 { code:0xFA09
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA09
  ,simpleLowerCaseMapping:0xFA09
  ,simpleTitleCaseMapping:0xFA09
 },
 { code:0xFA0A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA0A
  ,simpleLowerCaseMapping:0xFA0A
  ,simpleTitleCaseMapping:0xFA0A
 },
 { code:0xFA0B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA0B
  ,simpleLowerCaseMapping:0xFA0B
  ,simpleTitleCaseMapping:0xFA0B
 },
 { code:0xFA0C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA0C
  ,simpleLowerCaseMapping:0xFA0C
  ,simpleTitleCaseMapping:0xFA0C
 },
 { code:0xFA0D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA0D
  ,simpleLowerCaseMapping:0xFA0D
  ,simpleTitleCaseMapping:0xFA0D
 },
 { code:0xFA0E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA0E
  ,simpleLowerCaseMapping:0xFA0E
  ,simpleTitleCaseMapping:0xFA0E
 },
 { code:0xFA0F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA0F
  ,simpleLowerCaseMapping:0xFA0F
  ,simpleTitleCaseMapping:0xFA0F
 },
 { code:0xFA10
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA10
  ,simpleLowerCaseMapping:0xFA10
  ,simpleTitleCaseMapping:0xFA10
 },
 { code:0xFA11
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA11
  ,simpleLowerCaseMapping:0xFA11
  ,simpleTitleCaseMapping:0xFA11
 },
 { code:0xFA12
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA12
  ,simpleLowerCaseMapping:0xFA12
  ,simpleTitleCaseMapping:0xFA12
 },
 { code:0xFA13
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA13
  ,simpleLowerCaseMapping:0xFA13
  ,simpleTitleCaseMapping:0xFA13
 },
 { code:0xFA14
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA14
  ,simpleLowerCaseMapping:0xFA14
  ,simpleTitleCaseMapping:0xFA14
 },
 { code:0xFA15
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA15
  ,simpleLowerCaseMapping:0xFA15
  ,simpleTitleCaseMapping:0xFA15
 },
 { code:0xFA16
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA16
  ,simpleLowerCaseMapping:0xFA16
  ,simpleTitleCaseMapping:0xFA16
 },
 { code:0xFA17
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA17
  ,simpleLowerCaseMapping:0xFA17
  ,simpleTitleCaseMapping:0xFA17
 },
 { code:0xFA18
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA18
  ,simpleLowerCaseMapping:0xFA18
  ,simpleTitleCaseMapping:0xFA18
 },
 { code:0xFA19
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA19
  ,simpleLowerCaseMapping:0xFA19
  ,simpleTitleCaseMapping:0xFA19
 },
 { code:0xFA1A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA1A
  ,simpleLowerCaseMapping:0xFA1A
  ,simpleTitleCaseMapping:0xFA1A
 },
 { code:0xFA1B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA1B
  ,simpleLowerCaseMapping:0xFA1B
  ,simpleTitleCaseMapping:0xFA1B
 },
 { code:0xFA1C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA1C
  ,simpleLowerCaseMapping:0xFA1C
  ,simpleTitleCaseMapping:0xFA1C
 },
 { code:0xFA1D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA1D
  ,simpleLowerCaseMapping:0xFA1D
  ,simpleTitleCaseMapping:0xFA1D
 },
 { code:0xFA1E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA1E
  ,simpleLowerCaseMapping:0xFA1E
  ,simpleTitleCaseMapping:0xFA1E
 },
 { code:0xFA1F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA1F
  ,simpleLowerCaseMapping:0xFA1F
  ,simpleTitleCaseMapping:0xFA1F
 },
 { code:0xFA20
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA20
  ,simpleLowerCaseMapping:0xFA20
  ,simpleTitleCaseMapping:0xFA20
 },
 { code:0xFA21
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA21
  ,simpleLowerCaseMapping:0xFA21
  ,simpleTitleCaseMapping:0xFA21
 },
 { code:0xFA22
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA22
  ,simpleLowerCaseMapping:0xFA22
  ,simpleTitleCaseMapping:0xFA22
 },
 { code:0xFA23
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA23
  ,simpleLowerCaseMapping:0xFA23
  ,simpleTitleCaseMapping:0xFA23
 },
 { code:0xFA24
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA24
  ,simpleLowerCaseMapping:0xFA24
  ,simpleTitleCaseMapping:0xFA24
 },
 { code:0xFA25
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA25
  ,simpleLowerCaseMapping:0xFA25
  ,simpleTitleCaseMapping:0xFA25
 },
 { code:0xFA26
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA26
  ,simpleLowerCaseMapping:0xFA26
  ,simpleTitleCaseMapping:0xFA26
 },
 { code:0xFA27
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA27
  ,simpleLowerCaseMapping:0xFA27
  ,simpleTitleCaseMapping:0xFA27
 },
 { code:0xFA28
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA28
  ,simpleLowerCaseMapping:0xFA28
  ,simpleTitleCaseMapping:0xFA28
 },
 { code:0xFA29
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA29
  ,simpleLowerCaseMapping:0xFA29
  ,simpleTitleCaseMapping:0xFA29
 },
 { code:0xFA2A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA2A
  ,simpleLowerCaseMapping:0xFA2A
  ,simpleTitleCaseMapping:0xFA2A
 },
 { code:0xFA2B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA2B
  ,simpleLowerCaseMapping:0xFA2B
  ,simpleTitleCaseMapping:0xFA2B
 },
 { code:0xFA2C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA2C
  ,simpleLowerCaseMapping:0xFA2C
  ,simpleTitleCaseMapping:0xFA2C
 },
 { code:0xFA2D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA2D
  ,simpleLowerCaseMapping:0xFA2D
  ,simpleTitleCaseMapping:0xFA2D
 },
 { code:0xFA30
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA30
  ,simpleLowerCaseMapping:0xFA30
  ,simpleTitleCaseMapping:0xFA30
 },
 { code:0xFA31
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA31
  ,simpleLowerCaseMapping:0xFA31
  ,simpleTitleCaseMapping:0xFA31
 },
 { code:0xFA32
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA32
  ,simpleLowerCaseMapping:0xFA32
  ,simpleTitleCaseMapping:0xFA32
 },
 { code:0xFA33
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA33
  ,simpleLowerCaseMapping:0xFA33
  ,simpleTitleCaseMapping:0xFA33
 },
 { code:0xFA34
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA34
  ,simpleLowerCaseMapping:0xFA34
  ,simpleTitleCaseMapping:0xFA34
 },
 { code:0xFA35
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA35
  ,simpleLowerCaseMapping:0xFA35
  ,simpleTitleCaseMapping:0xFA35
 },
 { code:0xFA36
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA36
  ,simpleLowerCaseMapping:0xFA36
  ,simpleTitleCaseMapping:0xFA36
 },
 { code:0xFA37
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA37
  ,simpleLowerCaseMapping:0xFA37
  ,simpleTitleCaseMapping:0xFA37
 },
 { code:0xFA38
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA38
  ,simpleLowerCaseMapping:0xFA38
  ,simpleTitleCaseMapping:0xFA38
 },
 { code:0xFA39
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA39
  ,simpleLowerCaseMapping:0xFA39
  ,simpleTitleCaseMapping:0xFA39
 },
 { code:0xFA3A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA3A
  ,simpleLowerCaseMapping:0xFA3A
  ,simpleTitleCaseMapping:0xFA3A
 },
 { code:0xFA3B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA3B
  ,simpleLowerCaseMapping:0xFA3B
  ,simpleTitleCaseMapping:0xFA3B
 },
 { code:0xFA3C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA3C
  ,simpleLowerCaseMapping:0xFA3C
  ,simpleTitleCaseMapping:0xFA3C
 },
 { code:0xFA3D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA3D
  ,simpleLowerCaseMapping:0xFA3D
  ,simpleTitleCaseMapping:0xFA3D
 },
 { code:0xFA3E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA3E
  ,simpleLowerCaseMapping:0xFA3E
  ,simpleTitleCaseMapping:0xFA3E
 },
 { code:0xFA3F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA3F
  ,simpleLowerCaseMapping:0xFA3F
  ,simpleTitleCaseMapping:0xFA3F
 },
 { code:0xFA40
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA40
  ,simpleLowerCaseMapping:0xFA40
  ,simpleTitleCaseMapping:0xFA40
 },
 { code:0xFA41
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA41
  ,simpleLowerCaseMapping:0xFA41
  ,simpleTitleCaseMapping:0xFA41
 },
 { code:0xFA42
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA42
  ,simpleLowerCaseMapping:0xFA42
  ,simpleTitleCaseMapping:0xFA42
 },
 { code:0xFA43
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA43
  ,simpleLowerCaseMapping:0xFA43
  ,simpleTitleCaseMapping:0xFA43
 },
 { code:0xFA44
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA44
  ,simpleLowerCaseMapping:0xFA44
  ,simpleTitleCaseMapping:0xFA44
 },
 { code:0xFA45
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA45
  ,simpleLowerCaseMapping:0xFA45
  ,simpleTitleCaseMapping:0xFA45
 },
 { code:0xFA46
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA46
  ,simpleLowerCaseMapping:0xFA46
  ,simpleTitleCaseMapping:0xFA46
 },
 { code:0xFA47
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA47
  ,simpleLowerCaseMapping:0xFA47
  ,simpleTitleCaseMapping:0xFA47
 },
 { code:0xFA48
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA48
  ,simpleLowerCaseMapping:0xFA48
  ,simpleTitleCaseMapping:0xFA48
 },
 { code:0xFA49
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA49
  ,simpleLowerCaseMapping:0xFA49
  ,simpleTitleCaseMapping:0xFA49
 },
 { code:0xFA4A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA4A
  ,simpleLowerCaseMapping:0xFA4A
  ,simpleTitleCaseMapping:0xFA4A
 },
 { code:0xFA4B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA4B
  ,simpleLowerCaseMapping:0xFA4B
  ,simpleTitleCaseMapping:0xFA4B
 },
 { code:0xFA4C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA4C
  ,simpleLowerCaseMapping:0xFA4C
  ,simpleTitleCaseMapping:0xFA4C
 },
 { code:0xFA4D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA4D
  ,simpleLowerCaseMapping:0xFA4D
  ,simpleTitleCaseMapping:0xFA4D
 },
 { code:0xFA4E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA4E
  ,simpleLowerCaseMapping:0xFA4E
  ,simpleTitleCaseMapping:0xFA4E
 },
 { code:0xFA4F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA4F
  ,simpleLowerCaseMapping:0xFA4F
  ,simpleTitleCaseMapping:0xFA4F
 },
 { code:0xFA50
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA50
  ,simpleLowerCaseMapping:0xFA50
  ,simpleTitleCaseMapping:0xFA50
 },
 { code:0xFA51
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA51
  ,simpleLowerCaseMapping:0xFA51
  ,simpleTitleCaseMapping:0xFA51
 },
 { code:0xFA52
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA52
  ,simpleLowerCaseMapping:0xFA52
  ,simpleTitleCaseMapping:0xFA52
 },
 { code:0xFA53
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA53
  ,simpleLowerCaseMapping:0xFA53
  ,simpleTitleCaseMapping:0xFA53
 },
 { code:0xFA54
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA54
  ,simpleLowerCaseMapping:0xFA54
  ,simpleTitleCaseMapping:0xFA54
 },
 { code:0xFA55
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA55
  ,simpleLowerCaseMapping:0xFA55
  ,simpleTitleCaseMapping:0xFA55
 },
 { code:0xFA56
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA56
  ,simpleLowerCaseMapping:0xFA56
  ,simpleTitleCaseMapping:0xFA56
 },
 { code:0xFA57
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA57
  ,simpleLowerCaseMapping:0xFA57
  ,simpleTitleCaseMapping:0xFA57
 },
 { code:0xFA58
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA58
  ,simpleLowerCaseMapping:0xFA58
  ,simpleTitleCaseMapping:0xFA58
 },
 { code:0xFA59
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA59
  ,simpleLowerCaseMapping:0xFA59
  ,simpleTitleCaseMapping:0xFA59
 },
 { code:0xFA5A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA5A
  ,simpleLowerCaseMapping:0xFA5A
  ,simpleTitleCaseMapping:0xFA5A
 },
 { code:0xFA5B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA5B
  ,simpleLowerCaseMapping:0xFA5B
  ,simpleTitleCaseMapping:0xFA5B
 },
 { code:0xFA5C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA5C
  ,simpleLowerCaseMapping:0xFA5C
  ,simpleTitleCaseMapping:0xFA5C
 },
 { code:0xFA5D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA5D
  ,simpleLowerCaseMapping:0xFA5D
  ,simpleTitleCaseMapping:0xFA5D
 },
 { code:0xFA5E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA5E
  ,simpleLowerCaseMapping:0xFA5E
  ,simpleTitleCaseMapping:0xFA5E
 },
 { code:0xFA5F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA5F
  ,simpleLowerCaseMapping:0xFA5F
  ,simpleTitleCaseMapping:0xFA5F
 },
 { code:0xFA60
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA60
  ,simpleLowerCaseMapping:0xFA60
  ,simpleTitleCaseMapping:0xFA60
 },
 { code:0xFA61
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA61
  ,simpleLowerCaseMapping:0xFA61
  ,simpleTitleCaseMapping:0xFA61
 },
 { code:0xFA62
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA62
  ,simpleLowerCaseMapping:0xFA62
  ,simpleTitleCaseMapping:0xFA62
 },
 { code:0xFA63
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA63
  ,simpleLowerCaseMapping:0xFA63
  ,simpleTitleCaseMapping:0xFA63
 },
 { code:0xFA64
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA64
  ,simpleLowerCaseMapping:0xFA64
  ,simpleTitleCaseMapping:0xFA64
 },
 { code:0xFA65
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA65
  ,simpleLowerCaseMapping:0xFA65
  ,simpleTitleCaseMapping:0xFA65
 },
 { code:0xFA66
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA66
  ,simpleLowerCaseMapping:0xFA66
  ,simpleTitleCaseMapping:0xFA66
 },
 { code:0xFA67
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA67
  ,simpleLowerCaseMapping:0xFA67
  ,simpleTitleCaseMapping:0xFA67
 },
 { code:0xFA68
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA68
  ,simpleLowerCaseMapping:0xFA68
  ,simpleTitleCaseMapping:0xFA68
 },
 { code:0xFA69
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA69
  ,simpleLowerCaseMapping:0xFA69
  ,simpleTitleCaseMapping:0xFA69
 },
 { code:0xFA6A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA6A
  ,simpleLowerCaseMapping:0xFA6A
  ,simpleTitleCaseMapping:0xFA6A
 },
 { code:0xFA70
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA70
  ,simpleLowerCaseMapping:0xFA70
  ,simpleTitleCaseMapping:0xFA70
 },
 { code:0xFA71
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA71
  ,simpleLowerCaseMapping:0xFA71
  ,simpleTitleCaseMapping:0xFA71
 },
 { code:0xFA72
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA72
  ,simpleLowerCaseMapping:0xFA72
  ,simpleTitleCaseMapping:0xFA72
 },
 { code:0xFA73
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA73
  ,simpleLowerCaseMapping:0xFA73
  ,simpleTitleCaseMapping:0xFA73
 },
 { code:0xFA74
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA74
  ,simpleLowerCaseMapping:0xFA74
  ,simpleTitleCaseMapping:0xFA74
 },
 { code:0xFA75
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA75
  ,simpleLowerCaseMapping:0xFA75
  ,simpleTitleCaseMapping:0xFA75
 },
 { code:0xFA76
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA76
  ,simpleLowerCaseMapping:0xFA76
  ,simpleTitleCaseMapping:0xFA76
 },
 { code:0xFA77
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA77
  ,simpleLowerCaseMapping:0xFA77
  ,simpleTitleCaseMapping:0xFA77
 },
 { code:0xFA78
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA78
  ,simpleLowerCaseMapping:0xFA78
  ,simpleTitleCaseMapping:0xFA78
 },
 { code:0xFA79
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA79
  ,simpleLowerCaseMapping:0xFA79
  ,simpleTitleCaseMapping:0xFA79
 },
 { code:0xFA7A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA7A
  ,simpleLowerCaseMapping:0xFA7A
  ,simpleTitleCaseMapping:0xFA7A
 },
 { code:0xFA7B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA7B
  ,simpleLowerCaseMapping:0xFA7B
  ,simpleTitleCaseMapping:0xFA7B
 },
 { code:0xFA7C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA7C
  ,simpleLowerCaseMapping:0xFA7C
  ,simpleTitleCaseMapping:0xFA7C
 },
 { code:0xFA7D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA7D
  ,simpleLowerCaseMapping:0xFA7D
  ,simpleTitleCaseMapping:0xFA7D
 },
 { code:0xFA7E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA7E
  ,simpleLowerCaseMapping:0xFA7E
  ,simpleTitleCaseMapping:0xFA7E
 },
 { code:0xFA7F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA7F
  ,simpleLowerCaseMapping:0xFA7F
  ,simpleTitleCaseMapping:0xFA7F
 },
 { code:0xFA80
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA80
  ,simpleLowerCaseMapping:0xFA80
  ,simpleTitleCaseMapping:0xFA80
 },
 { code:0xFA81
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA81
  ,simpleLowerCaseMapping:0xFA81
  ,simpleTitleCaseMapping:0xFA81
 },
 { code:0xFA82
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA82
  ,simpleLowerCaseMapping:0xFA82
  ,simpleTitleCaseMapping:0xFA82
 },
 { code:0xFA83
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA83
  ,simpleLowerCaseMapping:0xFA83
  ,simpleTitleCaseMapping:0xFA83
 },
 { code:0xFA84
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA84
  ,simpleLowerCaseMapping:0xFA84
  ,simpleTitleCaseMapping:0xFA84
 },
 { code:0xFA85
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA85
  ,simpleLowerCaseMapping:0xFA85
  ,simpleTitleCaseMapping:0xFA85
 },
 { code:0xFA86
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA86
  ,simpleLowerCaseMapping:0xFA86
  ,simpleTitleCaseMapping:0xFA86
 },
 { code:0xFA87
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA87
  ,simpleLowerCaseMapping:0xFA87
  ,simpleTitleCaseMapping:0xFA87
 },
 { code:0xFA88
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA88
  ,simpleLowerCaseMapping:0xFA88
  ,simpleTitleCaseMapping:0xFA88
 },
 { code:0xFA89
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA89
  ,simpleLowerCaseMapping:0xFA89
  ,simpleTitleCaseMapping:0xFA89
 },
 { code:0xFA8A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA8A
  ,simpleLowerCaseMapping:0xFA8A
  ,simpleTitleCaseMapping:0xFA8A
 },
 { code:0xFA8B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA8B
  ,simpleLowerCaseMapping:0xFA8B
  ,simpleTitleCaseMapping:0xFA8B
 },
 { code:0xFA8C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA8C
  ,simpleLowerCaseMapping:0xFA8C
  ,simpleTitleCaseMapping:0xFA8C
 },
 { code:0xFA8D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA8D
  ,simpleLowerCaseMapping:0xFA8D
  ,simpleTitleCaseMapping:0xFA8D
 },
 { code:0xFA8E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA8E
  ,simpleLowerCaseMapping:0xFA8E
  ,simpleTitleCaseMapping:0xFA8E
 },
 { code:0xFA8F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA8F
  ,simpleLowerCaseMapping:0xFA8F
  ,simpleTitleCaseMapping:0xFA8F
 },
 { code:0xFA90
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA90
  ,simpleLowerCaseMapping:0xFA90
  ,simpleTitleCaseMapping:0xFA90
 },
 { code:0xFA91
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA91
  ,simpleLowerCaseMapping:0xFA91
  ,simpleTitleCaseMapping:0xFA91
 },
 { code:0xFA92
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA92
  ,simpleLowerCaseMapping:0xFA92
  ,simpleTitleCaseMapping:0xFA92
 },
 { code:0xFA93
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA93
  ,simpleLowerCaseMapping:0xFA93
  ,simpleTitleCaseMapping:0xFA93
 },
 { code:0xFA94
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA94
  ,simpleLowerCaseMapping:0xFA94
  ,simpleTitleCaseMapping:0xFA94
 },
 { code:0xFA95
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA95
  ,simpleLowerCaseMapping:0xFA95
  ,simpleTitleCaseMapping:0xFA95
 },
 { code:0xFA96
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA96
  ,simpleLowerCaseMapping:0xFA96
  ,simpleTitleCaseMapping:0xFA96
 },
 { code:0xFA97
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA97
  ,simpleLowerCaseMapping:0xFA97
  ,simpleTitleCaseMapping:0xFA97
 },
 { code:0xFA98
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA98
  ,simpleLowerCaseMapping:0xFA98
  ,simpleTitleCaseMapping:0xFA98
 },
 { code:0xFA99
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA99
  ,simpleLowerCaseMapping:0xFA99
  ,simpleTitleCaseMapping:0xFA99
 },
 { code:0xFA9A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA9A
  ,simpleLowerCaseMapping:0xFA9A
  ,simpleTitleCaseMapping:0xFA9A
 },
 { code:0xFA9B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA9B
  ,simpleLowerCaseMapping:0xFA9B
  ,simpleTitleCaseMapping:0xFA9B
 },
 { code:0xFA9C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA9C
  ,simpleLowerCaseMapping:0xFA9C
  ,simpleTitleCaseMapping:0xFA9C
 },
 { code:0xFA9D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA9D
  ,simpleLowerCaseMapping:0xFA9D
  ,simpleTitleCaseMapping:0xFA9D
 },
 { code:0xFA9E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA9E
  ,simpleLowerCaseMapping:0xFA9E
  ,simpleTitleCaseMapping:0xFA9E
 },
 { code:0xFA9F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFA9F
  ,simpleLowerCaseMapping:0xFA9F
  ,simpleTitleCaseMapping:0xFA9F
 },
 { code:0xFAA0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAA0
  ,simpleLowerCaseMapping:0xFAA0
  ,simpleTitleCaseMapping:0xFAA0
 },
 { code:0xFAA1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAA1
  ,simpleLowerCaseMapping:0xFAA1
  ,simpleTitleCaseMapping:0xFAA1
 },
 { code:0xFAA2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAA2
  ,simpleLowerCaseMapping:0xFAA2
  ,simpleTitleCaseMapping:0xFAA2
 },
 { code:0xFAA3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAA3
  ,simpleLowerCaseMapping:0xFAA3
  ,simpleTitleCaseMapping:0xFAA3
 },
 { code:0xFAA4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAA4
  ,simpleLowerCaseMapping:0xFAA4
  ,simpleTitleCaseMapping:0xFAA4
 },
 { code:0xFAA5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAA5
  ,simpleLowerCaseMapping:0xFAA5
  ,simpleTitleCaseMapping:0xFAA5
 },
 { code:0xFAA6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAA6
  ,simpleLowerCaseMapping:0xFAA6
  ,simpleTitleCaseMapping:0xFAA6
 },
 { code:0xFAA7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAA7
  ,simpleLowerCaseMapping:0xFAA7
  ,simpleTitleCaseMapping:0xFAA7
 },
 { code:0xFAA8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAA8
  ,simpleLowerCaseMapping:0xFAA8
  ,simpleTitleCaseMapping:0xFAA8
 },
 { code:0xFAA9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAA9
  ,simpleLowerCaseMapping:0xFAA9
  ,simpleTitleCaseMapping:0xFAA9
 },
 { code:0xFAAA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAAA
  ,simpleLowerCaseMapping:0xFAAA
  ,simpleTitleCaseMapping:0xFAAA
 },
 { code:0xFAAB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAAB
  ,simpleLowerCaseMapping:0xFAAB
  ,simpleTitleCaseMapping:0xFAAB
 },
 { code:0xFAAC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAAC
  ,simpleLowerCaseMapping:0xFAAC
  ,simpleTitleCaseMapping:0xFAAC
 },
 { code:0xFAAD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAAD
  ,simpleLowerCaseMapping:0xFAAD
  ,simpleTitleCaseMapping:0xFAAD
 },
 { code:0xFAAE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAAE
  ,simpleLowerCaseMapping:0xFAAE
  ,simpleTitleCaseMapping:0xFAAE
 },
 { code:0xFAAF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAAF
  ,simpleLowerCaseMapping:0xFAAF
  ,simpleTitleCaseMapping:0xFAAF
 },
 { code:0xFAB0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAB0
  ,simpleLowerCaseMapping:0xFAB0
  ,simpleTitleCaseMapping:0xFAB0
 },
 { code:0xFAB1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAB1
  ,simpleLowerCaseMapping:0xFAB1
  ,simpleTitleCaseMapping:0xFAB1
 },
 { code:0xFAB2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAB2
  ,simpleLowerCaseMapping:0xFAB2
  ,simpleTitleCaseMapping:0xFAB2
 },
 { code:0xFAB3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAB3
  ,simpleLowerCaseMapping:0xFAB3
  ,simpleTitleCaseMapping:0xFAB3
 },
 { code:0xFAB4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAB4
  ,simpleLowerCaseMapping:0xFAB4
  ,simpleTitleCaseMapping:0xFAB4
 },
 { code:0xFAB5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAB5
  ,simpleLowerCaseMapping:0xFAB5
  ,simpleTitleCaseMapping:0xFAB5
 },
 { code:0xFAB6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAB6
  ,simpleLowerCaseMapping:0xFAB6
  ,simpleTitleCaseMapping:0xFAB6
 },
 { code:0xFAB7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAB7
  ,simpleLowerCaseMapping:0xFAB7
  ,simpleTitleCaseMapping:0xFAB7
 },
 { code:0xFAB8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAB8
  ,simpleLowerCaseMapping:0xFAB8
  ,simpleTitleCaseMapping:0xFAB8
 },
 { code:0xFAB9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAB9
  ,simpleLowerCaseMapping:0xFAB9
  ,simpleTitleCaseMapping:0xFAB9
 },
 { code:0xFABA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFABA
  ,simpleLowerCaseMapping:0xFABA
  ,simpleTitleCaseMapping:0xFABA
 },
 { code:0xFABB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFABB
  ,simpleLowerCaseMapping:0xFABB
  ,simpleTitleCaseMapping:0xFABB
 },
 { code:0xFABC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFABC
  ,simpleLowerCaseMapping:0xFABC
  ,simpleTitleCaseMapping:0xFABC
 },
 { code:0xFABD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFABD
  ,simpleLowerCaseMapping:0xFABD
  ,simpleTitleCaseMapping:0xFABD
 },
 { code:0xFABE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFABE
  ,simpleLowerCaseMapping:0xFABE
  ,simpleTitleCaseMapping:0xFABE
 },
 { code:0xFABF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFABF
  ,simpleLowerCaseMapping:0xFABF
  ,simpleTitleCaseMapping:0xFABF
 },
 { code:0xFAC0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAC0
  ,simpleLowerCaseMapping:0xFAC0
  ,simpleTitleCaseMapping:0xFAC0
 },
 { code:0xFAC1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAC1
  ,simpleLowerCaseMapping:0xFAC1
  ,simpleTitleCaseMapping:0xFAC1
 },
 { code:0xFAC2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAC2
  ,simpleLowerCaseMapping:0xFAC2
  ,simpleTitleCaseMapping:0xFAC2
 },
 { code:0xFAC3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAC3
  ,simpleLowerCaseMapping:0xFAC3
  ,simpleTitleCaseMapping:0xFAC3
 },
 { code:0xFAC4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAC4
  ,simpleLowerCaseMapping:0xFAC4
  ,simpleTitleCaseMapping:0xFAC4
 },
 { code:0xFAC5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAC5
  ,simpleLowerCaseMapping:0xFAC5
  ,simpleTitleCaseMapping:0xFAC5
 },
 { code:0xFAC6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAC6
  ,simpleLowerCaseMapping:0xFAC6
  ,simpleTitleCaseMapping:0xFAC6
 },
 { code:0xFAC7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAC7
  ,simpleLowerCaseMapping:0xFAC7
  ,simpleTitleCaseMapping:0xFAC7
 },
 { code:0xFAC8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAC8
  ,simpleLowerCaseMapping:0xFAC8
  ,simpleTitleCaseMapping:0xFAC8
 },
 { code:0xFAC9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAC9
  ,simpleLowerCaseMapping:0xFAC9
  ,simpleTitleCaseMapping:0xFAC9
 },
 { code:0xFACA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFACA
  ,simpleLowerCaseMapping:0xFACA
  ,simpleTitleCaseMapping:0xFACA
 },
 { code:0xFACB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFACB
  ,simpleLowerCaseMapping:0xFACB
  ,simpleTitleCaseMapping:0xFACB
 },
 { code:0xFACC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFACC
  ,simpleLowerCaseMapping:0xFACC
  ,simpleTitleCaseMapping:0xFACC
 },
 { code:0xFACD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFACD
  ,simpleLowerCaseMapping:0xFACD
  ,simpleTitleCaseMapping:0xFACD
 },
 { code:0xFACE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFACE
  ,simpleLowerCaseMapping:0xFACE
  ,simpleTitleCaseMapping:0xFACE
 },
 { code:0xFACF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFACF
  ,simpleLowerCaseMapping:0xFACF
  ,simpleTitleCaseMapping:0xFACF
 },
 { code:0xFAD0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAD0
  ,simpleLowerCaseMapping:0xFAD0
  ,simpleTitleCaseMapping:0xFAD0
 },
 { code:0xFAD1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAD1
  ,simpleLowerCaseMapping:0xFAD1
  ,simpleTitleCaseMapping:0xFAD1
 },
 { code:0xFAD2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAD2
  ,simpleLowerCaseMapping:0xFAD2
  ,simpleTitleCaseMapping:0xFAD2
 },
 { code:0xFAD3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAD3
  ,simpleLowerCaseMapping:0xFAD3
  ,simpleTitleCaseMapping:0xFAD3
 },
 { code:0xFAD4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAD4
  ,simpleLowerCaseMapping:0xFAD4
  ,simpleTitleCaseMapping:0xFAD4
 },
 { code:0xFAD5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAD5
  ,simpleLowerCaseMapping:0xFAD5
  ,simpleTitleCaseMapping:0xFAD5
 },
 { code:0xFAD6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAD6
  ,simpleLowerCaseMapping:0xFAD6
  ,simpleTitleCaseMapping:0xFAD6
 },
 { code:0xFAD7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAD7
  ,simpleLowerCaseMapping:0xFAD7
  ,simpleTitleCaseMapping:0xFAD7
 },
 { code:0xFAD8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAD8
  ,simpleLowerCaseMapping:0xFAD8
  ,simpleTitleCaseMapping:0xFAD8
 },
 { code:0xFAD9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFAD9
  ,simpleLowerCaseMapping:0xFAD9
  ,simpleTitleCaseMapping:0xFAD9
 },
 { code:0xFB00
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0xFB00
  ,simpleLowerCaseMapping:0xFB00
  ,simpleTitleCaseMapping:0xFB00
 },
 { code:0xFB01
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0xFB01
  ,simpleLowerCaseMapping:0xFB01
  ,simpleTitleCaseMapping:0xFB01
 },
 { code:0xFB02
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0xFB02
  ,simpleLowerCaseMapping:0xFB02
  ,simpleTitleCaseMapping:0xFB02
 },
 { code:0xFB03
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0xFB03
  ,simpleLowerCaseMapping:0xFB03
  ,simpleTitleCaseMapping:0xFB03
 },
 { code:0xFB04
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0xFB04
  ,simpleLowerCaseMapping:0xFB04
  ,simpleTitleCaseMapping:0xFB04
 },
 { code:0xFB05
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0xFB05
  ,simpleLowerCaseMapping:0xFB05
  ,simpleTitleCaseMapping:0xFB05
 },
 { code:0xFB06
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0xFB06
  ,simpleLowerCaseMapping:0xFB06
  ,simpleTitleCaseMapping:0xFB06
 },
 { code:0xFB13
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0xFB13
  ,simpleLowerCaseMapping:0xFB13
  ,simpleTitleCaseMapping:0xFB13
 },
 { code:0xFB14
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0xFB14
  ,simpleLowerCaseMapping:0xFB14
  ,simpleTitleCaseMapping:0xFB14
 },
 { code:0xFB15
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0xFB15
  ,simpleLowerCaseMapping:0xFB15
  ,simpleTitleCaseMapping:0xFB15
 },
 { code:0xFB16
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0xFB16
  ,simpleLowerCaseMapping:0xFB16
  ,simpleTitleCaseMapping:0xFB16
 },
 { code:0xFB17
  ,generalCategory:UnicodeData.GeneralCategory.Ll | UnicodeData.GeneralCategory.SpecialMapping
  ,simpleUpperCaseMapping:0xFB17
  ,simpleLowerCaseMapping:0xFB17
  ,simpleTitleCaseMapping:0xFB17
 },
 { code:0xFB1D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB1D
  ,simpleLowerCaseMapping:0xFB1D
  ,simpleTitleCaseMapping:0xFB1D
 },
 { code:0xFB1E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFB1E
  ,simpleLowerCaseMapping:0xFB1E
  ,simpleTitleCaseMapping:0xFB1E
 },
 { code:0xFB1F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB1F
  ,simpleLowerCaseMapping:0xFB1F
  ,simpleTitleCaseMapping:0xFB1F
 },
 { code:0xFB20
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB20
  ,simpleLowerCaseMapping:0xFB20
  ,simpleTitleCaseMapping:0xFB20
 },
 { code:0xFB21
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB21
  ,simpleLowerCaseMapping:0xFB21
  ,simpleTitleCaseMapping:0xFB21
 },
 { code:0xFB22
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB22
  ,simpleLowerCaseMapping:0xFB22
  ,simpleTitleCaseMapping:0xFB22
 },
 { code:0xFB23
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB23
  ,simpleLowerCaseMapping:0xFB23
  ,simpleTitleCaseMapping:0xFB23
 },
 { code:0xFB24
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB24
  ,simpleLowerCaseMapping:0xFB24
  ,simpleTitleCaseMapping:0xFB24
 },
 { code:0xFB25
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB25
  ,simpleLowerCaseMapping:0xFB25
  ,simpleTitleCaseMapping:0xFB25
 },
 { code:0xFB26
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB26
  ,simpleLowerCaseMapping:0xFB26
  ,simpleTitleCaseMapping:0xFB26
 },
 { code:0xFB27
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB27
  ,simpleLowerCaseMapping:0xFB27
  ,simpleTitleCaseMapping:0xFB27
 },
 { code:0xFB28
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB28
  ,simpleLowerCaseMapping:0xFB28
  ,simpleTitleCaseMapping:0xFB28
 },
 { code:0xFB29
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0xFB29
  ,simpleLowerCaseMapping:0xFB29
  ,simpleTitleCaseMapping:0xFB29
 },
 { code:0xFB2A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB2A
  ,simpleLowerCaseMapping:0xFB2A
  ,simpleTitleCaseMapping:0xFB2A
 },
 { code:0xFB2B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB2B
  ,simpleLowerCaseMapping:0xFB2B
  ,simpleTitleCaseMapping:0xFB2B
 },
 { code:0xFB2C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB2C
  ,simpleLowerCaseMapping:0xFB2C
  ,simpleTitleCaseMapping:0xFB2C
 },
 { code:0xFB2D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB2D
  ,simpleLowerCaseMapping:0xFB2D
  ,simpleTitleCaseMapping:0xFB2D
 },
 { code:0xFB2E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB2E
  ,simpleLowerCaseMapping:0xFB2E
  ,simpleTitleCaseMapping:0xFB2E
 },
 { code:0xFB2F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB2F
  ,simpleLowerCaseMapping:0xFB2F
  ,simpleTitleCaseMapping:0xFB2F
 },
 { code:0xFB30
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB30
  ,simpleLowerCaseMapping:0xFB30
  ,simpleTitleCaseMapping:0xFB30
 },
 { code:0xFB31
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB31
  ,simpleLowerCaseMapping:0xFB31
  ,simpleTitleCaseMapping:0xFB31
 },
 { code:0xFB32
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB32
  ,simpleLowerCaseMapping:0xFB32
  ,simpleTitleCaseMapping:0xFB32
 },
 { code:0xFB33
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB33
  ,simpleLowerCaseMapping:0xFB33
  ,simpleTitleCaseMapping:0xFB33
 },
 { code:0xFB34
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB34
  ,simpleLowerCaseMapping:0xFB34
  ,simpleTitleCaseMapping:0xFB34
 },
 { code:0xFB35
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB35
  ,simpleLowerCaseMapping:0xFB35
  ,simpleTitleCaseMapping:0xFB35
 },
 { code:0xFB36
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB36
  ,simpleLowerCaseMapping:0xFB36
  ,simpleTitleCaseMapping:0xFB36
 },
 { code:0xFB38
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB38
  ,simpleLowerCaseMapping:0xFB38
  ,simpleTitleCaseMapping:0xFB38
 },
 { code:0xFB39
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB39
  ,simpleLowerCaseMapping:0xFB39
  ,simpleTitleCaseMapping:0xFB39
 },
 { code:0xFB3A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB3A
  ,simpleLowerCaseMapping:0xFB3A
  ,simpleTitleCaseMapping:0xFB3A
 },
 { code:0xFB3B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB3B
  ,simpleLowerCaseMapping:0xFB3B
  ,simpleTitleCaseMapping:0xFB3B
 },
 { code:0xFB3C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB3C
  ,simpleLowerCaseMapping:0xFB3C
  ,simpleTitleCaseMapping:0xFB3C
 },
 { code:0xFB3E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB3E
  ,simpleLowerCaseMapping:0xFB3E
  ,simpleTitleCaseMapping:0xFB3E
 },
 { code:0xFB40
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB40
  ,simpleLowerCaseMapping:0xFB40
  ,simpleTitleCaseMapping:0xFB40
 },
 { code:0xFB41
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB41
  ,simpleLowerCaseMapping:0xFB41
  ,simpleTitleCaseMapping:0xFB41
 },
 { code:0xFB43
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB43
  ,simpleLowerCaseMapping:0xFB43
  ,simpleTitleCaseMapping:0xFB43
 },
 { code:0xFB44
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB44
  ,simpleLowerCaseMapping:0xFB44
  ,simpleTitleCaseMapping:0xFB44
 },
 { code:0xFB46
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB46
  ,simpleLowerCaseMapping:0xFB46
  ,simpleTitleCaseMapping:0xFB46
 },
 { code:0xFB47
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB47
  ,simpleLowerCaseMapping:0xFB47
  ,simpleTitleCaseMapping:0xFB47
 },
 { code:0xFB48
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB48
  ,simpleLowerCaseMapping:0xFB48
  ,simpleTitleCaseMapping:0xFB48
 },
 { code:0xFB49
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB49
  ,simpleLowerCaseMapping:0xFB49
  ,simpleTitleCaseMapping:0xFB49
 },
 { code:0xFB4A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB4A
  ,simpleLowerCaseMapping:0xFB4A
  ,simpleTitleCaseMapping:0xFB4A
 },
 { code:0xFB4B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB4B
  ,simpleLowerCaseMapping:0xFB4B
  ,simpleTitleCaseMapping:0xFB4B
 },
 { code:0xFB4C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB4C
  ,simpleLowerCaseMapping:0xFB4C
  ,simpleTitleCaseMapping:0xFB4C
 },
 { code:0xFB4D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB4D
  ,simpleLowerCaseMapping:0xFB4D
  ,simpleTitleCaseMapping:0xFB4D
 },
 { code:0xFB4E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB4E
  ,simpleLowerCaseMapping:0xFB4E
  ,simpleTitleCaseMapping:0xFB4E
 },
 { code:0xFB4F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB4F
  ,simpleLowerCaseMapping:0xFB4F
  ,simpleTitleCaseMapping:0xFB4F
 },
 { code:0xFB50
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB50
  ,simpleLowerCaseMapping:0xFB50
  ,simpleTitleCaseMapping:0xFB50
 },
 { code:0xFB51
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB51
  ,simpleLowerCaseMapping:0xFB51
  ,simpleTitleCaseMapping:0xFB51
 },
 { code:0xFB52
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB52
  ,simpleLowerCaseMapping:0xFB52
  ,simpleTitleCaseMapping:0xFB52
 },
 { code:0xFB53
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB53
  ,simpleLowerCaseMapping:0xFB53
  ,simpleTitleCaseMapping:0xFB53
 },
 { code:0xFB54
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB54
  ,simpleLowerCaseMapping:0xFB54
  ,simpleTitleCaseMapping:0xFB54
 },
 { code:0xFB55
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB55
  ,simpleLowerCaseMapping:0xFB55
  ,simpleTitleCaseMapping:0xFB55
 },
 { code:0xFB56
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB56
  ,simpleLowerCaseMapping:0xFB56
  ,simpleTitleCaseMapping:0xFB56
 },
 { code:0xFB57
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB57
  ,simpleLowerCaseMapping:0xFB57
  ,simpleTitleCaseMapping:0xFB57
 },
 { code:0xFB58
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB58
  ,simpleLowerCaseMapping:0xFB58
  ,simpleTitleCaseMapping:0xFB58
 },
 { code:0xFB59
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB59
  ,simpleLowerCaseMapping:0xFB59
  ,simpleTitleCaseMapping:0xFB59
 },
 { code:0xFB5A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB5A
  ,simpleLowerCaseMapping:0xFB5A
  ,simpleTitleCaseMapping:0xFB5A
 },
 { code:0xFB5B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB5B
  ,simpleLowerCaseMapping:0xFB5B
  ,simpleTitleCaseMapping:0xFB5B
 },
 { code:0xFB5C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB5C
  ,simpleLowerCaseMapping:0xFB5C
  ,simpleTitleCaseMapping:0xFB5C
 },
 { code:0xFB5D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB5D
  ,simpleLowerCaseMapping:0xFB5D
  ,simpleTitleCaseMapping:0xFB5D
 },
 { code:0xFB5E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB5E
  ,simpleLowerCaseMapping:0xFB5E
  ,simpleTitleCaseMapping:0xFB5E
 },
 { code:0xFB5F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB5F
  ,simpleLowerCaseMapping:0xFB5F
  ,simpleTitleCaseMapping:0xFB5F
 },
 { code:0xFB60
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB60
  ,simpleLowerCaseMapping:0xFB60
  ,simpleTitleCaseMapping:0xFB60
 },
 { code:0xFB61
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB61
  ,simpleLowerCaseMapping:0xFB61
  ,simpleTitleCaseMapping:0xFB61
 },
 { code:0xFB62
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB62
  ,simpleLowerCaseMapping:0xFB62
  ,simpleTitleCaseMapping:0xFB62
 },
 { code:0xFB63
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB63
  ,simpleLowerCaseMapping:0xFB63
  ,simpleTitleCaseMapping:0xFB63
 },
 { code:0xFB64
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB64
  ,simpleLowerCaseMapping:0xFB64
  ,simpleTitleCaseMapping:0xFB64
 },
 { code:0xFB65
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB65
  ,simpleLowerCaseMapping:0xFB65
  ,simpleTitleCaseMapping:0xFB65
 },
 { code:0xFB66
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB66
  ,simpleLowerCaseMapping:0xFB66
  ,simpleTitleCaseMapping:0xFB66
 },
 { code:0xFB67
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB67
  ,simpleLowerCaseMapping:0xFB67
  ,simpleTitleCaseMapping:0xFB67
 },
 { code:0xFB68
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB68
  ,simpleLowerCaseMapping:0xFB68
  ,simpleTitleCaseMapping:0xFB68
 },
 { code:0xFB69
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB69
  ,simpleLowerCaseMapping:0xFB69
  ,simpleTitleCaseMapping:0xFB69
 },
 { code:0xFB6A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB6A
  ,simpleLowerCaseMapping:0xFB6A
  ,simpleTitleCaseMapping:0xFB6A
 },
 { code:0xFB6B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB6B
  ,simpleLowerCaseMapping:0xFB6B
  ,simpleTitleCaseMapping:0xFB6B
 },
 { code:0xFB6C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB6C
  ,simpleLowerCaseMapping:0xFB6C
  ,simpleTitleCaseMapping:0xFB6C
 },
 { code:0xFB6D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB6D
  ,simpleLowerCaseMapping:0xFB6D
  ,simpleTitleCaseMapping:0xFB6D
 },
 { code:0xFB6E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB6E
  ,simpleLowerCaseMapping:0xFB6E
  ,simpleTitleCaseMapping:0xFB6E
 },
 { code:0xFB6F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB6F
  ,simpleLowerCaseMapping:0xFB6F
  ,simpleTitleCaseMapping:0xFB6F
 },
 { code:0xFB70
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB70
  ,simpleLowerCaseMapping:0xFB70
  ,simpleTitleCaseMapping:0xFB70
 },
 { code:0xFB71
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB71
  ,simpleLowerCaseMapping:0xFB71
  ,simpleTitleCaseMapping:0xFB71
 },
 { code:0xFB72
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB72
  ,simpleLowerCaseMapping:0xFB72
  ,simpleTitleCaseMapping:0xFB72
 },
 { code:0xFB73
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB73
  ,simpleLowerCaseMapping:0xFB73
  ,simpleTitleCaseMapping:0xFB73
 },
 { code:0xFB74
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB74
  ,simpleLowerCaseMapping:0xFB74
  ,simpleTitleCaseMapping:0xFB74
 },
 { code:0xFB75
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB75
  ,simpleLowerCaseMapping:0xFB75
  ,simpleTitleCaseMapping:0xFB75
 },
 { code:0xFB76
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB76
  ,simpleLowerCaseMapping:0xFB76
  ,simpleTitleCaseMapping:0xFB76
 },
 { code:0xFB77
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB77
  ,simpleLowerCaseMapping:0xFB77
  ,simpleTitleCaseMapping:0xFB77
 },
 { code:0xFB78
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB78
  ,simpleLowerCaseMapping:0xFB78
  ,simpleTitleCaseMapping:0xFB78
 },
 { code:0xFB79
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB79
  ,simpleLowerCaseMapping:0xFB79
  ,simpleTitleCaseMapping:0xFB79
 },
 { code:0xFB7A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB7A
  ,simpleLowerCaseMapping:0xFB7A
  ,simpleTitleCaseMapping:0xFB7A
 },
 { code:0xFB7B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB7B
  ,simpleLowerCaseMapping:0xFB7B
  ,simpleTitleCaseMapping:0xFB7B
 },
 { code:0xFB7C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB7C
  ,simpleLowerCaseMapping:0xFB7C
  ,simpleTitleCaseMapping:0xFB7C
 },
 { code:0xFB7D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB7D
  ,simpleLowerCaseMapping:0xFB7D
  ,simpleTitleCaseMapping:0xFB7D
 },
 { code:0xFB7E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB7E
  ,simpleLowerCaseMapping:0xFB7E
  ,simpleTitleCaseMapping:0xFB7E
 },
 { code:0xFB7F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB7F
  ,simpleLowerCaseMapping:0xFB7F
  ,simpleTitleCaseMapping:0xFB7F
 },
 { code:0xFB80
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB80
  ,simpleLowerCaseMapping:0xFB80
  ,simpleTitleCaseMapping:0xFB80
 },
 { code:0xFB81
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB81
  ,simpleLowerCaseMapping:0xFB81
  ,simpleTitleCaseMapping:0xFB81
 },
 { code:0xFB82
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB82
  ,simpleLowerCaseMapping:0xFB82
  ,simpleTitleCaseMapping:0xFB82
 },
 { code:0xFB83
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB83
  ,simpleLowerCaseMapping:0xFB83
  ,simpleTitleCaseMapping:0xFB83
 },
 { code:0xFB84
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB84
  ,simpleLowerCaseMapping:0xFB84
  ,simpleTitleCaseMapping:0xFB84
 },
 { code:0xFB85
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB85
  ,simpleLowerCaseMapping:0xFB85
  ,simpleTitleCaseMapping:0xFB85
 },
 { code:0xFB86
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB86
  ,simpleLowerCaseMapping:0xFB86
  ,simpleTitleCaseMapping:0xFB86
 },
 { code:0xFB87
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB87
  ,simpleLowerCaseMapping:0xFB87
  ,simpleTitleCaseMapping:0xFB87
 },
 { code:0xFB88
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB88
  ,simpleLowerCaseMapping:0xFB88
  ,simpleTitleCaseMapping:0xFB88
 },
 { code:0xFB89
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB89
  ,simpleLowerCaseMapping:0xFB89
  ,simpleTitleCaseMapping:0xFB89
 },
 { code:0xFB8A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB8A
  ,simpleLowerCaseMapping:0xFB8A
  ,simpleTitleCaseMapping:0xFB8A
 },
 { code:0xFB8B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB8B
  ,simpleLowerCaseMapping:0xFB8B
  ,simpleTitleCaseMapping:0xFB8B
 },
 { code:0xFB8C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB8C
  ,simpleLowerCaseMapping:0xFB8C
  ,simpleTitleCaseMapping:0xFB8C
 },
 { code:0xFB8D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB8D
  ,simpleLowerCaseMapping:0xFB8D
  ,simpleTitleCaseMapping:0xFB8D
 },
 { code:0xFB8E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB8E
  ,simpleLowerCaseMapping:0xFB8E
  ,simpleTitleCaseMapping:0xFB8E
 },
 { code:0xFB8F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB8F
  ,simpleLowerCaseMapping:0xFB8F
  ,simpleTitleCaseMapping:0xFB8F
 },
 { code:0xFB90
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB90
  ,simpleLowerCaseMapping:0xFB90
  ,simpleTitleCaseMapping:0xFB90
 },
 { code:0xFB91
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB91
  ,simpleLowerCaseMapping:0xFB91
  ,simpleTitleCaseMapping:0xFB91
 },
 { code:0xFB92
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB92
  ,simpleLowerCaseMapping:0xFB92
  ,simpleTitleCaseMapping:0xFB92
 },
 { code:0xFB93
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB93
  ,simpleLowerCaseMapping:0xFB93
  ,simpleTitleCaseMapping:0xFB93
 },
 { code:0xFB94
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB94
  ,simpleLowerCaseMapping:0xFB94
  ,simpleTitleCaseMapping:0xFB94
 },
 { code:0xFB95
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB95
  ,simpleLowerCaseMapping:0xFB95
  ,simpleTitleCaseMapping:0xFB95
 },
 { code:0xFB96
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB96
  ,simpleLowerCaseMapping:0xFB96
  ,simpleTitleCaseMapping:0xFB96
 },
 { code:0xFB97
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB97
  ,simpleLowerCaseMapping:0xFB97
  ,simpleTitleCaseMapping:0xFB97
 },
 { code:0xFB98
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB98
  ,simpleLowerCaseMapping:0xFB98
  ,simpleTitleCaseMapping:0xFB98
 },
 { code:0xFB99
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB99
  ,simpleLowerCaseMapping:0xFB99
  ,simpleTitleCaseMapping:0xFB99
 },
 { code:0xFB9A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB9A
  ,simpleLowerCaseMapping:0xFB9A
  ,simpleTitleCaseMapping:0xFB9A
 },
 { code:0xFB9B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB9B
  ,simpleLowerCaseMapping:0xFB9B
  ,simpleTitleCaseMapping:0xFB9B
 },
 { code:0xFB9C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB9C
  ,simpleLowerCaseMapping:0xFB9C
  ,simpleTitleCaseMapping:0xFB9C
 },
 { code:0xFB9D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB9D
  ,simpleLowerCaseMapping:0xFB9D
  ,simpleTitleCaseMapping:0xFB9D
 },
 { code:0xFB9E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB9E
  ,simpleLowerCaseMapping:0xFB9E
  ,simpleTitleCaseMapping:0xFB9E
 },
 { code:0xFB9F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFB9F
  ,simpleLowerCaseMapping:0xFB9F
  ,simpleTitleCaseMapping:0xFB9F
 },
 { code:0xFBA0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBA0
  ,simpleLowerCaseMapping:0xFBA0
  ,simpleTitleCaseMapping:0xFBA0
 },
 { code:0xFBA1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBA1
  ,simpleLowerCaseMapping:0xFBA1
  ,simpleTitleCaseMapping:0xFBA1
 },
 { code:0xFBA2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBA2
  ,simpleLowerCaseMapping:0xFBA2
  ,simpleTitleCaseMapping:0xFBA2
 },
 { code:0xFBA3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBA3
  ,simpleLowerCaseMapping:0xFBA3
  ,simpleTitleCaseMapping:0xFBA3
 },
 { code:0xFBA4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBA4
  ,simpleLowerCaseMapping:0xFBA4
  ,simpleTitleCaseMapping:0xFBA4
 },
 { code:0xFBA5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBA5
  ,simpleLowerCaseMapping:0xFBA5
  ,simpleTitleCaseMapping:0xFBA5
 },
 { code:0xFBA6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBA6
  ,simpleLowerCaseMapping:0xFBA6
  ,simpleTitleCaseMapping:0xFBA6
 },
 { code:0xFBA7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBA7
  ,simpleLowerCaseMapping:0xFBA7
  ,simpleTitleCaseMapping:0xFBA7
 },
 { code:0xFBA8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBA8
  ,simpleLowerCaseMapping:0xFBA8
  ,simpleTitleCaseMapping:0xFBA8
 },
 { code:0xFBA9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBA9
  ,simpleLowerCaseMapping:0xFBA9
  ,simpleTitleCaseMapping:0xFBA9
 },
 { code:0xFBAA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBAA
  ,simpleLowerCaseMapping:0xFBAA
  ,simpleTitleCaseMapping:0xFBAA
 },
 { code:0xFBAB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBAB
  ,simpleLowerCaseMapping:0xFBAB
  ,simpleTitleCaseMapping:0xFBAB
 },
 { code:0xFBAC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBAC
  ,simpleLowerCaseMapping:0xFBAC
  ,simpleTitleCaseMapping:0xFBAC
 },
 { code:0xFBAD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBAD
  ,simpleLowerCaseMapping:0xFBAD
  ,simpleTitleCaseMapping:0xFBAD
 },
 { code:0xFBAE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBAE
  ,simpleLowerCaseMapping:0xFBAE
  ,simpleTitleCaseMapping:0xFBAE
 },
 { code:0xFBAF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBAF
  ,simpleLowerCaseMapping:0xFBAF
  ,simpleTitleCaseMapping:0xFBAF
 },
 { code:0xFBB0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBB0
  ,simpleLowerCaseMapping:0xFBB0
  ,simpleTitleCaseMapping:0xFBB0
 },
 { code:0xFBB1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBB1
  ,simpleLowerCaseMapping:0xFBB1
  ,simpleTitleCaseMapping:0xFBB1
 },
 { code:0xFBD3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBD3
  ,simpleLowerCaseMapping:0xFBD3
  ,simpleTitleCaseMapping:0xFBD3
 },
 { code:0xFBD4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBD4
  ,simpleLowerCaseMapping:0xFBD4
  ,simpleTitleCaseMapping:0xFBD4
 },
 { code:0xFBD5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBD5
  ,simpleLowerCaseMapping:0xFBD5
  ,simpleTitleCaseMapping:0xFBD5
 },
 { code:0xFBD6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBD6
  ,simpleLowerCaseMapping:0xFBD6
  ,simpleTitleCaseMapping:0xFBD6
 },
 { code:0xFBD7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBD7
  ,simpleLowerCaseMapping:0xFBD7
  ,simpleTitleCaseMapping:0xFBD7
 },
 { code:0xFBD8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBD8
  ,simpleLowerCaseMapping:0xFBD8
  ,simpleTitleCaseMapping:0xFBD8
 },
 { code:0xFBD9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBD9
  ,simpleLowerCaseMapping:0xFBD9
  ,simpleTitleCaseMapping:0xFBD9
 },
 { code:0xFBDA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBDA
  ,simpleLowerCaseMapping:0xFBDA
  ,simpleTitleCaseMapping:0xFBDA
 },
 { code:0xFBDB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBDB
  ,simpleLowerCaseMapping:0xFBDB
  ,simpleTitleCaseMapping:0xFBDB
 },
 { code:0xFBDC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBDC
  ,simpleLowerCaseMapping:0xFBDC
  ,simpleTitleCaseMapping:0xFBDC
 },
 { code:0xFBDD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBDD
  ,simpleLowerCaseMapping:0xFBDD
  ,simpleTitleCaseMapping:0xFBDD
 },
 { code:0xFBDE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBDE
  ,simpleLowerCaseMapping:0xFBDE
  ,simpleTitleCaseMapping:0xFBDE
 },
 { code:0xFBDF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBDF
  ,simpleLowerCaseMapping:0xFBDF
  ,simpleTitleCaseMapping:0xFBDF
 },
 { code:0xFBE0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBE0
  ,simpleLowerCaseMapping:0xFBE0
  ,simpleTitleCaseMapping:0xFBE0
 },
 { code:0xFBE1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBE1
  ,simpleLowerCaseMapping:0xFBE1
  ,simpleTitleCaseMapping:0xFBE1
 },
 { code:0xFBE2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBE2
  ,simpleLowerCaseMapping:0xFBE2
  ,simpleTitleCaseMapping:0xFBE2
 },
 { code:0xFBE3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBE3
  ,simpleLowerCaseMapping:0xFBE3
  ,simpleTitleCaseMapping:0xFBE3
 },
 { code:0xFBE4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBE4
  ,simpleLowerCaseMapping:0xFBE4
  ,simpleTitleCaseMapping:0xFBE4
 },
 { code:0xFBE5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBE5
  ,simpleLowerCaseMapping:0xFBE5
  ,simpleTitleCaseMapping:0xFBE5
 },
 { code:0xFBE6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBE6
  ,simpleLowerCaseMapping:0xFBE6
  ,simpleTitleCaseMapping:0xFBE6
 },
 { code:0xFBE7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBE7
  ,simpleLowerCaseMapping:0xFBE7
  ,simpleTitleCaseMapping:0xFBE7
 },
 { code:0xFBE8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBE8
  ,simpleLowerCaseMapping:0xFBE8
  ,simpleTitleCaseMapping:0xFBE8
 },
 { code:0xFBE9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBE9
  ,simpleLowerCaseMapping:0xFBE9
  ,simpleTitleCaseMapping:0xFBE9
 },
 { code:0xFBEA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBEA
  ,simpleLowerCaseMapping:0xFBEA
  ,simpleTitleCaseMapping:0xFBEA
 },
 { code:0xFBEB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBEB
  ,simpleLowerCaseMapping:0xFBEB
  ,simpleTitleCaseMapping:0xFBEB
 },
 { code:0xFBEC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBEC
  ,simpleLowerCaseMapping:0xFBEC
  ,simpleTitleCaseMapping:0xFBEC
 },
 { code:0xFBED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBED
  ,simpleLowerCaseMapping:0xFBED
  ,simpleTitleCaseMapping:0xFBED
 },
 { code:0xFBEE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBEE
  ,simpleLowerCaseMapping:0xFBEE
  ,simpleTitleCaseMapping:0xFBEE
 },
 { code:0xFBEF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBEF
  ,simpleLowerCaseMapping:0xFBEF
  ,simpleTitleCaseMapping:0xFBEF
 },
 { code:0xFBF0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBF0
  ,simpleLowerCaseMapping:0xFBF0
  ,simpleTitleCaseMapping:0xFBF0
 },
 { code:0xFBF1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBF1
  ,simpleLowerCaseMapping:0xFBF1
  ,simpleTitleCaseMapping:0xFBF1
 },
 { code:0xFBF2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBF2
  ,simpleLowerCaseMapping:0xFBF2
  ,simpleTitleCaseMapping:0xFBF2
 },
 { code:0xFBF3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBF3
  ,simpleLowerCaseMapping:0xFBF3
  ,simpleTitleCaseMapping:0xFBF3
 },
 { code:0xFBF4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBF4
  ,simpleLowerCaseMapping:0xFBF4
  ,simpleTitleCaseMapping:0xFBF4
 },
 { code:0xFBF5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBF5
  ,simpleLowerCaseMapping:0xFBF5
  ,simpleTitleCaseMapping:0xFBF5
 },
 { code:0xFBF6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBF6
  ,simpleLowerCaseMapping:0xFBF6
  ,simpleTitleCaseMapping:0xFBF6
 },
 { code:0xFBF7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBF7
  ,simpleLowerCaseMapping:0xFBF7
  ,simpleTitleCaseMapping:0xFBF7
 },
 { code:0xFBF8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBF8
  ,simpleLowerCaseMapping:0xFBF8
  ,simpleTitleCaseMapping:0xFBF8
 },
 { code:0xFBF9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBF9
  ,simpleLowerCaseMapping:0xFBF9
  ,simpleTitleCaseMapping:0xFBF9
 },
 { code:0xFBFA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBFA
  ,simpleLowerCaseMapping:0xFBFA
  ,simpleTitleCaseMapping:0xFBFA
 },
 { code:0xFBFB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBFB
  ,simpleLowerCaseMapping:0xFBFB
  ,simpleTitleCaseMapping:0xFBFB
 },
 { code:0xFBFC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBFC
  ,simpleLowerCaseMapping:0xFBFC
  ,simpleTitleCaseMapping:0xFBFC
 },
 { code:0xFBFD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBFD
  ,simpleLowerCaseMapping:0xFBFD
  ,simpleTitleCaseMapping:0xFBFD
 },
 { code:0xFBFE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBFE
  ,simpleLowerCaseMapping:0xFBFE
  ,simpleTitleCaseMapping:0xFBFE
 },
 { code:0xFBFF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFBFF
  ,simpleLowerCaseMapping:0xFBFF
  ,simpleTitleCaseMapping:0xFBFF
 },
 { code:0xFC00
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC00
  ,simpleLowerCaseMapping:0xFC00
  ,simpleTitleCaseMapping:0xFC00
 },
 { code:0xFC01
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC01
  ,simpleLowerCaseMapping:0xFC01
  ,simpleTitleCaseMapping:0xFC01
 },
 { code:0xFC02
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC02
  ,simpleLowerCaseMapping:0xFC02
  ,simpleTitleCaseMapping:0xFC02
 },
 { code:0xFC03
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC03
  ,simpleLowerCaseMapping:0xFC03
  ,simpleTitleCaseMapping:0xFC03
 },
 { code:0xFC04
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC04
  ,simpleLowerCaseMapping:0xFC04
  ,simpleTitleCaseMapping:0xFC04
 },
 { code:0xFC05
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC05
  ,simpleLowerCaseMapping:0xFC05
  ,simpleTitleCaseMapping:0xFC05
 },
 { code:0xFC06
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC06
  ,simpleLowerCaseMapping:0xFC06
  ,simpleTitleCaseMapping:0xFC06
 },
 { code:0xFC07
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC07
  ,simpleLowerCaseMapping:0xFC07
  ,simpleTitleCaseMapping:0xFC07
 },
 { code:0xFC08
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC08
  ,simpleLowerCaseMapping:0xFC08
  ,simpleTitleCaseMapping:0xFC08
 },
 { code:0xFC09
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC09
  ,simpleLowerCaseMapping:0xFC09
  ,simpleTitleCaseMapping:0xFC09
 },
 { code:0xFC0A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC0A
  ,simpleLowerCaseMapping:0xFC0A
  ,simpleTitleCaseMapping:0xFC0A
 },
 { code:0xFC0B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC0B
  ,simpleLowerCaseMapping:0xFC0B
  ,simpleTitleCaseMapping:0xFC0B
 },
 { code:0xFC0C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC0C
  ,simpleLowerCaseMapping:0xFC0C
  ,simpleTitleCaseMapping:0xFC0C
 },
 { code:0xFC0D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC0D
  ,simpleLowerCaseMapping:0xFC0D
  ,simpleTitleCaseMapping:0xFC0D
 },
 { code:0xFC0E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC0E
  ,simpleLowerCaseMapping:0xFC0E
  ,simpleTitleCaseMapping:0xFC0E
 },
 { code:0xFC0F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC0F
  ,simpleLowerCaseMapping:0xFC0F
  ,simpleTitleCaseMapping:0xFC0F
 },
 { code:0xFC10
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC10
  ,simpleLowerCaseMapping:0xFC10
  ,simpleTitleCaseMapping:0xFC10
 },
 { code:0xFC11
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC11
  ,simpleLowerCaseMapping:0xFC11
  ,simpleTitleCaseMapping:0xFC11
 },
 { code:0xFC12
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC12
  ,simpleLowerCaseMapping:0xFC12
  ,simpleTitleCaseMapping:0xFC12
 },
 { code:0xFC13
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC13
  ,simpleLowerCaseMapping:0xFC13
  ,simpleTitleCaseMapping:0xFC13
 },
 { code:0xFC14
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC14
  ,simpleLowerCaseMapping:0xFC14
  ,simpleTitleCaseMapping:0xFC14
 },
 { code:0xFC15
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC15
  ,simpleLowerCaseMapping:0xFC15
  ,simpleTitleCaseMapping:0xFC15
 },
 { code:0xFC16
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC16
  ,simpleLowerCaseMapping:0xFC16
  ,simpleTitleCaseMapping:0xFC16
 },
 { code:0xFC17
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC17
  ,simpleLowerCaseMapping:0xFC17
  ,simpleTitleCaseMapping:0xFC17
 },
 { code:0xFC18
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC18
  ,simpleLowerCaseMapping:0xFC18
  ,simpleTitleCaseMapping:0xFC18
 },
 { code:0xFC19
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC19
  ,simpleLowerCaseMapping:0xFC19
  ,simpleTitleCaseMapping:0xFC19
 },
 { code:0xFC1A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC1A
  ,simpleLowerCaseMapping:0xFC1A
  ,simpleTitleCaseMapping:0xFC1A
 },
 { code:0xFC1B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC1B
  ,simpleLowerCaseMapping:0xFC1B
  ,simpleTitleCaseMapping:0xFC1B
 },
 { code:0xFC1C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC1C
  ,simpleLowerCaseMapping:0xFC1C
  ,simpleTitleCaseMapping:0xFC1C
 },
 { code:0xFC1D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC1D
  ,simpleLowerCaseMapping:0xFC1D
  ,simpleTitleCaseMapping:0xFC1D
 },
 { code:0xFC1E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC1E
  ,simpleLowerCaseMapping:0xFC1E
  ,simpleTitleCaseMapping:0xFC1E
 },
 { code:0xFC1F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC1F
  ,simpleLowerCaseMapping:0xFC1F
  ,simpleTitleCaseMapping:0xFC1F
 },
 { code:0xFC20
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC20
  ,simpleLowerCaseMapping:0xFC20
  ,simpleTitleCaseMapping:0xFC20
 },
 { code:0xFC21
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC21
  ,simpleLowerCaseMapping:0xFC21
  ,simpleTitleCaseMapping:0xFC21
 },
 { code:0xFC22
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC22
  ,simpleLowerCaseMapping:0xFC22
  ,simpleTitleCaseMapping:0xFC22
 },
 { code:0xFC23
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC23
  ,simpleLowerCaseMapping:0xFC23
  ,simpleTitleCaseMapping:0xFC23
 },
 { code:0xFC24
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC24
  ,simpleLowerCaseMapping:0xFC24
  ,simpleTitleCaseMapping:0xFC24
 },
 { code:0xFC25
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC25
  ,simpleLowerCaseMapping:0xFC25
  ,simpleTitleCaseMapping:0xFC25
 },
 { code:0xFC26
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC26
  ,simpleLowerCaseMapping:0xFC26
  ,simpleTitleCaseMapping:0xFC26
 },
 { code:0xFC27
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC27
  ,simpleLowerCaseMapping:0xFC27
  ,simpleTitleCaseMapping:0xFC27
 },
 { code:0xFC28
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC28
  ,simpleLowerCaseMapping:0xFC28
  ,simpleTitleCaseMapping:0xFC28
 },
 { code:0xFC29
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC29
  ,simpleLowerCaseMapping:0xFC29
  ,simpleTitleCaseMapping:0xFC29
 },
 { code:0xFC2A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC2A
  ,simpleLowerCaseMapping:0xFC2A
  ,simpleTitleCaseMapping:0xFC2A
 },
 { code:0xFC2B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC2B
  ,simpleLowerCaseMapping:0xFC2B
  ,simpleTitleCaseMapping:0xFC2B
 },
 { code:0xFC2C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC2C
  ,simpleLowerCaseMapping:0xFC2C
  ,simpleTitleCaseMapping:0xFC2C
 },
 { code:0xFC2D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC2D
  ,simpleLowerCaseMapping:0xFC2D
  ,simpleTitleCaseMapping:0xFC2D
 },
 { code:0xFC2E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC2E
  ,simpleLowerCaseMapping:0xFC2E
  ,simpleTitleCaseMapping:0xFC2E
 },
 { code:0xFC2F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC2F
  ,simpleLowerCaseMapping:0xFC2F
  ,simpleTitleCaseMapping:0xFC2F
 },
 { code:0xFC30
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC30
  ,simpleLowerCaseMapping:0xFC30
  ,simpleTitleCaseMapping:0xFC30
 },
 { code:0xFC31
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC31
  ,simpleLowerCaseMapping:0xFC31
  ,simpleTitleCaseMapping:0xFC31
 },
 { code:0xFC32
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC32
  ,simpleLowerCaseMapping:0xFC32
  ,simpleTitleCaseMapping:0xFC32
 },
 { code:0xFC33
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC33
  ,simpleLowerCaseMapping:0xFC33
  ,simpleTitleCaseMapping:0xFC33
 },
 { code:0xFC34
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC34
  ,simpleLowerCaseMapping:0xFC34
  ,simpleTitleCaseMapping:0xFC34
 },
 { code:0xFC35
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC35
  ,simpleLowerCaseMapping:0xFC35
  ,simpleTitleCaseMapping:0xFC35
 },
 { code:0xFC36
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC36
  ,simpleLowerCaseMapping:0xFC36
  ,simpleTitleCaseMapping:0xFC36
 },
 { code:0xFC37
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC37
  ,simpleLowerCaseMapping:0xFC37
  ,simpleTitleCaseMapping:0xFC37
 },
 { code:0xFC38
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC38
  ,simpleLowerCaseMapping:0xFC38
  ,simpleTitleCaseMapping:0xFC38
 },
 { code:0xFC39
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC39
  ,simpleLowerCaseMapping:0xFC39
  ,simpleTitleCaseMapping:0xFC39
 },
 { code:0xFC3A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC3A
  ,simpleLowerCaseMapping:0xFC3A
  ,simpleTitleCaseMapping:0xFC3A
 },
 { code:0xFC3B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC3B
  ,simpleLowerCaseMapping:0xFC3B
  ,simpleTitleCaseMapping:0xFC3B
 },
 { code:0xFC3C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC3C
  ,simpleLowerCaseMapping:0xFC3C
  ,simpleTitleCaseMapping:0xFC3C
 },
 { code:0xFC3D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC3D
  ,simpleLowerCaseMapping:0xFC3D
  ,simpleTitleCaseMapping:0xFC3D
 },
 { code:0xFC3E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC3E
  ,simpleLowerCaseMapping:0xFC3E
  ,simpleTitleCaseMapping:0xFC3E
 },
 { code:0xFC3F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC3F
  ,simpleLowerCaseMapping:0xFC3F
  ,simpleTitleCaseMapping:0xFC3F
 },
 { code:0xFC40
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC40
  ,simpleLowerCaseMapping:0xFC40
  ,simpleTitleCaseMapping:0xFC40
 },
 { code:0xFC41
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC41
  ,simpleLowerCaseMapping:0xFC41
  ,simpleTitleCaseMapping:0xFC41
 },
 { code:0xFC42
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC42
  ,simpleLowerCaseMapping:0xFC42
  ,simpleTitleCaseMapping:0xFC42
 },
 { code:0xFC43
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC43
  ,simpleLowerCaseMapping:0xFC43
  ,simpleTitleCaseMapping:0xFC43
 },
 { code:0xFC44
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC44
  ,simpleLowerCaseMapping:0xFC44
  ,simpleTitleCaseMapping:0xFC44
 },
 { code:0xFC45
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC45
  ,simpleLowerCaseMapping:0xFC45
  ,simpleTitleCaseMapping:0xFC45
 },
 { code:0xFC46
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC46
  ,simpleLowerCaseMapping:0xFC46
  ,simpleTitleCaseMapping:0xFC46
 },
 { code:0xFC47
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC47
  ,simpleLowerCaseMapping:0xFC47
  ,simpleTitleCaseMapping:0xFC47
 },
 { code:0xFC48
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC48
  ,simpleLowerCaseMapping:0xFC48
  ,simpleTitleCaseMapping:0xFC48
 },
 { code:0xFC49
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC49
  ,simpleLowerCaseMapping:0xFC49
  ,simpleTitleCaseMapping:0xFC49
 },
 { code:0xFC4A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC4A
  ,simpleLowerCaseMapping:0xFC4A
  ,simpleTitleCaseMapping:0xFC4A
 },
 { code:0xFC4B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC4B
  ,simpleLowerCaseMapping:0xFC4B
  ,simpleTitleCaseMapping:0xFC4B
 },
 { code:0xFC4C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC4C
  ,simpleLowerCaseMapping:0xFC4C
  ,simpleTitleCaseMapping:0xFC4C
 },
 { code:0xFC4D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC4D
  ,simpleLowerCaseMapping:0xFC4D
  ,simpleTitleCaseMapping:0xFC4D
 },
 { code:0xFC4E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC4E
  ,simpleLowerCaseMapping:0xFC4E
  ,simpleTitleCaseMapping:0xFC4E
 },
 { code:0xFC4F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC4F
  ,simpleLowerCaseMapping:0xFC4F
  ,simpleTitleCaseMapping:0xFC4F
 },
 { code:0xFC50
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC50
  ,simpleLowerCaseMapping:0xFC50
  ,simpleTitleCaseMapping:0xFC50
 },
 { code:0xFC51
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC51
  ,simpleLowerCaseMapping:0xFC51
  ,simpleTitleCaseMapping:0xFC51
 },
 { code:0xFC52
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC52
  ,simpleLowerCaseMapping:0xFC52
  ,simpleTitleCaseMapping:0xFC52
 },
 { code:0xFC53
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC53
  ,simpleLowerCaseMapping:0xFC53
  ,simpleTitleCaseMapping:0xFC53
 },
 { code:0xFC54
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC54
  ,simpleLowerCaseMapping:0xFC54
  ,simpleTitleCaseMapping:0xFC54
 },
 { code:0xFC55
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC55
  ,simpleLowerCaseMapping:0xFC55
  ,simpleTitleCaseMapping:0xFC55
 },
 { code:0xFC56
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC56
  ,simpleLowerCaseMapping:0xFC56
  ,simpleTitleCaseMapping:0xFC56
 },
 { code:0xFC57
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC57
  ,simpleLowerCaseMapping:0xFC57
  ,simpleTitleCaseMapping:0xFC57
 },
 { code:0xFC58
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC58
  ,simpleLowerCaseMapping:0xFC58
  ,simpleTitleCaseMapping:0xFC58
 },
 { code:0xFC59
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC59
  ,simpleLowerCaseMapping:0xFC59
  ,simpleTitleCaseMapping:0xFC59
 },
 { code:0xFC5A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC5A
  ,simpleLowerCaseMapping:0xFC5A
  ,simpleTitleCaseMapping:0xFC5A
 },
 { code:0xFC5B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC5B
  ,simpleLowerCaseMapping:0xFC5B
  ,simpleTitleCaseMapping:0xFC5B
 },
 { code:0xFC5C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC5C
  ,simpleLowerCaseMapping:0xFC5C
  ,simpleTitleCaseMapping:0xFC5C
 },
 { code:0xFC5D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC5D
  ,simpleLowerCaseMapping:0xFC5D
  ,simpleTitleCaseMapping:0xFC5D
 },
 { code:0xFC5E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC5E
  ,simpleLowerCaseMapping:0xFC5E
  ,simpleTitleCaseMapping:0xFC5E
 },
 { code:0xFC5F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC5F
  ,simpleLowerCaseMapping:0xFC5F
  ,simpleTitleCaseMapping:0xFC5F
 },
 { code:0xFC60
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC60
  ,simpleLowerCaseMapping:0xFC60
  ,simpleTitleCaseMapping:0xFC60
 },
 { code:0xFC61
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC61
  ,simpleLowerCaseMapping:0xFC61
  ,simpleTitleCaseMapping:0xFC61
 },
 { code:0xFC62
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC62
  ,simpleLowerCaseMapping:0xFC62
  ,simpleTitleCaseMapping:0xFC62
 },
 { code:0xFC63
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC63
  ,simpleLowerCaseMapping:0xFC63
  ,simpleTitleCaseMapping:0xFC63
 },
 { code:0xFC64
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC64
  ,simpleLowerCaseMapping:0xFC64
  ,simpleTitleCaseMapping:0xFC64
 },
 { code:0xFC65
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC65
  ,simpleLowerCaseMapping:0xFC65
  ,simpleTitleCaseMapping:0xFC65
 },
 { code:0xFC66
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC66
  ,simpleLowerCaseMapping:0xFC66
  ,simpleTitleCaseMapping:0xFC66
 },
 { code:0xFC67
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC67
  ,simpleLowerCaseMapping:0xFC67
  ,simpleTitleCaseMapping:0xFC67
 },
 { code:0xFC68
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC68
  ,simpleLowerCaseMapping:0xFC68
  ,simpleTitleCaseMapping:0xFC68
 },
 { code:0xFC69
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC69
  ,simpleLowerCaseMapping:0xFC69
  ,simpleTitleCaseMapping:0xFC69
 },
 { code:0xFC6A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC6A
  ,simpleLowerCaseMapping:0xFC6A
  ,simpleTitleCaseMapping:0xFC6A
 },
 { code:0xFC6B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC6B
  ,simpleLowerCaseMapping:0xFC6B
  ,simpleTitleCaseMapping:0xFC6B
 },
 { code:0xFC6C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC6C
  ,simpleLowerCaseMapping:0xFC6C
  ,simpleTitleCaseMapping:0xFC6C
 },
 { code:0xFC6D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC6D
  ,simpleLowerCaseMapping:0xFC6D
  ,simpleTitleCaseMapping:0xFC6D
 },
 { code:0xFC6E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC6E
  ,simpleLowerCaseMapping:0xFC6E
  ,simpleTitleCaseMapping:0xFC6E
 },
 { code:0xFC6F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC6F
  ,simpleLowerCaseMapping:0xFC6F
  ,simpleTitleCaseMapping:0xFC6F
 },
 { code:0xFC70
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC70
  ,simpleLowerCaseMapping:0xFC70
  ,simpleTitleCaseMapping:0xFC70
 },
 { code:0xFC71
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC71
  ,simpleLowerCaseMapping:0xFC71
  ,simpleTitleCaseMapping:0xFC71
 },
 { code:0xFC72
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC72
  ,simpleLowerCaseMapping:0xFC72
  ,simpleTitleCaseMapping:0xFC72
 },
 { code:0xFC73
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC73
  ,simpleLowerCaseMapping:0xFC73
  ,simpleTitleCaseMapping:0xFC73
 },
 { code:0xFC74
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC74
  ,simpleLowerCaseMapping:0xFC74
  ,simpleTitleCaseMapping:0xFC74
 },
 { code:0xFC75
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC75
  ,simpleLowerCaseMapping:0xFC75
  ,simpleTitleCaseMapping:0xFC75
 },
 { code:0xFC76
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC76
  ,simpleLowerCaseMapping:0xFC76
  ,simpleTitleCaseMapping:0xFC76
 },
 { code:0xFC77
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC77
  ,simpleLowerCaseMapping:0xFC77
  ,simpleTitleCaseMapping:0xFC77
 },
 { code:0xFC78
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC78
  ,simpleLowerCaseMapping:0xFC78
  ,simpleTitleCaseMapping:0xFC78
 },
 { code:0xFC79
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC79
  ,simpleLowerCaseMapping:0xFC79
  ,simpleTitleCaseMapping:0xFC79
 },
 { code:0xFC7A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC7A
  ,simpleLowerCaseMapping:0xFC7A
  ,simpleTitleCaseMapping:0xFC7A
 },
 { code:0xFC7B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC7B
  ,simpleLowerCaseMapping:0xFC7B
  ,simpleTitleCaseMapping:0xFC7B
 },
 { code:0xFC7C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC7C
  ,simpleLowerCaseMapping:0xFC7C
  ,simpleTitleCaseMapping:0xFC7C
 },
 { code:0xFC7D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC7D
  ,simpleLowerCaseMapping:0xFC7D
  ,simpleTitleCaseMapping:0xFC7D
 },
 { code:0xFC7E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC7E
  ,simpleLowerCaseMapping:0xFC7E
  ,simpleTitleCaseMapping:0xFC7E
 },
 { code:0xFC7F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC7F
  ,simpleLowerCaseMapping:0xFC7F
  ,simpleTitleCaseMapping:0xFC7F
 },
 { code:0xFC80
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC80
  ,simpleLowerCaseMapping:0xFC80
  ,simpleTitleCaseMapping:0xFC80
 },
 { code:0xFC81
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC81
  ,simpleLowerCaseMapping:0xFC81
  ,simpleTitleCaseMapping:0xFC81
 },
 { code:0xFC82
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC82
  ,simpleLowerCaseMapping:0xFC82
  ,simpleTitleCaseMapping:0xFC82
 },
 { code:0xFC83
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC83
  ,simpleLowerCaseMapping:0xFC83
  ,simpleTitleCaseMapping:0xFC83
 },
 { code:0xFC84
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC84
  ,simpleLowerCaseMapping:0xFC84
  ,simpleTitleCaseMapping:0xFC84
 },
 { code:0xFC85
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC85
  ,simpleLowerCaseMapping:0xFC85
  ,simpleTitleCaseMapping:0xFC85
 },
 { code:0xFC86
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC86
  ,simpleLowerCaseMapping:0xFC86
  ,simpleTitleCaseMapping:0xFC86
 },
 { code:0xFC87
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC87
  ,simpleLowerCaseMapping:0xFC87
  ,simpleTitleCaseMapping:0xFC87
 },
 { code:0xFC88
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC88
  ,simpleLowerCaseMapping:0xFC88
  ,simpleTitleCaseMapping:0xFC88
 },
 { code:0xFC89
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC89
  ,simpleLowerCaseMapping:0xFC89
  ,simpleTitleCaseMapping:0xFC89
 },
 { code:0xFC8A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC8A
  ,simpleLowerCaseMapping:0xFC8A
  ,simpleTitleCaseMapping:0xFC8A
 },
 { code:0xFC8B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC8B
  ,simpleLowerCaseMapping:0xFC8B
  ,simpleTitleCaseMapping:0xFC8B
 },
 { code:0xFC8C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC8C
  ,simpleLowerCaseMapping:0xFC8C
  ,simpleTitleCaseMapping:0xFC8C
 },
 { code:0xFC8D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC8D
  ,simpleLowerCaseMapping:0xFC8D
  ,simpleTitleCaseMapping:0xFC8D
 },
 { code:0xFC8E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC8E
  ,simpleLowerCaseMapping:0xFC8E
  ,simpleTitleCaseMapping:0xFC8E
 },
 { code:0xFC8F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC8F
  ,simpleLowerCaseMapping:0xFC8F
  ,simpleTitleCaseMapping:0xFC8F
 },
 { code:0xFC90
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC90
  ,simpleLowerCaseMapping:0xFC90
  ,simpleTitleCaseMapping:0xFC90
 },
 { code:0xFC91
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC91
  ,simpleLowerCaseMapping:0xFC91
  ,simpleTitleCaseMapping:0xFC91
 },
 { code:0xFC92
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC92
  ,simpleLowerCaseMapping:0xFC92
  ,simpleTitleCaseMapping:0xFC92
 },
 { code:0xFC93
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC93
  ,simpleLowerCaseMapping:0xFC93
  ,simpleTitleCaseMapping:0xFC93
 },
 { code:0xFC94
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC94
  ,simpleLowerCaseMapping:0xFC94
  ,simpleTitleCaseMapping:0xFC94
 },
 { code:0xFC95
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC95
  ,simpleLowerCaseMapping:0xFC95
  ,simpleTitleCaseMapping:0xFC95
 },
 { code:0xFC96
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC96
  ,simpleLowerCaseMapping:0xFC96
  ,simpleTitleCaseMapping:0xFC96
 },
 { code:0xFC97
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC97
  ,simpleLowerCaseMapping:0xFC97
  ,simpleTitleCaseMapping:0xFC97
 },
 { code:0xFC98
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC98
  ,simpleLowerCaseMapping:0xFC98
  ,simpleTitleCaseMapping:0xFC98
 },
 { code:0xFC99
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC99
  ,simpleLowerCaseMapping:0xFC99
  ,simpleTitleCaseMapping:0xFC99
 },
 { code:0xFC9A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC9A
  ,simpleLowerCaseMapping:0xFC9A
  ,simpleTitleCaseMapping:0xFC9A
 },
 { code:0xFC9B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC9B
  ,simpleLowerCaseMapping:0xFC9B
  ,simpleTitleCaseMapping:0xFC9B
 },
 { code:0xFC9C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC9C
  ,simpleLowerCaseMapping:0xFC9C
  ,simpleTitleCaseMapping:0xFC9C
 },
 { code:0xFC9D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC9D
  ,simpleLowerCaseMapping:0xFC9D
  ,simpleTitleCaseMapping:0xFC9D
 },
 { code:0xFC9E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC9E
  ,simpleLowerCaseMapping:0xFC9E
  ,simpleTitleCaseMapping:0xFC9E
 },
 { code:0xFC9F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFC9F
  ,simpleLowerCaseMapping:0xFC9F
  ,simpleTitleCaseMapping:0xFC9F
 },
 { code:0xFCA0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCA0
  ,simpleLowerCaseMapping:0xFCA0
  ,simpleTitleCaseMapping:0xFCA0
 },
 { code:0xFCA1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCA1
  ,simpleLowerCaseMapping:0xFCA1
  ,simpleTitleCaseMapping:0xFCA1
 },
 { code:0xFCA2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCA2
  ,simpleLowerCaseMapping:0xFCA2
  ,simpleTitleCaseMapping:0xFCA2
 },
 { code:0xFCA3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCA3
  ,simpleLowerCaseMapping:0xFCA3
  ,simpleTitleCaseMapping:0xFCA3
 },
 { code:0xFCA4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCA4
  ,simpleLowerCaseMapping:0xFCA4
  ,simpleTitleCaseMapping:0xFCA4
 },
 { code:0xFCA5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCA5
  ,simpleLowerCaseMapping:0xFCA5
  ,simpleTitleCaseMapping:0xFCA5
 },
 { code:0xFCA6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCA6
  ,simpleLowerCaseMapping:0xFCA6
  ,simpleTitleCaseMapping:0xFCA6
 },
 { code:0xFCA7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCA7
  ,simpleLowerCaseMapping:0xFCA7
  ,simpleTitleCaseMapping:0xFCA7
 },
 { code:0xFCA8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCA8
  ,simpleLowerCaseMapping:0xFCA8
  ,simpleTitleCaseMapping:0xFCA8
 },
 { code:0xFCA9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCA9
  ,simpleLowerCaseMapping:0xFCA9
  ,simpleTitleCaseMapping:0xFCA9
 },
 { code:0xFCAA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCAA
  ,simpleLowerCaseMapping:0xFCAA
  ,simpleTitleCaseMapping:0xFCAA
 },
 { code:0xFCAB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCAB
  ,simpleLowerCaseMapping:0xFCAB
  ,simpleTitleCaseMapping:0xFCAB
 },
 { code:0xFCAC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCAC
  ,simpleLowerCaseMapping:0xFCAC
  ,simpleTitleCaseMapping:0xFCAC
 },
 { code:0xFCAD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCAD
  ,simpleLowerCaseMapping:0xFCAD
  ,simpleTitleCaseMapping:0xFCAD
 },
 { code:0xFCAE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCAE
  ,simpleLowerCaseMapping:0xFCAE
  ,simpleTitleCaseMapping:0xFCAE
 },
 { code:0xFCAF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCAF
  ,simpleLowerCaseMapping:0xFCAF
  ,simpleTitleCaseMapping:0xFCAF
 },
 { code:0xFCB0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCB0
  ,simpleLowerCaseMapping:0xFCB0
  ,simpleTitleCaseMapping:0xFCB0
 },
 { code:0xFCB1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCB1
  ,simpleLowerCaseMapping:0xFCB1
  ,simpleTitleCaseMapping:0xFCB1
 },
 { code:0xFCB2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCB2
  ,simpleLowerCaseMapping:0xFCB2
  ,simpleTitleCaseMapping:0xFCB2
 },
 { code:0xFCB3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCB3
  ,simpleLowerCaseMapping:0xFCB3
  ,simpleTitleCaseMapping:0xFCB3
 },
 { code:0xFCB4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCB4
  ,simpleLowerCaseMapping:0xFCB4
  ,simpleTitleCaseMapping:0xFCB4
 },
 { code:0xFCB5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCB5
  ,simpleLowerCaseMapping:0xFCB5
  ,simpleTitleCaseMapping:0xFCB5
 },
 { code:0xFCB6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCB6
  ,simpleLowerCaseMapping:0xFCB6
  ,simpleTitleCaseMapping:0xFCB6
 },
 { code:0xFCB7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCB7
  ,simpleLowerCaseMapping:0xFCB7
  ,simpleTitleCaseMapping:0xFCB7
 },
 { code:0xFCB8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCB8
  ,simpleLowerCaseMapping:0xFCB8
  ,simpleTitleCaseMapping:0xFCB8
 },
 { code:0xFCB9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCB9
  ,simpleLowerCaseMapping:0xFCB9
  ,simpleTitleCaseMapping:0xFCB9
 },
 { code:0xFCBA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCBA
  ,simpleLowerCaseMapping:0xFCBA
  ,simpleTitleCaseMapping:0xFCBA
 },
 { code:0xFCBB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCBB
  ,simpleLowerCaseMapping:0xFCBB
  ,simpleTitleCaseMapping:0xFCBB
 },
 { code:0xFCBC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCBC
  ,simpleLowerCaseMapping:0xFCBC
  ,simpleTitleCaseMapping:0xFCBC
 },
 { code:0xFCBD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCBD
  ,simpleLowerCaseMapping:0xFCBD
  ,simpleTitleCaseMapping:0xFCBD
 },
 { code:0xFCBE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCBE
  ,simpleLowerCaseMapping:0xFCBE
  ,simpleTitleCaseMapping:0xFCBE
 },
 { code:0xFCBF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCBF
  ,simpleLowerCaseMapping:0xFCBF
  ,simpleTitleCaseMapping:0xFCBF
 },
 { code:0xFCC0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCC0
  ,simpleLowerCaseMapping:0xFCC0
  ,simpleTitleCaseMapping:0xFCC0
 },
 { code:0xFCC1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCC1
  ,simpleLowerCaseMapping:0xFCC1
  ,simpleTitleCaseMapping:0xFCC1
 },
 { code:0xFCC2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCC2
  ,simpleLowerCaseMapping:0xFCC2
  ,simpleTitleCaseMapping:0xFCC2
 },
 { code:0xFCC3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCC3
  ,simpleLowerCaseMapping:0xFCC3
  ,simpleTitleCaseMapping:0xFCC3
 },
 { code:0xFCC4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCC4
  ,simpleLowerCaseMapping:0xFCC4
  ,simpleTitleCaseMapping:0xFCC4
 },
 { code:0xFCC5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCC5
  ,simpleLowerCaseMapping:0xFCC5
  ,simpleTitleCaseMapping:0xFCC5
 },
 { code:0xFCC6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCC6
  ,simpleLowerCaseMapping:0xFCC6
  ,simpleTitleCaseMapping:0xFCC6
 },
 { code:0xFCC7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCC7
  ,simpleLowerCaseMapping:0xFCC7
  ,simpleTitleCaseMapping:0xFCC7
 },
 { code:0xFCC8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCC8
  ,simpleLowerCaseMapping:0xFCC8
  ,simpleTitleCaseMapping:0xFCC8
 },
 { code:0xFCC9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCC9
  ,simpleLowerCaseMapping:0xFCC9
  ,simpleTitleCaseMapping:0xFCC9
 },
 { code:0xFCCA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCCA
  ,simpleLowerCaseMapping:0xFCCA
  ,simpleTitleCaseMapping:0xFCCA
 },
 { code:0xFCCB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCCB
  ,simpleLowerCaseMapping:0xFCCB
  ,simpleTitleCaseMapping:0xFCCB
 },
 { code:0xFCCC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCCC
  ,simpleLowerCaseMapping:0xFCCC
  ,simpleTitleCaseMapping:0xFCCC
 },
 { code:0xFCCD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCCD
  ,simpleLowerCaseMapping:0xFCCD
  ,simpleTitleCaseMapping:0xFCCD
 },
 { code:0xFCCE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCCE
  ,simpleLowerCaseMapping:0xFCCE
  ,simpleTitleCaseMapping:0xFCCE
 },
 { code:0xFCCF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCCF
  ,simpleLowerCaseMapping:0xFCCF
  ,simpleTitleCaseMapping:0xFCCF
 },
 { code:0xFCD0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCD0
  ,simpleLowerCaseMapping:0xFCD0
  ,simpleTitleCaseMapping:0xFCD0
 },
 { code:0xFCD1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCD1
  ,simpleLowerCaseMapping:0xFCD1
  ,simpleTitleCaseMapping:0xFCD1
 },
 { code:0xFCD2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCD2
  ,simpleLowerCaseMapping:0xFCD2
  ,simpleTitleCaseMapping:0xFCD2
 },
 { code:0xFCD3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCD3
  ,simpleLowerCaseMapping:0xFCD3
  ,simpleTitleCaseMapping:0xFCD3
 },
 { code:0xFCD4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCD4
  ,simpleLowerCaseMapping:0xFCD4
  ,simpleTitleCaseMapping:0xFCD4
 },
 { code:0xFCD5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCD5
  ,simpleLowerCaseMapping:0xFCD5
  ,simpleTitleCaseMapping:0xFCD5
 },
 { code:0xFCD6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCD6
  ,simpleLowerCaseMapping:0xFCD6
  ,simpleTitleCaseMapping:0xFCD6
 },
 { code:0xFCD7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCD7
  ,simpleLowerCaseMapping:0xFCD7
  ,simpleTitleCaseMapping:0xFCD7
 },
 { code:0xFCD8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCD8
  ,simpleLowerCaseMapping:0xFCD8
  ,simpleTitleCaseMapping:0xFCD8
 },
 { code:0xFCD9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCD9
  ,simpleLowerCaseMapping:0xFCD9
  ,simpleTitleCaseMapping:0xFCD9
 },
 { code:0xFCDA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCDA
  ,simpleLowerCaseMapping:0xFCDA
  ,simpleTitleCaseMapping:0xFCDA
 },
 { code:0xFCDB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCDB
  ,simpleLowerCaseMapping:0xFCDB
  ,simpleTitleCaseMapping:0xFCDB
 },
 { code:0xFCDC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCDC
  ,simpleLowerCaseMapping:0xFCDC
  ,simpleTitleCaseMapping:0xFCDC
 },
 { code:0xFCDD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCDD
  ,simpleLowerCaseMapping:0xFCDD
  ,simpleTitleCaseMapping:0xFCDD
 },
 { code:0xFCDE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCDE
  ,simpleLowerCaseMapping:0xFCDE
  ,simpleTitleCaseMapping:0xFCDE
 },
 { code:0xFCDF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCDF
  ,simpleLowerCaseMapping:0xFCDF
  ,simpleTitleCaseMapping:0xFCDF
 },
 { code:0xFCE0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCE0
  ,simpleLowerCaseMapping:0xFCE0
  ,simpleTitleCaseMapping:0xFCE0
 },
 { code:0xFCE1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCE1
  ,simpleLowerCaseMapping:0xFCE1
  ,simpleTitleCaseMapping:0xFCE1
 },
 { code:0xFCE2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCE2
  ,simpleLowerCaseMapping:0xFCE2
  ,simpleTitleCaseMapping:0xFCE2
 },
 { code:0xFCE3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCE3
  ,simpleLowerCaseMapping:0xFCE3
  ,simpleTitleCaseMapping:0xFCE3
 },
 { code:0xFCE4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCE4
  ,simpleLowerCaseMapping:0xFCE4
  ,simpleTitleCaseMapping:0xFCE4
 },
 { code:0xFCE5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCE5
  ,simpleLowerCaseMapping:0xFCE5
  ,simpleTitleCaseMapping:0xFCE5
 },
 { code:0xFCE6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCE6
  ,simpleLowerCaseMapping:0xFCE6
  ,simpleTitleCaseMapping:0xFCE6
 },
 { code:0xFCE7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCE7
  ,simpleLowerCaseMapping:0xFCE7
  ,simpleTitleCaseMapping:0xFCE7
 },
 { code:0xFCE8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCE8
  ,simpleLowerCaseMapping:0xFCE8
  ,simpleTitleCaseMapping:0xFCE8
 },
 { code:0xFCE9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCE9
  ,simpleLowerCaseMapping:0xFCE9
  ,simpleTitleCaseMapping:0xFCE9
 },
 { code:0xFCEA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCEA
  ,simpleLowerCaseMapping:0xFCEA
  ,simpleTitleCaseMapping:0xFCEA
 },
 { code:0xFCEB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCEB
  ,simpleLowerCaseMapping:0xFCEB
  ,simpleTitleCaseMapping:0xFCEB
 },
 { code:0xFCEC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCEC
  ,simpleLowerCaseMapping:0xFCEC
  ,simpleTitleCaseMapping:0xFCEC
 },
 { code:0xFCED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCED
  ,simpleLowerCaseMapping:0xFCED
  ,simpleTitleCaseMapping:0xFCED
 },
 { code:0xFCEE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCEE
  ,simpleLowerCaseMapping:0xFCEE
  ,simpleTitleCaseMapping:0xFCEE
 },
 { code:0xFCEF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCEF
  ,simpleLowerCaseMapping:0xFCEF
  ,simpleTitleCaseMapping:0xFCEF
 },
 { code:0xFCF0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCF0
  ,simpleLowerCaseMapping:0xFCF0
  ,simpleTitleCaseMapping:0xFCF0
 },
 { code:0xFCF1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCF1
  ,simpleLowerCaseMapping:0xFCF1
  ,simpleTitleCaseMapping:0xFCF1
 },
 { code:0xFCF2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCF2
  ,simpleLowerCaseMapping:0xFCF2
  ,simpleTitleCaseMapping:0xFCF2
 },
 { code:0xFCF3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCF3
  ,simpleLowerCaseMapping:0xFCF3
  ,simpleTitleCaseMapping:0xFCF3
 },
 { code:0xFCF4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCF4
  ,simpleLowerCaseMapping:0xFCF4
  ,simpleTitleCaseMapping:0xFCF4
 },
 { code:0xFCF5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCF5
  ,simpleLowerCaseMapping:0xFCF5
  ,simpleTitleCaseMapping:0xFCF5
 },
 { code:0xFCF6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCF6
  ,simpleLowerCaseMapping:0xFCF6
  ,simpleTitleCaseMapping:0xFCF6
 },
 { code:0xFCF7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCF7
  ,simpleLowerCaseMapping:0xFCF7
  ,simpleTitleCaseMapping:0xFCF7
 },
 { code:0xFCF8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCF8
  ,simpleLowerCaseMapping:0xFCF8
  ,simpleTitleCaseMapping:0xFCF8
 },
 { code:0xFCF9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCF9
  ,simpleLowerCaseMapping:0xFCF9
  ,simpleTitleCaseMapping:0xFCF9
 },
 { code:0xFCFA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCFA
  ,simpleLowerCaseMapping:0xFCFA
  ,simpleTitleCaseMapping:0xFCFA
 },
 { code:0xFCFB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCFB
  ,simpleLowerCaseMapping:0xFCFB
  ,simpleTitleCaseMapping:0xFCFB
 },
 { code:0xFCFC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCFC
  ,simpleLowerCaseMapping:0xFCFC
  ,simpleTitleCaseMapping:0xFCFC
 },
 { code:0xFCFD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCFD
  ,simpleLowerCaseMapping:0xFCFD
  ,simpleTitleCaseMapping:0xFCFD
 },
 { code:0xFCFE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCFE
  ,simpleLowerCaseMapping:0xFCFE
  ,simpleTitleCaseMapping:0xFCFE
 },
 { code:0xFCFF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFCFF
  ,simpleLowerCaseMapping:0xFCFF
  ,simpleTitleCaseMapping:0xFCFF
 },
 { code:0xFD00
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD00
  ,simpleLowerCaseMapping:0xFD00
  ,simpleTitleCaseMapping:0xFD00
 },
 { code:0xFD01
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD01
  ,simpleLowerCaseMapping:0xFD01
  ,simpleTitleCaseMapping:0xFD01
 },
 { code:0xFD02
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD02
  ,simpleLowerCaseMapping:0xFD02
  ,simpleTitleCaseMapping:0xFD02
 },
 { code:0xFD03
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD03
  ,simpleLowerCaseMapping:0xFD03
  ,simpleTitleCaseMapping:0xFD03
 },
 { code:0xFD04
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD04
  ,simpleLowerCaseMapping:0xFD04
  ,simpleTitleCaseMapping:0xFD04
 },
 { code:0xFD05
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD05
  ,simpleLowerCaseMapping:0xFD05
  ,simpleTitleCaseMapping:0xFD05
 },
 { code:0xFD06
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD06
  ,simpleLowerCaseMapping:0xFD06
  ,simpleTitleCaseMapping:0xFD06
 },
 { code:0xFD07
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD07
  ,simpleLowerCaseMapping:0xFD07
  ,simpleTitleCaseMapping:0xFD07
 },
 { code:0xFD08
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD08
  ,simpleLowerCaseMapping:0xFD08
  ,simpleTitleCaseMapping:0xFD08
 },
 { code:0xFD09
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD09
  ,simpleLowerCaseMapping:0xFD09
  ,simpleTitleCaseMapping:0xFD09
 },
 { code:0xFD0A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD0A
  ,simpleLowerCaseMapping:0xFD0A
  ,simpleTitleCaseMapping:0xFD0A
 },
 { code:0xFD0B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD0B
  ,simpleLowerCaseMapping:0xFD0B
  ,simpleTitleCaseMapping:0xFD0B
 },
 { code:0xFD0C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD0C
  ,simpleLowerCaseMapping:0xFD0C
  ,simpleTitleCaseMapping:0xFD0C
 },
 { code:0xFD0D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD0D
  ,simpleLowerCaseMapping:0xFD0D
  ,simpleTitleCaseMapping:0xFD0D
 },
 { code:0xFD0E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD0E
  ,simpleLowerCaseMapping:0xFD0E
  ,simpleTitleCaseMapping:0xFD0E
 },
 { code:0xFD0F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD0F
  ,simpleLowerCaseMapping:0xFD0F
  ,simpleTitleCaseMapping:0xFD0F
 },
 { code:0xFD10
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD10
  ,simpleLowerCaseMapping:0xFD10
  ,simpleTitleCaseMapping:0xFD10
 },
 { code:0xFD11
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD11
  ,simpleLowerCaseMapping:0xFD11
  ,simpleTitleCaseMapping:0xFD11
 },
 { code:0xFD12
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD12
  ,simpleLowerCaseMapping:0xFD12
  ,simpleTitleCaseMapping:0xFD12
 },
 { code:0xFD13
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD13
  ,simpleLowerCaseMapping:0xFD13
  ,simpleTitleCaseMapping:0xFD13
 },
 { code:0xFD14
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD14
  ,simpleLowerCaseMapping:0xFD14
  ,simpleTitleCaseMapping:0xFD14
 },
 { code:0xFD15
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD15
  ,simpleLowerCaseMapping:0xFD15
  ,simpleTitleCaseMapping:0xFD15
 },
 { code:0xFD16
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD16
  ,simpleLowerCaseMapping:0xFD16
  ,simpleTitleCaseMapping:0xFD16
 },
 { code:0xFD17
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD17
  ,simpleLowerCaseMapping:0xFD17
  ,simpleTitleCaseMapping:0xFD17
 },
 { code:0xFD18
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD18
  ,simpleLowerCaseMapping:0xFD18
  ,simpleTitleCaseMapping:0xFD18
 },
 { code:0xFD19
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD19
  ,simpleLowerCaseMapping:0xFD19
  ,simpleTitleCaseMapping:0xFD19
 },
 { code:0xFD1A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD1A
  ,simpleLowerCaseMapping:0xFD1A
  ,simpleTitleCaseMapping:0xFD1A
 },
 { code:0xFD1B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD1B
  ,simpleLowerCaseMapping:0xFD1B
  ,simpleTitleCaseMapping:0xFD1B
 },
 { code:0xFD1C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD1C
  ,simpleLowerCaseMapping:0xFD1C
  ,simpleTitleCaseMapping:0xFD1C
 },
 { code:0xFD1D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD1D
  ,simpleLowerCaseMapping:0xFD1D
  ,simpleTitleCaseMapping:0xFD1D
 },
 { code:0xFD1E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD1E
  ,simpleLowerCaseMapping:0xFD1E
  ,simpleTitleCaseMapping:0xFD1E
 },
 { code:0xFD1F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD1F
  ,simpleLowerCaseMapping:0xFD1F
  ,simpleTitleCaseMapping:0xFD1F
 },
 { code:0xFD20
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD20
  ,simpleLowerCaseMapping:0xFD20
  ,simpleTitleCaseMapping:0xFD20
 },
 { code:0xFD21
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD21
  ,simpleLowerCaseMapping:0xFD21
  ,simpleTitleCaseMapping:0xFD21
 },
 { code:0xFD22
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD22
  ,simpleLowerCaseMapping:0xFD22
  ,simpleTitleCaseMapping:0xFD22
 },
 { code:0xFD23
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD23
  ,simpleLowerCaseMapping:0xFD23
  ,simpleTitleCaseMapping:0xFD23
 },
 { code:0xFD24
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD24
  ,simpleLowerCaseMapping:0xFD24
  ,simpleTitleCaseMapping:0xFD24
 },
 { code:0xFD25
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD25
  ,simpleLowerCaseMapping:0xFD25
  ,simpleTitleCaseMapping:0xFD25
 },
 { code:0xFD26
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD26
  ,simpleLowerCaseMapping:0xFD26
  ,simpleTitleCaseMapping:0xFD26
 },
 { code:0xFD27
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD27
  ,simpleLowerCaseMapping:0xFD27
  ,simpleTitleCaseMapping:0xFD27
 },
 { code:0xFD28
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD28
  ,simpleLowerCaseMapping:0xFD28
  ,simpleTitleCaseMapping:0xFD28
 },
 { code:0xFD29
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD29
  ,simpleLowerCaseMapping:0xFD29
  ,simpleTitleCaseMapping:0xFD29
 },
 { code:0xFD2A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD2A
  ,simpleLowerCaseMapping:0xFD2A
  ,simpleTitleCaseMapping:0xFD2A
 },
 { code:0xFD2B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD2B
  ,simpleLowerCaseMapping:0xFD2B
  ,simpleTitleCaseMapping:0xFD2B
 },
 { code:0xFD2C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD2C
  ,simpleLowerCaseMapping:0xFD2C
  ,simpleTitleCaseMapping:0xFD2C
 },
 { code:0xFD2D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD2D
  ,simpleLowerCaseMapping:0xFD2D
  ,simpleTitleCaseMapping:0xFD2D
 },
 { code:0xFD2E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD2E
  ,simpleLowerCaseMapping:0xFD2E
  ,simpleTitleCaseMapping:0xFD2E
 },
 { code:0xFD2F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD2F
  ,simpleLowerCaseMapping:0xFD2F
  ,simpleTitleCaseMapping:0xFD2F
 },
 { code:0xFD30
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD30
  ,simpleLowerCaseMapping:0xFD30
  ,simpleTitleCaseMapping:0xFD30
 },
 { code:0xFD31
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD31
  ,simpleLowerCaseMapping:0xFD31
  ,simpleTitleCaseMapping:0xFD31
 },
 { code:0xFD32
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD32
  ,simpleLowerCaseMapping:0xFD32
  ,simpleTitleCaseMapping:0xFD32
 },
 { code:0xFD33
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD33
  ,simpleLowerCaseMapping:0xFD33
  ,simpleTitleCaseMapping:0xFD33
 },
 { code:0xFD34
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD34
  ,simpleLowerCaseMapping:0xFD34
  ,simpleTitleCaseMapping:0xFD34
 },
 { code:0xFD35
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD35
  ,simpleLowerCaseMapping:0xFD35
  ,simpleTitleCaseMapping:0xFD35
 },
 { code:0xFD36
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD36
  ,simpleLowerCaseMapping:0xFD36
  ,simpleTitleCaseMapping:0xFD36
 },
 { code:0xFD37
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD37
  ,simpleLowerCaseMapping:0xFD37
  ,simpleTitleCaseMapping:0xFD37
 },
 { code:0xFD38
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD38
  ,simpleLowerCaseMapping:0xFD38
  ,simpleTitleCaseMapping:0xFD38
 },
 { code:0xFD39
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD39
  ,simpleLowerCaseMapping:0xFD39
  ,simpleTitleCaseMapping:0xFD39
 },
 { code:0xFD3A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD3A
  ,simpleLowerCaseMapping:0xFD3A
  ,simpleTitleCaseMapping:0xFD3A
 },
 { code:0xFD3B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD3B
  ,simpleLowerCaseMapping:0xFD3B
  ,simpleTitleCaseMapping:0xFD3B
 },
 { code:0xFD3C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD3C
  ,simpleLowerCaseMapping:0xFD3C
  ,simpleTitleCaseMapping:0xFD3C
 },
 { code:0xFD3D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD3D
  ,simpleLowerCaseMapping:0xFD3D
  ,simpleTitleCaseMapping:0xFD3D
 },
 { code:0xFD3E
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFD3E
  ,simpleLowerCaseMapping:0xFD3E
  ,simpleTitleCaseMapping:0xFD3E
 },
 { code:0xFD3F
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFD3F
  ,simpleLowerCaseMapping:0xFD3F
  ,simpleTitleCaseMapping:0xFD3F
 },
 { code:0xFD50
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD50
  ,simpleLowerCaseMapping:0xFD50
  ,simpleTitleCaseMapping:0xFD50
 },
 { code:0xFD51
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD51
  ,simpleLowerCaseMapping:0xFD51
  ,simpleTitleCaseMapping:0xFD51
 },
 { code:0xFD52
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD52
  ,simpleLowerCaseMapping:0xFD52
  ,simpleTitleCaseMapping:0xFD52
 },
 { code:0xFD53
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD53
  ,simpleLowerCaseMapping:0xFD53
  ,simpleTitleCaseMapping:0xFD53
 },
 { code:0xFD54
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD54
  ,simpleLowerCaseMapping:0xFD54
  ,simpleTitleCaseMapping:0xFD54
 },
 { code:0xFD55
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD55
  ,simpleLowerCaseMapping:0xFD55
  ,simpleTitleCaseMapping:0xFD55
 },
 { code:0xFD56
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD56
  ,simpleLowerCaseMapping:0xFD56
  ,simpleTitleCaseMapping:0xFD56
 },
 { code:0xFD57
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD57
  ,simpleLowerCaseMapping:0xFD57
  ,simpleTitleCaseMapping:0xFD57
 },
 { code:0xFD58
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD58
  ,simpleLowerCaseMapping:0xFD58
  ,simpleTitleCaseMapping:0xFD58
 },
 { code:0xFD59
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD59
  ,simpleLowerCaseMapping:0xFD59
  ,simpleTitleCaseMapping:0xFD59
 },
 { code:0xFD5A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD5A
  ,simpleLowerCaseMapping:0xFD5A
  ,simpleTitleCaseMapping:0xFD5A
 },
 { code:0xFD5B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD5B
  ,simpleLowerCaseMapping:0xFD5B
  ,simpleTitleCaseMapping:0xFD5B
 },
 { code:0xFD5C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD5C
  ,simpleLowerCaseMapping:0xFD5C
  ,simpleTitleCaseMapping:0xFD5C
 },
 { code:0xFD5D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD5D
  ,simpleLowerCaseMapping:0xFD5D
  ,simpleTitleCaseMapping:0xFD5D
 },
 { code:0xFD5E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD5E
  ,simpleLowerCaseMapping:0xFD5E
  ,simpleTitleCaseMapping:0xFD5E
 },
 { code:0xFD5F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD5F
  ,simpleLowerCaseMapping:0xFD5F
  ,simpleTitleCaseMapping:0xFD5F
 },
 { code:0xFD60
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD60
  ,simpleLowerCaseMapping:0xFD60
  ,simpleTitleCaseMapping:0xFD60
 },
 { code:0xFD61
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD61
  ,simpleLowerCaseMapping:0xFD61
  ,simpleTitleCaseMapping:0xFD61
 },
 { code:0xFD62
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD62
  ,simpleLowerCaseMapping:0xFD62
  ,simpleTitleCaseMapping:0xFD62
 },
 { code:0xFD63
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD63
  ,simpleLowerCaseMapping:0xFD63
  ,simpleTitleCaseMapping:0xFD63
 },
 { code:0xFD64
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD64
  ,simpleLowerCaseMapping:0xFD64
  ,simpleTitleCaseMapping:0xFD64
 },
 { code:0xFD65
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD65
  ,simpleLowerCaseMapping:0xFD65
  ,simpleTitleCaseMapping:0xFD65
 },
 { code:0xFD66
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD66
  ,simpleLowerCaseMapping:0xFD66
  ,simpleTitleCaseMapping:0xFD66
 },
 { code:0xFD67
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD67
  ,simpleLowerCaseMapping:0xFD67
  ,simpleTitleCaseMapping:0xFD67
 },
 { code:0xFD68
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD68
  ,simpleLowerCaseMapping:0xFD68
  ,simpleTitleCaseMapping:0xFD68
 },
 { code:0xFD69
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD69
  ,simpleLowerCaseMapping:0xFD69
  ,simpleTitleCaseMapping:0xFD69
 },
 { code:0xFD6A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD6A
  ,simpleLowerCaseMapping:0xFD6A
  ,simpleTitleCaseMapping:0xFD6A
 },
 { code:0xFD6B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD6B
  ,simpleLowerCaseMapping:0xFD6B
  ,simpleTitleCaseMapping:0xFD6B
 },
 { code:0xFD6C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD6C
  ,simpleLowerCaseMapping:0xFD6C
  ,simpleTitleCaseMapping:0xFD6C
 },
 { code:0xFD6D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD6D
  ,simpleLowerCaseMapping:0xFD6D
  ,simpleTitleCaseMapping:0xFD6D
 },
 { code:0xFD6E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD6E
  ,simpleLowerCaseMapping:0xFD6E
  ,simpleTitleCaseMapping:0xFD6E
 },
 { code:0xFD6F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD6F
  ,simpleLowerCaseMapping:0xFD6F
  ,simpleTitleCaseMapping:0xFD6F
 },
 { code:0xFD70
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD70
  ,simpleLowerCaseMapping:0xFD70
  ,simpleTitleCaseMapping:0xFD70
 },
 { code:0xFD71
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD71
  ,simpleLowerCaseMapping:0xFD71
  ,simpleTitleCaseMapping:0xFD71
 },
 { code:0xFD72
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD72
  ,simpleLowerCaseMapping:0xFD72
  ,simpleTitleCaseMapping:0xFD72
 },
 { code:0xFD73
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD73
  ,simpleLowerCaseMapping:0xFD73
  ,simpleTitleCaseMapping:0xFD73
 },
 { code:0xFD74
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD74
  ,simpleLowerCaseMapping:0xFD74
  ,simpleTitleCaseMapping:0xFD74
 },
 { code:0xFD75
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD75
  ,simpleLowerCaseMapping:0xFD75
  ,simpleTitleCaseMapping:0xFD75
 },
 { code:0xFD76
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD76
  ,simpleLowerCaseMapping:0xFD76
  ,simpleTitleCaseMapping:0xFD76
 },
 { code:0xFD77
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD77
  ,simpleLowerCaseMapping:0xFD77
  ,simpleTitleCaseMapping:0xFD77
 },
 { code:0xFD78
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD78
  ,simpleLowerCaseMapping:0xFD78
  ,simpleTitleCaseMapping:0xFD78
 },
 { code:0xFD79
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD79
  ,simpleLowerCaseMapping:0xFD79
  ,simpleTitleCaseMapping:0xFD79
 },
 { code:0xFD7A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD7A
  ,simpleLowerCaseMapping:0xFD7A
  ,simpleTitleCaseMapping:0xFD7A
 },
 { code:0xFD7B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD7B
  ,simpleLowerCaseMapping:0xFD7B
  ,simpleTitleCaseMapping:0xFD7B
 },
 { code:0xFD7C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD7C
  ,simpleLowerCaseMapping:0xFD7C
  ,simpleTitleCaseMapping:0xFD7C
 },
 { code:0xFD7D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD7D
  ,simpleLowerCaseMapping:0xFD7D
  ,simpleTitleCaseMapping:0xFD7D
 },
 { code:0xFD7E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD7E
  ,simpleLowerCaseMapping:0xFD7E
  ,simpleTitleCaseMapping:0xFD7E
 },
 { code:0xFD7F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD7F
  ,simpleLowerCaseMapping:0xFD7F
  ,simpleTitleCaseMapping:0xFD7F
 },
 { code:0xFD80
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD80
  ,simpleLowerCaseMapping:0xFD80
  ,simpleTitleCaseMapping:0xFD80
 },
 { code:0xFD81
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD81
  ,simpleLowerCaseMapping:0xFD81
  ,simpleTitleCaseMapping:0xFD81
 },
 { code:0xFD82
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD82
  ,simpleLowerCaseMapping:0xFD82
  ,simpleTitleCaseMapping:0xFD82
 },
 { code:0xFD83
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD83
  ,simpleLowerCaseMapping:0xFD83
  ,simpleTitleCaseMapping:0xFD83
 },
 { code:0xFD84
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD84
  ,simpleLowerCaseMapping:0xFD84
  ,simpleTitleCaseMapping:0xFD84
 },
 { code:0xFD85
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD85
  ,simpleLowerCaseMapping:0xFD85
  ,simpleTitleCaseMapping:0xFD85
 },
 { code:0xFD86
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD86
  ,simpleLowerCaseMapping:0xFD86
  ,simpleTitleCaseMapping:0xFD86
 },
 { code:0xFD87
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD87
  ,simpleLowerCaseMapping:0xFD87
  ,simpleTitleCaseMapping:0xFD87
 },
 { code:0xFD88
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD88
  ,simpleLowerCaseMapping:0xFD88
  ,simpleTitleCaseMapping:0xFD88
 },
 { code:0xFD89
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD89
  ,simpleLowerCaseMapping:0xFD89
  ,simpleTitleCaseMapping:0xFD89
 },
 { code:0xFD8A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD8A
  ,simpleLowerCaseMapping:0xFD8A
  ,simpleTitleCaseMapping:0xFD8A
 },
 { code:0xFD8B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD8B
  ,simpleLowerCaseMapping:0xFD8B
  ,simpleTitleCaseMapping:0xFD8B
 },
 { code:0xFD8C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD8C
  ,simpleLowerCaseMapping:0xFD8C
  ,simpleTitleCaseMapping:0xFD8C
 },
 { code:0xFD8D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD8D
  ,simpleLowerCaseMapping:0xFD8D
  ,simpleTitleCaseMapping:0xFD8D
 },
 { code:0xFD8E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD8E
  ,simpleLowerCaseMapping:0xFD8E
  ,simpleTitleCaseMapping:0xFD8E
 },
 { code:0xFD8F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD8F
  ,simpleLowerCaseMapping:0xFD8F
  ,simpleTitleCaseMapping:0xFD8F
 },
 { code:0xFD92
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD92
  ,simpleLowerCaseMapping:0xFD92
  ,simpleTitleCaseMapping:0xFD92
 },
 { code:0xFD93
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD93
  ,simpleLowerCaseMapping:0xFD93
  ,simpleTitleCaseMapping:0xFD93
 },
 { code:0xFD94
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD94
  ,simpleLowerCaseMapping:0xFD94
  ,simpleTitleCaseMapping:0xFD94
 },
 { code:0xFD95
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD95
  ,simpleLowerCaseMapping:0xFD95
  ,simpleTitleCaseMapping:0xFD95
 },
 { code:0xFD96
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD96
  ,simpleLowerCaseMapping:0xFD96
  ,simpleTitleCaseMapping:0xFD96
 },
 { code:0xFD97
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD97
  ,simpleLowerCaseMapping:0xFD97
  ,simpleTitleCaseMapping:0xFD97
 },
 { code:0xFD98
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD98
  ,simpleLowerCaseMapping:0xFD98
  ,simpleTitleCaseMapping:0xFD98
 },
 { code:0xFD99
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD99
  ,simpleLowerCaseMapping:0xFD99
  ,simpleTitleCaseMapping:0xFD99
 },
 { code:0xFD9A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD9A
  ,simpleLowerCaseMapping:0xFD9A
  ,simpleTitleCaseMapping:0xFD9A
 },
 { code:0xFD9B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD9B
  ,simpleLowerCaseMapping:0xFD9B
  ,simpleTitleCaseMapping:0xFD9B
 },
 { code:0xFD9C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD9C
  ,simpleLowerCaseMapping:0xFD9C
  ,simpleTitleCaseMapping:0xFD9C
 },
 { code:0xFD9D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD9D
  ,simpleLowerCaseMapping:0xFD9D
  ,simpleTitleCaseMapping:0xFD9D
 },
 { code:0xFD9E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD9E
  ,simpleLowerCaseMapping:0xFD9E
  ,simpleTitleCaseMapping:0xFD9E
 },
 { code:0xFD9F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFD9F
  ,simpleLowerCaseMapping:0xFD9F
  ,simpleTitleCaseMapping:0xFD9F
 },
 { code:0xFDA0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDA0
  ,simpleLowerCaseMapping:0xFDA0
  ,simpleTitleCaseMapping:0xFDA0
 },
 { code:0xFDA1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDA1
  ,simpleLowerCaseMapping:0xFDA1
  ,simpleTitleCaseMapping:0xFDA1
 },
 { code:0xFDA2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDA2
  ,simpleLowerCaseMapping:0xFDA2
  ,simpleTitleCaseMapping:0xFDA2
 },
 { code:0xFDA3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDA3
  ,simpleLowerCaseMapping:0xFDA3
  ,simpleTitleCaseMapping:0xFDA3
 },
 { code:0xFDA4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDA4
  ,simpleLowerCaseMapping:0xFDA4
  ,simpleTitleCaseMapping:0xFDA4
 },
 { code:0xFDA5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDA5
  ,simpleLowerCaseMapping:0xFDA5
  ,simpleTitleCaseMapping:0xFDA5
 },
 { code:0xFDA6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDA6
  ,simpleLowerCaseMapping:0xFDA6
  ,simpleTitleCaseMapping:0xFDA6
 },
 { code:0xFDA7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDA7
  ,simpleLowerCaseMapping:0xFDA7
  ,simpleTitleCaseMapping:0xFDA7
 },
 { code:0xFDA8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDA8
  ,simpleLowerCaseMapping:0xFDA8
  ,simpleTitleCaseMapping:0xFDA8
 },
 { code:0xFDA9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDA9
  ,simpleLowerCaseMapping:0xFDA9
  ,simpleTitleCaseMapping:0xFDA9
 },
 { code:0xFDAA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDAA
  ,simpleLowerCaseMapping:0xFDAA
  ,simpleTitleCaseMapping:0xFDAA
 },
 { code:0xFDAB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDAB
  ,simpleLowerCaseMapping:0xFDAB
  ,simpleTitleCaseMapping:0xFDAB
 },
 { code:0xFDAC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDAC
  ,simpleLowerCaseMapping:0xFDAC
  ,simpleTitleCaseMapping:0xFDAC
 },
 { code:0xFDAD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDAD
  ,simpleLowerCaseMapping:0xFDAD
  ,simpleTitleCaseMapping:0xFDAD
 },
 { code:0xFDAE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDAE
  ,simpleLowerCaseMapping:0xFDAE
  ,simpleTitleCaseMapping:0xFDAE
 },
 { code:0xFDAF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDAF
  ,simpleLowerCaseMapping:0xFDAF
  ,simpleTitleCaseMapping:0xFDAF
 },
 { code:0xFDB0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDB0
  ,simpleLowerCaseMapping:0xFDB0
  ,simpleTitleCaseMapping:0xFDB0
 },
 { code:0xFDB1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDB1
  ,simpleLowerCaseMapping:0xFDB1
  ,simpleTitleCaseMapping:0xFDB1
 },
 { code:0xFDB2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDB2
  ,simpleLowerCaseMapping:0xFDB2
  ,simpleTitleCaseMapping:0xFDB2
 },
 { code:0xFDB3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDB3
  ,simpleLowerCaseMapping:0xFDB3
  ,simpleTitleCaseMapping:0xFDB3
 },
 { code:0xFDB4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDB4
  ,simpleLowerCaseMapping:0xFDB4
  ,simpleTitleCaseMapping:0xFDB4
 },
 { code:0xFDB5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDB5
  ,simpleLowerCaseMapping:0xFDB5
  ,simpleTitleCaseMapping:0xFDB5
 },
 { code:0xFDB6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDB6
  ,simpleLowerCaseMapping:0xFDB6
  ,simpleTitleCaseMapping:0xFDB6
 },
 { code:0xFDB7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDB7
  ,simpleLowerCaseMapping:0xFDB7
  ,simpleTitleCaseMapping:0xFDB7
 },
 { code:0xFDB8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDB8
  ,simpleLowerCaseMapping:0xFDB8
  ,simpleTitleCaseMapping:0xFDB8
 },
 { code:0xFDB9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDB9
  ,simpleLowerCaseMapping:0xFDB9
  ,simpleTitleCaseMapping:0xFDB9
 },
 { code:0xFDBA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDBA
  ,simpleLowerCaseMapping:0xFDBA
  ,simpleTitleCaseMapping:0xFDBA
 },
 { code:0xFDBB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDBB
  ,simpleLowerCaseMapping:0xFDBB
  ,simpleTitleCaseMapping:0xFDBB
 },
 { code:0xFDBC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDBC
  ,simpleLowerCaseMapping:0xFDBC
  ,simpleTitleCaseMapping:0xFDBC
 },
 { code:0xFDBD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDBD
  ,simpleLowerCaseMapping:0xFDBD
  ,simpleTitleCaseMapping:0xFDBD
 },
 { code:0xFDBE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDBE
  ,simpleLowerCaseMapping:0xFDBE
  ,simpleTitleCaseMapping:0xFDBE
 },
 { code:0xFDBF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDBF
  ,simpleLowerCaseMapping:0xFDBF
  ,simpleTitleCaseMapping:0xFDBF
 },
 { code:0xFDC0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDC0
  ,simpleLowerCaseMapping:0xFDC0
  ,simpleTitleCaseMapping:0xFDC0
 },
 { code:0xFDC1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDC1
  ,simpleLowerCaseMapping:0xFDC1
  ,simpleTitleCaseMapping:0xFDC1
 },
 { code:0xFDC2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDC2
  ,simpleLowerCaseMapping:0xFDC2
  ,simpleTitleCaseMapping:0xFDC2
 },
 { code:0xFDC3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDC3
  ,simpleLowerCaseMapping:0xFDC3
  ,simpleTitleCaseMapping:0xFDC3
 },
 { code:0xFDC4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDC4
  ,simpleLowerCaseMapping:0xFDC4
  ,simpleTitleCaseMapping:0xFDC4
 },
 { code:0xFDC5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDC5
  ,simpleLowerCaseMapping:0xFDC5
  ,simpleTitleCaseMapping:0xFDC5
 },
 { code:0xFDC6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDC6
  ,simpleLowerCaseMapping:0xFDC6
  ,simpleTitleCaseMapping:0xFDC6
 },
 { code:0xFDC7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDC7
  ,simpleLowerCaseMapping:0xFDC7
  ,simpleTitleCaseMapping:0xFDC7
 },
 { code:0xFDF0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDF0
  ,simpleLowerCaseMapping:0xFDF0
  ,simpleTitleCaseMapping:0xFDF0
 },
 { code:0xFDF1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDF1
  ,simpleLowerCaseMapping:0xFDF1
  ,simpleTitleCaseMapping:0xFDF1
 },
 { code:0xFDF2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDF2
  ,simpleLowerCaseMapping:0xFDF2
  ,simpleTitleCaseMapping:0xFDF2
 },
 { code:0xFDF3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDF3
  ,simpleLowerCaseMapping:0xFDF3
  ,simpleTitleCaseMapping:0xFDF3
 },
 { code:0xFDF4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDF4
  ,simpleLowerCaseMapping:0xFDF4
  ,simpleTitleCaseMapping:0xFDF4
 },
 { code:0xFDF5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDF5
  ,simpleLowerCaseMapping:0xFDF5
  ,simpleTitleCaseMapping:0xFDF5
 },
 { code:0xFDF6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDF6
  ,simpleLowerCaseMapping:0xFDF6
  ,simpleTitleCaseMapping:0xFDF6
 },
 { code:0xFDF7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDF7
  ,simpleLowerCaseMapping:0xFDF7
  ,simpleTitleCaseMapping:0xFDF7
 },
 { code:0xFDF8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDF8
  ,simpleLowerCaseMapping:0xFDF8
  ,simpleTitleCaseMapping:0xFDF8
 },
 { code:0xFDF9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDF9
  ,simpleLowerCaseMapping:0xFDF9
  ,simpleTitleCaseMapping:0xFDF9
 },
 { code:0xFDFA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDFA
  ,simpleLowerCaseMapping:0xFDFA
  ,simpleTitleCaseMapping:0xFDFA
 },
 { code:0xFDFB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFDFB
  ,simpleLowerCaseMapping:0xFDFB
  ,simpleTitleCaseMapping:0xFDFB
 },
 { code:0xFDFC
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0xFDFC
  ,simpleLowerCaseMapping:0xFDFC
  ,simpleTitleCaseMapping:0xFDFC
 },
 { code:0xFDFD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xFDFD
  ,simpleLowerCaseMapping:0xFDFD
  ,simpleTitleCaseMapping:0xFDFD
 },
 { code:0xFE00
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE00
  ,simpleLowerCaseMapping:0xFE00
  ,simpleTitleCaseMapping:0xFE00
 },
 { code:0xFE01
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE01
  ,simpleLowerCaseMapping:0xFE01
  ,simpleTitleCaseMapping:0xFE01
 },
 { code:0xFE02
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE02
  ,simpleLowerCaseMapping:0xFE02
  ,simpleTitleCaseMapping:0xFE02
 },
 { code:0xFE03
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE03
  ,simpleLowerCaseMapping:0xFE03
  ,simpleTitleCaseMapping:0xFE03
 },
 { code:0xFE04
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE04
  ,simpleLowerCaseMapping:0xFE04
  ,simpleTitleCaseMapping:0xFE04
 },
 { code:0xFE05
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE05
  ,simpleLowerCaseMapping:0xFE05
  ,simpleTitleCaseMapping:0xFE05
 },
 { code:0xFE06
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE06
  ,simpleLowerCaseMapping:0xFE06
  ,simpleTitleCaseMapping:0xFE06
 },
 { code:0xFE07
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE07
  ,simpleLowerCaseMapping:0xFE07
  ,simpleTitleCaseMapping:0xFE07
 },
 { code:0xFE08
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE08
  ,simpleLowerCaseMapping:0xFE08
  ,simpleTitleCaseMapping:0xFE08
 },
 { code:0xFE09
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE09
  ,simpleLowerCaseMapping:0xFE09
  ,simpleTitleCaseMapping:0xFE09
 },
 { code:0xFE0A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE0A
  ,simpleLowerCaseMapping:0xFE0A
  ,simpleTitleCaseMapping:0xFE0A
 },
 { code:0xFE0B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE0B
  ,simpleLowerCaseMapping:0xFE0B
  ,simpleTitleCaseMapping:0xFE0B
 },
 { code:0xFE0C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE0C
  ,simpleLowerCaseMapping:0xFE0C
  ,simpleTitleCaseMapping:0xFE0C
 },
 { code:0xFE0D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE0D
  ,simpleLowerCaseMapping:0xFE0D
  ,simpleTitleCaseMapping:0xFE0D
 },
 { code:0xFE0E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE0E
  ,simpleLowerCaseMapping:0xFE0E
  ,simpleTitleCaseMapping:0xFE0E
 },
 { code:0xFE0F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE0F
  ,simpleLowerCaseMapping:0xFE0F
  ,simpleTitleCaseMapping:0xFE0F
 },
 { code:0xFE10
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE10
  ,simpleLowerCaseMapping:0xFE10
  ,simpleTitleCaseMapping:0xFE10
 },
 { code:0xFE11
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE11
  ,simpleLowerCaseMapping:0xFE11
  ,simpleTitleCaseMapping:0xFE11
 },
 { code:0xFE12
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE12
  ,simpleLowerCaseMapping:0xFE12
  ,simpleTitleCaseMapping:0xFE12
 },
 { code:0xFE13
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE13
  ,simpleLowerCaseMapping:0xFE13
  ,simpleTitleCaseMapping:0xFE13
 },
 { code:0xFE14
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE14
  ,simpleLowerCaseMapping:0xFE14
  ,simpleTitleCaseMapping:0xFE14
 },
 { code:0xFE15
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE15
  ,simpleLowerCaseMapping:0xFE15
  ,simpleTitleCaseMapping:0xFE15
 },
 { code:0xFE16
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE16
  ,simpleLowerCaseMapping:0xFE16
  ,simpleTitleCaseMapping:0xFE16
 },
 { code:0xFE17
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFE17
  ,simpleLowerCaseMapping:0xFE17
  ,simpleTitleCaseMapping:0xFE17
 },
 { code:0xFE18
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFE18
  ,simpleLowerCaseMapping:0xFE18
  ,simpleTitleCaseMapping:0xFE18
 },
 { code:0xFE19
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE19
  ,simpleLowerCaseMapping:0xFE19
  ,simpleTitleCaseMapping:0xFE19
 },
 { code:0xFE20
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE20
  ,simpleLowerCaseMapping:0xFE20
  ,simpleTitleCaseMapping:0xFE20
 },
 { code:0xFE21
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE21
  ,simpleLowerCaseMapping:0xFE21
  ,simpleTitleCaseMapping:0xFE21
 },
 { code:0xFE22
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE22
  ,simpleLowerCaseMapping:0xFE22
  ,simpleTitleCaseMapping:0xFE22
 },
 { code:0xFE23
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xFE23
  ,simpleLowerCaseMapping:0xFE23
  ,simpleTitleCaseMapping:0xFE23
 },
 { code:0xFE30
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE30
  ,simpleLowerCaseMapping:0xFE30
  ,simpleTitleCaseMapping:0xFE30
 },
 { code:0xFE31
  ,generalCategory:UnicodeData.GeneralCategory.Pd
  ,simpleUpperCaseMapping:0xFE31
  ,simpleLowerCaseMapping:0xFE31
  ,simpleTitleCaseMapping:0xFE31
 },
 { code:0xFE32
  ,generalCategory:UnicodeData.GeneralCategory.Pd
  ,simpleUpperCaseMapping:0xFE32
  ,simpleLowerCaseMapping:0xFE32
  ,simpleTitleCaseMapping:0xFE32
 },
 { code:0xFE33
  ,generalCategory:UnicodeData.GeneralCategory.Pc
  ,simpleUpperCaseMapping:0xFE33
  ,simpleLowerCaseMapping:0xFE33
  ,simpleTitleCaseMapping:0xFE33
 },
 { code:0xFE34
  ,generalCategory:UnicodeData.GeneralCategory.Pc
  ,simpleUpperCaseMapping:0xFE34
  ,simpleLowerCaseMapping:0xFE34
  ,simpleTitleCaseMapping:0xFE34
 },
 { code:0xFE35
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFE35
  ,simpleLowerCaseMapping:0xFE35
  ,simpleTitleCaseMapping:0xFE35
 },
 { code:0xFE36
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFE36
  ,simpleLowerCaseMapping:0xFE36
  ,simpleTitleCaseMapping:0xFE36
 },
 { code:0xFE37
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFE37
  ,simpleLowerCaseMapping:0xFE37
  ,simpleTitleCaseMapping:0xFE37
 },
 { code:0xFE38
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFE38
  ,simpleLowerCaseMapping:0xFE38
  ,simpleTitleCaseMapping:0xFE38
 },
 { code:0xFE39
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFE39
  ,simpleLowerCaseMapping:0xFE39
  ,simpleTitleCaseMapping:0xFE39
 },
 { code:0xFE3A
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFE3A
  ,simpleLowerCaseMapping:0xFE3A
  ,simpleTitleCaseMapping:0xFE3A
 },
 { code:0xFE3B
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFE3B
  ,simpleLowerCaseMapping:0xFE3B
  ,simpleTitleCaseMapping:0xFE3B
 },
 { code:0xFE3C
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFE3C
  ,simpleLowerCaseMapping:0xFE3C
  ,simpleTitleCaseMapping:0xFE3C
 },
 { code:0xFE3D
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFE3D
  ,simpleLowerCaseMapping:0xFE3D
  ,simpleTitleCaseMapping:0xFE3D
 },
 { code:0xFE3E
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFE3E
  ,simpleLowerCaseMapping:0xFE3E
  ,simpleTitleCaseMapping:0xFE3E
 },
 { code:0xFE3F
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFE3F
  ,simpleLowerCaseMapping:0xFE3F
  ,simpleTitleCaseMapping:0xFE3F
 },
 { code:0xFE40
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFE40
  ,simpleLowerCaseMapping:0xFE40
  ,simpleTitleCaseMapping:0xFE40
 },
 { code:0xFE41
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFE41
  ,simpleLowerCaseMapping:0xFE41
  ,simpleTitleCaseMapping:0xFE41
 },
 { code:0xFE42
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFE42
  ,simpleLowerCaseMapping:0xFE42
  ,simpleTitleCaseMapping:0xFE42
 },
 { code:0xFE43
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFE43
  ,simpleLowerCaseMapping:0xFE43
  ,simpleTitleCaseMapping:0xFE43
 },
 { code:0xFE44
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFE44
  ,simpleLowerCaseMapping:0xFE44
  ,simpleTitleCaseMapping:0xFE44
 },
 { code:0xFE45
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE45
  ,simpleLowerCaseMapping:0xFE45
  ,simpleTitleCaseMapping:0xFE45
 },
 { code:0xFE46
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE46
  ,simpleLowerCaseMapping:0xFE46
  ,simpleTitleCaseMapping:0xFE46
 },
 { code:0xFE47
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFE47
  ,simpleLowerCaseMapping:0xFE47
  ,simpleTitleCaseMapping:0xFE47
 },
 { code:0xFE48
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFE48
  ,simpleLowerCaseMapping:0xFE48
  ,simpleTitleCaseMapping:0xFE48
 },
 { code:0xFE49
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE49
  ,simpleLowerCaseMapping:0xFE49
  ,simpleTitleCaseMapping:0xFE49
 },
 { code:0xFE4A
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE4A
  ,simpleLowerCaseMapping:0xFE4A
  ,simpleTitleCaseMapping:0xFE4A
 },
 { code:0xFE4B
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE4B
  ,simpleLowerCaseMapping:0xFE4B
  ,simpleTitleCaseMapping:0xFE4B
 },
 { code:0xFE4C
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE4C
  ,simpleLowerCaseMapping:0xFE4C
  ,simpleTitleCaseMapping:0xFE4C
 },
 { code:0xFE4D
  ,generalCategory:UnicodeData.GeneralCategory.Pc
  ,simpleUpperCaseMapping:0xFE4D
  ,simpleLowerCaseMapping:0xFE4D
  ,simpleTitleCaseMapping:0xFE4D
 },
 { code:0xFE4E
  ,generalCategory:UnicodeData.GeneralCategory.Pc
  ,simpleUpperCaseMapping:0xFE4E
  ,simpleLowerCaseMapping:0xFE4E
  ,simpleTitleCaseMapping:0xFE4E
 },
 { code:0xFE4F
  ,generalCategory:UnicodeData.GeneralCategory.Pc
  ,simpleUpperCaseMapping:0xFE4F
  ,simpleLowerCaseMapping:0xFE4F
  ,simpleTitleCaseMapping:0xFE4F
 },
 { code:0xFE50
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE50
  ,simpleLowerCaseMapping:0xFE50
  ,simpleTitleCaseMapping:0xFE50
 },
 { code:0xFE51
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE51
  ,simpleLowerCaseMapping:0xFE51
  ,simpleTitleCaseMapping:0xFE51
 },
 { code:0xFE52
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE52
  ,simpleLowerCaseMapping:0xFE52
  ,simpleTitleCaseMapping:0xFE52
 },
 { code:0xFE54
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE54
  ,simpleLowerCaseMapping:0xFE54
  ,simpleTitleCaseMapping:0xFE54
 },
 { code:0xFE55
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE55
  ,simpleLowerCaseMapping:0xFE55
  ,simpleTitleCaseMapping:0xFE55
 },
 { code:0xFE56
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE56
  ,simpleLowerCaseMapping:0xFE56
  ,simpleTitleCaseMapping:0xFE56
 },
 { code:0xFE57
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE57
  ,simpleLowerCaseMapping:0xFE57
  ,simpleTitleCaseMapping:0xFE57
 },
 { code:0xFE58
  ,generalCategory:UnicodeData.GeneralCategory.Pd
  ,simpleUpperCaseMapping:0xFE58
  ,simpleLowerCaseMapping:0xFE58
  ,simpleTitleCaseMapping:0xFE58
 },
 { code:0xFE59
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFE59
  ,simpleLowerCaseMapping:0xFE59
  ,simpleTitleCaseMapping:0xFE59
 },
 { code:0xFE5A
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFE5A
  ,simpleLowerCaseMapping:0xFE5A
  ,simpleTitleCaseMapping:0xFE5A
 },
 { code:0xFE5B
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFE5B
  ,simpleLowerCaseMapping:0xFE5B
  ,simpleTitleCaseMapping:0xFE5B
 },
 { code:0xFE5C
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFE5C
  ,simpleLowerCaseMapping:0xFE5C
  ,simpleTitleCaseMapping:0xFE5C
 },
 { code:0xFE5D
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFE5D
  ,simpleLowerCaseMapping:0xFE5D
  ,simpleTitleCaseMapping:0xFE5D
 },
 { code:0xFE5E
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFE5E
  ,simpleLowerCaseMapping:0xFE5E
  ,simpleTitleCaseMapping:0xFE5E
 },
 { code:0xFE5F
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE5F
  ,simpleLowerCaseMapping:0xFE5F
  ,simpleTitleCaseMapping:0xFE5F
 },
 { code:0xFE60
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE60
  ,simpleLowerCaseMapping:0xFE60
  ,simpleTitleCaseMapping:0xFE60
 },
 { code:0xFE61
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE61
  ,simpleLowerCaseMapping:0xFE61
  ,simpleTitleCaseMapping:0xFE61
 },
 { code:0xFE62
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0xFE62
  ,simpleLowerCaseMapping:0xFE62
  ,simpleTitleCaseMapping:0xFE62
 },
 { code:0xFE63
  ,generalCategory:UnicodeData.GeneralCategory.Pd
  ,simpleUpperCaseMapping:0xFE63
  ,simpleLowerCaseMapping:0xFE63
  ,simpleTitleCaseMapping:0xFE63
 },
 { code:0xFE64
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0xFE64
  ,simpleLowerCaseMapping:0xFE64
  ,simpleTitleCaseMapping:0xFE64
 },
 { code:0xFE65
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0xFE65
  ,simpleLowerCaseMapping:0xFE65
  ,simpleTitleCaseMapping:0xFE65
 },
 { code:0xFE66
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0xFE66
  ,simpleLowerCaseMapping:0xFE66
  ,simpleTitleCaseMapping:0xFE66
 },
 { code:0xFE68
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE68
  ,simpleLowerCaseMapping:0xFE68
  ,simpleTitleCaseMapping:0xFE68
 },
 { code:0xFE69
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0xFE69
  ,simpleLowerCaseMapping:0xFE69
  ,simpleTitleCaseMapping:0xFE69
 },
 { code:0xFE6A
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE6A
  ,simpleLowerCaseMapping:0xFE6A
  ,simpleTitleCaseMapping:0xFE6A
 },
 { code:0xFE6B
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFE6B
  ,simpleLowerCaseMapping:0xFE6B
  ,simpleTitleCaseMapping:0xFE6B
 },
 { code:0xFE70
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE70
  ,simpleLowerCaseMapping:0xFE70
  ,simpleTitleCaseMapping:0xFE70
 },
 { code:0xFE71
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE71
  ,simpleLowerCaseMapping:0xFE71
  ,simpleTitleCaseMapping:0xFE71
 },
 { code:0xFE72
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE72
  ,simpleLowerCaseMapping:0xFE72
  ,simpleTitleCaseMapping:0xFE72
 },
 { code:0xFE73
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE73
  ,simpleLowerCaseMapping:0xFE73
  ,simpleTitleCaseMapping:0xFE73
 },
 { code:0xFE74
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE74
  ,simpleLowerCaseMapping:0xFE74
  ,simpleTitleCaseMapping:0xFE74
 },
 { code:0xFE76
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE76
  ,simpleLowerCaseMapping:0xFE76
  ,simpleTitleCaseMapping:0xFE76
 },
 { code:0xFE77
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE77
  ,simpleLowerCaseMapping:0xFE77
  ,simpleTitleCaseMapping:0xFE77
 },
 { code:0xFE78
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE78
  ,simpleLowerCaseMapping:0xFE78
  ,simpleTitleCaseMapping:0xFE78
 },
 { code:0xFE79
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE79
  ,simpleLowerCaseMapping:0xFE79
  ,simpleTitleCaseMapping:0xFE79
 },
 { code:0xFE7A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE7A
  ,simpleLowerCaseMapping:0xFE7A
  ,simpleTitleCaseMapping:0xFE7A
 },
 { code:0xFE7B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE7B
  ,simpleLowerCaseMapping:0xFE7B
  ,simpleTitleCaseMapping:0xFE7B
 },
 { code:0xFE7C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE7C
  ,simpleLowerCaseMapping:0xFE7C
  ,simpleTitleCaseMapping:0xFE7C
 },
 { code:0xFE7D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE7D
  ,simpleLowerCaseMapping:0xFE7D
  ,simpleTitleCaseMapping:0xFE7D
 },
 { code:0xFE7E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE7E
  ,simpleLowerCaseMapping:0xFE7E
  ,simpleTitleCaseMapping:0xFE7E
 },
 { code:0xFE7F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE7F
  ,simpleLowerCaseMapping:0xFE7F
  ,simpleTitleCaseMapping:0xFE7F
 },
 { code:0xFE80
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE80
  ,simpleLowerCaseMapping:0xFE80
  ,simpleTitleCaseMapping:0xFE80
 },
 { code:0xFE81
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE81
  ,simpleLowerCaseMapping:0xFE81
  ,simpleTitleCaseMapping:0xFE81
 },
 { code:0xFE82
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE82
  ,simpleLowerCaseMapping:0xFE82
  ,simpleTitleCaseMapping:0xFE82
 },
 { code:0xFE83
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE83
  ,simpleLowerCaseMapping:0xFE83
  ,simpleTitleCaseMapping:0xFE83
 },
 { code:0xFE84
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE84
  ,simpleLowerCaseMapping:0xFE84
  ,simpleTitleCaseMapping:0xFE84
 },
 { code:0xFE85
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE85
  ,simpleLowerCaseMapping:0xFE85
  ,simpleTitleCaseMapping:0xFE85
 },
 { code:0xFE86
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE86
  ,simpleLowerCaseMapping:0xFE86
  ,simpleTitleCaseMapping:0xFE86
 },
 { code:0xFE87
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE87
  ,simpleLowerCaseMapping:0xFE87
  ,simpleTitleCaseMapping:0xFE87
 },
 { code:0xFE88
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE88
  ,simpleLowerCaseMapping:0xFE88
  ,simpleTitleCaseMapping:0xFE88
 },
 { code:0xFE89
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE89
  ,simpleLowerCaseMapping:0xFE89
  ,simpleTitleCaseMapping:0xFE89
 },
 { code:0xFE8A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE8A
  ,simpleLowerCaseMapping:0xFE8A
  ,simpleTitleCaseMapping:0xFE8A
 },
 { code:0xFE8B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE8B
  ,simpleLowerCaseMapping:0xFE8B
  ,simpleTitleCaseMapping:0xFE8B
 },
 { code:0xFE8C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE8C
  ,simpleLowerCaseMapping:0xFE8C
  ,simpleTitleCaseMapping:0xFE8C
 },
 { code:0xFE8D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE8D
  ,simpleLowerCaseMapping:0xFE8D
  ,simpleTitleCaseMapping:0xFE8D
 },
 { code:0xFE8E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE8E
  ,simpleLowerCaseMapping:0xFE8E
  ,simpleTitleCaseMapping:0xFE8E
 },
 { code:0xFE8F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE8F
  ,simpleLowerCaseMapping:0xFE8F
  ,simpleTitleCaseMapping:0xFE8F
 },
 { code:0xFE90
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE90
  ,simpleLowerCaseMapping:0xFE90
  ,simpleTitleCaseMapping:0xFE90
 },
 { code:0xFE91
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE91
  ,simpleLowerCaseMapping:0xFE91
  ,simpleTitleCaseMapping:0xFE91
 },
 { code:0xFE92
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE92
  ,simpleLowerCaseMapping:0xFE92
  ,simpleTitleCaseMapping:0xFE92
 },
 { code:0xFE93
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE93
  ,simpleLowerCaseMapping:0xFE93
  ,simpleTitleCaseMapping:0xFE93
 },
 { code:0xFE94
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE94
  ,simpleLowerCaseMapping:0xFE94
  ,simpleTitleCaseMapping:0xFE94
 },
 { code:0xFE95
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE95
  ,simpleLowerCaseMapping:0xFE95
  ,simpleTitleCaseMapping:0xFE95
 },
 { code:0xFE96
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE96
  ,simpleLowerCaseMapping:0xFE96
  ,simpleTitleCaseMapping:0xFE96
 },
 { code:0xFE97
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE97
  ,simpleLowerCaseMapping:0xFE97
  ,simpleTitleCaseMapping:0xFE97
 },
 { code:0xFE98
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE98
  ,simpleLowerCaseMapping:0xFE98
  ,simpleTitleCaseMapping:0xFE98
 },
 { code:0xFE99
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE99
  ,simpleLowerCaseMapping:0xFE99
  ,simpleTitleCaseMapping:0xFE99
 },
 { code:0xFE9A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE9A
  ,simpleLowerCaseMapping:0xFE9A
  ,simpleTitleCaseMapping:0xFE9A
 },
 { code:0xFE9B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE9B
  ,simpleLowerCaseMapping:0xFE9B
  ,simpleTitleCaseMapping:0xFE9B
 },
 { code:0xFE9C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE9C
  ,simpleLowerCaseMapping:0xFE9C
  ,simpleTitleCaseMapping:0xFE9C
 },
 { code:0xFE9D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE9D
  ,simpleLowerCaseMapping:0xFE9D
  ,simpleTitleCaseMapping:0xFE9D
 },
 { code:0xFE9E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE9E
  ,simpleLowerCaseMapping:0xFE9E
  ,simpleTitleCaseMapping:0xFE9E
 },
 { code:0xFE9F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFE9F
  ,simpleLowerCaseMapping:0xFE9F
  ,simpleTitleCaseMapping:0xFE9F
 },
 { code:0xFEA0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEA0
  ,simpleLowerCaseMapping:0xFEA0
  ,simpleTitleCaseMapping:0xFEA0
 },
 { code:0xFEA1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEA1
  ,simpleLowerCaseMapping:0xFEA1
  ,simpleTitleCaseMapping:0xFEA1
 },
 { code:0xFEA2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEA2
  ,simpleLowerCaseMapping:0xFEA2
  ,simpleTitleCaseMapping:0xFEA2
 },
 { code:0xFEA3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEA3
  ,simpleLowerCaseMapping:0xFEA3
  ,simpleTitleCaseMapping:0xFEA3
 },
 { code:0xFEA4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEA4
  ,simpleLowerCaseMapping:0xFEA4
  ,simpleTitleCaseMapping:0xFEA4
 },
 { code:0xFEA5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEA5
  ,simpleLowerCaseMapping:0xFEA5
  ,simpleTitleCaseMapping:0xFEA5
 },
 { code:0xFEA6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEA6
  ,simpleLowerCaseMapping:0xFEA6
  ,simpleTitleCaseMapping:0xFEA6
 },
 { code:0xFEA7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEA7
  ,simpleLowerCaseMapping:0xFEA7
  ,simpleTitleCaseMapping:0xFEA7
 },
 { code:0xFEA8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEA8
  ,simpleLowerCaseMapping:0xFEA8
  ,simpleTitleCaseMapping:0xFEA8
 },
 { code:0xFEA9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEA9
  ,simpleLowerCaseMapping:0xFEA9
  ,simpleTitleCaseMapping:0xFEA9
 },
 { code:0xFEAA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEAA
  ,simpleLowerCaseMapping:0xFEAA
  ,simpleTitleCaseMapping:0xFEAA
 },
 { code:0xFEAB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEAB
  ,simpleLowerCaseMapping:0xFEAB
  ,simpleTitleCaseMapping:0xFEAB
 },
 { code:0xFEAC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEAC
  ,simpleLowerCaseMapping:0xFEAC
  ,simpleTitleCaseMapping:0xFEAC
 },
 { code:0xFEAD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEAD
  ,simpleLowerCaseMapping:0xFEAD
  ,simpleTitleCaseMapping:0xFEAD
 },
 { code:0xFEAE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEAE
  ,simpleLowerCaseMapping:0xFEAE
  ,simpleTitleCaseMapping:0xFEAE
 },
 { code:0xFEAF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEAF
  ,simpleLowerCaseMapping:0xFEAF
  ,simpleTitleCaseMapping:0xFEAF
 },
 { code:0xFEB0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEB0
  ,simpleLowerCaseMapping:0xFEB0
  ,simpleTitleCaseMapping:0xFEB0
 },
 { code:0xFEB1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEB1
  ,simpleLowerCaseMapping:0xFEB1
  ,simpleTitleCaseMapping:0xFEB1
 },
 { code:0xFEB2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEB2
  ,simpleLowerCaseMapping:0xFEB2
  ,simpleTitleCaseMapping:0xFEB2
 },
 { code:0xFEB3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEB3
  ,simpleLowerCaseMapping:0xFEB3
  ,simpleTitleCaseMapping:0xFEB3
 },
 { code:0xFEB4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEB4
  ,simpleLowerCaseMapping:0xFEB4
  ,simpleTitleCaseMapping:0xFEB4
 },
 { code:0xFEB5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEB5
  ,simpleLowerCaseMapping:0xFEB5
  ,simpleTitleCaseMapping:0xFEB5
 },
 { code:0xFEB6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEB6
  ,simpleLowerCaseMapping:0xFEB6
  ,simpleTitleCaseMapping:0xFEB6
 },
 { code:0xFEB7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEB7
  ,simpleLowerCaseMapping:0xFEB7
  ,simpleTitleCaseMapping:0xFEB7
 },
 { code:0xFEB8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEB8
  ,simpleLowerCaseMapping:0xFEB8
  ,simpleTitleCaseMapping:0xFEB8
 },
 { code:0xFEB9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEB9
  ,simpleLowerCaseMapping:0xFEB9
  ,simpleTitleCaseMapping:0xFEB9
 },
 { code:0xFEBA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEBA
  ,simpleLowerCaseMapping:0xFEBA
  ,simpleTitleCaseMapping:0xFEBA
 },
 { code:0xFEBB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEBB
  ,simpleLowerCaseMapping:0xFEBB
  ,simpleTitleCaseMapping:0xFEBB
 },
 { code:0xFEBC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEBC
  ,simpleLowerCaseMapping:0xFEBC
  ,simpleTitleCaseMapping:0xFEBC
 },
 { code:0xFEBD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEBD
  ,simpleLowerCaseMapping:0xFEBD
  ,simpleTitleCaseMapping:0xFEBD
 },
 { code:0xFEBE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEBE
  ,simpleLowerCaseMapping:0xFEBE
  ,simpleTitleCaseMapping:0xFEBE
 },
 { code:0xFEBF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEBF
  ,simpleLowerCaseMapping:0xFEBF
  ,simpleTitleCaseMapping:0xFEBF
 },
 { code:0xFEC0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEC0
  ,simpleLowerCaseMapping:0xFEC0
  ,simpleTitleCaseMapping:0xFEC0
 },
 { code:0xFEC1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEC1
  ,simpleLowerCaseMapping:0xFEC1
  ,simpleTitleCaseMapping:0xFEC1
 },
 { code:0xFEC2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEC2
  ,simpleLowerCaseMapping:0xFEC2
  ,simpleTitleCaseMapping:0xFEC2
 },
 { code:0xFEC3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEC3
  ,simpleLowerCaseMapping:0xFEC3
  ,simpleTitleCaseMapping:0xFEC3
 },
 { code:0xFEC4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEC4
  ,simpleLowerCaseMapping:0xFEC4
  ,simpleTitleCaseMapping:0xFEC4
 },
 { code:0xFEC5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEC5
  ,simpleLowerCaseMapping:0xFEC5
  ,simpleTitleCaseMapping:0xFEC5
 },
 { code:0xFEC6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEC6
  ,simpleLowerCaseMapping:0xFEC6
  ,simpleTitleCaseMapping:0xFEC6
 },
 { code:0xFEC7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEC7
  ,simpleLowerCaseMapping:0xFEC7
  ,simpleTitleCaseMapping:0xFEC7
 },
 { code:0xFEC8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEC8
  ,simpleLowerCaseMapping:0xFEC8
  ,simpleTitleCaseMapping:0xFEC8
 },
 { code:0xFEC9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEC9
  ,simpleLowerCaseMapping:0xFEC9
  ,simpleTitleCaseMapping:0xFEC9
 },
 { code:0xFECA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFECA
  ,simpleLowerCaseMapping:0xFECA
  ,simpleTitleCaseMapping:0xFECA
 },
 { code:0xFECB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFECB
  ,simpleLowerCaseMapping:0xFECB
  ,simpleTitleCaseMapping:0xFECB
 },
 { code:0xFECC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFECC
  ,simpleLowerCaseMapping:0xFECC
  ,simpleTitleCaseMapping:0xFECC
 },
 { code:0xFECD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFECD
  ,simpleLowerCaseMapping:0xFECD
  ,simpleTitleCaseMapping:0xFECD
 },
 { code:0xFECE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFECE
  ,simpleLowerCaseMapping:0xFECE
  ,simpleTitleCaseMapping:0xFECE
 },
 { code:0xFECF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFECF
  ,simpleLowerCaseMapping:0xFECF
  ,simpleTitleCaseMapping:0xFECF
 },
 { code:0xFED0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFED0
  ,simpleLowerCaseMapping:0xFED0
  ,simpleTitleCaseMapping:0xFED0
 },
 { code:0xFED1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFED1
  ,simpleLowerCaseMapping:0xFED1
  ,simpleTitleCaseMapping:0xFED1
 },
 { code:0xFED2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFED2
  ,simpleLowerCaseMapping:0xFED2
  ,simpleTitleCaseMapping:0xFED2
 },
 { code:0xFED3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFED3
  ,simpleLowerCaseMapping:0xFED3
  ,simpleTitleCaseMapping:0xFED3
 },
 { code:0xFED4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFED4
  ,simpleLowerCaseMapping:0xFED4
  ,simpleTitleCaseMapping:0xFED4
 },
 { code:0xFED5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFED5
  ,simpleLowerCaseMapping:0xFED5
  ,simpleTitleCaseMapping:0xFED5
 },
 { code:0xFED6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFED6
  ,simpleLowerCaseMapping:0xFED6
  ,simpleTitleCaseMapping:0xFED6
 },
 { code:0xFED7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFED7
  ,simpleLowerCaseMapping:0xFED7
  ,simpleTitleCaseMapping:0xFED7
 },
 { code:0xFED8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFED8
  ,simpleLowerCaseMapping:0xFED8
  ,simpleTitleCaseMapping:0xFED8
 },
 { code:0xFED9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFED9
  ,simpleLowerCaseMapping:0xFED9
  ,simpleTitleCaseMapping:0xFED9
 },
 { code:0xFEDA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEDA
  ,simpleLowerCaseMapping:0xFEDA
  ,simpleTitleCaseMapping:0xFEDA
 },
 { code:0xFEDB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEDB
  ,simpleLowerCaseMapping:0xFEDB
  ,simpleTitleCaseMapping:0xFEDB
 },
 { code:0xFEDC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEDC
  ,simpleLowerCaseMapping:0xFEDC
  ,simpleTitleCaseMapping:0xFEDC
 },
 { code:0xFEDD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEDD
  ,simpleLowerCaseMapping:0xFEDD
  ,simpleTitleCaseMapping:0xFEDD
 },
 { code:0xFEDE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEDE
  ,simpleLowerCaseMapping:0xFEDE
  ,simpleTitleCaseMapping:0xFEDE
 },
 { code:0xFEDF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEDF
  ,simpleLowerCaseMapping:0xFEDF
  ,simpleTitleCaseMapping:0xFEDF
 },
 { code:0xFEE0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEE0
  ,simpleLowerCaseMapping:0xFEE0
  ,simpleTitleCaseMapping:0xFEE0
 },
 { code:0xFEE1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEE1
  ,simpleLowerCaseMapping:0xFEE1
  ,simpleTitleCaseMapping:0xFEE1
 },
 { code:0xFEE2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEE2
  ,simpleLowerCaseMapping:0xFEE2
  ,simpleTitleCaseMapping:0xFEE2
 },
 { code:0xFEE3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEE3
  ,simpleLowerCaseMapping:0xFEE3
  ,simpleTitleCaseMapping:0xFEE3
 },
 { code:0xFEE4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEE4
  ,simpleLowerCaseMapping:0xFEE4
  ,simpleTitleCaseMapping:0xFEE4
 },
 { code:0xFEE5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEE5
  ,simpleLowerCaseMapping:0xFEE5
  ,simpleTitleCaseMapping:0xFEE5
 },
 { code:0xFEE6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEE6
  ,simpleLowerCaseMapping:0xFEE6
  ,simpleTitleCaseMapping:0xFEE6
 },
 { code:0xFEE7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEE7
  ,simpleLowerCaseMapping:0xFEE7
  ,simpleTitleCaseMapping:0xFEE7
 },
 { code:0xFEE8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEE8
  ,simpleLowerCaseMapping:0xFEE8
  ,simpleTitleCaseMapping:0xFEE8
 },
 { code:0xFEE9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEE9
  ,simpleLowerCaseMapping:0xFEE9
  ,simpleTitleCaseMapping:0xFEE9
 },
 { code:0xFEEA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEEA
  ,simpleLowerCaseMapping:0xFEEA
  ,simpleTitleCaseMapping:0xFEEA
 },
 { code:0xFEEB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEEB
  ,simpleLowerCaseMapping:0xFEEB
  ,simpleTitleCaseMapping:0xFEEB
 },
 { code:0xFEEC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEEC
  ,simpleLowerCaseMapping:0xFEEC
  ,simpleTitleCaseMapping:0xFEEC
 },
 { code:0xFEED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEED
  ,simpleLowerCaseMapping:0xFEED
  ,simpleTitleCaseMapping:0xFEED
 },
 { code:0xFEEE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEEE
  ,simpleLowerCaseMapping:0xFEEE
  ,simpleTitleCaseMapping:0xFEEE
 },
 { code:0xFEEF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEEF
  ,simpleLowerCaseMapping:0xFEEF
  ,simpleTitleCaseMapping:0xFEEF
 },
 { code:0xFEF0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEF0
  ,simpleLowerCaseMapping:0xFEF0
  ,simpleTitleCaseMapping:0xFEF0
 },
 { code:0xFEF1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEF1
  ,simpleLowerCaseMapping:0xFEF1
  ,simpleTitleCaseMapping:0xFEF1
 },
 { code:0xFEF2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEF2
  ,simpleLowerCaseMapping:0xFEF2
  ,simpleTitleCaseMapping:0xFEF2
 },
 { code:0xFEF3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEF3
  ,simpleLowerCaseMapping:0xFEF3
  ,simpleTitleCaseMapping:0xFEF3
 },
 { code:0xFEF4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEF4
  ,simpleLowerCaseMapping:0xFEF4
  ,simpleTitleCaseMapping:0xFEF4
 },
 { code:0xFEF5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEF5
  ,simpleLowerCaseMapping:0xFEF5
  ,simpleTitleCaseMapping:0xFEF5
 },
 { code:0xFEF6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEF6
  ,simpleLowerCaseMapping:0xFEF6
  ,simpleTitleCaseMapping:0xFEF6
 },
 { code:0xFEF7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEF7
  ,simpleLowerCaseMapping:0xFEF7
  ,simpleTitleCaseMapping:0xFEF7
 },
 { code:0xFEF8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEF8
  ,simpleLowerCaseMapping:0xFEF8
  ,simpleTitleCaseMapping:0xFEF8
 },
 { code:0xFEF9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEF9
  ,simpleLowerCaseMapping:0xFEF9
  ,simpleTitleCaseMapping:0xFEF9
 },
 { code:0xFEFA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEFA
  ,simpleLowerCaseMapping:0xFEFA
  ,simpleTitleCaseMapping:0xFEFA
 },
 { code:0xFEFB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEFB
  ,simpleLowerCaseMapping:0xFEFB
  ,simpleTitleCaseMapping:0xFEFB
 },
 { code:0xFEFC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFEFC
  ,simpleLowerCaseMapping:0xFEFC
  ,simpleTitleCaseMapping:0xFEFC
 },
 { code:0xFEFF
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xFEFF
  ,simpleLowerCaseMapping:0xFEFF
  ,simpleTitleCaseMapping:0xFEFF
 },
 { code:0xFF01
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFF01
  ,simpleLowerCaseMapping:0xFF01
  ,simpleTitleCaseMapping:0xFF01
 },
 { code:0xFF02
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFF02
  ,simpleLowerCaseMapping:0xFF02
  ,simpleTitleCaseMapping:0xFF02
 },
 { code:0xFF03
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFF03
  ,simpleLowerCaseMapping:0xFF03
  ,simpleTitleCaseMapping:0xFF03
 },
 { code:0xFF04
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0xFF04
  ,simpleLowerCaseMapping:0xFF04
  ,simpleTitleCaseMapping:0xFF04
 },
 { code:0xFF05
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFF05
  ,simpleLowerCaseMapping:0xFF05
  ,simpleTitleCaseMapping:0xFF05
 },
 { code:0xFF06
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFF06
  ,simpleLowerCaseMapping:0xFF06
  ,simpleTitleCaseMapping:0xFF06
 },
 { code:0xFF07
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFF07
  ,simpleLowerCaseMapping:0xFF07
  ,simpleTitleCaseMapping:0xFF07
 },
 { code:0xFF08
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFF08
  ,simpleLowerCaseMapping:0xFF08
  ,simpleTitleCaseMapping:0xFF08
 },
 { code:0xFF09
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFF09
  ,simpleLowerCaseMapping:0xFF09
  ,simpleTitleCaseMapping:0xFF09
 },
 { code:0xFF0A
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFF0A
  ,simpleLowerCaseMapping:0xFF0A
  ,simpleTitleCaseMapping:0xFF0A
 },
 { code:0xFF0B
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0xFF0B
  ,simpleLowerCaseMapping:0xFF0B
  ,simpleTitleCaseMapping:0xFF0B
 },
 { code:0xFF0C
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFF0C
  ,simpleLowerCaseMapping:0xFF0C
  ,simpleTitleCaseMapping:0xFF0C
 },
 { code:0xFF0D
  ,generalCategory:UnicodeData.GeneralCategory.Pd
  ,simpleUpperCaseMapping:0xFF0D
  ,simpleLowerCaseMapping:0xFF0D
  ,simpleTitleCaseMapping:0xFF0D
 },
 { code:0xFF0E
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFF0E
  ,simpleLowerCaseMapping:0xFF0E
  ,simpleTitleCaseMapping:0xFF0E
 },
 { code:0xFF0F
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFF0F
  ,simpleLowerCaseMapping:0xFF0F
  ,simpleTitleCaseMapping:0xFF0F
 },
 { code:0xFF10
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0xFF10
  ,simpleLowerCaseMapping:0xFF10
  ,simpleTitleCaseMapping:0xFF10
 },
 { code:0xFF11
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0xFF11
  ,simpleLowerCaseMapping:0xFF11
  ,simpleTitleCaseMapping:0xFF11
 },
 { code:0xFF12
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0xFF12
  ,simpleLowerCaseMapping:0xFF12
  ,simpleTitleCaseMapping:0xFF12
 },
 { code:0xFF13
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0xFF13
  ,simpleLowerCaseMapping:0xFF13
  ,simpleTitleCaseMapping:0xFF13
 },
 { code:0xFF14
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0xFF14
  ,simpleLowerCaseMapping:0xFF14
  ,simpleTitleCaseMapping:0xFF14
 },
 { code:0xFF15
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0xFF15
  ,simpleLowerCaseMapping:0xFF15
  ,simpleTitleCaseMapping:0xFF15
 },
 { code:0xFF16
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0xFF16
  ,simpleLowerCaseMapping:0xFF16
  ,simpleTitleCaseMapping:0xFF16
 },
 { code:0xFF17
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0xFF17
  ,simpleLowerCaseMapping:0xFF17
  ,simpleTitleCaseMapping:0xFF17
 },
 { code:0xFF18
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0xFF18
  ,simpleLowerCaseMapping:0xFF18
  ,simpleTitleCaseMapping:0xFF18
 },
 { code:0xFF19
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0xFF19
  ,simpleLowerCaseMapping:0xFF19
  ,simpleTitleCaseMapping:0xFF19
 },
 { code:0xFF1A
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFF1A
  ,simpleLowerCaseMapping:0xFF1A
  ,simpleTitleCaseMapping:0xFF1A
 },
 { code:0xFF1B
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFF1B
  ,simpleLowerCaseMapping:0xFF1B
  ,simpleTitleCaseMapping:0xFF1B
 },
 { code:0xFF1C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0xFF1C
  ,simpleLowerCaseMapping:0xFF1C
  ,simpleTitleCaseMapping:0xFF1C
 },
 { code:0xFF1D
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0xFF1D
  ,simpleLowerCaseMapping:0xFF1D
  ,simpleTitleCaseMapping:0xFF1D
 },
 { code:0xFF1E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0xFF1E
  ,simpleLowerCaseMapping:0xFF1E
  ,simpleTitleCaseMapping:0xFF1E
 },
 { code:0xFF1F
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFF1F
  ,simpleLowerCaseMapping:0xFF1F
  ,simpleTitleCaseMapping:0xFF1F
 },
 { code:0xFF20
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFF20
  ,simpleLowerCaseMapping:0xFF20
  ,simpleTitleCaseMapping:0xFF20
 },
 { code:0xFF21
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF21
  ,simpleLowerCaseMapping:0xFF41
  ,simpleTitleCaseMapping:0xFF21
 },
 { code:0xFF22
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF22
  ,simpleLowerCaseMapping:0xFF42
  ,simpleTitleCaseMapping:0xFF22
 },
 { code:0xFF23
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF23
  ,simpleLowerCaseMapping:0xFF43
  ,simpleTitleCaseMapping:0xFF23
 },
 { code:0xFF24
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF24
  ,simpleLowerCaseMapping:0xFF44
  ,simpleTitleCaseMapping:0xFF24
 },
 { code:0xFF25
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF25
  ,simpleLowerCaseMapping:0xFF45
  ,simpleTitleCaseMapping:0xFF25
 },
 { code:0xFF26
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF26
  ,simpleLowerCaseMapping:0xFF46
  ,simpleTitleCaseMapping:0xFF26
 },
 { code:0xFF27
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF27
  ,simpleLowerCaseMapping:0xFF47
  ,simpleTitleCaseMapping:0xFF27
 },
 { code:0xFF28
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF28
  ,simpleLowerCaseMapping:0xFF48
  ,simpleTitleCaseMapping:0xFF28
 },
 { code:0xFF29
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF29
  ,simpleLowerCaseMapping:0xFF49
  ,simpleTitleCaseMapping:0xFF29
 },
 { code:0xFF2A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF2A
  ,simpleLowerCaseMapping:0xFF4A
  ,simpleTitleCaseMapping:0xFF2A
 },
 { code:0xFF2B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF2B
  ,simpleLowerCaseMapping:0xFF4B
  ,simpleTitleCaseMapping:0xFF2B
 },
 { code:0xFF2C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF2C
  ,simpleLowerCaseMapping:0xFF4C
  ,simpleTitleCaseMapping:0xFF2C
 },
 { code:0xFF2D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF2D
  ,simpleLowerCaseMapping:0xFF4D
  ,simpleTitleCaseMapping:0xFF2D
 },
 { code:0xFF2E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF2E
  ,simpleLowerCaseMapping:0xFF4E
  ,simpleTitleCaseMapping:0xFF2E
 },
 { code:0xFF2F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF2F
  ,simpleLowerCaseMapping:0xFF4F
  ,simpleTitleCaseMapping:0xFF2F
 },
 { code:0xFF30
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF30
  ,simpleLowerCaseMapping:0xFF50
  ,simpleTitleCaseMapping:0xFF30
 },
 { code:0xFF31
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF31
  ,simpleLowerCaseMapping:0xFF51
  ,simpleTitleCaseMapping:0xFF31
 },
 { code:0xFF32
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF32
  ,simpleLowerCaseMapping:0xFF52
  ,simpleTitleCaseMapping:0xFF32
 },
 { code:0xFF33
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF33
  ,simpleLowerCaseMapping:0xFF53
  ,simpleTitleCaseMapping:0xFF33
 },
 { code:0xFF34
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF34
  ,simpleLowerCaseMapping:0xFF54
  ,simpleTitleCaseMapping:0xFF34
 },
 { code:0xFF35
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF35
  ,simpleLowerCaseMapping:0xFF55
  ,simpleTitleCaseMapping:0xFF35
 },
 { code:0xFF36
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF36
  ,simpleLowerCaseMapping:0xFF56
  ,simpleTitleCaseMapping:0xFF36
 },
 { code:0xFF37
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF37
  ,simpleLowerCaseMapping:0xFF57
  ,simpleTitleCaseMapping:0xFF37
 },
 { code:0xFF38
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF38
  ,simpleLowerCaseMapping:0xFF58
  ,simpleTitleCaseMapping:0xFF38
 },
 { code:0xFF39
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF39
  ,simpleLowerCaseMapping:0xFF59
  ,simpleTitleCaseMapping:0xFF39
 },
 { code:0xFF3A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0xFF3A
  ,simpleLowerCaseMapping:0xFF5A
  ,simpleTitleCaseMapping:0xFF3A
 },
 { code:0xFF3B
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFF3B
  ,simpleLowerCaseMapping:0xFF3B
  ,simpleTitleCaseMapping:0xFF3B
 },
 { code:0xFF3C
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFF3C
  ,simpleLowerCaseMapping:0xFF3C
  ,simpleTitleCaseMapping:0xFF3C
 },
 { code:0xFF3D
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFF3D
  ,simpleLowerCaseMapping:0xFF3D
  ,simpleTitleCaseMapping:0xFF3D
 },
 { code:0xFF3E
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xFF3E
  ,simpleLowerCaseMapping:0xFF3E
  ,simpleTitleCaseMapping:0xFF3E
 },
 { code:0xFF3F
  ,generalCategory:UnicodeData.GeneralCategory.Pc
  ,simpleUpperCaseMapping:0xFF3F
  ,simpleLowerCaseMapping:0xFF3F
  ,simpleTitleCaseMapping:0xFF3F
 },
 { code:0xFF40
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xFF40
  ,simpleLowerCaseMapping:0xFF40
  ,simpleTitleCaseMapping:0xFF40
 },
 { code:0xFF41
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF21
  ,simpleLowerCaseMapping:0xFF41
  ,simpleTitleCaseMapping:0xFF21
 },
 { code:0xFF42
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF22
  ,simpleLowerCaseMapping:0xFF42
  ,simpleTitleCaseMapping:0xFF22
 },
 { code:0xFF43
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF23
  ,simpleLowerCaseMapping:0xFF43
  ,simpleTitleCaseMapping:0xFF23
 },
 { code:0xFF44
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF24
  ,simpleLowerCaseMapping:0xFF44
  ,simpleTitleCaseMapping:0xFF24
 },
 { code:0xFF45
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF25
  ,simpleLowerCaseMapping:0xFF45
  ,simpleTitleCaseMapping:0xFF25
 },
 { code:0xFF46
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF26
  ,simpleLowerCaseMapping:0xFF46
  ,simpleTitleCaseMapping:0xFF26
 },
 { code:0xFF47
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF27
  ,simpleLowerCaseMapping:0xFF47
  ,simpleTitleCaseMapping:0xFF27
 },
 { code:0xFF48
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF28
  ,simpleLowerCaseMapping:0xFF48
  ,simpleTitleCaseMapping:0xFF28
 },
 { code:0xFF49
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF29
  ,simpleLowerCaseMapping:0xFF49
  ,simpleTitleCaseMapping:0xFF29
 },
 { code:0xFF4A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF2A
  ,simpleLowerCaseMapping:0xFF4A
  ,simpleTitleCaseMapping:0xFF2A
 },
 { code:0xFF4B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF2B
  ,simpleLowerCaseMapping:0xFF4B
  ,simpleTitleCaseMapping:0xFF2B
 },
 { code:0xFF4C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF2C
  ,simpleLowerCaseMapping:0xFF4C
  ,simpleTitleCaseMapping:0xFF2C
 },
 { code:0xFF4D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF2D
  ,simpleLowerCaseMapping:0xFF4D
  ,simpleTitleCaseMapping:0xFF2D
 },
 { code:0xFF4E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF2E
  ,simpleLowerCaseMapping:0xFF4E
  ,simpleTitleCaseMapping:0xFF2E
 },
 { code:0xFF4F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF2F
  ,simpleLowerCaseMapping:0xFF4F
  ,simpleTitleCaseMapping:0xFF2F
 },
 { code:0xFF50
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF30
  ,simpleLowerCaseMapping:0xFF50
  ,simpleTitleCaseMapping:0xFF30
 },
 { code:0xFF51
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF31
  ,simpleLowerCaseMapping:0xFF51
  ,simpleTitleCaseMapping:0xFF31
 },
 { code:0xFF52
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF32
  ,simpleLowerCaseMapping:0xFF52
  ,simpleTitleCaseMapping:0xFF32
 },
 { code:0xFF53
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF33
  ,simpleLowerCaseMapping:0xFF53
  ,simpleTitleCaseMapping:0xFF33
 },
 { code:0xFF54
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF34
  ,simpleLowerCaseMapping:0xFF54
  ,simpleTitleCaseMapping:0xFF34
 },
 { code:0xFF55
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF35
  ,simpleLowerCaseMapping:0xFF55
  ,simpleTitleCaseMapping:0xFF35
 },
 { code:0xFF56
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF36
  ,simpleLowerCaseMapping:0xFF56
  ,simpleTitleCaseMapping:0xFF36
 },
 { code:0xFF57
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF37
  ,simpleLowerCaseMapping:0xFF57
  ,simpleTitleCaseMapping:0xFF37
 },
 { code:0xFF58
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF38
  ,simpleLowerCaseMapping:0xFF58
  ,simpleTitleCaseMapping:0xFF38
 },
 { code:0xFF59
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF39
  ,simpleLowerCaseMapping:0xFF59
  ,simpleTitleCaseMapping:0xFF39
 },
 { code:0xFF5A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0xFF3A
  ,simpleLowerCaseMapping:0xFF5A
  ,simpleTitleCaseMapping:0xFF3A
 },
 { code:0xFF5B
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFF5B
  ,simpleLowerCaseMapping:0xFF5B
  ,simpleTitleCaseMapping:0xFF5B
 },
 { code:0xFF5C
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0xFF5C
  ,simpleLowerCaseMapping:0xFF5C
  ,simpleTitleCaseMapping:0xFF5C
 },
 { code:0xFF5D
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFF5D
  ,simpleLowerCaseMapping:0xFF5D
  ,simpleTitleCaseMapping:0xFF5D
 },
 { code:0xFF5E
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0xFF5E
  ,simpleLowerCaseMapping:0xFF5E
  ,simpleTitleCaseMapping:0xFF5E
 },
 { code:0xFF5F
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFF5F
  ,simpleLowerCaseMapping:0xFF5F
  ,simpleTitleCaseMapping:0xFF5F
 },
 { code:0xFF60
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFF60
  ,simpleLowerCaseMapping:0xFF60
  ,simpleTitleCaseMapping:0xFF60
 },
 { code:0xFF61
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFF61
  ,simpleLowerCaseMapping:0xFF61
  ,simpleTitleCaseMapping:0xFF61
 },
 { code:0xFF62
  ,generalCategory:UnicodeData.GeneralCategory.Ps
  ,simpleUpperCaseMapping:0xFF62
  ,simpleLowerCaseMapping:0xFF62
  ,simpleTitleCaseMapping:0xFF62
 },
 { code:0xFF63
  ,generalCategory:UnicodeData.GeneralCategory.Pe
  ,simpleUpperCaseMapping:0xFF63
  ,simpleLowerCaseMapping:0xFF63
  ,simpleTitleCaseMapping:0xFF63
 },
 { code:0xFF64
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFF64
  ,simpleLowerCaseMapping:0xFF64
  ,simpleTitleCaseMapping:0xFF64
 },
 { code:0xFF65
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0xFF65
  ,simpleLowerCaseMapping:0xFF65
  ,simpleTitleCaseMapping:0xFF65
 },
 { code:0xFF66
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF66
  ,simpleLowerCaseMapping:0xFF66
  ,simpleTitleCaseMapping:0xFF66
 },
 { code:0xFF67
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF67
  ,simpleLowerCaseMapping:0xFF67
  ,simpleTitleCaseMapping:0xFF67
 },
 { code:0xFF68
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF68
  ,simpleLowerCaseMapping:0xFF68
  ,simpleTitleCaseMapping:0xFF68
 },
 { code:0xFF69
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF69
  ,simpleLowerCaseMapping:0xFF69
  ,simpleTitleCaseMapping:0xFF69
 },
 { code:0xFF6A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF6A
  ,simpleLowerCaseMapping:0xFF6A
  ,simpleTitleCaseMapping:0xFF6A
 },
 { code:0xFF6B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF6B
  ,simpleLowerCaseMapping:0xFF6B
  ,simpleTitleCaseMapping:0xFF6B
 },
 { code:0xFF6C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF6C
  ,simpleLowerCaseMapping:0xFF6C
  ,simpleTitleCaseMapping:0xFF6C
 },
 { code:0xFF6D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF6D
  ,simpleLowerCaseMapping:0xFF6D
  ,simpleTitleCaseMapping:0xFF6D
 },
 { code:0xFF6E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF6E
  ,simpleLowerCaseMapping:0xFF6E
  ,simpleTitleCaseMapping:0xFF6E
 },
 { code:0xFF6F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF6F
  ,simpleLowerCaseMapping:0xFF6F
  ,simpleTitleCaseMapping:0xFF6F
 },
 { code:0xFF70
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0xFF70
  ,simpleLowerCaseMapping:0xFF70
  ,simpleTitleCaseMapping:0xFF70
 },
 { code:0xFF71
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF71
  ,simpleLowerCaseMapping:0xFF71
  ,simpleTitleCaseMapping:0xFF71
 },
 { code:0xFF72
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF72
  ,simpleLowerCaseMapping:0xFF72
  ,simpleTitleCaseMapping:0xFF72
 },
 { code:0xFF73
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF73
  ,simpleLowerCaseMapping:0xFF73
  ,simpleTitleCaseMapping:0xFF73
 },
 { code:0xFF74
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF74
  ,simpleLowerCaseMapping:0xFF74
  ,simpleTitleCaseMapping:0xFF74
 },
 { code:0xFF75
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF75
  ,simpleLowerCaseMapping:0xFF75
  ,simpleTitleCaseMapping:0xFF75
 },
 { code:0xFF76
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF76
  ,simpleLowerCaseMapping:0xFF76
  ,simpleTitleCaseMapping:0xFF76
 },
 { code:0xFF77
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF77
  ,simpleLowerCaseMapping:0xFF77
  ,simpleTitleCaseMapping:0xFF77
 },
 { code:0xFF78
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF78
  ,simpleLowerCaseMapping:0xFF78
  ,simpleTitleCaseMapping:0xFF78
 },
 { code:0xFF79
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF79
  ,simpleLowerCaseMapping:0xFF79
  ,simpleTitleCaseMapping:0xFF79
 },
 { code:0xFF7A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF7A
  ,simpleLowerCaseMapping:0xFF7A
  ,simpleTitleCaseMapping:0xFF7A
 },
 { code:0xFF7B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF7B
  ,simpleLowerCaseMapping:0xFF7B
  ,simpleTitleCaseMapping:0xFF7B
 },
 { code:0xFF7C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF7C
  ,simpleLowerCaseMapping:0xFF7C
  ,simpleTitleCaseMapping:0xFF7C
 },
 { code:0xFF7D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF7D
  ,simpleLowerCaseMapping:0xFF7D
  ,simpleTitleCaseMapping:0xFF7D
 },
 { code:0xFF7E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF7E
  ,simpleLowerCaseMapping:0xFF7E
  ,simpleTitleCaseMapping:0xFF7E
 },
 { code:0xFF7F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF7F
  ,simpleLowerCaseMapping:0xFF7F
  ,simpleTitleCaseMapping:0xFF7F
 },
 { code:0xFF80
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF80
  ,simpleLowerCaseMapping:0xFF80
  ,simpleTitleCaseMapping:0xFF80
 },
 { code:0xFF81
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF81
  ,simpleLowerCaseMapping:0xFF81
  ,simpleTitleCaseMapping:0xFF81
 },
 { code:0xFF82
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF82
  ,simpleLowerCaseMapping:0xFF82
  ,simpleTitleCaseMapping:0xFF82
 },
 { code:0xFF83
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF83
  ,simpleLowerCaseMapping:0xFF83
  ,simpleTitleCaseMapping:0xFF83
 },
 { code:0xFF84
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF84
  ,simpleLowerCaseMapping:0xFF84
  ,simpleTitleCaseMapping:0xFF84
 },
 { code:0xFF85
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF85
  ,simpleLowerCaseMapping:0xFF85
  ,simpleTitleCaseMapping:0xFF85
 },
 { code:0xFF86
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF86
  ,simpleLowerCaseMapping:0xFF86
  ,simpleTitleCaseMapping:0xFF86
 },
 { code:0xFF87
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF87
  ,simpleLowerCaseMapping:0xFF87
  ,simpleTitleCaseMapping:0xFF87
 },
 { code:0xFF88
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF88
  ,simpleLowerCaseMapping:0xFF88
  ,simpleTitleCaseMapping:0xFF88
 },
 { code:0xFF89
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF89
  ,simpleLowerCaseMapping:0xFF89
  ,simpleTitleCaseMapping:0xFF89
 },
 { code:0xFF8A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF8A
  ,simpleLowerCaseMapping:0xFF8A
  ,simpleTitleCaseMapping:0xFF8A
 },
 { code:0xFF8B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF8B
  ,simpleLowerCaseMapping:0xFF8B
  ,simpleTitleCaseMapping:0xFF8B
 },
 { code:0xFF8C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF8C
  ,simpleLowerCaseMapping:0xFF8C
  ,simpleTitleCaseMapping:0xFF8C
 },
 { code:0xFF8D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF8D
  ,simpleLowerCaseMapping:0xFF8D
  ,simpleTitleCaseMapping:0xFF8D
 },
 { code:0xFF8E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF8E
  ,simpleLowerCaseMapping:0xFF8E
  ,simpleTitleCaseMapping:0xFF8E
 },
 { code:0xFF8F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF8F
  ,simpleLowerCaseMapping:0xFF8F
  ,simpleTitleCaseMapping:0xFF8F
 },
 { code:0xFF90
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF90
  ,simpleLowerCaseMapping:0xFF90
  ,simpleTitleCaseMapping:0xFF90
 },
 { code:0xFF91
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF91
  ,simpleLowerCaseMapping:0xFF91
  ,simpleTitleCaseMapping:0xFF91
 },
 { code:0xFF92
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF92
  ,simpleLowerCaseMapping:0xFF92
  ,simpleTitleCaseMapping:0xFF92
 },
 { code:0xFF93
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF93
  ,simpleLowerCaseMapping:0xFF93
  ,simpleTitleCaseMapping:0xFF93
 },
 { code:0xFF94
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF94
  ,simpleLowerCaseMapping:0xFF94
  ,simpleTitleCaseMapping:0xFF94
 },
 { code:0xFF95
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF95
  ,simpleLowerCaseMapping:0xFF95
  ,simpleTitleCaseMapping:0xFF95
 },
 { code:0xFF96
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF96
  ,simpleLowerCaseMapping:0xFF96
  ,simpleTitleCaseMapping:0xFF96
 },
 { code:0xFF97
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF97
  ,simpleLowerCaseMapping:0xFF97
  ,simpleTitleCaseMapping:0xFF97
 },
 { code:0xFF98
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF98
  ,simpleLowerCaseMapping:0xFF98
  ,simpleTitleCaseMapping:0xFF98
 },
 { code:0xFF99
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF99
  ,simpleLowerCaseMapping:0xFF99
  ,simpleTitleCaseMapping:0xFF99
 },
 { code:0xFF9A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF9A
  ,simpleLowerCaseMapping:0xFF9A
  ,simpleTitleCaseMapping:0xFF9A
 },
 { code:0xFF9B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF9B
  ,simpleLowerCaseMapping:0xFF9B
  ,simpleTitleCaseMapping:0xFF9B
 },
 { code:0xFF9C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF9C
  ,simpleLowerCaseMapping:0xFF9C
  ,simpleTitleCaseMapping:0xFF9C
 },
 { code:0xFF9D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFF9D
  ,simpleLowerCaseMapping:0xFF9D
  ,simpleTitleCaseMapping:0xFF9D
 },
 { code:0xFF9E
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0xFF9E
  ,simpleLowerCaseMapping:0xFF9E
  ,simpleTitleCaseMapping:0xFF9E
 },
 { code:0xFF9F
  ,generalCategory:UnicodeData.GeneralCategory.Lm
  ,simpleUpperCaseMapping:0xFF9F
  ,simpleLowerCaseMapping:0xFF9F
  ,simpleTitleCaseMapping:0xFF9F
 },
 { code:0xFFA0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFA0
  ,simpleLowerCaseMapping:0xFFA0
  ,simpleTitleCaseMapping:0xFFA0
 },
 { code:0xFFA1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFA1
  ,simpleLowerCaseMapping:0xFFA1
  ,simpleTitleCaseMapping:0xFFA1
 },
 { code:0xFFA2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFA2
  ,simpleLowerCaseMapping:0xFFA2
  ,simpleTitleCaseMapping:0xFFA2
 },
 { code:0xFFA3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFA3
  ,simpleLowerCaseMapping:0xFFA3
  ,simpleTitleCaseMapping:0xFFA3
 },
 { code:0xFFA4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFA4
  ,simpleLowerCaseMapping:0xFFA4
  ,simpleTitleCaseMapping:0xFFA4
 },
 { code:0xFFA5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFA5
  ,simpleLowerCaseMapping:0xFFA5
  ,simpleTitleCaseMapping:0xFFA5
 },
 { code:0xFFA6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFA6
  ,simpleLowerCaseMapping:0xFFA6
  ,simpleTitleCaseMapping:0xFFA6
 },
 { code:0xFFA7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFA7
  ,simpleLowerCaseMapping:0xFFA7
  ,simpleTitleCaseMapping:0xFFA7
 },
 { code:0xFFA8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFA8
  ,simpleLowerCaseMapping:0xFFA8
  ,simpleTitleCaseMapping:0xFFA8
 },
 { code:0xFFA9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFA9
  ,simpleLowerCaseMapping:0xFFA9
  ,simpleTitleCaseMapping:0xFFA9
 },
 { code:0xFFAA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFAA
  ,simpleLowerCaseMapping:0xFFAA
  ,simpleTitleCaseMapping:0xFFAA
 },
 { code:0xFFAB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFAB
  ,simpleLowerCaseMapping:0xFFAB
  ,simpleTitleCaseMapping:0xFFAB
 },
 { code:0xFFAC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFAC
  ,simpleLowerCaseMapping:0xFFAC
  ,simpleTitleCaseMapping:0xFFAC
 },
 { code:0xFFAD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFAD
  ,simpleLowerCaseMapping:0xFFAD
  ,simpleTitleCaseMapping:0xFFAD
 },
 { code:0xFFAE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFAE
  ,simpleLowerCaseMapping:0xFFAE
  ,simpleTitleCaseMapping:0xFFAE
 },
 { code:0xFFAF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFAF
  ,simpleLowerCaseMapping:0xFFAF
  ,simpleTitleCaseMapping:0xFFAF
 },
 { code:0xFFB0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFB0
  ,simpleLowerCaseMapping:0xFFB0
  ,simpleTitleCaseMapping:0xFFB0
 },
 { code:0xFFB1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFB1
  ,simpleLowerCaseMapping:0xFFB1
  ,simpleTitleCaseMapping:0xFFB1
 },
 { code:0xFFB2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFB2
  ,simpleLowerCaseMapping:0xFFB2
  ,simpleTitleCaseMapping:0xFFB2
 },
 { code:0xFFB3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFB3
  ,simpleLowerCaseMapping:0xFFB3
  ,simpleTitleCaseMapping:0xFFB3
 },
 { code:0xFFB4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFB4
  ,simpleLowerCaseMapping:0xFFB4
  ,simpleTitleCaseMapping:0xFFB4
 },
 { code:0xFFB5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFB5
  ,simpleLowerCaseMapping:0xFFB5
  ,simpleTitleCaseMapping:0xFFB5
 },
 { code:0xFFB6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFB6
  ,simpleLowerCaseMapping:0xFFB6
  ,simpleTitleCaseMapping:0xFFB6
 },
 { code:0xFFB7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFB7
  ,simpleLowerCaseMapping:0xFFB7
  ,simpleTitleCaseMapping:0xFFB7
 },
 { code:0xFFB8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFB8
  ,simpleLowerCaseMapping:0xFFB8
  ,simpleTitleCaseMapping:0xFFB8
 },
 { code:0xFFB9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFB9
  ,simpleLowerCaseMapping:0xFFB9
  ,simpleTitleCaseMapping:0xFFB9
 },
 { code:0xFFBA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFBA
  ,simpleLowerCaseMapping:0xFFBA
  ,simpleTitleCaseMapping:0xFFBA
 },
 { code:0xFFBB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFBB
  ,simpleLowerCaseMapping:0xFFBB
  ,simpleTitleCaseMapping:0xFFBB
 },
 { code:0xFFBC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFBC
  ,simpleLowerCaseMapping:0xFFBC
  ,simpleTitleCaseMapping:0xFFBC
 },
 { code:0xFFBD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFBD
  ,simpleLowerCaseMapping:0xFFBD
  ,simpleTitleCaseMapping:0xFFBD
 },
 { code:0xFFBE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFBE
  ,simpleLowerCaseMapping:0xFFBE
  ,simpleTitleCaseMapping:0xFFBE
 },
 { code:0xFFC2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFC2
  ,simpleLowerCaseMapping:0xFFC2
  ,simpleTitleCaseMapping:0xFFC2
 },
 { code:0xFFC3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFC3
  ,simpleLowerCaseMapping:0xFFC3
  ,simpleTitleCaseMapping:0xFFC3
 },
 { code:0xFFC4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFC4
  ,simpleLowerCaseMapping:0xFFC4
  ,simpleTitleCaseMapping:0xFFC4
 },
 { code:0xFFC5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFC5
  ,simpleLowerCaseMapping:0xFFC5
  ,simpleTitleCaseMapping:0xFFC5
 },
 { code:0xFFC6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFC6
  ,simpleLowerCaseMapping:0xFFC6
  ,simpleTitleCaseMapping:0xFFC6
 },
 { code:0xFFC7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFC7
  ,simpleLowerCaseMapping:0xFFC7
  ,simpleTitleCaseMapping:0xFFC7
 },
 { code:0xFFCA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFCA
  ,simpleLowerCaseMapping:0xFFCA
  ,simpleTitleCaseMapping:0xFFCA
 },
 { code:0xFFCB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFCB
  ,simpleLowerCaseMapping:0xFFCB
  ,simpleTitleCaseMapping:0xFFCB
 },
 { code:0xFFCC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFCC
  ,simpleLowerCaseMapping:0xFFCC
  ,simpleTitleCaseMapping:0xFFCC
 },
 { code:0xFFCD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFCD
  ,simpleLowerCaseMapping:0xFFCD
  ,simpleTitleCaseMapping:0xFFCD
 },
 { code:0xFFCE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFCE
  ,simpleLowerCaseMapping:0xFFCE
  ,simpleTitleCaseMapping:0xFFCE
 },
 { code:0xFFCF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFCF
  ,simpleLowerCaseMapping:0xFFCF
  ,simpleTitleCaseMapping:0xFFCF
 },
 { code:0xFFD2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFD2
  ,simpleLowerCaseMapping:0xFFD2
  ,simpleTitleCaseMapping:0xFFD2
 },
 { code:0xFFD3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFD3
  ,simpleLowerCaseMapping:0xFFD3
  ,simpleTitleCaseMapping:0xFFD3
 },
 { code:0xFFD4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFD4
  ,simpleLowerCaseMapping:0xFFD4
  ,simpleTitleCaseMapping:0xFFD4
 },
 { code:0xFFD5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFD5
  ,simpleLowerCaseMapping:0xFFD5
  ,simpleTitleCaseMapping:0xFFD5
 },
 { code:0xFFD6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFD6
  ,simpleLowerCaseMapping:0xFFD6
  ,simpleTitleCaseMapping:0xFFD6
 },
 { code:0xFFD7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFD7
  ,simpleLowerCaseMapping:0xFFD7
  ,simpleTitleCaseMapping:0xFFD7
 },
 { code:0xFFDA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFDA
  ,simpleLowerCaseMapping:0xFFDA
  ,simpleTitleCaseMapping:0xFFDA
 },
 { code:0xFFDB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFDB
  ,simpleLowerCaseMapping:0xFFDB
  ,simpleTitleCaseMapping:0xFFDB
 },
 { code:0xFFDC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0xFFDC
  ,simpleLowerCaseMapping:0xFFDC
  ,simpleTitleCaseMapping:0xFFDC
 },
 { code:0xFFE0
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0xFFE0
  ,simpleLowerCaseMapping:0xFFE0
  ,simpleTitleCaseMapping:0xFFE0
 },
 { code:0xFFE1
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0xFFE1
  ,simpleLowerCaseMapping:0xFFE1
  ,simpleTitleCaseMapping:0xFFE1
 },
 { code:0xFFE2
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0xFFE2
  ,simpleLowerCaseMapping:0xFFE2
  ,simpleTitleCaseMapping:0xFFE2
 },
 { code:0xFFE3
  ,generalCategory:UnicodeData.GeneralCategory.Sk
  ,simpleUpperCaseMapping:0xFFE3
  ,simpleLowerCaseMapping:0xFFE3
  ,simpleTitleCaseMapping:0xFFE3
 },
 { code:0xFFE4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xFFE4
  ,simpleLowerCaseMapping:0xFFE4
  ,simpleTitleCaseMapping:0xFFE4
 },
 { code:0xFFE5
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0xFFE5
  ,simpleLowerCaseMapping:0xFFE5
  ,simpleTitleCaseMapping:0xFFE5
 },
 { code:0xFFE6
  ,generalCategory:UnicodeData.GeneralCategory.Sc
  ,simpleUpperCaseMapping:0xFFE6
  ,simpleLowerCaseMapping:0xFFE6
  ,simpleTitleCaseMapping:0xFFE6
 },
 { code:0xFFE8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xFFE8
  ,simpleLowerCaseMapping:0xFFE8
  ,simpleTitleCaseMapping:0xFFE8
 },
 { code:0xFFE9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0xFFE9
  ,simpleLowerCaseMapping:0xFFE9
  ,simpleTitleCaseMapping:0xFFE9
 },
 { code:0xFFEA
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0xFFEA
  ,simpleLowerCaseMapping:0xFFEA
  ,simpleTitleCaseMapping:0xFFEA
 },
 { code:0xFFEB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0xFFEB
  ,simpleLowerCaseMapping:0xFFEB
  ,simpleTitleCaseMapping:0xFFEB
 },
 { code:0xFFEC
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0xFFEC
  ,simpleLowerCaseMapping:0xFFEC
  ,simpleTitleCaseMapping:0xFFEC
 },
 { code:0xFFED
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xFFED
  ,simpleLowerCaseMapping:0xFFED
  ,simpleTitleCaseMapping:0xFFED
 },
 { code:0xFFEE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xFFEE
  ,simpleLowerCaseMapping:0xFFEE
  ,simpleTitleCaseMapping:0xFFEE
 },
 { code:0xFFF9
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xFFF9
  ,simpleLowerCaseMapping:0xFFF9
  ,simpleTitleCaseMapping:0xFFF9
 },
 { code:0xFFFA
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xFFFA
  ,simpleLowerCaseMapping:0xFFFA
  ,simpleTitleCaseMapping:0xFFFA
 },
 { code:0xFFFB
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xFFFB
  ,simpleLowerCaseMapping:0xFFFB
  ,simpleTitleCaseMapping:0xFFFB
 },
 { code:0xFFFC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xFFFC
  ,simpleLowerCaseMapping:0xFFFC
  ,simpleTitleCaseMapping:0xFFFC
 },
 { code:0xFFFD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0xFFFD
  ,simpleLowerCaseMapping:0xFFFD
  ,simpleTitleCaseMapping:0xFFFD
 },
 { code:0x10000
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10000
  ,simpleLowerCaseMapping:0x10000
  ,simpleTitleCaseMapping:0x10000
 },
 { code:0x10001
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10001
  ,simpleLowerCaseMapping:0x10001
  ,simpleTitleCaseMapping:0x10001
 },
 { code:0x10002
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10002
  ,simpleLowerCaseMapping:0x10002
  ,simpleTitleCaseMapping:0x10002
 },
 { code:0x10003
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10003
  ,simpleLowerCaseMapping:0x10003
  ,simpleTitleCaseMapping:0x10003
 },
 { code:0x10004
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10004
  ,simpleLowerCaseMapping:0x10004
  ,simpleTitleCaseMapping:0x10004
 },
 { code:0x10005
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10005
  ,simpleLowerCaseMapping:0x10005
  ,simpleTitleCaseMapping:0x10005
 },
 { code:0x10006
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10006
  ,simpleLowerCaseMapping:0x10006
  ,simpleTitleCaseMapping:0x10006
 },
 { code:0x10007
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10007
  ,simpleLowerCaseMapping:0x10007
  ,simpleTitleCaseMapping:0x10007
 },
 { code:0x10008
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10008
  ,simpleLowerCaseMapping:0x10008
  ,simpleTitleCaseMapping:0x10008
 },
 { code:0x10009
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10009
  ,simpleLowerCaseMapping:0x10009
  ,simpleTitleCaseMapping:0x10009
 },
 { code:0x1000A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1000A
  ,simpleLowerCaseMapping:0x1000A
  ,simpleTitleCaseMapping:0x1000A
 },
 { code:0x1000B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1000B
  ,simpleLowerCaseMapping:0x1000B
  ,simpleTitleCaseMapping:0x1000B
 },
 { code:0x1000D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1000D
  ,simpleLowerCaseMapping:0x1000D
  ,simpleTitleCaseMapping:0x1000D
 },
 { code:0x1000E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1000E
  ,simpleLowerCaseMapping:0x1000E
  ,simpleTitleCaseMapping:0x1000E
 },
 { code:0x1000F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1000F
  ,simpleLowerCaseMapping:0x1000F
  ,simpleTitleCaseMapping:0x1000F
 },
 { code:0x10010
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10010
  ,simpleLowerCaseMapping:0x10010
  ,simpleTitleCaseMapping:0x10010
 },
 { code:0x10011
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10011
  ,simpleLowerCaseMapping:0x10011
  ,simpleTitleCaseMapping:0x10011
 },
 { code:0x10012
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10012
  ,simpleLowerCaseMapping:0x10012
  ,simpleTitleCaseMapping:0x10012
 },
 { code:0x10013
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10013
  ,simpleLowerCaseMapping:0x10013
  ,simpleTitleCaseMapping:0x10013
 },
 { code:0x10014
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10014
  ,simpleLowerCaseMapping:0x10014
  ,simpleTitleCaseMapping:0x10014
 },
 { code:0x10015
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10015
  ,simpleLowerCaseMapping:0x10015
  ,simpleTitleCaseMapping:0x10015
 },
 { code:0x10016
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10016
  ,simpleLowerCaseMapping:0x10016
  ,simpleTitleCaseMapping:0x10016
 },
 { code:0x10017
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10017
  ,simpleLowerCaseMapping:0x10017
  ,simpleTitleCaseMapping:0x10017
 },
 { code:0x10018
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10018
  ,simpleLowerCaseMapping:0x10018
  ,simpleTitleCaseMapping:0x10018
 },
 { code:0x10019
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10019
  ,simpleLowerCaseMapping:0x10019
  ,simpleTitleCaseMapping:0x10019
 },
 { code:0x1001A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1001A
  ,simpleLowerCaseMapping:0x1001A
  ,simpleTitleCaseMapping:0x1001A
 },
 { code:0x1001B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1001B
  ,simpleLowerCaseMapping:0x1001B
  ,simpleTitleCaseMapping:0x1001B
 },
 { code:0x1001C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1001C
  ,simpleLowerCaseMapping:0x1001C
  ,simpleTitleCaseMapping:0x1001C
 },
 { code:0x1001D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1001D
  ,simpleLowerCaseMapping:0x1001D
  ,simpleTitleCaseMapping:0x1001D
 },
 { code:0x1001E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1001E
  ,simpleLowerCaseMapping:0x1001E
  ,simpleTitleCaseMapping:0x1001E
 },
 { code:0x1001F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1001F
  ,simpleLowerCaseMapping:0x1001F
  ,simpleTitleCaseMapping:0x1001F
 },
 { code:0x10020
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10020
  ,simpleLowerCaseMapping:0x10020
  ,simpleTitleCaseMapping:0x10020
 },
 { code:0x10021
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10021
  ,simpleLowerCaseMapping:0x10021
  ,simpleTitleCaseMapping:0x10021
 },
 { code:0x10022
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10022
  ,simpleLowerCaseMapping:0x10022
  ,simpleTitleCaseMapping:0x10022
 },
 { code:0x10023
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10023
  ,simpleLowerCaseMapping:0x10023
  ,simpleTitleCaseMapping:0x10023
 },
 { code:0x10024
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10024
  ,simpleLowerCaseMapping:0x10024
  ,simpleTitleCaseMapping:0x10024
 },
 { code:0x10025
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10025
  ,simpleLowerCaseMapping:0x10025
  ,simpleTitleCaseMapping:0x10025
 },
 { code:0x10026
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10026
  ,simpleLowerCaseMapping:0x10026
  ,simpleTitleCaseMapping:0x10026
 },
 { code:0x10028
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10028
  ,simpleLowerCaseMapping:0x10028
  ,simpleTitleCaseMapping:0x10028
 },
 { code:0x10029
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10029
  ,simpleLowerCaseMapping:0x10029
  ,simpleTitleCaseMapping:0x10029
 },
 { code:0x1002A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1002A
  ,simpleLowerCaseMapping:0x1002A
  ,simpleTitleCaseMapping:0x1002A
 },
 { code:0x1002B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1002B
  ,simpleLowerCaseMapping:0x1002B
  ,simpleTitleCaseMapping:0x1002B
 },
 { code:0x1002C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1002C
  ,simpleLowerCaseMapping:0x1002C
  ,simpleTitleCaseMapping:0x1002C
 },
 { code:0x1002D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1002D
  ,simpleLowerCaseMapping:0x1002D
  ,simpleTitleCaseMapping:0x1002D
 },
 { code:0x1002E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1002E
  ,simpleLowerCaseMapping:0x1002E
  ,simpleTitleCaseMapping:0x1002E
 },
 { code:0x1002F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1002F
  ,simpleLowerCaseMapping:0x1002F
  ,simpleTitleCaseMapping:0x1002F
 },
 { code:0x10030
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10030
  ,simpleLowerCaseMapping:0x10030
  ,simpleTitleCaseMapping:0x10030
 },
 { code:0x10031
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10031
  ,simpleLowerCaseMapping:0x10031
  ,simpleTitleCaseMapping:0x10031
 },
 { code:0x10032
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10032
  ,simpleLowerCaseMapping:0x10032
  ,simpleTitleCaseMapping:0x10032
 },
 { code:0x10033
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10033
  ,simpleLowerCaseMapping:0x10033
  ,simpleTitleCaseMapping:0x10033
 },
 { code:0x10034
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10034
  ,simpleLowerCaseMapping:0x10034
  ,simpleTitleCaseMapping:0x10034
 },
 { code:0x10035
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10035
  ,simpleLowerCaseMapping:0x10035
  ,simpleTitleCaseMapping:0x10035
 },
 { code:0x10036
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10036
  ,simpleLowerCaseMapping:0x10036
  ,simpleTitleCaseMapping:0x10036
 },
 { code:0x10037
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10037
  ,simpleLowerCaseMapping:0x10037
  ,simpleTitleCaseMapping:0x10037
 },
 { code:0x10038
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10038
  ,simpleLowerCaseMapping:0x10038
  ,simpleTitleCaseMapping:0x10038
 },
 { code:0x10039
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10039
  ,simpleLowerCaseMapping:0x10039
  ,simpleTitleCaseMapping:0x10039
 },
 { code:0x1003A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1003A
  ,simpleLowerCaseMapping:0x1003A
  ,simpleTitleCaseMapping:0x1003A
 },
 { code:0x1003C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1003C
  ,simpleLowerCaseMapping:0x1003C
  ,simpleTitleCaseMapping:0x1003C
 },
 { code:0x1003D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1003D
  ,simpleLowerCaseMapping:0x1003D
  ,simpleTitleCaseMapping:0x1003D
 },
 { code:0x1003F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1003F
  ,simpleLowerCaseMapping:0x1003F
  ,simpleTitleCaseMapping:0x1003F
 },
 { code:0x10040
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10040
  ,simpleLowerCaseMapping:0x10040
  ,simpleTitleCaseMapping:0x10040
 },
 { code:0x10041
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10041
  ,simpleLowerCaseMapping:0x10041
  ,simpleTitleCaseMapping:0x10041
 },
 { code:0x10042
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10042
  ,simpleLowerCaseMapping:0x10042
  ,simpleTitleCaseMapping:0x10042
 },
 { code:0x10043
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10043
  ,simpleLowerCaseMapping:0x10043
  ,simpleTitleCaseMapping:0x10043
 },
 { code:0x10044
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10044
  ,simpleLowerCaseMapping:0x10044
  ,simpleTitleCaseMapping:0x10044
 },
 { code:0x10045
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10045
  ,simpleLowerCaseMapping:0x10045
  ,simpleTitleCaseMapping:0x10045
 },
 { code:0x10046
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10046
  ,simpleLowerCaseMapping:0x10046
  ,simpleTitleCaseMapping:0x10046
 },
 { code:0x10047
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10047
  ,simpleLowerCaseMapping:0x10047
  ,simpleTitleCaseMapping:0x10047
 },
 { code:0x10048
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10048
  ,simpleLowerCaseMapping:0x10048
  ,simpleTitleCaseMapping:0x10048
 },
 { code:0x10049
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10049
  ,simpleLowerCaseMapping:0x10049
  ,simpleTitleCaseMapping:0x10049
 },
 { code:0x1004A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1004A
  ,simpleLowerCaseMapping:0x1004A
  ,simpleTitleCaseMapping:0x1004A
 },
 { code:0x1004B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1004B
  ,simpleLowerCaseMapping:0x1004B
  ,simpleTitleCaseMapping:0x1004B
 },
 { code:0x1004C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1004C
  ,simpleLowerCaseMapping:0x1004C
  ,simpleTitleCaseMapping:0x1004C
 },
 { code:0x1004D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1004D
  ,simpleLowerCaseMapping:0x1004D
  ,simpleTitleCaseMapping:0x1004D
 },
 { code:0x10050
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10050
  ,simpleLowerCaseMapping:0x10050
  ,simpleTitleCaseMapping:0x10050
 },
 { code:0x10051
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10051
  ,simpleLowerCaseMapping:0x10051
  ,simpleTitleCaseMapping:0x10051
 },
 { code:0x10052
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10052
  ,simpleLowerCaseMapping:0x10052
  ,simpleTitleCaseMapping:0x10052
 },
 { code:0x10053
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10053
  ,simpleLowerCaseMapping:0x10053
  ,simpleTitleCaseMapping:0x10053
 },
 { code:0x10054
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10054
  ,simpleLowerCaseMapping:0x10054
  ,simpleTitleCaseMapping:0x10054
 },
 { code:0x10055
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10055
  ,simpleLowerCaseMapping:0x10055
  ,simpleTitleCaseMapping:0x10055
 },
 { code:0x10056
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10056
  ,simpleLowerCaseMapping:0x10056
  ,simpleTitleCaseMapping:0x10056
 },
 { code:0x10057
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10057
  ,simpleLowerCaseMapping:0x10057
  ,simpleTitleCaseMapping:0x10057
 },
 { code:0x10058
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10058
  ,simpleLowerCaseMapping:0x10058
  ,simpleTitleCaseMapping:0x10058
 },
 { code:0x10059
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10059
  ,simpleLowerCaseMapping:0x10059
  ,simpleTitleCaseMapping:0x10059
 },
 { code:0x1005A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1005A
  ,simpleLowerCaseMapping:0x1005A
  ,simpleTitleCaseMapping:0x1005A
 },
 { code:0x1005B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1005B
  ,simpleLowerCaseMapping:0x1005B
  ,simpleTitleCaseMapping:0x1005B
 },
 { code:0x1005C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1005C
  ,simpleLowerCaseMapping:0x1005C
  ,simpleTitleCaseMapping:0x1005C
 },
 { code:0x1005D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1005D
  ,simpleLowerCaseMapping:0x1005D
  ,simpleTitleCaseMapping:0x1005D
 },
 { code:0x10080
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10080
  ,simpleLowerCaseMapping:0x10080
  ,simpleTitleCaseMapping:0x10080
 },
 { code:0x10081
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10081
  ,simpleLowerCaseMapping:0x10081
  ,simpleTitleCaseMapping:0x10081
 },
 { code:0x10082
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10082
  ,simpleLowerCaseMapping:0x10082
  ,simpleTitleCaseMapping:0x10082
 },
 { code:0x10083
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10083
  ,simpleLowerCaseMapping:0x10083
  ,simpleTitleCaseMapping:0x10083
 },
 { code:0x10084
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10084
  ,simpleLowerCaseMapping:0x10084
  ,simpleTitleCaseMapping:0x10084
 },
 { code:0x10085
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10085
  ,simpleLowerCaseMapping:0x10085
  ,simpleTitleCaseMapping:0x10085
 },
 { code:0x10086
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10086
  ,simpleLowerCaseMapping:0x10086
  ,simpleTitleCaseMapping:0x10086
 },
 { code:0x10087
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10087
  ,simpleLowerCaseMapping:0x10087
  ,simpleTitleCaseMapping:0x10087
 },
 { code:0x10088
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10088
  ,simpleLowerCaseMapping:0x10088
  ,simpleTitleCaseMapping:0x10088
 },
 { code:0x10089
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10089
  ,simpleLowerCaseMapping:0x10089
  ,simpleTitleCaseMapping:0x10089
 },
 { code:0x1008A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1008A
  ,simpleLowerCaseMapping:0x1008A
  ,simpleTitleCaseMapping:0x1008A
 },
 { code:0x1008B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1008B
  ,simpleLowerCaseMapping:0x1008B
  ,simpleTitleCaseMapping:0x1008B
 },
 { code:0x1008C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1008C
  ,simpleLowerCaseMapping:0x1008C
  ,simpleTitleCaseMapping:0x1008C
 },
 { code:0x1008D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1008D
  ,simpleLowerCaseMapping:0x1008D
  ,simpleTitleCaseMapping:0x1008D
 },
 { code:0x1008E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1008E
  ,simpleLowerCaseMapping:0x1008E
  ,simpleTitleCaseMapping:0x1008E
 },
 { code:0x1008F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1008F
  ,simpleLowerCaseMapping:0x1008F
  ,simpleTitleCaseMapping:0x1008F
 },
 { code:0x10090
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10090
  ,simpleLowerCaseMapping:0x10090
  ,simpleTitleCaseMapping:0x10090
 },
 { code:0x10091
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10091
  ,simpleLowerCaseMapping:0x10091
  ,simpleTitleCaseMapping:0x10091
 },
 { code:0x10092
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10092
  ,simpleLowerCaseMapping:0x10092
  ,simpleTitleCaseMapping:0x10092
 },
 { code:0x10093
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10093
  ,simpleLowerCaseMapping:0x10093
  ,simpleTitleCaseMapping:0x10093
 },
 { code:0x10094
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10094
  ,simpleLowerCaseMapping:0x10094
  ,simpleTitleCaseMapping:0x10094
 },
 { code:0x10095
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10095
  ,simpleLowerCaseMapping:0x10095
  ,simpleTitleCaseMapping:0x10095
 },
 { code:0x10096
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10096
  ,simpleLowerCaseMapping:0x10096
  ,simpleTitleCaseMapping:0x10096
 },
 { code:0x10097
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10097
  ,simpleLowerCaseMapping:0x10097
  ,simpleTitleCaseMapping:0x10097
 },
 { code:0x10098
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10098
  ,simpleLowerCaseMapping:0x10098
  ,simpleTitleCaseMapping:0x10098
 },
 { code:0x10099
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10099
  ,simpleLowerCaseMapping:0x10099
  ,simpleTitleCaseMapping:0x10099
 },
 { code:0x1009A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1009A
  ,simpleLowerCaseMapping:0x1009A
  ,simpleTitleCaseMapping:0x1009A
 },
 { code:0x1009B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1009B
  ,simpleLowerCaseMapping:0x1009B
  ,simpleTitleCaseMapping:0x1009B
 },
 { code:0x1009C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1009C
  ,simpleLowerCaseMapping:0x1009C
  ,simpleTitleCaseMapping:0x1009C
 },
 { code:0x1009D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1009D
  ,simpleLowerCaseMapping:0x1009D
  ,simpleTitleCaseMapping:0x1009D
 },
 { code:0x1009E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1009E
  ,simpleLowerCaseMapping:0x1009E
  ,simpleTitleCaseMapping:0x1009E
 },
 { code:0x1009F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1009F
  ,simpleLowerCaseMapping:0x1009F
  ,simpleTitleCaseMapping:0x1009F
 },
 { code:0x100A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100A0
  ,simpleLowerCaseMapping:0x100A0
  ,simpleTitleCaseMapping:0x100A0
 },
 { code:0x100A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100A1
  ,simpleLowerCaseMapping:0x100A1
  ,simpleTitleCaseMapping:0x100A1
 },
 { code:0x100A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100A2
  ,simpleLowerCaseMapping:0x100A2
  ,simpleTitleCaseMapping:0x100A2
 },
 { code:0x100A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100A3
  ,simpleLowerCaseMapping:0x100A3
  ,simpleTitleCaseMapping:0x100A3
 },
 { code:0x100A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100A4
  ,simpleLowerCaseMapping:0x100A4
  ,simpleTitleCaseMapping:0x100A4
 },
 { code:0x100A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100A5
  ,simpleLowerCaseMapping:0x100A5
  ,simpleTitleCaseMapping:0x100A5
 },
 { code:0x100A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100A6
  ,simpleLowerCaseMapping:0x100A6
  ,simpleTitleCaseMapping:0x100A6
 },
 { code:0x100A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100A7
  ,simpleLowerCaseMapping:0x100A7
  ,simpleTitleCaseMapping:0x100A7
 },
 { code:0x100A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100A8
  ,simpleLowerCaseMapping:0x100A8
  ,simpleTitleCaseMapping:0x100A8
 },
 { code:0x100A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100A9
  ,simpleLowerCaseMapping:0x100A9
  ,simpleTitleCaseMapping:0x100A9
 },
 { code:0x100AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100AA
  ,simpleLowerCaseMapping:0x100AA
  ,simpleTitleCaseMapping:0x100AA
 },
 { code:0x100AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100AB
  ,simpleLowerCaseMapping:0x100AB
  ,simpleTitleCaseMapping:0x100AB
 },
 { code:0x100AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100AC
  ,simpleLowerCaseMapping:0x100AC
  ,simpleTitleCaseMapping:0x100AC
 },
 { code:0x100AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100AD
  ,simpleLowerCaseMapping:0x100AD
  ,simpleTitleCaseMapping:0x100AD
 },
 { code:0x100AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100AE
  ,simpleLowerCaseMapping:0x100AE
  ,simpleTitleCaseMapping:0x100AE
 },
 { code:0x100AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100AF
  ,simpleLowerCaseMapping:0x100AF
  ,simpleTitleCaseMapping:0x100AF
 },
 { code:0x100B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100B0
  ,simpleLowerCaseMapping:0x100B0
  ,simpleTitleCaseMapping:0x100B0
 },
 { code:0x100B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100B1
  ,simpleLowerCaseMapping:0x100B1
  ,simpleTitleCaseMapping:0x100B1
 },
 { code:0x100B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100B2
  ,simpleLowerCaseMapping:0x100B2
  ,simpleTitleCaseMapping:0x100B2
 },
 { code:0x100B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100B3
  ,simpleLowerCaseMapping:0x100B3
  ,simpleTitleCaseMapping:0x100B3
 },
 { code:0x100B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100B4
  ,simpleLowerCaseMapping:0x100B4
  ,simpleTitleCaseMapping:0x100B4
 },
 { code:0x100B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100B5
  ,simpleLowerCaseMapping:0x100B5
  ,simpleTitleCaseMapping:0x100B5
 },
 { code:0x100B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100B6
  ,simpleLowerCaseMapping:0x100B6
  ,simpleTitleCaseMapping:0x100B6
 },
 { code:0x100B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100B7
  ,simpleLowerCaseMapping:0x100B7
  ,simpleTitleCaseMapping:0x100B7
 },
 { code:0x100B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100B8
  ,simpleLowerCaseMapping:0x100B8
  ,simpleTitleCaseMapping:0x100B8
 },
 { code:0x100B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100B9
  ,simpleLowerCaseMapping:0x100B9
  ,simpleTitleCaseMapping:0x100B9
 },
 { code:0x100BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100BA
  ,simpleLowerCaseMapping:0x100BA
  ,simpleTitleCaseMapping:0x100BA
 },
 { code:0x100BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100BB
  ,simpleLowerCaseMapping:0x100BB
  ,simpleTitleCaseMapping:0x100BB
 },
 { code:0x100BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100BC
  ,simpleLowerCaseMapping:0x100BC
  ,simpleTitleCaseMapping:0x100BC
 },
 { code:0x100BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100BD
  ,simpleLowerCaseMapping:0x100BD
  ,simpleTitleCaseMapping:0x100BD
 },
 { code:0x100BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100BE
  ,simpleLowerCaseMapping:0x100BE
  ,simpleTitleCaseMapping:0x100BE
 },
 { code:0x100BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100BF
  ,simpleLowerCaseMapping:0x100BF
  ,simpleTitleCaseMapping:0x100BF
 },
 { code:0x100C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100C0
  ,simpleLowerCaseMapping:0x100C0
  ,simpleTitleCaseMapping:0x100C0
 },
 { code:0x100C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100C1
  ,simpleLowerCaseMapping:0x100C1
  ,simpleTitleCaseMapping:0x100C1
 },
 { code:0x100C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100C2
  ,simpleLowerCaseMapping:0x100C2
  ,simpleTitleCaseMapping:0x100C2
 },
 { code:0x100C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100C3
  ,simpleLowerCaseMapping:0x100C3
  ,simpleTitleCaseMapping:0x100C3
 },
 { code:0x100C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100C4
  ,simpleLowerCaseMapping:0x100C4
  ,simpleTitleCaseMapping:0x100C4
 },
 { code:0x100C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100C5
  ,simpleLowerCaseMapping:0x100C5
  ,simpleTitleCaseMapping:0x100C5
 },
 { code:0x100C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100C6
  ,simpleLowerCaseMapping:0x100C6
  ,simpleTitleCaseMapping:0x100C6
 },
 { code:0x100C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100C7
  ,simpleLowerCaseMapping:0x100C7
  ,simpleTitleCaseMapping:0x100C7
 },
 { code:0x100C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100C8
  ,simpleLowerCaseMapping:0x100C8
  ,simpleTitleCaseMapping:0x100C8
 },
 { code:0x100C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100C9
  ,simpleLowerCaseMapping:0x100C9
  ,simpleTitleCaseMapping:0x100C9
 },
 { code:0x100CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100CA
  ,simpleLowerCaseMapping:0x100CA
  ,simpleTitleCaseMapping:0x100CA
 },
 { code:0x100CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100CB
  ,simpleLowerCaseMapping:0x100CB
  ,simpleTitleCaseMapping:0x100CB
 },
 { code:0x100CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100CC
  ,simpleLowerCaseMapping:0x100CC
  ,simpleTitleCaseMapping:0x100CC
 },
 { code:0x100CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100CD
  ,simpleLowerCaseMapping:0x100CD
  ,simpleTitleCaseMapping:0x100CD
 },
 { code:0x100CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100CE
  ,simpleLowerCaseMapping:0x100CE
  ,simpleTitleCaseMapping:0x100CE
 },
 { code:0x100CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100CF
  ,simpleLowerCaseMapping:0x100CF
  ,simpleTitleCaseMapping:0x100CF
 },
 { code:0x100D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100D0
  ,simpleLowerCaseMapping:0x100D0
  ,simpleTitleCaseMapping:0x100D0
 },
 { code:0x100D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100D1
  ,simpleLowerCaseMapping:0x100D1
  ,simpleTitleCaseMapping:0x100D1
 },
 { code:0x100D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100D2
  ,simpleLowerCaseMapping:0x100D2
  ,simpleTitleCaseMapping:0x100D2
 },
 { code:0x100D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100D3
  ,simpleLowerCaseMapping:0x100D3
  ,simpleTitleCaseMapping:0x100D3
 },
 { code:0x100D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100D4
  ,simpleLowerCaseMapping:0x100D4
  ,simpleTitleCaseMapping:0x100D4
 },
 { code:0x100D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100D5
  ,simpleLowerCaseMapping:0x100D5
  ,simpleTitleCaseMapping:0x100D5
 },
 { code:0x100D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100D6
  ,simpleLowerCaseMapping:0x100D6
  ,simpleTitleCaseMapping:0x100D6
 },
 { code:0x100D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100D7
  ,simpleLowerCaseMapping:0x100D7
  ,simpleTitleCaseMapping:0x100D7
 },
 { code:0x100D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100D8
  ,simpleLowerCaseMapping:0x100D8
  ,simpleTitleCaseMapping:0x100D8
 },
 { code:0x100D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100D9
  ,simpleLowerCaseMapping:0x100D9
  ,simpleTitleCaseMapping:0x100D9
 },
 { code:0x100DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100DA
  ,simpleLowerCaseMapping:0x100DA
  ,simpleTitleCaseMapping:0x100DA
 },
 { code:0x100DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100DB
  ,simpleLowerCaseMapping:0x100DB
  ,simpleTitleCaseMapping:0x100DB
 },
 { code:0x100DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100DC
  ,simpleLowerCaseMapping:0x100DC
  ,simpleTitleCaseMapping:0x100DC
 },
 { code:0x100DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100DD
  ,simpleLowerCaseMapping:0x100DD
  ,simpleTitleCaseMapping:0x100DD
 },
 { code:0x100DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100DE
  ,simpleLowerCaseMapping:0x100DE
  ,simpleTitleCaseMapping:0x100DE
 },
 { code:0x100DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100DF
  ,simpleLowerCaseMapping:0x100DF
  ,simpleTitleCaseMapping:0x100DF
 },
 { code:0x100E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100E0
  ,simpleLowerCaseMapping:0x100E0
  ,simpleTitleCaseMapping:0x100E0
 },
 { code:0x100E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100E1
  ,simpleLowerCaseMapping:0x100E1
  ,simpleTitleCaseMapping:0x100E1
 },
 { code:0x100E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100E2
  ,simpleLowerCaseMapping:0x100E2
  ,simpleTitleCaseMapping:0x100E2
 },
 { code:0x100E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100E3
  ,simpleLowerCaseMapping:0x100E3
  ,simpleTitleCaseMapping:0x100E3
 },
 { code:0x100E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100E4
  ,simpleLowerCaseMapping:0x100E4
  ,simpleTitleCaseMapping:0x100E4
 },
 { code:0x100E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100E5
  ,simpleLowerCaseMapping:0x100E5
  ,simpleTitleCaseMapping:0x100E5
 },
 { code:0x100E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100E6
  ,simpleLowerCaseMapping:0x100E6
  ,simpleTitleCaseMapping:0x100E6
 },
 { code:0x100E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100E7
  ,simpleLowerCaseMapping:0x100E7
  ,simpleTitleCaseMapping:0x100E7
 },
 { code:0x100E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100E8
  ,simpleLowerCaseMapping:0x100E8
  ,simpleTitleCaseMapping:0x100E8
 },
 { code:0x100E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100E9
  ,simpleLowerCaseMapping:0x100E9
  ,simpleTitleCaseMapping:0x100E9
 },
 { code:0x100EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100EA
  ,simpleLowerCaseMapping:0x100EA
  ,simpleTitleCaseMapping:0x100EA
 },
 { code:0x100EB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100EB
  ,simpleLowerCaseMapping:0x100EB
  ,simpleTitleCaseMapping:0x100EB
 },
 { code:0x100EC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100EC
  ,simpleLowerCaseMapping:0x100EC
  ,simpleTitleCaseMapping:0x100EC
 },
 { code:0x100ED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100ED
  ,simpleLowerCaseMapping:0x100ED
  ,simpleTitleCaseMapping:0x100ED
 },
 { code:0x100EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100EE
  ,simpleLowerCaseMapping:0x100EE
  ,simpleTitleCaseMapping:0x100EE
 },
 { code:0x100EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100EF
  ,simpleLowerCaseMapping:0x100EF
  ,simpleTitleCaseMapping:0x100EF
 },
 { code:0x100F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100F0
  ,simpleLowerCaseMapping:0x100F0
  ,simpleTitleCaseMapping:0x100F0
 },
 { code:0x100F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100F1
  ,simpleLowerCaseMapping:0x100F1
  ,simpleTitleCaseMapping:0x100F1
 },
 { code:0x100F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100F2
  ,simpleLowerCaseMapping:0x100F2
  ,simpleTitleCaseMapping:0x100F2
 },
 { code:0x100F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100F3
  ,simpleLowerCaseMapping:0x100F3
  ,simpleTitleCaseMapping:0x100F3
 },
 { code:0x100F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100F4
  ,simpleLowerCaseMapping:0x100F4
  ,simpleTitleCaseMapping:0x100F4
 },
 { code:0x100F5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100F5
  ,simpleLowerCaseMapping:0x100F5
  ,simpleTitleCaseMapping:0x100F5
 },
 { code:0x100F6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100F6
  ,simpleLowerCaseMapping:0x100F6
  ,simpleTitleCaseMapping:0x100F6
 },
 { code:0x100F7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100F7
  ,simpleLowerCaseMapping:0x100F7
  ,simpleTitleCaseMapping:0x100F7
 },
 { code:0x100F8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100F8
  ,simpleLowerCaseMapping:0x100F8
  ,simpleTitleCaseMapping:0x100F8
 },
 { code:0x100F9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100F9
  ,simpleLowerCaseMapping:0x100F9
  ,simpleTitleCaseMapping:0x100F9
 },
 { code:0x100FA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x100FA
  ,simpleLowerCaseMapping:0x100FA
  ,simpleTitleCaseMapping:0x100FA
 },
 { code:0x10100
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x10100
  ,simpleLowerCaseMapping:0x10100
  ,simpleTitleCaseMapping:0x10100
 },
 { code:0x10101
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x10101
  ,simpleLowerCaseMapping:0x10101
  ,simpleTitleCaseMapping:0x10101
 },
 { code:0x10102
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x10102
  ,simpleLowerCaseMapping:0x10102
  ,simpleTitleCaseMapping:0x10102
 },
 { code:0x10107
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10107
  ,simpleLowerCaseMapping:0x10107
  ,simpleTitleCaseMapping:0x10107
 },
 { code:0x10108
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10108
  ,simpleLowerCaseMapping:0x10108
  ,simpleTitleCaseMapping:0x10108
 },
 { code:0x10109
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10109
  ,simpleLowerCaseMapping:0x10109
  ,simpleTitleCaseMapping:0x10109
 },
 { code:0x1010A
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1010A
  ,simpleLowerCaseMapping:0x1010A
  ,simpleTitleCaseMapping:0x1010A
 },
 { code:0x1010B
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1010B
  ,simpleLowerCaseMapping:0x1010B
  ,simpleTitleCaseMapping:0x1010B
 },
 { code:0x1010C
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1010C
  ,simpleLowerCaseMapping:0x1010C
  ,simpleTitleCaseMapping:0x1010C
 },
 { code:0x1010D
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1010D
  ,simpleLowerCaseMapping:0x1010D
  ,simpleTitleCaseMapping:0x1010D
 },
 { code:0x1010E
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1010E
  ,simpleLowerCaseMapping:0x1010E
  ,simpleTitleCaseMapping:0x1010E
 },
 { code:0x1010F
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1010F
  ,simpleLowerCaseMapping:0x1010F
  ,simpleTitleCaseMapping:0x1010F
 },
 { code:0x10110
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10110
  ,simpleLowerCaseMapping:0x10110
  ,simpleTitleCaseMapping:0x10110
 },
 { code:0x10111
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10111
  ,simpleLowerCaseMapping:0x10111
  ,simpleTitleCaseMapping:0x10111
 },
 { code:0x10112
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10112
  ,simpleLowerCaseMapping:0x10112
  ,simpleTitleCaseMapping:0x10112
 },
 { code:0x10113
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10113
  ,simpleLowerCaseMapping:0x10113
  ,simpleTitleCaseMapping:0x10113
 },
 { code:0x10114
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10114
  ,simpleLowerCaseMapping:0x10114
  ,simpleTitleCaseMapping:0x10114
 },
 { code:0x10115
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10115
  ,simpleLowerCaseMapping:0x10115
  ,simpleTitleCaseMapping:0x10115
 },
 { code:0x10116
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10116
  ,simpleLowerCaseMapping:0x10116
  ,simpleTitleCaseMapping:0x10116
 },
 { code:0x10117
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10117
  ,simpleLowerCaseMapping:0x10117
  ,simpleTitleCaseMapping:0x10117
 },
 { code:0x10118
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10118
  ,simpleLowerCaseMapping:0x10118
  ,simpleTitleCaseMapping:0x10118
 },
 { code:0x10119
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10119
  ,simpleLowerCaseMapping:0x10119
  ,simpleTitleCaseMapping:0x10119
 },
 { code:0x1011A
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1011A
  ,simpleLowerCaseMapping:0x1011A
  ,simpleTitleCaseMapping:0x1011A
 },
 { code:0x1011B
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1011B
  ,simpleLowerCaseMapping:0x1011B
  ,simpleTitleCaseMapping:0x1011B
 },
 { code:0x1011C
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1011C
  ,simpleLowerCaseMapping:0x1011C
  ,simpleTitleCaseMapping:0x1011C
 },
 { code:0x1011D
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1011D
  ,simpleLowerCaseMapping:0x1011D
  ,simpleTitleCaseMapping:0x1011D
 },
 { code:0x1011E
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1011E
  ,simpleLowerCaseMapping:0x1011E
  ,simpleTitleCaseMapping:0x1011E
 },
 { code:0x1011F
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1011F
  ,simpleLowerCaseMapping:0x1011F
  ,simpleTitleCaseMapping:0x1011F
 },
 { code:0x10120
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10120
  ,simpleLowerCaseMapping:0x10120
  ,simpleTitleCaseMapping:0x10120
 },
 { code:0x10121
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10121
  ,simpleLowerCaseMapping:0x10121
  ,simpleTitleCaseMapping:0x10121
 },
 { code:0x10122
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10122
  ,simpleLowerCaseMapping:0x10122
  ,simpleTitleCaseMapping:0x10122
 },
 { code:0x10123
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10123
  ,simpleLowerCaseMapping:0x10123
  ,simpleTitleCaseMapping:0x10123
 },
 { code:0x10124
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10124
  ,simpleLowerCaseMapping:0x10124
  ,simpleTitleCaseMapping:0x10124
 },
 { code:0x10125
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10125
  ,simpleLowerCaseMapping:0x10125
  ,simpleTitleCaseMapping:0x10125
 },
 { code:0x10126
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10126
  ,simpleLowerCaseMapping:0x10126
  ,simpleTitleCaseMapping:0x10126
 },
 { code:0x10127
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10127
  ,simpleLowerCaseMapping:0x10127
  ,simpleTitleCaseMapping:0x10127
 },
 { code:0x10128
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10128
  ,simpleLowerCaseMapping:0x10128
  ,simpleTitleCaseMapping:0x10128
 },
 { code:0x10129
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10129
  ,simpleLowerCaseMapping:0x10129
  ,simpleTitleCaseMapping:0x10129
 },
 { code:0x1012A
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1012A
  ,simpleLowerCaseMapping:0x1012A
  ,simpleTitleCaseMapping:0x1012A
 },
 { code:0x1012B
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1012B
  ,simpleLowerCaseMapping:0x1012B
  ,simpleTitleCaseMapping:0x1012B
 },
 { code:0x1012C
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1012C
  ,simpleLowerCaseMapping:0x1012C
  ,simpleTitleCaseMapping:0x1012C
 },
 { code:0x1012D
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1012D
  ,simpleLowerCaseMapping:0x1012D
  ,simpleTitleCaseMapping:0x1012D
 },
 { code:0x1012E
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1012E
  ,simpleLowerCaseMapping:0x1012E
  ,simpleTitleCaseMapping:0x1012E
 },
 { code:0x1012F
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1012F
  ,simpleLowerCaseMapping:0x1012F
  ,simpleTitleCaseMapping:0x1012F
 },
 { code:0x10130
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10130
  ,simpleLowerCaseMapping:0x10130
  ,simpleTitleCaseMapping:0x10130
 },
 { code:0x10131
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10131
  ,simpleLowerCaseMapping:0x10131
  ,simpleTitleCaseMapping:0x10131
 },
 { code:0x10132
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10132
  ,simpleLowerCaseMapping:0x10132
  ,simpleTitleCaseMapping:0x10132
 },
 { code:0x10133
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10133
  ,simpleLowerCaseMapping:0x10133
  ,simpleTitleCaseMapping:0x10133
 },
 { code:0x10137
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x10137
  ,simpleLowerCaseMapping:0x10137
  ,simpleTitleCaseMapping:0x10137
 },
 { code:0x10138
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x10138
  ,simpleLowerCaseMapping:0x10138
  ,simpleTitleCaseMapping:0x10138
 },
 { code:0x10139
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x10139
  ,simpleLowerCaseMapping:0x10139
  ,simpleTitleCaseMapping:0x10139
 },
 { code:0x1013A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1013A
  ,simpleLowerCaseMapping:0x1013A
  ,simpleTitleCaseMapping:0x1013A
 },
 { code:0x1013B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1013B
  ,simpleLowerCaseMapping:0x1013B
  ,simpleTitleCaseMapping:0x1013B
 },
 { code:0x1013C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1013C
  ,simpleLowerCaseMapping:0x1013C
  ,simpleTitleCaseMapping:0x1013C
 },
 { code:0x1013D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1013D
  ,simpleLowerCaseMapping:0x1013D
  ,simpleTitleCaseMapping:0x1013D
 },
 { code:0x1013E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1013E
  ,simpleLowerCaseMapping:0x1013E
  ,simpleTitleCaseMapping:0x1013E
 },
 { code:0x1013F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1013F
  ,simpleLowerCaseMapping:0x1013F
  ,simpleTitleCaseMapping:0x1013F
 },
 { code:0x10140
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10140
  ,simpleLowerCaseMapping:0x10140
  ,simpleTitleCaseMapping:0x10140
 },
 { code:0x10141
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10141
  ,simpleLowerCaseMapping:0x10141
  ,simpleTitleCaseMapping:0x10141
 },
 { code:0x10142
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10142
  ,simpleLowerCaseMapping:0x10142
  ,simpleTitleCaseMapping:0x10142
 },
 { code:0x10143
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10143
  ,simpleLowerCaseMapping:0x10143
  ,simpleTitleCaseMapping:0x10143
 },
 { code:0x10144
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10144
  ,simpleLowerCaseMapping:0x10144
  ,simpleTitleCaseMapping:0x10144
 },
 { code:0x10145
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10145
  ,simpleLowerCaseMapping:0x10145
  ,simpleTitleCaseMapping:0x10145
 },
 { code:0x10146
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10146
  ,simpleLowerCaseMapping:0x10146
  ,simpleTitleCaseMapping:0x10146
 },
 { code:0x10147
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10147
  ,simpleLowerCaseMapping:0x10147
  ,simpleTitleCaseMapping:0x10147
 },
 { code:0x10148
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10148
  ,simpleLowerCaseMapping:0x10148
  ,simpleTitleCaseMapping:0x10148
 },
 { code:0x10149
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10149
  ,simpleLowerCaseMapping:0x10149
  ,simpleTitleCaseMapping:0x10149
 },
 { code:0x1014A
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1014A
  ,simpleLowerCaseMapping:0x1014A
  ,simpleTitleCaseMapping:0x1014A
 },
 { code:0x1014B
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1014B
  ,simpleLowerCaseMapping:0x1014B
  ,simpleTitleCaseMapping:0x1014B
 },
 { code:0x1014C
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1014C
  ,simpleLowerCaseMapping:0x1014C
  ,simpleTitleCaseMapping:0x1014C
 },
 { code:0x1014D
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1014D
  ,simpleLowerCaseMapping:0x1014D
  ,simpleTitleCaseMapping:0x1014D
 },
 { code:0x1014E
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1014E
  ,simpleLowerCaseMapping:0x1014E
  ,simpleTitleCaseMapping:0x1014E
 },
 { code:0x1014F
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1014F
  ,simpleLowerCaseMapping:0x1014F
  ,simpleTitleCaseMapping:0x1014F
 },
 { code:0x10150
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10150
  ,simpleLowerCaseMapping:0x10150
  ,simpleTitleCaseMapping:0x10150
 },
 { code:0x10151
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10151
  ,simpleLowerCaseMapping:0x10151
  ,simpleTitleCaseMapping:0x10151
 },
 { code:0x10152
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10152
  ,simpleLowerCaseMapping:0x10152
  ,simpleTitleCaseMapping:0x10152
 },
 { code:0x10153
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10153
  ,simpleLowerCaseMapping:0x10153
  ,simpleTitleCaseMapping:0x10153
 },
 { code:0x10154
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10154
  ,simpleLowerCaseMapping:0x10154
  ,simpleTitleCaseMapping:0x10154
 },
 { code:0x10155
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10155
  ,simpleLowerCaseMapping:0x10155
  ,simpleTitleCaseMapping:0x10155
 },
 { code:0x10156
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10156
  ,simpleLowerCaseMapping:0x10156
  ,simpleTitleCaseMapping:0x10156
 },
 { code:0x10157
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10157
  ,simpleLowerCaseMapping:0x10157
  ,simpleTitleCaseMapping:0x10157
 },
 { code:0x10158
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10158
  ,simpleLowerCaseMapping:0x10158
  ,simpleTitleCaseMapping:0x10158
 },
 { code:0x10159
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10159
  ,simpleLowerCaseMapping:0x10159
  ,simpleTitleCaseMapping:0x10159
 },
 { code:0x1015A
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1015A
  ,simpleLowerCaseMapping:0x1015A
  ,simpleTitleCaseMapping:0x1015A
 },
 { code:0x1015B
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1015B
  ,simpleLowerCaseMapping:0x1015B
  ,simpleTitleCaseMapping:0x1015B
 },
 { code:0x1015C
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1015C
  ,simpleLowerCaseMapping:0x1015C
  ,simpleTitleCaseMapping:0x1015C
 },
 { code:0x1015D
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1015D
  ,simpleLowerCaseMapping:0x1015D
  ,simpleTitleCaseMapping:0x1015D
 },
 { code:0x1015E
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1015E
  ,simpleLowerCaseMapping:0x1015E
  ,simpleTitleCaseMapping:0x1015E
 },
 { code:0x1015F
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1015F
  ,simpleLowerCaseMapping:0x1015F
  ,simpleTitleCaseMapping:0x1015F
 },
 { code:0x10160
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10160
  ,simpleLowerCaseMapping:0x10160
  ,simpleTitleCaseMapping:0x10160
 },
 { code:0x10161
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10161
  ,simpleLowerCaseMapping:0x10161
  ,simpleTitleCaseMapping:0x10161
 },
 { code:0x10162
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10162
  ,simpleLowerCaseMapping:0x10162
  ,simpleTitleCaseMapping:0x10162
 },
 { code:0x10163
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10163
  ,simpleLowerCaseMapping:0x10163
  ,simpleTitleCaseMapping:0x10163
 },
 { code:0x10164
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10164
  ,simpleLowerCaseMapping:0x10164
  ,simpleTitleCaseMapping:0x10164
 },
 { code:0x10165
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10165
  ,simpleLowerCaseMapping:0x10165
  ,simpleTitleCaseMapping:0x10165
 },
 { code:0x10166
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10166
  ,simpleLowerCaseMapping:0x10166
  ,simpleTitleCaseMapping:0x10166
 },
 { code:0x10167
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10167
  ,simpleLowerCaseMapping:0x10167
  ,simpleTitleCaseMapping:0x10167
 },
 { code:0x10168
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10168
  ,simpleLowerCaseMapping:0x10168
  ,simpleTitleCaseMapping:0x10168
 },
 { code:0x10169
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10169
  ,simpleLowerCaseMapping:0x10169
  ,simpleTitleCaseMapping:0x10169
 },
 { code:0x1016A
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1016A
  ,simpleLowerCaseMapping:0x1016A
  ,simpleTitleCaseMapping:0x1016A
 },
 { code:0x1016B
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1016B
  ,simpleLowerCaseMapping:0x1016B
  ,simpleTitleCaseMapping:0x1016B
 },
 { code:0x1016C
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1016C
  ,simpleLowerCaseMapping:0x1016C
  ,simpleTitleCaseMapping:0x1016C
 },
 { code:0x1016D
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1016D
  ,simpleLowerCaseMapping:0x1016D
  ,simpleTitleCaseMapping:0x1016D
 },
 { code:0x1016E
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1016E
  ,simpleLowerCaseMapping:0x1016E
  ,simpleTitleCaseMapping:0x1016E
 },
 { code:0x1016F
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1016F
  ,simpleLowerCaseMapping:0x1016F
  ,simpleTitleCaseMapping:0x1016F
 },
 { code:0x10170
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10170
  ,simpleLowerCaseMapping:0x10170
  ,simpleTitleCaseMapping:0x10170
 },
 { code:0x10171
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10171
  ,simpleLowerCaseMapping:0x10171
  ,simpleTitleCaseMapping:0x10171
 },
 { code:0x10172
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10172
  ,simpleLowerCaseMapping:0x10172
  ,simpleTitleCaseMapping:0x10172
 },
 { code:0x10173
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10173
  ,simpleLowerCaseMapping:0x10173
  ,simpleTitleCaseMapping:0x10173
 },
 { code:0x10174
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10174
  ,simpleLowerCaseMapping:0x10174
  ,simpleTitleCaseMapping:0x10174
 },
 { code:0x10175
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10175
  ,simpleLowerCaseMapping:0x10175
  ,simpleTitleCaseMapping:0x10175
 },
 { code:0x10176
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10176
  ,simpleLowerCaseMapping:0x10176
  ,simpleTitleCaseMapping:0x10176
 },
 { code:0x10177
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10177
  ,simpleLowerCaseMapping:0x10177
  ,simpleTitleCaseMapping:0x10177
 },
 { code:0x10178
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10178
  ,simpleLowerCaseMapping:0x10178
  ,simpleTitleCaseMapping:0x10178
 },
 { code:0x10179
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x10179
  ,simpleLowerCaseMapping:0x10179
  ,simpleTitleCaseMapping:0x10179
 },
 { code:0x1017A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1017A
  ,simpleLowerCaseMapping:0x1017A
  ,simpleTitleCaseMapping:0x1017A
 },
 { code:0x1017B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1017B
  ,simpleLowerCaseMapping:0x1017B
  ,simpleTitleCaseMapping:0x1017B
 },
 { code:0x1017C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1017C
  ,simpleLowerCaseMapping:0x1017C
  ,simpleTitleCaseMapping:0x1017C
 },
 { code:0x1017D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1017D
  ,simpleLowerCaseMapping:0x1017D
  ,simpleTitleCaseMapping:0x1017D
 },
 { code:0x1017E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1017E
  ,simpleLowerCaseMapping:0x1017E
  ,simpleTitleCaseMapping:0x1017E
 },
 { code:0x1017F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1017F
  ,simpleLowerCaseMapping:0x1017F
  ,simpleTitleCaseMapping:0x1017F
 },
 { code:0x10180
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x10180
  ,simpleLowerCaseMapping:0x10180
  ,simpleTitleCaseMapping:0x10180
 },
 { code:0x10181
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x10181
  ,simpleLowerCaseMapping:0x10181
  ,simpleTitleCaseMapping:0x10181
 },
 { code:0x10182
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x10182
  ,simpleLowerCaseMapping:0x10182
  ,simpleTitleCaseMapping:0x10182
 },
 { code:0x10183
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x10183
  ,simpleLowerCaseMapping:0x10183
  ,simpleTitleCaseMapping:0x10183
 },
 { code:0x10184
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x10184
  ,simpleLowerCaseMapping:0x10184
  ,simpleTitleCaseMapping:0x10184
 },
 { code:0x10185
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x10185
  ,simpleLowerCaseMapping:0x10185
  ,simpleTitleCaseMapping:0x10185
 },
 { code:0x10186
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x10186
  ,simpleLowerCaseMapping:0x10186
  ,simpleTitleCaseMapping:0x10186
 },
 { code:0x10187
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x10187
  ,simpleLowerCaseMapping:0x10187
  ,simpleTitleCaseMapping:0x10187
 },
 { code:0x10188
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x10188
  ,simpleLowerCaseMapping:0x10188
  ,simpleTitleCaseMapping:0x10188
 },
 { code:0x10189
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x10189
  ,simpleLowerCaseMapping:0x10189
  ,simpleTitleCaseMapping:0x10189
 },
 { code:0x1018A
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1018A
  ,simpleLowerCaseMapping:0x1018A
  ,simpleTitleCaseMapping:0x1018A
 },
 { code:0x10300
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10300
  ,simpleLowerCaseMapping:0x10300
  ,simpleTitleCaseMapping:0x10300
 },
 { code:0x10301
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10301
  ,simpleLowerCaseMapping:0x10301
  ,simpleTitleCaseMapping:0x10301
 },
 { code:0x10302
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10302
  ,simpleLowerCaseMapping:0x10302
  ,simpleTitleCaseMapping:0x10302
 },
 { code:0x10303
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10303
  ,simpleLowerCaseMapping:0x10303
  ,simpleTitleCaseMapping:0x10303
 },
 { code:0x10304
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10304
  ,simpleLowerCaseMapping:0x10304
  ,simpleTitleCaseMapping:0x10304
 },
 { code:0x10305
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10305
  ,simpleLowerCaseMapping:0x10305
  ,simpleTitleCaseMapping:0x10305
 },
 { code:0x10306
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10306
  ,simpleLowerCaseMapping:0x10306
  ,simpleTitleCaseMapping:0x10306
 },
 { code:0x10307
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10307
  ,simpleLowerCaseMapping:0x10307
  ,simpleTitleCaseMapping:0x10307
 },
 { code:0x10308
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10308
  ,simpleLowerCaseMapping:0x10308
  ,simpleTitleCaseMapping:0x10308
 },
 { code:0x10309
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10309
  ,simpleLowerCaseMapping:0x10309
  ,simpleTitleCaseMapping:0x10309
 },
 { code:0x1030A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1030A
  ,simpleLowerCaseMapping:0x1030A
  ,simpleTitleCaseMapping:0x1030A
 },
 { code:0x1030B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1030B
  ,simpleLowerCaseMapping:0x1030B
  ,simpleTitleCaseMapping:0x1030B
 },
 { code:0x1030C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1030C
  ,simpleLowerCaseMapping:0x1030C
  ,simpleTitleCaseMapping:0x1030C
 },
 { code:0x1030D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1030D
  ,simpleLowerCaseMapping:0x1030D
  ,simpleTitleCaseMapping:0x1030D
 },
 { code:0x1030E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1030E
  ,simpleLowerCaseMapping:0x1030E
  ,simpleTitleCaseMapping:0x1030E
 },
 { code:0x1030F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1030F
  ,simpleLowerCaseMapping:0x1030F
  ,simpleTitleCaseMapping:0x1030F
 },
 { code:0x10310
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10310
  ,simpleLowerCaseMapping:0x10310
  ,simpleTitleCaseMapping:0x10310
 },
 { code:0x10311
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10311
  ,simpleLowerCaseMapping:0x10311
  ,simpleTitleCaseMapping:0x10311
 },
 { code:0x10312
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10312
  ,simpleLowerCaseMapping:0x10312
  ,simpleTitleCaseMapping:0x10312
 },
 { code:0x10313
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10313
  ,simpleLowerCaseMapping:0x10313
  ,simpleTitleCaseMapping:0x10313
 },
 { code:0x10314
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10314
  ,simpleLowerCaseMapping:0x10314
  ,simpleTitleCaseMapping:0x10314
 },
 { code:0x10315
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10315
  ,simpleLowerCaseMapping:0x10315
  ,simpleTitleCaseMapping:0x10315
 },
 { code:0x10316
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10316
  ,simpleLowerCaseMapping:0x10316
  ,simpleTitleCaseMapping:0x10316
 },
 { code:0x10317
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10317
  ,simpleLowerCaseMapping:0x10317
  ,simpleTitleCaseMapping:0x10317
 },
 { code:0x10318
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10318
  ,simpleLowerCaseMapping:0x10318
  ,simpleTitleCaseMapping:0x10318
 },
 { code:0x10319
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10319
  ,simpleLowerCaseMapping:0x10319
  ,simpleTitleCaseMapping:0x10319
 },
 { code:0x1031A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1031A
  ,simpleLowerCaseMapping:0x1031A
  ,simpleTitleCaseMapping:0x1031A
 },
 { code:0x1031B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1031B
  ,simpleLowerCaseMapping:0x1031B
  ,simpleTitleCaseMapping:0x1031B
 },
 { code:0x1031C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1031C
  ,simpleLowerCaseMapping:0x1031C
  ,simpleTitleCaseMapping:0x1031C
 },
 { code:0x1031D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1031D
  ,simpleLowerCaseMapping:0x1031D
  ,simpleTitleCaseMapping:0x1031D
 },
 { code:0x1031E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1031E
  ,simpleLowerCaseMapping:0x1031E
  ,simpleTitleCaseMapping:0x1031E
 },
 { code:0x10320
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10320
  ,simpleLowerCaseMapping:0x10320
  ,simpleTitleCaseMapping:0x10320
 },
 { code:0x10321
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10321
  ,simpleLowerCaseMapping:0x10321
  ,simpleTitleCaseMapping:0x10321
 },
 { code:0x10322
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10322
  ,simpleLowerCaseMapping:0x10322
  ,simpleTitleCaseMapping:0x10322
 },
 { code:0x10323
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10323
  ,simpleLowerCaseMapping:0x10323
  ,simpleTitleCaseMapping:0x10323
 },
 { code:0x10330
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10330
  ,simpleLowerCaseMapping:0x10330
  ,simpleTitleCaseMapping:0x10330
 },
 { code:0x10331
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10331
  ,simpleLowerCaseMapping:0x10331
  ,simpleTitleCaseMapping:0x10331
 },
 { code:0x10332
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10332
  ,simpleLowerCaseMapping:0x10332
  ,simpleTitleCaseMapping:0x10332
 },
 { code:0x10333
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10333
  ,simpleLowerCaseMapping:0x10333
  ,simpleTitleCaseMapping:0x10333
 },
 { code:0x10334
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10334
  ,simpleLowerCaseMapping:0x10334
  ,simpleTitleCaseMapping:0x10334
 },
 { code:0x10335
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10335
  ,simpleLowerCaseMapping:0x10335
  ,simpleTitleCaseMapping:0x10335
 },
 { code:0x10336
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10336
  ,simpleLowerCaseMapping:0x10336
  ,simpleTitleCaseMapping:0x10336
 },
 { code:0x10337
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10337
  ,simpleLowerCaseMapping:0x10337
  ,simpleTitleCaseMapping:0x10337
 },
 { code:0x10338
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10338
  ,simpleLowerCaseMapping:0x10338
  ,simpleTitleCaseMapping:0x10338
 },
 { code:0x10339
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10339
  ,simpleLowerCaseMapping:0x10339
  ,simpleTitleCaseMapping:0x10339
 },
 { code:0x1033A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1033A
  ,simpleLowerCaseMapping:0x1033A
  ,simpleTitleCaseMapping:0x1033A
 },
 { code:0x1033B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1033B
  ,simpleLowerCaseMapping:0x1033B
  ,simpleTitleCaseMapping:0x1033B
 },
 { code:0x1033C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1033C
  ,simpleLowerCaseMapping:0x1033C
  ,simpleTitleCaseMapping:0x1033C
 },
 { code:0x1033D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1033D
  ,simpleLowerCaseMapping:0x1033D
  ,simpleTitleCaseMapping:0x1033D
 },
 { code:0x1033E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1033E
  ,simpleLowerCaseMapping:0x1033E
  ,simpleTitleCaseMapping:0x1033E
 },
 { code:0x1033F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1033F
  ,simpleLowerCaseMapping:0x1033F
  ,simpleTitleCaseMapping:0x1033F
 },
 { code:0x10340
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10340
  ,simpleLowerCaseMapping:0x10340
  ,simpleTitleCaseMapping:0x10340
 },
 { code:0x10341
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x10341
  ,simpleLowerCaseMapping:0x10341
  ,simpleTitleCaseMapping:0x10341
 },
 { code:0x10342
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10342
  ,simpleLowerCaseMapping:0x10342
  ,simpleTitleCaseMapping:0x10342
 },
 { code:0x10343
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10343
  ,simpleLowerCaseMapping:0x10343
  ,simpleTitleCaseMapping:0x10343
 },
 { code:0x10344
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10344
  ,simpleLowerCaseMapping:0x10344
  ,simpleTitleCaseMapping:0x10344
 },
 { code:0x10345
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10345
  ,simpleLowerCaseMapping:0x10345
  ,simpleTitleCaseMapping:0x10345
 },
 { code:0x10346
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10346
  ,simpleLowerCaseMapping:0x10346
  ,simpleTitleCaseMapping:0x10346
 },
 { code:0x10347
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10347
  ,simpleLowerCaseMapping:0x10347
  ,simpleTitleCaseMapping:0x10347
 },
 { code:0x10348
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10348
  ,simpleLowerCaseMapping:0x10348
  ,simpleTitleCaseMapping:0x10348
 },
 { code:0x10349
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10349
  ,simpleLowerCaseMapping:0x10349
  ,simpleTitleCaseMapping:0x10349
 },
 { code:0x1034A
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1034A
  ,simpleLowerCaseMapping:0x1034A
  ,simpleTitleCaseMapping:0x1034A
 },
 { code:0x10380
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10380
  ,simpleLowerCaseMapping:0x10380
  ,simpleTitleCaseMapping:0x10380
 },
 { code:0x10381
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10381
  ,simpleLowerCaseMapping:0x10381
  ,simpleTitleCaseMapping:0x10381
 },
 { code:0x10382
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10382
  ,simpleLowerCaseMapping:0x10382
  ,simpleTitleCaseMapping:0x10382
 },
 { code:0x10383
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10383
  ,simpleLowerCaseMapping:0x10383
  ,simpleTitleCaseMapping:0x10383
 },
 { code:0x10384
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10384
  ,simpleLowerCaseMapping:0x10384
  ,simpleTitleCaseMapping:0x10384
 },
 { code:0x10385
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10385
  ,simpleLowerCaseMapping:0x10385
  ,simpleTitleCaseMapping:0x10385
 },
 { code:0x10386
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10386
  ,simpleLowerCaseMapping:0x10386
  ,simpleTitleCaseMapping:0x10386
 },
 { code:0x10387
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10387
  ,simpleLowerCaseMapping:0x10387
  ,simpleTitleCaseMapping:0x10387
 },
 { code:0x10388
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10388
  ,simpleLowerCaseMapping:0x10388
  ,simpleTitleCaseMapping:0x10388
 },
 { code:0x10389
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10389
  ,simpleLowerCaseMapping:0x10389
  ,simpleTitleCaseMapping:0x10389
 },
 { code:0x1038A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1038A
  ,simpleLowerCaseMapping:0x1038A
  ,simpleTitleCaseMapping:0x1038A
 },
 { code:0x1038B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1038B
  ,simpleLowerCaseMapping:0x1038B
  ,simpleTitleCaseMapping:0x1038B
 },
 { code:0x1038C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1038C
  ,simpleLowerCaseMapping:0x1038C
  ,simpleTitleCaseMapping:0x1038C
 },
 { code:0x1038D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1038D
  ,simpleLowerCaseMapping:0x1038D
  ,simpleTitleCaseMapping:0x1038D
 },
 { code:0x1038E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1038E
  ,simpleLowerCaseMapping:0x1038E
  ,simpleTitleCaseMapping:0x1038E
 },
 { code:0x1038F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1038F
  ,simpleLowerCaseMapping:0x1038F
  ,simpleTitleCaseMapping:0x1038F
 },
 { code:0x10390
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10390
  ,simpleLowerCaseMapping:0x10390
  ,simpleTitleCaseMapping:0x10390
 },
 { code:0x10391
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10391
  ,simpleLowerCaseMapping:0x10391
  ,simpleTitleCaseMapping:0x10391
 },
 { code:0x10392
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10392
  ,simpleLowerCaseMapping:0x10392
  ,simpleTitleCaseMapping:0x10392
 },
 { code:0x10393
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10393
  ,simpleLowerCaseMapping:0x10393
  ,simpleTitleCaseMapping:0x10393
 },
 { code:0x10394
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10394
  ,simpleLowerCaseMapping:0x10394
  ,simpleTitleCaseMapping:0x10394
 },
 { code:0x10395
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10395
  ,simpleLowerCaseMapping:0x10395
  ,simpleTitleCaseMapping:0x10395
 },
 { code:0x10396
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10396
  ,simpleLowerCaseMapping:0x10396
  ,simpleTitleCaseMapping:0x10396
 },
 { code:0x10397
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10397
  ,simpleLowerCaseMapping:0x10397
  ,simpleTitleCaseMapping:0x10397
 },
 { code:0x10398
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10398
  ,simpleLowerCaseMapping:0x10398
  ,simpleTitleCaseMapping:0x10398
 },
 { code:0x10399
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10399
  ,simpleLowerCaseMapping:0x10399
  ,simpleTitleCaseMapping:0x10399
 },
 { code:0x1039A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1039A
  ,simpleLowerCaseMapping:0x1039A
  ,simpleTitleCaseMapping:0x1039A
 },
 { code:0x1039B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1039B
  ,simpleLowerCaseMapping:0x1039B
  ,simpleTitleCaseMapping:0x1039B
 },
 { code:0x1039C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1039C
  ,simpleLowerCaseMapping:0x1039C
  ,simpleTitleCaseMapping:0x1039C
 },
 { code:0x1039D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1039D
  ,simpleLowerCaseMapping:0x1039D
  ,simpleTitleCaseMapping:0x1039D
 },
 { code:0x1039F
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1039F
  ,simpleLowerCaseMapping:0x1039F
  ,simpleTitleCaseMapping:0x1039F
 },
 { code:0x103A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103A0
  ,simpleLowerCaseMapping:0x103A0
  ,simpleTitleCaseMapping:0x103A0
 },
 { code:0x103A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103A1
  ,simpleLowerCaseMapping:0x103A1
  ,simpleTitleCaseMapping:0x103A1
 },
 { code:0x103A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103A2
  ,simpleLowerCaseMapping:0x103A2
  ,simpleTitleCaseMapping:0x103A2
 },
 { code:0x103A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103A3
  ,simpleLowerCaseMapping:0x103A3
  ,simpleTitleCaseMapping:0x103A3
 },
 { code:0x103A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103A4
  ,simpleLowerCaseMapping:0x103A4
  ,simpleTitleCaseMapping:0x103A4
 },
 { code:0x103A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103A5
  ,simpleLowerCaseMapping:0x103A5
  ,simpleTitleCaseMapping:0x103A5
 },
 { code:0x103A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103A6
  ,simpleLowerCaseMapping:0x103A6
  ,simpleTitleCaseMapping:0x103A6
 },
 { code:0x103A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103A7
  ,simpleLowerCaseMapping:0x103A7
  ,simpleTitleCaseMapping:0x103A7
 },
 { code:0x103A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103A8
  ,simpleLowerCaseMapping:0x103A8
  ,simpleTitleCaseMapping:0x103A8
 },
 { code:0x103A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103A9
  ,simpleLowerCaseMapping:0x103A9
  ,simpleTitleCaseMapping:0x103A9
 },
 { code:0x103AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103AA
  ,simpleLowerCaseMapping:0x103AA
  ,simpleTitleCaseMapping:0x103AA
 },
 { code:0x103AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103AB
  ,simpleLowerCaseMapping:0x103AB
  ,simpleTitleCaseMapping:0x103AB
 },
 { code:0x103AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103AC
  ,simpleLowerCaseMapping:0x103AC
  ,simpleTitleCaseMapping:0x103AC
 },
 { code:0x103AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103AD
  ,simpleLowerCaseMapping:0x103AD
  ,simpleTitleCaseMapping:0x103AD
 },
 { code:0x103AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103AE
  ,simpleLowerCaseMapping:0x103AE
  ,simpleTitleCaseMapping:0x103AE
 },
 { code:0x103AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103AF
  ,simpleLowerCaseMapping:0x103AF
  ,simpleTitleCaseMapping:0x103AF
 },
 { code:0x103B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103B0
  ,simpleLowerCaseMapping:0x103B0
  ,simpleTitleCaseMapping:0x103B0
 },
 { code:0x103B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103B1
  ,simpleLowerCaseMapping:0x103B1
  ,simpleTitleCaseMapping:0x103B1
 },
 { code:0x103B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103B2
  ,simpleLowerCaseMapping:0x103B2
  ,simpleTitleCaseMapping:0x103B2
 },
 { code:0x103B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103B3
  ,simpleLowerCaseMapping:0x103B3
  ,simpleTitleCaseMapping:0x103B3
 },
 { code:0x103B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103B4
  ,simpleLowerCaseMapping:0x103B4
  ,simpleTitleCaseMapping:0x103B4
 },
 { code:0x103B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103B5
  ,simpleLowerCaseMapping:0x103B5
  ,simpleTitleCaseMapping:0x103B5
 },
 { code:0x103B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103B6
  ,simpleLowerCaseMapping:0x103B6
  ,simpleTitleCaseMapping:0x103B6
 },
 { code:0x103B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103B7
  ,simpleLowerCaseMapping:0x103B7
  ,simpleTitleCaseMapping:0x103B7
 },
 { code:0x103B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103B8
  ,simpleLowerCaseMapping:0x103B8
  ,simpleTitleCaseMapping:0x103B8
 },
 { code:0x103B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103B9
  ,simpleLowerCaseMapping:0x103B9
  ,simpleTitleCaseMapping:0x103B9
 },
 { code:0x103BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103BA
  ,simpleLowerCaseMapping:0x103BA
  ,simpleTitleCaseMapping:0x103BA
 },
 { code:0x103BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103BB
  ,simpleLowerCaseMapping:0x103BB
  ,simpleTitleCaseMapping:0x103BB
 },
 { code:0x103BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103BC
  ,simpleLowerCaseMapping:0x103BC
  ,simpleTitleCaseMapping:0x103BC
 },
 { code:0x103BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103BD
  ,simpleLowerCaseMapping:0x103BD
  ,simpleTitleCaseMapping:0x103BD
 },
 { code:0x103BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103BE
  ,simpleLowerCaseMapping:0x103BE
  ,simpleTitleCaseMapping:0x103BE
 },
 { code:0x103BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103BF
  ,simpleLowerCaseMapping:0x103BF
  ,simpleTitleCaseMapping:0x103BF
 },
 { code:0x103C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103C0
  ,simpleLowerCaseMapping:0x103C0
  ,simpleTitleCaseMapping:0x103C0
 },
 { code:0x103C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103C1
  ,simpleLowerCaseMapping:0x103C1
  ,simpleTitleCaseMapping:0x103C1
 },
 { code:0x103C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103C2
  ,simpleLowerCaseMapping:0x103C2
  ,simpleTitleCaseMapping:0x103C2
 },
 { code:0x103C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103C3
  ,simpleLowerCaseMapping:0x103C3
  ,simpleTitleCaseMapping:0x103C3
 },
 { code:0x103C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103C8
  ,simpleLowerCaseMapping:0x103C8
  ,simpleTitleCaseMapping:0x103C8
 },
 { code:0x103C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103C9
  ,simpleLowerCaseMapping:0x103C9
  ,simpleTitleCaseMapping:0x103C9
 },
 { code:0x103CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103CA
  ,simpleLowerCaseMapping:0x103CA
  ,simpleTitleCaseMapping:0x103CA
 },
 { code:0x103CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103CB
  ,simpleLowerCaseMapping:0x103CB
  ,simpleTitleCaseMapping:0x103CB
 },
 { code:0x103CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103CC
  ,simpleLowerCaseMapping:0x103CC
  ,simpleTitleCaseMapping:0x103CC
 },
 { code:0x103CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103CD
  ,simpleLowerCaseMapping:0x103CD
  ,simpleTitleCaseMapping:0x103CD
 },
 { code:0x103CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103CE
  ,simpleLowerCaseMapping:0x103CE
  ,simpleTitleCaseMapping:0x103CE
 },
 { code:0x103CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x103CF
  ,simpleLowerCaseMapping:0x103CF
  ,simpleTitleCaseMapping:0x103CF
 },
 { code:0x103D0
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x103D0
  ,simpleLowerCaseMapping:0x103D0
  ,simpleTitleCaseMapping:0x103D0
 },
 { code:0x103D1
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x103D1
  ,simpleLowerCaseMapping:0x103D1
  ,simpleTitleCaseMapping:0x103D1
 },
 { code:0x103D2
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x103D2
  ,simpleLowerCaseMapping:0x103D2
  ,simpleTitleCaseMapping:0x103D2
 },
 { code:0x103D3
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x103D3
  ,simpleLowerCaseMapping:0x103D3
  ,simpleTitleCaseMapping:0x103D3
 },
 { code:0x103D4
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x103D4
  ,simpleLowerCaseMapping:0x103D4
  ,simpleTitleCaseMapping:0x103D4
 },
 { code:0x103D5
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x103D5
  ,simpleLowerCaseMapping:0x103D5
  ,simpleTitleCaseMapping:0x103D5
 },
 { code:0x10400
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10400
  ,simpleLowerCaseMapping:0x10428
  ,simpleTitleCaseMapping:0x10400
 },
 { code:0x10401
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10401
  ,simpleLowerCaseMapping:0x10429
  ,simpleTitleCaseMapping:0x10401
 },
 { code:0x10402
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10402
  ,simpleLowerCaseMapping:0x1042A
  ,simpleTitleCaseMapping:0x10402
 },
 { code:0x10403
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10403
  ,simpleLowerCaseMapping:0x1042B
  ,simpleTitleCaseMapping:0x10403
 },
 { code:0x10404
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10404
  ,simpleLowerCaseMapping:0x1042C
  ,simpleTitleCaseMapping:0x10404
 },
 { code:0x10405
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10405
  ,simpleLowerCaseMapping:0x1042D
  ,simpleTitleCaseMapping:0x10405
 },
 { code:0x10406
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10406
  ,simpleLowerCaseMapping:0x1042E
  ,simpleTitleCaseMapping:0x10406
 },
 { code:0x10407
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10407
  ,simpleLowerCaseMapping:0x1042F
  ,simpleTitleCaseMapping:0x10407
 },
 { code:0x10408
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10408
  ,simpleLowerCaseMapping:0x10430
  ,simpleTitleCaseMapping:0x10408
 },
 { code:0x10409
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10409
  ,simpleLowerCaseMapping:0x10431
  ,simpleTitleCaseMapping:0x10409
 },
 { code:0x1040A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1040A
  ,simpleLowerCaseMapping:0x10432
  ,simpleTitleCaseMapping:0x1040A
 },
 { code:0x1040B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1040B
  ,simpleLowerCaseMapping:0x10433
  ,simpleTitleCaseMapping:0x1040B
 },
 { code:0x1040C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1040C
  ,simpleLowerCaseMapping:0x10434
  ,simpleTitleCaseMapping:0x1040C
 },
 { code:0x1040D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1040D
  ,simpleLowerCaseMapping:0x10435
  ,simpleTitleCaseMapping:0x1040D
 },
 { code:0x1040E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1040E
  ,simpleLowerCaseMapping:0x10436
  ,simpleTitleCaseMapping:0x1040E
 },
 { code:0x1040F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1040F
  ,simpleLowerCaseMapping:0x10437
  ,simpleTitleCaseMapping:0x1040F
 },
 { code:0x10410
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10410
  ,simpleLowerCaseMapping:0x10438
  ,simpleTitleCaseMapping:0x10410
 },
 { code:0x10411
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10411
  ,simpleLowerCaseMapping:0x10439
  ,simpleTitleCaseMapping:0x10411
 },
 { code:0x10412
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10412
  ,simpleLowerCaseMapping:0x1043A
  ,simpleTitleCaseMapping:0x10412
 },
 { code:0x10413
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10413
  ,simpleLowerCaseMapping:0x1043B
  ,simpleTitleCaseMapping:0x10413
 },
 { code:0x10414
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10414
  ,simpleLowerCaseMapping:0x1043C
  ,simpleTitleCaseMapping:0x10414
 },
 { code:0x10415
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10415
  ,simpleLowerCaseMapping:0x1043D
  ,simpleTitleCaseMapping:0x10415
 },
 { code:0x10416
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10416
  ,simpleLowerCaseMapping:0x1043E
  ,simpleTitleCaseMapping:0x10416
 },
 { code:0x10417
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10417
  ,simpleLowerCaseMapping:0x1043F
  ,simpleTitleCaseMapping:0x10417
 },
 { code:0x10418
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10418
  ,simpleLowerCaseMapping:0x10440
  ,simpleTitleCaseMapping:0x10418
 },
 { code:0x10419
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10419
  ,simpleLowerCaseMapping:0x10441
  ,simpleTitleCaseMapping:0x10419
 },
 { code:0x1041A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1041A
  ,simpleLowerCaseMapping:0x10442
  ,simpleTitleCaseMapping:0x1041A
 },
 { code:0x1041B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1041B
  ,simpleLowerCaseMapping:0x10443
  ,simpleTitleCaseMapping:0x1041B
 },
 { code:0x1041C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1041C
  ,simpleLowerCaseMapping:0x10444
  ,simpleTitleCaseMapping:0x1041C
 },
 { code:0x1041D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1041D
  ,simpleLowerCaseMapping:0x10445
  ,simpleTitleCaseMapping:0x1041D
 },
 { code:0x1041E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1041E
  ,simpleLowerCaseMapping:0x10446
  ,simpleTitleCaseMapping:0x1041E
 },
 { code:0x1041F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1041F
  ,simpleLowerCaseMapping:0x10447
  ,simpleTitleCaseMapping:0x1041F
 },
 { code:0x10420
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10420
  ,simpleLowerCaseMapping:0x10448
  ,simpleTitleCaseMapping:0x10420
 },
 { code:0x10421
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10421
  ,simpleLowerCaseMapping:0x10449
  ,simpleTitleCaseMapping:0x10421
 },
 { code:0x10422
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10422
  ,simpleLowerCaseMapping:0x1044A
  ,simpleTitleCaseMapping:0x10422
 },
 { code:0x10423
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10423
  ,simpleLowerCaseMapping:0x1044B
  ,simpleTitleCaseMapping:0x10423
 },
 { code:0x10424
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10424
  ,simpleLowerCaseMapping:0x1044C
  ,simpleTitleCaseMapping:0x10424
 },
 { code:0x10425
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10425
  ,simpleLowerCaseMapping:0x1044D
  ,simpleTitleCaseMapping:0x10425
 },
 { code:0x10426
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10426
  ,simpleLowerCaseMapping:0x1044E
  ,simpleTitleCaseMapping:0x10426
 },
 { code:0x10427
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x10427
  ,simpleLowerCaseMapping:0x1044F
  ,simpleTitleCaseMapping:0x10427
 },
 { code:0x10428
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10400
  ,simpleLowerCaseMapping:0x10428
  ,simpleTitleCaseMapping:0x10400
 },
 { code:0x10429
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10401
  ,simpleLowerCaseMapping:0x10429
  ,simpleTitleCaseMapping:0x10401
 },
 { code:0x1042A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10402
  ,simpleLowerCaseMapping:0x1042A
  ,simpleTitleCaseMapping:0x10402
 },
 { code:0x1042B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10403
  ,simpleLowerCaseMapping:0x1042B
  ,simpleTitleCaseMapping:0x10403
 },
 { code:0x1042C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10404
  ,simpleLowerCaseMapping:0x1042C
  ,simpleTitleCaseMapping:0x10404
 },
 { code:0x1042D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10405
  ,simpleLowerCaseMapping:0x1042D
  ,simpleTitleCaseMapping:0x10405
 },
 { code:0x1042E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10406
  ,simpleLowerCaseMapping:0x1042E
  ,simpleTitleCaseMapping:0x10406
 },
 { code:0x1042F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10407
  ,simpleLowerCaseMapping:0x1042F
  ,simpleTitleCaseMapping:0x10407
 },
 { code:0x10430
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10408
  ,simpleLowerCaseMapping:0x10430
  ,simpleTitleCaseMapping:0x10408
 },
 { code:0x10431
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10409
  ,simpleLowerCaseMapping:0x10431
  ,simpleTitleCaseMapping:0x10409
 },
 { code:0x10432
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1040A
  ,simpleLowerCaseMapping:0x10432
  ,simpleTitleCaseMapping:0x1040A
 },
 { code:0x10433
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1040B
  ,simpleLowerCaseMapping:0x10433
  ,simpleTitleCaseMapping:0x1040B
 },
 { code:0x10434
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1040C
  ,simpleLowerCaseMapping:0x10434
  ,simpleTitleCaseMapping:0x1040C
 },
 { code:0x10435
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1040D
  ,simpleLowerCaseMapping:0x10435
  ,simpleTitleCaseMapping:0x1040D
 },
 { code:0x10436
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1040E
  ,simpleLowerCaseMapping:0x10436
  ,simpleTitleCaseMapping:0x1040E
 },
 { code:0x10437
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1040F
  ,simpleLowerCaseMapping:0x10437
  ,simpleTitleCaseMapping:0x1040F
 },
 { code:0x10438
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10410
  ,simpleLowerCaseMapping:0x10438
  ,simpleTitleCaseMapping:0x10410
 },
 { code:0x10439
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10411
  ,simpleLowerCaseMapping:0x10439
  ,simpleTitleCaseMapping:0x10411
 },
 { code:0x1043A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10412
  ,simpleLowerCaseMapping:0x1043A
  ,simpleTitleCaseMapping:0x10412
 },
 { code:0x1043B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10413
  ,simpleLowerCaseMapping:0x1043B
  ,simpleTitleCaseMapping:0x10413
 },
 { code:0x1043C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10414
  ,simpleLowerCaseMapping:0x1043C
  ,simpleTitleCaseMapping:0x10414
 },
 { code:0x1043D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10415
  ,simpleLowerCaseMapping:0x1043D
  ,simpleTitleCaseMapping:0x10415
 },
 { code:0x1043E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10416
  ,simpleLowerCaseMapping:0x1043E
  ,simpleTitleCaseMapping:0x10416
 },
 { code:0x1043F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10417
  ,simpleLowerCaseMapping:0x1043F
  ,simpleTitleCaseMapping:0x10417
 },
 { code:0x10440
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10418
  ,simpleLowerCaseMapping:0x10440
  ,simpleTitleCaseMapping:0x10418
 },
 { code:0x10441
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10419
  ,simpleLowerCaseMapping:0x10441
  ,simpleTitleCaseMapping:0x10419
 },
 { code:0x10442
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1041A
  ,simpleLowerCaseMapping:0x10442
  ,simpleTitleCaseMapping:0x1041A
 },
 { code:0x10443
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1041B
  ,simpleLowerCaseMapping:0x10443
  ,simpleTitleCaseMapping:0x1041B
 },
 { code:0x10444
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1041C
  ,simpleLowerCaseMapping:0x10444
  ,simpleTitleCaseMapping:0x1041C
 },
 { code:0x10445
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1041D
  ,simpleLowerCaseMapping:0x10445
  ,simpleTitleCaseMapping:0x1041D
 },
 { code:0x10446
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1041E
  ,simpleLowerCaseMapping:0x10446
  ,simpleTitleCaseMapping:0x1041E
 },
 { code:0x10447
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1041F
  ,simpleLowerCaseMapping:0x10447
  ,simpleTitleCaseMapping:0x1041F
 },
 { code:0x10448
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10420
  ,simpleLowerCaseMapping:0x10448
  ,simpleTitleCaseMapping:0x10420
 },
 { code:0x10449
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10421
  ,simpleLowerCaseMapping:0x10449
  ,simpleTitleCaseMapping:0x10421
 },
 { code:0x1044A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10422
  ,simpleLowerCaseMapping:0x1044A
  ,simpleTitleCaseMapping:0x10422
 },
 { code:0x1044B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10423
  ,simpleLowerCaseMapping:0x1044B
  ,simpleTitleCaseMapping:0x10423
 },
 { code:0x1044C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10424
  ,simpleLowerCaseMapping:0x1044C
  ,simpleTitleCaseMapping:0x10424
 },
 { code:0x1044D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10425
  ,simpleLowerCaseMapping:0x1044D
  ,simpleTitleCaseMapping:0x10425
 },
 { code:0x1044E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10426
  ,simpleLowerCaseMapping:0x1044E
  ,simpleTitleCaseMapping:0x10426
 },
 { code:0x1044F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x10427
  ,simpleLowerCaseMapping:0x1044F
  ,simpleTitleCaseMapping:0x10427
 },
 { code:0x10450
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10450
  ,simpleLowerCaseMapping:0x10450
  ,simpleTitleCaseMapping:0x10450
 },
 { code:0x10451
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10451
  ,simpleLowerCaseMapping:0x10451
  ,simpleTitleCaseMapping:0x10451
 },
 { code:0x10452
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10452
  ,simpleLowerCaseMapping:0x10452
  ,simpleTitleCaseMapping:0x10452
 },
 { code:0x10453
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10453
  ,simpleLowerCaseMapping:0x10453
  ,simpleTitleCaseMapping:0x10453
 },
 { code:0x10454
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10454
  ,simpleLowerCaseMapping:0x10454
  ,simpleTitleCaseMapping:0x10454
 },
 { code:0x10455
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10455
  ,simpleLowerCaseMapping:0x10455
  ,simpleTitleCaseMapping:0x10455
 },
 { code:0x10456
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10456
  ,simpleLowerCaseMapping:0x10456
  ,simpleTitleCaseMapping:0x10456
 },
 { code:0x10457
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10457
  ,simpleLowerCaseMapping:0x10457
  ,simpleTitleCaseMapping:0x10457
 },
 { code:0x10458
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10458
  ,simpleLowerCaseMapping:0x10458
  ,simpleTitleCaseMapping:0x10458
 },
 { code:0x10459
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10459
  ,simpleLowerCaseMapping:0x10459
  ,simpleTitleCaseMapping:0x10459
 },
 { code:0x1045A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1045A
  ,simpleLowerCaseMapping:0x1045A
  ,simpleTitleCaseMapping:0x1045A
 },
 { code:0x1045B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1045B
  ,simpleLowerCaseMapping:0x1045B
  ,simpleTitleCaseMapping:0x1045B
 },
 { code:0x1045C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1045C
  ,simpleLowerCaseMapping:0x1045C
  ,simpleTitleCaseMapping:0x1045C
 },
 { code:0x1045D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1045D
  ,simpleLowerCaseMapping:0x1045D
  ,simpleTitleCaseMapping:0x1045D
 },
 { code:0x1045E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1045E
  ,simpleLowerCaseMapping:0x1045E
  ,simpleTitleCaseMapping:0x1045E
 },
 { code:0x1045F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1045F
  ,simpleLowerCaseMapping:0x1045F
  ,simpleTitleCaseMapping:0x1045F
 },
 { code:0x10460
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10460
  ,simpleLowerCaseMapping:0x10460
  ,simpleTitleCaseMapping:0x10460
 },
 { code:0x10461
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10461
  ,simpleLowerCaseMapping:0x10461
  ,simpleTitleCaseMapping:0x10461
 },
 { code:0x10462
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10462
  ,simpleLowerCaseMapping:0x10462
  ,simpleTitleCaseMapping:0x10462
 },
 { code:0x10463
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10463
  ,simpleLowerCaseMapping:0x10463
  ,simpleTitleCaseMapping:0x10463
 },
 { code:0x10464
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10464
  ,simpleLowerCaseMapping:0x10464
  ,simpleTitleCaseMapping:0x10464
 },
 { code:0x10465
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10465
  ,simpleLowerCaseMapping:0x10465
  ,simpleTitleCaseMapping:0x10465
 },
 { code:0x10466
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10466
  ,simpleLowerCaseMapping:0x10466
  ,simpleTitleCaseMapping:0x10466
 },
 { code:0x10467
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10467
  ,simpleLowerCaseMapping:0x10467
  ,simpleTitleCaseMapping:0x10467
 },
 { code:0x10468
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10468
  ,simpleLowerCaseMapping:0x10468
  ,simpleTitleCaseMapping:0x10468
 },
 { code:0x10469
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10469
  ,simpleLowerCaseMapping:0x10469
  ,simpleTitleCaseMapping:0x10469
 },
 { code:0x1046A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1046A
  ,simpleLowerCaseMapping:0x1046A
  ,simpleTitleCaseMapping:0x1046A
 },
 { code:0x1046B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1046B
  ,simpleLowerCaseMapping:0x1046B
  ,simpleTitleCaseMapping:0x1046B
 },
 { code:0x1046C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1046C
  ,simpleLowerCaseMapping:0x1046C
  ,simpleTitleCaseMapping:0x1046C
 },
 { code:0x1046D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1046D
  ,simpleLowerCaseMapping:0x1046D
  ,simpleTitleCaseMapping:0x1046D
 },
 { code:0x1046E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1046E
  ,simpleLowerCaseMapping:0x1046E
  ,simpleTitleCaseMapping:0x1046E
 },
 { code:0x1046F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1046F
  ,simpleLowerCaseMapping:0x1046F
  ,simpleTitleCaseMapping:0x1046F
 },
 { code:0x10470
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10470
  ,simpleLowerCaseMapping:0x10470
  ,simpleTitleCaseMapping:0x10470
 },
 { code:0x10471
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10471
  ,simpleLowerCaseMapping:0x10471
  ,simpleTitleCaseMapping:0x10471
 },
 { code:0x10472
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10472
  ,simpleLowerCaseMapping:0x10472
  ,simpleTitleCaseMapping:0x10472
 },
 { code:0x10473
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10473
  ,simpleLowerCaseMapping:0x10473
  ,simpleTitleCaseMapping:0x10473
 },
 { code:0x10474
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10474
  ,simpleLowerCaseMapping:0x10474
  ,simpleTitleCaseMapping:0x10474
 },
 { code:0x10475
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10475
  ,simpleLowerCaseMapping:0x10475
  ,simpleTitleCaseMapping:0x10475
 },
 { code:0x10476
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10476
  ,simpleLowerCaseMapping:0x10476
  ,simpleTitleCaseMapping:0x10476
 },
 { code:0x10477
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10477
  ,simpleLowerCaseMapping:0x10477
  ,simpleTitleCaseMapping:0x10477
 },
 { code:0x10478
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10478
  ,simpleLowerCaseMapping:0x10478
  ,simpleTitleCaseMapping:0x10478
 },
 { code:0x10479
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10479
  ,simpleLowerCaseMapping:0x10479
  ,simpleTitleCaseMapping:0x10479
 },
 { code:0x1047A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1047A
  ,simpleLowerCaseMapping:0x1047A
  ,simpleTitleCaseMapping:0x1047A
 },
 { code:0x1047B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1047B
  ,simpleLowerCaseMapping:0x1047B
  ,simpleTitleCaseMapping:0x1047B
 },
 { code:0x1047C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1047C
  ,simpleLowerCaseMapping:0x1047C
  ,simpleTitleCaseMapping:0x1047C
 },
 { code:0x1047D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1047D
  ,simpleLowerCaseMapping:0x1047D
  ,simpleTitleCaseMapping:0x1047D
 },
 { code:0x1047E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1047E
  ,simpleLowerCaseMapping:0x1047E
  ,simpleTitleCaseMapping:0x1047E
 },
 { code:0x1047F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1047F
  ,simpleLowerCaseMapping:0x1047F
  ,simpleTitleCaseMapping:0x1047F
 },
 { code:0x10480
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10480
  ,simpleLowerCaseMapping:0x10480
  ,simpleTitleCaseMapping:0x10480
 },
 { code:0x10481
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10481
  ,simpleLowerCaseMapping:0x10481
  ,simpleTitleCaseMapping:0x10481
 },
 { code:0x10482
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10482
  ,simpleLowerCaseMapping:0x10482
  ,simpleTitleCaseMapping:0x10482
 },
 { code:0x10483
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10483
  ,simpleLowerCaseMapping:0x10483
  ,simpleTitleCaseMapping:0x10483
 },
 { code:0x10484
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10484
  ,simpleLowerCaseMapping:0x10484
  ,simpleTitleCaseMapping:0x10484
 },
 { code:0x10485
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10485
  ,simpleLowerCaseMapping:0x10485
  ,simpleTitleCaseMapping:0x10485
 },
 { code:0x10486
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10486
  ,simpleLowerCaseMapping:0x10486
  ,simpleTitleCaseMapping:0x10486
 },
 { code:0x10487
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10487
  ,simpleLowerCaseMapping:0x10487
  ,simpleTitleCaseMapping:0x10487
 },
 { code:0x10488
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10488
  ,simpleLowerCaseMapping:0x10488
  ,simpleTitleCaseMapping:0x10488
 },
 { code:0x10489
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10489
  ,simpleLowerCaseMapping:0x10489
  ,simpleTitleCaseMapping:0x10489
 },
 { code:0x1048A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1048A
  ,simpleLowerCaseMapping:0x1048A
  ,simpleTitleCaseMapping:0x1048A
 },
 { code:0x1048B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1048B
  ,simpleLowerCaseMapping:0x1048B
  ,simpleTitleCaseMapping:0x1048B
 },
 { code:0x1048C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1048C
  ,simpleLowerCaseMapping:0x1048C
  ,simpleTitleCaseMapping:0x1048C
 },
 { code:0x1048D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1048D
  ,simpleLowerCaseMapping:0x1048D
  ,simpleTitleCaseMapping:0x1048D
 },
 { code:0x1048E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1048E
  ,simpleLowerCaseMapping:0x1048E
  ,simpleTitleCaseMapping:0x1048E
 },
 { code:0x1048F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1048F
  ,simpleLowerCaseMapping:0x1048F
  ,simpleTitleCaseMapping:0x1048F
 },
 { code:0x10490
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10490
  ,simpleLowerCaseMapping:0x10490
  ,simpleTitleCaseMapping:0x10490
 },
 { code:0x10491
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10491
  ,simpleLowerCaseMapping:0x10491
  ,simpleTitleCaseMapping:0x10491
 },
 { code:0x10492
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10492
  ,simpleLowerCaseMapping:0x10492
  ,simpleTitleCaseMapping:0x10492
 },
 { code:0x10493
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10493
  ,simpleLowerCaseMapping:0x10493
  ,simpleTitleCaseMapping:0x10493
 },
 { code:0x10494
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10494
  ,simpleLowerCaseMapping:0x10494
  ,simpleTitleCaseMapping:0x10494
 },
 { code:0x10495
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10495
  ,simpleLowerCaseMapping:0x10495
  ,simpleTitleCaseMapping:0x10495
 },
 { code:0x10496
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10496
  ,simpleLowerCaseMapping:0x10496
  ,simpleTitleCaseMapping:0x10496
 },
 { code:0x10497
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10497
  ,simpleLowerCaseMapping:0x10497
  ,simpleTitleCaseMapping:0x10497
 },
 { code:0x10498
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10498
  ,simpleLowerCaseMapping:0x10498
  ,simpleTitleCaseMapping:0x10498
 },
 { code:0x10499
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10499
  ,simpleLowerCaseMapping:0x10499
  ,simpleTitleCaseMapping:0x10499
 },
 { code:0x1049A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1049A
  ,simpleLowerCaseMapping:0x1049A
  ,simpleTitleCaseMapping:0x1049A
 },
 { code:0x1049B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1049B
  ,simpleLowerCaseMapping:0x1049B
  ,simpleTitleCaseMapping:0x1049B
 },
 { code:0x1049C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1049C
  ,simpleLowerCaseMapping:0x1049C
  ,simpleTitleCaseMapping:0x1049C
 },
 { code:0x1049D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1049D
  ,simpleLowerCaseMapping:0x1049D
  ,simpleTitleCaseMapping:0x1049D
 },
 { code:0x104A0
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x104A0
  ,simpleLowerCaseMapping:0x104A0
  ,simpleTitleCaseMapping:0x104A0
 },
 { code:0x104A1
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x104A1
  ,simpleLowerCaseMapping:0x104A1
  ,simpleTitleCaseMapping:0x104A1
 },
 { code:0x104A2
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x104A2
  ,simpleLowerCaseMapping:0x104A2
  ,simpleTitleCaseMapping:0x104A2
 },
 { code:0x104A3
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x104A3
  ,simpleLowerCaseMapping:0x104A3
  ,simpleTitleCaseMapping:0x104A3
 },
 { code:0x104A4
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x104A4
  ,simpleLowerCaseMapping:0x104A4
  ,simpleTitleCaseMapping:0x104A4
 },
 { code:0x104A5
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x104A5
  ,simpleLowerCaseMapping:0x104A5
  ,simpleTitleCaseMapping:0x104A5
 },
 { code:0x104A6
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x104A6
  ,simpleLowerCaseMapping:0x104A6
  ,simpleTitleCaseMapping:0x104A6
 },
 { code:0x104A7
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x104A7
  ,simpleLowerCaseMapping:0x104A7
  ,simpleTitleCaseMapping:0x104A7
 },
 { code:0x104A8
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x104A8
  ,simpleLowerCaseMapping:0x104A8
  ,simpleTitleCaseMapping:0x104A8
 },
 { code:0x104A9
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x104A9
  ,simpleLowerCaseMapping:0x104A9
  ,simpleTitleCaseMapping:0x104A9
 },
 { code:0x10800
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10800
  ,simpleLowerCaseMapping:0x10800
  ,simpleTitleCaseMapping:0x10800
 },
 { code:0x10801
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10801
  ,simpleLowerCaseMapping:0x10801
  ,simpleTitleCaseMapping:0x10801
 },
 { code:0x10802
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10802
  ,simpleLowerCaseMapping:0x10802
  ,simpleTitleCaseMapping:0x10802
 },
 { code:0x10803
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10803
  ,simpleLowerCaseMapping:0x10803
  ,simpleTitleCaseMapping:0x10803
 },
 { code:0x10804
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10804
  ,simpleLowerCaseMapping:0x10804
  ,simpleTitleCaseMapping:0x10804
 },
 { code:0x10805
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10805
  ,simpleLowerCaseMapping:0x10805
  ,simpleTitleCaseMapping:0x10805
 },
 { code:0x10808
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10808
  ,simpleLowerCaseMapping:0x10808
  ,simpleTitleCaseMapping:0x10808
 },
 { code:0x1080A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1080A
  ,simpleLowerCaseMapping:0x1080A
  ,simpleTitleCaseMapping:0x1080A
 },
 { code:0x1080B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1080B
  ,simpleLowerCaseMapping:0x1080B
  ,simpleTitleCaseMapping:0x1080B
 },
 { code:0x1080C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1080C
  ,simpleLowerCaseMapping:0x1080C
  ,simpleTitleCaseMapping:0x1080C
 },
 { code:0x1080D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1080D
  ,simpleLowerCaseMapping:0x1080D
  ,simpleTitleCaseMapping:0x1080D
 },
 { code:0x1080E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1080E
  ,simpleLowerCaseMapping:0x1080E
  ,simpleTitleCaseMapping:0x1080E
 },
 { code:0x1080F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1080F
  ,simpleLowerCaseMapping:0x1080F
  ,simpleTitleCaseMapping:0x1080F
 },
 { code:0x10810
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10810
  ,simpleLowerCaseMapping:0x10810
  ,simpleTitleCaseMapping:0x10810
 },
 { code:0x10811
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10811
  ,simpleLowerCaseMapping:0x10811
  ,simpleTitleCaseMapping:0x10811
 },
 { code:0x10812
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10812
  ,simpleLowerCaseMapping:0x10812
  ,simpleTitleCaseMapping:0x10812
 },
 { code:0x10813
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10813
  ,simpleLowerCaseMapping:0x10813
  ,simpleTitleCaseMapping:0x10813
 },
 { code:0x10814
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10814
  ,simpleLowerCaseMapping:0x10814
  ,simpleTitleCaseMapping:0x10814
 },
 { code:0x10815
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10815
  ,simpleLowerCaseMapping:0x10815
  ,simpleTitleCaseMapping:0x10815
 },
 { code:0x10816
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10816
  ,simpleLowerCaseMapping:0x10816
  ,simpleTitleCaseMapping:0x10816
 },
 { code:0x10817
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10817
  ,simpleLowerCaseMapping:0x10817
  ,simpleTitleCaseMapping:0x10817
 },
 { code:0x10818
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10818
  ,simpleLowerCaseMapping:0x10818
  ,simpleTitleCaseMapping:0x10818
 },
 { code:0x10819
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10819
  ,simpleLowerCaseMapping:0x10819
  ,simpleTitleCaseMapping:0x10819
 },
 { code:0x1081A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1081A
  ,simpleLowerCaseMapping:0x1081A
  ,simpleTitleCaseMapping:0x1081A
 },
 { code:0x1081B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1081B
  ,simpleLowerCaseMapping:0x1081B
  ,simpleTitleCaseMapping:0x1081B
 },
 { code:0x1081C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1081C
  ,simpleLowerCaseMapping:0x1081C
  ,simpleTitleCaseMapping:0x1081C
 },
 { code:0x1081D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1081D
  ,simpleLowerCaseMapping:0x1081D
  ,simpleTitleCaseMapping:0x1081D
 },
 { code:0x1081E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1081E
  ,simpleLowerCaseMapping:0x1081E
  ,simpleTitleCaseMapping:0x1081E
 },
 { code:0x1081F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1081F
  ,simpleLowerCaseMapping:0x1081F
  ,simpleTitleCaseMapping:0x1081F
 },
 { code:0x10820
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10820
  ,simpleLowerCaseMapping:0x10820
  ,simpleTitleCaseMapping:0x10820
 },
 { code:0x10821
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10821
  ,simpleLowerCaseMapping:0x10821
  ,simpleTitleCaseMapping:0x10821
 },
 { code:0x10822
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10822
  ,simpleLowerCaseMapping:0x10822
  ,simpleTitleCaseMapping:0x10822
 },
 { code:0x10823
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10823
  ,simpleLowerCaseMapping:0x10823
  ,simpleTitleCaseMapping:0x10823
 },
 { code:0x10824
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10824
  ,simpleLowerCaseMapping:0x10824
  ,simpleTitleCaseMapping:0x10824
 },
 { code:0x10825
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10825
  ,simpleLowerCaseMapping:0x10825
  ,simpleTitleCaseMapping:0x10825
 },
 { code:0x10826
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10826
  ,simpleLowerCaseMapping:0x10826
  ,simpleTitleCaseMapping:0x10826
 },
 { code:0x10827
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10827
  ,simpleLowerCaseMapping:0x10827
  ,simpleTitleCaseMapping:0x10827
 },
 { code:0x10828
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10828
  ,simpleLowerCaseMapping:0x10828
  ,simpleTitleCaseMapping:0x10828
 },
 { code:0x10829
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10829
  ,simpleLowerCaseMapping:0x10829
  ,simpleTitleCaseMapping:0x10829
 },
 { code:0x1082A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1082A
  ,simpleLowerCaseMapping:0x1082A
  ,simpleTitleCaseMapping:0x1082A
 },
 { code:0x1082B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1082B
  ,simpleLowerCaseMapping:0x1082B
  ,simpleTitleCaseMapping:0x1082B
 },
 { code:0x1082C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1082C
  ,simpleLowerCaseMapping:0x1082C
  ,simpleTitleCaseMapping:0x1082C
 },
 { code:0x1082D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1082D
  ,simpleLowerCaseMapping:0x1082D
  ,simpleTitleCaseMapping:0x1082D
 },
 { code:0x1082E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1082E
  ,simpleLowerCaseMapping:0x1082E
  ,simpleTitleCaseMapping:0x1082E
 },
 { code:0x1082F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1082F
  ,simpleLowerCaseMapping:0x1082F
  ,simpleTitleCaseMapping:0x1082F
 },
 { code:0x10830
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10830
  ,simpleLowerCaseMapping:0x10830
  ,simpleTitleCaseMapping:0x10830
 },
 { code:0x10831
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10831
  ,simpleLowerCaseMapping:0x10831
  ,simpleTitleCaseMapping:0x10831
 },
 { code:0x10832
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10832
  ,simpleLowerCaseMapping:0x10832
  ,simpleTitleCaseMapping:0x10832
 },
 { code:0x10833
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10833
  ,simpleLowerCaseMapping:0x10833
  ,simpleTitleCaseMapping:0x10833
 },
 { code:0x10834
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10834
  ,simpleLowerCaseMapping:0x10834
  ,simpleTitleCaseMapping:0x10834
 },
 { code:0x10835
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10835
  ,simpleLowerCaseMapping:0x10835
  ,simpleTitleCaseMapping:0x10835
 },
 { code:0x10837
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10837
  ,simpleLowerCaseMapping:0x10837
  ,simpleTitleCaseMapping:0x10837
 },
 { code:0x10838
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10838
  ,simpleLowerCaseMapping:0x10838
  ,simpleTitleCaseMapping:0x10838
 },
 { code:0x1083C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1083C
  ,simpleLowerCaseMapping:0x1083C
  ,simpleTitleCaseMapping:0x1083C
 },
 { code:0x1083F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1083F
  ,simpleLowerCaseMapping:0x1083F
  ,simpleTitleCaseMapping:0x1083F
 },
 { code:0x10900
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10900
  ,simpleLowerCaseMapping:0x10900
  ,simpleTitleCaseMapping:0x10900
 },
 { code:0x10901
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10901
  ,simpleLowerCaseMapping:0x10901
  ,simpleTitleCaseMapping:0x10901
 },
 { code:0x10902
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10902
  ,simpleLowerCaseMapping:0x10902
  ,simpleTitleCaseMapping:0x10902
 },
 { code:0x10903
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10903
  ,simpleLowerCaseMapping:0x10903
  ,simpleTitleCaseMapping:0x10903
 },
 { code:0x10904
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10904
  ,simpleLowerCaseMapping:0x10904
  ,simpleTitleCaseMapping:0x10904
 },
 { code:0x10905
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10905
  ,simpleLowerCaseMapping:0x10905
  ,simpleTitleCaseMapping:0x10905
 },
 { code:0x10906
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10906
  ,simpleLowerCaseMapping:0x10906
  ,simpleTitleCaseMapping:0x10906
 },
 { code:0x10907
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10907
  ,simpleLowerCaseMapping:0x10907
  ,simpleTitleCaseMapping:0x10907
 },
 { code:0x10908
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10908
  ,simpleLowerCaseMapping:0x10908
  ,simpleTitleCaseMapping:0x10908
 },
 { code:0x10909
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10909
  ,simpleLowerCaseMapping:0x10909
  ,simpleTitleCaseMapping:0x10909
 },
 { code:0x1090A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1090A
  ,simpleLowerCaseMapping:0x1090A
  ,simpleTitleCaseMapping:0x1090A
 },
 { code:0x1090B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1090B
  ,simpleLowerCaseMapping:0x1090B
  ,simpleTitleCaseMapping:0x1090B
 },
 { code:0x1090C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1090C
  ,simpleLowerCaseMapping:0x1090C
  ,simpleTitleCaseMapping:0x1090C
 },
 { code:0x1090D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1090D
  ,simpleLowerCaseMapping:0x1090D
  ,simpleTitleCaseMapping:0x1090D
 },
 { code:0x1090E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1090E
  ,simpleLowerCaseMapping:0x1090E
  ,simpleTitleCaseMapping:0x1090E
 },
 { code:0x1090F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1090F
  ,simpleLowerCaseMapping:0x1090F
  ,simpleTitleCaseMapping:0x1090F
 },
 { code:0x10910
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10910
  ,simpleLowerCaseMapping:0x10910
  ,simpleTitleCaseMapping:0x10910
 },
 { code:0x10911
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10911
  ,simpleLowerCaseMapping:0x10911
  ,simpleTitleCaseMapping:0x10911
 },
 { code:0x10912
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10912
  ,simpleLowerCaseMapping:0x10912
  ,simpleTitleCaseMapping:0x10912
 },
 { code:0x10913
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10913
  ,simpleLowerCaseMapping:0x10913
  ,simpleTitleCaseMapping:0x10913
 },
 { code:0x10914
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10914
  ,simpleLowerCaseMapping:0x10914
  ,simpleTitleCaseMapping:0x10914
 },
 { code:0x10915
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10915
  ,simpleLowerCaseMapping:0x10915
  ,simpleTitleCaseMapping:0x10915
 },
 { code:0x10916
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10916
  ,simpleLowerCaseMapping:0x10916
  ,simpleTitleCaseMapping:0x10916
 },
 { code:0x10917
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10917
  ,simpleLowerCaseMapping:0x10917
  ,simpleTitleCaseMapping:0x10917
 },
 { code:0x10918
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10918
  ,simpleLowerCaseMapping:0x10918
  ,simpleTitleCaseMapping:0x10918
 },
 { code:0x10919
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10919
  ,simpleLowerCaseMapping:0x10919
  ,simpleTitleCaseMapping:0x10919
 },
 { code:0x1091F
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x1091F
  ,simpleLowerCaseMapping:0x1091F
  ,simpleTitleCaseMapping:0x1091F
 },
 { code:0x10A00
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A00
  ,simpleLowerCaseMapping:0x10A00
  ,simpleTitleCaseMapping:0x10A00
 },
 { code:0x10A01
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x10A01
  ,simpleLowerCaseMapping:0x10A01
  ,simpleTitleCaseMapping:0x10A01
 },
 { code:0x10A02
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x10A02
  ,simpleLowerCaseMapping:0x10A02
  ,simpleTitleCaseMapping:0x10A02
 },
 { code:0x10A03
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x10A03
  ,simpleLowerCaseMapping:0x10A03
  ,simpleTitleCaseMapping:0x10A03
 },
 { code:0x10A05
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x10A05
  ,simpleLowerCaseMapping:0x10A05
  ,simpleTitleCaseMapping:0x10A05
 },
 { code:0x10A06
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x10A06
  ,simpleLowerCaseMapping:0x10A06
  ,simpleTitleCaseMapping:0x10A06
 },
 { code:0x10A0C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x10A0C
  ,simpleLowerCaseMapping:0x10A0C
  ,simpleTitleCaseMapping:0x10A0C
 },
 { code:0x10A0D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x10A0D
  ,simpleLowerCaseMapping:0x10A0D
  ,simpleTitleCaseMapping:0x10A0D
 },
 { code:0x10A0E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x10A0E
  ,simpleLowerCaseMapping:0x10A0E
  ,simpleTitleCaseMapping:0x10A0E
 },
 { code:0x10A0F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x10A0F
  ,simpleLowerCaseMapping:0x10A0F
  ,simpleTitleCaseMapping:0x10A0F
 },
 { code:0x10A10
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A10
  ,simpleLowerCaseMapping:0x10A10
  ,simpleTitleCaseMapping:0x10A10
 },
 { code:0x10A11
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A11
  ,simpleLowerCaseMapping:0x10A11
  ,simpleTitleCaseMapping:0x10A11
 },
 { code:0x10A12
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A12
  ,simpleLowerCaseMapping:0x10A12
  ,simpleTitleCaseMapping:0x10A12
 },
 { code:0x10A13
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A13
  ,simpleLowerCaseMapping:0x10A13
  ,simpleTitleCaseMapping:0x10A13
 },
 { code:0x10A15
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A15
  ,simpleLowerCaseMapping:0x10A15
  ,simpleTitleCaseMapping:0x10A15
 },
 { code:0x10A16
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A16
  ,simpleLowerCaseMapping:0x10A16
  ,simpleTitleCaseMapping:0x10A16
 },
 { code:0x10A17
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A17
  ,simpleLowerCaseMapping:0x10A17
  ,simpleTitleCaseMapping:0x10A17
 },
 { code:0x10A19
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A19
  ,simpleLowerCaseMapping:0x10A19
  ,simpleTitleCaseMapping:0x10A19
 },
 { code:0x10A1A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A1A
  ,simpleLowerCaseMapping:0x10A1A
  ,simpleTitleCaseMapping:0x10A1A
 },
 { code:0x10A1B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A1B
  ,simpleLowerCaseMapping:0x10A1B
  ,simpleTitleCaseMapping:0x10A1B
 },
 { code:0x10A1C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A1C
  ,simpleLowerCaseMapping:0x10A1C
  ,simpleTitleCaseMapping:0x10A1C
 },
 { code:0x10A1D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A1D
  ,simpleLowerCaseMapping:0x10A1D
  ,simpleTitleCaseMapping:0x10A1D
 },
 { code:0x10A1E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A1E
  ,simpleLowerCaseMapping:0x10A1E
  ,simpleTitleCaseMapping:0x10A1E
 },
 { code:0x10A1F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A1F
  ,simpleLowerCaseMapping:0x10A1F
  ,simpleTitleCaseMapping:0x10A1F
 },
 { code:0x10A20
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A20
  ,simpleLowerCaseMapping:0x10A20
  ,simpleTitleCaseMapping:0x10A20
 },
 { code:0x10A21
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A21
  ,simpleLowerCaseMapping:0x10A21
  ,simpleTitleCaseMapping:0x10A21
 },
 { code:0x10A22
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A22
  ,simpleLowerCaseMapping:0x10A22
  ,simpleTitleCaseMapping:0x10A22
 },
 { code:0x10A23
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A23
  ,simpleLowerCaseMapping:0x10A23
  ,simpleTitleCaseMapping:0x10A23
 },
 { code:0x10A24
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A24
  ,simpleLowerCaseMapping:0x10A24
  ,simpleTitleCaseMapping:0x10A24
 },
 { code:0x10A25
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A25
  ,simpleLowerCaseMapping:0x10A25
  ,simpleTitleCaseMapping:0x10A25
 },
 { code:0x10A26
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A26
  ,simpleLowerCaseMapping:0x10A26
  ,simpleTitleCaseMapping:0x10A26
 },
 { code:0x10A27
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A27
  ,simpleLowerCaseMapping:0x10A27
  ,simpleTitleCaseMapping:0x10A27
 },
 { code:0x10A28
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A28
  ,simpleLowerCaseMapping:0x10A28
  ,simpleTitleCaseMapping:0x10A28
 },
 { code:0x10A29
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A29
  ,simpleLowerCaseMapping:0x10A29
  ,simpleTitleCaseMapping:0x10A29
 },
 { code:0x10A2A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A2A
  ,simpleLowerCaseMapping:0x10A2A
  ,simpleTitleCaseMapping:0x10A2A
 },
 { code:0x10A2B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A2B
  ,simpleLowerCaseMapping:0x10A2B
  ,simpleTitleCaseMapping:0x10A2B
 },
 { code:0x10A2C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A2C
  ,simpleLowerCaseMapping:0x10A2C
  ,simpleTitleCaseMapping:0x10A2C
 },
 { code:0x10A2D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A2D
  ,simpleLowerCaseMapping:0x10A2D
  ,simpleTitleCaseMapping:0x10A2D
 },
 { code:0x10A2E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A2E
  ,simpleLowerCaseMapping:0x10A2E
  ,simpleTitleCaseMapping:0x10A2E
 },
 { code:0x10A2F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A2F
  ,simpleLowerCaseMapping:0x10A2F
  ,simpleTitleCaseMapping:0x10A2F
 },
 { code:0x10A30
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A30
  ,simpleLowerCaseMapping:0x10A30
  ,simpleTitleCaseMapping:0x10A30
 },
 { code:0x10A31
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A31
  ,simpleLowerCaseMapping:0x10A31
  ,simpleTitleCaseMapping:0x10A31
 },
 { code:0x10A32
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A32
  ,simpleLowerCaseMapping:0x10A32
  ,simpleTitleCaseMapping:0x10A32
 },
 { code:0x10A33
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x10A33
  ,simpleLowerCaseMapping:0x10A33
  ,simpleTitleCaseMapping:0x10A33
 },
 { code:0x10A38
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x10A38
  ,simpleLowerCaseMapping:0x10A38
  ,simpleTitleCaseMapping:0x10A38
 },
 { code:0x10A39
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x10A39
  ,simpleLowerCaseMapping:0x10A39
  ,simpleTitleCaseMapping:0x10A39
 },
 { code:0x10A3A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x10A3A
  ,simpleLowerCaseMapping:0x10A3A
  ,simpleTitleCaseMapping:0x10A3A
 },
 { code:0x10A3F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x10A3F
  ,simpleLowerCaseMapping:0x10A3F
  ,simpleTitleCaseMapping:0x10A3F
 },
 { code:0x10A40
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10A40
  ,simpleLowerCaseMapping:0x10A40
  ,simpleTitleCaseMapping:0x10A40
 },
 { code:0x10A41
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10A41
  ,simpleLowerCaseMapping:0x10A41
  ,simpleTitleCaseMapping:0x10A41
 },
 { code:0x10A42
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10A42
  ,simpleLowerCaseMapping:0x10A42
  ,simpleTitleCaseMapping:0x10A42
 },
 { code:0x10A43
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10A43
  ,simpleLowerCaseMapping:0x10A43
  ,simpleTitleCaseMapping:0x10A43
 },
 { code:0x10A44
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10A44
  ,simpleLowerCaseMapping:0x10A44
  ,simpleTitleCaseMapping:0x10A44
 },
 { code:0x10A45
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10A45
  ,simpleLowerCaseMapping:0x10A45
  ,simpleTitleCaseMapping:0x10A45
 },
 { code:0x10A46
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10A46
  ,simpleLowerCaseMapping:0x10A46
  ,simpleTitleCaseMapping:0x10A46
 },
 { code:0x10A47
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x10A47
  ,simpleLowerCaseMapping:0x10A47
  ,simpleTitleCaseMapping:0x10A47
 },
 { code:0x10A50
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x10A50
  ,simpleLowerCaseMapping:0x10A50
  ,simpleTitleCaseMapping:0x10A50
 },
 { code:0x10A51
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x10A51
  ,simpleLowerCaseMapping:0x10A51
  ,simpleTitleCaseMapping:0x10A51
 },
 { code:0x10A52
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x10A52
  ,simpleLowerCaseMapping:0x10A52
  ,simpleTitleCaseMapping:0x10A52
 },
 { code:0x10A53
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x10A53
  ,simpleLowerCaseMapping:0x10A53
  ,simpleTitleCaseMapping:0x10A53
 },
 { code:0x10A54
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x10A54
  ,simpleLowerCaseMapping:0x10A54
  ,simpleTitleCaseMapping:0x10A54
 },
 { code:0x10A55
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x10A55
  ,simpleLowerCaseMapping:0x10A55
  ,simpleTitleCaseMapping:0x10A55
 },
 { code:0x10A56
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x10A56
  ,simpleLowerCaseMapping:0x10A56
  ,simpleTitleCaseMapping:0x10A56
 },
 { code:0x10A57
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x10A57
  ,simpleLowerCaseMapping:0x10A57
  ,simpleTitleCaseMapping:0x10A57
 },
 { code:0x10A58
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x10A58
  ,simpleLowerCaseMapping:0x10A58
  ,simpleTitleCaseMapping:0x10A58
 },
 { code:0x12000
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12000
  ,simpleLowerCaseMapping:0x12000
  ,simpleTitleCaseMapping:0x12000
 },
 { code:0x12001
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12001
  ,simpleLowerCaseMapping:0x12001
  ,simpleTitleCaseMapping:0x12001
 },
 { code:0x12002
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12002
  ,simpleLowerCaseMapping:0x12002
  ,simpleTitleCaseMapping:0x12002
 },
 { code:0x12003
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12003
  ,simpleLowerCaseMapping:0x12003
  ,simpleTitleCaseMapping:0x12003
 },
 { code:0x12004
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12004
  ,simpleLowerCaseMapping:0x12004
  ,simpleTitleCaseMapping:0x12004
 },
 { code:0x12005
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12005
  ,simpleLowerCaseMapping:0x12005
  ,simpleTitleCaseMapping:0x12005
 },
 { code:0x12006
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12006
  ,simpleLowerCaseMapping:0x12006
  ,simpleTitleCaseMapping:0x12006
 },
 { code:0x12007
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12007
  ,simpleLowerCaseMapping:0x12007
  ,simpleTitleCaseMapping:0x12007
 },
 { code:0x12008
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12008
  ,simpleLowerCaseMapping:0x12008
  ,simpleTitleCaseMapping:0x12008
 },
 { code:0x12009
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12009
  ,simpleLowerCaseMapping:0x12009
  ,simpleTitleCaseMapping:0x12009
 },
 { code:0x1200A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1200A
  ,simpleLowerCaseMapping:0x1200A
  ,simpleTitleCaseMapping:0x1200A
 },
 { code:0x1200B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1200B
  ,simpleLowerCaseMapping:0x1200B
  ,simpleTitleCaseMapping:0x1200B
 },
 { code:0x1200C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1200C
  ,simpleLowerCaseMapping:0x1200C
  ,simpleTitleCaseMapping:0x1200C
 },
 { code:0x1200D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1200D
  ,simpleLowerCaseMapping:0x1200D
  ,simpleTitleCaseMapping:0x1200D
 },
 { code:0x1200E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1200E
  ,simpleLowerCaseMapping:0x1200E
  ,simpleTitleCaseMapping:0x1200E
 },
 { code:0x1200F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1200F
  ,simpleLowerCaseMapping:0x1200F
  ,simpleTitleCaseMapping:0x1200F
 },
 { code:0x12010
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12010
  ,simpleLowerCaseMapping:0x12010
  ,simpleTitleCaseMapping:0x12010
 },
 { code:0x12011
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12011
  ,simpleLowerCaseMapping:0x12011
  ,simpleTitleCaseMapping:0x12011
 },
 { code:0x12012
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12012
  ,simpleLowerCaseMapping:0x12012
  ,simpleTitleCaseMapping:0x12012
 },
 { code:0x12013
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12013
  ,simpleLowerCaseMapping:0x12013
  ,simpleTitleCaseMapping:0x12013
 },
 { code:0x12014
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12014
  ,simpleLowerCaseMapping:0x12014
  ,simpleTitleCaseMapping:0x12014
 },
 { code:0x12015
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12015
  ,simpleLowerCaseMapping:0x12015
  ,simpleTitleCaseMapping:0x12015
 },
 { code:0x12016
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12016
  ,simpleLowerCaseMapping:0x12016
  ,simpleTitleCaseMapping:0x12016
 },
 { code:0x12017
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12017
  ,simpleLowerCaseMapping:0x12017
  ,simpleTitleCaseMapping:0x12017
 },
 { code:0x12018
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12018
  ,simpleLowerCaseMapping:0x12018
  ,simpleTitleCaseMapping:0x12018
 },
 { code:0x12019
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12019
  ,simpleLowerCaseMapping:0x12019
  ,simpleTitleCaseMapping:0x12019
 },
 { code:0x1201A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1201A
  ,simpleLowerCaseMapping:0x1201A
  ,simpleTitleCaseMapping:0x1201A
 },
 { code:0x1201B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1201B
  ,simpleLowerCaseMapping:0x1201B
  ,simpleTitleCaseMapping:0x1201B
 },
 { code:0x1201C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1201C
  ,simpleLowerCaseMapping:0x1201C
  ,simpleTitleCaseMapping:0x1201C
 },
 { code:0x1201D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1201D
  ,simpleLowerCaseMapping:0x1201D
  ,simpleTitleCaseMapping:0x1201D
 },
 { code:0x1201E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1201E
  ,simpleLowerCaseMapping:0x1201E
  ,simpleTitleCaseMapping:0x1201E
 },
 { code:0x1201F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1201F
  ,simpleLowerCaseMapping:0x1201F
  ,simpleTitleCaseMapping:0x1201F
 },
 { code:0x12020
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12020
  ,simpleLowerCaseMapping:0x12020
  ,simpleTitleCaseMapping:0x12020
 },
 { code:0x12021
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12021
  ,simpleLowerCaseMapping:0x12021
  ,simpleTitleCaseMapping:0x12021
 },
 { code:0x12022
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12022
  ,simpleLowerCaseMapping:0x12022
  ,simpleTitleCaseMapping:0x12022
 },
 { code:0x12023
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12023
  ,simpleLowerCaseMapping:0x12023
  ,simpleTitleCaseMapping:0x12023
 },
 { code:0x12024
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12024
  ,simpleLowerCaseMapping:0x12024
  ,simpleTitleCaseMapping:0x12024
 },
 { code:0x12025
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12025
  ,simpleLowerCaseMapping:0x12025
  ,simpleTitleCaseMapping:0x12025
 },
 { code:0x12026
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12026
  ,simpleLowerCaseMapping:0x12026
  ,simpleTitleCaseMapping:0x12026
 },
 { code:0x12027
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12027
  ,simpleLowerCaseMapping:0x12027
  ,simpleTitleCaseMapping:0x12027
 },
 { code:0x12028
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12028
  ,simpleLowerCaseMapping:0x12028
  ,simpleTitleCaseMapping:0x12028
 },
 { code:0x12029
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12029
  ,simpleLowerCaseMapping:0x12029
  ,simpleTitleCaseMapping:0x12029
 },
 { code:0x1202A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1202A
  ,simpleLowerCaseMapping:0x1202A
  ,simpleTitleCaseMapping:0x1202A
 },
 { code:0x1202B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1202B
  ,simpleLowerCaseMapping:0x1202B
  ,simpleTitleCaseMapping:0x1202B
 },
 { code:0x1202C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1202C
  ,simpleLowerCaseMapping:0x1202C
  ,simpleTitleCaseMapping:0x1202C
 },
 { code:0x1202D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1202D
  ,simpleLowerCaseMapping:0x1202D
  ,simpleTitleCaseMapping:0x1202D
 },
 { code:0x1202E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1202E
  ,simpleLowerCaseMapping:0x1202E
  ,simpleTitleCaseMapping:0x1202E
 },
 { code:0x1202F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1202F
  ,simpleLowerCaseMapping:0x1202F
  ,simpleTitleCaseMapping:0x1202F
 },
 { code:0x12030
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12030
  ,simpleLowerCaseMapping:0x12030
  ,simpleTitleCaseMapping:0x12030
 },
 { code:0x12031
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12031
  ,simpleLowerCaseMapping:0x12031
  ,simpleTitleCaseMapping:0x12031
 },
 { code:0x12032
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12032
  ,simpleLowerCaseMapping:0x12032
  ,simpleTitleCaseMapping:0x12032
 },
 { code:0x12033
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12033
  ,simpleLowerCaseMapping:0x12033
  ,simpleTitleCaseMapping:0x12033
 },
 { code:0x12034
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12034
  ,simpleLowerCaseMapping:0x12034
  ,simpleTitleCaseMapping:0x12034
 },
 { code:0x12035
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12035
  ,simpleLowerCaseMapping:0x12035
  ,simpleTitleCaseMapping:0x12035
 },
 { code:0x12036
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12036
  ,simpleLowerCaseMapping:0x12036
  ,simpleTitleCaseMapping:0x12036
 },
 { code:0x12037
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12037
  ,simpleLowerCaseMapping:0x12037
  ,simpleTitleCaseMapping:0x12037
 },
 { code:0x12038
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12038
  ,simpleLowerCaseMapping:0x12038
  ,simpleTitleCaseMapping:0x12038
 },
 { code:0x12039
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12039
  ,simpleLowerCaseMapping:0x12039
  ,simpleTitleCaseMapping:0x12039
 },
 { code:0x1203A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1203A
  ,simpleLowerCaseMapping:0x1203A
  ,simpleTitleCaseMapping:0x1203A
 },
 { code:0x1203B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1203B
  ,simpleLowerCaseMapping:0x1203B
  ,simpleTitleCaseMapping:0x1203B
 },
 { code:0x1203C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1203C
  ,simpleLowerCaseMapping:0x1203C
  ,simpleTitleCaseMapping:0x1203C
 },
 { code:0x1203D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1203D
  ,simpleLowerCaseMapping:0x1203D
  ,simpleTitleCaseMapping:0x1203D
 },
 { code:0x1203E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1203E
  ,simpleLowerCaseMapping:0x1203E
  ,simpleTitleCaseMapping:0x1203E
 },
 { code:0x1203F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1203F
  ,simpleLowerCaseMapping:0x1203F
  ,simpleTitleCaseMapping:0x1203F
 },
 { code:0x12040
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12040
  ,simpleLowerCaseMapping:0x12040
  ,simpleTitleCaseMapping:0x12040
 },
 { code:0x12041
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12041
  ,simpleLowerCaseMapping:0x12041
  ,simpleTitleCaseMapping:0x12041
 },
 { code:0x12042
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12042
  ,simpleLowerCaseMapping:0x12042
  ,simpleTitleCaseMapping:0x12042
 },
 { code:0x12043
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12043
  ,simpleLowerCaseMapping:0x12043
  ,simpleTitleCaseMapping:0x12043
 },
 { code:0x12044
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12044
  ,simpleLowerCaseMapping:0x12044
  ,simpleTitleCaseMapping:0x12044
 },
 { code:0x12045
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12045
  ,simpleLowerCaseMapping:0x12045
  ,simpleTitleCaseMapping:0x12045
 },
 { code:0x12046
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12046
  ,simpleLowerCaseMapping:0x12046
  ,simpleTitleCaseMapping:0x12046
 },
 { code:0x12047
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12047
  ,simpleLowerCaseMapping:0x12047
  ,simpleTitleCaseMapping:0x12047
 },
 { code:0x12048
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12048
  ,simpleLowerCaseMapping:0x12048
  ,simpleTitleCaseMapping:0x12048
 },
 { code:0x12049
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12049
  ,simpleLowerCaseMapping:0x12049
  ,simpleTitleCaseMapping:0x12049
 },
 { code:0x1204A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1204A
  ,simpleLowerCaseMapping:0x1204A
  ,simpleTitleCaseMapping:0x1204A
 },
 { code:0x1204B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1204B
  ,simpleLowerCaseMapping:0x1204B
  ,simpleTitleCaseMapping:0x1204B
 },
 { code:0x1204C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1204C
  ,simpleLowerCaseMapping:0x1204C
  ,simpleTitleCaseMapping:0x1204C
 },
 { code:0x1204D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1204D
  ,simpleLowerCaseMapping:0x1204D
  ,simpleTitleCaseMapping:0x1204D
 },
 { code:0x1204E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1204E
  ,simpleLowerCaseMapping:0x1204E
  ,simpleTitleCaseMapping:0x1204E
 },
 { code:0x1204F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1204F
  ,simpleLowerCaseMapping:0x1204F
  ,simpleTitleCaseMapping:0x1204F
 },
 { code:0x12050
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12050
  ,simpleLowerCaseMapping:0x12050
  ,simpleTitleCaseMapping:0x12050
 },
 { code:0x12051
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12051
  ,simpleLowerCaseMapping:0x12051
  ,simpleTitleCaseMapping:0x12051
 },
 { code:0x12052
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12052
  ,simpleLowerCaseMapping:0x12052
  ,simpleTitleCaseMapping:0x12052
 },
 { code:0x12053
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12053
  ,simpleLowerCaseMapping:0x12053
  ,simpleTitleCaseMapping:0x12053
 },
 { code:0x12054
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12054
  ,simpleLowerCaseMapping:0x12054
  ,simpleTitleCaseMapping:0x12054
 },
 { code:0x12055
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12055
  ,simpleLowerCaseMapping:0x12055
  ,simpleTitleCaseMapping:0x12055
 },
 { code:0x12056
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12056
  ,simpleLowerCaseMapping:0x12056
  ,simpleTitleCaseMapping:0x12056
 },
 { code:0x12057
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12057
  ,simpleLowerCaseMapping:0x12057
  ,simpleTitleCaseMapping:0x12057
 },
 { code:0x12058
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12058
  ,simpleLowerCaseMapping:0x12058
  ,simpleTitleCaseMapping:0x12058
 },
 { code:0x12059
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12059
  ,simpleLowerCaseMapping:0x12059
  ,simpleTitleCaseMapping:0x12059
 },
 { code:0x1205A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1205A
  ,simpleLowerCaseMapping:0x1205A
  ,simpleTitleCaseMapping:0x1205A
 },
 { code:0x1205B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1205B
  ,simpleLowerCaseMapping:0x1205B
  ,simpleTitleCaseMapping:0x1205B
 },
 { code:0x1205C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1205C
  ,simpleLowerCaseMapping:0x1205C
  ,simpleTitleCaseMapping:0x1205C
 },
 { code:0x1205D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1205D
  ,simpleLowerCaseMapping:0x1205D
  ,simpleTitleCaseMapping:0x1205D
 },
 { code:0x1205E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1205E
  ,simpleLowerCaseMapping:0x1205E
  ,simpleTitleCaseMapping:0x1205E
 },
 { code:0x1205F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1205F
  ,simpleLowerCaseMapping:0x1205F
  ,simpleTitleCaseMapping:0x1205F
 },
 { code:0x12060
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12060
  ,simpleLowerCaseMapping:0x12060
  ,simpleTitleCaseMapping:0x12060
 },
 { code:0x12061
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12061
  ,simpleLowerCaseMapping:0x12061
  ,simpleTitleCaseMapping:0x12061
 },
 { code:0x12062
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12062
  ,simpleLowerCaseMapping:0x12062
  ,simpleTitleCaseMapping:0x12062
 },
 { code:0x12063
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12063
  ,simpleLowerCaseMapping:0x12063
  ,simpleTitleCaseMapping:0x12063
 },
 { code:0x12064
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12064
  ,simpleLowerCaseMapping:0x12064
  ,simpleTitleCaseMapping:0x12064
 },
 { code:0x12065
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12065
  ,simpleLowerCaseMapping:0x12065
  ,simpleTitleCaseMapping:0x12065
 },
 { code:0x12066
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12066
  ,simpleLowerCaseMapping:0x12066
  ,simpleTitleCaseMapping:0x12066
 },
 { code:0x12067
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12067
  ,simpleLowerCaseMapping:0x12067
  ,simpleTitleCaseMapping:0x12067
 },
 { code:0x12068
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12068
  ,simpleLowerCaseMapping:0x12068
  ,simpleTitleCaseMapping:0x12068
 },
 { code:0x12069
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12069
  ,simpleLowerCaseMapping:0x12069
  ,simpleTitleCaseMapping:0x12069
 },
 { code:0x1206A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1206A
  ,simpleLowerCaseMapping:0x1206A
  ,simpleTitleCaseMapping:0x1206A
 },
 { code:0x1206B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1206B
  ,simpleLowerCaseMapping:0x1206B
  ,simpleTitleCaseMapping:0x1206B
 },
 { code:0x1206C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1206C
  ,simpleLowerCaseMapping:0x1206C
  ,simpleTitleCaseMapping:0x1206C
 },
 { code:0x1206D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1206D
  ,simpleLowerCaseMapping:0x1206D
  ,simpleTitleCaseMapping:0x1206D
 },
 { code:0x1206E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1206E
  ,simpleLowerCaseMapping:0x1206E
  ,simpleTitleCaseMapping:0x1206E
 },
 { code:0x1206F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1206F
  ,simpleLowerCaseMapping:0x1206F
  ,simpleTitleCaseMapping:0x1206F
 },
 { code:0x12070
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12070
  ,simpleLowerCaseMapping:0x12070
  ,simpleTitleCaseMapping:0x12070
 },
 { code:0x12071
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12071
  ,simpleLowerCaseMapping:0x12071
  ,simpleTitleCaseMapping:0x12071
 },
 { code:0x12072
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12072
  ,simpleLowerCaseMapping:0x12072
  ,simpleTitleCaseMapping:0x12072
 },
 { code:0x12073
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12073
  ,simpleLowerCaseMapping:0x12073
  ,simpleTitleCaseMapping:0x12073
 },
 { code:0x12074
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12074
  ,simpleLowerCaseMapping:0x12074
  ,simpleTitleCaseMapping:0x12074
 },
 { code:0x12075
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12075
  ,simpleLowerCaseMapping:0x12075
  ,simpleTitleCaseMapping:0x12075
 },
 { code:0x12076
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12076
  ,simpleLowerCaseMapping:0x12076
  ,simpleTitleCaseMapping:0x12076
 },
 { code:0x12077
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12077
  ,simpleLowerCaseMapping:0x12077
  ,simpleTitleCaseMapping:0x12077
 },
 { code:0x12078
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12078
  ,simpleLowerCaseMapping:0x12078
  ,simpleTitleCaseMapping:0x12078
 },
 { code:0x12079
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12079
  ,simpleLowerCaseMapping:0x12079
  ,simpleTitleCaseMapping:0x12079
 },
 { code:0x1207A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1207A
  ,simpleLowerCaseMapping:0x1207A
  ,simpleTitleCaseMapping:0x1207A
 },
 { code:0x1207B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1207B
  ,simpleLowerCaseMapping:0x1207B
  ,simpleTitleCaseMapping:0x1207B
 },
 { code:0x1207C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1207C
  ,simpleLowerCaseMapping:0x1207C
  ,simpleTitleCaseMapping:0x1207C
 },
 { code:0x1207D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1207D
  ,simpleLowerCaseMapping:0x1207D
  ,simpleTitleCaseMapping:0x1207D
 },
 { code:0x1207E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1207E
  ,simpleLowerCaseMapping:0x1207E
  ,simpleTitleCaseMapping:0x1207E
 },
 { code:0x1207F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1207F
  ,simpleLowerCaseMapping:0x1207F
  ,simpleTitleCaseMapping:0x1207F
 },
 { code:0x12080
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12080
  ,simpleLowerCaseMapping:0x12080
  ,simpleTitleCaseMapping:0x12080
 },
 { code:0x12081
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12081
  ,simpleLowerCaseMapping:0x12081
  ,simpleTitleCaseMapping:0x12081
 },
 { code:0x12082
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12082
  ,simpleLowerCaseMapping:0x12082
  ,simpleTitleCaseMapping:0x12082
 },
 { code:0x12083
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12083
  ,simpleLowerCaseMapping:0x12083
  ,simpleTitleCaseMapping:0x12083
 },
 { code:0x12084
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12084
  ,simpleLowerCaseMapping:0x12084
  ,simpleTitleCaseMapping:0x12084
 },
 { code:0x12085
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12085
  ,simpleLowerCaseMapping:0x12085
  ,simpleTitleCaseMapping:0x12085
 },
 { code:0x12086
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12086
  ,simpleLowerCaseMapping:0x12086
  ,simpleTitleCaseMapping:0x12086
 },
 { code:0x12087
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12087
  ,simpleLowerCaseMapping:0x12087
  ,simpleTitleCaseMapping:0x12087
 },
 { code:0x12088
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12088
  ,simpleLowerCaseMapping:0x12088
  ,simpleTitleCaseMapping:0x12088
 },
 { code:0x12089
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12089
  ,simpleLowerCaseMapping:0x12089
  ,simpleTitleCaseMapping:0x12089
 },
 { code:0x1208A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1208A
  ,simpleLowerCaseMapping:0x1208A
  ,simpleTitleCaseMapping:0x1208A
 },
 { code:0x1208B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1208B
  ,simpleLowerCaseMapping:0x1208B
  ,simpleTitleCaseMapping:0x1208B
 },
 { code:0x1208C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1208C
  ,simpleLowerCaseMapping:0x1208C
  ,simpleTitleCaseMapping:0x1208C
 },
 { code:0x1208D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1208D
  ,simpleLowerCaseMapping:0x1208D
  ,simpleTitleCaseMapping:0x1208D
 },
 { code:0x1208E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1208E
  ,simpleLowerCaseMapping:0x1208E
  ,simpleTitleCaseMapping:0x1208E
 },
 { code:0x1208F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1208F
  ,simpleLowerCaseMapping:0x1208F
  ,simpleTitleCaseMapping:0x1208F
 },
 { code:0x12090
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12090
  ,simpleLowerCaseMapping:0x12090
  ,simpleTitleCaseMapping:0x12090
 },
 { code:0x12091
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12091
  ,simpleLowerCaseMapping:0x12091
  ,simpleTitleCaseMapping:0x12091
 },
 { code:0x12092
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12092
  ,simpleLowerCaseMapping:0x12092
  ,simpleTitleCaseMapping:0x12092
 },
 { code:0x12093
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12093
  ,simpleLowerCaseMapping:0x12093
  ,simpleTitleCaseMapping:0x12093
 },
 { code:0x12094
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12094
  ,simpleLowerCaseMapping:0x12094
  ,simpleTitleCaseMapping:0x12094
 },
 { code:0x12095
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12095
  ,simpleLowerCaseMapping:0x12095
  ,simpleTitleCaseMapping:0x12095
 },
 { code:0x12096
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12096
  ,simpleLowerCaseMapping:0x12096
  ,simpleTitleCaseMapping:0x12096
 },
 { code:0x12097
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12097
  ,simpleLowerCaseMapping:0x12097
  ,simpleTitleCaseMapping:0x12097
 },
 { code:0x12098
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12098
  ,simpleLowerCaseMapping:0x12098
  ,simpleTitleCaseMapping:0x12098
 },
 { code:0x12099
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12099
  ,simpleLowerCaseMapping:0x12099
  ,simpleTitleCaseMapping:0x12099
 },
 { code:0x1209A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1209A
  ,simpleLowerCaseMapping:0x1209A
  ,simpleTitleCaseMapping:0x1209A
 },
 { code:0x1209B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1209B
  ,simpleLowerCaseMapping:0x1209B
  ,simpleTitleCaseMapping:0x1209B
 },
 { code:0x1209C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1209C
  ,simpleLowerCaseMapping:0x1209C
  ,simpleTitleCaseMapping:0x1209C
 },
 { code:0x1209D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1209D
  ,simpleLowerCaseMapping:0x1209D
  ,simpleTitleCaseMapping:0x1209D
 },
 { code:0x1209E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1209E
  ,simpleLowerCaseMapping:0x1209E
  ,simpleTitleCaseMapping:0x1209E
 },
 { code:0x1209F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1209F
  ,simpleLowerCaseMapping:0x1209F
  ,simpleTitleCaseMapping:0x1209F
 },
 { code:0x120A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120A0
  ,simpleLowerCaseMapping:0x120A0
  ,simpleTitleCaseMapping:0x120A0
 },
 { code:0x120A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120A1
  ,simpleLowerCaseMapping:0x120A1
  ,simpleTitleCaseMapping:0x120A1
 },
 { code:0x120A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120A2
  ,simpleLowerCaseMapping:0x120A2
  ,simpleTitleCaseMapping:0x120A2
 },
 { code:0x120A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120A3
  ,simpleLowerCaseMapping:0x120A3
  ,simpleTitleCaseMapping:0x120A3
 },
 { code:0x120A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120A4
  ,simpleLowerCaseMapping:0x120A4
  ,simpleTitleCaseMapping:0x120A4
 },
 { code:0x120A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120A5
  ,simpleLowerCaseMapping:0x120A5
  ,simpleTitleCaseMapping:0x120A5
 },
 { code:0x120A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120A6
  ,simpleLowerCaseMapping:0x120A6
  ,simpleTitleCaseMapping:0x120A6
 },
 { code:0x120A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120A7
  ,simpleLowerCaseMapping:0x120A7
  ,simpleTitleCaseMapping:0x120A7
 },
 { code:0x120A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120A8
  ,simpleLowerCaseMapping:0x120A8
  ,simpleTitleCaseMapping:0x120A8
 },
 { code:0x120A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120A9
  ,simpleLowerCaseMapping:0x120A9
  ,simpleTitleCaseMapping:0x120A9
 },
 { code:0x120AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120AA
  ,simpleLowerCaseMapping:0x120AA
  ,simpleTitleCaseMapping:0x120AA
 },
 { code:0x120AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120AB
  ,simpleLowerCaseMapping:0x120AB
  ,simpleTitleCaseMapping:0x120AB
 },
 { code:0x120AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120AC
  ,simpleLowerCaseMapping:0x120AC
  ,simpleTitleCaseMapping:0x120AC
 },
 { code:0x120AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120AD
  ,simpleLowerCaseMapping:0x120AD
  ,simpleTitleCaseMapping:0x120AD
 },
 { code:0x120AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120AE
  ,simpleLowerCaseMapping:0x120AE
  ,simpleTitleCaseMapping:0x120AE
 },
 { code:0x120AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120AF
  ,simpleLowerCaseMapping:0x120AF
  ,simpleTitleCaseMapping:0x120AF
 },
 { code:0x120B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120B0
  ,simpleLowerCaseMapping:0x120B0
  ,simpleTitleCaseMapping:0x120B0
 },
 { code:0x120B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120B1
  ,simpleLowerCaseMapping:0x120B1
  ,simpleTitleCaseMapping:0x120B1
 },
 { code:0x120B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120B2
  ,simpleLowerCaseMapping:0x120B2
  ,simpleTitleCaseMapping:0x120B2
 },
 { code:0x120B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120B3
  ,simpleLowerCaseMapping:0x120B3
  ,simpleTitleCaseMapping:0x120B3
 },
 { code:0x120B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120B4
  ,simpleLowerCaseMapping:0x120B4
  ,simpleTitleCaseMapping:0x120B4
 },
 { code:0x120B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120B5
  ,simpleLowerCaseMapping:0x120B5
  ,simpleTitleCaseMapping:0x120B5
 },
 { code:0x120B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120B6
  ,simpleLowerCaseMapping:0x120B6
  ,simpleTitleCaseMapping:0x120B6
 },
 { code:0x120B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120B7
  ,simpleLowerCaseMapping:0x120B7
  ,simpleTitleCaseMapping:0x120B7
 },
 { code:0x120B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120B8
  ,simpleLowerCaseMapping:0x120B8
  ,simpleTitleCaseMapping:0x120B8
 },
 { code:0x120B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120B9
  ,simpleLowerCaseMapping:0x120B9
  ,simpleTitleCaseMapping:0x120B9
 },
 { code:0x120BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120BA
  ,simpleLowerCaseMapping:0x120BA
  ,simpleTitleCaseMapping:0x120BA
 },
 { code:0x120BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120BB
  ,simpleLowerCaseMapping:0x120BB
  ,simpleTitleCaseMapping:0x120BB
 },
 { code:0x120BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120BC
  ,simpleLowerCaseMapping:0x120BC
  ,simpleTitleCaseMapping:0x120BC
 },
 { code:0x120BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120BD
  ,simpleLowerCaseMapping:0x120BD
  ,simpleTitleCaseMapping:0x120BD
 },
 { code:0x120BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120BE
  ,simpleLowerCaseMapping:0x120BE
  ,simpleTitleCaseMapping:0x120BE
 },
 { code:0x120BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120BF
  ,simpleLowerCaseMapping:0x120BF
  ,simpleTitleCaseMapping:0x120BF
 },
 { code:0x120C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120C0
  ,simpleLowerCaseMapping:0x120C0
  ,simpleTitleCaseMapping:0x120C0
 },
 { code:0x120C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120C1
  ,simpleLowerCaseMapping:0x120C1
  ,simpleTitleCaseMapping:0x120C1
 },
 { code:0x120C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120C2
  ,simpleLowerCaseMapping:0x120C2
  ,simpleTitleCaseMapping:0x120C2
 },
 { code:0x120C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120C3
  ,simpleLowerCaseMapping:0x120C3
  ,simpleTitleCaseMapping:0x120C3
 },
 { code:0x120C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120C4
  ,simpleLowerCaseMapping:0x120C4
  ,simpleTitleCaseMapping:0x120C4
 },
 { code:0x120C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120C5
  ,simpleLowerCaseMapping:0x120C5
  ,simpleTitleCaseMapping:0x120C5
 },
 { code:0x120C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120C6
  ,simpleLowerCaseMapping:0x120C6
  ,simpleTitleCaseMapping:0x120C6
 },
 { code:0x120C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120C7
  ,simpleLowerCaseMapping:0x120C7
  ,simpleTitleCaseMapping:0x120C7
 },
 { code:0x120C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120C8
  ,simpleLowerCaseMapping:0x120C8
  ,simpleTitleCaseMapping:0x120C8
 },
 { code:0x120C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120C9
  ,simpleLowerCaseMapping:0x120C9
  ,simpleTitleCaseMapping:0x120C9
 },
 { code:0x120CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120CA
  ,simpleLowerCaseMapping:0x120CA
  ,simpleTitleCaseMapping:0x120CA
 },
 { code:0x120CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120CB
  ,simpleLowerCaseMapping:0x120CB
  ,simpleTitleCaseMapping:0x120CB
 },
 { code:0x120CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120CC
  ,simpleLowerCaseMapping:0x120CC
  ,simpleTitleCaseMapping:0x120CC
 },
 { code:0x120CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120CD
  ,simpleLowerCaseMapping:0x120CD
  ,simpleTitleCaseMapping:0x120CD
 },
 { code:0x120CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120CE
  ,simpleLowerCaseMapping:0x120CE
  ,simpleTitleCaseMapping:0x120CE
 },
 { code:0x120CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120CF
  ,simpleLowerCaseMapping:0x120CF
  ,simpleTitleCaseMapping:0x120CF
 },
 { code:0x120D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120D0
  ,simpleLowerCaseMapping:0x120D0
  ,simpleTitleCaseMapping:0x120D0
 },
 { code:0x120D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120D1
  ,simpleLowerCaseMapping:0x120D1
  ,simpleTitleCaseMapping:0x120D1
 },
 { code:0x120D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120D2
  ,simpleLowerCaseMapping:0x120D2
  ,simpleTitleCaseMapping:0x120D2
 },
 { code:0x120D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120D3
  ,simpleLowerCaseMapping:0x120D3
  ,simpleTitleCaseMapping:0x120D3
 },
 { code:0x120D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120D4
  ,simpleLowerCaseMapping:0x120D4
  ,simpleTitleCaseMapping:0x120D4
 },
 { code:0x120D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120D5
  ,simpleLowerCaseMapping:0x120D5
  ,simpleTitleCaseMapping:0x120D5
 },
 { code:0x120D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120D6
  ,simpleLowerCaseMapping:0x120D6
  ,simpleTitleCaseMapping:0x120D6
 },
 { code:0x120D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120D7
  ,simpleLowerCaseMapping:0x120D7
  ,simpleTitleCaseMapping:0x120D7
 },
 { code:0x120D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120D8
  ,simpleLowerCaseMapping:0x120D8
  ,simpleTitleCaseMapping:0x120D8
 },
 { code:0x120D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120D9
  ,simpleLowerCaseMapping:0x120D9
  ,simpleTitleCaseMapping:0x120D9
 },
 { code:0x120DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120DA
  ,simpleLowerCaseMapping:0x120DA
  ,simpleTitleCaseMapping:0x120DA
 },
 { code:0x120DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120DB
  ,simpleLowerCaseMapping:0x120DB
  ,simpleTitleCaseMapping:0x120DB
 },
 { code:0x120DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120DC
  ,simpleLowerCaseMapping:0x120DC
  ,simpleTitleCaseMapping:0x120DC
 },
 { code:0x120DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120DD
  ,simpleLowerCaseMapping:0x120DD
  ,simpleTitleCaseMapping:0x120DD
 },
 { code:0x120DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120DE
  ,simpleLowerCaseMapping:0x120DE
  ,simpleTitleCaseMapping:0x120DE
 },
 { code:0x120DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120DF
  ,simpleLowerCaseMapping:0x120DF
  ,simpleTitleCaseMapping:0x120DF
 },
 { code:0x120E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120E0
  ,simpleLowerCaseMapping:0x120E0
  ,simpleTitleCaseMapping:0x120E0
 },
 { code:0x120E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120E1
  ,simpleLowerCaseMapping:0x120E1
  ,simpleTitleCaseMapping:0x120E1
 },
 { code:0x120E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120E2
  ,simpleLowerCaseMapping:0x120E2
  ,simpleTitleCaseMapping:0x120E2
 },
 { code:0x120E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120E3
  ,simpleLowerCaseMapping:0x120E3
  ,simpleTitleCaseMapping:0x120E3
 },
 { code:0x120E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120E4
  ,simpleLowerCaseMapping:0x120E4
  ,simpleTitleCaseMapping:0x120E4
 },
 { code:0x120E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120E5
  ,simpleLowerCaseMapping:0x120E5
  ,simpleTitleCaseMapping:0x120E5
 },
 { code:0x120E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120E6
  ,simpleLowerCaseMapping:0x120E6
  ,simpleTitleCaseMapping:0x120E6
 },
 { code:0x120E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120E7
  ,simpleLowerCaseMapping:0x120E7
  ,simpleTitleCaseMapping:0x120E7
 },
 { code:0x120E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120E8
  ,simpleLowerCaseMapping:0x120E8
  ,simpleTitleCaseMapping:0x120E8
 },
 { code:0x120E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120E9
  ,simpleLowerCaseMapping:0x120E9
  ,simpleTitleCaseMapping:0x120E9
 },
 { code:0x120EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120EA
  ,simpleLowerCaseMapping:0x120EA
  ,simpleTitleCaseMapping:0x120EA
 },
 { code:0x120EB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120EB
  ,simpleLowerCaseMapping:0x120EB
  ,simpleTitleCaseMapping:0x120EB
 },
 { code:0x120EC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120EC
  ,simpleLowerCaseMapping:0x120EC
  ,simpleTitleCaseMapping:0x120EC
 },
 { code:0x120ED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120ED
  ,simpleLowerCaseMapping:0x120ED
  ,simpleTitleCaseMapping:0x120ED
 },
 { code:0x120EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120EE
  ,simpleLowerCaseMapping:0x120EE
  ,simpleTitleCaseMapping:0x120EE
 },
 { code:0x120EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120EF
  ,simpleLowerCaseMapping:0x120EF
  ,simpleTitleCaseMapping:0x120EF
 },
 { code:0x120F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120F0
  ,simpleLowerCaseMapping:0x120F0
  ,simpleTitleCaseMapping:0x120F0
 },
 { code:0x120F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120F1
  ,simpleLowerCaseMapping:0x120F1
  ,simpleTitleCaseMapping:0x120F1
 },
 { code:0x120F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120F2
  ,simpleLowerCaseMapping:0x120F2
  ,simpleTitleCaseMapping:0x120F2
 },
 { code:0x120F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120F3
  ,simpleLowerCaseMapping:0x120F3
  ,simpleTitleCaseMapping:0x120F3
 },
 { code:0x120F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120F4
  ,simpleLowerCaseMapping:0x120F4
  ,simpleTitleCaseMapping:0x120F4
 },
 { code:0x120F5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120F5
  ,simpleLowerCaseMapping:0x120F5
  ,simpleTitleCaseMapping:0x120F5
 },
 { code:0x120F6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120F6
  ,simpleLowerCaseMapping:0x120F6
  ,simpleTitleCaseMapping:0x120F6
 },
 { code:0x120F7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120F7
  ,simpleLowerCaseMapping:0x120F7
  ,simpleTitleCaseMapping:0x120F7
 },
 { code:0x120F8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120F8
  ,simpleLowerCaseMapping:0x120F8
  ,simpleTitleCaseMapping:0x120F8
 },
 { code:0x120F9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120F9
  ,simpleLowerCaseMapping:0x120F9
  ,simpleTitleCaseMapping:0x120F9
 },
 { code:0x120FA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120FA
  ,simpleLowerCaseMapping:0x120FA
  ,simpleTitleCaseMapping:0x120FA
 },
 { code:0x120FB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120FB
  ,simpleLowerCaseMapping:0x120FB
  ,simpleTitleCaseMapping:0x120FB
 },
 { code:0x120FC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120FC
  ,simpleLowerCaseMapping:0x120FC
  ,simpleTitleCaseMapping:0x120FC
 },
 { code:0x120FD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120FD
  ,simpleLowerCaseMapping:0x120FD
  ,simpleTitleCaseMapping:0x120FD
 },
 { code:0x120FE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120FE
  ,simpleLowerCaseMapping:0x120FE
  ,simpleTitleCaseMapping:0x120FE
 },
 { code:0x120FF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x120FF
  ,simpleLowerCaseMapping:0x120FF
  ,simpleTitleCaseMapping:0x120FF
 },
 { code:0x12100
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12100
  ,simpleLowerCaseMapping:0x12100
  ,simpleTitleCaseMapping:0x12100
 },
 { code:0x12101
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12101
  ,simpleLowerCaseMapping:0x12101
  ,simpleTitleCaseMapping:0x12101
 },
 { code:0x12102
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12102
  ,simpleLowerCaseMapping:0x12102
  ,simpleTitleCaseMapping:0x12102
 },
 { code:0x12103
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12103
  ,simpleLowerCaseMapping:0x12103
  ,simpleTitleCaseMapping:0x12103
 },
 { code:0x12104
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12104
  ,simpleLowerCaseMapping:0x12104
  ,simpleTitleCaseMapping:0x12104
 },
 { code:0x12105
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12105
  ,simpleLowerCaseMapping:0x12105
  ,simpleTitleCaseMapping:0x12105
 },
 { code:0x12106
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12106
  ,simpleLowerCaseMapping:0x12106
  ,simpleTitleCaseMapping:0x12106
 },
 { code:0x12107
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12107
  ,simpleLowerCaseMapping:0x12107
  ,simpleTitleCaseMapping:0x12107
 },
 { code:0x12108
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12108
  ,simpleLowerCaseMapping:0x12108
  ,simpleTitleCaseMapping:0x12108
 },
 { code:0x12109
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12109
  ,simpleLowerCaseMapping:0x12109
  ,simpleTitleCaseMapping:0x12109
 },
 { code:0x1210A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1210A
  ,simpleLowerCaseMapping:0x1210A
  ,simpleTitleCaseMapping:0x1210A
 },
 { code:0x1210B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1210B
  ,simpleLowerCaseMapping:0x1210B
  ,simpleTitleCaseMapping:0x1210B
 },
 { code:0x1210C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1210C
  ,simpleLowerCaseMapping:0x1210C
  ,simpleTitleCaseMapping:0x1210C
 },
 { code:0x1210D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1210D
  ,simpleLowerCaseMapping:0x1210D
  ,simpleTitleCaseMapping:0x1210D
 },
 { code:0x1210E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1210E
  ,simpleLowerCaseMapping:0x1210E
  ,simpleTitleCaseMapping:0x1210E
 },
 { code:0x1210F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1210F
  ,simpleLowerCaseMapping:0x1210F
  ,simpleTitleCaseMapping:0x1210F
 },
 { code:0x12110
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12110
  ,simpleLowerCaseMapping:0x12110
  ,simpleTitleCaseMapping:0x12110
 },
 { code:0x12111
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12111
  ,simpleLowerCaseMapping:0x12111
  ,simpleTitleCaseMapping:0x12111
 },
 { code:0x12112
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12112
  ,simpleLowerCaseMapping:0x12112
  ,simpleTitleCaseMapping:0x12112
 },
 { code:0x12113
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12113
  ,simpleLowerCaseMapping:0x12113
  ,simpleTitleCaseMapping:0x12113
 },
 { code:0x12114
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12114
  ,simpleLowerCaseMapping:0x12114
  ,simpleTitleCaseMapping:0x12114
 },
 { code:0x12115
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12115
  ,simpleLowerCaseMapping:0x12115
  ,simpleTitleCaseMapping:0x12115
 },
 { code:0x12116
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12116
  ,simpleLowerCaseMapping:0x12116
  ,simpleTitleCaseMapping:0x12116
 },
 { code:0x12117
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12117
  ,simpleLowerCaseMapping:0x12117
  ,simpleTitleCaseMapping:0x12117
 },
 { code:0x12118
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12118
  ,simpleLowerCaseMapping:0x12118
  ,simpleTitleCaseMapping:0x12118
 },
 { code:0x12119
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12119
  ,simpleLowerCaseMapping:0x12119
  ,simpleTitleCaseMapping:0x12119
 },
 { code:0x1211A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1211A
  ,simpleLowerCaseMapping:0x1211A
  ,simpleTitleCaseMapping:0x1211A
 },
 { code:0x1211B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1211B
  ,simpleLowerCaseMapping:0x1211B
  ,simpleTitleCaseMapping:0x1211B
 },
 { code:0x1211C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1211C
  ,simpleLowerCaseMapping:0x1211C
  ,simpleTitleCaseMapping:0x1211C
 },
 { code:0x1211D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1211D
  ,simpleLowerCaseMapping:0x1211D
  ,simpleTitleCaseMapping:0x1211D
 },
 { code:0x1211E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1211E
  ,simpleLowerCaseMapping:0x1211E
  ,simpleTitleCaseMapping:0x1211E
 },
 { code:0x1211F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1211F
  ,simpleLowerCaseMapping:0x1211F
  ,simpleTitleCaseMapping:0x1211F
 },
 { code:0x12120
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12120
  ,simpleLowerCaseMapping:0x12120
  ,simpleTitleCaseMapping:0x12120
 },
 { code:0x12121
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12121
  ,simpleLowerCaseMapping:0x12121
  ,simpleTitleCaseMapping:0x12121
 },
 { code:0x12122
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12122
  ,simpleLowerCaseMapping:0x12122
  ,simpleTitleCaseMapping:0x12122
 },
 { code:0x12123
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12123
  ,simpleLowerCaseMapping:0x12123
  ,simpleTitleCaseMapping:0x12123
 },
 { code:0x12124
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12124
  ,simpleLowerCaseMapping:0x12124
  ,simpleTitleCaseMapping:0x12124
 },
 { code:0x12125
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12125
  ,simpleLowerCaseMapping:0x12125
  ,simpleTitleCaseMapping:0x12125
 },
 { code:0x12126
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12126
  ,simpleLowerCaseMapping:0x12126
  ,simpleTitleCaseMapping:0x12126
 },
 { code:0x12127
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12127
  ,simpleLowerCaseMapping:0x12127
  ,simpleTitleCaseMapping:0x12127
 },
 { code:0x12128
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12128
  ,simpleLowerCaseMapping:0x12128
  ,simpleTitleCaseMapping:0x12128
 },
 { code:0x12129
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12129
  ,simpleLowerCaseMapping:0x12129
  ,simpleTitleCaseMapping:0x12129
 },
 { code:0x1212A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1212A
  ,simpleLowerCaseMapping:0x1212A
  ,simpleTitleCaseMapping:0x1212A
 },
 { code:0x1212B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1212B
  ,simpleLowerCaseMapping:0x1212B
  ,simpleTitleCaseMapping:0x1212B
 },
 { code:0x1212C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1212C
  ,simpleLowerCaseMapping:0x1212C
  ,simpleTitleCaseMapping:0x1212C
 },
 { code:0x1212D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1212D
  ,simpleLowerCaseMapping:0x1212D
  ,simpleTitleCaseMapping:0x1212D
 },
 { code:0x1212E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1212E
  ,simpleLowerCaseMapping:0x1212E
  ,simpleTitleCaseMapping:0x1212E
 },
 { code:0x1212F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1212F
  ,simpleLowerCaseMapping:0x1212F
  ,simpleTitleCaseMapping:0x1212F
 },
 { code:0x12130
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12130
  ,simpleLowerCaseMapping:0x12130
  ,simpleTitleCaseMapping:0x12130
 },
 { code:0x12131
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12131
  ,simpleLowerCaseMapping:0x12131
  ,simpleTitleCaseMapping:0x12131
 },
 { code:0x12132
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12132
  ,simpleLowerCaseMapping:0x12132
  ,simpleTitleCaseMapping:0x12132
 },
 { code:0x12133
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12133
  ,simpleLowerCaseMapping:0x12133
  ,simpleTitleCaseMapping:0x12133
 },
 { code:0x12134
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12134
  ,simpleLowerCaseMapping:0x12134
  ,simpleTitleCaseMapping:0x12134
 },
 { code:0x12135
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12135
  ,simpleLowerCaseMapping:0x12135
  ,simpleTitleCaseMapping:0x12135
 },
 { code:0x12136
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12136
  ,simpleLowerCaseMapping:0x12136
  ,simpleTitleCaseMapping:0x12136
 },
 { code:0x12137
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12137
  ,simpleLowerCaseMapping:0x12137
  ,simpleTitleCaseMapping:0x12137
 },
 { code:0x12138
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12138
  ,simpleLowerCaseMapping:0x12138
  ,simpleTitleCaseMapping:0x12138
 },
 { code:0x12139
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12139
  ,simpleLowerCaseMapping:0x12139
  ,simpleTitleCaseMapping:0x12139
 },
 { code:0x1213A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1213A
  ,simpleLowerCaseMapping:0x1213A
  ,simpleTitleCaseMapping:0x1213A
 },
 { code:0x1213B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1213B
  ,simpleLowerCaseMapping:0x1213B
  ,simpleTitleCaseMapping:0x1213B
 },
 { code:0x1213C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1213C
  ,simpleLowerCaseMapping:0x1213C
  ,simpleTitleCaseMapping:0x1213C
 },
 { code:0x1213D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1213D
  ,simpleLowerCaseMapping:0x1213D
  ,simpleTitleCaseMapping:0x1213D
 },
 { code:0x1213E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1213E
  ,simpleLowerCaseMapping:0x1213E
  ,simpleTitleCaseMapping:0x1213E
 },
 { code:0x1213F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1213F
  ,simpleLowerCaseMapping:0x1213F
  ,simpleTitleCaseMapping:0x1213F
 },
 { code:0x12140
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12140
  ,simpleLowerCaseMapping:0x12140
  ,simpleTitleCaseMapping:0x12140
 },
 { code:0x12141
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12141
  ,simpleLowerCaseMapping:0x12141
  ,simpleTitleCaseMapping:0x12141
 },
 { code:0x12142
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12142
  ,simpleLowerCaseMapping:0x12142
  ,simpleTitleCaseMapping:0x12142
 },
 { code:0x12143
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12143
  ,simpleLowerCaseMapping:0x12143
  ,simpleTitleCaseMapping:0x12143
 },
 { code:0x12144
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12144
  ,simpleLowerCaseMapping:0x12144
  ,simpleTitleCaseMapping:0x12144
 },
 { code:0x12145
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12145
  ,simpleLowerCaseMapping:0x12145
  ,simpleTitleCaseMapping:0x12145
 },
 { code:0x12146
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12146
  ,simpleLowerCaseMapping:0x12146
  ,simpleTitleCaseMapping:0x12146
 },
 { code:0x12147
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12147
  ,simpleLowerCaseMapping:0x12147
  ,simpleTitleCaseMapping:0x12147
 },
 { code:0x12148
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12148
  ,simpleLowerCaseMapping:0x12148
  ,simpleTitleCaseMapping:0x12148
 },
 { code:0x12149
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12149
  ,simpleLowerCaseMapping:0x12149
  ,simpleTitleCaseMapping:0x12149
 },
 { code:0x1214A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1214A
  ,simpleLowerCaseMapping:0x1214A
  ,simpleTitleCaseMapping:0x1214A
 },
 { code:0x1214B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1214B
  ,simpleLowerCaseMapping:0x1214B
  ,simpleTitleCaseMapping:0x1214B
 },
 { code:0x1214C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1214C
  ,simpleLowerCaseMapping:0x1214C
  ,simpleTitleCaseMapping:0x1214C
 },
 { code:0x1214D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1214D
  ,simpleLowerCaseMapping:0x1214D
  ,simpleTitleCaseMapping:0x1214D
 },
 { code:0x1214E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1214E
  ,simpleLowerCaseMapping:0x1214E
  ,simpleTitleCaseMapping:0x1214E
 },
 { code:0x1214F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1214F
  ,simpleLowerCaseMapping:0x1214F
  ,simpleTitleCaseMapping:0x1214F
 },
 { code:0x12150
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12150
  ,simpleLowerCaseMapping:0x12150
  ,simpleTitleCaseMapping:0x12150
 },
 { code:0x12151
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12151
  ,simpleLowerCaseMapping:0x12151
  ,simpleTitleCaseMapping:0x12151
 },
 { code:0x12152
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12152
  ,simpleLowerCaseMapping:0x12152
  ,simpleTitleCaseMapping:0x12152
 },
 { code:0x12153
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12153
  ,simpleLowerCaseMapping:0x12153
  ,simpleTitleCaseMapping:0x12153
 },
 { code:0x12154
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12154
  ,simpleLowerCaseMapping:0x12154
  ,simpleTitleCaseMapping:0x12154
 },
 { code:0x12155
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12155
  ,simpleLowerCaseMapping:0x12155
  ,simpleTitleCaseMapping:0x12155
 },
 { code:0x12156
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12156
  ,simpleLowerCaseMapping:0x12156
  ,simpleTitleCaseMapping:0x12156
 },
 { code:0x12157
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12157
  ,simpleLowerCaseMapping:0x12157
  ,simpleTitleCaseMapping:0x12157
 },
 { code:0x12158
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12158
  ,simpleLowerCaseMapping:0x12158
  ,simpleTitleCaseMapping:0x12158
 },
 { code:0x12159
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12159
  ,simpleLowerCaseMapping:0x12159
  ,simpleTitleCaseMapping:0x12159
 },
 { code:0x1215A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1215A
  ,simpleLowerCaseMapping:0x1215A
  ,simpleTitleCaseMapping:0x1215A
 },
 { code:0x1215B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1215B
  ,simpleLowerCaseMapping:0x1215B
  ,simpleTitleCaseMapping:0x1215B
 },
 { code:0x1215C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1215C
  ,simpleLowerCaseMapping:0x1215C
  ,simpleTitleCaseMapping:0x1215C
 },
 { code:0x1215D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1215D
  ,simpleLowerCaseMapping:0x1215D
  ,simpleTitleCaseMapping:0x1215D
 },
 { code:0x1215E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1215E
  ,simpleLowerCaseMapping:0x1215E
  ,simpleTitleCaseMapping:0x1215E
 },
 { code:0x1215F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1215F
  ,simpleLowerCaseMapping:0x1215F
  ,simpleTitleCaseMapping:0x1215F
 },
 { code:0x12160
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12160
  ,simpleLowerCaseMapping:0x12160
  ,simpleTitleCaseMapping:0x12160
 },
 { code:0x12161
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12161
  ,simpleLowerCaseMapping:0x12161
  ,simpleTitleCaseMapping:0x12161
 },
 { code:0x12162
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12162
  ,simpleLowerCaseMapping:0x12162
  ,simpleTitleCaseMapping:0x12162
 },
 { code:0x12163
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12163
  ,simpleLowerCaseMapping:0x12163
  ,simpleTitleCaseMapping:0x12163
 },
 { code:0x12164
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12164
  ,simpleLowerCaseMapping:0x12164
  ,simpleTitleCaseMapping:0x12164
 },
 { code:0x12165
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12165
  ,simpleLowerCaseMapping:0x12165
  ,simpleTitleCaseMapping:0x12165
 },
 { code:0x12166
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12166
  ,simpleLowerCaseMapping:0x12166
  ,simpleTitleCaseMapping:0x12166
 },
 { code:0x12167
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12167
  ,simpleLowerCaseMapping:0x12167
  ,simpleTitleCaseMapping:0x12167
 },
 { code:0x12168
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12168
  ,simpleLowerCaseMapping:0x12168
  ,simpleTitleCaseMapping:0x12168
 },
 { code:0x12169
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12169
  ,simpleLowerCaseMapping:0x12169
  ,simpleTitleCaseMapping:0x12169
 },
 { code:0x1216A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1216A
  ,simpleLowerCaseMapping:0x1216A
  ,simpleTitleCaseMapping:0x1216A
 },
 { code:0x1216B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1216B
  ,simpleLowerCaseMapping:0x1216B
  ,simpleTitleCaseMapping:0x1216B
 },
 { code:0x1216C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1216C
  ,simpleLowerCaseMapping:0x1216C
  ,simpleTitleCaseMapping:0x1216C
 },
 { code:0x1216D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1216D
  ,simpleLowerCaseMapping:0x1216D
  ,simpleTitleCaseMapping:0x1216D
 },
 { code:0x1216E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1216E
  ,simpleLowerCaseMapping:0x1216E
  ,simpleTitleCaseMapping:0x1216E
 },
 { code:0x1216F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1216F
  ,simpleLowerCaseMapping:0x1216F
  ,simpleTitleCaseMapping:0x1216F
 },
 { code:0x12170
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12170
  ,simpleLowerCaseMapping:0x12170
  ,simpleTitleCaseMapping:0x12170
 },
 { code:0x12171
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12171
  ,simpleLowerCaseMapping:0x12171
  ,simpleTitleCaseMapping:0x12171
 },
 { code:0x12172
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12172
  ,simpleLowerCaseMapping:0x12172
  ,simpleTitleCaseMapping:0x12172
 },
 { code:0x12173
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12173
  ,simpleLowerCaseMapping:0x12173
  ,simpleTitleCaseMapping:0x12173
 },
 { code:0x12174
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12174
  ,simpleLowerCaseMapping:0x12174
  ,simpleTitleCaseMapping:0x12174
 },
 { code:0x12175
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12175
  ,simpleLowerCaseMapping:0x12175
  ,simpleTitleCaseMapping:0x12175
 },
 { code:0x12176
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12176
  ,simpleLowerCaseMapping:0x12176
  ,simpleTitleCaseMapping:0x12176
 },
 { code:0x12177
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12177
  ,simpleLowerCaseMapping:0x12177
  ,simpleTitleCaseMapping:0x12177
 },
 { code:0x12178
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12178
  ,simpleLowerCaseMapping:0x12178
  ,simpleTitleCaseMapping:0x12178
 },
 { code:0x12179
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12179
  ,simpleLowerCaseMapping:0x12179
  ,simpleTitleCaseMapping:0x12179
 },
 { code:0x1217A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1217A
  ,simpleLowerCaseMapping:0x1217A
  ,simpleTitleCaseMapping:0x1217A
 },
 { code:0x1217B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1217B
  ,simpleLowerCaseMapping:0x1217B
  ,simpleTitleCaseMapping:0x1217B
 },
 { code:0x1217C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1217C
  ,simpleLowerCaseMapping:0x1217C
  ,simpleTitleCaseMapping:0x1217C
 },
 { code:0x1217D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1217D
  ,simpleLowerCaseMapping:0x1217D
  ,simpleTitleCaseMapping:0x1217D
 },
 { code:0x1217E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1217E
  ,simpleLowerCaseMapping:0x1217E
  ,simpleTitleCaseMapping:0x1217E
 },
 { code:0x1217F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1217F
  ,simpleLowerCaseMapping:0x1217F
  ,simpleTitleCaseMapping:0x1217F
 },
 { code:0x12180
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12180
  ,simpleLowerCaseMapping:0x12180
  ,simpleTitleCaseMapping:0x12180
 },
 { code:0x12181
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12181
  ,simpleLowerCaseMapping:0x12181
  ,simpleTitleCaseMapping:0x12181
 },
 { code:0x12182
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12182
  ,simpleLowerCaseMapping:0x12182
  ,simpleTitleCaseMapping:0x12182
 },
 { code:0x12183
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12183
  ,simpleLowerCaseMapping:0x12183
  ,simpleTitleCaseMapping:0x12183
 },
 { code:0x12184
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12184
  ,simpleLowerCaseMapping:0x12184
  ,simpleTitleCaseMapping:0x12184
 },
 { code:0x12185
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12185
  ,simpleLowerCaseMapping:0x12185
  ,simpleTitleCaseMapping:0x12185
 },
 { code:0x12186
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12186
  ,simpleLowerCaseMapping:0x12186
  ,simpleTitleCaseMapping:0x12186
 },
 { code:0x12187
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12187
  ,simpleLowerCaseMapping:0x12187
  ,simpleTitleCaseMapping:0x12187
 },
 { code:0x12188
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12188
  ,simpleLowerCaseMapping:0x12188
  ,simpleTitleCaseMapping:0x12188
 },
 { code:0x12189
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12189
  ,simpleLowerCaseMapping:0x12189
  ,simpleTitleCaseMapping:0x12189
 },
 { code:0x1218A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1218A
  ,simpleLowerCaseMapping:0x1218A
  ,simpleTitleCaseMapping:0x1218A
 },
 { code:0x1218B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1218B
  ,simpleLowerCaseMapping:0x1218B
  ,simpleTitleCaseMapping:0x1218B
 },
 { code:0x1218C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1218C
  ,simpleLowerCaseMapping:0x1218C
  ,simpleTitleCaseMapping:0x1218C
 },
 { code:0x1218D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1218D
  ,simpleLowerCaseMapping:0x1218D
  ,simpleTitleCaseMapping:0x1218D
 },
 { code:0x1218E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1218E
  ,simpleLowerCaseMapping:0x1218E
  ,simpleTitleCaseMapping:0x1218E
 },
 { code:0x1218F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1218F
  ,simpleLowerCaseMapping:0x1218F
  ,simpleTitleCaseMapping:0x1218F
 },
 { code:0x12190
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12190
  ,simpleLowerCaseMapping:0x12190
  ,simpleTitleCaseMapping:0x12190
 },
 { code:0x12191
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12191
  ,simpleLowerCaseMapping:0x12191
  ,simpleTitleCaseMapping:0x12191
 },
 { code:0x12192
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12192
  ,simpleLowerCaseMapping:0x12192
  ,simpleTitleCaseMapping:0x12192
 },
 { code:0x12193
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12193
  ,simpleLowerCaseMapping:0x12193
  ,simpleTitleCaseMapping:0x12193
 },
 { code:0x12194
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12194
  ,simpleLowerCaseMapping:0x12194
  ,simpleTitleCaseMapping:0x12194
 },
 { code:0x12195
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12195
  ,simpleLowerCaseMapping:0x12195
  ,simpleTitleCaseMapping:0x12195
 },
 { code:0x12196
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12196
  ,simpleLowerCaseMapping:0x12196
  ,simpleTitleCaseMapping:0x12196
 },
 { code:0x12197
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12197
  ,simpleLowerCaseMapping:0x12197
  ,simpleTitleCaseMapping:0x12197
 },
 { code:0x12198
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12198
  ,simpleLowerCaseMapping:0x12198
  ,simpleTitleCaseMapping:0x12198
 },
 { code:0x12199
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12199
  ,simpleLowerCaseMapping:0x12199
  ,simpleTitleCaseMapping:0x12199
 },
 { code:0x1219A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1219A
  ,simpleLowerCaseMapping:0x1219A
  ,simpleTitleCaseMapping:0x1219A
 },
 { code:0x1219B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1219B
  ,simpleLowerCaseMapping:0x1219B
  ,simpleTitleCaseMapping:0x1219B
 },
 { code:0x1219C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1219C
  ,simpleLowerCaseMapping:0x1219C
  ,simpleTitleCaseMapping:0x1219C
 },
 { code:0x1219D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1219D
  ,simpleLowerCaseMapping:0x1219D
  ,simpleTitleCaseMapping:0x1219D
 },
 { code:0x1219E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1219E
  ,simpleLowerCaseMapping:0x1219E
  ,simpleTitleCaseMapping:0x1219E
 },
 { code:0x1219F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1219F
  ,simpleLowerCaseMapping:0x1219F
  ,simpleTitleCaseMapping:0x1219F
 },
 { code:0x121A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121A0
  ,simpleLowerCaseMapping:0x121A0
  ,simpleTitleCaseMapping:0x121A0
 },
 { code:0x121A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121A1
  ,simpleLowerCaseMapping:0x121A1
  ,simpleTitleCaseMapping:0x121A1
 },
 { code:0x121A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121A2
  ,simpleLowerCaseMapping:0x121A2
  ,simpleTitleCaseMapping:0x121A2
 },
 { code:0x121A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121A3
  ,simpleLowerCaseMapping:0x121A3
  ,simpleTitleCaseMapping:0x121A3
 },
 { code:0x121A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121A4
  ,simpleLowerCaseMapping:0x121A4
  ,simpleTitleCaseMapping:0x121A4
 },
 { code:0x121A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121A5
  ,simpleLowerCaseMapping:0x121A5
  ,simpleTitleCaseMapping:0x121A5
 },
 { code:0x121A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121A6
  ,simpleLowerCaseMapping:0x121A6
  ,simpleTitleCaseMapping:0x121A6
 },
 { code:0x121A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121A7
  ,simpleLowerCaseMapping:0x121A7
  ,simpleTitleCaseMapping:0x121A7
 },
 { code:0x121A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121A8
  ,simpleLowerCaseMapping:0x121A8
  ,simpleTitleCaseMapping:0x121A8
 },
 { code:0x121A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121A9
  ,simpleLowerCaseMapping:0x121A9
  ,simpleTitleCaseMapping:0x121A9
 },
 { code:0x121AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121AA
  ,simpleLowerCaseMapping:0x121AA
  ,simpleTitleCaseMapping:0x121AA
 },
 { code:0x121AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121AB
  ,simpleLowerCaseMapping:0x121AB
  ,simpleTitleCaseMapping:0x121AB
 },
 { code:0x121AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121AC
  ,simpleLowerCaseMapping:0x121AC
  ,simpleTitleCaseMapping:0x121AC
 },
 { code:0x121AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121AD
  ,simpleLowerCaseMapping:0x121AD
  ,simpleTitleCaseMapping:0x121AD
 },
 { code:0x121AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121AE
  ,simpleLowerCaseMapping:0x121AE
  ,simpleTitleCaseMapping:0x121AE
 },
 { code:0x121AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121AF
  ,simpleLowerCaseMapping:0x121AF
  ,simpleTitleCaseMapping:0x121AF
 },
 { code:0x121B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121B0
  ,simpleLowerCaseMapping:0x121B0
  ,simpleTitleCaseMapping:0x121B0
 },
 { code:0x121B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121B1
  ,simpleLowerCaseMapping:0x121B1
  ,simpleTitleCaseMapping:0x121B1
 },
 { code:0x121B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121B2
  ,simpleLowerCaseMapping:0x121B2
  ,simpleTitleCaseMapping:0x121B2
 },
 { code:0x121B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121B3
  ,simpleLowerCaseMapping:0x121B3
  ,simpleTitleCaseMapping:0x121B3
 },
 { code:0x121B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121B4
  ,simpleLowerCaseMapping:0x121B4
  ,simpleTitleCaseMapping:0x121B4
 },
 { code:0x121B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121B5
  ,simpleLowerCaseMapping:0x121B5
  ,simpleTitleCaseMapping:0x121B5
 },
 { code:0x121B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121B6
  ,simpleLowerCaseMapping:0x121B6
  ,simpleTitleCaseMapping:0x121B6
 },
 { code:0x121B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121B7
  ,simpleLowerCaseMapping:0x121B7
  ,simpleTitleCaseMapping:0x121B7
 },
 { code:0x121B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121B8
  ,simpleLowerCaseMapping:0x121B8
  ,simpleTitleCaseMapping:0x121B8
 },
 { code:0x121B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121B9
  ,simpleLowerCaseMapping:0x121B9
  ,simpleTitleCaseMapping:0x121B9
 },
 { code:0x121BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121BA
  ,simpleLowerCaseMapping:0x121BA
  ,simpleTitleCaseMapping:0x121BA
 },
 { code:0x121BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121BB
  ,simpleLowerCaseMapping:0x121BB
  ,simpleTitleCaseMapping:0x121BB
 },
 { code:0x121BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121BC
  ,simpleLowerCaseMapping:0x121BC
  ,simpleTitleCaseMapping:0x121BC
 },
 { code:0x121BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121BD
  ,simpleLowerCaseMapping:0x121BD
  ,simpleTitleCaseMapping:0x121BD
 },
 { code:0x121BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121BE
  ,simpleLowerCaseMapping:0x121BE
  ,simpleTitleCaseMapping:0x121BE
 },
 { code:0x121BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121BF
  ,simpleLowerCaseMapping:0x121BF
  ,simpleTitleCaseMapping:0x121BF
 },
 { code:0x121C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121C0
  ,simpleLowerCaseMapping:0x121C0
  ,simpleTitleCaseMapping:0x121C0
 },
 { code:0x121C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121C1
  ,simpleLowerCaseMapping:0x121C1
  ,simpleTitleCaseMapping:0x121C1
 },
 { code:0x121C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121C2
  ,simpleLowerCaseMapping:0x121C2
  ,simpleTitleCaseMapping:0x121C2
 },
 { code:0x121C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121C3
  ,simpleLowerCaseMapping:0x121C3
  ,simpleTitleCaseMapping:0x121C3
 },
 { code:0x121C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121C4
  ,simpleLowerCaseMapping:0x121C4
  ,simpleTitleCaseMapping:0x121C4
 },
 { code:0x121C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121C5
  ,simpleLowerCaseMapping:0x121C5
  ,simpleTitleCaseMapping:0x121C5
 },
 { code:0x121C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121C6
  ,simpleLowerCaseMapping:0x121C6
  ,simpleTitleCaseMapping:0x121C6
 },
 { code:0x121C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121C7
  ,simpleLowerCaseMapping:0x121C7
  ,simpleTitleCaseMapping:0x121C7
 },
 { code:0x121C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121C8
  ,simpleLowerCaseMapping:0x121C8
  ,simpleTitleCaseMapping:0x121C8
 },
 { code:0x121C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121C9
  ,simpleLowerCaseMapping:0x121C9
  ,simpleTitleCaseMapping:0x121C9
 },
 { code:0x121CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121CA
  ,simpleLowerCaseMapping:0x121CA
  ,simpleTitleCaseMapping:0x121CA
 },
 { code:0x121CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121CB
  ,simpleLowerCaseMapping:0x121CB
  ,simpleTitleCaseMapping:0x121CB
 },
 { code:0x121CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121CC
  ,simpleLowerCaseMapping:0x121CC
  ,simpleTitleCaseMapping:0x121CC
 },
 { code:0x121CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121CD
  ,simpleLowerCaseMapping:0x121CD
  ,simpleTitleCaseMapping:0x121CD
 },
 { code:0x121CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121CE
  ,simpleLowerCaseMapping:0x121CE
  ,simpleTitleCaseMapping:0x121CE
 },
 { code:0x121CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121CF
  ,simpleLowerCaseMapping:0x121CF
  ,simpleTitleCaseMapping:0x121CF
 },
 { code:0x121D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121D0
  ,simpleLowerCaseMapping:0x121D0
  ,simpleTitleCaseMapping:0x121D0
 },
 { code:0x121D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121D1
  ,simpleLowerCaseMapping:0x121D1
  ,simpleTitleCaseMapping:0x121D1
 },
 { code:0x121D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121D2
  ,simpleLowerCaseMapping:0x121D2
  ,simpleTitleCaseMapping:0x121D2
 },
 { code:0x121D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121D3
  ,simpleLowerCaseMapping:0x121D3
  ,simpleTitleCaseMapping:0x121D3
 },
 { code:0x121D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121D4
  ,simpleLowerCaseMapping:0x121D4
  ,simpleTitleCaseMapping:0x121D4
 },
 { code:0x121D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121D5
  ,simpleLowerCaseMapping:0x121D5
  ,simpleTitleCaseMapping:0x121D5
 },
 { code:0x121D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121D6
  ,simpleLowerCaseMapping:0x121D6
  ,simpleTitleCaseMapping:0x121D6
 },
 { code:0x121D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121D7
  ,simpleLowerCaseMapping:0x121D7
  ,simpleTitleCaseMapping:0x121D7
 },
 { code:0x121D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121D8
  ,simpleLowerCaseMapping:0x121D8
  ,simpleTitleCaseMapping:0x121D8
 },
 { code:0x121D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121D9
  ,simpleLowerCaseMapping:0x121D9
  ,simpleTitleCaseMapping:0x121D9
 },
 { code:0x121DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121DA
  ,simpleLowerCaseMapping:0x121DA
  ,simpleTitleCaseMapping:0x121DA
 },
 { code:0x121DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121DB
  ,simpleLowerCaseMapping:0x121DB
  ,simpleTitleCaseMapping:0x121DB
 },
 { code:0x121DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121DC
  ,simpleLowerCaseMapping:0x121DC
  ,simpleTitleCaseMapping:0x121DC
 },
 { code:0x121DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121DD
  ,simpleLowerCaseMapping:0x121DD
  ,simpleTitleCaseMapping:0x121DD
 },
 { code:0x121DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121DE
  ,simpleLowerCaseMapping:0x121DE
  ,simpleTitleCaseMapping:0x121DE
 },
 { code:0x121DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121DF
  ,simpleLowerCaseMapping:0x121DF
  ,simpleTitleCaseMapping:0x121DF
 },
 { code:0x121E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121E0
  ,simpleLowerCaseMapping:0x121E0
  ,simpleTitleCaseMapping:0x121E0
 },
 { code:0x121E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121E1
  ,simpleLowerCaseMapping:0x121E1
  ,simpleTitleCaseMapping:0x121E1
 },
 { code:0x121E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121E2
  ,simpleLowerCaseMapping:0x121E2
  ,simpleTitleCaseMapping:0x121E2
 },
 { code:0x121E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121E3
  ,simpleLowerCaseMapping:0x121E3
  ,simpleTitleCaseMapping:0x121E3
 },
 { code:0x121E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121E4
  ,simpleLowerCaseMapping:0x121E4
  ,simpleTitleCaseMapping:0x121E4
 },
 { code:0x121E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121E5
  ,simpleLowerCaseMapping:0x121E5
  ,simpleTitleCaseMapping:0x121E5
 },
 { code:0x121E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121E6
  ,simpleLowerCaseMapping:0x121E6
  ,simpleTitleCaseMapping:0x121E6
 },
 { code:0x121E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121E7
  ,simpleLowerCaseMapping:0x121E7
  ,simpleTitleCaseMapping:0x121E7
 },
 { code:0x121E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121E8
  ,simpleLowerCaseMapping:0x121E8
  ,simpleTitleCaseMapping:0x121E8
 },
 { code:0x121E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121E9
  ,simpleLowerCaseMapping:0x121E9
  ,simpleTitleCaseMapping:0x121E9
 },
 { code:0x121EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121EA
  ,simpleLowerCaseMapping:0x121EA
  ,simpleTitleCaseMapping:0x121EA
 },
 { code:0x121EB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121EB
  ,simpleLowerCaseMapping:0x121EB
  ,simpleTitleCaseMapping:0x121EB
 },
 { code:0x121EC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121EC
  ,simpleLowerCaseMapping:0x121EC
  ,simpleTitleCaseMapping:0x121EC
 },
 { code:0x121ED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121ED
  ,simpleLowerCaseMapping:0x121ED
  ,simpleTitleCaseMapping:0x121ED
 },
 { code:0x121EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121EE
  ,simpleLowerCaseMapping:0x121EE
  ,simpleTitleCaseMapping:0x121EE
 },
 { code:0x121EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121EF
  ,simpleLowerCaseMapping:0x121EF
  ,simpleTitleCaseMapping:0x121EF
 },
 { code:0x121F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121F0
  ,simpleLowerCaseMapping:0x121F0
  ,simpleTitleCaseMapping:0x121F0
 },
 { code:0x121F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121F1
  ,simpleLowerCaseMapping:0x121F1
  ,simpleTitleCaseMapping:0x121F1
 },
 { code:0x121F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121F2
  ,simpleLowerCaseMapping:0x121F2
  ,simpleTitleCaseMapping:0x121F2
 },
 { code:0x121F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121F3
  ,simpleLowerCaseMapping:0x121F3
  ,simpleTitleCaseMapping:0x121F3
 },
 { code:0x121F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121F4
  ,simpleLowerCaseMapping:0x121F4
  ,simpleTitleCaseMapping:0x121F4
 },
 { code:0x121F5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121F5
  ,simpleLowerCaseMapping:0x121F5
  ,simpleTitleCaseMapping:0x121F5
 },
 { code:0x121F6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121F6
  ,simpleLowerCaseMapping:0x121F6
  ,simpleTitleCaseMapping:0x121F6
 },
 { code:0x121F7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121F7
  ,simpleLowerCaseMapping:0x121F7
  ,simpleTitleCaseMapping:0x121F7
 },
 { code:0x121F8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121F8
  ,simpleLowerCaseMapping:0x121F8
  ,simpleTitleCaseMapping:0x121F8
 },
 { code:0x121F9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121F9
  ,simpleLowerCaseMapping:0x121F9
  ,simpleTitleCaseMapping:0x121F9
 },
 { code:0x121FA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121FA
  ,simpleLowerCaseMapping:0x121FA
  ,simpleTitleCaseMapping:0x121FA
 },
 { code:0x121FB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121FB
  ,simpleLowerCaseMapping:0x121FB
  ,simpleTitleCaseMapping:0x121FB
 },
 { code:0x121FC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121FC
  ,simpleLowerCaseMapping:0x121FC
  ,simpleTitleCaseMapping:0x121FC
 },
 { code:0x121FD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121FD
  ,simpleLowerCaseMapping:0x121FD
  ,simpleTitleCaseMapping:0x121FD
 },
 { code:0x121FE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121FE
  ,simpleLowerCaseMapping:0x121FE
  ,simpleTitleCaseMapping:0x121FE
 },
 { code:0x121FF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x121FF
  ,simpleLowerCaseMapping:0x121FF
  ,simpleTitleCaseMapping:0x121FF
 },
 { code:0x12200
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12200
  ,simpleLowerCaseMapping:0x12200
  ,simpleTitleCaseMapping:0x12200
 },
 { code:0x12201
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12201
  ,simpleLowerCaseMapping:0x12201
  ,simpleTitleCaseMapping:0x12201
 },
 { code:0x12202
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12202
  ,simpleLowerCaseMapping:0x12202
  ,simpleTitleCaseMapping:0x12202
 },
 { code:0x12203
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12203
  ,simpleLowerCaseMapping:0x12203
  ,simpleTitleCaseMapping:0x12203
 },
 { code:0x12204
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12204
  ,simpleLowerCaseMapping:0x12204
  ,simpleTitleCaseMapping:0x12204
 },
 { code:0x12205
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12205
  ,simpleLowerCaseMapping:0x12205
  ,simpleTitleCaseMapping:0x12205
 },
 { code:0x12206
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12206
  ,simpleLowerCaseMapping:0x12206
  ,simpleTitleCaseMapping:0x12206
 },
 { code:0x12207
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12207
  ,simpleLowerCaseMapping:0x12207
  ,simpleTitleCaseMapping:0x12207
 },
 { code:0x12208
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12208
  ,simpleLowerCaseMapping:0x12208
  ,simpleTitleCaseMapping:0x12208
 },
 { code:0x12209
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12209
  ,simpleLowerCaseMapping:0x12209
  ,simpleTitleCaseMapping:0x12209
 },
 { code:0x1220A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1220A
  ,simpleLowerCaseMapping:0x1220A
  ,simpleTitleCaseMapping:0x1220A
 },
 { code:0x1220B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1220B
  ,simpleLowerCaseMapping:0x1220B
  ,simpleTitleCaseMapping:0x1220B
 },
 { code:0x1220C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1220C
  ,simpleLowerCaseMapping:0x1220C
  ,simpleTitleCaseMapping:0x1220C
 },
 { code:0x1220D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1220D
  ,simpleLowerCaseMapping:0x1220D
  ,simpleTitleCaseMapping:0x1220D
 },
 { code:0x1220E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1220E
  ,simpleLowerCaseMapping:0x1220E
  ,simpleTitleCaseMapping:0x1220E
 },
 { code:0x1220F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1220F
  ,simpleLowerCaseMapping:0x1220F
  ,simpleTitleCaseMapping:0x1220F
 },
 { code:0x12210
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12210
  ,simpleLowerCaseMapping:0x12210
  ,simpleTitleCaseMapping:0x12210
 },
 { code:0x12211
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12211
  ,simpleLowerCaseMapping:0x12211
  ,simpleTitleCaseMapping:0x12211
 },
 { code:0x12212
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12212
  ,simpleLowerCaseMapping:0x12212
  ,simpleTitleCaseMapping:0x12212
 },
 { code:0x12213
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12213
  ,simpleLowerCaseMapping:0x12213
  ,simpleTitleCaseMapping:0x12213
 },
 { code:0x12214
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12214
  ,simpleLowerCaseMapping:0x12214
  ,simpleTitleCaseMapping:0x12214
 },
 { code:0x12215
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12215
  ,simpleLowerCaseMapping:0x12215
  ,simpleTitleCaseMapping:0x12215
 },
 { code:0x12216
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12216
  ,simpleLowerCaseMapping:0x12216
  ,simpleTitleCaseMapping:0x12216
 },
 { code:0x12217
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12217
  ,simpleLowerCaseMapping:0x12217
  ,simpleTitleCaseMapping:0x12217
 },
 { code:0x12218
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12218
  ,simpleLowerCaseMapping:0x12218
  ,simpleTitleCaseMapping:0x12218
 },
 { code:0x12219
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12219
  ,simpleLowerCaseMapping:0x12219
  ,simpleTitleCaseMapping:0x12219
 },
 { code:0x1221A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1221A
  ,simpleLowerCaseMapping:0x1221A
  ,simpleTitleCaseMapping:0x1221A
 },
 { code:0x1221B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1221B
  ,simpleLowerCaseMapping:0x1221B
  ,simpleTitleCaseMapping:0x1221B
 },
 { code:0x1221C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1221C
  ,simpleLowerCaseMapping:0x1221C
  ,simpleTitleCaseMapping:0x1221C
 },
 { code:0x1221D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1221D
  ,simpleLowerCaseMapping:0x1221D
  ,simpleTitleCaseMapping:0x1221D
 },
 { code:0x1221E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1221E
  ,simpleLowerCaseMapping:0x1221E
  ,simpleTitleCaseMapping:0x1221E
 },
 { code:0x1221F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1221F
  ,simpleLowerCaseMapping:0x1221F
  ,simpleTitleCaseMapping:0x1221F
 },
 { code:0x12220
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12220
  ,simpleLowerCaseMapping:0x12220
  ,simpleTitleCaseMapping:0x12220
 },
 { code:0x12221
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12221
  ,simpleLowerCaseMapping:0x12221
  ,simpleTitleCaseMapping:0x12221
 },
 { code:0x12222
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12222
  ,simpleLowerCaseMapping:0x12222
  ,simpleTitleCaseMapping:0x12222
 },
 { code:0x12223
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12223
  ,simpleLowerCaseMapping:0x12223
  ,simpleTitleCaseMapping:0x12223
 },
 { code:0x12224
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12224
  ,simpleLowerCaseMapping:0x12224
  ,simpleTitleCaseMapping:0x12224
 },
 { code:0x12225
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12225
  ,simpleLowerCaseMapping:0x12225
  ,simpleTitleCaseMapping:0x12225
 },
 { code:0x12226
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12226
  ,simpleLowerCaseMapping:0x12226
  ,simpleTitleCaseMapping:0x12226
 },
 { code:0x12227
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12227
  ,simpleLowerCaseMapping:0x12227
  ,simpleTitleCaseMapping:0x12227
 },
 { code:0x12228
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12228
  ,simpleLowerCaseMapping:0x12228
  ,simpleTitleCaseMapping:0x12228
 },
 { code:0x12229
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12229
  ,simpleLowerCaseMapping:0x12229
  ,simpleTitleCaseMapping:0x12229
 },
 { code:0x1222A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1222A
  ,simpleLowerCaseMapping:0x1222A
  ,simpleTitleCaseMapping:0x1222A
 },
 { code:0x1222B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1222B
  ,simpleLowerCaseMapping:0x1222B
  ,simpleTitleCaseMapping:0x1222B
 },
 { code:0x1222C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1222C
  ,simpleLowerCaseMapping:0x1222C
  ,simpleTitleCaseMapping:0x1222C
 },
 { code:0x1222D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1222D
  ,simpleLowerCaseMapping:0x1222D
  ,simpleTitleCaseMapping:0x1222D
 },
 { code:0x1222E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1222E
  ,simpleLowerCaseMapping:0x1222E
  ,simpleTitleCaseMapping:0x1222E
 },
 { code:0x1222F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1222F
  ,simpleLowerCaseMapping:0x1222F
  ,simpleTitleCaseMapping:0x1222F
 },
 { code:0x12230
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12230
  ,simpleLowerCaseMapping:0x12230
  ,simpleTitleCaseMapping:0x12230
 },
 { code:0x12231
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12231
  ,simpleLowerCaseMapping:0x12231
  ,simpleTitleCaseMapping:0x12231
 },
 { code:0x12232
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12232
  ,simpleLowerCaseMapping:0x12232
  ,simpleTitleCaseMapping:0x12232
 },
 { code:0x12233
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12233
  ,simpleLowerCaseMapping:0x12233
  ,simpleTitleCaseMapping:0x12233
 },
 { code:0x12234
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12234
  ,simpleLowerCaseMapping:0x12234
  ,simpleTitleCaseMapping:0x12234
 },
 { code:0x12235
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12235
  ,simpleLowerCaseMapping:0x12235
  ,simpleTitleCaseMapping:0x12235
 },
 { code:0x12236
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12236
  ,simpleLowerCaseMapping:0x12236
  ,simpleTitleCaseMapping:0x12236
 },
 { code:0x12237
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12237
  ,simpleLowerCaseMapping:0x12237
  ,simpleTitleCaseMapping:0x12237
 },
 { code:0x12238
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12238
  ,simpleLowerCaseMapping:0x12238
  ,simpleTitleCaseMapping:0x12238
 },
 { code:0x12239
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12239
  ,simpleLowerCaseMapping:0x12239
  ,simpleTitleCaseMapping:0x12239
 },
 { code:0x1223A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1223A
  ,simpleLowerCaseMapping:0x1223A
  ,simpleTitleCaseMapping:0x1223A
 },
 { code:0x1223B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1223B
  ,simpleLowerCaseMapping:0x1223B
  ,simpleTitleCaseMapping:0x1223B
 },
 { code:0x1223C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1223C
  ,simpleLowerCaseMapping:0x1223C
  ,simpleTitleCaseMapping:0x1223C
 },
 { code:0x1223D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1223D
  ,simpleLowerCaseMapping:0x1223D
  ,simpleTitleCaseMapping:0x1223D
 },
 { code:0x1223E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1223E
  ,simpleLowerCaseMapping:0x1223E
  ,simpleTitleCaseMapping:0x1223E
 },
 { code:0x1223F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1223F
  ,simpleLowerCaseMapping:0x1223F
  ,simpleTitleCaseMapping:0x1223F
 },
 { code:0x12240
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12240
  ,simpleLowerCaseMapping:0x12240
  ,simpleTitleCaseMapping:0x12240
 },
 { code:0x12241
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12241
  ,simpleLowerCaseMapping:0x12241
  ,simpleTitleCaseMapping:0x12241
 },
 { code:0x12242
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12242
  ,simpleLowerCaseMapping:0x12242
  ,simpleTitleCaseMapping:0x12242
 },
 { code:0x12243
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12243
  ,simpleLowerCaseMapping:0x12243
  ,simpleTitleCaseMapping:0x12243
 },
 { code:0x12244
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12244
  ,simpleLowerCaseMapping:0x12244
  ,simpleTitleCaseMapping:0x12244
 },
 { code:0x12245
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12245
  ,simpleLowerCaseMapping:0x12245
  ,simpleTitleCaseMapping:0x12245
 },
 { code:0x12246
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12246
  ,simpleLowerCaseMapping:0x12246
  ,simpleTitleCaseMapping:0x12246
 },
 { code:0x12247
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12247
  ,simpleLowerCaseMapping:0x12247
  ,simpleTitleCaseMapping:0x12247
 },
 { code:0x12248
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12248
  ,simpleLowerCaseMapping:0x12248
  ,simpleTitleCaseMapping:0x12248
 },
 { code:0x12249
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12249
  ,simpleLowerCaseMapping:0x12249
  ,simpleTitleCaseMapping:0x12249
 },
 { code:0x1224A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1224A
  ,simpleLowerCaseMapping:0x1224A
  ,simpleTitleCaseMapping:0x1224A
 },
 { code:0x1224B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1224B
  ,simpleLowerCaseMapping:0x1224B
  ,simpleTitleCaseMapping:0x1224B
 },
 { code:0x1224C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1224C
  ,simpleLowerCaseMapping:0x1224C
  ,simpleTitleCaseMapping:0x1224C
 },
 { code:0x1224D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1224D
  ,simpleLowerCaseMapping:0x1224D
  ,simpleTitleCaseMapping:0x1224D
 },
 { code:0x1224E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1224E
  ,simpleLowerCaseMapping:0x1224E
  ,simpleTitleCaseMapping:0x1224E
 },
 { code:0x1224F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1224F
  ,simpleLowerCaseMapping:0x1224F
  ,simpleTitleCaseMapping:0x1224F
 },
 { code:0x12250
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12250
  ,simpleLowerCaseMapping:0x12250
  ,simpleTitleCaseMapping:0x12250
 },
 { code:0x12251
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12251
  ,simpleLowerCaseMapping:0x12251
  ,simpleTitleCaseMapping:0x12251
 },
 { code:0x12252
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12252
  ,simpleLowerCaseMapping:0x12252
  ,simpleTitleCaseMapping:0x12252
 },
 { code:0x12253
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12253
  ,simpleLowerCaseMapping:0x12253
  ,simpleTitleCaseMapping:0x12253
 },
 { code:0x12254
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12254
  ,simpleLowerCaseMapping:0x12254
  ,simpleTitleCaseMapping:0x12254
 },
 { code:0x12255
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12255
  ,simpleLowerCaseMapping:0x12255
  ,simpleTitleCaseMapping:0x12255
 },
 { code:0x12256
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12256
  ,simpleLowerCaseMapping:0x12256
  ,simpleTitleCaseMapping:0x12256
 },
 { code:0x12257
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12257
  ,simpleLowerCaseMapping:0x12257
  ,simpleTitleCaseMapping:0x12257
 },
 { code:0x12258
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12258
  ,simpleLowerCaseMapping:0x12258
  ,simpleTitleCaseMapping:0x12258
 },
 { code:0x12259
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12259
  ,simpleLowerCaseMapping:0x12259
  ,simpleTitleCaseMapping:0x12259
 },
 { code:0x1225A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1225A
  ,simpleLowerCaseMapping:0x1225A
  ,simpleTitleCaseMapping:0x1225A
 },
 { code:0x1225B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1225B
  ,simpleLowerCaseMapping:0x1225B
  ,simpleTitleCaseMapping:0x1225B
 },
 { code:0x1225C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1225C
  ,simpleLowerCaseMapping:0x1225C
  ,simpleTitleCaseMapping:0x1225C
 },
 { code:0x1225D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1225D
  ,simpleLowerCaseMapping:0x1225D
  ,simpleTitleCaseMapping:0x1225D
 },
 { code:0x1225E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1225E
  ,simpleLowerCaseMapping:0x1225E
  ,simpleTitleCaseMapping:0x1225E
 },
 { code:0x1225F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1225F
  ,simpleLowerCaseMapping:0x1225F
  ,simpleTitleCaseMapping:0x1225F
 },
 { code:0x12260
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12260
  ,simpleLowerCaseMapping:0x12260
  ,simpleTitleCaseMapping:0x12260
 },
 { code:0x12261
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12261
  ,simpleLowerCaseMapping:0x12261
  ,simpleTitleCaseMapping:0x12261
 },
 { code:0x12262
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12262
  ,simpleLowerCaseMapping:0x12262
  ,simpleTitleCaseMapping:0x12262
 },
 { code:0x12263
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12263
  ,simpleLowerCaseMapping:0x12263
  ,simpleTitleCaseMapping:0x12263
 },
 { code:0x12264
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12264
  ,simpleLowerCaseMapping:0x12264
  ,simpleTitleCaseMapping:0x12264
 },
 { code:0x12265
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12265
  ,simpleLowerCaseMapping:0x12265
  ,simpleTitleCaseMapping:0x12265
 },
 { code:0x12266
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12266
  ,simpleLowerCaseMapping:0x12266
  ,simpleTitleCaseMapping:0x12266
 },
 { code:0x12267
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12267
  ,simpleLowerCaseMapping:0x12267
  ,simpleTitleCaseMapping:0x12267
 },
 { code:0x12268
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12268
  ,simpleLowerCaseMapping:0x12268
  ,simpleTitleCaseMapping:0x12268
 },
 { code:0x12269
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12269
  ,simpleLowerCaseMapping:0x12269
  ,simpleTitleCaseMapping:0x12269
 },
 { code:0x1226A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1226A
  ,simpleLowerCaseMapping:0x1226A
  ,simpleTitleCaseMapping:0x1226A
 },
 { code:0x1226B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1226B
  ,simpleLowerCaseMapping:0x1226B
  ,simpleTitleCaseMapping:0x1226B
 },
 { code:0x1226C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1226C
  ,simpleLowerCaseMapping:0x1226C
  ,simpleTitleCaseMapping:0x1226C
 },
 { code:0x1226D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1226D
  ,simpleLowerCaseMapping:0x1226D
  ,simpleTitleCaseMapping:0x1226D
 },
 { code:0x1226E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1226E
  ,simpleLowerCaseMapping:0x1226E
  ,simpleTitleCaseMapping:0x1226E
 },
 { code:0x1226F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1226F
  ,simpleLowerCaseMapping:0x1226F
  ,simpleTitleCaseMapping:0x1226F
 },
 { code:0x12270
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12270
  ,simpleLowerCaseMapping:0x12270
  ,simpleTitleCaseMapping:0x12270
 },
 { code:0x12271
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12271
  ,simpleLowerCaseMapping:0x12271
  ,simpleTitleCaseMapping:0x12271
 },
 { code:0x12272
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12272
  ,simpleLowerCaseMapping:0x12272
  ,simpleTitleCaseMapping:0x12272
 },
 { code:0x12273
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12273
  ,simpleLowerCaseMapping:0x12273
  ,simpleTitleCaseMapping:0x12273
 },
 { code:0x12274
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12274
  ,simpleLowerCaseMapping:0x12274
  ,simpleTitleCaseMapping:0x12274
 },
 { code:0x12275
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12275
  ,simpleLowerCaseMapping:0x12275
  ,simpleTitleCaseMapping:0x12275
 },
 { code:0x12276
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12276
  ,simpleLowerCaseMapping:0x12276
  ,simpleTitleCaseMapping:0x12276
 },
 { code:0x12277
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12277
  ,simpleLowerCaseMapping:0x12277
  ,simpleTitleCaseMapping:0x12277
 },
 { code:0x12278
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12278
  ,simpleLowerCaseMapping:0x12278
  ,simpleTitleCaseMapping:0x12278
 },
 { code:0x12279
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12279
  ,simpleLowerCaseMapping:0x12279
  ,simpleTitleCaseMapping:0x12279
 },
 { code:0x1227A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1227A
  ,simpleLowerCaseMapping:0x1227A
  ,simpleTitleCaseMapping:0x1227A
 },
 { code:0x1227B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1227B
  ,simpleLowerCaseMapping:0x1227B
  ,simpleTitleCaseMapping:0x1227B
 },
 { code:0x1227C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1227C
  ,simpleLowerCaseMapping:0x1227C
  ,simpleTitleCaseMapping:0x1227C
 },
 { code:0x1227D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1227D
  ,simpleLowerCaseMapping:0x1227D
  ,simpleTitleCaseMapping:0x1227D
 },
 { code:0x1227E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1227E
  ,simpleLowerCaseMapping:0x1227E
  ,simpleTitleCaseMapping:0x1227E
 },
 { code:0x1227F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1227F
  ,simpleLowerCaseMapping:0x1227F
  ,simpleTitleCaseMapping:0x1227F
 },
 { code:0x12280
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12280
  ,simpleLowerCaseMapping:0x12280
  ,simpleTitleCaseMapping:0x12280
 },
 { code:0x12281
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12281
  ,simpleLowerCaseMapping:0x12281
  ,simpleTitleCaseMapping:0x12281
 },
 { code:0x12282
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12282
  ,simpleLowerCaseMapping:0x12282
  ,simpleTitleCaseMapping:0x12282
 },
 { code:0x12283
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12283
  ,simpleLowerCaseMapping:0x12283
  ,simpleTitleCaseMapping:0x12283
 },
 { code:0x12284
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12284
  ,simpleLowerCaseMapping:0x12284
  ,simpleTitleCaseMapping:0x12284
 },
 { code:0x12285
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12285
  ,simpleLowerCaseMapping:0x12285
  ,simpleTitleCaseMapping:0x12285
 },
 { code:0x12286
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12286
  ,simpleLowerCaseMapping:0x12286
  ,simpleTitleCaseMapping:0x12286
 },
 { code:0x12287
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12287
  ,simpleLowerCaseMapping:0x12287
  ,simpleTitleCaseMapping:0x12287
 },
 { code:0x12288
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12288
  ,simpleLowerCaseMapping:0x12288
  ,simpleTitleCaseMapping:0x12288
 },
 { code:0x12289
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12289
  ,simpleLowerCaseMapping:0x12289
  ,simpleTitleCaseMapping:0x12289
 },
 { code:0x1228A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1228A
  ,simpleLowerCaseMapping:0x1228A
  ,simpleTitleCaseMapping:0x1228A
 },
 { code:0x1228B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1228B
  ,simpleLowerCaseMapping:0x1228B
  ,simpleTitleCaseMapping:0x1228B
 },
 { code:0x1228C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1228C
  ,simpleLowerCaseMapping:0x1228C
  ,simpleTitleCaseMapping:0x1228C
 },
 { code:0x1228D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1228D
  ,simpleLowerCaseMapping:0x1228D
  ,simpleTitleCaseMapping:0x1228D
 },
 { code:0x1228E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1228E
  ,simpleLowerCaseMapping:0x1228E
  ,simpleTitleCaseMapping:0x1228E
 },
 { code:0x1228F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1228F
  ,simpleLowerCaseMapping:0x1228F
  ,simpleTitleCaseMapping:0x1228F
 },
 { code:0x12290
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12290
  ,simpleLowerCaseMapping:0x12290
  ,simpleTitleCaseMapping:0x12290
 },
 { code:0x12291
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12291
  ,simpleLowerCaseMapping:0x12291
  ,simpleTitleCaseMapping:0x12291
 },
 { code:0x12292
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12292
  ,simpleLowerCaseMapping:0x12292
  ,simpleTitleCaseMapping:0x12292
 },
 { code:0x12293
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12293
  ,simpleLowerCaseMapping:0x12293
  ,simpleTitleCaseMapping:0x12293
 },
 { code:0x12294
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12294
  ,simpleLowerCaseMapping:0x12294
  ,simpleTitleCaseMapping:0x12294
 },
 { code:0x12295
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12295
  ,simpleLowerCaseMapping:0x12295
  ,simpleTitleCaseMapping:0x12295
 },
 { code:0x12296
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12296
  ,simpleLowerCaseMapping:0x12296
  ,simpleTitleCaseMapping:0x12296
 },
 { code:0x12297
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12297
  ,simpleLowerCaseMapping:0x12297
  ,simpleTitleCaseMapping:0x12297
 },
 { code:0x12298
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12298
  ,simpleLowerCaseMapping:0x12298
  ,simpleTitleCaseMapping:0x12298
 },
 { code:0x12299
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12299
  ,simpleLowerCaseMapping:0x12299
  ,simpleTitleCaseMapping:0x12299
 },
 { code:0x1229A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1229A
  ,simpleLowerCaseMapping:0x1229A
  ,simpleTitleCaseMapping:0x1229A
 },
 { code:0x1229B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1229B
  ,simpleLowerCaseMapping:0x1229B
  ,simpleTitleCaseMapping:0x1229B
 },
 { code:0x1229C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1229C
  ,simpleLowerCaseMapping:0x1229C
  ,simpleTitleCaseMapping:0x1229C
 },
 { code:0x1229D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1229D
  ,simpleLowerCaseMapping:0x1229D
  ,simpleTitleCaseMapping:0x1229D
 },
 { code:0x1229E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1229E
  ,simpleLowerCaseMapping:0x1229E
  ,simpleTitleCaseMapping:0x1229E
 },
 { code:0x1229F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1229F
  ,simpleLowerCaseMapping:0x1229F
  ,simpleTitleCaseMapping:0x1229F
 },
 { code:0x122A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122A0
  ,simpleLowerCaseMapping:0x122A0
  ,simpleTitleCaseMapping:0x122A0
 },
 { code:0x122A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122A1
  ,simpleLowerCaseMapping:0x122A1
  ,simpleTitleCaseMapping:0x122A1
 },
 { code:0x122A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122A2
  ,simpleLowerCaseMapping:0x122A2
  ,simpleTitleCaseMapping:0x122A2
 },
 { code:0x122A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122A3
  ,simpleLowerCaseMapping:0x122A3
  ,simpleTitleCaseMapping:0x122A3
 },
 { code:0x122A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122A4
  ,simpleLowerCaseMapping:0x122A4
  ,simpleTitleCaseMapping:0x122A4
 },
 { code:0x122A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122A5
  ,simpleLowerCaseMapping:0x122A5
  ,simpleTitleCaseMapping:0x122A5
 },
 { code:0x122A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122A6
  ,simpleLowerCaseMapping:0x122A6
  ,simpleTitleCaseMapping:0x122A6
 },
 { code:0x122A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122A7
  ,simpleLowerCaseMapping:0x122A7
  ,simpleTitleCaseMapping:0x122A7
 },
 { code:0x122A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122A8
  ,simpleLowerCaseMapping:0x122A8
  ,simpleTitleCaseMapping:0x122A8
 },
 { code:0x122A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122A9
  ,simpleLowerCaseMapping:0x122A9
  ,simpleTitleCaseMapping:0x122A9
 },
 { code:0x122AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122AA
  ,simpleLowerCaseMapping:0x122AA
  ,simpleTitleCaseMapping:0x122AA
 },
 { code:0x122AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122AB
  ,simpleLowerCaseMapping:0x122AB
  ,simpleTitleCaseMapping:0x122AB
 },
 { code:0x122AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122AC
  ,simpleLowerCaseMapping:0x122AC
  ,simpleTitleCaseMapping:0x122AC
 },
 { code:0x122AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122AD
  ,simpleLowerCaseMapping:0x122AD
  ,simpleTitleCaseMapping:0x122AD
 },
 { code:0x122AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122AE
  ,simpleLowerCaseMapping:0x122AE
  ,simpleTitleCaseMapping:0x122AE
 },
 { code:0x122AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122AF
  ,simpleLowerCaseMapping:0x122AF
  ,simpleTitleCaseMapping:0x122AF
 },
 { code:0x122B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122B0
  ,simpleLowerCaseMapping:0x122B0
  ,simpleTitleCaseMapping:0x122B0
 },
 { code:0x122B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122B1
  ,simpleLowerCaseMapping:0x122B1
  ,simpleTitleCaseMapping:0x122B1
 },
 { code:0x122B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122B2
  ,simpleLowerCaseMapping:0x122B2
  ,simpleTitleCaseMapping:0x122B2
 },
 { code:0x122B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122B3
  ,simpleLowerCaseMapping:0x122B3
  ,simpleTitleCaseMapping:0x122B3
 },
 { code:0x122B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122B4
  ,simpleLowerCaseMapping:0x122B4
  ,simpleTitleCaseMapping:0x122B4
 },
 { code:0x122B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122B5
  ,simpleLowerCaseMapping:0x122B5
  ,simpleTitleCaseMapping:0x122B5
 },
 { code:0x122B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122B6
  ,simpleLowerCaseMapping:0x122B6
  ,simpleTitleCaseMapping:0x122B6
 },
 { code:0x122B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122B7
  ,simpleLowerCaseMapping:0x122B7
  ,simpleTitleCaseMapping:0x122B7
 },
 { code:0x122B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122B8
  ,simpleLowerCaseMapping:0x122B8
  ,simpleTitleCaseMapping:0x122B8
 },
 { code:0x122B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122B9
  ,simpleLowerCaseMapping:0x122B9
  ,simpleTitleCaseMapping:0x122B9
 },
 { code:0x122BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122BA
  ,simpleLowerCaseMapping:0x122BA
  ,simpleTitleCaseMapping:0x122BA
 },
 { code:0x122BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122BB
  ,simpleLowerCaseMapping:0x122BB
  ,simpleTitleCaseMapping:0x122BB
 },
 { code:0x122BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122BC
  ,simpleLowerCaseMapping:0x122BC
  ,simpleTitleCaseMapping:0x122BC
 },
 { code:0x122BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122BD
  ,simpleLowerCaseMapping:0x122BD
  ,simpleTitleCaseMapping:0x122BD
 },
 { code:0x122BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122BE
  ,simpleLowerCaseMapping:0x122BE
  ,simpleTitleCaseMapping:0x122BE
 },
 { code:0x122BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122BF
  ,simpleLowerCaseMapping:0x122BF
  ,simpleTitleCaseMapping:0x122BF
 },
 { code:0x122C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122C0
  ,simpleLowerCaseMapping:0x122C0
  ,simpleTitleCaseMapping:0x122C0
 },
 { code:0x122C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122C1
  ,simpleLowerCaseMapping:0x122C1
  ,simpleTitleCaseMapping:0x122C1
 },
 { code:0x122C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122C2
  ,simpleLowerCaseMapping:0x122C2
  ,simpleTitleCaseMapping:0x122C2
 },
 { code:0x122C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122C3
  ,simpleLowerCaseMapping:0x122C3
  ,simpleTitleCaseMapping:0x122C3
 },
 { code:0x122C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122C4
  ,simpleLowerCaseMapping:0x122C4
  ,simpleTitleCaseMapping:0x122C4
 },
 { code:0x122C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122C5
  ,simpleLowerCaseMapping:0x122C5
  ,simpleTitleCaseMapping:0x122C5
 },
 { code:0x122C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122C6
  ,simpleLowerCaseMapping:0x122C6
  ,simpleTitleCaseMapping:0x122C6
 },
 { code:0x122C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122C7
  ,simpleLowerCaseMapping:0x122C7
  ,simpleTitleCaseMapping:0x122C7
 },
 { code:0x122C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122C8
  ,simpleLowerCaseMapping:0x122C8
  ,simpleTitleCaseMapping:0x122C8
 },
 { code:0x122C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122C9
  ,simpleLowerCaseMapping:0x122C9
  ,simpleTitleCaseMapping:0x122C9
 },
 { code:0x122CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122CA
  ,simpleLowerCaseMapping:0x122CA
  ,simpleTitleCaseMapping:0x122CA
 },
 { code:0x122CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122CB
  ,simpleLowerCaseMapping:0x122CB
  ,simpleTitleCaseMapping:0x122CB
 },
 { code:0x122CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122CC
  ,simpleLowerCaseMapping:0x122CC
  ,simpleTitleCaseMapping:0x122CC
 },
 { code:0x122CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122CD
  ,simpleLowerCaseMapping:0x122CD
  ,simpleTitleCaseMapping:0x122CD
 },
 { code:0x122CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122CE
  ,simpleLowerCaseMapping:0x122CE
  ,simpleTitleCaseMapping:0x122CE
 },
 { code:0x122CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122CF
  ,simpleLowerCaseMapping:0x122CF
  ,simpleTitleCaseMapping:0x122CF
 },
 { code:0x122D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122D0
  ,simpleLowerCaseMapping:0x122D0
  ,simpleTitleCaseMapping:0x122D0
 },
 { code:0x122D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122D1
  ,simpleLowerCaseMapping:0x122D1
  ,simpleTitleCaseMapping:0x122D1
 },
 { code:0x122D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122D2
  ,simpleLowerCaseMapping:0x122D2
  ,simpleTitleCaseMapping:0x122D2
 },
 { code:0x122D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122D3
  ,simpleLowerCaseMapping:0x122D3
  ,simpleTitleCaseMapping:0x122D3
 },
 { code:0x122D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122D4
  ,simpleLowerCaseMapping:0x122D4
  ,simpleTitleCaseMapping:0x122D4
 },
 { code:0x122D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122D5
  ,simpleLowerCaseMapping:0x122D5
  ,simpleTitleCaseMapping:0x122D5
 },
 { code:0x122D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122D6
  ,simpleLowerCaseMapping:0x122D6
  ,simpleTitleCaseMapping:0x122D6
 },
 { code:0x122D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122D7
  ,simpleLowerCaseMapping:0x122D7
  ,simpleTitleCaseMapping:0x122D7
 },
 { code:0x122D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122D8
  ,simpleLowerCaseMapping:0x122D8
  ,simpleTitleCaseMapping:0x122D8
 },
 { code:0x122D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122D9
  ,simpleLowerCaseMapping:0x122D9
  ,simpleTitleCaseMapping:0x122D9
 },
 { code:0x122DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122DA
  ,simpleLowerCaseMapping:0x122DA
  ,simpleTitleCaseMapping:0x122DA
 },
 { code:0x122DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122DB
  ,simpleLowerCaseMapping:0x122DB
  ,simpleTitleCaseMapping:0x122DB
 },
 { code:0x122DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122DC
  ,simpleLowerCaseMapping:0x122DC
  ,simpleTitleCaseMapping:0x122DC
 },
 { code:0x122DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122DD
  ,simpleLowerCaseMapping:0x122DD
  ,simpleTitleCaseMapping:0x122DD
 },
 { code:0x122DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122DE
  ,simpleLowerCaseMapping:0x122DE
  ,simpleTitleCaseMapping:0x122DE
 },
 { code:0x122DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122DF
  ,simpleLowerCaseMapping:0x122DF
  ,simpleTitleCaseMapping:0x122DF
 },
 { code:0x122E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122E0
  ,simpleLowerCaseMapping:0x122E0
  ,simpleTitleCaseMapping:0x122E0
 },
 { code:0x122E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122E1
  ,simpleLowerCaseMapping:0x122E1
  ,simpleTitleCaseMapping:0x122E1
 },
 { code:0x122E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122E2
  ,simpleLowerCaseMapping:0x122E2
  ,simpleTitleCaseMapping:0x122E2
 },
 { code:0x122E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122E3
  ,simpleLowerCaseMapping:0x122E3
  ,simpleTitleCaseMapping:0x122E3
 },
 { code:0x122E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122E4
  ,simpleLowerCaseMapping:0x122E4
  ,simpleTitleCaseMapping:0x122E4
 },
 { code:0x122E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122E5
  ,simpleLowerCaseMapping:0x122E5
  ,simpleTitleCaseMapping:0x122E5
 },
 { code:0x122E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122E6
  ,simpleLowerCaseMapping:0x122E6
  ,simpleTitleCaseMapping:0x122E6
 },
 { code:0x122E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122E7
  ,simpleLowerCaseMapping:0x122E7
  ,simpleTitleCaseMapping:0x122E7
 },
 { code:0x122E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122E8
  ,simpleLowerCaseMapping:0x122E8
  ,simpleTitleCaseMapping:0x122E8
 },
 { code:0x122E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122E9
  ,simpleLowerCaseMapping:0x122E9
  ,simpleTitleCaseMapping:0x122E9
 },
 { code:0x122EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122EA
  ,simpleLowerCaseMapping:0x122EA
  ,simpleTitleCaseMapping:0x122EA
 },
 { code:0x122EB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122EB
  ,simpleLowerCaseMapping:0x122EB
  ,simpleTitleCaseMapping:0x122EB
 },
 { code:0x122EC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122EC
  ,simpleLowerCaseMapping:0x122EC
  ,simpleTitleCaseMapping:0x122EC
 },
 { code:0x122ED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122ED
  ,simpleLowerCaseMapping:0x122ED
  ,simpleTitleCaseMapping:0x122ED
 },
 { code:0x122EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122EE
  ,simpleLowerCaseMapping:0x122EE
  ,simpleTitleCaseMapping:0x122EE
 },
 { code:0x122EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122EF
  ,simpleLowerCaseMapping:0x122EF
  ,simpleTitleCaseMapping:0x122EF
 },
 { code:0x122F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122F0
  ,simpleLowerCaseMapping:0x122F0
  ,simpleTitleCaseMapping:0x122F0
 },
 { code:0x122F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122F1
  ,simpleLowerCaseMapping:0x122F1
  ,simpleTitleCaseMapping:0x122F1
 },
 { code:0x122F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122F2
  ,simpleLowerCaseMapping:0x122F2
  ,simpleTitleCaseMapping:0x122F2
 },
 { code:0x122F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122F3
  ,simpleLowerCaseMapping:0x122F3
  ,simpleTitleCaseMapping:0x122F3
 },
 { code:0x122F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122F4
  ,simpleLowerCaseMapping:0x122F4
  ,simpleTitleCaseMapping:0x122F4
 },
 { code:0x122F5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122F5
  ,simpleLowerCaseMapping:0x122F5
  ,simpleTitleCaseMapping:0x122F5
 },
 { code:0x122F6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122F6
  ,simpleLowerCaseMapping:0x122F6
  ,simpleTitleCaseMapping:0x122F6
 },
 { code:0x122F7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122F7
  ,simpleLowerCaseMapping:0x122F7
  ,simpleTitleCaseMapping:0x122F7
 },
 { code:0x122F8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122F8
  ,simpleLowerCaseMapping:0x122F8
  ,simpleTitleCaseMapping:0x122F8
 },
 { code:0x122F9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122F9
  ,simpleLowerCaseMapping:0x122F9
  ,simpleTitleCaseMapping:0x122F9
 },
 { code:0x122FA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122FA
  ,simpleLowerCaseMapping:0x122FA
  ,simpleTitleCaseMapping:0x122FA
 },
 { code:0x122FB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122FB
  ,simpleLowerCaseMapping:0x122FB
  ,simpleTitleCaseMapping:0x122FB
 },
 { code:0x122FC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122FC
  ,simpleLowerCaseMapping:0x122FC
  ,simpleTitleCaseMapping:0x122FC
 },
 { code:0x122FD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122FD
  ,simpleLowerCaseMapping:0x122FD
  ,simpleTitleCaseMapping:0x122FD
 },
 { code:0x122FE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122FE
  ,simpleLowerCaseMapping:0x122FE
  ,simpleTitleCaseMapping:0x122FE
 },
 { code:0x122FF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x122FF
  ,simpleLowerCaseMapping:0x122FF
  ,simpleTitleCaseMapping:0x122FF
 },
 { code:0x12300
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12300
  ,simpleLowerCaseMapping:0x12300
  ,simpleTitleCaseMapping:0x12300
 },
 { code:0x12301
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12301
  ,simpleLowerCaseMapping:0x12301
  ,simpleTitleCaseMapping:0x12301
 },
 { code:0x12302
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12302
  ,simpleLowerCaseMapping:0x12302
  ,simpleTitleCaseMapping:0x12302
 },
 { code:0x12303
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12303
  ,simpleLowerCaseMapping:0x12303
  ,simpleTitleCaseMapping:0x12303
 },
 { code:0x12304
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12304
  ,simpleLowerCaseMapping:0x12304
  ,simpleTitleCaseMapping:0x12304
 },
 { code:0x12305
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12305
  ,simpleLowerCaseMapping:0x12305
  ,simpleTitleCaseMapping:0x12305
 },
 { code:0x12306
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12306
  ,simpleLowerCaseMapping:0x12306
  ,simpleTitleCaseMapping:0x12306
 },
 { code:0x12307
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12307
  ,simpleLowerCaseMapping:0x12307
  ,simpleTitleCaseMapping:0x12307
 },
 { code:0x12308
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12308
  ,simpleLowerCaseMapping:0x12308
  ,simpleTitleCaseMapping:0x12308
 },
 { code:0x12309
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12309
  ,simpleLowerCaseMapping:0x12309
  ,simpleTitleCaseMapping:0x12309
 },
 { code:0x1230A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1230A
  ,simpleLowerCaseMapping:0x1230A
  ,simpleTitleCaseMapping:0x1230A
 },
 { code:0x1230B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1230B
  ,simpleLowerCaseMapping:0x1230B
  ,simpleTitleCaseMapping:0x1230B
 },
 { code:0x1230C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1230C
  ,simpleLowerCaseMapping:0x1230C
  ,simpleTitleCaseMapping:0x1230C
 },
 { code:0x1230D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1230D
  ,simpleLowerCaseMapping:0x1230D
  ,simpleTitleCaseMapping:0x1230D
 },
 { code:0x1230E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1230E
  ,simpleLowerCaseMapping:0x1230E
  ,simpleTitleCaseMapping:0x1230E
 },
 { code:0x1230F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1230F
  ,simpleLowerCaseMapping:0x1230F
  ,simpleTitleCaseMapping:0x1230F
 },
 { code:0x12310
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12310
  ,simpleLowerCaseMapping:0x12310
  ,simpleTitleCaseMapping:0x12310
 },
 { code:0x12311
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12311
  ,simpleLowerCaseMapping:0x12311
  ,simpleTitleCaseMapping:0x12311
 },
 { code:0x12312
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12312
  ,simpleLowerCaseMapping:0x12312
  ,simpleTitleCaseMapping:0x12312
 },
 { code:0x12313
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12313
  ,simpleLowerCaseMapping:0x12313
  ,simpleTitleCaseMapping:0x12313
 },
 { code:0x12314
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12314
  ,simpleLowerCaseMapping:0x12314
  ,simpleTitleCaseMapping:0x12314
 },
 { code:0x12315
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12315
  ,simpleLowerCaseMapping:0x12315
  ,simpleTitleCaseMapping:0x12315
 },
 { code:0x12316
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12316
  ,simpleLowerCaseMapping:0x12316
  ,simpleTitleCaseMapping:0x12316
 },
 { code:0x12317
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12317
  ,simpleLowerCaseMapping:0x12317
  ,simpleTitleCaseMapping:0x12317
 },
 { code:0x12318
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12318
  ,simpleLowerCaseMapping:0x12318
  ,simpleTitleCaseMapping:0x12318
 },
 { code:0x12319
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12319
  ,simpleLowerCaseMapping:0x12319
  ,simpleTitleCaseMapping:0x12319
 },
 { code:0x1231A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1231A
  ,simpleLowerCaseMapping:0x1231A
  ,simpleTitleCaseMapping:0x1231A
 },
 { code:0x1231B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1231B
  ,simpleLowerCaseMapping:0x1231B
  ,simpleTitleCaseMapping:0x1231B
 },
 { code:0x1231C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1231C
  ,simpleLowerCaseMapping:0x1231C
  ,simpleTitleCaseMapping:0x1231C
 },
 { code:0x1231D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1231D
  ,simpleLowerCaseMapping:0x1231D
  ,simpleTitleCaseMapping:0x1231D
 },
 { code:0x1231E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1231E
  ,simpleLowerCaseMapping:0x1231E
  ,simpleTitleCaseMapping:0x1231E
 },
 { code:0x1231F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1231F
  ,simpleLowerCaseMapping:0x1231F
  ,simpleTitleCaseMapping:0x1231F
 },
 { code:0x12320
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12320
  ,simpleLowerCaseMapping:0x12320
  ,simpleTitleCaseMapping:0x12320
 },
 { code:0x12321
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12321
  ,simpleLowerCaseMapping:0x12321
  ,simpleTitleCaseMapping:0x12321
 },
 { code:0x12322
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12322
  ,simpleLowerCaseMapping:0x12322
  ,simpleTitleCaseMapping:0x12322
 },
 { code:0x12323
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12323
  ,simpleLowerCaseMapping:0x12323
  ,simpleTitleCaseMapping:0x12323
 },
 { code:0x12324
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12324
  ,simpleLowerCaseMapping:0x12324
  ,simpleTitleCaseMapping:0x12324
 },
 { code:0x12325
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12325
  ,simpleLowerCaseMapping:0x12325
  ,simpleTitleCaseMapping:0x12325
 },
 { code:0x12326
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12326
  ,simpleLowerCaseMapping:0x12326
  ,simpleTitleCaseMapping:0x12326
 },
 { code:0x12327
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12327
  ,simpleLowerCaseMapping:0x12327
  ,simpleTitleCaseMapping:0x12327
 },
 { code:0x12328
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12328
  ,simpleLowerCaseMapping:0x12328
  ,simpleTitleCaseMapping:0x12328
 },
 { code:0x12329
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12329
  ,simpleLowerCaseMapping:0x12329
  ,simpleTitleCaseMapping:0x12329
 },
 { code:0x1232A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1232A
  ,simpleLowerCaseMapping:0x1232A
  ,simpleTitleCaseMapping:0x1232A
 },
 { code:0x1232B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1232B
  ,simpleLowerCaseMapping:0x1232B
  ,simpleTitleCaseMapping:0x1232B
 },
 { code:0x1232C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1232C
  ,simpleLowerCaseMapping:0x1232C
  ,simpleTitleCaseMapping:0x1232C
 },
 { code:0x1232D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1232D
  ,simpleLowerCaseMapping:0x1232D
  ,simpleTitleCaseMapping:0x1232D
 },
 { code:0x1232E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1232E
  ,simpleLowerCaseMapping:0x1232E
  ,simpleTitleCaseMapping:0x1232E
 },
 { code:0x1232F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1232F
  ,simpleLowerCaseMapping:0x1232F
  ,simpleTitleCaseMapping:0x1232F
 },
 { code:0x12330
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12330
  ,simpleLowerCaseMapping:0x12330
  ,simpleTitleCaseMapping:0x12330
 },
 { code:0x12331
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12331
  ,simpleLowerCaseMapping:0x12331
  ,simpleTitleCaseMapping:0x12331
 },
 { code:0x12332
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12332
  ,simpleLowerCaseMapping:0x12332
  ,simpleTitleCaseMapping:0x12332
 },
 { code:0x12333
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12333
  ,simpleLowerCaseMapping:0x12333
  ,simpleTitleCaseMapping:0x12333
 },
 { code:0x12334
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12334
  ,simpleLowerCaseMapping:0x12334
  ,simpleTitleCaseMapping:0x12334
 },
 { code:0x12335
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12335
  ,simpleLowerCaseMapping:0x12335
  ,simpleTitleCaseMapping:0x12335
 },
 { code:0x12336
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12336
  ,simpleLowerCaseMapping:0x12336
  ,simpleTitleCaseMapping:0x12336
 },
 { code:0x12337
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12337
  ,simpleLowerCaseMapping:0x12337
  ,simpleTitleCaseMapping:0x12337
 },
 { code:0x12338
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12338
  ,simpleLowerCaseMapping:0x12338
  ,simpleTitleCaseMapping:0x12338
 },
 { code:0x12339
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12339
  ,simpleLowerCaseMapping:0x12339
  ,simpleTitleCaseMapping:0x12339
 },
 { code:0x1233A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1233A
  ,simpleLowerCaseMapping:0x1233A
  ,simpleTitleCaseMapping:0x1233A
 },
 { code:0x1233B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1233B
  ,simpleLowerCaseMapping:0x1233B
  ,simpleTitleCaseMapping:0x1233B
 },
 { code:0x1233C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1233C
  ,simpleLowerCaseMapping:0x1233C
  ,simpleTitleCaseMapping:0x1233C
 },
 { code:0x1233D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1233D
  ,simpleLowerCaseMapping:0x1233D
  ,simpleTitleCaseMapping:0x1233D
 },
 { code:0x1233E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1233E
  ,simpleLowerCaseMapping:0x1233E
  ,simpleTitleCaseMapping:0x1233E
 },
 { code:0x1233F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1233F
  ,simpleLowerCaseMapping:0x1233F
  ,simpleTitleCaseMapping:0x1233F
 },
 { code:0x12340
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12340
  ,simpleLowerCaseMapping:0x12340
  ,simpleTitleCaseMapping:0x12340
 },
 { code:0x12341
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12341
  ,simpleLowerCaseMapping:0x12341
  ,simpleTitleCaseMapping:0x12341
 },
 { code:0x12342
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12342
  ,simpleLowerCaseMapping:0x12342
  ,simpleTitleCaseMapping:0x12342
 },
 { code:0x12343
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12343
  ,simpleLowerCaseMapping:0x12343
  ,simpleTitleCaseMapping:0x12343
 },
 { code:0x12344
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12344
  ,simpleLowerCaseMapping:0x12344
  ,simpleTitleCaseMapping:0x12344
 },
 { code:0x12345
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12345
  ,simpleLowerCaseMapping:0x12345
  ,simpleTitleCaseMapping:0x12345
 },
 { code:0x12346
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12346
  ,simpleLowerCaseMapping:0x12346
  ,simpleTitleCaseMapping:0x12346
 },
 { code:0x12347
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12347
  ,simpleLowerCaseMapping:0x12347
  ,simpleTitleCaseMapping:0x12347
 },
 { code:0x12348
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12348
  ,simpleLowerCaseMapping:0x12348
  ,simpleTitleCaseMapping:0x12348
 },
 { code:0x12349
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12349
  ,simpleLowerCaseMapping:0x12349
  ,simpleTitleCaseMapping:0x12349
 },
 { code:0x1234A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1234A
  ,simpleLowerCaseMapping:0x1234A
  ,simpleTitleCaseMapping:0x1234A
 },
 { code:0x1234B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1234B
  ,simpleLowerCaseMapping:0x1234B
  ,simpleTitleCaseMapping:0x1234B
 },
 { code:0x1234C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1234C
  ,simpleLowerCaseMapping:0x1234C
  ,simpleTitleCaseMapping:0x1234C
 },
 { code:0x1234D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1234D
  ,simpleLowerCaseMapping:0x1234D
  ,simpleTitleCaseMapping:0x1234D
 },
 { code:0x1234E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1234E
  ,simpleLowerCaseMapping:0x1234E
  ,simpleTitleCaseMapping:0x1234E
 },
 { code:0x1234F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1234F
  ,simpleLowerCaseMapping:0x1234F
  ,simpleTitleCaseMapping:0x1234F
 },
 { code:0x12350
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12350
  ,simpleLowerCaseMapping:0x12350
  ,simpleTitleCaseMapping:0x12350
 },
 { code:0x12351
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12351
  ,simpleLowerCaseMapping:0x12351
  ,simpleTitleCaseMapping:0x12351
 },
 { code:0x12352
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12352
  ,simpleLowerCaseMapping:0x12352
  ,simpleTitleCaseMapping:0x12352
 },
 { code:0x12353
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12353
  ,simpleLowerCaseMapping:0x12353
  ,simpleTitleCaseMapping:0x12353
 },
 { code:0x12354
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12354
  ,simpleLowerCaseMapping:0x12354
  ,simpleTitleCaseMapping:0x12354
 },
 { code:0x12355
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12355
  ,simpleLowerCaseMapping:0x12355
  ,simpleTitleCaseMapping:0x12355
 },
 { code:0x12356
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12356
  ,simpleLowerCaseMapping:0x12356
  ,simpleTitleCaseMapping:0x12356
 },
 { code:0x12357
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12357
  ,simpleLowerCaseMapping:0x12357
  ,simpleTitleCaseMapping:0x12357
 },
 { code:0x12358
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12358
  ,simpleLowerCaseMapping:0x12358
  ,simpleTitleCaseMapping:0x12358
 },
 { code:0x12359
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12359
  ,simpleLowerCaseMapping:0x12359
  ,simpleTitleCaseMapping:0x12359
 },
 { code:0x1235A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1235A
  ,simpleLowerCaseMapping:0x1235A
  ,simpleTitleCaseMapping:0x1235A
 },
 { code:0x1235B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1235B
  ,simpleLowerCaseMapping:0x1235B
  ,simpleTitleCaseMapping:0x1235B
 },
 { code:0x1235C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1235C
  ,simpleLowerCaseMapping:0x1235C
  ,simpleTitleCaseMapping:0x1235C
 },
 { code:0x1235D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1235D
  ,simpleLowerCaseMapping:0x1235D
  ,simpleTitleCaseMapping:0x1235D
 },
 { code:0x1235E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1235E
  ,simpleLowerCaseMapping:0x1235E
  ,simpleTitleCaseMapping:0x1235E
 },
 { code:0x1235F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1235F
  ,simpleLowerCaseMapping:0x1235F
  ,simpleTitleCaseMapping:0x1235F
 },
 { code:0x12360
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12360
  ,simpleLowerCaseMapping:0x12360
  ,simpleTitleCaseMapping:0x12360
 },
 { code:0x12361
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12361
  ,simpleLowerCaseMapping:0x12361
  ,simpleTitleCaseMapping:0x12361
 },
 { code:0x12362
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12362
  ,simpleLowerCaseMapping:0x12362
  ,simpleTitleCaseMapping:0x12362
 },
 { code:0x12363
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12363
  ,simpleLowerCaseMapping:0x12363
  ,simpleTitleCaseMapping:0x12363
 },
 { code:0x12364
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12364
  ,simpleLowerCaseMapping:0x12364
  ,simpleTitleCaseMapping:0x12364
 },
 { code:0x12365
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12365
  ,simpleLowerCaseMapping:0x12365
  ,simpleTitleCaseMapping:0x12365
 },
 { code:0x12366
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12366
  ,simpleLowerCaseMapping:0x12366
  ,simpleTitleCaseMapping:0x12366
 },
 { code:0x12367
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12367
  ,simpleLowerCaseMapping:0x12367
  ,simpleTitleCaseMapping:0x12367
 },
 { code:0x12368
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12368
  ,simpleLowerCaseMapping:0x12368
  ,simpleTitleCaseMapping:0x12368
 },
 { code:0x12369
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x12369
  ,simpleLowerCaseMapping:0x12369
  ,simpleTitleCaseMapping:0x12369
 },
 { code:0x1236A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1236A
  ,simpleLowerCaseMapping:0x1236A
  ,simpleTitleCaseMapping:0x1236A
 },
 { code:0x1236B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1236B
  ,simpleLowerCaseMapping:0x1236B
  ,simpleTitleCaseMapping:0x1236B
 },
 { code:0x1236C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1236C
  ,simpleLowerCaseMapping:0x1236C
  ,simpleTitleCaseMapping:0x1236C
 },
 { code:0x1236D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1236D
  ,simpleLowerCaseMapping:0x1236D
  ,simpleTitleCaseMapping:0x1236D
 },
 { code:0x1236E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x1236E
  ,simpleLowerCaseMapping:0x1236E
  ,simpleTitleCaseMapping:0x1236E
 },
 { code:0x12400
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12400
  ,simpleLowerCaseMapping:0x12400
  ,simpleTitleCaseMapping:0x12400
 },
 { code:0x12401
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12401
  ,simpleLowerCaseMapping:0x12401
  ,simpleTitleCaseMapping:0x12401
 },
 { code:0x12402
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12402
  ,simpleLowerCaseMapping:0x12402
  ,simpleTitleCaseMapping:0x12402
 },
 { code:0x12403
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12403
  ,simpleLowerCaseMapping:0x12403
  ,simpleTitleCaseMapping:0x12403
 },
 { code:0x12404
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12404
  ,simpleLowerCaseMapping:0x12404
  ,simpleTitleCaseMapping:0x12404
 },
 { code:0x12405
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12405
  ,simpleLowerCaseMapping:0x12405
  ,simpleTitleCaseMapping:0x12405
 },
 { code:0x12406
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12406
  ,simpleLowerCaseMapping:0x12406
  ,simpleTitleCaseMapping:0x12406
 },
 { code:0x12407
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12407
  ,simpleLowerCaseMapping:0x12407
  ,simpleTitleCaseMapping:0x12407
 },
 { code:0x12408
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12408
  ,simpleLowerCaseMapping:0x12408
  ,simpleTitleCaseMapping:0x12408
 },
 { code:0x12409
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12409
  ,simpleLowerCaseMapping:0x12409
  ,simpleTitleCaseMapping:0x12409
 },
 { code:0x1240A
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1240A
  ,simpleLowerCaseMapping:0x1240A
  ,simpleTitleCaseMapping:0x1240A
 },
 { code:0x1240B
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1240B
  ,simpleLowerCaseMapping:0x1240B
  ,simpleTitleCaseMapping:0x1240B
 },
 { code:0x1240C
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1240C
  ,simpleLowerCaseMapping:0x1240C
  ,simpleTitleCaseMapping:0x1240C
 },
 { code:0x1240D
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1240D
  ,simpleLowerCaseMapping:0x1240D
  ,simpleTitleCaseMapping:0x1240D
 },
 { code:0x1240E
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1240E
  ,simpleLowerCaseMapping:0x1240E
  ,simpleTitleCaseMapping:0x1240E
 },
 { code:0x1240F
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1240F
  ,simpleLowerCaseMapping:0x1240F
  ,simpleTitleCaseMapping:0x1240F
 },
 { code:0x12410
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12410
  ,simpleLowerCaseMapping:0x12410
  ,simpleTitleCaseMapping:0x12410
 },
 { code:0x12411
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12411
  ,simpleLowerCaseMapping:0x12411
  ,simpleTitleCaseMapping:0x12411
 },
 { code:0x12412
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12412
  ,simpleLowerCaseMapping:0x12412
  ,simpleTitleCaseMapping:0x12412
 },
 { code:0x12413
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12413
  ,simpleLowerCaseMapping:0x12413
  ,simpleTitleCaseMapping:0x12413
 },
 { code:0x12414
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12414
  ,simpleLowerCaseMapping:0x12414
  ,simpleTitleCaseMapping:0x12414
 },
 { code:0x12415
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12415
  ,simpleLowerCaseMapping:0x12415
  ,simpleTitleCaseMapping:0x12415
 },
 { code:0x12416
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12416
  ,simpleLowerCaseMapping:0x12416
  ,simpleTitleCaseMapping:0x12416
 },
 { code:0x12417
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12417
  ,simpleLowerCaseMapping:0x12417
  ,simpleTitleCaseMapping:0x12417
 },
 { code:0x12418
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12418
  ,simpleLowerCaseMapping:0x12418
  ,simpleTitleCaseMapping:0x12418
 },
 { code:0x12419
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12419
  ,simpleLowerCaseMapping:0x12419
  ,simpleTitleCaseMapping:0x12419
 },
 { code:0x1241A
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1241A
  ,simpleLowerCaseMapping:0x1241A
  ,simpleTitleCaseMapping:0x1241A
 },
 { code:0x1241B
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1241B
  ,simpleLowerCaseMapping:0x1241B
  ,simpleTitleCaseMapping:0x1241B
 },
 { code:0x1241C
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1241C
  ,simpleLowerCaseMapping:0x1241C
  ,simpleTitleCaseMapping:0x1241C
 },
 { code:0x1241D
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1241D
  ,simpleLowerCaseMapping:0x1241D
  ,simpleTitleCaseMapping:0x1241D
 },
 { code:0x1241E
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1241E
  ,simpleLowerCaseMapping:0x1241E
  ,simpleTitleCaseMapping:0x1241E
 },
 { code:0x1241F
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1241F
  ,simpleLowerCaseMapping:0x1241F
  ,simpleTitleCaseMapping:0x1241F
 },
 { code:0x12420
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12420
  ,simpleLowerCaseMapping:0x12420
  ,simpleTitleCaseMapping:0x12420
 },
 { code:0x12421
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12421
  ,simpleLowerCaseMapping:0x12421
  ,simpleTitleCaseMapping:0x12421
 },
 { code:0x12422
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12422
  ,simpleLowerCaseMapping:0x12422
  ,simpleTitleCaseMapping:0x12422
 },
 { code:0x12423
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12423
  ,simpleLowerCaseMapping:0x12423
  ,simpleTitleCaseMapping:0x12423
 },
 { code:0x12424
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12424
  ,simpleLowerCaseMapping:0x12424
  ,simpleTitleCaseMapping:0x12424
 },
 { code:0x12425
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12425
  ,simpleLowerCaseMapping:0x12425
  ,simpleTitleCaseMapping:0x12425
 },
 { code:0x12426
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12426
  ,simpleLowerCaseMapping:0x12426
  ,simpleTitleCaseMapping:0x12426
 },
 { code:0x12427
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12427
  ,simpleLowerCaseMapping:0x12427
  ,simpleTitleCaseMapping:0x12427
 },
 { code:0x12428
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12428
  ,simpleLowerCaseMapping:0x12428
  ,simpleTitleCaseMapping:0x12428
 },
 { code:0x12429
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12429
  ,simpleLowerCaseMapping:0x12429
  ,simpleTitleCaseMapping:0x12429
 },
 { code:0x1242A
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1242A
  ,simpleLowerCaseMapping:0x1242A
  ,simpleTitleCaseMapping:0x1242A
 },
 { code:0x1242B
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1242B
  ,simpleLowerCaseMapping:0x1242B
  ,simpleTitleCaseMapping:0x1242B
 },
 { code:0x1242C
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1242C
  ,simpleLowerCaseMapping:0x1242C
  ,simpleTitleCaseMapping:0x1242C
 },
 { code:0x1242D
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1242D
  ,simpleLowerCaseMapping:0x1242D
  ,simpleTitleCaseMapping:0x1242D
 },
 { code:0x1242E
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1242E
  ,simpleLowerCaseMapping:0x1242E
  ,simpleTitleCaseMapping:0x1242E
 },
 { code:0x1242F
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1242F
  ,simpleLowerCaseMapping:0x1242F
  ,simpleTitleCaseMapping:0x1242F
 },
 { code:0x12430
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12430
  ,simpleLowerCaseMapping:0x12430
  ,simpleTitleCaseMapping:0x12430
 },
 { code:0x12431
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12431
  ,simpleLowerCaseMapping:0x12431
  ,simpleTitleCaseMapping:0x12431
 },
 { code:0x12432
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12432
  ,simpleLowerCaseMapping:0x12432
  ,simpleTitleCaseMapping:0x12432
 },
 { code:0x12433
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12433
  ,simpleLowerCaseMapping:0x12433
  ,simpleTitleCaseMapping:0x12433
 },
 { code:0x12434
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12434
  ,simpleLowerCaseMapping:0x12434
  ,simpleTitleCaseMapping:0x12434
 },
 { code:0x12435
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12435
  ,simpleLowerCaseMapping:0x12435
  ,simpleTitleCaseMapping:0x12435
 },
 { code:0x12436
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12436
  ,simpleLowerCaseMapping:0x12436
  ,simpleTitleCaseMapping:0x12436
 },
 { code:0x12437
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12437
  ,simpleLowerCaseMapping:0x12437
  ,simpleTitleCaseMapping:0x12437
 },
 { code:0x12438
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12438
  ,simpleLowerCaseMapping:0x12438
  ,simpleTitleCaseMapping:0x12438
 },
 { code:0x12439
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12439
  ,simpleLowerCaseMapping:0x12439
  ,simpleTitleCaseMapping:0x12439
 },
 { code:0x1243A
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1243A
  ,simpleLowerCaseMapping:0x1243A
  ,simpleTitleCaseMapping:0x1243A
 },
 { code:0x1243B
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1243B
  ,simpleLowerCaseMapping:0x1243B
  ,simpleTitleCaseMapping:0x1243B
 },
 { code:0x1243C
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1243C
  ,simpleLowerCaseMapping:0x1243C
  ,simpleTitleCaseMapping:0x1243C
 },
 { code:0x1243D
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1243D
  ,simpleLowerCaseMapping:0x1243D
  ,simpleTitleCaseMapping:0x1243D
 },
 { code:0x1243E
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1243E
  ,simpleLowerCaseMapping:0x1243E
  ,simpleTitleCaseMapping:0x1243E
 },
 { code:0x1243F
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1243F
  ,simpleLowerCaseMapping:0x1243F
  ,simpleTitleCaseMapping:0x1243F
 },
 { code:0x12440
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12440
  ,simpleLowerCaseMapping:0x12440
  ,simpleTitleCaseMapping:0x12440
 },
 { code:0x12441
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12441
  ,simpleLowerCaseMapping:0x12441
  ,simpleTitleCaseMapping:0x12441
 },
 { code:0x12442
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12442
  ,simpleLowerCaseMapping:0x12442
  ,simpleTitleCaseMapping:0x12442
 },
 { code:0x12443
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12443
  ,simpleLowerCaseMapping:0x12443
  ,simpleTitleCaseMapping:0x12443
 },
 { code:0x12444
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12444
  ,simpleLowerCaseMapping:0x12444
  ,simpleTitleCaseMapping:0x12444
 },
 { code:0x12445
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12445
  ,simpleLowerCaseMapping:0x12445
  ,simpleTitleCaseMapping:0x12445
 },
 { code:0x12446
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12446
  ,simpleLowerCaseMapping:0x12446
  ,simpleTitleCaseMapping:0x12446
 },
 { code:0x12447
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12447
  ,simpleLowerCaseMapping:0x12447
  ,simpleTitleCaseMapping:0x12447
 },
 { code:0x12448
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12448
  ,simpleLowerCaseMapping:0x12448
  ,simpleTitleCaseMapping:0x12448
 },
 { code:0x12449
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12449
  ,simpleLowerCaseMapping:0x12449
  ,simpleTitleCaseMapping:0x12449
 },
 { code:0x1244A
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1244A
  ,simpleLowerCaseMapping:0x1244A
  ,simpleTitleCaseMapping:0x1244A
 },
 { code:0x1244B
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1244B
  ,simpleLowerCaseMapping:0x1244B
  ,simpleTitleCaseMapping:0x1244B
 },
 { code:0x1244C
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1244C
  ,simpleLowerCaseMapping:0x1244C
  ,simpleTitleCaseMapping:0x1244C
 },
 { code:0x1244D
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1244D
  ,simpleLowerCaseMapping:0x1244D
  ,simpleTitleCaseMapping:0x1244D
 },
 { code:0x1244E
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1244E
  ,simpleLowerCaseMapping:0x1244E
  ,simpleTitleCaseMapping:0x1244E
 },
 { code:0x1244F
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1244F
  ,simpleLowerCaseMapping:0x1244F
  ,simpleTitleCaseMapping:0x1244F
 },
 { code:0x12450
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12450
  ,simpleLowerCaseMapping:0x12450
  ,simpleTitleCaseMapping:0x12450
 },
 { code:0x12451
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12451
  ,simpleLowerCaseMapping:0x12451
  ,simpleTitleCaseMapping:0x12451
 },
 { code:0x12452
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12452
  ,simpleLowerCaseMapping:0x12452
  ,simpleTitleCaseMapping:0x12452
 },
 { code:0x12453
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12453
  ,simpleLowerCaseMapping:0x12453
  ,simpleTitleCaseMapping:0x12453
 },
 { code:0x12454
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12454
  ,simpleLowerCaseMapping:0x12454
  ,simpleTitleCaseMapping:0x12454
 },
 { code:0x12455
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12455
  ,simpleLowerCaseMapping:0x12455
  ,simpleTitleCaseMapping:0x12455
 },
 { code:0x12456
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12456
  ,simpleLowerCaseMapping:0x12456
  ,simpleTitleCaseMapping:0x12456
 },
 { code:0x12457
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12457
  ,simpleLowerCaseMapping:0x12457
  ,simpleTitleCaseMapping:0x12457
 },
 { code:0x12458
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12458
  ,simpleLowerCaseMapping:0x12458
  ,simpleTitleCaseMapping:0x12458
 },
 { code:0x12459
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12459
  ,simpleLowerCaseMapping:0x12459
  ,simpleTitleCaseMapping:0x12459
 },
 { code:0x1245A
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1245A
  ,simpleLowerCaseMapping:0x1245A
  ,simpleTitleCaseMapping:0x1245A
 },
 { code:0x1245B
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1245B
  ,simpleLowerCaseMapping:0x1245B
  ,simpleTitleCaseMapping:0x1245B
 },
 { code:0x1245C
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1245C
  ,simpleLowerCaseMapping:0x1245C
  ,simpleTitleCaseMapping:0x1245C
 },
 { code:0x1245D
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1245D
  ,simpleLowerCaseMapping:0x1245D
  ,simpleTitleCaseMapping:0x1245D
 },
 { code:0x1245E
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1245E
  ,simpleLowerCaseMapping:0x1245E
  ,simpleTitleCaseMapping:0x1245E
 },
 { code:0x1245F
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x1245F
  ,simpleLowerCaseMapping:0x1245F
  ,simpleTitleCaseMapping:0x1245F
 },
 { code:0x12460
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12460
  ,simpleLowerCaseMapping:0x12460
  ,simpleTitleCaseMapping:0x12460
 },
 { code:0x12461
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12461
  ,simpleLowerCaseMapping:0x12461
  ,simpleTitleCaseMapping:0x12461
 },
 { code:0x12462
  ,generalCategory:UnicodeData.GeneralCategory.Nl
  ,simpleUpperCaseMapping:0x12462
  ,simpleLowerCaseMapping:0x12462
  ,simpleTitleCaseMapping:0x12462
 },
 { code:0x12470
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x12470
  ,simpleLowerCaseMapping:0x12470
  ,simpleTitleCaseMapping:0x12470
 },
 { code:0x12471
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x12471
  ,simpleLowerCaseMapping:0x12471
  ,simpleTitleCaseMapping:0x12471
 },
 { code:0x12472
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x12472
  ,simpleLowerCaseMapping:0x12472
  ,simpleTitleCaseMapping:0x12472
 },
 { code:0x12473
  ,generalCategory:UnicodeData.GeneralCategory.Po
  ,simpleUpperCaseMapping:0x12473
  ,simpleLowerCaseMapping:0x12473
  ,simpleTitleCaseMapping:0x12473
 },
 { code:0x1D000
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D000
  ,simpleLowerCaseMapping:0x1D000
  ,simpleTitleCaseMapping:0x1D000
 },
 { code:0x1D001
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D001
  ,simpleLowerCaseMapping:0x1D001
  ,simpleTitleCaseMapping:0x1D001
 },
 { code:0x1D002
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D002
  ,simpleLowerCaseMapping:0x1D002
  ,simpleTitleCaseMapping:0x1D002
 },
 { code:0x1D003
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D003
  ,simpleLowerCaseMapping:0x1D003
  ,simpleTitleCaseMapping:0x1D003
 },
 { code:0x1D004
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D004
  ,simpleLowerCaseMapping:0x1D004
  ,simpleTitleCaseMapping:0x1D004
 },
 { code:0x1D005
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D005
  ,simpleLowerCaseMapping:0x1D005
  ,simpleTitleCaseMapping:0x1D005
 },
 { code:0x1D006
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D006
  ,simpleLowerCaseMapping:0x1D006
  ,simpleTitleCaseMapping:0x1D006
 },
 { code:0x1D007
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D007
  ,simpleLowerCaseMapping:0x1D007
  ,simpleTitleCaseMapping:0x1D007
 },
 { code:0x1D008
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D008
  ,simpleLowerCaseMapping:0x1D008
  ,simpleTitleCaseMapping:0x1D008
 },
 { code:0x1D009
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D009
  ,simpleLowerCaseMapping:0x1D009
  ,simpleTitleCaseMapping:0x1D009
 },
 { code:0x1D00A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D00A
  ,simpleLowerCaseMapping:0x1D00A
  ,simpleTitleCaseMapping:0x1D00A
 },
 { code:0x1D00B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D00B
  ,simpleLowerCaseMapping:0x1D00B
  ,simpleTitleCaseMapping:0x1D00B
 },
 { code:0x1D00C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D00C
  ,simpleLowerCaseMapping:0x1D00C
  ,simpleTitleCaseMapping:0x1D00C
 },
 { code:0x1D00D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D00D
  ,simpleLowerCaseMapping:0x1D00D
  ,simpleTitleCaseMapping:0x1D00D
 },
 { code:0x1D00E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D00E
  ,simpleLowerCaseMapping:0x1D00E
  ,simpleTitleCaseMapping:0x1D00E
 },
 { code:0x1D00F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D00F
  ,simpleLowerCaseMapping:0x1D00F
  ,simpleTitleCaseMapping:0x1D00F
 },
 { code:0x1D010
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D010
  ,simpleLowerCaseMapping:0x1D010
  ,simpleTitleCaseMapping:0x1D010
 },
 { code:0x1D011
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D011
  ,simpleLowerCaseMapping:0x1D011
  ,simpleTitleCaseMapping:0x1D011
 },
 { code:0x1D012
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D012
  ,simpleLowerCaseMapping:0x1D012
  ,simpleTitleCaseMapping:0x1D012
 },
 { code:0x1D013
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D013
  ,simpleLowerCaseMapping:0x1D013
  ,simpleTitleCaseMapping:0x1D013
 },
 { code:0x1D014
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D014
  ,simpleLowerCaseMapping:0x1D014
  ,simpleTitleCaseMapping:0x1D014
 },
 { code:0x1D015
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D015
  ,simpleLowerCaseMapping:0x1D015
  ,simpleTitleCaseMapping:0x1D015
 },
 { code:0x1D016
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D016
  ,simpleLowerCaseMapping:0x1D016
  ,simpleTitleCaseMapping:0x1D016
 },
 { code:0x1D017
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D017
  ,simpleLowerCaseMapping:0x1D017
  ,simpleTitleCaseMapping:0x1D017
 },
 { code:0x1D018
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D018
  ,simpleLowerCaseMapping:0x1D018
  ,simpleTitleCaseMapping:0x1D018
 },
 { code:0x1D019
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D019
  ,simpleLowerCaseMapping:0x1D019
  ,simpleTitleCaseMapping:0x1D019
 },
 { code:0x1D01A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D01A
  ,simpleLowerCaseMapping:0x1D01A
  ,simpleTitleCaseMapping:0x1D01A
 },
 { code:0x1D01B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D01B
  ,simpleLowerCaseMapping:0x1D01B
  ,simpleTitleCaseMapping:0x1D01B
 },
 { code:0x1D01C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D01C
  ,simpleLowerCaseMapping:0x1D01C
  ,simpleTitleCaseMapping:0x1D01C
 },
 { code:0x1D01D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D01D
  ,simpleLowerCaseMapping:0x1D01D
  ,simpleTitleCaseMapping:0x1D01D
 },
 { code:0x1D01E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D01E
  ,simpleLowerCaseMapping:0x1D01E
  ,simpleTitleCaseMapping:0x1D01E
 },
 { code:0x1D01F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D01F
  ,simpleLowerCaseMapping:0x1D01F
  ,simpleTitleCaseMapping:0x1D01F
 },
 { code:0x1D020
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D020
  ,simpleLowerCaseMapping:0x1D020
  ,simpleTitleCaseMapping:0x1D020
 },
 { code:0x1D021
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D021
  ,simpleLowerCaseMapping:0x1D021
  ,simpleTitleCaseMapping:0x1D021
 },
 { code:0x1D022
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D022
  ,simpleLowerCaseMapping:0x1D022
  ,simpleTitleCaseMapping:0x1D022
 },
 { code:0x1D023
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D023
  ,simpleLowerCaseMapping:0x1D023
  ,simpleTitleCaseMapping:0x1D023
 },
 { code:0x1D024
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D024
  ,simpleLowerCaseMapping:0x1D024
  ,simpleTitleCaseMapping:0x1D024
 },
 { code:0x1D025
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D025
  ,simpleLowerCaseMapping:0x1D025
  ,simpleTitleCaseMapping:0x1D025
 },
 { code:0x1D026
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D026
  ,simpleLowerCaseMapping:0x1D026
  ,simpleTitleCaseMapping:0x1D026
 },
 { code:0x1D027
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D027
  ,simpleLowerCaseMapping:0x1D027
  ,simpleTitleCaseMapping:0x1D027
 },
 { code:0x1D028
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D028
  ,simpleLowerCaseMapping:0x1D028
  ,simpleTitleCaseMapping:0x1D028
 },
 { code:0x1D029
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D029
  ,simpleLowerCaseMapping:0x1D029
  ,simpleTitleCaseMapping:0x1D029
 },
 { code:0x1D02A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D02A
  ,simpleLowerCaseMapping:0x1D02A
  ,simpleTitleCaseMapping:0x1D02A
 },
 { code:0x1D02B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D02B
  ,simpleLowerCaseMapping:0x1D02B
  ,simpleTitleCaseMapping:0x1D02B
 },
 { code:0x1D02C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D02C
  ,simpleLowerCaseMapping:0x1D02C
  ,simpleTitleCaseMapping:0x1D02C
 },
 { code:0x1D02D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D02D
  ,simpleLowerCaseMapping:0x1D02D
  ,simpleTitleCaseMapping:0x1D02D
 },
 { code:0x1D02E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D02E
  ,simpleLowerCaseMapping:0x1D02E
  ,simpleTitleCaseMapping:0x1D02E
 },
 { code:0x1D02F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D02F
  ,simpleLowerCaseMapping:0x1D02F
  ,simpleTitleCaseMapping:0x1D02F
 },
 { code:0x1D030
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D030
  ,simpleLowerCaseMapping:0x1D030
  ,simpleTitleCaseMapping:0x1D030
 },
 { code:0x1D031
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D031
  ,simpleLowerCaseMapping:0x1D031
  ,simpleTitleCaseMapping:0x1D031
 },
 { code:0x1D032
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D032
  ,simpleLowerCaseMapping:0x1D032
  ,simpleTitleCaseMapping:0x1D032
 },
 { code:0x1D033
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D033
  ,simpleLowerCaseMapping:0x1D033
  ,simpleTitleCaseMapping:0x1D033
 },
 { code:0x1D034
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D034
  ,simpleLowerCaseMapping:0x1D034
  ,simpleTitleCaseMapping:0x1D034
 },
 { code:0x1D035
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D035
  ,simpleLowerCaseMapping:0x1D035
  ,simpleTitleCaseMapping:0x1D035
 },
 { code:0x1D036
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D036
  ,simpleLowerCaseMapping:0x1D036
  ,simpleTitleCaseMapping:0x1D036
 },
 { code:0x1D037
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D037
  ,simpleLowerCaseMapping:0x1D037
  ,simpleTitleCaseMapping:0x1D037
 },
 { code:0x1D038
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D038
  ,simpleLowerCaseMapping:0x1D038
  ,simpleTitleCaseMapping:0x1D038
 },
 { code:0x1D039
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D039
  ,simpleLowerCaseMapping:0x1D039
  ,simpleTitleCaseMapping:0x1D039
 },
 { code:0x1D03A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D03A
  ,simpleLowerCaseMapping:0x1D03A
  ,simpleTitleCaseMapping:0x1D03A
 },
 { code:0x1D03B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D03B
  ,simpleLowerCaseMapping:0x1D03B
  ,simpleTitleCaseMapping:0x1D03B
 },
 { code:0x1D03C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D03C
  ,simpleLowerCaseMapping:0x1D03C
  ,simpleTitleCaseMapping:0x1D03C
 },
 { code:0x1D03D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D03D
  ,simpleLowerCaseMapping:0x1D03D
  ,simpleTitleCaseMapping:0x1D03D
 },
 { code:0x1D03E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D03E
  ,simpleLowerCaseMapping:0x1D03E
  ,simpleTitleCaseMapping:0x1D03E
 },
 { code:0x1D03F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D03F
  ,simpleLowerCaseMapping:0x1D03F
  ,simpleTitleCaseMapping:0x1D03F
 },
 { code:0x1D040
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D040
  ,simpleLowerCaseMapping:0x1D040
  ,simpleTitleCaseMapping:0x1D040
 },
 { code:0x1D041
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D041
  ,simpleLowerCaseMapping:0x1D041
  ,simpleTitleCaseMapping:0x1D041
 },
 { code:0x1D042
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D042
  ,simpleLowerCaseMapping:0x1D042
  ,simpleTitleCaseMapping:0x1D042
 },
 { code:0x1D043
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D043
  ,simpleLowerCaseMapping:0x1D043
  ,simpleTitleCaseMapping:0x1D043
 },
 { code:0x1D044
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D044
  ,simpleLowerCaseMapping:0x1D044
  ,simpleTitleCaseMapping:0x1D044
 },
 { code:0x1D045
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D045
  ,simpleLowerCaseMapping:0x1D045
  ,simpleTitleCaseMapping:0x1D045
 },
 { code:0x1D046
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D046
  ,simpleLowerCaseMapping:0x1D046
  ,simpleTitleCaseMapping:0x1D046
 },
 { code:0x1D047
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D047
  ,simpleLowerCaseMapping:0x1D047
  ,simpleTitleCaseMapping:0x1D047
 },
 { code:0x1D048
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D048
  ,simpleLowerCaseMapping:0x1D048
  ,simpleTitleCaseMapping:0x1D048
 },
 { code:0x1D049
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D049
  ,simpleLowerCaseMapping:0x1D049
  ,simpleTitleCaseMapping:0x1D049
 },
 { code:0x1D04A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D04A
  ,simpleLowerCaseMapping:0x1D04A
  ,simpleTitleCaseMapping:0x1D04A
 },
 { code:0x1D04B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D04B
  ,simpleLowerCaseMapping:0x1D04B
  ,simpleTitleCaseMapping:0x1D04B
 },
 { code:0x1D04C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D04C
  ,simpleLowerCaseMapping:0x1D04C
  ,simpleTitleCaseMapping:0x1D04C
 },
 { code:0x1D04D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D04D
  ,simpleLowerCaseMapping:0x1D04D
  ,simpleTitleCaseMapping:0x1D04D
 },
 { code:0x1D04E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D04E
  ,simpleLowerCaseMapping:0x1D04E
  ,simpleTitleCaseMapping:0x1D04E
 },
 { code:0x1D04F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D04F
  ,simpleLowerCaseMapping:0x1D04F
  ,simpleTitleCaseMapping:0x1D04F
 },
 { code:0x1D050
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D050
  ,simpleLowerCaseMapping:0x1D050
  ,simpleTitleCaseMapping:0x1D050
 },
 { code:0x1D051
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D051
  ,simpleLowerCaseMapping:0x1D051
  ,simpleTitleCaseMapping:0x1D051
 },
 { code:0x1D052
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D052
  ,simpleLowerCaseMapping:0x1D052
  ,simpleTitleCaseMapping:0x1D052
 },
 { code:0x1D053
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D053
  ,simpleLowerCaseMapping:0x1D053
  ,simpleTitleCaseMapping:0x1D053
 },
 { code:0x1D054
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D054
  ,simpleLowerCaseMapping:0x1D054
  ,simpleTitleCaseMapping:0x1D054
 },
 { code:0x1D055
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D055
  ,simpleLowerCaseMapping:0x1D055
  ,simpleTitleCaseMapping:0x1D055
 },
 { code:0x1D056
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D056
  ,simpleLowerCaseMapping:0x1D056
  ,simpleTitleCaseMapping:0x1D056
 },
 { code:0x1D057
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D057
  ,simpleLowerCaseMapping:0x1D057
  ,simpleTitleCaseMapping:0x1D057
 },
 { code:0x1D058
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D058
  ,simpleLowerCaseMapping:0x1D058
  ,simpleTitleCaseMapping:0x1D058
 },
 { code:0x1D059
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D059
  ,simpleLowerCaseMapping:0x1D059
  ,simpleTitleCaseMapping:0x1D059
 },
 { code:0x1D05A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D05A
  ,simpleLowerCaseMapping:0x1D05A
  ,simpleTitleCaseMapping:0x1D05A
 },
 { code:0x1D05B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D05B
  ,simpleLowerCaseMapping:0x1D05B
  ,simpleTitleCaseMapping:0x1D05B
 },
 { code:0x1D05C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D05C
  ,simpleLowerCaseMapping:0x1D05C
  ,simpleTitleCaseMapping:0x1D05C
 },
 { code:0x1D05D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D05D
  ,simpleLowerCaseMapping:0x1D05D
  ,simpleTitleCaseMapping:0x1D05D
 },
 { code:0x1D05E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D05E
  ,simpleLowerCaseMapping:0x1D05E
  ,simpleTitleCaseMapping:0x1D05E
 },
 { code:0x1D05F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D05F
  ,simpleLowerCaseMapping:0x1D05F
  ,simpleTitleCaseMapping:0x1D05F
 },
 { code:0x1D060
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D060
  ,simpleLowerCaseMapping:0x1D060
  ,simpleTitleCaseMapping:0x1D060
 },
 { code:0x1D061
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D061
  ,simpleLowerCaseMapping:0x1D061
  ,simpleTitleCaseMapping:0x1D061
 },
 { code:0x1D062
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D062
  ,simpleLowerCaseMapping:0x1D062
  ,simpleTitleCaseMapping:0x1D062
 },
 { code:0x1D063
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D063
  ,simpleLowerCaseMapping:0x1D063
  ,simpleTitleCaseMapping:0x1D063
 },
 { code:0x1D064
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D064
  ,simpleLowerCaseMapping:0x1D064
  ,simpleTitleCaseMapping:0x1D064
 },
 { code:0x1D065
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D065
  ,simpleLowerCaseMapping:0x1D065
  ,simpleTitleCaseMapping:0x1D065
 },
 { code:0x1D066
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D066
  ,simpleLowerCaseMapping:0x1D066
  ,simpleTitleCaseMapping:0x1D066
 },
 { code:0x1D067
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D067
  ,simpleLowerCaseMapping:0x1D067
  ,simpleTitleCaseMapping:0x1D067
 },
 { code:0x1D068
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D068
  ,simpleLowerCaseMapping:0x1D068
  ,simpleTitleCaseMapping:0x1D068
 },
 { code:0x1D069
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D069
  ,simpleLowerCaseMapping:0x1D069
  ,simpleTitleCaseMapping:0x1D069
 },
 { code:0x1D06A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D06A
  ,simpleLowerCaseMapping:0x1D06A
  ,simpleTitleCaseMapping:0x1D06A
 },
 { code:0x1D06B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D06B
  ,simpleLowerCaseMapping:0x1D06B
  ,simpleTitleCaseMapping:0x1D06B
 },
 { code:0x1D06C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D06C
  ,simpleLowerCaseMapping:0x1D06C
  ,simpleTitleCaseMapping:0x1D06C
 },
 { code:0x1D06D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D06D
  ,simpleLowerCaseMapping:0x1D06D
  ,simpleTitleCaseMapping:0x1D06D
 },
 { code:0x1D06E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D06E
  ,simpleLowerCaseMapping:0x1D06E
  ,simpleTitleCaseMapping:0x1D06E
 },
 { code:0x1D06F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D06F
  ,simpleLowerCaseMapping:0x1D06F
  ,simpleTitleCaseMapping:0x1D06F
 },
 { code:0x1D070
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D070
  ,simpleLowerCaseMapping:0x1D070
  ,simpleTitleCaseMapping:0x1D070
 },
 { code:0x1D071
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D071
  ,simpleLowerCaseMapping:0x1D071
  ,simpleTitleCaseMapping:0x1D071
 },
 { code:0x1D072
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D072
  ,simpleLowerCaseMapping:0x1D072
  ,simpleTitleCaseMapping:0x1D072
 },
 { code:0x1D073
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D073
  ,simpleLowerCaseMapping:0x1D073
  ,simpleTitleCaseMapping:0x1D073
 },
 { code:0x1D074
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D074
  ,simpleLowerCaseMapping:0x1D074
  ,simpleTitleCaseMapping:0x1D074
 },
 { code:0x1D075
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D075
  ,simpleLowerCaseMapping:0x1D075
  ,simpleTitleCaseMapping:0x1D075
 },
 { code:0x1D076
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D076
  ,simpleLowerCaseMapping:0x1D076
  ,simpleTitleCaseMapping:0x1D076
 },
 { code:0x1D077
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D077
  ,simpleLowerCaseMapping:0x1D077
  ,simpleTitleCaseMapping:0x1D077
 },
 { code:0x1D078
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D078
  ,simpleLowerCaseMapping:0x1D078
  ,simpleTitleCaseMapping:0x1D078
 },
 { code:0x1D079
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D079
  ,simpleLowerCaseMapping:0x1D079
  ,simpleTitleCaseMapping:0x1D079
 },
 { code:0x1D07A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D07A
  ,simpleLowerCaseMapping:0x1D07A
  ,simpleTitleCaseMapping:0x1D07A
 },
 { code:0x1D07B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D07B
  ,simpleLowerCaseMapping:0x1D07B
  ,simpleTitleCaseMapping:0x1D07B
 },
 { code:0x1D07C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D07C
  ,simpleLowerCaseMapping:0x1D07C
  ,simpleTitleCaseMapping:0x1D07C
 },
 { code:0x1D07D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D07D
  ,simpleLowerCaseMapping:0x1D07D
  ,simpleTitleCaseMapping:0x1D07D
 },
 { code:0x1D07E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D07E
  ,simpleLowerCaseMapping:0x1D07E
  ,simpleTitleCaseMapping:0x1D07E
 },
 { code:0x1D07F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D07F
  ,simpleLowerCaseMapping:0x1D07F
  ,simpleTitleCaseMapping:0x1D07F
 },
 { code:0x1D080
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D080
  ,simpleLowerCaseMapping:0x1D080
  ,simpleTitleCaseMapping:0x1D080
 },
 { code:0x1D081
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D081
  ,simpleLowerCaseMapping:0x1D081
  ,simpleTitleCaseMapping:0x1D081
 },
 { code:0x1D082
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D082
  ,simpleLowerCaseMapping:0x1D082
  ,simpleTitleCaseMapping:0x1D082
 },
 { code:0x1D083
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D083
  ,simpleLowerCaseMapping:0x1D083
  ,simpleTitleCaseMapping:0x1D083
 },
 { code:0x1D084
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D084
  ,simpleLowerCaseMapping:0x1D084
  ,simpleTitleCaseMapping:0x1D084
 },
 { code:0x1D085
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D085
  ,simpleLowerCaseMapping:0x1D085
  ,simpleTitleCaseMapping:0x1D085
 },
 { code:0x1D086
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D086
  ,simpleLowerCaseMapping:0x1D086
  ,simpleTitleCaseMapping:0x1D086
 },
 { code:0x1D087
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D087
  ,simpleLowerCaseMapping:0x1D087
  ,simpleTitleCaseMapping:0x1D087
 },
 { code:0x1D088
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D088
  ,simpleLowerCaseMapping:0x1D088
  ,simpleTitleCaseMapping:0x1D088
 },
 { code:0x1D089
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D089
  ,simpleLowerCaseMapping:0x1D089
  ,simpleTitleCaseMapping:0x1D089
 },
 { code:0x1D08A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D08A
  ,simpleLowerCaseMapping:0x1D08A
  ,simpleTitleCaseMapping:0x1D08A
 },
 { code:0x1D08B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D08B
  ,simpleLowerCaseMapping:0x1D08B
  ,simpleTitleCaseMapping:0x1D08B
 },
 { code:0x1D08C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D08C
  ,simpleLowerCaseMapping:0x1D08C
  ,simpleTitleCaseMapping:0x1D08C
 },
 { code:0x1D08D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D08D
  ,simpleLowerCaseMapping:0x1D08D
  ,simpleTitleCaseMapping:0x1D08D
 },
 { code:0x1D08E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D08E
  ,simpleLowerCaseMapping:0x1D08E
  ,simpleTitleCaseMapping:0x1D08E
 },
 { code:0x1D08F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D08F
  ,simpleLowerCaseMapping:0x1D08F
  ,simpleTitleCaseMapping:0x1D08F
 },
 { code:0x1D090
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D090
  ,simpleLowerCaseMapping:0x1D090
  ,simpleTitleCaseMapping:0x1D090
 },
 { code:0x1D091
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D091
  ,simpleLowerCaseMapping:0x1D091
  ,simpleTitleCaseMapping:0x1D091
 },
 { code:0x1D092
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D092
  ,simpleLowerCaseMapping:0x1D092
  ,simpleTitleCaseMapping:0x1D092
 },
 { code:0x1D093
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D093
  ,simpleLowerCaseMapping:0x1D093
  ,simpleTitleCaseMapping:0x1D093
 },
 { code:0x1D094
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D094
  ,simpleLowerCaseMapping:0x1D094
  ,simpleTitleCaseMapping:0x1D094
 },
 { code:0x1D095
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D095
  ,simpleLowerCaseMapping:0x1D095
  ,simpleTitleCaseMapping:0x1D095
 },
 { code:0x1D096
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D096
  ,simpleLowerCaseMapping:0x1D096
  ,simpleTitleCaseMapping:0x1D096
 },
 { code:0x1D097
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D097
  ,simpleLowerCaseMapping:0x1D097
  ,simpleTitleCaseMapping:0x1D097
 },
 { code:0x1D098
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D098
  ,simpleLowerCaseMapping:0x1D098
  ,simpleTitleCaseMapping:0x1D098
 },
 { code:0x1D099
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D099
  ,simpleLowerCaseMapping:0x1D099
  ,simpleTitleCaseMapping:0x1D099
 },
 { code:0x1D09A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D09A
  ,simpleLowerCaseMapping:0x1D09A
  ,simpleTitleCaseMapping:0x1D09A
 },
 { code:0x1D09B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D09B
  ,simpleLowerCaseMapping:0x1D09B
  ,simpleTitleCaseMapping:0x1D09B
 },
 { code:0x1D09C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D09C
  ,simpleLowerCaseMapping:0x1D09C
  ,simpleTitleCaseMapping:0x1D09C
 },
 { code:0x1D09D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D09D
  ,simpleLowerCaseMapping:0x1D09D
  ,simpleTitleCaseMapping:0x1D09D
 },
 { code:0x1D09E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D09E
  ,simpleLowerCaseMapping:0x1D09E
  ,simpleTitleCaseMapping:0x1D09E
 },
 { code:0x1D09F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D09F
  ,simpleLowerCaseMapping:0x1D09F
  ,simpleTitleCaseMapping:0x1D09F
 },
 { code:0x1D0A0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0A0
  ,simpleLowerCaseMapping:0x1D0A0
  ,simpleTitleCaseMapping:0x1D0A0
 },
 { code:0x1D0A1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0A1
  ,simpleLowerCaseMapping:0x1D0A1
  ,simpleTitleCaseMapping:0x1D0A1
 },
 { code:0x1D0A2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0A2
  ,simpleLowerCaseMapping:0x1D0A2
  ,simpleTitleCaseMapping:0x1D0A2
 },
 { code:0x1D0A3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0A3
  ,simpleLowerCaseMapping:0x1D0A3
  ,simpleTitleCaseMapping:0x1D0A3
 },
 { code:0x1D0A4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0A4
  ,simpleLowerCaseMapping:0x1D0A4
  ,simpleTitleCaseMapping:0x1D0A4
 },
 { code:0x1D0A5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0A5
  ,simpleLowerCaseMapping:0x1D0A5
  ,simpleTitleCaseMapping:0x1D0A5
 },
 { code:0x1D0A6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0A6
  ,simpleLowerCaseMapping:0x1D0A6
  ,simpleTitleCaseMapping:0x1D0A6
 },
 { code:0x1D0A7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0A7
  ,simpleLowerCaseMapping:0x1D0A7
  ,simpleTitleCaseMapping:0x1D0A7
 },
 { code:0x1D0A8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0A8
  ,simpleLowerCaseMapping:0x1D0A8
  ,simpleTitleCaseMapping:0x1D0A8
 },
 { code:0x1D0A9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0A9
  ,simpleLowerCaseMapping:0x1D0A9
  ,simpleTitleCaseMapping:0x1D0A9
 },
 { code:0x1D0AA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0AA
  ,simpleLowerCaseMapping:0x1D0AA
  ,simpleTitleCaseMapping:0x1D0AA
 },
 { code:0x1D0AB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0AB
  ,simpleLowerCaseMapping:0x1D0AB
  ,simpleTitleCaseMapping:0x1D0AB
 },
 { code:0x1D0AC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0AC
  ,simpleLowerCaseMapping:0x1D0AC
  ,simpleTitleCaseMapping:0x1D0AC
 },
 { code:0x1D0AD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0AD
  ,simpleLowerCaseMapping:0x1D0AD
  ,simpleTitleCaseMapping:0x1D0AD
 },
 { code:0x1D0AE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0AE
  ,simpleLowerCaseMapping:0x1D0AE
  ,simpleTitleCaseMapping:0x1D0AE
 },
 { code:0x1D0AF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0AF
  ,simpleLowerCaseMapping:0x1D0AF
  ,simpleTitleCaseMapping:0x1D0AF
 },
 { code:0x1D0B0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0B0
  ,simpleLowerCaseMapping:0x1D0B0
  ,simpleTitleCaseMapping:0x1D0B0
 },
 { code:0x1D0B1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0B1
  ,simpleLowerCaseMapping:0x1D0B1
  ,simpleTitleCaseMapping:0x1D0B1
 },
 { code:0x1D0B2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0B2
  ,simpleLowerCaseMapping:0x1D0B2
  ,simpleTitleCaseMapping:0x1D0B2
 },
 { code:0x1D0B3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0B3
  ,simpleLowerCaseMapping:0x1D0B3
  ,simpleTitleCaseMapping:0x1D0B3
 },
 { code:0x1D0B4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0B4
  ,simpleLowerCaseMapping:0x1D0B4
  ,simpleTitleCaseMapping:0x1D0B4
 },
 { code:0x1D0B5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0B5
  ,simpleLowerCaseMapping:0x1D0B5
  ,simpleTitleCaseMapping:0x1D0B5
 },
 { code:0x1D0B6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0B6
  ,simpleLowerCaseMapping:0x1D0B6
  ,simpleTitleCaseMapping:0x1D0B6
 },
 { code:0x1D0B7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0B7
  ,simpleLowerCaseMapping:0x1D0B7
  ,simpleTitleCaseMapping:0x1D0B7
 },
 { code:0x1D0B8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0B8
  ,simpleLowerCaseMapping:0x1D0B8
  ,simpleTitleCaseMapping:0x1D0B8
 },
 { code:0x1D0B9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0B9
  ,simpleLowerCaseMapping:0x1D0B9
  ,simpleTitleCaseMapping:0x1D0B9
 },
 { code:0x1D0BA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0BA
  ,simpleLowerCaseMapping:0x1D0BA
  ,simpleTitleCaseMapping:0x1D0BA
 },
 { code:0x1D0BB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0BB
  ,simpleLowerCaseMapping:0x1D0BB
  ,simpleTitleCaseMapping:0x1D0BB
 },
 { code:0x1D0BC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0BC
  ,simpleLowerCaseMapping:0x1D0BC
  ,simpleTitleCaseMapping:0x1D0BC
 },
 { code:0x1D0BD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0BD
  ,simpleLowerCaseMapping:0x1D0BD
  ,simpleTitleCaseMapping:0x1D0BD
 },
 { code:0x1D0BE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0BE
  ,simpleLowerCaseMapping:0x1D0BE
  ,simpleTitleCaseMapping:0x1D0BE
 },
 { code:0x1D0BF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0BF
  ,simpleLowerCaseMapping:0x1D0BF
  ,simpleTitleCaseMapping:0x1D0BF
 },
 { code:0x1D0C0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0C0
  ,simpleLowerCaseMapping:0x1D0C0
  ,simpleTitleCaseMapping:0x1D0C0
 },
 { code:0x1D0C1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0C1
  ,simpleLowerCaseMapping:0x1D0C1
  ,simpleTitleCaseMapping:0x1D0C1
 },
 { code:0x1D0C2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0C2
  ,simpleLowerCaseMapping:0x1D0C2
  ,simpleTitleCaseMapping:0x1D0C2
 },
 { code:0x1D0C3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0C3
  ,simpleLowerCaseMapping:0x1D0C3
  ,simpleTitleCaseMapping:0x1D0C3
 },
 { code:0x1D0C4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0C4
  ,simpleLowerCaseMapping:0x1D0C4
  ,simpleTitleCaseMapping:0x1D0C4
 },
 { code:0x1D0C5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0C5
  ,simpleLowerCaseMapping:0x1D0C5
  ,simpleTitleCaseMapping:0x1D0C5
 },
 { code:0x1D0C6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0C6
  ,simpleLowerCaseMapping:0x1D0C6
  ,simpleTitleCaseMapping:0x1D0C6
 },
 { code:0x1D0C7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0C7
  ,simpleLowerCaseMapping:0x1D0C7
  ,simpleTitleCaseMapping:0x1D0C7
 },
 { code:0x1D0C8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0C8
  ,simpleLowerCaseMapping:0x1D0C8
  ,simpleTitleCaseMapping:0x1D0C8
 },
 { code:0x1D0C9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0C9
  ,simpleLowerCaseMapping:0x1D0C9
  ,simpleTitleCaseMapping:0x1D0C9
 },
 { code:0x1D0CA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0CA
  ,simpleLowerCaseMapping:0x1D0CA
  ,simpleTitleCaseMapping:0x1D0CA
 },
 { code:0x1D0CB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0CB
  ,simpleLowerCaseMapping:0x1D0CB
  ,simpleTitleCaseMapping:0x1D0CB
 },
 { code:0x1D0CC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0CC
  ,simpleLowerCaseMapping:0x1D0CC
  ,simpleTitleCaseMapping:0x1D0CC
 },
 { code:0x1D0CD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0CD
  ,simpleLowerCaseMapping:0x1D0CD
  ,simpleTitleCaseMapping:0x1D0CD
 },
 { code:0x1D0CE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0CE
  ,simpleLowerCaseMapping:0x1D0CE
  ,simpleTitleCaseMapping:0x1D0CE
 },
 { code:0x1D0CF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0CF
  ,simpleLowerCaseMapping:0x1D0CF
  ,simpleTitleCaseMapping:0x1D0CF
 },
 { code:0x1D0D0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0D0
  ,simpleLowerCaseMapping:0x1D0D0
  ,simpleTitleCaseMapping:0x1D0D0
 },
 { code:0x1D0D1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0D1
  ,simpleLowerCaseMapping:0x1D0D1
  ,simpleTitleCaseMapping:0x1D0D1
 },
 { code:0x1D0D2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0D2
  ,simpleLowerCaseMapping:0x1D0D2
  ,simpleTitleCaseMapping:0x1D0D2
 },
 { code:0x1D0D3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0D3
  ,simpleLowerCaseMapping:0x1D0D3
  ,simpleTitleCaseMapping:0x1D0D3
 },
 { code:0x1D0D4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0D4
  ,simpleLowerCaseMapping:0x1D0D4
  ,simpleTitleCaseMapping:0x1D0D4
 },
 { code:0x1D0D5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0D5
  ,simpleLowerCaseMapping:0x1D0D5
  ,simpleTitleCaseMapping:0x1D0D5
 },
 { code:0x1D0D6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0D6
  ,simpleLowerCaseMapping:0x1D0D6
  ,simpleTitleCaseMapping:0x1D0D6
 },
 { code:0x1D0D7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0D7
  ,simpleLowerCaseMapping:0x1D0D7
  ,simpleTitleCaseMapping:0x1D0D7
 },
 { code:0x1D0D8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0D8
  ,simpleLowerCaseMapping:0x1D0D8
  ,simpleTitleCaseMapping:0x1D0D8
 },
 { code:0x1D0D9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0D9
  ,simpleLowerCaseMapping:0x1D0D9
  ,simpleTitleCaseMapping:0x1D0D9
 },
 { code:0x1D0DA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0DA
  ,simpleLowerCaseMapping:0x1D0DA
  ,simpleTitleCaseMapping:0x1D0DA
 },
 { code:0x1D0DB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0DB
  ,simpleLowerCaseMapping:0x1D0DB
  ,simpleTitleCaseMapping:0x1D0DB
 },
 { code:0x1D0DC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0DC
  ,simpleLowerCaseMapping:0x1D0DC
  ,simpleTitleCaseMapping:0x1D0DC
 },
 { code:0x1D0DD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0DD
  ,simpleLowerCaseMapping:0x1D0DD
  ,simpleTitleCaseMapping:0x1D0DD
 },
 { code:0x1D0DE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0DE
  ,simpleLowerCaseMapping:0x1D0DE
  ,simpleTitleCaseMapping:0x1D0DE
 },
 { code:0x1D0DF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0DF
  ,simpleLowerCaseMapping:0x1D0DF
  ,simpleTitleCaseMapping:0x1D0DF
 },
 { code:0x1D0E0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0E0
  ,simpleLowerCaseMapping:0x1D0E0
  ,simpleTitleCaseMapping:0x1D0E0
 },
 { code:0x1D0E1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0E1
  ,simpleLowerCaseMapping:0x1D0E1
  ,simpleTitleCaseMapping:0x1D0E1
 },
 { code:0x1D0E2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0E2
  ,simpleLowerCaseMapping:0x1D0E2
  ,simpleTitleCaseMapping:0x1D0E2
 },
 { code:0x1D0E3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0E3
  ,simpleLowerCaseMapping:0x1D0E3
  ,simpleTitleCaseMapping:0x1D0E3
 },
 { code:0x1D0E4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0E4
  ,simpleLowerCaseMapping:0x1D0E4
  ,simpleTitleCaseMapping:0x1D0E4
 },
 { code:0x1D0E5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0E5
  ,simpleLowerCaseMapping:0x1D0E5
  ,simpleTitleCaseMapping:0x1D0E5
 },
 { code:0x1D0E6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0E6
  ,simpleLowerCaseMapping:0x1D0E6
  ,simpleTitleCaseMapping:0x1D0E6
 },
 { code:0x1D0E7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0E7
  ,simpleLowerCaseMapping:0x1D0E7
  ,simpleTitleCaseMapping:0x1D0E7
 },
 { code:0x1D0E8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0E8
  ,simpleLowerCaseMapping:0x1D0E8
  ,simpleTitleCaseMapping:0x1D0E8
 },
 { code:0x1D0E9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0E9
  ,simpleLowerCaseMapping:0x1D0E9
  ,simpleTitleCaseMapping:0x1D0E9
 },
 { code:0x1D0EA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0EA
  ,simpleLowerCaseMapping:0x1D0EA
  ,simpleTitleCaseMapping:0x1D0EA
 },
 { code:0x1D0EB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0EB
  ,simpleLowerCaseMapping:0x1D0EB
  ,simpleTitleCaseMapping:0x1D0EB
 },
 { code:0x1D0EC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0EC
  ,simpleLowerCaseMapping:0x1D0EC
  ,simpleTitleCaseMapping:0x1D0EC
 },
 { code:0x1D0ED
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0ED
  ,simpleLowerCaseMapping:0x1D0ED
  ,simpleTitleCaseMapping:0x1D0ED
 },
 { code:0x1D0EE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0EE
  ,simpleLowerCaseMapping:0x1D0EE
  ,simpleTitleCaseMapping:0x1D0EE
 },
 { code:0x1D0EF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0EF
  ,simpleLowerCaseMapping:0x1D0EF
  ,simpleTitleCaseMapping:0x1D0EF
 },
 { code:0x1D0F0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0F0
  ,simpleLowerCaseMapping:0x1D0F0
  ,simpleTitleCaseMapping:0x1D0F0
 },
 { code:0x1D0F1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0F1
  ,simpleLowerCaseMapping:0x1D0F1
  ,simpleTitleCaseMapping:0x1D0F1
 },
 { code:0x1D0F2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0F2
  ,simpleLowerCaseMapping:0x1D0F2
  ,simpleTitleCaseMapping:0x1D0F2
 },
 { code:0x1D0F3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0F3
  ,simpleLowerCaseMapping:0x1D0F3
  ,simpleTitleCaseMapping:0x1D0F3
 },
 { code:0x1D0F4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0F4
  ,simpleLowerCaseMapping:0x1D0F4
  ,simpleTitleCaseMapping:0x1D0F4
 },
 { code:0x1D0F5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D0F5
  ,simpleLowerCaseMapping:0x1D0F5
  ,simpleTitleCaseMapping:0x1D0F5
 },
 { code:0x1D100
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D100
  ,simpleLowerCaseMapping:0x1D100
  ,simpleTitleCaseMapping:0x1D100
 },
 { code:0x1D101
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D101
  ,simpleLowerCaseMapping:0x1D101
  ,simpleTitleCaseMapping:0x1D101
 },
 { code:0x1D102
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D102
  ,simpleLowerCaseMapping:0x1D102
  ,simpleTitleCaseMapping:0x1D102
 },
 { code:0x1D103
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D103
  ,simpleLowerCaseMapping:0x1D103
  ,simpleTitleCaseMapping:0x1D103
 },
 { code:0x1D104
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D104
  ,simpleLowerCaseMapping:0x1D104
  ,simpleTitleCaseMapping:0x1D104
 },
 { code:0x1D105
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D105
  ,simpleLowerCaseMapping:0x1D105
  ,simpleTitleCaseMapping:0x1D105
 },
 { code:0x1D106
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D106
  ,simpleLowerCaseMapping:0x1D106
  ,simpleTitleCaseMapping:0x1D106
 },
 { code:0x1D107
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D107
  ,simpleLowerCaseMapping:0x1D107
  ,simpleTitleCaseMapping:0x1D107
 },
 { code:0x1D108
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D108
  ,simpleLowerCaseMapping:0x1D108
  ,simpleTitleCaseMapping:0x1D108
 },
 { code:0x1D109
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D109
  ,simpleLowerCaseMapping:0x1D109
  ,simpleTitleCaseMapping:0x1D109
 },
 { code:0x1D10A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D10A
  ,simpleLowerCaseMapping:0x1D10A
  ,simpleTitleCaseMapping:0x1D10A
 },
 { code:0x1D10B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D10B
  ,simpleLowerCaseMapping:0x1D10B
  ,simpleTitleCaseMapping:0x1D10B
 },
 { code:0x1D10C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D10C
  ,simpleLowerCaseMapping:0x1D10C
  ,simpleTitleCaseMapping:0x1D10C
 },
 { code:0x1D10D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D10D
  ,simpleLowerCaseMapping:0x1D10D
  ,simpleTitleCaseMapping:0x1D10D
 },
 { code:0x1D10E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D10E
  ,simpleLowerCaseMapping:0x1D10E
  ,simpleTitleCaseMapping:0x1D10E
 },
 { code:0x1D10F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D10F
  ,simpleLowerCaseMapping:0x1D10F
  ,simpleTitleCaseMapping:0x1D10F
 },
 { code:0x1D110
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D110
  ,simpleLowerCaseMapping:0x1D110
  ,simpleTitleCaseMapping:0x1D110
 },
 { code:0x1D111
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D111
  ,simpleLowerCaseMapping:0x1D111
  ,simpleTitleCaseMapping:0x1D111
 },
 { code:0x1D112
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D112
  ,simpleLowerCaseMapping:0x1D112
  ,simpleTitleCaseMapping:0x1D112
 },
 { code:0x1D113
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D113
  ,simpleLowerCaseMapping:0x1D113
  ,simpleTitleCaseMapping:0x1D113
 },
 { code:0x1D114
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D114
  ,simpleLowerCaseMapping:0x1D114
  ,simpleTitleCaseMapping:0x1D114
 },
 { code:0x1D115
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D115
  ,simpleLowerCaseMapping:0x1D115
  ,simpleTitleCaseMapping:0x1D115
 },
 { code:0x1D116
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D116
  ,simpleLowerCaseMapping:0x1D116
  ,simpleTitleCaseMapping:0x1D116
 },
 { code:0x1D117
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D117
  ,simpleLowerCaseMapping:0x1D117
  ,simpleTitleCaseMapping:0x1D117
 },
 { code:0x1D118
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D118
  ,simpleLowerCaseMapping:0x1D118
  ,simpleTitleCaseMapping:0x1D118
 },
 { code:0x1D119
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D119
  ,simpleLowerCaseMapping:0x1D119
  ,simpleTitleCaseMapping:0x1D119
 },
 { code:0x1D11A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D11A
  ,simpleLowerCaseMapping:0x1D11A
  ,simpleTitleCaseMapping:0x1D11A
 },
 { code:0x1D11B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D11B
  ,simpleLowerCaseMapping:0x1D11B
  ,simpleTitleCaseMapping:0x1D11B
 },
 { code:0x1D11C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D11C
  ,simpleLowerCaseMapping:0x1D11C
  ,simpleTitleCaseMapping:0x1D11C
 },
 { code:0x1D11D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D11D
  ,simpleLowerCaseMapping:0x1D11D
  ,simpleTitleCaseMapping:0x1D11D
 },
 { code:0x1D11E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D11E
  ,simpleLowerCaseMapping:0x1D11E
  ,simpleTitleCaseMapping:0x1D11E
 },
 { code:0x1D11F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D11F
  ,simpleLowerCaseMapping:0x1D11F
  ,simpleTitleCaseMapping:0x1D11F
 },
 { code:0x1D120
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D120
  ,simpleLowerCaseMapping:0x1D120
  ,simpleTitleCaseMapping:0x1D120
 },
 { code:0x1D121
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D121
  ,simpleLowerCaseMapping:0x1D121
  ,simpleTitleCaseMapping:0x1D121
 },
 { code:0x1D122
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D122
  ,simpleLowerCaseMapping:0x1D122
  ,simpleTitleCaseMapping:0x1D122
 },
 { code:0x1D123
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D123
  ,simpleLowerCaseMapping:0x1D123
  ,simpleTitleCaseMapping:0x1D123
 },
 { code:0x1D124
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D124
  ,simpleLowerCaseMapping:0x1D124
  ,simpleTitleCaseMapping:0x1D124
 },
 { code:0x1D125
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D125
  ,simpleLowerCaseMapping:0x1D125
  ,simpleTitleCaseMapping:0x1D125
 },
 { code:0x1D126
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D126
  ,simpleLowerCaseMapping:0x1D126
  ,simpleTitleCaseMapping:0x1D126
 },
 { code:0x1D12A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D12A
  ,simpleLowerCaseMapping:0x1D12A
  ,simpleTitleCaseMapping:0x1D12A
 },
 { code:0x1D12B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D12B
  ,simpleLowerCaseMapping:0x1D12B
  ,simpleTitleCaseMapping:0x1D12B
 },
 { code:0x1D12C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D12C
  ,simpleLowerCaseMapping:0x1D12C
  ,simpleTitleCaseMapping:0x1D12C
 },
 { code:0x1D12D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D12D
  ,simpleLowerCaseMapping:0x1D12D
  ,simpleTitleCaseMapping:0x1D12D
 },
 { code:0x1D12E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D12E
  ,simpleLowerCaseMapping:0x1D12E
  ,simpleTitleCaseMapping:0x1D12E
 },
 { code:0x1D12F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D12F
  ,simpleLowerCaseMapping:0x1D12F
  ,simpleTitleCaseMapping:0x1D12F
 },
 { code:0x1D130
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D130
  ,simpleLowerCaseMapping:0x1D130
  ,simpleTitleCaseMapping:0x1D130
 },
 { code:0x1D131
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D131
  ,simpleLowerCaseMapping:0x1D131
  ,simpleTitleCaseMapping:0x1D131
 },
 { code:0x1D132
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D132
  ,simpleLowerCaseMapping:0x1D132
  ,simpleTitleCaseMapping:0x1D132
 },
 { code:0x1D133
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D133
  ,simpleLowerCaseMapping:0x1D133
  ,simpleTitleCaseMapping:0x1D133
 },
 { code:0x1D134
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D134
  ,simpleLowerCaseMapping:0x1D134
  ,simpleTitleCaseMapping:0x1D134
 },
 { code:0x1D135
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D135
  ,simpleLowerCaseMapping:0x1D135
  ,simpleTitleCaseMapping:0x1D135
 },
 { code:0x1D136
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D136
  ,simpleLowerCaseMapping:0x1D136
  ,simpleTitleCaseMapping:0x1D136
 },
 { code:0x1D137
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D137
  ,simpleLowerCaseMapping:0x1D137
  ,simpleTitleCaseMapping:0x1D137
 },
 { code:0x1D138
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D138
  ,simpleLowerCaseMapping:0x1D138
  ,simpleTitleCaseMapping:0x1D138
 },
 { code:0x1D139
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D139
  ,simpleLowerCaseMapping:0x1D139
  ,simpleTitleCaseMapping:0x1D139
 },
 { code:0x1D13A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D13A
  ,simpleLowerCaseMapping:0x1D13A
  ,simpleTitleCaseMapping:0x1D13A
 },
 { code:0x1D13B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D13B
  ,simpleLowerCaseMapping:0x1D13B
  ,simpleTitleCaseMapping:0x1D13B
 },
 { code:0x1D13C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D13C
  ,simpleLowerCaseMapping:0x1D13C
  ,simpleTitleCaseMapping:0x1D13C
 },
 { code:0x1D13D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D13D
  ,simpleLowerCaseMapping:0x1D13D
  ,simpleTitleCaseMapping:0x1D13D
 },
 { code:0x1D13E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D13E
  ,simpleLowerCaseMapping:0x1D13E
  ,simpleTitleCaseMapping:0x1D13E
 },
 { code:0x1D13F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D13F
  ,simpleLowerCaseMapping:0x1D13F
  ,simpleTitleCaseMapping:0x1D13F
 },
 { code:0x1D140
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D140
  ,simpleLowerCaseMapping:0x1D140
  ,simpleTitleCaseMapping:0x1D140
 },
 { code:0x1D141
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D141
  ,simpleLowerCaseMapping:0x1D141
  ,simpleTitleCaseMapping:0x1D141
 },
 { code:0x1D142
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D142
  ,simpleLowerCaseMapping:0x1D142
  ,simpleTitleCaseMapping:0x1D142
 },
 { code:0x1D143
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D143
  ,simpleLowerCaseMapping:0x1D143
  ,simpleTitleCaseMapping:0x1D143
 },
 { code:0x1D144
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D144
  ,simpleLowerCaseMapping:0x1D144
  ,simpleTitleCaseMapping:0x1D144
 },
 { code:0x1D145
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D145
  ,simpleLowerCaseMapping:0x1D145
  ,simpleTitleCaseMapping:0x1D145
 },
 { code:0x1D146
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D146
  ,simpleLowerCaseMapping:0x1D146
  ,simpleTitleCaseMapping:0x1D146
 },
 { code:0x1D147
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D147
  ,simpleLowerCaseMapping:0x1D147
  ,simpleTitleCaseMapping:0x1D147
 },
 { code:0x1D148
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D148
  ,simpleLowerCaseMapping:0x1D148
  ,simpleTitleCaseMapping:0x1D148
 },
 { code:0x1D149
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D149
  ,simpleLowerCaseMapping:0x1D149
  ,simpleTitleCaseMapping:0x1D149
 },
 { code:0x1D14A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D14A
  ,simpleLowerCaseMapping:0x1D14A
  ,simpleTitleCaseMapping:0x1D14A
 },
 { code:0x1D14B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D14B
  ,simpleLowerCaseMapping:0x1D14B
  ,simpleTitleCaseMapping:0x1D14B
 },
 { code:0x1D14C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D14C
  ,simpleLowerCaseMapping:0x1D14C
  ,simpleTitleCaseMapping:0x1D14C
 },
 { code:0x1D14D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D14D
  ,simpleLowerCaseMapping:0x1D14D
  ,simpleTitleCaseMapping:0x1D14D
 },
 { code:0x1D14E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D14E
  ,simpleLowerCaseMapping:0x1D14E
  ,simpleTitleCaseMapping:0x1D14E
 },
 { code:0x1D14F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D14F
  ,simpleLowerCaseMapping:0x1D14F
  ,simpleTitleCaseMapping:0x1D14F
 },
 { code:0x1D150
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D150
  ,simpleLowerCaseMapping:0x1D150
  ,simpleTitleCaseMapping:0x1D150
 },
 { code:0x1D151
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D151
  ,simpleLowerCaseMapping:0x1D151
  ,simpleTitleCaseMapping:0x1D151
 },
 { code:0x1D152
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D152
  ,simpleLowerCaseMapping:0x1D152
  ,simpleTitleCaseMapping:0x1D152
 },
 { code:0x1D153
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D153
  ,simpleLowerCaseMapping:0x1D153
  ,simpleTitleCaseMapping:0x1D153
 },
 { code:0x1D154
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D154
  ,simpleLowerCaseMapping:0x1D154
  ,simpleTitleCaseMapping:0x1D154
 },
 { code:0x1D155
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D155
  ,simpleLowerCaseMapping:0x1D155
  ,simpleTitleCaseMapping:0x1D155
 },
 { code:0x1D156
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D156
  ,simpleLowerCaseMapping:0x1D156
  ,simpleTitleCaseMapping:0x1D156
 },
 { code:0x1D157
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D157
  ,simpleLowerCaseMapping:0x1D157
  ,simpleTitleCaseMapping:0x1D157
 },
 { code:0x1D158
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D158
  ,simpleLowerCaseMapping:0x1D158
  ,simpleTitleCaseMapping:0x1D158
 },
 { code:0x1D159
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D159
  ,simpleLowerCaseMapping:0x1D159
  ,simpleTitleCaseMapping:0x1D159
 },
 { code:0x1D15A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D15A
  ,simpleLowerCaseMapping:0x1D15A
  ,simpleTitleCaseMapping:0x1D15A
 },
 { code:0x1D15B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D15B
  ,simpleLowerCaseMapping:0x1D15B
  ,simpleTitleCaseMapping:0x1D15B
 },
 { code:0x1D15C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D15C
  ,simpleLowerCaseMapping:0x1D15C
  ,simpleTitleCaseMapping:0x1D15C
 },
 { code:0x1D15D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D15D
  ,simpleLowerCaseMapping:0x1D15D
  ,simpleTitleCaseMapping:0x1D15D
 },
 { code:0x1D15E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D15E
  ,simpleLowerCaseMapping:0x1D15E
  ,simpleTitleCaseMapping:0x1D15E
 },
 { code:0x1D15F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D15F
  ,simpleLowerCaseMapping:0x1D15F
  ,simpleTitleCaseMapping:0x1D15F
 },
 { code:0x1D160
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D160
  ,simpleLowerCaseMapping:0x1D160
  ,simpleTitleCaseMapping:0x1D160
 },
 { code:0x1D161
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D161
  ,simpleLowerCaseMapping:0x1D161
  ,simpleTitleCaseMapping:0x1D161
 },
 { code:0x1D162
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D162
  ,simpleLowerCaseMapping:0x1D162
  ,simpleTitleCaseMapping:0x1D162
 },
 { code:0x1D163
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D163
  ,simpleLowerCaseMapping:0x1D163
  ,simpleTitleCaseMapping:0x1D163
 },
 { code:0x1D164
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D164
  ,simpleLowerCaseMapping:0x1D164
  ,simpleTitleCaseMapping:0x1D164
 },
 { code:0x1D165
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1D165
  ,simpleLowerCaseMapping:0x1D165
  ,simpleTitleCaseMapping:0x1D165
 },
 { code:0x1D166
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1D166
  ,simpleLowerCaseMapping:0x1D166
  ,simpleTitleCaseMapping:0x1D166
 },
 { code:0x1D167
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D167
  ,simpleLowerCaseMapping:0x1D167
  ,simpleTitleCaseMapping:0x1D167
 },
 { code:0x1D168
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D168
  ,simpleLowerCaseMapping:0x1D168
  ,simpleTitleCaseMapping:0x1D168
 },
 { code:0x1D169
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D169
  ,simpleLowerCaseMapping:0x1D169
  ,simpleTitleCaseMapping:0x1D169
 },
 { code:0x1D16A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D16A
  ,simpleLowerCaseMapping:0x1D16A
  ,simpleTitleCaseMapping:0x1D16A
 },
 { code:0x1D16B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D16B
  ,simpleLowerCaseMapping:0x1D16B
  ,simpleTitleCaseMapping:0x1D16B
 },
 { code:0x1D16C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D16C
  ,simpleLowerCaseMapping:0x1D16C
  ,simpleTitleCaseMapping:0x1D16C
 },
 { code:0x1D16D
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1D16D
  ,simpleLowerCaseMapping:0x1D16D
  ,simpleTitleCaseMapping:0x1D16D
 },
 { code:0x1D16E
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1D16E
  ,simpleLowerCaseMapping:0x1D16E
  ,simpleTitleCaseMapping:0x1D16E
 },
 { code:0x1D16F
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1D16F
  ,simpleLowerCaseMapping:0x1D16F
  ,simpleTitleCaseMapping:0x1D16F
 },
 { code:0x1D170
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1D170
  ,simpleLowerCaseMapping:0x1D170
  ,simpleTitleCaseMapping:0x1D170
 },
 { code:0x1D171
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1D171
  ,simpleLowerCaseMapping:0x1D171
  ,simpleTitleCaseMapping:0x1D171
 },
 { code:0x1D172
  ,generalCategory:UnicodeData.GeneralCategory.Mc
  ,simpleUpperCaseMapping:0x1D172
  ,simpleLowerCaseMapping:0x1D172
  ,simpleTitleCaseMapping:0x1D172
 },
 { code:0x1D173
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x1D173
  ,simpleLowerCaseMapping:0x1D173
  ,simpleTitleCaseMapping:0x1D173
 },
 { code:0x1D174
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x1D174
  ,simpleLowerCaseMapping:0x1D174
  ,simpleTitleCaseMapping:0x1D174
 },
 { code:0x1D175
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x1D175
  ,simpleLowerCaseMapping:0x1D175
  ,simpleTitleCaseMapping:0x1D175
 },
 { code:0x1D176
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x1D176
  ,simpleLowerCaseMapping:0x1D176
  ,simpleTitleCaseMapping:0x1D176
 },
 { code:0x1D177
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x1D177
  ,simpleLowerCaseMapping:0x1D177
  ,simpleTitleCaseMapping:0x1D177
 },
 { code:0x1D178
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x1D178
  ,simpleLowerCaseMapping:0x1D178
  ,simpleTitleCaseMapping:0x1D178
 },
 { code:0x1D179
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x1D179
  ,simpleLowerCaseMapping:0x1D179
  ,simpleTitleCaseMapping:0x1D179
 },
 { code:0x1D17A
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0x1D17A
  ,simpleLowerCaseMapping:0x1D17A
  ,simpleTitleCaseMapping:0x1D17A
 },
 { code:0x1D17B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D17B
  ,simpleLowerCaseMapping:0x1D17B
  ,simpleTitleCaseMapping:0x1D17B
 },
 { code:0x1D17C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D17C
  ,simpleLowerCaseMapping:0x1D17C
  ,simpleTitleCaseMapping:0x1D17C
 },
 { code:0x1D17D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D17D
  ,simpleLowerCaseMapping:0x1D17D
  ,simpleTitleCaseMapping:0x1D17D
 },
 { code:0x1D17E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D17E
  ,simpleLowerCaseMapping:0x1D17E
  ,simpleTitleCaseMapping:0x1D17E
 },
 { code:0x1D17F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D17F
  ,simpleLowerCaseMapping:0x1D17F
  ,simpleTitleCaseMapping:0x1D17F
 },
 { code:0x1D180
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D180
  ,simpleLowerCaseMapping:0x1D180
  ,simpleTitleCaseMapping:0x1D180
 },
 { code:0x1D181
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D181
  ,simpleLowerCaseMapping:0x1D181
  ,simpleTitleCaseMapping:0x1D181
 },
 { code:0x1D182
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D182
  ,simpleLowerCaseMapping:0x1D182
  ,simpleTitleCaseMapping:0x1D182
 },
 { code:0x1D183
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D183
  ,simpleLowerCaseMapping:0x1D183
  ,simpleTitleCaseMapping:0x1D183
 },
 { code:0x1D184
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D184
  ,simpleLowerCaseMapping:0x1D184
  ,simpleTitleCaseMapping:0x1D184
 },
 { code:0x1D185
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D185
  ,simpleLowerCaseMapping:0x1D185
  ,simpleTitleCaseMapping:0x1D185
 },
 { code:0x1D186
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D186
  ,simpleLowerCaseMapping:0x1D186
  ,simpleTitleCaseMapping:0x1D186
 },
 { code:0x1D187
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D187
  ,simpleLowerCaseMapping:0x1D187
  ,simpleTitleCaseMapping:0x1D187
 },
 { code:0x1D188
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D188
  ,simpleLowerCaseMapping:0x1D188
  ,simpleTitleCaseMapping:0x1D188
 },
 { code:0x1D189
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D189
  ,simpleLowerCaseMapping:0x1D189
  ,simpleTitleCaseMapping:0x1D189
 },
 { code:0x1D18A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D18A
  ,simpleLowerCaseMapping:0x1D18A
  ,simpleTitleCaseMapping:0x1D18A
 },
 { code:0x1D18B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D18B
  ,simpleLowerCaseMapping:0x1D18B
  ,simpleTitleCaseMapping:0x1D18B
 },
 { code:0x1D18C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D18C
  ,simpleLowerCaseMapping:0x1D18C
  ,simpleTitleCaseMapping:0x1D18C
 },
 { code:0x1D18D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D18D
  ,simpleLowerCaseMapping:0x1D18D
  ,simpleTitleCaseMapping:0x1D18D
 },
 { code:0x1D18E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D18E
  ,simpleLowerCaseMapping:0x1D18E
  ,simpleTitleCaseMapping:0x1D18E
 },
 { code:0x1D18F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D18F
  ,simpleLowerCaseMapping:0x1D18F
  ,simpleTitleCaseMapping:0x1D18F
 },
 { code:0x1D190
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D190
  ,simpleLowerCaseMapping:0x1D190
  ,simpleTitleCaseMapping:0x1D190
 },
 { code:0x1D191
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D191
  ,simpleLowerCaseMapping:0x1D191
  ,simpleTitleCaseMapping:0x1D191
 },
 { code:0x1D192
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D192
  ,simpleLowerCaseMapping:0x1D192
  ,simpleTitleCaseMapping:0x1D192
 },
 { code:0x1D193
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D193
  ,simpleLowerCaseMapping:0x1D193
  ,simpleTitleCaseMapping:0x1D193
 },
 { code:0x1D194
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D194
  ,simpleLowerCaseMapping:0x1D194
  ,simpleTitleCaseMapping:0x1D194
 },
 { code:0x1D195
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D195
  ,simpleLowerCaseMapping:0x1D195
  ,simpleTitleCaseMapping:0x1D195
 },
 { code:0x1D196
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D196
  ,simpleLowerCaseMapping:0x1D196
  ,simpleTitleCaseMapping:0x1D196
 },
 { code:0x1D197
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D197
  ,simpleLowerCaseMapping:0x1D197
  ,simpleTitleCaseMapping:0x1D197
 },
 { code:0x1D198
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D198
  ,simpleLowerCaseMapping:0x1D198
  ,simpleTitleCaseMapping:0x1D198
 },
 { code:0x1D199
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D199
  ,simpleLowerCaseMapping:0x1D199
  ,simpleTitleCaseMapping:0x1D199
 },
 { code:0x1D19A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D19A
  ,simpleLowerCaseMapping:0x1D19A
  ,simpleTitleCaseMapping:0x1D19A
 },
 { code:0x1D19B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D19B
  ,simpleLowerCaseMapping:0x1D19B
  ,simpleTitleCaseMapping:0x1D19B
 },
 { code:0x1D19C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D19C
  ,simpleLowerCaseMapping:0x1D19C
  ,simpleTitleCaseMapping:0x1D19C
 },
 { code:0x1D19D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D19D
  ,simpleLowerCaseMapping:0x1D19D
  ,simpleTitleCaseMapping:0x1D19D
 },
 { code:0x1D19E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D19E
  ,simpleLowerCaseMapping:0x1D19E
  ,simpleTitleCaseMapping:0x1D19E
 },
 { code:0x1D19F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D19F
  ,simpleLowerCaseMapping:0x1D19F
  ,simpleTitleCaseMapping:0x1D19F
 },
 { code:0x1D1A0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1A0
  ,simpleLowerCaseMapping:0x1D1A0
  ,simpleTitleCaseMapping:0x1D1A0
 },
 { code:0x1D1A1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1A1
  ,simpleLowerCaseMapping:0x1D1A1
  ,simpleTitleCaseMapping:0x1D1A1
 },
 { code:0x1D1A2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1A2
  ,simpleLowerCaseMapping:0x1D1A2
  ,simpleTitleCaseMapping:0x1D1A2
 },
 { code:0x1D1A3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1A3
  ,simpleLowerCaseMapping:0x1D1A3
  ,simpleTitleCaseMapping:0x1D1A3
 },
 { code:0x1D1A4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1A4
  ,simpleLowerCaseMapping:0x1D1A4
  ,simpleTitleCaseMapping:0x1D1A4
 },
 { code:0x1D1A5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1A5
  ,simpleLowerCaseMapping:0x1D1A5
  ,simpleTitleCaseMapping:0x1D1A5
 },
 { code:0x1D1A6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1A6
  ,simpleLowerCaseMapping:0x1D1A6
  ,simpleTitleCaseMapping:0x1D1A6
 },
 { code:0x1D1A7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1A7
  ,simpleLowerCaseMapping:0x1D1A7
  ,simpleTitleCaseMapping:0x1D1A7
 },
 { code:0x1D1A8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1A8
  ,simpleLowerCaseMapping:0x1D1A8
  ,simpleTitleCaseMapping:0x1D1A8
 },
 { code:0x1D1A9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1A9
  ,simpleLowerCaseMapping:0x1D1A9
  ,simpleTitleCaseMapping:0x1D1A9
 },
 { code:0x1D1AA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D1AA
  ,simpleLowerCaseMapping:0x1D1AA
  ,simpleTitleCaseMapping:0x1D1AA
 },
 { code:0x1D1AB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D1AB
  ,simpleLowerCaseMapping:0x1D1AB
  ,simpleTitleCaseMapping:0x1D1AB
 },
 { code:0x1D1AC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D1AC
  ,simpleLowerCaseMapping:0x1D1AC
  ,simpleTitleCaseMapping:0x1D1AC
 },
 { code:0x1D1AD
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D1AD
  ,simpleLowerCaseMapping:0x1D1AD
  ,simpleTitleCaseMapping:0x1D1AD
 },
 { code:0x1D1AE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1AE
  ,simpleLowerCaseMapping:0x1D1AE
  ,simpleTitleCaseMapping:0x1D1AE
 },
 { code:0x1D1AF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1AF
  ,simpleLowerCaseMapping:0x1D1AF
  ,simpleTitleCaseMapping:0x1D1AF
 },
 { code:0x1D1B0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1B0
  ,simpleLowerCaseMapping:0x1D1B0
  ,simpleTitleCaseMapping:0x1D1B0
 },
 { code:0x1D1B1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1B1
  ,simpleLowerCaseMapping:0x1D1B1
  ,simpleTitleCaseMapping:0x1D1B1
 },
 { code:0x1D1B2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1B2
  ,simpleLowerCaseMapping:0x1D1B2
  ,simpleTitleCaseMapping:0x1D1B2
 },
 { code:0x1D1B3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1B3
  ,simpleLowerCaseMapping:0x1D1B3
  ,simpleTitleCaseMapping:0x1D1B3
 },
 { code:0x1D1B4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1B4
  ,simpleLowerCaseMapping:0x1D1B4
  ,simpleTitleCaseMapping:0x1D1B4
 },
 { code:0x1D1B5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1B5
  ,simpleLowerCaseMapping:0x1D1B5
  ,simpleTitleCaseMapping:0x1D1B5
 },
 { code:0x1D1B6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1B6
  ,simpleLowerCaseMapping:0x1D1B6
  ,simpleTitleCaseMapping:0x1D1B6
 },
 { code:0x1D1B7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1B7
  ,simpleLowerCaseMapping:0x1D1B7
  ,simpleTitleCaseMapping:0x1D1B7
 },
 { code:0x1D1B8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1B8
  ,simpleLowerCaseMapping:0x1D1B8
  ,simpleTitleCaseMapping:0x1D1B8
 },
 { code:0x1D1B9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1B9
  ,simpleLowerCaseMapping:0x1D1B9
  ,simpleTitleCaseMapping:0x1D1B9
 },
 { code:0x1D1BA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1BA
  ,simpleLowerCaseMapping:0x1D1BA
  ,simpleTitleCaseMapping:0x1D1BA
 },
 { code:0x1D1BB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1BB
  ,simpleLowerCaseMapping:0x1D1BB
  ,simpleTitleCaseMapping:0x1D1BB
 },
 { code:0x1D1BC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1BC
  ,simpleLowerCaseMapping:0x1D1BC
  ,simpleTitleCaseMapping:0x1D1BC
 },
 { code:0x1D1BD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1BD
  ,simpleLowerCaseMapping:0x1D1BD
  ,simpleTitleCaseMapping:0x1D1BD
 },
 { code:0x1D1BE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1BE
  ,simpleLowerCaseMapping:0x1D1BE
  ,simpleTitleCaseMapping:0x1D1BE
 },
 { code:0x1D1BF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1BF
  ,simpleLowerCaseMapping:0x1D1BF
  ,simpleTitleCaseMapping:0x1D1BF
 },
 { code:0x1D1C0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1C0
  ,simpleLowerCaseMapping:0x1D1C0
  ,simpleTitleCaseMapping:0x1D1C0
 },
 { code:0x1D1C1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1C1
  ,simpleLowerCaseMapping:0x1D1C1
  ,simpleTitleCaseMapping:0x1D1C1
 },
 { code:0x1D1C2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1C2
  ,simpleLowerCaseMapping:0x1D1C2
  ,simpleTitleCaseMapping:0x1D1C2
 },
 { code:0x1D1C3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1C3
  ,simpleLowerCaseMapping:0x1D1C3
  ,simpleTitleCaseMapping:0x1D1C3
 },
 { code:0x1D1C4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1C4
  ,simpleLowerCaseMapping:0x1D1C4
  ,simpleTitleCaseMapping:0x1D1C4
 },
 { code:0x1D1C5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1C5
  ,simpleLowerCaseMapping:0x1D1C5
  ,simpleTitleCaseMapping:0x1D1C5
 },
 { code:0x1D1C6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1C6
  ,simpleLowerCaseMapping:0x1D1C6
  ,simpleTitleCaseMapping:0x1D1C6
 },
 { code:0x1D1C7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1C7
  ,simpleLowerCaseMapping:0x1D1C7
  ,simpleTitleCaseMapping:0x1D1C7
 },
 { code:0x1D1C8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1C8
  ,simpleLowerCaseMapping:0x1D1C8
  ,simpleTitleCaseMapping:0x1D1C8
 },
 { code:0x1D1C9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1C9
  ,simpleLowerCaseMapping:0x1D1C9
  ,simpleTitleCaseMapping:0x1D1C9
 },
 { code:0x1D1CA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1CA
  ,simpleLowerCaseMapping:0x1D1CA
  ,simpleTitleCaseMapping:0x1D1CA
 },
 { code:0x1D1CB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1CB
  ,simpleLowerCaseMapping:0x1D1CB
  ,simpleTitleCaseMapping:0x1D1CB
 },
 { code:0x1D1CC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1CC
  ,simpleLowerCaseMapping:0x1D1CC
  ,simpleTitleCaseMapping:0x1D1CC
 },
 { code:0x1D1CD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1CD
  ,simpleLowerCaseMapping:0x1D1CD
  ,simpleTitleCaseMapping:0x1D1CD
 },
 { code:0x1D1CE
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1CE
  ,simpleLowerCaseMapping:0x1D1CE
  ,simpleTitleCaseMapping:0x1D1CE
 },
 { code:0x1D1CF
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1CF
  ,simpleLowerCaseMapping:0x1D1CF
  ,simpleTitleCaseMapping:0x1D1CF
 },
 { code:0x1D1D0
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1D0
  ,simpleLowerCaseMapping:0x1D1D0
  ,simpleTitleCaseMapping:0x1D1D0
 },
 { code:0x1D1D1
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1D1
  ,simpleLowerCaseMapping:0x1D1D1
  ,simpleTitleCaseMapping:0x1D1D1
 },
 { code:0x1D1D2
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1D2
  ,simpleLowerCaseMapping:0x1D1D2
  ,simpleTitleCaseMapping:0x1D1D2
 },
 { code:0x1D1D3
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1D3
  ,simpleLowerCaseMapping:0x1D1D3
  ,simpleTitleCaseMapping:0x1D1D3
 },
 { code:0x1D1D4
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1D4
  ,simpleLowerCaseMapping:0x1D1D4
  ,simpleTitleCaseMapping:0x1D1D4
 },
 { code:0x1D1D5
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1D5
  ,simpleLowerCaseMapping:0x1D1D5
  ,simpleTitleCaseMapping:0x1D1D5
 },
 { code:0x1D1D6
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1D6
  ,simpleLowerCaseMapping:0x1D1D6
  ,simpleTitleCaseMapping:0x1D1D6
 },
 { code:0x1D1D7
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1D7
  ,simpleLowerCaseMapping:0x1D1D7
  ,simpleTitleCaseMapping:0x1D1D7
 },
 { code:0x1D1D8
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1D8
  ,simpleLowerCaseMapping:0x1D1D8
  ,simpleTitleCaseMapping:0x1D1D8
 },
 { code:0x1D1D9
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1D9
  ,simpleLowerCaseMapping:0x1D1D9
  ,simpleTitleCaseMapping:0x1D1D9
 },
 { code:0x1D1DA
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1DA
  ,simpleLowerCaseMapping:0x1D1DA
  ,simpleTitleCaseMapping:0x1D1DA
 },
 { code:0x1D1DB
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1DB
  ,simpleLowerCaseMapping:0x1D1DB
  ,simpleTitleCaseMapping:0x1D1DB
 },
 { code:0x1D1DC
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1DC
  ,simpleLowerCaseMapping:0x1D1DC
  ,simpleTitleCaseMapping:0x1D1DC
 },
 { code:0x1D1DD
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D1DD
  ,simpleLowerCaseMapping:0x1D1DD
  ,simpleTitleCaseMapping:0x1D1DD
 },
 { code:0x1D200
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D200
  ,simpleLowerCaseMapping:0x1D200
  ,simpleTitleCaseMapping:0x1D200
 },
 { code:0x1D201
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D201
  ,simpleLowerCaseMapping:0x1D201
  ,simpleTitleCaseMapping:0x1D201
 },
 { code:0x1D202
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D202
  ,simpleLowerCaseMapping:0x1D202
  ,simpleTitleCaseMapping:0x1D202
 },
 { code:0x1D203
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D203
  ,simpleLowerCaseMapping:0x1D203
  ,simpleTitleCaseMapping:0x1D203
 },
 { code:0x1D204
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D204
  ,simpleLowerCaseMapping:0x1D204
  ,simpleTitleCaseMapping:0x1D204
 },
 { code:0x1D205
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D205
  ,simpleLowerCaseMapping:0x1D205
  ,simpleTitleCaseMapping:0x1D205
 },
 { code:0x1D206
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D206
  ,simpleLowerCaseMapping:0x1D206
  ,simpleTitleCaseMapping:0x1D206
 },
 { code:0x1D207
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D207
  ,simpleLowerCaseMapping:0x1D207
  ,simpleTitleCaseMapping:0x1D207
 },
 { code:0x1D208
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D208
  ,simpleLowerCaseMapping:0x1D208
  ,simpleTitleCaseMapping:0x1D208
 },
 { code:0x1D209
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D209
  ,simpleLowerCaseMapping:0x1D209
  ,simpleTitleCaseMapping:0x1D209
 },
 { code:0x1D20A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D20A
  ,simpleLowerCaseMapping:0x1D20A
  ,simpleTitleCaseMapping:0x1D20A
 },
 { code:0x1D20B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D20B
  ,simpleLowerCaseMapping:0x1D20B
  ,simpleTitleCaseMapping:0x1D20B
 },
 { code:0x1D20C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D20C
  ,simpleLowerCaseMapping:0x1D20C
  ,simpleTitleCaseMapping:0x1D20C
 },
 { code:0x1D20D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D20D
  ,simpleLowerCaseMapping:0x1D20D
  ,simpleTitleCaseMapping:0x1D20D
 },
 { code:0x1D20E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D20E
  ,simpleLowerCaseMapping:0x1D20E
  ,simpleTitleCaseMapping:0x1D20E
 },
 { code:0x1D20F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D20F
  ,simpleLowerCaseMapping:0x1D20F
  ,simpleTitleCaseMapping:0x1D20F
 },
 { code:0x1D210
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D210
  ,simpleLowerCaseMapping:0x1D210
  ,simpleTitleCaseMapping:0x1D210
 },
 { code:0x1D211
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D211
  ,simpleLowerCaseMapping:0x1D211
  ,simpleTitleCaseMapping:0x1D211
 },
 { code:0x1D212
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D212
  ,simpleLowerCaseMapping:0x1D212
  ,simpleTitleCaseMapping:0x1D212
 },
 { code:0x1D213
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D213
  ,simpleLowerCaseMapping:0x1D213
  ,simpleTitleCaseMapping:0x1D213
 },
 { code:0x1D214
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D214
  ,simpleLowerCaseMapping:0x1D214
  ,simpleTitleCaseMapping:0x1D214
 },
 { code:0x1D215
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D215
  ,simpleLowerCaseMapping:0x1D215
  ,simpleTitleCaseMapping:0x1D215
 },
 { code:0x1D216
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D216
  ,simpleLowerCaseMapping:0x1D216
  ,simpleTitleCaseMapping:0x1D216
 },
 { code:0x1D217
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D217
  ,simpleLowerCaseMapping:0x1D217
  ,simpleTitleCaseMapping:0x1D217
 },
 { code:0x1D218
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D218
  ,simpleLowerCaseMapping:0x1D218
  ,simpleTitleCaseMapping:0x1D218
 },
 { code:0x1D219
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D219
  ,simpleLowerCaseMapping:0x1D219
  ,simpleTitleCaseMapping:0x1D219
 },
 { code:0x1D21A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D21A
  ,simpleLowerCaseMapping:0x1D21A
  ,simpleTitleCaseMapping:0x1D21A
 },
 { code:0x1D21B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D21B
  ,simpleLowerCaseMapping:0x1D21B
  ,simpleTitleCaseMapping:0x1D21B
 },
 { code:0x1D21C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D21C
  ,simpleLowerCaseMapping:0x1D21C
  ,simpleTitleCaseMapping:0x1D21C
 },
 { code:0x1D21D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D21D
  ,simpleLowerCaseMapping:0x1D21D
  ,simpleTitleCaseMapping:0x1D21D
 },
 { code:0x1D21E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D21E
  ,simpleLowerCaseMapping:0x1D21E
  ,simpleTitleCaseMapping:0x1D21E
 },
 { code:0x1D21F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D21F
  ,simpleLowerCaseMapping:0x1D21F
  ,simpleTitleCaseMapping:0x1D21F
 },
 { code:0x1D220
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D220
  ,simpleLowerCaseMapping:0x1D220
  ,simpleTitleCaseMapping:0x1D220
 },
 { code:0x1D221
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D221
  ,simpleLowerCaseMapping:0x1D221
  ,simpleTitleCaseMapping:0x1D221
 },
 { code:0x1D222
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D222
  ,simpleLowerCaseMapping:0x1D222
  ,simpleTitleCaseMapping:0x1D222
 },
 { code:0x1D223
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D223
  ,simpleLowerCaseMapping:0x1D223
  ,simpleTitleCaseMapping:0x1D223
 },
 { code:0x1D224
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D224
  ,simpleLowerCaseMapping:0x1D224
  ,simpleTitleCaseMapping:0x1D224
 },
 { code:0x1D225
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D225
  ,simpleLowerCaseMapping:0x1D225
  ,simpleTitleCaseMapping:0x1D225
 },
 { code:0x1D226
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D226
  ,simpleLowerCaseMapping:0x1D226
  ,simpleTitleCaseMapping:0x1D226
 },
 { code:0x1D227
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D227
  ,simpleLowerCaseMapping:0x1D227
  ,simpleTitleCaseMapping:0x1D227
 },
 { code:0x1D228
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D228
  ,simpleLowerCaseMapping:0x1D228
  ,simpleTitleCaseMapping:0x1D228
 },
 { code:0x1D229
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D229
  ,simpleLowerCaseMapping:0x1D229
  ,simpleTitleCaseMapping:0x1D229
 },
 { code:0x1D22A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D22A
  ,simpleLowerCaseMapping:0x1D22A
  ,simpleTitleCaseMapping:0x1D22A
 },
 { code:0x1D22B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D22B
  ,simpleLowerCaseMapping:0x1D22B
  ,simpleTitleCaseMapping:0x1D22B
 },
 { code:0x1D22C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D22C
  ,simpleLowerCaseMapping:0x1D22C
  ,simpleTitleCaseMapping:0x1D22C
 },
 { code:0x1D22D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D22D
  ,simpleLowerCaseMapping:0x1D22D
  ,simpleTitleCaseMapping:0x1D22D
 },
 { code:0x1D22E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D22E
  ,simpleLowerCaseMapping:0x1D22E
  ,simpleTitleCaseMapping:0x1D22E
 },
 { code:0x1D22F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D22F
  ,simpleLowerCaseMapping:0x1D22F
  ,simpleTitleCaseMapping:0x1D22F
 },
 { code:0x1D230
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D230
  ,simpleLowerCaseMapping:0x1D230
  ,simpleTitleCaseMapping:0x1D230
 },
 { code:0x1D231
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D231
  ,simpleLowerCaseMapping:0x1D231
  ,simpleTitleCaseMapping:0x1D231
 },
 { code:0x1D232
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D232
  ,simpleLowerCaseMapping:0x1D232
  ,simpleTitleCaseMapping:0x1D232
 },
 { code:0x1D233
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D233
  ,simpleLowerCaseMapping:0x1D233
  ,simpleTitleCaseMapping:0x1D233
 },
 { code:0x1D234
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D234
  ,simpleLowerCaseMapping:0x1D234
  ,simpleTitleCaseMapping:0x1D234
 },
 { code:0x1D235
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D235
  ,simpleLowerCaseMapping:0x1D235
  ,simpleTitleCaseMapping:0x1D235
 },
 { code:0x1D236
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D236
  ,simpleLowerCaseMapping:0x1D236
  ,simpleTitleCaseMapping:0x1D236
 },
 { code:0x1D237
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D237
  ,simpleLowerCaseMapping:0x1D237
  ,simpleTitleCaseMapping:0x1D237
 },
 { code:0x1D238
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D238
  ,simpleLowerCaseMapping:0x1D238
  ,simpleTitleCaseMapping:0x1D238
 },
 { code:0x1D239
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D239
  ,simpleLowerCaseMapping:0x1D239
  ,simpleTitleCaseMapping:0x1D239
 },
 { code:0x1D23A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D23A
  ,simpleLowerCaseMapping:0x1D23A
  ,simpleTitleCaseMapping:0x1D23A
 },
 { code:0x1D23B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D23B
  ,simpleLowerCaseMapping:0x1D23B
  ,simpleTitleCaseMapping:0x1D23B
 },
 { code:0x1D23C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D23C
  ,simpleLowerCaseMapping:0x1D23C
  ,simpleTitleCaseMapping:0x1D23C
 },
 { code:0x1D23D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D23D
  ,simpleLowerCaseMapping:0x1D23D
  ,simpleTitleCaseMapping:0x1D23D
 },
 { code:0x1D23E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D23E
  ,simpleLowerCaseMapping:0x1D23E
  ,simpleTitleCaseMapping:0x1D23E
 },
 { code:0x1D23F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D23F
  ,simpleLowerCaseMapping:0x1D23F
  ,simpleTitleCaseMapping:0x1D23F
 },
 { code:0x1D240
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D240
  ,simpleLowerCaseMapping:0x1D240
  ,simpleTitleCaseMapping:0x1D240
 },
 { code:0x1D241
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D241
  ,simpleLowerCaseMapping:0x1D241
  ,simpleTitleCaseMapping:0x1D241
 },
 { code:0x1D242
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D242
  ,simpleLowerCaseMapping:0x1D242
  ,simpleTitleCaseMapping:0x1D242
 },
 { code:0x1D243
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D243
  ,simpleLowerCaseMapping:0x1D243
  ,simpleTitleCaseMapping:0x1D243
 },
 { code:0x1D244
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0x1D244
  ,simpleLowerCaseMapping:0x1D244
  ,simpleTitleCaseMapping:0x1D244
 },
 { code:0x1D245
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D245
  ,simpleLowerCaseMapping:0x1D245
  ,simpleTitleCaseMapping:0x1D245
 },
 { code:0x1D300
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D300
  ,simpleLowerCaseMapping:0x1D300
  ,simpleTitleCaseMapping:0x1D300
 },
 { code:0x1D301
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D301
  ,simpleLowerCaseMapping:0x1D301
  ,simpleTitleCaseMapping:0x1D301
 },
 { code:0x1D302
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D302
  ,simpleLowerCaseMapping:0x1D302
  ,simpleTitleCaseMapping:0x1D302
 },
 { code:0x1D303
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D303
  ,simpleLowerCaseMapping:0x1D303
  ,simpleTitleCaseMapping:0x1D303
 },
 { code:0x1D304
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D304
  ,simpleLowerCaseMapping:0x1D304
  ,simpleTitleCaseMapping:0x1D304
 },
 { code:0x1D305
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D305
  ,simpleLowerCaseMapping:0x1D305
  ,simpleTitleCaseMapping:0x1D305
 },
 { code:0x1D306
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D306
  ,simpleLowerCaseMapping:0x1D306
  ,simpleTitleCaseMapping:0x1D306
 },
 { code:0x1D307
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D307
  ,simpleLowerCaseMapping:0x1D307
  ,simpleTitleCaseMapping:0x1D307
 },
 { code:0x1D308
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D308
  ,simpleLowerCaseMapping:0x1D308
  ,simpleTitleCaseMapping:0x1D308
 },
 { code:0x1D309
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D309
  ,simpleLowerCaseMapping:0x1D309
  ,simpleTitleCaseMapping:0x1D309
 },
 { code:0x1D30A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D30A
  ,simpleLowerCaseMapping:0x1D30A
  ,simpleTitleCaseMapping:0x1D30A
 },
 { code:0x1D30B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D30B
  ,simpleLowerCaseMapping:0x1D30B
  ,simpleTitleCaseMapping:0x1D30B
 },
 { code:0x1D30C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D30C
  ,simpleLowerCaseMapping:0x1D30C
  ,simpleTitleCaseMapping:0x1D30C
 },
 { code:0x1D30D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D30D
  ,simpleLowerCaseMapping:0x1D30D
  ,simpleTitleCaseMapping:0x1D30D
 },
 { code:0x1D30E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D30E
  ,simpleLowerCaseMapping:0x1D30E
  ,simpleTitleCaseMapping:0x1D30E
 },
 { code:0x1D30F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D30F
  ,simpleLowerCaseMapping:0x1D30F
  ,simpleTitleCaseMapping:0x1D30F
 },
 { code:0x1D310
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D310
  ,simpleLowerCaseMapping:0x1D310
  ,simpleTitleCaseMapping:0x1D310
 },
 { code:0x1D311
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D311
  ,simpleLowerCaseMapping:0x1D311
  ,simpleTitleCaseMapping:0x1D311
 },
 { code:0x1D312
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D312
  ,simpleLowerCaseMapping:0x1D312
  ,simpleTitleCaseMapping:0x1D312
 },
 { code:0x1D313
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D313
  ,simpleLowerCaseMapping:0x1D313
  ,simpleTitleCaseMapping:0x1D313
 },
 { code:0x1D314
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D314
  ,simpleLowerCaseMapping:0x1D314
  ,simpleTitleCaseMapping:0x1D314
 },
 { code:0x1D315
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D315
  ,simpleLowerCaseMapping:0x1D315
  ,simpleTitleCaseMapping:0x1D315
 },
 { code:0x1D316
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D316
  ,simpleLowerCaseMapping:0x1D316
  ,simpleTitleCaseMapping:0x1D316
 },
 { code:0x1D317
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D317
  ,simpleLowerCaseMapping:0x1D317
  ,simpleTitleCaseMapping:0x1D317
 },
 { code:0x1D318
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D318
  ,simpleLowerCaseMapping:0x1D318
  ,simpleTitleCaseMapping:0x1D318
 },
 { code:0x1D319
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D319
  ,simpleLowerCaseMapping:0x1D319
  ,simpleTitleCaseMapping:0x1D319
 },
 { code:0x1D31A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D31A
  ,simpleLowerCaseMapping:0x1D31A
  ,simpleTitleCaseMapping:0x1D31A
 },
 { code:0x1D31B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D31B
  ,simpleLowerCaseMapping:0x1D31B
  ,simpleTitleCaseMapping:0x1D31B
 },
 { code:0x1D31C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D31C
  ,simpleLowerCaseMapping:0x1D31C
  ,simpleTitleCaseMapping:0x1D31C
 },
 { code:0x1D31D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D31D
  ,simpleLowerCaseMapping:0x1D31D
  ,simpleTitleCaseMapping:0x1D31D
 },
 { code:0x1D31E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D31E
  ,simpleLowerCaseMapping:0x1D31E
  ,simpleTitleCaseMapping:0x1D31E
 },
 { code:0x1D31F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D31F
  ,simpleLowerCaseMapping:0x1D31F
  ,simpleTitleCaseMapping:0x1D31F
 },
 { code:0x1D320
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D320
  ,simpleLowerCaseMapping:0x1D320
  ,simpleTitleCaseMapping:0x1D320
 },
 { code:0x1D321
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D321
  ,simpleLowerCaseMapping:0x1D321
  ,simpleTitleCaseMapping:0x1D321
 },
 { code:0x1D322
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D322
  ,simpleLowerCaseMapping:0x1D322
  ,simpleTitleCaseMapping:0x1D322
 },
 { code:0x1D323
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D323
  ,simpleLowerCaseMapping:0x1D323
  ,simpleTitleCaseMapping:0x1D323
 },
 { code:0x1D324
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D324
  ,simpleLowerCaseMapping:0x1D324
  ,simpleTitleCaseMapping:0x1D324
 },
 { code:0x1D325
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D325
  ,simpleLowerCaseMapping:0x1D325
  ,simpleTitleCaseMapping:0x1D325
 },
 { code:0x1D326
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D326
  ,simpleLowerCaseMapping:0x1D326
  ,simpleTitleCaseMapping:0x1D326
 },
 { code:0x1D327
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D327
  ,simpleLowerCaseMapping:0x1D327
  ,simpleTitleCaseMapping:0x1D327
 },
 { code:0x1D328
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D328
  ,simpleLowerCaseMapping:0x1D328
  ,simpleTitleCaseMapping:0x1D328
 },
 { code:0x1D329
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D329
  ,simpleLowerCaseMapping:0x1D329
  ,simpleTitleCaseMapping:0x1D329
 },
 { code:0x1D32A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D32A
  ,simpleLowerCaseMapping:0x1D32A
  ,simpleTitleCaseMapping:0x1D32A
 },
 { code:0x1D32B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D32B
  ,simpleLowerCaseMapping:0x1D32B
  ,simpleTitleCaseMapping:0x1D32B
 },
 { code:0x1D32C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D32C
  ,simpleLowerCaseMapping:0x1D32C
  ,simpleTitleCaseMapping:0x1D32C
 },
 { code:0x1D32D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D32D
  ,simpleLowerCaseMapping:0x1D32D
  ,simpleTitleCaseMapping:0x1D32D
 },
 { code:0x1D32E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D32E
  ,simpleLowerCaseMapping:0x1D32E
  ,simpleTitleCaseMapping:0x1D32E
 },
 { code:0x1D32F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D32F
  ,simpleLowerCaseMapping:0x1D32F
  ,simpleTitleCaseMapping:0x1D32F
 },
 { code:0x1D330
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D330
  ,simpleLowerCaseMapping:0x1D330
  ,simpleTitleCaseMapping:0x1D330
 },
 { code:0x1D331
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D331
  ,simpleLowerCaseMapping:0x1D331
  ,simpleTitleCaseMapping:0x1D331
 },
 { code:0x1D332
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D332
  ,simpleLowerCaseMapping:0x1D332
  ,simpleTitleCaseMapping:0x1D332
 },
 { code:0x1D333
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D333
  ,simpleLowerCaseMapping:0x1D333
  ,simpleTitleCaseMapping:0x1D333
 },
 { code:0x1D334
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D334
  ,simpleLowerCaseMapping:0x1D334
  ,simpleTitleCaseMapping:0x1D334
 },
 { code:0x1D335
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D335
  ,simpleLowerCaseMapping:0x1D335
  ,simpleTitleCaseMapping:0x1D335
 },
 { code:0x1D336
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D336
  ,simpleLowerCaseMapping:0x1D336
  ,simpleTitleCaseMapping:0x1D336
 },
 { code:0x1D337
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D337
  ,simpleLowerCaseMapping:0x1D337
  ,simpleTitleCaseMapping:0x1D337
 },
 { code:0x1D338
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D338
  ,simpleLowerCaseMapping:0x1D338
  ,simpleTitleCaseMapping:0x1D338
 },
 { code:0x1D339
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D339
  ,simpleLowerCaseMapping:0x1D339
  ,simpleTitleCaseMapping:0x1D339
 },
 { code:0x1D33A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D33A
  ,simpleLowerCaseMapping:0x1D33A
  ,simpleTitleCaseMapping:0x1D33A
 },
 { code:0x1D33B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D33B
  ,simpleLowerCaseMapping:0x1D33B
  ,simpleTitleCaseMapping:0x1D33B
 },
 { code:0x1D33C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D33C
  ,simpleLowerCaseMapping:0x1D33C
  ,simpleTitleCaseMapping:0x1D33C
 },
 { code:0x1D33D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D33D
  ,simpleLowerCaseMapping:0x1D33D
  ,simpleTitleCaseMapping:0x1D33D
 },
 { code:0x1D33E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D33E
  ,simpleLowerCaseMapping:0x1D33E
  ,simpleTitleCaseMapping:0x1D33E
 },
 { code:0x1D33F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D33F
  ,simpleLowerCaseMapping:0x1D33F
  ,simpleTitleCaseMapping:0x1D33F
 },
 { code:0x1D340
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D340
  ,simpleLowerCaseMapping:0x1D340
  ,simpleTitleCaseMapping:0x1D340
 },
 { code:0x1D341
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D341
  ,simpleLowerCaseMapping:0x1D341
  ,simpleTitleCaseMapping:0x1D341
 },
 { code:0x1D342
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D342
  ,simpleLowerCaseMapping:0x1D342
  ,simpleTitleCaseMapping:0x1D342
 },
 { code:0x1D343
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D343
  ,simpleLowerCaseMapping:0x1D343
  ,simpleTitleCaseMapping:0x1D343
 },
 { code:0x1D344
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D344
  ,simpleLowerCaseMapping:0x1D344
  ,simpleTitleCaseMapping:0x1D344
 },
 { code:0x1D345
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D345
  ,simpleLowerCaseMapping:0x1D345
  ,simpleTitleCaseMapping:0x1D345
 },
 { code:0x1D346
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D346
  ,simpleLowerCaseMapping:0x1D346
  ,simpleTitleCaseMapping:0x1D346
 },
 { code:0x1D347
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D347
  ,simpleLowerCaseMapping:0x1D347
  ,simpleTitleCaseMapping:0x1D347
 },
 { code:0x1D348
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D348
  ,simpleLowerCaseMapping:0x1D348
  ,simpleTitleCaseMapping:0x1D348
 },
 { code:0x1D349
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D349
  ,simpleLowerCaseMapping:0x1D349
  ,simpleTitleCaseMapping:0x1D349
 },
 { code:0x1D34A
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D34A
  ,simpleLowerCaseMapping:0x1D34A
  ,simpleTitleCaseMapping:0x1D34A
 },
 { code:0x1D34B
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D34B
  ,simpleLowerCaseMapping:0x1D34B
  ,simpleTitleCaseMapping:0x1D34B
 },
 { code:0x1D34C
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D34C
  ,simpleLowerCaseMapping:0x1D34C
  ,simpleTitleCaseMapping:0x1D34C
 },
 { code:0x1D34D
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D34D
  ,simpleLowerCaseMapping:0x1D34D
  ,simpleTitleCaseMapping:0x1D34D
 },
 { code:0x1D34E
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D34E
  ,simpleLowerCaseMapping:0x1D34E
  ,simpleTitleCaseMapping:0x1D34E
 },
 { code:0x1D34F
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D34F
  ,simpleLowerCaseMapping:0x1D34F
  ,simpleTitleCaseMapping:0x1D34F
 },
 { code:0x1D350
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D350
  ,simpleLowerCaseMapping:0x1D350
  ,simpleTitleCaseMapping:0x1D350
 },
 { code:0x1D351
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D351
  ,simpleLowerCaseMapping:0x1D351
  ,simpleTitleCaseMapping:0x1D351
 },
 { code:0x1D352
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D352
  ,simpleLowerCaseMapping:0x1D352
  ,simpleTitleCaseMapping:0x1D352
 },
 { code:0x1D353
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D353
  ,simpleLowerCaseMapping:0x1D353
  ,simpleTitleCaseMapping:0x1D353
 },
 { code:0x1D354
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D354
  ,simpleLowerCaseMapping:0x1D354
  ,simpleTitleCaseMapping:0x1D354
 },
 { code:0x1D355
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D355
  ,simpleLowerCaseMapping:0x1D355
  ,simpleTitleCaseMapping:0x1D355
 },
 { code:0x1D356
  ,generalCategory:UnicodeData.GeneralCategory.So
  ,simpleUpperCaseMapping:0x1D356
  ,simpleLowerCaseMapping:0x1D356
  ,simpleTitleCaseMapping:0x1D356
 },
 { code:0x1D360
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1D360
  ,simpleLowerCaseMapping:0x1D360
  ,simpleTitleCaseMapping:0x1D360
 },
 { code:0x1D361
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1D361
  ,simpleLowerCaseMapping:0x1D361
  ,simpleTitleCaseMapping:0x1D361
 },
 { code:0x1D362
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1D362
  ,simpleLowerCaseMapping:0x1D362
  ,simpleTitleCaseMapping:0x1D362
 },
 { code:0x1D363
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1D363
  ,simpleLowerCaseMapping:0x1D363
  ,simpleTitleCaseMapping:0x1D363
 },
 { code:0x1D364
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1D364
  ,simpleLowerCaseMapping:0x1D364
  ,simpleTitleCaseMapping:0x1D364
 },
 { code:0x1D365
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1D365
  ,simpleLowerCaseMapping:0x1D365
  ,simpleTitleCaseMapping:0x1D365
 },
 { code:0x1D366
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1D366
  ,simpleLowerCaseMapping:0x1D366
  ,simpleTitleCaseMapping:0x1D366
 },
 { code:0x1D367
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1D367
  ,simpleLowerCaseMapping:0x1D367
  ,simpleTitleCaseMapping:0x1D367
 },
 { code:0x1D368
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1D368
  ,simpleLowerCaseMapping:0x1D368
  ,simpleTitleCaseMapping:0x1D368
 },
 { code:0x1D369
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1D369
  ,simpleLowerCaseMapping:0x1D369
  ,simpleTitleCaseMapping:0x1D369
 },
 { code:0x1D36A
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1D36A
  ,simpleLowerCaseMapping:0x1D36A
  ,simpleTitleCaseMapping:0x1D36A
 },
 { code:0x1D36B
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1D36B
  ,simpleLowerCaseMapping:0x1D36B
  ,simpleTitleCaseMapping:0x1D36B
 },
 { code:0x1D36C
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1D36C
  ,simpleLowerCaseMapping:0x1D36C
  ,simpleTitleCaseMapping:0x1D36C
 },
 { code:0x1D36D
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1D36D
  ,simpleLowerCaseMapping:0x1D36D
  ,simpleTitleCaseMapping:0x1D36D
 },
 { code:0x1D36E
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1D36E
  ,simpleLowerCaseMapping:0x1D36E
  ,simpleTitleCaseMapping:0x1D36E
 },
 { code:0x1D36F
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1D36F
  ,simpleLowerCaseMapping:0x1D36F
  ,simpleTitleCaseMapping:0x1D36F
 },
 { code:0x1D370
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1D370
  ,simpleLowerCaseMapping:0x1D370
  ,simpleTitleCaseMapping:0x1D370
 },
 { code:0x1D371
  ,generalCategory:UnicodeData.GeneralCategory.No
  ,simpleUpperCaseMapping:0x1D371
  ,simpleLowerCaseMapping:0x1D371
  ,simpleTitleCaseMapping:0x1D371
 },
 { code:0x1D400
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D400
  ,simpleLowerCaseMapping:0x1D400
  ,simpleTitleCaseMapping:0x1D400
 },
 { code:0x1D401
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D401
  ,simpleLowerCaseMapping:0x1D401
  ,simpleTitleCaseMapping:0x1D401
 },
 { code:0x1D402
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D402
  ,simpleLowerCaseMapping:0x1D402
  ,simpleTitleCaseMapping:0x1D402
 },
 { code:0x1D403
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D403
  ,simpleLowerCaseMapping:0x1D403
  ,simpleTitleCaseMapping:0x1D403
 },
 { code:0x1D404
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D404
  ,simpleLowerCaseMapping:0x1D404
  ,simpleTitleCaseMapping:0x1D404
 },
 { code:0x1D405
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D405
  ,simpleLowerCaseMapping:0x1D405
  ,simpleTitleCaseMapping:0x1D405
 },
 { code:0x1D406
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D406
  ,simpleLowerCaseMapping:0x1D406
  ,simpleTitleCaseMapping:0x1D406
 },
 { code:0x1D407
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D407
  ,simpleLowerCaseMapping:0x1D407
  ,simpleTitleCaseMapping:0x1D407
 },
 { code:0x1D408
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D408
  ,simpleLowerCaseMapping:0x1D408
  ,simpleTitleCaseMapping:0x1D408
 },
 { code:0x1D409
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D409
  ,simpleLowerCaseMapping:0x1D409
  ,simpleTitleCaseMapping:0x1D409
 },
 { code:0x1D40A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D40A
  ,simpleLowerCaseMapping:0x1D40A
  ,simpleTitleCaseMapping:0x1D40A
 },
 { code:0x1D40B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D40B
  ,simpleLowerCaseMapping:0x1D40B
  ,simpleTitleCaseMapping:0x1D40B
 },
 { code:0x1D40C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D40C
  ,simpleLowerCaseMapping:0x1D40C
  ,simpleTitleCaseMapping:0x1D40C
 },
 { code:0x1D40D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D40D
  ,simpleLowerCaseMapping:0x1D40D
  ,simpleTitleCaseMapping:0x1D40D
 },
 { code:0x1D40E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D40E
  ,simpleLowerCaseMapping:0x1D40E
  ,simpleTitleCaseMapping:0x1D40E
 },
 { code:0x1D40F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D40F
  ,simpleLowerCaseMapping:0x1D40F
  ,simpleTitleCaseMapping:0x1D40F
 },
 { code:0x1D410
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D410
  ,simpleLowerCaseMapping:0x1D410
  ,simpleTitleCaseMapping:0x1D410
 },
 { code:0x1D411
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D411
  ,simpleLowerCaseMapping:0x1D411
  ,simpleTitleCaseMapping:0x1D411
 },
 { code:0x1D412
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D412
  ,simpleLowerCaseMapping:0x1D412
  ,simpleTitleCaseMapping:0x1D412
 },
 { code:0x1D413
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D413
  ,simpleLowerCaseMapping:0x1D413
  ,simpleTitleCaseMapping:0x1D413
 },
 { code:0x1D414
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D414
  ,simpleLowerCaseMapping:0x1D414
  ,simpleTitleCaseMapping:0x1D414
 },
 { code:0x1D415
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D415
  ,simpleLowerCaseMapping:0x1D415
  ,simpleTitleCaseMapping:0x1D415
 },
 { code:0x1D416
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D416
  ,simpleLowerCaseMapping:0x1D416
  ,simpleTitleCaseMapping:0x1D416
 },
 { code:0x1D417
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D417
  ,simpleLowerCaseMapping:0x1D417
  ,simpleTitleCaseMapping:0x1D417
 },
 { code:0x1D418
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D418
  ,simpleLowerCaseMapping:0x1D418
  ,simpleTitleCaseMapping:0x1D418
 },
 { code:0x1D419
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D419
  ,simpleLowerCaseMapping:0x1D419
  ,simpleTitleCaseMapping:0x1D419
 },
 { code:0x1D41A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D41A
  ,simpleLowerCaseMapping:0x1D41A
  ,simpleTitleCaseMapping:0x1D41A
 },
 { code:0x1D41B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D41B
  ,simpleLowerCaseMapping:0x1D41B
  ,simpleTitleCaseMapping:0x1D41B
 },
 { code:0x1D41C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D41C
  ,simpleLowerCaseMapping:0x1D41C
  ,simpleTitleCaseMapping:0x1D41C
 },
 { code:0x1D41D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D41D
  ,simpleLowerCaseMapping:0x1D41D
  ,simpleTitleCaseMapping:0x1D41D
 },
 { code:0x1D41E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D41E
  ,simpleLowerCaseMapping:0x1D41E
  ,simpleTitleCaseMapping:0x1D41E
 },
 { code:0x1D41F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D41F
  ,simpleLowerCaseMapping:0x1D41F
  ,simpleTitleCaseMapping:0x1D41F
 },
 { code:0x1D420
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D420
  ,simpleLowerCaseMapping:0x1D420
  ,simpleTitleCaseMapping:0x1D420
 },
 { code:0x1D421
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D421
  ,simpleLowerCaseMapping:0x1D421
  ,simpleTitleCaseMapping:0x1D421
 },
 { code:0x1D422
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D422
  ,simpleLowerCaseMapping:0x1D422
  ,simpleTitleCaseMapping:0x1D422
 },
 { code:0x1D423
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D423
  ,simpleLowerCaseMapping:0x1D423
  ,simpleTitleCaseMapping:0x1D423
 },
 { code:0x1D424
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D424
  ,simpleLowerCaseMapping:0x1D424
  ,simpleTitleCaseMapping:0x1D424
 },
 { code:0x1D425
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D425
  ,simpleLowerCaseMapping:0x1D425
  ,simpleTitleCaseMapping:0x1D425
 },
 { code:0x1D426
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D426
  ,simpleLowerCaseMapping:0x1D426
  ,simpleTitleCaseMapping:0x1D426
 },
 { code:0x1D427
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D427
  ,simpleLowerCaseMapping:0x1D427
  ,simpleTitleCaseMapping:0x1D427
 },
 { code:0x1D428
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D428
  ,simpleLowerCaseMapping:0x1D428
  ,simpleTitleCaseMapping:0x1D428
 },
 { code:0x1D429
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D429
  ,simpleLowerCaseMapping:0x1D429
  ,simpleTitleCaseMapping:0x1D429
 },
 { code:0x1D42A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D42A
  ,simpleLowerCaseMapping:0x1D42A
  ,simpleTitleCaseMapping:0x1D42A
 },
 { code:0x1D42B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D42B
  ,simpleLowerCaseMapping:0x1D42B
  ,simpleTitleCaseMapping:0x1D42B
 },
 { code:0x1D42C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D42C
  ,simpleLowerCaseMapping:0x1D42C
  ,simpleTitleCaseMapping:0x1D42C
 },
 { code:0x1D42D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D42D
  ,simpleLowerCaseMapping:0x1D42D
  ,simpleTitleCaseMapping:0x1D42D
 },
 { code:0x1D42E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D42E
  ,simpleLowerCaseMapping:0x1D42E
  ,simpleTitleCaseMapping:0x1D42E
 },
 { code:0x1D42F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D42F
  ,simpleLowerCaseMapping:0x1D42F
  ,simpleTitleCaseMapping:0x1D42F
 },
 { code:0x1D430
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D430
  ,simpleLowerCaseMapping:0x1D430
  ,simpleTitleCaseMapping:0x1D430
 },
 { code:0x1D431
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D431
  ,simpleLowerCaseMapping:0x1D431
  ,simpleTitleCaseMapping:0x1D431
 },
 { code:0x1D432
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D432
  ,simpleLowerCaseMapping:0x1D432
  ,simpleTitleCaseMapping:0x1D432
 },
 { code:0x1D433
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D433
  ,simpleLowerCaseMapping:0x1D433
  ,simpleTitleCaseMapping:0x1D433
 },
 { code:0x1D434
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D434
  ,simpleLowerCaseMapping:0x1D434
  ,simpleTitleCaseMapping:0x1D434
 },
 { code:0x1D435
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D435
  ,simpleLowerCaseMapping:0x1D435
  ,simpleTitleCaseMapping:0x1D435
 },
 { code:0x1D436
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D436
  ,simpleLowerCaseMapping:0x1D436
  ,simpleTitleCaseMapping:0x1D436
 },
 { code:0x1D437
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D437
  ,simpleLowerCaseMapping:0x1D437
  ,simpleTitleCaseMapping:0x1D437
 },
 { code:0x1D438
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D438
  ,simpleLowerCaseMapping:0x1D438
  ,simpleTitleCaseMapping:0x1D438
 },
 { code:0x1D439
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D439
  ,simpleLowerCaseMapping:0x1D439
  ,simpleTitleCaseMapping:0x1D439
 },
 { code:0x1D43A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D43A
  ,simpleLowerCaseMapping:0x1D43A
  ,simpleTitleCaseMapping:0x1D43A
 },
 { code:0x1D43B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D43B
  ,simpleLowerCaseMapping:0x1D43B
  ,simpleTitleCaseMapping:0x1D43B
 },
 { code:0x1D43C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D43C
  ,simpleLowerCaseMapping:0x1D43C
  ,simpleTitleCaseMapping:0x1D43C
 },
 { code:0x1D43D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D43D
  ,simpleLowerCaseMapping:0x1D43D
  ,simpleTitleCaseMapping:0x1D43D
 },
 { code:0x1D43E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D43E
  ,simpleLowerCaseMapping:0x1D43E
  ,simpleTitleCaseMapping:0x1D43E
 },
 { code:0x1D43F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D43F
  ,simpleLowerCaseMapping:0x1D43F
  ,simpleTitleCaseMapping:0x1D43F
 },
 { code:0x1D440
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D440
  ,simpleLowerCaseMapping:0x1D440
  ,simpleTitleCaseMapping:0x1D440
 },
 { code:0x1D441
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D441
  ,simpleLowerCaseMapping:0x1D441
  ,simpleTitleCaseMapping:0x1D441
 },
 { code:0x1D442
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D442
  ,simpleLowerCaseMapping:0x1D442
  ,simpleTitleCaseMapping:0x1D442
 },
 { code:0x1D443
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D443
  ,simpleLowerCaseMapping:0x1D443
  ,simpleTitleCaseMapping:0x1D443
 },
 { code:0x1D444
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D444
  ,simpleLowerCaseMapping:0x1D444
  ,simpleTitleCaseMapping:0x1D444
 },
 { code:0x1D445
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D445
  ,simpleLowerCaseMapping:0x1D445
  ,simpleTitleCaseMapping:0x1D445
 },
 { code:0x1D446
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D446
  ,simpleLowerCaseMapping:0x1D446
  ,simpleTitleCaseMapping:0x1D446
 },
 { code:0x1D447
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D447
  ,simpleLowerCaseMapping:0x1D447
  ,simpleTitleCaseMapping:0x1D447
 },
 { code:0x1D448
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D448
  ,simpleLowerCaseMapping:0x1D448
  ,simpleTitleCaseMapping:0x1D448
 },
 { code:0x1D449
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D449
  ,simpleLowerCaseMapping:0x1D449
  ,simpleTitleCaseMapping:0x1D449
 },
 { code:0x1D44A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D44A
  ,simpleLowerCaseMapping:0x1D44A
  ,simpleTitleCaseMapping:0x1D44A
 },
 { code:0x1D44B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D44B
  ,simpleLowerCaseMapping:0x1D44B
  ,simpleTitleCaseMapping:0x1D44B
 },
 { code:0x1D44C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D44C
  ,simpleLowerCaseMapping:0x1D44C
  ,simpleTitleCaseMapping:0x1D44C
 },
 { code:0x1D44D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D44D
  ,simpleLowerCaseMapping:0x1D44D
  ,simpleTitleCaseMapping:0x1D44D
 },
 { code:0x1D44E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D44E
  ,simpleLowerCaseMapping:0x1D44E
  ,simpleTitleCaseMapping:0x1D44E
 },
 { code:0x1D44F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D44F
  ,simpleLowerCaseMapping:0x1D44F
  ,simpleTitleCaseMapping:0x1D44F
 },
 { code:0x1D450
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D450
  ,simpleLowerCaseMapping:0x1D450
  ,simpleTitleCaseMapping:0x1D450
 },
 { code:0x1D451
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D451
  ,simpleLowerCaseMapping:0x1D451
  ,simpleTitleCaseMapping:0x1D451
 },
 { code:0x1D452
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D452
  ,simpleLowerCaseMapping:0x1D452
  ,simpleTitleCaseMapping:0x1D452
 },
 { code:0x1D453
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D453
  ,simpleLowerCaseMapping:0x1D453
  ,simpleTitleCaseMapping:0x1D453
 },
 { code:0x1D454
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D454
  ,simpleLowerCaseMapping:0x1D454
  ,simpleTitleCaseMapping:0x1D454
 },
 { code:0x1D456
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D456
  ,simpleLowerCaseMapping:0x1D456
  ,simpleTitleCaseMapping:0x1D456
 },
 { code:0x1D457
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D457
  ,simpleLowerCaseMapping:0x1D457
  ,simpleTitleCaseMapping:0x1D457
 },
 { code:0x1D458
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D458
  ,simpleLowerCaseMapping:0x1D458
  ,simpleTitleCaseMapping:0x1D458
 },
 { code:0x1D459
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D459
  ,simpleLowerCaseMapping:0x1D459
  ,simpleTitleCaseMapping:0x1D459
 },
 { code:0x1D45A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D45A
  ,simpleLowerCaseMapping:0x1D45A
  ,simpleTitleCaseMapping:0x1D45A
 },
 { code:0x1D45B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D45B
  ,simpleLowerCaseMapping:0x1D45B
  ,simpleTitleCaseMapping:0x1D45B
 },
 { code:0x1D45C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D45C
  ,simpleLowerCaseMapping:0x1D45C
  ,simpleTitleCaseMapping:0x1D45C
 },
 { code:0x1D45D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D45D
  ,simpleLowerCaseMapping:0x1D45D
  ,simpleTitleCaseMapping:0x1D45D
 },
 { code:0x1D45E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D45E
  ,simpleLowerCaseMapping:0x1D45E
  ,simpleTitleCaseMapping:0x1D45E
 },
 { code:0x1D45F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D45F
  ,simpleLowerCaseMapping:0x1D45F
  ,simpleTitleCaseMapping:0x1D45F
 },
 { code:0x1D460
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D460
  ,simpleLowerCaseMapping:0x1D460
  ,simpleTitleCaseMapping:0x1D460
 },
 { code:0x1D461
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D461
  ,simpleLowerCaseMapping:0x1D461
  ,simpleTitleCaseMapping:0x1D461
 },
 { code:0x1D462
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D462
  ,simpleLowerCaseMapping:0x1D462
  ,simpleTitleCaseMapping:0x1D462
 },
 { code:0x1D463
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D463
  ,simpleLowerCaseMapping:0x1D463
  ,simpleTitleCaseMapping:0x1D463
 },
 { code:0x1D464
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D464
  ,simpleLowerCaseMapping:0x1D464
  ,simpleTitleCaseMapping:0x1D464
 },
 { code:0x1D465
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D465
  ,simpleLowerCaseMapping:0x1D465
  ,simpleTitleCaseMapping:0x1D465
 },
 { code:0x1D466
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D466
  ,simpleLowerCaseMapping:0x1D466
  ,simpleTitleCaseMapping:0x1D466
 },
 { code:0x1D467
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D467
  ,simpleLowerCaseMapping:0x1D467
  ,simpleTitleCaseMapping:0x1D467
 },
 { code:0x1D468
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D468
  ,simpleLowerCaseMapping:0x1D468
  ,simpleTitleCaseMapping:0x1D468
 },
 { code:0x1D469
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D469
  ,simpleLowerCaseMapping:0x1D469
  ,simpleTitleCaseMapping:0x1D469
 },
 { code:0x1D46A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D46A
  ,simpleLowerCaseMapping:0x1D46A
  ,simpleTitleCaseMapping:0x1D46A
 },
 { code:0x1D46B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D46B
  ,simpleLowerCaseMapping:0x1D46B
  ,simpleTitleCaseMapping:0x1D46B
 },
 { code:0x1D46C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D46C
  ,simpleLowerCaseMapping:0x1D46C
  ,simpleTitleCaseMapping:0x1D46C
 },
 { code:0x1D46D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D46D
  ,simpleLowerCaseMapping:0x1D46D
  ,simpleTitleCaseMapping:0x1D46D
 },
 { code:0x1D46E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D46E
  ,simpleLowerCaseMapping:0x1D46E
  ,simpleTitleCaseMapping:0x1D46E
 },
 { code:0x1D46F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D46F
  ,simpleLowerCaseMapping:0x1D46F
  ,simpleTitleCaseMapping:0x1D46F
 },
 { code:0x1D470
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D470
  ,simpleLowerCaseMapping:0x1D470
  ,simpleTitleCaseMapping:0x1D470
 },
 { code:0x1D471
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D471
  ,simpleLowerCaseMapping:0x1D471
  ,simpleTitleCaseMapping:0x1D471
 },
 { code:0x1D472
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D472
  ,simpleLowerCaseMapping:0x1D472
  ,simpleTitleCaseMapping:0x1D472
 },
 { code:0x1D473
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D473
  ,simpleLowerCaseMapping:0x1D473
  ,simpleTitleCaseMapping:0x1D473
 },
 { code:0x1D474
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D474
  ,simpleLowerCaseMapping:0x1D474
  ,simpleTitleCaseMapping:0x1D474
 },
 { code:0x1D475
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D475
  ,simpleLowerCaseMapping:0x1D475
  ,simpleTitleCaseMapping:0x1D475
 },
 { code:0x1D476
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D476
  ,simpleLowerCaseMapping:0x1D476
  ,simpleTitleCaseMapping:0x1D476
 },
 { code:0x1D477
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D477
  ,simpleLowerCaseMapping:0x1D477
  ,simpleTitleCaseMapping:0x1D477
 },
 { code:0x1D478
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D478
  ,simpleLowerCaseMapping:0x1D478
  ,simpleTitleCaseMapping:0x1D478
 },
 { code:0x1D479
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D479
  ,simpleLowerCaseMapping:0x1D479
  ,simpleTitleCaseMapping:0x1D479
 },
 { code:0x1D47A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D47A
  ,simpleLowerCaseMapping:0x1D47A
  ,simpleTitleCaseMapping:0x1D47A
 },
 { code:0x1D47B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D47B
  ,simpleLowerCaseMapping:0x1D47B
  ,simpleTitleCaseMapping:0x1D47B
 },
 { code:0x1D47C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D47C
  ,simpleLowerCaseMapping:0x1D47C
  ,simpleTitleCaseMapping:0x1D47C
 },
 { code:0x1D47D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D47D
  ,simpleLowerCaseMapping:0x1D47D
  ,simpleTitleCaseMapping:0x1D47D
 },
 { code:0x1D47E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D47E
  ,simpleLowerCaseMapping:0x1D47E
  ,simpleTitleCaseMapping:0x1D47E
 },
 { code:0x1D47F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D47F
  ,simpleLowerCaseMapping:0x1D47F
  ,simpleTitleCaseMapping:0x1D47F
 },
 { code:0x1D480
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D480
  ,simpleLowerCaseMapping:0x1D480
  ,simpleTitleCaseMapping:0x1D480
 },
 { code:0x1D481
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D481
  ,simpleLowerCaseMapping:0x1D481
  ,simpleTitleCaseMapping:0x1D481
 },
 { code:0x1D482
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D482
  ,simpleLowerCaseMapping:0x1D482
  ,simpleTitleCaseMapping:0x1D482
 },
 { code:0x1D483
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D483
  ,simpleLowerCaseMapping:0x1D483
  ,simpleTitleCaseMapping:0x1D483
 },
 { code:0x1D484
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D484
  ,simpleLowerCaseMapping:0x1D484
  ,simpleTitleCaseMapping:0x1D484
 },
 { code:0x1D485
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D485
  ,simpleLowerCaseMapping:0x1D485
  ,simpleTitleCaseMapping:0x1D485
 },
 { code:0x1D486
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D486
  ,simpleLowerCaseMapping:0x1D486
  ,simpleTitleCaseMapping:0x1D486
 },
 { code:0x1D487
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D487
  ,simpleLowerCaseMapping:0x1D487
  ,simpleTitleCaseMapping:0x1D487
 },
 { code:0x1D488
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D488
  ,simpleLowerCaseMapping:0x1D488
  ,simpleTitleCaseMapping:0x1D488
 },
 { code:0x1D489
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D489
  ,simpleLowerCaseMapping:0x1D489
  ,simpleTitleCaseMapping:0x1D489
 },
 { code:0x1D48A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D48A
  ,simpleLowerCaseMapping:0x1D48A
  ,simpleTitleCaseMapping:0x1D48A
 },
 { code:0x1D48B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D48B
  ,simpleLowerCaseMapping:0x1D48B
  ,simpleTitleCaseMapping:0x1D48B
 },
 { code:0x1D48C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D48C
  ,simpleLowerCaseMapping:0x1D48C
  ,simpleTitleCaseMapping:0x1D48C
 },
 { code:0x1D48D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D48D
  ,simpleLowerCaseMapping:0x1D48D
  ,simpleTitleCaseMapping:0x1D48D
 },
 { code:0x1D48E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D48E
  ,simpleLowerCaseMapping:0x1D48E
  ,simpleTitleCaseMapping:0x1D48E
 },
 { code:0x1D48F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D48F
  ,simpleLowerCaseMapping:0x1D48F
  ,simpleTitleCaseMapping:0x1D48F
 },
 { code:0x1D490
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D490
  ,simpleLowerCaseMapping:0x1D490
  ,simpleTitleCaseMapping:0x1D490
 },
 { code:0x1D491
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D491
  ,simpleLowerCaseMapping:0x1D491
  ,simpleTitleCaseMapping:0x1D491
 },
 { code:0x1D492
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D492
  ,simpleLowerCaseMapping:0x1D492
  ,simpleTitleCaseMapping:0x1D492
 },
 { code:0x1D493
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D493
  ,simpleLowerCaseMapping:0x1D493
  ,simpleTitleCaseMapping:0x1D493
 },
 { code:0x1D494
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D494
  ,simpleLowerCaseMapping:0x1D494
  ,simpleTitleCaseMapping:0x1D494
 },
 { code:0x1D495
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D495
  ,simpleLowerCaseMapping:0x1D495
  ,simpleTitleCaseMapping:0x1D495
 },
 { code:0x1D496
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D496
  ,simpleLowerCaseMapping:0x1D496
  ,simpleTitleCaseMapping:0x1D496
 },
 { code:0x1D497
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D497
  ,simpleLowerCaseMapping:0x1D497
  ,simpleTitleCaseMapping:0x1D497
 },
 { code:0x1D498
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D498
  ,simpleLowerCaseMapping:0x1D498
  ,simpleTitleCaseMapping:0x1D498
 },
 { code:0x1D499
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D499
  ,simpleLowerCaseMapping:0x1D499
  ,simpleTitleCaseMapping:0x1D499
 },
 { code:0x1D49A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D49A
  ,simpleLowerCaseMapping:0x1D49A
  ,simpleTitleCaseMapping:0x1D49A
 },
 { code:0x1D49B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D49B
  ,simpleLowerCaseMapping:0x1D49B
  ,simpleTitleCaseMapping:0x1D49B
 },
 { code:0x1D49C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D49C
  ,simpleLowerCaseMapping:0x1D49C
  ,simpleTitleCaseMapping:0x1D49C
 },
 { code:0x1D49E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D49E
  ,simpleLowerCaseMapping:0x1D49E
  ,simpleTitleCaseMapping:0x1D49E
 },
 { code:0x1D49F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D49F
  ,simpleLowerCaseMapping:0x1D49F
  ,simpleTitleCaseMapping:0x1D49F
 },
 { code:0x1D4A2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4A2
  ,simpleLowerCaseMapping:0x1D4A2
  ,simpleTitleCaseMapping:0x1D4A2
 },
 { code:0x1D4A5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4A5
  ,simpleLowerCaseMapping:0x1D4A5
  ,simpleTitleCaseMapping:0x1D4A5
 },
 { code:0x1D4A6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4A6
  ,simpleLowerCaseMapping:0x1D4A6
  ,simpleTitleCaseMapping:0x1D4A6
 },
 { code:0x1D4A9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4A9
  ,simpleLowerCaseMapping:0x1D4A9
  ,simpleTitleCaseMapping:0x1D4A9
 },
 { code:0x1D4AA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4AA
  ,simpleLowerCaseMapping:0x1D4AA
  ,simpleTitleCaseMapping:0x1D4AA
 },
 { code:0x1D4AB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4AB
  ,simpleLowerCaseMapping:0x1D4AB
  ,simpleTitleCaseMapping:0x1D4AB
 },
 { code:0x1D4AC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4AC
  ,simpleLowerCaseMapping:0x1D4AC
  ,simpleTitleCaseMapping:0x1D4AC
 },
 { code:0x1D4AE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4AE
  ,simpleLowerCaseMapping:0x1D4AE
  ,simpleTitleCaseMapping:0x1D4AE
 },
 { code:0x1D4AF
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4AF
  ,simpleLowerCaseMapping:0x1D4AF
  ,simpleTitleCaseMapping:0x1D4AF
 },
 { code:0x1D4B0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4B0
  ,simpleLowerCaseMapping:0x1D4B0
  ,simpleTitleCaseMapping:0x1D4B0
 },
 { code:0x1D4B1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4B1
  ,simpleLowerCaseMapping:0x1D4B1
  ,simpleTitleCaseMapping:0x1D4B1
 },
 { code:0x1D4B2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4B2
  ,simpleLowerCaseMapping:0x1D4B2
  ,simpleTitleCaseMapping:0x1D4B2
 },
 { code:0x1D4B3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4B3
  ,simpleLowerCaseMapping:0x1D4B3
  ,simpleTitleCaseMapping:0x1D4B3
 },
 { code:0x1D4B4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4B4
  ,simpleLowerCaseMapping:0x1D4B4
  ,simpleTitleCaseMapping:0x1D4B4
 },
 { code:0x1D4B5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4B5
  ,simpleLowerCaseMapping:0x1D4B5
  ,simpleTitleCaseMapping:0x1D4B5
 },
 { code:0x1D4B6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4B6
  ,simpleLowerCaseMapping:0x1D4B6
  ,simpleTitleCaseMapping:0x1D4B6
 },
 { code:0x1D4B7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4B7
  ,simpleLowerCaseMapping:0x1D4B7
  ,simpleTitleCaseMapping:0x1D4B7
 },
 { code:0x1D4B8
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4B8
  ,simpleLowerCaseMapping:0x1D4B8
  ,simpleTitleCaseMapping:0x1D4B8
 },
 { code:0x1D4B9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4B9
  ,simpleLowerCaseMapping:0x1D4B9
  ,simpleTitleCaseMapping:0x1D4B9
 },
 { code:0x1D4BB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4BB
  ,simpleLowerCaseMapping:0x1D4BB
  ,simpleTitleCaseMapping:0x1D4BB
 },
 { code:0x1D4BD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4BD
  ,simpleLowerCaseMapping:0x1D4BD
  ,simpleTitleCaseMapping:0x1D4BD
 },
 { code:0x1D4BE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4BE
  ,simpleLowerCaseMapping:0x1D4BE
  ,simpleTitleCaseMapping:0x1D4BE
 },
 { code:0x1D4BF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4BF
  ,simpleLowerCaseMapping:0x1D4BF
  ,simpleTitleCaseMapping:0x1D4BF
 },
 { code:0x1D4C0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4C0
  ,simpleLowerCaseMapping:0x1D4C0
  ,simpleTitleCaseMapping:0x1D4C0
 },
 { code:0x1D4C1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4C1
  ,simpleLowerCaseMapping:0x1D4C1
  ,simpleTitleCaseMapping:0x1D4C1
 },
 { code:0x1D4C2
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4C2
  ,simpleLowerCaseMapping:0x1D4C2
  ,simpleTitleCaseMapping:0x1D4C2
 },
 { code:0x1D4C3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4C3
  ,simpleLowerCaseMapping:0x1D4C3
  ,simpleTitleCaseMapping:0x1D4C3
 },
 { code:0x1D4C5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4C5
  ,simpleLowerCaseMapping:0x1D4C5
  ,simpleTitleCaseMapping:0x1D4C5
 },
 { code:0x1D4C6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4C6
  ,simpleLowerCaseMapping:0x1D4C6
  ,simpleTitleCaseMapping:0x1D4C6
 },
 { code:0x1D4C7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4C7
  ,simpleLowerCaseMapping:0x1D4C7
  ,simpleTitleCaseMapping:0x1D4C7
 },
 { code:0x1D4C8
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4C8
  ,simpleLowerCaseMapping:0x1D4C8
  ,simpleTitleCaseMapping:0x1D4C8
 },
 { code:0x1D4C9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4C9
  ,simpleLowerCaseMapping:0x1D4C9
  ,simpleTitleCaseMapping:0x1D4C9
 },
 { code:0x1D4CA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4CA
  ,simpleLowerCaseMapping:0x1D4CA
  ,simpleTitleCaseMapping:0x1D4CA
 },
 { code:0x1D4CB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4CB
  ,simpleLowerCaseMapping:0x1D4CB
  ,simpleTitleCaseMapping:0x1D4CB
 },
 { code:0x1D4CC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4CC
  ,simpleLowerCaseMapping:0x1D4CC
  ,simpleTitleCaseMapping:0x1D4CC
 },
 { code:0x1D4CD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4CD
  ,simpleLowerCaseMapping:0x1D4CD
  ,simpleTitleCaseMapping:0x1D4CD
 },
 { code:0x1D4CE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4CE
  ,simpleLowerCaseMapping:0x1D4CE
  ,simpleTitleCaseMapping:0x1D4CE
 },
 { code:0x1D4CF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4CF
  ,simpleLowerCaseMapping:0x1D4CF
  ,simpleTitleCaseMapping:0x1D4CF
 },
 { code:0x1D4D0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4D0
  ,simpleLowerCaseMapping:0x1D4D0
  ,simpleTitleCaseMapping:0x1D4D0
 },
 { code:0x1D4D1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4D1
  ,simpleLowerCaseMapping:0x1D4D1
  ,simpleTitleCaseMapping:0x1D4D1
 },
 { code:0x1D4D2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4D2
  ,simpleLowerCaseMapping:0x1D4D2
  ,simpleTitleCaseMapping:0x1D4D2
 },
 { code:0x1D4D3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4D3
  ,simpleLowerCaseMapping:0x1D4D3
  ,simpleTitleCaseMapping:0x1D4D3
 },
 { code:0x1D4D4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4D4
  ,simpleLowerCaseMapping:0x1D4D4
  ,simpleTitleCaseMapping:0x1D4D4
 },
 { code:0x1D4D5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4D5
  ,simpleLowerCaseMapping:0x1D4D5
  ,simpleTitleCaseMapping:0x1D4D5
 },
 { code:0x1D4D6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4D6
  ,simpleLowerCaseMapping:0x1D4D6
  ,simpleTitleCaseMapping:0x1D4D6
 },
 { code:0x1D4D7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4D7
  ,simpleLowerCaseMapping:0x1D4D7
  ,simpleTitleCaseMapping:0x1D4D7
 },
 { code:0x1D4D8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4D8
  ,simpleLowerCaseMapping:0x1D4D8
  ,simpleTitleCaseMapping:0x1D4D8
 },
 { code:0x1D4D9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4D9
  ,simpleLowerCaseMapping:0x1D4D9
  ,simpleTitleCaseMapping:0x1D4D9
 },
 { code:0x1D4DA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4DA
  ,simpleLowerCaseMapping:0x1D4DA
  ,simpleTitleCaseMapping:0x1D4DA
 },
 { code:0x1D4DB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4DB
  ,simpleLowerCaseMapping:0x1D4DB
  ,simpleTitleCaseMapping:0x1D4DB
 },
 { code:0x1D4DC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4DC
  ,simpleLowerCaseMapping:0x1D4DC
  ,simpleTitleCaseMapping:0x1D4DC
 },
 { code:0x1D4DD
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4DD
  ,simpleLowerCaseMapping:0x1D4DD
  ,simpleTitleCaseMapping:0x1D4DD
 },
 { code:0x1D4DE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4DE
  ,simpleLowerCaseMapping:0x1D4DE
  ,simpleTitleCaseMapping:0x1D4DE
 },
 { code:0x1D4DF
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4DF
  ,simpleLowerCaseMapping:0x1D4DF
  ,simpleTitleCaseMapping:0x1D4DF
 },
 { code:0x1D4E0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4E0
  ,simpleLowerCaseMapping:0x1D4E0
  ,simpleTitleCaseMapping:0x1D4E0
 },
 { code:0x1D4E1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4E1
  ,simpleLowerCaseMapping:0x1D4E1
  ,simpleTitleCaseMapping:0x1D4E1
 },
 { code:0x1D4E2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4E2
  ,simpleLowerCaseMapping:0x1D4E2
  ,simpleTitleCaseMapping:0x1D4E2
 },
 { code:0x1D4E3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4E3
  ,simpleLowerCaseMapping:0x1D4E3
  ,simpleTitleCaseMapping:0x1D4E3
 },
 { code:0x1D4E4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4E4
  ,simpleLowerCaseMapping:0x1D4E4
  ,simpleTitleCaseMapping:0x1D4E4
 },
 { code:0x1D4E5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4E5
  ,simpleLowerCaseMapping:0x1D4E5
  ,simpleTitleCaseMapping:0x1D4E5
 },
 { code:0x1D4E6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4E6
  ,simpleLowerCaseMapping:0x1D4E6
  ,simpleTitleCaseMapping:0x1D4E6
 },
 { code:0x1D4E7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4E7
  ,simpleLowerCaseMapping:0x1D4E7
  ,simpleTitleCaseMapping:0x1D4E7
 },
 { code:0x1D4E8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4E8
  ,simpleLowerCaseMapping:0x1D4E8
  ,simpleTitleCaseMapping:0x1D4E8
 },
 { code:0x1D4E9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D4E9
  ,simpleLowerCaseMapping:0x1D4E9
  ,simpleTitleCaseMapping:0x1D4E9
 },
 { code:0x1D4EA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4EA
  ,simpleLowerCaseMapping:0x1D4EA
  ,simpleTitleCaseMapping:0x1D4EA
 },
 { code:0x1D4EB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4EB
  ,simpleLowerCaseMapping:0x1D4EB
  ,simpleTitleCaseMapping:0x1D4EB
 },
 { code:0x1D4EC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4EC
  ,simpleLowerCaseMapping:0x1D4EC
  ,simpleTitleCaseMapping:0x1D4EC
 },
 { code:0x1D4ED
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4ED
  ,simpleLowerCaseMapping:0x1D4ED
  ,simpleTitleCaseMapping:0x1D4ED
 },
 { code:0x1D4EE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4EE
  ,simpleLowerCaseMapping:0x1D4EE
  ,simpleTitleCaseMapping:0x1D4EE
 },
 { code:0x1D4EF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4EF
  ,simpleLowerCaseMapping:0x1D4EF
  ,simpleTitleCaseMapping:0x1D4EF
 },
 { code:0x1D4F0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4F0
  ,simpleLowerCaseMapping:0x1D4F0
  ,simpleTitleCaseMapping:0x1D4F0
 },
 { code:0x1D4F1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4F1
  ,simpleLowerCaseMapping:0x1D4F1
  ,simpleTitleCaseMapping:0x1D4F1
 },
 { code:0x1D4F2
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4F2
  ,simpleLowerCaseMapping:0x1D4F2
  ,simpleTitleCaseMapping:0x1D4F2
 },
 { code:0x1D4F3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4F3
  ,simpleLowerCaseMapping:0x1D4F3
  ,simpleTitleCaseMapping:0x1D4F3
 },
 { code:0x1D4F4
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4F4
  ,simpleLowerCaseMapping:0x1D4F4
  ,simpleTitleCaseMapping:0x1D4F4
 },
 { code:0x1D4F5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4F5
  ,simpleLowerCaseMapping:0x1D4F5
  ,simpleTitleCaseMapping:0x1D4F5
 },
 { code:0x1D4F6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4F6
  ,simpleLowerCaseMapping:0x1D4F6
  ,simpleTitleCaseMapping:0x1D4F6
 },
 { code:0x1D4F7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4F7
  ,simpleLowerCaseMapping:0x1D4F7
  ,simpleTitleCaseMapping:0x1D4F7
 },
 { code:0x1D4F8
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4F8
  ,simpleLowerCaseMapping:0x1D4F8
  ,simpleTitleCaseMapping:0x1D4F8
 },
 { code:0x1D4F9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4F9
  ,simpleLowerCaseMapping:0x1D4F9
  ,simpleTitleCaseMapping:0x1D4F9
 },
 { code:0x1D4FA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4FA
  ,simpleLowerCaseMapping:0x1D4FA
  ,simpleTitleCaseMapping:0x1D4FA
 },
 { code:0x1D4FB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4FB
  ,simpleLowerCaseMapping:0x1D4FB
  ,simpleTitleCaseMapping:0x1D4FB
 },
 { code:0x1D4FC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4FC
  ,simpleLowerCaseMapping:0x1D4FC
  ,simpleTitleCaseMapping:0x1D4FC
 },
 { code:0x1D4FD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4FD
  ,simpleLowerCaseMapping:0x1D4FD
  ,simpleTitleCaseMapping:0x1D4FD
 },
 { code:0x1D4FE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4FE
  ,simpleLowerCaseMapping:0x1D4FE
  ,simpleTitleCaseMapping:0x1D4FE
 },
 { code:0x1D4FF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D4FF
  ,simpleLowerCaseMapping:0x1D4FF
  ,simpleTitleCaseMapping:0x1D4FF
 },
 { code:0x1D500
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D500
  ,simpleLowerCaseMapping:0x1D500
  ,simpleTitleCaseMapping:0x1D500
 },
 { code:0x1D501
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D501
  ,simpleLowerCaseMapping:0x1D501
  ,simpleTitleCaseMapping:0x1D501
 },
 { code:0x1D502
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D502
  ,simpleLowerCaseMapping:0x1D502
  ,simpleTitleCaseMapping:0x1D502
 },
 { code:0x1D503
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D503
  ,simpleLowerCaseMapping:0x1D503
  ,simpleTitleCaseMapping:0x1D503
 },
 { code:0x1D504
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D504
  ,simpleLowerCaseMapping:0x1D504
  ,simpleTitleCaseMapping:0x1D504
 },
 { code:0x1D505
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D505
  ,simpleLowerCaseMapping:0x1D505
  ,simpleTitleCaseMapping:0x1D505
 },
 { code:0x1D507
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D507
  ,simpleLowerCaseMapping:0x1D507
  ,simpleTitleCaseMapping:0x1D507
 },
 { code:0x1D508
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D508
  ,simpleLowerCaseMapping:0x1D508
  ,simpleTitleCaseMapping:0x1D508
 },
 { code:0x1D509
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D509
  ,simpleLowerCaseMapping:0x1D509
  ,simpleTitleCaseMapping:0x1D509
 },
 { code:0x1D50A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D50A
  ,simpleLowerCaseMapping:0x1D50A
  ,simpleTitleCaseMapping:0x1D50A
 },
 { code:0x1D50D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D50D
  ,simpleLowerCaseMapping:0x1D50D
  ,simpleTitleCaseMapping:0x1D50D
 },
 { code:0x1D50E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D50E
  ,simpleLowerCaseMapping:0x1D50E
  ,simpleTitleCaseMapping:0x1D50E
 },
 { code:0x1D50F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D50F
  ,simpleLowerCaseMapping:0x1D50F
  ,simpleTitleCaseMapping:0x1D50F
 },
 { code:0x1D510
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D510
  ,simpleLowerCaseMapping:0x1D510
  ,simpleTitleCaseMapping:0x1D510
 },
 { code:0x1D511
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D511
  ,simpleLowerCaseMapping:0x1D511
  ,simpleTitleCaseMapping:0x1D511
 },
 { code:0x1D512
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D512
  ,simpleLowerCaseMapping:0x1D512
  ,simpleTitleCaseMapping:0x1D512
 },
 { code:0x1D513
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D513
  ,simpleLowerCaseMapping:0x1D513
  ,simpleTitleCaseMapping:0x1D513
 },
 { code:0x1D514
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D514
  ,simpleLowerCaseMapping:0x1D514
  ,simpleTitleCaseMapping:0x1D514
 },
 { code:0x1D516
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D516
  ,simpleLowerCaseMapping:0x1D516
  ,simpleTitleCaseMapping:0x1D516
 },
 { code:0x1D517
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D517
  ,simpleLowerCaseMapping:0x1D517
  ,simpleTitleCaseMapping:0x1D517
 },
 { code:0x1D518
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D518
  ,simpleLowerCaseMapping:0x1D518
  ,simpleTitleCaseMapping:0x1D518
 },
 { code:0x1D519
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D519
  ,simpleLowerCaseMapping:0x1D519
  ,simpleTitleCaseMapping:0x1D519
 },
 { code:0x1D51A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D51A
  ,simpleLowerCaseMapping:0x1D51A
  ,simpleTitleCaseMapping:0x1D51A
 },
 { code:0x1D51B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D51B
  ,simpleLowerCaseMapping:0x1D51B
  ,simpleTitleCaseMapping:0x1D51B
 },
 { code:0x1D51C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D51C
  ,simpleLowerCaseMapping:0x1D51C
  ,simpleTitleCaseMapping:0x1D51C
 },
 { code:0x1D51E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D51E
  ,simpleLowerCaseMapping:0x1D51E
  ,simpleTitleCaseMapping:0x1D51E
 },
 { code:0x1D51F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D51F
  ,simpleLowerCaseMapping:0x1D51F
  ,simpleTitleCaseMapping:0x1D51F
 },
 { code:0x1D520
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D520
  ,simpleLowerCaseMapping:0x1D520
  ,simpleTitleCaseMapping:0x1D520
 },
 { code:0x1D521
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D521
  ,simpleLowerCaseMapping:0x1D521
  ,simpleTitleCaseMapping:0x1D521
 },
 { code:0x1D522
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D522
  ,simpleLowerCaseMapping:0x1D522
  ,simpleTitleCaseMapping:0x1D522
 },
 { code:0x1D523
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D523
  ,simpleLowerCaseMapping:0x1D523
  ,simpleTitleCaseMapping:0x1D523
 },
 { code:0x1D524
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D524
  ,simpleLowerCaseMapping:0x1D524
  ,simpleTitleCaseMapping:0x1D524
 },
 { code:0x1D525
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D525
  ,simpleLowerCaseMapping:0x1D525
  ,simpleTitleCaseMapping:0x1D525
 },
 { code:0x1D526
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D526
  ,simpleLowerCaseMapping:0x1D526
  ,simpleTitleCaseMapping:0x1D526
 },
 { code:0x1D527
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D527
  ,simpleLowerCaseMapping:0x1D527
  ,simpleTitleCaseMapping:0x1D527
 },
 { code:0x1D528
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D528
  ,simpleLowerCaseMapping:0x1D528
  ,simpleTitleCaseMapping:0x1D528
 },
 { code:0x1D529
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D529
  ,simpleLowerCaseMapping:0x1D529
  ,simpleTitleCaseMapping:0x1D529
 },
 { code:0x1D52A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D52A
  ,simpleLowerCaseMapping:0x1D52A
  ,simpleTitleCaseMapping:0x1D52A
 },
 { code:0x1D52B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D52B
  ,simpleLowerCaseMapping:0x1D52B
  ,simpleTitleCaseMapping:0x1D52B
 },
 { code:0x1D52C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D52C
  ,simpleLowerCaseMapping:0x1D52C
  ,simpleTitleCaseMapping:0x1D52C
 },
 { code:0x1D52D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D52D
  ,simpleLowerCaseMapping:0x1D52D
  ,simpleTitleCaseMapping:0x1D52D
 },
 { code:0x1D52E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D52E
  ,simpleLowerCaseMapping:0x1D52E
  ,simpleTitleCaseMapping:0x1D52E
 },
 { code:0x1D52F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D52F
  ,simpleLowerCaseMapping:0x1D52F
  ,simpleTitleCaseMapping:0x1D52F
 },
 { code:0x1D530
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D530
  ,simpleLowerCaseMapping:0x1D530
  ,simpleTitleCaseMapping:0x1D530
 },
 { code:0x1D531
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D531
  ,simpleLowerCaseMapping:0x1D531
  ,simpleTitleCaseMapping:0x1D531
 },
 { code:0x1D532
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D532
  ,simpleLowerCaseMapping:0x1D532
  ,simpleTitleCaseMapping:0x1D532
 },
 { code:0x1D533
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D533
  ,simpleLowerCaseMapping:0x1D533
  ,simpleTitleCaseMapping:0x1D533
 },
 { code:0x1D534
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D534
  ,simpleLowerCaseMapping:0x1D534
  ,simpleTitleCaseMapping:0x1D534
 },
 { code:0x1D535
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D535
  ,simpleLowerCaseMapping:0x1D535
  ,simpleTitleCaseMapping:0x1D535
 },
 { code:0x1D536
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D536
  ,simpleLowerCaseMapping:0x1D536
  ,simpleTitleCaseMapping:0x1D536
 },
 { code:0x1D537
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D537
  ,simpleLowerCaseMapping:0x1D537
  ,simpleTitleCaseMapping:0x1D537
 },
 { code:0x1D538
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D538
  ,simpleLowerCaseMapping:0x1D538
  ,simpleTitleCaseMapping:0x1D538
 },
 { code:0x1D539
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D539
  ,simpleLowerCaseMapping:0x1D539
  ,simpleTitleCaseMapping:0x1D539
 },
 { code:0x1D53B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D53B
  ,simpleLowerCaseMapping:0x1D53B
  ,simpleTitleCaseMapping:0x1D53B
 },
 { code:0x1D53C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D53C
  ,simpleLowerCaseMapping:0x1D53C
  ,simpleTitleCaseMapping:0x1D53C
 },
 { code:0x1D53D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D53D
  ,simpleLowerCaseMapping:0x1D53D
  ,simpleTitleCaseMapping:0x1D53D
 },
 { code:0x1D53E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D53E
  ,simpleLowerCaseMapping:0x1D53E
  ,simpleTitleCaseMapping:0x1D53E
 },
 { code:0x1D540
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D540
  ,simpleLowerCaseMapping:0x1D540
  ,simpleTitleCaseMapping:0x1D540
 },
 { code:0x1D541
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D541
  ,simpleLowerCaseMapping:0x1D541
  ,simpleTitleCaseMapping:0x1D541
 },
 { code:0x1D542
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D542
  ,simpleLowerCaseMapping:0x1D542
  ,simpleTitleCaseMapping:0x1D542
 },
 { code:0x1D543
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D543
  ,simpleLowerCaseMapping:0x1D543
  ,simpleTitleCaseMapping:0x1D543
 },
 { code:0x1D544
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D544
  ,simpleLowerCaseMapping:0x1D544
  ,simpleTitleCaseMapping:0x1D544
 },
 { code:0x1D546
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D546
  ,simpleLowerCaseMapping:0x1D546
  ,simpleTitleCaseMapping:0x1D546
 },
 { code:0x1D54A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D54A
  ,simpleLowerCaseMapping:0x1D54A
  ,simpleTitleCaseMapping:0x1D54A
 },
 { code:0x1D54B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D54B
  ,simpleLowerCaseMapping:0x1D54B
  ,simpleTitleCaseMapping:0x1D54B
 },
 { code:0x1D54C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D54C
  ,simpleLowerCaseMapping:0x1D54C
  ,simpleTitleCaseMapping:0x1D54C
 },
 { code:0x1D54D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D54D
  ,simpleLowerCaseMapping:0x1D54D
  ,simpleTitleCaseMapping:0x1D54D
 },
 { code:0x1D54E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D54E
  ,simpleLowerCaseMapping:0x1D54E
  ,simpleTitleCaseMapping:0x1D54E
 },
 { code:0x1D54F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D54F
  ,simpleLowerCaseMapping:0x1D54F
  ,simpleTitleCaseMapping:0x1D54F
 },
 { code:0x1D550
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D550
  ,simpleLowerCaseMapping:0x1D550
  ,simpleTitleCaseMapping:0x1D550
 },
 { code:0x1D552
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D552
  ,simpleLowerCaseMapping:0x1D552
  ,simpleTitleCaseMapping:0x1D552
 },
 { code:0x1D553
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D553
  ,simpleLowerCaseMapping:0x1D553
  ,simpleTitleCaseMapping:0x1D553
 },
 { code:0x1D554
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D554
  ,simpleLowerCaseMapping:0x1D554
  ,simpleTitleCaseMapping:0x1D554
 },
 { code:0x1D555
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D555
  ,simpleLowerCaseMapping:0x1D555
  ,simpleTitleCaseMapping:0x1D555
 },
 { code:0x1D556
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D556
  ,simpleLowerCaseMapping:0x1D556
  ,simpleTitleCaseMapping:0x1D556
 },
 { code:0x1D557
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D557
  ,simpleLowerCaseMapping:0x1D557
  ,simpleTitleCaseMapping:0x1D557
 },
 { code:0x1D558
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D558
  ,simpleLowerCaseMapping:0x1D558
  ,simpleTitleCaseMapping:0x1D558
 },
 { code:0x1D559
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D559
  ,simpleLowerCaseMapping:0x1D559
  ,simpleTitleCaseMapping:0x1D559
 },
 { code:0x1D55A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D55A
  ,simpleLowerCaseMapping:0x1D55A
  ,simpleTitleCaseMapping:0x1D55A
 },
 { code:0x1D55B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D55B
  ,simpleLowerCaseMapping:0x1D55B
  ,simpleTitleCaseMapping:0x1D55B
 },
 { code:0x1D55C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D55C
  ,simpleLowerCaseMapping:0x1D55C
  ,simpleTitleCaseMapping:0x1D55C
 },
 { code:0x1D55D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D55D
  ,simpleLowerCaseMapping:0x1D55D
  ,simpleTitleCaseMapping:0x1D55D
 },
 { code:0x1D55E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D55E
  ,simpleLowerCaseMapping:0x1D55E
  ,simpleTitleCaseMapping:0x1D55E
 },
 { code:0x1D55F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D55F
  ,simpleLowerCaseMapping:0x1D55F
  ,simpleTitleCaseMapping:0x1D55F
 },
 { code:0x1D560
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D560
  ,simpleLowerCaseMapping:0x1D560
  ,simpleTitleCaseMapping:0x1D560
 },
 { code:0x1D561
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D561
  ,simpleLowerCaseMapping:0x1D561
  ,simpleTitleCaseMapping:0x1D561
 },
 { code:0x1D562
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D562
  ,simpleLowerCaseMapping:0x1D562
  ,simpleTitleCaseMapping:0x1D562
 },
 { code:0x1D563
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D563
  ,simpleLowerCaseMapping:0x1D563
  ,simpleTitleCaseMapping:0x1D563
 },
 { code:0x1D564
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D564
  ,simpleLowerCaseMapping:0x1D564
  ,simpleTitleCaseMapping:0x1D564
 },
 { code:0x1D565
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D565
  ,simpleLowerCaseMapping:0x1D565
  ,simpleTitleCaseMapping:0x1D565
 },
 { code:0x1D566
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D566
  ,simpleLowerCaseMapping:0x1D566
  ,simpleTitleCaseMapping:0x1D566
 },
 { code:0x1D567
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D567
  ,simpleLowerCaseMapping:0x1D567
  ,simpleTitleCaseMapping:0x1D567
 },
 { code:0x1D568
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D568
  ,simpleLowerCaseMapping:0x1D568
  ,simpleTitleCaseMapping:0x1D568
 },
 { code:0x1D569
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D569
  ,simpleLowerCaseMapping:0x1D569
  ,simpleTitleCaseMapping:0x1D569
 },
 { code:0x1D56A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D56A
  ,simpleLowerCaseMapping:0x1D56A
  ,simpleTitleCaseMapping:0x1D56A
 },
 { code:0x1D56B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D56B
  ,simpleLowerCaseMapping:0x1D56B
  ,simpleTitleCaseMapping:0x1D56B
 },
 { code:0x1D56C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D56C
  ,simpleLowerCaseMapping:0x1D56C
  ,simpleTitleCaseMapping:0x1D56C
 },
 { code:0x1D56D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D56D
  ,simpleLowerCaseMapping:0x1D56D
  ,simpleTitleCaseMapping:0x1D56D
 },
 { code:0x1D56E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D56E
  ,simpleLowerCaseMapping:0x1D56E
  ,simpleTitleCaseMapping:0x1D56E
 },
 { code:0x1D56F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D56F
  ,simpleLowerCaseMapping:0x1D56F
  ,simpleTitleCaseMapping:0x1D56F
 },
 { code:0x1D570
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D570
  ,simpleLowerCaseMapping:0x1D570
  ,simpleTitleCaseMapping:0x1D570
 },
 { code:0x1D571
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D571
  ,simpleLowerCaseMapping:0x1D571
  ,simpleTitleCaseMapping:0x1D571
 },
 { code:0x1D572
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D572
  ,simpleLowerCaseMapping:0x1D572
  ,simpleTitleCaseMapping:0x1D572
 },
 { code:0x1D573
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D573
  ,simpleLowerCaseMapping:0x1D573
  ,simpleTitleCaseMapping:0x1D573
 },
 { code:0x1D574
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D574
  ,simpleLowerCaseMapping:0x1D574
  ,simpleTitleCaseMapping:0x1D574
 },
 { code:0x1D575
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D575
  ,simpleLowerCaseMapping:0x1D575
  ,simpleTitleCaseMapping:0x1D575
 },
 { code:0x1D576
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D576
  ,simpleLowerCaseMapping:0x1D576
  ,simpleTitleCaseMapping:0x1D576
 },
 { code:0x1D577
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D577
  ,simpleLowerCaseMapping:0x1D577
  ,simpleTitleCaseMapping:0x1D577
 },
 { code:0x1D578
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D578
  ,simpleLowerCaseMapping:0x1D578
  ,simpleTitleCaseMapping:0x1D578
 },
 { code:0x1D579
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D579
  ,simpleLowerCaseMapping:0x1D579
  ,simpleTitleCaseMapping:0x1D579
 },
 { code:0x1D57A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D57A
  ,simpleLowerCaseMapping:0x1D57A
  ,simpleTitleCaseMapping:0x1D57A
 },
 { code:0x1D57B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D57B
  ,simpleLowerCaseMapping:0x1D57B
  ,simpleTitleCaseMapping:0x1D57B
 },
 { code:0x1D57C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D57C
  ,simpleLowerCaseMapping:0x1D57C
  ,simpleTitleCaseMapping:0x1D57C
 },
 { code:0x1D57D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D57D
  ,simpleLowerCaseMapping:0x1D57D
  ,simpleTitleCaseMapping:0x1D57D
 },
 { code:0x1D57E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D57E
  ,simpleLowerCaseMapping:0x1D57E
  ,simpleTitleCaseMapping:0x1D57E
 },
 { code:0x1D57F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D57F
  ,simpleLowerCaseMapping:0x1D57F
  ,simpleTitleCaseMapping:0x1D57F
 },
 { code:0x1D580
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D580
  ,simpleLowerCaseMapping:0x1D580
  ,simpleTitleCaseMapping:0x1D580
 },
 { code:0x1D581
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D581
  ,simpleLowerCaseMapping:0x1D581
  ,simpleTitleCaseMapping:0x1D581
 },
 { code:0x1D582
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D582
  ,simpleLowerCaseMapping:0x1D582
  ,simpleTitleCaseMapping:0x1D582
 },
 { code:0x1D583
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D583
  ,simpleLowerCaseMapping:0x1D583
  ,simpleTitleCaseMapping:0x1D583
 },
 { code:0x1D584
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D584
  ,simpleLowerCaseMapping:0x1D584
  ,simpleTitleCaseMapping:0x1D584
 },
 { code:0x1D585
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D585
  ,simpleLowerCaseMapping:0x1D585
  ,simpleTitleCaseMapping:0x1D585
 },
 { code:0x1D586
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D586
  ,simpleLowerCaseMapping:0x1D586
  ,simpleTitleCaseMapping:0x1D586
 },
 { code:0x1D587
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D587
  ,simpleLowerCaseMapping:0x1D587
  ,simpleTitleCaseMapping:0x1D587
 },
 { code:0x1D588
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D588
  ,simpleLowerCaseMapping:0x1D588
  ,simpleTitleCaseMapping:0x1D588
 },
 { code:0x1D589
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D589
  ,simpleLowerCaseMapping:0x1D589
  ,simpleTitleCaseMapping:0x1D589
 },
 { code:0x1D58A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D58A
  ,simpleLowerCaseMapping:0x1D58A
  ,simpleTitleCaseMapping:0x1D58A
 },
 { code:0x1D58B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D58B
  ,simpleLowerCaseMapping:0x1D58B
  ,simpleTitleCaseMapping:0x1D58B
 },
 { code:0x1D58C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D58C
  ,simpleLowerCaseMapping:0x1D58C
  ,simpleTitleCaseMapping:0x1D58C
 },
 { code:0x1D58D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D58D
  ,simpleLowerCaseMapping:0x1D58D
  ,simpleTitleCaseMapping:0x1D58D
 },
 { code:0x1D58E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D58E
  ,simpleLowerCaseMapping:0x1D58E
  ,simpleTitleCaseMapping:0x1D58E
 },
 { code:0x1D58F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D58F
  ,simpleLowerCaseMapping:0x1D58F
  ,simpleTitleCaseMapping:0x1D58F
 },
 { code:0x1D590
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D590
  ,simpleLowerCaseMapping:0x1D590
  ,simpleTitleCaseMapping:0x1D590
 },
 { code:0x1D591
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D591
  ,simpleLowerCaseMapping:0x1D591
  ,simpleTitleCaseMapping:0x1D591
 },
 { code:0x1D592
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D592
  ,simpleLowerCaseMapping:0x1D592
  ,simpleTitleCaseMapping:0x1D592
 },
 { code:0x1D593
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D593
  ,simpleLowerCaseMapping:0x1D593
  ,simpleTitleCaseMapping:0x1D593
 },
 { code:0x1D594
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D594
  ,simpleLowerCaseMapping:0x1D594
  ,simpleTitleCaseMapping:0x1D594
 },
 { code:0x1D595
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D595
  ,simpleLowerCaseMapping:0x1D595
  ,simpleTitleCaseMapping:0x1D595
 },
 { code:0x1D596
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D596
  ,simpleLowerCaseMapping:0x1D596
  ,simpleTitleCaseMapping:0x1D596
 },
 { code:0x1D597
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D597
  ,simpleLowerCaseMapping:0x1D597
  ,simpleTitleCaseMapping:0x1D597
 },
 { code:0x1D598
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D598
  ,simpleLowerCaseMapping:0x1D598
  ,simpleTitleCaseMapping:0x1D598
 },
 { code:0x1D599
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D599
  ,simpleLowerCaseMapping:0x1D599
  ,simpleTitleCaseMapping:0x1D599
 },
 { code:0x1D59A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D59A
  ,simpleLowerCaseMapping:0x1D59A
  ,simpleTitleCaseMapping:0x1D59A
 },
 { code:0x1D59B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D59B
  ,simpleLowerCaseMapping:0x1D59B
  ,simpleTitleCaseMapping:0x1D59B
 },
 { code:0x1D59C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D59C
  ,simpleLowerCaseMapping:0x1D59C
  ,simpleTitleCaseMapping:0x1D59C
 },
 { code:0x1D59D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D59D
  ,simpleLowerCaseMapping:0x1D59D
  ,simpleTitleCaseMapping:0x1D59D
 },
 { code:0x1D59E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D59E
  ,simpleLowerCaseMapping:0x1D59E
  ,simpleTitleCaseMapping:0x1D59E
 },
 { code:0x1D59F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D59F
  ,simpleLowerCaseMapping:0x1D59F
  ,simpleTitleCaseMapping:0x1D59F
 },
 { code:0x1D5A0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5A0
  ,simpleLowerCaseMapping:0x1D5A0
  ,simpleTitleCaseMapping:0x1D5A0
 },
 { code:0x1D5A1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5A1
  ,simpleLowerCaseMapping:0x1D5A1
  ,simpleTitleCaseMapping:0x1D5A1
 },
 { code:0x1D5A2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5A2
  ,simpleLowerCaseMapping:0x1D5A2
  ,simpleTitleCaseMapping:0x1D5A2
 },
 { code:0x1D5A3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5A3
  ,simpleLowerCaseMapping:0x1D5A3
  ,simpleTitleCaseMapping:0x1D5A3
 },
 { code:0x1D5A4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5A4
  ,simpleLowerCaseMapping:0x1D5A4
  ,simpleTitleCaseMapping:0x1D5A4
 },
 { code:0x1D5A5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5A5
  ,simpleLowerCaseMapping:0x1D5A5
  ,simpleTitleCaseMapping:0x1D5A5
 },
 { code:0x1D5A6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5A6
  ,simpleLowerCaseMapping:0x1D5A6
  ,simpleTitleCaseMapping:0x1D5A6
 },
 { code:0x1D5A7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5A7
  ,simpleLowerCaseMapping:0x1D5A7
  ,simpleTitleCaseMapping:0x1D5A7
 },
 { code:0x1D5A8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5A8
  ,simpleLowerCaseMapping:0x1D5A8
  ,simpleTitleCaseMapping:0x1D5A8
 },
 { code:0x1D5A9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5A9
  ,simpleLowerCaseMapping:0x1D5A9
  ,simpleTitleCaseMapping:0x1D5A9
 },
 { code:0x1D5AA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5AA
  ,simpleLowerCaseMapping:0x1D5AA
  ,simpleTitleCaseMapping:0x1D5AA
 },
 { code:0x1D5AB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5AB
  ,simpleLowerCaseMapping:0x1D5AB
  ,simpleTitleCaseMapping:0x1D5AB
 },
 { code:0x1D5AC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5AC
  ,simpleLowerCaseMapping:0x1D5AC
  ,simpleTitleCaseMapping:0x1D5AC
 },
 { code:0x1D5AD
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5AD
  ,simpleLowerCaseMapping:0x1D5AD
  ,simpleTitleCaseMapping:0x1D5AD
 },
 { code:0x1D5AE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5AE
  ,simpleLowerCaseMapping:0x1D5AE
  ,simpleTitleCaseMapping:0x1D5AE
 },
 { code:0x1D5AF
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5AF
  ,simpleLowerCaseMapping:0x1D5AF
  ,simpleTitleCaseMapping:0x1D5AF
 },
 { code:0x1D5B0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5B0
  ,simpleLowerCaseMapping:0x1D5B0
  ,simpleTitleCaseMapping:0x1D5B0
 },
 { code:0x1D5B1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5B1
  ,simpleLowerCaseMapping:0x1D5B1
  ,simpleTitleCaseMapping:0x1D5B1
 },
 { code:0x1D5B2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5B2
  ,simpleLowerCaseMapping:0x1D5B2
  ,simpleTitleCaseMapping:0x1D5B2
 },
 { code:0x1D5B3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5B3
  ,simpleLowerCaseMapping:0x1D5B3
  ,simpleTitleCaseMapping:0x1D5B3
 },
 { code:0x1D5B4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5B4
  ,simpleLowerCaseMapping:0x1D5B4
  ,simpleTitleCaseMapping:0x1D5B4
 },
 { code:0x1D5B5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5B5
  ,simpleLowerCaseMapping:0x1D5B5
  ,simpleTitleCaseMapping:0x1D5B5
 },
 { code:0x1D5B6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5B6
  ,simpleLowerCaseMapping:0x1D5B6
  ,simpleTitleCaseMapping:0x1D5B6
 },
 { code:0x1D5B7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5B7
  ,simpleLowerCaseMapping:0x1D5B7
  ,simpleTitleCaseMapping:0x1D5B7
 },
 { code:0x1D5B8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5B8
  ,simpleLowerCaseMapping:0x1D5B8
  ,simpleTitleCaseMapping:0x1D5B8
 },
 { code:0x1D5B9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5B9
  ,simpleLowerCaseMapping:0x1D5B9
  ,simpleTitleCaseMapping:0x1D5B9
 },
 { code:0x1D5BA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5BA
  ,simpleLowerCaseMapping:0x1D5BA
  ,simpleTitleCaseMapping:0x1D5BA
 },
 { code:0x1D5BB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5BB
  ,simpleLowerCaseMapping:0x1D5BB
  ,simpleTitleCaseMapping:0x1D5BB
 },
 { code:0x1D5BC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5BC
  ,simpleLowerCaseMapping:0x1D5BC
  ,simpleTitleCaseMapping:0x1D5BC
 },
 { code:0x1D5BD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5BD
  ,simpleLowerCaseMapping:0x1D5BD
  ,simpleTitleCaseMapping:0x1D5BD
 },
 { code:0x1D5BE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5BE
  ,simpleLowerCaseMapping:0x1D5BE
  ,simpleTitleCaseMapping:0x1D5BE
 },
 { code:0x1D5BF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5BF
  ,simpleLowerCaseMapping:0x1D5BF
  ,simpleTitleCaseMapping:0x1D5BF
 },
 { code:0x1D5C0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5C0
  ,simpleLowerCaseMapping:0x1D5C0
  ,simpleTitleCaseMapping:0x1D5C0
 },
 { code:0x1D5C1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5C1
  ,simpleLowerCaseMapping:0x1D5C1
  ,simpleTitleCaseMapping:0x1D5C1
 },
 { code:0x1D5C2
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5C2
  ,simpleLowerCaseMapping:0x1D5C2
  ,simpleTitleCaseMapping:0x1D5C2
 },
 { code:0x1D5C3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5C3
  ,simpleLowerCaseMapping:0x1D5C3
  ,simpleTitleCaseMapping:0x1D5C3
 },
 { code:0x1D5C4
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5C4
  ,simpleLowerCaseMapping:0x1D5C4
  ,simpleTitleCaseMapping:0x1D5C4
 },
 { code:0x1D5C5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5C5
  ,simpleLowerCaseMapping:0x1D5C5
  ,simpleTitleCaseMapping:0x1D5C5
 },
 { code:0x1D5C6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5C6
  ,simpleLowerCaseMapping:0x1D5C6
  ,simpleTitleCaseMapping:0x1D5C6
 },
 { code:0x1D5C7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5C7
  ,simpleLowerCaseMapping:0x1D5C7
  ,simpleTitleCaseMapping:0x1D5C7
 },
 { code:0x1D5C8
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5C8
  ,simpleLowerCaseMapping:0x1D5C8
  ,simpleTitleCaseMapping:0x1D5C8
 },
 { code:0x1D5C9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5C9
  ,simpleLowerCaseMapping:0x1D5C9
  ,simpleTitleCaseMapping:0x1D5C9
 },
 { code:0x1D5CA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5CA
  ,simpleLowerCaseMapping:0x1D5CA
  ,simpleTitleCaseMapping:0x1D5CA
 },
 { code:0x1D5CB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5CB
  ,simpleLowerCaseMapping:0x1D5CB
  ,simpleTitleCaseMapping:0x1D5CB
 },
 { code:0x1D5CC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5CC
  ,simpleLowerCaseMapping:0x1D5CC
  ,simpleTitleCaseMapping:0x1D5CC
 },
 { code:0x1D5CD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5CD
  ,simpleLowerCaseMapping:0x1D5CD
  ,simpleTitleCaseMapping:0x1D5CD
 },
 { code:0x1D5CE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5CE
  ,simpleLowerCaseMapping:0x1D5CE
  ,simpleTitleCaseMapping:0x1D5CE
 },
 { code:0x1D5CF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5CF
  ,simpleLowerCaseMapping:0x1D5CF
  ,simpleTitleCaseMapping:0x1D5CF
 },
 { code:0x1D5D0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5D0
  ,simpleLowerCaseMapping:0x1D5D0
  ,simpleTitleCaseMapping:0x1D5D0
 },
 { code:0x1D5D1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5D1
  ,simpleLowerCaseMapping:0x1D5D1
  ,simpleTitleCaseMapping:0x1D5D1
 },
 { code:0x1D5D2
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5D2
  ,simpleLowerCaseMapping:0x1D5D2
  ,simpleTitleCaseMapping:0x1D5D2
 },
 { code:0x1D5D3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5D3
  ,simpleLowerCaseMapping:0x1D5D3
  ,simpleTitleCaseMapping:0x1D5D3
 },
 { code:0x1D5D4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5D4
  ,simpleLowerCaseMapping:0x1D5D4
  ,simpleTitleCaseMapping:0x1D5D4
 },
 { code:0x1D5D5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5D5
  ,simpleLowerCaseMapping:0x1D5D5
  ,simpleTitleCaseMapping:0x1D5D5
 },
 { code:0x1D5D6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5D6
  ,simpleLowerCaseMapping:0x1D5D6
  ,simpleTitleCaseMapping:0x1D5D6
 },
 { code:0x1D5D7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5D7
  ,simpleLowerCaseMapping:0x1D5D7
  ,simpleTitleCaseMapping:0x1D5D7
 },
 { code:0x1D5D8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5D8
  ,simpleLowerCaseMapping:0x1D5D8
  ,simpleTitleCaseMapping:0x1D5D8
 },
 { code:0x1D5D9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5D9
  ,simpleLowerCaseMapping:0x1D5D9
  ,simpleTitleCaseMapping:0x1D5D9
 },
 { code:0x1D5DA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5DA
  ,simpleLowerCaseMapping:0x1D5DA
  ,simpleTitleCaseMapping:0x1D5DA
 },
 { code:0x1D5DB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5DB
  ,simpleLowerCaseMapping:0x1D5DB
  ,simpleTitleCaseMapping:0x1D5DB
 },
 { code:0x1D5DC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5DC
  ,simpleLowerCaseMapping:0x1D5DC
  ,simpleTitleCaseMapping:0x1D5DC
 },
 { code:0x1D5DD
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5DD
  ,simpleLowerCaseMapping:0x1D5DD
  ,simpleTitleCaseMapping:0x1D5DD
 },
 { code:0x1D5DE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5DE
  ,simpleLowerCaseMapping:0x1D5DE
  ,simpleTitleCaseMapping:0x1D5DE
 },
 { code:0x1D5DF
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5DF
  ,simpleLowerCaseMapping:0x1D5DF
  ,simpleTitleCaseMapping:0x1D5DF
 },
 { code:0x1D5E0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5E0
  ,simpleLowerCaseMapping:0x1D5E0
  ,simpleTitleCaseMapping:0x1D5E0
 },
 { code:0x1D5E1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5E1
  ,simpleLowerCaseMapping:0x1D5E1
  ,simpleTitleCaseMapping:0x1D5E1
 },
 { code:0x1D5E2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5E2
  ,simpleLowerCaseMapping:0x1D5E2
  ,simpleTitleCaseMapping:0x1D5E2
 },
 { code:0x1D5E3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5E3
  ,simpleLowerCaseMapping:0x1D5E3
  ,simpleTitleCaseMapping:0x1D5E3
 },
 { code:0x1D5E4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5E4
  ,simpleLowerCaseMapping:0x1D5E4
  ,simpleTitleCaseMapping:0x1D5E4
 },
 { code:0x1D5E5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5E5
  ,simpleLowerCaseMapping:0x1D5E5
  ,simpleTitleCaseMapping:0x1D5E5
 },
 { code:0x1D5E6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5E6
  ,simpleLowerCaseMapping:0x1D5E6
  ,simpleTitleCaseMapping:0x1D5E6
 },
 { code:0x1D5E7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5E7
  ,simpleLowerCaseMapping:0x1D5E7
  ,simpleTitleCaseMapping:0x1D5E7
 },
 { code:0x1D5E8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5E8
  ,simpleLowerCaseMapping:0x1D5E8
  ,simpleTitleCaseMapping:0x1D5E8
 },
 { code:0x1D5E9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5E9
  ,simpleLowerCaseMapping:0x1D5E9
  ,simpleTitleCaseMapping:0x1D5E9
 },
 { code:0x1D5EA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5EA
  ,simpleLowerCaseMapping:0x1D5EA
  ,simpleTitleCaseMapping:0x1D5EA
 },
 { code:0x1D5EB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5EB
  ,simpleLowerCaseMapping:0x1D5EB
  ,simpleTitleCaseMapping:0x1D5EB
 },
 { code:0x1D5EC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5EC
  ,simpleLowerCaseMapping:0x1D5EC
  ,simpleTitleCaseMapping:0x1D5EC
 },
 { code:0x1D5ED
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D5ED
  ,simpleLowerCaseMapping:0x1D5ED
  ,simpleTitleCaseMapping:0x1D5ED
 },
 { code:0x1D5EE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5EE
  ,simpleLowerCaseMapping:0x1D5EE
  ,simpleTitleCaseMapping:0x1D5EE
 },
 { code:0x1D5EF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5EF
  ,simpleLowerCaseMapping:0x1D5EF
  ,simpleTitleCaseMapping:0x1D5EF
 },
 { code:0x1D5F0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5F0
  ,simpleLowerCaseMapping:0x1D5F0
  ,simpleTitleCaseMapping:0x1D5F0
 },
 { code:0x1D5F1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5F1
  ,simpleLowerCaseMapping:0x1D5F1
  ,simpleTitleCaseMapping:0x1D5F1
 },
 { code:0x1D5F2
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5F2
  ,simpleLowerCaseMapping:0x1D5F2
  ,simpleTitleCaseMapping:0x1D5F2
 },
 { code:0x1D5F3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5F3
  ,simpleLowerCaseMapping:0x1D5F3
  ,simpleTitleCaseMapping:0x1D5F3
 },
 { code:0x1D5F4
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5F4
  ,simpleLowerCaseMapping:0x1D5F4
  ,simpleTitleCaseMapping:0x1D5F4
 },
 { code:0x1D5F5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5F5
  ,simpleLowerCaseMapping:0x1D5F5
  ,simpleTitleCaseMapping:0x1D5F5
 },
 { code:0x1D5F6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5F6
  ,simpleLowerCaseMapping:0x1D5F6
  ,simpleTitleCaseMapping:0x1D5F6
 },
 { code:0x1D5F7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5F7
  ,simpleLowerCaseMapping:0x1D5F7
  ,simpleTitleCaseMapping:0x1D5F7
 },
 { code:0x1D5F8
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5F8
  ,simpleLowerCaseMapping:0x1D5F8
  ,simpleTitleCaseMapping:0x1D5F8
 },
 { code:0x1D5F9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5F9
  ,simpleLowerCaseMapping:0x1D5F9
  ,simpleTitleCaseMapping:0x1D5F9
 },
 { code:0x1D5FA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5FA
  ,simpleLowerCaseMapping:0x1D5FA
  ,simpleTitleCaseMapping:0x1D5FA
 },
 { code:0x1D5FB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5FB
  ,simpleLowerCaseMapping:0x1D5FB
  ,simpleTitleCaseMapping:0x1D5FB
 },
 { code:0x1D5FC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5FC
  ,simpleLowerCaseMapping:0x1D5FC
  ,simpleTitleCaseMapping:0x1D5FC
 },
 { code:0x1D5FD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5FD
  ,simpleLowerCaseMapping:0x1D5FD
  ,simpleTitleCaseMapping:0x1D5FD
 },
 { code:0x1D5FE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5FE
  ,simpleLowerCaseMapping:0x1D5FE
  ,simpleTitleCaseMapping:0x1D5FE
 },
 { code:0x1D5FF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D5FF
  ,simpleLowerCaseMapping:0x1D5FF
  ,simpleTitleCaseMapping:0x1D5FF
 },
 { code:0x1D600
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D600
  ,simpleLowerCaseMapping:0x1D600
  ,simpleTitleCaseMapping:0x1D600
 },
 { code:0x1D601
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D601
  ,simpleLowerCaseMapping:0x1D601
  ,simpleTitleCaseMapping:0x1D601
 },
 { code:0x1D602
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D602
  ,simpleLowerCaseMapping:0x1D602
  ,simpleTitleCaseMapping:0x1D602
 },
 { code:0x1D603
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D603
  ,simpleLowerCaseMapping:0x1D603
  ,simpleTitleCaseMapping:0x1D603
 },
 { code:0x1D604
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D604
  ,simpleLowerCaseMapping:0x1D604
  ,simpleTitleCaseMapping:0x1D604
 },
 { code:0x1D605
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D605
  ,simpleLowerCaseMapping:0x1D605
  ,simpleTitleCaseMapping:0x1D605
 },
 { code:0x1D606
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D606
  ,simpleLowerCaseMapping:0x1D606
  ,simpleTitleCaseMapping:0x1D606
 },
 { code:0x1D607
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D607
  ,simpleLowerCaseMapping:0x1D607
  ,simpleTitleCaseMapping:0x1D607
 },
 { code:0x1D608
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D608
  ,simpleLowerCaseMapping:0x1D608
  ,simpleTitleCaseMapping:0x1D608
 },
 { code:0x1D609
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D609
  ,simpleLowerCaseMapping:0x1D609
  ,simpleTitleCaseMapping:0x1D609
 },
 { code:0x1D60A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D60A
  ,simpleLowerCaseMapping:0x1D60A
  ,simpleTitleCaseMapping:0x1D60A
 },
 { code:0x1D60B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D60B
  ,simpleLowerCaseMapping:0x1D60B
  ,simpleTitleCaseMapping:0x1D60B
 },
 { code:0x1D60C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D60C
  ,simpleLowerCaseMapping:0x1D60C
  ,simpleTitleCaseMapping:0x1D60C
 },
 { code:0x1D60D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D60D
  ,simpleLowerCaseMapping:0x1D60D
  ,simpleTitleCaseMapping:0x1D60D
 },
 { code:0x1D60E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D60E
  ,simpleLowerCaseMapping:0x1D60E
  ,simpleTitleCaseMapping:0x1D60E
 },
 { code:0x1D60F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D60F
  ,simpleLowerCaseMapping:0x1D60F
  ,simpleTitleCaseMapping:0x1D60F
 },
 { code:0x1D610
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D610
  ,simpleLowerCaseMapping:0x1D610
  ,simpleTitleCaseMapping:0x1D610
 },
 { code:0x1D611
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D611
  ,simpleLowerCaseMapping:0x1D611
  ,simpleTitleCaseMapping:0x1D611
 },
 { code:0x1D612
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D612
  ,simpleLowerCaseMapping:0x1D612
  ,simpleTitleCaseMapping:0x1D612
 },
 { code:0x1D613
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D613
  ,simpleLowerCaseMapping:0x1D613
  ,simpleTitleCaseMapping:0x1D613
 },
 { code:0x1D614
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D614
  ,simpleLowerCaseMapping:0x1D614
  ,simpleTitleCaseMapping:0x1D614
 },
 { code:0x1D615
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D615
  ,simpleLowerCaseMapping:0x1D615
  ,simpleTitleCaseMapping:0x1D615
 },
 { code:0x1D616
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D616
  ,simpleLowerCaseMapping:0x1D616
  ,simpleTitleCaseMapping:0x1D616
 },
 { code:0x1D617
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D617
  ,simpleLowerCaseMapping:0x1D617
  ,simpleTitleCaseMapping:0x1D617
 },
 { code:0x1D618
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D618
  ,simpleLowerCaseMapping:0x1D618
  ,simpleTitleCaseMapping:0x1D618
 },
 { code:0x1D619
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D619
  ,simpleLowerCaseMapping:0x1D619
  ,simpleTitleCaseMapping:0x1D619
 },
 { code:0x1D61A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D61A
  ,simpleLowerCaseMapping:0x1D61A
  ,simpleTitleCaseMapping:0x1D61A
 },
 { code:0x1D61B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D61B
  ,simpleLowerCaseMapping:0x1D61B
  ,simpleTitleCaseMapping:0x1D61B
 },
 { code:0x1D61C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D61C
  ,simpleLowerCaseMapping:0x1D61C
  ,simpleTitleCaseMapping:0x1D61C
 },
 { code:0x1D61D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D61D
  ,simpleLowerCaseMapping:0x1D61D
  ,simpleTitleCaseMapping:0x1D61D
 },
 { code:0x1D61E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D61E
  ,simpleLowerCaseMapping:0x1D61E
  ,simpleTitleCaseMapping:0x1D61E
 },
 { code:0x1D61F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D61F
  ,simpleLowerCaseMapping:0x1D61F
  ,simpleTitleCaseMapping:0x1D61F
 },
 { code:0x1D620
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D620
  ,simpleLowerCaseMapping:0x1D620
  ,simpleTitleCaseMapping:0x1D620
 },
 { code:0x1D621
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D621
  ,simpleLowerCaseMapping:0x1D621
  ,simpleTitleCaseMapping:0x1D621
 },
 { code:0x1D622
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D622
  ,simpleLowerCaseMapping:0x1D622
  ,simpleTitleCaseMapping:0x1D622
 },
 { code:0x1D623
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D623
  ,simpleLowerCaseMapping:0x1D623
  ,simpleTitleCaseMapping:0x1D623
 },
 { code:0x1D624
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D624
  ,simpleLowerCaseMapping:0x1D624
  ,simpleTitleCaseMapping:0x1D624
 },
 { code:0x1D625
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D625
  ,simpleLowerCaseMapping:0x1D625
  ,simpleTitleCaseMapping:0x1D625
 },
 { code:0x1D626
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D626
  ,simpleLowerCaseMapping:0x1D626
  ,simpleTitleCaseMapping:0x1D626
 },
 { code:0x1D627
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D627
  ,simpleLowerCaseMapping:0x1D627
  ,simpleTitleCaseMapping:0x1D627
 },
 { code:0x1D628
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D628
  ,simpleLowerCaseMapping:0x1D628
  ,simpleTitleCaseMapping:0x1D628
 },
 { code:0x1D629
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D629
  ,simpleLowerCaseMapping:0x1D629
  ,simpleTitleCaseMapping:0x1D629
 },
 { code:0x1D62A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D62A
  ,simpleLowerCaseMapping:0x1D62A
  ,simpleTitleCaseMapping:0x1D62A
 },
 { code:0x1D62B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D62B
  ,simpleLowerCaseMapping:0x1D62B
  ,simpleTitleCaseMapping:0x1D62B
 },
 { code:0x1D62C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D62C
  ,simpleLowerCaseMapping:0x1D62C
  ,simpleTitleCaseMapping:0x1D62C
 },
 { code:0x1D62D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D62D
  ,simpleLowerCaseMapping:0x1D62D
  ,simpleTitleCaseMapping:0x1D62D
 },
 { code:0x1D62E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D62E
  ,simpleLowerCaseMapping:0x1D62E
  ,simpleTitleCaseMapping:0x1D62E
 },
 { code:0x1D62F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D62F
  ,simpleLowerCaseMapping:0x1D62F
  ,simpleTitleCaseMapping:0x1D62F
 },
 { code:0x1D630
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D630
  ,simpleLowerCaseMapping:0x1D630
  ,simpleTitleCaseMapping:0x1D630
 },
 { code:0x1D631
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D631
  ,simpleLowerCaseMapping:0x1D631
  ,simpleTitleCaseMapping:0x1D631
 },
 { code:0x1D632
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D632
  ,simpleLowerCaseMapping:0x1D632
  ,simpleTitleCaseMapping:0x1D632
 },
 { code:0x1D633
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D633
  ,simpleLowerCaseMapping:0x1D633
  ,simpleTitleCaseMapping:0x1D633
 },
 { code:0x1D634
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D634
  ,simpleLowerCaseMapping:0x1D634
  ,simpleTitleCaseMapping:0x1D634
 },
 { code:0x1D635
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D635
  ,simpleLowerCaseMapping:0x1D635
  ,simpleTitleCaseMapping:0x1D635
 },
 { code:0x1D636
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D636
  ,simpleLowerCaseMapping:0x1D636
  ,simpleTitleCaseMapping:0x1D636
 },
 { code:0x1D637
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D637
  ,simpleLowerCaseMapping:0x1D637
  ,simpleTitleCaseMapping:0x1D637
 },
 { code:0x1D638
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D638
  ,simpleLowerCaseMapping:0x1D638
  ,simpleTitleCaseMapping:0x1D638
 },
 { code:0x1D639
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D639
  ,simpleLowerCaseMapping:0x1D639
  ,simpleTitleCaseMapping:0x1D639
 },
 { code:0x1D63A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D63A
  ,simpleLowerCaseMapping:0x1D63A
  ,simpleTitleCaseMapping:0x1D63A
 },
 { code:0x1D63B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D63B
  ,simpleLowerCaseMapping:0x1D63B
  ,simpleTitleCaseMapping:0x1D63B
 },
 { code:0x1D63C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D63C
  ,simpleLowerCaseMapping:0x1D63C
  ,simpleTitleCaseMapping:0x1D63C
 },
 { code:0x1D63D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D63D
  ,simpleLowerCaseMapping:0x1D63D
  ,simpleTitleCaseMapping:0x1D63D
 },
 { code:0x1D63E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D63E
  ,simpleLowerCaseMapping:0x1D63E
  ,simpleTitleCaseMapping:0x1D63E
 },
 { code:0x1D63F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D63F
  ,simpleLowerCaseMapping:0x1D63F
  ,simpleTitleCaseMapping:0x1D63F
 },
 { code:0x1D640
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D640
  ,simpleLowerCaseMapping:0x1D640
  ,simpleTitleCaseMapping:0x1D640
 },
 { code:0x1D641
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D641
  ,simpleLowerCaseMapping:0x1D641
  ,simpleTitleCaseMapping:0x1D641
 },
 { code:0x1D642
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D642
  ,simpleLowerCaseMapping:0x1D642
  ,simpleTitleCaseMapping:0x1D642
 },
 { code:0x1D643
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D643
  ,simpleLowerCaseMapping:0x1D643
  ,simpleTitleCaseMapping:0x1D643
 },
 { code:0x1D644
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D644
  ,simpleLowerCaseMapping:0x1D644
  ,simpleTitleCaseMapping:0x1D644
 },
 { code:0x1D645
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D645
  ,simpleLowerCaseMapping:0x1D645
  ,simpleTitleCaseMapping:0x1D645
 },
 { code:0x1D646
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D646
  ,simpleLowerCaseMapping:0x1D646
  ,simpleTitleCaseMapping:0x1D646
 },
 { code:0x1D647
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D647
  ,simpleLowerCaseMapping:0x1D647
  ,simpleTitleCaseMapping:0x1D647
 },
 { code:0x1D648
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D648
  ,simpleLowerCaseMapping:0x1D648
  ,simpleTitleCaseMapping:0x1D648
 },
 { code:0x1D649
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D649
  ,simpleLowerCaseMapping:0x1D649
  ,simpleTitleCaseMapping:0x1D649
 },
 { code:0x1D64A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D64A
  ,simpleLowerCaseMapping:0x1D64A
  ,simpleTitleCaseMapping:0x1D64A
 },
 { code:0x1D64B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D64B
  ,simpleLowerCaseMapping:0x1D64B
  ,simpleTitleCaseMapping:0x1D64B
 },
 { code:0x1D64C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D64C
  ,simpleLowerCaseMapping:0x1D64C
  ,simpleTitleCaseMapping:0x1D64C
 },
 { code:0x1D64D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D64D
  ,simpleLowerCaseMapping:0x1D64D
  ,simpleTitleCaseMapping:0x1D64D
 },
 { code:0x1D64E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D64E
  ,simpleLowerCaseMapping:0x1D64E
  ,simpleTitleCaseMapping:0x1D64E
 },
 { code:0x1D64F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D64F
  ,simpleLowerCaseMapping:0x1D64F
  ,simpleTitleCaseMapping:0x1D64F
 },
 { code:0x1D650
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D650
  ,simpleLowerCaseMapping:0x1D650
  ,simpleTitleCaseMapping:0x1D650
 },
 { code:0x1D651
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D651
  ,simpleLowerCaseMapping:0x1D651
  ,simpleTitleCaseMapping:0x1D651
 },
 { code:0x1D652
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D652
  ,simpleLowerCaseMapping:0x1D652
  ,simpleTitleCaseMapping:0x1D652
 },
 { code:0x1D653
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D653
  ,simpleLowerCaseMapping:0x1D653
  ,simpleTitleCaseMapping:0x1D653
 },
 { code:0x1D654
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D654
  ,simpleLowerCaseMapping:0x1D654
  ,simpleTitleCaseMapping:0x1D654
 },
 { code:0x1D655
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D655
  ,simpleLowerCaseMapping:0x1D655
  ,simpleTitleCaseMapping:0x1D655
 },
 { code:0x1D656
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D656
  ,simpleLowerCaseMapping:0x1D656
  ,simpleTitleCaseMapping:0x1D656
 },
 { code:0x1D657
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D657
  ,simpleLowerCaseMapping:0x1D657
  ,simpleTitleCaseMapping:0x1D657
 },
 { code:0x1D658
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D658
  ,simpleLowerCaseMapping:0x1D658
  ,simpleTitleCaseMapping:0x1D658
 },
 { code:0x1D659
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D659
  ,simpleLowerCaseMapping:0x1D659
  ,simpleTitleCaseMapping:0x1D659
 },
 { code:0x1D65A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D65A
  ,simpleLowerCaseMapping:0x1D65A
  ,simpleTitleCaseMapping:0x1D65A
 },
 { code:0x1D65B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D65B
  ,simpleLowerCaseMapping:0x1D65B
  ,simpleTitleCaseMapping:0x1D65B
 },
 { code:0x1D65C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D65C
  ,simpleLowerCaseMapping:0x1D65C
  ,simpleTitleCaseMapping:0x1D65C
 },
 { code:0x1D65D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D65D
  ,simpleLowerCaseMapping:0x1D65D
  ,simpleTitleCaseMapping:0x1D65D
 },
 { code:0x1D65E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D65E
  ,simpleLowerCaseMapping:0x1D65E
  ,simpleTitleCaseMapping:0x1D65E
 },
 { code:0x1D65F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D65F
  ,simpleLowerCaseMapping:0x1D65F
  ,simpleTitleCaseMapping:0x1D65F
 },
 { code:0x1D660
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D660
  ,simpleLowerCaseMapping:0x1D660
  ,simpleTitleCaseMapping:0x1D660
 },
 { code:0x1D661
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D661
  ,simpleLowerCaseMapping:0x1D661
  ,simpleTitleCaseMapping:0x1D661
 },
 { code:0x1D662
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D662
  ,simpleLowerCaseMapping:0x1D662
  ,simpleTitleCaseMapping:0x1D662
 },
 { code:0x1D663
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D663
  ,simpleLowerCaseMapping:0x1D663
  ,simpleTitleCaseMapping:0x1D663
 },
 { code:0x1D664
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D664
  ,simpleLowerCaseMapping:0x1D664
  ,simpleTitleCaseMapping:0x1D664
 },
 { code:0x1D665
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D665
  ,simpleLowerCaseMapping:0x1D665
  ,simpleTitleCaseMapping:0x1D665
 },
 { code:0x1D666
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D666
  ,simpleLowerCaseMapping:0x1D666
  ,simpleTitleCaseMapping:0x1D666
 },
 { code:0x1D667
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D667
  ,simpleLowerCaseMapping:0x1D667
  ,simpleTitleCaseMapping:0x1D667
 },
 { code:0x1D668
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D668
  ,simpleLowerCaseMapping:0x1D668
  ,simpleTitleCaseMapping:0x1D668
 },
 { code:0x1D669
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D669
  ,simpleLowerCaseMapping:0x1D669
  ,simpleTitleCaseMapping:0x1D669
 },
 { code:0x1D66A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D66A
  ,simpleLowerCaseMapping:0x1D66A
  ,simpleTitleCaseMapping:0x1D66A
 },
 { code:0x1D66B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D66B
  ,simpleLowerCaseMapping:0x1D66B
  ,simpleTitleCaseMapping:0x1D66B
 },
 { code:0x1D66C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D66C
  ,simpleLowerCaseMapping:0x1D66C
  ,simpleTitleCaseMapping:0x1D66C
 },
 { code:0x1D66D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D66D
  ,simpleLowerCaseMapping:0x1D66D
  ,simpleTitleCaseMapping:0x1D66D
 },
 { code:0x1D66E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D66E
  ,simpleLowerCaseMapping:0x1D66E
  ,simpleTitleCaseMapping:0x1D66E
 },
 { code:0x1D66F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D66F
  ,simpleLowerCaseMapping:0x1D66F
  ,simpleTitleCaseMapping:0x1D66F
 },
 { code:0x1D670
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D670
  ,simpleLowerCaseMapping:0x1D670
  ,simpleTitleCaseMapping:0x1D670
 },
 { code:0x1D671
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D671
  ,simpleLowerCaseMapping:0x1D671
  ,simpleTitleCaseMapping:0x1D671
 },
 { code:0x1D672
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D672
  ,simpleLowerCaseMapping:0x1D672
  ,simpleTitleCaseMapping:0x1D672
 },
 { code:0x1D673
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D673
  ,simpleLowerCaseMapping:0x1D673
  ,simpleTitleCaseMapping:0x1D673
 },
 { code:0x1D674
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D674
  ,simpleLowerCaseMapping:0x1D674
  ,simpleTitleCaseMapping:0x1D674
 },
 { code:0x1D675
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D675
  ,simpleLowerCaseMapping:0x1D675
  ,simpleTitleCaseMapping:0x1D675
 },
 { code:0x1D676
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D676
  ,simpleLowerCaseMapping:0x1D676
  ,simpleTitleCaseMapping:0x1D676
 },
 { code:0x1D677
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D677
  ,simpleLowerCaseMapping:0x1D677
  ,simpleTitleCaseMapping:0x1D677
 },
 { code:0x1D678
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D678
  ,simpleLowerCaseMapping:0x1D678
  ,simpleTitleCaseMapping:0x1D678
 },
 { code:0x1D679
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D679
  ,simpleLowerCaseMapping:0x1D679
  ,simpleTitleCaseMapping:0x1D679
 },
 { code:0x1D67A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D67A
  ,simpleLowerCaseMapping:0x1D67A
  ,simpleTitleCaseMapping:0x1D67A
 },
 { code:0x1D67B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D67B
  ,simpleLowerCaseMapping:0x1D67B
  ,simpleTitleCaseMapping:0x1D67B
 },
 { code:0x1D67C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D67C
  ,simpleLowerCaseMapping:0x1D67C
  ,simpleTitleCaseMapping:0x1D67C
 },
 { code:0x1D67D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D67D
  ,simpleLowerCaseMapping:0x1D67D
  ,simpleTitleCaseMapping:0x1D67D
 },
 { code:0x1D67E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D67E
  ,simpleLowerCaseMapping:0x1D67E
  ,simpleTitleCaseMapping:0x1D67E
 },
 { code:0x1D67F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D67F
  ,simpleLowerCaseMapping:0x1D67F
  ,simpleTitleCaseMapping:0x1D67F
 },
 { code:0x1D680
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D680
  ,simpleLowerCaseMapping:0x1D680
  ,simpleTitleCaseMapping:0x1D680
 },
 { code:0x1D681
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D681
  ,simpleLowerCaseMapping:0x1D681
  ,simpleTitleCaseMapping:0x1D681
 },
 { code:0x1D682
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D682
  ,simpleLowerCaseMapping:0x1D682
  ,simpleTitleCaseMapping:0x1D682
 },
 { code:0x1D683
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D683
  ,simpleLowerCaseMapping:0x1D683
  ,simpleTitleCaseMapping:0x1D683
 },
 { code:0x1D684
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D684
  ,simpleLowerCaseMapping:0x1D684
  ,simpleTitleCaseMapping:0x1D684
 },
 { code:0x1D685
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D685
  ,simpleLowerCaseMapping:0x1D685
  ,simpleTitleCaseMapping:0x1D685
 },
 { code:0x1D686
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D686
  ,simpleLowerCaseMapping:0x1D686
  ,simpleTitleCaseMapping:0x1D686
 },
 { code:0x1D687
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D687
  ,simpleLowerCaseMapping:0x1D687
  ,simpleTitleCaseMapping:0x1D687
 },
 { code:0x1D688
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D688
  ,simpleLowerCaseMapping:0x1D688
  ,simpleTitleCaseMapping:0x1D688
 },
 { code:0x1D689
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D689
  ,simpleLowerCaseMapping:0x1D689
  ,simpleTitleCaseMapping:0x1D689
 },
 { code:0x1D68A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D68A
  ,simpleLowerCaseMapping:0x1D68A
  ,simpleTitleCaseMapping:0x1D68A
 },
 { code:0x1D68B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D68B
  ,simpleLowerCaseMapping:0x1D68B
  ,simpleTitleCaseMapping:0x1D68B
 },
 { code:0x1D68C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D68C
  ,simpleLowerCaseMapping:0x1D68C
  ,simpleTitleCaseMapping:0x1D68C
 },
 { code:0x1D68D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D68D
  ,simpleLowerCaseMapping:0x1D68D
  ,simpleTitleCaseMapping:0x1D68D
 },
 { code:0x1D68E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D68E
  ,simpleLowerCaseMapping:0x1D68E
  ,simpleTitleCaseMapping:0x1D68E
 },
 { code:0x1D68F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D68F
  ,simpleLowerCaseMapping:0x1D68F
  ,simpleTitleCaseMapping:0x1D68F
 },
 { code:0x1D690
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D690
  ,simpleLowerCaseMapping:0x1D690
  ,simpleTitleCaseMapping:0x1D690
 },
 { code:0x1D691
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D691
  ,simpleLowerCaseMapping:0x1D691
  ,simpleTitleCaseMapping:0x1D691
 },
 { code:0x1D692
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D692
  ,simpleLowerCaseMapping:0x1D692
  ,simpleTitleCaseMapping:0x1D692
 },
 { code:0x1D693
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D693
  ,simpleLowerCaseMapping:0x1D693
  ,simpleTitleCaseMapping:0x1D693
 },
 { code:0x1D694
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D694
  ,simpleLowerCaseMapping:0x1D694
  ,simpleTitleCaseMapping:0x1D694
 },
 { code:0x1D695
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D695
  ,simpleLowerCaseMapping:0x1D695
  ,simpleTitleCaseMapping:0x1D695
 },
 { code:0x1D696
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D696
  ,simpleLowerCaseMapping:0x1D696
  ,simpleTitleCaseMapping:0x1D696
 },
 { code:0x1D697
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D697
  ,simpleLowerCaseMapping:0x1D697
  ,simpleTitleCaseMapping:0x1D697
 },
 { code:0x1D698
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D698
  ,simpleLowerCaseMapping:0x1D698
  ,simpleTitleCaseMapping:0x1D698
 },
 { code:0x1D699
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D699
  ,simpleLowerCaseMapping:0x1D699
  ,simpleTitleCaseMapping:0x1D699
 },
 { code:0x1D69A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D69A
  ,simpleLowerCaseMapping:0x1D69A
  ,simpleTitleCaseMapping:0x1D69A
 },
 { code:0x1D69B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D69B
  ,simpleLowerCaseMapping:0x1D69B
  ,simpleTitleCaseMapping:0x1D69B
 },
 { code:0x1D69C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D69C
  ,simpleLowerCaseMapping:0x1D69C
  ,simpleTitleCaseMapping:0x1D69C
 },
 { code:0x1D69D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D69D
  ,simpleLowerCaseMapping:0x1D69D
  ,simpleTitleCaseMapping:0x1D69D
 },
 { code:0x1D69E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D69E
  ,simpleLowerCaseMapping:0x1D69E
  ,simpleTitleCaseMapping:0x1D69E
 },
 { code:0x1D69F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D69F
  ,simpleLowerCaseMapping:0x1D69F
  ,simpleTitleCaseMapping:0x1D69F
 },
 { code:0x1D6A0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6A0
  ,simpleLowerCaseMapping:0x1D6A0
  ,simpleTitleCaseMapping:0x1D6A0
 },
 { code:0x1D6A1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6A1
  ,simpleLowerCaseMapping:0x1D6A1
  ,simpleTitleCaseMapping:0x1D6A1
 },
 { code:0x1D6A2
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6A2
  ,simpleLowerCaseMapping:0x1D6A2
  ,simpleTitleCaseMapping:0x1D6A2
 },
 { code:0x1D6A3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6A3
  ,simpleLowerCaseMapping:0x1D6A3
  ,simpleTitleCaseMapping:0x1D6A3
 },
 { code:0x1D6A4
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6A4
  ,simpleLowerCaseMapping:0x1D6A4
  ,simpleTitleCaseMapping:0x1D6A4
 },
 { code:0x1D6A5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6A5
  ,simpleLowerCaseMapping:0x1D6A5
  ,simpleTitleCaseMapping:0x1D6A5
 },
 { code:0x1D6A8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6A8
  ,simpleLowerCaseMapping:0x1D6A8
  ,simpleTitleCaseMapping:0x1D6A8
 },
 { code:0x1D6A9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6A9
  ,simpleLowerCaseMapping:0x1D6A9
  ,simpleTitleCaseMapping:0x1D6A9
 },
 { code:0x1D6AA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6AA
  ,simpleLowerCaseMapping:0x1D6AA
  ,simpleTitleCaseMapping:0x1D6AA
 },
 { code:0x1D6AB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6AB
  ,simpleLowerCaseMapping:0x1D6AB
  ,simpleTitleCaseMapping:0x1D6AB
 },
 { code:0x1D6AC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6AC
  ,simpleLowerCaseMapping:0x1D6AC
  ,simpleTitleCaseMapping:0x1D6AC
 },
 { code:0x1D6AD
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6AD
  ,simpleLowerCaseMapping:0x1D6AD
  ,simpleTitleCaseMapping:0x1D6AD
 },
 { code:0x1D6AE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6AE
  ,simpleLowerCaseMapping:0x1D6AE
  ,simpleTitleCaseMapping:0x1D6AE
 },
 { code:0x1D6AF
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6AF
  ,simpleLowerCaseMapping:0x1D6AF
  ,simpleTitleCaseMapping:0x1D6AF
 },
 { code:0x1D6B0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6B0
  ,simpleLowerCaseMapping:0x1D6B0
  ,simpleTitleCaseMapping:0x1D6B0
 },
 { code:0x1D6B1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6B1
  ,simpleLowerCaseMapping:0x1D6B1
  ,simpleTitleCaseMapping:0x1D6B1
 },
 { code:0x1D6B2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6B2
  ,simpleLowerCaseMapping:0x1D6B2
  ,simpleTitleCaseMapping:0x1D6B2
 },
 { code:0x1D6B3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6B3
  ,simpleLowerCaseMapping:0x1D6B3
  ,simpleTitleCaseMapping:0x1D6B3
 },
 { code:0x1D6B4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6B4
  ,simpleLowerCaseMapping:0x1D6B4
  ,simpleTitleCaseMapping:0x1D6B4
 },
 { code:0x1D6B5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6B5
  ,simpleLowerCaseMapping:0x1D6B5
  ,simpleTitleCaseMapping:0x1D6B5
 },
 { code:0x1D6B6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6B6
  ,simpleLowerCaseMapping:0x1D6B6
  ,simpleTitleCaseMapping:0x1D6B6
 },
 { code:0x1D6B7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6B7
  ,simpleLowerCaseMapping:0x1D6B7
  ,simpleTitleCaseMapping:0x1D6B7
 },
 { code:0x1D6B8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6B8
  ,simpleLowerCaseMapping:0x1D6B8
  ,simpleTitleCaseMapping:0x1D6B8
 },
 { code:0x1D6B9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6B9
  ,simpleLowerCaseMapping:0x1D6B9
  ,simpleTitleCaseMapping:0x1D6B9
 },
 { code:0x1D6BA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6BA
  ,simpleLowerCaseMapping:0x1D6BA
  ,simpleTitleCaseMapping:0x1D6BA
 },
 { code:0x1D6BB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6BB
  ,simpleLowerCaseMapping:0x1D6BB
  ,simpleTitleCaseMapping:0x1D6BB
 },
 { code:0x1D6BC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6BC
  ,simpleLowerCaseMapping:0x1D6BC
  ,simpleTitleCaseMapping:0x1D6BC
 },
 { code:0x1D6BD
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6BD
  ,simpleLowerCaseMapping:0x1D6BD
  ,simpleTitleCaseMapping:0x1D6BD
 },
 { code:0x1D6BE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6BE
  ,simpleLowerCaseMapping:0x1D6BE
  ,simpleTitleCaseMapping:0x1D6BE
 },
 { code:0x1D6BF
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6BF
  ,simpleLowerCaseMapping:0x1D6BF
  ,simpleTitleCaseMapping:0x1D6BF
 },
 { code:0x1D6C0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6C0
  ,simpleLowerCaseMapping:0x1D6C0
  ,simpleTitleCaseMapping:0x1D6C0
 },
 { code:0x1D6C1
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x1D6C1
  ,simpleLowerCaseMapping:0x1D6C1
  ,simpleTitleCaseMapping:0x1D6C1
 },
 { code:0x1D6C2
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6C2
  ,simpleLowerCaseMapping:0x1D6C2
  ,simpleTitleCaseMapping:0x1D6C2
 },
 { code:0x1D6C3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6C3
  ,simpleLowerCaseMapping:0x1D6C3
  ,simpleTitleCaseMapping:0x1D6C3
 },
 { code:0x1D6C4
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6C4
  ,simpleLowerCaseMapping:0x1D6C4
  ,simpleTitleCaseMapping:0x1D6C4
 },
 { code:0x1D6C5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6C5
  ,simpleLowerCaseMapping:0x1D6C5
  ,simpleTitleCaseMapping:0x1D6C5
 },
 { code:0x1D6C6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6C6
  ,simpleLowerCaseMapping:0x1D6C6
  ,simpleTitleCaseMapping:0x1D6C6
 },
 { code:0x1D6C7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6C7
  ,simpleLowerCaseMapping:0x1D6C7
  ,simpleTitleCaseMapping:0x1D6C7
 },
 { code:0x1D6C8
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6C8
  ,simpleLowerCaseMapping:0x1D6C8
  ,simpleTitleCaseMapping:0x1D6C8
 },
 { code:0x1D6C9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6C9
  ,simpleLowerCaseMapping:0x1D6C9
  ,simpleTitleCaseMapping:0x1D6C9
 },
 { code:0x1D6CA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6CA
  ,simpleLowerCaseMapping:0x1D6CA
  ,simpleTitleCaseMapping:0x1D6CA
 },
 { code:0x1D6CB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6CB
  ,simpleLowerCaseMapping:0x1D6CB
  ,simpleTitleCaseMapping:0x1D6CB
 },
 { code:0x1D6CC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6CC
  ,simpleLowerCaseMapping:0x1D6CC
  ,simpleTitleCaseMapping:0x1D6CC
 },
 { code:0x1D6CD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6CD
  ,simpleLowerCaseMapping:0x1D6CD
  ,simpleTitleCaseMapping:0x1D6CD
 },
 { code:0x1D6CE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6CE
  ,simpleLowerCaseMapping:0x1D6CE
  ,simpleTitleCaseMapping:0x1D6CE
 },
 { code:0x1D6CF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6CF
  ,simpleLowerCaseMapping:0x1D6CF
  ,simpleTitleCaseMapping:0x1D6CF
 },
 { code:0x1D6D0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6D0
  ,simpleLowerCaseMapping:0x1D6D0
  ,simpleTitleCaseMapping:0x1D6D0
 },
 { code:0x1D6D1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6D1
  ,simpleLowerCaseMapping:0x1D6D1
  ,simpleTitleCaseMapping:0x1D6D1
 },
 { code:0x1D6D2
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6D2
  ,simpleLowerCaseMapping:0x1D6D2
  ,simpleTitleCaseMapping:0x1D6D2
 },
 { code:0x1D6D3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6D3
  ,simpleLowerCaseMapping:0x1D6D3
  ,simpleTitleCaseMapping:0x1D6D3
 },
 { code:0x1D6D4
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6D4
  ,simpleLowerCaseMapping:0x1D6D4
  ,simpleTitleCaseMapping:0x1D6D4
 },
 { code:0x1D6D5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6D5
  ,simpleLowerCaseMapping:0x1D6D5
  ,simpleTitleCaseMapping:0x1D6D5
 },
 { code:0x1D6D6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6D6
  ,simpleLowerCaseMapping:0x1D6D6
  ,simpleTitleCaseMapping:0x1D6D6
 },
 { code:0x1D6D7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6D7
  ,simpleLowerCaseMapping:0x1D6D7
  ,simpleTitleCaseMapping:0x1D6D7
 },
 { code:0x1D6D8
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6D8
  ,simpleLowerCaseMapping:0x1D6D8
  ,simpleTitleCaseMapping:0x1D6D8
 },
 { code:0x1D6D9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6D9
  ,simpleLowerCaseMapping:0x1D6D9
  ,simpleTitleCaseMapping:0x1D6D9
 },
 { code:0x1D6DA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6DA
  ,simpleLowerCaseMapping:0x1D6DA
  ,simpleTitleCaseMapping:0x1D6DA
 },
 { code:0x1D6DB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x1D6DB
  ,simpleLowerCaseMapping:0x1D6DB
  ,simpleTitleCaseMapping:0x1D6DB
 },
 { code:0x1D6DC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6DC
  ,simpleLowerCaseMapping:0x1D6DC
  ,simpleTitleCaseMapping:0x1D6DC
 },
 { code:0x1D6DD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6DD
  ,simpleLowerCaseMapping:0x1D6DD
  ,simpleTitleCaseMapping:0x1D6DD
 },
 { code:0x1D6DE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6DE
  ,simpleLowerCaseMapping:0x1D6DE
  ,simpleTitleCaseMapping:0x1D6DE
 },
 { code:0x1D6DF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6DF
  ,simpleLowerCaseMapping:0x1D6DF
  ,simpleTitleCaseMapping:0x1D6DF
 },
 { code:0x1D6E0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6E0
  ,simpleLowerCaseMapping:0x1D6E0
  ,simpleTitleCaseMapping:0x1D6E0
 },
 { code:0x1D6E1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6E1
  ,simpleLowerCaseMapping:0x1D6E1
  ,simpleTitleCaseMapping:0x1D6E1
 },
 { code:0x1D6E2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6E2
  ,simpleLowerCaseMapping:0x1D6E2
  ,simpleTitleCaseMapping:0x1D6E2
 },
 { code:0x1D6E3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6E3
  ,simpleLowerCaseMapping:0x1D6E3
  ,simpleTitleCaseMapping:0x1D6E3
 },
 { code:0x1D6E4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6E4
  ,simpleLowerCaseMapping:0x1D6E4
  ,simpleTitleCaseMapping:0x1D6E4
 },
 { code:0x1D6E5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6E5
  ,simpleLowerCaseMapping:0x1D6E5
  ,simpleTitleCaseMapping:0x1D6E5
 },
 { code:0x1D6E6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6E6
  ,simpleLowerCaseMapping:0x1D6E6
  ,simpleTitleCaseMapping:0x1D6E6
 },
 { code:0x1D6E7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6E7
  ,simpleLowerCaseMapping:0x1D6E7
  ,simpleTitleCaseMapping:0x1D6E7
 },
 { code:0x1D6E8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6E8
  ,simpleLowerCaseMapping:0x1D6E8
  ,simpleTitleCaseMapping:0x1D6E8
 },
 { code:0x1D6E9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6E9
  ,simpleLowerCaseMapping:0x1D6E9
  ,simpleTitleCaseMapping:0x1D6E9
 },
 { code:0x1D6EA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6EA
  ,simpleLowerCaseMapping:0x1D6EA
  ,simpleTitleCaseMapping:0x1D6EA
 },
 { code:0x1D6EB
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6EB
  ,simpleLowerCaseMapping:0x1D6EB
  ,simpleTitleCaseMapping:0x1D6EB
 },
 { code:0x1D6EC
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6EC
  ,simpleLowerCaseMapping:0x1D6EC
  ,simpleTitleCaseMapping:0x1D6EC
 },
 { code:0x1D6ED
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6ED
  ,simpleLowerCaseMapping:0x1D6ED
  ,simpleTitleCaseMapping:0x1D6ED
 },
 { code:0x1D6EE
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6EE
  ,simpleLowerCaseMapping:0x1D6EE
  ,simpleTitleCaseMapping:0x1D6EE
 },
 { code:0x1D6EF
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6EF
  ,simpleLowerCaseMapping:0x1D6EF
  ,simpleTitleCaseMapping:0x1D6EF
 },
 { code:0x1D6F0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6F0
  ,simpleLowerCaseMapping:0x1D6F0
  ,simpleTitleCaseMapping:0x1D6F0
 },
 { code:0x1D6F1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6F1
  ,simpleLowerCaseMapping:0x1D6F1
  ,simpleTitleCaseMapping:0x1D6F1
 },
 { code:0x1D6F2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6F2
  ,simpleLowerCaseMapping:0x1D6F2
  ,simpleTitleCaseMapping:0x1D6F2
 },
 { code:0x1D6F3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6F3
  ,simpleLowerCaseMapping:0x1D6F3
  ,simpleTitleCaseMapping:0x1D6F3
 },
 { code:0x1D6F4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6F4
  ,simpleLowerCaseMapping:0x1D6F4
  ,simpleTitleCaseMapping:0x1D6F4
 },
 { code:0x1D6F5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6F5
  ,simpleLowerCaseMapping:0x1D6F5
  ,simpleTitleCaseMapping:0x1D6F5
 },
 { code:0x1D6F6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6F6
  ,simpleLowerCaseMapping:0x1D6F6
  ,simpleTitleCaseMapping:0x1D6F6
 },
 { code:0x1D6F7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6F7
  ,simpleLowerCaseMapping:0x1D6F7
  ,simpleTitleCaseMapping:0x1D6F7
 },
 { code:0x1D6F8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6F8
  ,simpleLowerCaseMapping:0x1D6F8
  ,simpleTitleCaseMapping:0x1D6F8
 },
 { code:0x1D6F9
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6F9
  ,simpleLowerCaseMapping:0x1D6F9
  ,simpleTitleCaseMapping:0x1D6F9
 },
 { code:0x1D6FA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D6FA
  ,simpleLowerCaseMapping:0x1D6FA
  ,simpleTitleCaseMapping:0x1D6FA
 },
 { code:0x1D6FB
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x1D6FB
  ,simpleLowerCaseMapping:0x1D6FB
  ,simpleTitleCaseMapping:0x1D6FB
 },
 { code:0x1D6FC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6FC
  ,simpleLowerCaseMapping:0x1D6FC
  ,simpleTitleCaseMapping:0x1D6FC
 },
 { code:0x1D6FD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6FD
  ,simpleLowerCaseMapping:0x1D6FD
  ,simpleTitleCaseMapping:0x1D6FD
 },
 { code:0x1D6FE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6FE
  ,simpleLowerCaseMapping:0x1D6FE
  ,simpleTitleCaseMapping:0x1D6FE
 },
 { code:0x1D6FF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D6FF
  ,simpleLowerCaseMapping:0x1D6FF
  ,simpleTitleCaseMapping:0x1D6FF
 },
 { code:0x1D700
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D700
  ,simpleLowerCaseMapping:0x1D700
  ,simpleTitleCaseMapping:0x1D700
 },
 { code:0x1D701
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D701
  ,simpleLowerCaseMapping:0x1D701
  ,simpleTitleCaseMapping:0x1D701
 },
 { code:0x1D702
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D702
  ,simpleLowerCaseMapping:0x1D702
  ,simpleTitleCaseMapping:0x1D702
 },
 { code:0x1D703
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D703
  ,simpleLowerCaseMapping:0x1D703
  ,simpleTitleCaseMapping:0x1D703
 },
 { code:0x1D704
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D704
  ,simpleLowerCaseMapping:0x1D704
  ,simpleTitleCaseMapping:0x1D704
 },
 { code:0x1D705
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D705
  ,simpleLowerCaseMapping:0x1D705
  ,simpleTitleCaseMapping:0x1D705
 },
 { code:0x1D706
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D706
  ,simpleLowerCaseMapping:0x1D706
  ,simpleTitleCaseMapping:0x1D706
 },
 { code:0x1D707
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D707
  ,simpleLowerCaseMapping:0x1D707
  ,simpleTitleCaseMapping:0x1D707
 },
 { code:0x1D708
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D708
  ,simpleLowerCaseMapping:0x1D708
  ,simpleTitleCaseMapping:0x1D708
 },
 { code:0x1D709
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D709
  ,simpleLowerCaseMapping:0x1D709
  ,simpleTitleCaseMapping:0x1D709
 },
 { code:0x1D70A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D70A
  ,simpleLowerCaseMapping:0x1D70A
  ,simpleTitleCaseMapping:0x1D70A
 },
 { code:0x1D70B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D70B
  ,simpleLowerCaseMapping:0x1D70B
  ,simpleTitleCaseMapping:0x1D70B
 },
 { code:0x1D70C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D70C
  ,simpleLowerCaseMapping:0x1D70C
  ,simpleTitleCaseMapping:0x1D70C
 },
 { code:0x1D70D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D70D
  ,simpleLowerCaseMapping:0x1D70D
  ,simpleTitleCaseMapping:0x1D70D
 },
 { code:0x1D70E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D70E
  ,simpleLowerCaseMapping:0x1D70E
  ,simpleTitleCaseMapping:0x1D70E
 },
 { code:0x1D70F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D70F
  ,simpleLowerCaseMapping:0x1D70F
  ,simpleTitleCaseMapping:0x1D70F
 },
 { code:0x1D710
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D710
  ,simpleLowerCaseMapping:0x1D710
  ,simpleTitleCaseMapping:0x1D710
 },
 { code:0x1D711
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D711
  ,simpleLowerCaseMapping:0x1D711
  ,simpleTitleCaseMapping:0x1D711
 },
 { code:0x1D712
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D712
  ,simpleLowerCaseMapping:0x1D712
  ,simpleTitleCaseMapping:0x1D712
 },
 { code:0x1D713
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D713
  ,simpleLowerCaseMapping:0x1D713
  ,simpleTitleCaseMapping:0x1D713
 },
 { code:0x1D714
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D714
  ,simpleLowerCaseMapping:0x1D714
  ,simpleTitleCaseMapping:0x1D714
 },
 { code:0x1D715
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x1D715
  ,simpleLowerCaseMapping:0x1D715
  ,simpleTitleCaseMapping:0x1D715
 },
 { code:0x1D716
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D716
  ,simpleLowerCaseMapping:0x1D716
  ,simpleTitleCaseMapping:0x1D716
 },
 { code:0x1D717
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D717
  ,simpleLowerCaseMapping:0x1D717
  ,simpleTitleCaseMapping:0x1D717
 },
 { code:0x1D718
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D718
  ,simpleLowerCaseMapping:0x1D718
  ,simpleTitleCaseMapping:0x1D718
 },
 { code:0x1D719
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D719
  ,simpleLowerCaseMapping:0x1D719
  ,simpleTitleCaseMapping:0x1D719
 },
 { code:0x1D71A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D71A
  ,simpleLowerCaseMapping:0x1D71A
  ,simpleTitleCaseMapping:0x1D71A
 },
 { code:0x1D71B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D71B
  ,simpleLowerCaseMapping:0x1D71B
  ,simpleTitleCaseMapping:0x1D71B
 },
 { code:0x1D71C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D71C
  ,simpleLowerCaseMapping:0x1D71C
  ,simpleTitleCaseMapping:0x1D71C
 },
 { code:0x1D71D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D71D
  ,simpleLowerCaseMapping:0x1D71D
  ,simpleTitleCaseMapping:0x1D71D
 },
 { code:0x1D71E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D71E
  ,simpleLowerCaseMapping:0x1D71E
  ,simpleTitleCaseMapping:0x1D71E
 },
 { code:0x1D71F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D71F
  ,simpleLowerCaseMapping:0x1D71F
  ,simpleTitleCaseMapping:0x1D71F
 },
 { code:0x1D720
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D720
  ,simpleLowerCaseMapping:0x1D720
  ,simpleTitleCaseMapping:0x1D720
 },
 { code:0x1D721
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D721
  ,simpleLowerCaseMapping:0x1D721
  ,simpleTitleCaseMapping:0x1D721
 },
 { code:0x1D722
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D722
  ,simpleLowerCaseMapping:0x1D722
  ,simpleTitleCaseMapping:0x1D722
 },
 { code:0x1D723
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D723
  ,simpleLowerCaseMapping:0x1D723
  ,simpleTitleCaseMapping:0x1D723
 },
 { code:0x1D724
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D724
  ,simpleLowerCaseMapping:0x1D724
  ,simpleTitleCaseMapping:0x1D724
 },
 { code:0x1D725
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D725
  ,simpleLowerCaseMapping:0x1D725
  ,simpleTitleCaseMapping:0x1D725
 },
 { code:0x1D726
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D726
  ,simpleLowerCaseMapping:0x1D726
  ,simpleTitleCaseMapping:0x1D726
 },
 { code:0x1D727
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D727
  ,simpleLowerCaseMapping:0x1D727
  ,simpleTitleCaseMapping:0x1D727
 },
 { code:0x1D728
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D728
  ,simpleLowerCaseMapping:0x1D728
  ,simpleTitleCaseMapping:0x1D728
 },
 { code:0x1D729
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D729
  ,simpleLowerCaseMapping:0x1D729
  ,simpleTitleCaseMapping:0x1D729
 },
 { code:0x1D72A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D72A
  ,simpleLowerCaseMapping:0x1D72A
  ,simpleTitleCaseMapping:0x1D72A
 },
 { code:0x1D72B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D72B
  ,simpleLowerCaseMapping:0x1D72B
  ,simpleTitleCaseMapping:0x1D72B
 },
 { code:0x1D72C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D72C
  ,simpleLowerCaseMapping:0x1D72C
  ,simpleTitleCaseMapping:0x1D72C
 },
 { code:0x1D72D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D72D
  ,simpleLowerCaseMapping:0x1D72D
  ,simpleTitleCaseMapping:0x1D72D
 },
 { code:0x1D72E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D72E
  ,simpleLowerCaseMapping:0x1D72E
  ,simpleTitleCaseMapping:0x1D72E
 },
 { code:0x1D72F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D72F
  ,simpleLowerCaseMapping:0x1D72F
  ,simpleTitleCaseMapping:0x1D72F
 },
 { code:0x1D730
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D730
  ,simpleLowerCaseMapping:0x1D730
  ,simpleTitleCaseMapping:0x1D730
 },
 { code:0x1D731
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D731
  ,simpleLowerCaseMapping:0x1D731
  ,simpleTitleCaseMapping:0x1D731
 },
 { code:0x1D732
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D732
  ,simpleLowerCaseMapping:0x1D732
  ,simpleTitleCaseMapping:0x1D732
 },
 { code:0x1D733
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D733
  ,simpleLowerCaseMapping:0x1D733
  ,simpleTitleCaseMapping:0x1D733
 },
 { code:0x1D734
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D734
  ,simpleLowerCaseMapping:0x1D734
  ,simpleTitleCaseMapping:0x1D734
 },
 { code:0x1D735
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x1D735
  ,simpleLowerCaseMapping:0x1D735
  ,simpleTitleCaseMapping:0x1D735
 },
 { code:0x1D736
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D736
  ,simpleLowerCaseMapping:0x1D736
  ,simpleTitleCaseMapping:0x1D736
 },
 { code:0x1D737
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D737
  ,simpleLowerCaseMapping:0x1D737
  ,simpleTitleCaseMapping:0x1D737
 },
 { code:0x1D738
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D738
  ,simpleLowerCaseMapping:0x1D738
  ,simpleTitleCaseMapping:0x1D738
 },
 { code:0x1D739
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D739
  ,simpleLowerCaseMapping:0x1D739
  ,simpleTitleCaseMapping:0x1D739
 },
 { code:0x1D73A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D73A
  ,simpleLowerCaseMapping:0x1D73A
  ,simpleTitleCaseMapping:0x1D73A
 },
 { code:0x1D73B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D73B
  ,simpleLowerCaseMapping:0x1D73B
  ,simpleTitleCaseMapping:0x1D73B
 },
 { code:0x1D73C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D73C
  ,simpleLowerCaseMapping:0x1D73C
  ,simpleTitleCaseMapping:0x1D73C
 },
 { code:0x1D73D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D73D
  ,simpleLowerCaseMapping:0x1D73D
  ,simpleTitleCaseMapping:0x1D73D
 },
 { code:0x1D73E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D73E
  ,simpleLowerCaseMapping:0x1D73E
  ,simpleTitleCaseMapping:0x1D73E
 },
 { code:0x1D73F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D73F
  ,simpleLowerCaseMapping:0x1D73F
  ,simpleTitleCaseMapping:0x1D73F
 },
 { code:0x1D740
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D740
  ,simpleLowerCaseMapping:0x1D740
  ,simpleTitleCaseMapping:0x1D740
 },
 { code:0x1D741
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D741
  ,simpleLowerCaseMapping:0x1D741
  ,simpleTitleCaseMapping:0x1D741
 },
 { code:0x1D742
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D742
  ,simpleLowerCaseMapping:0x1D742
  ,simpleTitleCaseMapping:0x1D742
 },
 { code:0x1D743
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D743
  ,simpleLowerCaseMapping:0x1D743
  ,simpleTitleCaseMapping:0x1D743
 },
 { code:0x1D744
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D744
  ,simpleLowerCaseMapping:0x1D744
  ,simpleTitleCaseMapping:0x1D744
 },
 { code:0x1D745
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D745
  ,simpleLowerCaseMapping:0x1D745
  ,simpleTitleCaseMapping:0x1D745
 },
 { code:0x1D746
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D746
  ,simpleLowerCaseMapping:0x1D746
  ,simpleTitleCaseMapping:0x1D746
 },
 { code:0x1D747
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D747
  ,simpleLowerCaseMapping:0x1D747
  ,simpleTitleCaseMapping:0x1D747
 },
 { code:0x1D748
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D748
  ,simpleLowerCaseMapping:0x1D748
  ,simpleTitleCaseMapping:0x1D748
 },
 { code:0x1D749
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D749
  ,simpleLowerCaseMapping:0x1D749
  ,simpleTitleCaseMapping:0x1D749
 },
 { code:0x1D74A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D74A
  ,simpleLowerCaseMapping:0x1D74A
  ,simpleTitleCaseMapping:0x1D74A
 },
 { code:0x1D74B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D74B
  ,simpleLowerCaseMapping:0x1D74B
  ,simpleTitleCaseMapping:0x1D74B
 },
 { code:0x1D74C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D74C
  ,simpleLowerCaseMapping:0x1D74C
  ,simpleTitleCaseMapping:0x1D74C
 },
 { code:0x1D74D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D74D
  ,simpleLowerCaseMapping:0x1D74D
  ,simpleTitleCaseMapping:0x1D74D
 },
 { code:0x1D74E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D74E
  ,simpleLowerCaseMapping:0x1D74E
  ,simpleTitleCaseMapping:0x1D74E
 },
 { code:0x1D74F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x1D74F
  ,simpleLowerCaseMapping:0x1D74F
  ,simpleTitleCaseMapping:0x1D74F
 },
 { code:0x1D750
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D750
  ,simpleLowerCaseMapping:0x1D750
  ,simpleTitleCaseMapping:0x1D750
 },
 { code:0x1D751
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D751
  ,simpleLowerCaseMapping:0x1D751
  ,simpleTitleCaseMapping:0x1D751
 },
 { code:0x1D752
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D752
  ,simpleLowerCaseMapping:0x1D752
  ,simpleTitleCaseMapping:0x1D752
 },
 { code:0x1D753
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D753
  ,simpleLowerCaseMapping:0x1D753
  ,simpleTitleCaseMapping:0x1D753
 },
 { code:0x1D754
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D754
  ,simpleLowerCaseMapping:0x1D754
  ,simpleTitleCaseMapping:0x1D754
 },
 { code:0x1D755
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D755
  ,simpleLowerCaseMapping:0x1D755
  ,simpleTitleCaseMapping:0x1D755
 },
 { code:0x1D756
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D756
  ,simpleLowerCaseMapping:0x1D756
  ,simpleTitleCaseMapping:0x1D756
 },
 { code:0x1D757
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D757
  ,simpleLowerCaseMapping:0x1D757
  ,simpleTitleCaseMapping:0x1D757
 },
 { code:0x1D758
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D758
  ,simpleLowerCaseMapping:0x1D758
  ,simpleTitleCaseMapping:0x1D758
 },
 { code:0x1D759
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D759
  ,simpleLowerCaseMapping:0x1D759
  ,simpleTitleCaseMapping:0x1D759
 },
 { code:0x1D75A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D75A
  ,simpleLowerCaseMapping:0x1D75A
  ,simpleTitleCaseMapping:0x1D75A
 },
 { code:0x1D75B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D75B
  ,simpleLowerCaseMapping:0x1D75B
  ,simpleTitleCaseMapping:0x1D75B
 },
 { code:0x1D75C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D75C
  ,simpleLowerCaseMapping:0x1D75C
  ,simpleTitleCaseMapping:0x1D75C
 },
 { code:0x1D75D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D75D
  ,simpleLowerCaseMapping:0x1D75D
  ,simpleTitleCaseMapping:0x1D75D
 },
 { code:0x1D75E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D75E
  ,simpleLowerCaseMapping:0x1D75E
  ,simpleTitleCaseMapping:0x1D75E
 },
 { code:0x1D75F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D75F
  ,simpleLowerCaseMapping:0x1D75F
  ,simpleTitleCaseMapping:0x1D75F
 },
 { code:0x1D760
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D760
  ,simpleLowerCaseMapping:0x1D760
  ,simpleTitleCaseMapping:0x1D760
 },
 { code:0x1D761
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D761
  ,simpleLowerCaseMapping:0x1D761
  ,simpleTitleCaseMapping:0x1D761
 },
 { code:0x1D762
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D762
  ,simpleLowerCaseMapping:0x1D762
  ,simpleTitleCaseMapping:0x1D762
 },
 { code:0x1D763
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D763
  ,simpleLowerCaseMapping:0x1D763
  ,simpleTitleCaseMapping:0x1D763
 },
 { code:0x1D764
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D764
  ,simpleLowerCaseMapping:0x1D764
  ,simpleTitleCaseMapping:0x1D764
 },
 { code:0x1D765
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D765
  ,simpleLowerCaseMapping:0x1D765
  ,simpleTitleCaseMapping:0x1D765
 },
 { code:0x1D766
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D766
  ,simpleLowerCaseMapping:0x1D766
  ,simpleTitleCaseMapping:0x1D766
 },
 { code:0x1D767
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D767
  ,simpleLowerCaseMapping:0x1D767
  ,simpleTitleCaseMapping:0x1D767
 },
 { code:0x1D768
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D768
  ,simpleLowerCaseMapping:0x1D768
  ,simpleTitleCaseMapping:0x1D768
 },
 { code:0x1D769
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D769
  ,simpleLowerCaseMapping:0x1D769
  ,simpleTitleCaseMapping:0x1D769
 },
 { code:0x1D76A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D76A
  ,simpleLowerCaseMapping:0x1D76A
  ,simpleTitleCaseMapping:0x1D76A
 },
 { code:0x1D76B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D76B
  ,simpleLowerCaseMapping:0x1D76B
  ,simpleTitleCaseMapping:0x1D76B
 },
 { code:0x1D76C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D76C
  ,simpleLowerCaseMapping:0x1D76C
  ,simpleTitleCaseMapping:0x1D76C
 },
 { code:0x1D76D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D76D
  ,simpleLowerCaseMapping:0x1D76D
  ,simpleTitleCaseMapping:0x1D76D
 },
 { code:0x1D76E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D76E
  ,simpleLowerCaseMapping:0x1D76E
  ,simpleTitleCaseMapping:0x1D76E
 },
 { code:0x1D76F
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x1D76F
  ,simpleLowerCaseMapping:0x1D76F
  ,simpleTitleCaseMapping:0x1D76F
 },
 { code:0x1D770
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D770
  ,simpleLowerCaseMapping:0x1D770
  ,simpleTitleCaseMapping:0x1D770
 },
 { code:0x1D771
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D771
  ,simpleLowerCaseMapping:0x1D771
  ,simpleTitleCaseMapping:0x1D771
 },
 { code:0x1D772
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D772
  ,simpleLowerCaseMapping:0x1D772
  ,simpleTitleCaseMapping:0x1D772
 },
 { code:0x1D773
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D773
  ,simpleLowerCaseMapping:0x1D773
  ,simpleTitleCaseMapping:0x1D773
 },
 { code:0x1D774
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D774
  ,simpleLowerCaseMapping:0x1D774
  ,simpleTitleCaseMapping:0x1D774
 },
 { code:0x1D775
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D775
  ,simpleLowerCaseMapping:0x1D775
  ,simpleTitleCaseMapping:0x1D775
 },
 { code:0x1D776
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D776
  ,simpleLowerCaseMapping:0x1D776
  ,simpleTitleCaseMapping:0x1D776
 },
 { code:0x1D777
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D777
  ,simpleLowerCaseMapping:0x1D777
  ,simpleTitleCaseMapping:0x1D777
 },
 { code:0x1D778
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D778
  ,simpleLowerCaseMapping:0x1D778
  ,simpleTitleCaseMapping:0x1D778
 },
 { code:0x1D779
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D779
  ,simpleLowerCaseMapping:0x1D779
  ,simpleTitleCaseMapping:0x1D779
 },
 { code:0x1D77A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D77A
  ,simpleLowerCaseMapping:0x1D77A
  ,simpleTitleCaseMapping:0x1D77A
 },
 { code:0x1D77B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D77B
  ,simpleLowerCaseMapping:0x1D77B
  ,simpleTitleCaseMapping:0x1D77B
 },
 { code:0x1D77C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D77C
  ,simpleLowerCaseMapping:0x1D77C
  ,simpleTitleCaseMapping:0x1D77C
 },
 { code:0x1D77D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D77D
  ,simpleLowerCaseMapping:0x1D77D
  ,simpleTitleCaseMapping:0x1D77D
 },
 { code:0x1D77E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D77E
  ,simpleLowerCaseMapping:0x1D77E
  ,simpleTitleCaseMapping:0x1D77E
 },
 { code:0x1D77F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D77F
  ,simpleLowerCaseMapping:0x1D77F
  ,simpleTitleCaseMapping:0x1D77F
 },
 { code:0x1D780
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D780
  ,simpleLowerCaseMapping:0x1D780
  ,simpleTitleCaseMapping:0x1D780
 },
 { code:0x1D781
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D781
  ,simpleLowerCaseMapping:0x1D781
  ,simpleTitleCaseMapping:0x1D781
 },
 { code:0x1D782
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D782
  ,simpleLowerCaseMapping:0x1D782
  ,simpleTitleCaseMapping:0x1D782
 },
 { code:0x1D783
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D783
  ,simpleLowerCaseMapping:0x1D783
  ,simpleTitleCaseMapping:0x1D783
 },
 { code:0x1D784
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D784
  ,simpleLowerCaseMapping:0x1D784
  ,simpleTitleCaseMapping:0x1D784
 },
 { code:0x1D785
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D785
  ,simpleLowerCaseMapping:0x1D785
  ,simpleTitleCaseMapping:0x1D785
 },
 { code:0x1D786
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D786
  ,simpleLowerCaseMapping:0x1D786
  ,simpleTitleCaseMapping:0x1D786
 },
 { code:0x1D787
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D787
  ,simpleLowerCaseMapping:0x1D787
  ,simpleTitleCaseMapping:0x1D787
 },
 { code:0x1D788
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D788
  ,simpleLowerCaseMapping:0x1D788
  ,simpleTitleCaseMapping:0x1D788
 },
 { code:0x1D789
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x1D789
  ,simpleLowerCaseMapping:0x1D789
  ,simpleTitleCaseMapping:0x1D789
 },
 { code:0x1D78A
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D78A
  ,simpleLowerCaseMapping:0x1D78A
  ,simpleTitleCaseMapping:0x1D78A
 },
 { code:0x1D78B
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D78B
  ,simpleLowerCaseMapping:0x1D78B
  ,simpleTitleCaseMapping:0x1D78B
 },
 { code:0x1D78C
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D78C
  ,simpleLowerCaseMapping:0x1D78C
  ,simpleTitleCaseMapping:0x1D78C
 },
 { code:0x1D78D
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D78D
  ,simpleLowerCaseMapping:0x1D78D
  ,simpleTitleCaseMapping:0x1D78D
 },
 { code:0x1D78E
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D78E
  ,simpleLowerCaseMapping:0x1D78E
  ,simpleTitleCaseMapping:0x1D78E
 },
 { code:0x1D78F
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D78F
  ,simpleLowerCaseMapping:0x1D78F
  ,simpleTitleCaseMapping:0x1D78F
 },
 { code:0x1D790
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D790
  ,simpleLowerCaseMapping:0x1D790
  ,simpleTitleCaseMapping:0x1D790
 },
 { code:0x1D791
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D791
  ,simpleLowerCaseMapping:0x1D791
  ,simpleTitleCaseMapping:0x1D791
 },
 { code:0x1D792
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D792
  ,simpleLowerCaseMapping:0x1D792
  ,simpleTitleCaseMapping:0x1D792
 },
 { code:0x1D793
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D793
  ,simpleLowerCaseMapping:0x1D793
  ,simpleTitleCaseMapping:0x1D793
 },
 { code:0x1D794
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D794
  ,simpleLowerCaseMapping:0x1D794
  ,simpleTitleCaseMapping:0x1D794
 },
 { code:0x1D795
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D795
  ,simpleLowerCaseMapping:0x1D795
  ,simpleTitleCaseMapping:0x1D795
 },
 { code:0x1D796
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D796
  ,simpleLowerCaseMapping:0x1D796
  ,simpleTitleCaseMapping:0x1D796
 },
 { code:0x1D797
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D797
  ,simpleLowerCaseMapping:0x1D797
  ,simpleTitleCaseMapping:0x1D797
 },
 { code:0x1D798
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D798
  ,simpleLowerCaseMapping:0x1D798
  ,simpleTitleCaseMapping:0x1D798
 },
 { code:0x1D799
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D799
  ,simpleLowerCaseMapping:0x1D799
  ,simpleTitleCaseMapping:0x1D799
 },
 { code:0x1D79A
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D79A
  ,simpleLowerCaseMapping:0x1D79A
  ,simpleTitleCaseMapping:0x1D79A
 },
 { code:0x1D79B
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D79B
  ,simpleLowerCaseMapping:0x1D79B
  ,simpleTitleCaseMapping:0x1D79B
 },
 { code:0x1D79C
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D79C
  ,simpleLowerCaseMapping:0x1D79C
  ,simpleTitleCaseMapping:0x1D79C
 },
 { code:0x1D79D
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D79D
  ,simpleLowerCaseMapping:0x1D79D
  ,simpleTitleCaseMapping:0x1D79D
 },
 { code:0x1D79E
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D79E
  ,simpleLowerCaseMapping:0x1D79E
  ,simpleTitleCaseMapping:0x1D79E
 },
 { code:0x1D79F
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D79F
  ,simpleLowerCaseMapping:0x1D79F
  ,simpleTitleCaseMapping:0x1D79F
 },
 { code:0x1D7A0
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D7A0
  ,simpleLowerCaseMapping:0x1D7A0
  ,simpleTitleCaseMapping:0x1D7A0
 },
 { code:0x1D7A1
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D7A1
  ,simpleLowerCaseMapping:0x1D7A1
  ,simpleTitleCaseMapping:0x1D7A1
 },
 { code:0x1D7A2
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D7A2
  ,simpleLowerCaseMapping:0x1D7A2
  ,simpleTitleCaseMapping:0x1D7A2
 },
 { code:0x1D7A3
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D7A3
  ,simpleLowerCaseMapping:0x1D7A3
  ,simpleTitleCaseMapping:0x1D7A3
 },
 { code:0x1D7A4
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D7A4
  ,simpleLowerCaseMapping:0x1D7A4
  ,simpleTitleCaseMapping:0x1D7A4
 },
 { code:0x1D7A5
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D7A5
  ,simpleLowerCaseMapping:0x1D7A5
  ,simpleTitleCaseMapping:0x1D7A5
 },
 { code:0x1D7A6
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D7A6
  ,simpleLowerCaseMapping:0x1D7A6
  ,simpleTitleCaseMapping:0x1D7A6
 },
 { code:0x1D7A7
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D7A7
  ,simpleLowerCaseMapping:0x1D7A7
  ,simpleTitleCaseMapping:0x1D7A7
 },
 { code:0x1D7A8
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D7A8
  ,simpleLowerCaseMapping:0x1D7A8
  ,simpleTitleCaseMapping:0x1D7A8
 },
 { code:0x1D7A9
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x1D7A9
  ,simpleLowerCaseMapping:0x1D7A9
  ,simpleTitleCaseMapping:0x1D7A9
 },
 { code:0x1D7AA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7AA
  ,simpleLowerCaseMapping:0x1D7AA
  ,simpleTitleCaseMapping:0x1D7AA
 },
 { code:0x1D7AB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7AB
  ,simpleLowerCaseMapping:0x1D7AB
  ,simpleTitleCaseMapping:0x1D7AB
 },
 { code:0x1D7AC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7AC
  ,simpleLowerCaseMapping:0x1D7AC
  ,simpleTitleCaseMapping:0x1D7AC
 },
 { code:0x1D7AD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7AD
  ,simpleLowerCaseMapping:0x1D7AD
  ,simpleTitleCaseMapping:0x1D7AD
 },
 { code:0x1D7AE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7AE
  ,simpleLowerCaseMapping:0x1D7AE
  ,simpleTitleCaseMapping:0x1D7AE
 },
 { code:0x1D7AF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7AF
  ,simpleLowerCaseMapping:0x1D7AF
  ,simpleTitleCaseMapping:0x1D7AF
 },
 { code:0x1D7B0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7B0
  ,simpleLowerCaseMapping:0x1D7B0
  ,simpleTitleCaseMapping:0x1D7B0
 },
 { code:0x1D7B1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7B1
  ,simpleLowerCaseMapping:0x1D7B1
  ,simpleTitleCaseMapping:0x1D7B1
 },
 { code:0x1D7B2
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7B2
  ,simpleLowerCaseMapping:0x1D7B2
  ,simpleTitleCaseMapping:0x1D7B2
 },
 { code:0x1D7B3
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7B3
  ,simpleLowerCaseMapping:0x1D7B3
  ,simpleTitleCaseMapping:0x1D7B3
 },
 { code:0x1D7B4
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7B4
  ,simpleLowerCaseMapping:0x1D7B4
  ,simpleTitleCaseMapping:0x1D7B4
 },
 { code:0x1D7B5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7B5
  ,simpleLowerCaseMapping:0x1D7B5
  ,simpleTitleCaseMapping:0x1D7B5
 },
 { code:0x1D7B6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7B6
  ,simpleLowerCaseMapping:0x1D7B6
  ,simpleTitleCaseMapping:0x1D7B6
 },
 { code:0x1D7B7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7B7
  ,simpleLowerCaseMapping:0x1D7B7
  ,simpleTitleCaseMapping:0x1D7B7
 },
 { code:0x1D7B8
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7B8
  ,simpleLowerCaseMapping:0x1D7B8
  ,simpleTitleCaseMapping:0x1D7B8
 },
 { code:0x1D7B9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7B9
  ,simpleLowerCaseMapping:0x1D7B9
  ,simpleTitleCaseMapping:0x1D7B9
 },
 { code:0x1D7BA
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7BA
  ,simpleLowerCaseMapping:0x1D7BA
  ,simpleTitleCaseMapping:0x1D7BA
 },
 { code:0x1D7BB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7BB
  ,simpleLowerCaseMapping:0x1D7BB
  ,simpleTitleCaseMapping:0x1D7BB
 },
 { code:0x1D7BC
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7BC
  ,simpleLowerCaseMapping:0x1D7BC
  ,simpleTitleCaseMapping:0x1D7BC
 },
 { code:0x1D7BD
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7BD
  ,simpleLowerCaseMapping:0x1D7BD
  ,simpleTitleCaseMapping:0x1D7BD
 },
 { code:0x1D7BE
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7BE
  ,simpleLowerCaseMapping:0x1D7BE
  ,simpleTitleCaseMapping:0x1D7BE
 },
 { code:0x1D7BF
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7BF
  ,simpleLowerCaseMapping:0x1D7BF
  ,simpleTitleCaseMapping:0x1D7BF
 },
 { code:0x1D7C0
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7C0
  ,simpleLowerCaseMapping:0x1D7C0
  ,simpleTitleCaseMapping:0x1D7C0
 },
 { code:0x1D7C1
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7C1
  ,simpleLowerCaseMapping:0x1D7C1
  ,simpleTitleCaseMapping:0x1D7C1
 },
 { code:0x1D7C2
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7C2
  ,simpleLowerCaseMapping:0x1D7C2
  ,simpleTitleCaseMapping:0x1D7C2
 },
 { code:0x1D7C3
  ,generalCategory:UnicodeData.GeneralCategory.Sm
  ,simpleUpperCaseMapping:0x1D7C3
  ,simpleLowerCaseMapping:0x1D7C3
  ,simpleTitleCaseMapping:0x1D7C3
 },
 { code:0x1D7C4
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7C4
  ,simpleLowerCaseMapping:0x1D7C4
  ,simpleTitleCaseMapping:0x1D7C4
 },
 { code:0x1D7C5
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7C5
  ,simpleLowerCaseMapping:0x1D7C5
  ,simpleTitleCaseMapping:0x1D7C5
 },
 { code:0x1D7C6
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7C6
  ,simpleLowerCaseMapping:0x1D7C6
  ,simpleTitleCaseMapping:0x1D7C6
 },
 { code:0x1D7C7
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7C7
  ,simpleLowerCaseMapping:0x1D7C7
  ,simpleTitleCaseMapping:0x1D7C7
 },
 { code:0x1D7C8
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7C8
  ,simpleLowerCaseMapping:0x1D7C8
  ,simpleTitleCaseMapping:0x1D7C8
 },
 { code:0x1D7C9
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7C9
  ,simpleLowerCaseMapping:0x1D7C9
  ,simpleTitleCaseMapping:0x1D7C9
 },
 { code:0x1D7CA
  ,generalCategory:UnicodeData.GeneralCategory.Lu
  ,simpleUpperCaseMapping:0x1D7CA
  ,simpleLowerCaseMapping:0x1D7CA
  ,simpleTitleCaseMapping:0x1D7CA
 },
 { code:0x1D7CB
  ,generalCategory:UnicodeData.GeneralCategory.Ll
  ,simpleUpperCaseMapping:0x1D7CB
  ,simpleLowerCaseMapping:0x1D7CB
  ,simpleTitleCaseMapping:0x1D7CB
 },
 { code:0x1D7CE
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7CE
  ,simpleLowerCaseMapping:0x1D7CE
  ,simpleTitleCaseMapping:0x1D7CE
 },
 { code:0x1D7CF
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7CF
  ,simpleLowerCaseMapping:0x1D7CF
  ,simpleTitleCaseMapping:0x1D7CF
 },
 { code:0x1D7D0
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7D0
  ,simpleLowerCaseMapping:0x1D7D0
  ,simpleTitleCaseMapping:0x1D7D0
 },
 { code:0x1D7D1
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7D1
  ,simpleLowerCaseMapping:0x1D7D1
  ,simpleTitleCaseMapping:0x1D7D1
 },
 { code:0x1D7D2
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7D2
  ,simpleLowerCaseMapping:0x1D7D2
  ,simpleTitleCaseMapping:0x1D7D2
 },
 { code:0x1D7D3
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7D3
  ,simpleLowerCaseMapping:0x1D7D3
  ,simpleTitleCaseMapping:0x1D7D3
 },
 { code:0x1D7D4
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7D4
  ,simpleLowerCaseMapping:0x1D7D4
  ,simpleTitleCaseMapping:0x1D7D4
 },
 { code:0x1D7D5
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7D5
  ,simpleLowerCaseMapping:0x1D7D5
  ,simpleTitleCaseMapping:0x1D7D5
 },
 { code:0x1D7D6
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7D6
  ,simpleLowerCaseMapping:0x1D7D6
  ,simpleTitleCaseMapping:0x1D7D6
 },
 { code:0x1D7D7
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7D7
  ,simpleLowerCaseMapping:0x1D7D7
  ,simpleTitleCaseMapping:0x1D7D7
 },
 { code:0x1D7D8
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7D8
  ,simpleLowerCaseMapping:0x1D7D8
  ,simpleTitleCaseMapping:0x1D7D8
 },
 { code:0x1D7D9
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7D9
  ,simpleLowerCaseMapping:0x1D7D9
  ,simpleTitleCaseMapping:0x1D7D9
 },
 { code:0x1D7DA
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7DA
  ,simpleLowerCaseMapping:0x1D7DA
  ,simpleTitleCaseMapping:0x1D7DA
 },
 { code:0x1D7DB
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7DB
  ,simpleLowerCaseMapping:0x1D7DB
  ,simpleTitleCaseMapping:0x1D7DB
 },
 { code:0x1D7DC
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7DC
  ,simpleLowerCaseMapping:0x1D7DC
  ,simpleTitleCaseMapping:0x1D7DC
 },
 { code:0x1D7DD
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7DD
  ,simpleLowerCaseMapping:0x1D7DD
  ,simpleTitleCaseMapping:0x1D7DD
 },
 { code:0x1D7DE
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7DE
  ,simpleLowerCaseMapping:0x1D7DE
  ,simpleTitleCaseMapping:0x1D7DE
 },
 { code:0x1D7DF
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7DF
  ,simpleLowerCaseMapping:0x1D7DF
  ,simpleTitleCaseMapping:0x1D7DF
 },
 { code:0x1D7E0
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7E0
  ,simpleLowerCaseMapping:0x1D7E0
  ,simpleTitleCaseMapping:0x1D7E0
 },
 { code:0x1D7E1
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7E1
  ,simpleLowerCaseMapping:0x1D7E1
  ,simpleTitleCaseMapping:0x1D7E1
 },
 { code:0x1D7E2
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7E2
  ,simpleLowerCaseMapping:0x1D7E2
  ,simpleTitleCaseMapping:0x1D7E2
 },
 { code:0x1D7E3
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7E3
  ,simpleLowerCaseMapping:0x1D7E3
  ,simpleTitleCaseMapping:0x1D7E3
 },
 { code:0x1D7E4
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7E4
  ,simpleLowerCaseMapping:0x1D7E4
  ,simpleTitleCaseMapping:0x1D7E4
 },
 { code:0x1D7E5
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7E5
  ,simpleLowerCaseMapping:0x1D7E5
  ,simpleTitleCaseMapping:0x1D7E5
 },
 { code:0x1D7E6
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7E6
  ,simpleLowerCaseMapping:0x1D7E6
  ,simpleTitleCaseMapping:0x1D7E6
 },
 { code:0x1D7E7
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7E7
  ,simpleLowerCaseMapping:0x1D7E7
  ,simpleTitleCaseMapping:0x1D7E7
 },
 { code:0x1D7E8
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7E8
  ,simpleLowerCaseMapping:0x1D7E8
  ,simpleTitleCaseMapping:0x1D7E8
 },
 { code:0x1D7E9
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7E9
  ,simpleLowerCaseMapping:0x1D7E9
  ,simpleTitleCaseMapping:0x1D7E9
 },
 { code:0x1D7EA
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7EA
  ,simpleLowerCaseMapping:0x1D7EA
  ,simpleTitleCaseMapping:0x1D7EA
 },
 { code:0x1D7EB
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7EB
  ,simpleLowerCaseMapping:0x1D7EB
  ,simpleTitleCaseMapping:0x1D7EB
 },
 { code:0x1D7EC
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7EC
  ,simpleLowerCaseMapping:0x1D7EC
  ,simpleTitleCaseMapping:0x1D7EC
 },
 { code:0x1D7ED
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7ED
  ,simpleLowerCaseMapping:0x1D7ED
  ,simpleTitleCaseMapping:0x1D7ED
 },
 { code:0x1D7EE
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7EE
  ,simpleLowerCaseMapping:0x1D7EE
  ,simpleTitleCaseMapping:0x1D7EE
 },
 { code:0x1D7EF
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7EF
  ,simpleLowerCaseMapping:0x1D7EF
  ,simpleTitleCaseMapping:0x1D7EF
 },
 { code:0x1D7F0
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7F0
  ,simpleLowerCaseMapping:0x1D7F0
  ,simpleTitleCaseMapping:0x1D7F0
 },
 { code:0x1D7F1
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7F1
  ,simpleLowerCaseMapping:0x1D7F1
  ,simpleTitleCaseMapping:0x1D7F1
 },
 { code:0x1D7F2
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7F2
  ,simpleLowerCaseMapping:0x1D7F2
  ,simpleTitleCaseMapping:0x1D7F2
 },
 { code:0x1D7F3
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7F3
  ,simpleLowerCaseMapping:0x1D7F3
  ,simpleTitleCaseMapping:0x1D7F3
 },
 { code:0x1D7F4
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7F4
  ,simpleLowerCaseMapping:0x1D7F4
  ,simpleTitleCaseMapping:0x1D7F4
 },
 { code:0x1D7F5
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7F5
  ,simpleLowerCaseMapping:0x1D7F5
  ,simpleTitleCaseMapping:0x1D7F5
 },
 { code:0x1D7F6
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7F6
  ,simpleLowerCaseMapping:0x1D7F6
  ,simpleTitleCaseMapping:0x1D7F6
 },
 { code:0x1D7F7
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7F7
  ,simpleLowerCaseMapping:0x1D7F7
  ,simpleTitleCaseMapping:0x1D7F7
 },
 { code:0x1D7F8
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7F8
  ,simpleLowerCaseMapping:0x1D7F8
  ,simpleTitleCaseMapping:0x1D7F8
 },
 { code:0x1D7F9
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7F9
  ,simpleLowerCaseMapping:0x1D7F9
  ,simpleTitleCaseMapping:0x1D7F9
 },
 { code:0x1D7FA
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7FA
  ,simpleLowerCaseMapping:0x1D7FA
  ,simpleTitleCaseMapping:0x1D7FA
 },
 { code:0x1D7FB
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7FB
  ,simpleLowerCaseMapping:0x1D7FB
  ,simpleTitleCaseMapping:0x1D7FB
 },
 { code:0x1D7FC
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7FC
  ,simpleLowerCaseMapping:0x1D7FC
  ,simpleTitleCaseMapping:0x1D7FC
 },
 { code:0x1D7FD
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7FD
  ,simpleLowerCaseMapping:0x1D7FD
  ,simpleTitleCaseMapping:0x1D7FD
 },
 { code:0x1D7FE
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7FE
  ,simpleLowerCaseMapping:0x1D7FE
  ,simpleTitleCaseMapping:0x1D7FE
 },
 { code:0x1D7FF
  ,generalCategory:UnicodeData.GeneralCategory.Nd
  ,simpleUpperCaseMapping:0x1D7FF
  ,simpleLowerCaseMapping:0x1D7FF
  ,simpleTitleCaseMapping:0x1D7FF
 },
 { code:0x20000
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x20000
  ,simpleLowerCaseMapping:0x20000
  ,simpleTitleCaseMapping:0x20000
 },
 { code:0x2A6D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2A6D6
  ,simpleLowerCaseMapping:0x2A6D6
  ,simpleTitleCaseMapping:0x2A6D6
 },
 { code:0x2F800
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F800
  ,simpleLowerCaseMapping:0x2F800
  ,simpleTitleCaseMapping:0x2F800
 },
 { code:0x2F801
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F801
  ,simpleLowerCaseMapping:0x2F801
  ,simpleTitleCaseMapping:0x2F801
 },
 { code:0x2F802
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F802
  ,simpleLowerCaseMapping:0x2F802
  ,simpleTitleCaseMapping:0x2F802
 },
 { code:0x2F803
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F803
  ,simpleLowerCaseMapping:0x2F803
  ,simpleTitleCaseMapping:0x2F803
 },
 { code:0x2F804
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F804
  ,simpleLowerCaseMapping:0x2F804
  ,simpleTitleCaseMapping:0x2F804
 },
 { code:0x2F805
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F805
  ,simpleLowerCaseMapping:0x2F805
  ,simpleTitleCaseMapping:0x2F805
 },
 { code:0x2F806
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F806
  ,simpleLowerCaseMapping:0x2F806
  ,simpleTitleCaseMapping:0x2F806
 },
 { code:0x2F807
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F807
  ,simpleLowerCaseMapping:0x2F807
  ,simpleTitleCaseMapping:0x2F807
 },
 { code:0x2F808
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F808
  ,simpleLowerCaseMapping:0x2F808
  ,simpleTitleCaseMapping:0x2F808
 },
 { code:0x2F809
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F809
  ,simpleLowerCaseMapping:0x2F809
  ,simpleTitleCaseMapping:0x2F809
 },
 { code:0x2F80A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F80A
  ,simpleLowerCaseMapping:0x2F80A
  ,simpleTitleCaseMapping:0x2F80A
 },
 { code:0x2F80B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F80B
  ,simpleLowerCaseMapping:0x2F80B
  ,simpleTitleCaseMapping:0x2F80B
 },
 { code:0x2F80C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F80C
  ,simpleLowerCaseMapping:0x2F80C
  ,simpleTitleCaseMapping:0x2F80C
 },
 { code:0x2F80D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F80D
  ,simpleLowerCaseMapping:0x2F80D
  ,simpleTitleCaseMapping:0x2F80D
 },
 { code:0x2F80E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F80E
  ,simpleLowerCaseMapping:0x2F80E
  ,simpleTitleCaseMapping:0x2F80E
 },
 { code:0x2F80F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F80F
  ,simpleLowerCaseMapping:0x2F80F
  ,simpleTitleCaseMapping:0x2F80F
 },
 { code:0x2F810
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F810
  ,simpleLowerCaseMapping:0x2F810
  ,simpleTitleCaseMapping:0x2F810
 },
 { code:0x2F811
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F811
  ,simpleLowerCaseMapping:0x2F811
  ,simpleTitleCaseMapping:0x2F811
 },
 { code:0x2F812
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F812
  ,simpleLowerCaseMapping:0x2F812
  ,simpleTitleCaseMapping:0x2F812
 },
 { code:0x2F813
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F813
  ,simpleLowerCaseMapping:0x2F813
  ,simpleTitleCaseMapping:0x2F813
 },
 { code:0x2F814
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F814
  ,simpleLowerCaseMapping:0x2F814
  ,simpleTitleCaseMapping:0x2F814
 },
 { code:0x2F815
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F815
  ,simpleLowerCaseMapping:0x2F815
  ,simpleTitleCaseMapping:0x2F815
 },
 { code:0x2F816
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F816
  ,simpleLowerCaseMapping:0x2F816
  ,simpleTitleCaseMapping:0x2F816
 },
 { code:0x2F817
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F817
  ,simpleLowerCaseMapping:0x2F817
  ,simpleTitleCaseMapping:0x2F817
 },
 { code:0x2F818
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F818
  ,simpleLowerCaseMapping:0x2F818
  ,simpleTitleCaseMapping:0x2F818
 },
 { code:0x2F819
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F819
  ,simpleLowerCaseMapping:0x2F819
  ,simpleTitleCaseMapping:0x2F819
 },
 { code:0x2F81A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F81A
  ,simpleLowerCaseMapping:0x2F81A
  ,simpleTitleCaseMapping:0x2F81A
 },
 { code:0x2F81B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F81B
  ,simpleLowerCaseMapping:0x2F81B
  ,simpleTitleCaseMapping:0x2F81B
 },
 { code:0x2F81C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F81C
  ,simpleLowerCaseMapping:0x2F81C
  ,simpleTitleCaseMapping:0x2F81C
 },
 { code:0x2F81D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F81D
  ,simpleLowerCaseMapping:0x2F81D
  ,simpleTitleCaseMapping:0x2F81D
 },
 { code:0x2F81E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F81E
  ,simpleLowerCaseMapping:0x2F81E
  ,simpleTitleCaseMapping:0x2F81E
 },
 { code:0x2F81F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F81F
  ,simpleLowerCaseMapping:0x2F81F
  ,simpleTitleCaseMapping:0x2F81F
 },
 { code:0x2F820
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F820
  ,simpleLowerCaseMapping:0x2F820
  ,simpleTitleCaseMapping:0x2F820
 },
 { code:0x2F821
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F821
  ,simpleLowerCaseMapping:0x2F821
  ,simpleTitleCaseMapping:0x2F821
 },
 { code:0x2F822
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F822
  ,simpleLowerCaseMapping:0x2F822
  ,simpleTitleCaseMapping:0x2F822
 },
 { code:0x2F823
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F823
  ,simpleLowerCaseMapping:0x2F823
  ,simpleTitleCaseMapping:0x2F823
 },
 { code:0x2F824
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F824
  ,simpleLowerCaseMapping:0x2F824
  ,simpleTitleCaseMapping:0x2F824
 },
 { code:0x2F825
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F825
  ,simpleLowerCaseMapping:0x2F825
  ,simpleTitleCaseMapping:0x2F825
 },
 { code:0x2F826
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F826
  ,simpleLowerCaseMapping:0x2F826
  ,simpleTitleCaseMapping:0x2F826
 },
 { code:0x2F827
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F827
  ,simpleLowerCaseMapping:0x2F827
  ,simpleTitleCaseMapping:0x2F827
 },
 { code:0x2F828
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F828
  ,simpleLowerCaseMapping:0x2F828
  ,simpleTitleCaseMapping:0x2F828
 },
 { code:0x2F829
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F829
  ,simpleLowerCaseMapping:0x2F829
  ,simpleTitleCaseMapping:0x2F829
 },
 { code:0x2F82A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F82A
  ,simpleLowerCaseMapping:0x2F82A
  ,simpleTitleCaseMapping:0x2F82A
 },
 { code:0x2F82B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F82B
  ,simpleLowerCaseMapping:0x2F82B
  ,simpleTitleCaseMapping:0x2F82B
 },
 { code:0x2F82C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F82C
  ,simpleLowerCaseMapping:0x2F82C
  ,simpleTitleCaseMapping:0x2F82C
 },
 { code:0x2F82D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F82D
  ,simpleLowerCaseMapping:0x2F82D
  ,simpleTitleCaseMapping:0x2F82D
 },
 { code:0x2F82E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F82E
  ,simpleLowerCaseMapping:0x2F82E
  ,simpleTitleCaseMapping:0x2F82E
 },
 { code:0x2F82F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F82F
  ,simpleLowerCaseMapping:0x2F82F
  ,simpleTitleCaseMapping:0x2F82F
 },
 { code:0x2F830
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F830
  ,simpleLowerCaseMapping:0x2F830
  ,simpleTitleCaseMapping:0x2F830
 },
 { code:0x2F831
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F831
  ,simpleLowerCaseMapping:0x2F831
  ,simpleTitleCaseMapping:0x2F831
 },
 { code:0x2F832
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F832
  ,simpleLowerCaseMapping:0x2F832
  ,simpleTitleCaseMapping:0x2F832
 },
 { code:0x2F833
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F833
  ,simpleLowerCaseMapping:0x2F833
  ,simpleTitleCaseMapping:0x2F833
 },
 { code:0x2F834
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F834
  ,simpleLowerCaseMapping:0x2F834
  ,simpleTitleCaseMapping:0x2F834
 },
 { code:0x2F835
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F835
  ,simpleLowerCaseMapping:0x2F835
  ,simpleTitleCaseMapping:0x2F835
 },
 { code:0x2F836
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F836
  ,simpleLowerCaseMapping:0x2F836
  ,simpleTitleCaseMapping:0x2F836
 },
 { code:0x2F837
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F837
  ,simpleLowerCaseMapping:0x2F837
  ,simpleTitleCaseMapping:0x2F837
 },
 { code:0x2F838
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F838
  ,simpleLowerCaseMapping:0x2F838
  ,simpleTitleCaseMapping:0x2F838
 },
 { code:0x2F839
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F839
  ,simpleLowerCaseMapping:0x2F839
  ,simpleTitleCaseMapping:0x2F839
 },
 { code:0x2F83A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F83A
  ,simpleLowerCaseMapping:0x2F83A
  ,simpleTitleCaseMapping:0x2F83A
 },
 { code:0x2F83B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F83B
  ,simpleLowerCaseMapping:0x2F83B
  ,simpleTitleCaseMapping:0x2F83B
 },
 { code:0x2F83C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F83C
  ,simpleLowerCaseMapping:0x2F83C
  ,simpleTitleCaseMapping:0x2F83C
 },
 { code:0x2F83D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F83D
  ,simpleLowerCaseMapping:0x2F83D
  ,simpleTitleCaseMapping:0x2F83D
 },
 { code:0x2F83E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F83E
  ,simpleLowerCaseMapping:0x2F83E
  ,simpleTitleCaseMapping:0x2F83E
 },
 { code:0x2F83F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F83F
  ,simpleLowerCaseMapping:0x2F83F
  ,simpleTitleCaseMapping:0x2F83F
 },
 { code:0x2F840
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F840
  ,simpleLowerCaseMapping:0x2F840
  ,simpleTitleCaseMapping:0x2F840
 },
 { code:0x2F841
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F841
  ,simpleLowerCaseMapping:0x2F841
  ,simpleTitleCaseMapping:0x2F841
 },
 { code:0x2F842
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F842
  ,simpleLowerCaseMapping:0x2F842
  ,simpleTitleCaseMapping:0x2F842
 },
 { code:0x2F843
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F843
  ,simpleLowerCaseMapping:0x2F843
  ,simpleTitleCaseMapping:0x2F843
 },
 { code:0x2F844
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F844
  ,simpleLowerCaseMapping:0x2F844
  ,simpleTitleCaseMapping:0x2F844
 },
 { code:0x2F845
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F845
  ,simpleLowerCaseMapping:0x2F845
  ,simpleTitleCaseMapping:0x2F845
 },
 { code:0x2F846
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F846
  ,simpleLowerCaseMapping:0x2F846
  ,simpleTitleCaseMapping:0x2F846
 },
 { code:0x2F847
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F847
  ,simpleLowerCaseMapping:0x2F847
  ,simpleTitleCaseMapping:0x2F847
 },
 { code:0x2F848
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F848
  ,simpleLowerCaseMapping:0x2F848
  ,simpleTitleCaseMapping:0x2F848
 },
 { code:0x2F849
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F849
  ,simpleLowerCaseMapping:0x2F849
  ,simpleTitleCaseMapping:0x2F849
 },
 { code:0x2F84A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F84A
  ,simpleLowerCaseMapping:0x2F84A
  ,simpleTitleCaseMapping:0x2F84A
 },
 { code:0x2F84B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F84B
  ,simpleLowerCaseMapping:0x2F84B
  ,simpleTitleCaseMapping:0x2F84B
 },
 { code:0x2F84C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F84C
  ,simpleLowerCaseMapping:0x2F84C
  ,simpleTitleCaseMapping:0x2F84C
 },
 { code:0x2F84D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F84D
  ,simpleLowerCaseMapping:0x2F84D
  ,simpleTitleCaseMapping:0x2F84D
 },
 { code:0x2F84E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F84E
  ,simpleLowerCaseMapping:0x2F84E
  ,simpleTitleCaseMapping:0x2F84E
 },
 { code:0x2F84F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F84F
  ,simpleLowerCaseMapping:0x2F84F
  ,simpleTitleCaseMapping:0x2F84F
 },
 { code:0x2F850
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F850
  ,simpleLowerCaseMapping:0x2F850
  ,simpleTitleCaseMapping:0x2F850
 },
 { code:0x2F851
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F851
  ,simpleLowerCaseMapping:0x2F851
  ,simpleTitleCaseMapping:0x2F851
 },
 { code:0x2F852
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F852
  ,simpleLowerCaseMapping:0x2F852
  ,simpleTitleCaseMapping:0x2F852
 },
 { code:0x2F853
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F853
  ,simpleLowerCaseMapping:0x2F853
  ,simpleTitleCaseMapping:0x2F853
 },
 { code:0x2F854
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F854
  ,simpleLowerCaseMapping:0x2F854
  ,simpleTitleCaseMapping:0x2F854
 },
 { code:0x2F855
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F855
  ,simpleLowerCaseMapping:0x2F855
  ,simpleTitleCaseMapping:0x2F855
 },
 { code:0x2F856
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F856
  ,simpleLowerCaseMapping:0x2F856
  ,simpleTitleCaseMapping:0x2F856
 },
 { code:0x2F857
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F857
  ,simpleLowerCaseMapping:0x2F857
  ,simpleTitleCaseMapping:0x2F857
 },
 { code:0x2F858
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F858
  ,simpleLowerCaseMapping:0x2F858
  ,simpleTitleCaseMapping:0x2F858
 },
 { code:0x2F859
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F859
  ,simpleLowerCaseMapping:0x2F859
  ,simpleTitleCaseMapping:0x2F859
 },
 { code:0x2F85A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F85A
  ,simpleLowerCaseMapping:0x2F85A
  ,simpleTitleCaseMapping:0x2F85A
 },
 { code:0x2F85B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F85B
  ,simpleLowerCaseMapping:0x2F85B
  ,simpleTitleCaseMapping:0x2F85B
 },
 { code:0x2F85C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F85C
  ,simpleLowerCaseMapping:0x2F85C
  ,simpleTitleCaseMapping:0x2F85C
 },
 { code:0x2F85D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F85D
  ,simpleLowerCaseMapping:0x2F85D
  ,simpleTitleCaseMapping:0x2F85D
 },
 { code:0x2F85E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F85E
  ,simpleLowerCaseMapping:0x2F85E
  ,simpleTitleCaseMapping:0x2F85E
 },
 { code:0x2F85F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F85F
  ,simpleLowerCaseMapping:0x2F85F
  ,simpleTitleCaseMapping:0x2F85F
 },
 { code:0x2F860
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F860
  ,simpleLowerCaseMapping:0x2F860
  ,simpleTitleCaseMapping:0x2F860
 },
 { code:0x2F861
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F861
  ,simpleLowerCaseMapping:0x2F861
  ,simpleTitleCaseMapping:0x2F861
 },
 { code:0x2F862
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F862
  ,simpleLowerCaseMapping:0x2F862
  ,simpleTitleCaseMapping:0x2F862
 },
 { code:0x2F863
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F863
  ,simpleLowerCaseMapping:0x2F863
  ,simpleTitleCaseMapping:0x2F863
 },
 { code:0x2F864
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F864
  ,simpleLowerCaseMapping:0x2F864
  ,simpleTitleCaseMapping:0x2F864
 },
 { code:0x2F865
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F865
  ,simpleLowerCaseMapping:0x2F865
  ,simpleTitleCaseMapping:0x2F865
 },
 { code:0x2F866
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F866
  ,simpleLowerCaseMapping:0x2F866
  ,simpleTitleCaseMapping:0x2F866
 },
 { code:0x2F867
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F867
  ,simpleLowerCaseMapping:0x2F867
  ,simpleTitleCaseMapping:0x2F867
 },
 { code:0x2F868
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F868
  ,simpleLowerCaseMapping:0x2F868
  ,simpleTitleCaseMapping:0x2F868
 },
 { code:0x2F869
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F869
  ,simpleLowerCaseMapping:0x2F869
  ,simpleTitleCaseMapping:0x2F869
 },
 { code:0x2F86A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F86A
  ,simpleLowerCaseMapping:0x2F86A
  ,simpleTitleCaseMapping:0x2F86A
 },
 { code:0x2F86B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F86B
  ,simpleLowerCaseMapping:0x2F86B
  ,simpleTitleCaseMapping:0x2F86B
 },
 { code:0x2F86C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F86C
  ,simpleLowerCaseMapping:0x2F86C
  ,simpleTitleCaseMapping:0x2F86C
 },
 { code:0x2F86D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F86D
  ,simpleLowerCaseMapping:0x2F86D
  ,simpleTitleCaseMapping:0x2F86D
 },
 { code:0x2F86E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F86E
  ,simpleLowerCaseMapping:0x2F86E
  ,simpleTitleCaseMapping:0x2F86E
 },
 { code:0x2F86F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F86F
  ,simpleLowerCaseMapping:0x2F86F
  ,simpleTitleCaseMapping:0x2F86F
 },
 { code:0x2F870
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F870
  ,simpleLowerCaseMapping:0x2F870
  ,simpleTitleCaseMapping:0x2F870
 },
 { code:0x2F871
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F871
  ,simpleLowerCaseMapping:0x2F871
  ,simpleTitleCaseMapping:0x2F871
 },
 { code:0x2F872
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F872
  ,simpleLowerCaseMapping:0x2F872
  ,simpleTitleCaseMapping:0x2F872
 },
 { code:0x2F873
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F873
  ,simpleLowerCaseMapping:0x2F873
  ,simpleTitleCaseMapping:0x2F873
 },
 { code:0x2F874
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F874
  ,simpleLowerCaseMapping:0x2F874
  ,simpleTitleCaseMapping:0x2F874
 },
 { code:0x2F875
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F875
  ,simpleLowerCaseMapping:0x2F875
  ,simpleTitleCaseMapping:0x2F875
 },
 { code:0x2F876
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F876
  ,simpleLowerCaseMapping:0x2F876
  ,simpleTitleCaseMapping:0x2F876
 },
 { code:0x2F877
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F877
  ,simpleLowerCaseMapping:0x2F877
  ,simpleTitleCaseMapping:0x2F877
 },
 { code:0x2F878
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F878
  ,simpleLowerCaseMapping:0x2F878
  ,simpleTitleCaseMapping:0x2F878
 },
 { code:0x2F879
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F879
  ,simpleLowerCaseMapping:0x2F879
  ,simpleTitleCaseMapping:0x2F879
 },
 { code:0x2F87A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F87A
  ,simpleLowerCaseMapping:0x2F87A
  ,simpleTitleCaseMapping:0x2F87A
 },
 { code:0x2F87B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F87B
  ,simpleLowerCaseMapping:0x2F87B
  ,simpleTitleCaseMapping:0x2F87B
 },
 { code:0x2F87C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F87C
  ,simpleLowerCaseMapping:0x2F87C
  ,simpleTitleCaseMapping:0x2F87C
 },
 { code:0x2F87D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F87D
  ,simpleLowerCaseMapping:0x2F87D
  ,simpleTitleCaseMapping:0x2F87D
 },
 { code:0x2F87E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F87E
  ,simpleLowerCaseMapping:0x2F87E
  ,simpleTitleCaseMapping:0x2F87E
 },
 { code:0x2F87F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F87F
  ,simpleLowerCaseMapping:0x2F87F
  ,simpleTitleCaseMapping:0x2F87F
 },
 { code:0x2F880
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F880
  ,simpleLowerCaseMapping:0x2F880
  ,simpleTitleCaseMapping:0x2F880
 },
 { code:0x2F881
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F881
  ,simpleLowerCaseMapping:0x2F881
  ,simpleTitleCaseMapping:0x2F881
 },
 { code:0x2F882
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F882
  ,simpleLowerCaseMapping:0x2F882
  ,simpleTitleCaseMapping:0x2F882
 },
 { code:0x2F883
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F883
  ,simpleLowerCaseMapping:0x2F883
  ,simpleTitleCaseMapping:0x2F883
 },
 { code:0x2F884
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F884
  ,simpleLowerCaseMapping:0x2F884
  ,simpleTitleCaseMapping:0x2F884
 },
 { code:0x2F885
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F885
  ,simpleLowerCaseMapping:0x2F885
  ,simpleTitleCaseMapping:0x2F885
 },
 { code:0x2F886
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F886
  ,simpleLowerCaseMapping:0x2F886
  ,simpleTitleCaseMapping:0x2F886
 },
 { code:0x2F887
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F887
  ,simpleLowerCaseMapping:0x2F887
  ,simpleTitleCaseMapping:0x2F887
 },
 { code:0x2F888
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F888
  ,simpleLowerCaseMapping:0x2F888
  ,simpleTitleCaseMapping:0x2F888
 },
 { code:0x2F889
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F889
  ,simpleLowerCaseMapping:0x2F889
  ,simpleTitleCaseMapping:0x2F889
 },
 { code:0x2F88A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F88A
  ,simpleLowerCaseMapping:0x2F88A
  ,simpleTitleCaseMapping:0x2F88A
 },
 { code:0x2F88B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F88B
  ,simpleLowerCaseMapping:0x2F88B
  ,simpleTitleCaseMapping:0x2F88B
 },
 { code:0x2F88C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F88C
  ,simpleLowerCaseMapping:0x2F88C
  ,simpleTitleCaseMapping:0x2F88C
 },
 { code:0x2F88D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F88D
  ,simpleLowerCaseMapping:0x2F88D
  ,simpleTitleCaseMapping:0x2F88D
 },
 { code:0x2F88E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F88E
  ,simpleLowerCaseMapping:0x2F88E
  ,simpleTitleCaseMapping:0x2F88E
 },
 { code:0x2F88F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F88F
  ,simpleLowerCaseMapping:0x2F88F
  ,simpleTitleCaseMapping:0x2F88F
 },
 { code:0x2F890
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F890
  ,simpleLowerCaseMapping:0x2F890
  ,simpleTitleCaseMapping:0x2F890
 },
 { code:0x2F891
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F891
  ,simpleLowerCaseMapping:0x2F891
  ,simpleTitleCaseMapping:0x2F891
 },
 { code:0x2F892
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F892
  ,simpleLowerCaseMapping:0x2F892
  ,simpleTitleCaseMapping:0x2F892
 },
 { code:0x2F893
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F893
  ,simpleLowerCaseMapping:0x2F893
  ,simpleTitleCaseMapping:0x2F893
 },
 { code:0x2F894
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F894
  ,simpleLowerCaseMapping:0x2F894
  ,simpleTitleCaseMapping:0x2F894
 },
 { code:0x2F895
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F895
  ,simpleLowerCaseMapping:0x2F895
  ,simpleTitleCaseMapping:0x2F895
 },
 { code:0x2F896
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F896
  ,simpleLowerCaseMapping:0x2F896
  ,simpleTitleCaseMapping:0x2F896
 },
 { code:0x2F897
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F897
  ,simpleLowerCaseMapping:0x2F897
  ,simpleTitleCaseMapping:0x2F897
 },
 { code:0x2F898
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F898
  ,simpleLowerCaseMapping:0x2F898
  ,simpleTitleCaseMapping:0x2F898
 },
 { code:0x2F899
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F899
  ,simpleLowerCaseMapping:0x2F899
  ,simpleTitleCaseMapping:0x2F899
 },
 { code:0x2F89A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F89A
  ,simpleLowerCaseMapping:0x2F89A
  ,simpleTitleCaseMapping:0x2F89A
 },
 { code:0x2F89B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F89B
  ,simpleLowerCaseMapping:0x2F89B
  ,simpleTitleCaseMapping:0x2F89B
 },
 { code:0x2F89C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F89C
  ,simpleLowerCaseMapping:0x2F89C
  ,simpleTitleCaseMapping:0x2F89C
 },
 { code:0x2F89D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F89D
  ,simpleLowerCaseMapping:0x2F89D
  ,simpleTitleCaseMapping:0x2F89D
 },
 { code:0x2F89E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F89E
  ,simpleLowerCaseMapping:0x2F89E
  ,simpleTitleCaseMapping:0x2F89E
 },
 { code:0x2F89F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F89F
  ,simpleLowerCaseMapping:0x2F89F
  ,simpleTitleCaseMapping:0x2F89F
 },
 { code:0x2F8A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8A0
  ,simpleLowerCaseMapping:0x2F8A0
  ,simpleTitleCaseMapping:0x2F8A0
 },
 { code:0x2F8A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8A1
  ,simpleLowerCaseMapping:0x2F8A1
  ,simpleTitleCaseMapping:0x2F8A1
 },
 { code:0x2F8A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8A2
  ,simpleLowerCaseMapping:0x2F8A2
  ,simpleTitleCaseMapping:0x2F8A2
 },
 { code:0x2F8A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8A3
  ,simpleLowerCaseMapping:0x2F8A3
  ,simpleTitleCaseMapping:0x2F8A3
 },
 { code:0x2F8A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8A4
  ,simpleLowerCaseMapping:0x2F8A4
  ,simpleTitleCaseMapping:0x2F8A4
 },
 { code:0x2F8A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8A5
  ,simpleLowerCaseMapping:0x2F8A5
  ,simpleTitleCaseMapping:0x2F8A5
 },
 { code:0x2F8A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8A6
  ,simpleLowerCaseMapping:0x2F8A6
  ,simpleTitleCaseMapping:0x2F8A6
 },
 { code:0x2F8A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8A7
  ,simpleLowerCaseMapping:0x2F8A7
  ,simpleTitleCaseMapping:0x2F8A7
 },
 { code:0x2F8A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8A8
  ,simpleLowerCaseMapping:0x2F8A8
  ,simpleTitleCaseMapping:0x2F8A8
 },
 { code:0x2F8A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8A9
  ,simpleLowerCaseMapping:0x2F8A9
  ,simpleTitleCaseMapping:0x2F8A9
 },
 { code:0x2F8AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8AA
  ,simpleLowerCaseMapping:0x2F8AA
  ,simpleTitleCaseMapping:0x2F8AA
 },
 { code:0x2F8AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8AB
  ,simpleLowerCaseMapping:0x2F8AB
  ,simpleTitleCaseMapping:0x2F8AB
 },
 { code:0x2F8AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8AC
  ,simpleLowerCaseMapping:0x2F8AC
  ,simpleTitleCaseMapping:0x2F8AC
 },
 { code:0x2F8AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8AD
  ,simpleLowerCaseMapping:0x2F8AD
  ,simpleTitleCaseMapping:0x2F8AD
 },
 { code:0x2F8AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8AE
  ,simpleLowerCaseMapping:0x2F8AE
  ,simpleTitleCaseMapping:0x2F8AE
 },
 { code:0x2F8AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8AF
  ,simpleLowerCaseMapping:0x2F8AF
  ,simpleTitleCaseMapping:0x2F8AF
 },
 { code:0x2F8B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8B0
  ,simpleLowerCaseMapping:0x2F8B0
  ,simpleTitleCaseMapping:0x2F8B0
 },
 { code:0x2F8B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8B1
  ,simpleLowerCaseMapping:0x2F8B1
  ,simpleTitleCaseMapping:0x2F8B1
 },
 { code:0x2F8B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8B2
  ,simpleLowerCaseMapping:0x2F8B2
  ,simpleTitleCaseMapping:0x2F8B2
 },
 { code:0x2F8B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8B3
  ,simpleLowerCaseMapping:0x2F8B3
  ,simpleTitleCaseMapping:0x2F8B3
 },
 { code:0x2F8B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8B4
  ,simpleLowerCaseMapping:0x2F8B4
  ,simpleTitleCaseMapping:0x2F8B4
 },
 { code:0x2F8B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8B5
  ,simpleLowerCaseMapping:0x2F8B5
  ,simpleTitleCaseMapping:0x2F8B5
 },
 { code:0x2F8B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8B6
  ,simpleLowerCaseMapping:0x2F8B6
  ,simpleTitleCaseMapping:0x2F8B6
 },
 { code:0x2F8B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8B7
  ,simpleLowerCaseMapping:0x2F8B7
  ,simpleTitleCaseMapping:0x2F8B7
 },
 { code:0x2F8B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8B8
  ,simpleLowerCaseMapping:0x2F8B8
  ,simpleTitleCaseMapping:0x2F8B8
 },
 { code:0x2F8B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8B9
  ,simpleLowerCaseMapping:0x2F8B9
  ,simpleTitleCaseMapping:0x2F8B9
 },
 { code:0x2F8BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8BA
  ,simpleLowerCaseMapping:0x2F8BA
  ,simpleTitleCaseMapping:0x2F8BA
 },
 { code:0x2F8BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8BB
  ,simpleLowerCaseMapping:0x2F8BB
  ,simpleTitleCaseMapping:0x2F8BB
 },
 { code:0x2F8BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8BC
  ,simpleLowerCaseMapping:0x2F8BC
  ,simpleTitleCaseMapping:0x2F8BC
 },
 { code:0x2F8BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8BD
  ,simpleLowerCaseMapping:0x2F8BD
  ,simpleTitleCaseMapping:0x2F8BD
 },
 { code:0x2F8BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8BE
  ,simpleLowerCaseMapping:0x2F8BE
  ,simpleTitleCaseMapping:0x2F8BE
 },
 { code:0x2F8BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8BF
  ,simpleLowerCaseMapping:0x2F8BF
  ,simpleTitleCaseMapping:0x2F8BF
 },
 { code:0x2F8C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8C0
  ,simpleLowerCaseMapping:0x2F8C0
  ,simpleTitleCaseMapping:0x2F8C0
 },
 { code:0x2F8C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8C1
  ,simpleLowerCaseMapping:0x2F8C1
  ,simpleTitleCaseMapping:0x2F8C1
 },
 { code:0x2F8C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8C2
  ,simpleLowerCaseMapping:0x2F8C2
  ,simpleTitleCaseMapping:0x2F8C2
 },
 { code:0x2F8C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8C3
  ,simpleLowerCaseMapping:0x2F8C3
  ,simpleTitleCaseMapping:0x2F8C3
 },
 { code:0x2F8C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8C4
  ,simpleLowerCaseMapping:0x2F8C4
  ,simpleTitleCaseMapping:0x2F8C4
 },
 { code:0x2F8C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8C5
  ,simpleLowerCaseMapping:0x2F8C5
  ,simpleTitleCaseMapping:0x2F8C5
 },
 { code:0x2F8C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8C6
  ,simpleLowerCaseMapping:0x2F8C6
  ,simpleTitleCaseMapping:0x2F8C6
 },
 { code:0x2F8C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8C7
  ,simpleLowerCaseMapping:0x2F8C7
  ,simpleTitleCaseMapping:0x2F8C7
 },
 { code:0x2F8C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8C8
  ,simpleLowerCaseMapping:0x2F8C8
  ,simpleTitleCaseMapping:0x2F8C8
 },
 { code:0x2F8C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8C9
  ,simpleLowerCaseMapping:0x2F8C9
  ,simpleTitleCaseMapping:0x2F8C9
 },
 { code:0x2F8CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8CA
  ,simpleLowerCaseMapping:0x2F8CA
  ,simpleTitleCaseMapping:0x2F8CA
 },
 { code:0x2F8CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8CB
  ,simpleLowerCaseMapping:0x2F8CB
  ,simpleTitleCaseMapping:0x2F8CB
 },
 { code:0x2F8CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8CC
  ,simpleLowerCaseMapping:0x2F8CC
  ,simpleTitleCaseMapping:0x2F8CC
 },
 { code:0x2F8CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8CD
  ,simpleLowerCaseMapping:0x2F8CD
  ,simpleTitleCaseMapping:0x2F8CD
 },
 { code:0x2F8CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8CE
  ,simpleLowerCaseMapping:0x2F8CE
  ,simpleTitleCaseMapping:0x2F8CE
 },
 { code:0x2F8CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8CF
  ,simpleLowerCaseMapping:0x2F8CF
  ,simpleTitleCaseMapping:0x2F8CF
 },
 { code:0x2F8D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8D0
  ,simpleLowerCaseMapping:0x2F8D0
  ,simpleTitleCaseMapping:0x2F8D0
 },
 { code:0x2F8D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8D1
  ,simpleLowerCaseMapping:0x2F8D1
  ,simpleTitleCaseMapping:0x2F8D1
 },
 { code:0x2F8D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8D2
  ,simpleLowerCaseMapping:0x2F8D2
  ,simpleTitleCaseMapping:0x2F8D2
 },
 { code:0x2F8D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8D3
  ,simpleLowerCaseMapping:0x2F8D3
  ,simpleTitleCaseMapping:0x2F8D3
 },
 { code:0x2F8D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8D4
  ,simpleLowerCaseMapping:0x2F8D4
  ,simpleTitleCaseMapping:0x2F8D4
 },
 { code:0x2F8D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8D5
  ,simpleLowerCaseMapping:0x2F8D5
  ,simpleTitleCaseMapping:0x2F8D5
 },
 { code:0x2F8D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8D6
  ,simpleLowerCaseMapping:0x2F8D6
  ,simpleTitleCaseMapping:0x2F8D6
 },
 { code:0x2F8D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8D7
  ,simpleLowerCaseMapping:0x2F8D7
  ,simpleTitleCaseMapping:0x2F8D7
 },
 { code:0x2F8D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8D8
  ,simpleLowerCaseMapping:0x2F8D8
  ,simpleTitleCaseMapping:0x2F8D8
 },
 { code:0x2F8D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8D9
  ,simpleLowerCaseMapping:0x2F8D9
  ,simpleTitleCaseMapping:0x2F8D9
 },
 { code:0x2F8DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8DA
  ,simpleLowerCaseMapping:0x2F8DA
  ,simpleTitleCaseMapping:0x2F8DA
 },
 { code:0x2F8DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8DB
  ,simpleLowerCaseMapping:0x2F8DB
  ,simpleTitleCaseMapping:0x2F8DB
 },
 { code:0x2F8DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8DC
  ,simpleLowerCaseMapping:0x2F8DC
  ,simpleTitleCaseMapping:0x2F8DC
 },
 { code:0x2F8DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8DD
  ,simpleLowerCaseMapping:0x2F8DD
  ,simpleTitleCaseMapping:0x2F8DD
 },
 { code:0x2F8DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8DE
  ,simpleLowerCaseMapping:0x2F8DE
  ,simpleTitleCaseMapping:0x2F8DE
 },
 { code:0x2F8DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8DF
  ,simpleLowerCaseMapping:0x2F8DF
  ,simpleTitleCaseMapping:0x2F8DF
 },
 { code:0x2F8E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8E0
  ,simpleLowerCaseMapping:0x2F8E0
  ,simpleTitleCaseMapping:0x2F8E0
 },
 { code:0x2F8E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8E1
  ,simpleLowerCaseMapping:0x2F8E1
  ,simpleTitleCaseMapping:0x2F8E1
 },
 { code:0x2F8E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8E2
  ,simpleLowerCaseMapping:0x2F8E2
  ,simpleTitleCaseMapping:0x2F8E2
 },
 { code:0x2F8E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8E3
  ,simpleLowerCaseMapping:0x2F8E3
  ,simpleTitleCaseMapping:0x2F8E3
 },
 { code:0x2F8E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8E4
  ,simpleLowerCaseMapping:0x2F8E4
  ,simpleTitleCaseMapping:0x2F8E4
 },
 { code:0x2F8E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8E5
  ,simpleLowerCaseMapping:0x2F8E5
  ,simpleTitleCaseMapping:0x2F8E5
 },
 { code:0x2F8E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8E6
  ,simpleLowerCaseMapping:0x2F8E6
  ,simpleTitleCaseMapping:0x2F8E6
 },
 { code:0x2F8E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8E7
  ,simpleLowerCaseMapping:0x2F8E7
  ,simpleTitleCaseMapping:0x2F8E7
 },
 { code:0x2F8E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8E8
  ,simpleLowerCaseMapping:0x2F8E8
  ,simpleTitleCaseMapping:0x2F8E8
 },
 { code:0x2F8E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8E9
  ,simpleLowerCaseMapping:0x2F8E9
  ,simpleTitleCaseMapping:0x2F8E9
 },
 { code:0x2F8EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8EA
  ,simpleLowerCaseMapping:0x2F8EA
  ,simpleTitleCaseMapping:0x2F8EA
 },
 { code:0x2F8EB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8EB
  ,simpleLowerCaseMapping:0x2F8EB
  ,simpleTitleCaseMapping:0x2F8EB
 },
 { code:0x2F8EC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8EC
  ,simpleLowerCaseMapping:0x2F8EC
  ,simpleTitleCaseMapping:0x2F8EC
 },
 { code:0x2F8ED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8ED
  ,simpleLowerCaseMapping:0x2F8ED
  ,simpleTitleCaseMapping:0x2F8ED
 },
 { code:0x2F8EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8EE
  ,simpleLowerCaseMapping:0x2F8EE
  ,simpleTitleCaseMapping:0x2F8EE
 },
 { code:0x2F8EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8EF
  ,simpleLowerCaseMapping:0x2F8EF
  ,simpleTitleCaseMapping:0x2F8EF
 },
 { code:0x2F8F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8F0
  ,simpleLowerCaseMapping:0x2F8F0
  ,simpleTitleCaseMapping:0x2F8F0
 },
 { code:0x2F8F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8F1
  ,simpleLowerCaseMapping:0x2F8F1
  ,simpleTitleCaseMapping:0x2F8F1
 },
 { code:0x2F8F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8F2
  ,simpleLowerCaseMapping:0x2F8F2
  ,simpleTitleCaseMapping:0x2F8F2
 },
 { code:0x2F8F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8F3
  ,simpleLowerCaseMapping:0x2F8F3
  ,simpleTitleCaseMapping:0x2F8F3
 },
 { code:0x2F8F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8F4
  ,simpleLowerCaseMapping:0x2F8F4
  ,simpleTitleCaseMapping:0x2F8F4
 },
 { code:0x2F8F5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8F5
  ,simpleLowerCaseMapping:0x2F8F5
  ,simpleTitleCaseMapping:0x2F8F5
 },
 { code:0x2F8F6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8F6
  ,simpleLowerCaseMapping:0x2F8F6
  ,simpleTitleCaseMapping:0x2F8F6
 },
 { code:0x2F8F7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8F7
  ,simpleLowerCaseMapping:0x2F8F7
  ,simpleTitleCaseMapping:0x2F8F7
 },
 { code:0x2F8F8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8F8
  ,simpleLowerCaseMapping:0x2F8F8
  ,simpleTitleCaseMapping:0x2F8F8
 },
 { code:0x2F8F9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8F9
  ,simpleLowerCaseMapping:0x2F8F9
  ,simpleTitleCaseMapping:0x2F8F9
 },
 { code:0x2F8FA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8FA
  ,simpleLowerCaseMapping:0x2F8FA
  ,simpleTitleCaseMapping:0x2F8FA
 },
 { code:0x2F8FB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8FB
  ,simpleLowerCaseMapping:0x2F8FB
  ,simpleTitleCaseMapping:0x2F8FB
 },
 { code:0x2F8FC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8FC
  ,simpleLowerCaseMapping:0x2F8FC
  ,simpleTitleCaseMapping:0x2F8FC
 },
 { code:0x2F8FD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8FD
  ,simpleLowerCaseMapping:0x2F8FD
  ,simpleTitleCaseMapping:0x2F8FD
 },
 { code:0x2F8FE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8FE
  ,simpleLowerCaseMapping:0x2F8FE
  ,simpleTitleCaseMapping:0x2F8FE
 },
 { code:0x2F8FF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F8FF
  ,simpleLowerCaseMapping:0x2F8FF
  ,simpleTitleCaseMapping:0x2F8FF
 },
 { code:0x2F900
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F900
  ,simpleLowerCaseMapping:0x2F900
  ,simpleTitleCaseMapping:0x2F900
 },
 { code:0x2F901
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F901
  ,simpleLowerCaseMapping:0x2F901
  ,simpleTitleCaseMapping:0x2F901
 },
 { code:0x2F902
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F902
  ,simpleLowerCaseMapping:0x2F902
  ,simpleTitleCaseMapping:0x2F902
 },
 { code:0x2F903
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F903
  ,simpleLowerCaseMapping:0x2F903
  ,simpleTitleCaseMapping:0x2F903
 },
 { code:0x2F904
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F904
  ,simpleLowerCaseMapping:0x2F904
  ,simpleTitleCaseMapping:0x2F904
 },
 { code:0x2F905
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F905
  ,simpleLowerCaseMapping:0x2F905
  ,simpleTitleCaseMapping:0x2F905
 },
 { code:0x2F906
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F906
  ,simpleLowerCaseMapping:0x2F906
  ,simpleTitleCaseMapping:0x2F906
 },
 { code:0x2F907
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F907
  ,simpleLowerCaseMapping:0x2F907
  ,simpleTitleCaseMapping:0x2F907
 },
 { code:0x2F908
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F908
  ,simpleLowerCaseMapping:0x2F908
  ,simpleTitleCaseMapping:0x2F908
 },
 { code:0x2F909
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F909
  ,simpleLowerCaseMapping:0x2F909
  ,simpleTitleCaseMapping:0x2F909
 },
 { code:0x2F90A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F90A
  ,simpleLowerCaseMapping:0x2F90A
  ,simpleTitleCaseMapping:0x2F90A
 },
 { code:0x2F90B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F90B
  ,simpleLowerCaseMapping:0x2F90B
  ,simpleTitleCaseMapping:0x2F90B
 },
 { code:0x2F90C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F90C
  ,simpleLowerCaseMapping:0x2F90C
  ,simpleTitleCaseMapping:0x2F90C
 },
 { code:0x2F90D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F90D
  ,simpleLowerCaseMapping:0x2F90D
  ,simpleTitleCaseMapping:0x2F90D
 },
 { code:0x2F90E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F90E
  ,simpleLowerCaseMapping:0x2F90E
  ,simpleTitleCaseMapping:0x2F90E
 },
 { code:0x2F90F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F90F
  ,simpleLowerCaseMapping:0x2F90F
  ,simpleTitleCaseMapping:0x2F90F
 },
 { code:0x2F910
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F910
  ,simpleLowerCaseMapping:0x2F910
  ,simpleTitleCaseMapping:0x2F910
 },
 { code:0x2F911
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F911
  ,simpleLowerCaseMapping:0x2F911
  ,simpleTitleCaseMapping:0x2F911
 },
 { code:0x2F912
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F912
  ,simpleLowerCaseMapping:0x2F912
  ,simpleTitleCaseMapping:0x2F912
 },
 { code:0x2F913
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F913
  ,simpleLowerCaseMapping:0x2F913
  ,simpleTitleCaseMapping:0x2F913
 },
 { code:0x2F914
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F914
  ,simpleLowerCaseMapping:0x2F914
  ,simpleTitleCaseMapping:0x2F914
 },
 { code:0x2F915
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F915
  ,simpleLowerCaseMapping:0x2F915
  ,simpleTitleCaseMapping:0x2F915
 },
 { code:0x2F916
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F916
  ,simpleLowerCaseMapping:0x2F916
  ,simpleTitleCaseMapping:0x2F916
 },
 { code:0x2F917
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F917
  ,simpleLowerCaseMapping:0x2F917
  ,simpleTitleCaseMapping:0x2F917
 },
 { code:0x2F918
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F918
  ,simpleLowerCaseMapping:0x2F918
  ,simpleTitleCaseMapping:0x2F918
 },
 { code:0x2F919
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F919
  ,simpleLowerCaseMapping:0x2F919
  ,simpleTitleCaseMapping:0x2F919
 },
 { code:0x2F91A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F91A
  ,simpleLowerCaseMapping:0x2F91A
  ,simpleTitleCaseMapping:0x2F91A
 },
 { code:0x2F91B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F91B
  ,simpleLowerCaseMapping:0x2F91B
  ,simpleTitleCaseMapping:0x2F91B
 },
 { code:0x2F91C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F91C
  ,simpleLowerCaseMapping:0x2F91C
  ,simpleTitleCaseMapping:0x2F91C
 },
 { code:0x2F91D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F91D
  ,simpleLowerCaseMapping:0x2F91D
  ,simpleTitleCaseMapping:0x2F91D
 },
 { code:0x2F91E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F91E
  ,simpleLowerCaseMapping:0x2F91E
  ,simpleTitleCaseMapping:0x2F91E
 },
 { code:0x2F91F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F91F
  ,simpleLowerCaseMapping:0x2F91F
  ,simpleTitleCaseMapping:0x2F91F
 },
 { code:0x2F920
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F920
  ,simpleLowerCaseMapping:0x2F920
  ,simpleTitleCaseMapping:0x2F920
 },
 { code:0x2F921
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F921
  ,simpleLowerCaseMapping:0x2F921
  ,simpleTitleCaseMapping:0x2F921
 },
 { code:0x2F922
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F922
  ,simpleLowerCaseMapping:0x2F922
  ,simpleTitleCaseMapping:0x2F922
 },
 { code:0x2F923
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F923
  ,simpleLowerCaseMapping:0x2F923
  ,simpleTitleCaseMapping:0x2F923
 },
 { code:0x2F924
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F924
  ,simpleLowerCaseMapping:0x2F924
  ,simpleTitleCaseMapping:0x2F924
 },
 { code:0x2F925
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F925
  ,simpleLowerCaseMapping:0x2F925
  ,simpleTitleCaseMapping:0x2F925
 },
 { code:0x2F926
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F926
  ,simpleLowerCaseMapping:0x2F926
  ,simpleTitleCaseMapping:0x2F926
 },
 { code:0x2F927
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F927
  ,simpleLowerCaseMapping:0x2F927
  ,simpleTitleCaseMapping:0x2F927
 },
 { code:0x2F928
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F928
  ,simpleLowerCaseMapping:0x2F928
  ,simpleTitleCaseMapping:0x2F928
 },
 { code:0x2F929
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F929
  ,simpleLowerCaseMapping:0x2F929
  ,simpleTitleCaseMapping:0x2F929
 },
 { code:0x2F92A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F92A
  ,simpleLowerCaseMapping:0x2F92A
  ,simpleTitleCaseMapping:0x2F92A
 },
 { code:0x2F92B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F92B
  ,simpleLowerCaseMapping:0x2F92B
  ,simpleTitleCaseMapping:0x2F92B
 },
 { code:0x2F92C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F92C
  ,simpleLowerCaseMapping:0x2F92C
  ,simpleTitleCaseMapping:0x2F92C
 },
 { code:0x2F92D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F92D
  ,simpleLowerCaseMapping:0x2F92D
  ,simpleTitleCaseMapping:0x2F92D
 },
 { code:0x2F92E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F92E
  ,simpleLowerCaseMapping:0x2F92E
  ,simpleTitleCaseMapping:0x2F92E
 },
 { code:0x2F92F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F92F
  ,simpleLowerCaseMapping:0x2F92F
  ,simpleTitleCaseMapping:0x2F92F
 },
 { code:0x2F930
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F930
  ,simpleLowerCaseMapping:0x2F930
  ,simpleTitleCaseMapping:0x2F930
 },
 { code:0x2F931
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F931
  ,simpleLowerCaseMapping:0x2F931
  ,simpleTitleCaseMapping:0x2F931
 },
 { code:0x2F932
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F932
  ,simpleLowerCaseMapping:0x2F932
  ,simpleTitleCaseMapping:0x2F932
 },
 { code:0x2F933
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F933
  ,simpleLowerCaseMapping:0x2F933
  ,simpleTitleCaseMapping:0x2F933
 },
 { code:0x2F934
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F934
  ,simpleLowerCaseMapping:0x2F934
  ,simpleTitleCaseMapping:0x2F934
 },
 { code:0x2F935
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F935
  ,simpleLowerCaseMapping:0x2F935
  ,simpleTitleCaseMapping:0x2F935
 },
 { code:0x2F936
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F936
  ,simpleLowerCaseMapping:0x2F936
  ,simpleTitleCaseMapping:0x2F936
 },
 { code:0x2F937
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F937
  ,simpleLowerCaseMapping:0x2F937
  ,simpleTitleCaseMapping:0x2F937
 },
 { code:0x2F938
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F938
  ,simpleLowerCaseMapping:0x2F938
  ,simpleTitleCaseMapping:0x2F938
 },
 { code:0x2F939
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F939
  ,simpleLowerCaseMapping:0x2F939
  ,simpleTitleCaseMapping:0x2F939
 },
 { code:0x2F93A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F93A
  ,simpleLowerCaseMapping:0x2F93A
  ,simpleTitleCaseMapping:0x2F93A
 },
 { code:0x2F93B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F93B
  ,simpleLowerCaseMapping:0x2F93B
  ,simpleTitleCaseMapping:0x2F93B
 },
 { code:0x2F93C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F93C
  ,simpleLowerCaseMapping:0x2F93C
  ,simpleTitleCaseMapping:0x2F93C
 },
 { code:0x2F93D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F93D
  ,simpleLowerCaseMapping:0x2F93D
  ,simpleTitleCaseMapping:0x2F93D
 },
 { code:0x2F93E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F93E
  ,simpleLowerCaseMapping:0x2F93E
  ,simpleTitleCaseMapping:0x2F93E
 },
 { code:0x2F93F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F93F
  ,simpleLowerCaseMapping:0x2F93F
  ,simpleTitleCaseMapping:0x2F93F
 },
 { code:0x2F940
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F940
  ,simpleLowerCaseMapping:0x2F940
  ,simpleTitleCaseMapping:0x2F940
 },
 { code:0x2F941
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F941
  ,simpleLowerCaseMapping:0x2F941
  ,simpleTitleCaseMapping:0x2F941
 },
 { code:0x2F942
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F942
  ,simpleLowerCaseMapping:0x2F942
  ,simpleTitleCaseMapping:0x2F942
 },
 { code:0x2F943
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F943
  ,simpleLowerCaseMapping:0x2F943
  ,simpleTitleCaseMapping:0x2F943
 },
 { code:0x2F944
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F944
  ,simpleLowerCaseMapping:0x2F944
  ,simpleTitleCaseMapping:0x2F944
 },
 { code:0x2F945
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F945
  ,simpleLowerCaseMapping:0x2F945
  ,simpleTitleCaseMapping:0x2F945
 },
 { code:0x2F946
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F946
  ,simpleLowerCaseMapping:0x2F946
  ,simpleTitleCaseMapping:0x2F946
 },
 { code:0x2F947
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F947
  ,simpleLowerCaseMapping:0x2F947
  ,simpleTitleCaseMapping:0x2F947
 },
 { code:0x2F948
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F948
  ,simpleLowerCaseMapping:0x2F948
  ,simpleTitleCaseMapping:0x2F948
 },
 { code:0x2F949
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F949
  ,simpleLowerCaseMapping:0x2F949
  ,simpleTitleCaseMapping:0x2F949
 },
 { code:0x2F94A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F94A
  ,simpleLowerCaseMapping:0x2F94A
  ,simpleTitleCaseMapping:0x2F94A
 },
 { code:0x2F94B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F94B
  ,simpleLowerCaseMapping:0x2F94B
  ,simpleTitleCaseMapping:0x2F94B
 },
 { code:0x2F94C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F94C
  ,simpleLowerCaseMapping:0x2F94C
  ,simpleTitleCaseMapping:0x2F94C
 },
 { code:0x2F94D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F94D
  ,simpleLowerCaseMapping:0x2F94D
  ,simpleTitleCaseMapping:0x2F94D
 },
 { code:0x2F94E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F94E
  ,simpleLowerCaseMapping:0x2F94E
  ,simpleTitleCaseMapping:0x2F94E
 },
 { code:0x2F94F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F94F
  ,simpleLowerCaseMapping:0x2F94F
  ,simpleTitleCaseMapping:0x2F94F
 },
 { code:0x2F950
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F950
  ,simpleLowerCaseMapping:0x2F950
  ,simpleTitleCaseMapping:0x2F950
 },
 { code:0x2F951
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F951
  ,simpleLowerCaseMapping:0x2F951
  ,simpleTitleCaseMapping:0x2F951
 },
 { code:0x2F952
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F952
  ,simpleLowerCaseMapping:0x2F952
  ,simpleTitleCaseMapping:0x2F952
 },
 { code:0x2F953
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F953
  ,simpleLowerCaseMapping:0x2F953
  ,simpleTitleCaseMapping:0x2F953
 },
 { code:0x2F954
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F954
  ,simpleLowerCaseMapping:0x2F954
  ,simpleTitleCaseMapping:0x2F954
 },
 { code:0x2F955
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F955
  ,simpleLowerCaseMapping:0x2F955
  ,simpleTitleCaseMapping:0x2F955
 },
 { code:0x2F956
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F956
  ,simpleLowerCaseMapping:0x2F956
  ,simpleTitleCaseMapping:0x2F956
 },
 { code:0x2F957
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F957
  ,simpleLowerCaseMapping:0x2F957
  ,simpleTitleCaseMapping:0x2F957
 },
 { code:0x2F958
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F958
  ,simpleLowerCaseMapping:0x2F958
  ,simpleTitleCaseMapping:0x2F958
 },
 { code:0x2F959
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F959
  ,simpleLowerCaseMapping:0x2F959
  ,simpleTitleCaseMapping:0x2F959
 },
 { code:0x2F95A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F95A
  ,simpleLowerCaseMapping:0x2F95A
  ,simpleTitleCaseMapping:0x2F95A
 },
 { code:0x2F95B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F95B
  ,simpleLowerCaseMapping:0x2F95B
  ,simpleTitleCaseMapping:0x2F95B
 },
 { code:0x2F95C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F95C
  ,simpleLowerCaseMapping:0x2F95C
  ,simpleTitleCaseMapping:0x2F95C
 },
 { code:0x2F95D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F95D
  ,simpleLowerCaseMapping:0x2F95D
  ,simpleTitleCaseMapping:0x2F95D
 },
 { code:0x2F95E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F95E
  ,simpleLowerCaseMapping:0x2F95E
  ,simpleTitleCaseMapping:0x2F95E
 },
 { code:0x2F95F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F95F
  ,simpleLowerCaseMapping:0x2F95F
  ,simpleTitleCaseMapping:0x2F95F
 },
 { code:0x2F960
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F960
  ,simpleLowerCaseMapping:0x2F960
  ,simpleTitleCaseMapping:0x2F960
 },
 { code:0x2F961
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F961
  ,simpleLowerCaseMapping:0x2F961
  ,simpleTitleCaseMapping:0x2F961
 },
 { code:0x2F962
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F962
  ,simpleLowerCaseMapping:0x2F962
  ,simpleTitleCaseMapping:0x2F962
 },
 { code:0x2F963
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F963
  ,simpleLowerCaseMapping:0x2F963
  ,simpleTitleCaseMapping:0x2F963
 },
 { code:0x2F964
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F964
  ,simpleLowerCaseMapping:0x2F964
  ,simpleTitleCaseMapping:0x2F964
 },
 { code:0x2F965
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F965
  ,simpleLowerCaseMapping:0x2F965
  ,simpleTitleCaseMapping:0x2F965
 },
 { code:0x2F966
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F966
  ,simpleLowerCaseMapping:0x2F966
  ,simpleTitleCaseMapping:0x2F966
 },
 { code:0x2F967
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F967
  ,simpleLowerCaseMapping:0x2F967
  ,simpleTitleCaseMapping:0x2F967
 },
 { code:0x2F968
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F968
  ,simpleLowerCaseMapping:0x2F968
  ,simpleTitleCaseMapping:0x2F968
 },
 { code:0x2F969
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F969
  ,simpleLowerCaseMapping:0x2F969
  ,simpleTitleCaseMapping:0x2F969
 },
 { code:0x2F96A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F96A
  ,simpleLowerCaseMapping:0x2F96A
  ,simpleTitleCaseMapping:0x2F96A
 },
 { code:0x2F96B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F96B
  ,simpleLowerCaseMapping:0x2F96B
  ,simpleTitleCaseMapping:0x2F96B
 },
 { code:0x2F96C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F96C
  ,simpleLowerCaseMapping:0x2F96C
  ,simpleTitleCaseMapping:0x2F96C
 },
 { code:0x2F96D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F96D
  ,simpleLowerCaseMapping:0x2F96D
  ,simpleTitleCaseMapping:0x2F96D
 },
 { code:0x2F96E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F96E
  ,simpleLowerCaseMapping:0x2F96E
  ,simpleTitleCaseMapping:0x2F96E
 },
 { code:0x2F96F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F96F
  ,simpleLowerCaseMapping:0x2F96F
  ,simpleTitleCaseMapping:0x2F96F
 },
 { code:0x2F970
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F970
  ,simpleLowerCaseMapping:0x2F970
  ,simpleTitleCaseMapping:0x2F970
 },
 { code:0x2F971
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F971
  ,simpleLowerCaseMapping:0x2F971
  ,simpleTitleCaseMapping:0x2F971
 },
 { code:0x2F972
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F972
  ,simpleLowerCaseMapping:0x2F972
  ,simpleTitleCaseMapping:0x2F972
 },
 { code:0x2F973
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F973
  ,simpleLowerCaseMapping:0x2F973
  ,simpleTitleCaseMapping:0x2F973
 },
 { code:0x2F974
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F974
  ,simpleLowerCaseMapping:0x2F974
  ,simpleTitleCaseMapping:0x2F974
 },
 { code:0x2F975
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F975
  ,simpleLowerCaseMapping:0x2F975
  ,simpleTitleCaseMapping:0x2F975
 },
 { code:0x2F976
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F976
  ,simpleLowerCaseMapping:0x2F976
  ,simpleTitleCaseMapping:0x2F976
 },
 { code:0x2F977
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F977
  ,simpleLowerCaseMapping:0x2F977
  ,simpleTitleCaseMapping:0x2F977
 },
 { code:0x2F978
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F978
  ,simpleLowerCaseMapping:0x2F978
  ,simpleTitleCaseMapping:0x2F978
 },
 { code:0x2F979
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F979
  ,simpleLowerCaseMapping:0x2F979
  ,simpleTitleCaseMapping:0x2F979
 },
 { code:0x2F97A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F97A
  ,simpleLowerCaseMapping:0x2F97A
  ,simpleTitleCaseMapping:0x2F97A
 },
 { code:0x2F97B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F97B
  ,simpleLowerCaseMapping:0x2F97B
  ,simpleTitleCaseMapping:0x2F97B
 },
 { code:0x2F97C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F97C
  ,simpleLowerCaseMapping:0x2F97C
  ,simpleTitleCaseMapping:0x2F97C
 },
 { code:0x2F97D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F97D
  ,simpleLowerCaseMapping:0x2F97D
  ,simpleTitleCaseMapping:0x2F97D
 },
 { code:0x2F97E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F97E
  ,simpleLowerCaseMapping:0x2F97E
  ,simpleTitleCaseMapping:0x2F97E
 },
 { code:0x2F97F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F97F
  ,simpleLowerCaseMapping:0x2F97F
  ,simpleTitleCaseMapping:0x2F97F
 },
 { code:0x2F980
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F980
  ,simpleLowerCaseMapping:0x2F980
  ,simpleTitleCaseMapping:0x2F980
 },
 { code:0x2F981
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F981
  ,simpleLowerCaseMapping:0x2F981
  ,simpleTitleCaseMapping:0x2F981
 },
 { code:0x2F982
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F982
  ,simpleLowerCaseMapping:0x2F982
  ,simpleTitleCaseMapping:0x2F982
 },
 { code:0x2F983
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F983
  ,simpleLowerCaseMapping:0x2F983
  ,simpleTitleCaseMapping:0x2F983
 },
 { code:0x2F984
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F984
  ,simpleLowerCaseMapping:0x2F984
  ,simpleTitleCaseMapping:0x2F984
 },
 { code:0x2F985
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F985
  ,simpleLowerCaseMapping:0x2F985
  ,simpleTitleCaseMapping:0x2F985
 },
 { code:0x2F986
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F986
  ,simpleLowerCaseMapping:0x2F986
  ,simpleTitleCaseMapping:0x2F986
 },
 { code:0x2F987
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F987
  ,simpleLowerCaseMapping:0x2F987
  ,simpleTitleCaseMapping:0x2F987
 },
 { code:0x2F988
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F988
  ,simpleLowerCaseMapping:0x2F988
  ,simpleTitleCaseMapping:0x2F988
 },
 { code:0x2F989
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F989
  ,simpleLowerCaseMapping:0x2F989
  ,simpleTitleCaseMapping:0x2F989
 },
 { code:0x2F98A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F98A
  ,simpleLowerCaseMapping:0x2F98A
  ,simpleTitleCaseMapping:0x2F98A
 },
 { code:0x2F98B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F98B
  ,simpleLowerCaseMapping:0x2F98B
  ,simpleTitleCaseMapping:0x2F98B
 },
 { code:0x2F98C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F98C
  ,simpleLowerCaseMapping:0x2F98C
  ,simpleTitleCaseMapping:0x2F98C
 },
 { code:0x2F98D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F98D
  ,simpleLowerCaseMapping:0x2F98D
  ,simpleTitleCaseMapping:0x2F98D
 },
 { code:0x2F98E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F98E
  ,simpleLowerCaseMapping:0x2F98E
  ,simpleTitleCaseMapping:0x2F98E
 },
 { code:0x2F98F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F98F
  ,simpleLowerCaseMapping:0x2F98F
  ,simpleTitleCaseMapping:0x2F98F
 },
 { code:0x2F990
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F990
  ,simpleLowerCaseMapping:0x2F990
  ,simpleTitleCaseMapping:0x2F990
 },
 { code:0x2F991
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F991
  ,simpleLowerCaseMapping:0x2F991
  ,simpleTitleCaseMapping:0x2F991
 },
 { code:0x2F992
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F992
  ,simpleLowerCaseMapping:0x2F992
  ,simpleTitleCaseMapping:0x2F992
 },
 { code:0x2F993
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F993
  ,simpleLowerCaseMapping:0x2F993
  ,simpleTitleCaseMapping:0x2F993
 },
 { code:0x2F994
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F994
  ,simpleLowerCaseMapping:0x2F994
  ,simpleTitleCaseMapping:0x2F994
 },
 { code:0x2F995
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F995
  ,simpleLowerCaseMapping:0x2F995
  ,simpleTitleCaseMapping:0x2F995
 },
 { code:0x2F996
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F996
  ,simpleLowerCaseMapping:0x2F996
  ,simpleTitleCaseMapping:0x2F996
 },
 { code:0x2F997
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F997
  ,simpleLowerCaseMapping:0x2F997
  ,simpleTitleCaseMapping:0x2F997
 },
 { code:0x2F998
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F998
  ,simpleLowerCaseMapping:0x2F998
  ,simpleTitleCaseMapping:0x2F998
 },
 { code:0x2F999
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F999
  ,simpleLowerCaseMapping:0x2F999
  ,simpleTitleCaseMapping:0x2F999
 },
 { code:0x2F99A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F99A
  ,simpleLowerCaseMapping:0x2F99A
  ,simpleTitleCaseMapping:0x2F99A
 },
 { code:0x2F99B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F99B
  ,simpleLowerCaseMapping:0x2F99B
  ,simpleTitleCaseMapping:0x2F99B
 },
 { code:0x2F99C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F99C
  ,simpleLowerCaseMapping:0x2F99C
  ,simpleTitleCaseMapping:0x2F99C
 },
 { code:0x2F99D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F99D
  ,simpleLowerCaseMapping:0x2F99D
  ,simpleTitleCaseMapping:0x2F99D
 },
 { code:0x2F99E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F99E
  ,simpleLowerCaseMapping:0x2F99E
  ,simpleTitleCaseMapping:0x2F99E
 },
 { code:0x2F99F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F99F
  ,simpleLowerCaseMapping:0x2F99F
  ,simpleTitleCaseMapping:0x2F99F
 },
 { code:0x2F9A0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9A0
  ,simpleLowerCaseMapping:0x2F9A0
  ,simpleTitleCaseMapping:0x2F9A0
 },
 { code:0x2F9A1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9A1
  ,simpleLowerCaseMapping:0x2F9A1
  ,simpleTitleCaseMapping:0x2F9A1
 },
 { code:0x2F9A2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9A2
  ,simpleLowerCaseMapping:0x2F9A2
  ,simpleTitleCaseMapping:0x2F9A2
 },
 { code:0x2F9A3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9A3
  ,simpleLowerCaseMapping:0x2F9A3
  ,simpleTitleCaseMapping:0x2F9A3
 },
 { code:0x2F9A4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9A4
  ,simpleLowerCaseMapping:0x2F9A4
  ,simpleTitleCaseMapping:0x2F9A4
 },
 { code:0x2F9A5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9A5
  ,simpleLowerCaseMapping:0x2F9A5
  ,simpleTitleCaseMapping:0x2F9A5
 },
 { code:0x2F9A6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9A6
  ,simpleLowerCaseMapping:0x2F9A6
  ,simpleTitleCaseMapping:0x2F9A6
 },
 { code:0x2F9A7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9A7
  ,simpleLowerCaseMapping:0x2F9A7
  ,simpleTitleCaseMapping:0x2F9A7
 },
 { code:0x2F9A8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9A8
  ,simpleLowerCaseMapping:0x2F9A8
  ,simpleTitleCaseMapping:0x2F9A8
 },
 { code:0x2F9A9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9A9
  ,simpleLowerCaseMapping:0x2F9A9
  ,simpleTitleCaseMapping:0x2F9A9
 },
 { code:0x2F9AA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9AA
  ,simpleLowerCaseMapping:0x2F9AA
  ,simpleTitleCaseMapping:0x2F9AA
 },
 { code:0x2F9AB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9AB
  ,simpleLowerCaseMapping:0x2F9AB
  ,simpleTitleCaseMapping:0x2F9AB
 },
 { code:0x2F9AC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9AC
  ,simpleLowerCaseMapping:0x2F9AC
  ,simpleTitleCaseMapping:0x2F9AC
 },
 { code:0x2F9AD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9AD
  ,simpleLowerCaseMapping:0x2F9AD
  ,simpleTitleCaseMapping:0x2F9AD
 },
 { code:0x2F9AE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9AE
  ,simpleLowerCaseMapping:0x2F9AE
  ,simpleTitleCaseMapping:0x2F9AE
 },
 { code:0x2F9AF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9AF
  ,simpleLowerCaseMapping:0x2F9AF
  ,simpleTitleCaseMapping:0x2F9AF
 },
 { code:0x2F9B0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9B0
  ,simpleLowerCaseMapping:0x2F9B0
  ,simpleTitleCaseMapping:0x2F9B0
 },
 { code:0x2F9B1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9B1
  ,simpleLowerCaseMapping:0x2F9B1
  ,simpleTitleCaseMapping:0x2F9B1
 },
 { code:0x2F9B2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9B2
  ,simpleLowerCaseMapping:0x2F9B2
  ,simpleTitleCaseMapping:0x2F9B2
 },
 { code:0x2F9B3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9B3
  ,simpleLowerCaseMapping:0x2F9B3
  ,simpleTitleCaseMapping:0x2F9B3
 },
 { code:0x2F9B4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9B4
  ,simpleLowerCaseMapping:0x2F9B4
  ,simpleTitleCaseMapping:0x2F9B4
 },
 { code:0x2F9B5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9B5
  ,simpleLowerCaseMapping:0x2F9B5
  ,simpleTitleCaseMapping:0x2F9B5
 },
 { code:0x2F9B6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9B6
  ,simpleLowerCaseMapping:0x2F9B6
  ,simpleTitleCaseMapping:0x2F9B6
 },
 { code:0x2F9B7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9B7
  ,simpleLowerCaseMapping:0x2F9B7
  ,simpleTitleCaseMapping:0x2F9B7
 },
 { code:0x2F9B8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9B8
  ,simpleLowerCaseMapping:0x2F9B8
  ,simpleTitleCaseMapping:0x2F9B8
 },
 { code:0x2F9B9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9B9
  ,simpleLowerCaseMapping:0x2F9B9
  ,simpleTitleCaseMapping:0x2F9B9
 },
 { code:0x2F9BA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9BA
  ,simpleLowerCaseMapping:0x2F9BA
  ,simpleTitleCaseMapping:0x2F9BA
 },
 { code:0x2F9BB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9BB
  ,simpleLowerCaseMapping:0x2F9BB
  ,simpleTitleCaseMapping:0x2F9BB
 },
 { code:0x2F9BC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9BC
  ,simpleLowerCaseMapping:0x2F9BC
  ,simpleTitleCaseMapping:0x2F9BC
 },
 { code:0x2F9BD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9BD
  ,simpleLowerCaseMapping:0x2F9BD
  ,simpleTitleCaseMapping:0x2F9BD
 },
 { code:0x2F9BE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9BE
  ,simpleLowerCaseMapping:0x2F9BE
  ,simpleTitleCaseMapping:0x2F9BE
 },
 { code:0x2F9BF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9BF
  ,simpleLowerCaseMapping:0x2F9BF
  ,simpleTitleCaseMapping:0x2F9BF
 },
 { code:0x2F9C0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9C0
  ,simpleLowerCaseMapping:0x2F9C0
  ,simpleTitleCaseMapping:0x2F9C0
 },
 { code:0x2F9C1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9C1
  ,simpleLowerCaseMapping:0x2F9C1
  ,simpleTitleCaseMapping:0x2F9C1
 },
 { code:0x2F9C2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9C2
  ,simpleLowerCaseMapping:0x2F9C2
  ,simpleTitleCaseMapping:0x2F9C2
 },
 { code:0x2F9C3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9C3
  ,simpleLowerCaseMapping:0x2F9C3
  ,simpleTitleCaseMapping:0x2F9C3
 },
 { code:0x2F9C4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9C4
  ,simpleLowerCaseMapping:0x2F9C4
  ,simpleTitleCaseMapping:0x2F9C4
 },
 { code:0x2F9C5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9C5
  ,simpleLowerCaseMapping:0x2F9C5
  ,simpleTitleCaseMapping:0x2F9C5
 },
 { code:0x2F9C6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9C6
  ,simpleLowerCaseMapping:0x2F9C6
  ,simpleTitleCaseMapping:0x2F9C6
 },
 { code:0x2F9C7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9C7
  ,simpleLowerCaseMapping:0x2F9C7
  ,simpleTitleCaseMapping:0x2F9C7
 },
 { code:0x2F9C8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9C8
  ,simpleLowerCaseMapping:0x2F9C8
  ,simpleTitleCaseMapping:0x2F9C8
 },
 { code:0x2F9C9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9C9
  ,simpleLowerCaseMapping:0x2F9C9
  ,simpleTitleCaseMapping:0x2F9C9
 },
 { code:0x2F9CA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9CA
  ,simpleLowerCaseMapping:0x2F9CA
  ,simpleTitleCaseMapping:0x2F9CA
 },
 { code:0x2F9CB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9CB
  ,simpleLowerCaseMapping:0x2F9CB
  ,simpleTitleCaseMapping:0x2F9CB
 },
 { code:0x2F9CC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9CC
  ,simpleLowerCaseMapping:0x2F9CC
  ,simpleTitleCaseMapping:0x2F9CC
 },
 { code:0x2F9CD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9CD
  ,simpleLowerCaseMapping:0x2F9CD
  ,simpleTitleCaseMapping:0x2F9CD
 },
 { code:0x2F9CE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9CE
  ,simpleLowerCaseMapping:0x2F9CE
  ,simpleTitleCaseMapping:0x2F9CE
 },
 { code:0x2F9CF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9CF
  ,simpleLowerCaseMapping:0x2F9CF
  ,simpleTitleCaseMapping:0x2F9CF
 },
 { code:0x2F9D0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9D0
  ,simpleLowerCaseMapping:0x2F9D0
  ,simpleTitleCaseMapping:0x2F9D0
 },
 { code:0x2F9D1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9D1
  ,simpleLowerCaseMapping:0x2F9D1
  ,simpleTitleCaseMapping:0x2F9D1
 },
 { code:0x2F9D2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9D2
  ,simpleLowerCaseMapping:0x2F9D2
  ,simpleTitleCaseMapping:0x2F9D2
 },
 { code:0x2F9D3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9D3
  ,simpleLowerCaseMapping:0x2F9D3
  ,simpleTitleCaseMapping:0x2F9D3
 },
 { code:0x2F9D4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9D4
  ,simpleLowerCaseMapping:0x2F9D4
  ,simpleTitleCaseMapping:0x2F9D4
 },
 { code:0x2F9D5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9D5
  ,simpleLowerCaseMapping:0x2F9D5
  ,simpleTitleCaseMapping:0x2F9D5
 },
 { code:0x2F9D6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9D6
  ,simpleLowerCaseMapping:0x2F9D6
  ,simpleTitleCaseMapping:0x2F9D6
 },
 { code:0x2F9D7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9D7
  ,simpleLowerCaseMapping:0x2F9D7
  ,simpleTitleCaseMapping:0x2F9D7
 },
 { code:0x2F9D8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9D8
  ,simpleLowerCaseMapping:0x2F9D8
  ,simpleTitleCaseMapping:0x2F9D8
 },
 { code:0x2F9D9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9D9
  ,simpleLowerCaseMapping:0x2F9D9
  ,simpleTitleCaseMapping:0x2F9D9
 },
 { code:0x2F9DA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9DA
  ,simpleLowerCaseMapping:0x2F9DA
  ,simpleTitleCaseMapping:0x2F9DA
 },
 { code:0x2F9DB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9DB
  ,simpleLowerCaseMapping:0x2F9DB
  ,simpleTitleCaseMapping:0x2F9DB
 },
 { code:0x2F9DC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9DC
  ,simpleLowerCaseMapping:0x2F9DC
  ,simpleTitleCaseMapping:0x2F9DC
 },
 { code:0x2F9DD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9DD
  ,simpleLowerCaseMapping:0x2F9DD
  ,simpleTitleCaseMapping:0x2F9DD
 },
 { code:0x2F9DE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9DE
  ,simpleLowerCaseMapping:0x2F9DE
  ,simpleTitleCaseMapping:0x2F9DE
 },
 { code:0x2F9DF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9DF
  ,simpleLowerCaseMapping:0x2F9DF
  ,simpleTitleCaseMapping:0x2F9DF
 },
 { code:0x2F9E0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9E0
  ,simpleLowerCaseMapping:0x2F9E0
  ,simpleTitleCaseMapping:0x2F9E0
 },
 { code:0x2F9E1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9E1
  ,simpleLowerCaseMapping:0x2F9E1
  ,simpleTitleCaseMapping:0x2F9E1
 },
 { code:0x2F9E2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9E2
  ,simpleLowerCaseMapping:0x2F9E2
  ,simpleTitleCaseMapping:0x2F9E2
 },
 { code:0x2F9E3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9E3
  ,simpleLowerCaseMapping:0x2F9E3
  ,simpleTitleCaseMapping:0x2F9E3
 },
 { code:0x2F9E4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9E4
  ,simpleLowerCaseMapping:0x2F9E4
  ,simpleTitleCaseMapping:0x2F9E4
 },
 { code:0x2F9E5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9E5
  ,simpleLowerCaseMapping:0x2F9E5
  ,simpleTitleCaseMapping:0x2F9E5
 },
 { code:0x2F9E6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9E6
  ,simpleLowerCaseMapping:0x2F9E6
  ,simpleTitleCaseMapping:0x2F9E6
 },
 { code:0x2F9E7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9E7
  ,simpleLowerCaseMapping:0x2F9E7
  ,simpleTitleCaseMapping:0x2F9E7
 },
 { code:0x2F9E8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9E8
  ,simpleLowerCaseMapping:0x2F9E8
  ,simpleTitleCaseMapping:0x2F9E8
 },
 { code:0x2F9E9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9E9
  ,simpleLowerCaseMapping:0x2F9E9
  ,simpleTitleCaseMapping:0x2F9E9
 },
 { code:0x2F9EA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9EA
  ,simpleLowerCaseMapping:0x2F9EA
  ,simpleTitleCaseMapping:0x2F9EA
 },
 { code:0x2F9EB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9EB
  ,simpleLowerCaseMapping:0x2F9EB
  ,simpleTitleCaseMapping:0x2F9EB
 },
 { code:0x2F9EC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9EC
  ,simpleLowerCaseMapping:0x2F9EC
  ,simpleTitleCaseMapping:0x2F9EC
 },
 { code:0x2F9ED
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9ED
  ,simpleLowerCaseMapping:0x2F9ED
  ,simpleTitleCaseMapping:0x2F9ED
 },
 { code:0x2F9EE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9EE
  ,simpleLowerCaseMapping:0x2F9EE
  ,simpleTitleCaseMapping:0x2F9EE
 },
 { code:0x2F9EF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9EF
  ,simpleLowerCaseMapping:0x2F9EF
  ,simpleTitleCaseMapping:0x2F9EF
 },
 { code:0x2F9F0
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9F0
  ,simpleLowerCaseMapping:0x2F9F0
  ,simpleTitleCaseMapping:0x2F9F0
 },
 { code:0x2F9F1
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9F1
  ,simpleLowerCaseMapping:0x2F9F1
  ,simpleTitleCaseMapping:0x2F9F1
 },
 { code:0x2F9F2
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9F2
  ,simpleLowerCaseMapping:0x2F9F2
  ,simpleTitleCaseMapping:0x2F9F2
 },
 { code:0x2F9F3
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9F3
  ,simpleLowerCaseMapping:0x2F9F3
  ,simpleTitleCaseMapping:0x2F9F3
 },
 { code:0x2F9F4
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9F4
  ,simpleLowerCaseMapping:0x2F9F4
  ,simpleTitleCaseMapping:0x2F9F4
 },
 { code:0x2F9F5
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9F5
  ,simpleLowerCaseMapping:0x2F9F5
  ,simpleTitleCaseMapping:0x2F9F5
 },
 { code:0x2F9F6
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9F6
  ,simpleLowerCaseMapping:0x2F9F6
  ,simpleTitleCaseMapping:0x2F9F6
 },
 { code:0x2F9F7
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9F7
  ,simpleLowerCaseMapping:0x2F9F7
  ,simpleTitleCaseMapping:0x2F9F7
 },
 { code:0x2F9F8
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9F8
  ,simpleLowerCaseMapping:0x2F9F8
  ,simpleTitleCaseMapping:0x2F9F8
 },
 { code:0x2F9F9
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9F9
  ,simpleLowerCaseMapping:0x2F9F9
  ,simpleTitleCaseMapping:0x2F9F9
 },
 { code:0x2F9FA
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9FA
  ,simpleLowerCaseMapping:0x2F9FA
  ,simpleTitleCaseMapping:0x2F9FA
 },
 { code:0x2F9FB
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9FB
  ,simpleLowerCaseMapping:0x2F9FB
  ,simpleTitleCaseMapping:0x2F9FB
 },
 { code:0x2F9FC
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9FC
  ,simpleLowerCaseMapping:0x2F9FC
  ,simpleTitleCaseMapping:0x2F9FC
 },
 { code:0x2F9FD
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9FD
  ,simpleLowerCaseMapping:0x2F9FD
  ,simpleTitleCaseMapping:0x2F9FD
 },
 { code:0x2F9FE
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9FE
  ,simpleLowerCaseMapping:0x2F9FE
  ,simpleTitleCaseMapping:0x2F9FE
 },
 { code:0x2F9FF
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2F9FF
  ,simpleLowerCaseMapping:0x2F9FF
  ,simpleTitleCaseMapping:0x2F9FF
 },
 { code:0x2FA00
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA00
  ,simpleLowerCaseMapping:0x2FA00
  ,simpleTitleCaseMapping:0x2FA00
 },
 { code:0x2FA01
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA01
  ,simpleLowerCaseMapping:0x2FA01
  ,simpleTitleCaseMapping:0x2FA01
 },
 { code:0x2FA02
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA02
  ,simpleLowerCaseMapping:0x2FA02
  ,simpleTitleCaseMapping:0x2FA02
 },
 { code:0x2FA03
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA03
  ,simpleLowerCaseMapping:0x2FA03
  ,simpleTitleCaseMapping:0x2FA03
 },
 { code:0x2FA04
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA04
  ,simpleLowerCaseMapping:0x2FA04
  ,simpleTitleCaseMapping:0x2FA04
 },
 { code:0x2FA05
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA05
  ,simpleLowerCaseMapping:0x2FA05
  ,simpleTitleCaseMapping:0x2FA05
 },
 { code:0x2FA06
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA06
  ,simpleLowerCaseMapping:0x2FA06
  ,simpleTitleCaseMapping:0x2FA06
 },
 { code:0x2FA07
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA07
  ,simpleLowerCaseMapping:0x2FA07
  ,simpleTitleCaseMapping:0x2FA07
 },
 { code:0x2FA08
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA08
  ,simpleLowerCaseMapping:0x2FA08
  ,simpleTitleCaseMapping:0x2FA08
 },
 { code:0x2FA09
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA09
  ,simpleLowerCaseMapping:0x2FA09
  ,simpleTitleCaseMapping:0x2FA09
 },
 { code:0x2FA0A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA0A
  ,simpleLowerCaseMapping:0x2FA0A
  ,simpleTitleCaseMapping:0x2FA0A
 },
 { code:0x2FA0B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA0B
  ,simpleLowerCaseMapping:0x2FA0B
  ,simpleTitleCaseMapping:0x2FA0B
 },
 { code:0x2FA0C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA0C
  ,simpleLowerCaseMapping:0x2FA0C
  ,simpleTitleCaseMapping:0x2FA0C
 },
 { code:0x2FA0D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA0D
  ,simpleLowerCaseMapping:0x2FA0D
  ,simpleTitleCaseMapping:0x2FA0D
 },
 { code:0x2FA0E
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA0E
  ,simpleLowerCaseMapping:0x2FA0E
  ,simpleTitleCaseMapping:0x2FA0E
 },
 { code:0x2FA0F
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA0F
  ,simpleLowerCaseMapping:0x2FA0F
  ,simpleTitleCaseMapping:0x2FA0F
 },
 { code:0x2FA10
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA10
  ,simpleLowerCaseMapping:0x2FA10
  ,simpleTitleCaseMapping:0x2FA10
 },
 { code:0x2FA11
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA11
  ,simpleLowerCaseMapping:0x2FA11
  ,simpleTitleCaseMapping:0x2FA11
 },
 { code:0x2FA12
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA12
  ,simpleLowerCaseMapping:0x2FA12
  ,simpleTitleCaseMapping:0x2FA12
 },
 { code:0x2FA13
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA13
  ,simpleLowerCaseMapping:0x2FA13
  ,simpleTitleCaseMapping:0x2FA13
 },
 { code:0x2FA14
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA14
  ,simpleLowerCaseMapping:0x2FA14
  ,simpleTitleCaseMapping:0x2FA14
 },
 { code:0x2FA15
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA15
  ,simpleLowerCaseMapping:0x2FA15
  ,simpleTitleCaseMapping:0x2FA15
 },
 { code:0x2FA16
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA16
  ,simpleLowerCaseMapping:0x2FA16
  ,simpleTitleCaseMapping:0x2FA16
 },
 { code:0x2FA17
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA17
  ,simpleLowerCaseMapping:0x2FA17
  ,simpleTitleCaseMapping:0x2FA17
 },
 { code:0x2FA18
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA18
  ,simpleLowerCaseMapping:0x2FA18
  ,simpleTitleCaseMapping:0x2FA18
 },
 { code:0x2FA19
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA19
  ,simpleLowerCaseMapping:0x2FA19
  ,simpleTitleCaseMapping:0x2FA19
 },
 { code:0x2FA1A
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA1A
  ,simpleLowerCaseMapping:0x2FA1A
  ,simpleTitleCaseMapping:0x2FA1A
 },
 { code:0x2FA1B
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA1B
  ,simpleLowerCaseMapping:0x2FA1B
  ,simpleTitleCaseMapping:0x2FA1B
 },
 { code:0x2FA1C
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA1C
  ,simpleLowerCaseMapping:0x2FA1C
  ,simpleTitleCaseMapping:0x2FA1C
 },
 { code:0x2FA1D
  ,generalCategory:UnicodeData.GeneralCategory.Lo
  ,simpleUpperCaseMapping:0x2FA1D
  ,simpleLowerCaseMapping:0x2FA1D
  ,simpleTitleCaseMapping:0x2FA1D
 },
 { code:0xE0001
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0001
  ,simpleLowerCaseMapping:0xE0001
  ,simpleTitleCaseMapping:0xE0001
 },
 { code:0xE0020
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0020
  ,simpleLowerCaseMapping:0xE0020
  ,simpleTitleCaseMapping:0xE0020
 },
 { code:0xE0021
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0021
  ,simpleLowerCaseMapping:0xE0021
  ,simpleTitleCaseMapping:0xE0021
 },
 { code:0xE0022
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0022
  ,simpleLowerCaseMapping:0xE0022
  ,simpleTitleCaseMapping:0xE0022
 },
 { code:0xE0023
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0023
  ,simpleLowerCaseMapping:0xE0023
  ,simpleTitleCaseMapping:0xE0023
 },
 { code:0xE0024
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0024
  ,simpleLowerCaseMapping:0xE0024
  ,simpleTitleCaseMapping:0xE0024
 },
 { code:0xE0025
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0025
  ,simpleLowerCaseMapping:0xE0025
  ,simpleTitleCaseMapping:0xE0025
 },
 { code:0xE0026
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0026
  ,simpleLowerCaseMapping:0xE0026
  ,simpleTitleCaseMapping:0xE0026
 },
 { code:0xE0027
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0027
  ,simpleLowerCaseMapping:0xE0027
  ,simpleTitleCaseMapping:0xE0027
 },
 { code:0xE0028
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0028
  ,simpleLowerCaseMapping:0xE0028
  ,simpleTitleCaseMapping:0xE0028
 },
 { code:0xE0029
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0029
  ,simpleLowerCaseMapping:0xE0029
  ,simpleTitleCaseMapping:0xE0029
 },
 { code:0xE002A
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE002A
  ,simpleLowerCaseMapping:0xE002A
  ,simpleTitleCaseMapping:0xE002A
 },
 { code:0xE002B
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE002B
  ,simpleLowerCaseMapping:0xE002B
  ,simpleTitleCaseMapping:0xE002B
 },
 { code:0xE002C
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE002C
  ,simpleLowerCaseMapping:0xE002C
  ,simpleTitleCaseMapping:0xE002C
 },
 { code:0xE002D
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE002D
  ,simpleLowerCaseMapping:0xE002D
  ,simpleTitleCaseMapping:0xE002D
 },
 { code:0xE002E
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE002E
  ,simpleLowerCaseMapping:0xE002E
  ,simpleTitleCaseMapping:0xE002E
 },
 { code:0xE002F
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE002F
  ,simpleLowerCaseMapping:0xE002F
  ,simpleTitleCaseMapping:0xE002F
 },
 { code:0xE0030
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0030
  ,simpleLowerCaseMapping:0xE0030
  ,simpleTitleCaseMapping:0xE0030
 },
 { code:0xE0031
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0031
  ,simpleLowerCaseMapping:0xE0031
  ,simpleTitleCaseMapping:0xE0031
 },
 { code:0xE0032
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0032
  ,simpleLowerCaseMapping:0xE0032
  ,simpleTitleCaseMapping:0xE0032
 },
 { code:0xE0033
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0033
  ,simpleLowerCaseMapping:0xE0033
  ,simpleTitleCaseMapping:0xE0033
 },
 { code:0xE0034
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0034
  ,simpleLowerCaseMapping:0xE0034
  ,simpleTitleCaseMapping:0xE0034
 },
 { code:0xE0035
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0035
  ,simpleLowerCaseMapping:0xE0035
  ,simpleTitleCaseMapping:0xE0035
 },
 { code:0xE0036
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0036
  ,simpleLowerCaseMapping:0xE0036
  ,simpleTitleCaseMapping:0xE0036
 },
 { code:0xE0037
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0037
  ,simpleLowerCaseMapping:0xE0037
  ,simpleTitleCaseMapping:0xE0037
 },
 { code:0xE0038
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0038
  ,simpleLowerCaseMapping:0xE0038
  ,simpleTitleCaseMapping:0xE0038
 },
 { code:0xE0039
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0039
  ,simpleLowerCaseMapping:0xE0039
  ,simpleTitleCaseMapping:0xE0039
 },
 { code:0xE003A
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE003A
  ,simpleLowerCaseMapping:0xE003A
  ,simpleTitleCaseMapping:0xE003A
 },
 { code:0xE003B
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE003B
  ,simpleLowerCaseMapping:0xE003B
  ,simpleTitleCaseMapping:0xE003B
 },
 { code:0xE003C
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE003C
  ,simpleLowerCaseMapping:0xE003C
  ,simpleTitleCaseMapping:0xE003C
 },
 { code:0xE003D
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE003D
  ,simpleLowerCaseMapping:0xE003D
  ,simpleTitleCaseMapping:0xE003D
 },
 { code:0xE003E
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE003E
  ,simpleLowerCaseMapping:0xE003E
  ,simpleTitleCaseMapping:0xE003E
 },
 { code:0xE003F
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE003F
  ,simpleLowerCaseMapping:0xE003F
  ,simpleTitleCaseMapping:0xE003F
 },
 { code:0xE0040
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0040
  ,simpleLowerCaseMapping:0xE0040
  ,simpleTitleCaseMapping:0xE0040
 },
 { code:0xE0041
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0041
  ,simpleLowerCaseMapping:0xE0041
  ,simpleTitleCaseMapping:0xE0041
 },
 { code:0xE0042
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0042
  ,simpleLowerCaseMapping:0xE0042
  ,simpleTitleCaseMapping:0xE0042
 },
 { code:0xE0043
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0043
  ,simpleLowerCaseMapping:0xE0043
  ,simpleTitleCaseMapping:0xE0043
 },
 { code:0xE0044
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0044
  ,simpleLowerCaseMapping:0xE0044
  ,simpleTitleCaseMapping:0xE0044
 },
 { code:0xE0045
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0045
  ,simpleLowerCaseMapping:0xE0045
  ,simpleTitleCaseMapping:0xE0045
 },
 { code:0xE0046
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0046
  ,simpleLowerCaseMapping:0xE0046
  ,simpleTitleCaseMapping:0xE0046
 },
 { code:0xE0047
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0047
  ,simpleLowerCaseMapping:0xE0047
  ,simpleTitleCaseMapping:0xE0047
 },
 { code:0xE0048
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0048
  ,simpleLowerCaseMapping:0xE0048
  ,simpleTitleCaseMapping:0xE0048
 },
 { code:0xE0049
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0049
  ,simpleLowerCaseMapping:0xE0049
  ,simpleTitleCaseMapping:0xE0049
 },
 { code:0xE004A
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE004A
  ,simpleLowerCaseMapping:0xE004A
  ,simpleTitleCaseMapping:0xE004A
 },
 { code:0xE004B
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE004B
  ,simpleLowerCaseMapping:0xE004B
  ,simpleTitleCaseMapping:0xE004B
 },
 { code:0xE004C
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE004C
  ,simpleLowerCaseMapping:0xE004C
  ,simpleTitleCaseMapping:0xE004C
 },
 { code:0xE004D
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE004D
  ,simpleLowerCaseMapping:0xE004D
  ,simpleTitleCaseMapping:0xE004D
 },
 { code:0xE004E
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE004E
  ,simpleLowerCaseMapping:0xE004E
  ,simpleTitleCaseMapping:0xE004E
 },
 { code:0xE004F
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE004F
  ,simpleLowerCaseMapping:0xE004F
  ,simpleTitleCaseMapping:0xE004F
 },
 { code:0xE0050
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0050
  ,simpleLowerCaseMapping:0xE0050
  ,simpleTitleCaseMapping:0xE0050
 },
 { code:0xE0051
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0051
  ,simpleLowerCaseMapping:0xE0051
  ,simpleTitleCaseMapping:0xE0051
 },
 { code:0xE0052
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0052
  ,simpleLowerCaseMapping:0xE0052
  ,simpleTitleCaseMapping:0xE0052
 },
 { code:0xE0053
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0053
  ,simpleLowerCaseMapping:0xE0053
  ,simpleTitleCaseMapping:0xE0053
 },
 { code:0xE0054
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0054
  ,simpleLowerCaseMapping:0xE0054
  ,simpleTitleCaseMapping:0xE0054
 },
 { code:0xE0055
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0055
  ,simpleLowerCaseMapping:0xE0055
  ,simpleTitleCaseMapping:0xE0055
 },
 { code:0xE0056
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0056
  ,simpleLowerCaseMapping:0xE0056
  ,simpleTitleCaseMapping:0xE0056
 },
 { code:0xE0057
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0057
  ,simpleLowerCaseMapping:0xE0057
  ,simpleTitleCaseMapping:0xE0057
 },
 { code:0xE0058
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0058
  ,simpleLowerCaseMapping:0xE0058
  ,simpleTitleCaseMapping:0xE0058
 },
 { code:0xE0059
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0059
  ,simpleLowerCaseMapping:0xE0059
  ,simpleTitleCaseMapping:0xE0059
 },
 { code:0xE005A
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE005A
  ,simpleLowerCaseMapping:0xE005A
  ,simpleTitleCaseMapping:0xE005A
 },
 { code:0xE005B
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE005B
  ,simpleLowerCaseMapping:0xE005B
  ,simpleTitleCaseMapping:0xE005B
 },
 { code:0xE005C
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE005C
  ,simpleLowerCaseMapping:0xE005C
  ,simpleTitleCaseMapping:0xE005C
 },
 { code:0xE005D
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE005D
  ,simpleLowerCaseMapping:0xE005D
  ,simpleTitleCaseMapping:0xE005D
 },
 { code:0xE005E
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE005E
  ,simpleLowerCaseMapping:0xE005E
  ,simpleTitleCaseMapping:0xE005E
 },
 { code:0xE005F
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE005F
  ,simpleLowerCaseMapping:0xE005F
  ,simpleTitleCaseMapping:0xE005F
 },
 { code:0xE0060
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0060
  ,simpleLowerCaseMapping:0xE0060
  ,simpleTitleCaseMapping:0xE0060
 },
 { code:0xE0061
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0061
  ,simpleLowerCaseMapping:0xE0061
  ,simpleTitleCaseMapping:0xE0061
 },
 { code:0xE0062
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0062
  ,simpleLowerCaseMapping:0xE0062
  ,simpleTitleCaseMapping:0xE0062
 },
 { code:0xE0063
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0063
  ,simpleLowerCaseMapping:0xE0063
  ,simpleTitleCaseMapping:0xE0063
 },
 { code:0xE0064
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0064
  ,simpleLowerCaseMapping:0xE0064
  ,simpleTitleCaseMapping:0xE0064
 },
 { code:0xE0065
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0065
  ,simpleLowerCaseMapping:0xE0065
  ,simpleTitleCaseMapping:0xE0065
 },
 { code:0xE0066
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0066
  ,simpleLowerCaseMapping:0xE0066
  ,simpleTitleCaseMapping:0xE0066
 },
 { code:0xE0067
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0067
  ,simpleLowerCaseMapping:0xE0067
  ,simpleTitleCaseMapping:0xE0067
 },
 { code:0xE0068
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0068
  ,simpleLowerCaseMapping:0xE0068
  ,simpleTitleCaseMapping:0xE0068
 },
 { code:0xE0069
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0069
  ,simpleLowerCaseMapping:0xE0069
  ,simpleTitleCaseMapping:0xE0069
 },
 { code:0xE006A
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE006A
  ,simpleLowerCaseMapping:0xE006A
  ,simpleTitleCaseMapping:0xE006A
 },
 { code:0xE006B
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE006B
  ,simpleLowerCaseMapping:0xE006B
  ,simpleTitleCaseMapping:0xE006B
 },
 { code:0xE006C
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE006C
  ,simpleLowerCaseMapping:0xE006C
  ,simpleTitleCaseMapping:0xE006C
 },
 { code:0xE006D
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE006D
  ,simpleLowerCaseMapping:0xE006D
  ,simpleTitleCaseMapping:0xE006D
 },
 { code:0xE006E
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE006E
  ,simpleLowerCaseMapping:0xE006E
  ,simpleTitleCaseMapping:0xE006E
 },
 { code:0xE006F
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE006F
  ,simpleLowerCaseMapping:0xE006F
  ,simpleTitleCaseMapping:0xE006F
 },
 { code:0xE0070
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0070
  ,simpleLowerCaseMapping:0xE0070
  ,simpleTitleCaseMapping:0xE0070
 },
 { code:0xE0071
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0071
  ,simpleLowerCaseMapping:0xE0071
  ,simpleTitleCaseMapping:0xE0071
 },
 { code:0xE0072
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0072
  ,simpleLowerCaseMapping:0xE0072
  ,simpleTitleCaseMapping:0xE0072
 },
 { code:0xE0073
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0073
  ,simpleLowerCaseMapping:0xE0073
  ,simpleTitleCaseMapping:0xE0073
 },
 { code:0xE0074
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0074
  ,simpleLowerCaseMapping:0xE0074
  ,simpleTitleCaseMapping:0xE0074
 },
 { code:0xE0075
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0075
  ,simpleLowerCaseMapping:0xE0075
  ,simpleTitleCaseMapping:0xE0075
 },
 { code:0xE0076
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0076
  ,simpleLowerCaseMapping:0xE0076
  ,simpleTitleCaseMapping:0xE0076
 },
 { code:0xE0077
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0077
  ,simpleLowerCaseMapping:0xE0077
  ,simpleTitleCaseMapping:0xE0077
 },
 { code:0xE0078
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0078
  ,simpleLowerCaseMapping:0xE0078
  ,simpleTitleCaseMapping:0xE0078
 },
 { code:0xE0079
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE0079
  ,simpleLowerCaseMapping:0xE0079
  ,simpleTitleCaseMapping:0xE0079
 },
 { code:0xE007A
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE007A
  ,simpleLowerCaseMapping:0xE007A
  ,simpleTitleCaseMapping:0xE007A
 },
 { code:0xE007B
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE007B
  ,simpleLowerCaseMapping:0xE007B
  ,simpleTitleCaseMapping:0xE007B
 },
 { code:0xE007C
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE007C
  ,simpleLowerCaseMapping:0xE007C
  ,simpleTitleCaseMapping:0xE007C
 },
 { code:0xE007D
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE007D
  ,simpleLowerCaseMapping:0xE007D
  ,simpleTitleCaseMapping:0xE007D
 },
 { code:0xE007E
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE007E
  ,simpleLowerCaseMapping:0xE007E
  ,simpleTitleCaseMapping:0xE007E
 },
 { code:0xE007F
  ,generalCategory:UnicodeData.GeneralCategory.Cf
  ,simpleUpperCaseMapping:0xE007F
  ,simpleLowerCaseMapping:0xE007F
  ,simpleTitleCaseMapping:0xE007F
 },
 { code:0xE0100
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0100
  ,simpleLowerCaseMapping:0xE0100
  ,simpleTitleCaseMapping:0xE0100
 },
 { code:0xE0101
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0101
  ,simpleLowerCaseMapping:0xE0101
  ,simpleTitleCaseMapping:0xE0101
 },
 { code:0xE0102
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0102
  ,simpleLowerCaseMapping:0xE0102
  ,simpleTitleCaseMapping:0xE0102
 },
 { code:0xE0103
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0103
  ,simpleLowerCaseMapping:0xE0103
  ,simpleTitleCaseMapping:0xE0103
 },
 { code:0xE0104
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0104
  ,simpleLowerCaseMapping:0xE0104
  ,simpleTitleCaseMapping:0xE0104
 },
 { code:0xE0105
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0105
  ,simpleLowerCaseMapping:0xE0105
  ,simpleTitleCaseMapping:0xE0105
 },
 { code:0xE0106
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0106
  ,simpleLowerCaseMapping:0xE0106
  ,simpleTitleCaseMapping:0xE0106
 },
 { code:0xE0107
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0107
  ,simpleLowerCaseMapping:0xE0107
  ,simpleTitleCaseMapping:0xE0107
 },
 { code:0xE0108
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0108
  ,simpleLowerCaseMapping:0xE0108
  ,simpleTitleCaseMapping:0xE0108
 },
 { code:0xE0109
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0109
  ,simpleLowerCaseMapping:0xE0109
  ,simpleTitleCaseMapping:0xE0109
 },
 { code:0xE010A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE010A
  ,simpleLowerCaseMapping:0xE010A
  ,simpleTitleCaseMapping:0xE010A
 },
 { code:0xE010B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE010B
  ,simpleLowerCaseMapping:0xE010B
  ,simpleTitleCaseMapping:0xE010B
 },
 { code:0xE010C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE010C
  ,simpleLowerCaseMapping:0xE010C
  ,simpleTitleCaseMapping:0xE010C
 },
 { code:0xE010D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE010D
  ,simpleLowerCaseMapping:0xE010D
  ,simpleTitleCaseMapping:0xE010D
 },
 { code:0xE010E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE010E
  ,simpleLowerCaseMapping:0xE010E
  ,simpleTitleCaseMapping:0xE010E
 },
 { code:0xE010F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE010F
  ,simpleLowerCaseMapping:0xE010F
  ,simpleTitleCaseMapping:0xE010F
 },
 { code:0xE0110
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0110
  ,simpleLowerCaseMapping:0xE0110
  ,simpleTitleCaseMapping:0xE0110
 },
 { code:0xE0111
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0111
  ,simpleLowerCaseMapping:0xE0111
  ,simpleTitleCaseMapping:0xE0111
 },
 { code:0xE0112
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0112
  ,simpleLowerCaseMapping:0xE0112
  ,simpleTitleCaseMapping:0xE0112
 },
 { code:0xE0113
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0113
  ,simpleLowerCaseMapping:0xE0113
  ,simpleTitleCaseMapping:0xE0113
 },
 { code:0xE0114
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0114
  ,simpleLowerCaseMapping:0xE0114
  ,simpleTitleCaseMapping:0xE0114
 },
 { code:0xE0115
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0115
  ,simpleLowerCaseMapping:0xE0115
  ,simpleTitleCaseMapping:0xE0115
 },
 { code:0xE0116
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0116
  ,simpleLowerCaseMapping:0xE0116
  ,simpleTitleCaseMapping:0xE0116
 },
 { code:0xE0117
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0117
  ,simpleLowerCaseMapping:0xE0117
  ,simpleTitleCaseMapping:0xE0117
 },
 { code:0xE0118
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0118
  ,simpleLowerCaseMapping:0xE0118
  ,simpleTitleCaseMapping:0xE0118
 },
 { code:0xE0119
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0119
  ,simpleLowerCaseMapping:0xE0119
  ,simpleTitleCaseMapping:0xE0119
 },
 { code:0xE011A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE011A
  ,simpleLowerCaseMapping:0xE011A
  ,simpleTitleCaseMapping:0xE011A
 },
 { code:0xE011B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE011B
  ,simpleLowerCaseMapping:0xE011B
  ,simpleTitleCaseMapping:0xE011B
 },
 { code:0xE011C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE011C
  ,simpleLowerCaseMapping:0xE011C
  ,simpleTitleCaseMapping:0xE011C
 },
 { code:0xE011D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE011D
  ,simpleLowerCaseMapping:0xE011D
  ,simpleTitleCaseMapping:0xE011D
 },
 { code:0xE011E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE011E
  ,simpleLowerCaseMapping:0xE011E
  ,simpleTitleCaseMapping:0xE011E
 },
 { code:0xE011F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE011F
  ,simpleLowerCaseMapping:0xE011F
  ,simpleTitleCaseMapping:0xE011F
 },
 { code:0xE0120
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0120
  ,simpleLowerCaseMapping:0xE0120
  ,simpleTitleCaseMapping:0xE0120
 },
 { code:0xE0121
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0121
  ,simpleLowerCaseMapping:0xE0121
  ,simpleTitleCaseMapping:0xE0121
 },
 { code:0xE0122
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0122
  ,simpleLowerCaseMapping:0xE0122
  ,simpleTitleCaseMapping:0xE0122
 },
 { code:0xE0123
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0123
  ,simpleLowerCaseMapping:0xE0123
  ,simpleTitleCaseMapping:0xE0123
 },
 { code:0xE0124
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0124
  ,simpleLowerCaseMapping:0xE0124
  ,simpleTitleCaseMapping:0xE0124
 },
 { code:0xE0125
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0125
  ,simpleLowerCaseMapping:0xE0125
  ,simpleTitleCaseMapping:0xE0125
 },
 { code:0xE0126
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0126
  ,simpleLowerCaseMapping:0xE0126
  ,simpleTitleCaseMapping:0xE0126
 },
 { code:0xE0127
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0127
  ,simpleLowerCaseMapping:0xE0127
  ,simpleTitleCaseMapping:0xE0127
 },
 { code:0xE0128
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0128
  ,simpleLowerCaseMapping:0xE0128
  ,simpleTitleCaseMapping:0xE0128
 },
 { code:0xE0129
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0129
  ,simpleLowerCaseMapping:0xE0129
  ,simpleTitleCaseMapping:0xE0129
 },
 { code:0xE012A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE012A
  ,simpleLowerCaseMapping:0xE012A
  ,simpleTitleCaseMapping:0xE012A
 },
 { code:0xE012B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE012B
  ,simpleLowerCaseMapping:0xE012B
  ,simpleTitleCaseMapping:0xE012B
 },
 { code:0xE012C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE012C
  ,simpleLowerCaseMapping:0xE012C
  ,simpleTitleCaseMapping:0xE012C
 },
 { code:0xE012D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE012D
  ,simpleLowerCaseMapping:0xE012D
  ,simpleTitleCaseMapping:0xE012D
 },
 { code:0xE012E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE012E
  ,simpleLowerCaseMapping:0xE012E
  ,simpleTitleCaseMapping:0xE012E
 },
 { code:0xE012F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE012F
  ,simpleLowerCaseMapping:0xE012F
  ,simpleTitleCaseMapping:0xE012F
 },
 { code:0xE0130
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0130
  ,simpleLowerCaseMapping:0xE0130
  ,simpleTitleCaseMapping:0xE0130
 },
 { code:0xE0131
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0131
  ,simpleLowerCaseMapping:0xE0131
  ,simpleTitleCaseMapping:0xE0131
 },
 { code:0xE0132
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0132
  ,simpleLowerCaseMapping:0xE0132
  ,simpleTitleCaseMapping:0xE0132
 },
 { code:0xE0133
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0133
  ,simpleLowerCaseMapping:0xE0133
  ,simpleTitleCaseMapping:0xE0133
 },
 { code:0xE0134
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0134
  ,simpleLowerCaseMapping:0xE0134
  ,simpleTitleCaseMapping:0xE0134
 },
 { code:0xE0135
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0135
  ,simpleLowerCaseMapping:0xE0135
  ,simpleTitleCaseMapping:0xE0135
 },
 { code:0xE0136
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0136
  ,simpleLowerCaseMapping:0xE0136
  ,simpleTitleCaseMapping:0xE0136
 },
 { code:0xE0137
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0137
  ,simpleLowerCaseMapping:0xE0137
  ,simpleTitleCaseMapping:0xE0137
 },
 { code:0xE0138
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0138
  ,simpleLowerCaseMapping:0xE0138
  ,simpleTitleCaseMapping:0xE0138
 },
 { code:0xE0139
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0139
  ,simpleLowerCaseMapping:0xE0139
  ,simpleTitleCaseMapping:0xE0139
 },
 { code:0xE013A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE013A
  ,simpleLowerCaseMapping:0xE013A
  ,simpleTitleCaseMapping:0xE013A
 },
 { code:0xE013B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE013B
  ,simpleLowerCaseMapping:0xE013B
  ,simpleTitleCaseMapping:0xE013B
 },
 { code:0xE013C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE013C
  ,simpleLowerCaseMapping:0xE013C
  ,simpleTitleCaseMapping:0xE013C
 },
 { code:0xE013D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE013D
  ,simpleLowerCaseMapping:0xE013D
  ,simpleTitleCaseMapping:0xE013D
 },
 { code:0xE013E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE013E
  ,simpleLowerCaseMapping:0xE013E
  ,simpleTitleCaseMapping:0xE013E
 },
 { code:0xE013F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE013F
  ,simpleLowerCaseMapping:0xE013F
  ,simpleTitleCaseMapping:0xE013F
 },
 { code:0xE0140
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0140
  ,simpleLowerCaseMapping:0xE0140
  ,simpleTitleCaseMapping:0xE0140
 },
 { code:0xE0141
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0141
  ,simpleLowerCaseMapping:0xE0141
  ,simpleTitleCaseMapping:0xE0141
 },
 { code:0xE0142
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0142
  ,simpleLowerCaseMapping:0xE0142
  ,simpleTitleCaseMapping:0xE0142
 },
 { code:0xE0143
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0143
  ,simpleLowerCaseMapping:0xE0143
  ,simpleTitleCaseMapping:0xE0143
 },
 { code:0xE0144
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0144
  ,simpleLowerCaseMapping:0xE0144
  ,simpleTitleCaseMapping:0xE0144
 },
 { code:0xE0145
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0145
  ,simpleLowerCaseMapping:0xE0145
  ,simpleTitleCaseMapping:0xE0145
 },
 { code:0xE0146
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0146
  ,simpleLowerCaseMapping:0xE0146
  ,simpleTitleCaseMapping:0xE0146
 },
 { code:0xE0147
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0147
  ,simpleLowerCaseMapping:0xE0147
  ,simpleTitleCaseMapping:0xE0147
 },
 { code:0xE0148
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0148
  ,simpleLowerCaseMapping:0xE0148
  ,simpleTitleCaseMapping:0xE0148
 },
 { code:0xE0149
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0149
  ,simpleLowerCaseMapping:0xE0149
  ,simpleTitleCaseMapping:0xE0149
 },
 { code:0xE014A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE014A
  ,simpleLowerCaseMapping:0xE014A
  ,simpleTitleCaseMapping:0xE014A
 },
 { code:0xE014B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE014B
  ,simpleLowerCaseMapping:0xE014B
  ,simpleTitleCaseMapping:0xE014B
 },
 { code:0xE014C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE014C
  ,simpleLowerCaseMapping:0xE014C
  ,simpleTitleCaseMapping:0xE014C
 },
 { code:0xE014D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE014D
  ,simpleLowerCaseMapping:0xE014D
  ,simpleTitleCaseMapping:0xE014D
 },
 { code:0xE014E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE014E
  ,simpleLowerCaseMapping:0xE014E
  ,simpleTitleCaseMapping:0xE014E
 },
 { code:0xE014F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE014F
  ,simpleLowerCaseMapping:0xE014F
  ,simpleTitleCaseMapping:0xE014F
 },
 { code:0xE0150
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0150
  ,simpleLowerCaseMapping:0xE0150
  ,simpleTitleCaseMapping:0xE0150
 },
 { code:0xE0151
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0151
  ,simpleLowerCaseMapping:0xE0151
  ,simpleTitleCaseMapping:0xE0151
 },
 { code:0xE0152
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0152
  ,simpleLowerCaseMapping:0xE0152
  ,simpleTitleCaseMapping:0xE0152
 },
 { code:0xE0153
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0153
  ,simpleLowerCaseMapping:0xE0153
  ,simpleTitleCaseMapping:0xE0153
 },
 { code:0xE0154
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0154
  ,simpleLowerCaseMapping:0xE0154
  ,simpleTitleCaseMapping:0xE0154
 },
 { code:0xE0155
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0155
  ,simpleLowerCaseMapping:0xE0155
  ,simpleTitleCaseMapping:0xE0155
 },
 { code:0xE0156
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0156
  ,simpleLowerCaseMapping:0xE0156
  ,simpleTitleCaseMapping:0xE0156
 },
 { code:0xE0157
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0157
  ,simpleLowerCaseMapping:0xE0157
  ,simpleTitleCaseMapping:0xE0157
 },
 { code:0xE0158
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0158
  ,simpleLowerCaseMapping:0xE0158
  ,simpleTitleCaseMapping:0xE0158
 },
 { code:0xE0159
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0159
  ,simpleLowerCaseMapping:0xE0159
  ,simpleTitleCaseMapping:0xE0159
 },
 { code:0xE015A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE015A
  ,simpleLowerCaseMapping:0xE015A
  ,simpleTitleCaseMapping:0xE015A
 },
 { code:0xE015B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE015B
  ,simpleLowerCaseMapping:0xE015B
  ,simpleTitleCaseMapping:0xE015B
 },
 { code:0xE015C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE015C
  ,simpleLowerCaseMapping:0xE015C
  ,simpleTitleCaseMapping:0xE015C
 },
 { code:0xE015D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE015D
  ,simpleLowerCaseMapping:0xE015D
  ,simpleTitleCaseMapping:0xE015D
 },
 { code:0xE015E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE015E
  ,simpleLowerCaseMapping:0xE015E
  ,simpleTitleCaseMapping:0xE015E
 },
 { code:0xE015F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE015F
  ,simpleLowerCaseMapping:0xE015F
  ,simpleTitleCaseMapping:0xE015F
 },
 { code:0xE0160
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0160
  ,simpleLowerCaseMapping:0xE0160
  ,simpleTitleCaseMapping:0xE0160
 },
 { code:0xE0161
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0161
  ,simpleLowerCaseMapping:0xE0161
  ,simpleTitleCaseMapping:0xE0161
 },
 { code:0xE0162
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0162
  ,simpleLowerCaseMapping:0xE0162
  ,simpleTitleCaseMapping:0xE0162
 },
 { code:0xE0163
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0163
  ,simpleLowerCaseMapping:0xE0163
  ,simpleTitleCaseMapping:0xE0163
 },
 { code:0xE0164
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0164
  ,simpleLowerCaseMapping:0xE0164
  ,simpleTitleCaseMapping:0xE0164
 },
 { code:0xE0165
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0165
  ,simpleLowerCaseMapping:0xE0165
  ,simpleTitleCaseMapping:0xE0165
 },
 { code:0xE0166
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0166
  ,simpleLowerCaseMapping:0xE0166
  ,simpleTitleCaseMapping:0xE0166
 },
 { code:0xE0167
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0167
  ,simpleLowerCaseMapping:0xE0167
  ,simpleTitleCaseMapping:0xE0167
 },
 { code:0xE0168
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0168
  ,simpleLowerCaseMapping:0xE0168
  ,simpleTitleCaseMapping:0xE0168
 },
 { code:0xE0169
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0169
  ,simpleLowerCaseMapping:0xE0169
  ,simpleTitleCaseMapping:0xE0169
 },
 { code:0xE016A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE016A
  ,simpleLowerCaseMapping:0xE016A
  ,simpleTitleCaseMapping:0xE016A
 },
 { code:0xE016B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE016B
  ,simpleLowerCaseMapping:0xE016B
  ,simpleTitleCaseMapping:0xE016B
 },
 { code:0xE016C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE016C
  ,simpleLowerCaseMapping:0xE016C
  ,simpleTitleCaseMapping:0xE016C
 },
 { code:0xE016D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE016D
  ,simpleLowerCaseMapping:0xE016D
  ,simpleTitleCaseMapping:0xE016D
 },
 { code:0xE016E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE016E
  ,simpleLowerCaseMapping:0xE016E
  ,simpleTitleCaseMapping:0xE016E
 },
 { code:0xE016F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE016F
  ,simpleLowerCaseMapping:0xE016F
  ,simpleTitleCaseMapping:0xE016F
 },
 { code:0xE0170
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0170
  ,simpleLowerCaseMapping:0xE0170
  ,simpleTitleCaseMapping:0xE0170
 },
 { code:0xE0171
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0171
  ,simpleLowerCaseMapping:0xE0171
  ,simpleTitleCaseMapping:0xE0171
 },
 { code:0xE0172
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0172
  ,simpleLowerCaseMapping:0xE0172
  ,simpleTitleCaseMapping:0xE0172
 },
 { code:0xE0173
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0173
  ,simpleLowerCaseMapping:0xE0173
  ,simpleTitleCaseMapping:0xE0173
 },
 { code:0xE0174
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0174
  ,simpleLowerCaseMapping:0xE0174
  ,simpleTitleCaseMapping:0xE0174
 },
 { code:0xE0175
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0175
  ,simpleLowerCaseMapping:0xE0175
  ,simpleTitleCaseMapping:0xE0175
 },
 { code:0xE0176
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0176
  ,simpleLowerCaseMapping:0xE0176
  ,simpleTitleCaseMapping:0xE0176
 },
 { code:0xE0177
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0177
  ,simpleLowerCaseMapping:0xE0177
  ,simpleTitleCaseMapping:0xE0177
 },
 { code:0xE0178
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0178
  ,simpleLowerCaseMapping:0xE0178
  ,simpleTitleCaseMapping:0xE0178
 },
 { code:0xE0179
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0179
  ,simpleLowerCaseMapping:0xE0179
  ,simpleTitleCaseMapping:0xE0179
 },
 { code:0xE017A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE017A
  ,simpleLowerCaseMapping:0xE017A
  ,simpleTitleCaseMapping:0xE017A
 },
 { code:0xE017B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE017B
  ,simpleLowerCaseMapping:0xE017B
  ,simpleTitleCaseMapping:0xE017B
 },
 { code:0xE017C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE017C
  ,simpleLowerCaseMapping:0xE017C
  ,simpleTitleCaseMapping:0xE017C
 },
 { code:0xE017D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE017D
  ,simpleLowerCaseMapping:0xE017D
  ,simpleTitleCaseMapping:0xE017D
 },
 { code:0xE017E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE017E
  ,simpleLowerCaseMapping:0xE017E
  ,simpleTitleCaseMapping:0xE017E
 },
 { code:0xE017F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE017F
  ,simpleLowerCaseMapping:0xE017F
  ,simpleTitleCaseMapping:0xE017F
 },
 { code:0xE0180
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0180
  ,simpleLowerCaseMapping:0xE0180
  ,simpleTitleCaseMapping:0xE0180
 },
 { code:0xE0181
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0181
  ,simpleLowerCaseMapping:0xE0181
  ,simpleTitleCaseMapping:0xE0181
 },
 { code:0xE0182
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0182
  ,simpleLowerCaseMapping:0xE0182
  ,simpleTitleCaseMapping:0xE0182
 },
 { code:0xE0183
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0183
  ,simpleLowerCaseMapping:0xE0183
  ,simpleTitleCaseMapping:0xE0183
 },
 { code:0xE0184
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0184
  ,simpleLowerCaseMapping:0xE0184
  ,simpleTitleCaseMapping:0xE0184
 },
 { code:0xE0185
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0185
  ,simpleLowerCaseMapping:0xE0185
  ,simpleTitleCaseMapping:0xE0185
 },
 { code:0xE0186
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0186
  ,simpleLowerCaseMapping:0xE0186
  ,simpleTitleCaseMapping:0xE0186
 },
 { code:0xE0187
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0187
  ,simpleLowerCaseMapping:0xE0187
  ,simpleTitleCaseMapping:0xE0187
 },
 { code:0xE0188
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0188
  ,simpleLowerCaseMapping:0xE0188
  ,simpleTitleCaseMapping:0xE0188
 },
 { code:0xE0189
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0189
  ,simpleLowerCaseMapping:0xE0189
  ,simpleTitleCaseMapping:0xE0189
 },
 { code:0xE018A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE018A
  ,simpleLowerCaseMapping:0xE018A
  ,simpleTitleCaseMapping:0xE018A
 },
 { code:0xE018B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE018B
  ,simpleLowerCaseMapping:0xE018B
  ,simpleTitleCaseMapping:0xE018B
 },
 { code:0xE018C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE018C
  ,simpleLowerCaseMapping:0xE018C
  ,simpleTitleCaseMapping:0xE018C
 },
 { code:0xE018D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE018D
  ,simpleLowerCaseMapping:0xE018D
  ,simpleTitleCaseMapping:0xE018D
 },
 { code:0xE018E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE018E
  ,simpleLowerCaseMapping:0xE018E
  ,simpleTitleCaseMapping:0xE018E
 },
 { code:0xE018F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE018F
  ,simpleLowerCaseMapping:0xE018F
  ,simpleTitleCaseMapping:0xE018F
 },
 { code:0xE0190
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0190
  ,simpleLowerCaseMapping:0xE0190
  ,simpleTitleCaseMapping:0xE0190
 },
 { code:0xE0191
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0191
  ,simpleLowerCaseMapping:0xE0191
  ,simpleTitleCaseMapping:0xE0191
 },
 { code:0xE0192
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0192
  ,simpleLowerCaseMapping:0xE0192
  ,simpleTitleCaseMapping:0xE0192
 },
 { code:0xE0193
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0193
  ,simpleLowerCaseMapping:0xE0193
  ,simpleTitleCaseMapping:0xE0193
 },
 { code:0xE0194
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0194
  ,simpleLowerCaseMapping:0xE0194
  ,simpleTitleCaseMapping:0xE0194
 },
 { code:0xE0195
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0195
  ,simpleLowerCaseMapping:0xE0195
  ,simpleTitleCaseMapping:0xE0195
 },
 { code:0xE0196
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0196
  ,simpleLowerCaseMapping:0xE0196
  ,simpleTitleCaseMapping:0xE0196
 },
 { code:0xE0197
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0197
  ,simpleLowerCaseMapping:0xE0197
  ,simpleTitleCaseMapping:0xE0197
 },
 { code:0xE0198
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0198
  ,simpleLowerCaseMapping:0xE0198
  ,simpleTitleCaseMapping:0xE0198
 },
 { code:0xE0199
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE0199
  ,simpleLowerCaseMapping:0xE0199
  ,simpleTitleCaseMapping:0xE0199
 },
 { code:0xE019A
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE019A
  ,simpleLowerCaseMapping:0xE019A
  ,simpleTitleCaseMapping:0xE019A
 },
 { code:0xE019B
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE019B
  ,simpleLowerCaseMapping:0xE019B
  ,simpleTitleCaseMapping:0xE019B
 },
 { code:0xE019C
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE019C
  ,simpleLowerCaseMapping:0xE019C
  ,simpleTitleCaseMapping:0xE019C
 },
 { code:0xE019D
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE019D
  ,simpleLowerCaseMapping:0xE019D
  ,simpleTitleCaseMapping:0xE019D
 },
 { code:0xE019E
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE019E
  ,simpleLowerCaseMapping:0xE019E
  ,simpleTitleCaseMapping:0xE019E
 },
 { code:0xE019F
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE019F
  ,simpleLowerCaseMapping:0xE019F
  ,simpleTitleCaseMapping:0xE019F
 },
 { code:0xE01A0
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01A0
  ,simpleLowerCaseMapping:0xE01A0
  ,simpleTitleCaseMapping:0xE01A0
 },
 { code:0xE01A1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01A1
  ,simpleLowerCaseMapping:0xE01A1
  ,simpleTitleCaseMapping:0xE01A1
 },
 { code:0xE01A2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01A2
  ,simpleLowerCaseMapping:0xE01A2
  ,simpleTitleCaseMapping:0xE01A2
 },
 { code:0xE01A3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01A3
  ,simpleLowerCaseMapping:0xE01A3
  ,simpleTitleCaseMapping:0xE01A3
 },
 { code:0xE01A4
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01A4
  ,simpleLowerCaseMapping:0xE01A4
  ,simpleTitleCaseMapping:0xE01A4
 },
 { code:0xE01A5
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01A5
  ,simpleLowerCaseMapping:0xE01A5
  ,simpleTitleCaseMapping:0xE01A5
 },
 { code:0xE01A6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01A6
  ,simpleLowerCaseMapping:0xE01A6
  ,simpleTitleCaseMapping:0xE01A6
 },
 { code:0xE01A7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01A7
  ,simpleLowerCaseMapping:0xE01A7
  ,simpleTitleCaseMapping:0xE01A7
 },
 { code:0xE01A8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01A8
  ,simpleLowerCaseMapping:0xE01A8
  ,simpleTitleCaseMapping:0xE01A8
 },
 { code:0xE01A9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01A9
  ,simpleLowerCaseMapping:0xE01A9
  ,simpleTitleCaseMapping:0xE01A9
 },
 { code:0xE01AA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01AA
  ,simpleLowerCaseMapping:0xE01AA
  ,simpleTitleCaseMapping:0xE01AA
 },
 { code:0xE01AB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01AB
  ,simpleLowerCaseMapping:0xE01AB
  ,simpleTitleCaseMapping:0xE01AB
 },
 { code:0xE01AC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01AC
  ,simpleLowerCaseMapping:0xE01AC
  ,simpleTitleCaseMapping:0xE01AC
 },
 { code:0xE01AD
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01AD
  ,simpleLowerCaseMapping:0xE01AD
  ,simpleTitleCaseMapping:0xE01AD
 },
 { code:0xE01AE
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01AE
  ,simpleLowerCaseMapping:0xE01AE
  ,simpleTitleCaseMapping:0xE01AE
 },
 { code:0xE01AF
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01AF
  ,simpleLowerCaseMapping:0xE01AF
  ,simpleTitleCaseMapping:0xE01AF
 },
 { code:0xE01B0
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01B0
  ,simpleLowerCaseMapping:0xE01B0
  ,simpleTitleCaseMapping:0xE01B0
 },
 { code:0xE01B1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01B1
  ,simpleLowerCaseMapping:0xE01B1
  ,simpleTitleCaseMapping:0xE01B1
 },
 { code:0xE01B2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01B2
  ,simpleLowerCaseMapping:0xE01B2
  ,simpleTitleCaseMapping:0xE01B2
 },
 { code:0xE01B3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01B3
  ,simpleLowerCaseMapping:0xE01B3
  ,simpleTitleCaseMapping:0xE01B3
 },
 { code:0xE01B4
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01B4
  ,simpleLowerCaseMapping:0xE01B4
  ,simpleTitleCaseMapping:0xE01B4
 },
 { code:0xE01B5
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01B5
  ,simpleLowerCaseMapping:0xE01B5
  ,simpleTitleCaseMapping:0xE01B5
 },
 { code:0xE01B6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01B6
  ,simpleLowerCaseMapping:0xE01B6
  ,simpleTitleCaseMapping:0xE01B6
 },
 { code:0xE01B7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01B7
  ,simpleLowerCaseMapping:0xE01B7
  ,simpleTitleCaseMapping:0xE01B7
 },
 { code:0xE01B8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01B8
  ,simpleLowerCaseMapping:0xE01B8
  ,simpleTitleCaseMapping:0xE01B8
 },
 { code:0xE01B9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01B9
  ,simpleLowerCaseMapping:0xE01B9
  ,simpleTitleCaseMapping:0xE01B9
 },
 { code:0xE01BA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01BA
  ,simpleLowerCaseMapping:0xE01BA
  ,simpleTitleCaseMapping:0xE01BA
 },
 { code:0xE01BB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01BB
  ,simpleLowerCaseMapping:0xE01BB
  ,simpleTitleCaseMapping:0xE01BB
 },
 { code:0xE01BC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01BC
  ,simpleLowerCaseMapping:0xE01BC
  ,simpleTitleCaseMapping:0xE01BC
 },
 { code:0xE01BD
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01BD
  ,simpleLowerCaseMapping:0xE01BD
  ,simpleTitleCaseMapping:0xE01BD
 },
 { code:0xE01BE
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01BE
  ,simpleLowerCaseMapping:0xE01BE
  ,simpleTitleCaseMapping:0xE01BE
 },
 { code:0xE01BF
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01BF
  ,simpleLowerCaseMapping:0xE01BF
  ,simpleTitleCaseMapping:0xE01BF
 },
 { code:0xE01C0
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01C0
  ,simpleLowerCaseMapping:0xE01C0
  ,simpleTitleCaseMapping:0xE01C0
 },
 { code:0xE01C1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01C1
  ,simpleLowerCaseMapping:0xE01C1
  ,simpleTitleCaseMapping:0xE01C1
 },
 { code:0xE01C2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01C2
  ,simpleLowerCaseMapping:0xE01C2
  ,simpleTitleCaseMapping:0xE01C2
 },
 { code:0xE01C3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01C3
  ,simpleLowerCaseMapping:0xE01C3
  ,simpleTitleCaseMapping:0xE01C3
 },
 { code:0xE01C4
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01C4
  ,simpleLowerCaseMapping:0xE01C4
  ,simpleTitleCaseMapping:0xE01C4
 },
 { code:0xE01C5
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01C5
  ,simpleLowerCaseMapping:0xE01C5
  ,simpleTitleCaseMapping:0xE01C5
 },
 { code:0xE01C6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01C6
  ,simpleLowerCaseMapping:0xE01C6
  ,simpleTitleCaseMapping:0xE01C6
 },
 { code:0xE01C7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01C7
  ,simpleLowerCaseMapping:0xE01C7
  ,simpleTitleCaseMapping:0xE01C7
 },
 { code:0xE01C8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01C8
  ,simpleLowerCaseMapping:0xE01C8
  ,simpleTitleCaseMapping:0xE01C8
 },
 { code:0xE01C9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01C9
  ,simpleLowerCaseMapping:0xE01C9
  ,simpleTitleCaseMapping:0xE01C9
 },
 { code:0xE01CA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01CA
  ,simpleLowerCaseMapping:0xE01CA
  ,simpleTitleCaseMapping:0xE01CA
 },
 { code:0xE01CB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01CB
  ,simpleLowerCaseMapping:0xE01CB
  ,simpleTitleCaseMapping:0xE01CB
 },
 { code:0xE01CC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01CC
  ,simpleLowerCaseMapping:0xE01CC
  ,simpleTitleCaseMapping:0xE01CC
 },
 { code:0xE01CD
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01CD
  ,simpleLowerCaseMapping:0xE01CD
  ,simpleTitleCaseMapping:0xE01CD
 },
 { code:0xE01CE
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01CE
  ,simpleLowerCaseMapping:0xE01CE
  ,simpleTitleCaseMapping:0xE01CE
 },
 { code:0xE01CF
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01CF
  ,simpleLowerCaseMapping:0xE01CF
  ,simpleTitleCaseMapping:0xE01CF
 },
 { code:0xE01D0
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01D0
  ,simpleLowerCaseMapping:0xE01D0
  ,simpleTitleCaseMapping:0xE01D0
 },
 { code:0xE01D1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01D1
  ,simpleLowerCaseMapping:0xE01D1
  ,simpleTitleCaseMapping:0xE01D1
 },
 { code:0xE01D2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01D2
  ,simpleLowerCaseMapping:0xE01D2
  ,simpleTitleCaseMapping:0xE01D2
 },
 { code:0xE01D3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01D3
  ,simpleLowerCaseMapping:0xE01D3
  ,simpleTitleCaseMapping:0xE01D3
 },
 { code:0xE01D4
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01D4
  ,simpleLowerCaseMapping:0xE01D4
  ,simpleTitleCaseMapping:0xE01D4
 },
 { code:0xE01D5
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01D5
  ,simpleLowerCaseMapping:0xE01D5
  ,simpleTitleCaseMapping:0xE01D5
 },
 { code:0xE01D6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01D6
  ,simpleLowerCaseMapping:0xE01D6
  ,simpleTitleCaseMapping:0xE01D6
 },
 { code:0xE01D7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01D7
  ,simpleLowerCaseMapping:0xE01D7
  ,simpleTitleCaseMapping:0xE01D7
 },
 { code:0xE01D8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01D8
  ,simpleLowerCaseMapping:0xE01D8
  ,simpleTitleCaseMapping:0xE01D8
 },
 { code:0xE01D9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01D9
  ,simpleLowerCaseMapping:0xE01D9
  ,simpleTitleCaseMapping:0xE01D9
 },
 { code:0xE01DA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01DA
  ,simpleLowerCaseMapping:0xE01DA
  ,simpleTitleCaseMapping:0xE01DA
 },
 { code:0xE01DB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01DB
  ,simpleLowerCaseMapping:0xE01DB
  ,simpleTitleCaseMapping:0xE01DB
 },
 { code:0xE01DC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01DC
  ,simpleLowerCaseMapping:0xE01DC
  ,simpleTitleCaseMapping:0xE01DC
 },
 { code:0xE01DD
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01DD
  ,simpleLowerCaseMapping:0xE01DD
  ,simpleTitleCaseMapping:0xE01DD
 },
 { code:0xE01DE
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01DE
  ,simpleLowerCaseMapping:0xE01DE
  ,simpleTitleCaseMapping:0xE01DE
 },
 { code:0xE01DF
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01DF
  ,simpleLowerCaseMapping:0xE01DF
  ,simpleTitleCaseMapping:0xE01DF
 },
 { code:0xE01E0
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01E0
  ,simpleLowerCaseMapping:0xE01E0
  ,simpleTitleCaseMapping:0xE01E0
 },
 { code:0xE01E1
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01E1
  ,simpleLowerCaseMapping:0xE01E1
  ,simpleTitleCaseMapping:0xE01E1
 },
 { code:0xE01E2
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01E2
  ,simpleLowerCaseMapping:0xE01E2
  ,simpleTitleCaseMapping:0xE01E2
 },
 { code:0xE01E3
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01E3
  ,simpleLowerCaseMapping:0xE01E3
  ,simpleTitleCaseMapping:0xE01E3
 },
 { code:0xE01E4
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01E4
  ,simpleLowerCaseMapping:0xE01E4
  ,simpleTitleCaseMapping:0xE01E4
 },
 { code:0xE01E5
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01E5
  ,simpleLowerCaseMapping:0xE01E5
  ,simpleTitleCaseMapping:0xE01E5
 },
 { code:0xE01E6
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01E6
  ,simpleLowerCaseMapping:0xE01E6
  ,simpleTitleCaseMapping:0xE01E6
 },
 { code:0xE01E7
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01E7
  ,simpleLowerCaseMapping:0xE01E7
  ,simpleTitleCaseMapping:0xE01E7
 },
 { code:0xE01E8
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01E8
  ,simpleLowerCaseMapping:0xE01E8
  ,simpleTitleCaseMapping:0xE01E8
 },
 { code:0xE01E9
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01E9
  ,simpleLowerCaseMapping:0xE01E9
  ,simpleTitleCaseMapping:0xE01E9
 },
 { code:0xE01EA
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01EA
  ,simpleLowerCaseMapping:0xE01EA
  ,simpleTitleCaseMapping:0xE01EA
 },
 { code:0xE01EB
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01EB
  ,simpleLowerCaseMapping:0xE01EB
  ,simpleTitleCaseMapping:0xE01EB
 },
 { code:0xE01EC
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01EC
  ,simpleLowerCaseMapping:0xE01EC
  ,simpleTitleCaseMapping:0xE01EC
 },
 { code:0xE01ED
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01ED
  ,simpleLowerCaseMapping:0xE01ED
  ,simpleTitleCaseMapping:0xE01ED
 },
 { code:0xE01EE
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01EE
  ,simpleLowerCaseMapping:0xE01EE
  ,simpleTitleCaseMapping:0xE01EE
 },
 { code:0xE01EF
  ,generalCategory:UnicodeData.GeneralCategory.Mn
  ,simpleUpperCaseMapping:0xE01EF
  ,simpleLowerCaseMapping:0xE01EF
  ,simpleTitleCaseMapping:0xE01EF
 },
 { code:0xF0000
  ,generalCategory:UnicodeData.GeneralCategory.Co
  ,simpleUpperCaseMapping:0xF0000
  ,simpleLowerCaseMapping:0xF0000
  ,simpleTitleCaseMapping:0xF0000
 },
 { code:0xFFFFD
  ,generalCategory:UnicodeData.GeneralCategory.Co
  ,simpleUpperCaseMapping:0xFFFFD
  ,simpleLowerCaseMapping:0xFFFFD
  ,simpleTitleCaseMapping:0xFFFFD
 },
 { code:0x100000
  ,generalCategory:UnicodeData.GeneralCategory.Co
  ,simpleUpperCaseMapping:0x100000
  ,simpleLowerCaseMapping:0x100000
  ,simpleTitleCaseMapping:0x100000
 },
 { code:0x10FFFD
  ,generalCategory:UnicodeData.GeneralCategory.Co
  ,simpleUpperCaseMapping:0x10FFFD
  ,simpleLowerCaseMapping:0x10FFFD
  ,simpleTitleCaseMapping:0x10FFFD
 },

];
    SpecialCaseData internalSpecialCaseData[] = [
 { code:0x00DF
  ,upperCaseMapping:[ 0x0053, 0x0053 ]
  ,lowerCaseMapping:[ 0x00DF ]
  ,titleCaseMapping:[ 0x0053, 0x0073 ]

 },
 { code:0x0130
  ,upperCaseMapping:[ 0x0130 ]
  ,lowerCaseMapping:[ 0x0069, 0x0307 ]
  ,titleCaseMapping:[ 0x0130 ]

 },
 { code:0x0149
  ,upperCaseMapping:[ 0x02BC, 0x004E ]
  ,lowerCaseMapping:[ 0x0149 ]
  ,titleCaseMapping:[ 0x02BC, 0x004E ]

 },
 { code:0x01F0
  ,upperCaseMapping:[ 0x004A, 0x030C ]
  ,lowerCaseMapping:[ 0x01F0 ]
  ,titleCaseMapping:[ 0x004A, 0x030C ]

 },
 { code:0x0390
  ,upperCaseMapping:[ 0x0399, 0x0308, 0x0301 ]
  ,lowerCaseMapping:[ 0x0390 ]
  ,titleCaseMapping:[ 0x0399, 0x0308, 0x0301 ]

 },
 { code:0x03B0
  ,upperCaseMapping:[ 0x03A5, 0x0308, 0x0301 ]
  ,lowerCaseMapping:[ 0x03B0 ]
  ,titleCaseMapping:[ 0x03A5, 0x0308, 0x0301 ]

 },
 { code:0x0587
  ,upperCaseMapping:[ 0x0535, 0x0552 ]
  ,lowerCaseMapping:[ 0x0587 ]
  ,titleCaseMapping:[ 0x0535, 0x0582 ]

 },
 { code:0x1E96
  ,upperCaseMapping:[ 0x0048, 0x0331 ]
  ,lowerCaseMapping:[ 0x1E96 ]
  ,titleCaseMapping:[ 0x0048, 0x0331 ]

 },
 { code:0x1E97
  ,upperCaseMapping:[ 0x0054, 0x0308 ]
  ,lowerCaseMapping:[ 0x1E97 ]
  ,titleCaseMapping:[ 0x0054, 0x0308 ]

 },
 { code:0x1E98
  ,upperCaseMapping:[ 0x0057, 0x030A ]
  ,lowerCaseMapping:[ 0x1E98 ]
  ,titleCaseMapping:[ 0x0057, 0x030A ]

 },
 { code:0x1E99
  ,upperCaseMapping:[ 0x0059, 0x030A ]
  ,lowerCaseMapping:[ 0x1E99 ]
  ,titleCaseMapping:[ 0x0059, 0x030A ]

 },
 { code:0x1E9A
  ,upperCaseMapping:[ 0x0041, 0x02BE ]
  ,lowerCaseMapping:[ 0x1E9A ]
  ,titleCaseMapping:[ 0x0041, 0x02BE ]

 },
 { code:0x1F50
  ,upperCaseMapping:[ 0x03A5, 0x0313 ]
  ,lowerCaseMapping:[ 0x1F50 ]
  ,titleCaseMapping:[ 0x03A5, 0x0313 ]

 },
 { code:0x1F52
  ,upperCaseMapping:[ 0x03A5, 0x0313, 0x0300 ]
  ,lowerCaseMapping:[ 0x1F52 ]
  ,titleCaseMapping:[ 0x03A5, 0x0313, 0x0300 ]

 },
 { code:0x1F54
  ,upperCaseMapping:[ 0x03A5, 0x0313, 0x0301 ]
  ,lowerCaseMapping:[ 0x1F54 ]
  ,titleCaseMapping:[ 0x03A5, 0x0313, 0x0301 ]

 },
 { code:0x1F56
  ,upperCaseMapping:[ 0x03A5, 0x0313, 0x0342 ]
  ,lowerCaseMapping:[ 0x1F56 ]
  ,titleCaseMapping:[ 0x03A5, 0x0313, 0x0342 ]

 },
 { code:0x1F80
  ,upperCaseMapping:[ 0x1F08, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F80 ]
  ,titleCaseMapping:[ 0x1F88 ]

 },
 { code:0x1F81
  ,upperCaseMapping:[ 0x1F09, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F81 ]
  ,titleCaseMapping:[ 0x1F89 ]

 },
 { code:0x1F82
  ,upperCaseMapping:[ 0x1F0A, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F82 ]
  ,titleCaseMapping:[ 0x1F8A ]

 },
 { code:0x1F83
  ,upperCaseMapping:[ 0x1F0B, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F83 ]
  ,titleCaseMapping:[ 0x1F8B ]

 },
 { code:0x1F84
  ,upperCaseMapping:[ 0x1F0C, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F84 ]
  ,titleCaseMapping:[ 0x1F8C ]

 },
 { code:0x1F85
  ,upperCaseMapping:[ 0x1F0D, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F85 ]
  ,titleCaseMapping:[ 0x1F8D ]

 },
 { code:0x1F86
  ,upperCaseMapping:[ 0x1F0E, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F86 ]
  ,titleCaseMapping:[ 0x1F8E ]

 },
 { code:0x1F87
  ,upperCaseMapping:[ 0x1F0F, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F87 ]
  ,titleCaseMapping:[ 0x1F8F ]

 },
 { code:0x1F88
  ,upperCaseMapping:[ 0x1F08, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F80 ]
  ,titleCaseMapping:[ 0x1F88 ]

 },
 { code:0x1F89
  ,upperCaseMapping:[ 0x1F09, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F81 ]
  ,titleCaseMapping:[ 0x1F89 ]

 },
 { code:0x1F8A
  ,upperCaseMapping:[ 0x1F0A, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F82 ]
  ,titleCaseMapping:[ 0x1F8A ]

 },
 { code:0x1F8B
  ,upperCaseMapping:[ 0x1F0B, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F83 ]
  ,titleCaseMapping:[ 0x1F8B ]

 },
 { code:0x1F8C
  ,upperCaseMapping:[ 0x1F0C, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F84 ]
  ,titleCaseMapping:[ 0x1F8C ]

 },
 { code:0x1F8D
  ,upperCaseMapping:[ 0x1F0D, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F85 ]
  ,titleCaseMapping:[ 0x1F8D ]

 },
 { code:0x1F8E
  ,upperCaseMapping:[ 0x1F0E, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F86 ]
  ,titleCaseMapping:[ 0x1F8E ]

 },
 { code:0x1F8F
  ,upperCaseMapping:[ 0x1F0F, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F87 ]
  ,titleCaseMapping:[ 0x1F8F ]

 },
 { code:0x1F90
  ,upperCaseMapping:[ 0x1F28, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F90 ]
  ,titleCaseMapping:[ 0x1F98 ]

 },
 { code:0x1F91
  ,upperCaseMapping:[ 0x1F29, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F91 ]
  ,titleCaseMapping:[ 0x1F99 ]

 },
 { code:0x1F92
  ,upperCaseMapping:[ 0x1F2A, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F92 ]
  ,titleCaseMapping:[ 0x1F9A ]

 },
 { code:0x1F93
  ,upperCaseMapping:[ 0x1F2B, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F93 ]
  ,titleCaseMapping:[ 0x1F9B ]

 },
 { code:0x1F94
  ,upperCaseMapping:[ 0x1F2C, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F94 ]
  ,titleCaseMapping:[ 0x1F9C ]

 },
 { code:0x1F95
  ,upperCaseMapping:[ 0x1F2D, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F95 ]
  ,titleCaseMapping:[ 0x1F9D ]

 },
 { code:0x1F96
  ,upperCaseMapping:[ 0x1F2E, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F96 ]
  ,titleCaseMapping:[ 0x1F9E ]

 },
 { code:0x1F97
  ,upperCaseMapping:[ 0x1F2F, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F97 ]
  ,titleCaseMapping:[ 0x1F9F ]

 },
 { code:0x1F98
  ,upperCaseMapping:[ 0x1F28, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F90 ]
  ,titleCaseMapping:[ 0x1F98 ]

 },
 { code:0x1F99
  ,upperCaseMapping:[ 0x1F29, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F91 ]
  ,titleCaseMapping:[ 0x1F99 ]

 },
 { code:0x1F9A
  ,upperCaseMapping:[ 0x1F2A, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F92 ]
  ,titleCaseMapping:[ 0x1F9A ]

 },
 { code:0x1F9B
  ,upperCaseMapping:[ 0x1F2B, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F93 ]
  ,titleCaseMapping:[ 0x1F9B ]

 },
 { code:0x1F9C
  ,upperCaseMapping:[ 0x1F2C, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F94 ]
  ,titleCaseMapping:[ 0x1F9C ]

 },
 { code:0x1F9D
  ,upperCaseMapping:[ 0x1F2D, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F95 ]
  ,titleCaseMapping:[ 0x1F9D ]

 },
 { code:0x1F9E
  ,upperCaseMapping:[ 0x1F2E, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F96 ]
  ,titleCaseMapping:[ 0x1F9E ]

 },
 { code:0x1F9F
  ,upperCaseMapping:[ 0x1F2F, 0x0399 ]
  ,lowerCaseMapping:[ 0x1F97 ]
  ,titleCaseMapping:[ 0x1F9F ]

 },
 { code:0x1FA0
  ,upperCaseMapping:[ 0x1F68, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FA0 ]
  ,titleCaseMapping:[ 0x1FA8 ]

 },
 { code:0x1FA1
  ,upperCaseMapping:[ 0x1F69, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FA1 ]
  ,titleCaseMapping:[ 0x1FA9 ]

 },
 { code:0x1FA2
  ,upperCaseMapping:[ 0x1F6A, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FA2 ]
  ,titleCaseMapping:[ 0x1FAA ]

 },
 { code:0x1FA3
  ,upperCaseMapping:[ 0x1F6B, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FA3 ]
  ,titleCaseMapping:[ 0x1FAB ]

 },
 { code:0x1FA4
  ,upperCaseMapping:[ 0x1F6C, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FA4 ]
  ,titleCaseMapping:[ 0x1FAC ]

 },
 { code:0x1FA5
  ,upperCaseMapping:[ 0x1F6D, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FA5 ]
  ,titleCaseMapping:[ 0x1FAD ]

 },
 { code:0x1FA6
  ,upperCaseMapping:[ 0x1F6E, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FA6 ]
  ,titleCaseMapping:[ 0x1FAE ]

 },
 { code:0x1FA7
  ,upperCaseMapping:[ 0x1F6F, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FA7 ]
  ,titleCaseMapping:[ 0x1FAF ]

 },
 { code:0x1FA8
  ,upperCaseMapping:[ 0x1F68, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FA0 ]
  ,titleCaseMapping:[ 0x1FA8 ]

 },
 { code:0x1FA9
  ,upperCaseMapping:[ 0x1F69, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FA1 ]
  ,titleCaseMapping:[ 0x1FA9 ]

 },
 { code:0x1FAA
  ,upperCaseMapping:[ 0x1F6A, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FA2 ]
  ,titleCaseMapping:[ 0x1FAA ]

 },
 { code:0x1FAB
  ,upperCaseMapping:[ 0x1F6B, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FA3 ]
  ,titleCaseMapping:[ 0x1FAB ]

 },
 { code:0x1FAC
  ,upperCaseMapping:[ 0x1F6C, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FA4 ]
  ,titleCaseMapping:[ 0x1FAC ]

 },
 { code:0x1FAD
  ,upperCaseMapping:[ 0x1F6D, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FA5 ]
  ,titleCaseMapping:[ 0x1FAD ]

 },
 { code:0x1FAE
  ,upperCaseMapping:[ 0x1F6E, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FA6 ]
  ,titleCaseMapping:[ 0x1FAE ]

 },
 { code:0x1FAF
  ,upperCaseMapping:[ 0x1F6F, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FA7 ]
  ,titleCaseMapping:[ 0x1FAF ]

 },
 { code:0x1FB2
  ,upperCaseMapping:[ 0x1FBA, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FB2 ]
  ,titleCaseMapping:[ 0x1FBA, 0x0345 ]

 },
 { code:0x1FB3
  ,upperCaseMapping:[ 0x0391, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FB3 ]
  ,titleCaseMapping:[ 0x1FBC ]

 },
 { code:0x1FB4
  ,upperCaseMapping:[ 0x0386, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FB4 ]
  ,titleCaseMapping:[ 0x0386, 0x0345 ]

 },
 { code:0x1FB6
  ,upperCaseMapping:[ 0x0391, 0x0342 ]
  ,lowerCaseMapping:[ 0x1FB6 ]
  ,titleCaseMapping:[ 0x0391, 0x0342 ]

 },
 { code:0x1FB7
  ,upperCaseMapping:[ 0x0391, 0x0342, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FB7 ]
  ,titleCaseMapping:[ 0x0391, 0x0342, 0x0345 ]

 },
 { code:0x1FBC
  ,upperCaseMapping:[ 0x0391, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FB3 ]
  ,titleCaseMapping:[ 0x1FBC ]

 },
 { code:0x1FC2
  ,upperCaseMapping:[ 0x1FCA, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FC2 ]
  ,titleCaseMapping:[ 0x1FCA, 0x0345 ]

 },
 { code:0x1FC3
  ,upperCaseMapping:[ 0x0397, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FC3 ]
  ,titleCaseMapping:[ 0x1FCC ]

 },
 { code:0x1FC4
  ,upperCaseMapping:[ 0x0389, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FC4 ]
  ,titleCaseMapping:[ 0x0389, 0x0345 ]

 },
 { code:0x1FC6
  ,upperCaseMapping:[ 0x0397, 0x0342 ]
  ,lowerCaseMapping:[ 0x1FC6 ]
  ,titleCaseMapping:[ 0x0397, 0x0342 ]

 },
 { code:0x1FC7
  ,upperCaseMapping:[ 0x0397, 0x0342, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FC7 ]
  ,titleCaseMapping:[ 0x0397, 0x0342, 0x0345 ]

 },
 { code:0x1FCC
  ,upperCaseMapping:[ 0x0397, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FC3 ]
  ,titleCaseMapping:[ 0x1FCC ]

 },
 { code:0x1FD2
  ,upperCaseMapping:[ 0x0399, 0x0308, 0x0300 ]
  ,lowerCaseMapping:[ 0x1FD2 ]
  ,titleCaseMapping:[ 0x0399, 0x0308, 0x0300 ]

 },
 { code:0x1FD3
  ,upperCaseMapping:[ 0x0399, 0x0308, 0x0301 ]
  ,lowerCaseMapping:[ 0x1FD3 ]
  ,titleCaseMapping:[ 0x0399, 0x0308, 0x0301 ]

 },
 { code:0x1FD6
  ,upperCaseMapping:[ 0x0399, 0x0342 ]
  ,lowerCaseMapping:[ 0x1FD6 ]
  ,titleCaseMapping:[ 0x0399, 0x0342 ]

 },
 { code:0x1FD7
  ,upperCaseMapping:[ 0x0399, 0x0308, 0x0342 ]
  ,lowerCaseMapping:[ 0x1FD7 ]
  ,titleCaseMapping:[ 0x0399, 0x0308, 0x0342 ]

 },
 { code:0x1FE2
  ,upperCaseMapping:[ 0x03A5, 0x0308, 0x0300 ]
  ,lowerCaseMapping:[ 0x1FE2 ]
  ,titleCaseMapping:[ 0x03A5, 0x0308, 0x0300 ]

 },
 { code:0x1FE3
  ,upperCaseMapping:[ 0x03A5, 0x0308, 0x0301 ]
  ,lowerCaseMapping:[ 0x1FE3 ]
  ,titleCaseMapping:[ 0x03A5, 0x0308, 0x0301 ]

 },
 { code:0x1FE4
  ,upperCaseMapping:[ 0x03A1, 0x0313 ]
  ,lowerCaseMapping:[ 0x1FE4 ]
  ,titleCaseMapping:[ 0x03A1, 0x0313 ]

 },
 { code:0x1FE6
  ,upperCaseMapping:[ 0x03A5, 0x0342 ]
  ,lowerCaseMapping:[ 0x1FE6 ]
  ,titleCaseMapping:[ 0x03A5, 0x0342 ]

 },
 { code:0x1FE7
  ,upperCaseMapping:[ 0x03A5, 0x0308, 0x0342 ]
  ,lowerCaseMapping:[ 0x1FE7 ]
  ,titleCaseMapping:[ 0x03A5, 0x0308, 0x0342 ]

 },
 { code:0x1FF2
  ,upperCaseMapping:[ 0x1FFA, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FF2 ]
  ,titleCaseMapping:[ 0x1FFA, 0x0345 ]

 },
 { code:0x1FF3
  ,upperCaseMapping:[ 0x03A9, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FF3 ]
  ,titleCaseMapping:[ 0x1FFC ]

 },
 { code:0x1FF4
  ,upperCaseMapping:[ 0x038F, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FF4 ]
  ,titleCaseMapping:[ 0x038F, 0x0345 ]

 },
 { code:0x1FF6
  ,upperCaseMapping:[ 0x03A9, 0x0342 ]
  ,lowerCaseMapping:[ 0x1FF6 ]
  ,titleCaseMapping:[ 0x03A9, 0x0342 ]

 },
 { code:0x1FF7
  ,upperCaseMapping:[ 0x03A9, 0x0342, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FF7 ]
  ,titleCaseMapping:[ 0x03A9, 0x0342, 0x0345 ]

 },
 { code:0x1FFC
  ,upperCaseMapping:[ 0x03A9, 0x0399 ]
  ,lowerCaseMapping:[ 0x1FF3 ]
  ,titleCaseMapping:[ 0x1FFC ]

 },
 { code:0xFB00
  ,upperCaseMapping:[ 0x0046, 0x0046 ]
  ,lowerCaseMapping:[ 0xFB00 ]
  ,titleCaseMapping:[ 0x0046, 0x0066 ]

 },
 { code:0xFB01
  ,upperCaseMapping:[ 0x0046, 0x0049 ]
  ,lowerCaseMapping:[ 0xFB01 ]
  ,titleCaseMapping:[ 0x0046, 0x0069 ]

 },
 { code:0xFB02
  ,upperCaseMapping:[ 0x0046, 0x004C ]
  ,lowerCaseMapping:[ 0xFB02 ]
  ,titleCaseMapping:[ 0x0046, 0x006C ]

 },
 { code:0xFB03
  ,upperCaseMapping:[ 0x0046, 0x0046, 0x0049 ]
  ,lowerCaseMapping:[ 0xFB03 ]
  ,titleCaseMapping:[ 0x0046, 0x0066, 0x0069 ]

 },
 { code:0xFB04
  ,upperCaseMapping:[ 0x0046, 0x0046, 0x004C ]
  ,lowerCaseMapping:[ 0xFB04 ]
  ,titleCaseMapping:[ 0x0046, 0x0066, 0x006C ]

 },
 { code:0xFB05
  ,upperCaseMapping:[ 0x0053, 0x0054 ]
  ,lowerCaseMapping:[ 0xFB05 ]
  ,titleCaseMapping:[ 0x0053, 0x0074 ]

 },
 { code:0xFB06
  ,upperCaseMapping:[ 0x0053, 0x0054 ]
  ,lowerCaseMapping:[ 0xFB06 ]
  ,titleCaseMapping:[ 0x0053, 0x0074 ]

 },
 { code:0xFB13
  ,upperCaseMapping:[ 0x0544, 0x0546 ]
  ,lowerCaseMapping:[ 0xFB13 ]
  ,titleCaseMapping:[ 0x0544, 0x0576 ]

 },
 { code:0xFB14
  ,upperCaseMapping:[ 0x0544, 0x0535 ]
  ,lowerCaseMapping:[ 0xFB14 ]
  ,titleCaseMapping:[ 0x0544, 0x0565 ]

 },
 { code:0xFB15
  ,upperCaseMapping:[ 0x0544, 0x053B ]
  ,lowerCaseMapping:[ 0xFB15 ]
  ,titleCaseMapping:[ 0x0544, 0x056B ]

 },
 { code:0xFB16
  ,upperCaseMapping:[ 0x054E, 0x0546 ]
  ,lowerCaseMapping:[ 0xFB16 ]
  ,titleCaseMapping:[ 0x054E, 0x0576 ]

 },
 { code:0xFB17
  ,upperCaseMapping:[ 0x0544, 0x053D ]
  ,lowerCaseMapping:[ 0xFB17 ]
  ,titleCaseMapping:[ 0x0544, 0x056D ]

 },

];
    FoldingCaseData internalFoldingCaseData[] = [
 {
   code:0x0041
  ,mapping: [ 0x0061 ]
 },
 {
   code:0x0042
  ,mapping: [ 0x0062 ]
 },
 {
   code:0x0043
  ,mapping: [ 0x0063 ]
 },
 {
   code:0x0044
  ,mapping: [ 0x0064 ]
 },
 {
   code:0x0045
  ,mapping: [ 0x0065 ]
 },
 {
   code:0x0046
  ,mapping: [ 0x0066 ]
 },
 {
   code:0x0047
  ,mapping: [ 0x0067 ]
 },
 {
   code:0x0048
  ,mapping: [ 0x0068 ]
 },
 {
   code:0x0049
  ,mapping: [ 0x0069 ]
 },
 {
   code:0x004A
  ,mapping: [ 0x006A ]
 },
 {
   code:0x004B
  ,mapping: [ 0x006B ]
 },
 {
   code:0x004C
  ,mapping: [ 0x006C ]
 },
 {
   code:0x004D
  ,mapping: [ 0x006D ]
 },
 {
   code:0x004E
  ,mapping: [ 0x006E ]
 },
 {
   code:0x004F
  ,mapping: [ 0x006F ]
 },
 {
   code:0x0050
  ,mapping: [ 0x0070 ]
 },
 {
   code:0x0051
  ,mapping: [ 0x0071 ]
 },
 {
   code:0x0052
  ,mapping: [ 0x0072 ]
 },
 {
   code:0x0053
  ,mapping: [ 0x0073 ]
 },
 {
   code:0x0054
  ,mapping: [ 0x0074 ]
 },
 {
   code:0x0055
  ,mapping: [ 0x0075 ]
 },
 {
   code:0x0056
  ,mapping: [ 0x0076 ]
 },
 {
   code:0x0057
  ,mapping: [ 0x0077 ]
 },
 {
   code:0x0058
  ,mapping: [ 0x0078 ]
 },
 {
   code:0x0059
  ,mapping: [ 0x0079 ]
 },
 {
   code:0x005A
  ,mapping: [ 0x007A ]
 },
 {
   code:0x00B5
  ,mapping: [ 0x03BC ]
 },
 {
   code:0x00C0
  ,mapping: [ 0x00E0 ]
 },
 {
   code:0x00C1
  ,mapping: [ 0x00E1 ]
 },
 {
   code:0x00C2
  ,mapping: [ 0x00E2 ]
 },
 {
   code:0x00C3
  ,mapping: [ 0x00E3 ]
 },
 {
   code:0x00C4
  ,mapping: [ 0x00E4 ]
 },
 {
   code:0x00C5
  ,mapping: [ 0x00E5 ]
 },
 {
   code:0x00C6
  ,mapping: [ 0x00E6 ]
 },
 {
   code:0x00C7
  ,mapping: [ 0x00E7 ]
 },
 {
   code:0x00C8
  ,mapping: [ 0x00E8 ]
 },
 {
   code:0x00C9
  ,mapping: [ 0x00E9 ]
 },
 {
   code:0x00CA
  ,mapping: [ 0x00EA ]
 },
 {
   code:0x00CB
  ,mapping: [ 0x00EB ]
 },
 {
   code:0x00CC
  ,mapping: [ 0x00EC ]
 },
 {
   code:0x00CD
  ,mapping: [ 0x00ED ]
 },
 {
   code:0x00CE
  ,mapping: [ 0x00EE ]
 },
 {
   code:0x00CF
  ,mapping: [ 0x00EF ]
 },
 {
   code:0x00D0
  ,mapping: [ 0x00F0 ]
 },
 {
   code:0x00D1
  ,mapping: [ 0x00F1 ]
 },
 {
   code:0x00D2
  ,mapping: [ 0x00F2 ]
 },
 {
   code:0x00D3
  ,mapping: [ 0x00F3 ]
 },
 {
   code:0x00D4
  ,mapping: [ 0x00F4 ]
 },
 {
   code:0x00D5
  ,mapping: [ 0x00F5 ]
 },
 {
   code:0x00D6
  ,mapping: [ 0x00F6 ]
 },
 {
   code:0x00D8
  ,mapping: [ 0x00F8 ]
 },
 {
   code:0x00D9
  ,mapping: [ 0x00F9 ]
 },
 {
   code:0x00DA
  ,mapping: [ 0x00FA ]
 },
 {
   code:0x00DB
  ,mapping: [ 0x00FB ]
 },
 {
   code:0x00DC
  ,mapping: [ 0x00FC ]
 },
 {
   code:0x00DD
  ,mapping: [ 0x00FD ]
 },
 {
   code:0x00DE
  ,mapping: [ 0x00FE ]
 },
 {
   code:0x00DF
  ,mapping: [ 0x0073, 0x0073 ]
 },
 {
   code:0x0100
  ,mapping: [ 0x0101 ]
 },
 {
   code:0x0102
  ,mapping: [ 0x0103 ]
 },
 {
   code:0x0104
  ,mapping: [ 0x0105 ]
 },
 {
   code:0x0106
  ,mapping: [ 0x0107 ]
 },
 {
   code:0x0108
  ,mapping: [ 0x0109 ]
 },
 {
   code:0x010A
  ,mapping: [ 0x010B ]
 },
 {
   code:0x010C
  ,mapping: [ 0x010D ]
 },
 {
   code:0x010E
  ,mapping: [ 0x010F ]
 },
 {
   code:0x0110
  ,mapping: [ 0x0111 ]
 },
 {
   code:0x0112
  ,mapping: [ 0x0113 ]
 },
 {
   code:0x0114
  ,mapping: [ 0x0115 ]
 },
 {
   code:0x0116
  ,mapping: [ 0x0117 ]
 },
 {
   code:0x0118
  ,mapping: [ 0x0119 ]
 },
 {
   code:0x011A
  ,mapping: [ 0x011B ]
 },
 {
   code:0x011C
  ,mapping: [ 0x011D ]
 },
 {
   code:0x011E
  ,mapping: [ 0x011F ]
 },
 {
   code:0x0120
  ,mapping: [ 0x0121 ]
 },
 {
   code:0x0122
  ,mapping: [ 0x0123 ]
 },
 {
   code:0x0124
  ,mapping: [ 0x0125 ]
 },
 {
   code:0x0126
  ,mapping: [ 0x0127 ]
 },
 {
   code:0x0128
  ,mapping: [ 0x0129 ]
 },
 {
   code:0x012A
  ,mapping: [ 0x012B ]
 },
 {
   code:0x012C
  ,mapping: [ 0x012D ]
 },
 {
   code:0x012E
  ,mapping: [ 0x012F ]
 },
 {
   code:0x0130
  ,mapping: [ 0x0069, 0x0307 ]
 },
 {
   code:0x0132
  ,mapping: [ 0x0133 ]
 },
 {
   code:0x0134
  ,mapping: [ 0x0135 ]
 },
 {
   code:0x0136
  ,mapping: [ 0x0137 ]
 },
 {
   code:0x0139
  ,mapping: [ 0x013A ]
 },
 {
   code:0x013B
  ,mapping: [ 0x013C ]
 },
 {
   code:0x013D
  ,mapping: [ 0x013E ]
 },
 {
   code:0x013F
  ,mapping: [ 0x0140 ]
 },
 {
   code:0x0141
  ,mapping: [ 0x0142 ]
 },
 {
   code:0x0143
  ,mapping: [ 0x0144 ]
 },
 {
   code:0x0145
  ,mapping: [ 0x0146 ]
 },
 {
   code:0x0147
  ,mapping: [ 0x0148 ]
 },
 {
   code:0x0149
  ,mapping: [ 0x02BC, 0x006E ]
 },
 {
   code:0x014A
  ,mapping: [ 0x014B ]
 },
 {
   code:0x014C
  ,mapping: [ 0x014D ]
 },
 {
   code:0x014E
  ,mapping: [ 0x014F ]
 },
 {
   code:0x0150
  ,mapping: [ 0x0151 ]
 },
 {
   code:0x0152
  ,mapping: [ 0x0153 ]
 },
 {
   code:0x0154
  ,mapping: [ 0x0155 ]
 },
 {
   code:0x0156
  ,mapping: [ 0x0157 ]
 },
 {
   code:0x0158
  ,mapping: [ 0x0159 ]
 },
 {
   code:0x015A
  ,mapping: [ 0x015B ]
 },
 {
   code:0x015C
  ,mapping: [ 0x015D ]
 },
 {
   code:0x015E
  ,mapping: [ 0x015F ]
 },
 {
   code:0x0160
  ,mapping: [ 0x0161 ]
 },
 {
   code:0x0162
  ,mapping: [ 0x0163 ]
 },
 {
   code:0x0164
  ,mapping: [ 0x0165 ]
 },
 {
   code:0x0166
  ,mapping: [ 0x0167 ]
 },
 {
   code:0x0168
  ,mapping: [ 0x0169 ]
 },
 {
   code:0x016A
  ,mapping: [ 0x016B ]
 },
 {
   code:0x016C
  ,mapping: [ 0x016D ]
 },
 {
   code:0x016E
  ,mapping: [ 0x016F ]
 },
 {
   code:0x0170
  ,mapping: [ 0x0171 ]
 },
 {
   code:0x0172
  ,mapping: [ 0x0173 ]
 },
 {
   code:0x0174
  ,mapping: [ 0x0175 ]
 },
 {
   code:0x0176
  ,mapping: [ 0x0177 ]
 },
 {
   code:0x0178
  ,mapping: [ 0x00FF ]
 },
 {
   code:0x0179
  ,mapping: [ 0x017A ]
 },
 {
   code:0x017B
  ,mapping: [ 0x017C ]
 },
 {
   code:0x017D
  ,mapping: [ 0x017E ]
 },
 {
   code:0x017F
  ,mapping: [ 0x0073 ]
 },
 {
   code:0x0181
  ,mapping: [ 0x0253 ]
 },
 {
   code:0x0182
  ,mapping: [ 0x0183 ]
 },
 {
   code:0x0184
  ,mapping: [ 0x0185 ]
 },
 {
   code:0x0186
  ,mapping: [ 0x0254 ]
 },
 {
   code:0x0187
  ,mapping: [ 0x0188 ]
 },
 {
   code:0x0189
  ,mapping: [ 0x0256 ]
 },
 {
   code:0x018A
  ,mapping: [ 0x0257 ]
 },
 {
   code:0x018B
  ,mapping: [ 0x018C ]
 },
 {
   code:0x018E
  ,mapping: [ 0x01DD ]
 },
 {
   code:0x018F
  ,mapping: [ 0x0259 ]
 },
 {
   code:0x0190
  ,mapping: [ 0x025B ]
 },
 {
   code:0x0191
  ,mapping: [ 0x0192 ]
 },
 {
   code:0x0193
  ,mapping: [ 0x0260 ]
 },
 {
   code:0x0194
  ,mapping: [ 0x0263 ]
 },
 {
   code:0x0196
  ,mapping: [ 0x0269 ]
 },
 {
   code:0x0197
  ,mapping: [ 0x0268 ]
 },
 {
   code:0x0198
  ,mapping: [ 0x0199 ]
 },
 {
   code:0x019C
  ,mapping: [ 0x026F ]
 },
 {
   code:0x019D
  ,mapping: [ 0x0272 ]
 },
 {
   code:0x019F
  ,mapping: [ 0x0275 ]
 },
 {
   code:0x01A0
  ,mapping: [ 0x01A1 ]
 },
 {
   code:0x01A2
  ,mapping: [ 0x01A3 ]
 },
 {
   code:0x01A4
  ,mapping: [ 0x01A5 ]
 },
 {
   code:0x01A6
  ,mapping: [ 0x0280 ]
 },
 {
   code:0x01A7
  ,mapping: [ 0x01A8 ]
 },
 {
   code:0x01A9
  ,mapping: [ 0x0283 ]
 },
 {
   code:0x01AC
  ,mapping: [ 0x01AD ]
 },
 {
   code:0x01AE
  ,mapping: [ 0x0288 ]
 },
 {
   code:0x01AF
  ,mapping: [ 0x01B0 ]
 },
 {
   code:0x01B1
  ,mapping: [ 0x028A ]
 },
 {
   code:0x01B2
  ,mapping: [ 0x028B ]
 },
 {
   code:0x01B3
  ,mapping: [ 0x01B4 ]
 },
 {
   code:0x01B5
  ,mapping: [ 0x01B6 ]
 },
 {
   code:0x01B7
  ,mapping: [ 0x0292 ]
 },
 {
   code:0x01B8
  ,mapping: [ 0x01B9 ]
 },
 {
   code:0x01BC
  ,mapping: [ 0x01BD ]
 },
 {
   code:0x01C4
  ,mapping: [ 0x01C6 ]
 },
 {
   code:0x01C5
  ,mapping: [ 0x01C6 ]
 },
 {
   code:0x01C7
  ,mapping: [ 0x01C9 ]
 },
 {
   code:0x01C8
  ,mapping: [ 0x01C9 ]
 },
 {
   code:0x01CA
  ,mapping: [ 0x01CC ]
 },
 {
   code:0x01CB
  ,mapping: [ 0x01CC ]
 },
 {
   code:0x01CD
  ,mapping: [ 0x01CE ]
 },
 {
   code:0x01CF
  ,mapping: [ 0x01D0 ]
 },
 {
   code:0x01D1
  ,mapping: [ 0x01D2 ]
 },
 {
   code:0x01D3
  ,mapping: [ 0x01D4 ]
 },
 {
   code:0x01D5
  ,mapping: [ 0x01D6 ]
 },
 {
   code:0x01D7
  ,mapping: [ 0x01D8 ]
 },
 {
   code:0x01D9
  ,mapping: [ 0x01DA ]
 },
 {
   code:0x01DB
  ,mapping: [ 0x01DC ]
 },
 {
   code:0x01DE
  ,mapping: [ 0x01DF ]
 },
 {
   code:0x01E0
  ,mapping: [ 0x01E1 ]
 },
 {
   code:0x01E2
  ,mapping: [ 0x01E3 ]
 },
 {
   code:0x01E4
  ,mapping: [ 0x01E5 ]
 },
 {
   code:0x01E6
  ,mapping: [ 0x01E7 ]
 },
 {
   code:0x01E8
  ,mapping: [ 0x01E9 ]
 },
 {
   code:0x01EA
  ,mapping: [ 0x01EB ]
 },
 {
   code:0x01EC
  ,mapping: [ 0x01ED ]
 },
 {
   code:0x01EE
  ,mapping: [ 0x01EF ]
 },
 {
   code:0x01F0
  ,mapping: [ 0x006A, 0x030C ]
 },
 {
   code:0x01F1
  ,mapping: [ 0x01F3 ]
 },
 {
   code:0x01F2
  ,mapping: [ 0x01F3 ]
 },
 {
   code:0x01F4
  ,mapping: [ 0x01F5 ]
 },
 {
   code:0x01F6
  ,mapping: [ 0x0195 ]
 },
 {
   code:0x01F7
  ,mapping: [ 0x01BF ]
 },
 {
   code:0x01F8
  ,mapping: [ 0x01F9 ]
 },
 {
   code:0x01FA
  ,mapping: [ 0x01FB ]
 },
 {
   code:0x01FC
  ,mapping: [ 0x01FD ]
 },
 {
   code:0x01FE
  ,mapping: [ 0x01FF ]
 },
 {
   code:0x0200
  ,mapping: [ 0x0201 ]
 },
 {
   code:0x0202
  ,mapping: [ 0x0203 ]
 },
 {
   code:0x0204
  ,mapping: [ 0x0205 ]
 },
 {
   code:0x0206
  ,mapping: [ 0x0207 ]
 },
 {
   code:0x0208
  ,mapping: [ 0x0209 ]
 },
 {
   code:0x020A
  ,mapping: [ 0x020B ]
 },
 {
   code:0x020C
  ,mapping: [ 0x020D ]
 },
 {
   code:0x020E
  ,mapping: [ 0x020F ]
 },
 {
   code:0x0210
  ,mapping: [ 0x0211 ]
 },
 {
   code:0x0212
  ,mapping: [ 0x0213 ]
 },
 {
   code:0x0214
  ,mapping: [ 0x0215 ]
 },
 {
   code:0x0216
  ,mapping: [ 0x0217 ]
 },
 {
   code:0x0218
  ,mapping: [ 0x0219 ]
 },
 {
   code:0x021A
  ,mapping: [ 0x021B ]
 },
 {
   code:0x021C
  ,mapping: [ 0x021D ]
 },
 {
   code:0x021E
  ,mapping: [ 0x021F ]
 },
 {
   code:0x0220
  ,mapping: [ 0x019E ]
 },
 {
   code:0x0222
  ,mapping: [ 0x0223 ]
 },
 {
   code:0x0224
  ,mapping: [ 0x0225 ]
 },
 {
   code:0x0226
  ,mapping: [ 0x0227 ]
 },
 {
   code:0x0228
  ,mapping: [ 0x0229 ]
 },
 {
   code:0x022A
  ,mapping: [ 0x022B ]
 },
 {
   code:0x022C
  ,mapping: [ 0x022D ]
 },
 {
   code:0x022E
  ,mapping: [ 0x022F ]
 },
 {
   code:0x0230
  ,mapping: [ 0x0231 ]
 },
 {
   code:0x0232
  ,mapping: [ 0x0233 ]
 },
 {
   code:0x023A
  ,mapping: [ 0x2C65 ]
 },
 {
   code:0x023B
  ,mapping: [ 0x023C ]
 },
 {
   code:0x023D
  ,mapping: [ 0x019A ]
 },
 {
   code:0x023E
  ,mapping: [ 0x2C66 ]
 },
 {
   code:0x0241
  ,mapping: [ 0x0242 ]
 },
 {
   code:0x0243
  ,mapping: [ 0x0180 ]
 },
 {
   code:0x0244
  ,mapping: [ 0x0289 ]
 },
 {
   code:0x0245
  ,mapping: [ 0x028C ]
 },
 {
   code:0x0246
  ,mapping: [ 0x0247 ]
 },
 {
   code:0x0248
  ,mapping: [ 0x0249 ]
 },
 {
   code:0x024A
  ,mapping: [ 0x024B ]
 },
 {
   code:0x024C
  ,mapping: [ 0x024D ]
 },
 {
   code:0x024E
  ,mapping: [ 0x024F ]
 },
 {
   code:0x0345
  ,mapping: [ 0x03B9 ]
 },
 {
   code:0x0386
  ,mapping: [ 0x03AC ]
 },
 {
   code:0x0388
  ,mapping: [ 0x03AD ]
 },
 {
   code:0x0389
  ,mapping: [ 0x03AE ]
 },
 {
   code:0x038A
  ,mapping: [ 0x03AF ]
 },
 {
   code:0x038C
  ,mapping: [ 0x03CC ]
 },
 {
   code:0x038E
  ,mapping: [ 0x03CD ]
 },
 {
   code:0x038F
  ,mapping: [ 0x03CE ]
 },
 {
   code:0x0390
  ,mapping: [ 0x03B9, 0x0308, 0x0301 ]
 },
 {
   code:0x0391
  ,mapping: [ 0x03B1 ]
 },
 {
   code:0x0392
  ,mapping: [ 0x03B2 ]
 },
 {
   code:0x0393
  ,mapping: [ 0x03B3 ]
 },
 {
   code:0x0394
  ,mapping: [ 0x03B4 ]
 },
 {
   code:0x0395
  ,mapping: [ 0x03B5 ]
 },
 {
   code:0x0396
  ,mapping: [ 0x03B6 ]
 },
 {
   code:0x0397
  ,mapping: [ 0x03B7 ]
 },
 {
   code:0x0398
  ,mapping: [ 0x03B8 ]
 },
 {
   code:0x0399
  ,mapping: [ 0x03B9 ]
 },
 {
   code:0x039A
  ,mapping: [ 0x03BA ]
 },
 {
   code:0x039B
  ,mapping: [ 0x03BB ]
 },
 {
   code:0x039C
  ,mapping: [ 0x03BC ]
 },
 {
   code:0x039D
  ,mapping: [ 0x03BD ]
 },
 {
   code:0x039E
  ,mapping: [ 0x03BE ]
 },
 {
   code:0x039F
  ,mapping: [ 0x03BF ]
 },
 {
   code:0x03A0
  ,mapping: [ 0x03C0 ]
 },
 {
   code:0x03A1
  ,mapping: [ 0x03C1 ]
 },
 {
   code:0x03A3
  ,mapping: [ 0x03C3 ]
 },
 {
   code:0x03A4
  ,mapping: [ 0x03C4 ]
 },
 {
   code:0x03A5
  ,mapping: [ 0x03C5 ]
 },
 {
   code:0x03A6
  ,mapping: [ 0x03C6 ]
 },
 {
   code:0x03A7
  ,mapping: [ 0x03C7 ]
 },
 {
   code:0x03A8
  ,mapping: [ 0x03C8 ]
 },
 {
   code:0x03A9
  ,mapping: [ 0x03C9 ]
 },
 {
   code:0x03AA
  ,mapping: [ 0x03CA ]
 },
 {
   code:0x03AB
  ,mapping: [ 0x03CB ]
 },
 {
   code:0x03B0
  ,mapping: [ 0x03C5, 0x0308, 0x0301 ]
 },
 {
   code:0x03C2
  ,mapping: [ 0x03C3 ]
 },
 {
   code:0x03D0
  ,mapping: [ 0x03B2 ]
 },
 {
   code:0x03D1
  ,mapping: [ 0x03B8 ]
 },
 {
   code:0x03D5
  ,mapping: [ 0x03C6 ]
 },
 {
   code:0x03D6
  ,mapping: [ 0x03C0 ]
 },
 {
   code:0x03D8
  ,mapping: [ 0x03D9 ]
 },
 {
   code:0x03DA
  ,mapping: [ 0x03DB ]
 },
 {
   code:0x03DC
  ,mapping: [ 0x03DD ]
 },
 {
   code:0x03DE
  ,mapping: [ 0x03DF ]
 },
 {
   code:0x03E0
  ,mapping: [ 0x03E1 ]
 },
 {
   code:0x03E2
  ,mapping: [ 0x03E3 ]
 },
 {
   code:0x03E4
  ,mapping: [ 0x03E5 ]
 },
 {
   code:0x03E6
  ,mapping: [ 0x03E7 ]
 },
 {
   code:0x03E8
  ,mapping: [ 0x03E9 ]
 },
 {
   code:0x03EA
  ,mapping: [ 0x03EB ]
 },
 {
   code:0x03EC
  ,mapping: [ 0x03ED ]
 },
 {
   code:0x03EE
  ,mapping: [ 0x03EF ]
 },
 {
   code:0x03F0
  ,mapping: [ 0x03BA ]
 },
 {
   code:0x03F1
  ,mapping: [ 0x03C1 ]
 },
 {
   code:0x03F4
  ,mapping: [ 0x03B8 ]
 },
 {
   code:0x03F5
  ,mapping: [ 0x03B5 ]
 },
 {
   code:0x03F7
  ,mapping: [ 0x03F8 ]
 },
 {
   code:0x03F9
  ,mapping: [ 0x03F2 ]
 },
 {
   code:0x03FA
  ,mapping: [ 0x03FB ]
 },
 {
   code:0x03FD
  ,mapping: [ 0x037B ]
 },
 {
   code:0x03FE
  ,mapping: [ 0x037C ]
 },
 {
   code:0x03FF
  ,mapping: [ 0x037D ]
 },
 {
   code:0x0400
  ,mapping: [ 0x0450 ]
 },
 {
   code:0x0401
  ,mapping: [ 0x0451 ]
 },
 {
   code:0x0402
  ,mapping: [ 0x0452 ]
 },
 {
   code:0x0403
  ,mapping: [ 0x0453 ]
 },
 {
   code:0x0404
  ,mapping: [ 0x0454 ]
 },
 {
   code:0x0405
  ,mapping: [ 0x0455 ]
 },
 {
   code:0x0406
  ,mapping: [ 0x0456 ]
 },
 {
   code:0x0407
  ,mapping: [ 0x0457 ]
 },
 {
   code:0x0408
  ,mapping: [ 0x0458 ]
 },
 {
   code:0x0409
  ,mapping: [ 0x0459 ]
 },
 {
   code:0x040A
  ,mapping: [ 0x045A ]
 },
 {
   code:0x040B
  ,mapping: [ 0x045B ]
 },
 {
   code:0x040C
  ,mapping: [ 0x045C ]
 },
 {
   code:0x040D
  ,mapping: [ 0x045D ]
 },
 {
   code:0x040E
  ,mapping: [ 0x045E ]
 },
 {
   code:0x040F
  ,mapping: [ 0x045F ]
 },
 {
   code:0x0410
  ,mapping: [ 0x0430 ]
 },
 {
   code:0x0411
  ,mapping: [ 0x0431 ]
 },
 {
   code:0x0412
  ,mapping: [ 0x0432 ]
 },
 {
   code:0x0413
  ,mapping: [ 0x0433 ]
 },
 {
   code:0x0414
  ,mapping: [ 0x0434 ]
 },
 {
   code:0x0415
  ,mapping: [ 0x0435 ]
 },
 {
   code:0x0416
  ,mapping: [ 0x0436 ]
 },
 {
   code:0x0417
  ,mapping: [ 0x0437 ]
 },
 {
   code:0x0418
  ,mapping: [ 0x0438 ]
 },
 {
   code:0x0419
  ,mapping: [ 0x0439 ]
 },
 {
   code:0x041A
  ,mapping: [ 0x043A ]
 },
 {
   code:0x041B
  ,mapping: [ 0x043B ]
 },
 {
   code:0x041C
  ,mapping: [ 0x043C ]
 },
 {
   code:0x041D
  ,mapping: [ 0x043D ]
 },
 {
   code:0x041E
  ,mapping: [ 0x043E ]
 },
 {
   code:0x041F
  ,mapping: [ 0x043F ]
 },
 {
   code:0x0420
  ,mapping: [ 0x0440 ]
 },
 {
   code:0x0421
  ,mapping: [ 0x0441 ]
 },
 {
   code:0x0422
  ,mapping: [ 0x0442 ]
 },
 {
   code:0x0423
  ,mapping: [ 0x0443 ]
 },
 {
   code:0x0424
  ,mapping: [ 0x0444 ]
 },
 {
   code:0x0425
  ,mapping: [ 0x0445 ]
 },
 {
   code:0x0426
  ,mapping: [ 0x0446 ]
 },
 {
   code:0x0427
  ,mapping: [ 0x0447 ]
 },
 {
   code:0x0428
  ,mapping: [ 0x0448 ]
 },
 {
   code:0x0429
  ,mapping: [ 0x0449 ]
 },
 {
   code:0x042A
  ,mapping: [ 0x044A ]
 },
 {
   code:0x042B
  ,mapping: [ 0x044B ]
 },
 {
   code:0x042C
  ,mapping: [ 0x044C ]
 },
 {
   code:0x042D
  ,mapping: [ 0x044D ]
 },
 {
   code:0x042E
  ,mapping: [ 0x044E ]
 },
 {
   code:0x042F
  ,mapping: [ 0x044F ]
 },
 {
   code:0x0460
  ,mapping: [ 0x0461 ]
 },
 {
   code:0x0462
  ,mapping: [ 0x0463 ]
 },
 {
   code:0x0464
  ,mapping: [ 0x0465 ]
 },
 {
   code:0x0466
  ,mapping: [ 0x0467 ]
 },
 {
   code:0x0468
  ,mapping: [ 0x0469 ]
 },
 {
   code:0x046A
  ,mapping: [ 0x046B ]
 },
 {
   code:0x046C
  ,mapping: [ 0x046D ]
 },
 {
   code:0x046E
  ,mapping: [ 0x046F ]
 },
 {
   code:0x0470
  ,mapping: [ 0x0471 ]
 },
 {
   code:0x0472
  ,mapping: [ 0x0473 ]
 },
 {
   code:0x0474
  ,mapping: [ 0x0475 ]
 },
 {
   code:0x0476
  ,mapping: [ 0x0477 ]
 },
 {
   code:0x0478
  ,mapping: [ 0x0479 ]
 },
 {
   code:0x047A
  ,mapping: [ 0x047B ]
 },
 {
   code:0x047C
  ,mapping: [ 0x047D ]
 },
 {
   code:0x047E
  ,mapping: [ 0x047F ]
 },
 {
   code:0x0480
  ,mapping: [ 0x0481 ]
 },
 {
   code:0x048A
  ,mapping: [ 0x048B ]
 },
 {
   code:0x048C
  ,mapping: [ 0x048D ]
 },
 {
   code:0x048E
  ,mapping: [ 0x048F ]
 },
 {
   code:0x0490
  ,mapping: [ 0x0491 ]
 },
 {
   code:0x0492
  ,mapping: [ 0x0493 ]
 },
 {
   code:0x0494
  ,mapping: [ 0x0495 ]
 },
 {
   code:0x0496
  ,mapping: [ 0x0497 ]
 },
 {
   code:0x0498
  ,mapping: [ 0x0499 ]
 },
 {
   code:0x049A
  ,mapping: [ 0x049B ]
 },
 {
   code:0x049C
  ,mapping: [ 0x049D ]
 },
 {
   code:0x049E
  ,mapping: [ 0x049F ]
 },
 {
   code:0x04A0
  ,mapping: [ 0x04A1 ]
 },
 {
   code:0x04A2
  ,mapping: [ 0x04A3 ]
 },
 {
   code:0x04A4
  ,mapping: [ 0x04A5 ]
 },
 {
   code:0x04A6
  ,mapping: [ 0x04A7 ]
 },
 {
   code:0x04A8
  ,mapping: [ 0x04A9 ]
 },
 {
   code:0x04AA
  ,mapping: [ 0x04AB ]
 },
 {
   code:0x04AC
  ,mapping: [ 0x04AD ]
 },
 {
   code:0x04AE
  ,mapping: [ 0x04AF ]
 },
 {
   code:0x04B0
  ,mapping: [ 0x04B1 ]
 },
 {
   code:0x04B2
  ,mapping: [ 0x04B3 ]
 },
 {
   code:0x04B4
  ,mapping: [ 0x04B5 ]
 },
 {
   code:0x04B6
  ,mapping: [ 0x04B7 ]
 },
 {
   code:0x04B8
  ,mapping: [ 0x04B9 ]
 },
 {
   code:0x04BA
  ,mapping: [ 0x04BB ]
 },
 {
   code:0x04BC
  ,mapping: [ 0x04BD ]
 },
 {
   code:0x04BE
  ,mapping: [ 0x04BF ]
 },
 {
   code:0x04C0
  ,mapping: [ 0x04CF ]
 },
 {
   code:0x04C1
  ,mapping: [ 0x04C2 ]
 },
 {
   code:0x04C3
  ,mapping: [ 0x04C4 ]
 },
 {
   code:0x04C5
  ,mapping: [ 0x04C6 ]
 },
 {
   code:0x04C7
  ,mapping: [ 0x04C8 ]
 },
 {
   code:0x04C9
  ,mapping: [ 0x04CA ]
 },
 {
   code:0x04CB
  ,mapping: [ 0x04CC ]
 },
 {
   code:0x04CD
  ,mapping: [ 0x04CE ]
 },
 {
   code:0x04D0
  ,mapping: [ 0x04D1 ]
 },
 {
   code:0x04D2
  ,mapping: [ 0x04D3 ]
 },
 {
   code:0x04D4
  ,mapping: [ 0x04D5 ]
 },
 {
   code:0x04D6
  ,mapping: [ 0x04D7 ]
 },
 {
   code:0x04D8
  ,mapping: [ 0x04D9 ]
 },
 {
   code:0x04DA
  ,mapping: [ 0x04DB ]
 },
 {
   code:0x04DC
  ,mapping: [ 0x04DD ]
 },
 {
   code:0x04DE
  ,mapping: [ 0x04DF ]
 },
 {
   code:0x04E0
  ,mapping: [ 0x04E1 ]
 },
 {
   code:0x04E2
  ,mapping: [ 0x04E3 ]
 },
 {
   code:0x04E4
  ,mapping: [ 0x04E5 ]
 },
 {
   code:0x04E6
  ,mapping: [ 0x04E7 ]
 },
 {
   code:0x04E8
  ,mapping: [ 0x04E9 ]
 },
 {
   code:0x04EA
  ,mapping: [ 0x04EB ]
 },
 {
   code:0x04EC
  ,mapping: [ 0x04ED ]
 },
 {
   code:0x04EE
  ,mapping: [ 0x04EF ]
 },
 {
   code:0x04F0
  ,mapping: [ 0x04F1 ]
 },
 {
   code:0x04F2
  ,mapping: [ 0x04F3 ]
 },
 {
   code:0x04F4
  ,mapping: [ 0x04F5 ]
 },
 {
   code:0x04F6
  ,mapping: [ 0x04F7 ]
 },
 {
   code:0x04F8
  ,mapping: [ 0x04F9 ]
 },
 {
   code:0x04FA
  ,mapping: [ 0x04FB ]
 },
 {
   code:0x04FC
  ,mapping: [ 0x04FD ]
 },
 {
   code:0x04FE
  ,mapping: [ 0x04FF ]
 },
 {
   code:0x0500
  ,mapping: [ 0x0501 ]
 },
 {
   code:0x0502
  ,mapping: [ 0x0503 ]
 },
 {
   code:0x0504
  ,mapping: [ 0x0505 ]
 },
 {
   code:0x0506
  ,mapping: [ 0x0507 ]
 },
 {
   code:0x0508
  ,mapping: [ 0x0509 ]
 },
 {
   code:0x050A
  ,mapping: [ 0x050B ]
 },
 {
   code:0x050C
  ,mapping: [ 0x050D ]
 },
 {
   code:0x050E
  ,mapping: [ 0x050F ]
 },
 {
   code:0x0510
  ,mapping: [ 0x0511 ]
 },
 {
   code:0x0512
  ,mapping: [ 0x0513 ]
 },
 {
   code:0x0531
  ,mapping: [ 0x0561 ]
 },
 {
   code:0x0532
  ,mapping: [ 0x0562 ]
 },
 {
   code:0x0533
  ,mapping: [ 0x0563 ]
 },
 {
   code:0x0534
  ,mapping: [ 0x0564 ]
 },
 {
   code:0x0535
  ,mapping: [ 0x0565 ]
 },
 {
   code:0x0536
  ,mapping: [ 0x0566 ]
 },
 {
   code:0x0537
  ,mapping: [ 0x0567 ]
 },
 {
   code:0x0538
  ,mapping: [ 0x0568 ]
 },
 {
   code:0x0539
  ,mapping: [ 0x0569 ]
 },
 {
   code:0x053A
  ,mapping: [ 0x056A ]
 },
 {
   code:0x053B
  ,mapping: [ 0x056B ]
 },
 {
   code:0x053C
  ,mapping: [ 0x056C ]
 },
 {
   code:0x053D
  ,mapping: [ 0x056D ]
 },
 {
   code:0x053E
  ,mapping: [ 0x056E ]
 },
 {
   code:0x053F
  ,mapping: [ 0x056F ]
 },
 {
   code:0x0540
  ,mapping: [ 0x0570 ]
 },
 {
   code:0x0541
  ,mapping: [ 0x0571 ]
 },
 {
   code:0x0542
  ,mapping: [ 0x0572 ]
 },
 {
   code:0x0543
  ,mapping: [ 0x0573 ]
 },
 {
   code:0x0544
  ,mapping: [ 0x0574 ]
 },
 {
   code:0x0545
  ,mapping: [ 0x0575 ]
 },
 {
   code:0x0546
  ,mapping: [ 0x0576 ]
 },
 {
   code:0x0547
  ,mapping: [ 0x0577 ]
 },
 {
   code:0x0548
  ,mapping: [ 0x0578 ]
 },
 {
   code:0x0549
  ,mapping: [ 0x0579 ]
 },
 {
   code:0x054A
  ,mapping: [ 0x057A ]
 },
 {
   code:0x054B
  ,mapping: [ 0x057B ]
 },
 {
   code:0x054C
  ,mapping: [ 0x057C ]
 },
 {
   code:0x054D
  ,mapping: [ 0x057D ]
 },
 {
   code:0x054E
  ,mapping: [ 0x057E ]
 },
 {
   code:0x054F
  ,mapping: [ 0x057F ]
 },
 {
   code:0x0550
  ,mapping: [ 0x0580 ]
 },
 {
   code:0x0551
  ,mapping: [ 0x0581 ]
 },
 {
   code:0x0552
  ,mapping: [ 0x0582 ]
 },
 {
   code:0x0553
  ,mapping: [ 0x0583 ]
 },
 {
   code:0x0554
  ,mapping: [ 0x0584 ]
 },
 {
   code:0x0555
  ,mapping: [ 0x0585 ]
 },
 {
   code:0x0556
  ,mapping: [ 0x0586 ]
 },
 {
   code:0x0587
  ,mapping: [ 0x0565, 0x0582 ]
 },
 {
   code:0x10A0
  ,mapping: [ 0x2D00 ]
 },
 {
   code:0x10A1
  ,mapping: [ 0x2D01 ]
 },
 {
   code:0x10A2
  ,mapping: [ 0x2D02 ]
 },
 {
   code:0x10A3
  ,mapping: [ 0x2D03 ]
 },
 {
   code:0x10A4
  ,mapping: [ 0x2D04 ]
 },
 {
   code:0x10A5
  ,mapping: [ 0x2D05 ]
 },
 {
   code:0x10A6
  ,mapping: [ 0x2D06 ]
 },
 {
   code:0x10A7
  ,mapping: [ 0x2D07 ]
 },
 {
   code:0x10A8
  ,mapping: [ 0x2D08 ]
 },
 {
   code:0x10A9
  ,mapping: [ 0x2D09 ]
 },
 {
   code:0x10AA
  ,mapping: [ 0x2D0A ]
 },
 {
   code:0x10AB
  ,mapping: [ 0x2D0B ]
 },
 {
   code:0x10AC
  ,mapping: [ 0x2D0C ]
 },
 {
   code:0x10AD
  ,mapping: [ 0x2D0D ]
 },
 {
   code:0x10AE
  ,mapping: [ 0x2D0E ]
 },
 {
   code:0x10AF
  ,mapping: [ 0x2D0F ]
 },
 {
   code:0x10B0
  ,mapping: [ 0x2D10 ]
 },
 {
   code:0x10B1
  ,mapping: [ 0x2D11 ]
 },
 {
   code:0x10B2
  ,mapping: [ 0x2D12 ]
 },
 {
   code:0x10B3
  ,mapping: [ 0x2D13 ]
 },
 {
   code:0x10B4
  ,mapping: [ 0x2D14 ]
 },
 {
   code:0x10B5
  ,mapping: [ 0x2D15 ]
 },
 {
   code:0x10B6
  ,mapping: [ 0x2D16 ]
 },
 {
   code:0x10B7
  ,mapping: [ 0x2D17 ]
 },
 {
   code:0x10B8
  ,mapping: [ 0x2D18 ]
 },
 {
   code:0x10B9
  ,mapping: [ 0x2D19 ]
 },
 {
   code:0x10BA
  ,mapping: [ 0x2D1A ]
 },
 {
   code:0x10BB
  ,mapping: [ 0x2D1B ]
 },
 {
   code:0x10BC
  ,mapping: [ 0x2D1C ]
 },
 {
   code:0x10BD
  ,mapping: [ 0x2D1D ]
 },
 {
   code:0x10BE
  ,mapping: [ 0x2D1E ]
 },
 {
   code:0x10BF
  ,mapping: [ 0x2D1F ]
 },
 {
   code:0x10C0
  ,mapping: [ 0x2D20 ]
 },
 {
   code:0x10C1
  ,mapping: [ 0x2D21 ]
 },
 {
   code:0x10C2
  ,mapping: [ 0x2D22 ]
 },
 {
   code:0x10C3
  ,mapping: [ 0x2D23 ]
 },
 {
   code:0x10C4
  ,mapping: [ 0x2D24 ]
 },
 {
   code:0x10C5
  ,mapping: [ 0x2D25 ]
 },
 {
   code:0x1E00
  ,mapping: [ 0x1E01 ]
 },
 {
   code:0x1E02
  ,mapping: [ 0x1E03 ]
 },
 {
   code:0x1E04
  ,mapping: [ 0x1E05 ]
 },
 {
   code:0x1E06
  ,mapping: [ 0x1E07 ]
 },
 {
   code:0x1E08
  ,mapping: [ 0x1E09 ]
 },
 {
   code:0x1E0A
  ,mapping: [ 0x1E0B ]
 },
 {
   code:0x1E0C
  ,mapping: [ 0x1E0D ]
 },
 {
   code:0x1E0E
  ,mapping: [ 0x1E0F ]
 },
 {
   code:0x1E10
  ,mapping: [ 0x1E11 ]
 },
 {
   code:0x1E12
  ,mapping: [ 0x1E13 ]
 },
 {
   code:0x1E14
  ,mapping: [ 0x1E15 ]
 },
 {
   code:0x1E16
  ,mapping: [ 0x1E17 ]
 },
 {
   code:0x1E18
  ,mapping: [ 0x1E19 ]
 },
 {
   code:0x1E1A
  ,mapping: [ 0x1E1B ]
 },
 {
   code:0x1E1C
  ,mapping: [ 0x1E1D ]
 },
 {
   code:0x1E1E
  ,mapping: [ 0x1E1F ]
 },
 {
   code:0x1E20
  ,mapping: [ 0x1E21 ]
 },
 {
   code:0x1E22
  ,mapping: [ 0x1E23 ]
 },
 {
   code:0x1E24
  ,mapping: [ 0x1E25 ]
 },
 {
   code:0x1E26
  ,mapping: [ 0x1E27 ]
 },
 {
   code:0x1E28
  ,mapping: [ 0x1E29 ]
 },
 {
   code:0x1E2A
  ,mapping: [ 0x1E2B ]
 },
 {
   code:0x1E2C
  ,mapping: [ 0x1E2D ]
 },
 {
   code:0x1E2E
  ,mapping: [ 0x1E2F ]
 },
 {
   code:0x1E30
  ,mapping: [ 0x1E31 ]
 },
 {
   code:0x1E32
  ,mapping: [ 0x1E33 ]
 },
 {
   code:0x1E34
  ,mapping: [ 0x1E35 ]
 },
 {
   code:0x1E36
  ,mapping: [ 0x1E37 ]
 },
 {
   code:0x1E38
  ,mapping: [ 0x1E39 ]
 },
 {
   code:0x1E3A
  ,mapping: [ 0x1E3B ]
 },
 {
   code:0x1E3C
  ,mapping: [ 0x1E3D ]
 },
 {
   code:0x1E3E
  ,mapping: [ 0x1E3F ]
 },
 {
   code:0x1E40
  ,mapping: [ 0x1E41 ]
 },
 {
   code:0x1E42
  ,mapping: [ 0x1E43 ]
 },
 {
   code:0x1E44
  ,mapping: [ 0x1E45 ]
 },
 {
   code:0x1E46
  ,mapping: [ 0x1E47 ]
 },
 {
   code:0x1E48
  ,mapping: [ 0x1E49 ]
 },
 {
   code:0x1E4A
  ,mapping: [ 0x1E4B ]
 },
 {
   code:0x1E4C
  ,mapping: [ 0x1E4D ]
 },
 {
   code:0x1E4E
  ,mapping: [ 0x1E4F ]
 },
 {
   code:0x1E50
  ,mapping: [ 0x1E51 ]
 },
 {
   code:0x1E52
  ,mapping: [ 0x1E53 ]
 },
 {
   code:0x1E54
  ,mapping: [ 0x1E55 ]
 },
 {
   code:0x1E56
  ,mapping: [ 0x1E57 ]
 },
 {
   code:0x1E58
  ,mapping: [ 0x1E59 ]
 },
 {
   code:0x1E5A
  ,mapping: [ 0x1E5B ]
 },
 {
   code:0x1E5C
  ,mapping: [ 0x1E5D ]
 },
 {
   code:0x1E5E
  ,mapping: [ 0x1E5F ]
 },
 {
   code:0x1E60
  ,mapping: [ 0x1E61 ]
 },
 {
   code:0x1E62
  ,mapping: [ 0x1E63 ]
 },
 {
   code:0x1E64
  ,mapping: [ 0x1E65 ]
 },
 {
   code:0x1E66
  ,mapping: [ 0x1E67 ]
 },
 {
   code:0x1E68
  ,mapping: [ 0x1E69 ]
 },
 {
   code:0x1E6A
  ,mapping: [ 0x1E6B ]
 },
 {
   code:0x1E6C
  ,mapping: [ 0x1E6D ]
 },
 {
   code:0x1E6E
  ,mapping: [ 0x1E6F ]
 },
 {
   code:0x1E70
  ,mapping: [ 0x1E71 ]
 },
 {
   code:0x1E72
  ,mapping: [ 0x1E73 ]
 },
 {
   code:0x1E74
  ,mapping: [ 0x1E75 ]
 },
 {
   code:0x1E76
  ,mapping: [ 0x1E77 ]
 },
 {
   code:0x1E78
  ,mapping: [ 0x1E79 ]
 },
 {
   code:0x1E7A
  ,mapping: [ 0x1E7B ]
 },
 {
   code:0x1E7C
  ,mapping: [ 0x1E7D ]
 },
 {
   code:0x1E7E
  ,mapping: [ 0x1E7F ]
 },
 {
   code:0x1E80
  ,mapping: [ 0x1E81 ]
 },
 {
   code:0x1E82
  ,mapping: [ 0x1E83 ]
 },
 {
   code:0x1E84
  ,mapping: [ 0x1E85 ]
 },
 {
   code:0x1E86
  ,mapping: [ 0x1E87 ]
 },
 {
   code:0x1E88
  ,mapping: [ 0x1E89 ]
 },
 {
   code:0x1E8A
  ,mapping: [ 0x1E8B ]
 },
 {
   code:0x1E8C
  ,mapping: [ 0x1E8D ]
 },
 {
   code:0x1E8E
  ,mapping: [ 0x1E8F ]
 },
 {
   code:0x1E90
  ,mapping: [ 0x1E91 ]
 },
 {
   code:0x1E92
  ,mapping: [ 0x1E93 ]
 },
 {
   code:0x1E94
  ,mapping: [ 0x1E95 ]
 },
 {
   code:0x1E96
  ,mapping: [ 0x0068, 0x0331 ]
 },
 {
   code:0x1E97
  ,mapping: [ 0x0074, 0x0308 ]
 },
 {
   code:0x1E98
  ,mapping: [ 0x0077, 0x030A ]
 },
 {
   code:0x1E99
  ,mapping: [ 0x0079, 0x030A ]
 },
 {
   code:0x1E9A
  ,mapping: [ 0x0061, 0x02BE ]
 },
 {
   code:0x1E9B
  ,mapping: [ 0x1E61 ]
 },
 {
   code:0x1EA0
  ,mapping: [ 0x1EA1 ]
 },
 {
   code:0x1EA2
  ,mapping: [ 0x1EA3 ]
 },
 {
   code:0x1EA4
  ,mapping: [ 0x1EA5 ]
 },
 {
   code:0x1EA6
  ,mapping: [ 0x1EA7 ]
 },
 {
   code:0x1EA8
  ,mapping: [ 0x1EA9 ]
 },
 {
   code:0x1EAA
  ,mapping: [ 0x1EAB ]
 },
 {
   code:0x1EAC
  ,mapping: [ 0x1EAD ]
 },
 {
   code:0x1EAE
  ,mapping: [ 0x1EAF ]
 },
 {
   code:0x1EB0
  ,mapping: [ 0x1EB1 ]
 },
 {
   code:0x1EB2
  ,mapping: [ 0x1EB3 ]
 },
 {
   code:0x1EB4
  ,mapping: [ 0x1EB5 ]
 },
 {
   code:0x1EB6
  ,mapping: [ 0x1EB7 ]
 },
 {
   code:0x1EB8
  ,mapping: [ 0x1EB9 ]
 },
 {
   code:0x1EBA
  ,mapping: [ 0x1EBB ]
 },
 {
   code:0x1EBC
  ,mapping: [ 0x1EBD ]
 },
 {
   code:0x1EBE
  ,mapping: [ 0x1EBF ]
 },
 {
   code:0x1EC0
  ,mapping: [ 0x1EC1 ]
 },
 {
   code:0x1EC2
  ,mapping: [ 0x1EC3 ]
 },
 {
   code:0x1EC4
  ,mapping: [ 0x1EC5 ]
 },
 {
   code:0x1EC6
  ,mapping: [ 0x1EC7 ]
 },
 {
   code:0x1EC8
  ,mapping: [ 0x1EC9 ]
 },
 {
   code:0x1ECA
  ,mapping: [ 0x1ECB ]
 },
 {
   code:0x1ECC
  ,mapping: [ 0x1ECD ]
 },
 {
   code:0x1ECE
  ,mapping: [ 0x1ECF ]
 },
 {
   code:0x1ED0
  ,mapping: [ 0x1ED1 ]
 },
 {
   code:0x1ED2
  ,mapping: [ 0x1ED3 ]
 },
 {
   code:0x1ED4
  ,mapping: [ 0x1ED5 ]
 },
 {
   code:0x1ED6
  ,mapping: [ 0x1ED7 ]
 },
 {
   code:0x1ED8
  ,mapping: [ 0x1ED9 ]
 },
 {
   code:0x1EDA
  ,mapping: [ 0x1EDB ]
 },
 {
   code:0x1EDC
  ,mapping: [ 0x1EDD ]
 },
 {
   code:0x1EDE
  ,mapping: [ 0x1EDF ]
 },
 {
   code:0x1EE0
  ,mapping: [ 0x1EE1 ]
 },
 {
   code:0x1EE2
  ,mapping: [ 0x1EE3 ]
 },
 {
   code:0x1EE4
  ,mapping: [ 0x1EE5 ]
 },
 {
   code:0x1EE6
  ,mapping: [ 0x1EE7 ]
 },
 {
   code:0x1EE8
  ,mapping: [ 0x1EE9 ]
 },
 {
   code:0x1EEA
  ,mapping: [ 0x1EEB ]
 },
 {
   code:0x1EEC
  ,mapping: [ 0x1EED ]
 },
 {
   code:0x1EEE
  ,mapping: [ 0x1EEF ]
 },
 {
   code:0x1EF0
  ,mapping: [ 0x1EF1 ]
 },
 {
   code:0x1EF2
  ,mapping: [ 0x1EF3 ]
 },
 {
   code:0x1EF4
  ,mapping: [ 0x1EF5 ]
 },
 {
   code:0x1EF6
  ,mapping: [ 0x1EF7 ]
 },
 {
   code:0x1EF8
  ,mapping: [ 0x1EF9 ]
 },
 {
   code:0x1F08
  ,mapping: [ 0x1F00 ]
 },
 {
   code:0x1F09
  ,mapping: [ 0x1F01 ]
 },
 {
   code:0x1F0A
  ,mapping: [ 0x1F02 ]
 },
 {
   code:0x1F0B
  ,mapping: [ 0x1F03 ]
 },
 {
   code:0x1F0C
  ,mapping: [ 0x1F04 ]
 },
 {
   code:0x1F0D
  ,mapping: [ 0x1F05 ]
 },
 {
   code:0x1F0E
  ,mapping: [ 0x1F06 ]
 },
 {
   code:0x1F0F
  ,mapping: [ 0x1F07 ]
 },
 {
   code:0x1F18
  ,mapping: [ 0x1F10 ]
 },
 {
   code:0x1F19
  ,mapping: [ 0x1F11 ]
 },
 {
   code:0x1F1A
  ,mapping: [ 0x1F12 ]
 },
 {
   code:0x1F1B
  ,mapping: [ 0x1F13 ]
 },
 {
   code:0x1F1C
  ,mapping: [ 0x1F14 ]
 },
 {
   code:0x1F1D
  ,mapping: [ 0x1F15 ]
 },
 {
   code:0x1F28
  ,mapping: [ 0x1F20 ]
 },
 {
   code:0x1F29
  ,mapping: [ 0x1F21 ]
 },
 {
   code:0x1F2A
  ,mapping: [ 0x1F22 ]
 },
 {
   code:0x1F2B
  ,mapping: [ 0x1F23 ]
 },
 {
   code:0x1F2C
  ,mapping: [ 0x1F24 ]
 },
 {
   code:0x1F2D
  ,mapping: [ 0x1F25 ]
 },
 {
   code:0x1F2E
  ,mapping: [ 0x1F26 ]
 },
 {
   code:0x1F2F
  ,mapping: [ 0x1F27 ]
 },
 {
   code:0x1F38
  ,mapping: [ 0x1F30 ]
 },
 {
   code:0x1F39
  ,mapping: [ 0x1F31 ]
 },
 {
   code:0x1F3A
  ,mapping: [ 0x1F32 ]
 },
 {
   code:0x1F3B
  ,mapping: [ 0x1F33 ]
 },
 {
   code:0x1F3C
  ,mapping: [ 0x1F34 ]
 },
 {
   code:0x1F3D
  ,mapping: [ 0x1F35 ]
 },
 {
   code:0x1F3E
  ,mapping: [ 0x1F36 ]
 },
 {
   code:0x1F3F
  ,mapping: [ 0x1F37 ]
 },
 {
   code:0x1F48
  ,mapping: [ 0x1F40 ]
 },
 {
   code:0x1F49
  ,mapping: [ 0x1F41 ]
 },
 {
   code:0x1F4A
  ,mapping: [ 0x1F42 ]
 },
 {
   code:0x1F4B
  ,mapping: [ 0x1F43 ]
 },
 {
   code:0x1F4C
  ,mapping: [ 0x1F44 ]
 },
 {
   code:0x1F4D
  ,mapping: [ 0x1F45 ]
 },
 {
   code:0x1F50
  ,mapping: [ 0x03C5, 0x0313 ]
 },
 {
   code:0x1F52
  ,mapping: [ 0x03C5, 0x0313, 0x0300 ]
 },
 {
   code:0x1F54
  ,mapping: [ 0x03C5, 0x0313, 0x0301 ]
 },
 {
   code:0x1F56
  ,mapping: [ 0x03C5, 0x0313, 0x0342 ]
 },
 {
   code:0x1F59
  ,mapping: [ 0x1F51 ]
 },
 {
   code:0x1F5B
  ,mapping: [ 0x1F53 ]
 },
 {
   code:0x1F5D
  ,mapping: [ 0x1F55 ]
 },
 {
   code:0x1F5F
  ,mapping: [ 0x1F57 ]
 },
 {
   code:0x1F68
  ,mapping: [ 0x1F60 ]
 },
 {
   code:0x1F69
  ,mapping: [ 0x1F61 ]
 },
 {
   code:0x1F6A
  ,mapping: [ 0x1F62 ]
 },
 {
   code:0x1F6B
  ,mapping: [ 0x1F63 ]
 },
 {
   code:0x1F6C
  ,mapping: [ 0x1F64 ]
 },
 {
   code:0x1F6D
  ,mapping: [ 0x1F65 ]
 },
 {
   code:0x1F6E
  ,mapping: [ 0x1F66 ]
 },
 {
   code:0x1F6F
  ,mapping: [ 0x1F67 ]
 },
 {
   code:0x1F80
  ,mapping: [ 0x1F00, 0x03B9 ]
 },
 {
   code:0x1F81
  ,mapping: [ 0x1F01, 0x03B9 ]
 },
 {
   code:0x1F82
  ,mapping: [ 0x1F02, 0x03B9 ]
 },
 {
   code:0x1F83
  ,mapping: [ 0x1F03, 0x03B9 ]
 },
 {
   code:0x1F84
  ,mapping: [ 0x1F04, 0x03B9 ]
 },
 {
   code:0x1F85
  ,mapping: [ 0x1F05, 0x03B9 ]
 },
 {
   code:0x1F86
  ,mapping: [ 0x1F06, 0x03B9 ]
 },
 {
   code:0x1F87
  ,mapping: [ 0x1F07, 0x03B9 ]
 },
 {
   code:0x1F88
  ,mapping: [ 0x1F00, 0x03B9 ]
 },
 {
   code:0x1F89
  ,mapping: [ 0x1F01, 0x03B9 ]
 },
 {
   code:0x1F8A
  ,mapping: [ 0x1F02, 0x03B9 ]
 },
 {
   code:0x1F8B
  ,mapping: [ 0x1F03, 0x03B9 ]
 },
 {
   code:0x1F8C
  ,mapping: [ 0x1F04, 0x03B9 ]
 },
 {
   code:0x1F8D
  ,mapping: [ 0x1F05, 0x03B9 ]
 },
 {
   code:0x1F8E
  ,mapping: [ 0x1F06, 0x03B9 ]
 },
 {
   code:0x1F8F
  ,mapping: [ 0x1F07, 0x03B9 ]
 },
 {
   code:0x1F90
  ,mapping: [ 0x1F20, 0x03B9 ]
 },
 {
   code:0x1F91
  ,mapping: [ 0x1F21, 0x03B9 ]
 },
 {
   code:0x1F92
  ,mapping: [ 0x1F22, 0x03B9 ]
 },
 {
   code:0x1F93
  ,mapping: [ 0x1F23, 0x03B9 ]
 },
 {
   code:0x1F94
  ,mapping: [ 0x1F24, 0x03B9 ]
 },
 {
   code:0x1F95
  ,mapping: [ 0x1F25, 0x03B9 ]
 },
 {
   code:0x1F96
  ,mapping: [ 0x1F26, 0x03B9 ]
 },
 {
   code:0x1F97
  ,mapping: [ 0x1F27, 0x03B9 ]
 },
 {
   code:0x1F98
  ,mapping: [ 0x1F20, 0x03B9 ]
 },
 {
   code:0x1F99
  ,mapping: [ 0x1F21, 0x03B9 ]
 },
 {
   code:0x1F9A
  ,mapping: [ 0x1F22, 0x03B9 ]
 },
 {
   code:0x1F9B
  ,mapping: [ 0x1F23, 0x03B9 ]
 },
 {
   code:0x1F9C
  ,mapping: [ 0x1F24, 0x03B9 ]
 },
 {
   code:0x1F9D
  ,mapping: [ 0x1F25, 0x03B9 ]
 },
 {
   code:0x1F9E
  ,mapping: [ 0x1F26, 0x03B9 ]
 },
 {
   code:0x1F9F
  ,mapping: [ 0x1F27, 0x03B9 ]
 },
 {
   code:0x1FA0
  ,mapping: [ 0x1F60, 0x03B9 ]
 },
 {
   code:0x1FA1
  ,mapping: [ 0x1F61, 0x03B9 ]
 },
 {
   code:0x1FA2
  ,mapping: [ 0x1F62, 0x03B9 ]
 },
 {
   code:0x1FA3
  ,mapping: [ 0x1F63, 0x03B9 ]
 },
 {
   code:0x1FA4
  ,mapping: [ 0x1F64, 0x03B9 ]
 },
 {
   code:0x1FA5
  ,mapping: [ 0x1F65, 0x03B9 ]
 },
 {
   code:0x1FA6
  ,mapping: [ 0x1F66, 0x03B9 ]
 },
 {
   code:0x1FA7
  ,mapping: [ 0x1F67, 0x03B9 ]
 },
 {
   code:0x1FA8
  ,mapping: [ 0x1F60, 0x03B9 ]
 },
 {
   code:0x1FA9
  ,mapping: [ 0x1F61, 0x03B9 ]
 },
 {
   code:0x1FAA
  ,mapping: [ 0x1F62, 0x03B9 ]
 },
 {
   code:0x1FAB
  ,mapping: [ 0x1F63, 0x03B9 ]
 },
 {
   code:0x1FAC
  ,mapping: [ 0x1F64, 0x03B9 ]
 },
 {
   code:0x1FAD
  ,mapping: [ 0x1F65, 0x03B9 ]
 },
 {
   code:0x1FAE
  ,mapping: [ 0x1F66, 0x03B9 ]
 },
 {
   code:0x1FAF
  ,mapping: [ 0x1F67, 0x03B9 ]
 },
 {
   code:0x1FB2
  ,mapping: [ 0x1F70, 0x03B9 ]
 },
 {
   code:0x1FB3
  ,mapping: [ 0x03B1, 0x03B9 ]
 },
 {
   code:0x1FB4
  ,mapping: [ 0x03AC, 0x03B9 ]
 },
 {
   code:0x1FB6
  ,mapping: [ 0x03B1, 0x0342 ]
 },
 {
   code:0x1FB7
  ,mapping: [ 0x03B1, 0x0342, 0x03B9 ]
 },
 {
   code:0x1FB8
  ,mapping: [ 0x1FB0 ]
 },
 {
   code:0x1FB9
  ,mapping: [ 0x1FB1 ]
 },
 {
   code:0x1FBA
  ,mapping: [ 0x1F70 ]
 },
 {
   code:0x1FBB
  ,mapping: [ 0x1F71 ]
 },
 {
   code:0x1FBC
  ,mapping: [ 0x03B1, 0x03B9 ]
 },
 {
   code:0x1FBE
  ,mapping: [ 0x03B9 ]
 },
 {
   code:0x1FC2
  ,mapping: [ 0x1F74, 0x03B9 ]
 },
 {
   code:0x1FC3
  ,mapping: [ 0x03B7, 0x03B9 ]
 },
 {
   code:0x1FC4
  ,mapping: [ 0x03AE, 0x03B9 ]
 },
 {
   code:0x1FC6
  ,mapping: [ 0x03B7, 0x0342 ]
 },
 {
   code:0x1FC7
  ,mapping: [ 0x03B7, 0x0342, 0x03B9 ]
 },
 {
   code:0x1FC8
  ,mapping: [ 0x1F72 ]
 },
 {
   code:0x1FC9
  ,mapping: [ 0x1F73 ]
 },
 {
   code:0x1FCA
  ,mapping: [ 0x1F74 ]
 },
 {
   code:0x1FCB
  ,mapping: [ 0x1F75 ]
 },
 {
   code:0x1FCC
  ,mapping: [ 0x03B7, 0x03B9 ]
 },
 {
   code:0x1FD2
  ,mapping: [ 0x03B9, 0x0308, 0x0300 ]
 },
 {
   code:0x1FD3
  ,mapping: [ 0x03B9, 0x0308, 0x0301 ]
 },
 {
   code:0x1FD6
  ,mapping: [ 0x03B9, 0x0342 ]
 },
 {
   code:0x1FD7
  ,mapping: [ 0x03B9, 0x0308, 0x0342 ]
 },
 {
   code:0x1FD8
  ,mapping: [ 0x1FD0 ]
 },
 {
   code:0x1FD9
  ,mapping: [ 0x1FD1 ]
 },
 {
   code:0x1FDA
  ,mapping: [ 0x1F76 ]
 },
 {
   code:0x1FDB
  ,mapping: [ 0x1F77 ]
 },
 {
   code:0x1FE2
  ,mapping: [ 0x03C5, 0x0308, 0x0300 ]
 },
 {
   code:0x1FE3
  ,mapping: [ 0x03C5, 0x0308, 0x0301 ]
 },
 {
   code:0x1FE4
  ,mapping: [ 0x03C1, 0x0313 ]
 },
 {
   code:0x1FE6
  ,mapping: [ 0x03C5, 0x0342 ]
 },
 {
   code:0x1FE7
  ,mapping: [ 0x03C5, 0x0308, 0x0342 ]
 },
 {
   code:0x1FE8
  ,mapping: [ 0x1FE0 ]
 },
 {
   code:0x1FE9
  ,mapping: [ 0x1FE1 ]
 },
 {
   code:0x1FEA
  ,mapping: [ 0x1F7A ]
 },
 {
   code:0x1FEB
  ,mapping: [ 0x1F7B ]
 },
 {
   code:0x1FEC
  ,mapping: [ 0x1FE5 ]
 },
 {
   code:0x1FF2
  ,mapping: [ 0x1F7C, 0x03B9 ]
 },
 {
   code:0x1FF3
  ,mapping: [ 0x03C9, 0x03B9 ]
 },
 {
   code:0x1FF4
  ,mapping: [ 0x03CE, 0x03B9 ]
 },
 {
   code:0x1FF6
  ,mapping: [ 0x03C9, 0x0342 ]
 },
 {
   code:0x1FF7
  ,mapping: [ 0x03C9, 0x0342, 0x03B9 ]
 },
 {
   code:0x1FF8
  ,mapping: [ 0x1F78 ]
 },
 {
   code:0x1FF9
  ,mapping: [ 0x1F79 ]
 },
 {
   code:0x1FFA
  ,mapping: [ 0x1F7C ]
 },
 {
   code:0x1FFB
  ,mapping: [ 0x1F7D ]
 },
 {
   code:0x1FFC
  ,mapping: [ 0x03C9, 0x03B9 ]
 },
 {
   code:0x2126
  ,mapping: [ 0x03C9 ]
 },
 {
   code:0x212A
  ,mapping: [ 0x006B ]
 },
 {
   code:0x212B
  ,mapping: [ 0x00E5 ]
 },
 {
   code:0x2132
  ,mapping: [ 0x214E ]
 },
 {
   code:0x2160
  ,mapping: [ 0x2170 ]
 },
 {
   code:0x2161
  ,mapping: [ 0x2171 ]
 },
 {
   code:0x2162
  ,mapping: [ 0x2172 ]
 },
 {
   code:0x2163
  ,mapping: [ 0x2173 ]
 },
 {
   code:0x2164
  ,mapping: [ 0x2174 ]
 },
 {
   code:0x2165
  ,mapping: [ 0x2175 ]
 },
 {
   code:0x2166
  ,mapping: [ 0x2176 ]
 },
 {
   code:0x2167
  ,mapping: [ 0x2177 ]
 },
 {
   code:0x2168
  ,mapping: [ 0x2178 ]
 },
 {
   code:0x2169
  ,mapping: [ 0x2179 ]
 },
 {
   code:0x216A
  ,mapping: [ 0x217A ]
 },
 {
   code:0x216B
  ,mapping: [ 0x217B ]
 },
 {
   code:0x216C
  ,mapping: [ 0x217C ]
 },
 {
   code:0x216D
  ,mapping: [ 0x217D ]
 },
 {
   code:0x216E
  ,mapping: [ 0x217E ]
 },
 {
   code:0x216F
  ,mapping: [ 0x217F ]
 },
 {
   code:0x2183
  ,mapping: [ 0x2184 ]
 },
 {
   code:0x24B6
  ,mapping: [ 0x24D0 ]
 },
 {
   code:0x24B7
  ,mapping: [ 0x24D1 ]
 },
 {
   code:0x24B8
  ,mapping: [ 0x24D2 ]
 },
 {
   code:0x24B9
  ,mapping: [ 0x24D3 ]
 },
 {
   code:0x24BA
  ,mapping: [ 0x24D4 ]
 },
 {
   code:0x24BB
  ,mapping: [ 0x24D5 ]
 },
 {
   code:0x24BC
  ,mapping: [ 0x24D6 ]
 },
 {
   code:0x24BD
  ,mapping: [ 0x24D7 ]
 },
 {
   code:0x24BE
  ,mapping: [ 0x24D8 ]
 },
 {
   code:0x24BF
  ,mapping: [ 0x24D9 ]
 },
 {
   code:0x24C0
  ,mapping: [ 0x24DA ]
 },
 {
   code:0x24C1
  ,mapping: [ 0x24DB ]
 },
 {
   code:0x24C2
  ,mapping: [ 0x24DC ]
 },
 {
   code:0x24C3
  ,mapping: [ 0x24DD ]
 },
 {
   code:0x24C4
  ,mapping: [ 0x24DE ]
 },
 {
   code:0x24C5
  ,mapping: [ 0x24DF ]
 },
 {
   code:0x24C6
  ,mapping: [ 0x24E0 ]
 },
 {
   code:0x24C7
  ,mapping: [ 0x24E1 ]
 },
 {
   code:0x24C8
  ,mapping: [ 0x24E2 ]
 },
 {
   code:0x24C9
  ,mapping: [ 0x24E3 ]
 },
 {
   code:0x24CA
  ,mapping: [ 0x24E4 ]
 },
 {
   code:0x24CB
  ,mapping: [ 0x24E5 ]
 },
 {
   code:0x24CC
  ,mapping: [ 0x24E6 ]
 },
 {
   code:0x24CD
  ,mapping: [ 0x24E7 ]
 },
 {
   code:0x24CE
  ,mapping: [ 0x24E8 ]
 },
 {
   code:0x24CF
  ,mapping: [ 0x24E9 ]
 },
 {
   code:0x2C00
  ,mapping: [ 0x2C30 ]
 },
 {
   code:0x2C01
  ,mapping: [ 0x2C31 ]
 },
 {
   code:0x2C02
  ,mapping: [ 0x2C32 ]
 },
 {
   code:0x2C03
  ,mapping: [ 0x2C33 ]
 },
 {
   code:0x2C04
  ,mapping: [ 0x2C34 ]
 },
 {
   code:0x2C05
  ,mapping: [ 0x2C35 ]
 },
 {
   code:0x2C06
  ,mapping: [ 0x2C36 ]
 },
 {
   code:0x2C07
  ,mapping: [ 0x2C37 ]
 },
 {
   code:0x2C08
  ,mapping: [ 0x2C38 ]
 },
 {
   code:0x2C09
  ,mapping: [ 0x2C39 ]
 },
 {
   code:0x2C0A
  ,mapping: [ 0x2C3A ]
 },
 {
   code:0x2C0B
  ,mapping: [ 0x2C3B ]
 },
 {
   code:0x2C0C
  ,mapping: [ 0x2C3C ]
 },
 {
   code:0x2C0D
  ,mapping: [ 0x2C3D ]
 },
 {
   code:0x2C0E
  ,mapping: [ 0x2C3E ]
 },
 {
   code:0x2C0F
  ,mapping: [ 0x2C3F ]
 },
 {
   code:0x2C10
  ,mapping: [ 0x2C40 ]
 },
 {
   code:0x2C11
  ,mapping: [ 0x2C41 ]
 },
 {
   code:0x2C12
  ,mapping: [ 0x2C42 ]
 },
 {
   code:0x2C13
  ,mapping: [ 0x2C43 ]
 },
 {
   code:0x2C14
  ,mapping: [ 0x2C44 ]
 },
 {
   code:0x2C15
  ,mapping: [ 0x2C45 ]
 },
 {
   code:0x2C16
  ,mapping: [ 0x2C46 ]
 },
 {
   code:0x2C17
  ,mapping: [ 0x2C47 ]
 },
 {
   code:0x2C18
  ,mapping: [ 0x2C48 ]
 },
 {
   code:0x2C19
  ,mapping: [ 0x2C49 ]
 },
 {
   code:0x2C1A
  ,mapping: [ 0x2C4A ]
 },
 {
   code:0x2C1B
  ,mapping: [ 0x2C4B ]
 },
 {
   code:0x2C1C
  ,mapping: [ 0x2C4C ]
 },
 {
   code:0x2C1D
  ,mapping: [ 0x2C4D ]
 },
 {
   code:0x2C1E
  ,mapping: [ 0x2C4E ]
 },
 {
   code:0x2C1F
  ,mapping: [ 0x2C4F ]
 },
 {
   code:0x2C20
  ,mapping: [ 0x2C50 ]
 },
 {
   code:0x2C21
  ,mapping: [ 0x2C51 ]
 },
 {
   code:0x2C22
  ,mapping: [ 0x2C52 ]
 },
 {
   code:0x2C23
  ,mapping: [ 0x2C53 ]
 },
 {
   code:0x2C24
  ,mapping: [ 0x2C54 ]
 },
 {
   code:0x2C25
  ,mapping: [ 0x2C55 ]
 },
 {
   code:0x2C26
  ,mapping: [ 0x2C56 ]
 },
 {
   code:0x2C27
  ,mapping: [ 0x2C57 ]
 },
 {
   code:0x2C28
  ,mapping: [ 0x2C58 ]
 },
 {
   code:0x2C29
  ,mapping: [ 0x2C59 ]
 },
 {
   code:0x2C2A
  ,mapping: [ 0x2C5A ]
 },
 {
   code:0x2C2B
  ,mapping: [ 0x2C5B ]
 },
 {
   code:0x2C2C
  ,mapping: [ 0x2C5C ]
 },
 {
   code:0x2C2D
  ,mapping: [ 0x2C5D ]
 },
 {
   code:0x2C2E
  ,mapping: [ 0x2C5E ]
 },
 {
   code:0x2C60
  ,mapping: [ 0x2C61 ]
 },
 {
   code:0x2C62
  ,mapping: [ 0x026B ]
 },
 {
   code:0x2C63
  ,mapping: [ 0x1D7D ]
 },
 {
   code:0x2C64
  ,mapping: [ 0x027D ]
 },
 {
   code:0x2C67
  ,mapping: [ 0x2C68 ]
 },
 {
   code:0x2C69
  ,mapping: [ 0x2C6A ]
 },
 {
   code:0x2C6B
  ,mapping: [ 0x2C6C ]
 },
 {
   code:0x2C75
  ,mapping: [ 0x2C76 ]
 },
 {
   code:0x2C80
  ,mapping: [ 0x2C81 ]
 },
 {
   code:0x2C82
  ,mapping: [ 0x2C83 ]
 },
 {
   code:0x2C84
  ,mapping: [ 0x2C85 ]
 },
 {
   code:0x2C86
  ,mapping: [ 0x2C87 ]
 },
 {
   code:0x2C88
  ,mapping: [ 0x2C89 ]
 },
 {
   code:0x2C8A
  ,mapping: [ 0x2C8B ]
 },
 {
   code:0x2C8C
  ,mapping: [ 0x2C8D ]
 },
 {
   code:0x2C8E
  ,mapping: [ 0x2C8F ]
 },
 {
   code:0x2C90
  ,mapping: [ 0x2C91 ]
 },
 {
   code:0x2C92
  ,mapping: [ 0x2C93 ]
 },
 {
   code:0x2C94
  ,mapping: [ 0x2C95 ]
 },
 {
   code:0x2C96
  ,mapping: [ 0x2C97 ]
 },
 {
   code:0x2C98
  ,mapping: [ 0x2C99 ]
 },
 {
   code:0x2C9A
  ,mapping: [ 0x2C9B ]
 },
 {
   code:0x2C9C
  ,mapping: [ 0x2C9D ]
 },
 {
   code:0x2C9E
  ,mapping: [ 0x2C9F ]
 },
 {
   code:0x2CA0
  ,mapping: [ 0x2CA1 ]
 },
 {
   code:0x2CA2
  ,mapping: [ 0x2CA3 ]
 },
 {
   code:0x2CA4
  ,mapping: [ 0x2CA5 ]
 },
 {
   code:0x2CA6
  ,mapping: [ 0x2CA7 ]
 },
 {
   code:0x2CA8
  ,mapping: [ 0x2CA9 ]
 },
 {
   code:0x2CAA
  ,mapping: [ 0x2CAB ]
 },
 {
   code:0x2CAC
  ,mapping: [ 0x2CAD ]
 },
 {
   code:0x2CAE
  ,mapping: [ 0x2CAF ]
 },
 {
   code:0x2CB0
  ,mapping: [ 0x2CB1 ]
 },
 {
   code:0x2CB2
  ,mapping: [ 0x2CB3 ]
 },
 {
   code:0x2CB4
  ,mapping: [ 0x2CB5 ]
 },
 {
   code:0x2CB6
  ,mapping: [ 0x2CB7 ]
 },
 {
   code:0x2CB8
  ,mapping: [ 0x2CB9 ]
 },
 {
   code:0x2CBA
  ,mapping: [ 0x2CBB ]
 },
 {
   code:0x2CBC
  ,mapping: [ 0x2CBD ]
 },
 {
   code:0x2CBE
  ,mapping: [ 0x2CBF ]
 },
 {
   code:0x2CC0
  ,mapping: [ 0x2CC1 ]
 },
 {
   code:0x2CC2
  ,mapping: [ 0x2CC3 ]
 },
 {
   code:0x2CC4
  ,mapping: [ 0x2CC5 ]
 },
 {
   code:0x2CC6
  ,mapping: [ 0x2CC7 ]
 },
 {
   code:0x2CC8
  ,mapping: [ 0x2CC9 ]
 },
 {
   code:0x2CCA
  ,mapping: [ 0x2CCB ]
 },
 {
   code:0x2CCC
  ,mapping: [ 0x2CCD ]
 },
 {
   code:0x2CCE
  ,mapping: [ 0x2CCF ]
 },
 {
   code:0x2CD0
  ,mapping: [ 0x2CD1 ]
 },
 {
   code:0x2CD2
  ,mapping: [ 0x2CD3 ]
 },
 {
   code:0x2CD4
  ,mapping: [ 0x2CD5 ]
 },
 {
   code:0x2CD6
  ,mapping: [ 0x2CD7 ]
 },
 {
   code:0x2CD8
  ,mapping: [ 0x2CD9 ]
 },
 {
   code:0x2CDA
  ,mapping: [ 0x2CDB ]
 },
 {
   code:0x2CDC
  ,mapping: [ 0x2CDD ]
 },
 {
   code:0x2CDE
  ,mapping: [ 0x2CDF ]
 },
 {
   code:0x2CE0
  ,mapping: [ 0x2CE1 ]
 },
 {
   code:0x2CE2
  ,mapping: [ 0x2CE3 ]
 },
 {
   code:0xFB00
  ,mapping: [ 0x0066, 0x0066 ]
 },
 {
   code:0xFB01
  ,mapping: [ 0x0066, 0x0069 ]
 },
 {
   code:0xFB02
  ,mapping: [ 0x0066, 0x006C ]
 },
 {
   code:0xFB03
  ,mapping: [ 0x0066, 0x0066, 0x0069 ]
 },
 {
   code:0xFB04
  ,mapping: [ 0x0066, 0x0066, 0x006C ]
 },
 {
   code:0xFB05
  ,mapping: [ 0x0073, 0x0074 ]
 },
 {
   code:0xFB06
  ,mapping: [ 0x0073, 0x0074 ]
 },
 {
   code:0xFB13
  ,mapping: [ 0x0574, 0x0576 ]
 },
 {
   code:0xFB14
  ,mapping: [ 0x0574, 0x0565 ]
 },
 {
   code:0xFB15
  ,mapping: [ 0x0574, 0x056B ]
 },
 {
   code:0xFB16
  ,mapping: [ 0x057E, 0x0576 ]
 },
 {
   code:0xFB17
  ,mapping: [ 0x0574, 0x056D ]
 },
 {
   code:0xFF21
  ,mapping: [ 0xFF41 ]
 },
 {
   code:0xFF22
  ,mapping: [ 0xFF42 ]
 },
 {
   code:0xFF23
  ,mapping: [ 0xFF43 ]
 },
 {
   code:0xFF24
  ,mapping: [ 0xFF44 ]
 },
 {
   code:0xFF25
  ,mapping: [ 0xFF45 ]
 },
 {
   code:0xFF26
  ,mapping: [ 0xFF46 ]
 },
 {
   code:0xFF27
  ,mapping: [ 0xFF47 ]
 },
 {
   code:0xFF28
  ,mapping: [ 0xFF48 ]
 },
 {
   code:0xFF29
  ,mapping: [ 0xFF49 ]
 },
 {
   code:0xFF2A
  ,mapping: [ 0xFF4A ]
 },
 {
   code:0xFF2B
  ,mapping: [ 0xFF4B ]
 },
 {
   code:0xFF2C
  ,mapping: [ 0xFF4C ]
 },
 {
   code:0xFF2D
  ,mapping: [ 0xFF4D ]
 },
 {
   code:0xFF2E
  ,mapping: [ 0xFF4E ]
 },
 {
   code:0xFF2F
  ,mapping: [ 0xFF4F ]
 },
 {
   code:0xFF30
  ,mapping: [ 0xFF50 ]
 },
 {
   code:0xFF31
  ,mapping: [ 0xFF51 ]
 },
 {
   code:0xFF32
  ,mapping: [ 0xFF52 ]
 },
 {
   code:0xFF33
  ,mapping: [ 0xFF53 ]
 },
 {
   code:0xFF34
  ,mapping: [ 0xFF54 ]
 },
 {
   code:0xFF35
  ,mapping: [ 0xFF55 ]
 },
 {
   code:0xFF36
  ,mapping: [ 0xFF56 ]
 },
 {
   code:0xFF37
  ,mapping: [ 0xFF57 ]
 },
 {
   code:0xFF38
  ,mapping: [ 0xFF58 ]
 },
 {
   code:0xFF39
  ,mapping: [ 0xFF59 ]
 },
 {
   code:0xFF3A
  ,mapping: [ 0xFF5A ]
 },
 {
   code:0x10400
  ,mapping: [ 0x10428 ]
 },
 {
   code:0x10401
  ,mapping: [ 0x10429 ]
 },
 {
   code:0x10402
  ,mapping: [ 0x1042A ]
 },
 {
   code:0x10403
  ,mapping: [ 0x1042B ]
 },
 {
   code:0x10404
  ,mapping: [ 0x1042C ]
 },
 {
   code:0x10405
  ,mapping: [ 0x1042D ]
 },
 {
   code:0x10406
  ,mapping: [ 0x1042E ]
 },
 {
   code:0x10407
  ,mapping: [ 0x1042F ]
 },
 {
   code:0x10408
  ,mapping: [ 0x10430 ]
 },
 {
   code:0x10409
  ,mapping: [ 0x10431 ]
 },
 {
   code:0x1040A
  ,mapping: [ 0x10432 ]
 },
 {
   code:0x1040B
  ,mapping: [ 0x10433 ]
 },
 {
   code:0x1040C
  ,mapping: [ 0x10434 ]
 },
 {
   code:0x1040D
  ,mapping: [ 0x10435 ]
 },
 {
   code:0x1040E
  ,mapping: [ 0x10436 ]
 },
 {
   code:0x1040F
  ,mapping: [ 0x10437 ]
 },
 {
   code:0x10410
  ,mapping: [ 0x10438 ]
 },
 {
   code:0x10411
  ,mapping: [ 0x10439 ]
 },
 {
   code:0x10412
  ,mapping: [ 0x1043A ]
 },
 {
   code:0x10413
  ,mapping: [ 0x1043B ]
 },
 {
   code:0x10414
  ,mapping: [ 0x1043C ]
 },
 {
   code:0x10415
  ,mapping: [ 0x1043D ]
 },
 {
   code:0x10416
  ,mapping: [ 0x1043E ]
 },
 {
   code:0x10417
  ,mapping: [ 0x1043F ]
 },
 {
   code:0x10418
  ,mapping: [ 0x10440 ]
 },
 {
   code:0x10419
  ,mapping: [ 0x10441 ]
 },
 {
   code:0x1041A
  ,mapping: [ 0x10442 ]
 },
 {
   code:0x1041B
  ,mapping: [ 0x10443 ]
 },
 {
   code:0x1041C
  ,mapping: [ 0x10444 ]
 },
 {
   code:0x1041D
  ,mapping: [ 0x10445 ]
 },
 {
   code:0x1041E
  ,mapping: [ 0x10446 ]
 },
 {
   code:0x1041F
  ,mapping: [ 0x10447 ]
 },
 {
   code:0x10420
  ,mapping: [ 0x10448 ]
 },
 {
   code:0x10421
  ,mapping: [ 0x10449 ]
 },
 {
   code:0x10422
  ,mapping: [ 0x1044A ]
 },
 {
   code:0x10423
  ,mapping: [ 0x1044B ]
 },
 {
   code:0x10424
  ,mapping: [ 0x1044C ]
 },
 {
   code:0x10425
  ,mapping: [ 0x1044D ]
 },
 {
   code:0x10426
  ,mapping: [ 0x1044E ]
 },
 {
   code:0x10427
  ,mapping: [ 0x1044F ]
 },

];

}

static this() {
	foreach(inout entry; internalUnicodeData)
		unicodeData[entry.code] = &entry;
	unicodeData.rehash;
	
	foreach(inout entry; internalSpecialCaseData)
		specialCaseData[entry.code] = &entry;
	specialCaseData.rehash;
	
	foreach(inout entry; internalFoldingCaseData)
		foldingCaseData[entry.code] = &entry;
	foldingCaseData.rehash;
}
